#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 751
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 85
#define ALIAS_COUNT 0
#define TOKEN_COUNT 40
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 1

enum {
  sym__escape_identity = 1,
  anon_sym_BSLASHt = 2,
  anon_sym_BSLASHr = 3,
  anon_sym_BSLASHn = 4,
  sym__escape_semicolon = 5,
  aux_sym_variable_token1 = 6,
  anon_sym_DOLLAR = 7,
  anon_sym_LBRACE = 8,
  anon_sym_RBRACE = 9,
  anon_sym_ENV = 10,
  anon_sym_CACHE = 11,
  anon_sym_LT = 12,
  anon_sym_GT = 13,
  anon_sym_COLON = 14,
  aux_sym__gen_exp_arguments_token1 = 15,
  aux_sym__untrimmed_argument_token1 = 16,
  anon_sym_LPAREN = 17,
  anon_sym_RPAREN = 18,
  anon_sym_DQUOTE = 19,
  aux_sym_quoted_element_token1 = 20,
  aux_sym_unquoted_argument_token1 = 21,
  aux_sym_if_command_token1 = 22,
  aux_sym_else_command_token1 = 23,
  sym_if = 24,
  sym_elseif = 25,
  sym_else = 26,
  sym_endif = 27,
  sym_foreach = 28,
  sym_endforeach = 29,
  sym_while = 30,
  sym_endwhile = 31,
  sym_function = 32,
  sym_endfunction = 33,
  sym_macro = 34,
  sym_endmacro = 35,
  sym_identifier = 36,
  sym_bracket_argument = 37,
  sym_bracket_comment = 38,
  sym_line_comment = 39,
  sym_source_file = 40,
  sym_escape_sequence = 41,
  sym__escape_encoded = 42,
  sym_variable = 43,
  sym_variable_ref = 44,
  sym_normal_var = 45,
  sym_env_var = 46,
  sym_cache_var = 47,
  sym_gen_exp = 48,
  sym__gen_exp_content = 49,
  sym__gen_exp_arguments = 50,
  sym_argument = 51,
  sym__untrimmed_argument = 52,
  sym__paren_argument = 53,
  sym_quoted_argument = 54,
  sym_quoted_element = 55,
  sym_unquoted_argument = 56,
  sym_if_command = 57,
  sym_elseif_command = 58,
  sym_else_command = 59,
  sym_endif_command = 60,
  sym_if_condition = 61,
  sym_foreach_command = 62,
  sym_endforeach_command = 63,
  sym_foreach_loop = 64,
  sym_while_command = 65,
  sym_endwhile_command = 66,
  sym_while_loop = 67,
  sym_function_command = 68,
  sym_endfunction_command = 69,
  sym_function_def = 70,
  sym_macro_command = 71,
  sym_endmacro_command = 72,
  sym_macro_def = 73,
  sym_normal_command = 74,
  sym__command_invocation = 75,
  sym__untrimmed_command_invocation = 76,
  aux_sym_source_file_repeat1 = 77,
  aux_sym_variable_repeat1 = 78,
  aux_sym__gen_exp_arguments_repeat1 = 79,
  aux_sym__paren_argument_repeat1 = 80,
  aux_sym_quoted_element_repeat1 = 81,
  aux_sym_unquoted_argument_repeat1 = 82,
  aux_sym_if_command_repeat1 = 83,
  aux_sym_if_condition_repeat1 = 84,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__escape_identity] = "_escape_identity",
  [anon_sym_BSLASHt] = "\\t",
  [anon_sym_BSLASHr] = "\\r",
  [anon_sym_BSLASHn] = "\\n",
  [sym__escape_semicolon] = "_escape_semicolon",
  [aux_sym_variable_token1] = "variable_token1",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_ENV] = "ENV",
  [anon_sym_CACHE] = "CACHE",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_COLON] = ":",
  [aux_sym__gen_exp_arguments_token1] = "_gen_exp_arguments_token1",
  [aux_sym__untrimmed_argument_token1] = "_untrimmed_argument_token1",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_quoted_element_token1] = "quoted_element_token1",
  [aux_sym_unquoted_argument_token1] = "unquoted_argument_token1",
  [aux_sym_if_command_token1] = "if_command_token1",
  [aux_sym_else_command_token1] = "else_command_token1",
  [sym_if] = "if",
  [sym_elseif] = "elseif",
  [sym_else] = "else",
  [sym_endif] = "endif",
  [sym_foreach] = "foreach",
  [sym_endforeach] = "endforeach",
  [sym_while] = "while",
  [sym_endwhile] = "endwhile",
  [sym_function] = "function",
  [sym_endfunction] = "endfunction",
  [sym_macro] = "macro",
  [sym_endmacro] = "endmacro",
  [sym_identifier] = "identifier",
  [sym_bracket_argument] = "bracket_argument",
  [sym_bracket_comment] = "bracket_comment",
  [sym_line_comment] = "line_comment",
  [sym_source_file] = "source_file",
  [sym_escape_sequence] = "escape_sequence",
  [sym__escape_encoded] = "_escape_encoded",
  [sym_variable] = "variable",
  [sym_variable_ref] = "variable_ref",
  [sym_normal_var] = "normal_var",
  [sym_env_var] = "env_var",
  [sym_cache_var] = "cache_var",
  [sym_gen_exp] = "gen_exp",
  [sym__gen_exp_content] = "_gen_exp_content",
  [sym__gen_exp_arguments] = "_gen_exp_arguments",
  [sym_argument] = "argument",
  [sym__untrimmed_argument] = "_untrimmed_argument",
  [sym__paren_argument] = "_paren_argument",
  [sym_quoted_argument] = "quoted_argument",
  [sym_quoted_element] = "quoted_element",
  [sym_unquoted_argument] = "unquoted_argument",
  [sym_if_command] = "if_command",
  [sym_elseif_command] = "elseif_command",
  [sym_else_command] = "else_command",
  [sym_endif_command] = "endif_command",
  [sym_if_condition] = "if_condition",
  [sym_foreach_command] = "foreach_command",
  [sym_endforeach_command] = "endforeach_command",
  [sym_foreach_loop] = "foreach_loop",
  [sym_while_command] = "while_command",
  [sym_endwhile_command] = "endwhile_command",
  [sym_while_loop] = "while_loop",
  [sym_function_command] = "function_command",
  [sym_endfunction_command] = "endfunction_command",
  [sym_function_def] = "function_def",
  [sym_macro_command] = "macro_command",
  [sym_endmacro_command] = "endmacro_command",
  [sym_macro_def] = "macro_def",
  [sym_normal_command] = "normal_command",
  [sym__command_invocation] = "_command_invocation",
  [sym__untrimmed_command_invocation] = "_untrimmed_command_invocation",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_variable_repeat1] = "variable_repeat1",
  [aux_sym__gen_exp_arguments_repeat1] = "_gen_exp_arguments_repeat1",
  [aux_sym__paren_argument_repeat1] = "_paren_argument_repeat1",
  [aux_sym_quoted_element_repeat1] = "quoted_element_repeat1",
  [aux_sym_unquoted_argument_repeat1] = "unquoted_argument_repeat1",
  [aux_sym_if_command_repeat1] = "if_command_repeat1",
  [aux_sym_if_condition_repeat1] = "if_condition_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__escape_identity] = sym__escape_identity,
  [anon_sym_BSLASHt] = anon_sym_BSLASHt,
  [anon_sym_BSLASHr] = anon_sym_BSLASHr,
  [anon_sym_BSLASHn] = anon_sym_BSLASHn,
  [sym__escape_semicolon] = sym__escape_semicolon,
  [aux_sym_variable_token1] = aux_sym_variable_token1,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_ENV] = anon_sym_ENV,
  [anon_sym_CACHE] = anon_sym_CACHE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [aux_sym__gen_exp_arguments_token1] = aux_sym__gen_exp_arguments_token1,
  [aux_sym__untrimmed_argument_token1] = aux_sym__untrimmed_argument_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_quoted_element_token1] = aux_sym_quoted_element_token1,
  [aux_sym_unquoted_argument_token1] = aux_sym_unquoted_argument_token1,
  [aux_sym_if_command_token1] = aux_sym_if_command_token1,
  [aux_sym_else_command_token1] = aux_sym_else_command_token1,
  [sym_if] = sym_if,
  [sym_elseif] = sym_elseif,
  [sym_else] = sym_else,
  [sym_endif] = sym_endif,
  [sym_foreach] = sym_foreach,
  [sym_endforeach] = sym_endforeach,
  [sym_while] = sym_while,
  [sym_endwhile] = sym_endwhile,
  [sym_function] = sym_function,
  [sym_endfunction] = sym_endfunction,
  [sym_macro] = sym_macro,
  [sym_endmacro] = sym_endmacro,
  [sym_identifier] = sym_identifier,
  [sym_bracket_argument] = sym_bracket_argument,
  [sym_bracket_comment] = sym_bracket_comment,
  [sym_line_comment] = sym_line_comment,
  [sym_source_file] = sym_source_file,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__escape_encoded] = sym__escape_encoded,
  [sym_variable] = sym_variable,
  [sym_variable_ref] = sym_variable_ref,
  [sym_normal_var] = sym_normal_var,
  [sym_env_var] = sym_env_var,
  [sym_cache_var] = sym_cache_var,
  [sym_gen_exp] = sym_gen_exp,
  [sym__gen_exp_content] = sym__gen_exp_content,
  [sym__gen_exp_arguments] = sym__gen_exp_arguments,
  [sym_argument] = sym_argument,
  [sym__untrimmed_argument] = sym__untrimmed_argument,
  [sym__paren_argument] = sym__paren_argument,
  [sym_quoted_argument] = sym_quoted_argument,
  [sym_quoted_element] = sym_quoted_element,
  [sym_unquoted_argument] = sym_unquoted_argument,
  [sym_if_command] = sym_if_command,
  [sym_elseif_command] = sym_elseif_command,
  [sym_else_command] = sym_else_command,
  [sym_endif_command] = sym_endif_command,
  [sym_if_condition] = sym_if_condition,
  [sym_foreach_command] = sym_foreach_command,
  [sym_endforeach_command] = sym_endforeach_command,
  [sym_foreach_loop] = sym_foreach_loop,
  [sym_while_command] = sym_while_command,
  [sym_endwhile_command] = sym_endwhile_command,
  [sym_while_loop] = sym_while_loop,
  [sym_function_command] = sym_function_command,
  [sym_endfunction_command] = sym_endfunction_command,
  [sym_function_def] = sym_function_def,
  [sym_macro_command] = sym_macro_command,
  [sym_endmacro_command] = sym_endmacro_command,
  [sym_macro_def] = sym_macro_def,
  [sym_normal_command] = sym_normal_command,
  [sym__command_invocation] = sym__command_invocation,
  [sym__untrimmed_command_invocation] = sym__untrimmed_command_invocation,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_variable_repeat1] = aux_sym_variable_repeat1,
  [aux_sym__gen_exp_arguments_repeat1] = aux_sym__gen_exp_arguments_repeat1,
  [aux_sym__paren_argument_repeat1] = aux_sym__paren_argument_repeat1,
  [aux_sym_quoted_element_repeat1] = aux_sym_quoted_element_repeat1,
  [aux_sym_unquoted_argument_repeat1] = aux_sym_unquoted_argument_repeat1,
  [aux_sym_if_command_repeat1] = aux_sym_if_command_repeat1,
  [aux_sym_if_condition_repeat1] = aux_sym_if_condition_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__escape_identity] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_BSLASHt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHn] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_semicolon] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_variable_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ENV] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CACHE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__gen_exp_arguments_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__untrimmed_argument_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_element_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unquoted_argument_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_command_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_else_command_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_endif] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach] = {
    .visible = true,
    .named = true,
  },
  [sym_endforeach] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_endwhile] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_endfunction] = {
    .visible = true,
    .named = true,
  },
  [sym_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_endmacro] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_bracket_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_bracket_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_encoded] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_normal_var] = {
    .visible = true,
    .named = true,
  },
  [sym_env_var] = {
    .visible = true,
    .named = true,
  },
  [sym_cache_var] = {
    .visible = true,
    .named = true,
  },
  [sym_gen_exp] = {
    .visible = true,
    .named = true,
  },
  [sym__gen_exp_content] = {
    .visible = false,
    .named = true,
  },
  [sym__gen_exp_arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__untrimmed_argument] = {
    .visible = false,
    .named = true,
  },
  [sym__paren_argument] = {
    .visible = false,
    .named = true,
  },
  [sym_quoted_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_element] = {
    .visible = true,
    .named = true,
  },
  [sym_unquoted_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_if_command] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_command] = {
    .visible = true,
    .named = true,
  },
  [sym_else_command] = {
    .visible = true,
    .named = true,
  },
  [sym_endif_command] = {
    .visible = true,
    .named = true,
  },
  [sym_if_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_command] = {
    .visible = true,
    .named = true,
  },
  [sym_endforeach_command] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_while_command] = {
    .visible = true,
    .named = true,
  },
  [sym_endwhile_command] = {
    .visible = true,
    .named = true,
  },
  [sym_while_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_function_command] = {
    .visible = true,
    .named = true,
  },
  [sym_endfunction_command] = {
    .visible = true,
    .named = true,
  },
  [sym_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_command] = {
    .visible = true,
    .named = true,
  },
  [sym_endmacro_command] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_def] = {
    .visible = true,
    .named = true,
  },
  [sym_normal_command] = {
    .visible = true,
    .named = true,
  },
  [sym__command_invocation] = {
    .visible = false,
    .named = true,
  },
  [sym__untrimmed_command_invocation] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__gen_exp_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__paren_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_quoted_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unquoted_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_condition_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(21);
      if (lookahead == '"') ADVANCE(40);
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == ')') ADVANCE(39);
      if (lookahead == ',') ADVANCE(36);
      if (lookahead == ':') ADVANCE(35);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '>') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(37);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(37);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(42);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(40);
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == ')') ADVANCE(39);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(42);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(40);
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '>') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '#' &&
          lookahead != ')') ADVANCE(42);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(40);
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == ',') ADVANCE(36);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '>') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(42);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(40);
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead != 0) ADVANCE(41);
      END_STATE();
    case 5:
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == ':') ADVANCE(35);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '>') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(42);
      END_STATE();
    case 6:
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '}') ADVANCE(30);
      if (lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 7:
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == 'C') ADVANCE(8);
      if (lookahead == 'E') ADVANCE(12);
      if (lookahead == '{') ADVANCE(29);
      END_STATE();
    case 8:
      if (lookahead == 'A') ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'C') ADVANCE(11);
      END_STATE();
    case 10:
      if (lookahead == 'E') ADVANCE(32);
      END_STATE();
    case 11:
      if (lookahead == 'H') ADVANCE(10);
      END_STATE();
    case 12:
      if (lookahead == 'N') ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'V') ADVANCE(31);
      END_STATE();
    case 14:
      if (lookahead == 'n') ADVANCE(25);
      if (lookahead == 'r') ADVANCE(24);
      if (lookahead == 't') ADVANCE(23);
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != ';' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(22);
      END_STATE();
    case 15:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(93);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(105);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(79);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(59);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 16:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(100);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(105);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(79);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(59);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 17:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(101);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(105);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(79);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(59);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 18:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(102);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(105);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(79);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(59);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 19:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(103);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(105);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(79);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(59);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 20:
      if (eof) ADVANCE(21);
      if (lookahead == '{') ADVANCE(29);
      if (lookahead == '}') ADVANCE(30);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(105);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(79);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(59);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym__escape_identity);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_BSLASHt);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_BSLASHr);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_BSLASHn);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym__escape_semicolon);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_ENV);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_CACHE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(aux_sym__gen_exp_arguments_token1);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(aux_sym__untrimmed_argument_token1);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(aux_sym_quoted_element_token1);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(aux_sym_unquoted_argument_token1);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(aux_sym_if_command_token1);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(aux_sym_else_command_token1);
      if (lookahead == '$') ADVANCE(28);
      if (lookahead == ';') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(42);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_else_command_token1);
      if (lookahead == ')') ADVANCE(39);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_else_command_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(46);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_elseif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_else);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_endif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_foreach);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_endforeach);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_endwhile);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_function);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_endfunction);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_macro);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_endmacro);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(115);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(111);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 20, .external_lex_state = 2},
  [2] = {.lex_state = 15, .external_lex_state = 2},
  [3] = {.lex_state = 15, .external_lex_state = 2},
  [4] = {.lex_state = 15, .external_lex_state = 2},
  [5] = {.lex_state = 15, .external_lex_state = 2},
  [6] = {.lex_state = 15, .external_lex_state = 2},
  [7] = {.lex_state = 15, .external_lex_state = 2},
  [8] = {.lex_state = 15, .external_lex_state = 2},
  [9] = {.lex_state = 15, .external_lex_state = 2},
  [10] = {.lex_state = 15, .external_lex_state = 2},
  [11] = {.lex_state = 15, .external_lex_state = 2},
  [12] = {.lex_state = 15, .external_lex_state = 2},
  [13] = {.lex_state = 15, .external_lex_state = 2},
  [14] = {.lex_state = 1, .external_lex_state = 1},
  [15] = {.lex_state = 1, .external_lex_state = 1},
  [16] = {.lex_state = 1, .external_lex_state = 1},
  [17] = {.lex_state = 1, .external_lex_state = 1},
  [18] = {.lex_state = 1, .external_lex_state = 1},
  [19] = {.lex_state = 1, .external_lex_state = 1},
  [20] = {.lex_state = 1, .external_lex_state = 1},
  [21] = {.lex_state = 1, .external_lex_state = 1},
  [22] = {.lex_state = 1, .external_lex_state = 1},
  [23] = {.lex_state = 1, .external_lex_state = 1},
  [24] = {.lex_state = 1, .external_lex_state = 1},
  [25] = {.lex_state = 1, .external_lex_state = 1},
  [26] = {.lex_state = 1, .external_lex_state = 1},
  [27] = {.lex_state = 1, .external_lex_state = 1},
  [28] = {.lex_state = 1, .external_lex_state = 1},
  [29] = {.lex_state = 1, .external_lex_state = 1},
  [30] = {.lex_state = 1, .external_lex_state = 1},
  [31] = {.lex_state = 1, .external_lex_state = 1},
  [32] = {.lex_state = 1, .external_lex_state = 1},
  [33] = {.lex_state = 1, .external_lex_state = 1},
  [34] = {.lex_state = 1, .external_lex_state = 1},
  [35] = {.lex_state = 1, .external_lex_state = 1},
  [36] = {.lex_state = 1, .external_lex_state = 1},
  [37] = {.lex_state = 1, .external_lex_state = 1},
  [38] = {.lex_state = 1, .external_lex_state = 1},
  [39] = {.lex_state = 1, .external_lex_state = 1},
  [40] = {.lex_state = 1, .external_lex_state = 1},
  [41] = {.lex_state = 1, .external_lex_state = 1},
  [42] = {.lex_state = 1, .external_lex_state = 1},
  [43] = {.lex_state = 1, .external_lex_state = 1},
  [44] = {.lex_state = 1, .external_lex_state = 1},
  [45] = {.lex_state = 1, .external_lex_state = 1},
  [46] = {.lex_state = 1, .external_lex_state = 1},
  [47] = {.lex_state = 1, .external_lex_state = 1},
  [48] = {.lex_state = 1, .external_lex_state = 1},
  [49] = {.lex_state = 1, .external_lex_state = 1},
  [50] = {.lex_state = 1, .external_lex_state = 1},
  [51] = {.lex_state = 1, .external_lex_state = 1},
  [52] = {.lex_state = 1, .external_lex_state = 1},
  [53] = {.lex_state = 1, .external_lex_state = 1},
  [54] = {.lex_state = 1, .external_lex_state = 1},
  [55] = {.lex_state = 1, .external_lex_state = 1},
  [56] = {.lex_state = 1, .external_lex_state = 1},
  [57] = {.lex_state = 1, .external_lex_state = 1},
  [58] = {.lex_state = 1, .external_lex_state = 1},
  [59] = {.lex_state = 1, .external_lex_state = 1},
  [60] = {.lex_state = 1, .external_lex_state = 1},
  [61] = {.lex_state = 1, .external_lex_state = 1},
  [62] = {.lex_state = 1, .external_lex_state = 1},
  [63] = {.lex_state = 1, .external_lex_state = 1},
  [64] = {.lex_state = 1, .external_lex_state = 1},
  [65] = {.lex_state = 1, .external_lex_state = 1},
  [66] = {.lex_state = 1, .external_lex_state = 1},
  [67] = {.lex_state = 1, .external_lex_state = 1},
  [68] = {.lex_state = 1, .external_lex_state = 1},
  [69] = {.lex_state = 1, .external_lex_state = 1},
  [70] = {.lex_state = 1, .external_lex_state = 1},
  [71] = {.lex_state = 1, .external_lex_state = 1},
  [72] = {.lex_state = 1, .external_lex_state = 1},
  [73] = {.lex_state = 1, .external_lex_state = 1},
  [74] = {.lex_state = 1, .external_lex_state = 1},
  [75] = {.lex_state = 1, .external_lex_state = 1},
  [76] = {.lex_state = 1, .external_lex_state = 1},
  [77] = {.lex_state = 1, .external_lex_state = 1},
  [78] = {.lex_state = 1, .external_lex_state = 1},
  [79] = {.lex_state = 1, .external_lex_state = 1},
  [80] = {.lex_state = 15, .external_lex_state = 2},
  [81] = {.lex_state = 1, .external_lex_state = 1},
  [82] = {.lex_state = 1, .external_lex_state = 1},
  [83] = {.lex_state = 1, .external_lex_state = 1},
  [84] = {.lex_state = 1, .external_lex_state = 1},
  [85] = {.lex_state = 1, .external_lex_state = 1},
  [86] = {.lex_state = 1, .external_lex_state = 1},
  [87] = {.lex_state = 1, .external_lex_state = 1},
  [88] = {.lex_state = 1, .external_lex_state = 1},
  [89] = {.lex_state = 1, .external_lex_state = 1},
  [90] = {.lex_state = 1, .external_lex_state = 1},
  [91] = {.lex_state = 1, .external_lex_state = 1},
  [92] = {.lex_state = 1, .external_lex_state = 1},
  [93] = {.lex_state = 1, .external_lex_state = 1},
  [94] = {.lex_state = 1, .external_lex_state = 1},
  [95] = {.lex_state = 1, .external_lex_state = 1},
  [96] = {.lex_state = 1, .external_lex_state = 1},
  [97] = {.lex_state = 1, .external_lex_state = 1},
  [98] = {.lex_state = 1, .external_lex_state = 1},
  [99] = {.lex_state = 1, .external_lex_state = 1},
  [100] = {.lex_state = 1, .external_lex_state = 1},
  [101] = {.lex_state = 1, .external_lex_state = 1},
  [102] = {.lex_state = 1, .external_lex_state = 1},
  [103] = {.lex_state = 1, .external_lex_state = 1},
  [104] = {.lex_state = 1, .external_lex_state = 1},
  [105] = {.lex_state = 1, .external_lex_state = 1},
  [106] = {.lex_state = 1, .external_lex_state = 1},
  [107] = {.lex_state = 1, .external_lex_state = 1},
  [108] = {.lex_state = 1, .external_lex_state = 1},
  [109] = {.lex_state = 1, .external_lex_state = 1},
  [110] = {.lex_state = 1, .external_lex_state = 1},
  [111] = {.lex_state = 1, .external_lex_state = 1},
  [112] = {.lex_state = 1, .external_lex_state = 1},
  [113] = {.lex_state = 1, .external_lex_state = 1},
  [114] = {.lex_state = 16, .external_lex_state = 2},
  [115] = {.lex_state = 19, .external_lex_state = 2},
  [116] = {.lex_state = 19, .external_lex_state = 2},
  [117] = {.lex_state = 17, .external_lex_state = 2},
  [118] = {.lex_state = 19, .external_lex_state = 2},
  [119] = {.lex_state = 16, .external_lex_state = 2},
  [120] = {.lex_state = 17, .external_lex_state = 2},
  [121] = {.lex_state = 18, .external_lex_state = 2},
  [122] = {.lex_state = 17, .external_lex_state = 2},
  [123] = {.lex_state = 18, .external_lex_state = 2},
  [124] = {.lex_state = 17, .external_lex_state = 2},
  [125] = {.lex_state = 16, .external_lex_state = 2},
  [126] = {.lex_state = 18, .external_lex_state = 2},
  [127] = {.lex_state = 18, .external_lex_state = 2},
  [128] = {.lex_state = 16, .external_lex_state = 2},
  [129] = {.lex_state = 16, .external_lex_state = 2},
  [130] = {.lex_state = 17, .external_lex_state = 2},
  [131] = {.lex_state = 17, .external_lex_state = 2},
  [132] = {.lex_state = 17, .external_lex_state = 2},
  [133] = {.lex_state = 16, .external_lex_state = 2},
  [134] = {.lex_state = 17, .external_lex_state = 2},
  [135] = {.lex_state = 18, .external_lex_state = 2},
  [136] = {.lex_state = 19, .external_lex_state = 2},
  [137] = {.lex_state = 17, .external_lex_state = 2},
  [138] = {.lex_state = 16, .external_lex_state = 2},
  [139] = {.lex_state = 16, .external_lex_state = 2},
  [140] = {.lex_state = 16, .external_lex_state = 2},
  [141] = {.lex_state = 18, .external_lex_state = 2},
  [142] = {.lex_state = 17, .external_lex_state = 2},
  [143] = {.lex_state = 19, .external_lex_state = 2},
  [144] = {.lex_state = 18, .external_lex_state = 2},
  [145] = {.lex_state = 19, .external_lex_state = 2},
  [146] = {.lex_state = 19, .external_lex_state = 2},
  [147] = {.lex_state = 18, .external_lex_state = 2},
  [148] = {.lex_state = 16, .external_lex_state = 2},
  [149] = {.lex_state = 17, .external_lex_state = 2},
  [150] = {.lex_state = 19, .external_lex_state = 2},
  [151] = {.lex_state = 18, .external_lex_state = 2},
  [152] = {.lex_state = 16, .external_lex_state = 2},
  [153] = {.lex_state = 18, .external_lex_state = 2},
  [154] = {.lex_state = 18, .external_lex_state = 2},
  [155] = {.lex_state = 19, .external_lex_state = 2},
  [156] = {.lex_state = 17, .external_lex_state = 2},
  [157] = {.lex_state = 19, .external_lex_state = 2},
  [158] = {.lex_state = 16, .external_lex_state = 2},
  [159] = {.lex_state = 19, .external_lex_state = 2},
  [160] = {.lex_state = 18, .external_lex_state = 2},
  [161] = {.lex_state = 19, .external_lex_state = 2},
  [162] = {.lex_state = 16, .external_lex_state = 2},
  [163] = {.lex_state = 20, .external_lex_state = 2},
  [164] = {.lex_state = 20, .external_lex_state = 2},
  [165] = {.lex_state = 17, .external_lex_state = 2},
  [166] = {.lex_state = 18, .external_lex_state = 2},
  [167] = {.lex_state = 19, .external_lex_state = 2},
  [168] = {.lex_state = 1, .external_lex_state = 1},
  [169] = {.lex_state = 2, .external_lex_state = 3},
  [170] = {.lex_state = 2, .external_lex_state = 3},
  [171] = {.lex_state = 2, .external_lex_state = 3},
  [172] = {.lex_state = 2, .external_lex_state = 3},
  [173] = {.lex_state = 1, .external_lex_state = 1},
  [174] = {.lex_state = 2, .external_lex_state = 3},
  [175] = {.lex_state = 2, .external_lex_state = 3},
  [176] = {.lex_state = 2, .external_lex_state = 3},
  [177] = {.lex_state = 2, .external_lex_state = 3},
  [178] = {.lex_state = 2, .external_lex_state = 3},
  [179] = {.lex_state = 1, .external_lex_state = 3},
  [180] = {.lex_state = 1, .external_lex_state = 3},
  [181] = {.lex_state = 1, .external_lex_state = 3},
  [182] = {.lex_state = 1, .external_lex_state = 3},
  [183] = {.lex_state = 1, .external_lex_state = 3},
  [184] = {.lex_state = 1, .external_lex_state = 3},
  [185] = {.lex_state = 1, .external_lex_state = 3},
  [186] = {.lex_state = 1, .external_lex_state = 3},
  [187] = {.lex_state = 1, .external_lex_state = 3},
  [188] = {.lex_state = 1, .external_lex_state = 3},
  [189] = {.lex_state = 1, .external_lex_state = 3},
  [190] = {.lex_state = 1, .external_lex_state = 3},
  [191] = {.lex_state = 1, .external_lex_state = 3},
  [192] = {.lex_state = 1, .external_lex_state = 3},
  [193] = {.lex_state = 1, .external_lex_state = 3},
  [194] = {.lex_state = 1, .external_lex_state = 3},
  [195] = {.lex_state = 1, .external_lex_state = 3},
  [196] = {.lex_state = 1, .external_lex_state = 3},
  [197] = {.lex_state = 1, .external_lex_state = 3},
  [198] = {.lex_state = 1, .external_lex_state = 3},
  [199] = {.lex_state = 1, .external_lex_state = 3},
  [200] = {.lex_state = 1, .external_lex_state = 3},
  [201] = {.lex_state = 1, .external_lex_state = 3},
  [202] = {.lex_state = 1, .external_lex_state = 3},
  [203] = {.lex_state = 1, .external_lex_state = 3},
  [204] = {.lex_state = 1, .external_lex_state = 3},
  [205] = {.lex_state = 1, .external_lex_state = 3},
  [206] = {.lex_state = 1, .external_lex_state = 3},
  [207] = {.lex_state = 1, .external_lex_state = 3},
  [208] = {.lex_state = 1, .external_lex_state = 3},
  [209] = {.lex_state = 1, .external_lex_state = 3},
  [210] = {.lex_state = 1, .external_lex_state = 3},
  [211] = {.lex_state = 1, .external_lex_state = 3},
  [212] = {.lex_state = 1, .external_lex_state = 3},
  [213] = {.lex_state = 1, .external_lex_state = 3},
  [214] = {.lex_state = 1, .external_lex_state = 3},
  [215] = {.lex_state = 1, .external_lex_state = 3},
  [216] = {.lex_state = 1, .external_lex_state = 3},
  [217] = {.lex_state = 3, .external_lex_state = 3},
  [218] = {.lex_state = 3, .external_lex_state = 3},
  [219] = {.lex_state = 4},
  [220] = {.lex_state = 4},
  [221] = {.lex_state = 5},
  [222] = {.lex_state = 4},
  [223] = {.lex_state = 4},
  [224] = {.lex_state = 5},
  [225] = {.lex_state = 4},
  [226] = {.lex_state = 1},
  [227] = {.lex_state = 4},
  [228] = {.lex_state = 44},
  [229] = {.lex_state = 44},
  [230] = {.lex_state = 1},
  [231] = {.lex_state = 6},
  [232] = {.lex_state = 6},
  [233] = {.lex_state = 6},
  [234] = {.lex_state = 6},
  [235] = {.lex_state = 6},
  [236] = {.lex_state = 6},
  [237] = {.lex_state = 6},
  [238] = {.lex_state = 6},
  [239] = {.lex_state = 6},
  [240] = {.lex_state = 6},
  [241] = {.lex_state = 6},
  [242] = {.lex_state = 6},
  [243] = {.lex_state = 6},
  [244] = {.lex_state = 6},
  [245] = {.lex_state = 6},
  [246] = {.lex_state = 6},
  [247] = {.lex_state = 6},
  [248] = {.lex_state = 6},
  [249] = {.lex_state = 6},
  [250] = {.lex_state = 6},
  [251] = {.lex_state = 6},
  [252] = {.lex_state = 6},
  [253] = {.lex_state = 6},
  [254] = {.lex_state = 1, .external_lex_state = 1},
  [255] = {.lex_state = 1, .external_lex_state = 1},
  [256] = {.lex_state = 1, .external_lex_state = 1},
  [257] = {.lex_state = 1, .external_lex_state = 1},
  [258] = {.lex_state = 1, .external_lex_state = 1},
  [259] = {.lex_state = 1, .external_lex_state = 1},
  [260] = {.lex_state = 1, .external_lex_state = 1},
  [261] = {.lex_state = 1, .external_lex_state = 1},
  [262] = {.lex_state = 1, .external_lex_state = 1},
  [263] = {.lex_state = 1, .external_lex_state = 1},
  [264] = {.lex_state = 1, .external_lex_state = 1},
  [265] = {.lex_state = 1, .external_lex_state = 1},
  [266] = {.lex_state = 15, .external_lex_state = 2},
  [267] = {.lex_state = 15, .external_lex_state = 2},
  [268] = {.lex_state = 15, .external_lex_state = 2},
  [269] = {.lex_state = 15, .external_lex_state = 2},
  [270] = {.lex_state = 15, .external_lex_state = 2},
  [271] = {.lex_state = 15, .external_lex_state = 2},
  [272] = {.lex_state = 15, .external_lex_state = 2},
  [273] = {.lex_state = 15, .external_lex_state = 2},
  [274] = {.lex_state = 15, .external_lex_state = 2},
  [275] = {.lex_state = 15, .external_lex_state = 2},
  [276] = {.lex_state = 15, .external_lex_state = 2},
  [277] = {.lex_state = 15, .external_lex_state = 2},
  [278] = {.lex_state = 15, .external_lex_state = 2},
  [279] = {.lex_state = 15, .external_lex_state = 2},
  [280] = {.lex_state = 15, .external_lex_state = 2},
  [281] = {.lex_state = 15, .external_lex_state = 2},
  [282] = {.lex_state = 15, .external_lex_state = 2},
  [283] = {.lex_state = 15, .external_lex_state = 2},
  [284] = {.lex_state = 15, .external_lex_state = 2},
  [285] = {.lex_state = 15, .external_lex_state = 2},
  [286] = {.lex_state = 15, .external_lex_state = 2},
  [287] = {.lex_state = 15, .external_lex_state = 2},
  [288] = {.lex_state = 15, .external_lex_state = 2},
  [289] = {.lex_state = 15, .external_lex_state = 2},
  [290] = {.lex_state = 15, .external_lex_state = 2},
  [291] = {.lex_state = 15, .external_lex_state = 2},
  [292] = {.lex_state = 15, .external_lex_state = 2},
  [293] = {.lex_state = 15, .external_lex_state = 2},
  [294] = {.lex_state = 15, .external_lex_state = 2},
  [295] = {.lex_state = 15, .external_lex_state = 2},
  [296] = {.lex_state = 15, .external_lex_state = 2},
  [297] = {.lex_state = 15, .external_lex_state = 2},
  [298] = {.lex_state = 15, .external_lex_state = 2},
  [299] = {.lex_state = 15, .external_lex_state = 2},
  [300] = {.lex_state = 15, .external_lex_state = 2},
  [301] = {.lex_state = 15, .external_lex_state = 2},
  [302] = {.lex_state = 15, .external_lex_state = 2},
  [303] = {.lex_state = 15, .external_lex_state = 2},
  [304] = {.lex_state = 15, .external_lex_state = 2},
  [305] = {.lex_state = 15, .external_lex_state = 2},
  [306] = {.lex_state = 3, .external_lex_state = 3},
  [307] = {.lex_state = 3, .external_lex_state = 3},
  [308] = {.lex_state = 3, .external_lex_state = 3},
  [309] = {.lex_state = 3, .external_lex_state = 3},
  [310] = {.lex_state = 3, .external_lex_state = 3},
  [311] = {.lex_state = 3, .external_lex_state = 3},
  [312] = {.lex_state = 3, .external_lex_state = 3},
  [313] = {.lex_state = 3, .external_lex_state = 3},
  [314] = {.lex_state = 3, .external_lex_state = 3},
  [315] = {.lex_state = 3, .external_lex_state = 3},
  [316] = {.lex_state = 3, .external_lex_state = 3},
  [317] = {.lex_state = 18, .external_lex_state = 2},
  [318] = {.lex_state = 18, .external_lex_state = 2},
  [319] = {.lex_state = 20, .external_lex_state = 2},
  [320] = {.lex_state = 20, .external_lex_state = 2},
  [321] = {.lex_state = 18, .external_lex_state = 2},
  [322] = {.lex_state = 20, .external_lex_state = 2},
  [323] = {.lex_state = 18, .external_lex_state = 2},
  [324] = {.lex_state = 20, .external_lex_state = 2},
  [325] = {.lex_state = 20, .external_lex_state = 2},
  [326] = {.lex_state = 18, .external_lex_state = 2},
  [327] = {.lex_state = 18, .external_lex_state = 2},
  [328] = {.lex_state = 18, .external_lex_state = 2},
  [329] = {.lex_state = 18, .external_lex_state = 2},
  [330] = {.lex_state = 19, .external_lex_state = 2},
  [331] = {.lex_state = 19, .external_lex_state = 2},
  [332] = {.lex_state = 19, .external_lex_state = 2},
  [333] = {.lex_state = 19, .external_lex_state = 2},
  [334] = {.lex_state = 19, .external_lex_state = 2},
  [335] = {.lex_state = 20, .external_lex_state = 2},
  [336] = {.lex_state = 16, .external_lex_state = 2},
  [337] = {.lex_state = 16, .external_lex_state = 2},
  [338] = {.lex_state = 16, .external_lex_state = 2},
  [339] = {.lex_state = 19, .external_lex_state = 2},
  [340] = {.lex_state = 19, .external_lex_state = 2},
  [341] = {.lex_state = 19, .external_lex_state = 2},
  [342] = {.lex_state = 19, .external_lex_state = 2},
  [343] = {.lex_state = 19, .external_lex_state = 2},
  [344] = {.lex_state = 19, .external_lex_state = 2},
  [345] = {.lex_state = 16, .external_lex_state = 2},
  [346] = {.lex_state = 19, .external_lex_state = 2},
  [347] = {.lex_state = 19, .external_lex_state = 2},
  [348] = {.lex_state = 19, .external_lex_state = 2},
  [349] = {.lex_state = 19, .external_lex_state = 2},
  [350] = {.lex_state = 19, .external_lex_state = 2},
  [351] = {.lex_state = 19, .external_lex_state = 2},
  [352] = {.lex_state = 16, .external_lex_state = 2},
  [353] = {.lex_state = 19, .external_lex_state = 2},
  [354] = {.lex_state = 19, .external_lex_state = 2},
  [355] = {.lex_state = 19, .external_lex_state = 2},
  [356] = {.lex_state = 19, .external_lex_state = 2},
  [357] = {.lex_state = 19, .external_lex_state = 2},
  [358] = {.lex_state = 19, .external_lex_state = 2},
  [359] = {.lex_state = 20, .external_lex_state = 2},
  [360] = {.lex_state = 17, .external_lex_state = 2},
  [361] = {.lex_state = 19, .external_lex_state = 2},
  [362] = {.lex_state = 19, .external_lex_state = 2},
  [363] = {.lex_state = 19, .external_lex_state = 2},
  [364] = {.lex_state = 20, .external_lex_state = 2},
  [365] = {.lex_state = 19, .external_lex_state = 2},
  [366] = {.lex_state = 19, .external_lex_state = 2},
  [367] = {.lex_state = 19, .external_lex_state = 2},
  [368] = {.lex_state = 19, .external_lex_state = 2},
  [369] = {.lex_state = 19, .external_lex_state = 2},
  [370] = {.lex_state = 17, .external_lex_state = 2},
  [371] = {.lex_state = 17, .external_lex_state = 2},
  [372] = {.lex_state = 17, .external_lex_state = 2},
  [373] = {.lex_state = 17, .external_lex_state = 2},
  [374] = {.lex_state = 17, .external_lex_state = 2},
  [375] = {.lex_state = 18, .external_lex_state = 2},
  [376] = {.lex_state = 16, .external_lex_state = 2},
  [377] = {.lex_state = 17, .external_lex_state = 2},
  [378] = {.lex_state = 17, .external_lex_state = 2},
  [379] = {.lex_state = 17, .external_lex_state = 2},
  [380] = {.lex_state = 17, .external_lex_state = 2},
  [381] = {.lex_state = 17, .external_lex_state = 2},
  [382] = {.lex_state = 17, .external_lex_state = 2},
  [383] = {.lex_state = 17, .external_lex_state = 2},
  [384] = {.lex_state = 17, .external_lex_state = 2},
  [385] = {.lex_state = 17, .external_lex_state = 2},
  [386] = {.lex_state = 17, .external_lex_state = 2},
  [387] = {.lex_state = 17, .external_lex_state = 2},
  [388] = {.lex_state = 17, .external_lex_state = 2},
  [389] = {.lex_state = 16, .external_lex_state = 2},
  [390] = {.lex_state = 17, .external_lex_state = 2},
  [391] = {.lex_state = 17, .external_lex_state = 2},
  [392] = {.lex_state = 17, .external_lex_state = 2},
  [393] = {.lex_state = 17, .external_lex_state = 2},
  [394] = {.lex_state = 17, .external_lex_state = 2},
  [395] = {.lex_state = 17, .external_lex_state = 2},
  [396] = {.lex_state = 16, .external_lex_state = 2},
  [397] = {.lex_state = 18, .external_lex_state = 2},
  [398] = {.lex_state = 17, .external_lex_state = 2},
  [399] = {.lex_state = 17, .external_lex_state = 2},
  [400] = {.lex_state = 17, .external_lex_state = 2},
  [401] = {.lex_state = 16, .external_lex_state = 2},
  [402] = {.lex_state = 16, .external_lex_state = 2},
  [403] = {.lex_state = 17, .external_lex_state = 2},
  [404] = {.lex_state = 17, .external_lex_state = 2},
  [405] = {.lex_state = 17, .external_lex_state = 2},
  [406] = {.lex_state = 17, .external_lex_state = 2},
  [407] = {.lex_state = 18, .external_lex_state = 2},
  [408] = {.lex_state = 18, .external_lex_state = 2},
  [409] = {.lex_state = 18, .external_lex_state = 2},
  [410] = {.lex_state = 18, .external_lex_state = 2},
  [411] = {.lex_state = 16, .external_lex_state = 2},
  [412] = {.lex_state = 18, .external_lex_state = 2},
  [413] = {.lex_state = 16, .external_lex_state = 2},
  [414] = {.lex_state = 16, .external_lex_state = 2},
  [415] = {.lex_state = 18, .external_lex_state = 2},
  [416] = {.lex_state = 18, .external_lex_state = 2},
  [417] = {.lex_state = 18, .external_lex_state = 2},
  [418] = {.lex_state = 18, .external_lex_state = 2},
  [419] = {.lex_state = 20, .external_lex_state = 2},
  [420] = {.lex_state = 16, .external_lex_state = 2},
  [421] = {.lex_state = 18, .external_lex_state = 2},
  [422] = {.lex_state = 20, .external_lex_state = 2},
  [423] = {.lex_state = 18, .external_lex_state = 2},
  [424] = {.lex_state = 20, .external_lex_state = 2},
  [425] = {.lex_state = 20, .external_lex_state = 2},
  [426] = {.lex_state = 20, .external_lex_state = 2},
  [427] = {.lex_state = 18, .external_lex_state = 2},
  [428] = {.lex_state = 20, .external_lex_state = 2},
  [429] = {.lex_state = 18, .external_lex_state = 2},
  [430] = {.lex_state = 18, .external_lex_state = 2},
  [431] = {.lex_state = 18, .external_lex_state = 2},
  [432] = {.lex_state = 18, .external_lex_state = 2},
  [433] = {.lex_state = 16, .external_lex_state = 2},
  [434] = {.lex_state = 16, .external_lex_state = 2},
  [435] = {.lex_state = 20, .external_lex_state = 2},
  [436] = {.lex_state = 20, .external_lex_state = 2},
  [437] = {.lex_state = 20, .external_lex_state = 2},
  [438] = {.lex_state = 16, .external_lex_state = 2},
  [439] = {.lex_state = 20, .external_lex_state = 2},
  [440] = {.lex_state = 18, .external_lex_state = 2},
  [441] = {.lex_state = 18, .external_lex_state = 2},
  [442] = {.lex_state = 18, .external_lex_state = 2},
  [443] = {.lex_state = 20, .external_lex_state = 2},
  [444] = {.lex_state = 16, .external_lex_state = 2},
  [445] = {.lex_state = 18, .external_lex_state = 2},
  [446] = {.lex_state = 18, .external_lex_state = 2},
  [447] = {.lex_state = 18, .external_lex_state = 2},
  [448] = {.lex_state = 20, .external_lex_state = 2},
  [449] = {.lex_state = 19, .external_lex_state = 2},
  [450] = {.lex_state = 17, .external_lex_state = 2},
  [451] = {.lex_state = 20, .external_lex_state = 2},
  [452] = {.lex_state = 17, .external_lex_state = 2},
  [453] = {.lex_state = 16, .external_lex_state = 2},
  [454] = {.lex_state = 16, .external_lex_state = 2},
  [455] = {.lex_state = 16, .external_lex_state = 2},
  [456] = {.lex_state = 16, .external_lex_state = 2},
  [457] = {.lex_state = 16, .external_lex_state = 2},
  [458] = {.lex_state = 20, .external_lex_state = 2},
  [459] = {.lex_state = 19, .external_lex_state = 2},
  [460] = {.lex_state = 16, .external_lex_state = 2},
  [461] = {.lex_state = 16, .external_lex_state = 2},
  [462] = {.lex_state = 18, .external_lex_state = 2},
  [463] = {.lex_state = 16, .external_lex_state = 2},
  [464] = {.lex_state = 16, .external_lex_state = 2},
  [465] = {.lex_state = 16, .external_lex_state = 2},
  [466] = {.lex_state = 20, .external_lex_state = 2},
  [467] = {.lex_state = 20, .external_lex_state = 2},
  [468] = {.lex_state = 16, .external_lex_state = 2},
  [469] = {.lex_state = 20, .external_lex_state = 2},
  [470] = {.lex_state = 16, .external_lex_state = 2},
  [471] = {.lex_state = 16, .external_lex_state = 2},
  [472] = {.lex_state = 20, .external_lex_state = 2},
  [473] = {.lex_state = 20, .external_lex_state = 2},
  [474] = {.lex_state = 20, .external_lex_state = 2},
  [475] = {.lex_state = 20, .external_lex_state = 2},
  [476] = {.lex_state = 20, .external_lex_state = 2},
  [477] = {.lex_state = 16, .external_lex_state = 2},
  [478] = {.lex_state = 16, .external_lex_state = 2},
  [479] = {.lex_state = 2, .external_lex_state = 3},
  [480] = {.lex_state = 5},
  [481] = {.lex_state = 5},
  [482] = {.lex_state = 5},
  [483] = {.lex_state = 5},
  [484] = {.lex_state = 5},
  [485] = {.lex_state = 5},
  [486] = {.lex_state = 5},
  [487] = {.lex_state = 44},
  [488] = {.lex_state = 1},
  [489] = {.lex_state = 6},
  [490] = {.lex_state = 1},
  [491] = {.lex_state = 4},
  [492] = {.lex_state = 6},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 1},
  [497] = {.lex_state = 4},
  [498] = {.lex_state = 4},
  [499] = {.lex_state = 1},
  [500] = {.lex_state = 4},
  [501] = {.lex_state = 4},
  [502] = {.lex_state = 4},
  [503] = {.lex_state = 44},
  [504] = {.lex_state = 44},
  [505] = {.lex_state = 44},
  [506] = {.lex_state = 44},
  [507] = {.lex_state = 1},
  [508] = {.lex_state = 4},
  [509] = {.lex_state = 1},
  [510] = {.lex_state = 44},
  [511] = {.lex_state = 1},
  [512] = {.lex_state = 44},
  [513] = {.lex_state = 7},
  [514] = {.lex_state = 7},
  [515] = {.lex_state = 7},
  [516] = {.lex_state = 7},
  [517] = {.lex_state = 7},
  [518] = {.lex_state = 7},
  [519] = {.lex_state = 2},
  [520] = {.lex_state = 2},
  [521] = {.lex_state = 2},
  [522] = {.lex_state = 2},
  [523] = {.lex_state = 2},
  [524] = {.lex_state = 2},
  [525] = {.lex_state = 2},
  [526] = {.lex_state = 2},
  [527] = {.lex_state = 2},
  [528] = {.lex_state = 2},
  [529] = {.lex_state = 2},
  [530] = {.lex_state = 2},
  [531] = {.lex_state = 2},
  [532] = {.lex_state = 2},
  [533] = {.lex_state = 2},
  [534] = {.lex_state = 2},
  [535] = {.lex_state = 2},
  [536] = {.lex_state = 2},
  [537] = {.lex_state = 2},
  [538] = {.lex_state = 2},
  [539] = {.lex_state = 2},
  [540] = {.lex_state = 2},
  [541] = {.lex_state = 2},
  [542] = {.lex_state = 2},
  [543] = {.lex_state = 2},
  [544] = {.lex_state = 2},
  [545] = {.lex_state = 2},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 2},
  [548] = {.lex_state = 2},
  [549] = {.lex_state = 2},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 2},
  [552] = {.lex_state = 7},
  [553] = {.lex_state = 2},
  [554] = {.lex_state = 2},
  [555] = {.lex_state = 2},
  [556] = {.lex_state = 2},
  [557] = {.lex_state = 2},
  [558] = {.lex_state = 2},
  [559] = {.lex_state = 2},
  [560] = {.lex_state = 2},
  [561] = {.lex_state = 2},
  [562] = {.lex_state = 2},
  [563] = {.lex_state = 2},
  [564] = {.lex_state = 2},
  [565] = {.lex_state = 2},
  [566] = {.lex_state = 2},
  [567] = {.lex_state = 2},
  [568] = {.lex_state = 2},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 2},
  [571] = {.lex_state = 2},
  [572] = {.lex_state = 2},
  [573] = {.lex_state = 2},
  [574] = {.lex_state = 2},
  [575] = {.lex_state = 2},
  [576] = {.lex_state = 2},
  [577] = {.lex_state = 2},
  [578] = {.lex_state = 2},
  [579] = {.lex_state = 2},
  [580] = {.lex_state = 2},
  [581] = {.lex_state = 2},
  [582] = {.lex_state = 2},
  [583] = {.lex_state = 2},
  [584] = {.lex_state = 2},
  [585] = {.lex_state = 2},
  [586] = {.lex_state = 2},
  [587] = {.lex_state = 2},
  [588] = {.lex_state = 2},
  [589] = {.lex_state = 2},
  [590] = {.lex_state = 2},
  [591] = {.lex_state = 2},
  [592] = {.lex_state = 2},
  [593] = {.lex_state = 2},
  [594] = {.lex_state = 2},
  [595] = {.lex_state = 2},
  [596] = {.lex_state = 2},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 2},
  [599] = {.lex_state = 2},
  [600] = {.lex_state = 2},
  [601] = {.lex_state = 2},
  [602] = {.lex_state = 2},
  [603] = {.lex_state = 2},
  [604] = {.lex_state = 2},
  [605] = {.lex_state = 2},
  [606] = {.lex_state = 2},
  [607] = {.lex_state = 2},
  [608] = {.lex_state = 2},
  [609] = {.lex_state = 2},
  [610] = {.lex_state = 2},
  [611] = {.lex_state = 45},
  [612] = {.lex_state = 45},
  [613] = {.lex_state = 45},
  [614] = {.lex_state = 45},
  [615] = {.lex_state = 45},
  [616] = {.lex_state = 45},
  [617] = {.lex_state = 45},
  [618] = {.lex_state = 45},
  [619] = {.lex_state = 45},
  [620] = {.lex_state = 45},
  [621] = {.lex_state = 45},
  [622] = {.lex_state = 45},
  [623] = {.lex_state = 45},
  [624] = {.lex_state = 45},
  [625] = {.lex_state = 45},
  [626] = {.lex_state = 45},
  [627] = {.lex_state = 45},
  [628] = {.lex_state = 45},
  [629] = {.lex_state = 45},
  [630] = {.lex_state = 45},
  [631] = {.lex_state = 45},
  [632] = {.lex_state = 45},
  [633] = {.lex_state = 45},
  [634] = {.lex_state = 45},
  [635] = {.lex_state = 45},
  [636] = {.lex_state = 45},
  [637] = {.lex_state = 46},
  [638] = {.lex_state = 46},
  [639] = {.lex_state = 46},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 46},
  [642] = {.lex_state = 46},
  [643] = {.lex_state = 20},
  [644] = {.lex_state = 20},
  [645] = {.lex_state = 20},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 46},
  [653] = {.lex_state = 46},
  [654] = {.lex_state = 46},
  [655] = {.lex_state = 46},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 20},
  [658] = {.lex_state = 20},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 20},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 20},
  [667] = {.lex_state = 20},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 20},
  [670] = {.lex_state = 20},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 46},
  [673] = {.lex_state = 46},
  [674] = {.lex_state = 46},
  [675] = {.lex_state = 46},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 20},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 20},
  [682] = {.lex_state = 20},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 20},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 46},
  [693] = {.lex_state = 46},
  [694] = {.lex_state = 46},
  [695] = {.lex_state = 46},
  [696] = {.lex_state = 20},
  [697] = {.lex_state = 20},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 20},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 46},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 20},
  [708] = {.lex_state = 46},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 46},
  [713] = {.lex_state = 46},
  [714] = {.lex_state = 46},
  [715] = {.lex_state = 46},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 46},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 20},
  [720] = {.lex_state = 20},
  [721] = {.lex_state = 46},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 46},
  [724] = {.lex_state = 20},
  [725] = {.lex_state = 20},
  [726] = {.lex_state = 20},
  [727] = {.lex_state = 46},
  [728] = {.lex_state = 20},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 46},
  [731] = {.lex_state = 20},
  [732] = {.lex_state = 20},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 20},
  [738] = {.lex_state = 20},
  [739] = {.lex_state = 20},
  [740] = {.lex_state = 20},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 46},
  [743] = {.lex_state = 20},
  [744] = {.lex_state = 20},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 20},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 20},
  [750] = {.lex_state = 20},
};

enum {
  ts_external_token_bracket_argument = 0,
  ts_external_token_bracket_comment = 1,
  ts_external_token_line_comment = 2,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_bracket_argument] = sym_bracket_argument,
  [ts_external_token_bracket_comment] = sym_bracket_comment,
  [ts_external_token_line_comment] = sym_line_comment,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_bracket_argument] = true,
    [ts_external_token_bracket_comment] = true,
    [ts_external_token_line_comment] = true,
  },
  [2] = {
    [ts_external_token_bracket_comment] = true,
    [ts_external_token_line_comment] = true,
  },
  [3] = {
    [ts_external_token_bracket_argument] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__escape_identity] = ACTIONS(1),
    [anon_sym_BSLASHt] = ACTIONS(1),
    [anon_sym_BSLASHr] = ACTIONS(1),
    [anon_sym_BSLASHn] = ACTIONS(1),
    [sym__escape_semicolon] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [aux_sym__gen_exp_arguments_token1] = ACTIONS(1),
    [aux_sym__untrimmed_argument_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_unquoted_argument_token1] = ACTIONS(1),
    [aux_sym_if_command_token1] = ACTIONS(1),
    [sym_bracket_argument] = ACTIONS(1),
    [sym_bracket_comment] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(741),
    [sym_if_command] = STATE(9),
    [sym_if_condition] = STATE(163),
    [sym_foreach_command] = STATE(138),
    [sym_foreach_loop] = STATE(163),
    [sym_while_command] = STATE(154),
    [sym_while_loop] = STATE(163),
    [sym_function_command] = STATE(157),
    [sym_function_def] = STATE(163),
    [sym_macro_command] = STATE(132),
    [sym_macro_def] = STATE(163),
    [sym_normal_command] = STATE(163),
    [sym__command_invocation] = STATE(163),
    [sym__untrimmed_command_invocation] = STATE(163),
    [aux_sym_source_file_repeat1] = STATE(163),
    [ts_builtin_sym_end] = ACTIONS(3),
    [aux_sym__untrimmed_argument_token1] = ACTIONS(5),
    [sym_if] = ACTIONS(7),
    [sym_foreach] = ACTIONS(9),
    [sym_while] = ACTIONS(11),
    [sym_function] = ACTIONS(13),
    [sym_macro] = ACTIONS(15),
    [sym_identifier] = ACTIONS(17),
    [sym_bracket_comment] = ACTIONS(5),
    [sym_line_comment] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(25), 1,
      sym_endif,
    ACTIONS(27), 1,
      sym_identifier,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(378), 1,
      sym_endif_command,
    ACTIONS(19), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(80), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [64] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(31), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(273), 1,
      sym_endif_command,
    ACTIONS(29), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(4), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [128] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(31), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(279), 1,
      sym_endif_command,
    ACTIONS(19), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(80), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [192] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(35), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(414), 1,
      sym_endif_command,
    ACTIONS(33), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(6), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [256] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(35), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(455), 1,
      sym_endif_command,
    ACTIONS(19), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(80), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [320] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(39), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(446), 1,
      sym_endif_command,
    ACTIONS(37), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(8), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [384] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(39), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(431), 1,
      sym_endif_command,
    ACTIONS(19), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(80), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [448] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(43), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(364), 1,
      sym_endif_command,
    ACTIONS(41), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(13), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [512] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(47), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(330), 1,
      sym_endif_command,
    ACTIONS(45), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(11), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [576] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(47), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(340), 1,
      sym_endif_command,
    ACTIONS(19), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(80), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [640] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(25), 1,
      sym_endif,
    ACTIONS(27), 1,
      sym_identifier,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(370), 1,
      sym_endif_command,
    ACTIONS(49), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(2), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [704] = 17,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(21), 1,
      sym_elseif,
    ACTIONS(23), 1,
      sym_else,
    ACTIONS(27), 1,
      sym_identifier,
    ACTIONS(43), 1,
      sym_endif,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    STATE(467), 1,
      sym_endif_command,
    ACTIONS(19), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(80), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [768] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_RPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [823] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(67), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(14), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [878] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(71), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(17), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [933] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [988] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(77), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(54), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1043] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(81), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(27), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1098] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(83), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(59), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1153] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(87), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1208] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(89), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(62), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1263] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(93), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(29), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1318] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(99), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(97), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(65), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1373] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(101), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(31), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1428] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(107), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(105), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(68), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1483] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(109), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1538] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(113), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(111), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(71), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1593] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(115), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1648] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(115), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(117), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(33), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1703] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(119), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1758] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(119), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(121), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(34), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1813] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(123), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1868] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(125), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1923] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(129), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(127), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(36), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [1978] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(131), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2033] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(131), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(133), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(40), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2088] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(137), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(135), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(41), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2143] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(141), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(139), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(43), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2198] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(143), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2253] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(145), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2308] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(145), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(147), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(44), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2363] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2418] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(149), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2473] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(153), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(151), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(46), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2528] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(155), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2583] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(155), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(157), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(53), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2638] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(161), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(159), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(55), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2693] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(165), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(163), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(58), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2748] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(169), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(167), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(98), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2803] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(171), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2858] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(173), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2913] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(175), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [2968] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(177), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3023] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(179), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3078] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(177), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(181), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(104), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3133] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(179), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(183), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(64), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3188] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(185), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3243] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(187), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3298] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(187), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(189), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(106), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3353] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(185), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(191), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(67), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3408] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(193), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3463] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(193), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(195), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(108), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3518] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(197), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3573] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(199), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3628] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(199), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(201), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(110), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3683] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(203), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3738] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(205), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3793] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(205), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(207), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(112), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3848] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(209), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3903] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(211), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [3958] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(211), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(213), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(113), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4013] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(217), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(215), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(86), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4068] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(221), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(219), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(75), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4123] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(223), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4178] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(225), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4233] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(227), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4288] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(231), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(229), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(76), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4343] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(231), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4398] = 16,
    ACTIONS(236), 1,
      sym_if,
    ACTIONS(239), 1,
      sym_elseif,
    ACTIONS(242), 1,
      sym_else,
    ACTIONS(245), 1,
      sym_endif,
    ACTIONS(247), 1,
      sym_foreach,
    ACTIONS(250), 1,
      sym_while,
    ACTIONS(253), 1,
      sym_function,
    ACTIONS(256), 1,
      sym_macro,
    ACTIONS(259), 1,
      sym_identifier,
    STATE(3), 1,
      sym_if_command,
    STATE(125), 1,
      sym_foreach_command,
    STATE(126), 1,
      sym_while_command,
    STATE(131), 1,
      sym_macro_command,
    STATE(146), 1,
      sym_function_command,
    ACTIONS(233), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(80), 11,
      sym_elseif_command,
      sym_else_command,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_if_condition_repeat1,
  [4459] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(264), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(262), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(100), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4514] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(268), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(266), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(77), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4569] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(268), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4624] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(272), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(270), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(97), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4679] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(274), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4734] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(276), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4789] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(280), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(278), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(95), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4844] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(284), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(282), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(79), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4899] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(288), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(286), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(83), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [4954] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(292), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(290), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(21), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5009] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(223), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(294), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(96), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5064] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(298), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(296), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(85), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5119] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(302), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(300), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(52), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5174] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(298), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5229] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(302), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5284] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(304), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5339] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(306), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5394] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(308), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5449] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(306), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(310), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(103), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5504] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(312), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5559] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(312), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(314), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(107), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5614] = 13,
    ACTIONS(319), 1,
      anon_sym_DOLLAR,
    ACTIONS(325), 1,
      anon_sym_LPAREN,
    ACTIONS(328), 1,
      anon_sym_RPAREN,
    ACTIONS(330), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(336), 1,
      sym_bracket_argument,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(322), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(316), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5669] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(339), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5724] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(341), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5779] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(345), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(343), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(94), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5834] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(347), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5889] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(349), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5944] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(351), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [5999] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(276), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(353), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(70), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [6054] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(355), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [6109] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(87), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(357), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(51), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [6164] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(359), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [6219] = 13,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      anon_sym_DQUOTE,
    ACTIONS(63), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(65), 1,
      sym_bracket_argument,
    ACTIONS(361), 1,
      anon_sym_RPAREN,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(256), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    ACTIONS(55), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(102), 4,
      sym_argument,
      sym__untrimmed_argument,
      sym__paren_argument,
      aux_sym__paren_argument_repeat1,
    STATE(168), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [6274] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(365), 1,
      sym_endforeach,
    ACTIONS(367), 1,
      sym_identifier,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(341), 1,
      sym_endforeach_command,
    ACTIONS(363), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(162), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6330] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(371), 1,
      sym_endfunction,
    ACTIONS(373), 1,
      sym_identifier,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(381), 1,
      sym_endfunction_command,
    ACTIONS(369), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(167), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6386] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(371), 1,
      sym_endfunction,
    ACTIONS(373), 1,
      sym_identifier,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(373), 1,
      sym_endfunction_command,
    ACTIONS(375), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(115), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6442] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(379), 1,
      sym_endmacro,
    ACTIONS(381), 1,
      sym_identifier,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(374), 1,
      sym_endmacro_command,
    ACTIONS(377), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(130), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6498] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(383), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(427), 1,
      sym_endfunction_command,
    ACTIONS(369), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(167), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6554] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(385), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(389), 1,
      sym_endforeach_command,
    ACTIONS(363), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(162), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6610] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(389), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(423), 1,
      sym_endmacro_command,
    ACTIONS(387), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(165), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6666] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(393), 1,
      sym_endwhile,
    ACTIONS(395), 1,
      sym_identifier,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(442), 1,
      sym_endwhile_command,
    ACTIONS(391), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(127), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6722] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(389), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(440), 1,
      sym_endmacro_command,
    ACTIONS(397), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(120), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6778] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(401), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(380), 1,
      sym_endwhile_command,
    ACTIONS(399), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(166), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6834] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(405), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(338), 1,
      sym_endmacro_command,
    ACTIONS(403), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(156), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6890] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(409), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(274), 1,
      sym_endforeach_command,
    ACTIONS(407), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(133), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [6946] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(413), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(275), 1,
      sym_endwhile_command,
    ACTIONS(411), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(135), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7002] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(393), 1,
      sym_endwhile,
    ACTIONS(395), 1,
      sym_identifier,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(429), 1,
      sym_endwhile_command,
    ACTIONS(399), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(166), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7058] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(417), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(371), 1,
      sym_endforeach_command,
    ACTIONS(415), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(129), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7114] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(417), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(379), 1,
      sym_endforeach_command,
    ACTIONS(363), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(162), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7170] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(379), 1,
      sym_endmacro,
    ACTIONS(381), 1,
      sym_identifier,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(382), 1,
      sym_endmacro_command,
    ACTIONS(387), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(165), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7226] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(421), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(277), 1,
      sym_endmacro_command,
    ACTIONS(419), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(137), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7282] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(425), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(428), 1,
      sym_endmacro_command,
    ACTIONS(423), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(134), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7338] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(409), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(280), 1,
      sym_endforeach_command,
    ACTIONS(363), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(162), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7394] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(425), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(476), 1,
      sym_endmacro_command,
    ACTIONS(387), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(165), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7450] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(413), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(281), 1,
      sym_endwhile_command,
    ACTIONS(399), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(166), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7506] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(427), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(282), 1,
      sym_endfunction_command,
    ACTIONS(369), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(167), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7562] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(421), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(283), 1,
      sym_endmacro_command,
    ACTIONS(387), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(165), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7618] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(431), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(443), 1,
      sym_endforeach_command,
    ACTIONS(429), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(158), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7674] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(433), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(430), 1,
      sym_endforeach_command,
    ACTIONS(363), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(162), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7730] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(385), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(413), 1,
      sym_endforeach_command,
    ACTIONS(435), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(119), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7786] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(439), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(376), 1,
      sym_endwhile_command,
    ACTIONS(437), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(153), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7842] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(441), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(344), 1,
      sym_endmacro_command,
    ACTIONS(387), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(165), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7898] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(443), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(343), 1,
      sym_endfunction_command,
    ACTIONS(369), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(167), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [7954] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(445), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(342), 1,
      sym_endwhile_command,
    ACTIONS(399), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(166), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8010] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(449), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(345), 1,
      sym_endfunction_command,
    ACTIONS(447), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(155), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8066] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(427), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(276), 1,
      sym_endfunction_command,
    ACTIONS(451), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(136), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8122] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(401), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(372), 1,
      sym_endwhile_command,
    ACTIONS(453), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(123), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8178] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(433), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(445), 1,
      sym_endforeach_command,
    ACTIONS(455), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(139), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8234] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(441), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(334), 1,
      sym_endmacro_command,
    ACTIONS(457), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(142), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8290] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(443), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(333), 1,
      sym_endfunction_command,
    ACTIONS(459), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(143), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8346] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(445), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(332), 1,
      sym_endwhile_command,
    ACTIONS(461), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(144), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8402] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(365), 1,
      sym_endforeach,
    ACTIONS(367), 1,
      sym_identifier,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(331), 1,
      sym_endforeach_command,
    ACTIONS(463), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(114), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8458] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(439), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(336), 1,
      sym_endwhile_command,
    ACTIONS(399), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(166), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8514] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(467), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(335), 1,
      sym_endwhile_command,
    ACTIONS(465), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(160), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8570] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(449), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(337), 1,
      sym_endfunction_command,
    ACTIONS(369), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(167), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8626] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(405), 1,
      sym_endmacro,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    STATE(352), 1,
      sym_endmacro_command,
    ACTIONS(387), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(165), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8682] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(471), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(426), 1,
      sym_endfunction_command,
    ACTIONS(469), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(161), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8738] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(367), 1,
      sym_identifier,
    ACTIONS(431), 1,
      sym_endforeach,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    STATE(469), 1,
      sym_endforeach_command,
    ACTIONS(363), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(162), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8794] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(383), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(441), 1,
      sym_endfunction_command,
    ACTIONS(473), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(118), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8850] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(467), 1,
      sym_endwhile,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    STATE(473), 1,
      sym_endwhile_command,
    ACTIONS(399), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(166), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8906] = 15,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(373), 1,
      sym_identifier,
    ACTIONS(471), 1,
      sym_endfunction,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    STATE(475), 1,
      sym_endfunction_command,
    ACTIONS(369), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(167), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [8962] = 14,
    ACTIONS(478), 1,
      sym_if,
    ACTIONS(481), 1,
      sym_foreach,
    ACTIONS(484), 1,
      sym_endforeach,
    ACTIONS(486), 1,
      sym_while,
    ACTIONS(489), 1,
      sym_function,
    ACTIONS(492), 1,
      sym_macro,
    ACTIONS(495), 1,
      sym_identifier,
    STATE(5), 1,
      sym_if_command,
    STATE(124), 1,
      sym_macro_command,
    STATE(140), 1,
      sym_foreach_command,
    STATE(141), 1,
      sym_while_command,
    STATE(145), 1,
      sym_function_command,
    ACTIONS(475), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(162), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [9015] = 14,
    ACTIONS(7), 1,
      sym_if,
    ACTIONS(9), 1,
      sym_foreach,
    ACTIONS(11), 1,
      sym_while,
    ACTIONS(13), 1,
      sym_function,
    ACTIONS(15), 1,
      sym_macro,
    ACTIONS(17), 1,
      sym_identifier,
    ACTIONS(498), 1,
      ts_builtin_sym_end,
    STATE(9), 1,
      sym_if_command,
    STATE(132), 1,
      sym_macro_command,
    STATE(138), 1,
      sym_foreach_command,
    STATE(154), 1,
      sym_while_command,
    STATE(157), 1,
      sym_function_command,
    ACTIONS(500), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(164), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [9068] = 14,
    ACTIONS(478), 1,
      sym_if,
    ACTIONS(481), 1,
      sym_foreach,
    ACTIONS(486), 1,
      sym_while,
    ACTIONS(489), 1,
      sym_function,
    ACTIONS(492), 1,
      sym_macro,
    ACTIONS(502), 1,
      ts_builtin_sym_end,
    ACTIONS(507), 1,
      sym_identifier,
    STATE(9), 1,
      sym_if_command,
    STATE(132), 1,
      sym_macro_command,
    STATE(138), 1,
      sym_foreach_command,
    STATE(154), 1,
      sym_while_command,
    STATE(157), 1,
      sym_function_command,
    ACTIONS(504), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(164), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [9121] = 14,
    ACTIONS(478), 1,
      sym_if,
    ACTIONS(481), 1,
      sym_foreach,
    ACTIONS(484), 1,
      sym_endmacro,
    ACTIONS(486), 1,
      sym_while,
    ACTIONS(489), 1,
      sym_function,
    ACTIONS(492), 1,
      sym_macro,
    ACTIONS(513), 1,
      sym_identifier,
    STATE(12), 1,
      sym_if_command,
    STATE(116), 1,
      sym_function_command,
    STATE(117), 1,
      sym_macro_command,
    STATE(128), 1,
      sym_foreach_command,
    STATE(147), 1,
      sym_while_command,
    ACTIONS(510), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(165), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [9174] = 14,
    ACTIONS(478), 1,
      sym_if,
    ACTIONS(481), 1,
      sym_foreach,
    ACTIONS(484), 1,
      sym_endwhile,
    ACTIONS(486), 1,
      sym_while,
    ACTIONS(489), 1,
      sym_function,
    ACTIONS(492), 1,
      sym_macro,
    ACTIONS(519), 1,
      sym_identifier,
    STATE(7), 1,
      sym_if_command,
    STATE(121), 1,
      sym_while_command,
    STATE(122), 1,
      sym_macro_command,
    STATE(148), 1,
      sym_foreach_command,
    STATE(159), 1,
      sym_function_command,
    ACTIONS(516), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(166), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [9227] = 14,
    ACTIONS(478), 1,
      sym_if,
    ACTIONS(481), 1,
      sym_foreach,
    ACTIONS(484), 1,
      sym_endfunction,
    ACTIONS(486), 1,
      sym_while,
    ACTIONS(489), 1,
      sym_function,
    ACTIONS(492), 1,
      sym_macro,
    ACTIONS(525), 1,
      sym_identifier,
    STATE(10), 1,
      sym_if_command,
    STATE(149), 1,
      sym_macro_command,
    STATE(150), 1,
      sym_function_command,
    STATE(151), 1,
      sym_while_command,
    STATE(152), 1,
      sym_foreach_command,
    ACTIONS(522), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    STATE(167), 9,
      sym_if_condition,
      sym_foreach_loop,
      sym_while_loop,
      sym_function_def,
      sym_macro_def,
      sym_normal_command,
      sym__command_invocation,
      sym__untrimmed_command_invocation,
      aux_sym_source_file_repeat1,
  [9280] = 7,
    ACTIONS(53), 1,
      anon_sym_DOLLAR,
    ACTIONS(530), 1,
      aux_sym_unquoted_argument_token1,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(173), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(51), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
    ACTIONS(528), 7,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [9317] = 12,
    ACTIONS(535), 1,
      anon_sym_DOLLAR,
    ACTIONS(538), 1,
      anon_sym_GT,
    ACTIONS(540), 1,
      anon_sym_DQUOTE,
    ACTIONS(543), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(546), 1,
      sym_bracket_argument,
    STATE(169), 1,
      aux_sym__gen_exp_arguments_repeat1,
    STATE(309), 1,
      sym_argument,
    STATE(315), 1,
      sym__escape_encoded,
    STATE(307), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(314), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(218), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(532), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9364] = 12,
    ACTIONS(551), 1,
      anon_sym_DOLLAR,
    ACTIONS(553), 1,
      anon_sym_GT,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(559), 1,
      sym_bracket_argument,
    STATE(482), 1,
      sym__escape_encoded,
    STATE(546), 1,
      sym_argument,
    STATE(678), 1,
      sym__gen_exp_content,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(221), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(549), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9411] = 12,
    ACTIONS(563), 1,
      anon_sym_DOLLAR,
    ACTIONS(565), 1,
      anon_sym_GT,
    ACTIONS(567), 1,
      anon_sym_DQUOTE,
    ACTIONS(569), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(571), 1,
      sym_bracket_argument,
    STATE(169), 1,
      aux_sym__gen_exp_arguments_repeat1,
    STATE(309), 1,
      sym_argument,
    STATE(315), 1,
      sym__escape_encoded,
    STATE(307), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(314), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(218), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(561), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9458] = 12,
    ACTIONS(551), 1,
      anon_sym_DOLLAR,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(573), 1,
      anon_sym_GT,
    STATE(482), 1,
      sym__escape_encoded,
    STATE(546), 1,
      sym_argument,
    STATE(746), 1,
      sym__gen_exp_content,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(221), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(549), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9505] = 7,
    ACTIONS(578), 1,
      anon_sym_DOLLAR,
    ACTIONS(583), 1,
      aux_sym_unquoted_argument_token1,
    STATE(258), 1,
      sym__escape_encoded,
    STATE(260), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(173), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(575), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
    ACTIONS(581), 7,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [9542] = 12,
    ACTIONS(551), 1,
      anon_sym_DOLLAR,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(586), 1,
      anon_sym_GT,
    STATE(482), 1,
      sym__escape_encoded,
    STATE(546), 1,
      sym_argument,
    STATE(689), 1,
      sym__gen_exp_content,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(221), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(549), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9589] = 12,
    ACTIONS(551), 1,
      anon_sym_DOLLAR,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(588), 1,
      anon_sym_GT,
    STATE(482), 1,
      sym__escape_encoded,
    STATE(546), 1,
      sym_argument,
    STATE(660), 1,
      sym__gen_exp_content,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(221), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(549), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9636] = 12,
    ACTIONS(551), 1,
      anon_sym_DOLLAR,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(590), 1,
      anon_sym_GT,
    STATE(482), 1,
      sym__escape_encoded,
    STATE(546), 1,
      sym_argument,
    STATE(700), 1,
      sym__gen_exp_content,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(221), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(549), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9683] = 12,
    ACTIONS(551), 1,
      anon_sym_DOLLAR,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(592), 1,
      anon_sym_GT,
    STATE(482), 1,
      sym__escape_encoded,
    STATE(546), 1,
      sym_argument,
    STATE(710), 1,
      sym__gen_exp_content,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(221), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(549), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9730] = 12,
    ACTIONS(563), 1,
      anon_sym_DOLLAR,
    ACTIONS(567), 1,
      anon_sym_DQUOTE,
    ACTIONS(569), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(571), 1,
      sym_bracket_argument,
    ACTIONS(594), 1,
      anon_sym_GT,
    STATE(171), 1,
      aux_sym__gen_exp_arguments_repeat1,
    STATE(309), 1,
      sym_argument,
    STATE(315), 1,
      sym__escape_encoded,
    STATE(307), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(314), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(218), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(561), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9777] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(600), 1,
      anon_sym_RPAREN,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(665), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9821] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(604), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(659), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9865] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(606), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(683), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9909] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(608), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(703), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9953] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(610), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(640), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [9997] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(612), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(748), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10041] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(614), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(705), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10085] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(616), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(664), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10129] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(618), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(745), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10173] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(620), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(699), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10217] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(622), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(709), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10261] = 11,
    ACTIONS(555), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      sym_bracket_argument,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(602), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(624), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(679), 1,
      sym_argument,
    STATE(550), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(226), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10305] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(641), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10346] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(717), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10387] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(693), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10428] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(694), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10469] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(742), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10510] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(655), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10551] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(654), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10592] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(653), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10633] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(714), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10674] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(639), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10715] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(704), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10756] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(713), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10797] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(642), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10838] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(708), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10879] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(652), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10920] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(638), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [10961] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(637), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11002] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(730), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11043] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(692), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11084] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(675), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11125] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(674), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11166] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(695), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11207] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(672), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11248] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(673), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11289] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(715), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11330] = 10,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(630), 1,
      anon_sym_DQUOTE,
    ACTIONS(632), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(634), 1,
      sym_bracket_argument,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(712), 1,
      sym_argument,
    STATE(723), 2,
      sym_quoted_argument,
      sym_unquoted_argument,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(228), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11371] = 8,
    ACTIONS(639), 1,
      anon_sym_DOLLAR,
    ACTIONS(642), 1,
      aux_sym__gen_exp_arguments_token1,
    ACTIONS(644), 1,
      aux_sym_unquoted_argument_token1,
    STATE(315), 1,
      sym__escape_encoded,
    ACTIONS(581), 3,
      sym_bracket_argument,
      anon_sym_GT,
      anon_sym_DQUOTE,
    STATE(314), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(217), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(636), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11407] = 8,
    ACTIONS(563), 1,
      anon_sym_DOLLAR,
    ACTIONS(647), 1,
      aux_sym__gen_exp_arguments_token1,
    ACTIONS(649), 1,
      aux_sym_unquoted_argument_token1,
    STATE(315), 1,
      sym__escape_encoded,
    ACTIONS(528), 3,
      sym_bracket_argument,
      anon_sym_GT,
      anon_sym_DQUOTE,
    STATE(314), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(217), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(561), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11443] = 8,
    ACTIONS(653), 1,
      anon_sym_DOLLAR,
    ACTIONS(655), 1,
      anon_sym_DQUOTE,
    ACTIONS(657), 1,
      aux_sym_quoted_element_token1,
    STATE(502), 1,
      sym__escape_encoded,
    STATE(729), 1,
      sym_quoted_element,
    STATE(508), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(227), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_quoted_element_repeat1,
    ACTIONS(651), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11477] = 8,
    ACTIONS(653), 1,
      anon_sym_DOLLAR,
    ACTIONS(657), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(659), 1,
      anon_sym_DQUOTE,
    STATE(502), 1,
      sym__escape_encoded,
    STATE(711), 1,
      sym_quoted_element,
    STATE(508), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(227), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_quoted_element_repeat1,
    ACTIONS(651), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11511] = 7,
    ACTIONS(551), 1,
      anon_sym_DOLLAR,
    ACTIONS(661), 1,
      aux_sym_unquoted_argument_token1,
    STATE(482), 1,
      sym__escape_encoded,
    ACTIONS(528), 2,
      anon_sym_GT,
      anon_sym_COLON,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(224), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(549), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11543] = 8,
    ACTIONS(653), 1,
      anon_sym_DOLLAR,
    ACTIONS(657), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(663), 1,
      anon_sym_DQUOTE,
    STATE(502), 1,
      sym__escape_encoded,
    STATE(662), 1,
      sym_quoted_element,
    STATE(508), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(227), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_quoted_element_repeat1,
    ACTIONS(651), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11577] = 8,
    ACTIONS(653), 1,
      anon_sym_DOLLAR,
    ACTIONS(657), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(665), 1,
      anon_sym_DQUOTE,
    STATE(502), 1,
      sym__escape_encoded,
    STATE(676), 1,
      sym_quoted_element,
    STATE(508), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(227), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_quoted_element_repeat1,
    ACTIONS(651), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11611] = 7,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(673), 1,
      aux_sym_unquoted_argument_token1,
    STATE(482), 1,
      sym__escape_encoded,
    ACTIONS(581), 2,
      anon_sym_GT,
      anon_sym_COLON,
    STATE(483), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(224), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(667), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11643] = 7,
    ACTIONS(679), 1,
      anon_sym_DOLLAR,
    ACTIONS(682), 1,
      anon_sym_DQUOTE,
    ACTIONS(684), 1,
      aux_sym_quoted_element_token1,
    STATE(502), 1,
      sym__escape_encoded,
    STATE(508), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(225), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_quoted_element_repeat1,
    ACTIONS(676), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11674] = 7,
    ACTIONS(528), 1,
      anon_sym_RPAREN,
    ACTIONS(598), 1,
      anon_sym_DOLLAR,
    ACTIONS(687), 1,
      aux_sym_unquoted_argument_token1,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(230), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(596), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11705] = 7,
    ACTIONS(653), 1,
      anon_sym_DOLLAR,
    ACTIONS(689), 1,
      anon_sym_DQUOTE,
    ACTIONS(691), 1,
      aux_sym_quoted_element_token1,
    STATE(502), 1,
      sym__escape_encoded,
    STATE(508), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(225), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_quoted_element_repeat1,
    ACTIONS(651), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11736] = 7,
    ACTIONS(628), 1,
      anon_sym_DOLLAR,
    ACTIONS(647), 1,
      aux_sym_else_command_token1,
    ACTIONS(693), 1,
      aux_sym_unquoted_argument_token1,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(229), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(626), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11767] = 7,
    ACTIONS(642), 1,
      aux_sym_else_command_token1,
    ACTIONS(698), 1,
      anon_sym_DOLLAR,
    ACTIONS(701), 1,
      aux_sym_unquoted_argument_token1,
    STATE(487), 1,
      sym__escape_encoded,
    STATE(506), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(229), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(695), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11798] = 7,
    ACTIONS(581), 1,
      anon_sym_RPAREN,
    ACTIONS(707), 1,
      anon_sym_DOLLAR,
    ACTIONS(710), 1,
      aux_sym_unquoted_argument_token1,
    STATE(499), 1,
      sym__escape_encoded,
    STATE(496), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    STATE(230), 4,
      sym_escape_sequence,
      sym_variable_ref,
      sym_gen_exp,
      aux_sym_unquoted_argument_repeat1,
    ACTIONS(704), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11829] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(643), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11859] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(707), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11889] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(724), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11919] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(677), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11949] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(728), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [11979] = 7,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    ACTIONS(719), 1,
      aux_sym_variable_token1,
    ACTIONS(721), 1,
      anon_sym_RBRACE,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(252), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12009] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(681), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12039] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(682), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12069] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(747), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12099] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(690), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12129] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(740), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12159] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(669), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12189] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(644), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12219] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(645), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12249] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(739), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12279] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(657), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12309] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(658), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12339] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(701), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12369] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(661), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12399] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(670), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12429] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(697), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12459] = 7,
    ACTIONS(726), 1,
      aux_sym_variable_token1,
    ACTIONS(729), 1,
      anon_sym_DOLLAR,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(252), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(723), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12489] = 7,
    ACTIONS(715), 1,
      aux_sym_variable_token1,
    ACTIONS(717), 1,
      anon_sym_DOLLAR,
    STATE(493), 1,
      sym__escape_encoded,
    STATE(696), 1,
      sym_variable,
    STATE(236), 3,
      sym_escape_sequence,
      sym_variable_ref,
      aux_sym_variable_repeat1,
    STATE(495), 3,
      sym_normal_var,
      sym_env_var,
      sym_cache_var,
    ACTIONS(713), 5,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
  [12519] = 2,
    ACTIONS(736), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(734), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12538] = 2,
    ACTIONS(740), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(738), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12557] = 2,
    ACTIONS(744), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(742), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12576] = 2,
    ACTIONS(748), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(746), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12595] = 2,
    ACTIONS(752), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(750), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12614] = 2,
    ACTIONS(756), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(754), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12633] = 2,
    ACTIONS(760), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(758), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12652] = 2,
    ACTIONS(764), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(762), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12671] = 2,
    ACTIONS(768), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(766), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12690] = 2,
    ACTIONS(772), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(770), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12709] = 2,
    ACTIONS(776), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(774), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12728] = 2,
    ACTIONS(780), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(778), 13,
      sym_bracket_argument,
      sym_bracket_comment,
      sym_line_comment,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      aux_sym__untrimmed_argument_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [12747] = 2,
    ACTIONS(782), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(784), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12764] = 2,
    ACTIONS(786), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(788), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12781] = 2,
    ACTIONS(790), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(792), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12798] = 2,
    ACTIONS(794), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(796), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12815] = 2,
    ACTIONS(798), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(800), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12832] = 2,
    ACTIONS(802), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(804), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12849] = 2,
    ACTIONS(806), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(808), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12866] = 2,
    ACTIONS(810), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(812), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12883] = 2,
    ACTIONS(814), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(816), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12900] = 2,
    ACTIONS(818), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(820), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12917] = 2,
    ACTIONS(822), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(824), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12934] = 2,
    ACTIONS(826), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(828), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12951] = 2,
    ACTIONS(830), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(832), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12968] = 2,
    ACTIONS(834), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(836), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [12985] = 2,
    ACTIONS(838), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(840), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13002] = 2,
    ACTIONS(842), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(844), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13019] = 2,
    ACTIONS(846), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(848), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13036] = 2,
    ACTIONS(850), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(852), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13053] = 2,
    ACTIONS(854), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(856), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13070] = 2,
    ACTIONS(858), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(860), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13087] = 2,
    ACTIONS(862), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(864), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13104] = 2,
    ACTIONS(866), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(868), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13121] = 2,
    ACTIONS(870), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(872), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13138] = 2,
    ACTIONS(874), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(876), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13155] = 2,
    ACTIONS(878), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(880), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13172] = 2,
    ACTIONS(882), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(884), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13189] = 2,
    ACTIONS(886), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(888), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13206] = 2,
    ACTIONS(890), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(892), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13223] = 2,
    ACTIONS(894), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(896), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13240] = 2,
    ACTIONS(898), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(900), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13257] = 2,
    ACTIONS(902), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(904), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13274] = 2,
    ACTIONS(906), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(908), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13291] = 2,
    ACTIONS(910), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(912), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13308] = 2,
    ACTIONS(914), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(916), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13325] = 2,
    ACTIONS(918), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(920), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13342] = 2,
    ACTIONS(922), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(924), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13359] = 2,
    ACTIONS(926), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(928), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13376] = 2,
    ACTIONS(930), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(932), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13393] = 2,
    ACTIONS(934), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(936), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13410] = 2,
    ACTIONS(938), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(940), 9,
      sym_if,
      sym_elseif,
      sym_else,
      sym_endif,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13427] = 2,
    ACTIONS(740), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(738), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13443] = 2,
    ACTIONS(744), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(742), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13459] = 2,
    ACTIONS(776), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(774), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13475] = 3,
    ACTIONS(944), 1,
      aux_sym__gen_exp_arguments_token1,
    ACTIONS(946), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(942), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13493] = 2,
    ACTIONS(736), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(734), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13509] = 2,
    ACTIONS(780), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(778), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13525] = 2,
    ACTIONS(768), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(766), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13541] = 2,
    ACTIONS(748), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(746), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13557] = 2,
    ACTIONS(760), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(758), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13573] = 2,
    ACTIONS(752), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(750), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13589] = 2,
    ACTIONS(756), 2,
      aux_sym__gen_exp_arguments_token1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(754), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [13605] = 2,
    ACTIONS(926), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(928), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13620] = 2,
    ACTIONS(782), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(784), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13635] = 2,
    ACTIONS(906), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(908), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13650] = 2,
    ACTIONS(910), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(912), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13665] = 2,
    ACTIONS(922), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(924), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13680] = 2,
    ACTIONS(898), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(900), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13695] = 2,
    ACTIONS(934), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(936), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13710] = 2,
    ACTIONS(914), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(916), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13725] = 2,
    ACTIONS(918), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(920), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13740] = 2,
    ACTIONS(938), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(940), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13755] = 2,
    ACTIONS(930), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(932), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13770] = 2,
    ACTIONS(890), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(892), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13785] = 2,
    ACTIONS(858), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(860), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [13800] = 2,
    ACTIONS(810), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(812), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13815] = 2,
    ACTIONS(814), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(816), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13830] = 2,
    ACTIONS(818), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(820), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13845] = 2,
    ACTIONS(822), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(824), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13860] = 2,
    ACTIONS(826), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(828), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13875] = 2,
    ACTIONS(818), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(820), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13890] = 2,
    ACTIONS(842), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(844), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13905] = 2,
    ACTIONS(846), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(848), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13920] = 2,
    ACTIONS(826), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(828), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [13935] = 2,
    ACTIONS(830), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(832), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13950] = 2,
    ACTIONS(834), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(836), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13965] = 2,
    ACTIONS(838), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(840), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13980] = 2,
    ACTIONS(842), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(844), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [13995] = 2,
    ACTIONS(846), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(848), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14010] = 2,
    ACTIONS(850), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(852), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14025] = 2,
    ACTIONS(822), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(824), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14040] = 2,
    ACTIONS(854), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(856), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14055] = 2,
    ACTIONS(782), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(784), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14070] = 2,
    ACTIONS(862), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(864), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14085] = 2,
    ACTIONS(866), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(868), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14100] = 2,
    ACTIONS(874), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(876), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14115] = 2,
    ACTIONS(878), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(880), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14130] = 2,
    ACTIONS(850), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(852), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14145] = 2,
    ACTIONS(886), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(888), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14160] = 2,
    ACTIONS(898), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(900), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14175] = 2,
    ACTIONS(906), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(908), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14190] = 2,
    ACTIONS(910), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(912), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14205] = 2,
    ACTIONS(914), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(916), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14220] = 2,
    ACTIONS(918), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(920), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14235] = 2,
    ACTIONS(886), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(888), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14250] = 2,
    ACTIONS(948), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(950), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14265] = 2,
    ACTIONS(922), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(924), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14280] = 2,
    ACTIONS(926), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(928), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14295] = 2,
    ACTIONS(934), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(936), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14310] = 2,
    ACTIONS(810), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(812), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14325] = 2,
    ACTIONS(952), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(954), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14340] = 2,
    ACTIONS(938), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(940), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14355] = 2,
    ACTIONS(930), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(932), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14370] = 2,
    ACTIONS(890), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(892), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14385] = 2,
    ACTIONS(858), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(860), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [14400] = 2,
    ACTIONS(810), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(812), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14415] = 2,
    ACTIONS(814), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(816), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14430] = 2,
    ACTIONS(818), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(820), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14445] = 2,
    ACTIONS(822), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(824), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14460] = 2,
    ACTIONS(826), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(828), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14475] = 2,
    ACTIONS(956), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(958), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [14490] = 2,
    ACTIONS(818), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(820), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14505] = 2,
    ACTIONS(830), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(832), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14520] = 2,
    ACTIONS(834), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(836), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14535] = 2,
    ACTIONS(838), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(840), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14550] = 2,
    ACTIONS(842), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(844), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14565] = 2,
    ACTIONS(846), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(848), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14580] = 2,
    ACTIONS(850), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(852), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14595] = 2,
    ACTIONS(854), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(856), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14610] = 2,
    ACTIONS(782), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(784), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14625] = 2,
    ACTIONS(862), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(864), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14640] = 2,
    ACTIONS(866), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(868), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14655] = 2,
    ACTIONS(874), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(876), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14670] = 2,
    ACTIONS(878), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(880), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14685] = 2,
    ACTIONS(838), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(840), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14700] = 2,
    ACTIONS(886), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(888), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14715] = 2,
    ACTIONS(898), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(900), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14730] = 2,
    ACTIONS(906), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(908), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14745] = 2,
    ACTIONS(910), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(912), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14760] = 2,
    ACTIONS(914), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(916), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14775] = 2,
    ACTIONS(918), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(920), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14790] = 2,
    ACTIONS(960), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(962), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14805] = 2,
    ACTIONS(914), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(916), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [14820] = 2,
    ACTIONS(922), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(924), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14835] = 2,
    ACTIONS(926), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(928), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14850] = 2,
    ACTIONS(934), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(936), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14865] = 2,
    ACTIONS(854), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(856), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14880] = 2,
    ACTIONS(782), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(784), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [14895] = 2,
    ACTIONS(938), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(940), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14910] = 2,
    ACTIONS(930), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(932), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14925] = 2,
    ACTIONS(890), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(892), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14940] = 2,
    ACTIONS(858), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(860), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [14955] = 2,
    ACTIONS(910), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(912), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [14970] = 2,
    ACTIONS(906), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(908), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [14985] = 2,
    ACTIONS(898), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(900), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15000] = 2,
    ACTIONS(886), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(888), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15015] = 2,
    ACTIONS(862), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(864), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15030] = 2,
    ACTIONS(878), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(880), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15045] = 2,
    ACTIONS(814), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(816), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15060] = 2,
    ACTIONS(810), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(812), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15075] = 2,
    ACTIONS(874), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(876), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15090] = 2,
    ACTIONS(866), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(868), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15105] = 2,
    ACTIONS(862), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(864), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15120] = 2,
    ACTIONS(918), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(920), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15135] = 2,
    ACTIONS(922), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(924), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15150] = 2,
    ACTIONS(866), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(868), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15165] = 2,
    ACTIONS(854), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(856), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15180] = 2,
    ACTIONS(874), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(876), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15195] = 2,
    ACTIONS(850), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(852), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15210] = 2,
    ACTIONS(926), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(928), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15225] = 2,
    ACTIONS(934), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(936), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15240] = 2,
    ACTIONS(822), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(824), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15255] = 2,
    ACTIONS(846), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(848), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15270] = 2,
    ACTIONS(826), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(828), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15285] = 2,
    ACTIONS(842), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(844), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15300] = 2,
    ACTIONS(838), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(840), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15315] = 2,
    ACTIONS(834), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(836), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15330] = 2,
    ACTIONS(830), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(832), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15345] = 2,
    ACTIONS(874), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(876), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15360] = 2,
    ACTIONS(878), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(880), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15375] = 2,
    ACTIONS(878), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(880), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15390] = 2,
    ACTIONS(866), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(868), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15405] = 2,
    ACTIONS(862), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(864), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15420] = 2,
    ACTIONS(830), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(832), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15435] = 2,
    ACTIONS(782), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(784), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15450] = 2,
    ACTIONS(826), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(828), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15465] = 2,
    ACTIONS(822), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(824), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15480] = 2,
    ACTIONS(818), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(820), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15495] = 2,
    ACTIONS(814), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(816), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15510] = 2,
    ACTIONS(964), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(966), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15525] = 2,
    ACTIONS(814), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(816), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15540] = 2,
    ACTIONS(810), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(812), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15555] = 2,
    ACTIONS(968), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(970), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15570] = 2,
    ACTIONS(854), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(856), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15585] = 2,
    ACTIONS(972), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(974), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [15600] = 2,
    ACTIONS(976), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(978), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [15615] = 2,
    ACTIONS(830), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(832), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15630] = 2,
    ACTIONS(980), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(982), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_endmacro,
      sym_identifier,
  [15645] = 2,
    ACTIONS(858), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(860), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15660] = 2,
    ACTIONS(890), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(892), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15675] = 2,
    ACTIONS(834), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(836), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15690] = 2,
    ACTIONS(930), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(932), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15705] = 2,
    ACTIONS(938), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(940), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15720] = 2,
    ACTIONS(938), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(940), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15735] = 2,
    ACTIONS(984), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(986), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_endfunction,
      sym_macro,
      sym_identifier,
  [15750] = 2,
    ACTIONS(934), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(936), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15765] = 2,
    ACTIONS(926), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(928), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15780] = 2,
    ACTIONS(988), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(990), 7,
      sym_if,
      sym_foreach,
      sym_while,
      sym_endwhile,
      sym_function,
      sym_macro,
      sym_identifier,
  [15795] = 2,
    ACTIONS(992), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(994), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15810] = 2,
    ACTIONS(886), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(888), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15825] = 2,
    ACTIONS(922), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(924), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15840] = 2,
    ACTIONS(930), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(932), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15855] = 2,
    ACTIONS(834), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(836), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15870] = 2,
    ACTIONS(898), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(900), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15885] = 2,
    ACTIONS(838), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(840), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15900] = 2,
    ACTIONS(918), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(920), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15915] = 2,
    ACTIONS(914), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(916), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15930] = 2,
    ACTIONS(858), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(860), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15945] = 2,
    ACTIONS(842), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(844), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15960] = 2,
    ACTIONS(890), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(892), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15975] = 2,
    ACTIONS(846), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(848), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [15990] = 2,
    ACTIONS(850), 4,
      sym_bracket_comment,
      sym_line_comment,
      ts_builtin_sym_end,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(852), 6,
      sym_if,
      sym_foreach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [16005] = 2,
    ACTIONS(910), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(912), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [16020] = 2,
    ACTIONS(906), 3,
      sym_bracket_comment,
      sym_line_comment,
      aux_sym__untrimmed_argument_token1,
    ACTIONS(908), 7,
      sym_if,
      sym_foreach,
      sym_endforeach,
      sym_while,
      sym_function,
      sym_macro,
      sym_identifier,
  [16035] = 2,
    ACTIONS(996), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(538), 9,
      sym_bracket_argument,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_DQUOTE,
  [16050] = 2,
    ACTIONS(776), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(774), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_COLON,
  [16064] = 2,
    ACTIONS(756), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(754), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_COLON,
  [16078] = 2,
    ACTIONS(752), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(750), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_COLON,
  [16092] = 2,
    ACTIONS(760), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(758), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_COLON,
  [16106] = 2,
    ACTIONS(748), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(746), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_COLON,
  [16120] = 2,
    ACTIONS(780), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(778), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_COLON,
  [16134] = 2,
    ACTIONS(736), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(734), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_GT,
      anon_sym_COLON,
  [16148] = 2,
    ACTIONS(752), 2,
      aux_sym_unquoted_argument_token1,
      aux_sym_else_command_token1,
    ACTIONS(750), 6,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
  [16161] = 2,
    ACTIONS(756), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(754), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_RPAREN,
  [16174] = 1,
    ACTIONS(746), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      aux_sym_variable_token1,
      anon_sym_DOLLAR,
      anon_sym_RBRACE,
  [16185] = 2,
    ACTIONS(776), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(774), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_RPAREN,
  [16198] = 2,
    ACTIONS(776), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(774), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
  [16211] = 1,
    ACTIONS(778), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      aux_sym_variable_token1,
      anon_sym_DOLLAR,
      anon_sym_RBRACE,
  [16222] = 1,
    ACTIONS(750), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      aux_sym_variable_token1,
      anon_sym_DOLLAR,
      anon_sym_RBRACE,
  [16233] = 1,
    ACTIONS(734), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      aux_sym_variable_token1,
      anon_sym_DOLLAR,
      anon_sym_RBRACE,
  [16244] = 1,
    ACTIONS(758), 8,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      aux_sym_variable_token1,
      anon_sym_DOLLAR,
      anon_sym_RBRACE,
  [16255] = 2,
    ACTIONS(760), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(758), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_RPAREN,
  [16268] = 2,
    ACTIONS(748), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(746), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
  [16281] = 2,
    ACTIONS(756), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(754), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
  [16294] = 2,
    ACTIONS(752), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(750), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_RPAREN,
  [16307] = 2,
    ACTIONS(780), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(778), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
  [16320] = 2,
    ACTIONS(736), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(734), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
  [16333] = 2,
    ACTIONS(752), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(750), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
  [16346] = 2,
    ACTIONS(736), 2,
      aux_sym_unquoted_argument_token1,
      aux_sym_else_command_token1,
    ACTIONS(734), 6,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
  [16359] = 2,
    ACTIONS(780), 2,
      aux_sym_unquoted_argument_token1,
      aux_sym_else_command_token1,
    ACTIONS(778), 6,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
  [16372] = 2,
    ACTIONS(748), 2,
      aux_sym_unquoted_argument_token1,
      aux_sym_else_command_token1,
    ACTIONS(746), 6,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
  [16385] = 2,
    ACTIONS(760), 2,
      aux_sym_unquoted_argument_token1,
      aux_sym_else_command_token1,
    ACTIONS(758), 6,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
  [16398] = 2,
    ACTIONS(748), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(746), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_RPAREN,
  [16411] = 2,
    ACTIONS(760), 1,
      aux_sym_quoted_element_token1,
    ACTIONS(758), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
  [16424] = 2,
    ACTIONS(736), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(734), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_RPAREN,
  [16437] = 2,
    ACTIONS(756), 2,
      aux_sym_unquoted_argument_token1,
      aux_sym_else_command_token1,
    ACTIONS(754), 6,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
  [16450] = 2,
    ACTIONS(780), 1,
      aux_sym_unquoted_argument_token1,
    ACTIONS(778), 7,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
      anon_sym_RPAREN,
  [16463] = 2,
    ACTIONS(776), 2,
      aux_sym_unquoted_argument_token1,
      aux_sym_else_command_token1,
    ACTIONS(774), 6,
      sym__escape_identity,
      anon_sym_BSLASHt,
      anon_sym_BSLASHr,
      anon_sym_BSLASHn,
      sym__escape_semicolon,
      anon_sym_DOLLAR,
  [16476] = 4,
    ACTIONS(998), 1,
      anon_sym_LBRACE,
    ACTIONS(1000), 1,
      anon_sym_ENV,
    ACTIONS(1002), 1,
      anon_sym_CACHE,
    ACTIONS(1004), 1,
      anon_sym_LT,
  [16489] = 4,
    ACTIONS(1006), 1,
      anon_sym_LBRACE,
    ACTIONS(1008), 1,
      anon_sym_ENV,
    ACTIONS(1010), 1,
      anon_sym_CACHE,
    ACTIONS(1012), 1,
      anon_sym_LT,
  [16502] = 4,
    ACTIONS(1014), 1,
      anon_sym_LBRACE,
    ACTIONS(1016), 1,
      anon_sym_ENV,
    ACTIONS(1018), 1,
      anon_sym_CACHE,
    ACTIONS(1020), 1,
      anon_sym_LT,
  [16515] = 4,
    ACTIONS(1022), 1,
      anon_sym_LBRACE,
    ACTIONS(1024), 1,
      anon_sym_ENV,
    ACTIONS(1026), 1,
      anon_sym_CACHE,
    ACTIONS(1028), 1,
      anon_sym_LT,
  [16528] = 4,
    ACTIONS(1030), 1,
      anon_sym_LBRACE,
    ACTIONS(1032), 1,
      anon_sym_ENV,
    ACTIONS(1034), 1,
      anon_sym_CACHE,
    ACTIONS(1036), 1,
      anon_sym_LT,
  [16541] = 4,
    ACTIONS(1038), 1,
      anon_sym_LBRACE,
    ACTIONS(1040), 1,
      anon_sym_ENV,
    ACTIONS(1042), 1,
      anon_sym_CACHE,
    ACTIONS(1044), 1,
      anon_sym_LT,
  [16554] = 3,
    ACTIONS(1046), 1,
      anon_sym_LPAREN,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16564] = 3,
    ACTIONS(1050), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      aux_sym_if_command_token1,
    STATE(607), 1,
      aux_sym_if_command_repeat1,
  [16574] = 3,
    ACTIONS(1054), 1,
      anon_sym_LPAREN,
    ACTIONS(1056), 1,
      aux_sym_if_command_token1,
    STATE(529), 1,
      aux_sym_if_command_repeat1,
  [16584] = 3,
    ACTIONS(1058), 1,
      anon_sym_LPAREN,
    ACTIONS(1060), 1,
      aux_sym_if_command_token1,
    STATE(530), 1,
      aux_sym_if_command_repeat1,
  [16594] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16604] = 3,
    ACTIONS(1064), 1,
      anon_sym_LPAREN,
    ACTIONS(1066), 1,
      aux_sym_if_command_token1,
    STATE(531), 1,
      aux_sym_if_command_repeat1,
  [16614] = 3,
    ACTIONS(1068), 1,
      anon_sym_LPAREN,
    ACTIONS(1070), 1,
      aux_sym_if_command_token1,
    STATE(532), 1,
      aux_sym_if_command_repeat1,
  [16624] = 3,
    ACTIONS(1072), 1,
      anon_sym_LPAREN,
    ACTIONS(1074), 1,
      aux_sym_if_command_token1,
    STATE(533), 1,
      aux_sym_if_command_repeat1,
  [16634] = 3,
    ACTIONS(1076), 1,
      anon_sym_LPAREN,
    ACTIONS(1078), 1,
      aux_sym_if_command_token1,
    STATE(523), 1,
      aux_sym_if_command_repeat1,
  [16644] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1080), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16654] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16664] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1084), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16674] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1086), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16684] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16694] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16704] = 3,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      aux_sym_if_command_token1,
    STATE(543), 1,
      aux_sym_if_command_repeat1,
  [16714] = 3,
    ACTIONS(1096), 1,
      anon_sym_LPAREN,
    ACTIONS(1098), 1,
      aux_sym_if_command_token1,
    STATE(601), 1,
      aux_sym_if_command_repeat1,
  [16724] = 3,
    ACTIONS(1100), 1,
      anon_sym_LPAREN,
    ACTIONS(1102), 1,
      aux_sym_if_command_token1,
    STATE(553), 1,
      aux_sym_if_command_repeat1,
  [16734] = 3,
    ACTIONS(1104), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      aux_sym_if_command_token1,
    STATE(605), 1,
      aux_sym_if_command_repeat1,
  [16744] = 3,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    ACTIONS(1110), 1,
      aux_sym_if_command_token1,
    STATE(600), 1,
      aux_sym_if_command_repeat1,
  [16754] = 3,
    ACTIONS(1112), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      aux_sym_if_command_token1,
    STATE(596), 1,
      aux_sym_if_command_repeat1,
  [16764] = 3,
    ACTIONS(1116), 1,
      anon_sym_LPAREN,
    ACTIONS(1118), 1,
      aux_sym_if_command_token1,
    STATE(606), 1,
      aux_sym_if_command_repeat1,
  [16774] = 3,
    ACTIONS(1120), 1,
      anon_sym_LPAREN,
    ACTIONS(1122), 1,
      aux_sym_if_command_token1,
    STATE(610), 1,
      aux_sym_if_command_repeat1,
  [16784] = 3,
    ACTIONS(1124), 1,
      anon_sym_LPAREN,
    ACTIONS(1126), 1,
      aux_sym_if_command_token1,
    STATE(592), 1,
      aux_sym_if_command_repeat1,
  [16794] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1128), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16804] = 3,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1132), 1,
      aux_sym_if_command_token1,
    STATE(590), 1,
      aux_sym_if_command_repeat1,
  [16814] = 3,
    ACTIONS(1134), 1,
      anon_sym_LPAREN,
    ACTIONS(1136), 1,
      aux_sym_if_command_token1,
    STATE(528), 1,
      aux_sym_if_command_repeat1,
  [16824] = 3,
    ACTIONS(1138), 1,
      anon_sym_GT,
    ACTIONS(1140), 1,
      anon_sym_COLON,
    STATE(722), 1,
      sym__gen_exp_arguments,
  [16834] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1142), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16844] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16854] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1146), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16864] = 1,
    ACTIONS(742), 3,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [16870] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1148), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16880] = 3,
    ACTIONS(1150), 1,
      anon_sym_LBRACE,
    ACTIONS(1152), 1,
      anon_sym_ENV,
    ACTIONS(1154), 1,
      anon_sym_CACHE,
  [16890] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1156), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16900] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1158), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16910] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1160), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16920] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1162), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16930] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1164), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16940] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [16950] = 3,
    ACTIONS(1168), 1,
      anon_sym_LPAREN,
    ACTIONS(1170), 1,
      aux_sym_if_command_token1,
    STATE(548), 1,
      aux_sym_if_command_repeat1,
  [16960] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1174), 1,
      aux_sym_if_command_token1,
    STATE(547), 1,
      aux_sym_if_command_repeat1,
  [16970] = 3,
    ACTIONS(1176), 1,
      anon_sym_LPAREN,
    ACTIONS(1178), 1,
      aux_sym_if_command_token1,
    STATE(549), 1,
      aux_sym_if_command_repeat1,
  [16980] = 3,
    ACTIONS(1180), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      aux_sym_if_command_token1,
    STATE(519), 1,
      aux_sym_if_command_repeat1,
  [16990] = 3,
    ACTIONS(1184), 1,
      anon_sym_LPAREN,
    ACTIONS(1186), 1,
      aux_sym_if_command_token1,
    STATE(551), 1,
      aux_sym_if_command_repeat1,
  [17000] = 3,
    ACTIONS(1188), 1,
      anon_sym_LPAREN,
    ACTIONS(1190), 1,
      aux_sym_if_command_token1,
    STATE(554), 1,
      aux_sym_if_command_repeat1,
  [17010] = 3,
    ACTIONS(1192), 1,
      anon_sym_LPAREN,
    ACTIONS(1194), 1,
      aux_sym_if_command_token1,
    STATE(556), 1,
      aux_sym_if_command_repeat1,
  [17020] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1196), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17030] = 3,
    ACTIONS(1198), 1,
      anon_sym_LPAREN,
    ACTIONS(1200), 1,
      aux_sym_if_command_token1,
    STATE(555), 1,
      aux_sym_if_command_repeat1,
  [17040] = 3,
    ACTIONS(1202), 1,
      anon_sym_LPAREN,
    ACTIONS(1204), 1,
      aux_sym_if_command_token1,
    STATE(566), 1,
      aux_sym_if_command_repeat1,
  [17050] = 1,
    ACTIONS(766), 3,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [17056] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1206), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17066] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1208), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17076] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1210), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17086] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1212), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17096] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17106] = 3,
    ACTIONS(1216), 1,
      anon_sym_LPAREN,
    ACTIONS(1218), 1,
      aux_sym_if_command_token1,
    STATE(570), 1,
      aux_sym_if_command_repeat1,
  [17116] = 3,
    ACTIONS(1220), 1,
      anon_sym_LPAREN,
    ACTIONS(1222), 1,
      aux_sym_if_command_token1,
    STATE(571), 1,
      aux_sym_if_command_repeat1,
  [17126] = 3,
    ACTIONS(1224), 1,
      anon_sym_LPAREN,
    ACTIONS(1226), 1,
      aux_sym_if_command_token1,
    STATE(572), 1,
      aux_sym_if_command_repeat1,
  [17136] = 3,
    ACTIONS(1228), 1,
      anon_sym_LPAREN,
    ACTIONS(1230), 1,
      aux_sym_if_command_token1,
    STATE(573), 1,
      aux_sym_if_command_repeat1,
  [17146] = 3,
    ACTIONS(1232), 1,
      anon_sym_LPAREN,
    ACTIONS(1234), 1,
      aux_sym_if_command_token1,
    STATE(574), 1,
      aux_sym_if_command_repeat1,
  [17156] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1236), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17166] = 3,
    ACTIONS(1238), 1,
      anon_sym_LPAREN,
    ACTIONS(1240), 1,
      aux_sym_if_command_token1,
    STATE(580), 1,
      aux_sym_if_command_repeat1,
  [17176] = 3,
    ACTIONS(1242), 1,
      anon_sym_LPAREN,
    ACTIONS(1244), 1,
      aux_sym_if_command_token1,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17186] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1247), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17196] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1249), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17206] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17216] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1253), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17226] = 3,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      aux_sym_if_command_token1,
    STATE(557), 1,
      aux_sym_if_command_repeat1,
  [17236] = 3,
    ACTIONS(1259), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      aux_sym_if_command_token1,
    STATE(558), 1,
      aux_sym_if_command_repeat1,
  [17246] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17256] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1265), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17266] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1267), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17276] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1269), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17286] = 3,
    ACTIONS(1271), 1,
      anon_sym_LPAREN,
    ACTIONS(1273), 1,
      aux_sym_if_command_token1,
    STATE(589), 1,
      aux_sym_if_command_repeat1,
  [17296] = 3,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1277), 1,
      aux_sym_if_command_token1,
    STATE(609), 1,
      aux_sym_if_command_repeat1,
  [17306] = 3,
    ACTIONS(1279), 1,
      anon_sym_LPAREN,
    ACTIONS(1281), 1,
      aux_sym_if_command_token1,
    STATE(583), 1,
      aux_sym_if_command_repeat1,
  [17316] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17326] = 1,
    ACTIONS(738), 3,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [17332] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17342] = 3,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    ACTIONS(1289), 1,
      aux_sym_if_command_token1,
    STATE(584), 1,
      aux_sym_if_command_repeat1,
  [17352] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17362] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1293), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17372] = 3,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      aux_sym_if_command_token1,
    STATE(585), 1,
      aux_sym_if_command_repeat1,
  [17382] = 3,
    ACTIONS(1299), 1,
      anon_sym_LPAREN,
    ACTIONS(1301), 1,
      aux_sym_if_command_token1,
    STATE(586), 1,
      aux_sym_if_command_repeat1,
  [17392] = 3,
    ACTIONS(1303), 1,
      anon_sym_LPAREN,
    ACTIONS(1305), 1,
      aux_sym_if_command_token1,
    STATE(591), 1,
      aux_sym_if_command_repeat1,
  [17402] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1307), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17412] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17422] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1311), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17432] = 3,
    ACTIONS(1313), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      aux_sym_if_command_token1,
    STATE(598), 1,
      aux_sym_if_command_repeat1,
  [17442] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1317), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17452] = 3,
    ACTIONS(1048), 1,
      aux_sym_if_command_token1,
    ACTIONS(1319), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      aux_sym_if_command_repeat1,
  [17462] = 2,
    ACTIONS(1321), 1,
      anon_sym_RPAREN,
    ACTIONS(1323), 1,
      aux_sym_else_command_token1,
  [17469] = 2,
    ACTIONS(1325), 1,
      anon_sym_RPAREN,
    ACTIONS(1327), 1,
      aux_sym_else_command_token1,
  [17476] = 2,
    ACTIONS(1329), 1,
      anon_sym_RPAREN,
    ACTIONS(1331), 1,
      aux_sym_else_command_token1,
  [17483] = 2,
    ACTIONS(1333), 1,
      anon_sym_RPAREN,
    ACTIONS(1335), 1,
      aux_sym_else_command_token1,
  [17490] = 2,
    ACTIONS(1337), 1,
      anon_sym_RPAREN,
    ACTIONS(1339), 1,
      aux_sym_else_command_token1,
  [17497] = 2,
    ACTIONS(1341), 1,
      anon_sym_RPAREN,
    ACTIONS(1343), 1,
      aux_sym_else_command_token1,
  [17504] = 2,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    ACTIONS(1347), 1,
      aux_sym_else_command_token1,
  [17511] = 2,
    ACTIONS(1349), 1,
      anon_sym_RPAREN,
    ACTIONS(1351), 1,
      aux_sym_else_command_token1,
  [17518] = 2,
    ACTIONS(1353), 1,
      anon_sym_RPAREN,
    ACTIONS(1355), 1,
      aux_sym_else_command_token1,
  [17525] = 2,
    ACTIONS(1357), 1,
      anon_sym_RPAREN,
    ACTIONS(1359), 1,
      aux_sym_else_command_token1,
  [17532] = 2,
    ACTIONS(1361), 1,
      anon_sym_RPAREN,
    ACTIONS(1363), 1,
      aux_sym_else_command_token1,
  [17539] = 2,
    ACTIONS(1365), 1,
      anon_sym_RPAREN,
    ACTIONS(1367), 1,
      aux_sym_else_command_token1,
  [17546] = 2,
    ACTIONS(1369), 1,
      anon_sym_RPAREN,
    ACTIONS(1371), 1,
      aux_sym_else_command_token1,
  [17553] = 2,
    ACTIONS(1373), 1,
      anon_sym_RPAREN,
    ACTIONS(1375), 1,
      aux_sym_else_command_token1,
  [17560] = 2,
    ACTIONS(1377), 1,
      anon_sym_RPAREN,
    ACTIONS(1379), 1,
      aux_sym_else_command_token1,
  [17567] = 2,
    ACTIONS(1381), 1,
      anon_sym_RPAREN,
    ACTIONS(1383), 1,
      aux_sym_else_command_token1,
  [17574] = 2,
    ACTIONS(1385), 1,
      anon_sym_RPAREN,
    ACTIONS(1387), 1,
      aux_sym_else_command_token1,
  [17581] = 2,
    ACTIONS(1389), 1,
      anon_sym_RPAREN,
    ACTIONS(1391), 1,
      aux_sym_else_command_token1,
  [17588] = 2,
    ACTIONS(1393), 1,
      anon_sym_RPAREN,
    ACTIONS(1395), 1,
      aux_sym_else_command_token1,
  [17595] = 2,
    ACTIONS(1397), 1,
      anon_sym_RPAREN,
    ACTIONS(1399), 1,
      aux_sym_else_command_token1,
  [17602] = 2,
    ACTIONS(1401), 1,
      anon_sym_RPAREN,
    ACTIONS(1403), 1,
      aux_sym_else_command_token1,
  [17609] = 2,
    ACTIONS(1405), 1,
      anon_sym_RPAREN,
    ACTIONS(1407), 1,
      aux_sym_else_command_token1,
  [17616] = 2,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
    ACTIONS(1411), 1,
      aux_sym_else_command_token1,
  [17623] = 2,
    ACTIONS(1413), 1,
      anon_sym_RPAREN,
    ACTIONS(1415), 1,
      aux_sym_else_command_token1,
  [17630] = 2,
    ACTIONS(1417), 1,
      anon_sym_RPAREN,
    ACTIONS(1419), 1,
      aux_sym_else_command_token1,
  [17637] = 2,
    ACTIONS(1421), 1,
      anon_sym_RPAREN,
    ACTIONS(1423), 1,
      aux_sym_else_command_token1,
  [17644] = 1,
    ACTIONS(1425), 1,
      aux_sym_else_command_token1,
  [17648] = 1,
    ACTIONS(1427), 1,
      aux_sym_else_command_token1,
  [17652] = 1,
    ACTIONS(1429), 1,
      aux_sym_else_command_token1,
  [17656] = 1,
    ACTIONS(618), 1,
      anon_sym_RPAREN,
  [17660] = 1,
    ACTIONS(1431), 1,
      aux_sym_else_command_token1,
  [17664] = 1,
    ACTIONS(1433), 1,
      aux_sym_else_command_token1,
  [17668] = 1,
    ACTIONS(1435), 1,
      anon_sym_RBRACE,
  [17672] = 1,
    ACTIONS(1437), 1,
      anon_sym_RBRACE,
  [17676] = 1,
    ACTIONS(1439), 1,
      anon_sym_RBRACE,
  [17680] = 1,
    ACTIONS(1441), 1,
      anon_sym_RPAREN,
  [17684] = 1,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
  [17688] = 1,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
  [17692] = 1,
    ACTIONS(1447), 1,
      anon_sym_RPAREN,
  [17696] = 1,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
  [17700] = 1,
    ACTIONS(1451), 1,
      anon_sym_RPAREN,
  [17704] = 1,
    ACTIONS(1453), 1,
      aux_sym_else_command_token1,
  [17708] = 1,
    ACTIONS(1455), 1,
      aux_sym_else_command_token1,
  [17712] = 1,
    ACTIONS(1457), 1,
      aux_sym_else_command_token1,
  [17716] = 1,
    ACTIONS(1459), 1,
      aux_sym_else_command_token1,
  [17720] = 1,
    ACTIONS(1461), 1,
      anon_sym_RPAREN,
  [17724] = 1,
    ACTIONS(1463), 1,
      anon_sym_RBRACE,
  [17728] = 1,
    ACTIONS(1465), 1,
      anon_sym_RBRACE,
  [17732] = 1,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
  [17736] = 1,
    ACTIONS(1469), 1,
      anon_sym_GT,
  [17740] = 1,
    ACTIONS(1471), 1,
      anon_sym_RBRACE,
  [17744] = 1,
    ACTIONS(1473), 1,
      anon_sym_DQUOTE,
  [17748] = 1,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
  [17752] = 1,
    ACTIONS(604), 1,
      anon_sym_RPAREN,
  [17756] = 1,
    ACTIONS(624), 1,
      anon_sym_RPAREN,
  [17760] = 1,
    ACTIONS(1477), 1,
      anon_sym_LBRACE,
  [17764] = 1,
    ACTIONS(1479), 1,
      anon_sym_LBRACE,
  [17768] = 1,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
  [17772] = 1,
    ACTIONS(1483), 1,
      anon_sym_RBRACE,
  [17776] = 1,
    ACTIONS(1485), 1,
      anon_sym_RBRACE,
  [17780] = 1,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
  [17784] = 1,
    ACTIONS(1489), 1,
      aux_sym_else_command_token1,
  [17788] = 1,
    ACTIONS(1491), 1,
      aux_sym_else_command_token1,
  [17792] = 1,
    ACTIONS(1493), 1,
      aux_sym_else_command_token1,
  [17796] = 1,
    ACTIONS(1495), 1,
      aux_sym_else_command_token1,
  [17800] = 1,
    ACTIONS(1497), 1,
      anon_sym_DQUOTE,
  [17804] = 1,
    ACTIONS(1499), 1,
      anon_sym_RBRACE,
  [17808] = 1,
    ACTIONS(1501), 1,
      anon_sym_GT,
  [17812] = 1,
    ACTIONS(1503), 1,
      anon_sym_RPAREN,
  [17816] = 1,
    ACTIONS(1505), 1,
      anon_sym_RPAREN,
  [17820] = 1,
    ACTIONS(1507), 1,
      anon_sym_RBRACE,
  [17824] = 1,
    ACTIONS(1509), 1,
      anon_sym_RBRACE,
  [17828] = 1,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
  [17832] = 1,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
  [17836] = 1,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
  [17840] = 1,
    ACTIONS(1517), 1,
      anon_sym_RPAREN,
  [17844] = 1,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
  [17848] = 1,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
  [17852] = 1,
    ACTIONS(1523), 1,
      anon_sym_GT,
  [17856] = 1,
    ACTIONS(1525), 1,
      anon_sym_RBRACE,
  [17860] = 1,
    ACTIONS(1527), 1,
      anon_sym_RPAREN,
  [17864] = 1,
    ACTIONS(1529), 1,
      aux_sym_else_command_token1,
  [17868] = 1,
    ACTIONS(1531), 1,
      aux_sym_else_command_token1,
  [17872] = 1,
    ACTIONS(1533), 1,
      aux_sym_else_command_token1,
  [17876] = 1,
    ACTIONS(1535), 1,
      aux_sym_else_command_token1,
  [17880] = 1,
    ACTIONS(1537), 1,
      anon_sym_RBRACE,
  [17884] = 1,
    ACTIONS(1539), 1,
      anon_sym_RBRACE,
  [17888] = 1,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
  [17892] = 1,
    ACTIONS(1543), 1,
      anon_sym_RPAREN,
  [17896] = 1,
    ACTIONS(1545), 1,
      anon_sym_GT,
  [17900] = 1,
    ACTIONS(1547), 1,
      anon_sym_RBRACE,
  [17904] = 1,
    ACTIONS(1549), 1,
      anon_sym_RPAREN,
  [17908] = 1,
    ACTIONS(612), 1,
      anon_sym_RPAREN,
  [17912] = 1,
    ACTIONS(1551), 1,
      aux_sym_else_command_token1,
  [17916] = 1,
    ACTIONS(620), 1,
      anon_sym_RPAREN,
  [17920] = 1,
    ACTIONS(1553), 1,
      anon_sym_RPAREN,
  [17924] = 1,
    ACTIONS(1555), 1,
      anon_sym_RBRACE,
  [17928] = 1,
    ACTIONS(1557), 1,
      aux_sym_else_command_token1,
  [17932] = 1,
    ACTIONS(606), 1,
      anon_sym_RPAREN,
  [17936] = 1,
    ACTIONS(1559), 1,
      anon_sym_GT,
  [17940] = 1,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
  [17944] = 1,
    ACTIONS(1563), 1,
      aux_sym_else_command_token1,
  [17948] = 1,
    ACTIONS(1565), 1,
      aux_sym_else_command_token1,
  [17952] = 1,
    ACTIONS(1567), 1,
      aux_sym_else_command_token1,
  [17956] = 1,
    ACTIONS(1569), 1,
      aux_sym_else_command_token1,
  [17960] = 1,
    ACTIONS(1571), 1,
      anon_sym_RPAREN,
  [17964] = 1,
    ACTIONS(1573), 1,
      aux_sym_else_command_token1,
  [17968] = 1,
    ACTIONS(1575), 1,
      anon_sym_RPAREN,
  [17972] = 1,
    ACTIONS(1577), 1,
      anon_sym_LBRACE,
  [17976] = 1,
    ACTIONS(1579), 1,
      anon_sym_LBRACE,
  [17980] = 1,
    ACTIONS(738), 1,
      aux_sym_else_command_token1,
  [17984] = 1,
    ACTIONS(1581), 1,
      anon_sym_GT,
  [17988] = 1,
    ACTIONS(742), 1,
      aux_sym_else_command_token1,
  [17992] = 1,
    ACTIONS(1583), 1,
      anon_sym_RBRACE,
  [17996] = 1,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
  [18000] = 1,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
  [18004] = 1,
    ACTIONS(766), 1,
      aux_sym_else_command_token1,
  [18008] = 1,
    ACTIONS(1589), 1,
      anon_sym_RBRACE,
  [18012] = 1,
    ACTIONS(1591), 1,
      anon_sym_DQUOTE,
  [18016] = 1,
    ACTIONS(1593), 1,
      aux_sym_else_command_token1,
  [18020] = 1,
    ACTIONS(1595), 1,
      anon_sym_LBRACE,
  [18024] = 1,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
  [18028] = 1,
    ACTIONS(1599), 1,
      anon_sym_RPAREN,
  [18032] = 1,
    ACTIONS(1601), 1,
      anon_sym_RPAREN,
  [18036] = 1,
    ACTIONS(1603), 1,
      anon_sym_RPAREN,
  [18040] = 1,
    ACTIONS(1605), 1,
      anon_sym_RPAREN,
  [18044] = 1,
    ACTIONS(1607), 1,
      anon_sym_LBRACE,
  [18048] = 1,
    ACTIONS(1609), 1,
      anon_sym_LBRACE,
  [18052] = 1,
    ACTIONS(1611), 1,
      anon_sym_RBRACE,
  [18056] = 1,
    ACTIONS(1613), 1,
      anon_sym_RBRACE,
  [18060] = 1,
    ACTIONS(1615), 1,
      ts_builtin_sym_end,
  [18064] = 1,
    ACTIONS(1617), 1,
      aux_sym_else_command_token1,
  [18068] = 1,
    ACTIONS(1619), 1,
      anon_sym_LBRACE,
  [18072] = 1,
    ACTIONS(1621), 1,
      anon_sym_LBRACE,
  [18076] = 1,
    ACTIONS(1623), 1,
      anon_sym_RPAREN,
  [18080] = 1,
    ACTIONS(1625), 1,
      anon_sym_GT,
  [18084] = 1,
    ACTIONS(1627), 1,
      anon_sym_RBRACE,
  [18088] = 1,
    ACTIONS(1629), 1,
      anon_sym_RPAREN,
  [18092] = 1,
    ACTIONS(1631), 1,
      anon_sym_LBRACE,
  [18096] = 1,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 64,
  [SMALL_STATE(4)] = 128,
  [SMALL_STATE(5)] = 192,
  [SMALL_STATE(6)] = 256,
  [SMALL_STATE(7)] = 320,
  [SMALL_STATE(8)] = 384,
  [SMALL_STATE(9)] = 448,
  [SMALL_STATE(10)] = 512,
  [SMALL_STATE(11)] = 576,
  [SMALL_STATE(12)] = 640,
  [SMALL_STATE(13)] = 704,
  [SMALL_STATE(14)] = 768,
  [SMALL_STATE(15)] = 823,
  [SMALL_STATE(16)] = 878,
  [SMALL_STATE(17)] = 933,
  [SMALL_STATE(18)] = 988,
  [SMALL_STATE(19)] = 1043,
  [SMALL_STATE(20)] = 1098,
  [SMALL_STATE(21)] = 1153,
  [SMALL_STATE(22)] = 1208,
  [SMALL_STATE(23)] = 1263,
  [SMALL_STATE(24)] = 1318,
  [SMALL_STATE(25)] = 1373,
  [SMALL_STATE(26)] = 1428,
  [SMALL_STATE(27)] = 1483,
  [SMALL_STATE(28)] = 1538,
  [SMALL_STATE(29)] = 1593,
  [SMALL_STATE(30)] = 1648,
  [SMALL_STATE(31)] = 1703,
  [SMALL_STATE(32)] = 1758,
  [SMALL_STATE(33)] = 1813,
  [SMALL_STATE(34)] = 1868,
  [SMALL_STATE(35)] = 1923,
  [SMALL_STATE(36)] = 1978,
  [SMALL_STATE(37)] = 2033,
  [SMALL_STATE(38)] = 2088,
  [SMALL_STATE(39)] = 2143,
  [SMALL_STATE(40)] = 2198,
  [SMALL_STATE(41)] = 2253,
  [SMALL_STATE(42)] = 2308,
  [SMALL_STATE(43)] = 2363,
  [SMALL_STATE(44)] = 2418,
  [SMALL_STATE(45)] = 2473,
  [SMALL_STATE(46)] = 2528,
  [SMALL_STATE(47)] = 2583,
  [SMALL_STATE(48)] = 2638,
  [SMALL_STATE(49)] = 2693,
  [SMALL_STATE(50)] = 2748,
  [SMALL_STATE(51)] = 2803,
  [SMALL_STATE(52)] = 2858,
  [SMALL_STATE(53)] = 2913,
  [SMALL_STATE(54)] = 2968,
  [SMALL_STATE(55)] = 3023,
  [SMALL_STATE(56)] = 3078,
  [SMALL_STATE(57)] = 3133,
  [SMALL_STATE(58)] = 3188,
  [SMALL_STATE(59)] = 3243,
  [SMALL_STATE(60)] = 3298,
  [SMALL_STATE(61)] = 3353,
  [SMALL_STATE(62)] = 3408,
  [SMALL_STATE(63)] = 3463,
  [SMALL_STATE(64)] = 3518,
  [SMALL_STATE(65)] = 3573,
  [SMALL_STATE(66)] = 3628,
  [SMALL_STATE(67)] = 3683,
  [SMALL_STATE(68)] = 3738,
  [SMALL_STATE(69)] = 3793,
  [SMALL_STATE(70)] = 3848,
  [SMALL_STATE(71)] = 3903,
  [SMALL_STATE(72)] = 3958,
  [SMALL_STATE(73)] = 4013,
  [SMALL_STATE(74)] = 4068,
  [SMALL_STATE(75)] = 4123,
  [SMALL_STATE(76)] = 4178,
  [SMALL_STATE(77)] = 4233,
  [SMALL_STATE(78)] = 4288,
  [SMALL_STATE(79)] = 4343,
  [SMALL_STATE(80)] = 4398,
  [SMALL_STATE(81)] = 4459,
  [SMALL_STATE(82)] = 4514,
  [SMALL_STATE(83)] = 4569,
  [SMALL_STATE(84)] = 4624,
  [SMALL_STATE(85)] = 4679,
  [SMALL_STATE(86)] = 4734,
  [SMALL_STATE(87)] = 4789,
  [SMALL_STATE(88)] = 4844,
  [SMALL_STATE(89)] = 4899,
  [SMALL_STATE(90)] = 4954,
  [SMALL_STATE(91)] = 5009,
  [SMALL_STATE(92)] = 5064,
  [SMALL_STATE(93)] = 5119,
  [SMALL_STATE(94)] = 5174,
  [SMALL_STATE(95)] = 5229,
  [SMALL_STATE(96)] = 5284,
  [SMALL_STATE(97)] = 5339,
  [SMALL_STATE(98)] = 5394,
  [SMALL_STATE(99)] = 5449,
  [SMALL_STATE(100)] = 5504,
  [SMALL_STATE(101)] = 5559,
  [SMALL_STATE(102)] = 5614,
  [SMALL_STATE(103)] = 5669,
  [SMALL_STATE(104)] = 5724,
  [SMALL_STATE(105)] = 5779,
  [SMALL_STATE(106)] = 5834,
  [SMALL_STATE(107)] = 5889,
  [SMALL_STATE(108)] = 5944,
  [SMALL_STATE(109)] = 5999,
  [SMALL_STATE(110)] = 6054,
  [SMALL_STATE(111)] = 6109,
  [SMALL_STATE(112)] = 6164,
  [SMALL_STATE(113)] = 6219,
  [SMALL_STATE(114)] = 6274,
  [SMALL_STATE(115)] = 6330,
  [SMALL_STATE(116)] = 6386,
  [SMALL_STATE(117)] = 6442,
  [SMALL_STATE(118)] = 6498,
  [SMALL_STATE(119)] = 6554,
  [SMALL_STATE(120)] = 6610,
  [SMALL_STATE(121)] = 6666,
  [SMALL_STATE(122)] = 6722,
  [SMALL_STATE(123)] = 6778,
  [SMALL_STATE(124)] = 6834,
  [SMALL_STATE(125)] = 6890,
  [SMALL_STATE(126)] = 6946,
  [SMALL_STATE(127)] = 7002,
  [SMALL_STATE(128)] = 7058,
  [SMALL_STATE(129)] = 7114,
  [SMALL_STATE(130)] = 7170,
  [SMALL_STATE(131)] = 7226,
  [SMALL_STATE(132)] = 7282,
  [SMALL_STATE(133)] = 7338,
  [SMALL_STATE(134)] = 7394,
  [SMALL_STATE(135)] = 7450,
  [SMALL_STATE(136)] = 7506,
  [SMALL_STATE(137)] = 7562,
  [SMALL_STATE(138)] = 7618,
  [SMALL_STATE(139)] = 7674,
  [SMALL_STATE(140)] = 7730,
  [SMALL_STATE(141)] = 7786,
  [SMALL_STATE(142)] = 7842,
  [SMALL_STATE(143)] = 7898,
  [SMALL_STATE(144)] = 7954,
  [SMALL_STATE(145)] = 8010,
  [SMALL_STATE(146)] = 8066,
  [SMALL_STATE(147)] = 8122,
  [SMALL_STATE(148)] = 8178,
  [SMALL_STATE(149)] = 8234,
  [SMALL_STATE(150)] = 8290,
  [SMALL_STATE(151)] = 8346,
  [SMALL_STATE(152)] = 8402,
  [SMALL_STATE(153)] = 8458,
  [SMALL_STATE(154)] = 8514,
  [SMALL_STATE(155)] = 8570,
  [SMALL_STATE(156)] = 8626,
  [SMALL_STATE(157)] = 8682,
  [SMALL_STATE(158)] = 8738,
  [SMALL_STATE(159)] = 8794,
  [SMALL_STATE(160)] = 8850,
  [SMALL_STATE(161)] = 8906,
  [SMALL_STATE(162)] = 8962,
  [SMALL_STATE(163)] = 9015,
  [SMALL_STATE(164)] = 9068,
  [SMALL_STATE(165)] = 9121,
  [SMALL_STATE(166)] = 9174,
  [SMALL_STATE(167)] = 9227,
  [SMALL_STATE(168)] = 9280,
  [SMALL_STATE(169)] = 9317,
  [SMALL_STATE(170)] = 9364,
  [SMALL_STATE(171)] = 9411,
  [SMALL_STATE(172)] = 9458,
  [SMALL_STATE(173)] = 9505,
  [SMALL_STATE(174)] = 9542,
  [SMALL_STATE(175)] = 9589,
  [SMALL_STATE(176)] = 9636,
  [SMALL_STATE(177)] = 9683,
  [SMALL_STATE(178)] = 9730,
  [SMALL_STATE(179)] = 9777,
  [SMALL_STATE(180)] = 9821,
  [SMALL_STATE(181)] = 9865,
  [SMALL_STATE(182)] = 9909,
  [SMALL_STATE(183)] = 9953,
  [SMALL_STATE(184)] = 9997,
  [SMALL_STATE(185)] = 10041,
  [SMALL_STATE(186)] = 10085,
  [SMALL_STATE(187)] = 10129,
  [SMALL_STATE(188)] = 10173,
  [SMALL_STATE(189)] = 10217,
  [SMALL_STATE(190)] = 10261,
  [SMALL_STATE(191)] = 10305,
  [SMALL_STATE(192)] = 10346,
  [SMALL_STATE(193)] = 10387,
  [SMALL_STATE(194)] = 10428,
  [SMALL_STATE(195)] = 10469,
  [SMALL_STATE(196)] = 10510,
  [SMALL_STATE(197)] = 10551,
  [SMALL_STATE(198)] = 10592,
  [SMALL_STATE(199)] = 10633,
  [SMALL_STATE(200)] = 10674,
  [SMALL_STATE(201)] = 10715,
  [SMALL_STATE(202)] = 10756,
  [SMALL_STATE(203)] = 10797,
  [SMALL_STATE(204)] = 10838,
  [SMALL_STATE(205)] = 10879,
  [SMALL_STATE(206)] = 10920,
  [SMALL_STATE(207)] = 10961,
  [SMALL_STATE(208)] = 11002,
  [SMALL_STATE(209)] = 11043,
  [SMALL_STATE(210)] = 11084,
  [SMALL_STATE(211)] = 11125,
  [SMALL_STATE(212)] = 11166,
  [SMALL_STATE(213)] = 11207,
  [SMALL_STATE(214)] = 11248,
  [SMALL_STATE(215)] = 11289,
  [SMALL_STATE(216)] = 11330,
  [SMALL_STATE(217)] = 11371,
  [SMALL_STATE(218)] = 11407,
  [SMALL_STATE(219)] = 11443,
  [SMALL_STATE(220)] = 11477,
  [SMALL_STATE(221)] = 11511,
  [SMALL_STATE(222)] = 11543,
  [SMALL_STATE(223)] = 11577,
  [SMALL_STATE(224)] = 11611,
  [SMALL_STATE(225)] = 11643,
  [SMALL_STATE(226)] = 11674,
  [SMALL_STATE(227)] = 11705,
  [SMALL_STATE(228)] = 11736,
  [SMALL_STATE(229)] = 11767,
  [SMALL_STATE(230)] = 11798,
  [SMALL_STATE(231)] = 11829,
  [SMALL_STATE(232)] = 11859,
  [SMALL_STATE(233)] = 11889,
  [SMALL_STATE(234)] = 11919,
  [SMALL_STATE(235)] = 11949,
  [SMALL_STATE(236)] = 11979,
  [SMALL_STATE(237)] = 12009,
  [SMALL_STATE(238)] = 12039,
  [SMALL_STATE(239)] = 12069,
  [SMALL_STATE(240)] = 12099,
  [SMALL_STATE(241)] = 12129,
  [SMALL_STATE(242)] = 12159,
  [SMALL_STATE(243)] = 12189,
  [SMALL_STATE(244)] = 12219,
  [SMALL_STATE(245)] = 12249,
  [SMALL_STATE(246)] = 12279,
  [SMALL_STATE(247)] = 12309,
  [SMALL_STATE(248)] = 12339,
  [SMALL_STATE(249)] = 12369,
  [SMALL_STATE(250)] = 12399,
  [SMALL_STATE(251)] = 12429,
  [SMALL_STATE(252)] = 12459,
  [SMALL_STATE(253)] = 12489,
  [SMALL_STATE(254)] = 12519,
  [SMALL_STATE(255)] = 12538,
  [SMALL_STATE(256)] = 12557,
  [SMALL_STATE(257)] = 12576,
  [SMALL_STATE(258)] = 12595,
  [SMALL_STATE(259)] = 12614,
  [SMALL_STATE(260)] = 12633,
  [SMALL_STATE(261)] = 12652,
  [SMALL_STATE(262)] = 12671,
  [SMALL_STATE(263)] = 12690,
  [SMALL_STATE(264)] = 12709,
  [SMALL_STATE(265)] = 12728,
  [SMALL_STATE(266)] = 12747,
  [SMALL_STATE(267)] = 12764,
  [SMALL_STATE(268)] = 12781,
  [SMALL_STATE(269)] = 12798,
  [SMALL_STATE(270)] = 12815,
  [SMALL_STATE(271)] = 12832,
  [SMALL_STATE(272)] = 12849,
  [SMALL_STATE(273)] = 12866,
  [SMALL_STATE(274)] = 12883,
  [SMALL_STATE(275)] = 12900,
  [SMALL_STATE(276)] = 12917,
  [SMALL_STATE(277)] = 12934,
  [SMALL_STATE(278)] = 12951,
  [SMALL_STATE(279)] = 12968,
  [SMALL_STATE(280)] = 12985,
  [SMALL_STATE(281)] = 13002,
  [SMALL_STATE(282)] = 13019,
  [SMALL_STATE(283)] = 13036,
  [SMALL_STATE(284)] = 13053,
  [SMALL_STATE(285)] = 13070,
  [SMALL_STATE(286)] = 13087,
  [SMALL_STATE(287)] = 13104,
  [SMALL_STATE(288)] = 13121,
  [SMALL_STATE(289)] = 13138,
  [SMALL_STATE(290)] = 13155,
  [SMALL_STATE(291)] = 13172,
  [SMALL_STATE(292)] = 13189,
  [SMALL_STATE(293)] = 13206,
  [SMALL_STATE(294)] = 13223,
  [SMALL_STATE(295)] = 13240,
  [SMALL_STATE(296)] = 13257,
  [SMALL_STATE(297)] = 13274,
  [SMALL_STATE(298)] = 13291,
  [SMALL_STATE(299)] = 13308,
  [SMALL_STATE(300)] = 13325,
  [SMALL_STATE(301)] = 13342,
  [SMALL_STATE(302)] = 13359,
  [SMALL_STATE(303)] = 13376,
  [SMALL_STATE(304)] = 13393,
  [SMALL_STATE(305)] = 13410,
  [SMALL_STATE(306)] = 13427,
  [SMALL_STATE(307)] = 13443,
  [SMALL_STATE(308)] = 13459,
  [SMALL_STATE(309)] = 13475,
  [SMALL_STATE(310)] = 13493,
  [SMALL_STATE(311)] = 13509,
  [SMALL_STATE(312)] = 13525,
  [SMALL_STATE(313)] = 13541,
  [SMALL_STATE(314)] = 13557,
  [SMALL_STATE(315)] = 13573,
  [SMALL_STATE(316)] = 13589,
  [SMALL_STATE(317)] = 13605,
  [SMALL_STATE(318)] = 13620,
  [SMALL_STATE(319)] = 13635,
  [SMALL_STATE(320)] = 13650,
  [SMALL_STATE(321)] = 13665,
  [SMALL_STATE(322)] = 13680,
  [SMALL_STATE(323)] = 13695,
  [SMALL_STATE(324)] = 13710,
  [SMALL_STATE(325)] = 13725,
  [SMALL_STATE(326)] = 13740,
  [SMALL_STATE(327)] = 13755,
  [SMALL_STATE(328)] = 13770,
  [SMALL_STATE(329)] = 13785,
  [SMALL_STATE(330)] = 13800,
  [SMALL_STATE(331)] = 13815,
  [SMALL_STATE(332)] = 13830,
  [SMALL_STATE(333)] = 13845,
  [SMALL_STATE(334)] = 13860,
  [SMALL_STATE(335)] = 13875,
  [SMALL_STATE(336)] = 13890,
  [SMALL_STATE(337)] = 13905,
  [SMALL_STATE(338)] = 13920,
  [SMALL_STATE(339)] = 13935,
  [SMALL_STATE(340)] = 13950,
  [SMALL_STATE(341)] = 13965,
  [SMALL_STATE(342)] = 13980,
  [SMALL_STATE(343)] = 13995,
  [SMALL_STATE(344)] = 14010,
  [SMALL_STATE(345)] = 14025,
  [SMALL_STATE(346)] = 14040,
  [SMALL_STATE(347)] = 14055,
  [SMALL_STATE(348)] = 14070,
  [SMALL_STATE(349)] = 14085,
  [SMALL_STATE(350)] = 14100,
  [SMALL_STATE(351)] = 14115,
  [SMALL_STATE(352)] = 14130,
  [SMALL_STATE(353)] = 14145,
  [SMALL_STATE(354)] = 14160,
  [SMALL_STATE(355)] = 14175,
  [SMALL_STATE(356)] = 14190,
  [SMALL_STATE(357)] = 14205,
  [SMALL_STATE(358)] = 14220,
  [SMALL_STATE(359)] = 14235,
  [SMALL_STATE(360)] = 14250,
  [SMALL_STATE(361)] = 14265,
  [SMALL_STATE(362)] = 14280,
  [SMALL_STATE(363)] = 14295,
  [SMALL_STATE(364)] = 14310,
  [SMALL_STATE(365)] = 14325,
  [SMALL_STATE(366)] = 14340,
  [SMALL_STATE(367)] = 14355,
  [SMALL_STATE(368)] = 14370,
  [SMALL_STATE(369)] = 14385,
  [SMALL_STATE(370)] = 14400,
  [SMALL_STATE(371)] = 14415,
  [SMALL_STATE(372)] = 14430,
  [SMALL_STATE(373)] = 14445,
  [SMALL_STATE(374)] = 14460,
  [SMALL_STATE(375)] = 14475,
  [SMALL_STATE(376)] = 14490,
  [SMALL_STATE(377)] = 14505,
  [SMALL_STATE(378)] = 14520,
  [SMALL_STATE(379)] = 14535,
  [SMALL_STATE(380)] = 14550,
  [SMALL_STATE(381)] = 14565,
  [SMALL_STATE(382)] = 14580,
  [SMALL_STATE(383)] = 14595,
  [SMALL_STATE(384)] = 14610,
  [SMALL_STATE(385)] = 14625,
  [SMALL_STATE(386)] = 14640,
  [SMALL_STATE(387)] = 14655,
  [SMALL_STATE(388)] = 14670,
  [SMALL_STATE(389)] = 14685,
  [SMALL_STATE(390)] = 14700,
  [SMALL_STATE(391)] = 14715,
  [SMALL_STATE(392)] = 14730,
  [SMALL_STATE(393)] = 14745,
  [SMALL_STATE(394)] = 14760,
  [SMALL_STATE(395)] = 14775,
  [SMALL_STATE(396)] = 14790,
  [SMALL_STATE(397)] = 14805,
  [SMALL_STATE(398)] = 14820,
  [SMALL_STATE(399)] = 14835,
  [SMALL_STATE(400)] = 14850,
  [SMALL_STATE(401)] = 14865,
  [SMALL_STATE(402)] = 14880,
  [SMALL_STATE(403)] = 14895,
  [SMALL_STATE(404)] = 14910,
  [SMALL_STATE(405)] = 14925,
  [SMALL_STATE(406)] = 14940,
  [SMALL_STATE(407)] = 14955,
  [SMALL_STATE(408)] = 14970,
  [SMALL_STATE(409)] = 14985,
  [SMALL_STATE(410)] = 15000,
  [SMALL_STATE(411)] = 15015,
  [SMALL_STATE(412)] = 15030,
  [SMALL_STATE(413)] = 15045,
  [SMALL_STATE(414)] = 15060,
  [SMALL_STATE(415)] = 15075,
  [SMALL_STATE(416)] = 15090,
  [SMALL_STATE(417)] = 15105,
  [SMALL_STATE(418)] = 15120,
  [SMALL_STATE(419)] = 15135,
  [SMALL_STATE(420)] = 15150,
  [SMALL_STATE(421)] = 15165,
  [SMALL_STATE(422)] = 15180,
  [SMALL_STATE(423)] = 15195,
  [SMALL_STATE(424)] = 15210,
  [SMALL_STATE(425)] = 15225,
  [SMALL_STATE(426)] = 15240,
  [SMALL_STATE(427)] = 15255,
  [SMALL_STATE(428)] = 15270,
  [SMALL_STATE(429)] = 15285,
  [SMALL_STATE(430)] = 15300,
  [SMALL_STATE(431)] = 15315,
  [SMALL_STATE(432)] = 15330,
  [SMALL_STATE(433)] = 15345,
  [SMALL_STATE(434)] = 15360,
  [SMALL_STATE(435)] = 15375,
  [SMALL_STATE(436)] = 15390,
  [SMALL_STATE(437)] = 15405,
  [SMALL_STATE(438)] = 15420,
  [SMALL_STATE(439)] = 15435,
  [SMALL_STATE(440)] = 15450,
  [SMALL_STATE(441)] = 15465,
  [SMALL_STATE(442)] = 15480,
  [SMALL_STATE(443)] = 15495,
  [SMALL_STATE(444)] = 15510,
  [SMALL_STATE(445)] = 15525,
  [SMALL_STATE(446)] = 15540,
  [SMALL_STATE(447)] = 15555,
  [SMALL_STATE(448)] = 15570,
  [SMALL_STATE(449)] = 15585,
  [SMALL_STATE(450)] = 15600,
  [SMALL_STATE(451)] = 15615,
  [SMALL_STATE(452)] = 15630,
  [SMALL_STATE(453)] = 15645,
  [SMALL_STATE(454)] = 15660,
  [SMALL_STATE(455)] = 15675,
  [SMALL_STATE(456)] = 15690,
  [SMALL_STATE(457)] = 15705,
  [SMALL_STATE(458)] = 15720,
  [SMALL_STATE(459)] = 15735,
  [SMALL_STATE(460)] = 15750,
  [SMALL_STATE(461)] = 15765,
  [SMALL_STATE(462)] = 15780,
  [SMALL_STATE(463)] = 15795,
  [SMALL_STATE(464)] = 15810,
  [SMALL_STATE(465)] = 15825,
  [SMALL_STATE(466)] = 15840,
  [SMALL_STATE(467)] = 15855,
  [SMALL_STATE(468)] = 15870,
  [SMALL_STATE(469)] = 15885,
  [SMALL_STATE(470)] = 15900,
  [SMALL_STATE(471)] = 15915,
  [SMALL_STATE(472)] = 15930,
  [SMALL_STATE(473)] = 15945,
  [SMALL_STATE(474)] = 15960,
  [SMALL_STATE(475)] = 15975,
  [SMALL_STATE(476)] = 15990,
  [SMALL_STATE(477)] = 16005,
  [SMALL_STATE(478)] = 16020,
  [SMALL_STATE(479)] = 16035,
  [SMALL_STATE(480)] = 16050,
  [SMALL_STATE(481)] = 16064,
  [SMALL_STATE(482)] = 16078,
  [SMALL_STATE(483)] = 16092,
  [SMALL_STATE(484)] = 16106,
  [SMALL_STATE(485)] = 16120,
  [SMALL_STATE(486)] = 16134,
  [SMALL_STATE(487)] = 16148,
  [SMALL_STATE(488)] = 16161,
  [SMALL_STATE(489)] = 16174,
  [SMALL_STATE(490)] = 16185,
  [SMALL_STATE(491)] = 16198,
  [SMALL_STATE(492)] = 16211,
  [SMALL_STATE(493)] = 16222,
  [SMALL_STATE(494)] = 16233,
  [SMALL_STATE(495)] = 16244,
  [SMALL_STATE(496)] = 16255,
  [SMALL_STATE(497)] = 16268,
  [SMALL_STATE(498)] = 16281,
  [SMALL_STATE(499)] = 16294,
  [SMALL_STATE(500)] = 16307,
  [SMALL_STATE(501)] = 16320,
  [SMALL_STATE(502)] = 16333,
  [SMALL_STATE(503)] = 16346,
  [SMALL_STATE(504)] = 16359,
  [SMALL_STATE(505)] = 16372,
  [SMALL_STATE(506)] = 16385,
  [SMALL_STATE(507)] = 16398,
  [SMALL_STATE(508)] = 16411,
  [SMALL_STATE(509)] = 16424,
  [SMALL_STATE(510)] = 16437,
  [SMALL_STATE(511)] = 16450,
  [SMALL_STATE(512)] = 16463,
  [SMALL_STATE(513)] = 16476,
  [SMALL_STATE(514)] = 16489,
  [SMALL_STATE(515)] = 16502,
  [SMALL_STATE(516)] = 16515,
  [SMALL_STATE(517)] = 16528,
  [SMALL_STATE(518)] = 16541,
  [SMALL_STATE(519)] = 16554,
  [SMALL_STATE(520)] = 16564,
  [SMALL_STATE(521)] = 16574,
  [SMALL_STATE(522)] = 16584,
  [SMALL_STATE(523)] = 16594,
  [SMALL_STATE(524)] = 16604,
  [SMALL_STATE(525)] = 16614,
  [SMALL_STATE(526)] = 16624,
  [SMALL_STATE(527)] = 16634,
  [SMALL_STATE(528)] = 16644,
  [SMALL_STATE(529)] = 16654,
  [SMALL_STATE(530)] = 16664,
  [SMALL_STATE(531)] = 16674,
  [SMALL_STATE(532)] = 16684,
  [SMALL_STATE(533)] = 16694,
  [SMALL_STATE(534)] = 16704,
  [SMALL_STATE(535)] = 16714,
  [SMALL_STATE(536)] = 16724,
  [SMALL_STATE(537)] = 16734,
  [SMALL_STATE(538)] = 16744,
  [SMALL_STATE(539)] = 16754,
  [SMALL_STATE(540)] = 16764,
  [SMALL_STATE(541)] = 16774,
  [SMALL_STATE(542)] = 16784,
  [SMALL_STATE(543)] = 16794,
  [SMALL_STATE(544)] = 16804,
  [SMALL_STATE(545)] = 16814,
  [SMALL_STATE(546)] = 16824,
  [SMALL_STATE(547)] = 16834,
  [SMALL_STATE(548)] = 16844,
  [SMALL_STATE(549)] = 16854,
  [SMALL_STATE(550)] = 16864,
  [SMALL_STATE(551)] = 16870,
  [SMALL_STATE(552)] = 16880,
  [SMALL_STATE(553)] = 16890,
  [SMALL_STATE(554)] = 16900,
  [SMALL_STATE(555)] = 16910,
  [SMALL_STATE(556)] = 16920,
  [SMALL_STATE(557)] = 16930,
  [SMALL_STATE(558)] = 16940,
  [SMALL_STATE(559)] = 16950,
  [SMALL_STATE(560)] = 16960,
  [SMALL_STATE(561)] = 16970,
  [SMALL_STATE(562)] = 16980,
  [SMALL_STATE(563)] = 16990,
  [SMALL_STATE(564)] = 17000,
  [SMALL_STATE(565)] = 17010,
  [SMALL_STATE(566)] = 17020,
  [SMALL_STATE(567)] = 17030,
  [SMALL_STATE(568)] = 17040,
  [SMALL_STATE(569)] = 17050,
  [SMALL_STATE(570)] = 17056,
  [SMALL_STATE(571)] = 17066,
  [SMALL_STATE(572)] = 17076,
  [SMALL_STATE(573)] = 17086,
  [SMALL_STATE(574)] = 17096,
  [SMALL_STATE(575)] = 17106,
  [SMALL_STATE(576)] = 17116,
  [SMALL_STATE(577)] = 17126,
  [SMALL_STATE(578)] = 17136,
  [SMALL_STATE(579)] = 17146,
  [SMALL_STATE(580)] = 17156,
  [SMALL_STATE(581)] = 17166,
  [SMALL_STATE(582)] = 17176,
  [SMALL_STATE(583)] = 17186,
  [SMALL_STATE(584)] = 17196,
  [SMALL_STATE(585)] = 17206,
  [SMALL_STATE(586)] = 17216,
  [SMALL_STATE(587)] = 17226,
  [SMALL_STATE(588)] = 17236,
  [SMALL_STATE(589)] = 17246,
  [SMALL_STATE(590)] = 17256,
  [SMALL_STATE(591)] = 17266,
  [SMALL_STATE(592)] = 17276,
  [SMALL_STATE(593)] = 17286,
  [SMALL_STATE(594)] = 17296,
  [SMALL_STATE(595)] = 17306,
  [SMALL_STATE(596)] = 17316,
  [SMALL_STATE(597)] = 17326,
  [SMALL_STATE(598)] = 17332,
  [SMALL_STATE(599)] = 17342,
  [SMALL_STATE(600)] = 17352,
  [SMALL_STATE(601)] = 17362,
  [SMALL_STATE(602)] = 17372,
  [SMALL_STATE(603)] = 17382,
  [SMALL_STATE(604)] = 17392,
  [SMALL_STATE(605)] = 17402,
  [SMALL_STATE(606)] = 17412,
  [SMALL_STATE(607)] = 17422,
  [SMALL_STATE(608)] = 17432,
  [SMALL_STATE(609)] = 17442,
  [SMALL_STATE(610)] = 17452,
  [SMALL_STATE(611)] = 17462,
  [SMALL_STATE(612)] = 17469,
  [SMALL_STATE(613)] = 17476,
  [SMALL_STATE(614)] = 17483,
  [SMALL_STATE(615)] = 17490,
  [SMALL_STATE(616)] = 17497,
  [SMALL_STATE(617)] = 17504,
  [SMALL_STATE(618)] = 17511,
  [SMALL_STATE(619)] = 17518,
  [SMALL_STATE(620)] = 17525,
  [SMALL_STATE(621)] = 17532,
  [SMALL_STATE(622)] = 17539,
  [SMALL_STATE(623)] = 17546,
  [SMALL_STATE(624)] = 17553,
  [SMALL_STATE(625)] = 17560,
  [SMALL_STATE(626)] = 17567,
  [SMALL_STATE(627)] = 17574,
  [SMALL_STATE(628)] = 17581,
  [SMALL_STATE(629)] = 17588,
  [SMALL_STATE(630)] = 17595,
  [SMALL_STATE(631)] = 17602,
  [SMALL_STATE(632)] = 17609,
  [SMALL_STATE(633)] = 17616,
  [SMALL_STATE(634)] = 17623,
  [SMALL_STATE(635)] = 17630,
  [SMALL_STATE(636)] = 17637,
  [SMALL_STATE(637)] = 17644,
  [SMALL_STATE(638)] = 17648,
  [SMALL_STATE(639)] = 17652,
  [SMALL_STATE(640)] = 17656,
  [SMALL_STATE(641)] = 17660,
  [SMALL_STATE(642)] = 17664,
  [SMALL_STATE(643)] = 17668,
  [SMALL_STATE(644)] = 17672,
  [SMALL_STATE(645)] = 17676,
  [SMALL_STATE(646)] = 17680,
  [SMALL_STATE(647)] = 17684,
  [SMALL_STATE(648)] = 17688,
  [SMALL_STATE(649)] = 17692,
  [SMALL_STATE(650)] = 17696,
  [SMALL_STATE(651)] = 17700,
  [SMALL_STATE(652)] = 17704,
  [SMALL_STATE(653)] = 17708,
  [SMALL_STATE(654)] = 17712,
  [SMALL_STATE(655)] = 17716,
  [SMALL_STATE(656)] = 17720,
  [SMALL_STATE(657)] = 17724,
  [SMALL_STATE(658)] = 17728,
  [SMALL_STATE(659)] = 17732,
  [SMALL_STATE(660)] = 17736,
  [SMALL_STATE(661)] = 17740,
  [SMALL_STATE(662)] = 17744,
  [SMALL_STATE(663)] = 17748,
  [SMALL_STATE(664)] = 17752,
  [SMALL_STATE(665)] = 17756,
  [SMALL_STATE(666)] = 17760,
  [SMALL_STATE(667)] = 17764,
  [SMALL_STATE(668)] = 17768,
  [SMALL_STATE(669)] = 17772,
  [SMALL_STATE(670)] = 17776,
  [SMALL_STATE(671)] = 17780,
  [SMALL_STATE(672)] = 17784,
  [SMALL_STATE(673)] = 17788,
  [SMALL_STATE(674)] = 17792,
  [SMALL_STATE(675)] = 17796,
  [SMALL_STATE(676)] = 17800,
  [SMALL_STATE(677)] = 17804,
  [SMALL_STATE(678)] = 17808,
  [SMALL_STATE(679)] = 17812,
  [SMALL_STATE(680)] = 17816,
  [SMALL_STATE(681)] = 17820,
  [SMALL_STATE(682)] = 17824,
  [SMALL_STATE(683)] = 17828,
  [SMALL_STATE(684)] = 17832,
  [SMALL_STATE(685)] = 17836,
  [SMALL_STATE(686)] = 17840,
  [SMALL_STATE(687)] = 17844,
  [SMALL_STATE(688)] = 17848,
  [SMALL_STATE(689)] = 17852,
  [SMALL_STATE(690)] = 17856,
  [SMALL_STATE(691)] = 17860,
  [SMALL_STATE(692)] = 17864,
  [SMALL_STATE(693)] = 17868,
  [SMALL_STATE(694)] = 17872,
  [SMALL_STATE(695)] = 17876,
  [SMALL_STATE(696)] = 17880,
  [SMALL_STATE(697)] = 17884,
  [SMALL_STATE(698)] = 17888,
  [SMALL_STATE(699)] = 17892,
  [SMALL_STATE(700)] = 17896,
  [SMALL_STATE(701)] = 17900,
  [SMALL_STATE(702)] = 17904,
  [SMALL_STATE(703)] = 17908,
  [SMALL_STATE(704)] = 17912,
  [SMALL_STATE(705)] = 17916,
  [SMALL_STATE(706)] = 17920,
  [SMALL_STATE(707)] = 17924,
  [SMALL_STATE(708)] = 17928,
  [SMALL_STATE(709)] = 17932,
  [SMALL_STATE(710)] = 17936,
  [SMALL_STATE(711)] = 17940,
  [SMALL_STATE(712)] = 17944,
  [SMALL_STATE(713)] = 17948,
  [SMALL_STATE(714)] = 17952,
  [SMALL_STATE(715)] = 17956,
  [SMALL_STATE(716)] = 17960,
  [SMALL_STATE(717)] = 17964,
  [SMALL_STATE(718)] = 17968,
  [SMALL_STATE(719)] = 17972,
  [SMALL_STATE(720)] = 17976,
  [SMALL_STATE(721)] = 17980,
  [SMALL_STATE(722)] = 17984,
  [SMALL_STATE(723)] = 17988,
  [SMALL_STATE(724)] = 17992,
  [SMALL_STATE(725)] = 17996,
  [SMALL_STATE(726)] = 18000,
  [SMALL_STATE(727)] = 18004,
  [SMALL_STATE(728)] = 18008,
  [SMALL_STATE(729)] = 18012,
  [SMALL_STATE(730)] = 18016,
  [SMALL_STATE(731)] = 18020,
  [SMALL_STATE(732)] = 18024,
  [SMALL_STATE(733)] = 18028,
  [SMALL_STATE(734)] = 18032,
  [SMALL_STATE(735)] = 18036,
  [SMALL_STATE(736)] = 18040,
  [SMALL_STATE(737)] = 18044,
  [SMALL_STATE(738)] = 18048,
  [SMALL_STATE(739)] = 18052,
  [SMALL_STATE(740)] = 18056,
  [SMALL_STATE(741)] = 18060,
  [SMALL_STATE(742)] = 18064,
  [SMALL_STATE(743)] = 18068,
  [SMALL_STATE(744)] = 18072,
  [SMALL_STATE(745)] = 18076,
  [SMALL_STATE(746)] = 18080,
  [SMALL_STATE(747)] = 18084,
  [SMALL_STATE(748)] = 18088,
  [SMALL_STATE(749)] = 18092,
  [SMALL_STATE(750)] = 18096,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(80),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(545),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(534),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(536),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(521),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(522),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(524),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(525),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(593),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paren_argument_repeat1, 2), SHIFT_REPEAT(258),
  [319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paren_argument_repeat1, 2), SHIFT_REPEAT(516),
  [322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paren_argument_repeat1, 2), SHIFT_REPEAT(102),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paren_argument_repeat1, 2), SHIFT_REPEAT(50),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__paren_argument_repeat1, 2),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paren_argument_repeat1, 2), SHIFT_REPEAT(223),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paren_argument_repeat1, 2), SHIFT_REPEAT(168),
  [336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paren_argument_repeat1, 2), SHIFT_REPEAT(256),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(162),
  [478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(545),
  [481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(521),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(522),
  [489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(524),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(525),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(527),
  [498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(164),
  [507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(526),
  [510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(165),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(568),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(166),
  [519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(520),
  [522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(167),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(581),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquoted_argument, 1),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 2), SHIFT_REPEAT(315),
  [535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 2), SHIFT_REPEAT(515),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 2),
  [540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 2), SHIFT_REPEAT(219),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 2), SHIFT_REPEAT(218),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 2), SHIFT_REPEAT(307),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gen_exp_arguments, 2),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(258),
  [578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(516),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(173),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gen_exp_arguments, 1),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(315),
  [639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(515),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2),
  [644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(217),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquoted_argument, 1),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(482),
  [670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(514),
  [673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(224),
  [676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_element_repeat1, 2), SHIFT_REPEAT(502),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_element_repeat1, 2), SHIFT_REPEAT(517),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_quoted_element_repeat1, 2),
  [684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quoted_element_repeat1, 2), SHIFT_REPEAT(225),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_element, 1),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(487),
  [698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(518),
  [701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(229),
  [704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(499),
  [707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(513),
  [710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unquoted_argument_repeat1, 2), SHIFT_REPEAT(230),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1),
  [723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_repeat1, 2), SHIFT_REPEAT(493),
  [726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_repeat1, 2), SHIFT_REPEAT(252),
  [729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_repeat1, 2), SHIFT_REPEAT(552),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_repeat1, 2),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cache_var, 5),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cache_var, 5),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_argument, 2),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_argument, 2),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument, 1),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_var, 4),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_var, 4),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape_sequence, 1),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_escape_sequence, 1),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gen_exp, 4),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gen_exp, 4),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_ref, 1),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_ref, 1),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paren_argument, 2),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paren_argument, 2),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_argument, 3),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_argument, 3),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paren_argument, 3),
  [772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paren_argument, 3),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gen_exp, 3),
  [776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gen_exp, 3),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_env_var, 5),
  [780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_env_var, 5),
  [782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endif_command, 3),
  [784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endif_command, 3),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_command, 3),
  [788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_command, 3),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_command, 6),
  [792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_command, 6),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_command, 3),
  [796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_command, 3),
  [798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_command, 3),
  [800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_command, 3),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_command, 4),
  [804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_command, 4),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_command, 7),
  [808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_command, 7),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_condition, 2),
  [812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_condition, 2),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_loop, 2),
  [816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_loop, 2),
  [818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_loop, 2),
  [820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_loop, 2),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_def, 2),
  [824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_def, 2),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_def, 2),
  [828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_def, 2),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_command, 3),
  [832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_command, 3),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_condition, 3),
  [836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_condition, 3),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_loop, 3),
  [840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_loop, 3),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_loop, 3),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_loop, 3),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_def, 3),
  [848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_def, 3),
  [850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_def, 3),
  [852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_def, 3),
  [854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_command, 4),
  [856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_command, 4),
  [858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endwhile_command, 7),
  [860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endwhile_command, 7),
  [862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endforeach_command, 3),
  [864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endforeach_command, 3),
  [866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endwhile_command, 3),
  [868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endwhile_command, 3),
  [870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_command, 4),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_command, 4),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endfunction_command, 3),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endfunction_command, 3),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endmacro_command, 3),
  [880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endmacro_command, 3),
  [882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_command, 5),
  [884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_command, 5),
  [886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_command, 5),
  [888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_command, 5),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endif_command, 7),
  [892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endif_command, 7),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_command, 5),
  [896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_command, 5),
  [898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endif_command, 4),
  [900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endif_command, 4),
  [902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_command, 4),
  [904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_command, 4),
  [906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endforeach_command, 4),
  [908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endforeach_command, 4),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endwhile_command, 4),
  [912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endwhile_command, 4),
  [914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endfunction_command, 4),
  [916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endfunction_command, 4),
  [918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endmacro_command, 4),
  [920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endmacro_command, 4),
  [922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endforeach_command, 5),
  [924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endforeach_command, 5),
  [926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endfunction_command, 5),
  [928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endfunction_command, 5),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endwhile_command, 6),
  [932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endwhile_command, 6),
  [934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endmacro_command, 5),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endmacro_command, 5),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endif_command, 6),
  [940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_endif_command, 6),
  [942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 1),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 1),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_command, 5),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_command, 5),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_command, 5),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_command, 5),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_command, 5),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_command, 5),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 5),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 5),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 3),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 3),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_command, 3),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_command, 3),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_command, 3),
  [974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_command, 3),
  [976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_command, 3),
  [978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_command, 3),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_command, 4),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_command, 4),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_command, 4),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_command, 4),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_command, 4),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_command, 4),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 4),
  [994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 4),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__gen_exp_arguments_repeat1, 2),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gen_exp_content, 1),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_command_repeat1, 2),
  [1244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_command_repeat1, 2), SHIFT_REPEAT(582),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gen_exp_content, 2),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1615] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_cmake_external_scanner_create(void);
void tree_sitter_cmake_external_scanner_destroy(void *);
bool tree_sitter_cmake_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cmake_external_scanner_serialize(void *, char *);
void tree_sitter_cmake_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_cmake(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_cmake_external_scanner_create,
      tree_sitter_cmake_external_scanner_destroy,
      tree_sitter_cmake_external_scanner_scan,
      tree_sitter_cmake_external_scanner_serialize,
      tree_sitter_cmake_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
