#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 552
#define LARGE_STATE_COUNT 4
#define SYMBOL_COUNT 120
#define ALIAS_COUNT 0
#define TOKEN_COUNT 64
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 8
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 17

enum {
  anon_sym_and = 1,
  anon_sym_or = 2,
  anon_sym_PIPE_PIPE = 3,
  anon_sym_AMP_AMP = 4,
  sym_stream_redirect = 5,
  sym_direction = 6,
  anon_sym_PIPE = 7,
  anon_sym_SEMI = 8,
  anon_sym_AMP = 9,
  anon_sym_LF = 10,
  anon_sym_CR = 11,
  anon_sym_CR_LF = 12,
  anon_sym_BANG = 13,
  anon_sym_not = 14,
  anon_sym_LPAREN = 15,
  anon_sym_RPAREN = 16,
  anon_sym_function = 17,
  anon_sym_end = 18,
  sym_integer = 19,
  sym_float = 20,
  anon_sym_return = 21,
  anon_sym_switch = 22,
  anon_sym_case = 23,
  sym_break = 24,
  sym_continue = 25,
  anon_sym_for = 26,
  anon_sym_in = 27,
  anon_sym_while = 28,
  anon_sym_if = 29,
  anon_sym_else = 30,
  anon_sym_begin = 31,
  aux_sym_test_command_token1 = 32,
  anon_sym_RBRACK = 33,
  aux_sym_test_command_token2 = 34,
  anon_sym_test = 35,
  anon_sym_BSLASH_LPAREN = 36,
  anon_sym_BSLASH_RPAREN = 37,
  anon_sym_DASHa = 38,
  anon_sym_DASHo = 39,
  anon_sym_EQ = 40,
  anon_sym_BANG_EQ = 41,
  sym_test_option = 42,
  sym_comment = 43,
  sym_variable_name = 44,
  anon_sym_DOLLAR = 45,
  anon_sym_DOT_DOT = 46,
  anon_sym_LBRACK = 47,
  anon_sym_LBRACE = 48,
  anon_sym_COMMA = 49,
  anon_sym_RBRACE = 50,
  anon_sym_DQUOTE = 51,
  aux_sym_double_quote_string_token1 = 52,
  anon_sym_SQUOTE = 53,
  aux_sym_single_quote_string_token1 = 54,
  sym_escape_sequence = 55,
  sym__special_character = 56,
  sym_home_dir_expansion = 57,
  sym_glob = 58,
  sym_word = 59,
  sym_brace_word = 60,
  sym__concat = 61,
  sym__brace_concat = 62,
  sym__concat_list = 63,
  sym_program = 64,
  sym_conditional_execution = 65,
  sym_redirected_statement = 66,
  sym_file_redirect = 67,
  sym_pipe = 68,
  sym__terminated_statement = 69,
  sym__terminated_opt_statement = 70,
  sym_negated_statement = 71,
  sym_command_substitution = 72,
  sym_function_definition = 73,
  sym_return = 74,
  sym_switch_statement = 75,
  sym_case_clause = 76,
  sym_for_statement = 77,
  sym_while_statement = 78,
  sym_if_statement = 79,
  sym_else_if_clause = 80,
  sym_else_clause = 81,
  sym_begin_statement = 82,
  sym_test_command = 83,
  sym__test_expression = 84,
  sym__parenthesized_test_expression = 85,
  sym_negated_expression = 86,
  sym_conditional_expression = 87,
  sym_unary_expression = 88,
  sym_binary_expression = 89,
  sym_variable_expansion = 90,
  sym_index = 91,
  sym_range = 92,
  sym_list_element_access = 93,
  sym_brace_expansion = 94,
  sym_double_quote_string = 95,
  sym_single_quote_string = 96,
  sym_command = 97,
  sym_concatenation = 98,
  sym__expression = 99,
  sym_brace_concatenation = 100,
  sym__brace_expression = 101,
  sym__base_brace_expression = 102,
  aux_sym_program_repeat1 = 103,
  aux_sym_function_definition_repeat1 = 104,
  aux_sym_function_definition_repeat2 = 105,
  aux_sym_switch_statement_repeat1 = 106,
  aux_sym_case_clause_repeat1 = 107,
  aux_sym_for_statement_repeat1 = 108,
  aux_sym_while_statement_repeat1 = 109,
  aux_sym_if_statement_repeat1 = 110,
  aux_sym_variable_expansion_repeat1 = 111,
  aux_sym_variable_expansion_repeat2 = 112,
  aux_sym_list_element_access_repeat1 = 113,
  aux_sym_brace_expansion_repeat1 = 114,
  aux_sym_double_quote_string_repeat1 = 115,
  aux_sym_single_quote_string_repeat1 = 116,
  aux_sym_command_repeat1 = 117,
  aux_sym_concatenation_repeat1 = 118,
  aux_sym_brace_concatenation_repeat1 = 119,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [sym_stream_redirect] = "stream_redirect",
  [sym_direction] = "direction",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_AMP] = "&",
  [anon_sym_LF] = "\n",
  [anon_sym_CR] = "\r",
  [anon_sym_CR_LF] = "\r\n",
  [anon_sym_BANG] = "!",
  [anon_sym_not] = "not",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_function] = "function",
  [anon_sym_end] = "end",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_return] = "return",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [sym_break] = "break",
  [sym_continue] = "continue",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_begin] = "begin",
  [aux_sym_test_command_token1] = "[",
  [anon_sym_RBRACK] = "]",
  [aux_sym_test_command_token2] = "]",
  [anon_sym_test] = "test",
  [anon_sym_BSLASH_LPAREN] = "\\(",
  [anon_sym_BSLASH_RPAREN] = "\\)",
  [anon_sym_DASHa] = "test_option",
  [anon_sym_DASHo] = "test_option",
  [anon_sym_EQ] = "=",
  [anon_sym_BANG_EQ] = "!=",
  [sym_test_option] = "test_option",
  [sym_comment] = "comment",
  [sym_variable_name] = "variable_name",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_LBRACK] = "[",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_double_quote_string_token1] = "double_quote_string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_single_quote_string_token1] = "single_quote_string_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym__special_character] = "_special_character",
  [sym_home_dir_expansion] = "home_dir_expansion",
  [sym_glob] = "glob",
  [sym_word] = "word",
  [sym_brace_word] = "word",
  [sym__concat] = "_concat",
  [sym__brace_concat] = "_brace_concat",
  [sym__concat_list] = "_concat_list",
  [sym_program] = "program",
  [sym_conditional_execution] = "conditional_execution",
  [sym_redirected_statement] = "redirected_statement",
  [sym_file_redirect] = "file_redirect",
  [sym_pipe] = "pipe",
  [sym__terminated_statement] = "_terminated_statement",
  [sym__terminated_opt_statement] = "_terminated_opt_statement",
  [sym_negated_statement] = "negated_statement",
  [sym_command_substitution] = "command_substitution",
  [sym_function_definition] = "function_definition",
  [sym_return] = "return",
  [sym_switch_statement] = "switch_statement",
  [sym_case_clause] = "case_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_begin_statement] = "begin_statement",
  [sym_test_command] = "test_command",
  [sym__test_expression] = "_test_expression",
  [sym__parenthesized_test_expression] = "_parenthesized_test_expression",
  [sym_negated_expression] = "negated_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_variable_expansion] = "variable_expansion",
  [sym_index] = "index",
  [sym_range] = "range",
  [sym_list_element_access] = "list_element_access",
  [sym_brace_expansion] = "brace_expansion",
  [sym_double_quote_string] = "double_quote_string",
  [sym_single_quote_string] = "single_quote_string",
  [sym_command] = "command",
  [sym_concatenation] = "concatenation",
  [sym__expression] = "_expression",
  [sym_brace_concatenation] = "concatenation",
  [sym__brace_expression] = "_brace_expression",
  [sym__base_brace_expression] = "_base_brace_expression",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_function_definition_repeat2] = "function_definition_repeat2",
  [aux_sym_switch_statement_repeat1] = "switch_statement_repeat1",
  [aux_sym_case_clause_repeat1] = "case_clause_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_variable_expansion_repeat1] = "variable_expansion_repeat1",
  [aux_sym_variable_expansion_repeat2] = "variable_expansion_repeat2",
  [aux_sym_list_element_access_repeat1] = "list_element_access_repeat1",
  [aux_sym_brace_expansion_repeat1] = "brace_expansion_repeat1",
  [aux_sym_double_quote_string_repeat1] = "double_quote_string_repeat1",
  [aux_sym_single_quote_string_repeat1] = "single_quote_string_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_brace_concatenation_repeat1] = "brace_concatenation_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [sym_stream_redirect] = sym_stream_redirect,
  [sym_direction] = sym_direction,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR] = anon_sym_CR,
  [anon_sym_CR_LF] = anon_sym_CR_LF,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_end] = anon_sym_end,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [sym_break] = sym_break,
  [sym_continue] = sym_continue,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_begin] = anon_sym_begin,
  [aux_sym_test_command_token1] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [aux_sym_test_command_token2] = anon_sym_RBRACK,
  [anon_sym_test] = anon_sym_test,
  [anon_sym_BSLASH_LPAREN] = anon_sym_BSLASH_LPAREN,
  [anon_sym_BSLASH_RPAREN] = anon_sym_BSLASH_RPAREN,
  [anon_sym_DASHa] = sym_test_option,
  [anon_sym_DASHo] = sym_test_option,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [sym_test_option] = sym_test_option,
  [sym_comment] = sym_comment,
  [sym_variable_name] = sym_variable_name,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_double_quote_string_token1] = aux_sym_double_quote_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_single_quote_string_token1] = aux_sym_single_quote_string_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__special_character] = sym__special_character,
  [sym_home_dir_expansion] = sym_home_dir_expansion,
  [sym_glob] = sym_glob,
  [sym_word] = sym_word,
  [sym_brace_word] = sym_word,
  [sym__concat] = sym__concat,
  [sym__brace_concat] = sym__brace_concat,
  [sym__concat_list] = sym__concat_list,
  [sym_program] = sym_program,
  [sym_conditional_execution] = sym_conditional_execution,
  [sym_redirected_statement] = sym_redirected_statement,
  [sym_file_redirect] = sym_file_redirect,
  [sym_pipe] = sym_pipe,
  [sym__terminated_statement] = sym__terminated_statement,
  [sym__terminated_opt_statement] = sym__terminated_opt_statement,
  [sym_negated_statement] = sym_negated_statement,
  [sym_command_substitution] = sym_command_substitution,
  [sym_function_definition] = sym_function_definition,
  [sym_return] = sym_return,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_clause] = sym_case_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_begin_statement] = sym_begin_statement,
  [sym_test_command] = sym_test_command,
  [sym__test_expression] = sym__test_expression,
  [sym__parenthesized_test_expression] = sym__parenthesized_test_expression,
  [sym_negated_expression] = sym_negated_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_variable_expansion] = sym_variable_expansion,
  [sym_index] = sym_index,
  [sym_range] = sym_range,
  [sym_list_element_access] = sym_list_element_access,
  [sym_brace_expansion] = sym_brace_expansion,
  [sym_double_quote_string] = sym_double_quote_string,
  [sym_single_quote_string] = sym_single_quote_string,
  [sym_command] = sym_command,
  [sym_concatenation] = sym_concatenation,
  [sym__expression] = sym__expression,
  [sym_brace_concatenation] = sym_concatenation,
  [sym__brace_expression] = sym__brace_expression,
  [sym__base_brace_expression] = sym__base_brace_expression,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_function_definition_repeat2] = aux_sym_function_definition_repeat2,
  [aux_sym_switch_statement_repeat1] = aux_sym_switch_statement_repeat1,
  [aux_sym_case_clause_repeat1] = aux_sym_case_clause_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_while_statement_repeat1] = aux_sym_while_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_variable_expansion_repeat1] = aux_sym_variable_expansion_repeat1,
  [aux_sym_variable_expansion_repeat2] = aux_sym_variable_expansion_repeat2,
  [aux_sym_list_element_access_repeat1] = aux_sym_list_element_access_repeat1,
  [aux_sym_brace_expansion_repeat1] = aux_sym_brace_expansion_repeat1,
  [aux_sym_double_quote_string_repeat1] = aux_sym_double_quote_string_repeat1,
  [aux_sym_single_quote_string_repeat1] = aux_sym_single_quote_string_repeat1,
  [aux_sym_command_repeat1] = aux_sym_command_repeat1,
  [aux_sym_concatenation_repeat1] = aux_sym_concatenation_repeat1,
  [aux_sym_brace_concatenation_repeat1] = aux_sym_brace_concatenation_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_stream_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_direction] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_continue] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_test_command_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_test_command_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_test] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHa] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASHo] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_test_option] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_double_quote_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_single_quote_string_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__special_character] = {
    .visible = false,
    .named = true,
  },
  [sym_home_dir_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_glob] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_brace_word] = {
    .visible = true,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym__brace_concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat_list] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_execution] = {
    .visible = true,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__terminated_opt_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_negated_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_begin_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym__test_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__parenthesized_test_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_negated_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_index] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_list_element_access] = {
    .visible = true,
    .named = true,
  },
  [sym_brace_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_double_quote_string] = {
    .visible = true,
    .named = true,
  },
  [sym_single_quote_string] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_brace_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__brace_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__base_brace_expression] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_expansion_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_element_access_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_brace_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quote_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quote_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_brace_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_argument = 1,
  field_condition = 2,
  field_destination = 3,
  field_name = 4,
  field_operator = 5,
  field_option = 6,
  field_value = 7,
  field_variable = 8,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_argument] = "argument",
  [field_condition] = "condition",
  [field_destination] = "destination",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_option] = "option",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 2},
  [7] = {.index = 7, .length = 1},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 2},
  [11] = {.index = 13, .length = 1},
  [12] = {.index = 14, .length = 1},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 2},
  [15] = {.index = 19, .length = 1},
  [16] = {.index = 20, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_argument, 0},
  [2] =
    {field_argument, 1, .inherited = true},
    {field_name, 0},
  [4] =
    {field_option, 0},
  [5] =
    {field_destination, 1},
    {field_operator, 0},
  [7] =
    {field_condition, 1},
  [8] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [10] =
    {field_name, 1},
  [11] =
    {field_option, 0, .inherited = true},
    {field_option, 1, .inherited = true},
  [13] =
    {field_value, 1},
  [14] =
    {field_value, 0},
  [15] =
    {field_name, 1},
    {field_option, 2, .inherited = true},
  [17] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [19] =
    {field_condition, 2},
  [20] =
    {field_value, 3, .inherited = true},
    {field_variable, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_word,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_word_character_set_1(int32_t c) {
  return (c < '&'
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '$')))
    : (c <= '*' || (c < '['
      ? (c < '>'
        ? (c >= ';' && c <= '<')
        : c <= '>')
      : (c <= '^' || (c >= '{' && c <= '~')))));
}

static inline bool sym_word_character_set_2(int32_t c) {
  return (c < '"'
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == ' '))
    : (c <= '$' || (c < '['
      ? (c < ';'
        ? (c >= '&' && c <= '*')
        : c <= ';')
      : (c <= '^' || (c >= '{' && c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(100);
      if (lookahead == '!') ADVANCE(124);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(185);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(175);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '[') ADVANCE(183);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == ']') ADVANCE(165);
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'b') ADVANCE(46);
      if (lookahead == 'c') ADVANCE(38);
      if (lookahead == 'e') ADVANCE(66);
      if (lookahead == 'f') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(55);
      if (lookahead == 'n') ADVANCE(74);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 'r') ADVANCE(53);
      if (lookahead == 's') ADVANCE(91);
      if (lookahead == 't') ADVANCE(52);
      if (lookahead == 'w') ADVANCE(58);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '}') ADVANCE(186);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '[') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(212);
      if (lookahead == 'a') ADVANCE(242);
      if (lookahead == 'b') ADVANCE(222);
      if (lookahead == 'c') ADVANCE(251);
      if (lookahead == 'e') ADVANCE(240);
      if (lookahead == 'f') ADVANCE(252);
      if (lookahead == 'i') ADVANCE(230);
      if (lookahead == 'n') ADVANCE(250);
      if (lookahead == 'o') ADVANCE(254);
      if (lookahead == 'r') ADVANCE(229);
      if (lookahead == 's') ADVANCE(268);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'w') ADVANCE(233);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(1)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '[') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(212);
      if (lookahead == 'a') ADVANCE(242);
      if (lookahead == 'b') ADVANCE(222);
      if (lookahead == 'c') ADVANCE(251);
      if (lookahead == 'e') ADVANCE(247);
      if (lookahead == 'f') ADVANCE(252);
      if (lookahead == 'i') ADVANCE(230);
      if (lookahead == 'n') ADVANCE(250);
      if (lookahead == 'o') ADVANCE(254);
      if (lookahead == 'r') ADVANCE(229);
      if (lookahead == 's') ADVANCE(268);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'w') ADVANCE(233);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(2)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '[' ||
          lookahead == ']') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(3)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      if (lookahead != 0 &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '[' ||
          lookahead == ']') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(4)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(119);
      if (lookahead == '\r') ADVANCE(122);
      if (lookahead == '!') ADVANCE(32);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(175);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '\\') SKIP(93)
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(5)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(31);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(119);
      if (lookahead == '\r') ADVANCE(122);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '\\') SKIP(94)
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(6)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(119);
      if (lookahead == '\r') ADVANCE(122);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '\\') SKIP(95)
      if (lookahead == 'i') ADVANCE(54);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(7)
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(120);
      if (lookahead == '\r') ADVANCE(123);
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+') ADVANCE(270);
      if (lookahead == '-') ADVANCE(269);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '[' ||
          lookahead == ']') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(8)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      if (lookahead != 0 &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(124);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(185);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(175);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '[') ADVANCE(183);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == ']') ADVANCE(165);
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'b') ADVANCE(46);
      if (lookahead == 'c') ADVANCE(38);
      if (lookahead == 'e') ADVANCE(66);
      if (lookahead == 'f') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(55);
      if (lookahead == 'n') ADVANCE(74);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 'r') ADVANCE(53);
      if (lookahead == 's') ADVANCE(91);
      if (lookahead == 't') ADVANCE(52);
      if (lookahead == 'w') ADVANCE(58);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '}') ADVANCE(186);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+') ADVANCE(270);
      if (lookahead == '-') ADVANCE(269);
      if (lookahead == '[') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(165);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+') ADVANCE(270);
      if (lookahead == '-') ADVANCE(269);
      if (lookahead == '[' ||
          lookahead == ']') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == '[') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(212);
      if (lookahead == 'a') ADVANCE(242);
      if (lookahead == 'b') ADVANCE(222);
      if (lookahead == 'c') ADVANCE(251);
      if (lookahead == 'e') ADVANCE(247);
      if (lookahead == 'f') ADVANCE(252);
      if (lookahead == 'i') ADVANCE(230);
      if (lookahead == 'n') ADVANCE(250);
      if (lookahead == 'o') ADVANCE(254);
      if (lookahead == 'r') ADVANCE(229);
      if (lookahead == 's') ADVANCE(268);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'w') ADVANCE(233);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == '[') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(212);
      if (lookahead == 'a') ADVANCE(242);
      if (lookahead == 'b') ADVANCE(222);
      if (lookahead == 'c') ADVANCE(251);
      if (lookahead == 'f') ADVANCE(252);
      if (lookahead == 'i') ADVANCE(230);
      if (lookahead == 'n') ADVANCE(250);
      if (lookahead == 'o') ADVANCE(254);
      if (lookahead == 'r') ADVANCE(229);
      if (lookahead == 's') ADVANCE(268);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'w') ADVANCE(233);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == '[') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(212);
      if (lookahead == 'a') ADVANCE(242);
      if (lookahead == 'b') ADVANCE(222);
      if (lookahead == 'c') ADVANCE(217);
      if (lookahead == 'e') ADVANCE(247);
      if (lookahead == 'f') ADVANCE(252);
      if (lookahead == 'i') ADVANCE(230);
      if (lookahead == 'n') ADVANCE(250);
      if (lookahead == 'o') ADVANCE(254);
      if (lookahead == 'r') ADVANCE(229);
      if (lookahead == 's') ADVANCE(268);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'w') ADVANCE(233);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(32);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '=') ADVANCE(175);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(180);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(32);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '=') ADVANCE(175);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(180);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == '[' ||
          lookahead == ']') ADVANCE(212);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '+') ADVANCE(98);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '[') ADVANCE(183);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(165);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(18)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(275);
      if (lookahead == ',') ADVANCE(185);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '}') ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != ')') ADVANCE(277);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(188);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(189);
      if (lookahead != 0) ADVANCE(190);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == ']') ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(21);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(21);
      END_STATE();
    case 23:
      if (lookahead == '#') ADVANCE(192);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(193);
      if (lookahead != 0) ADVANCE(194);
      END_STATE();
    case 24:
      if (lookahead == '(') ADVANCE(169);
      if (lookahead == ')') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      END_STATE();
    case 25:
      if (lookahead == '(') ADVANCE(169);
      if (lookahead == 'U') ADVANCE(210);
      if (lookahead == 'X') ADVANCE(204);
      if (lookahead == 'c') ADVANCE(211);
      if (lookahead == 'u') ADVANCE(206);
      if (lookahead == 'x') ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(202);
      if (lookahead != 0) ADVANCE(195);
      END_STATE();
    case 26:
      if (lookahead == '(') ADVANCE(169);
      if (lookahead == 'U') ADVANCE(210);
      if (lookahead == 'X') ADVANCE(204);
      if (lookahead == 'c') ADVANCE(211);
      if (lookahead == 'u') ADVANCE(206);
      if (lookahead == 'x') ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(202);
      if (lookahead != 0) ADVANCE(195);
      END_STATE();
    case 27:
      if (lookahead == ')') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(18)
      END_STATE();
    case 28:
      if (lookahead == ')') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16)
      END_STATE();
    case 29:
      if (lookahead == ')') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(182);
      END_STATE();
    case 31:
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '>') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(176);
      END_STATE();
    case 33:
      if (lookahead == 'U') ADVANCE(210);
      if (lookahead == 'X') ADVANCE(204);
      if (lookahead == 'c') ADVANCE(211);
      if (lookahead == 'u') ADVANCE(206);
      if (lookahead == 'x') ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(202);
      if (lookahead != 0) ADVANCE(195);
      END_STATE();
    case 34:
      if (lookahead == 'U') ADVANCE(210);
      if (lookahead == 'X') ADVANCE(204);
      if (lookahead == 'c') ADVANCE(211);
      if (lookahead == 'u') ADVANCE(206);
      if (lookahead == 'x') ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(202);
      if (lookahead != 0) ADVANCE(195);
      END_STATE();
    case 35:
      if (lookahead == 'U') ADVANCE(210);
      if (lookahead == 'X') ADVANCE(204);
      if (lookahead == 'c') ADVANCE(211);
      if (lookahead == 'u') ADVANCE(206);
      if (lookahead == 'x') ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(200);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(202);
      if (lookahead != 0) ADVANCE(195);
      END_STATE();
    case 36:
      if (lookahead == 'a') ADVANCE(172);
      if (lookahead == 'o') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(135);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(177);
      END_STATE();
    case 37:
      if (lookahead == 'a') ADVANCE(172);
      if (lookahead == 'o') ADVANCE(174);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(177);
      END_STATE();
    case 38:
      if (lookahead == 'a') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 40:
      if (lookahead == 'a') ADVANCE(171);
      if (lookahead == 'o') ADVANCE(173);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(171);
      if (lookahead == 'o') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      END_STATE();
    case 42:
      if (lookahead == 'c') ADVANCE(57);
      END_STATE();
    case 43:
      if (lookahead == 'c') ADVANCE(87);
      END_STATE();
    case 44:
      if (lookahead == 'd') ADVANCE(101);
      END_STATE();
    case 45:
      if (lookahead == 'd') ADVANCE(132);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(56);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(82);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 54:
      if (lookahead == 'f') ADVANCE(158);
      END_STATE();
    case 55:
      if (lookahead == 'f') ADVANCE(158);
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 56:
      if (lookahead == 'g') ADVANCE(61);
      END_STATE();
    case 57:
      if (lookahead == 'h') ADVANCE(145);
      END_STATE();
    case 58:
      if (lookahead == 'h') ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 64:
      if (lookahead == 'k') ADVANCE(149);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(50);
      END_STATE();
    case 66:
      if (lookahead == 'l') ADVANCE(81);
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 67:
      if (lookahead == 'n') ADVANCE(44);
      END_STATE();
    case 68:
      if (lookahead == 'n') ADVANCE(43);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(162);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 71:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(88);
      END_STATE();
    case 74:
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 75:
      if (lookahead == 'o') ADVANCE(78);
      if (lookahead == 'u') ADVANCE(68);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(48);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(49);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(85);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 84:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 86:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 89:
      if (lookahead == 'u') ADVANCE(79);
      END_STATE();
    case 90:
      if (lookahead == 'u') ADVANCE(51);
      END_STATE();
    case 91:
      if (lookahead == 'w') ADVANCE(62);
      END_STATE();
    case 92:
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '2')) ADVANCE(107);
      END_STATE();
    case 93:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      END_STATE();
    case 94:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      END_STATE();
    case 95:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(135);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      END_STATE();
    case 99:
      if (eof) ADVANCE(100);
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '!') ADVANCE(125);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(191);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(270);
      if (lookahead == ';') ADVANCE(115);
      if (lookahead == '[') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(212);
      if (lookahead == 'a') ADVANCE(242);
      if (lookahead == 'b') ADVANCE(222);
      if (lookahead == 'c') ADVANCE(251);
      if (lookahead == 'f') ADVANCE(252);
      if (lookahead == 'i') ADVANCE(230);
      if (lookahead == 'n') ADVANCE(250);
      if (lookahead == 'o') ADVANCE(254);
      if (lookahead == 'r') ADVANCE(229);
      if (lookahead == 's') ADVANCE(268);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'w') ADVANCE(233);
      if (lookahead == '{') ADVANCE(184);
      if (lookahead == '~') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(99)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(272);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_and);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_or);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_stream_redirect);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_direction);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_direction);
      if (lookahead == '&') ADVANCE(92);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_direction);
      if (lookahead == '&') ADVANCE(92);
      if (lookahead == '>') ADVANCE(111);
      if (lookahead == '?') ADVANCE(108);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_direction);
      if (lookahead == '&') ADVANCE(92);
      if (lookahead == '?') ADVANCE(108);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_direction);
      if (lookahead == '>') ADVANCE(113);
      if (lookahead == '?') ADVANCE(108);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_direction);
      if (lookahead == '?') ADVANCE(108);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(105);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(106);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(33);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(119);
      if (lookahead == '\r') ADVANCE(122);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(120);
      if (lookahead == '\r') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(25);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_CR);
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(33);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_CR);
      if (lookahead == '\n') ADVANCE(119);
      if (lookahead == '\r') ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_CR);
      if (lookahead == '\n') ADVANCE(120);
      if (lookahead == '\r') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(25);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_not);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_function);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_end);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '>') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(271);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '>') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      if (!sym_word_character_set_2(lookahead)) ADVANCE(272);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(271);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(276);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '\'' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(277);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '\'' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(277);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_return);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_switch);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_case);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_break);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_break);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_continue);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_continue);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_for);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_while);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_if);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_else);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_begin);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_test_command_token1);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_test_command_token2);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_test);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_test);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_BSLASH_LPAREN);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_BSLASH_RPAREN);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_DASHa);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DASHa);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(177);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DASHo);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_DASHo);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(177);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_test_option);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_test_option);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(178);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym_double_quote_string_token1);
      if (lookahead == '\n') ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_double_quote_string_token1);
      if (lookahead == '#') ADVANCE(188);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(189);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\\') ADVANCE(190);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_double_quote_string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_single_quote_string_token1);
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_single_quote_string_token1);
      if (lookahead == '#') ADVANCE(192);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_single_quote_string_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(118);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(33);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(120);
      if (lookahead == '\r') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(25);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(34);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(26);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(195);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(201);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(195);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(203);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(204);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(205);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(206);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(207);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(208);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(209);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(195);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym__special_character);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym__special_character);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(164);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_home_dir_expansion);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_glob);
      if (lookahead == '*') ADVANCE(215);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(239);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(259);
      if (lookahead == 'o') ADVANCE(249);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'c') ADVANCE(232);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'c') ADVANCE(264);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'd') ADVANCE(102);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'd') ADVANCE(133);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(231);
      if (lookahead == 'r') ADVANCE(224);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(257);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(216);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(157);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(152);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(161);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(148);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(261);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'f') ADVANCE(159);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'g') ADVANCE(235);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'h') ADVANCE(146);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'h') ADVANCE(234);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(241);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(244);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(263);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(248);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(253);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'k') ADVANCE(150);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(258);
      if (lookahead == 'n') ADVANCE(221);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(225);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(220);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(219);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(163);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(144);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(131);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(221);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(267);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(265);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(260);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(249);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(255);
      if (lookahead == 'u') ADVANCE(243);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(246);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(104);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(154);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(245);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 's') ADVANCE(262);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 's') ADVANCE(227);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 's') ADVANCE(228);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(127);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(266);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(168);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(218);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(238);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(237);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'u') ADVANCE(256);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'u') ADVANCE(226);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'w') ADVANCE(236);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_word);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(178);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_word);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_word);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_word);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_brace_word);
      if (lookahead == '\n') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '\'' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(273);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_brace_word);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(275);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '\'' || ',' < lookahead) &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(277);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_brace_word);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '\'' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(277);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_brace_word);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '\'' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(277);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_brace_word);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '\'' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(277);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 99},
  [2] = {.lex_state = 1},
  [3] = {.lex_state = 1},
  [4] = {.lex_state = 1},
  [5] = {.lex_state = 1},
  [6] = {.lex_state = 1},
  [7] = {.lex_state = 2},
  [8] = {.lex_state = 2},
  [9] = {.lex_state = 2},
  [10] = {.lex_state = 2},
  [11] = {.lex_state = 2},
  [12] = {.lex_state = 2},
  [13] = {.lex_state = 2},
  [14] = {.lex_state = 99},
  [15] = {.lex_state = 99},
  [16] = {.lex_state = 99},
  [17] = {.lex_state = 99},
  [18] = {.lex_state = 99},
  [19] = {.lex_state = 99},
  [20] = {.lex_state = 99},
  [21] = {.lex_state = 99},
  [22] = {.lex_state = 99},
  [23] = {.lex_state = 99},
  [24] = {.lex_state = 99},
  [25] = {.lex_state = 99},
  [26] = {.lex_state = 99},
  [27] = {.lex_state = 99},
  [28] = {.lex_state = 99},
  [29] = {.lex_state = 99},
  [30] = {.lex_state = 99},
  [31] = {.lex_state = 99},
  [32] = {.lex_state = 99},
  [33] = {.lex_state = 99},
  [34] = {.lex_state = 99},
  [35] = {.lex_state = 14},
  [36] = {.lex_state = 14},
  [37] = {.lex_state = 14},
  [38] = {.lex_state = 12},
  [39] = {.lex_state = 12},
  [40] = {.lex_state = 12},
  [41] = {.lex_state = 12},
  [42] = {.lex_state = 12},
  [43] = {.lex_state = 12},
  [44] = {.lex_state = 12},
  [45] = {.lex_state = 12},
  [46] = {.lex_state = 12},
  [47] = {.lex_state = 12},
  [48] = {.lex_state = 12},
  [49] = {.lex_state = 12},
  [50] = {.lex_state = 12},
  [51] = {.lex_state = 12},
  [52] = {.lex_state = 12},
  [53] = {.lex_state = 12},
  [54] = {.lex_state = 12},
  [55] = {.lex_state = 12},
  [56] = {.lex_state = 12},
  [57] = {.lex_state = 12},
  [58] = {.lex_state = 12},
  [59] = {.lex_state = 12},
  [60] = {.lex_state = 12},
  [61] = {.lex_state = 13},
  [62] = {.lex_state = 13},
  [63] = {.lex_state = 13},
  [64] = {.lex_state = 13},
  [65] = {.lex_state = 13},
  [66] = {.lex_state = 13},
  [67] = {.lex_state = 13},
  [68] = {.lex_state = 8},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 99},
  [72] = {.lex_state = 99},
  [73] = {.lex_state = 2},
  [74] = {.lex_state = 2},
  [75] = {.lex_state = 3},
  [76] = {.lex_state = 3},
  [77] = {.lex_state = 3},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 10},
  [80] = {.lex_state = 14},
  [81] = {.lex_state = 11},
  [82] = {.lex_state = 11},
  [83] = {.lex_state = 11},
  [84] = {.lex_state = 11},
  [85] = {.lex_state = 11},
  [86] = {.lex_state = 11},
  [87] = {.lex_state = 12},
  [88] = {.lex_state = 4},
  [89] = {.lex_state = 3, .external_lex_state = 2},
  [90] = {.lex_state = 4},
  [91] = {.lex_state = 3, .external_lex_state = 2},
  [92] = {.lex_state = 4},
  [93] = {.lex_state = 4},
  [94] = {.lex_state = 4},
  [95] = {.lex_state = 4},
  [96] = {.lex_state = 4},
  [97] = {.lex_state = 3, .external_lex_state = 2},
  [98] = {.lex_state = 3, .external_lex_state = 3},
  [99] = {.lex_state = 3, .external_lex_state = 2},
  [100] = {.lex_state = 3, .external_lex_state = 3},
  [101] = {.lex_state = 3, .external_lex_state = 2},
  [102] = {.lex_state = 3, .external_lex_state = 2},
  [103] = {.lex_state = 3, .external_lex_state = 3},
  [104] = {.lex_state = 3, .external_lex_state = 3},
  [105] = {.lex_state = 3, .external_lex_state = 3},
  [106] = {.lex_state = 3, .external_lex_state = 3},
  [107] = {.lex_state = 3, .external_lex_state = 3},
  [108] = {.lex_state = 3, .external_lex_state = 3},
  [109] = {.lex_state = 3, .external_lex_state = 3},
  [110] = {.lex_state = 3, .external_lex_state = 3},
  [111] = {.lex_state = 3, .external_lex_state = 3},
  [112] = {.lex_state = 3, .external_lex_state = 3},
  [113] = {.lex_state = 3, .external_lex_state = 3},
  [114] = {.lex_state = 3, .external_lex_state = 3},
  [115] = {.lex_state = 3, .external_lex_state = 3},
  [116] = {.lex_state = 3},
  [117] = {.lex_state = 19},
  [118] = {.lex_state = 19},
  [119] = {.lex_state = 19},
  [120] = {.lex_state = 19},
  [121] = {.lex_state = 19},
  [122] = {.lex_state = 19},
  [123] = {.lex_state = 19},
  [124] = {.lex_state = 19},
  [125] = {.lex_state = 19},
  [126] = {.lex_state = 17},
  [127] = {.lex_state = 19},
  [128] = {.lex_state = 19},
  [129] = {.lex_state = 19},
  [130] = {.lex_state = 19},
  [131] = {.lex_state = 19},
  [132] = {.lex_state = 19},
  [133] = {.lex_state = 19},
  [134] = {.lex_state = 17},
  [135] = {.lex_state = 19},
  [136] = {.lex_state = 4, .external_lex_state = 2},
  [137] = {.lex_state = 17},
  [138] = {.lex_state = 17},
  [139] = {.lex_state = 17},
  [140] = {.lex_state = 4, .external_lex_state = 2},
  [141] = {.lex_state = 17},
  [142] = {.lex_state = 17},
  [143] = {.lex_state = 4, .external_lex_state = 2},
  [144] = {.lex_state = 17},
  [145] = {.lex_state = 17},
  [146] = {.lex_state = 5, .external_lex_state = 2},
  [147] = {.lex_state = 4, .external_lex_state = 3},
  [148] = {.lex_state = 4, .external_lex_state = 3},
  [149] = {.lex_state = 4, .external_lex_state = 3},
  [150] = {.lex_state = 4, .external_lex_state = 3},
  [151] = {.lex_state = 4, .external_lex_state = 2},
  [152] = {.lex_state = 4, .external_lex_state = 2},
  [153] = {.lex_state = 4, .external_lex_state = 2},
  [154] = {.lex_state = 5, .external_lex_state = 2},
  [155] = {.lex_state = 5, .external_lex_state = 2},
  [156] = {.lex_state = 4, .external_lex_state = 3},
  [157] = {.lex_state = 4, .external_lex_state = 3},
  [158] = {.lex_state = 4, .external_lex_state = 3},
  [159] = {.lex_state = 5, .external_lex_state = 2},
  [160] = {.lex_state = 4, .external_lex_state = 3},
  [161] = {.lex_state = 17},
  [162] = {.lex_state = 17},
  [163] = {.lex_state = 4, .external_lex_state = 3},
  [164] = {.lex_state = 4, .external_lex_state = 3},
  [165] = {.lex_state = 4, .external_lex_state = 3},
  [166] = {.lex_state = 5, .external_lex_state = 3},
  [167] = {.lex_state = 4, .external_lex_state = 3},
  [168] = {.lex_state = 4, .external_lex_state = 3},
  [169] = {.lex_state = 17},
  [170] = {.lex_state = 17},
  [171] = {.lex_state = 4, .external_lex_state = 3},
  [172] = {.lex_state = 5, .external_lex_state = 3},
  [173] = {.lex_state = 17},
  [174] = {.lex_state = 5, .external_lex_state = 3},
  [175] = {.lex_state = 5, .external_lex_state = 3},
  [176] = {.lex_state = 5, .external_lex_state = 2},
  [177] = {.lex_state = 5, .external_lex_state = 2},
  [178] = {.lex_state = 4, .external_lex_state = 3},
  [179] = {.lex_state = 17},
  [180] = {.lex_state = 17},
  [181] = {.lex_state = 5, .external_lex_state = 3},
  [182] = {.lex_state = 5, .external_lex_state = 3},
  [183] = {.lex_state = 5, .external_lex_state = 3},
  [184] = {.lex_state = 5, .external_lex_state = 3},
  [185] = {.lex_state = 5, .external_lex_state = 3},
  [186] = {.lex_state = 5, .external_lex_state = 3},
  [187] = {.lex_state = 4},
  [188] = {.lex_state = 19},
  [189] = {.lex_state = 5, .external_lex_state = 3},
  [190] = {.lex_state = 5, .external_lex_state = 3},
  [191] = {.lex_state = 5, .external_lex_state = 3},
  [192] = {.lex_state = 5, .external_lex_state = 3},
  [193] = {.lex_state = 5, .external_lex_state = 3},
  [194] = {.lex_state = 4},
  [195] = {.lex_state = 6, .external_lex_state = 2},
  [196] = {.lex_state = 6, .external_lex_state = 2},
  [197] = {.lex_state = 6, .external_lex_state = 2},
  [198] = {.lex_state = 5},
  [199] = {.lex_state = 18},
  [200] = {.lex_state = 18},
  [201] = {.lex_state = 18},
  [202] = {.lex_state = 18},
  [203] = {.lex_state = 18},
  [204] = {.lex_state = 6, .external_lex_state = 3},
  [205] = {.lex_state = 18},
  [206] = {.lex_state = 6, .external_lex_state = 3},
  [207] = {.lex_state = 18},
  [208] = {.lex_state = 6, .external_lex_state = 3},
  [209] = {.lex_state = 6, .external_lex_state = 3},
  [210] = {.lex_state = 18},
  [211] = {.lex_state = 18},
  [212] = {.lex_state = 18},
  [213] = {.lex_state = 18},
  [214] = {.lex_state = 18},
  [215] = {.lex_state = 18},
  [216] = {.lex_state = 18},
  [217] = {.lex_state = 18},
  [218] = {.lex_state = 18},
  [219] = {.lex_state = 18},
  [220] = {.lex_state = 18},
  [221] = {.lex_state = 18},
  [222] = {.lex_state = 6, .external_lex_state = 2},
  [223] = {.lex_state = 6, .external_lex_state = 2},
  [224] = {.lex_state = 6, .external_lex_state = 2},
  [225] = {.lex_state = 18},
  [226] = {.lex_state = 18},
  [227] = {.lex_state = 6, .external_lex_state = 3},
  [228] = {.lex_state = 6, .external_lex_state = 3},
  [229] = {.lex_state = 6, .external_lex_state = 3},
  [230] = {.lex_state = 6, .external_lex_state = 3},
  [231] = {.lex_state = 6, .external_lex_state = 3},
  [232] = {.lex_state = 6, .external_lex_state = 3},
  [233] = {.lex_state = 6, .external_lex_state = 3},
  [234] = {.lex_state = 6, .external_lex_state = 3},
  [235] = {.lex_state = 6, .external_lex_state = 3},
  [236] = {.lex_state = 6, .external_lex_state = 3},
  [237] = {.lex_state = 6, .external_lex_state = 3},
  [238] = {.lex_state = 6},
  [239] = {.lex_state = 18},
  [240] = {.lex_state = 6},
  [241] = {.lex_state = 18},
  [242] = {.lex_state = 6},
  [243] = {.lex_state = 6},
  [244] = {.lex_state = 6},
  [245] = {.lex_state = 6},
  [246] = {.lex_state = 5},
  [247] = {.lex_state = 5},
  [248] = {.lex_state = 5},
  [249] = {.lex_state = 5},
  [250] = {.lex_state = 5},
  [251] = {.lex_state = 5},
  [252] = {.lex_state = 5},
  [253] = {.lex_state = 5},
  [254] = {.lex_state = 5},
  [255] = {.lex_state = 5},
  [256] = {.lex_state = 5},
  [257] = {.lex_state = 5},
  [258] = {.lex_state = 5},
  [259] = {.lex_state = 5},
  [260] = {.lex_state = 5},
  [261] = {.lex_state = 5},
  [262] = {.lex_state = 5},
  [263] = {.lex_state = 5},
  [264] = {.lex_state = 5},
  [265] = {.lex_state = 5},
  [266] = {.lex_state = 5},
  [267] = {.lex_state = 5},
  [268] = {.lex_state = 5},
  [269] = {.lex_state = 5},
  [270] = {.lex_state = 5},
  [271] = {.lex_state = 5},
  [272] = {.lex_state = 5},
  [273] = {.lex_state = 5},
  [274] = {.lex_state = 5},
  [275] = {.lex_state = 5},
  [276] = {.lex_state = 5},
  [277] = {.lex_state = 5},
  [278] = {.lex_state = 5},
  [279] = {.lex_state = 5},
  [280] = {.lex_state = 5},
  [281] = {.lex_state = 5},
  [282] = {.lex_state = 5},
  [283] = {.lex_state = 5},
  [284] = {.lex_state = 5},
  [285] = {.lex_state = 5},
  [286] = {.lex_state = 5},
  [287] = {.lex_state = 5},
  [288] = {.lex_state = 5},
  [289] = {.lex_state = 5},
  [290] = {.lex_state = 5},
  [291] = {.lex_state = 5},
  [292] = {.lex_state = 5},
  [293] = {.lex_state = 5},
  [294] = {.lex_state = 5},
  [295] = {.lex_state = 5},
  [296] = {.lex_state = 5},
  [297] = {.lex_state = 5},
  [298] = {.lex_state = 5},
  [299] = {.lex_state = 5},
  [300] = {.lex_state = 5},
  [301] = {.lex_state = 5},
  [302] = {.lex_state = 5},
  [303] = {.lex_state = 5},
  [304] = {.lex_state = 5},
  [305] = {.lex_state = 5},
  [306] = {.lex_state = 5},
  [307] = {.lex_state = 5},
  [308] = {.lex_state = 5},
  [309] = {.lex_state = 5},
  [310] = {.lex_state = 5},
  [311] = {.lex_state = 5},
  [312] = {.lex_state = 5},
  [313] = {.lex_state = 16, .external_lex_state = 2},
  [314] = {.lex_state = 16, .external_lex_state = 2},
  [315] = {.lex_state = 16, .external_lex_state = 2},
  [316] = {.lex_state = 16, .external_lex_state = 3},
  [317] = {.lex_state = 16, .external_lex_state = 3},
  [318] = {.lex_state = 16, .external_lex_state = 2},
  [319] = {.lex_state = 18, .external_lex_state = 4},
  [320] = {.lex_state = 18, .external_lex_state = 4},
  [321] = {.lex_state = 16, .external_lex_state = 2},
  [322] = {.lex_state = 16, .external_lex_state = 3},
  [323] = {.lex_state = 16, .external_lex_state = 2},
  [324] = {.lex_state = 18, .external_lex_state = 4},
  [325] = {.lex_state = 16, .external_lex_state = 3},
  [326] = {.lex_state = 16, .external_lex_state = 3},
  [327] = {.lex_state = 16, .external_lex_state = 3},
  [328] = {.lex_state = 16, .external_lex_state = 3},
  [329] = {.lex_state = 16, .external_lex_state = 3},
  [330] = {.lex_state = 7, .external_lex_state = 2},
  [331] = {.lex_state = 18, .external_lex_state = 4},
  [332] = {.lex_state = 18, .external_lex_state = 4},
  [333] = {.lex_state = 16, .external_lex_state = 3},
  [334] = {.lex_state = 18, .external_lex_state = 4},
  [335] = {.lex_state = 16, .external_lex_state = 3},
  [336] = {.lex_state = 16, .external_lex_state = 3},
  [337] = {.lex_state = 16, .external_lex_state = 3},
  [338] = {.lex_state = 16, .external_lex_state = 3},
  [339] = {.lex_state = 16, .external_lex_state = 3},
  [340] = {.lex_state = 7, .external_lex_state = 2},
  [341] = {.lex_state = 16, .external_lex_state = 3},
  [342] = {.lex_state = 7, .external_lex_state = 2},
  [343] = {.lex_state = 18},
  [344] = {.lex_state = 20},
  [345] = {.lex_state = 18},
  [346] = {.lex_state = 20},
  [347] = {.lex_state = 18},
  [348] = {.lex_state = 22, .external_lex_state = 2},
  [349] = {.lex_state = 18},
  [350] = {.lex_state = 20},
  [351] = {.lex_state = 18},
  [352] = {.lex_state = 18},
  [353] = {.lex_state = 22, .external_lex_state = 2},
  [354] = {.lex_state = 18},
  [355] = {.lex_state = 20},
  [356] = {.lex_state = 20},
  [357] = {.lex_state = 22, .external_lex_state = 2},
  [358] = {.lex_state = 18},
  [359] = {.lex_state = 18},
  [360] = {.lex_state = 7, .external_lex_state = 3},
  [361] = {.lex_state = 20},
  [362] = {.lex_state = 20},
  [363] = {.lex_state = 18},
  [364] = {.lex_state = 20},
  [365] = {.lex_state = 18},
  [366] = {.lex_state = 20},
  [367] = {.lex_state = 20},
  [368] = {.lex_state = 16},
  [369] = {.lex_state = 7, .external_lex_state = 3},
  [370] = {.lex_state = 7, .external_lex_state = 3},
  [371] = {.lex_state = 20},
  [372] = {.lex_state = 20},
  [373] = {.lex_state = 7, .external_lex_state = 3},
  [374] = {.lex_state = 20},
  [375] = {.lex_state = 20},
  [376] = {.lex_state = 20},
  [377] = {.lex_state = 20},
  [378] = {.lex_state = 7, .external_lex_state = 2},
  [379] = {.lex_state = 7, .external_lex_state = 2},
  [380] = {.lex_state = 20},
  [381] = {.lex_state = 20},
  [382] = {.lex_state = 7, .external_lex_state = 2},
  [383] = {.lex_state = 20},
  [384] = {.lex_state = 22, .external_lex_state = 3},
  [385] = {.lex_state = 7, .external_lex_state = 3},
  [386] = {.lex_state = 7, .external_lex_state = 3},
  [387] = {.lex_state = 22, .external_lex_state = 3},
  [388] = {.lex_state = 22, .external_lex_state = 3},
  [389] = {.lex_state = 22, .external_lex_state = 3},
  [390] = {.lex_state = 7, .external_lex_state = 3},
  [391] = {.lex_state = 22, .external_lex_state = 2},
  [392] = {.lex_state = 22, .external_lex_state = 2},
  [393] = {.lex_state = 22, .external_lex_state = 2},
  [394] = {.lex_state = 7},
  [395] = {.lex_state = 7, .external_lex_state = 3},
  [396] = {.lex_state = 7, .external_lex_state = 3},
  [397] = {.lex_state = 20, .external_lex_state = 4},
  [398] = {.lex_state = 7, .external_lex_state = 3},
  [399] = {.lex_state = 20, .external_lex_state = 4},
  [400] = {.lex_state = 7, .external_lex_state = 3},
  [401] = {.lex_state = 20, .external_lex_state = 4},
  [402] = {.lex_state = 7, .external_lex_state = 3},
  [403] = {.lex_state = 7, .external_lex_state = 3},
  [404] = {.lex_state = 7, .external_lex_state = 3},
  [405] = {.lex_state = 7, .external_lex_state = 3},
  [406] = {.lex_state = 22, .external_lex_state = 3},
  [407] = {.lex_state = 22, .external_lex_state = 3},
  [408] = {.lex_state = 22, .external_lex_state = 3},
  [409] = {.lex_state = 22, .external_lex_state = 3},
  [410] = {.lex_state = 0, .external_lex_state = 5},
  [411] = {.lex_state = 22, .external_lex_state = 3},
  [412] = {.lex_state = 22, .external_lex_state = 3},
  [413] = {.lex_state = 20, .external_lex_state = 4},
  [414] = {.lex_state = 22, .external_lex_state = 3},
  [415] = {.lex_state = 22, .external_lex_state = 3},
  [416] = {.lex_state = 20, .external_lex_state = 4},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 20, .external_lex_state = 4},
  [419] = {.lex_state = 22, .external_lex_state = 3},
  [420] = {.lex_state = 22, .external_lex_state = 3},
  [421] = {.lex_state = 22, .external_lex_state = 3},
  [422] = {.lex_state = 0, .external_lex_state = 5},
  [423] = {.lex_state = 7},
  [424] = {.lex_state = 0, .external_lex_state = 5},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 0, .external_lex_state = 6},
  [427] = {.lex_state = 0, .external_lex_state = 5},
  [428] = {.lex_state = 23},
  [429] = {.lex_state = 23},
  [430] = {.lex_state = 23},
  [431] = {.lex_state = 0, .external_lex_state = 6},
  [432] = {.lex_state = 23},
  [433] = {.lex_state = 23},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 22},
  [436] = {.lex_state = 22},
  [437] = {.lex_state = 0, .external_lex_state = 6},
  [438] = {.lex_state = 23},
  [439] = {.lex_state = 23},
  [440] = {.lex_state = 23},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 23},
  [443] = {.lex_state = 23},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 23},
  [446] = {.lex_state = 22},
  [447] = {.lex_state = 22},
  [448] = {.lex_state = 22},
  [449] = {.lex_state = 23},
  [450] = {.lex_state = 23},
  [451] = {.lex_state = 23},
  [452] = {.lex_state = 23},
  [453] = {.lex_state = 23},
  [454] = {.lex_state = 0, .external_lex_state = 5},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 23},
  [457] = {.lex_state = 0, .external_lex_state = 5},
  [458] = {.lex_state = 23},
  [459] = {.lex_state = 23},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 18},
  [465] = {.lex_state = 0, .external_lex_state = 6},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 0, .external_lex_state = 6},
  [468] = {.lex_state = 16},
  [469] = {.lex_state = 16},
  [470] = {.lex_state = 0, .external_lex_state = 6},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0, .external_lex_state = 6},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 0, .external_lex_state = 6},
  [477] = {.lex_state = 0, .external_lex_state = 6},
  [478] = {.lex_state = 0, .external_lex_state = 6},
  [479] = {.lex_state = 16},
  [480] = {.lex_state = 0, .external_lex_state = 6},
  [481] = {.lex_state = 0, .external_lex_state = 6},
  [482] = {.lex_state = 0, .external_lex_state = 6},
  [483] = {.lex_state = 0, .external_lex_state = 6},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0, .external_lex_state = 6},
  [486] = {.lex_state = 0, .external_lex_state = 6},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 16},
  [490] = {.lex_state = 16},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 22},
  [493] = {.lex_state = 0, .external_lex_state = 6},
  [494] = {.lex_state = 16},
  [495] = {.lex_state = 0, .external_lex_state = 6},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0, .external_lex_state = 6},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 0, .external_lex_state = 6},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 0},
  [506] = {.lex_state = 0, .external_lex_state = 6},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 0},
  [509] = {.lex_state = 16},
  [510] = {.lex_state = 16},
  [511] = {.lex_state = 16},
  [512] = {.lex_state = 0},
  [513] = {.lex_state = 0, .external_lex_state = 6},
  [514] = {.lex_state = 0},
  [515] = {.lex_state = 0},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 0},
  [519] = {.lex_state = 16},
  [520] = {.lex_state = 16},
  [521] = {.lex_state = 0},
  [522] = {.lex_state = 0},
  [523] = {.lex_state = 18},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 0},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 0},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 18},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 18},
  [532] = {.lex_state = 18},
  [533] = {.lex_state = 18},
  [534] = {.lex_state = 0},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 18},
  [538] = {.lex_state = 18},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 18},
  [541] = {.lex_state = 18},
  [542] = {.lex_state = 18},
  [543] = {.lex_state = 18},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 16},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 0},
};

enum {
  ts_external_token__concat = 0,
  ts_external_token__brace_concat = 1,
  ts_external_token__concat_list = 2,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__concat] = sym__concat,
  [ts_external_token__brace_concat] = sym__brace_concat,
  [ts_external_token__concat_list] = sym__concat_list,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__concat] = true,
    [ts_external_token__brace_concat] = true,
    [ts_external_token__concat_list] = true,
  },
  [2] = {
    [ts_external_token__concat] = true,
    [ts_external_token__concat_list] = true,
  },
  [3] = {
    [ts_external_token__concat] = true,
  },
  [4] = {
    [ts_external_token__concat_list] = true,
  },
  [5] = {
    [ts_external_token__brace_concat] = true,
    [ts_external_token__concat_list] = true,
  },
  [6] = {
    [ts_external_token__brace_concat] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [sym_stream_redirect] = ACTIONS(1),
    [sym_direction] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [sym_break] = ACTIONS(1),
    [sym_continue] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [aux_sym_test_command_token2] = ACTIONS(1),
    [anon_sym_test] = ACTIONS(1),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1),
    [anon_sym_DASHa] = ACTIONS(1),
    [anon_sym_DASHo] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [sym_test_option] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym__special_character] = ACTIONS(1),
    [sym_home_dir_expansion] = ACTIONS(1),
    [sym_glob] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym__brace_concat] = ACTIONS(1),
    [sym__concat_list] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(548),
    [sym_conditional_execution] = STATE(288),
    [sym_redirected_statement] = STATE(288),
    [sym_pipe] = STATE(288),
    [sym_negated_statement] = STATE(288),
    [sym_command_substitution] = STATE(100),
    [sym_function_definition] = STATE(288),
    [sym_return] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_for_statement] = STATE(288),
    [sym_while_statement] = STATE(288),
    [sym_if_statement] = STATE(288),
    [sym_begin_statement] = STATE(288),
    [sym_test_command] = STATE(288),
    [sym_variable_expansion] = STATE(100),
    [sym_brace_expansion] = STATE(100),
    [sym_double_quote_string] = STATE(100),
    [sym_single_quote_string] = STATE(100),
    [sym_command] = STATE(288),
    [sym_concatenation] = STATE(77),
    [sym__expression] = STATE(77),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_variable_expansion_repeat1] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_and] = ACTIONS(7),
    [anon_sym_or] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(9),
    [anon_sym_LF] = ACTIONS(9),
    [anon_sym_CR] = ACTIONS(9),
    [anon_sym_CR_LF] = ACTIONS(9),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_not] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_function] = ACTIONS(15),
    [sym_integer] = ACTIONS(17),
    [sym_float] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [sym_break] = ACTIONS(23),
    [sym_continue] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_begin] = ACTIONS(31),
    [aux_sym_test_command_token1] = ACTIONS(33),
    [anon_sym_test] = ACTIONS(35),
    [sym_comment] = ACTIONS(37),
    [anon_sym_DOLLAR] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
    [sym_escape_sequence] = ACTIONS(17),
    [sym__special_character] = ACTIONS(47),
    [sym_home_dir_expansion] = ACTIONS(17),
    [sym_glob] = ACTIONS(17),
    [sym_word] = ACTIONS(17),
  },
  [2] = {
    [sym_conditional_execution] = STATE(275),
    [sym_redirected_statement] = STATE(275),
    [sym_pipe] = STATE(275),
    [sym__terminated_opt_statement] = STATE(3),
    [sym_negated_statement] = STATE(275),
    [sym_command_substitution] = STATE(100),
    [sym_function_definition] = STATE(275),
    [sym_return] = STATE(275),
    [sym_switch_statement] = STATE(275),
    [sym_for_statement] = STATE(275),
    [sym_while_statement] = STATE(275),
    [sym_if_statement] = STATE(275),
    [sym_else_if_clause] = STATE(417),
    [sym_else_clause] = STATE(550),
    [sym_begin_statement] = STATE(275),
    [sym_test_command] = STATE(275),
    [sym_variable_expansion] = STATE(100),
    [sym_brace_expansion] = STATE(100),
    [sym_double_quote_string] = STATE(100),
    [sym_single_quote_string] = STATE(100),
    [sym_command] = STATE(275),
    [sym_concatenation] = STATE(77),
    [sym__expression] = STATE(77),
    [aux_sym_while_statement_repeat1] = STATE(3),
    [aux_sym_if_statement_repeat1] = STATE(417),
    [aux_sym_variable_expansion_repeat1] = STATE(490),
    [anon_sym_and] = ACTIONS(7),
    [anon_sym_or] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(49),
    [anon_sym_LF] = ACTIONS(49),
    [anon_sym_CR] = ACTIONS(49),
    [anon_sym_CR_LF] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_not] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_function] = ACTIONS(15),
    [anon_sym_end] = ACTIONS(51),
    [sym_integer] = ACTIONS(17),
    [sym_float] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [sym_break] = ACTIONS(53),
    [sym_continue] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_else] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(31),
    [aux_sym_test_command_token1] = ACTIONS(33),
    [anon_sym_test] = ACTIONS(35),
    [sym_comment] = ACTIONS(37),
    [anon_sym_DOLLAR] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
    [sym_escape_sequence] = ACTIONS(17),
    [sym__special_character] = ACTIONS(47),
    [sym_home_dir_expansion] = ACTIONS(17),
    [sym_glob] = ACTIONS(17),
    [sym_word] = ACTIONS(17),
  },
  [3] = {
    [sym_conditional_execution] = STATE(275),
    [sym_redirected_statement] = STATE(275),
    [sym_pipe] = STATE(275),
    [sym__terminated_opt_statement] = STATE(5),
    [sym_negated_statement] = STATE(275),
    [sym_command_substitution] = STATE(100),
    [sym_function_definition] = STATE(275),
    [sym_return] = STATE(275),
    [sym_switch_statement] = STATE(275),
    [sym_for_statement] = STATE(275),
    [sym_while_statement] = STATE(275),
    [sym_if_statement] = STATE(275),
    [sym_else_if_clause] = STATE(425),
    [sym_else_clause] = STATE(551),
    [sym_begin_statement] = STATE(275),
    [sym_test_command] = STATE(275),
    [sym_variable_expansion] = STATE(100),
    [sym_brace_expansion] = STATE(100),
    [sym_double_quote_string] = STATE(100),
    [sym_single_quote_string] = STATE(100),
    [sym_command] = STATE(275),
    [sym_concatenation] = STATE(77),
    [sym__expression] = STATE(77),
    [aux_sym_while_statement_repeat1] = STATE(5),
    [aux_sym_if_statement_repeat1] = STATE(425),
    [aux_sym_variable_expansion_repeat1] = STATE(490),
    [anon_sym_and] = ACTIONS(7),
    [anon_sym_or] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(57),
    [anon_sym_CR] = ACTIONS(57),
    [anon_sym_CR_LF] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(11),
    [anon_sym_not] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_function] = ACTIONS(15),
    [anon_sym_end] = ACTIONS(59),
    [sym_integer] = ACTIONS(17),
    [sym_float] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [sym_break] = ACTIONS(53),
    [sym_continue] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_else] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(31),
    [aux_sym_test_command_token1] = ACTIONS(33),
    [anon_sym_test] = ACTIONS(35),
    [sym_comment] = ACTIONS(37),
    [anon_sym_DOLLAR] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_SQUOTE] = ACTIONS(45),
    [sym_escape_sequence] = ACTIONS(17),
    [sym__special_character] = ACTIONS(47),
    [sym_home_dir_expansion] = ACTIONS(17),
    [sym_glob] = ACTIONS(17),
    [sym_word] = ACTIONS(17),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(53), 2,
      sym_break,
      sym_continue,
    ACTIONS(63), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(6), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(61), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(275), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [113] = 27,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(74), 1,
      anon_sym_LPAREN,
    ACTIONS(77), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_return,
    ACTIONS(88), 1,
      anon_sym_switch,
    ACTIONS(94), 1,
      anon_sym_for,
    ACTIONS(97), 1,
      anon_sym_while,
    ACTIONS(100), 1,
      anon_sym_if,
    ACTIONS(103), 1,
      anon_sym_begin,
    ACTIONS(106), 1,
      aux_sym_test_command_token1,
    ACTIONS(109), 1,
      anon_sym_test,
    ACTIONS(112), 1,
      anon_sym_DOLLAR,
    ACTIONS(115), 1,
      anon_sym_LBRACE,
    ACTIONS(118), 1,
      anon_sym_DQUOTE,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(124), 1,
      sym__special_character,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(65), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(71), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(80), 2,
      anon_sym_end,
      anon_sym_else,
    ACTIONS(91), 2,
      sym_break,
      sym_continue,
    STATE(5), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(68), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(82), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(275), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [226] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(53), 2,
      sym_break,
      sym_continue,
    ACTIONS(127), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(5), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(57), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(275), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [339] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(131), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(133), 2,
      sym_break,
      sym_continue,
    STATE(11), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(129), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(299), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [451] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(137), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(133), 2,
      sym_break,
      sym_continue,
    STATE(9), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(135), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(299), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [563] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(141), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(133), 2,
      sym_break,
      sym_continue,
    STATE(12), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(139), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(299), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [675] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(145), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(133), 2,
      sym_break,
      sym_continue,
    STATE(13), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(143), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(299), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [787] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(147), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(133), 2,
      sym_break,
      sym_continue,
    STATE(12), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(139), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(299), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [899] = 27,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(74), 1,
      anon_sym_LPAREN,
    ACTIONS(77), 1,
      anon_sym_function,
    ACTIONS(80), 1,
      anon_sym_end,
    ACTIONS(85), 1,
      anon_sym_return,
    ACTIONS(88), 1,
      anon_sym_switch,
    ACTIONS(94), 1,
      anon_sym_for,
    ACTIONS(97), 1,
      anon_sym_while,
    ACTIONS(100), 1,
      anon_sym_if,
    ACTIONS(103), 1,
      anon_sym_begin,
    ACTIONS(106), 1,
      aux_sym_test_command_token1,
    ACTIONS(109), 1,
      anon_sym_test,
    ACTIONS(112), 1,
      anon_sym_DOLLAR,
    ACTIONS(115), 1,
      anon_sym_LBRACE,
    ACTIONS(118), 1,
      anon_sym_DQUOTE,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(124), 1,
      sym__special_character,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(65), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(71), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(152), 2,
      sym_break,
      sym_continue,
    STATE(12), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(149), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(82), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(299), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1011] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(155), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(133), 2,
      sym_break,
      sym_continue,
    STATE(12), 2,
      sym__terminated_opt_statement,
      aux_sym_while_statement_repeat1,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(139), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(299), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1123] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(159), 1,
      anon_sym_RPAREN,
    STATE(28), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(161), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(157), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(264), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1234] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(165), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(167), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(253), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1345] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(169), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(171), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(252), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1456] = 27,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(182), 1,
      anon_sym_LPAREN,
    ACTIONS(185), 1,
      anon_sym_RPAREN,
    ACTIONS(187), 1,
      anon_sym_function,
    ACTIONS(193), 1,
      anon_sym_return,
    ACTIONS(196), 1,
      anon_sym_switch,
    ACTIONS(202), 1,
      anon_sym_for,
    ACTIONS(205), 1,
      anon_sym_while,
    ACTIONS(208), 1,
      anon_sym_if,
    ACTIONS(211), 1,
      anon_sym_begin,
    ACTIONS(214), 1,
      aux_sym_test_command_token1,
    ACTIONS(217), 1,
      anon_sym_test,
    ACTIONS(220), 1,
      anon_sym_DOLLAR,
    ACTIONS(223), 1,
      anon_sym_LBRACE,
    ACTIONS(226), 1,
      anon_sym_DQUOTE,
    ACTIONS(229), 1,
      anon_sym_SQUOTE,
    ACTIONS(232), 1,
      sym__special_character,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(173), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(179), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(199), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(176), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(190), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(281), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1567] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(235), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(237), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(266), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1678] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(239), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(241), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(257), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1789] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(245), 1,
      anon_sym_RPAREN,
    STATE(16), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(247), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(243), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(246), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [1900] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(249), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(251), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(263), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2011] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(253), 1,
      ts_builtin_sym_end,
    STATE(23), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(23), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(255), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(288), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2122] = 27,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(182), 1,
      anon_sym_LPAREN,
    ACTIONS(187), 1,
      anon_sym_function,
    ACTIONS(193), 1,
      anon_sym_return,
    ACTIONS(196), 1,
      anon_sym_switch,
    ACTIONS(202), 1,
      anon_sym_for,
    ACTIONS(205), 1,
      anon_sym_while,
    ACTIONS(208), 1,
      anon_sym_if,
    ACTIONS(211), 1,
      anon_sym_begin,
    ACTIONS(214), 1,
      aux_sym_test_command_token1,
    ACTIONS(217), 1,
      anon_sym_test,
    ACTIONS(220), 1,
      anon_sym_DOLLAR,
    ACTIONS(223), 1,
      anon_sym_LBRACE,
    ACTIONS(226), 1,
      anon_sym_DQUOTE,
    ACTIONS(229), 1,
      anon_sym_SQUOTE,
    ACTIONS(232), 1,
      sym__special_character,
    ACTIONS(257), 1,
      ts_builtin_sym_end,
    STATE(23), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(173), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(179), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(262), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(259), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(190), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(288), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2233] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    STATE(18), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(269), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(265), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(259), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2344] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(273), 1,
      anon_sym_RPAREN,
    STATE(19), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(275), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(271), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(256), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2455] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(279), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(281), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(277), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(255), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2566] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(285), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(249), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2677] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(289), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(251), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2788] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(293), 1,
      anon_sym_RPAREN,
    STATE(27), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(295), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(291), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(262), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [2899] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    STATE(21), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(301), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(297), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(247), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3010] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(305), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(248), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3121] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(309), 1,
      anon_sym_RPAREN,
    STATE(33), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(311), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(307), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(258), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3232] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(313), 1,
      anon_sym_RPAREN,
    STATE(17), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(315), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(163), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(265), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3343] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    STATE(15), 1,
      aux_sym_program_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(321), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(317), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(260), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3454] = 27,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(329), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_function,
    ACTIONS(340), 1,
      anon_sym_return,
    ACTIONS(343), 1,
      anon_sym_switch,
    ACTIONS(349), 1,
      anon_sym_for,
    ACTIONS(352), 1,
      anon_sym_while,
    ACTIONS(355), 1,
      anon_sym_if,
    ACTIONS(358), 1,
      anon_sym_begin,
    ACTIONS(361), 1,
      aux_sym_test_command_token1,
    ACTIONS(364), 1,
      anon_sym_test,
    ACTIONS(367), 1,
      anon_sym_DOLLAR,
    ACTIONS(370), 1,
      anon_sym_LBRACE,
    ACTIONS(373), 1,
      anon_sym_DQUOTE,
    ACTIONS(376), 1,
      anon_sym_SQUOTE,
    ACTIONS(379), 1,
      sym_escape_sequence,
    ACTIONS(382), 1,
      sym__special_character,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(323), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(326), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(335), 2,
      anon_sym_end,
      anon_sym_case,
    ACTIONS(346), 2,
      sym_break,
      sym_continue,
    STATE(35), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(337), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(293), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3562] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(385), 2,
      anon_sym_end,
      anon_sym_case,
    ACTIONS(387), 2,
      sym_break,
      sym_continue,
    STATE(35), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(293), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3670] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(387), 2,
      sym_break,
      sym_continue,
    ACTIONS(391), 2,
      anon_sym_end,
      anon_sym_case,
    STATE(36), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(293), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3778] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(393), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(39), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3885] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(397), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [3992] = 27,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(329), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_function,
    ACTIONS(335), 1,
      anon_sym_end,
    ACTIONS(340), 1,
      anon_sym_return,
    ACTIONS(343), 1,
      anon_sym_switch,
    ACTIONS(349), 1,
      anon_sym_for,
    ACTIONS(352), 1,
      anon_sym_while,
    ACTIONS(355), 1,
      anon_sym_if,
    ACTIONS(358), 1,
      anon_sym_begin,
    ACTIONS(361), 1,
      aux_sym_test_command_token1,
    ACTIONS(364), 1,
      anon_sym_test,
    ACTIONS(367), 1,
      anon_sym_DOLLAR,
    ACTIONS(370), 1,
      anon_sym_LBRACE,
    ACTIONS(373), 1,
      anon_sym_DQUOTE,
    ACTIONS(376), 1,
      anon_sym_SQUOTE,
    ACTIONS(379), 1,
      sym_escape_sequence,
    ACTIONS(382), 1,
      sym__special_character,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(323), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(326), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(399), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(337), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4099] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(402), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4206] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(404), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4313] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(406), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4420] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(408), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4527] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(410), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4634] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(412), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(45), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4741] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(414), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(44), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4848] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(416), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(43), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [4955] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(418), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(42), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5062] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(420), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(41), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5169] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(422), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(56), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5276] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(424), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(57), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5383] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(426), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(58), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5490] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(428), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(59), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5597] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(430), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(60), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5704] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(432), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5811] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(434), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [5918] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(436), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6025] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(438), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6132] = 27,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    ACTIONS(440), 1,
      anon_sym_end,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(395), 2,
      sym_break,
      sym_continue,
    STATE(40), 2,
      sym__terminated_statement,
      aux_sym_function_definition_repeat2,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(295), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6239] = 26,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(4), 1,
      sym__terminated_statement,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(442), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(276), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6342] = 26,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(7), 1,
      sym__terminated_statement,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(444), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(308), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6445] = 26,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(2), 1,
      sym__terminated_statement,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(442), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(276), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6548] = 25,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(446), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(261), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6648] = 25,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(448), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(250), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6748] = 25,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(450), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(267), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6848] = 25,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_function,
    ACTIONS(19), 1,
      anon_sym_return,
    ACTIONS(21), 1,
      anon_sym_switch,
    ACTIONS(25), 1,
      anon_sym_for,
    ACTIONS(27), 1,
      anon_sym_while,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_begin,
    ACTIONS(33), 1,
      aux_sym_test_command_token1,
    ACTIONS(35), 1,
      anon_sym_test,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    ACTIONS(389), 1,
      sym_escape_sequence,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(7), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(11), 2,
      anon_sym_BANG,
      anon_sym_not,
    ACTIONS(452), 2,
      sym_break,
      sym_continue,
    STATE(77), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(17), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    STATE(254), 13,
      sym_conditional_execution,
      sym_redirected_statement,
      sym_pipe,
      sym_negated_statement,
      sym_function_definition,
      sym_return,
      sym_switch_statement,
      sym_for_statement,
      sym_while_statement,
      sym_if_statement,
      sym_begin_statement,
      sym_test_command,
      sym_command,
  [6948] = 16,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(456), 1,
      anon_sym_BANG,
    ACTIONS(458), 1,
      anon_sym_LPAREN,
    ACTIONS(462), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(464), 1,
      sym_test_option,
    ACTIONS(466), 1,
      anon_sym_DOLLAR,
    ACTIONS(468), 1,
      anon_sym_LBRACE,
    ACTIONS(470), 1,
      anon_sym_DQUOTE,
    ACTIONS(472), 1,
      anon_sym_SQUOTE,
    ACTIONS(474), 1,
      sym__special_character,
    STATE(509), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(198), 2,
      sym_concatenation,
      sym__expression,
    STATE(175), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(460), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(245), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
    ACTIONS(454), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [7022] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(476), 34,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_function,
      anon_sym_end,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_else,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [7062] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(478), 34,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_function,
      anon_sym_end,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_else,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [7102] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(257), 1,
      ts_builtin_sym_end,
    ACTIONS(185), 32,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_function,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [7143] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(185), 33,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_function,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [7182] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(478), 33,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_function,
      anon_sym_end,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [7221] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(476), 33,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_function,
      anon_sym_end,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [7260] = 13,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    STATE(76), 1,
      aux_sym_command_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(116), 2,
      sym_concatenation,
      sym__expression,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    ACTIONS(480), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [7320] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_LPAREN,
    ACTIONS(490), 1,
      anon_sym_DOLLAR,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(496), 1,
      anon_sym_DQUOTE,
    ACTIONS(499), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      sym__special_character,
    STATE(76), 1,
      aux_sym_command_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(116), 2,
      sym_concatenation,
      sym__expression,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(487), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    ACTIONS(482), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [7380] = 13,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(47), 1,
      sym__special_character,
    STATE(75), 1,
      aux_sym_command_repeat1,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(116), 2,
      sym_concatenation,
      sym__expression,
    STATE(100), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(17), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    ACTIONS(505), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [7440] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(458), 1,
      anon_sym_LPAREN,
    ACTIONS(466), 1,
      anon_sym_DOLLAR,
    ACTIONS(468), 1,
      anon_sym_LBRACE,
    ACTIONS(470), 1,
      anon_sym_DQUOTE,
    ACTIONS(472), 1,
      anon_sym_SQUOTE,
    ACTIONS(474), 1,
      sym__special_character,
    STATE(509), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(274), 2,
      sym_concatenation,
      sym__expression,
    STATE(175), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(460), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    ACTIONS(507), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [7497] = 16,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_BANG,
    ACTIONS(511), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      anon_sym_RBRACK,
    ACTIONS(517), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(519), 1,
      sym_test_option,
    ACTIONS(521), 1,
      anon_sym_DOLLAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_DQUOTE,
    ACTIONS(527), 1,
      anon_sym_SQUOTE,
    ACTIONS(529), 1,
      sym__special_character,
    STATE(511), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(368), 2,
      sym_concatenation,
      sym__expression,
    STATE(322), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(513), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(492), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
  [7561] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(531), 1,
      sym_escape_sequence,
    ACTIONS(476), 28,
      anon_sym_and,
      anon_sym_or,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_function,
      anon_sym_end,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_case,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [7598] = 15,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(456), 1,
      anon_sym_BANG,
    ACTIONS(458), 1,
      anon_sym_LPAREN,
    ACTIONS(462), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(464), 1,
      sym_test_option,
    ACTIONS(466), 1,
      anon_sym_DOLLAR,
    ACTIONS(468), 1,
      anon_sym_LBRACE,
    ACTIONS(470), 1,
      anon_sym_DQUOTE,
    ACTIONS(472), 1,
      anon_sym_SQUOTE,
    ACTIONS(474), 1,
      sym__special_character,
    STATE(509), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(198), 2,
      sym_concatenation,
      sym__expression,
    STATE(175), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(460), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(238), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
  [7659] = 15,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(456), 1,
      anon_sym_BANG,
    ACTIONS(458), 1,
      anon_sym_LPAREN,
    ACTIONS(462), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(464), 1,
      sym_test_option,
    ACTIONS(466), 1,
      anon_sym_DOLLAR,
    ACTIONS(468), 1,
      anon_sym_LBRACE,
    ACTIONS(470), 1,
      anon_sym_DQUOTE,
    ACTIONS(472), 1,
      anon_sym_SQUOTE,
    ACTIONS(474), 1,
      sym__special_character,
    STATE(509), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(198), 2,
      sym_concatenation,
      sym__expression,
    STATE(175), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(460), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(244), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
  [7720] = 15,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_BANG,
    ACTIONS(511), 1,
      anon_sym_LPAREN,
    ACTIONS(517), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(519), 1,
      sym_test_option,
    ACTIONS(521), 1,
      anon_sym_DOLLAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_DQUOTE,
    ACTIONS(527), 1,
      anon_sym_SQUOTE,
    ACTIONS(529), 1,
      sym__special_character,
    STATE(511), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(368), 2,
      sym_concatenation,
      sym__expression,
    STATE(322), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(513), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(464), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
  [7781] = 15,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_BANG,
    ACTIONS(511), 1,
      anon_sym_LPAREN,
    ACTIONS(517), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(519), 1,
      sym_test_option,
    ACTIONS(521), 1,
      anon_sym_DOLLAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_DQUOTE,
    ACTIONS(527), 1,
      anon_sym_SQUOTE,
    ACTIONS(529), 1,
      sym__special_character,
    STATE(511), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(368), 2,
      sym_concatenation,
      sym__expression,
    STATE(322), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(513), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(435), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
  [7842] = 15,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_BANG,
    ACTIONS(511), 1,
      anon_sym_LPAREN,
    ACTIONS(517), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(519), 1,
      sym_test_option,
    ACTIONS(521), 1,
      anon_sym_DOLLAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_DQUOTE,
    ACTIONS(527), 1,
      anon_sym_SQUOTE,
    ACTIONS(529), 1,
      sym__special_character,
    STATE(511), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(368), 2,
      sym_concatenation,
      sym__expression,
    STATE(322), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(513), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(447), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
  [7903] = 15,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_BANG,
    ACTIONS(511), 1,
      anon_sym_LPAREN,
    ACTIONS(517), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(519), 1,
      sym_test_option,
    ACTIONS(521), 1,
      anon_sym_DOLLAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_DQUOTE,
    ACTIONS(527), 1,
      anon_sym_SQUOTE,
    ACTIONS(529), 1,
      sym__special_character,
    STATE(511), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(368), 2,
      sym_concatenation,
      sym__expression,
    STATE(322), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(513), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(523), 6,
      sym__test_expression,
      sym__parenthesized_test_expression,
      sym_negated_expression,
      sym_conditional_expression,
      sym_unary_expression,
      sym_binary_expression,
  [7964] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(531), 1,
      sym_escape_sequence,
    ACTIONS(476), 27,
      anon_sym_and,
      anon_sym_or,
      anon_sym_BANG,
      anon_sym_not,
      anon_sym_LPAREN,
      anon_sym_function,
      anon_sym_end,
      sym_integer,
      sym_float,
      anon_sym_return,
      anon_sym_switch,
      sym_break,
      sym_continue,
      anon_sym_for,
      anon_sym_while,
      anon_sym_if,
      anon_sym_begin,
      aux_sym_test_command_token1,
      anon_sym_test,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8000] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(535), 1,
      anon_sym_LPAREN,
    ACTIONS(541), 1,
      anon_sym_DOLLAR,
    ACTIONS(544), 1,
      anon_sym_LBRACE,
    ACTIONS(547), 1,
      anon_sym_DQUOTE,
    ACTIONS(550), 1,
      anon_sym_SQUOTE,
    ACTIONS(553), 1,
      sym__special_character,
    STATE(88), 1,
      aux_sym_for_statement_repeat1,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(187), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(533), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(538), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8054] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 1,
      sym__concat,
    ACTIONS(560), 1,
      sym__concat_list,
    STATE(89), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(556), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8092] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(577), 1,
      sym__special_character,
    STATE(95), 1,
      aux_sym_function_definition_repeat1,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(194), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(563), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(567), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8146] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(581), 1,
      sym__concat,
    ACTIONS(583), 1,
      sym__concat_list,
    STATE(97), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(579), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8184] = 17,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(577), 1,
      sym__special_character,
    ACTIONS(585), 1,
      anon_sym_SEMI,
    ACTIONS(587), 1,
      anon_sym_AMP,
    ACTIONS(589), 1,
      anon_sym_LF,
    ACTIONS(591), 1,
      anon_sym_CR,
    ACTIONS(593), 1,
      anon_sym_CR_LF,
    STATE(88), 1,
      aux_sym_for_statement_repeat1,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(187), 2,
      sym_concatenation,
      sym__expression,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(567), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8246] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(577), 1,
      sym__special_character,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(96), 3,
      sym_concatenation,
      sym__expression,
      aux_sym_case_clause_repeat1,
    ACTIONS(595), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(567), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8298] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(599), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_DOLLAR,
    ACTIONS(608), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_DQUOTE,
    ACTIONS(614), 1,
      anon_sym_SQUOTE,
    ACTIONS(617), 1,
      sym__special_character,
    STATE(94), 1,
      aux_sym_function_definition_repeat1,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(194), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(597), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(602), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8352] = 17,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(577), 1,
      sym__special_character,
    ACTIONS(620), 1,
      anon_sym_SEMI,
    ACTIONS(622), 1,
      anon_sym_AMP,
    ACTIONS(624), 1,
      anon_sym_LF,
    ACTIONS(626), 1,
      anon_sym_CR,
    ACTIONS(628), 1,
      anon_sym_CR_LF,
    STATE(94), 1,
      aux_sym_function_definition_repeat1,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(194), 2,
      sym_concatenation,
      sym__expression,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(567), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8414] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(638), 1,
      anon_sym_DOLLAR,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(644), 1,
      anon_sym_DQUOTE,
    ACTIONS(647), 1,
      anon_sym_SQUOTE,
    ACTIONS(650), 1,
      sym__special_character,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(96), 3,
      sym_concatenation,
      sym__expression,
      aux_sym_case_clause_repeat1,
    ACTIONS(630), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(635), 6,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8466] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(583), 1,
      sym__concat_list,
    ACTIONS(655), 1,
      sym__concat,
    STATE(89), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(653), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8504] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(659), 1,
      sym__concat,
    STATE(98), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(657), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8539] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(556), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8572] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(664), 1,
      sym__concat,
    STATE(103), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(662), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8607] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(668), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(666), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8640] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(672), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(670), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8673] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(664), 1,
      sym__concat,
    STATE(98), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(674), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8708] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(664), 1,
      sym__concat,
    STATE(103), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(676), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8743] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym__concat,
    ACTIONS(678), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8775] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(684), 1,
      sym__concat,
    ACTIONS(682), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8807] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(688), 1,
      sym__concat,
    ACTIONS(686), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8839] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(692), 1,
      sym__concat,
    ACTIONS(690), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8871] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(696), 1,
      sym__concat,
    ACTIONS(694), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8903] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(700), 1,
      sym__concat,
    ACTIONS(698), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8935] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(704), 1,
      sym__concat,
    ACTIONS(702), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8967] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(708), 1,
      sym__concat,
    ACTIONS(706), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [8999] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(712), 1,
      sym__concat,
    ACTIONS(710), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [9031] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(714), 1,
      sym__concat,
    ACTIONS(657), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [9063] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(718), 1,
      sym__concat,
    ACTIONS(716), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [9095] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(720), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [9124] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(524), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(508), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9174] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(518), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(521), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9224] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(505), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(501), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9274] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(502), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(462), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9324] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(473), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(491), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9374] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(487), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(488), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9424] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(500), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(525), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9474] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(730), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(517), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(516), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9524] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(738), 1,
      anon_sym_COMMA,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(497), 1,
      sym_variable_expansion,
    STATE(498), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(539), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9573] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(577), 1,
      sym__special_character,
    ACTIONS(740), 1,
      sym_escape_sequence,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(93), 3,
      sym_concatenation,
      sym__expression,
      aux_sym_case_clause_repeat1,
    ACTIONS(567), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [9620] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(742), 1,
      anon_sym_COMMA,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(513), 1,
      sym_variable_expansion,
    STATE(514), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(530), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9669] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      anon_sym_COMMA,
    STATE(461), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(506), 1,
      sym_variable_expansion,
    STATE(526), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9718] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(746), 1,
      anon_sym_COMMA,
    STATE(466), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(467), 1,
      sym_variable_expansion,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(528), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9767] = 11,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(732), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(535), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9812] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(748), 1,
      anon_sym_COMMA,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(499), 1,
      sym_variable_expansion,
    STATE(512), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(536), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9861] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(750), 1,
      anon_sym_COMMA,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(474), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(493), 1,
      sym_variable_expansion,
    STATE(534), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9910] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(752), 1,
      anon_sym_COMMA,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(483), 1,
      sym_variable_expansion,
    STATE(484), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(544), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [9959] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(577), 1,
      sym__special_character,
    ACTIONS(740), 1,
      sym_escape_sequence,
    STATE(92), 1,
      aux_sym_for_statement_repeat1,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(187), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(567), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10008] = 13,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    ACTIONS(754), 1,
      anon_sym_COMMA,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(470), 1,
      sym_variable_expansion,
    STATE(471), 1,
      aux_sym_brace_expansion_repeat1,
    STATE(527), 2,
      sym_brace_concatenation,
      sym__brace_expression,
    ACTIONS(724), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(431), 5,
      sym_command_substitution,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [10057] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(581), 1,
      sym__concat,
    ACTIONS(756), 1,
      sym__concat_list,
    STATE(140), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(579), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10089] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(577), 1,
      sym__special_character,
    ACTIONS(740), 1,
      sym_escape_sequence,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(90), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(567), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(149), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10135] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_DOLLAR,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(766), 1,
      anon_sym_DQUOTE,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      sym_escape_sequence,
    ACTIONS(772), 1,
      sym__special_character,
    STATE(489), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(423), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(760), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(369), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10181] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(778), 1,
      anon_sym_DOLLAR,
    ACTIONS(780), 1,
      anon_sym_LBRACE,
    ACTIONS(782), 1,
      anon_sym_DQUOTE,
    ACTIONS(784), 1,
      anon_sym_SQUOTE,
    ACTIONS(786), 1,
      sym_escape_sequence,
    ACTIONS(788), 1,
      sym__special_character,
    STATE(494), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(448), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(776), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(384), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10227] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(655), 1,
      sym__concat,
    ACTIONS(756), 1,
      sym__concat_list,
    STATE(143), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(653), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10259] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(458), 1,
      anon_sym_LPAREN,
    ACTIONS(466), 1,
      anon_sym_DOLLAR,
    ACTIONS(468), 1,
      anon_sym_LBRACE,
    ACTIONS(470), 1,
      anon_sym_DQUOTE,
    ACTIONS(472), 1,
      anon_sym_SQUOTE,
    ACTIONS(474), 1,
      sym__special_character,
    ACTIONS(790), 1,
      sym_escape_sequence,
    STATE(509), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(309), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(460), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(175), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10305] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_LPAREN,
    ACTIONS(796), 1,
      anon_sym_DOLLAR,
    ACTIONS(798), 1,
      anon_sym_LBRACE,
    ACTIONS(800), 1,
      anon_sym_DQUOTE,
    ACTIONS(802), 1,
      anon_sym_SQUOTE,
    ACTIONS(804), 1,
      sym_escape_sequence,
    ACTIONS(806), 1,
      sym__special_character,
    STATE(510), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(243), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(794), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(209), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10351] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 1,
      sym__concat,
    ACTIONS(808), 1,
      sym__concat_list,
    STATE(143), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(556), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10383] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_LPAREN,
    ACTIONS(796), 1,
      anon_sym_DOLLAR,
    ACTIONS(798), 1,
      anon_sym_LBRACE,
    ACTIONS(800), 1,
      anon_sym_DQUOTE,
    ACTIONS(802), 1,
      anon_sym_SQUOTE,
    ACTIONS(804), 1,
      sym_escape_sequence,
    ACTIONS(806), 1,
      sym__special_character,
    STATE(510), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(242), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(794), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(209), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10429] = 12,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(778), 1,
      anon_sym_DOLLAR,
    ACTIONS(780), 1,
      anon_sym_LBRACE,
    ACTIONS(782), 1,
      anon_sym_DQUOTE,
    ACTIONS(784), 1,
      anon_sym_SQUOTE,
    ACTIONS(786), 1,
      sym_escape_sequence,
    ACTIONS(788), 1,
      sym__special_character,
    STATE(494), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(436), 2,
      sym_concatenation,
      sym__expression,
    ACTIONS(776), 5,
      sym_integer,
      sym_float,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
    STATE(384), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [10475] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 1,
      sym__concat,
    ACTIONS(811), 1,
      sym__concat_list,
    STATE(146), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(556), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [10506] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(814), 1,
      sym__concat,
    STATE(150), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(674), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10535] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(814), 1,
      sym__concat,
    STATE(147), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(676), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10564] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(814), 1,
      sym__concat,
    STATE(147), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(662), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10593] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(816), 1,
      sym__concat,
    STATE(150), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(657), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10622] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(556), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10649] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(672), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(670), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10676] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(668), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(666), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10703] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(581), 1,
      sym__concat,
    ACTIONS(819), 1,
      sym__concat_list,
    STATE(155), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(579), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [10734] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(655), 1,
      sym__concat,
    ACTIONS(819), 1,
      sym__concat_list,
    STATE(146), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(653), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [10765] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(684), 1,
      sym__concat,
    ACTIONS(682), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10791] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(714), 1,
      sym__concat,
    ACTIONS(657), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10817] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(688), 1,
      sym__concat,
    ACTIONS(686), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10843] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(556), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [10869] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(700), 1,
      sym__concat,
    ACTIONS(698), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10895] = 10,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(458), 1,
      anon_sym_LPAREN,
    ACTIONS(466), 1,
      anon_sym_DOLLAR,
    ACTIONS(468), 1,
      anon_sym_LBRACE,
    ACTIONS(470), 1,
      anon_sym_DQUOTE,
    ACTIONS(472), 1,
      anon_sym_SQUOTE,
    ACTIONS(823), 1,
      sym_escape_sequence,
    STATE(509), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(185), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(821), 6,
      sym_integer,
      sym_float,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10935] = 10,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_LPAREN,
    ACTIONS(796), 1,
      anon_sym_DOLLAR,
    ACTIONS(798), 1,
      anon_sym_LBRACE,
    ACTIONS(800), 1,
      anon_sym_DQUOTE,
    ACTIONS(802), 1,
      anon_sym_SQUOTE,
    ACTIONS(827), 1,
      sym_escape_sequence,
    STATE(510), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(235), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(825), 6,
      sym_integer,
      sym_float,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [10975] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(704), 1,
      sym__concat,
    ACTIONS(702), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11001] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym__concat,
    ACTIONS(678), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11027] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(718), 1,
      sym__concat,
    ACTIONS(716), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11053] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(829), 1,
      sym__concat,
    STATE(166), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(657), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11081] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(692), 1,
      sym__concat,
    ACTIONS(690), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11107] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(696), 1,
      sym__concat,
    ACTIONS(694), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11133] = 10,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(778), 1,
      anon_sym_DOLLAR,
    ACTIONS(780), 1,
      anon_sym_LBRACE,
    ACTIONS(782), 1,
      anon_sym_DQUOTE,
    ACTIONS(784), 1,
      anon_sym_SQUOTE,
    ACTIONS(834), 1,
      sym_escape_sequence,
    STATE(494), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(421), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(832), 6,
      sym_integer,
      sym_float,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11173] = 10,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    ACTIONS(569), 1,
      anon_sym_DOLLAR,
    ACTIONS(571), 1,
      anon_sym_LBRACE,
    ACTIONS(573), 1,
      anon_sym_DQUOTE,
    ACTIONS(575), 1,
      anon_sym_SQUOTE,
    ACTIONS(838), 1,
      sym_escape_sequence,
    STATE(469), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(157), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(836), 6,
      sym_integer,
      sym_float,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11213] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(712), 1,
      sym__concat,
    ACTIONS(710), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11239] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(840), 1,
      sym__concat,
    STATE(166), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(674), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11267] = 10,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_DOLLAR,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(766), 1,
      anon_sym_DQUOTE,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(844), 1,
      sym_escape_sequence,
    STATE(489), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(398), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(842), 6,
      sym_integer,
      sym_float,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11307] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(840), 1,
      sym__concat,
    STATE(172), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(676), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11335] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(840), 1,
      sym__concat,
    STATE(172), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(662), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11363] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(672), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(670), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11389] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(668), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(666), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11415] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(708), 1,
      sym__concat,
    ACTIONS(706), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11441] = 10,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(511), 1,
      anon_sym_LPAREN,
    ACTIONS(521), 1,
      anon_sym_DOLLAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_DQUOTE,
    ACTIONS(527), 1,
      anon_sym_SQUOTE,
    ACTIONS(848), 1,
      sym_escape_sequence,
    STATE(511), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(326), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(846), 6,
      sym_integer,
      sym_float,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11481] = 10,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DOLLAR,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_SQUOTE,
    ACTIONS(852), 1,
      sym_escape_sequence,
    STATE(490), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(114), 5,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
    ACTIONS(850), 6,
      sym_integer,
      sym_float,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11521] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(704), 1,
      sym__concat,
    ACTIONS(702), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11546] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(700), 1,
      sym__concat,
    ACTIONS(698), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11571] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(688), 1,
      sym__concat,
    ACTIONS(686), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11596] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(718), 1,
      sym__concat,
    ACTIONS(716), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11621] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(714), 1,
      sym__concat,
    ACTIONS(657), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11646] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym__concat,
    ACTIONS(678), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11671] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(854), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11694] = 9,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LPAREN,
    ACTIONS(726), 1,
      anon_sym_DOLLAR,
    ACTIONS(728), 1,
      anon_sym_LBRACE,
    ACTIONS(734), 1,
      anon_sym_DQUOTE,
    ACTIONS(736), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(856), 5,
      sym_integer,
      sym_float,
      sym_escape_sequence,
      sym_glob,
      sym_brace_word,
    STATE(495), 6,
      sym_command_substitution,
      sym_variable_expansion,
      sym_brace_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
      sym__base_brace_expression,
  [11731] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(692), 1,
      sym__concat,
    ACTIONS(690), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11756] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(696), 1,
      sym__concat,
    ACTIONS(694), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11781] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(712), 1,
      sym__concat,
    ACTIONS(710), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11806] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(684), 1,
      sym__concat,
    ACTIONS(682), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11831] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(708), 1,
      sym__concat,
    ACTIONS(706), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
  [11856] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(858), 17,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_LPAREN,
      sym_integer,
      sym_float,
      anon_sym_DOLLAR,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_escape_sequence,
      sym__special_character,
      sym_home_dir_expansion,
      sym_glob,
      sym_word,
  [11879] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 1,
      sym__concat,
    ACTIONS(860), 1,
      sym__concat_list,
    STATE(195), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(556), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [11907] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(655), 1,
      sym__concat,
    ACTIONS(863), 1,
      sym__concat_list,
    STATE(195), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(653), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [11935] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(581), 1,
      sym__concat,
    ACTIONS(863), 1,
      sym__concat_list,
    STATE(196), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(579), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [11963] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(867), 3,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      sym_test_option,
    ACTIONS(865), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [11987] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(873), 1,
      anon_sym_RBRACK,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12028] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(883), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(226), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12069] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(885), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12110] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(887), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(207), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12151] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(889), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(220), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12192] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(891), 1,
      sym__concat,
    STATE(204), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(657), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [12217] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(894), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(201), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12258] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(896), 1,
      sym__concat,
    STATE(204), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(674), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [12283] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(898), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12324] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(896), 1,
      sym__concat,
    STATE(206), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(676), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [12349] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(896), 1,
      sym__concat,
    STATE(206), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(662), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [12374] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      sym_integer,
    ACTIONS(906), 1,
      anon_sym_RBRACK,
    ACTIONS(908), 1,
      anon_sym_DOLLAR,
    ACTIONS(911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(914), 1,
      anon_sym_DQUOTE,
    ACTIONS(917), 1,
      anon_sym_SQUOTE,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12415] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(920), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(215), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12456] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(922), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(213), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12497] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(924), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12538] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(926), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12579] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(928), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12620] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(930), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(199), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12661] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(932), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(214), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12702] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(934), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12743] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(936), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(218), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12784] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(938), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12825] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(940), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(225), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12866] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(556), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [12889] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(672), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(670), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [12912] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(668), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(666), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [12935] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(942), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [12976] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(877), 1,
      anon_sym_DOT_DOT,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    ACTIONS(944), 1,
      anon_sym_RBRACK,
    STATE(359), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(210), 2,
      sym_range,
      aux_sym_list_element_access_repeat1,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [13017] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(712), 1,
      sym__concat,
    ACTIONS(710), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13039] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(696), 1,
      sym__concat,
    ACTIONS(694), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13061] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(692), 1,
      sym__concat,
    ACTIONS(690), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13083] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(708), 1,
      sym__concat,
    ACTIONS(706), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13105] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(718), 1,
      sym__concat,
    ACTIONS(716), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13127] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(688), 1,
      sym__concat,
    ACTIONS(686), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13149] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(700), 1,
      sym__concat,
    ACTIONS(698), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13171] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(704), 1,
      sym__concat,
    ACTIONS(702), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13193] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(714), 1,
      sym__concat,
    ACTIONS(657), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13215] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym__concat,
    ACTIONS(678), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13237] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(684), 1,
      sym__concat,
    ACTIONS(682), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13259] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(948), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
    ACTIONS(946), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [13280] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    STATE(363), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(950), 2,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [13315] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(952), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13334] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      sym_integer,
    ACTIONS(875), 1,
      anon_sym_DOLLAR,
    ACTIONS(879), 1,
      anon_sym_DQUOTE,
    ACTIONS(881), 1,
      anon_sym_SQUOTE,
    STATE(365), 1,
      sym_index,
    STATE(519), 1,
      aux_sym_variable_expansion_repeat1,
    ACTIONS(954), 2,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
    STATE(358), 4,
      sym_command_substitution,
      sym_variable_expansion,
      sym_double_quote_string,
      sym_single_quote_string,
  [13369] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(956), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13388] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(958), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [13407] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(948), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
    ACTIONS(960), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [13428] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(948), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
    ACTIONS(962), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [13449] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(169), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13479] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(249), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13509] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(974), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13539] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(976), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13569] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(978), 6,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [13597] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(980), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13627] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(982), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13657] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(984), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13687] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(986), 6,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [13715] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13745] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(239), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13775] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(988), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13805] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13835] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(235), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13865] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(165), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13895] = 6,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(990), 8,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [13921] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(283), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13951] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [13981] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_RPAREN,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14011] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(994), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14041] = 8,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    ACTIONS(996), 1,
      anon_sym_RPAREN,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14071] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(998), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14095] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1000), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14112] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1002), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14129] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1000), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14146] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1004), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14163] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1000), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14180] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(962), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14197] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1006), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14214] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(1008), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14241] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(1010), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14268] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1012), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14285] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1014), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14302] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1016), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14319] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1018), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14336] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(972), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14363] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1012), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14380] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1020), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14397] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1012), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14414] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1000), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14431] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1022), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14448] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1012), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14465] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(1024), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14492] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1000), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14509] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1026), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14526] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1012), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14543] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1028), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14560] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(1030), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14587] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1032), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14604] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(1034), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14631] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1036), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14648] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1036), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14665] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1038), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14682] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(1040), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14709] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1042), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14726] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1044), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14743] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1042), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14760] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1046), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14777] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1036), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14794] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1036), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14811] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1042), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14828] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1036), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14845] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym_stream_redirect,
    ACTIONS(968), 1,
      sym_direction,
    ACTIONS(970), 1,
      anon_sym_PIPE,
    STATE(278), 1,
      sym_file_redirect,
    ACTIONS(964), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(1048), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [14872] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1050), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14889] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1042), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14906] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1042), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14923] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1052), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_stream_redirect,
      sym_direction,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
      anon_sym_RPAREN,
  [14940] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1054), 1,
      sym__concat_list,
    STATE(313), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(556), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(558), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [14962] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 1,
      sym__concat_list,
    STATE(313), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(653), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(655), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [14984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 1,
      sym__concat_list,
    STATE(314), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(579), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(581), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      sym__concat,
    STATE(325), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(676), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(1059), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      sym__concat,
    STATE(317), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(657), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(714), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(556), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(558), 6,
      sym__concat,
      sym__concat_list,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      sym__concat_list,
    STATE(320), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(581), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      sym__concat_list,
    STATE(324), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(655), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(670), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(672), 6,
      sym__concat,
      sym__concat_list,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      sym__concat,
    STATE(325), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(662), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(1068), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(668), 6,
      sym__concat,
      sym__concat_list,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      sym__concat_list,
    STATE(324), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(558), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      sym__concat,
    STATE(317), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(674), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(1073), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(714), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(686), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(688), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(718), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(706), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(708), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15262] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(581), 1,
      sym__concat,
    ACTIONS(1075), 1,
      sym__concat_list,
    STATE(342), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(579), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [15282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(668), 8,
      sym__concat_list,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(672), 8,
      sym__concat_list,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(700), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 8,
      sym__concat_list,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(678), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(680), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(702), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(704), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(690), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(692), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(694), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(696), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(712), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15420] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 1,
      sym__concat,
    ACTIONS(1077), 1,
      sym__concat_list,
    STATE(340), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(556), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [15440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 3,
      anon_sym_DASHa,
      anon_sym_DASHo,
      sym_test_option,
    ACTIONS(684), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15456] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(655), 1,
      sym__concat,
    ACTIONS(1075), 1,
      sym__concat_list,
    STATE(340), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(653), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [15476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15489] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1082), 1,
      anon_sym_DQUOTE,
    ACTIONS(1084), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1086), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(364), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(704), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15525] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1088), 1,
      anon_sym_DQUOTE,
    ACTIONS(1090), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1092), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(356), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(688), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 1,
      sym__concat_list,
    STATE(353), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(581), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [15578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15591] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1096), 1,
      anon_sym_DQUOTE,
    ACTIONS(1098), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1100), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(362), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(692), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 1,
      sym__concat_list,
    STATE(357), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(655), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [15657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(712), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15670] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1102), 1,
      anon_sym_DOLLAR,
    ACTIONS(1105), 1,
      anon_sym_DQUOTE,
    ACTIONS(1107), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1110), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15693] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1113), 1,
      anon_sym_DQUOTE,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      sym__concat_list,
    STATE(357), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(558), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [15733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1124), 6,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15761] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1128), 1,
      sym__concat,
    STATE(360), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(657), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [15778] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1131), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15801] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1133), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15837] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1135), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1137), 7,
      anon_sym_LPAREN,
      sym_integer,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [15873] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1139), 1,
      anon_sym_DQUOTE,
    ACTIONS(1141), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1143), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(367), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15896] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1145), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 1,
      sym_test_option,
    ACTIONS(865), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
    ACTIONS(1147), 2,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
    ACTIONS(1149), 2,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
  [15938] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1153), 1,
      sym__concat,
    STATE(373), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(662), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [15955] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1153), 1,
      sym__concat,
    STATE(373), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(676), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [15972] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1155), 1,
      anon_sym_DQUOTE,
    ACTIONS(1157), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1159), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(374), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [15995] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1161), 1,
      anon_sym_DQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1165), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(361), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16018] = 4,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1153), 1,
      sym__concat,
    STATE(360), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(674), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16035] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1167), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16058] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1169), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16081] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1171), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16104] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1117), 1,
      sym_escape_sequence,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(355), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16127] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(556), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16142] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(672), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(670), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16157] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1175), 1,
      anon_sym_DQUOTE,
    ACTIONS(1177), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1179), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(375), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16180] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1181), 1,
      anon_sym_DQUOTE,
    ACTIONS(1183), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1185), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(376), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16203] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(668), 2,
      sym__concat,
      sym__concat_list,
    ACTIONS(666), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16218] = 7,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_DOLLAR,
    ACTIONS(1187), 1,
      anon_sym_DQUOTE,
    ACTIONS(1189), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1191), 1,
      sym_escape_sequence,
    STATE(479), 1,
      aux_sym_variable_expansion_repeat1,
    STATE(377), 2,
      sym_variable_expansion,
      aux_sym_double_quote_string_repeat1,
  [16241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      sym__concat,
    STATE(387), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(1068), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16257] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(696), 1,
      sym__concat,
    ACTIONS(694), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16271] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(708), 1,
      sym__concat,
    ACTIONS(706), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      sym__concat,
    STATE(388), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(1073), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 1,
      sym__concat,
    STATE(388), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(714), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      sym__concat,
    STATE(387), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(1059), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16333] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(704), 1,
      sym__concat,
    ACTIONS(702), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 6,
      sym__concat,
      sym__concat_list,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(672), 6,
      sym__concat,
      sym__concat_list,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(668), 6,
      sym__concat,
      sym__concat_list,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16383] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1200), 1,
      anon_sym_if,
    ACTIONS(1198), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16397] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(692), 1,
      sym__concat,
    ACTIONS(690), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16411] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(680), 1,
      sym__concat,
    ACTIONS(678), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16425] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(581), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1202), 1,
      sym__concat_list,
    STATE(401), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(579), 3,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [16443] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(714), 1,
      sym__concat,
    ACTIONS(657), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16457] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1204), 1,
      sym__concat_list,
    STATE(399), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(556), 3,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [16475] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(718), 1,
      sym__concat,
    ACTIONS(716), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16489] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(655), 1,
      aux_sym_double_quote_string_token1,
    ACTIONS(1202), 1,
      sym__concat_list,
    STATE(399), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(653), 3,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [16507] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(688), 1,
      sym__concat,
    ACTIONS(686), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16521] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(700), 1,
      sym__concat,
    ACTIONS(698), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16535] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(712), 1,
      sym__concat,
    ACTIONS(710), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16549] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(684), 1,
      sym__concat,
    ACTIONS(682), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(704), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(680), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(692), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 1,
      sym__concat_list,
    STATE(410), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(558), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [16622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(712), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(684), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16644] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(558), 2,
      sym__concat_list,
      aux_sym_double_quote_string_token1,
    ACTIONS(556), 3,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [16657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(708), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16679] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(668), 2,
      sym__concat_list,
      aux_sym_double_quote_string_token1,
    ACTIONS(666), 3,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [16692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1210), 1,
      anon_sym_end,
    ACTIONS(1212), 1,
      anon_sym_else,
    STATE(551), 1,
      sym_else_clause,
    STATE(444), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
  [16709] = 3,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(672), 2,
      sym__concat_list,
      aux_sym_double_quote_string_token1,
    ACTIONS(670), 3,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [16722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(688), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(714), 5,
      sym__concat,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1214), 1,
      sym__concat_list,
    STATE(410), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(655), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [16770] = 2,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1216), 5,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LF,
      anon_sym_CR,
      anon_sym_CR_LF,
  [16781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1214), 1,
      sym__concat_list,
    STATE(422), 1,
      aux_sym_variable_expansion_repeat2,
    ACTIONS(581), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [16796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_else,
    ACTIONS(1218), 1,
      anon_sym_end,
    STATE(547), 1,
      sym_else_clause,
    STATE(444), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
  [16813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1222), 1,
      sym__brace_concat,
    STATE(426), 1,
      aux_sym_brace_concatenation_repeat1,
    ACTIONS(1220), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [16827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 4,
      sym__brace_concat,
      sym__concat_list,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [16837] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1225), 1,
      anon_sym_SQUOTE,
    ACTIONS(1227), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1229), 1,
      sym_escape_sequence,
    STATE(433), 1,
      aux_sym_single_quote_string_repeat1,
  [16853] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_SQUOTE,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [16869] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1241), 1,
      sym_escape_sequence,
    STATE(432), 1,
      aux_sym_single_quote_string_repeat1,
  [16885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      sym__brace_concat,
    STATE(437), 1,
      aux_sym_brace_concatenation_repeat1,
    ACTIONS(1243), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [16899] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1247), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [16915] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1249), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [16931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_end,
    ACTIONS(1253), 1,
      anon_sym_case,
    STATE(441), 2,
      sym_case_clause,
      aux_sym_switch_statement_repeat1,
  [16945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 2,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
    ACTIONS(1257), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [16967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      sym__brace_concat,
    STATE(426), 1,
      aux_sym_brace_concatenation_repeat1,
    ACTIONS(1261), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [16981] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1263), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [16997] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1265), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [17013] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1267), 1,
      anon_sym_SQUOTE,
    ACTIONS(1269), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1272), 1,
      sym_escape_sequence,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [17029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_case,
    ACTIONS(1275), 1,
      anon_sym_end,
    STATE(455), 2,
      sym_case_clause,
      aux_sym_switch_statement_repeat1,
  [17043] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1277), 1,
      anon_sym_SQUOTE,
    ACTIONS(1279), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1281), 1,
      sym_escape_sequence,
    STATE(450), 1,
      aux_sym_single_quote_string_repeat1,
  [17059] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1283), 1,
      anon_sym_SQUOTE,
    ACTIONS(1285), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1287), 1,
      sym_escape_sequence,
    STATE(438), 1,
      aux_sym_single_quote_string_repeat1,
  [17075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      anon_sym_end,
    ACTIONS(1291), 1,
      anon_sym_else,
    STATE(444), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
  [17089] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_SQUOTE,
    ACTIONS(1296), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1298), 1,
      sym_escape_sequence,
    STATE(439), 1,
      aux_sym_single_quote_string_repeat1,
  [17105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [17115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
    ACTIONS(1302), 2,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
  [17127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 4,
      aux_sym_test_command_token2,
      anon_sym_BSLASH_RPAREN,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [17137] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1306), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [17153] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1308), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [17169] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_SQUOTE,
    ACTIONS(1312), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1314), 1,
      sym_escape_sequence,
    STATE(449), 1,
      aux_sym_single_quote_string_repeat1,
  [17185] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1316), 1,
      anon_sym_SQUOTE,
    ACTIONS(1318), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1320), 1,
      sym_escape_sequence,
    STATE(456), 1,
      aux_sym_single_quote_string_repeat1,
  [17201] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1322), 1,
      anon_sym_SQUOTE,
    ACTIONS(1324), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1326), 1,
      sym_escape_sequence,
    STATE(429), 1,
      aux_sym_single_quote_string_repeat1,
  [17217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(668), 4,
      sym__brace_concat,
      sym__concat_list,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 1,
      anon_sym_end,
    ACTIONS(1330), 1,
      anon_sym_case,
    STATE(455), 2,
      sym_case_clause,
      aux_sym_switch_statement_repeat1,
  [17241] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1333), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [17257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(672), 4,
      sym__brace_concat,
      sym__concat_list,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17267] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1235), 1,
      sym_escape_sequence,
    ACTIONS(1335), 1,
      anon_sym_SQUOTE,
    STATE(440), 1,
      aux_sym_single_quote_string_repeat1,
  [17283] = 5,
    ACTIONS(37), 1,
      sym_comment,
    ACTIONS(1337), 1,
      anon_sym_SQUOTE,
    ACTIONS(1339), 1,
      aux_sym_single_quote_string_token1,
    ACTIONS(1341), 1,
      sym_escape_sequence,
    STATE(458), 1,
      aux_sym_single_quote_string_repeat1,
  [17299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1345), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1347), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(504), 1,
      aux_sym_brace_expansion_repeat1,
  [17338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1351), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1353), 1,
      anon_sym_BSLASH_RPAREN,
    ACTIONS(1257), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [17362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(704), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 1,
      sym_variable_name,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1363), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1365), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(708), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1369), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1371), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(684), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(712), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1373), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(692), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(680), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(688), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1377), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(460), 1,
      aux_sym_brace_expansion_repeat1,
  [17628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1379), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(475), 1,
      aux_sym_brace_expansion_repeat1,
  [17667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      aux_sym_test_command_token2,
    ACTIONS(1257), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [17678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1385), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1220), 3,
      sym__brace_concat,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [17711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1387), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1389), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1393), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(463), 1,
      aux_sym_brace_expansion_repeat1,
  [17785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1395), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1397), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1399), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1401), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1403), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(522), 1,
      aux_sym_brace_expansion_repeat1,
  [17874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1405), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1407), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1409), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [17913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1391), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 1,
      anon_sym_RBRACE,
    ACTIONS(1357), 2,
      sym__brace_concat,
      anon_sym_COMMA,
  [17937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1411), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    ACTIONS(1413), 1,
      anon_sym_COMMA,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(503), 1,
      aux_sym_brace_expansion_repeat1,
  [17976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1416), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [17989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [18002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 1,
      anon_sym_DOLLAR,
    ACTIONS(1420), 1,
      sym_variable_name,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [18015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 1,
      sym_variable_name,
    ACTIONS(1424), 1,
      anon_sym_DOLLAR,
    STATE(520), 1,
      aux_sym_variable_expansion_repeat1,
  [18028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(496), 1,
      aux_sym_brace_expansion_repeat1,
  [18041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1427), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [18054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1429), 1,
      anon_sym_BSLASH_RPAREN,
    ACTIONS(1257), 2,
      anon_sym_DASHa,
      anon_sym_DASHo,
  [18065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1431), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      aux_sym_brace_expansion_repeat1,
  [18078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(507), 1,
      aux_sym_brace_expansion_repeat1,
  [18091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(505), 1,
      aux_sym_brace_expansion_repeat1,
  [18101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(473), 1,
      aux_sym_brace_expansion_repeat1,
  [18111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(500), 1,
      aux_sym_brace_expansion_repeat1,
  [18121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      anon_sym_LBRACK,
    STATE(334), 1,
      sym_list_element_access,
  [18131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(517), 1,
      aux_sym_brace_expansion_repeat1,
  [18141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 1,
      anon_sym_LBRACK,
    STATE(222), 1,
      sym_list_element_access,
  [18151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    STATE(159), 1,
      sym_list_element_access,
  [18161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_LBRACK,
    STATE(99), 1,
      sym_list_element_access,
  [18171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(524), 1,
      aux_sym_brace_expansion_repeat1,
  [18181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [18189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(518), 1,
      aux_sym_brace_expansion_repeat1,
  [18199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 1,
      anon_sym_LBRACK,
    STATE(391), 1,
      sym_list_element_access,
  [18209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1443), 1,
      anon_sym_LBRACK,
    STATE(378), 1,
      sym_list_element_access,
  [18219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(502), 1,
      aux_sym_brace_expansion_repeat1,
  [18229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LBRACK,
    STATE(318), 1,
      sym_list_element_access,
  [18239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 1,
      anon_sym_LBRACK,
    STATE(427), 1,
      sym_list_element_access,
  [18249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_LBRACK,
    STATE(151), 1,
      sym_list_element_access,
  [18259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 1,
      anon_sym_LBRACK,
    STATE(413), 1,
      sym_list_element_access,
  [18269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(487), 1,
      aux_sym_brace_expansion_repeat1,
  [18279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1453), 1,
      anon_sym_if,
  [18286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1455), 1,
      anon_sym_in,
  [18293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_end,
  [18300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      ts_builtin_sym_end,
  [18307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      sym_variable_name,
  [18314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1210), 1,
      anon_sym_end,
  [18321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(4)] = 0,
  [SMALL_STATE(5)] = 113,
  [SMALL_STATE(6)] = 226,
  [SMALL_STATE(7)] = 339,
  [SMALL_STATE(8)] = 451,
  [SMALL_STATE(9)] = 563,
  [SMALL_STATE(10)] = 675,
  [SMALL_STATE(11)] = 787,
  [SMALL_STATE(12)] = 899,
  [SMALL_STATE(13)] = 1011,
  [SMALL_STATE(14)] = 1123,
  [SMALL_STATE(15)] = 1234,
  [SMALL_STATE(16)] = 1345,
  [SMALL_STATE(17)] = 1456,
  [SMALL_STATE(18)] = 1567,
  [SMALL_STATE(19)] = 1678,
  [SMALL_STATE(20)] = 1789,
  [SMALL_STATE(21)] = 1900,
  [SMALL_STATE(22)] = 2011,
  [SMALL_STATE(23)] = 2122,
  [SMALL_STATE(24)] = 2233,
  [SMALL_STATE(25)] = 2344,
  [SMALL_STATE(26)] = 2455,
  [SMALL_STATE(27)] = 2566,
  [SMALL_STATE(28)] = 2677,
  [SMALL_STATE(29)] = 2788,
  [SMALL_STATE(30)] = 2899,
  [SMALL_STATE(31)] = 3010,
  [SMALL_STATE(32)] = 3121,
  [SMALL_STATE(33)] = 3232,
  [SMALL_STATE(34)] = 3343,
  [SMALL_STATE(35)] = 3454,
  [SMALL_STATE(36)] = 3562,
  [SMALL_STATE(37)] = 3670,
  [SMALL_STATE(38)] = 3778,
  [SMALL_STATE(39)] = 3885,
  [SMALL_STATE(40)] = 3992,
  [SMALL_STATE(41)] = 4099,
  [SMALL_STATE(42)] = 4206,
  [SMALL_STATE(43)] = 4313,
  [SMALL_STATE(44)] = 4420,
  [SMALL_STATE(45)] = 4527,
  [SMALL_STATE(46)] = 4634,
  [SMALL_STATE(47)] = 4741,
  [SMALL_STATE(48)] = 4848,
  [SMALL_STATE(49)] = 4955,
  [SMALL_STATE(50)] = 5062,
  [SMALL_STATE(51)] = 5169,
  [SMALL_STATE(52)] = 5276,
  [SMALL_STATE(53)] = 5383,
  [SMALL_STATE(54)] = 5490,
  [SMALL_STATE(55)] = 5597,
  [SMALL_STATE(56)] = 5704,
  [SMALL_STATE(57)] = 5811,
  [SMALL_STATE(58)] = 5918,
  [SMALL_STATE(59)] = 6025,
  [SMALL_STATE(60)] = 6132,
  [SMALL_STATE(61)] = 6239,
  [SMALL_STATE(62)] = 6342,
  [SMALL_STATE(63)] = 6445,
  [SMALL_STATE(64)] = 6548,
  [SMALL_STATE(65)] = 6648,
  [SMALL_STATE(66)] = 6748,
  [SMALL_STATE(67)] = 6848,
  [SMALL_STATE(68)] = 6948,
  [SMALL_STATE(69)] = 7022,
  [SMALL_STATE(70)] = 7062,
  [SMALL_STATE(71)] = 7102,
  [SMALL_STATE(72)] = 7143,
  [SMALL_STATE(73)] = 7182,
  [SMALL_STATE(74)] = 7221,
  [SMALL_STATE(75)] = 7260,
  [SMALL_STATE(76)] = 7320,
  [SMALL_STATE(77)] = 7380,
  [SMALL_STATE(78)] = 7440,
  [SMALL_STATE(79)] = 7497,
  [SMALL_STATE(80)] = 7561,
  [SMALL_STATE(81)] = 7598,
  [SMALL_STATE(82)] = 7659,
  [SMALL_STATE(83)] = 7720,
  [SMALL_STATE(84)] = 7781,
  [SMALL_STATE(85)] = 7842,
  [SMALL_STATE(86)] = 7903,
  [SMALL_STATE(87)] = 7964,
  [SMALL_STATE(88)] = 8000,
  [SMALL_STATE(89)] = 8054,
  [SMALL_STATE(90)] = 8092,
  [SMALL_STATE(91)] = 8146,
  [SMALL_STATE(92)] = 8184,
  [SMALL_STATE(93)] = 8246,
  [SMALL_STATE(94)] = 8298,
  [SMALL_STATE(95)] = 8352,
  [SMALL_STATE(96)] = 8414,
  [SMALL_STATE(97)] = 8466,
  [SMALL_STATE(98)] = 8504,
  [SMALL_STATE(99)] = 8539,
  [SMALL_STATE(100)] = 8572,
  [SMALL_STATE(101)] = 8607,
  [SMALL_STATE(102)] = 8640,
  [SMALL_STATE(103)] = 8673,
  [SMALL_STATE(104)] = 8708,
  [SMALL_STATE(105)] = 8743,
  [SMALL_STATE(106)] = 8775,
  [SMALL_STATE(107)] = 8807,
  [SMALL_STATE(108)] = 8839,
  [SMALL_STATE(109)] = 8871,
  [SMALL_STATE(110)] = 8903,
  [SMALL_STATE(111)] = 8935,
  [SMALL_STATE(112)] = 8967,
  [SMALL_STATE(113)] = 8999,
  [SMALL_STATE(114)] = 9031,
  [SMALL_STATE(115)] = 9063,
  [SMALL_STATE(116)] = 9095,
  [SMALL_STATE(117)] = 9124,
  [SMALL_STATE(118)] = 9174,
  [SMALL_STATE(119)] = 9224,
  [SMALL_STATE(120)] = 9274,
  [SMALL_STATE(121)] = 9324,
  [SMALL_STATE(122)] = 9374,
  [SMALL_STATE(123)] = 9424,
  [SMALL_STATE(124)] = 9474,
  [SMALL_STATE(125)] = 9524,
  [SMALL_STATE(126)] = 9573,
  [SMALL_STATE(127)] = 9620,
  [SMALL_STATE(128)] = 9669,
  [SMALL_STATE(129)] = 9718,
  [SMALL_STATE(130)] = 9767,
  [SMALL_STATE(131)] = 9812,
  [SMALL_STATE(132)] = 9861,
  [SMALL_STATE(133)] = 9910,
  [SMALL_STATE(134)] = 9959,
  [SMALL_STATE(135)] = 10008,
  [SMALL_STATE(136)] = 10057,
  [SMALL_STATE(137)] = 10089,
  [SMALL_STATE(138)] = 10135,
  [SMALL_STATE(139)] = 10181,
  [SMALL_STATE(140)] = 10227,
  [SMALL_STATE(141)] = 10259,
  [SMALL_STATE(142)] = 10305,
  [SMALL_STATE(143)] = 10351,
  [SMALL_STATE(144)] = 10383,
  [SMALL_STATE(145)] = 10429,
  [SMALL_STATE(146)] = 10475,
  [SMALL_STATE(147)] = 10506,
  [SMALL_STATE(148)] = 10535,
  [SMALL_STATE(149)] = 10564,
  [SMALL_STATE(150)] = 10593,
  [SMALL_STATE(151)] = 10622,
  [SMALL_STATE(152)] = 10649,
  [SMALL_STATE(153)] = 10676,
  [SMALL_STATE(154)] = 10703,
  [SMALL_STATE(155)] = 10734,
  [SMALL_STATE(156)] = 10765,
  [SMALL_STATE(157)] = 10791,
  [SMALL_STATE(158)] = 10817,
  [SMALL_STATE(159)] = 10843,
  [SMALL_STATE(160)] = 10869,
  [SMALL_STATE(161)] = 10895,
  [SMALL_STATE(162)] = 10935,
  [SMALL_STATE(163)] = 10975,
  [SMALL_STATE(164)] = 11001,
  [SMALL_STATE(165)] = 11027,
  [SMALL_STATE(166)] = 11053,
  [SMALL_STATE(167)] = 11081,
  [SMALL_STATE(168)] = 11107,
  [SMALL_STATE(169)] = 11133,
  [SMALL_STATE(170)] = 11173,
  [SMALL_STATE(171)] = 11213,
  [SMALL_STATE(172)] = 11239,
  [SMALL_STATE(173)] = 11267,
  [SMALL_STATE(174)] = 11307,
  [SMALL_STATE(175)] = 11335,
  [SMALL_STATE(176)] = 11363,
  [SMALL_STATE(177)] = 11389,
  [SMALL_STATE(178)] = 11415,
  [SMALL_STATE(179)] = 11441,
  [SMALL_STATE(180)] = 11481,
  [SMALL_STATE(181)] = 11521,
  [SMALL_STATE(182)] = 11546,
  [SMALL_STATE(183)] = 11571,
  [SMALL_STATE(184)] = 11596,
  [SMALL_STATE(185)] = 11621,
  [SMALL_STATE(186)] = 11646,
  [SMALL_STATE(187)] = 11671,
  [SMALL_STATE(188)] = 11694,
  [SMALL_STATE(189)] = 11731,
  [SMALL_STATE(190)] = 11756,
  [SMALL_STATE(191)] = 11781,
  [SMALL_STATE(192)] = 11806,
  [SMALL_STATE(193)] = 11831,
  [SMALL_STATE(194)] = 11856,
  [SMALL_STATE(195)] = 11879,
  [SMALL_STATE(196)] = 11907,
  [SMALL_STATE(197)] = 11935,
  [SMALL_STATE(198)] = 11963,
  [SMALL_STATE(199)] = 11987,
  [SMALL_STATE(200)] = 12028,
  [SMALL_STATE(201)] = 12069,
  [SMALL_STATE(202)] = 12110,
  [SMALL_STATE(203)] = 12151,
  [SMALL_STATE(204)] = 12192,
  [SMALL_STATE(205)] = 12217,
  [SMALL_STATE(206)] = 12258,
  [SMALL_STATE(207)] = 12283,
  [SMALL_STATE(208)] = 12324,
  [SMALL_STATE(209)] = 12349,
  [SMALL_STATE(210)] = 12374,
  [SMALL_STATE(211)] = 12415,
  [SMALL_STATE(212)] = 12456,
  [SMALL_STATE(213)] = 12497,
  [SMALL_STATE(214)] = 12538,
  [SMALL_STATE(215)] = 12579,
  [SMALL_STATE(216)] = 12620,
  [SMALL_STATE(217)] = 12661,
  [SMALL_STATE(218)] = 12702,
  [SMALL_STATE(219)] = 12743,
  [SMALL_STATE(220)] = 12784,
  [SMALL_STATE(221)] = 12825,
  [SMALL_STATE(222)] = 12866,
  [SMALL_STATE(223)] = 12889,
  [SMALL_STATE(224)] = 12912,
  [SMALL_STATE(225)] = 12935,
  [SMALL_STATE(226)] = 12976,
  [SMALL_STATE(227)] = 13017,
  [SMALL_STATE(228)] = 13039,
  [SMALL_STATE(229)] = 13061,
  [SMALL_STATE(230)] = 13083,
  [SMALL_STATE(231)] = 13105,
  [SMALL_STATE(232)] = 13127,
  [SMALL_STATE(233)] = 13149,
  [SMALL_STATE(234)] = 13171,
  [SMALL_STATE(235)] = 13193,
  [SMALL_STATE(236)] = 13215,
  [SMALL_STATE(237)] = 13237,
  [SMALL_STATE(238)] = 13259,
  [SMALL_STATE(239)] = 13280,
  [SMALL_STATE(240)] = 13315,
  [SMALL_STATE(241)] = 13334,
  [SMALL_STATE(242)] = 13369,
  [SMALL_STATE(243)] = 13388,
  [SMALL_STATE(244)] = 13407,
  [SMALL_STATE(245)] = 13428,
  [SMALL_STATE(246)] = 13449,
  [SMALL_STATE(247)] = 13479,
  [SMALL_STATE(248)] = 13509,
  [SMALL_STATE(249)] = 13539,
  [SMALL_STATE(250)] = 13569,
  [SMALL_STATE(251)] = 13597,
  [SMALL_STATE(252)] = 13627,
  [SMALL_STATE(253)] = 13657,
  [SMALL_STATE(254)] = 13687,
  [SMALL_STATE(255)] = 13715,
  [SMALL_STATE(256)] = 13745,
  [SMALL_STATE(257)] = 13775,
  [SMALL_STATE(258)] = 13805,
  [SMALL_STATE(259)] = 13835,
  [SMALL_STATE(260)] = 13865,
  [SMALL_STATE(261)] = 13895,
  [SMALL_STATE(262)] = 13921,
  [SMALL_STATE(263)] = 13951,
  [SMALL_STATE(264)] = 13981,
  [SMALL_STATE(265)] = 14011,
  [SMALL_STATE(266)] = 14041,
  [SMALL_STATE(267)] = 14071,
  [SMALL_STATE(268)] = 14095,
  [SMALL_STATE(269)] = 14112,
  [SMALL_STATE(270)] = 14129,
  [SMALL_STATE(271)] = 14146,
  [SMALL_STATE(272)] = 14163,
  [SMALL_STATE(273)] = 14180,
  [SMALL_STATE(274)] = 14197,
  [SMALL_STATE(275)] = 14214,
  [SMALL_STATE(276)] = 14241,
  [SMALL_STATE(277)] = 14268,
  [SMALL_STATE(278)] = 14285,
  [SMALL_STATE(279)] = 14302,
  [SMALL_STATE(280)] = 14319,
  [SMALL_STATE(281)] = 14336,
  [SMALL_STATE(282)] = 14363,
  [SMALL_STATE(283)] = 14380,
  [SMALL_STATE(284)] = 14397,
  [SMALL_STATE(285)] = 14414,
  [SMALL_STATE(286)] = 14431,
  [SMALL_STATE(287)] = 14448,
  [SMALL_STATE(288)] = 14465,
  [SMALL_STATE(289)] = 14492,
  [SMALL_STATE(290)] = 14509,
  [SMALL_STATE(291)] = 14526,
  [SMALL_STATE(292)] = 14543,
  [SMALL_STATE(293)] = 14560,
  [SMALL_STATE(294)] = 14587,
  [SMALL_STATE(295)] = 14604,
  [SMALL_STATE(296)] = 14631,
  [SMALL_STATE(297)] = 14648,
  [SMALL_STATE(298)] = 14665,
  [SMALL_STATE(299)] = 14682,
  [SMALL_STATE(300)] = 14709,
  [SMALL_STATE(301)] = 14726,
  [SMALL_STATE(302)] = 14743,
  [SMALL_STATE(303)] = 14760,
  [SMALL_STATE(304)] = 14777,
  [SMALL_STATE(305)] = 14794,
  [SMALL_STATE(306)] = 14811,
  [SMALL_STATE(307)] = 14828,
  [SMALL_STATE(308)] = 14845,
  [SMALL_STATE(309)] = 14872,
  [SMALL_STATE(310)] = 14889,
  [SMALL_STATE(311)] = 14906,
  [SMALL_STATE(312)] = 14923,
  [SMALL_STATE(313)] = 14940,
  [SMALL_STATE(314)] = 14962,
  [SMALL_STATE(315)] = 14984,
  [SMALL_STATE(316)] = 15006,
  [SMALL_STATE(317)] = 15027,
  [SMALL_STATE(318)] = 15048,
  [SMALL_STATE(319)] = 15065,
  [SMALL_STATE(320)] = 15084,
  [SMALL_STATE(321)] = 15103,
  [SMALL_STATE(322)] = 15120,
  [SMALL_STATE(323)] = 15141,
  [SMALL_STATE(324)] = 15158,
  [SMALL_STATE(325)] = 15177,
  [SMALL_STATE(326)] = 15198,
  [SMALL_STATE(327)] = 15214,
  [SMALL_STATE(328)] = 15230,
  [SMALL_STATE(329)] = 15246,
  [SMALL_STATE(330)] = 15262,
  [SMALL_STATE(331)] = 15282,
  [SMALL_STATE(332)] = 15296,
  [SMALL_STATE(333)] = 15310,
  [SMALL_STATE(334)] = 15326,
  [SMALL_STATE(335)] = 15340,
  [SMALL_STATE(336)] = 15356,
  [SMALL_STATE(337)] = 15372,
  [SMALL_STATE(338)] = 15388,
  [SMALL_STATE(339)] = 15404,
  [SMALL_STATE(340)] = 15420,
  [SMALL_STATE(341)] = 15440,
  [SMALL_STATE(342)] = 15456,
  [SMALL_STATE(343)] = 15476,
  [SMALL_STATE(344)] = 15489,
  [SMALL_STATE(345)] = 15512,
  [SMALL_STATE(346)] = 15525,
  [SMALL_STATE(347)] = 15548,
  [SMALL_STATE(348)] = 15561,
  [SMALL_STATE(349)] = 15578,
  [SMALL_STATE(350)] = 15591,
  [SMALL_STATE(351)] = 15614,
  [SMALL_STATE(352)] = 15627,
  [SMALL_STATE(353)] = 15640,
  [SMALL_STATE(354)] = 15657,
  [SMALL_STATE(355)] = 15670,
  [SMALL_STATE(356)] = 15693,
  [SMALL_STATE(357)] = 15716,
  [SMALL_STATE(358)] = 15733,
  [SMALL_STATE(359)] = 15746,
  [SMALL_STATE(360)] = 15761,
  [SMALL_STATE(361)] = 15778,
  [SMALL_STATE(362)] = 15801,
  [SMALL_STATE(363)] = 15824,
  [SMALL_STATE(364)] = 15837,
  [SMALL_STATE(365)] = 15860,
  [SMALL_STATE(366)] = 15873,
  [SMALL_STATE(367)] = 15896,
  [SMALL_STATE(368)] = 15919,
  [SMALL_STATE(369)] = 15938,
  [SMALL_STATE(370)] = 15955,
  [SMALL_STATE(371)] = 15972,
  [SMALL_STATE(372)] = 15995,
  [SMALL_STATE(373)] = 16018,
  [SMALL_STATE(374)] = 16035,
  [SMALL_STATE(375)] = 16058,
  [SMALL_STATE(376)] = 16081,
  [SMALL_STATE(377)] = 16104,
  [SMALL_STATE(378)] = 16127,
  [SMALL_STATE(379)] = 16142,
  [SMALL_STATE(380)] = 16157,
  [SMALL_STATE(381)] = 16180,
  [SMALL_STATE(382)] = 16203,
  [SMALL_STATE(383)] = 16218,
  [SMALL_STATE(384)] = 16241,
  [SMALL_STATE(385)] = 16257,
  [SMALL_STATE(386)] = 16271,
  [SMALL_STATE(387)] = 16285,
  [SMALL_STATE(388)] = 16301,
  [SMALL_STATE(389)] = 16317,
  [SMALL_STATE(390)] = 16333,
  [SMALL_STATE(391)] = 16347,
  [SMALL_STATE(392)] = 16359,
  [SMALL_STATE(393)] = 16371,
  [SMALL_STATE(394)] = 16383,
  [SMALL_STATE(395)] = 16397,
  [SMALL_STATE(396)] = 16411,
  [SMALL_STATE(397)] = 16425,
  [SMALL_STATE(398)] = 16443,
  [SMALL_STATE(399)] = 16457,
  [SMALL_STATE(400)] = 16475,
  [SMALL_STATE(401)] = 16489,
  [SMALL_STATE(402)] = 16507,
  [SMALL_STATE(403)] = 16521,
  [SMALL_STATE(404)] = 16535,
  [SMALL_STATE(405)] = 16549,
  [SMALL_STATE(406)] = 16563,
  [SMALL_STATE(407)] = 16574,
  [SMALL_STATE(408)] = 16585,
  [SMALL_STATE(409)] = 16596,
  [SMALL_STATE(410)] = 16607,
  [SMALL_STATE(411)] = 16622,
  [SMALL_STATE(412)] = 16633,
  [SMALL_STATE(413)] = 16644,
  [SMALL_STATE(414)] = 16657,
  [SMALL_STATE(415)] = 16668,
  [SMALL_STATE(416)] = 16679,
  [SMALL_STATE(417)] = 16692,
  [SMALL_STATE(418)] = 16709,
  [SMALL_STATE(419)] = 16722,
  [SMALL_STATE(420)] = 16733,
  [SMALL_STATE(421)] = 16744,
  [SMALL_STATE(422)] = 16755,
  [SMALL_STATE(423)] = 16770,
  [SMALL_STATE(424)] = 16781,
  [SMALL_STATE(425)] = 16796,
  [SMALL_STATE(426)] = 16813,
  [SMALL_STATE(427)] = 16827,
  [SMALL_STATE(428)] = 16837,
  [SMALL_STATE(429)] = 16853,
  [SMALL_STATE(430)] = 16869,
  [SMALL_STATE(431)] = 16885,
  [SMALL_STATE(432)] = 16899,
  [SMALL_STATE(433)] = 16915,
  [SMALL_STATE(434)] = 16931,
  [SMALL_STATE(435)] = 16945,
  [SMALL_STATE(436)] = 16957,
  [SMALL_STATE(437)] = 16967,
  [SMALL_STATE(438)] = 16981,
  [SMALL_STATE(439)] = 16997,
  [SMALL_STATE(440)] = 17013,
  [SMALL_STATE(441)] = 17029,
  [SMALL_STATE(442)] = 17043,
  [SMALL_STATE(443)] = 17059,
  [SMALL_STATE(444)] = 17075,
  [SMALL_STATE(445)] = 17089,
  [SMALL_STATE(446)] = 17105,
  [SMALL_STATE(447)] = 17115,
  [SMALL_STATE(448)] = 17127,
  [SMALL_STATE(449)] = 17137,
  [SMALL_STATE(450)] = 17153,
  [SMALL_STATE(451)] = 17169,
  [SMALL_STATE(452)] = 17185,
  [SMALL_STATE(453)] = 17201,
  [SMALL_STATE(454)] = 17217,
  [SMALL_STATE(455)] = 17227,
  [SMALL_STATE(456)] = 17241,
  [SMALL_STATE(457)] = 17257,
  [SMALL_STATE(458)] = 17267,
  [SMALL_STATE(459)] = 17283,
  [SMALL_STATE(460)] = 17299,
  [SMALL_STATE(461)] = 17312,
  [SMALL_STATE(462)] = 17325,
  [SMALL_STATE(463)] = 17338,
  [SMALL_STATE(464)] = 17351,
  [SMALL_STATE(465)] = 17362,
  [SMALL_STATE(466)] = 17371,
  [SMALL_STATE(467)] = 17384,
  [SMALL_STATE(468)] = 17395,
  [SMALL_STATE(469)] = 17408,
  [SMALL_STATE(470)] = 17421,
  [SMALL_STATE(471)] = 17432,
  [SMALL_STATE(472)] = 17445,
  [SMALL_STATE(473)] = 17454,
  [SMALL_STATE(474)] = 17467,
  [SMALL_STATE(475)] = 17480,
  [SMALL_STATE(476)] = 17493,
  [SMALL_STATE(477)] = 17502,
  [SMALL_STATE(478)] = 17511,
  [SMALL_STATE(479)] = 17520,
  [SMALL_STATE(480)] = 17533,
  [SMALL_STATE(481)] = 17542,
  [SMALL_STATE(482)] = 17551,
  [SMALL_STATE(483)] = 17560,
  [SMALL_STATE(484)] = 17571,
  [SMALL_STATE(485)] = 17584,
  [SMALL_STATE(486)] = 17593,
  [SMALL_STATE(487)] = 17602,
  [SMALL_STATE(488)] = 17615,
  [SMALL_STATE(489)] = 17628,
  [SMALL_STATE(490)] = 17641,
  [SMALL_STATE(491)] = 17654,
  [SMALL_STATE(492)] = 17667,
  [SMALL_STATE(493)] = 17678,
  [SMALL_STATE(494)] = 17689,
  [SMALL_STATE(495)] = 17702,
  [SMALL_STATE(496)] = 17711,
  [SMALL_STATE(497)] = 17724,
  [SMALL_STATE(498)] = 17735,
  [SMALL_STATE(499)] = 17748,
  [SMALL_STATE(500)] = 17759,
  [SMALL_STATE(501)] = 17772,
  [SMALL_STATE(502)] = 17785,
  [SMALL_STATE(503)] = 17798,
  [SMALL_STATE(504)] = 17811,
  [SMALL_STATE(505)] = 17824,
  [SMALL_STATE(506)] = 17837,
  [SMALL_STATE(507)] = 17848,
  [SMALL_STATE(508)] = 17861,
  [SMALL_STATE(509)] = 17874,
  [SMALL_STATE(510)] = 17887,
  [SMALL_STATE(511)] = 17900,
  [SMALL_STATE(512)] = 17913,
  [SMALL_STATE(513)] = 17926,
  [SMALL_STATE(514)] = 17937,
  [SMALL_STATE(515)] = 17950,
  [SMALL_STATE(516)] = 17963,
  [SMALL_STATE(517)] = 17976,
  [SMALL_STATE(518)] = 17989,
  [SMALL_STATE(519)] = 18002,
  [SMALL_STATE(520)] = 18015,
  [SMALL_STATE(521)] = 18028,
  [SMALL_STATE(522)] = 18041,
  [SMALL_STATE(523)] = 18054,
  [SMALL_STATE(524)] = 18065,
  [SMALL_STATE(525)] = 18078,
  [SMALL_STATE(526)] = 18091,
  [SMALL_STATE(527)] = 18101,
  [SMALL_STATE(528)] = 18111,
  [SMALL_STATE(529)] = 18121,
  [SMALL_STATE(530)] = 18131,
  [SMALL_STATE(531)] = 18141,
  [SMALL_STATE(532)] = 18151,
  [SMALL_STATE(533)] = 18161,
  [SMALL_STATE(534)] = 18171,
  [SMALL_STATE(535)] = 18181,
  [SMALL_STATE(536)] = 18189,
  [SMALL_STATE(537)] = 18199,
  [SMALL_STATE(538)] = 18209,
  [SMALL_STATE(539)] = 18219,
  [SMALL_STATE(540)] = 18229,
  [SMALL_STATE(541)] = 18239,
  [SMALL_STATE(542)] = 18249,
  [SMALL_STATE(543)] = 18259,
  [SMALL_STATE(544)] = 18269,
  [SMALL_STATE(545)] = 18279,
  [SMALL_STATE(546)] = 18286,
  [SMALL_STATE(547)] = 18293,
  [SMALL_STATE(548)] = 18300,
  [SMALL_STATE(549)] = 18307,
  [SMALL_STATE(550)] = 18314,
  [SMALL_STATE(551)] = 18321,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [63] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause, 3, .production_id = 15),
  [65] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(67),
  [68] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(5),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(64),
  [74] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(14),
  [77] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(137),
  [80] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [82] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(100),
  [85] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(78),
  [88] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(138),
  [91] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(275),
  [94] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(549),
  [97] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(62),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(63),
  [103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(8),
  [106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(79),
  [109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(68),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(490),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(131),
  [118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(366),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(430),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(104),
  [127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause, 4, .production_id = 15),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(12),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(299),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(67),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(64),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(137),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(100),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(78),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(138),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(281),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(549),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(62),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(63),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(79),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(68),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(490),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(131),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(366),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(430),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(104),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(288),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(67),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(64),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(14),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(137),
  [335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(100),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(78),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(138),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(293),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(549),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(62),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(63),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(8),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(79),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(68),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(490),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(131),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(366),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(430),
  [379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(100),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(104),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause, 4),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause, 3),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat2, 2), SHIFT_REPEAT(295),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_command, 1),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__terminated_statement, 2),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__terminated_opt_statement, 2),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 2, .production_id = 4),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8),
  [484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8), SHIFT_REPEAT(14),
  [487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8), SHIFT_REPEAT(100),
  [490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8), SHIFT_REPEAT(490),
  [493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8), SHIFT_REPEAT(131),
  [496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8), SHIFT_REPEAT(366),
  [499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8), SHIFT_REPEAT(430),
  [502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 8), SHIFT_REPEAT(104),
  [505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 1, .production_id = 2),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 1),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__terminated_statement, 2),
  [533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14), SHIFT_REPEAT(32),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14), SHIFT_REPEAT(149),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14), SHIFT_REPEAT(469),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14), SHIFT_REPEAT(129),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14), SHIFT_REPEAT(381),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14), SHIFT_REPEAT(453),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 14), SHIFT_REPEAT(148),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_expansion_repeat2, 2),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2),
  [560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(533),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_expansion, 2),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_expansion, 2),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10), SHIFT_REPEAT(32),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10), SHIFT_REPEAT(149),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10), SHIFT_REPEAT(469),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10), SHIFT_REPEAT(129),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10), SHIFT_REPEAT(381),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10), SHIFT_REPEAT(453),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, .production_id = 10), SHIFT_REPEAT(148),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2),
  [632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(32),
  [635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(149),
  [638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(469),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(129),
  [644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(381),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(453),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(148),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_expansion, 3),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_expansion, 3),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(180),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_element_access, 3),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_element_access, 3),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_element_access, 2),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_element_access, 2),
  [674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 2),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_expansion, 3),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_expansion, 3),
  [682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_expansion, 4),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_expansion, 4),
  [686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quote_string, 2),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quote_string, 2),
  [690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quote_string, 3),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quote_string, 3),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quote_string, 3),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quote_string, 3),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quote_string, 2),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quote_string, 2),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_substitution, 2),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_substitution, 2),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_expansion, 5),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_expansion, 5),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_substitution, 4),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_substitution, 4),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_substitution, 3),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_substitution, 3),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 1, .production_id = 3),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_brace_expansion_repeat1, 1),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(542),
  [811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(532),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(170),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(161),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 1, .production_id = 12),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 1, .production_id = 5),
  [860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(531),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__test_expression, 1),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(162),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 2), SHIFT_REPEAT(20),
  [903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 2), SHIFT_REPEAT(358),
  [906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 2),
  [908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 2), SHIFT_REPEAT(519),
  [911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 2), SHIFT_REPEAT(239),
  [914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 2), SHIFT_REPEAT(346),
  [917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 2), SHIFT_REPEAT(443),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 3),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 1),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parenthesized_test_expression, 3),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2),
  [960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_expression, 2),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_command, 2),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_execution, 3),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_execution, 2),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_statement, 2),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe, 3),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 13),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 9),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 7),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 2),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 16),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redirected_statement, 2),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_command, 3),
  [1018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 7),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_statement, 3),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5, .production_id = 11),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 4, .production_id = 11),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 7),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 7),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 16),
  [1038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 7),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 13),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 9),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_statement, 2),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_file_redirect, 2, .production_id = 6),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 7),
  [1054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(540),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(179),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(529),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 2),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(538),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quote_string_repeat1, 2), SHIFT_REPEAT(479),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_double_quote_string_repeat1, 2),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_double_quote_string_repeat1, 2), SHIFT_REPEAT(355),
  [1110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quote_string_repeat1, 2), SHIFT_REPEAT(355),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(537),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index, 1),
  [1124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_element_access_repeat1, 1),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(173),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 3),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__test_expression, 1),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(169),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(543),
  [1207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat2, 2), SHIFT_REPEAT(541),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_brace_concatenation_repeat1, 2),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brace_concatenation_repeat1, 2), SHIFT_REPEAT(188),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__brace_expression, 1),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_expression, 2),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_concatenation, 2),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_single_quote_string_repeat1, 2),
  [1269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_single_quote_string_repeat1, 2), SHIFT_REPEAT(440),
  [1272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_single_quote_string_repeat1, 2), SHIFT_REPEAT(440),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [1291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(545),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parenthesized_test_expression, 3),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 3),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_statement_repeat1, 2),
  [1330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_statement_repeat1, 2), SHIFT_REPEAT(126),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_brace_expansion_repeat1, 2),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__base_brace_expression, 1),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brace_expansion_repeat1, 2), SHIFT_REPEAT(130),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat1, 2),
  [1424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_expansion_repeat1, 2), SHIFT_REPEAT(520),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [1459] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_fish_external_scanner_create(void);
void tree_sitter_fish_external_scanner_destroy(void *);
bool tree_sitter_fish_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_fish_external_scanner_serialize(void *, char *);
void tree_sitter_fish_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_fish(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_fish_external_scanner_create,
      tree_sitter_fish_external_scanner_destroy,
      tree_sitter_fish_external_scanner_scan,
      tree_sitter_fish_external_scanner_serialize,
      tree_sitter_fish_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
