#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1232
#define LARGE_STATE_COUNT 22
#define SYMBOL_COUNT 206
#define ALIAS_COUNT 4
#define TOKEN_COUNT 92
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 104

enum {
  sym_identifier = 1,
  anon_sym_LF = 2,
  anon_sym_SEMI = 3,
  anon_sym_package = 4,
  anon_sym_import = 5,
  anon_sym_DOT = 6,
  sym_blank_identifier = 7,
  anon_sym_LPAREN = 8,
  anon_sym_RPAREN = 9,
  anon_sym_const = 10,
  anon_sym_COMMA = 11,
  anon_sym_EQ = 12,
  anon_sym_var = 13,
  anon_sym_func = 14,
  anon_sym_LBRACK = 15,
  anon_sym_RBRACK = 16,
  anon_sym_DOT_DOT_DOT = 17,
  anon_sym_type = 18,
  anon_sym_STAR = 19,
  anon_sym_struct = 20,
  anon_sym_LBRACE = 21,
  anon_sym_RBRACE = 22,
  anon_sym_interface = 23,
  anon_sym_PIPE = 24,
  anon_sym_TILDE = 25,
  anon_sym_map = 26,
  anon_sym_chan = 27,
  anon_sym_LT_DASH = 28,
  anon_sym_COLON_EQ = 29,
  anon_sym_PLUS_PLUS = 30,
  anon_sym_DASH_DASH = 31,
  anon_sym_STAR_EQ = 32,
  anon_sym_SLASH_EQ = 33,
  anon_sym_PERCENT_EQ = 34,
  anon_sym_LT_LT_EQ = 35,
  anon_sym_GT_GT_EQ = 36,
  anon_sym_AMP_EQ = 37,
  anon_sym_AMP_CARET_EQ = 38,
  anon_sym_PLUS_EQ = 39,
  anon_sym_DASH_EQ = 40,
  anon_sym_PIPE_EQ = 41,
  anon_sym_CARET_EQ = 42,
  anon_sym_COLON = 43,
  anon_sym_fallthrough = 44,
  anon_sym_break = 45,
  anon_sym_continue = 46,
  anon_sym_goto = 47,
  anon_sym_return = 48,
  anon_sym_go = 49,
  anon_sym_defer = 50,
  anon_sym_if = 51,
  anon_sym_else = 52,
  anon_sym_for = 53,
  anon_sym_range = 54,
  anon_sym_switch = 55,
  anon_sym_case = 56,
  anon_sym_default = 57,
  anon_sym_select = 58,
  anon_sym_new = 59,
  anon_sym_make = 60,
  anon_sym_PLUS = 61,
  anon_sym_DASH = 62,
  anon_sym_BANG = 63,
  anon_sym_CARET = 64,
  anon_sym_AMP = 65,
  anon_sym_SLASH = 66,
  anon_sym_PERCENT = 67,
  anon_sym_LT_LT = 68,
  anon_sym_GT_GT = 69,
  anon_sym_AMP_CARET = 70,
  anon_sym_EQ_EQ = 71,
  anon_sym_BANG_EQ = 72,
  anon_sym_LT = 73,
  anon_sym_LT_EQ = 74,
  anon_sym_GT = 75,
  anon_sym_GT_EQ = 76,
  anon_sym_AMP_AMP = 77,
  anon_sym_PIPE_PIPE = 78,
  sym_raw_string_literal = 79,
  anon_sym_DQUOTE = 80,
  aux_sym_interpreted_string_literal_token1 = 81,
  sym_escape_sequence = 82,
  sym_int_literal = 83,
  sym_float_literal = 84,
  sym_imaginary_literal = 85,
  sym_rune_literal = 86,
  sym_nil = 87,
  sym_true = 88,
  sym_false = 89,
  sym_iota = 90,
  sym_comment = 91,
  sym_source_file = 92,
  sym_package_clause = 93,
  sym_import_declaration = 94,
  sym_import_spec = 95,
  sym_dot = 96,
  sym_import_spec_list = 97,
  sym__declaration = 98,
  sym_const_declaration = 99,
  sym_const_spec = 100,
  sym_var_declaration = 101,
  sym_var_spec = 102,
  sym_function_declaration = 103,
  sym_method_declaration = 104,
  sym_type_parameter_list = 105,
  sym_parameter_list = 106,
  sym_parameter_declaration = 107,
  sym_variadic_parameter_declaration = 108,
  sym_type_alias = 109,
  sym_type_declaration = 110,
  sym_type_spec = 111,
  sym_expression_list = 112,
  sym_parenthesized_type = 113,
  sym__simple_type = 114,
  sym_generic_type = 115,
  sym_type_arguments = 116,
  sym_pointer_type = 117,
  sym_array_type = 118,
  sym_implicit_length_array_type = 119,
  sym_slice_type = 120,
  sym_struct_type = 121,
  sym_field_declaration_list = 122,
  sym_field_declaration = 123,
  sym_interface_type = 124,
  sym__interface_body = 125,
  sym_interface_type_name = 126,
  sym_constraint_elem = 127,
  sym_constraint_term = 128,
  sym_method_spec = 129,
  sym_map_type = 130,
  sym_channel_type = 131,
  sym_function_type = 132,
  sym_block = 133,
  sym__statement_list = 134,
  sym__statement = 135,
  sym_empty_statement = 136,
  sym__simple_statement = 137,
  sym_send_statement = 138,
  sym_receive_statement = 139,
  sym_inc_statement = 140,
  sym_dec_statement = 141,
  sym_assignment_statement = 142,
  sym_short_var_declaration = 143,
  sym_labeled_statement = 144,
  sym_empty_labeled_statement = 145,
  sym_fallthrough_statement = 146,
  sym_break_statement = 147,
  sym_continue_statement = 148,
  sym_goto_statement = 149,
  sym_return_statement = 150,
  sym_go_statement = 151,
  sym_defer_statement = 152,
  sym_if_statement = 153,
  sym_for_statement = 154,
  sym_for_clause = 155,
  sym_range_clause = 156,
  sym_expression_switch_statement = 157,
  sym_expression_case = 158,
  sym_default_case = 159,
  sym_type_switch_statement = 160,
  sym__type_switch_header = 161,
  sym_type_case = 162,
  sym_select_statement = 163,
  sym_communication_case = 164,
  sym__expression = 165,
  sym_parenthesized_expression = 166,
  sym_call_expression = 167,
  sym_variadic_argument = 168,
  sym_special_argument_list = 169,
  sym_argument_list = 170,
  sym_selector_expression = 171,
  sym_index_expression = 172,
  sym_slice_expression = 173,
  sym_type_assertion_expression = 174,
  sym_type_conversion_expression = 175,
  sym_composite_literal = 176,
  sym_literal_value = 177,
  sym_keyed_element = 178,
  sym_element = 179,
  sym_func_literal = 180,
  sym_unary_expression = 181,
  sym_binary_expression = 182,
  sym_qualified_type = 183,
  sym_interpreted_string_literal = 184,
  aux_sym_source_file_repeat1 = 185,
  aux_sym_import_spec_list_repeat1 = 186,
  aux_sym_const_declaration_repeat1 = 187,
  aux_sym_const_spec_repeat1 = 188,
  aux_sym_var_declaration_repeat1 = 189,
  aux_sym_type_parameter_list_repeat1 = 190,
  aux_sym_parameter_list_repeat1 = 191,
  aux_sym_type_declaration_repeat1 = 192,
  aux_sym_field_name_list_repeat1 = 193,
  aux_sym_expression_list_repeat1 = 194,
  aux_sym_type_arguments_repeat1 = 195,
  aux_sym_field_declaration_list_repeat1 = 196,
  aux_sym_interface_type_repeat1 = 197,
  aux_sym_constraint_elem_repeat1 = 198,
  aux_sym__statement_list_repeat1 = 199,
  aux_sym_expression_switch_statement_repeat1 = 200,
  aux_sym_type_switch_statement_repeat1 = 201,
  aux_sym_select_statement_repeat1 = 202,
  aux_sym_argument_list_repeat1 = 203,
  aux_sym_literal_value_repeat1 = 204,
  aux_sym_interpreted_string_literal_repeat1 = 205,
  alias_sym_field_identifier = 206,
  alias_sym_label_name = 207,
  alias_sym_package_identifier = 208,
  alias_sym_type_identifier = 209,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LF] = "\n",
  [anon_sym_SEMI] = ";",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [sym_blank_identifier] = "blank_identifier",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_const] = "const",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_var] = "var",
  [anon_sym_func] = "func",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_type] = "type",
  [anon_sym_STAR] = "*",
  [anon_sym_struct] = "struct",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_PIPE] = "|",
  [anon_sym_TILDE] = "~",
  [anon_sym_map] = "map",
  [anon_sym_chan] = "chan",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_AMP_CARET_EQ] = "&^=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_COLON] = ":",
  [anon_sym_fallthrough] = "fallthrough",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_return] = "return",
  [anon_sym_go] = "go",
  [anon_sym_defer] = "defer",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_range] = "range",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_select] = "select",
  [anon_sym_new] = "identifier",
  [anon_sym_make] = "identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_CARET] = "&^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [sym_raw_string_literal] = "raw_string_literal",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_interpreted_string_literal_token1] = "interpreted_string_literal_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_int_literal] = "int_literal",
  [sym_float_literal] = "float_literal",
  [sym_imaginary_literal] = "imaginary_literal",
  [sym_rune_literal] = "rune_literal",
  [sym_nil] = "nil",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_iota] = "iota",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym_package_clause] = "package_clause",
  [sym_import_declaration] = "import_declaration",
  [sym_import_spec] = "import_spec",
  [sym_dot] = "dot",
  [sym_import_spec_list] = "import_spec_list",
  [sym__declaration] = "_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_const_spec] = "const_spec",
  [sym_var_declaration] = "var_declaration",
  [sym_var_spec] = "var_spec",
  [sym_function_declaration] = "function_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_type_alias] = "type_alias",
  [sym_type_declaration] = "type_declaration",
  [sym_type_spec] = "type_spec",
  [sym_expression_list] = "expression_list",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym__simple_type] = "_simple_type",
  [sym_generic_type] = "generic_type",
  [sym_type_arguments] = "type_arguments",
  [sym_pointer_type] = "pointer_type",
  [sym_array_type] = "array_type",
  [sym_implicit_length_array_type] = "implicit_length_array_type",
  [sym_slice_type] = "slice_type",
  [sym_struct_type] = "struct_type",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_interface_type] = "interface_type",
  [sym__interface_body] = "_interface_body",
  [sym_interface_type_name] = "interface_type_name",
  [sym_constraint_elem] = "constraint_elem",
  [sym_constraint_term] = "constraint_term",
  [sym_method_spec] = "method_spec",
  [sym_map_type] = "map_type",
  [sym_channel_type] = "channel_type",
  [sym_function_type] = "function_type",
  [sym_block] = "block",
  [sym__statement_list] = "_statement_list",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym__simple_statement] = "_simple_statement",
  [sym_send_statement] = "send_statement",
  [sym_receive_statement] = "receive_statement",
  [sym_inc_statement] = "inc_statement",
  [sym_dec_statement] = "dec_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_short_var_declaration] = "short_var_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_empty_labeled_statement] = "labeled_statement",
  [sym_fallthrough_statement] = "fallthrough_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_return_statement] = "return_statement",
  [sym_go_statement] = "go_statement",
  [sym_defer_statement] = "defer_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_clause] = "for_clause",
  [sym_range_clause] = "range_clause",
  [sym_expression_switch_statement] = "expression_switch_statement",
  [sym_expression_case] = "expression_case",
  [sym_default_case] = "default_case",
  [sym_type_switch_statement] = "type_switch_statement",
  [sym__type_switch_header] = "_type_switch_header",
  [sym_type_case] = "type_case",
  [sym_select_statement] = "select_statement",
  [sym_communication_case] = "communication_case",
  [sym__expression] = "_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call_expression] = "call_expression",
  [sym_variadic_argument] = "variadic_argument",
  [sym_special_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym_selector_expression] = "selector_expression",
  [sym_index_expression] = "index_expression",
  [sym_slice_expression] = "slice_expression",
  [sym_type_assertion_expression] = "type_assertion_expression",
  [sym_type_conversion_expression] = "type_conversion_expression",
  [sym_composite_literal] = "composite_literal",
  [sym_literal_value] = "literal_value",
  [sym_keyed_element] = "keyed_element",
  [sym_element] = "element",
  [sym_func_literal] = "func_literal",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_qualified_type] = "qualified_type",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_import_spec_list_repeat1] = "import_spec_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_const_spec_repeat1] = "const_spec_repeat1",
  [aux_sym_var_declaration_repeat1] = "var_declaration_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_type_declaration_repeat1] = "type_declaration_repeat1",
  [aux_sym_field_name_list_repeat1] = "field_name_list_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_interface_type_repeat1] = "interface_type_repeat1",
  [aux_sym_constraint_elem_repeat1] = "constraint_elem_repeat1",
  [aux_sym__statement_list_repeat1] = "_statement_list_repeat1",
  [aux_sym_expression_switch_statement_repeat1] = "expression_switch_statement_repeat1",
  [aux_sym_type_switch_statement_repeat1] = "type_switch_statement_repeat1",
  [aux_sym_select_statement_repeat1] = "select_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_literal_value_repeat1] = "literal_value_repeat1",
  [aux_sym_interpreted_string_literal_repeat1] = "interpreted_string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_label_name] = "label_name",
  [alias_sym_package_identifier] = "package_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_blank_identifier] = sym_blank_identifier,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_func] = anon_sym_func,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_chan] = anon_sym_chan,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_AMP_CARET_EQ] = anon_sym_AMP_CARET_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_fallthrough] = anon_sym_fallthrough,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_go] = anon_sym_go,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_range] = anon_sym_range,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_new] = sym_identifier,
  [anon_sym_make] = sym_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_AMP_CARET] = anon_sym_AMP_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_interpreted_string_literal_token1] = aux_sym_interpreted_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_int_literal] = sym_int_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_imaginary_literal] = sym_imaginary_literal,
  [sym_rune_literal] = sym_rune_literal,
  [sym_nil] = sym_nil,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_iota] = sym_iota,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym_package_clause] = sym_package_clause,
  [sym_import_declaration] = sym_import_declaration,
  [sym_import_spec] = sym_import_spec,
  [sym_dot] = sym_dot,
  [sym_import_spec_list] = sym_import_spec_list,
  [sym__declaration] = sym__declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_const_spec] = sym_const_spec,
  [sym_var_declaration] = sym_var_declaration,
  [sym_var_spec] = sym_var_spec,
  [sym_function_declaration] = sym_function_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_type_alias] = sym_type_alias,
  [sym_type_declaration] = sym_type_declaration,
  [sym_type_spec] = sym_type_spec,
  [sym_expression_list] = sym_expression_list,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym__simple_type] = sym__simple_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_pointer_type] = sym_pointer_type,
  [sym_array_type] = sym_array_type,
  [sym_implicit_length_array_type] = sym_implicit_length_array_type,
  [sym_slice_type] = sym_slice_type,
  [sym_struct_type] = sym_struct_type,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_interface_type] = sym_interface_type,
  [sym__interface_body] = sym__interface_body,
  [sym_interface_type_name] = sym_interface_type_name,
  [sym_constraint_elem] = sym_constraint_elem,
  [sym_constraint_term] = sym_constraint_term,
  [sym_method_spec] = sym_method_spec,
  [sym_map_type] = sym_map_type,
  [sym_channel_type] = sym_channel_type,
  [sym_function_type] = sym_function_type,
  [sym_block] = sym_block,
  [sym__statement_list] = sym__statement_list,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym__simple_statement] = sym__simple_statement,
  [sym_send_statement] = sym_send_statement,
  [sym_receive_statement] = sym_receive_statement,
  [sym_inc_statement] = sym_inc_statement,
  [sym_dec_statement] = sym_dec_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_short_var_declaration] = sym_short_var_declaration,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_empty_labeled_statement] = sym_labeled_statement,
  [sym_fallthrough_statement] = sym_fallthrough_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_go_statement] = sym_go_statement,
  [sym_defer_statement] = sym_defer_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_clause] = sym_for_clause,
  [sym_range_clause] = sym_range_clause,
  [sym_expression_switch_statement] = sym_expression_switch_statement,
  [sym_expression_case] = sym_expression_case,
  [sym_default_case] = sym_default_case,
  [sym_type_switch_statement] = sym_type_switch_statement,
  [sym__type_switch_header] = sym__type_switch_header,
  [sym_type_case] = sym_type_case,
  [sym_select_statement] = sym_select_statement,
  [sym_communication_case] = sym_communication_case,
  [sym__expression] = sym__expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_variadic_argument] = sym_variadic_argument,
  [sym_special_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_selector_expression] = sym_selector_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_slice_expression] = sym_slice_expression,
  [sym_type_assertion_expression] = sym_type_assertion_expression,
  [sym_type_conversion_expression] = sym_type_conversion_expression,
  [sym_composite_literal] = sym_composite_literal,
  [sym_literal_value] = sym_literal_value,
  [sym_keyed_element] = sym_keyed_element,
  [sym_element] = sym_element,
  [sym_func_literal] = sym_func_literal,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_qualified_type] = sym_qualified_type,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_import_spec_list_repeat1] = aux_sym_import_spec_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_const_spec_repeat1] = aux_sym_const_spec_repeat1,
  [aux_sym_var_declaration_repeat1] = aux_sym_var_declaration_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_type_declaration_repeat1] = aux_sym_type_declaration_repeat1,
  [aux_sym_field_name_list_repeat1] = aux_sym_field_name_list_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_interface_type_repeat1] = aux_sym_interface_type_repeat1,
  [aux_sym_constraint_elem_repeat1] = aux_sym_constraint_elem_repeat1,
  [aux_sym__statement_list_repeat1] = aux_sym__statement_list_repeat1,
  [aux_sym_expression_switch_statement_repeat1] = aux_sym_expression_switch_statement_repeat1,
  [aux_sym_type_switch_statement_repeat1] = aux_sym_type_switch_statement_repeat1,
  [aux_sym_select_statement_repeat1] = aux_sym_select_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_literal_value_repeat1] = aux_sym_literal_value_repeat1,
  [aux_sym_interpreted_string_literal_repeat1] = aux_sym_interpreted_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_label_name] = alias_sym_label_name,
  [alias_sym_package_identifier] = alias_sym_package_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_blank_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallthrough] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_go] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_make] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_imaginary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_rune_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_iota] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_package_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_dot] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_var_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_length_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_type] = {
    .visible = true,
    .named = true,
  },
  [sym__interface_body] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_term] = {
    .visible = true,
    .named = true,
  },
  [sym_method_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_channel_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_list] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_send_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_receive_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inc_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_short_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fallthrough_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_go_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_range_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_case] = {
    .visible = true,
    .named = true,
  },
  [sym_default_case] = {
    .visible = true,
    .named = true,
  },
  [sym_type_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__type_switch_header] = {
    .visible = false,
    .named = true,
  },
  [sym_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_select_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_communication_case] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_special_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_composite_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_value] = {
    .visible = true,
    .named = true,
  },
  [sym_keyed_element] = {
    .visible = true,
    .named = true,
  },
  [sym_element] = {
    .visible = true,
    .named = true,
  },
  [sym_func_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_spec_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_var_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraint_elem_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_label_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_package_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_arguments = 3,
  field_body = 4,
  field_capacity = 5,
  field_channel = 6,
  field_communication = 7,
  field_condition = 8,
  field_consequence = 9,
  field_element = 10,
  field_end = 11,
  field_field = 12,
  field_function = 13,
  field_index = 14,
  field_initializer = 15,
  field_key = 16,
  field_label = 17,
  field_left = 18,
  field_length = 19,
  field_name = 20,
  field_operand = 21,
  field_operator = 22,
  field_package = 23,
  field_parameters = 24,
  field_path = 25,
  field_receiver = 26,
  field_result = 27,
  field_right = 28,
  field_start = 29,
  field_tag = 30,
  field_type = 31,
  field_type_arguments = 32,
  field_type_parameters = 33,
  field_update = 34,
  field_value = 35,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_capacity] = "capacity",
  [field_channel] = "channel",
  [field_communication] = "communication",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_element] = "element",
  [field_end] = "end",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_receiver] = "receiver",
  [field_result] = "result",
  [field_right] = "right",
  [field_start] = "start",
  [field_tag] = "tag",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 2},
  [7] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 2},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 13, .length = 2},
  [15] = {.index = 13, .length = 2},
  [16] = {.index = 15, .length = 2},
  [17] = {.index = 17, .length = 2},
  [18] = {.index = 19, .length = 1},
  [19] = {.index = 20, .length = 2},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 24, .length = 2},
  [22] = {.index = 26, .length = 1},
  [23] = {.index = 17, .length = 2},
  [24] = {.index = 19, .length = 1},
  [25] = {.index = 27, .length = 1},
  [26] = {.index = 28, .length = 1},
  [27] = {.index = 29, .length = 2},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 1},
  [30] = {.index = 33, .length = 2},
  [31] = {.index = 35, .length = 3},
  [32] = {.index = 38, .length = 2},
  [33] = {.index = 40, .length = 2},
  [34] = {.index = 42, .length = 2},
  [35] = {.index = 44, .length = 3},
  [36] = {.index = 47, .length = 2},
  [37] = {.index = 49, .length = 3},
  [38] = {.index = 52, .length = 1},
  [39] = {.index = 53, .length = 3},
  [40] = {.index = 56, .length = 3},
  [41] = {.index = 59, .length = 3},
  [42] = {.index = 62, .length = 3},
  [43] = {.index = 65, .length = 3},
  [44] = {.index = 68, .length = 1},
  [45] = {.index = 69, .length = 2},
  [46] = {.index = 71, .length = 2},
  [47] = {.index = 73, .length = 3},
  [48] = {.index = 52, .length = 1},
  [49] = {.index = 76, .length = 2},
  [50] = {.index = 17, .length = 2},
  [51] = {.index = 76, .length = 2},
  [53] = {.index = 78, .length = 2},
  [54] = {.index = 80, .length = 1},
  [55] = {.index = 81, .length = 1},
  [56] = {.index = 82, .length = 1},
  [57] = {.index = 83, .length = 3},
  [58] = {.index = 86, .length = 1},
  [59] = {.index = 87, .length = 2},
  [60] = {.index = 89, .length = 1},
  [61] = {.index = 90, .length = 2},
  [62] = {.index = 92, .length = 3},
  [63] = {.index = 95, .length = 3},
  [64] = {.index = 71, .length = 2},
  [65] = {.index = 98, .length = 4},
  [66] = {.index = 102, .length = 4},
  [67] = {.index = 106, .length = 4},
  [68] = {.index = 110, .length = 4},
  [69] = {.index = 114, .length = 4},
  [70] = {.index = 118, .length = 2},
  [71] = {.index = 118, .length = 2},
  [73] = {.index = 120, .length = 3},
  [74] = {.index = 49, .length = 3},
  [75] = {.index = 123, .length = 3},
  [76] = {.index = 126, .length = 2},
  [77] = {.index = 128, .length = 3},
  [78] = {.index = 131, .length = 3},
  [79] = {.index = 134, .length = 2},
  [80] = {.index = 136, .length = 2},
  [81] = {.index = 138, .length = 2},
  [82] = {.index = 140, .length = 2},
  [83] = {.index = 142, .length = 1},
  [84] = {.index = 143, .length = 1},
  [86] = {.index = 144, .length = 2},
  [87] = {.index = 146, .length = 2},
  [88] = {.index = 148, .length = 2},
  [89] = {.index = 150, .length = 4},
  [90] = {.index = 154, .length = 5},
  [91] = {.index = 159, .length = 5},
  [92] = {.index = 164, .length = 4},
  [93] = {.index = 168, .length = 3},
  [94] = {.index = 171, .length = 2},
  [95] = {.index = 173, .length = 1},
  [96] = {.index = 174, .length = 3},
  [97] = {.index = 177, .length = 4},
  [98] = {.index = 181, .length = 2},
  [99] = {.index = 183, .length = 3},
  [100] = {.index = 186, .length = 2},
  [101] = {.index = 188, .length = 2},
  [102] = {.index = 190, .length = 4},
  [103] = {.index = 194, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_path, 0},
  [1] =
    {field_name, 0},
  [2] =
    {field_parameters, 1},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_value, 1},
  [6] =
    {field_body, 1},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_type, 0},
    {field_type_arguments, 1},
  [11] =
    {field_body, 1},
    {field_type, 0},
  [13] =
    {field_name, 0},
    {field_path, 1},
  [15] =
    {field_name, 0},
    {field_name, 1},
  [17] =
    {field_name, 0},
    {field_type, 1},
  [19] =
    {field_type, 0},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_parameters, 1},
    {field_result, 2},
  [24] =
    {field_body, 2},
    {field_parameters, 1},
  [26] =
    {field_element, 2},
  [27] =
    {field_label, 0},
  [28] =
    {field_value, 2},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_right, 1},
  [32] =
    {field_body, 2},
  [33] =
    {field_name, 2},
    {field_package, 0},
  [35] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [38] =
    {field_left, 0},
    {field_right, 2},
  [40] =
    {field_field, 2},
    {field_operand, 0},
  [42] =
    {field_channel, 0},
    {field_value, 2},
  [44] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [47] =
    {field_name, 0},
    {field_value, 2},
  [49] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
  [52] =
    {field_type, 1},
  [53] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [56] =
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [59] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [62] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [65] =
    {field_body, 3},
    {field_parameters, 1},
    {field_result, 2},
  [68] =
    {field_element, 3},
  [69] =
    {field_element, 3},
    {field_length, 1},
  [71] =
    {field_name, 0},
    {field_type, 2},
  [73] =
    {field_name, 0},
    {field_type, 2},
    {field_type_parameters, 1},
  [76] =
    {field_tag, 1},
    {field_type, 0},
  [78] =
    {field_name, 0},
    {field_parameters, 1},
  [80] =
    {field_update, 2},
  [81] =
    {field_condition, 1},
  [82] =
    {field_initializer, 0},
  [83] =
    {field_alias, 1, .inherited = true},
    {field_initializer, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [86] =
    {field_right, 0},
  [87] =
    {field_operand, 2},
    {field_type, 0},
  [89] =
    {field_operand, 0},
  [90] =
    {field_index, 2},
    {field_operand, 0},
  [92] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 3},
  [95] =
    {field_name, 0},
    {field_name, 1},
    {field_value, 3},
  [98] =
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [102] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [106] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [110] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [114] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [118] =
    {field_tag, 2},
    {field_type, 1},
  [120] =
    {field_name, 0},
    {field_tag, 2},
    {field_type, 1},
  [123] =
    {field_name, 0},
    {field_parameters, 1},
    {field_result, 2},
  [126] =
    {field_key, 2},
    {field_value, 4},
  [128] =
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [131] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [134] =
    {field_condition, 1},
    {field_update, 3},
  [136] =
    {field_left, 0},
    {field_right, 3},
  [138] =
    {field_initializer, 0},
    {field_update, 3},
  [140] =
    {field_condition, 2},
    {field_initializer, 0},
  [142] =
    {field_initializer, 1},
  [143] =
    {field_communication, 1},
  [144] =
    {field_operand, 0},
    {field_type, 3},
  [146] =
    {field_end, 3},
    {field_operand, 0},
  [148] =
    {field_operand, 0},
    {field_start, 2},
  [150] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
    {field_value, 4},
  [154] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [159] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [164] =
    {field_name, 0},
    {field_name, 1},
    {field_tag, 3},
    {field_type, 2},
  [168] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [171] =
    {field_initializer, 1},
    {field_value, 3},
  [173] =
    {field_value, 0},
  [174] =
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [177] =
    {field_alternative, 6},
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [181] =
    {field_type, 1},
    {field_type, 2},
  [183] =
    {field_capacity, 5},
    {field_end, 3},
    {field_operand, 0},
  [186] =
    {field_alias, 0},
    {field_value, 2},
  [188] =
    {field_initializer, 0},
    {field_value, 2},
  [190] =
    {field_capacity, 6},
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [194] =
    {field_alias, 2},
    {field_initializer, 0},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [1] = alias_sym_package_identifier,
  },
  [8] = {
    [1] = alias_sym_label_name,
  },
  [11] = {
    [0] = alias_sym_type_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_package_identifier,
  },
  [23] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [0] = alias_sym_type_identifier,
  },
  [25] = {
    [0] = alias_sym_label_name,
  },
  [30] = {
    [0] = alias_sym_package_identifier,
    [2] = alias_sym_type_identifier,
  },
  [33] = {
    [2] = alias_sym_field_identifier,
  },
  [42] = {
    [2] = alias_sym_field_identifier,
  },
  [46] = {
    [0] = alias_sym_type_identifier,
  },
  [47] = {
    [0] = alias_sym_type_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [0] = alias_sym_type_identifier,
  },
  [50] = {
    [0] = alias_sym_field_identifier,
  },
  [52] = {
    [1] = alias_sym_type_identifier,
  },
  [53] = {
    [0] = alias_sym_field_identifier,
  },
  [68] = {
    [2] = alias_sym_field_identifier,
  },
  [69] = {
    [2] = alias_sym_field_identifier,
  },
  [70] = {
    [1] = alias_sym_type_identifier,
  },
  [72] = {
    [1] = alias_sym_field_identifier,
  },
  [73] = {
    [0] = alias_sym_field_identifier,
  },
  [74] = {
    [0] = alias_sym_field_identifier,
  },
  [75] = {
    [0] = alias_sym_field_identifier,
  },
  [85] = {
    [0] = alias_sym_field_identifier,
  },
  [91] = {
    [2] = alias_sym_field_identifier,
  },
  [92] = {
    [0] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6688
    ? (c < 2984
      ? (c < 2365
        ? (c < 1488
          ? (c < 886
            ? (c < 216
              ? (c < 181
                ? (c < 'a'
                  ? (c >= 'A' && c <= '_')
                  : (c <= 'z' || c == 170))
                : (c <= 181 || (c < 192
                  ? c == 186
                  : c <= 214)))
              : (c <= 246 || (c < 748
                ? (c < 710
                  ? (c >= 248 && c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))
                : (c <= 748 || (c < 880
                  ? c == 750
                  : c <= 884)))))
            : (c <= 887 || (c < 931
              ? (c < 904
                ? (c < 895
                  ? (c >= 890 && c <= 893)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 910
                  ? c == 908
                  : c <= 929)))
              : (c <= 1013 || (c < 1329
                ? (c < 1162
                  ? (c >= 1015 && c <= 1153)
                  : c <= 1327)
                : (c <= 1366 || (c < 1376
                  ? c == 1369
                  : c <= 1416)))))))
          : (c <= 1514 || (c < 1994
            ? (c < 1774
              ? (c < 1649
                ? (c < 1568
                  ? (c >= 1519 && c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1765
                  ? c == 1749
                  : c <= 1766)))
              : (c <= 1775 || (c < 1810
                ? (c < 1791
                  ? (c >= 1786 && c <= 1788)
                  : (c <= 1791 || c == 1808))
                : (c <= 1839 || (c < 1969
                  ? (c >= 1869 && c <= 1957)
                  : c <= 1969)))))
            : (c <= 2026 || (c < 2112
              ? (c < 2074
                ? (c < 2042
                  ? (c >= 2036 && c <= 2037)
                  : (c <= 2042 || (c >= 2048 && c <= 2069)))
                : (c <= 2074 || (c < 2088
                  ? c == 2084
                  : c <= 2088)))
              : (c <= 2136 || (c < 2185
                ? (c < 2160
                  ? (c >= 2144 && c <= 2154)
                  : c <= 2183)
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2544
            ? (c < 2474
              ? (c < 2437
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2654
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)
                : (c <= 2654 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2869
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2835
                ? (c < 2821
                  ? c == 2809
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))
                : (c <= 2856 || (c < 2866
                  ? (c >= 2858 && c <= 2864)
                  : c <= 2867)))))
            : (c <= 2873 || (c < 2958
              ? (c < 2929
                ? (c < 2908
                  ? c == 2877
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2949
                  ? c == 2947
                  : c <= 2954)))
              : (c <= 2960 || (c < 2972
                ? (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)
                : (c <= 2972 || (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : c <= 2980)))))))))))
      : (c <= 2986 || (c < 4176
        ? (c < 3423
          ? (c < 3218
            ? (c < 3133
              ? (c < 3086
                ? (c < 3024
                  ? (c >= 2990 && c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : c <= 3129)))
              : (c <= 3133 || (c < 3200
                ? (c < 3165
                  ? (c >= 3160 && c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3332
              ? (c < 3293
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : (c <= 3257 || c == 3261))
                : (c <= 3294 || (c < 3313
                  ? (c >= 3296 && c <= 3297)
                  : c <= 3314)))
              : (c <= 3340 || (c < 3389
                ? (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)
                : (c <= 3389 || (c < 3412
                  ? c == 3406
                  : c <= 3414)))))))
          : (c <= 3425 || (c < 3749
            ? (c < 3585
              ? (c < 3507
                ? (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3520
                  ? c == 3517
                  : c <= 3526)))
              : (c <= 3632 || (c < 3716
                ? (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3724
                  ? (c >= 3718 && c <= 3722)
                  : c <= 3747)))))
            : (c <= 3749 || (c < 3840
              ? (c < 3776
                ? (c < 3762
                  ? (c >= 3751 && c <= 3760)
                  : (c <= 3763 || c == 3773))
                : (c <= 3780 || (c < 3804
                  ? c == 3782
                  : c <= 3807)))
              : (c <= 3840 || (c < 3976
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : c <= 3948)
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : c <= 4159)))))))))
        : (c <= 4181 || (c < 4992
          ? (c < 4696
            ? (c < 4256
              ? (c < 4206
                ? (c < 4193
                  ? (c >= 4186 && c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))
                : (c <= 4208 || (c < 4238
                  ? (c >= 4213 && c <= 4225)
                  : c <= 4238)))
              : (c <= 4293 || (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))))
            : (c <= 4696 || (c < 4800
              ? (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))
              : (c <= 4800 || (c < 4824
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : c <= 4822)
                : (c <= 4880 || (c < 4888
                  ? (c >= 4882 && c <= 4885)
                  : c <= 4954)))))))
          : (c <= 5007 || (c < 6103
            ? (c < 5873
              ? (c < 5743
                ? (c < 5112
                  ? (c >= 5024 && c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))
                : (c <= 5759 || (c < 5792
                  ? (c >= 5761 && c <= 5786)
                  : c <= 5866)))
              : (c <= 5880 || (c < 5984
                ? (c < 5919
                  ? (c >= 5888 && c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6016
                  ? (c >= 5998 && c <= 6000)
                  : c <= 6067)))))
            : (c <= 6103 || (c < 6400
              ? (c < 6279
                ? (c < 6176
                  ? c == 6108
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))
              : (c <= 6430 || (c < 6528
                ? (c < 6512
                  ? (c >= 6480 && c <= 6509)
                  : c <= 6516)
                : (c <= 6571 || (c < 6656
                  ? (c >= 6576 && c <= 6601)
                  : c <= 6678)))))))))))))
    : (c <= 6740 || (c < 43261
      ? (c < 11264
        ? (c < 8064
          ? (c < 7406
            ? (c < 7168
              ? (c < 7043
                ? (c < 6917
                  ? c == 6823
                  : (c <= 6963 || (c >= 6981 && c <= 6988)))
                : (c <= 7072 || (c < 7098
                  ? (c >= 7086 && c <= 7087)
                  : c <= 7141)))
              : (c <= 7203 || (c < 7312
                ? (c < 7258
                  ? (c >= 7245 && c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))
                : (c <= 7354 || (c < 7401
                  ? (c >= 7357 && c <= 7359)
                  : c <= 7404)))))
            : (c <= 7411 || (c < 8008
              ? (c < 7680
                ? (c < 7418
                  ? (c >= 7413 && c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))
                : (c <= 7957 || (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : c <= 8005)))
              : (c <= 8013 || (c < 8027
                ? (c < 8025
                  ? (c >= 8016 && c <= 8023)
                  : c <= 8025)
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))))))
          : (c <= 8116 || (c < 8455
            ? (c < 8160
              ? (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))
              : (c <= 8172 || (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))))
            : (c <= 8455 || (c < 8490
              ? (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))
              : (c <= 8493 || (c < 8517
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : c <= 8511)
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : c <= 8580)))))))))
        : (c <= 11492 || (c < 12704
          ? (c < 11720
            ? (c < 11631
              ? (c < 11559
                ? (c < 11506
                  ? (c >= 11499 && c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11568
                  ? c == 11565
                  : c <= 11623)))
              : (c <= 11631 || (c < 11696
                ? (c < 11680
                  ? (c >= 11648 && c <= 11670)
                  : (c <= 11686 || (c >= 11688 && c <= 11694)))
                : (c <= 11702 || (c < 11712
                  ? (c >= 11704 && c <= 11710)
                  : c <= 11718)))))
            : (c <= 11726 || (c < 12353
              ? (c < 12293
                ? (c < 11736
                  ? (c >= 11728 && c <= 11734)
                  : (c <= 11742 || c == 11823))
                : (c <= 12294 || (c < 12347
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)))
              : (c <= 12438 || (c < 12540
                ? (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)
                : (c <= 12543 || (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)))))))
          : (c <= 12735 || (c < 42786
            ? (c < 42240
              ? (c < 19968
                ? (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : (c <= 13312 || c == 19903))
                : (c <= 19968 || (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : c <= 42237)))
              : (c <= 42508 || (c < 42623
                ? (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : c <= 42783)))))
            : (c <= 42888 || (c < 43015
              ? (c < 42965
                ? (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : c <= 43013)))
              : (c <= 43018 || (c < 43138
                ? (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)
                : (c <= 43187 || (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : c <= 43259)))))))))))
      : (c <= 43262 || (c < 65345
        ? (c < 43816
          ? (c < 43646
            ? (c < 43494
              ? (c < 43396
                ? (c < 43312
                  ? (c >= 43274 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43488
                  ? c == 43471
                  : c <= 43492)))
              : (c <= 43503 || (c < 43588
                ? (c < 43520
                  ? (c >= 43514 && c <= 43518)
                  : (c <= 43560 || (c >= 43584 && c <= 43586)))
                : (c <= 43595 || (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : c <= 43642)))))
            : (c <= 43695 || (c < 43744
              ? (c < 43712
                ? (c < 43701
                  ? c == 43697
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43739
                  ? c == 43714
                  : c <= 43741)))
              : (c <= 43754 || (c < 43785
                ? (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)
                : (c <= 43790 || (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)))))))
          : (c <= 43822 || (c < 64298
            ? (c < 55243
              ? (c < 44032
                ? (c < 43868
                  ? (c >= 43824 && c <= 43866)
                  : (c <= 43881 || (c >= 43888 && c <= 44002)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : c <= 55238)))
              : (c <= 55291 || (c < 64275
                ? (c < 64112
                  ? (c >= 63744 && c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))
                : (c <= 64279 || (c < 64287
                  ? c == 64285
                  : c <= 64296)))))
            : (c <= 64310 || (c < 64848
              ? (c < 64323
                ? (c < 64318
                  ? (c >= 64312 && c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)))
              : (c <= 64911 || (c < 65136
                ? (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)
                : (c <= 65140 || (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)))))))))
        : (c <= 65370 || (c < 66928
          ? (c < 66208
            ? (c < 65549
              ? (c < 65490
                ? (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65536
                  ? (c >= 65498 && c <= 65500)
                  : c <= 65547)))
              : (c <= 65574 || (c < 65616
                ? (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))
                : (c <= 65629 || (c < 66176
                  ? (c >= 65664 && c <= 65786)
                  : c <= 66204)))))
            : (c <= 66256 || (c < 66504
              ? (c < 66384
                ? (c < 66349
                  ? (c >= 66304 && c <= 66335)
                  : (c <= 66368 || (c >= 66370 && c <= 66377)))
                : (c <= 66421 || (c < 66464
                  ? (c >= 66432 && c <= 66461)
                  : c <= 66499)))
              : (c <= 66511 || (c < 66776
                ? (c < 66736
                  ? (c >= 66560 && c <= 66717)
                  : c <= 66771)
                : (c <= 66811 || (c < 66864
                  ? (c >= 66816 && c <= 66855)
                  : c <= 66915)))))))
          : (c <= 66938 || (c < 67506
            ? (c < 67003
              ? (c < 66967
                ? (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))
                : (c <= 66977 || (c < 66995
                  ? (c >= 66979 && c <= 66993)
                  : c <= 67001)))
              : (c <= 67004 || (c < 67424
                ? (c < 67392
                  ? (c >= 67072 && c <= 67382)
                  : c <= 67413)
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= 'A' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? (c >= '0' && c <= '9')
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_rune_literal_character_set_1(int32_t c) {
  return (c < 'f'
    ? (c < '\\'
      ? (c < '\''
        ? c == '"'
        : c <= '\'')
      : (c <= '\\' || (c >= 'a' && c <= 'b')))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(109);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(109);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(112);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(113);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(131);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(8)
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(141);
      if (lookahead != 0) ADVANCE(142);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(109);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(102);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(109);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(112);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(113);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(131);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(108);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(112);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(113);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(131);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      END_STATE();
    case 9:
      if (lookahead == '\'') ADVANCE(156);
      END_STATE();
    case 10:
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 11:
      if (lookahead == '*') ADVANCE(11);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == '*') ADVANCE(11);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == '-') ADVANCE(83);
      END_STATE();
    case 14:
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(74);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 21:
      if (lookahead == 'U') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 22:
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(9);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(150);
      END_STATE();
    case 24:
      if (lookahead == '_') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(151);
      END_STATE();
    case 25:
      if (lookahead == '`') ADVANCE(136);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(152);
      END_STATE();
    case 27:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 29:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(150);
      END_STATE();
    case 30:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(9);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(151);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(31);
      END_STATE();
    case 34:
      if (sym_rune_literal_character_set_1(lookahead)) ADVANCE(9);
      if (lookahead == 'U') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(33);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(15);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(152);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(143);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 57:
      if (eof) ADVANCE(60);
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(13);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(79);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 58:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(109);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 59:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(14);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(13);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(16);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(96);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_AMP_CARET_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '^') ADVANCE(122);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '^') ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '=') ADVANCE(88);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(89);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_raw_string_literal);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(142);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(24);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(17);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_imaginary_literal);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_rune_literal);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(158);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'v') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(sym_blank_identifier);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(17);
      if (lookahead == 'h') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      if (lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(26);
      if (lookahead == 'm') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'i') ADVANCE(32);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(33);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      if (lookahead == 'w') ADVANCE(38);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'y') ADVANCE(40);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(41);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 20:
      if (lookahead == 'f') ADVANCE(46);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_go);
      if (lookahead == 't') ADVANCE(51);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(52);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(54);
      END_STATE();
    case 30:
      if (lookahead == 'k') ADVANCE(55);
      if (lookahead == 'p') ADVANCE(56);
      END_STATE();
    case 31:
      if (lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(58);
      END_STATE();
    case 33:
      if (lookahead == 'c') ADVANCE(59);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(63);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 39:
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 40:
      if (lookahead == 'p') ADVANCE(66);
      END_STATE();
    case 41:
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(68);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(73);
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(76);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(78);
      END_STATE();
    case 51:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_map);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 59:
      if (lookahead == 'k') ADVANCE(84);
      END_STATE();
    case 60:
      if (lookahead == 'g') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 68:
      if (lookahead == 'k') ADVANCE(92);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_chan);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 73:
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(99);
      END_STATE();
    case 81:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_iota);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_make);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(104);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(105);
      END_STATE();
    case 89:
      if (lookahead == 'c') ADVANCE(106);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(107);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(108);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 97:
      if (lookahead == 'h') ADVANCE(109);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 100:
      if (lookahead == 'f') ADVANCE(111);
      END_STATE();
    case 101:
      if (lookahead == 'g') ADVANCE(112);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_range);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(113);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(116);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(117);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(120);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 119:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 120:
      if (lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 123:
      if (lookahead == 'u') ADVANCE(125);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 125:
      if (lookahead == 'g') ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_fallthrough);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 59},
  [2] = {.lex_state = 59},
  [3] = {.lex_state = 59},
  [4] = {.lex_state = 59},
  [5] = {.lex_state = 59},
  [6] = {.lex_state = 59},
  [7] = {.lex_state = 59},
  [8] = {.lex_state = 59},
  [9] = {.lex_state = 59},
  [10] = {.lex_state = 59},
  [11] = {.lex_state = 59},
  [12] = {.lex_state = 59},
  [13] = {.lex_state = 59},
  [14] = {.lex_state = 59},
  [15] = {.lex_state = 59},
  [16] = {.lex_state = 59},
  [17] = {.lex_state = 59},
  [18] = {.lex_state = 59},
  [19] = {.lex_state = 59},
  [20] = {.lex_state = 59},
  [21] = {.lex_state = 59},
  [22] = {.lex_state = 59},
  [23] = {.lex_state = 59},
  [24] = {.lex_state = 59},
  [25] = {.lex_state = 59},
  [26] = {.lex_state = 59},
  [27] = {.lex_state = 59},
  [28] = {.lex_state = 57},
  [29] = {.lex_state = 57},
  [30] = {.lex_state = 57},
  [31] = {.lex_state = 57},
  [32] = {.lex_state = 57},
  [33] = {.lex_state = 59},
  [34] = {.lex_state = 59},
  [35] = {.lex_state = 59},
  [36] = {.lex_state = 59},
  [37] = {.lex_state = 59},
  [38] = {.lex_state = 59},
  [39] = {.lex_state = 59},
  [40] = {.lex_state = 59},
  [41] = {.lex_state = 59},
  [42] = {.lex_state = 59},
  [43] = {.lex_state = 59},
  [44] = {.lex_state = 59},
  [45] = {.lex_state = 59},
  [46] = {.lex_state = 59},
  [47] = {.lex_state = 59},
  [48] = {.lex_state = 59},
  [49] = {.lex_state = 59},
  [50] = {.lex_state = 59},
  [51] = {.lex_state = 59},
  [52] = {.lex_state = 59},
  [53] = {.lex_state = 59},
  [54] = {.lex_state = 59},
  [55] = {.lex_state = 59},
  [56] = {.lex_state = 59},
  [57] = {.lex_state = 59},
  [58] = {.lex_state = 59},
  [59] = {.lex_state = 59},
  [60] = {.lex_state = 59},
  [61] = {.lex_state = 59},
  [62] = {.lex_state = 59},
  [63] = {.lex_state = 59},
  [64] = {.lex_state = 59},
  [65] = {.lex_state = 59},
  [66] = {.lex_state = 59},
  [67] = {.lex_state = 59},
  [68] = {.lex_state = 59},
  [69] = {.lex_state = 59},
  [70] = {.lex_state = 59},
  [71] = {.lex_state = 59},
  [72] = {.lex_state = 59},
  [73] = {.lex_state = 59},
  [74] = {.lex_state = 59},
  [75] = {.lex_state = 59},
  [76] = {.lex_state = 59},
  [77] = {.lex_state = 59},
  [78] = {.lex_state = 59},
  [79] = {.lex_state = 59},
  [80] = {.lex_state = 59},
  [81] = {.lex_state = 59},
  [82] = {.lex_state = 59},
  [83] = {.lex_state = 59},
  [84] = {.lex_state = 59},
  [85] = {.lex_state = 59},
  [86] = {.lex_state = 59},
  [87] = {.lex_state = 59},
  [88] = {.lex_state = 59},
  [89] = {.lex_state = 59},
  [90] = {.lex_state = 59},
  [91] = {.lex_state = 59},
  [92] = {.lex_state = 59},
  [93] = {.lex_state = 59},
  [94] = {.lex_state = 59},
  [95] = {.lex_state = 59},
  [96] = {.lex_state = 59},
  [97] = {.lex_state = 59},
  [98] = {.lex_state = 59},
  [99] = {.lex_state = 59},
  [100] = {.lex_state = 59},
  [101] = {.lex_state = 59},
  [102] = {.lex_state = 59},
  [103] = {.lex_state = 59},
  [104] = {.lex_state = 59},
  [105] = {.lex_state = 59},
  [106] = {.lex_state = 59},
  [107] = {.lex_state = 59},
  [108] = {.lex_state = 59},
  [109] = {.lex_state = 59},
  [110] = {.lex_state = 59},
  [111] = {.lex_state = 59},
  [112] = {.lex_state = 59},
  [113] = {.lex_state = 59},
  [114] = {.lex_state = 59},
  [115] = {.lex_state = 59},
  [116] = {.lex_state = 59},
  [117] = {.lex_state = 59},
  [118] = {.lex_state = 59},
  [119] = {.lex_state = 59},
  [120] = {.lex_state = 59},
  [121] = {.lex_state = 59},
  [122] = {.lex_state = 59},
  [123] = {.lex_state = 59},
  [124] = {.lex_state = 59},
  [125] = {.lex_state = 59},
  [126] = {.lex_state = 59},
  [127] = {.lex_state = 59},
  [128] = {.lex_state = 59},
  [129] = {.lex_state = 59},
  [130] = {.lex_state = 59},
  [131] = {.lex_state = 59},
  [132] = {.lex_state = 59},
  [133] = {.lex_state = 59},
  [134] = {.lex_state = 59},
  [135] = {.lex_state = 59},
  [136] = {.lex_state = 59},
  [137] = {.lex_state = 59},
  [138] = {.lex_state = 59},
  [139] = {.lex_state = 59},
  [140] = {.lex_state = 59},
  [141] = {.lex_state = 59},
  [142] = {.lex_state = 59},
  [143] = {.lex_state = 59},
  [144] = {.lex_state = 59},
  [145] = {.lex_state = 59},
  [146] = {.lex_state = 59},
  [147] = {.lex_state = 59},
  [148] = {.lex_state = 59},
  [149] = {.lex_state = 59},
  [150] = {.lex_state = 59},
  [151] = {.lex_state = 59},
  [152] = {.lex_state = 59},
  [153] = {.lex_state = 59},
  [154] = {.lex_state = 59},
  [155] = {.lex_state = 59},
  [156] = {.lex_state = 59},
  [157] = {.lex_state = 59},
  [158] = {.lex_state = 59},
  [159] = {.lex_state = 59},
  [160] = {.lex_state = 59},
  [161] = {.lex_state = 59},
  [162] = {.lex_state = 59},
  [163] = {.lex_state = 59},
  [164] = {.lex_state = 59},
  [165] = {.lex_state = 59},
  [166] = {.lex_state = 59},
  [167] = {.lex_state = 59},
  [168] = {.lex_state = 59},
  [169] = {.lex_state = 59},
  [170] = {.lex_state = 59},
  [171] = {.lex_state = 59},
  [172] = {.lex_state = 59},
  [173] = {.lex_state = 59},
  [174] = {.lex_state = 59},
  [175] = {.lex_state = 59},
  [176] = {.lex_state = 59},
  [177] = {.lex_state = 59},
  [178] = {.lex_state = 59},
  [179] = {.lex_state = 59},
  [180] = {.lex_state = 59},
  [181] = {.lex_state = 59},
  [182] = {.lex_state = 59},
  [183] = {.lex_state = 59},
  [184] = {.lex_state = 59},
  [185] = {.lex_state = 59},
  [186] = {.lex_state = 59},
  [187] = {.lex_state = 59},
  [188] = {.lex_state = 59},
  [189] = {.lex_state = 59},
  [190] = {.lex_state = 59},
  [191] = {.lex_state = 59},
  [192] = {.lex_state = 59},
  [193] = {.lex_state = 59},
  [194] = {.lex_state = 59},
  [195] = {.lex_state = 59},
  [196] = {.lex_state = 59},
  [197] = {.lex_state = 59},
  [198] = {.lex_state = 59},
  [199] = {.lex_state = 59},
  [200] = {.lex_state = 59},
  [201] = {.lex_state = 59},
  [202] = {.lex_state = 59},
  [203] = {.lex_state = 59},
  [204] = {.lex_state = 59},
  [205] = {.lex_state = 59},
  [206] = {.lex_state = 59},
  [207] = {.lex_state = 59},
  [208] = {.lex_state = 59},
  [209] = {.lex_state = 59},
  [210] = {.lex_state = 59},
  [211] = {.lex_state = 59},
  [212] = {.lex_state = 59},
  [213] = {.lex_state = 59},
  [214] = {.lex_state = 59},
  [215] = {.lex_state = 59},
  [216] = {.lex_state = 59},
  [217] = {.lex_state = 59},
  [218] = {.lex_state = 59},
  [219] = {.lex_state = 59},
  [220] = {.lex_state = 59},
  [221] = {.lex_state = 59},
  [222] = {.lex_state = 59},
  [223] = {.lex_state = 59},
  [224] = {.lex_state = 59},
  [225] = {.lex_state = 59},
  [226] = {.lex_state = 59},
  [227] = {.lex_state = 59},
  [228] = {.lex_state = 59},
  [229] = {.lex_state = 59},
  [230] = {.lex_state = 59},
  [231] = {.lex_state = 59},
  [232] = {.lex_state = 59},
  [233] = {.lex_state = 59},
  [234] = {.lex_state = 59},
  [235] = {.lex_state = 59},
  [236] = {.lex_state = 59},
  [237] = {.lex_state = 57},
  [238] = {.lex_state = 1},
  [239] = {.lex_state = 57},
  [240] = {.lex_state = 1},
  [241] = {.lex_state = 57},
  [242] = {.lex_state = 57},
  [243] = {.lex_state = 57},
  [244] = {.lex_state = 57},
  [245] = {.lex_state = 57},
  [246] = {.lex_state = 1},
  [247] = {.lex_state = 1},
  [248] = {.lex_state = 57},
  [249] = {.lex_state = 57},
  [250] = {.lex_state = 57},
  [251] = {.lex_state = 57},
  [252] = {.lex_state = 57},
  [253] = {.lex_state = 57},
  [254] = {.lex_state = 57},
  [255] = {.lex_state = 57},
  [256] = {.lex_state = 57},
  [257] = {.lex_state = 57},
  [258] = {.lex_state = 57},
  [259] = {.lex_state = 57},
  [260] = {.lex_state = 57},
  [261] = {.lex_state = 57},
  [262] = {.lex_state = 57},
  [263] = {.lex_state = 57},
  [264] = {.lex_state = 57},
  [265] = {.lex_state = 57},
  [266] = {.lex_state = 57},
  [267] = {.lex_state = 57},
  [268] = {.lex_state = 57},
  [269] = {.lex_state = 57},
  [270] = {.lex_state = 57},
  [271] = {.lex_state = 57},
  [272] = {.lex_state = 57},
  [273] = {.lex_state = 57},
  [274] = {.lex_state = 57},
  [275] = {.lex_state = 57},
  [276] = {.lex_state = 57},
  [277] = {.lex_state = 57},
  [278] = {.lex_state = 7},
  [279] = {.lex_state = 57},
  [280] = {.lex_state = 57},
  [281] = {.lex_state = 57},
  [282] = {.lex_state = 57},
  [283] = {.lex_state = 57},
  [284] = {.lex_state = 57},
  [285] = {.lex_state = 57},
  [286] = {.lex_state = 57},
  [287] = {.lex_state = 57},
  [288] = {.lex_state = 57},
  [289] = {.lex_state = 57},
  [290] = {.lex_state = 57},
  [291] = {.lex_state = 57},
  [292] = {.lex_state = 57},
  [293] = {.lex_state = 59},
  [294] = {.lex_state = 1},
  [295] = {.lex_state = 1},
  [296] = {.lex_state = 1},
  [297] = {.lex_state = 1},
  [298] = {.lex_state = 1},
  [299] = {.lex_state = 1},
  [300] = {.lex_state = 4},
  [301] = {.lex_state = 4},
  [302] = {.lex_state = 1},
  [303] = {.lex_state = 1},
  [304] = {.lex_state = 1},
  [305] = {.lex_state = 1},
  [306] = {.lex_state = 1},
  [307] = {.lex_state = 1},
  [308] = {.lex_state = 1},
  [309] = {.lex_state = 1},
  [310] = {.lex_state = 1},
  [311] = {.lex_state = 1},
  [312] = {.lex_state = 1},
  [313] = {.lex_state = 1},
  [314] = {.lex_state = 1},
  [315] = {.lex_state = 1},
  [316] = {.lex_state = 1},
  [317] = {.lex_state = 1},
  [318] = {.lex_state = 1},
  [319] = {.lex_state = 1},
  [320] = {.lex_state = 1},
  [321] = {.lex_state = 1},
  [322] = {.lex_state = 1},
  [323] = {.lex_state = 1},
  [324] = {.lex_state = 1},
  [325] = {.lex_state = 1},
  [326] = {.lex_state = 1},
  [327] = {.lex_state = 1},
  [328] = {.lex_state = 1},
  [329] = {.lex_state = 1},
  [330] = {.lex_state = 1},
  [331] = {.lex_state = 1},
  [332] = {.lex_state = 1},
  [333] = {.lex_state = 1},
  [334] = {.lex_state = 1},
  [335] = {.lex_state = 1},
  [336] = {.lex_state = 1},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 4},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 4},
  [342] = {.lex_state = 4},
  [343] = {.lex_state = 4},
  [344] = {.lex_state = 4},
  [345] = {.lex_state = 4},
  [346] = {.lex_state = 4},
  [347] = {.lex_state = 4},
  [348] = {.lex_state = 4},
  [349] = {.lex_state = 4},
  [350] = {.lex_state = 4},
  [351] = {.lex_state = 4},
  [352] = {.lex_state = 4},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 4},
  [355] = {.lex_state = 4},
  [356] = {.lex_state = 4},
  [357] = {.lex_state = 4},
  [358] = {.lex_state = 4},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 4},
  [361] = {.lex_state = 4},
  [362] = {.lex_state = 4},
  [363] = {.lex_state = 4},
  [364] = {.lex_state = 4},
  [365] = {.lex_state = 4},
  [366] = {.lex_state = 4},
  [367] = {.lex_state = 4},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 4},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 4},
  [372] = {.lex_state = 4},
  [373] = {.lex_state = 4},
  [374] = {.lex_state = 4},
  [375] = {.lex_state = 4},
  [376] = {.lex_state = 4},
  [377] = {.lex_state = 4},
  [378] = {.lex_state = 4},
  [379] = {.lex_state = 4},
  [380] = {.lex_state = 4},
  [381] = {.lex_state = 5},
  [382] = {.lex_state = 5},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 5},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 5},
  [387] = {.lex_state = 5},
  [388] = {.lex_state = 5},
  [389] = {.lex_state = 5},
  [390] = {.lex_state = 5},
  [391] = {.lex_state = 5},
  [392] = {.lex_state = 5},
  [393] = {.lex_state = 5},
  [394] = {.lex_state = 5},
  [395] = {.lex_state = 5},
  [396] = {.lex_state = 5},
  [397] = {.lex_state = 5},
  [398] = {.lex_state = 5},
  [399] = {.lex_state = 5},
  [400] = {.lex_state = 5},
  [401] = {.lex_state = 5},
  [402] = {.lex_state = 5},
  [403] = {.lex_state = 5},
  [404] = {.lex_state = 5},
  [405] = {.lex_state = 5},
  [406] = {.lex_state = 5},
  [407] = {.lex_state = 5},
  [408] = {.lex_state = 5},
  [409] = {.lex_state = 5},
  [410] = {.lex_state = 5},
  [411] = {.lex_state = 5},
  [412] = {.lex_state = 5},
  [413] = {.lex_state = 5},
  [414] = {.lex_state = 5},
  [415] = {.lex_state = 5},
  [416] = {.lex_state = 5},
  [417] = {.lex_state = 5},
  [418] = {.lex_state = 5},
  [419] = {.lex_state = 5},
  [420] = {.lex_state = 5},
  [421] = {.lex_state = 5},
  [422] = {.lex_state = 5},
  [423] = {.lex_state = 5},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 6},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6},
  [438] = {.lex_state = 6},
  [439] = {.lex_state = 6},
  [440] = {.lex_state = 6},
  [441] = {.lex_state = 6},
  [442] = {.lex_state = 6},
  [443] = {.lex_state = 6},
  [444] = {.lex_state = 6},
  [445] = {.lex_state = 6},
  [446] = {.lex_state = 6},
  [447] = {.lex_state = 6},
  [448] = {.lex_state = 6},
  [449] = {.lex_state = 6},
  [450] = {.lex_state = 6},
  [451] = {.lex_state = 6},
  [452] = {.lex_state = 6},
  [453] = {.lex_state = 6},
  [454] = {.lex_state = 6},
  [455] = {.lex_state = 6},
  [456] = {.lex_state = 6},
  [457] = {.lex_state = 6},
  [458] = {.lex_state = 6},
  [459] = {.lex_state = 6},
  [460] = {.lex_state = 6},
  [461] = {.lex_state = 6},
  [462] = {.lex_state = 6},
  [463] = {.lex_state = 2},
  [464] = {.lex_state = 57},
  [465] = {.lex_state = 6},
  [466] = {.lex_state = 6},
  [467] = {.lex_state = 6},
  [468] = {.lex_state = 2},
  [469] = {.lex_state = 2},
  [470] = {.lex_state = 57},
  [471] = {.lex_state = 7},
  [472] = {.lex_state = 7},
  [473] = {.lex_state = 57},
  [474] = {.lex_state = 2},
  [475] = {.lex_state = 57},
  [476] = {.lex_state = 2},
  [477] = {.lex_state = 2},
  [478] = {.lex_state = 2},
  [479] = {.lex_state = 2},
  [480] = {.lex_state = 2},
  [481] = {.lex_state = 2},
  [482] = {.lex_state = 7},
  [483] = {.lex_state = 7},
  [484] = {.lex_state = 2},
  [485] = {.lex_state = 7},
  [486] = {.lex_state = 7},
  [487] = {.lex_state = 7},
  [488] = {.lex_state = 2},
  [489] = {.lex_state = 7},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 6},
  [492] = {.lex_state = 2},
  [493] = {.lex_state = 2},
  [494] = {.lex_state = 2},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 2},
  [497] = {.lex_state = 2},
  [498] = {.lex_state = 6},
  [499] = {.lex_state = 2},
  [500] = {.lex_state = 2},
  [501] = {.lex_state = 2},
  [502] = {.lex_state = 2},
  [503] = {.lex_state = 2},
  [504] = {.lex_state = 2},
  [505] = {.lex_state = 2},
  [506] = {.lex_state = 2},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 2},
  [509] = {.lex_state = 6},
  [510] = {.lex_state = 2},
  [511] = {.lex_state = 2},
  [512] = {.lex_state = 6},
  [513] = {.lex_state = 6},
  [514] = {.lex_state = 2},
  [515] = {.lex_state = 6},
  [516] = {.lex_state = 2},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 2},
  [519] = {.lex_state = 6},
  [520] = {.lex_state = 2},
  [521] = {.lex_state = 2},
  [522] = {.lex_state = 2},
  [523] = {.lex_state = 2},
  [524] = {.lex_state = 2},
  [525] = {.lex_state = 6},
  [526] = {.lex_state = 2},
  [527] = {.lex_state = 2},
  [528] = {.lex_state = 7},
  [529] = {.lex_state = 2},
  [530] = {.lex_state = 6},
  [531] = {.lex_state = 2},
  [532] = {.lex_state = 2},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 2},
  [535] = {.lex_state = 2},
  [536] = {.lex_state = 2},
  [537] = {.lex_state = 2},
  [538] = {.lex_state = 2},
  [539] = {.lex_state = 6},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 7},
  [542] = {.lex_state = 6},
  [543] = {.lex_state = 6},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 7},
  [546] = {.lex_state = 7},
  [547] = {.lex_state = 6},
  [548] = {.lex_state = 6},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 7},
  [551] = {.lex_state = 7},
  [552] = {.lex_state = 6},
  [553] = {.lex_state = 7},
  [554] = {.lex_state = 6},
  [555] = {.lex_state = 7},
  [556] = {.lex_state = 6},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 7},
  [559] = {.lex_state = 7},
  [560] = {.lex_state = 7},
  [561] = {.lex_state = 7},
  [562] = {.lex_state = 6},
  [563] = {.lex_state = 6},
  [564] = {.lex_state = 7},
  [565] = {.lex_state = 7},
  [566] = {.lex_state = 7},
  [567] = {.lex_state = 7},
  [568] = {.lex_state = 7},
  [569] = {.lex_state = 7},
  [570] = {.lex_state = 7},
  [571] = {.lex_state = 7},
  [572] = {.lex_state = 7},
  [573] = {.lex_state = 7},
  [574] = {.lex_state = 7},
  [575] = {.lex_state = 7},
  [576] = {.lex_state = 6},
  [577] = {.lex_state = 7},
  [578] = {.lex_state = 6},
  [579] = {.lex_state = 6},
  [580] = {.lex_state = 6},
  [581] = {.lex_state = 7},
  [582] = {.lex_state = 7},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 7},
  [585] = {.lex_state = 7},
  [586] = {.lex_state = 7},
  [587] = {.lex_state = 7},
  [588] = {.lex_state = 7},
  [589] = {.lex_state = 7},
  [590] = {.lex_state = 7},
  [591] = {.lex_state = 7},
  [592] = {.lex_state = 6},
  [593] = {.lex_state = 6},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 6},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 6},
  [598] = {.lex_state = 6},
  [599] = {.lex_state = 6},
  [600] = {.lex_state = 6},
  [601] = {.lex_state = 6},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 6},
  [605] = {.lex_state = 6},
  [606] = {.lex_state = 6},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 6},
  [609] = {.lex_state = 6},
  [610] = {.lex_state = 6},
  [611] = {.lex_state = 6},
  [612] = {.lex_state = 6},
  [613] = {.lex_state = 6},
  [614] = {.lex_state = 6},
  [615] = {.lex_state = 6},
  [616] = {.lex_state = 6},
  [617] = {.lex_state = 6},
  [618] = {.lex_state = 6},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 6},
  [621] = {.lex_state = 6},
  [622] = {.lex_state = 6},
  [623] = {.lex_state = 6},
  [624] = {.lex_state = 6},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 6},
  [627] = {.lex_state = 6},
  [628] = {.lex_state = 6},
  [629] = {.lex_state = 6},
  [630] = {.lex_state = 6},
  [631] = {.lex_state = 6},
  [632] = {.lex_state = 6},
  [633] = {.lex_state = 6},
  [634] = {.lex_state = 6},
  [635] = {.lex_state = 6},
  [636] = {.lex_state = 6},
  [637] = {.lex_state = 6},
  [638] = {.lex_state = 6},
  [639] = {.lex_state = 6},
  [640] = {.lex_state = 6},
  [641] = {.lex_state = 6},
  [642] = {.lex_state = 57},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 6},
  [645] = {.lex_state = 6},
  [646] = {.lex_state = 6},
  [647] = {.lex_state = 6},
  [648] = {.lex_state = 6},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 6},
  [651] = {.lex_state = 6},
  [652] = {.lex_state = 6},
  [653] = {.lex_state = 6},
  [654] = {.lex_state = 6},
  [655] = {.lex_state = 6},
  [656] = {.lex_state = 6},
  [657] = {.lex_state = 6},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 6},
  [660] = {.lex_state = 6},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 6},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 57},
  [747] = {.lex_state = 57},
  [748] = {.lex_state = 57},
  [749] = {.lex_state = 57},
  [750] = {.lex_state = 57},
  [751] = {.lex_state = 57},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 57},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 57},
  [786] = {.lex_state = 57},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 57},
  [789] = {.lex_state = 57},
  [790] = {.lex_state = 57},
  [791] = {.lex_state = 57},
  [792] = {.lex_state = 57},
  [793] = {.lex_state = 57},
  [794] = {.lex_state = 57},
  [795] = {.lex_state = 57},
  [796] = {.lex_state = 57},
  [797] = {.lex_state = 57},
  [798] = {.lex_state = 57},
  [799] = {.lex_state = 57},
  [800] = {.lex_state = 57},
  [801] = {.lex_state = 57},
  [802] = {.lex_state = 57},
  [803] = {.lex_state = 57},
  [804] = {.lex_state = 57},
  [805] = {.lex_state = 57},
  [806] = {.lex_state = 57},
  [807] = {.lex_state = 57},
  [808] = {.lex_state = 57},
  [809] = {.lex_state = 57},
  [810] = {.lex_state = 57},
  [811] = {.lex_state = 57},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 57},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 57},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 0},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 57},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 57},
  [842] = {.lex_state = 0},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 57},
  [845] = {.lex_state = 57},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 57},
  [848] = {.lex_state = 57},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 57},
  [851] = {.lex_state = 0},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 57},
  [855] = {.lex_state = 57},
  [856] = {.lex_state = 57},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 57},
  [859] = {.lex_state = 57},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 57},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 57},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 57},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 57},
  [877] = {.lex_state = 57},
  [878] = {.lex_state = 57},
  [879] = {.lex_state = 57},
  [880] = {.lex_state = 57},
  [881] = {.lex_state = 57},
  [882] = {.lex_state = 57},
  [883] = {.lex_state = 57},
  [884] = {.lex_state = 57},
  [885] = {.lex_state = 57},
  [886] = {.lex_state = 57},
  [887] = {.lex_state = 57},
  [888] = {.lex_state = 57},
  [889] = {.lex_state = 57},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 57},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 57},
  [894] = {.lex_state = 57},
  [895] = {.lex_state = 57},
  [896] = {.lex_state = 57},
  [897] = {.lex_state = 57},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 57},
  [901] = {.lex_state = 57},
  [902] = {.lex_state = 57},
  [903] = {.lex_state = 57},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 57},
  [906] = {.lex_state = 57},
  [907] = {.lex_state = 57},
  [908] = {.lex_state = 57},
  [909] = {.lex_state = 57},
  [910] = {.lex_state = 57},
  [911] = {.lex_state = 57},
  [912] = {.lex_state = 57},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 57},
  [915] = {.lex_state = 57},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 57},
  [918] = {.lex_state = 57},
  [919] = {.lex_state = 57},
  [920] = {.lex_state = 57},
  [921] = {.lex_state = 57},
  [922] = {.lex_state = 57},
  [923] = {.lex_state = 57},
  [924] = {.lex_state = 57},
  [925] = {.lex_state = 57},
  [926] = {.lex_state = 57},
  [927] = {.lex_state = 57},
  [928] = {.lex_state = 57},
  [929] = {.lex_state = 57},
  [930] = {.lex_state = 57},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 57},
  [934] = {.lex_state = 57},
  [935] = {.lex_state = 0},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 57},
  [938] = {.lex_state = 57},
  [939] = {.lex_state = 57},
  [940] = {.lex_state = 3},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 57},
  [943] = {.lex_state = 57},
  [944] = {.lex_state = 3},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 3},
  [950] = {.lex_state = 3},
  [951] = {.lex_state = 3},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 3},
  [956] = {.lex_state = 3},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 57},
  [959] = {.lex_state = 57},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 3},
  [962] = {.lex_state = 57},
  [963] = {.lex_state = 3},
  [964] = {.lex_state = 3},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 57},
  [968] = {.lex_state = 57},
  [969] = {.lex_state = 57},
  [970] = {.lex_state = 3},
  [971] = {.lex_state = 57},
  [972] = {.lex_state = 3},
  [973] = {.lex_state = 57},
  [974] = {.lex_state = 57},
  [975] = {.lex_state = 3},
  [976] = {.lex_state = 3},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 57},
  [979] = {.lex_state = 57},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 57},
  [982] = {.lex_state = 57},
  [983] = {.lex_state = 3},
  [984] = {.lex_state = 57},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 57},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 57},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 57},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 57},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 57},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 57},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 57},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 57},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 57},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 57},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 57},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 57},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 57},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 57},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 57},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 57},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 57},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 57},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_blank_identifier] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_chan] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_fallthrough] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_go] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_range] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_make] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_imaginary_literal] = ACTIONS(1),
    [sym_rune_literal] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_iota] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(1207),
    [sym_package_clause] = STATE(259),
    [sym_import_declaration] = STATE(259),
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_function_declaration] = STATE(259),
    [sym_method_declaration] = STATE(259),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(1108),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_package_clause] = STATE(259),
    [sym_import_declaration] = STATE(259),
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_function_declaration] = STATE(259),
    [sym_method_declaration] = STATE(259),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(1108),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(73),
    [sym_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(78),
    [anon_sym_package] = ACTIONS(81),
    [anon_sym_import] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(87),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_var] = ACTIONS(93),
    [anon_sym_func] = ACTIONS(96),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_type] = ACTIONS(102),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(108),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(114),
    [anon_sym_map] = ACTIONS(117),
    [anon_sym_chan] = ACTIONS(120),
    [anon_sym_LT_DASH] = ACTIONS(123),
    [anon_sym_fallthrough] = ACTIONS(126),
    [anon_sym_break] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(132),
    [anon_sym_goto] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(138),
    [anon_sym_go] = ACTIONS(141),
    [anon_sym_defer] = ACTIONS(144),
    [anon_sym_if] = ACTIONS(147),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_switch] = ACTIONS(153),
    [anon_sym_select] = ACTIONS(156),
    [anon_sym_new] = ACTIONS(159),
    [anon_sym_make] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_BANG] = ACTIONS(162),
    [anon_sym_CARET] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
    [sym_raw_string_literal] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_int_literal] = ACTIONS(171),
    [sym_float_literal] = ACTIONS(171),
    [sym_imaginary_literal] = ACTIONS(165),
    [sym_rune_literal] = ACTIONS(165),
    [sym_nil] = ACTIONS(171),
    [sym_true] = ACTIONS(171),
    [sym_false] = ACTIONS(171),
    [sym_iota] = ACTIONS(171),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_package_clause] = STATE(259),
    [sym_import_declaration] = STATE(259),
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_function_declaration] = STATE(259),
    [sym_method_declaration] = STATE(259),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(1108),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(174),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1016),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1016),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(180),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(182),
    [anon_sym_default] = ACTIONS(182),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1008),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1008),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(184),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_default] = ACTIONS(186),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1007),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1007),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(188),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(190),
    [anon_sym_default] = ACTIONS(190),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1010),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1010),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(192),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(194),
    [anon_sym_default] = ACTIONS(194),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1079),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1079),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(196),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_default] = ACTIONS(198),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(917),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(996),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(200),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(202),
    [anon_sym_default] = ACTIONS(202),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(917),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1044),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(204),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(206),
    [anon_sym_default] = ACTIONS(206),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(888),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(208),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(210),
    [anon_sym_default] = ACTIONS(210),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1163),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1163),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(212),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1177),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1177),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(214),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1152),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1152),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1195),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1195),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(218),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1213),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1213),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(220),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1193),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1193),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement_list] = STATE(1219),
    [sym__statement] = STATE(854),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_empty_labeled_statement] = STATE(1219),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(224),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(888),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__declaration] = STATE(911),
    [sym_const_declaration] = STATE(911),
    [sym_var_declaration] = STATE(911),
    [sym_type_declaration] = STATE(911),
    [sym_expression_list] = STATE(759),
    [sym_parenthesized_type] = STATE(1205),
    [sym__simple_type] = STATE(1205),
    [sym_generic_type] = STATE(999),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(999),
    [sym_implicit_length_array_type] = STATE(1107),
    [sym_slice_type] = STATE(999),
    [sym_struct_type] = STATE(999),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(999),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(911),
    [sym__statement] = STATE(917),
    [sym_empty_statement] = STATE(911),
    [sym__simple_statement] = STATE(911),
    [sym_send_statement] = STATE(877),
    [sym_inc_statement] = STATE(877),
    [sym_dec_statement] = STATE(877),
    [sym_assignment_statement] = STATE(877),
    [sym_short_var_declaration] = STATE(877),
    [sym_labeled_statement] = STATE(911),
    [sym_fallthrough_statement] = STATE(911),
    [sym_break_statement] = STATE(911),
    [sym_continue_statement] = STATE(911),
    [sym_goto_statement] = STATE(911),
    [sym_return_statement] = STATE(911),
    [sym_go_statement] = STATE(911),
    [sym_defer_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_for_statement] = STATE(911),
    [sym_expression_switch_statement] = STATE(911),
    [sym_type_switch_statement] = STATE(911),
    [sym_select_statement] = STATE(911),
    [sym__expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_selector_expression] = STATE(319),
    [sym_index_expression] = STATE(319),
    [sym_slice_expression] = STATE(319),
    [sym_type_assertion_expression] = STATE(319),
    [sym_type_conversion_expression] = STATE(319),
    [sym_composite_literal] = STATE(319),
    [sym_func_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_qualified_type] = STATE(999),
    [sym_interpreted_string_literal] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_expression_list] = STATE(762),
    [sym_parenthesized_type] = STATE(1228),
    [sym__simple_type] = STATE(1228),
    [sym_generic_type] = STATE(1050),
    [sym_pointer_type] = STATE(813),
    [sym_array_type] = STATE(1050),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1050),
    [sym_struct_type] = STATE(1050),
    [sym_interface_type] = STATE(813),
    [sym_map_type] = STATE(1050),
    [sym_channel_type] = STATE(813),
    [sym_function_type] = STATE(813),
    [sym_block] = STATE(915),
    [sym__simple_statement] = STATE(1165),
    [sym_send_statement] = STATE(1136),
    [sym_inc_statement] = STATE(1136),
    [sym_dec_statement] = STATE(1136),
    [sym_assignment_statement] = STATE(1136),
    [sym_short_var_declaration] = STATE(1136),
    [sym_for_clause] = STATE(1147),
    [sym_range_clause] = STATE(1147),
    [sym__expression] = STATE(300),
    [sym_parenthesized_expression] = STATE(378),
    [sym_call_expression] = STATE(378),
    [sym_selector_expression] = STATE(378),
    [sym_index_expression] = STATE(378),
    [sym_slice_expression] = STATE(378),
    [sym_type_assertion_expression] = STATE(378),
    [sym_type_conversion_expression] = STATE(378),
    [sym_composite_literal] = STATE(378),
    [sym_func_literal] = STATE(378),
    [sym_unary_expression] = STATE(378),
    [sym_binary_expression] = STATE(378),
    [sym_qualified_type] = STATE(1050),
    [sym_interpreted_string_literal] = STATE(378),
    [sym_identifier] = ACTIONS(226),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(230),
    [anon_sym_func] = ACTIONS(232),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(234),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(236),
    [anon_sym_range] = ACTIONS(238),
    [anon_sym_new] = ACTIONS(240),
    [anon_sym_make] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(242),
    [anon_sym_AMP] = ACTIONS(242),
    [sym_raw_string_literal] = ACTIONS(244),
    [anon_sym_DQUOTE] = ACTIONS(246),
    [sym_int_literal] = ACTIONS(248),
    [sym_float_literal] = ACTIONS(248),
    [sym_imaginary_literal] = ACTIONS(244),
    [sym_rune_literal] = ACTIONS(244),
    [sym_nil] = ACTIONS(248),
    [sym_true] = ACTIONS(248),
    [sym_false] = ACTIONS(248),
    [sym_iota] = ACTIONS(248),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    STATE(337), 1,
      sym__expression,
    STATE(760), 1,
      sym_expression_list,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    STATE(1158), 1,
      sym__type_switch_header,
    STATE(1159), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1136), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [118] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(252), 1,
      anon_sym_LBRACE,
    STATE(340), 1,
      sym__expression,
    STATE(763), 1,
      sym_expression_list,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    STATE(1153), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1136), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [233] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(254), 1,
      anon_sym_LBRACE,
    STATE(340), 1,
      sym__expression,
    STATE(763), 1,
      sym_expression_list,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    STATE(1161), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1136), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [348] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(256), 1,
      anon_sym_LBRACE,
    STATE(340), 1,
      sym__expression,
    STATE(763), 1,
      sym_expression_list,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    STATE(1203), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1136), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [463] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(258), 1,
      anon_sym_LBRACE,
    STATE(340), 1,
      sym__expression,
    STATE(763), 1,
      sym_expression_list,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    STATE(1222), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1136), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [578] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(301), 1,
      sym__expression,
    STATE(758), 1,
      sym_expression_list,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    STATE(1167), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1136), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [690] = 17,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(266), 1,
      anon_sym_LPAREN,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(270), 1,
      anon_sym_LBRACK,
    ACTIONS(272), 1,
      anon_sym_STAR,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(284), 1,
      anon_sym_LT_DASH,
    ACTIONS(286), 1,
      sym_comment,
    STATE(273), 1,
      sym_block,
    ACTIONS(260), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(242), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(264), 34,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [786] = 17,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(266), 1,
      anon_sym_LPAREN,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(270), 1,
      anon_sym_LBRACK,
    ACTIONS(272), 1,
      anon_sym_STAR,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(284), 1,
      anon_sym_LT_DASH,
    ACTIONS(286), 1,
      sym_comment,
    STATE(291), 1,
      sym_block,
    ACTIONS(288), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(239), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(290), 34,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [882] = 17,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(266), 1,
      anon_sym_LPAREN,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(270), 1,
      anon_sym_LBRACK,
    ACTIONS(272), 1,
      anon_sym_STAR,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(284), 1,
      anon_sym_LT_DASH,
    ACTIONS(286), 1,
      sym_comment,
    STATE(243), 1,
      sym_block,
    ACTIONS(292), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(241), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(294), 34,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [978] = 24,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(298), 1,
      anon_sym_LF,
    ACTIONS(302), 1,
      anon_sym_LPAREN,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(306), 1,
      anon_sym_LBRACK,
    ACTIONS(308), 1,
      anon_sym_STAR,
    ACTIONS(310), 1,
      anon_sym_LT_DASH,
    ACTIONS(318), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(918), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(300), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(314), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    ACTIONS(316), 9,
      sym_raw_string_literal,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1087] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(322), 1,
      sym_identifier,
    ACTIONS(327), 1,
      anon_sym_LPAREN,
    ACTIONS(330), 1,
      anon_sym_func,
    ACTIONS(333), 1,
      anon_sym_LBRACK,
    ACTIONS(336), 1,
      anon_sym_STAR,
    ACTIONS(339), 1,
      anon_sym_struct,
    ACTIONS(342), 1,
      anon_sym_interface,
    ACTIONS(345), 1,
      anon_sym_map,
    ACTIONS(348), 1,
      anon_sym_chan,
    ACTIONS(351), 1,
      anon_sym_LT_DASH,
    ACTIONS(320), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(253), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(325), 35,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_LBRACE,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [1178] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_RBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1290] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1041), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1402] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(380), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1514] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(382), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1019), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1626] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(384), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1075), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1738] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(386), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1062), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1850] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(388), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1962] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(390), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2074] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2186] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(394), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2298] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(396), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2410] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(398), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1055), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2522] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(400), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(988), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2634] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2746] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(404), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2858] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(406), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2970] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(408), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3082] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_RBRACE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3194] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(354), 1,
      sym_identifier,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    STATE(562), 1,
      sym__expression,
    STATE(1057), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_keyed_element,
      sym_element,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3303] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(471), 1,
      sym__expression,
    STATE(1123), 1,
      sym_expression_list,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1194), 2,
      sym_send_statement,
      sym_receive_statement,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3409] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(628), 1,
      sym__expression,
    STATE(1102), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3514] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_RPAREN,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3619] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(444), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3724] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(446), 1,
      anon_sym_RPAREN,
    STATE(525), 1,
      sym__expression,
    STATE(1022), 1,
      sym_variadic_argument,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3829] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(448), 1,
      anon_sym_RPAREN,
    STATE(519), 1,
      sym__expression,
    STATE(1037), 1,
      sym_variadic_argument,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3934] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(627), 1,
      sym__expression,
    STATE(1104), 1,
      sym_literal_value,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4039] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(450), 1,
      anon_sym_range,
    STATE(530), 1,
      sym__expression,
    STATE(1094), 1,
      sym_expression_list,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4144] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(452), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4249] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(454), 1,
      anon_sym_RPAREN,
    STATE(533), 1,
      sym__expression,
    STATE(1048), 1,
      sym_variadic_argument,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4354] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(456), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4459] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_LBRACE,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(495), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1204), 1,
      sym_expression_list,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4564] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(468), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4669] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4774] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4879] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(474), 1,
      anon_sym_RPAREN,
    STATE(513), 1,
      sym__expression,
    STATE(1073), 1,
      sym_variadic_argument,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4984] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(450), 1,
      anon_sym_range,
    STATE(530), 1,
      sym__expression,
    STATE(1096), 1,
      sym_expression_list,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5089] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(476), 1,
      anon_sym_RBRACK,
    ACTIONS(478), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(636), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5194] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(480), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5299] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(482), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5404] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(484), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5509] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5614] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
    STATE(509), 1,
      sym__expression,
    STATE(1064), 1,
      sym_variadic_argument,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5719] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5824] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(492), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_RBRACK,
    ACTIONS(496), 1,
      anon_sym_STAR,
    STATE(652), 1,
      sym__expression,
    STATE(1029), 1,
      sym_parameter_declaration,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1011), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5929] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(498), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1077), 1,
      sym_variadic_argument,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6034] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(556), 1,
      sym__expression,
    STATE(1096), 1,
      sym_expression_list,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6136] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(900), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6238] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(934), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6340] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(930), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6442] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(512), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6544] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(530), 1,
      sym__expression,
    STATE(1094), 1,
      sym_expression_list,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6646] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(530), 1,
      sym__expression,
    STATE(1096), 1,
      sym_expression_list,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6748] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    ACTIONS(516), 1,
      anon_sym_COLON,
    STATE(605), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(980), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6850] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(518), 1,
      anon_sym_RBRACK,
    STATE(621), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6952] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(929), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7054] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(927), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7156] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    ACTIONS(520), 1,
      anon_sym_COLON,
    STATE(612), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(980), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7258] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    ACTIONS(522), 1,
      anon_sym_RBRACK,
    STATE(650), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(980), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7360] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(522), 1,
      anon_sym_RBRACK,
    STATE(650), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7462] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(524), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7564] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(526), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7666] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(528), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7768] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(542), 1,
      sym__expression,
    STATE(1094), 1,
      sym_expression_list,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7870] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(563), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1114), 1,
      sym_variadic_argument,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7972] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(476), 1,
      anon_sym_RBRACK,
    STATE(636), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8074] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(530), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    STATE(1216), 1,
      sym_expression_list,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8176] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(530), 1,
      anon_sym_RBRACK,
    STATE(617), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8278] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_SEMI,
    STATE(654), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8380] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8482] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    ACTIONS(536), 1,
      anon_sym_COLON,
    STATE(618), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(980), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8584] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8686] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(540), 1,
      anon_sym_RBRACK,
    STATE(622), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8788] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_RBRACK,
    STATE(632), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8890] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(544), 1,
      anon_sym_RBRACK,
    STATE(615), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8992] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9094] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    ACTIONS(548), 1,
      anon_sym_COLON,
    STATE(601), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(980), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9196] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(550), 1,
      anon_sym_SEMI,
    STATE(638), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9298] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(552), 1,
      anon_sym_RBRACK,
    STATE(595), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9400] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(554), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9502] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(556), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9604] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(558), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9706] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(560), 1,
      anon_sym_RBRACK,
    STATE(614), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9808] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    ACTIONS(562), 1,
      anon_sym_COLON,
    STATE(593), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(980), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9910] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(895), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10012] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_RBRACK,
    STATE(611), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10114] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10216] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_RBRACK,
    STATE(652), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10318] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(568), 1,
      anon_sym_RBRACK,
    STATE(599), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10420] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10522] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(556), 1,
      sym__expression,
    STATE(1094), 1,
      sym_expression_list,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10624] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(889), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10726] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(891), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10828] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_RBRACK,
    STATE(616), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10930] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(897), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11032] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(574), 1,
      anon_sym_RBRACK,
    STATE(626), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11134] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_RBRACK,
    STATE(597), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11236] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(901), 1,
      sym_expression_list,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11338] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    ACTIONS(578), 1,
      anon_sym_COLON,
    STATE(613), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(980), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11440] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11542] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(480), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11641] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    STATE(299), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1205), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11740] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(477), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11839] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(604), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11938] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    STATE(297), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1205), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12037] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    STATE(298), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1205), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12136] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(489), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12235] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_STAR,
    STATE(633), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1122), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12334] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(469), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12433] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(578), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12532] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(637), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12631] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(657), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12730] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    STATE(295), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1205), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12829] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(388), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12928] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(659), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13027] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(344), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13126] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(592), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13225] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13324] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_STAR,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13423] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(579), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13522] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(580), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13621] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(382), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13720] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(554), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13819] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13918] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(610), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14017] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(341), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14116] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(424), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14215] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14314] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14413] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(576), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14512] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14611] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(467), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14710] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(485), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14809] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(382), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14908] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(382), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15007] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(462), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15106] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(648), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15205] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15304] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(424), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15403] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(466), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(465), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15601] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(656), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15700] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(486), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15799] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(543), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15898] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(651), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15997] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(547), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16096] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_STAR,
    STATE(634), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1122), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16195] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(548), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16294] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(469), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16393] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(609), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16492] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(487), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16591] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(474), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16690] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(639), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16789] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(483), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16888] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(387), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16987] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(488), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17086] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(663), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17185] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17284] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(647), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17383] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17482] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(644), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17581] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_STAR,
    STATE(635), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1122), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17680] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17779] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(478), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17878] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(469), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17977] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(640), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18076] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(345), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18175] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    STATE(294), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1205), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18274] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(345), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18373] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(476), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18472] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18571] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(608), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18670] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(496), 1,
      anon_sym_STAR,
    ACTIONS(514), 1,
      sym_identifier,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18769] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(296), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_func,
    ACTIONS(500), 1,
      anon_sym_LPAREN,
    ACTIONS(502), 1,
      anon_sym_STAR,
    ACTIONS(504), 1,
      anon_sym_LT_DASH,
    ACTIONS(510), 1,
      anon_sym_DQUOTE,
    STATE(490), 1,
      sym__expression,
    STATE(1089), 1,
      sym_implicit_length_array_type,
    ACTIONS(312), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1227), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(508), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(506), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(316), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(994), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(536), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18868] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(624), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18967] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(620), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19066] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(483), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19165] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_STAR,
    STATE(646), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1122), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19264] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(345), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19363] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_STAR,
    STATE(630), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1122), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19462] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(631), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19561] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    ACTIONS(606), 1,
      anon_sym_chan,
    STATE(294), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1205), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19660] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(482), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19759] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_func,
    ACTIONS(418), 1,
      anon_sym_STAR,
    ACTIONS(420), 1,
      anon_sym_LT_DASH,
    ACTIONS(428), 1,
      anon_sym_DQUOTE,
    STATE(483), 1,
      sym__expression,
    STATE(1126), 1,
      sym_implicit_length_array_type,
    ACTIONS(422), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(426), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(430), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1051), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(553), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19858] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(343), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19957] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(653), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20056] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(641), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20155] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_STAR,
    STATE(645), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1122), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20254] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(655), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20353] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(338), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20452] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(383), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20551] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(660), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20650] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(425), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20749] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(384), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20848] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    STATE(294), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(948), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20947] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(598), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21046] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(385), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21145] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      sym_identifier,
    ACTIONS(460), 1,
      anon_sym_STAR,
    ACTIONS(464), 1,
      anon_sym_LT_DASH,
    STATE(623), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(466), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21244] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(342), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1228), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1050), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(378), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21343] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(586), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_func,
    ACTIONS(592), 1,
      anon_sym_STAR,
    ACTIONS(594), 1,
      anon_sym_LT_DASH,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(386), 1,
      sym__expression,
    STATE(1095), 1,
      sym_implicit_length_array_type,
    ACTIONS(596), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1229), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(600), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(598), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(604), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1076), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(409), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21442] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(606), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21541] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(582), 1,
      sym_identifier,
    STATE(296), 1,
      sym__expression,
    STATE(1107), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1205), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(999), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(319), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21640] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(629), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21739] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(360), 1,
      anon_sym_STAR,
    ACTIONS(366), 1,
      anon_sym_LT_DASH,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    STATE(491), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(370), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21838] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_func,
    ACTIONS(374), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(438), 1,
      anon_sym_STAR,
    ACTIONS(440), 1,
      anon_sym_LT_DASH,
    STATE(424), 1,
      sym__expression,
    STATE(1112), 1,
      sym_implicit_length_array_type,
    ACTIONS(368), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1224), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(372), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(813), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(442), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(376), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(862), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(436), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21937] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_DOT,
    ACTIONS(614), 1,
      anon_sym_LBRACK,
    STATE(287), 1,
      sym_type_arguments,
    ACTIONS(608), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(610), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22000] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(621), 1,
      anon_sym_DOT,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(627), 1,
      anon_sym_LBRACK,
    ACTIONS(630), 1,
      anon_sym_LBRACE,
    ACTIONS(632), 1,
      anon_sym_COLON,
    STATE(330), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22070] = 5,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(286), 1,
      sym_comment,
    STATE(269), 1,
      sym_block,
    ACTIONS(634), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(636), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22130] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(621), 1,
      anon_sym_DOT,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(627), 1,
      anon_sym_LBRACK,
    ACTIONS(630), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      anon_sym_COLON,
    STATE(330), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22200] = 5,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(286), 1,
      sym_comment,
    STATE(271), 1,
      sym_block,
    ACTIONS(640), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(642), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22260] = 5,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(286), 1,
      sym_comment,
    STATE(270), 1,
      sym_block,
    ACTIONS(644), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(646), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22320] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(648), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(650), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22375] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(652), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(654), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22430] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(656), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(658), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22485] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(621), 1,
      anon_sym_DOT,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(627), 1,
      anon_sym_LBRACK,
    ACTIONS(630), 1,
      anon_sym_LBRACE,
    STATE(330), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22552] = 19,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_LF,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(666), 1,
      anon_sym_LPAREN,
    ACTIONS(668), 1,
      anon_sym_COMMA,
    ACTIONS(672), 1,
      anon_sym_LBRACK,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(680), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(682), 1,
      anon_sym_DASH_DASH,
    ACTIONS(686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(688), 1,
      anon_sym_PIPE_PIPE,
    STATE(317), 1,
      sym_argument_list,
    STATE(757), 1,
      aux_sym_expression_list_repeat1,
    STATE(1149), 1,
      sym_type_arguments,
    ACTIONS(662), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(676), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(684), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(674), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(670), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [22639] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(690), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(692), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22694] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(694), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(696), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22749] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(698), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(700), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22804] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(702), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(704), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22859] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(706), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(708), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22914] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(710), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(712), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22969] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(714), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(716), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23024] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(718), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(720), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23079] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(722), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(724), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23134] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(726), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(728), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23189] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(730), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(732), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23244] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(734), 1,
      ts_builtin_sym_end,
    ACTIONS(738), 1,
      anon_sym_LF,
    ACTIONS(740), 1,
      anon_sym_SEMI,
    ACTIONS(736), 44,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23303] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(745), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23358] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(747), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(749), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23413] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(751), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(753), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23468] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(755), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(757), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23523] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(759), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(761), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23578] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(763), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(765), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23633] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(767), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(769), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23688] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(771), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(773), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23743] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(775), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(777), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23798] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(779), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(781), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23853] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(783), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(785), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23908] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(787), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(789), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23963] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(791), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(793), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24018] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(795), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(797), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24073] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(799), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(801), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24128] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(730), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(732), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24183] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(730), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(732), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24238] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(803), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(805), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24293] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(812), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_COMMA,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(821), 1,
      anon_sym_LBRACK,
    ACTIONS(824), 1,
      anon_sym_RBRACK,
    ACTIONS(827), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    STATE(432), 1,
      sym_literal_value,
    STATE(668), 1,
      aux_sym_const_spec_repeat1,
    STATE(839), 1,
      sym_type_arguments,
    STATE(1033), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(619), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(617), 13,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24386] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(836), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(838), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24441] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(840), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(842), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24496] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(844), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(846), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24551] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(850), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24606] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(852), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(854), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24661] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(856), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(858), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24716] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(860), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(862), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24771] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(864), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(866), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24826] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(868), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(870), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24881] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(872), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(874), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24936] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(876), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(878), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24991] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(880), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(882), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [25046] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(884), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(886), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [25101] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(888), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(890), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [25156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_imaginary_literal,
      sym_rune_literal,
    ACTIONS(892), 30,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      sym_identifier,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [25210] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(666), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LF,
    STATE(317), 1,
      sym_argument_list,
    STATE(1149), 1,
      sym_type_arguments,
    ACTIONS(896), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25274] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(666), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_LBRACK,
    ACTIONS(898), 1,
      anon_sym_LF,
    STATE(317), 1,
      sym_argument_list,
    STATE(1149), 1,
      sym_type_arguments,
    ACTIONS(900), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25338] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(666), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_LBRACK,
    ACTIONS(898), 1,
      anon_sym_LF,
    STATE(317), 1,
      sym_argument_list,
    STATE(1149), 1,
      sym_type_arguments,
    ACTIONS(674), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(900), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25404] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(666), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_LBRACK,
    ACTIONS(898), 1,
      anon_sym_LF,
    STATE(317), 1,
      sym_argument_list,
    STATE(1149), 1,
      sym_type_arguments,
    ACTIONS(676), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(674), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(900), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25472] = 11,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(666), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_LBRACK,
    ACTIONS(898), 1,
      anon_sym_LF,
    STATE(317), 1,
      sym_argument_list,
    STATE(1149), 1,
      sym_type_arguments,
    ACTIONS(676), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(684), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(674), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(900), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25542] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_DOT,
    ACTIONS(666), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_LBRACK,
    ACTIONS(686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(898), 1,
      anon_sym_LF,
    STATE(317), 1,
      sym_argument_list,
    STATE(1149), 1,
      sym_type_arguments,
    ACTIONS(676), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(684), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(674), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(900), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
  [25614] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(660), 1,
      anon_sym_SEMI,
    ACTIONS(670), 1,
      anon_sym_EQ,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_COMMA,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(914), 1,
      anon_sym_LT_DASH,
    ACTIONS(918), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(920), 1,
      anon_sym_DASH_DASH,
    ACTIONS(926), 1,
      anon_sym_AMP_AMP,
    ACTIONS(928), 1,
      anon_sym_PIPE_PIPE,
    STATE(372), 1,
      sym_argument_list,
    STATE(757), 1,
      aux_sym_expression_list_repeat1,
    STATE(907), 1,
      sym_block,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(924), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(922), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(916), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [25705] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(660), 1,
      anon_sym_SEMI,
    ACTIONS(670), 1,
      anon_sym_EQ,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_COMMA,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(914), 1,
      anon_sym_LT_DASH,
    ACTIONS(918), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(920), 1,
      anon_sym_DASH_DASH,
    ACTIONS(926), 1,
      anon_sym_AMP_AMP,
    ACTIONS(928), 1,
      anon_sym_PIPE_PIPE,
    STATE(372), 1,
      sym_argument_list,
    STATE(757), 1,
      aux_sym_expression_list_repeat1,
    STATE(858), 1,
      sym_block,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(924), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(922), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(916), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [25796] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_LF,
    ACTIONS(854), 44,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25849] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_LF,
    ACTIONS(850), 44,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25902] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(930), 1,
      anon_sym_LPAREN,
    STATE(317), 1,
      sym_special_argument_list,
    ACTIONS(619), 42,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25959] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(932), 1,
      anon_sym_LF,
    ACTIONS(934), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26011] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_LF,
    ACTIONS(938), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26063] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(940), 1,
      anon_sym_LF,
    ACTIONS(942), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26115] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(944), 1,
      anon_sym_LF,
    ACTIONS(946), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26167] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(948), 1,
      anon_sym_LF,
    ACTIONS(950), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26219] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(952), 1,
      anon_sym_LF,
    ACTIONS(954), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26271] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(956), 1,
      anon_sym_LF,
    ACTIONS(958), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26323] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 1,
      anon_sym_LF,
    ACTIONS(745), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26375] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(960), 1,
      anon_sym_LF,
    ACTIONS(962), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26427] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(964), 1,
      anon_sym_LF,
    ACTIONS(966), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26479] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(968), 1,
      anon_sym_LF,
    ACTIONS(970), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26531] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LF,
    ACTIONS(974), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26583] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_LF,
    ACTIONS(978), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26635] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(980), 1,
      anon_sym_LF,
    ACTIONS(982), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26687] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(619), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26739] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(984), 1,
      anon_sym_LF,
    ACTIONS(986), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26791] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(988), 1,
      anon_sym_LF,
    ACTIONS(990), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26843] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(656), 1,
      anon_sym_LF,
    ACTIONS(658), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26895] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(992), 1,
      anon_sym_LF,
    ACTIONS(994), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26947] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_LF,
    ACTIONS(998), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26999] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1000), 1,
      anon_sym_LF,
    ACTIONS(1002), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27051] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1004), 1,
      anon_sym_LF,
    ACTIONS(1006), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27103] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1008), 1,
      anon_sym_LF,
    ACTIONS(1010), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27155] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1012), 1,
      anon_sym_LF,
    ACTIONS(1014), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27207] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1016), 1,
      anon_sym_LF,
    ACTIONS(1018), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27259] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1020), 1,
      anon_sym_LF,
    ACTIONS(1022), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27311] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_LF,
    ACTIONS(1026), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27363] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1028), 1,
      anon_sym_LF,
    ACTIONS(1030), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27415] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_LF,
    ACTIONS(1034), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27467] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_LF,
    ACTIONS(1038), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27519] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1040), 1,
      anon_sym_LF,
    ACTIONS(1042), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27571] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1044), 1,
      anon_sym_LF,
    ACTIONS(1046), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27623] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_SEMI,
    ACTIONS(670), 1,
      anon_sym_EQ,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_COMMA,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(914), 1,
      anon_sym_LT_DASH,
    ACTIONS(918), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(920), 1,
      anon_sym_DASH_DASH,
    ACTIONS(926), 1,
      anon_sym_AMP_AMP,
    ACTIONS(928), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1048), 1,
      anon_sym_DOT,
    ACTIONS(1050), 1,
      anon_sym_LBRACE,
    STATE(372), 1,
      sym_argument_list,
    STATE(757), 1,
      aux_sym_expression_list_repeat1,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(924), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(922), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(916), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [27711] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(372), 1,
      sym_argument_list,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(900), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27774] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    STATE(348), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27835] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_LBRACE,
    ACTIONS(670), 1,
      anon_sym_EQ,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_COMMA,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(918), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(920), 1,
      anon_sym_DASH_DASH,
    ACTIONS(926), 1,
      anon_sym_AMP_AMP,
    ACTIONS(928), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1055), 1,
      anon_sym_LT_DASH,
    STATE(372), 1,
      sym_argument_list,
    STATE(757), 1,
      aux_sym_expression_list_repeat1,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(924), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(922), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(916), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [27920] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      anon_sym_EQ,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(372), 1,
      sym_argument_list,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(924), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(922), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27989] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(372), 1,
      sym_argument_list,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(900), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(372), 1,
      sym_argument_list,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(900), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(898), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28115] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      anon_sym_EQ,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(926), 1,
      anon_sym_AMP_AMP,
    STATE(372), 1,
      sym_argument_list,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(924), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(922), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(910), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [28186] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(902), 1,
      anon_sym_DOT,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(372), 1,
      sym_argument_list,
    STATE(1116), 1,
      sym_type_arguments,
    ACTIONS(896), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    STATE(372), 1,
      sym_special_argument_list,
    ACTIONS(619), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1020), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1006), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(948), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1016), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1008), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1032), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(658), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(656), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(940), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1000), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(944), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(986), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(984), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(982), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(972), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1030), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1028), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(990), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(988), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(964), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(934), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(932), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(958), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(994), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(992), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(936), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1012), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(976), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1024), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1046), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1044), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1036), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(996), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(960), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(852), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29967] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    STATE(390), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30026] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_DOT,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    STATE(419), 1,
      sym_argument_list,
    STATE(1100), 1,
      sym_type_arguments,
    ACTIONS(896), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30082] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      anon_sym_EQ,
    ACTIONS(1061), 1,
      anon_sym_DOT,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1075), 1,
      anon_sym_AMP_AMP,
    STATE(419), 1,
      sym_argument_list,
    STATE(1100), 1,
      sym_type_arguments,
    ACTIONS(1073), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1069), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1071), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1067), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 14,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [30148] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      anon_sym_EQ,
    ACTIONS(1061), 1,
      anon_sym_DOT,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    STATE(419), 1,
      sym_argument_list,
    STATE(1100), 1,
      sym_type_arguments,
    ACTIONS(1073), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1069), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1071), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1067), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 15,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30212] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_DOT,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    STATE(419), 1,
      sym_argument_list,
    STATE(1100), 1,
      sym_type_arguments,
    ACTIONS(900), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1069), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1067), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30272] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_DOT,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    STATE(419), 1,
      sym_argument_list,
    STATE(1100), 1,
      sym_type_arguments,
    ACTIONS(900), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1067), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30330] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_DOT,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    STATE(419), 1,
      sym_argument_list,
    STATE(1100), 1,
      sym_type_arguments,
    ACTIONS(900), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(898), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30386] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_DOT,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1079), 1,
      anon_sym_EQ,
    ACTIONS(1081), 1,
      anon_sym_PIPE_PIPE,
    STATE(419), 1,
      sym_argument_list,
    STATE(1100), 1,
      sym_type_arguments,
    ACTIONS(1073), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1069), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1071), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1067), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(1077), 13,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [30454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1083), 1,
      anon_sym_LPAREN,
    STATE(419), 1,
      sym_special_argument_list,
    ACTIONS(619), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 21,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1020), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1012), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(658), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(656), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(990), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(988), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(936), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(994), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(992), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(986), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(984), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(940), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(982), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(972), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(964), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(960), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1030), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1028), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(852), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(958), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(996), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1000), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(948), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(944), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(934), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(932), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1006), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1046), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1044), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1024), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1032), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(976), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1036), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1016), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1008), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(900), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(898), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(896), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32103] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    STATE(432), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(824), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(619), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_LPAREN,
    STATE(433), 1,
      sym_special_argument_list,
    ACTIONS(619), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 23,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(994), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(992), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1012), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1000), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(944), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1020), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(976), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(852), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1030), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1028), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(658), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(656), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(936), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(990), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(988), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(996), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(940), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1032), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(958), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(948), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(934), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(932), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1006), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1036), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(986), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(984), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(982), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1016), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1008), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1046), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1044), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(972), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(964), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1024), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(960), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33561] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(900), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33618] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(621), 1,
      anon_sym_DOT,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(627), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LBRACE,
    STATE(538), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33669] = 21,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1107), 1,
      anon_sym_LF,
    ACTIONS(1111), 1,
      anon_sym_DOT,
    ACTIONS(1113), 1,
      anon_sym_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_COMMA,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LBRACK,
    ACTIONS(1121), 1,
      anon_sym_STAR,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1131), 1,
      anon_sym_LT_DASH,
    ACTIONS(1133), 1,
      sym_raw_string_literal,
    ACTIONS(1135), 1,
      anon_sym_DQUOTE,
    STATE(662), 1,
      aux_sym_field_name_list_repeat1,
    STATE(1003), 1,
      sym_interpreted_string_literal,
    ACTIONS(1109), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(844), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [33744] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(900), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
  [33807] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(900), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33868] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(900), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33921] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(916), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    STATE(521), 1,
      sym_argument_list,
    STATE(816), 1,
      aux_sym_expression_list_repeat1,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(670), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1155), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [33984] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(896), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34032] = 18,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LF,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1169), 1,
      anon_sym_EQ,
    ACTIONS(1171), 1,
      anon_sym_LBRACK,
    ACTIONS(1173), 1,
      anon_sym_STAR,
    ACTIONS(1175), 1,
      anon_sym_LT_DASH,
    STATE(473), 1,
      aux_sym_const_spec_repeat1,
    STATE(1190), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(1163), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [34100] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_EQ,
    ACTIONS(914), 1,
      anon_sym_LT_DASH,
    ACTIONS(916), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    ACTIONS(1189), 1,
      anon_sym_COLON,
    ACTIONS(1199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1201), 1,
      anon_sym_PIPE_PIPE,
    STATE(546), 1,
      sym_argument_list,
    STATE(853), 1,
      aux_sym_expression_list_repeat1,
    STATE(1133), 1,
      sym_type_arguments,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1197), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1195), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    STATE(545), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34222] = 18,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1171), 1,
      anon_sym_LBRACK,
    ACTIONS(1173), 1,
      anon_sym_STAR,
    ACTIONS(1175), 1,
      anon_sym_LT_DASH,
    ACTIONS(1205), 1,
      anon_sym_LF,
    ACTIONS(1209), 1,
      anon_sym_EQ,
    STATE(748), 1,
      aux_sym_const_spec_repeat1,
    STATE(1184), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(1207), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [34290] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(898), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(900), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34338] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_LF,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LBRACK,
    ACTIONS(1121), 1,
      anon_sym_STAR,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1131), 1,
      anon_sym_LT_DASH,
    ACTIONS(1211), 1,
      anon_sym_LPAREN,
    STATE(798), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(325), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [34400] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(898), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(900), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
    ACTIONS(1155), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34456] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1079), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1155), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34514] = 11,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(898), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1155), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(900), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34568] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(898), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(900), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34620] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(898), 1,
      anon_sym_LF,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(900), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34670] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1213), 1,
      anon_sym_LF,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1155), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34727] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    STATE(546), 1,
      sym_argument_list,
    STATE(1133), 1,
      sym_type_arguments,
    ACTIONS(900), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(898), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34774] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    STATE(546), 1,
      sym_argument_list,
    STATE(1133), 1,
      sym_type_arguments,
    ACTIONS(896), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34821] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(1217), 1,
      anon_sym_LPAREN,
    STATE(521), 1,
      sym_special_argument_list,
    ACTIONS(619), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34862] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    ACTIONS(1199), 1,
      anon_sym_AMP_AMP,
    STATE(546), 1,
      sym_argument_list,
    STATE(1133), 1,
      sym_type_arguments,
    ACTIONS(900), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1197), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(898), 4,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1195), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34923] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    STATE(546), 1,
      sym_argument_list,
    STATE(1133), 1,
      sym_type_arguments,
    ACTIONS(900), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1197), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1195), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(898), 5,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34982] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    STATE(546), 1,
      sym_argument_list,
    STATE(1133), 1,
      sym_type_arguments,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(900), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 9,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35037] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1219), 1,
      anon_sym_LF,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1221), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1155), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35094] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    STATE(546), 1,
      sym_argument_list,
    STATE(1133), 1,
      sym_type_arguments,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(900), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 12,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35145] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_LBRACK,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1223), 1,
      anon_sym_LF,
    STATE(521), 1,
      sym_argument_list,
    STATE(1144), 1,
      sym_type_arguments,
    ACTIONS(1153), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1225), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1155), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1151), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35202] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1079), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1077), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35265] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1028), 1,
      anon_sym_LF,
    ACTIONS(1030), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35301] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(940), 1,
      anon_sym_LF,
    ACTIONS(942), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35337] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(956), 1,
      anon_sym_LF,
    ACTIONS(958), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35373] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(916), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1229), 1,
      anon_sym_DOT,
    ACTIONS(1233), 1,
      anon_sym_LBRACE,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1247), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(853), 1,
      aux_sym_expression_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35439] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(960), 1,
      anon_sym_LF,
    ACTIONS(962), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35475] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(964), 1,
      anon_sym_LF,
    ACTIONS(966), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35511] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(621), 1,
      anon_sym_DOT,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    STATE(432), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35559] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 1,
      anon_sym_LF,
    ACTIONS(745), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35595] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(656), 1,
      anon_sym_LF,
    ACTIONS(658), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35631] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(992), 1,
      anon_sym_LF,
    ACTIONS(994), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35667] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_LF,
    ACTIONS(850), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35703] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1044), 1,
      anon_sym_LF,
    ACTIONS(1046), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35739] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(968), 1,
      anon_sym_LF,
    ACTIONS(970), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35775] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LF,
    ACTIONS(974), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35811] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_LF,
    ACTIONS(938), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35847] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(608), 1,
      anon_sym_RPAREN,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(816), 1,
      anon_sym_COMMA,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1249), 1,
      anon_sym_DOT,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1253), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    STATE(668), 1,
      aux_sym_const_spec_repeat1,
    STATE(839), 1,
      sym_type_arguments,
    STATE(1033), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [35915] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(948), 1,
      anon_sym_LF,
    ACTIONS(950), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35951] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_RPAREN,
    ACTIONS(1261), 1,
      anon_sym_COMMA,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1074), 1,
      aux_sym_argument_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36017] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(932), 1,
      anon_sym_LF,
    ACTIONS(934), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36053] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_LF,
    ACTIONS(854), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36089] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    ACTIONS(1281), 1,
      anon_sym_COLON,
    STATE(432), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 16,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36139] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1283), 1,
      anon_sym_RPAREN,
    ACTIONS(1285), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1035), 1,
      aux_sym_argument_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36205] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(988), 1,
      anon_sym_LF,
    ACTIONS(990), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    ACTIONS(608), 1,
      anon_sym_COMMA,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    STATE(432), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(824), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(619), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 15,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36291] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(980), 1,
      anon_sym_LF,
    ACTIONS(982), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36327] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(829), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(320), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [36385] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_LF,
    ACTIONS(1034), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36421] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1291), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1021), 1,
      aux_sym_argument_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36487] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1008), 1,
      anon_sym_LF,
    ACTIONS(1010), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36523] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(976), 1,
      anon_sym_LF,
    ACTIONS(978), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36559] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1016), 1,
      anon_sym_LF,
    ACTIONS(1018), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36595] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_LF,
    ACTIONS(1026), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36631] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(984), 1,
      anon_sym_LF,
    ACTIONS(986), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1295), 1,
      anon_sym_RPAREN,
    ACTIONS(1297), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1038), 1,
      aux_sym_argument_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36733] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1004), 1,
      anon_sym_LF,
    ACTIONS(1006), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36769] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_LF,
    ACTIONS(1038), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 1,
      anon_sym_LPAREN,
    STATE(546), 1,
      sym_special_argument_list,
    ACTIONS(619), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 19,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36845] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_LF,
    ACTIONS(998), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36881] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(853), 1,
      aux_sym_expression_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(916), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36945] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1000), 1,
      anon_sym_LF,
    ACTIONS(1002), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36981] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1012), 1,
      anon_sym_LF,
    ACTIONS(1014), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37017] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1301), 1,
      anon_sym_RPAREN,
    ACTIONS(1303), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(995), 1,
      aux_sym_argument_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37083] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(944), 1,
      anon_sym_LF,
    ACTIONS(946), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37119] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1040), 1,
      anon_sym_LF,
    ACTIONS(1042), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37155] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LF,
    ACTIONS(619), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37191] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(952), 1,
      anon_sym_LF,
    ACTIONS(954), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37227] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1020), 1,
      anon_sym_LF,
    ACTIONS(1022), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37263] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    ACTIONS(1307), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1067), 1,
      aux_sym_argument_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37329] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1318), 1,
      anon_sym_LBRACE,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(442), 1,
      sym_block,
    STATE(846), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(320), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(964), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37425] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(916), 1,
      anon_sym_SEMI,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1322), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    STATE(853), 1,
      aux_sym_expression_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37488] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(900), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 12,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37537] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1326), 1,
      anon_sym_RPAREN,
    ACTIONS(1328), 1,
      anon_sym_COMMA,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1053), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1020), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(976), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37670] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(900), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 9,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37723] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(898), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37778] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1332), 1,
      anon_sym_RPAREN,
    ACTIONS(1334), 1,
      anon_sym_COMMA,
    STATE(1000), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(944), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_DOT,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      anon_sym_LBRACK,
    STATE(432), 1,
      sym_literal_value,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(619), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(617), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37991] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(898), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38083] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(916), 1,
      anon_sym_LBRACE,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1336), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1020), 1,
      aux_sym_expression_list_repeat1,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38146] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1338), 1,
      anon_sym_RPAREN,
    ACTIONS(1340), 1,
      anon_sym_COMMA,
    STATE(1014), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [38209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(658), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(656), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(936), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(986), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(984), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(982), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38349] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1344), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1342), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38410] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1263), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1346), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1000), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(996), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(852), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(972), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1030), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1028), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(960), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(994), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(992), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(958), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(948), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(934), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(932), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38891] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(900), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1006), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38975] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(900), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(898), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39028] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(898), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39083] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_DOT,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(898), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1046), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1044), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39210] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(608), 1,
      anon_sym_RBRACK,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(816), 1,
      anon_sym_COMMA,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1253), 1,
      anon_sym_LBRACK,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1348), 1,
      anon_sym_DOT,
    STATE(668), 1,
      aux_sym_const_spec_repeat1,
    STATE(839), 1,
      sym_type_arguments,
    STATE(1033), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [39275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1024), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1012), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1036), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1016), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(990), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(988), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(940), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1008), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1032), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39555] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    ACTIONS(1352), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39615] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1354), 1,
      anon_sym_RBRACK,
    ACTIONS(1356), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39675] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1358), 1,
      anon_sym_RPAREN,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1106), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [39735] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1360), 1,
      anon_sym_RBRACK,
    ACTIONS(1362), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39795] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1106), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [39855] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1366), 1,
      anon_sym_RBRACK,
    ACTIONS(1368), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39915] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1370), 1,
      anon_sym_RPAREN,
    ACTIONS(1372), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39975] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1374), 1,
      anon_sym_RBRACK,
    ACTIONS(1376), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40035] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1378), 1,
      anon_sym_RBRACK,
    ACTIONS(1380), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40095] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1382), 1,
      anon_sym_RBRACK,
    ACTIONS(1384), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40155] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1106), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40215] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1388), 1,
      anon_sym_RPAREN,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1106), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40275] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1219), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40333] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1390), 1,
      anon_sym_RBRACK,
    ACTIONS(1392), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40393] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
    ACTIONS(1396), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40453] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1106), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40513] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1077), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40571] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1400), 1,
      anon_sym_RPAREN,
    ACTIONS(1402), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40631] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1404), 1,
      anon_sym_RPAREN,
    ACTIONS(1406), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40691] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1408), 1,
      anon_sym_RBRACK,
    ACTIONS(1410), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40751] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1412), 1,
      anon_sym_RBRACK,
    ACTIONS(1414), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40811] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1416), 1,
      anon_sym_RBRACK,
    ACTIONS(1418), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40871] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1420), 1,
      anon_sym_RBRACK,
    ACTIONS(1422), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40931] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1424), 1,
      anon_sym_RBRACK,
    ACTIONS(1426), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40991] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1428), 1,
      anon_sym_RBRACK,
    ACTIONS(1430), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41051] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1432), 1,
      anon_sym_RBRACK,
    ACTIONS(1434), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41111] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_RBRACK,
    ACTIONS(1438), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41171] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(829), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(320), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41227] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1247), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(867), 1,
      sym_block,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41287] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1440), 1,
      anon_sym_RBRACK,
    ACTIONS(1442), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41347] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1444), 1,
      anon_sym_RBRACK,
    ACTIONS(1446), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41407] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1247), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1077), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41465] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1448), 1,
      anon_sym_RPAREN,
    ACTIONS(1450), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41525] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1452), 1,
      anon_sym_RPAREN,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1106), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41585] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1454), 1,
      anon_sym_RBRACK,
    ACTIONS(1456), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41645] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1458), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41703] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41761] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1462), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41818] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1464), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41875] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1466), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41932] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1468), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41989] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42046] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1472), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42103] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1474), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42160] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1476), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42217] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1478), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42274] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1480), 1,
      anon_sym_SEMI,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42331] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_LBRACE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42388] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1484), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42445] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1486), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42502] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LBRACK,
    ACTIONS(1121), 1,
      anon_sym_STAR,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1131), 1,
      anon_sym_LT_DASH,
    ACTIONS(1211), 1,
      anon_sym_LPAREN,
    ACTIONS(1488), 1,
      anon_sym_LF,
    ACTIONS(1490), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(1045), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42559] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1494), 1,
      anon_sym_COMMA,
    ACTIONS(1496), 1,
      anon_sym_EQ,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(761), 1,
      aux_sym_const_spec_repeat1,
    STATE(848), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42618] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1504), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42675] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1506), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42732] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1267), 1,
      anon_sym_PIPE,
    ACTIONS(1277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1279), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1508), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1271), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1269), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1265), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42789] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1510), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42846] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1512), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42903] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1494), 1,
      anon_sym_COMMA,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    ACTIONS(1514), 1,
      anon_sym_EQ,
    STATE(643), 1,
      aux_sym_const_spec_repeat1,
    STATE(850), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42962] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1516), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43019] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1518), 1,
      anon_sym_LBRACE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43076] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1520), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43133] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1522), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43190] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1524), 1,
      anon_sym_SEMI,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43247] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1526), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43304] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1528), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43361] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1219), 1,
      anon_sym_LBRACE,
    ACTIONS(1235), 1,
      anon_sym_PIPE,
    ACTIONS(1245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1247), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1239), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1243), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1231), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43418] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1324), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1106), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43475] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1530), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43532] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1532), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43589] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    ACTIONS(1534), 1,
      sym_identifier,
    STATE(324), 1,
      sym_block,
    STATE(1056), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43645] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    ACTIONS(1536), 1,
      anon_sym_COMMA,
    STATE(765), 1,
      aux_sym_field_name_list_repeat1,
    STATE(845), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43701] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1097), 1,
      anon_sym_PIPE,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1227), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1538), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    STATE(1148), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1139), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1099), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1095), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43755] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      sym_identifier,
    ACTIONS(1542), 1,
      anon_sym_RBRACK,
    STATE(1117), 1,
      sym_parameter_declaration,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43811] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(324), 1,
      sym_block,
    STATE(1056), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43867] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    ACTIONS(1544), 1,
      anon_sym_LBRACE,
    STATE(376), 1,
      sym_block,
    STATE(1060), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43923] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      sym_identifier,
    ACTIONS(1546), 1,
      anon_sym_RBRACK,
    STATE(1117), 1,
      sym_parameter_declaration,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43979] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1494), 1,
      anon_sym_COMMA,
    STATE(761), 1,
      aux_sym_const_spec_repeat1,
    STATE(1078), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44035] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    STATE(408), 1,
      sym_block,
    STATE(1081), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44091] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    ACTIONS(1550), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_block,
    STATE(1015), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44147] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    ACTIONS(1552), 1,
      anon_sym_EQ,
    ACTIONS(1554), 1,
      anon_sym_LBRACK,
    STATE(714), 1,
      sym_type_parameter_list,
    STATE(887), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44203] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    ACTIONS(1556), 1,
      anon_sym_LBRACE,
    STATE(565), 1,
      sym_block,
    STATE(1043), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44259] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      anon_sym_type,
    STATE(1162), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44312] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 1,
      anon_sym_RBRACK,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44365] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1562), 1,
      anon_sym_RBRACK,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44418] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1564), 1,
      anon_sym_RBRACK,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44471] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1566), 1,
      anon_sym_type,
    STATE(1162), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44524] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1568), 1,
      anon_sym_type,
    STATE(1202), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44577] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_RBRACK,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44630] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1572), 1,
      anon_sym_RBRACK,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44683] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(1162), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44736] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      sym_identifier,
    STATE(1117), 1,
      sym_parameter_declaration,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44789] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1576), 1,
      anon_sym_RBRACK,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44842] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      sym_identifier,
    STATE(1029), 1,
      sym_parameter_declaration,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1202), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44945] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    STATE(285), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44995] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(817), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45045] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    STATE(251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45095] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1142), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45145] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1155), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45195] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1586), 1,
      anon_sym_LT_DASH,
    STATE(806), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45245] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1017), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45295] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(801), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45345] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1192), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45395] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1042), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1588), 1,
      anon_sym_LT_DASH,
    STATE(827), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45495] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1200), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45545] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(820), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45595] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1186), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45645] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    STATE(258), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45695] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(828), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45745] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(990), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45795] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(817), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45845] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(985), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    STATE(277), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45945] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(992), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45995] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1590), 1,
      anon_sym_LT_DASH,
    STATE(814), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46045] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1172), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46095] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(837), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46145] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(819), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46195] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(908), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46245] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1058), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46295] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1183), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46345] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(909), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46395] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1206), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    ACTIONS(1592), 1,
      anon_sym_chan,
    STATE(276), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46495] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    STATE(263), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46545] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1221), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46595] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(820), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46645] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(804), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46695] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1083), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46745] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1061), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46795] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1162), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46845] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_chan,
    STATE(815), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1101), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46945] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1586), 1,
      anon_sym_LT_DASH,
    STATE(802), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46995] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1218), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47045] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1175), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47095] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1596), 1,
      anon_sym_LT_DASH,
    STATE(286), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47145] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1220), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47195] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1063), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47245] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(796), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47295] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1578), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_LBRACK,
    ACTIONS(1582), 1,
      anon_sym_STAR,
    ACTIONS(1596), 1,
      anon_sym_LT_DASH,
    STATE(275), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(280), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47345] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(837), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47395] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(828), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(819), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47495] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    ACTIONS(1590), 1,
      anon_sym_LT_DASH,
    STATE(827), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47545] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1212), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47595] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1588), 1,
      anon_sym_LT_DASH,
    STATE(814), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47645] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(808), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47695] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    ACTIONS(1598), 1,
      anon_sym_chan,
    STATE(807), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47745] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1018), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47795] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_func,
    ACTIONS(1123), 1,
      anon_sym_struct,
    ACTIONS(1125), 1,
      anon_sym_interface,
    ACTIONS(1127), 1,
      anon_sym_map,
    ACTIONS(1129), 1,
      anon_sym_chan,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_STAR,
    ACTIONS(1502), 1,
      anon_sym_LT_DASH,
    STATE(793), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(788), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47845] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(819), 1,
      anon_sym_func,
    ACTIONS(830), 1,
      anon_sym_map,
    ACTIONS(832), 1,
      anon_sym_chan,
    ACTIONS(834), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_STAR,
    ACTIONS(1289), 1,
      anon_sym_LBRACK,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(606), 1,
      anon_sym_chan,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1251), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_func,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_LT_DASH,
    STATE(815), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(813), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47945] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(791), 1,
      anon_sym_LF,
    ACTIONS(793), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [47971] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_LF,
    ACTIONS(769), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [47997] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1602), 1,
      anon_sym_LF,
    ACTIONS(1604), 1,
      anon_sym_COMMA,
    STATE(748), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1600), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [48027] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(771), 1,
      anon_sym_LF,
    ACTIONS(773), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48053] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_LF,
    ACTIONS(882), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48079] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1602), 1,
      anon_sym_LF,
    ACTIONS(1600), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [48104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(767), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [48128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(773), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(771), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [48152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(882), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(880), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [48176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(793), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(791), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [48200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_COMMA,
    STATE(756), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1077), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(906), 1,
      anon_sym_COMMA,
    STATE(756), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1610), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1612), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1616), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1620), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1612), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    STATE(761), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1602), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1600), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_EQ,
    ACTIONS(1627), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1612), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1629), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1602), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
  [48402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1637), 1,
      anon_sym_COMMA,
    STATE(765), 1,
      aux_sym_field_name_list_repeat1,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1633), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48426] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(608), 1,
      anon_sym_LF,
    ACTIONS(1111), 1,
      anon_sym_DOT,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    STATE(803), 1,
      sym_type_arguments,
    ACTIONS(610), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1644), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1642), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1648), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1646), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1650), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48506] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 1,
      sym_identifier,
    ACTIONS(1657), 1,
      anon_sym_DOT,
    ACTIONS(1660), 1,
      sym_blank_identifier,
    ACTIONS(1663), 1,
      anon_sym_RPAREN,
    ACTIONS(1665), 1,
      sym_raw_string_literal,
    ACTIONS(1668), 1,
      anon_sym_DQUOTE,
    STATE(770), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1066), 1,
      sym_dot,
    STATE(1134), 1,
      sym_interpreted_string_literal,
    STATE(1145), 1,
      sym_import_spec,
  [48540] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(1671), 1,
      sym_identifier,
    ACTIONS(1673), 1,
      anon_sym_DOT,
    ACTIONS(1675), 1,
      sym_blank_identifier,
    ACTIONS(1677), 1,
      anon_sym_RPAREN,
    ACTIONS(1679), 1,
      sym_raw_string_literal,
    STATE(773), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1066), 1,
      sym_dot,
    STATE(1134), 1,
      sym_interpreted_string_literal,
    STATE(1145), 1,
      sym_import_spec,
  [48574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1681), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(1671), 1,
      sym_identifier,
    ACTIONS(1673), 1,
      anon_sym_DOT,
    ACTIONS(1675), 1,
      sym_blank_identifier,
    ACTIONS(1679), 1,
      sym_raw_string_literal,
    ACTIONS(1685), 1,
      anon_sym_RPAREN,
    STATE(770), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1066), 1,
      sym_dot,
    STATE(1134), 1,
      sym_interpreted_string_literal,
    STATE(1145), 1,
      sym_import_spec,
  [48626] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DOT,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1689), 1,
      sym_blank_identifier,
    ACTIONS(1691), 1,
      anon_sym_LPAREN,
    ACTIONS(1693), 1,
      sym_raw_string_literal,
    ACTIONS(1695), 1,
      anon_sym_DQUOTE,
    STATE(244), 1,
      sym_interpreted_string_literal,
    STATE(1001), 1,
      sym_dot,
    STATE(289), 2,
      sym_import_spec,
      sym_import_spec_list,
  [48658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 1,
      anon_sym_DOT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    STATE(839), 1,
      sym_type_arguments,
    ACTIONS(608), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [48680] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(1049), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48705] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(1049), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48730] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1707), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(1049), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48755] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1709), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(1049), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48780] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1711), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(968), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48805] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1713), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(979), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48830] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1715), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(962), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48855] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1717), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(1049), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48880] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(1719), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(1049), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48905] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_LF,
    ACTIONS(728), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48921] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_LF,
    ACTIONS(858), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      sym_identifier,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    STATE(881), 1,
      sym_constraint_term,
    STATE(1084), 1,
      sym_qualified_type,
    STATE(1049), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48959] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LF,
    ACTIONS(842), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48975] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_LF,
    ACTIONS(846), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48991] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(694), 1,
      anon_sym_LF,
    ACTIONS(696), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49007] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LF,
    ACTIONS(724), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49023] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(706), 1,
      anon_sym_LF,
    ACTIONS(708), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49039] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(702), 1,
      anon_sym_LF,
    ACTIONS(704), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49055] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(698), 1,
      anon_sym_LF,
    ACTIONS(700), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49071] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(747), 1,
      anon_sym_LF,
    ACTIONS(749), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49087] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_LF,
    ACTIONS(732), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49103] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(718), 1,
      anon_sym_LF,
    ACTIONS(720), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49119] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_LF,
    ACTIONS(712), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49135] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(714), 1,
      anon_sym_LF,
    ACTIONS(716), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49151] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_LF,
    ACTIONS(753), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49167] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LF,
    ACTIONS(757), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49183] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_LF,
    ACTIONS(866), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49199] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(868), 1,
      anon_sym_LF,
    ACTIONS(870), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49215] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_LF,
    ACTIONS(862), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49231] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_LF,
    ACTIONS(801), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49247] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_LF,
    ACTIONS(732), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49263] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_LF,
    ACTIONS(732), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49279] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_LF,
    ACTIONS(805), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49295] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LF,
    ACTIONS(874), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49311] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(836), 1,
      anon_sym_LF,
    ACTIONS(838), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49327] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_DOT,
    ACTIONS(1211), 1,
      anon_sym_LPAREN,
    ACTIONS(1721), 1,
      anon_sym_LF,
    ACTIONS(1725), 1,
      anon_sym_PIPE,
    STATE(642), 1,
      sym_parameter_list,
    ACTIONS(1723), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49402] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(1610), 1,
      anon_sym_LF,
    STATE(821), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1727), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(718), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(702), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49473] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_LF,
    ACTIONS(1729), 1,
      anon_sym_COMMA,
    STATE(821), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1079), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(706), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(714), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(747), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(694), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49700] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_DOT,
    ACTIONS(1135), 1,
      anon_sym_DQUOTE,
    ACTIONS(1732), 1,
      anon_sym_LF,
    ACTIONS(1736), 1,
      sym_raw_string_literal,
    STATE(1023), 1,
      sym_interpreted_string_literal,
    ACTIONS(1734), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 1,
      anon_sym_RBRACE,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    STATE(852), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49754] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_DQUOTE,
    ACTIONS(1744), 1,
      anon_sym_LF,
    ACTIONS(1748), 1,
      sym_raw_string_literal,
    STATE(1025), 1,
      sym_interpreted_string_literal,
    ACTIONS(1746), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1750), 1,
      anon_sym_RBRACE,
    ACTIONS(1752), 1,
      anon_sym_case,
    STATE(857), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [49792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1754), 1,
      anon_sym_RBRACE,
    STATE(872), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49810] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_DQUOTE,
    ACTIONS(1756), 1,
      anon_sym_LF,
    ACTIONS(1760), 1,
      sym_raw_string_literal,
    STATE(1027), 1,
      sym_interpreted_string_literal,
    ACTIONS(1758), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49830] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_DQUOTE,
    ACTIONS(1762), 1,
      anon_sym_LF,
    ACTIONS(1766), 1,
      sym_raw_string_literal,
    STATE(1047), 1,
      sym_interpreted_string_literal,
    ACTIONS(1764), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_block,
    ACTIONS(710), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [49866] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1768), 1,
      anon_sym_LF,
    ACTIONS(1771), 1,
      anon_sym_SEMI,
    STATE(847), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1774), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49884] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1776), 1,
      anon_sym_LF,
    ACTIONS(1780), 1,
      anon_sym_EQ,
    ACTIONS(1778), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(1663), 4,
      anon_sym_DOT,
      anon_sym_RPAREN,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49914] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1784), 1,
      anon_sym_LF,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(1786), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49930] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 1,
      anon_sym_LBRACE,
    ACTIONS(1348), 1,
      anon_sym_DOT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1790), 1,
      anon_sym_LPAREN,
    STATE(28), 1,
      sym_parameter_list,
    STATE(839), 1,
      sym_type_arguments,
  [49952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1792), 1,
      anon_sym_RBRACE,
    ACTIONS(1794), 1,
      anon_sym_case,
    ACTIONS(1797), 1,
      anon_sym_default,
    STATE(852), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1727), 1,
      anon_sym_COLON,
    STATE(868), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1610), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [49988] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_LF,
    ACTIONS(1802), 1,
      anon_sym_SEMI,
    STATE(855), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1804), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50006] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1806), 1,
      anon_sym_LF,
    ACTIONS(1808), 1,
      anon_sym_SEMI,
    STATE(847), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(202), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50024] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1810), 1,
      sym_identifier,
    ACTIONS(1812), 1,
      anon_sym_LF,
    ACTIONS(1814), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1752), 1,
      anon_sym_case,
    ACTIONS(1816), 1,
      anon_sym_RBRACE,
    STATE(873), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [50058] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym_LF,
    ACTIONS(1822), 1,
      anon_sym_else,
    ACTIONS(1820), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50074] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_DQUOTE,
    ACTIONS(1824), 1,
      anon_sym_LF,
    ACTIONS(1828), 1,
      sym_raw_string_literal,
    STATE(997), 1,
      sym_interpreted_string_literal,
    ACTIONS(1826), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1830), 1,
      anon_sym_RBRACE,
    STATE(870), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [50112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1832), 1,
      anon_sym_RBRACE,
    STATE(871), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [50130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    STATE(431), 1,
      sym_literal_value,
    ACTIONS(840), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [50146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1836), 1,
      anon_sym_case,
    STATE(866), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [50164] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1838), 1,
      sym_identifier,
    ACTIONS(1840), 1,
      anon_sym_LF,
    ACTIONS(1842), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1836), 1,
      anon_sym_case,
    ACTIONS(1844), 1,
      anon_sym_RBRACE,
    STATE(863), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [50198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_RBRACE,
    ACTIONS(1848), 1,
      anon_sym_case,
    ACTIONS(1851), 1,
      anon_sym_default,
    STATE(866), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [50216] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_LF,
    ACTIONS(1858), 1,
      anon_sym_else,
    ACTIONS(1856), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      anon_sym_COLON,
    ACTIONS(1860), 1,
      anon_sym_COMMA,
    STATE(868), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1077), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [50250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1863), 1,
      anon_sym_RBRACE,
    STATE(840), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [50268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1865), 1,
      anon_sym_RBRACE,
    STATE(852), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [50286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1867), 1,
      anon_sym_RBRACE,
    STATE(852), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [50304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_case,
    ACTIONS(1742), 1,
      anon_sym_default,
    ACTIONS(1869), 1,
      anon_sym_RBRACE,
    STATE(852), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [50322] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_RBRACE,
    ACTIONS(1873), 1,
      anon_sym_case,
    ACTIONS(1876), 1,
      anon_sym_default,
    STATE(873), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [50340] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_LF,
    ACTIONS(1881), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      sym_identifier,
    ACTIONS(1886), 1,
      anon_sym_RPAREN,
    STATE(875), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1113), 2,
      sym_type_alias,
      sym_type_spec,
  [50370] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1888), 1,
      anon_sym_LF,
    ACTIONS(1890), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50383] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_LF,
    ACTIONS(662), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50396] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1892), 1,
      anon_sym_LF,
    ACTIONS(1894), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50409] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LF,
    ACTIONS(1898), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50422] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1900), 1,
      anon_sym_LF,
    ACTIONS(1902), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50435] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1904), 1,
      anon_sym_LF,
    ACTIONS(1908), 1,
      anon_sym_PIPE,
    STATE(921), 1,
      aux_sym_constraint_elem_repeat1,
    ACTIONS(1906), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50452] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_LF,
    ACTIONS(1912), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50465] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_LF,
    ACTIONS(1916), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50478] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LF,
    ACTIONS(1920), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50491] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1922), 1,
      anon_sym_LF,
    ACTIONS(1924), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50504] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_LF,
    ACTIONS(1930), 1,
      anon_sym_PIPE,
    STATE(886), 1,
      aux_sym_constraint_elem_repeat1,
    ACTIONS(1928), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50521] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1933), 1,
      anon_sym_LF,
    ACTIONS(1935), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50534] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1937), 1,
      anon_sym_LF,
    ACTIONS(1939), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50547] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_LF,
    ACTIONS(1943), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50560] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(1949), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(982), 1,
      sym_field_declaration,
  [50579] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LF,
    ACTIONS(1953), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 1,
      sym_identifier,
    ACTIONS(1957), 1,
      anon_sym_RPAREN,
    STATE(875), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1113), 2,
      sym_type_alias,
      sym_type_spec,
  [50609] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1959), 1,
      anon_sym_LF,
    ACTIONS(1961), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50622] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LF,
    ACTIONS(1965), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50635] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LF,
    ACTIONS(1969), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50648] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LF,
    ACTIONS(1973), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50661] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1975), 1,
      anon_sym_LF,
    ACTIONS(1977), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(1979), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(1040), 1,
      sym_field_declaration,
  [50693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(1981), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(1040), 1,
      sym_field_declaration,
  [50712] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1983), 1,
      anon_sym_LF,
    ACTIONS(1985), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50725] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LF,
    ACTIONS(1989), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50738] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1991), 1,
      anon_sym_LF,
    ACTIONS(1993), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50751] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LF,
    ACTIONS(1997), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(1999), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(1040), 1,
      sym_field_declaration,
  [50783] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2001), 1,
      anon_sym_LF,
    ACTIONS(2003), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50796] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LF,
    ACTIONS(2007), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50809] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_LF,
    ACTIONS(2011), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50822] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_LF,
    ACTIONS(2015), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50835] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LF,
    ACTIONS(2019), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50848] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_LF,
    ACTIONS(2023), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50861] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym_LF,
    ACTIONS(2027), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50874] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LF,
    ACTIONS(2031), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50887] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(2033), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(1040), 1,
      sym_field_declaration,
  [50906] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_LF,
    ACTIONS(2037), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50919] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2039), 1,
      anon_sym_LF,
    ACTIONS(2041), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(967), 1,
      sym_field_declaration,
  [50951] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2045), 1,
      anon_sym_LF,
    ACTIONS(1774), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50964] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2047), 1,
      anon_sym_LF,
    ACTIONS(2049), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50977] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LF,
    ACTIONS(2053), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50990] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2055), 1,
      anon_sym_LF,
    ACTIONS(2057), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51003] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_PIPE,
    ACTIONS(2059), 1,
      anon_sym_LF,
    STATE(886), 1,
      aux_sym_constraint_elem_repeat1,
    ACTIONS(2061), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [51020] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_LF,
    ACTIONS(2065), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51033] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2067), 1,
      anon_sym_LF,
    ACTIONS(2069), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51046] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_LF,
    ACTIONS(2073), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51059] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_LF,
    ACTIONS(2077), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51072] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2079), 1,
      anon_sym_LF,
    ACTIONS(2081), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51085] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2083), 1,
      anon_sym_LF,
    ACTIONS(2085), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51098] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LF,
    ACTIONS(2089), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51111] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2091), 1,
      anon_sym_LF,
    ACTIONS(2093), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51124] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2095), 1,
      anon_sym_LF,
    ACTIONS(2097), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51137] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(2099), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(958), 1,
      sym_field_declaration,
  [51156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(2101), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(1040), 1,
      sym_field_declaration,
  [51175] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2103), 1,
      anon_sym_LF,
    ACTIONS(2105), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51188] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_LF,
    ACTIONS(2109), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    ACTIONS(2111), 1,
      anon_sym_RBRACE,
    STATE(859), 1,
      sym_qualified_type,
    STATE(1040), 1,
      sym_field_declaration,
  [51220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 1,
      sym_identifier,
    ACTIONS(2113), 1,
      anon_sym_RPAREN,
    STATE(892), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1113), 2,
      sym_type_alias,
      sym_type_spec,
  [51237] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_LF,
    ACTIONS(2117), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51250] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2119), 1,
      anon_sym_LF,
    ACTIONS(2121), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51263] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2123), 1,
      anon_sym_LF,
    ACTIONS(2126), 1,
      anon_sym_SEMI,
    ACTIONS(2129), 1,
      anon_sym_RBRACE,
    STATE(939), 1,
      aux_sym_field_declaration_list_repeat1,
  [51279] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2131), 1,
      anon_sym_DQUOTE,
    STATE(983), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2133), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 1,
      sym_identifier,
    ACTIONS(2135), 1,
      anon_sym_LPAREN,
    STATE(933), 2,
      sym_type_alias,
      sym_type_spec,
  [51307] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_LF,
    ACTIONS(2139), 1,
      anon_sym_SEMI,
    ACTIONS(2141), 1,
      anon_sym_RBRACE,
    STATE(939), 1,
      aux_sym_field_declaration_list_repeat1,
  [51323] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2143), 1,
      anon_sym_LF,
    ACTIONS(2145), 1,
      anon_sym_SEMI,
    ACTIONS(2147), 1,
      anon_sym_RBRACE,
    STATE(974), 1,
      aux_sym_interface_type_repeat1,
  [51339] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2149), 1,
      anon_sym_DQUOTE,
    STATE(951), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2151), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      sym_identifier,
    ACTIONS(2155), 1,
      anon_sym_RPAREN,
    STATE(954), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1141), 1,
      sym_const_spec,
  [51369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 1,
      sym_identifier,
    ACTIONS(2159), 1,
      anon_sym_RPAREN,
    STATE(957), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1127), 1,
      sym_var_spec,
  [51385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1790), 1,
      anon_sym_LPAREN,
    ACTIONS(2161), 1,
      anon_sym_LBRACK,
    STATE(29), 1,
      sym_parameter_list,
    STATE(1118), 1,
      sym_type_parameter_list,
  [51401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [51411] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2165), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51425] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2167), 1,
      anon_sym_DQUOTE,
    STATE(949), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2169), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51439] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2171), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2165), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(2173), 1,
      anon_sym_if,
    STATE(914), 2,
      sym_block,
      sym_if_statement,
  [51467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_STAR,
    STATE(859), 1,
      sym_qualified_type,
    STATE(1040), 1,
      sym_field_declaration,
  [51483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      sym_identifier,
    ACTIONS(2175), 1,
      anon_sym_RPAREN,
    STATE(965), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1141), 1,
      sym_const_spec,
  [51499] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2177), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2165), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51513] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2179), 1,
      anon_sym_DQUOTE,
    STATE(955), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2181), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 1,
      sym_identifier,
    ACTIONS(2183), 1,
      anon_sym_RPAREN,
    STATE(977), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1127), 1,
      sym_var_spec,
  [51543] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LF,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2189), 1,
      anon_sym_RBRACE,
    STATE(981), 1,
      aux_sym_field_declaration_list_repeat1,
  [51559] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_LF,
    ACTIONS(2193), 1,
      anon_sym_SEMI,
    ACTIONS(2195), 1,
      anon_sym_RBRACE,
    STATE(974), 1,
      aux_sym_interface_type_repeat1,
  [51575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COMMA,
    STATE(960), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(2200), 2,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [51589] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2202), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2165), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51603] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2204), 1,
      anon_sym_LF,
    ACTIONS(2206), 1,
      anon_sym_SEMI,
    ACTIONS(2208), 1,
      anon_sym_RBRACE,
    STATE(959), 1,
      aux_sym_interface_type_repeat1,
  [51619] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2210), 1,
      anon_sym_DQUOTE,
    STATE(961), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2212), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51633] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_DQUOTE,
    STATE(976), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2216), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      sym_identifier,
    ACTIONS(2221), 1,
      anon_sym_RPAREN,
    STATE(965), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1141), 1,
      sym_const_spec,
  [51663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(2173), 1,
      anon_sym_if,
    STATE(878), 2,
      sym_block,
      sym_if_statement,
  [51677] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LF,
    ACTIONS(2225), 1,
      anon_sym_SEMI,
    ACTIONS(2227), 1,
      anon_sym_RBRACE,
    STATE(969), 1,
      aux_sym_field_declaration_list_repeat1,
  [51693] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_LF,
    ACTIONS(2231), 1,
      anon_sym_SEMI,
    ACTIONS(2233), 1,
      anon_sym_RBRACE,
    STATE(971), 1,
      aux_sym_interface_type_repeat1,
  [51709] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2235), 1,
      anon_sym_LF,
    ACTIONS(2237), 1,
      anon_sym_SEMI,
    ACTIONS(2239), 1,
      anon_sym_RBRACE,
    STATE(939), 1,
      aux_sym_field_declaration_list_repeat1,
  [51725] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2243), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51739] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2246), 1,
      anon_sym_LF,
    ACTIONS(2248), 1,
      anon_sym_SEMI,
    ACTIONS(2250), 1,
      anon_sym_RBRACE,
    STATE(974), 1,
      aux_sym_interface_type_repeat1,
  [51755] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2252), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2165), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51769] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2254), 1,
      anon_sym_LF,
    ACTIONS(2256), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [51781] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2258), 1,
      anon_sym_LF,
    ACTIONS(2261), 1,
      anon_sym_SEMI,
    ACTIONS(2264), 1,
      anon_sym_RBRACE,
    STATE(974), 1,
      aux_sym_interface_type_repeat1,
  [51797] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2266), 1,
      anon_sym_DQUOTE,
    STATE(972), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2268), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51811] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2270), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2165), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 1,
      sym_identifier,
    ACTIONS(2275), 1,
      anon_sym_RPAREN,
    STATE(977), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1127), 1,
      sym_var_spec,
  [51841] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_LF,
    ACTIONS(1928), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [51853] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_LF,
    ACTIONS(2279), 1,
      anon_sym_SEMI,
    ACTIONS(2281), 1,
      anon_sym_RBRACE,
    STATE(943), 1,
      aux_sym_interface_type_repeat1,
  [51869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_LPAREN,
    ACTIONS(2285), 1,
      anon_sym_COMMA,
    ACTIONS(2287), 1,
      anon_sym_RBRACK,
    STATE(1039), 1,
      aux_sym_type_arguments_repeat1,
  [51885] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2289), 1,
      anon_sym_LF,
    ACTIONS(2291), 1,
      anon_sym_SEMI,
    ACTIONS(2293), 1,
      anon_sym_RBRACE,
    STATE(939), 1,
      aux_sym_field_declaration_list_repeat1,
  [51901] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_LF,
    ACTIONS(2297), 1,
      anon_sym_SEMI,
    ACTIONS(2299), 1,
      anon_sym_RBRACE,
    STATE(942), 1,
      aux_sym_field_declaration_list_repeat1,
  [51917] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2165), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [51931] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LF,
    ACTIONS(1725), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [51943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_COMMA,
    ACTIONS(2307), 1,
      anon_sym_COLON,
    STATE(1012), 1,
      aux_sym_type_arguments_repeat1,
  [51956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_RPAREN,
    ACTIONS(2309), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
  [51969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      sym_identifier,
    ACTIONS(2312), 1,
      anon_sym_LPAREN,
    STATE(938), 1,
      sym_const_spec,
  [51982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_COMMA,
    ACTIONS(2316), 1,
      anon_sym_RBRACE,
    STATE(1006), 1,
      aux_sym_literal_value_repeat1,
  [51995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1703), 1,
      anon_sym_TILDE,
    ACTIONS(2318), 1,
      sym_identifier,
    STATE(978), 1,
      sym_constraint_term,
  [52008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      anon_sym_COMMA,
    ACTIONS(2322), 1,
      anon_sym_RBRACK,
    STATE(1004), 1,
      aux_sym_type_arguments_repeat1,
  [52021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      anon_sym_LPAREN,
    STATE(937), 1,
      sym_var_spec,
  [52034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 1,
      anon_sym_RPAREN,
    ACTIONS(2328), 1,
      anon_sym_COMMA,
    STATE(998), 1,
      aux_sym_expression_list_repeat1,
  [52047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    ACTIONS(2330), 1,
      sym_identifier,
    STATE(661), 1,
      sym_parameter_list,
  [52060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(534), 1,
      sym_literal_value,
  [52073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
    ACTIONS(2334), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      aux_sym_argument_list_repeat1,
  [52086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(204), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52095] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2336), 1,
      anon_sym_LF,
    ACTIONS(2338), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    ACTIONS(2340), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
  [52119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(2342), 1,
      anon_sym_LBRACE,
    STATE(308), 1,
      sym_literal_value,
  [52132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2344), 1,
      anon_sym_RPAREN,
    ACTIONS(2346), 1,
      anon_sym_COMMA,
    STATE(1082), 1,
      aux_sym_parameter_list_repeat1,
  [52145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 1,
      anon_sym_DQUOTE,
    ACTIONS(2348), 1,
      sym_raw_string_literal,
    STATE(268), 1,
      sym_interpreted_string_literal,
  [52158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 1,
      anon_sym_DQUOTE,
    ACTIONS(2350), 1,
      sym_raw_string_literal,
    STATE(264), 1,
      sym_interpreted_string_literal,
  [52171] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2352), 1,
      anon_sym_LF,
    ACTIONS(2354), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 1,
      anon_sym_RBRACK,
    ACTIONS(2356), 1,
      anon_sym_COMMA,
    STATE(960), 1,
      aux_sym_type_arguments_repeat1,
  [52195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_LBRACE,
    ACTIONS(2358), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      aux_sym_expression_list_repeat1,
  [52208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 1,
      anon_sym_RBRACE,
    ACTIONS(2361), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_literal_value_repeat1,
  [52221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 1,
      anon_sym_RBRACK,
    ACTIONS(2367), 1,
      anon_sym_COMMA,
    STATE(1052), 1,
      aux_sym_type_parameter_list_repeat1,
  [52252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_LPAREN,
    ACTIONS(2371), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_COMMA,
    ACTIONS(2373), 1,
      anon_sym_COLON,
    STATE(960), 1,
      aux_sym_type_arguments_repeat1,
  [52285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 1,
      anon_sym_RPAREN,
    ACTIONS(2377), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_parameter_list_repeat1,
  [52298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 1,
      anon_sym_RPAREN,
    ACTIONS(2382), 1,
      anon_sym_COMMA,
    STATE(1026), 1,
      aux_sym_parameter_list_repeat1,
  [52311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_LPAREN,
    ACTIONS(1550), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_block,
  [52324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2384), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 1,
      anon_sym_RPAREN,
    ACTIONS(2388), 1,
      anon_sym_COMMA,
    STATE(1030), 1,
      aux_sym_expression_list_repeat1,
  [52346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 1,
      anon_sym_COMMA,
    ACTIONS(2392), 1,
      anon_sym_RBRACK,
    STATE(1032), 1,
      aux_sym_type_arguments_repeat1,
  [52359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_COMMA,
    ACTIONS(2396), 1,
      anon_sym_RBRACE,
    STATE(1034), 1,
      aux_sym_literal_value_repeat1,
  [52372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1336), 1,
      anon_sym_COMMA,
    ACTIONS(1610), 1,
      anon_sym_LBRACE,
    STATE(1005), 1,
      aux_sym_expression_list_repeat1,
  [52385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 1,
      anon_sym_RPAREN,
    ACTIONS(2398), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      aux_sym_argument_list_repeat1,
  [52398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1295), 1,
      anon_sym_RPAREN,
    ACTIONS(1297), 1,
      anon_sym_COMMA,
    STATE(1038), 1,
      aux_sym_argument_list_repeat1,
  [52411] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_LF,
    ACTIONS(2402), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 1,
      anon_sym_RBRACE,
    ACTIONS(2404), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_literal_value_repeat1,
  [52435] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_LF,
    ACTIONS(2408), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_RPAREN,
    ACTIONS(2410), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_parameter_list_repeat1,
  [52459] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2412), 1,
      anon_sym_LF,
    ACTIONS(2414), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    ACTIONS(2416), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
  [52483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      anon_sym_COMMA,
    ACTIONS(2420), 1,
      anon_sym_RBRACK,
    STATE(1009), 1,
      aux_sym_type_parameter_list_repeat1,
  [52496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(526), 1,
      anon_sym_RPAREN,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
  [52509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
    ACTIONS(2424), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_parameter_list_repeat1,
  [52522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_RBRACK,
    ACTIONS(2426), 1,
      anon_sym_COMMA,
    STATE(960), 1,
      aux_sym_type_arguments_repeat1,
  [52535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(390), 1,
      anon_sym_RBRACE,
    ACTIONS(2430), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_literal_value_repeat1,
  [52557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      anon_sym_RPAREN,
    ACTIONS(2432), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      aux_sym_argument_list_repeat1,
  [52570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(410), 1,
      anon_sym_RBRACE,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_literal_value_repeat1,
  [52583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 1,
      anon_sym_COMMA,
    STATE(1021), 1,
      aux_sym_argument_list_repeat1,
  [52596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    ACTIONS(2436), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      aux_sym_argument_list_repeat1,
  [52609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 1,
      anon_sym_RBRACK,
    ACTIONS(2438), 1,
      anon_sym_COMMA,
    STATE(960), 1,
      aux_sym_type_arguments_repeat1,
  [52622] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LF,
    ACTIONS(2129), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      anon_sym_COMMA,
    ACTIONS(2444), 1,
      anon_sym_RBRACE,
    STATE(1024), 1,
      aux_sym_literal_value_repeat1,
  [52646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_RPAREN,
    ACTIONS(2448), 1,
      anon_sym_COMMA,
    STATE(1028), 1,
      aux_sym_expression_list_repeat1,
  [52659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_LPAREN,
    ACTIONS(1556), 1,
      anon_sym_LBRACE,
    STATE(589), 1,
      sym_block,
  [52672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52681] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LF,
    ACTIONS(2454), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 1,
      anon_sym_RPAREN,
    ACTIONS(2456), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
  [52705] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_LF,
    ACTIONS(2460), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1301), 1,
      anon_sym_RPAREN,
    ACTIONS(1303), 1,
      anon_sym_COMMA,
    STATE(995), 1,
      aux_sym_argument_list_repeat1,
  [52729] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_LF,
    ACTIONS(2264), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    STATE(358), 1,
      sym_literal_value,
  [52753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    STATE(551), 1,
      sym_literal_value,
  [52766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_COMMA,
    ACTIONS(2469), 1,
      anon_sym_RBRACK,
    STATE(1052), 1,
      aux_sym_type_parameter_list_repeat1,
  [52779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_RPAREN,
    ACTIONS(2473), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      aux_sym_parameter_list_repeat1,
  [52792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2475), 1,
      anon_sym_COMMA,
    ACTIONS(2477), 1,
      anon_sym_RBRACE,
    STATE(1036), 1,
      aux_sym_literal_value_repeat1,
  [52814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(710), 1,
      anon_sym_LPAREN,
    STATE(307), 1,
      sym_block,
  [52827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1344), 1,
      anon_sym_COLON,
    ACTIONS(1342), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [52838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 1,
      anon_sym_COMMA,
    ACTIONS(2287), 1,
      anon_sym_RBRACK,
    STATE(1039), 1,
      aux_sym_type_arguments_repeat1,
  [52851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 1,
      anon_sym_RPAREN,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      aux_sym_argument_list_repeat1,
  [52864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_LPAREN,
    ACTIONS(1544), 1,
      anon_sym_LBRACE,
    STATE(356), 1,
      sym_block,
  [52877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_RPAREN,
    ACTIONS(2484), 1,
      anon_sym_COMMA,
    STATE(1068), 1,
      aux_sym_expression_list_repeat1,
  [52890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_COMMA,
    ACTIONS(2488), 1,
      anon_sym_RBRACE,
    STATE(1070), 1,
      aux_sym_literal_value_repeat1,
  [52903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 1,
      anon_sym_RPAREN,
    ACTIONS(2492), 1,
      anon_sym_COMMA,
    STATE(1046), 1,
      aux_sym_expression_list_repeat1,
  [52916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 1,
      anon_sym_RPAREN,
    ACTIONS(1261), 1,
      anon_sym_COMMA,
    STATE(1074), 1,
      aux_sym_argument_list_repeat1,
  [52929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(2494), 1,
      sym_raw_string_literal,
    STATE(1103), 1,
      sym_interpreted_string_literal,
  [52942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(2496), 1,
      sym_raw_string_literal,
    STATE(1110), 1,
      sym_interpreted_string_literal,
  [52955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    ACTIONS(2498), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      aux_sym_argument_list_repeat1,
  [52968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(528), 1,
      anon_sym_RPAREN,
    ACTIONS(2500), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
  [52981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2505), 1,
      anon_sym_RBRACE,
    STATE(1069), 1,
      aux_sym_literal_value_repeat1,
  [52994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(406), 1,
      anon_sym_RBRACE,
    ACTIONS(2507), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_literal_value_repeat1,
  [53007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(364), 1,
      anon_sym_RBRACE,
    ACTIONS(2509), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_literal_value_repeat1,
  [53020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(2511), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
  [53033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 1,
      anon_sym_RPAREN,
    ACTIONS(1285), 1,
      anon_sym_COMMA,
    STATE(1035), 1,
      aux_sym_argument_list_repeat1,
  [53046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_RPAREN,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      aux_sym_argument_list_repeat1,
  [53059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_RBRACE,
    STATE(1071), 1,
      aux_sym_literal_value_repeat1,
  [53072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    STATE(412), 1,
      sym_literal_value,
  [53085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    ACTIONS(1307), 1,
      anon_sym_COMMA,
    STATE(1067), 1,
      aux_sym_argument_list_repeat1,
  [53098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [53107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [53116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2200), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [53125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_LPAREN,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    STATE(397), 1,
      sym_block,
  [53138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 1,
      anon_sym_RPAREN,
    ACTIONS(2523), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_parameter_list_repeat1,
  [53151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_RPAREN,
    ACTIONS(2527), 1,
      anon_sym_COMMA,
    STATE(1072), 1,
      aux_sym_expression_list_repeat1,
  [53164] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_LF,
    ACTIONS(2531), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [53175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [53183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      sym_identifier,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
  [53193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_LBRACE,
    STATE(281), 1,
      sym_field_declaration_list,
  [53203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2539), 1,
      anon_sym_LBRACE,
    STATE(789), 1,
      sym_field_declaration_list,
  [53213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(534), 1,
      sym_literal_value,
  [53223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 1,
      sym_identifier,
    ACTIONS(2543), 1,
      anon_sym_LPAREN,
  [53233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 1,
      sym_identifier,
    ACTIONS(2545), 1,
      anon_sym_LPAREN,
  [53243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_LBRACE,
    STATE(825), 1,
      sym_field_declaration_list,
  [53253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(672), 1,
      sym_parameter_list,
  [53263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    STATE(412), 1,
      sym_literal_value,
  [53281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(669), 1,
      sym_parameter_list,
  [53299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 1,
      sym_identifier,
    ACTIONS(2551), 1,
      anon_sym_LPAREN,
  [53309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    STATE(475), 1,
      sym_parameter_list,
  [53319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      anon_sym_LPAREN,
    STATE(393), 1,
      sym_argument_list,
  [53329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [53345] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(759), 1,
      anon_sym_LF,
    ACTIONS(761), 1,
      anon_sym_SEMI,
  [53355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [53363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 1,
      sym_identifier,
    STATE(841), 1,
      sym_qualified_type,
  [53373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 1,
      anon_sym_LBRACE,
    STATE(308), 1,
      sym_literal_value,
  [53391] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(738), 1,
      anon_sym_LF,
    ACTIONS(2559), 1,
      anon_sym_SEMI,
  [53401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(666), 1,
      sym_parameter_list,
  [53411] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(775), 1,
      anon_sym_LF,
    ACTIONS(777), 1,
      anon_sym_SEMI,
  [53421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 2,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [53429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    STATE(431), 1,
      sym_literal_value,
  [53439] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2563), 1,
      anon_sym_LF,
    ACTIONS(2565), 1,
      anon_sym_SEMI,
  [53449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 1,
      sym_identifier,
    ACTIONS(2569), 1,
      anon_sym_LPAREN,
  [53467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 1,
      anon_sym_LPAREN,
    STATE(364), 1,
      sym_argument_list,
  [53477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [53485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1790), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parameter_list,
  [53495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 1,
      sym_identifier,
    ACTIONS(2571), 1,
      anon_sym_LPAREN,
  [53505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1790), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym_parameter_list,
  [53515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      sym_parameter_list,
  [53525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_LPAREN,
    ACTIONS(2573), 1,
      anon_sym_RPAREN,
  [53535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2575), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [53543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    STATE(551), 1,
      sym_literal_value,
  [53569] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_LF,
    ACTIONS(2581), 1,
      anon_sym_SEMI,
  [53579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(670), 1,
      sym_parameter_list,
  [53589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    STATE(358), 1,
      sym_literal_value,
  [53599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(517), 1,
      sym_parameter_list,
  [53609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      sym_identifier,
    ACTIONS(2585), 1,
      anon_sym_LPAREN,
  [53619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_argument_list,
  [53637] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(652), 1,
      anon_sym_LF,
    ACTIONS(654), 1,
      anon_sym_SEMI,
  [53647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [53655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [53671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2587), 1,
      sym_identifier,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
  [53681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(619), 1,
      sym_parameter_list,
  [53691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 1,
      sym_identifier,
    ACTIONS(2591), 1,
      anon_sym_LPAREN,
  [53701] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_LF,
    ACTIONS(2595), 1,
      anon_sym_SEMI,
  [53711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_LPAREN,
    STATE(665), 1,
      sym_parameter_list,
  [53729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    STATE(514), 1,
      sym_argument_list,
  [53739] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_LF,
    ACTIONS(2603), 1,
      anon_sym_SEMI,
  [53749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 1,
      sym_identifier,
    ACTIONS(2605), 1,
      anon_sym_LPAREN,
  [53759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    STATE(907), 1,
      sym_block,
  [53769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_LPAREN,
    STATE(441), 1,
      sym_argument_list,
  [53779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_LPAREN,
    STATE(321), 1,
      sym_argument_list,
  [53789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [53797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_RPAREN,
  [53804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_RBRACE,
  [53811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2611), 1,
      anon_sym_LBRACE,
  [53818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_RPAREN,
  [53825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_RBRACK,
  [53832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 1,
      sym_identifier,
  [53839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 1,
      anon_sym_RPAREN,
  [53846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_LBRACE,
  [53853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_SEMI,
  [53860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_LBRACE,
  [53867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_LBRACE,
  [53874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_RPAREN,
  [53881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_RBRACE,
  [53888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_RPAREN,
  [53895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_SEMI,
  [53902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_chan,
  [53909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_SEMI,
  [53916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 1,
      anon_sym_RPAREN,
  [53923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 1,
      anon_sym_RPAREN,
  [53930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_LBRACE,
  [53937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2645), 1,
      anon_sym_RPAREN,
  [53944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 1,
      anon_sym_LBRACE,
  [53951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_RPAREN,
  [53958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
  [53965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 1,
      anon_sym_RPAREN,
  [53972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 1,
      sym_identifier,
  [53979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_RBRACE,
  [53986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 1,
      anon_sym_RPAREN,
  [53993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
  [54000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2663), 1,
      sym_identifier,
  [54007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      sym_identifier,
  [54014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_chan,
  [54021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_RBRACK,
  [54028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_EQ,
  [54035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_RBRACK,
  [54042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_RPAREN,
  [54049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2677), 1,
      anon_sym_chan,
  [54056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_chan,
  [54063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_LBRACE,
  [54070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2683), 1,
      anon_sym_EQ,
  [54077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2685), 1,
      sym_identifier,
  [54084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2687), 1,
      anon_sym_RPAREN,
  [54091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_RBRACE,
  [54098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_COLON,
  [54105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_RBRACE,
  [54112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2695), 1,
      sym_identifier,
  [54119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2344), 1,
      anon_sym_RPAREN,
  [54126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_COLON,
  [54133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_RPAREN,
  [54140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
  [54147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_RPAREN,
  [54154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_RPAREN,
  [54161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2707), 1,
      anon_sym_LBRACE,
  [54168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_COLON_EQ,
  [54175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_LPAREN,
  [54182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_RPAREN,
  [54189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2715), 1,
      ts_builtin_sym_end,
  [54196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      sym_identifier,
  [54203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 1,
      anon_sym_RPAREN,
  [54210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_LBRACE,
  [54217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 1,
      sym_identifier,
  [54224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 1,
      anon_sym_RPAREN,
  [54231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_RBRACE,
  [54238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 1,
      anon_sym_LBRACE,
  [54245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2731), 1,
      anon_sym_LBRACK,
  [54252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_COLON,
  [54259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_LBRACE,
  [54266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 1,
      anon_sym_RBRACK,
  [54273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_RBRACE,
  [54280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_RPAREN,
  [54287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_RBRACK,
  [54294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2743), 1,
      anon_sym_LBRACE,
  [54301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2745), 1,
      anon_sym_LBRACK,
  [54308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_LPAREN,
  [54315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2747), 1,
      sym_identifier,
  [54322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2749), 1,
      anon_sym_LBRACK,
  [54329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 1,
      anon_sym_LPAREN,
  [54336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 1,
      anon_sym_LPAREN,
  [54343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 1,
      anon_sym_LPAREN,
  [54350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 1,
      anon_sym_LPAREN,
  [54357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACK,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(22)] = 0,
  [SMALL_STATE(23)] = 118,
  [SMALL_STATE(24)] = 233,
  [SMALL_STATE(25)] = 348,
  [SMALL_STATE(26)] = 463,
  [SMALL_STATE(27)] = 578,
  [SMALL_STATE(28)] = 690,
  [SMALL_STATE(29)] = 786,
  [SMALL_STATE(30)] = 882,
  [SMALL_STATE(31)] = 978,
  [SMALL_STATE(32)] = 1087,
  [SMALL_STATE(33)] = 1178,
  [SMALL_STATE(34)] = 1290,
  [SMALL_STATE(35)] = 1402,
  [SMALL_STATE(36)] = 1514,
  [SMALL_STATE(37)] = 1626,
  [SMALL_STATE(38)] = 1738,
  [SMALL_STATE(39)] = 1850,
  [SMALL_STATE(40)] = 1962,
  [SMALL_STATE(41)] = 2074,
  [SMALL_STATE(42)] = 2186,
  [SMALL_STATE(43)] = 2298,
  [SMALL_STATE(44)] = 2410,
  [SMALL_STATE(45)] = 2522,
  [SMALL_STATE(46)] = 2634,
  [SMALL_STATE(47)] = 2746,
  [SMALL_STATE(48)] = 2858,
  [SMALL_STATE(49)] = 2970,
  [SMALL_STATE(50)] = 3082,
  [SMALL_STATE(51)] = 3194,
  [SMALL_STATE(52)] = 3303,
  [SMALL_STATE(53)] = 3409,
  [SMALL_STATE(54)] = 3514,
  [SMALL_STATE(55)] = 3619,
  [SMALL_STATE(56)] = 3724,
  [SMALL_STATE(57)] = 3829,
  [SMALL_STATE(58)] = 3934,
  [SMALL_STATE(59)] = 4039,
  [SMALL_STATE(60)] = 4144,
  [SMALL_STATE(61)] = 4249,
  [SMALL_STATE(62)] = 4354,
  [SMALL_STATE(63)] = 4459,
  [SMALL_STATE(64)] = 4564,
  [SMALL_STATE(65)] = 4669,
  [SMALL_STATE(66)] = 4774,
  [SMALL_STATE(67)] = 4879,
  [SMALL_STATE(68)] = 4984,
  [SMALL_STATE(69)] = 5089,
  [SMALL_STATE(70)] = 5194,
  [SMALL_STATE(71)] = 5299,
  [SMALL_STATE(72)] = 5404,
  [SMALL_STATE(73)] = 5509,
  [SMALL_STATE(74)] = 5614,
  [SMALL_STATE(75)] = 5719,
  [SMALL_STATE(76)] = 5824,
  [SMALL_STATE(77)] = 5929,
  [SMALL_STATE(78)] = 6034,
  [SMALL_STATE(79)] = 6136,
  [SMALL_STATE(80)] = 6238,
  [SMALL_STATE(81)] = 6340,
  [SMALL_STATE(82)] = 6442,
  [SMALL_STATE(83)] = 6544,
  [SMALL_STATE(84)] = 6646,
  [SMALL_STATE(85)] = 6748,
  [SMALL_STATE(86)] = 6850,
  [SMALL_STATE(87)] = 6952,
  [SMALL_STATE(88)] = 7054,
  [SMALL_STATE(89)] = 7156,
  [SMALL_STATE(90)] = 7258,
  [SMALL_STATE(91)] = 7360,
  [SMALL_STATE(92)] = 7462,
  [SMALL_STATE(93)] = 7564,
  [SMALL_STATE(94)] = 7666,
  [SMALL_STATE(95)] = 7768,
  [SMALL_STATE(96)] = 7870,
  [SMALL_STATE(97)] = 7972,
  [SMALL_STATE(98)] = 8074,
  [SMALL_STATE(99)] = 8176,
  [SMALL_STATE(100)] = 8278,
  [SMALL_STATE(101)] = 8380,
  [SMALL_STATE(102)] = 8482,
  [SMALL_STATE(103)] = 8584,
  [SMALL_STATE(104)] = 8686,
  [SMALL_STATE(105)] = 8788,
  [SMALL_STATE(106)] = 8890,
  [SMALL_STATE(107)] = 8992,
  [SMALL_STATE(108)] = 9094,
  [SMALL_STATE(109)] = 9196,
  [SMALL_STATE(110)] = 9298,
  [SMALL_STATE(111)] = 9400,
  [SMALL_STATE(112)] = 9502,
  [SMALL_STATE(113)] = 9604,
  [SMALL_STATE(114)] = 9706,
  [SMALL_STATE(115)] = 9808,
  [SMALL_STATE(116)] = 9910,
  [SMALL_STATE(117)] = 10012,
  [SMALL_STATE(118)] = 10114,
  [SMALL_STATE(119)] = 10216,
  [SMALL_STATE(120)] = 10318,
  [SMALL_STATE(121)] = 10420,
  [SMALL_STATE(122)] = 10522,
  [SMALL_STATE(123)] = 10624,
  [SMALL_STATE(124)] = 10726,
  [SMALL_STATE(125)] = 10828,
  [SMALL_STATE(126)] = 10930,
  [SMALL_STATE(127)] = 11032,
  [SMALL_STATE(128)] = 11134,
  [SMALL_STATE(129)] = 11236,
  [SMALL_STATE(130)] = 11338,
  [SMALL_STATE(131)] = 11440,
  [SMALL_STATE(132)] = 11542,
  [SMALL_STATE(133)] = 11641,
  [SMALL_STATE(134)] = 11740,
  [SMALL_STATE(135)] = 11839,
  [SMALL_STATE(136)] = 11938,
  [SMALL_STATE(137)] = 12037,
  [SMALL_STATE(138)] = 12136,
  [SMALL_STATE(139)] = 12235,
  [SMALL_STATE(140)] = 12334,
  [SMALL_STATE(141)] = 12433,
  [SMALL_STATE(142)] = 12532,
  [SMALL_STATE(143)] = 12631,
  [SMALL_STATE(144)] = 12730,
  [SMALL_STATE(145)] = 12829,
  [SMALL_STATE(146)] = 12928,
  [SMALL_STATE(147)] = 13027,
  [SMALL_STATE(148)] = 13126,
  [SMALL_STATE(149)] = 13225,
  [SMALL_STATE(150)] = 13324,
  [SMALL_STATE(151)] = 13423,
  [SMALL_STATE(152)] = 13522,
  [SMALL_STATE(153)] = 13621,
  [SMALL_STATE(154)] = 13720,
  [SMALL_STATE(155)] = 13819,
  [SMALL_STATE(156)] = 13918,
  [SMALL_STATE(157)] = 14017,
  [SMALL_STATE(158)] = 14116,
  [SMALL_STATE(159)] = 14215,
  [SMALL_STATE(160)] = 14314,
  [SMALL_STATE(161)] = 14413,
  [SMALL_STATE(162)] = 14512,
  [SMALL_STATE(163)] = 14611,
  [SMALL_STATE(164)] = 14710,
  [SMALL_STATE(165)] = 14809,
  [SMALL_STATE(166)] = 14908,
  [SMALL_STATE(167)] = 15007,
  [SMALL_STATE(168)] = 15106,
  [SMALL_STATE(169)] = 15205,
  [SMALL_STATE(170)] = 15304,
  [SMALL_STATE(171)] = 15403,
  [SMALL_STATE(172)] = 15502,
  [SMALL_STATE(173)] = 15601,
  [SMALL_STATE(174)] = 15700,
  [SMALL_STATE(175)] = 15799,
  [SMALL_STATE(176)] = 15898,
  [SMALL_STATE(177)] = 15997,
  [SMALL_STATE(178)] = 16096,
  [SMALL_STATE(179)] = 16195,
  [SMALL_STATE(180)] = 16294,
  [SMALL_STATE(181)] = 16393,
  [SMALL_STATE(182)] = 16492,
  [SMALL_STATE(183)] = 16591,
  [SMALL_STATE(184)] = 16690,
  [SMALL_STATE(185)] = 16789,
  [SMALL_STATE(186)] = 16888,
  [SMALL_STATE(187)] = 16987,
  [SMALL_STATE(188)] = 17086,
  [SMALL_STATE(189)] = 17185,
  [SMALL_STATE(190)] = 17284,
  [SMALL_STATE(191)] = 17383,
  [SMALL_STATE(192)] = 17482,
  [SMALL_STATE(193)] = 17581,
  [SMALL_STATE(194)] = 17680,
  [SMALL_STATE(195)] = 17779,
  [SMALL_STATE(196)] = 17878,
  [SMALL_STATE(197)] = 17977,
  [SMALL_STATE(198)] = 18076,
  [SMALL_STATE(199)] = 18175,
  [SMALL_STATE(200)] = 18274,
  [SMALL_STATE(201)] = 18373,
  [SMALL_STATE(202)] = 18472,
  [SMALL_STATE(203)] = 18571,
  [SMALL_STATE(204)] = 18670,
  [SMALL_STATE(205)] = 18769,
  [SMALL_STATE(206)] = 18868,
  [SMALL_STATE(207)] = 18967,
  [SMALL_STATE(208)] = 19066,
  [SMALL_STATE(209)] = 19165,
  [SMALL_STATE(210)] = 19264,
  [SMALL_STATE(211)] = 19363,
  [SMALL_STATE(212)] = 19462,
  [SMALL_STATE(213)] = 19561,
  [SMALL_STATE(214)] = 19660,
  [SMALL_STATE(215)] = 19759,
  [SMALL_STATE(216)] = 19858,
  [SMALL_STATE(217)] = 19957,
  [SMALL_STATE(218)] = 20056,
  [SMALL_STATE(219)] = 20155,
  [SMALL_STATE(220)] = 20254,
  [SMALL_STATE(221)] = 20353,
  [SMALL_STATE(222)] = 20452,
  [SMALL_STATE(223)] = 20551,
  [SMALL_STATE(224)] = 20650,
  [SMALL_STATE(225)] = 20749,
  [SMALL_STATE(226)] = 20848,
  [SMALL_STATE(227)] = 20947,
  [SMALL_STATE(228)] = 21046,
  [SMALL_STATE(229)] = 21145,
  [SMALL_STATE(230)] = 21244,
  [SMALL_STATE(231)] = 21343,
  [SMALL_STATE(232)] = 21442,
  [SMALL_STATE(233)] = 21541,
  [SMALL_STATE(234)] = 21640,
  [SMALL_STATE(235)] = 21739,
  [SMALL_STATE(236)] = 21838,
  [SMALL_STATE(237)] = 21937,
  [SMALL_STATE(238)] = 22000,
  [SMALL_STATE(239)] = 22070,
  [SMALL_STATE(240)] = 22130,
  [SMALL_STATE(241)] = 22200,
  [SMALL_STATE(242)] = 22260,
  [SMALL_STATE(243)] = 22320,
  [SMALL_STATE(244)] = 22375,
  [SMALL_STATE(245)] = 22430,
  [SMALL_STATE(246)] = 22485,
  [SMALL_STATE(247)] = 22552,
  [SMALL_STATE(248)] = 22639,
  [SMALL_STATE(249)] = 22694,
  [SMALL_STATE(250)] = 22749,
  [SMALL_STATE(251)] = 22804,
  [SMALL_STATE(252)] = 22859,
  [SMALL_STATE(253)] = 22914,
  [SMALL_STATE(254)] = 22969,
  [SMALL_STATE(255)] = 23024,
  [SMALL_STATE(256)] = 23079,
  [SMALL_STATE(257)] = 23134,
  [SMALL_STATE(258)] = 23189,
  [SMALL_STATE(259)] = 23244,
  [SMALL_STATE(260)] = 23303,
  [SMALL_STATE(261)] = 23358,
  [SMALL_STATE(262)] = 23413,
  [SMALL_STATE(263)] = 23468,
  [SMALL_STATE(264)] = 23523,
  [SMALL_STATE(265)] = 23578,
  [SMALL_STATE(266)] = 23633,
  [SMALL_STATE(267)] = 23688,
  [SMALL_STATE(268)] = 23743,
  [SMALL_STATE(269)] = 23798,
  [SMALL_STATE(270)] = 23853,
  [SMALL_STATE(271)] = 23908,
  [SMALL_STATE(272)] = 23963,
  [SMALL_STATE(273)] = 24018,
  [SMALL_STATE(274)] = 24073,
  [SMALL_STATE(275)] = 24128,
  [SMALL_STATE(276)] = 24183,
  [SMALL_STATE(277)] = 24238,
  [SMALL_STATE(278)] = 24293,
  [SMALL_STATE(279)] = 24386,
  [SMALL_STATE(280)] = 24441,
  [SMALL_STATE(281)] = 24496,
  [SMALL_STATE(282)] = 24551,
  [SMALL_STATE(283)] = 24606,
  [SMALL_STATE(284)] = 24661,
  [SMALL_STATE(285)] = 24716,
  [SMALL_STATE(286)] = 24771,
  [SMALL_STATE(287)] = 24826,
  [SMALL_STATE(288)] = 24881,
  [SMALL_STATE(289)] = 24936,
  [SMALL_STATE(290)] = 24991,
  [SMALL_STATE(291)] = 25046,
  [SMALL_STATE(292)] = 25101,
  [SMALL_STATE(293)] = 25156,
  [SMALL_STATE(294)] = 25210,
  [SMALL_STATE(295)] = 25274,
  [SMALL_STATE(296)] = 25338,
  [SMALL_STATE(297)] = 25404,
  [SMALL_STATE(298)] = 25472,
  [SMALL_STATE(299)] = 25542,
  [SMALL_STATE(300)] = 25614,
  [SMALL_STATE(301)] = 25705,
  [SMALL_STATE(302)] = 25796,
  [SMALL_STATE(303)] = 25849,
  [SMALL_STATE(304)] = 25902,
  [SMALL_STATE(305)] = 25959,
  [SMALL_STATE(306)] = 26011,
  [SMALL_STATE(307)] = 26063,
  [SMALL_STATE(308)] = 26115,
  [SMALL_STATE(309)] = 26167,
  [SMALL_STATE(310)] = 26219,
  [SMALL_STATE(311)] = 26271,
  [SMALL_STATE(312)] = 26323,
  [SMALL_STATE(313)] = 26375,
  [SMALL_STATE(314)] = 26427,
  [SMALL_STATE(315)] = 26479,
  [SMALL_STATE(316)] = 26531,
  [SMALL_STATE(317)] = 26583,
  [SMALL_STATE(318)] = 26635,
  [SMALL_STATE(319)] = 26687,
  [SMALL_STATE(320)] = 26739,
  [SMALL_STATE(321)] = 26791,
  [SMALL_STATE(322)] = 26843,
  [SMALL_STATE(323)] = 26895,
  [SMALL_STATE(324)] = 26947,
  [SMALL_STATE(325)] = 26999,
  [SMALL_STATE(326)] = 27051,
  [SMALL_STATE(327)] = 27103,
  [SMALL_STATE(328)] = 27155,
  [SMALL_STATE(329)] = 27207,
  [SMALL_STATE(330)] = 27259,
  [SMALL_STATE(331)] = 27311,
  [SMALL_STATE(332)] = 27363,
  [SMALL_STATE(333)] = 27415,
  [SMALL_STATE(334)] = 27467,
  [SMALL_STATE(335)] = 27519,
  [SMALL_STATE(336)] = 27571,
  [SMALL_STATE(337)] = 27623,
  [SMALL_STATE(338)] = 27711,
  [SMALL_STATE(339)] = 27774,
  [SMALL_STATE(340)] = 27835,
  [SMALL_STATE(341)] = 27920,
  [SMALL_STATE(342)] = 27989,
  [SMALL_STATE(343)] = 28054,
  [SMALL_STATE(344)] = 28115,
  [SMALL_STATE(345)] = 28186,
  [SMALL_STATE(346)] = 28247,
  [SMALL_STATE(347)] = 28301,
  [SMALL_STATE(348)] = 28350,
  [SMALL_STATE(349)] = 28399,
  [SMALL_STATE(350)] = 28448,
  [SMALL_STATE(351)] = 28497,
  [SMALL_STATE(352)] = 28546,
  [SMALL_STATE(353)] = 28595,
  [SMALL_STATE(354)] = 28644,
  [SMALL_STATE(355)] = 28693,
  [SMALL_STATE(356)] = 28742,
  [SMALL_STATE(357)] = 28791,
  [SMALL_STATE(358)] = 28840,
  [SMALL_STATE(359)] = 28889,
  [SMALL_STATE(360)] = 28938,
  [SMALL_STATE(361)] = 28987,
  [SMALL_STATE(362)] = 29036,
  [SMALL_STATE(363)] = 29085,
  [SMALL_STATE(364)] = 29134,
  [SMALL_STATE(365)] = 29183,
  [SMALL_STATE(366)] = 29232,
  [SMALL_STATE(367)] = 29281,
  [SMALL_STATE(368)] = 29330,
  [SMALL_STATE(369)] = 29379,
  [SMALL_STATE(370)] = 29428,
  [SMALL_STATE(371)] = 29477,
  [SMALL_STATE(372)] = 29526,
  [SMALL_STATE(373)] = 29575,
  [SMALL_STATE(374)] = 29624,
  [SMALL_STATE(375)] = 29673,
  [SMALL_STATE(376)] = 29722,
  [SMALL_STATE(377)] = 29771,
  [SMALL_STATE(378)] = 29820,
  [SMALL_STATE(379)] = 29869,
  [SMALL_STATE(380)] = 29918,
  [SMALL_STATE(381)] = 29967,
  [SMALL_STATE(382)] = 30026,
  [SMALL_STATE(383)] = 30082,
  [SMALL_STATE(384)] = 30148,
  [SMALL_STATE(385)] = 30212,
  [SMALL_STATE(386)] = 30272,
  [SMALL_STATE(387)] = 30330,
  [SMALL_STATE(388)] = 30386,
  [SMALL_STATE(389)] = 30454,
  [SMALL_STATE(390)] = 30503,
  [SMALL_STATE(391)] = 30547,
  [SMALL_STATE(392)] = 30591,
  [SMALL_STATE(393)] = 30635,
  [SMALL_STATE(394)] = 30679,
  [SMALL_STATE(395)] = 30723,
  [SMALL_STATE(396)] = 30767,
  [SMALL_STATE(397)] = 30811,
  [SMALL_STATE(398)] = 30855,
  [SMALL_STATE(399)] = 30899,
  [SMALL_STATE(400)] = 30943,
  [SMALL_STATE(401)] = 30987,
  [SMALL_STATE(402)] = 31031,
  [SMALL_STATE(403)] = 31075,
  [SMALL_STATE(404)] = 31119,
  [SMALL_STATE(405)] = 31163,
  [SMALL_STATE(406)] = 31207,
  [SMALL_STATE(407)] = 31251,
  [SMALL_STATE(408)] = 31295,
  [SMALL_STATE(409)] = 31339,
  [SMALL_STATE(410)] = 31383,
  [SMALL_STATE(411)] = 31427,
  [SMALL_STATE(412)] = 31471,
  [SMALL_STATE(413)] = 31515,
  [SMALL_STATE(414)] = 31559,
  [SMALL_STATE(415)] = 31603,
  [SMALL_STATE(416)] = 31647,
  [SMALL_STATE(417)] = 31691,
  [SMALL_STATE(418)] = 31735,
  [SMALL_STATE(419)] = 31779,
  [SMALL_STATE(420)] = 31823,
  [SMALL_STATE(421)] = 31867,
  [SMALL_STATE(422)] = 31911,
  [SMALL_STATE(423)] = 31955,
  [SMALL_STATE(424)] = 31999,
  [SMALL_STATE(425)] = 32051,
  [SMALL_STATE(426)] = 32103,
  [SMALL_STATE(427)] = 32156,
  [SMALL_STATE(428)] = 32201,
  [SMALL_STATE(429)] = 32241,
  [SMALL_STATE(430)] = 32281,
  [SMALL_STATE(431)] = 32321,
  [SMALL_STATE(432)] = 32361,
  [SMALL_STATE(433)] = 32401,
  [SMALL_STATE(434)] = 32441,
  [SMALL_STATE(435)] = 32481,
  [SMALL_STATE(436)] = 32521,
  [SMALL_STATE(437)] = 32561,
  [SMALL_STATE(438)] = 32601,
  [SMALL_STATE(439)] = 32641,
  [SMALL_STATE(440)] = 32681,
  [SMALL_STATE(441)] = 32721,
  [SMALL_STATE(442)] = 32761,
  [SMALL_STATE(443)] = 32801,
  [SMALL_STATE(444)] = 32841,
  [SMALL_STATE(445)] = 32881,
  [SMALL_STATE(446)] = 32921,
  [SMALL_STATE(447)] = 32961,
  [SMALL_STATE(448)] = 33001,
  [SMALL_STATE(449)] = 33041,
  [SMALL_STATE(450)] = 33081,
  [SMALL_STATE(451)] = 33121,
  [SMALL_STATE(452)] = 33161,
  [SMALL_STATE(453)] = 33201,
  [SMALL_STATE(454)] = 33241,
  [SMALL_STATE(455)] = 33281,
  [SMALL_STATE(456)] = 33321,
  [SMALL_STATE(457)] = 33361,
  [SMALL_STATE(458)] = 33401,
  [SMALL_STATE(459)] = 33441,
  [SMALL_STATE(460)] = 33481,
  [SMALL_STATE(461)] = 33521,
  [SMALL_STATE(462)] = 33561,
  [SMALL_STATE(463)] = 33618,
  [SMALL_STATE(464)] = 33669,
  [SMALL_STATE(465)] = 33744,
  [SMALL_STATE(466)] = 33807,
  [SMALL_STATE(467)] = 33868,
  [SMALL_STATE(468)] = 33921,
  [SMALL_STATE(469)] = 33984,
  [SMALL_STATE(470)] = 34032,
  [SMALL_STATE(471)] = 34100,
  [SMALL_STATE(472)] = 34172,
  [SMALL_STATE(473)] = 34222,
  [SMALL_STATE(474)] = 34290,
  [SMALL_STATE(475)] = 34338,
  [SMALL_STATE(476)] = 34400,
  [SMALL_STATE(477)] = 34456,
  [SMALL_STATE(478)] = 34514,
  [SMALL_STATE(479)] = 34568,
  [SMALL_STATE(480)] = 34620,
  [SMALL_STATE(481)] = 34670,
  [SMALL_STATE(482)] = 34727,
  [SMALL_STATE(483)] = 34774,
  [SMALL_STATE(484)] = 34821,
  [SMALL_STATE(485)] = 34862,
  [SMALL_STATE(486)] = 34923,
  [SMALL_STATE(487)] = 34982,
  [SMALL_STATE(488)] = 35037,
  [SMALL_STATE(489)] = 35094,
  [SMALL_STATE(490)] = 35145,
  [SMALL_STATE(491)] = 35202,
  [SMALL_STATE(492)] = 35265,
  [SMALL_STATE(493)] = 35301,
  [SMALL_STATE(494)] = 35337,
  [SMALL_STATE(495)] = 35373,
  [SMALL_STATE(496)] = 35439,
  [SMALL_STATE(497)] = 35475,
  [SMALL_STATE(498)] = 35511,
  [SMALL_STATE(499)] = 35559,
  [SMALL_STATE(500)] = 35595,
  [SMALL_STATE(501)] = 35631,
  [SMALL_STATE(502)] = 35667,
  [SMALL_STATE(503)] = 35703,
  [SMALL_STATE(504)] = 35739,
  [SMALL_STATE(505)] = 35775,
  [SMALL_STATE(506)] = 35811,
  [SMALL_STATE(507)] = 35847,
  [SMALL_STATE(508)] = 35915,
  [SMALL_STATE(509)] = 35951,
  [SMALL_STATE(510)] = 36017,
  [SMALL_STATE(511)] = 36053,
  [SMALL_STATE(512)] = 36089,
  [SMALL_STATE(513)] = 36139,
  [SMALL_STATE(514)] = 36205,
  [SMALL_STATE(515)] = 36241,
  [SMALL_STATE(516)] = 36291,
  [SMALL_STATE(517)] = 36327,
  [SMALL_STATE(518)] = 36385,
  [SMALL_STATE(519)] = 36421,
  [SMALL_STATE(520)] = 36487,
  [SMALL_STATE(521)] = 36523,
  [SMALL_STATE(522)] = 36559,
  [SMALL_STATE(523)] = 36595,
  [SMALL_STATE(524)] = 36631,
  [SMALL_STATE(525)] = 36667,
  [SMALL_STATE(526)] = 36733,
  [SMALL_STATE(527)] = 36769,
  [SMALL_STATE(528)] = 36805,
  [SMALL_STATE(529)] = 36845,
  [SMALL_STATE(530)] = 36881,
  [SMALL_STATE(531)] = 36945,
  [SMALL_STATE(532)] = 36981,
  [SMALL_STATE(533)] = 37017,
  [SMALL_STATE(534)] = 37083,
  [SMALL_STATE(535)] = 37119,
  [SMALL_STATE(536)] = 37155,
  [SMALL_STATE(537)] = 37191,
  [SMALL_STATE(538)] = 37227,
  [SMALL_STATE(539)] = 37263,
  [SMALL_STATE(540)] = 37329,
  [SMALL_STATE(541)] = 37390,
  [SMALL_STATE(542)] = 37425,
  [SMALL_STATE(543)] = 37488,
  [SMALL_STATE(544)] = 37537,
  [SMALL_STATE(545)] = 37600,
  [SMALL_STATE(546)] = 37635,
  [SMALL_STATE(547)] = 37670,
  [SMALL_STATE(548)] = 37723,
  [SMALL_STATE(549)] = 37778,
  [SMALL_STATE(550)] = 37841,
  [SMALL_STATE(551)] = 37876,
  [SMALL_STATE(552)] = 37911,
  [SMALL_STATE(553)] = 37956,
  [SMALL_STATE(554)] = 37991,
  [SMALL_STATE(555)] = 38048,
  [SMALL_STATE(556)] = 38083,
  [SMALL_STATE(557)] = 38146,
  [SMALL_STATE(558)] = 38209,
  [SMALL_STATE(559)] = 38244,
  [SMALL_STATE(560)] = 38279,
  [SMALL_STATE(561)] = 38314,
  [SMALL_STATE(562)] = 38349,
  [SMALL_STATE(563)] = 38410,
  [SMALL_STATE(564)] = 38471,
  [SMALL_STATE(565)] = 38506,
  [SMALL_STATE(566)] = 38541,
  [SMALL_STATE(567)] = 38576,
  [SMALL_STATE(568)] = 38611,
  [SMALL_STATE(569)] = 38646,
  [SMALL_STATE(570)] = 38681,
  [SMALL_STATE(571)] = 38716,
  [SMALL_STATE(572)] = 38751,
  [SMALL_STATE(573)] = 38786,
  [SMALL_STATE(574)] = 38821,
  [SMALL_STATE(575)] = 38856,
  [SMALL_STATE(576)] = 38891,
  [SMALL_STATE(577)] = 38940,
  [SMALL_STATE(578)] = 38975,
  [SMALL_STATE(579)] = 39028,
  [SMALL_STATE(580)] = 39083,
  [SMALL_STATE(581)] = 39140,
  [SMALL_STATE(582)] = 39175,
  [SMALL_STATE(583)] = 39210,
  [SMALL_STATE(584)] = 39275,
  [SMALL_STATE(585)] = 39310,
  [SMALL_STATE(586)] = 39345,
  [SMALL_STATE(587)] = 39380,
  [SMALL_STATE(588)] = 39415,
  [SMALL_STATE(589)] = 39450,
  [SMALL_STATE(590)] = 39485,
  [SMALL_STATE(591)] = 39520,
  [SMALL_STATE(592)] = 39555,
  [SMALL_STATE(593)] = 39615,
  [SMALL_STATE(594)] = 39675,
  [SMALL_STATE(595)] = 39735,
  [SMALL_STATE(596)] = 39795,
  [SMALL_STATE(597)] = 39855,
  [SMALL_STATE(598)] = 39915,
  [SMALL_STATE(599)] = 39975,
  [SMALL_STATE(600)] = 40035,
  [SMALL_STATE(601)] = 40095,
  [SMALL_STATE(602)] = 40155,
  [SMALL_STATE(603)] = 40215,
  [SMALL_STATE(604)] = 40275,
  [SMALL_STATE(605)] = 40333,
  [SMALL_STATE(606)] = 40393,
  [SMALL_STATE(607)] = 40453,
  [SMALL_STATE(608)] = 40513,
  [SMALL_STATE(609)] = 40571,
  [SMALL_STATE(610)] = 40631,
  [SMALL_STATE(611)] = 40691,
  [SMALL_STATE(612)] = 40751,
  [SMALL_STATE(613)] = 40811,
  [SMALL_STATE(614)] = 40871,
  [SMALL_STATE(615)] = 40931,
  [SMALL_STATE(616)] = 40991,
  [SMALL_STATE(617)] = 41051,
  [SMALL_STATE(618)] = 41111,
  [SMALL_STATE(619)] = 41171,
  [SMALL_STATE(620)] = 41227,
  [SMALL_STATE(621)] = 41287,
  [SMALL_STATE(622)] = 41347,
  [SMALL_STATE(623)] = 41407,
  [SMALL_STATE(624)] = 41465,
  [SMALL_STATE(625)] = 41525,
  [SMALL_STATE(626)] = 41585,
  [SMALL_STATE(627)] = 41645,
  [SMALL_STATE(628)] = 41703,
  [SMALL_STATE(629)] = 41761,
  [SMALL_STATE(630)] = 41818,
  [SMALL_STATE(631)] = 41875,
  [SMALL_STATE(632)] = 41932,
  [SMALL_STATE(633)] = 41989,
  [SMALL_STATE(634)] = 42046,
  [SMALL_STATE(635)] = 42103,
  [SMALL_STATE(636)] = 42160,
  [SMALL_STATE(637)] = 42217,
  [SMALL_STATE(638)] = 42274,
  [SMALL_STATE(639)] = 42331,
  [SMALL_STATE(640)] = 42388,
  [SMALL_STATE(641)] = 42445,
  [SMALL_STATE(642)] = 42502,
  [SMALL_STATE(643)] = 42559,
  [SMALL_STATE(644)] = 42618,
  [SMALL_STATE(645)] = 42675,
  [SMALL_STATE(646)] = 42732,
  [SMALL_STATE(647)] = 42789,
  [SMALL_STATE(648)] = 42846,
  [SMALL_STATE(649)] = 42903,
  [SMALL_STATE(650)] = 42962,
  [SMALL_STATE(651)] = 43019,
  [SMALL_STATE(652)] = 43076,
  [SMALL_STATE(653)] = 43133,
  [SMALL_STATE(654)] = 43190,
  [SMALL_STATE(655)] = 43247,
  [SMALL_STATE(656)] = 43304,
  [SMALL_STATE(657)] = 43361,
  [SMALL_STATE(658)] = 43418,
  [SMALL_STATE(659)] = 43475,
  [SMALL_STATE(660)] = 43532,
  [SMALL_STATE(661)] = 43589,
  [SMALL_STATE(662)] = 43645,
  [SMALL_STATE(663)] = 43701,
  [SMALL_STATE(664)] = 43755,
  [SMALL_STATE(665)] = 43811,
  [SMALL_STATE(666)] = 43867,
  [SMALL_STATE(667)] = 43923,
  [SMALL_STATE(668)] = 43979,
  [SMALL_STATE(669)] = 44035,
  [SMALL_STATE(670)] = 44091,
  [SMALL_STATE(671)] = 44147,
  [SMALL_STATE(672)] = 44203,
  [SMALL_STATE(673)] = 44259,
  [SMALL_STATE(674)] = 44312,
  [SMALL_STATE(675)] = 44365,
  [SMALL_STATE(676)] = 44418,
  [SMALL_STATE(677)] = 44471,
  [SMALL_STATE(678)] = 44524,
  [SMALL_STATE(679)] = 44577,
  [SMALL_STATE(680)] = 44630,
  [SMALL_STATE(681)] = 44683,
  [SMALL_STATE(682)] = 44736,
  [SMALL_STATE(683)] = 44789,
  [SMALL_STATE(684)] = 44842,
  [SMALL_STATE(685)] = 44895,
  [SMALL_STATE(686)] = 44945,
  [SMALL_STATE(687)] = 44995,
  [SMALL_STATE(688)] = 45045,
  [SMALL_STATE(689)] = 45095,
  [SMALL_STATE(690)] = 45145,
  [SMALL_STATE(691)] = 45195,
  [SMALL_STATE(692)] = 45245,
  [SMALL_STATE(693)] = 45295,
  [SMALL_STATE(694)] = 45345,
  [SMALL_STATE(695)] = 45395,
  [SMALL_STATE(696)] = 45445,
  [SMALL_STATE(697)] = 45495,
  [SMALL_STATE(698)] = 45545,
  [SMALL_STATE(699)] = 45595,
  [SMALL_STATE(700)] = 45645,
  [SMALL_STATE(701)] = 45695,
  [SMALL_STATE(702)] = 45745,
  [SMALL_STATE(703)] = 45795,
  [SMALL_STATE(704)] = 45845,
  [SMALL_STATE(705)] = 45895,
  [SMALL_STATE(706)] = 45945,
  [SMALL_STATE(707)] = 45995,
  [SMALL_STATE(708)] = 46045,
  [SMALL_STATE(709)] = 46095,
  [SMALL_STATE(710)] = 46145,
  [SMALL_STATE(711)] = 46195,
  [SMALL_STATE(712)] = 46245,
  [SMALL_STATE(713)] = 46295,
  [SMALL_STATE(714)] = 46345,
  [SMALL_STATE(715)] = 46395,
  [SMALL_STATE(716)] = 46445,
  [SMALL_STATE(717)] = 46495,
  [SMALL_STATE(718)] = 46545,
  [SMALL_STATE(719)] = 46595,
  [SMALL_STATE(720)] = 46645,
  [SMALL_STATE(721)] = 46695,
  [SMALL_STATE(722)] = 46745,
  [SMALL_STATE(723)] = 46795,
  [SMALL_STATE(724)] = 46845,
  [SMALL_STATE(725)] = 46895,
  [SMALL_STATE(726)] = 46945,
  [SMALL_STATE(727)] = 46995,
  [SMALL_STATE(728)] = 47045,
  [SMALL_STATE(729)] = 47095,
  [SMALL_STATE(730)] = 47145,
  [SMALL_STATE(731)] = 47195,
  [SMALL_STATE(732)] = 47245,
  [SMALL_STATE(733)] = 47295,
  [SMALL_STATE(734)] = 47345,
  [SMALL_STATE(735)] = 47395,
  [SMALL_STATE(736)] = 47445,
  [SMALL_STATE(737)] = 47495,
  [SMALL_STATE(738)] = 47545,
  [SMALL_STATE(739)] = 47595,
  [SMALL_STATE(740)] = 47645,
  [SMALL_STATE(741)] = 47695,
  [SMALL_STATE(742)] = 47745,
  [SMALL_STATE(743)] = 47795,
  [SMALL_STATE(744)] = 47845,
  [SMALL_STATE(745)] = 47895,
  [SMALL_STATE(746)] = 47945,
  [SMALL_STATE(747)] = 47971,
  [SMALL_STATE(748)] = 47997,
  [SMALL_STATE(749)] = 48027,
  [SMALL_STATE(750)] = 48053,
  [SMALL_STATE(751)] = 48079,
  [SMALL_STATE(752)] = 48104,
  [SMALL_STATE(753)] = 48128,
  [SMALL_STATE(754)] = 48152,
  [SMALL_STATE(755)] = 48176,
  [SMALL_STATE(756)] = 48200,
  [SMALL_STATE(757)] = 48225,
  [SMALL_STATE(758)] = 48250,
  [SMALL_STATE(759)] = 48271,
  [SMALL_STATE(760)] = 48292,
  [SMALL_STATE(761)] = 48313,
  [SMALL_STATE(762)] = 48338,
  [SMALL_STATE(763)] = 48361,
  [SMALL_STATE(764)] = 48382,
  [SMALL_STATE(765)] = 48402,
  [SMALL_STATE(766)] = 48426,
  [SMALL_STATE(767)] = 48451,
  [SMALL_STATE(768)] = 48470,
  [SMALL_STATE(769)] = 48488,
  [SMALL_STATE(770)] = 48506,
  [SMALL_STATE(771)] = 48540,
  [SMALL_STATE(772)] = 48574,
  [SMALL_STATE(773)] = 48592,
  [SMALL_STATE(774)] = 48626,
  [SMALL_STATE(775)] = 48658,
  [SMALL_STATE(776)] = 48680,
  [SMALL_STATE(777)] = 48705,
  [SMALL_STATE(778)] = 48730,
  [SMALL_STATE(779)] = 48755,
  [SMALL_STATE(780)] = 48780,
  [SMALL_STATE(781)] = 48805,
  [SMALL_STATE(782)] = 48830,
  [SMALL_STATE(783)] = 48855,
  [SMALL_STATE(784)] = 48880,
  [SMALL_STATE(785)] = 48905,
  [SMALL_STATE(786)] = 48921,
  [SMALL_STATE(787)] = 48937,
  [SMALL_STATE(788)] = 48959,
  [SMALL_STATE(789)] = 48975,
  [SMALL_STATE(790)] = 48991,
  [SMALL_STATE(791)] = 49007,
  [SMALL_STATE(792)] = 49023,
  [SMALL_STATE(793)] = 49039,
  [SMALL_STATE(794)] = 49055,
  [SMALL_STATE(795)] = 49071,
  [SMALL_STATE(796)] = 49087,
  [SMALL_STATE(797)] = 49103,
  [SMALL_STATE(798)] = 49119,
  [SMALL_STATE(799)] = 49135,
  [SMALL_STATE(800)] = 49151,
  [SMALL_STATE(801)] = 49167,
  [SMALL_STATE(802)] = 49183,
  [SMALL_STATE(803)] = 49199,
  [SMALL_STATE(804)] = 49215,
  [SMALL_STATE(805)] = 49231,
  [SMALL_STATE(806)] = 49247,
  [SMALL_STATE(807)] = 49263,
  [SMALL_STATE(808)] = 49279,
  [SMALL_STATE(809)] = 49295,
  [SMALL_STATE(810)] = 49311,
  [SMALL_STATE(811)] = 49327,
  [SMALL_STATE(812)] = 49350,
  [SMALL_STATE(813)] = 49363,
  [SMALL_STATE(814)] = 49376,
  [SMALL_STATE(815)] = 49389,
  [SMALL_STATE(816)] = 49402,
  [SMALL_STATE(817)] = 49421,
  [SMALL_STATE(818)] = 49434,
  [SMALL_STATE(819)] = 49447,
  [SMALL_STATE(820)] = 49460,
  [SMALL_STATE(821)] = 49473,
  [SMALL_STATE(822)] = 49492,
  [SMALL_STATE(823)] = 49505,
  [SMALL_STATE(824)] = 49518,
  [SMALL_STATE(825)] = 49531,
  [SMALL_STATE(826)] = 49544,
  [SMALL_STATE(827)] = 49557,
  [SMALL_STATE(828)] = 49570,
  [SMALL_STATE(829)] = 49583,
  [SMALL_STATE(830)] = 49596,
  [SMALL_STATE(831)] = 49609,
  [SMALL_STATE(832)] = 49622,
  [SMALL_STATE(833)] = 49635,
  [SMALL_STATE(834)] = 49648,
  [SMALL_STATE(835)] = 49661,
  [SMALL_STATE(836)] = 49674,
  [SMALL_STATE(837)] = 49687,
  [SMALL_STATE(838)] = 49700,
  [SMALL_STATE(839)] = 49723,
  [SMALL_STATE(840)] = 49736,
  [SMALL_STATE(841)] = 49754,
  [SMALL_STATE(842)] = 49774,
  [SMALL_STATE(843)] = 49792,
  [SMALL_STATE(844)] = 49810,
  [SMALL_STATE(845)] = 49830,
  [SMALL_STATE(846)] = 49850,
  [SMALL_STATE(847)] = 49866,
  [SMALL_STATE(848)] = 49884,
  [SMALL_STATE(849)] = 49900,
  [SMALL_STATE(850)] = 49914,
  [SMALL_STATE(851)] = 49930,
  [SMALL_STATE(852)] = 49952,
  [SMALL_STATE(853)] = 49970,
  [SMALL_STATE(854)] = 49988,
  [SMALL_STATE(855)] = 50006,
  [SMALL_STATE(856)] = 50024,
  [SMALL_STATE(857)] = 50040,
  [SMALL_STATE(858)] = 50058,
  [SMALL_STATE(859)] = 50074,
  [SMALL_STATE(860)] = 50094,
  [SMALL_STATE(861)] = 50112,
  [SMALL_STATE(862)] = 50130,
  [SMALL_STATE(863)] = 50146,
  [SMALL_STATE(864)] = 50164,
  [SMALL_STATE(865)] = 50180,
  [SMALL_STATE(866)] = 50198,
  [SMALL_STATE(867)] = 50216,
  [SMALL_STATE(868)] = 50232,
  [SMALL_STATE(869)] = 50250,
  [SMALL_STATE(870)] = 50268,
  [SMALL_STATE(871)] = 50286,
  [SMALL_STATE(872)] = 50304,
  [SMALL_STATE(873)] = 50322,
  [SMALL_STATE(874)] = 50340,
  [SMALL_STATE(875)] = 50353,
  [SMALL_STATE(876)] = 50370,
  [SMALL_STATE(877)] = 50383,
  [SMALL_STATE(878)] = 50396,
  [SMALL_STATE(879)] = 50409,
  [SMALL_STATE(880)] = 50422,
  [SMALL_STATE(881)] = 50435,
  [SMALL_STATE(882)] = 50452,
  [SMALL_STATE(883)] = 50465,
  [SMALL_STATE(884)] = 50478,
  [SMALL_STATE(885)] = 50491,
  [SMALL_STATE(886)] = 50504,
  [SMALL_STATE(887)] = 50521,
  [SMALL_STATE(888)] = 50534,
  [SMALL_STATE(889)] = 50547,
  [SMALL_STATE(890)] = 50560,
  [SMALL_STATE(891)] = 50579,
  [SMALL_STATE(892)] = 50592,
  [SMALL_STATE(893)] = 50609,
  [SMALL_STATE(894)] = 50622,
  [SMALL_STATE(895)] = 50635,
  [SMALL_STATE(896)] = 50648,
  [SMALL_STATE(897)] = 50661,
  [SMALL_STATE(898)] = 50674,
  [SMALL_STATE(899)] = 50693,
  [SMALL_STATE(900)] = 50712,
  [SMALL_STATE(901)] = 50725,
  [SMALL_STATE(902)] = 50738,
  [SMALL_STATE(903)] = 50751,
  [SMALL_STATE(904)] = 50764,
  [SMALL_STATE(905)] = 50783,
  [SMALL_STATE(906)] = 50796,
  [SMALL_STATE(907)] = 50809,
  [SMALL_STATE(908)] = 50822,
  [SMALL_STATE(909)] = 50835,
  [SMALL_STATE(910)] = 50848,
  [SMALL_STATE(911)] = 50861,
  [SMALL_STATE(912)] = 50874,
  [SMALL_STATE(913)] = 50887,
  [SMALL_STATE(914)] = 50906,
  [SMALL_STATE(915)] = 50919,
  [SMALL_STATE(916)] = 50932,
  [SMALL_STATE(917)] = 50951,
  [SMALL_STATE(918)] = 50964,
  [SMALL_STATE(919)] = 50977,
  [SMALL_STATE(920)] = 50990,
  [SMALL_STATE(921)] = 51003,
  [SMALL_STATE(922)] = 51020,
  [SMALL_STATE(923)] = 51033,
  [SMALL_STATE(924)] = 51046,
  [SMALL_STATE(925)] = 51059,
  [SMALL_STATE(926)] = 51072,
  [SMALL_STATE(927)] = 51085,
  [SMALL_STATE(928)] = 51098,
  [SMALL_STATE(929)] = 51111,
  [SMALL_STATE(930)] = 51124,
  [SMALL_STATE(931)] = 51137,
  [SMALL_STATE(932)] = 51156,
  [SMALL_STATE(933)] = 51175,
  [SMALL_STATE(934)] = 51188,
  [SMALL_STATE(935)] = 51201,
  [SMALL_STATE(936)] = 51220,
  [SMALL_STATE(937)] = 51237,
  [SMALL_STATE(938)] = 51250,
  [SMALL_STATE(939)] = 51263,
  [SMALL_STATE(940)] = 51279,
  [SMALL_STATE(941)] = 51293,
  [SMALL_STATE(942)] = 51307,
  [SMALL_STATE(943)] = 51323,
  [SMALL_STATE(944)] = 51339,
  [SMALL_STATE(945)] = 51353,
  [SMALL_STATE(946)] = 51369,
  [SMALL_STATE(947)] = 51385,
  [SMALL_STATE(948)] = 51401,
  [SMALL_STATE(949)] = 51411,
  [SMALL_STATE(950)] = 51425,
  [SMALL_STATE(951)] = 51439,
  [SMALL_STATE(952)] = 51453,
  [SMALL_STATE(953)] = 51467,
  [SMALL_STATE(954)] = 51483,
  [SMALL_STATE(955)] = 51499,
  [SMALL_STATE(956)] = 51513,
  [SMALL_STATE(957)] = 51527,
  [SMALL_STATE(958)] = 51543,
  [SMALL_STATE(959)] = 51559,
  [SMALL_STATE(960)] = 51575,
  [SMALL_STATE(961)] = 51589,
  [SMALL_STATE(962)] = 51603,
  [SMALL_STATE(963)] = 51619,
  [SMALL_STATE(964)] = 51633,
  [SMALL_STATE(965)] = 51647,
  [SMALL_STATE(966)] = 51663,
  [SMALL_STATE(967)] = 51677,
  [SMALL_STATE(968)] = 51693,
  [SMALL_STATE(969)] = 51709,
  [SMALL_STATE(970)] = 51725,
  [SMALL_STATE(971)] = 51739,
  [SMALL_STATE(972)] = 51755,
  [SMALL_STATE(973)] = 51769,
  [SMALL_STATE(974)] = 51781,
  [SMALL_STATE(975)] = 51797,
  [SMALL_STATE(976)] = 51811,
  [SMALL_STATE(977)] = 51825,
  [SMALL_STATE(978)] = 51841,
  [SMALL_STATE(979)] = 51853,
  [SMALL_STATE(980)] = 51869,
  [SMALL_STATE(981)] = 51885,
  [SMALL_STATE(982)] = 51901,
  [SMALL_STATE(983)] = 51917,
  [SMALL_STATE(984)] = 51931,
  [SMALL_STATE(985)] = 51943,
  [SMALL_STATE(986)] = 51956,
  [SMALL_STATE(987)] = 51969,
  [SMALL_STATE(988)] = 51982,
  [SMALL_STATE(989)] = 51995,
  [SMALL_STATE(990)] = 52008,
  [SMALL_STATE(991)] = 52021,
  [SMALL_STATE(992)] = 52034,
  [SMALL_STATE(993)] = 52047,
  [SMALL_STATE(994)] = 52060,
  [SMALL_STATE(995)] = 52073,
  [SMALL_STATE(996)] = 52086,
  [SMALL_STATE(997)] = 52095,
  [SMALL_STATE(998)] = 52106,
  [SMALL_STATE(999)] = 52119,
  [SMALL_STATE(1000)] = 52132,
  [SMALL_STATE(1001)] = 52145,
  [SMALL_STATE(1002)] = 52158,
  [SMALL_STATE(1003)] = 52171,
  [SMALL_STATE(1004)] = 52182,
  [SMALL_STATE(1005)] = 52195,
  [SMALL_STATE(1006)] = 52208,
  [SMALL_STATE(1007)] = 52221,
  [SMALL_STATE(1008)] = 52230,
  [SMALL_STATE(1009)] = 52239,
  [SMALL_STATE(1010)] = 52252,
  [SMALL_STATE(1011)] = 52261,
  [SMALL_STATE(1012)] = 52272,
  [SMALL_STATE(1013)] = 52285,
  [SMALL_STATE(1014)] = 52298,
  [SMALL_STATE(1015)] = 52311,
  [SMALL_STATE(1016)] = 52324,
  [SMALL_STATE(1017)] = 52333,
  [SMALL_STATE(1018)] = 52346,
  [SMALL_STATE(1019)] = 52359,
  [SMALL_STATE(1020)] = 52372,
  [SMALL_STATE(1021)] = 52385,
  [SMALL_STATE(1022)] = 52398,
  [SMALL_STATE(1023)] = 52411,
  [SMALL_STATE(1024)] = 52422,
  [SMALL_STATE(1025)] = 52435,
  [SMALL_STATE(1026)] = 52446,
  [SMALL_STATE(1027)] = 52459,
  [SMALL_STATE(1028)] = 52470,
  [SMALL_STATE(1029)] = 52483,
  [SMALL_STATE(1030)] = 52496,
  [SMALL_STATE(1031)] = 52509,
  [SMALL_STATE(1032)] = 52522,
  [SMALL_STATE(1033)] = 52535,
  [SMALL_STATE(1034)] = 52544,
  [SMALL_STATE(1035)] = 52557,
  [SMALL_STATE(1036)] = 52570,
  [SMALL_STATE(1037)] = 52583,
  [SMALL_STATE(1038)] = 52596,
  [SMALL_STATE(1039)] = 52609,
  [SMALL_STATE(1040)] = 52622,
  [SMALL_STATE(1041)] = 52633,
  [SMALL_STATE(1042)] = 52646,
  [SMALL_STATE(1043)] = 52659,
  [SMALL_STATE(1044)] = 52672,
  [SMALL_STATE(1045)] = 52681,
  [SMALL_STATE(1046)] = 52692,
  [SMALL_STATE(1047)] = 52705,
  [SMALL_STATE(1048)] = 52716,
  [SMALL_STATE(1049)] = 52729,
  [SMALL_STATE(1050)] = 52740,
  [SMALL_STATE(1051)] = 52753,
  [SMALL_STATE(1052)] = 52766,
  [SMALL_STATE(1053)] = 52779,
  [SMALL_STATE(1054)] = 52792,
  [SMALL_STATE(1055)] = 52801,
  [SMALL_STATE(1056)] = 52814,
  [SMALL_STATE(1057)] = 52827,
  [SMALL_STATE(1058)] = 52838,
  [SMALL_STATE(1059)] = 52851,
  [SMALL_STATE(1060)] = 52864,
  [SMALL_STATE(1061)] = 52877,
  [SMALL_STATE(1062)] = 52890,
  [SMALL_STATE(1063)] = 52903,
  [SMALL_STATE(1064)] = 52916,
  [SMALL_STATE(1065)] = 52929,
  [SMALL_STATE(1066)] = 52942,
  [SMALL_STATE(1067)] = 52955,
  [SMALL_STATE(1068)] = 52968,
  [SMALL_STATE(1069)] = 52981,
  [SMALL_STATE(1070)] = 52994,
  [SMALL_STATE(1071)] = 53007,
  [SMALL_STATE(1072)] = 53020,
  [SMALL_STATE(1073)] = 53033,
  [SMALL_STATE(1074)] = 53046,
  [SMALL_STATE(1075)] = 53059,
  [SMALL_STATE(1076)] = 53072,
  [SMALL_STATE(1077)] = 53085,
  [SMALL_STATE(1078)] = 53098,
  [SMALL_STATE(1079)] = 53107,
  [SMALL_STATE(1080)] = 53116,
  [SMALL_STATE(1081)] = 53125,
  [SMALL_STATE(1082)] = 53138,
  [SMALL_STATE(1083)] = 53151,
  [SMALL_STATE(1084)] = 53164,
  [SMALL_STATE(1085)] = 53175,
  [SMALL_STATE(1086)] = 53183,
  [SMALL_STATE(1087)] = 53193,
  [SMALL_STATE(1088)] = 53203,
  [SMALL_STATE(1089)] = 53213,
  [SMALL_STATE(1090)] = 53223,
  [SMALL_STATE(1091)] = 53233,
  [SMALL_STATE(1092)] = 53243,
  [SMALL_STATE(1093)] = 53253,
  [SMALL_STATE(1094)] = 53263,
  [SMALL_STATE(1095)] = 53271,
  [SMALL_STATE(1096)] = 53281,
  [SMALL_STATE(1097)] = 53289,
  [SMALL_STATE(1098)] = 53299,
  [SMALL_STATE(1099)] = 53309,
  [SMALL_STATE(1100)] = 53319,
  [SMALL_STATE(1101)] = 53329,
  [SMALL_STATE(1102)] = 53337,
  [SMALL_STATE(1103)] = 53345,
  [SMALL_STATE(1104)] = 53355,
  [SMALL_STATE(1105)] = 53363,
  [SMALL_STATE(1106)] = 53373,
  [SMALL_STATE(1107)] = 53381,
  [SMALL_STATE(1108)] = 53391,
  [SMALL_STATE(1109)] = 53401,
  [SMALL_STATE(1110)] = 53411,
  [SMALL_STATE(1111)] = 53421,
  [SMALL_STATE(1112)] = 53429,
  [SMALL_STATE(1113)] = 53439,
  [SMALL_STATE(1114)] = 53449,
  [SMALL_STATE(1115)] = 53457,
  [SMALL_STATE(1116)] = 53467,
  [SMALL_STATE(1117)] = 53477,
  [SMALL_STATE(1118)] = 53485,
  [SMALL_STATE(1119)] = 53495,
  [SMALL_STATE(1120)] = 53505,
  [SMALL_STATE(1121)] = 53515,
  [SMALL_STATE(1122)] = 53525,
  [SMALL_STATE(1123)] = 53535,
  [SMALL_STATE(1124)] = 53543,
  [SMALL_STATE(1125)] = 53551,
  [SMALL_STATE(1126)] = 53559,
  [SMALL_STATE(1127)] = 53569,
  [SMALL_STATE(1128)] = 53579,
  [SMALL_STATE(1129)] = 53589,
  [SMALL_STATE(1130)] = 53599,
  [SMALL_STATE(1131)] = 53609,
  [SMALL_STATE(1132)] = 53619,
  [SMALL_STATE(1133)] = 53627,
  [SMALL_STATE(1134)] = 53637,
  [SMALL_STATE(1135)] = 53647,
  [SMALL_STATE(1136)] = 53655,
  [SMALL_STATE(1137)] = 53663,
  [SMALL_STATE(1138)] = 53671,
  [SMALL_STATE(1139)] = 53681,
  [SMALL_STATE(1140)] = 53691,
  [SMALL_STATE(1141)] = 53701,
  [SMALL_STATE(1142)] = 53711,
  [SMALL_STATE(1143)] = 53719,
  [SMALL_STATE(1144)] = 53729,
  [SMALL_STATE(1145)] = 53739,
  [SMALL_STATE(1146)] = 53749,
  [SMALL_STATE(1147)] = 53759,
  [SMALL_STATE(1148)] = 53769,
  [SMALL_STATE(1149)] = 53779,
  [SMALL_STATE(1150)] = 53789,
  [SMALL_STATE(1151)] = 53797,
  [SMALL_STATE(1152)] = 53804,
  [SMALL_STATE(1153)] = 53811,
  [SMALL_STATE(1154)] = 53818,
  [SMALL_STATE(1155)] = 53825,
  [SMALL_STATE(1156)] = 53832,
  [SMALL_STATE(1157)] = 53839,
  [SMALL_STATE(1158)] = 53846,
  [SMALL_STATE(1159)] = 53853,
  [SMALL_STATE(1160)] = 53860,
  [SMALL_STATE(1161)] = 53867,
  [SMALL_STATE(1162)] = 53874,
  [SMALL_STATE(1163)] = 53881,
  [SMALL_STATE(1164)] = 53888,
  [SMALL_STATE(1165)] = 53895,
  [SMALL_STATE(1166)] = 53902,
  [SMALL_STATE(1167)] = 53909,
  [SMALL_STATE(1168)] = 53916,
  [SMALL_STATE(1169)] = 53923,
  [SMALL_STATE(1170)] = 53930,
  [SMALL_STATE(1171)] = 53937,
  [SMALL_STATE(1172)] = 53944,
  [SMALL_STATE(1173)] = 53951,
  [SMALL_STATE(1174)] = 53958,
  [SMALL_STATE(1175)] = 53965,
  [SMALL_STATE(1176)] = 53972,
  [SMALL_STATE(1177)] = 53979,
  [SMALL_STATE(1178)] = 53986,
  [SMALL_STATE(1179)] = 53993,
  [SMALL_STATE(1180)] = 54000,
  [SMALL_STATE(1181)] = 54007,
  [SMALL_STATE(1182)] = 54014,
  [SMALL_STATE(1183)] = 54021,
  [SMALL_STATE(1184)] = 54028,
  [SMALL_STATE(1185)] = 54035,
  [SMALL_STATE(1186)] = 54042,
  [SMALL_STATE(1187)] = 54049,
  [SMALL_STATE(1188)] = 54056,
  [SMALL_STATE(1189)] = 54063,
  [SMALL_STATE(1190)] = 54070,
  [SMALL_STATE(1191)] = 54077,
  [SMALL_STATE(1192)] = 54084,
  [SMALL_STATE(1193)] = 54091,
  [SMALL_STATE(1194)] = 54098,
  [SMALL_STATE(1195)] = 54105,
  [SMALL_STATE(1196)] = 54112,
  [SMALL_STATE(1197)] = 54119,
  [SMALL_STATE(1198)] = 54126,
  [SMALL_STATE(1199)] = 54133,
  [SMALL_STATE(1200)] = 54140,
  [SMALL_STATE(1201)] = 54147,
  [SMALL_STATE(1202)] = 54154,
  [SMALL_STATE(1203)] = 54161,
  [SMALL_STATE(1204)] = 54168,
  [SMALL_STATE(1205)] = 54175,
  [SMALL_STATE(1206)] = 54182,
  [SMALL_STATE(1207)] = 54189,
  [SMALL_STATE(1208)] = 54196,
  [SMALL_STATE(1209)] = 54203,
  [SMALL_STATE(1210)] = 54210,
  [SMALL_STATE(1211)] = 54217,
  [SMALL_STATE(1212)] = 54224,
  [SMALL_STATE(1213)] = 54231,
  [SMALL_STATE(1214)] = 54238,
  [SMALL_STATE(1215)] = 54245,
  [SMALL_STATE(1216)] = 54252,
  [SMALL_STATE(1217)] = 54259,
  [SMALL_STATE(1218)] = 54266,
  [SMALL_STATE(1219)] = 54273,
  [SMALL_STATE(1220)] = 54280,
  [SMALL_STATE(1221)] = 54287,
  [SMALL_STATE(1222)] = 54294,
  [SMALL_STATE(1223)] = 54301,
  [SMALL_STATE(1224)] = 54308,
  [SMALL_STATE(1225)] = 54315,
  [SMALL_STATE(1226)] = 54322,
  [SMALL_STATE(1227)] = 54329,
  [SMALL_STATE(1228)] = 54336,
  [SMALL_STATE(1229)] = 54343,
  [SMALL_STATE(1230)] = 54350,
  [SMALL_STATE(1231)] = 54357,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(240),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(874),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1225),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(774),
  [87] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(211),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(987),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(991),
  [96] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(993),
  [99] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(69),
  [102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(941),
  [105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(226),
  [108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1092),
  [111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(13),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1217),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1215),
  [120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(696),
  [123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(213),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(903),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(856),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(864),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1211),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(31),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(205),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(202),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(27),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(21),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(22),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1210),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(304),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(199),
  [165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(319),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(944),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(319),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 3, .production_id = 38),
  [186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 3, .production_id = 38),
  [188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 98),
  [190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 4, .production_id = 98),
  [192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 3, .production_id = 84),
  [194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_communication_case, 3, .production_id = 84),
  [196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 2),
  [198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_case, 2),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 2),
  [202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 2),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 3),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 3),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 25),
  [210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 25),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 82),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 55),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 56),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 42),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, .production_id = 42),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, .production_id = 19),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, .production_id = 19),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 39),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 39),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(237),
  [325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(549),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1120),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(105),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(705),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1087),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1189),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1226),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(729),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1166),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(742),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(1156),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(712),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 40),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 40),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 65),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 65),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 68),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 68),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 66),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 66),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2),
  [658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statement, 1),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statement, 1),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 1),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 3),
  [692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 3),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, .dynamic_precedence = 2),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, .dynamic_precedence = 2),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 5),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 5),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 5, .production_id = 76),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_type, 5, .production_id = 76),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, .dynamic_precedence = 2),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, .dynamic_precedence = 2),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 20),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 20),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 4),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 4),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, .dynamic_precedence = 2),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, .dynamic_precedence = 2),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5),
  [726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 6),
  [728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 6),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 3, .production_id = 26),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 3, .production_id = 26),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT_REPEAT(293),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, .production_id = 45),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, .production_id = 45),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 15),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 15),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 2),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 2),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 14),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 14),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 67),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 67),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 91),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 91),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 90),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 90),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 5),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 69),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 69),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, .production_id = 30),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 3, .production_id = 30),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1156),
  [812] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1), SHIFT(730),
  [816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(1176),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(90),
  [824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(710),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 3),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 3),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 3, .production_id = 22),
  [862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 3, .production_id = 22),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 2),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 2),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 41),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 41),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 31),
  [900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 31),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 86),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 86),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 4, .production_id = 43),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 4, .production_id = 43),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 13),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 13),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 87),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 87),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 88),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 88),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 5),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 5),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 5),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 5),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, .production_id = 96),
  [974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, .production_id = 96),
  [976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 7, .production_id = 99),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 7, .production_id = 99),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 8, .production_id = 102),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 8, .production_id = 102),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 35),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 35),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_expression, 3, .production_id = 33),
  [994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_expression, 3, .production_id = 33),
  [996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 3, .production_id = 21),
  [998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 3, .production_id = 21),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 59),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 59),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 3),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 3),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, .production_id = 60),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, .production_id = 60),
  [1016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 59),
  [1018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 59),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [1024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, .production_id = 61),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, .production_id = 61),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 2),
  [1030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 2),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 3),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 3),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 4),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 4),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 4),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 4),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(712),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [1079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 24),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 24),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [1189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receive_statement, 1, .production_id = 58),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 2, .production_id = 16),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 2, .production_id = 16),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_send_statement, 3, .production_id = 34),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_send_statement, 3, .production_id = 34),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_go_statement, 2),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_go_statement, 2),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(544),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 1),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyed_element, 3),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyed_element, 3, .production_id = 85),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 4, .production_id = 80),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receive_statement, 3, .production_id = 32),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 2, .production_id = 53),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 2, .production_id = 53),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 2, .production_id = 28),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1181),
  [1607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(145),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1176),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_name_list_repeat1, 2),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_name_list_repeat1, 2),
  [1637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_name_list_repeat1, 2), SHIFT_REPEAT(1196),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_name_list_repeat1, 2, .production_id = 72),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_name_list_repeat1, 2, .production_id = 72),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 5),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 5),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 4),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4),
  [1654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1065),
  [1657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1111),
  [1660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1066),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [1665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1134),
  [1668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(944),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 3),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type_name, 1, .production_id = 1),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type_name, 1, .production_id = 1),
  [1725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_term, 1, .production_id = 1),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [1729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(134),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 48),
  [1734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 48),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [1744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 38),
  [1746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 38),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [1756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 50),
  [1758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 50),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 74),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 74),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [1768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(20),
  [1771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(20),
  [1774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [1776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 37),
  [1778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 37),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [1784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 2, .production_id = 17),
  [1786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 2, .production_id = 17),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2),
  [1794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(98),
  [1797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(1198),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [1804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 1),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [1812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [1814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 27),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 27),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 18),
  [1826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 18),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [1842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2),
  [1848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(704),
  [1851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(1198),
  [1854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 77),
  [1856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 77),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [1860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(235),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2),
  [1873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(52),
  [1876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(1198),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2), SHIFT_REPEAT(671),
  [1886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 3),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 3),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 78),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 78),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 83),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 83),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 5, .production_id = 57),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 5, .production_id = 57),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_elem, 1),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_elem, 1),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [1912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 4),
  [1916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 4),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 3),
  [1920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 3),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inc_statement, 2),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inc_statement, 2),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraint_elem_repeat1, 2),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constraint_elem_repeat1, 2),
  [1930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_elem_repeat1, 2), SHIFT_REPEAT(989),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 2, .production_id = 23),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 2, .production_id = 23),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 25),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 25),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, .production_id = 31),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, .production_id = 31),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_var_declaration, 3, .production_id = 32),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_var_declaration, 3, .production_id = 32),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 3),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 3, .production_id = 36),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 3, .production_id = 36),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 4),
  [1973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 4),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 5, .production_id = 89),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 5, .production_id = 89),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 36),
  [1985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 36),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 5, .production_id = 89),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 5, .production_id = 89),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 3),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 3),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallthrough_statement, 1),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallthrough_statement, 1),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 4),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, .production_id = 29),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, .production_id = 29),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 3, .production_id = 46),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 3, .production_id = 46),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 3, .production_id = 47),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 3, .production_id = 47),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dec_statement, 2),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dec_statement, 2),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 94),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 94),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 97),
  [2037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 97),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [2041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [2053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [2055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 94),
  [2057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 94),
  [2059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_elem, 2),
  [2061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_elem, 2),
  [2063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [2065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [2067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4),
  [2069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4),
  [2071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [2073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 83),
  [2077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 83),
  [2079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 4, .production_id = 57),
  [2081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 4, .production_id = 57),
  [2083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 63),
  [2085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 63),
  [2087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [2089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 62),
  [2093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 62),
  [2095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 63),
  [2097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 63),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 2),
  [2105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 2),
  [2107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 62),
  [2109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 62),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 2),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 2),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 2),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 2),
  [2123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(953),
  [2126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(953),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [2197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(744),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2), SHIFT_REPEAT(470),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2),
  [2243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2), SHIFT_REPEAT(970),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_term, 2, .production_id = 52),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_term, 2, .production_id = 52),
  [2258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2), SHIFT_REPEAT(787),
  [2261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2), SHIFT_REPEAT(787),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [2272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2), SHIFT_REPEAT(649),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_term, 1, .production_id = 1),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(203),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 51),
  [2338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 51),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 49),
  [2354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 49),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(229),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 5, .production_id = 98),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 38),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 4, .production_id = 84),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 18),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [2377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(658),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 4, .production_id = 7),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 70),
  [2402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 70),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 71),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 71),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 73),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 73),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 17),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 4),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 3, .production_id = 75),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 3, .production_id = 75),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 92),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 92),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2), SHIFT_REPEAT(682),
  [2469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(96),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2), SHIFT_REPEAT(51),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, .production_id = 37),
  [2521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 3),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type_name, 1),
  [2531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type_name, 1),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 3, .production_id = 64),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot, 1),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_argument, 2),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, .production_id = 38),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, .production_id = 93),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 5, .production_id = 95),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 79),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_length_array_type, 4, .production_id = 44),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 100),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 9, .production_id = 103),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 54),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2715] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 101),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 81),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_go(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
