#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 962
#define LARGE_STATE_COUNT 245
#define SYMBOL_COUNT 271
#define ALIAS_COUNT 1
#define TOKEN_COUNT 123
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 30
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 169

enum {
  sym_identifier = 1,
  sym_decimal_integer_literal = 2,
  sym_hex_integer_literal = 3,
  sym_octal_integer_literal = 4,
  sym_binary_integer_literal = 5,
  sym_decimal_floating_point_literal = 6,
  sym_hex_floating_point_literal = 7,
  sym_true = 8,
  sym_false = 9,
  sym_character_literal = 10,
  sym_string_literal = 11,
  sym_null_literal = 12,
  anon_sym_LPAREN = 13,
  anon_sym_AMP = 14,
  anon_sym_RPAREN = 15,
  anon_sym_EQ = 16,
  anon_sym_PLUS_EQ = 17,
  anon_sym_DASH_EQ = 18,
  anon_sym_STAR_EQ = 19,
  anon_sym_SLASH_EQ = 20,
  anon_sym_AMP_EQ = 21,
  anon_sym_PIPE_EQ = 22,
  anon_sym_CARET_EQ = 23,
  anon_sym_PERCENT_EQ = 24,
  anon_sym_LT_LT_EQ = 25,
  anon_sym_GT_GT_EQ = 26,
  anon_sym_GT_GT_GT_EQ = 27,
  anon_sym_GT = 28,
  anon_sym_LT = 29,
  anon_sym_EQ_EQ = 30,
  anon_sym_GT_EQ = 31,
  anon_sym_LT_EQ = 32,
  anon_sym_BANG_EQ = 33,
  anon_sym_AMP_AMP = 34,
  anon_sym_PIPE_PIPE = 35,
  anon_sym_PLUS = 36,
  anon_sym_DASH = 37,
  anon_sym_STAR = 38,
  anon_sym_SLASH = 39,
  anon_sym_PIPE = 40,
  anon_sym_CARET = 41,
  anon_sym_PERCENT = 42,
  anon_sym_LT_LT = 43,
  anon_sym_GT_GT = 44,
  anon_sym_GT_GT_GT = 45,
  anon_sym_instanceof = 46,
  anon_sym_DASH_GT = 47,
  anon_sym_COMMA = 48,
  anon_sym_QMARK = 49,
  anon_sym_COLON = 50,
  anon_sym_BANG = 51,
  anon_sym_TILDE = 52,
  anon_sym_PLUS_PLUS = 53,
  anon_sym_DASH_DASH = 54,
  anon_sym_new = 55,
  anon_sym_LBRACK = 56,
  anon_sym_RBRACK = 57,
  anon_sym_DOT = 58,
  anon_sym_class = 59,
  anon_sym_COLON_COLON = 60,
  anon_sym_extends = 61,
  anon_sym_SEMI = 62,
  anon_sym_LBRACE = 63,
  anon_sym_RBRACE = 64,
  anon_sym_assert = 65,
  anon_sym_switch = 66,
  anon_sym_case = 67,
  anon_sym_default = 68,
  anon_sym_do = 69,
  anon_sym_while = 70,
  anon_sym_break = 71,
  anon_sym_continue = 72,
  anon_sym_return = 73,
  anon_sym_synchronized = 74,
  anon_sym_throw = 75,
  anon_sym_try = 76,
  anon_sym_catch = 77,
  anon_sym_finally = 78,
  anon_sym_if = 79,
  anon_sym_else = 80,
  anon_sym_for = 81,
  anon_sym_AT = 82,
  anon_sym_open = 83,
  anon_sym_module = 84,
  anon_sym_requires = 85,
  anon_sym_exports = 86,
  anon_sym_to = 87,
  anon_sym_opens = 88,
  anon_sym_uses = 89,
  anon_sym_provides = 90,
  anon_sym_with = 91,
  anon_sym_transitive = 92,
  anon_sym_static = 93,
  anon_sym_package = 94,
  anon_sym_import = 95,
  anon_sym_enum = 96,
  anon_sym_public = 97,
  anon_sym_protected = 98,
  anon_sym_private = 99,
  anon_sym_abstract = 100,
  anon_sym_final = 101,
  anon_sym_strictfp = 102,
  anon_sym_native = 103,
  anon_sym_transient = 104,
  anon_sym_volatile = 105,
  anon_sym_implements = 106,
  anon_sym_ATinterface = 107,
  anon_sym_interface = 108,
  anon_sym_byte = 109,
  anon_sym_short = 110,
  anon_sym_int = 111,
  anon_sym_long = 112,
  anon_sym_char = 113,
  anon_sym_float = 114,
  anon_sym_double = 115,
  sym_boolean_type = 116,
  sym_void_type = 117,
  anon_sym_DOT_DOT_DOT = 118,
  anon_sym_throws = 119,
  sym_this = 120,
  sym_super = 121,
  sym_comment = 122,
  sym_program = 123,
  sym__literal = 124,
  sym_expression = 125,
  sym_cast_expression = 126,
  sym_assignment_expression = 127,
  sym_binary_expression = 128,
  sym_instanceof_expression = 129,
  sym_lambda_expression = 130,
  sym_inferred_parameters = 131,
  sym_ternary_expression = 132,
  sym_unary_expression = 133,
  sym_update_expression = 134,
  sym_primary_expression = 135,
  sym_array_creation_expression = 136,
  sym_dimensions_expr = 137,
  sym_parenthesized_expression = 138,
  sym_class_literal = 139,
  sym_object_creation_expression = 140,
  sym__unqualified_object_creation_expression = 141,
  sym_field_access = 142,
  sym_array_access = 143,
  sym_method_invocation = 144,
  sym_argument_list = 145,
  sym_method_reference = 146,
  sym_type_arguments = 147,
  sym_wildcard = 148,
  sym__wildcard_bounds = 149,
  sym_dimensions = 150,
  sym_statement = 151,
  sym_block = 152,
  sym_expression_statement = 153,
  sym_labeled_statement = 154,
  sym_assert_statement = 155,
  sym_switch_statement = 156,
  sym_switch_block = 157,
  sym_switch_label = 158,
  sym_do_statement = 159,
  sym_break_statement = 160,
  sym_continue_statement = 161,
  sym_return_statement = 162,
  sym_synchronized_statement = 163,
  sym_throw_statement = 164,
  sym_try_statement = 165,
  sym_catch_clause = 166,
  sym_catch_formal_parameter = 167,
  sym_catch_type = 168,
  sym_finally_clause = 169,
  sym_try_with_resources_statement = 170,
  sym_resource_specification = 171,
  sym_resource = 172,
  sym_if_statement = 173,
  sym_while_statement = 174,
  sym_for_statement = 175,
  sym_enhanced_for_statement = 176,
  sym__annotation = 177,
  sym_marker_annotation = 178,
  sym_annotation = 179,
  sym_annotation_argument_list = 180,
  sym_element_value_pair = 181,
  sym__element_value = 182,
  sym_element_value_array_initializer = 183,
  sym_declaration = 184,
  sym_module_declaration = 185,
  sym_module_body = 186,
  sym_module_directive = 187,
  sym_requires_modifier = 188,
  sym_package_declaration = 189,
  sym_import_declaration = 190,
  sym_asterisk = 191,
  sym_enum_declaration = 192,
  sym_enum_body = 193,
  sym_enum_body_declarations = 194,
  sym_enum_constant = 195,
  sym_class_declaration = 196,
  sym_modifiers = 197,
  sym_type_parameters = 198,
  sym_type_parameter = 199,
  sym_type_bound = 200,
  sym_superclass = 201,
  sym_super_interfaces = 202,
  sym_interface_type_list = 203,
  sym_class_body = 204,
  sym_static_initializer = 205,
  sym_constructor_declaration = 206,
  sym__constructor_declarator = 207,
  sym_constructor_body = 208,
  sym_explicit_constructor_invocation = 209,
  sym_scoped_identifier = 210,
  sym_field_declaration = 211,
  sym_annotation_type_declaration = 212,
  sym_annotation_type_body = 213,
  sym_annotation_type_element_declaration = 214,
  sym__default_value = 215,
  sym_interface_declaration = 216,
  sym_extends_interfaces = 217,
  sym_interface_body = 218,
  sym_constant_declaration = 219,
  sym__variable_declarator_list = 220,
  sym_variable_declarator = 221,
  sym__variable_declarator_id = 222,
  sym_array_initializer = 223,
  sym__type = 224,
  sym__unannotated_type = 225,
  sym_annotated_type = 226,
  sym_scoped_type_identifier = 227,
  sym_generic_type = 228,
  sym_array_type = 229,
  sym_integral_type = 230,
  sym_floating_point_type = 231,
  sym__method_header = 232,
  sym__method_declarator = 233,
  sym_formal_parameters = 234,
  sym_formal_parameter = 235,
  sym_receiver_parameter = 236,
  sym_spread_parameter = 237,
  sym_throws = 238,
  sym_local_variable_declaration = 239,
  sym_method_declaration = 240,
  aux_sym_program_repeat1 = 241,
  aux_sym_cast_expression_repeat1 = 242,
  aux_sym_inferred_parameters_repeat1 = 243,
  aux_sym_array_creation_expression_repeat1 = 244,
  aux_sym_dimensions_expr_repeat1 = 245,
  aux_sym_argument_list_repeat1 = 246,
  aux_sym_type_arguments_repeat1 = 247,
  aux_sym_dimensions_repeat1 = 248,
  aux_sym_switch_block_repeat1 = 249,
  aux_sym_try_statement_repeat1 = 250,
  aux_sym_catch_type_repeat1 = 251,
  aux_sym_resource_specification_repeat1 = 252,
  aux_sym_for_statement_repeat1 = 253,
  aux_sym_for_statement_repeat2 = 254,
  aux_sym_annotation_argument_list_repeat1 = 255,
  aux_sym_element_value_array_initializer_repeat1 = 256,
  aux_sym_module_body_repeat1 = 257,
  aux_sym_module_directive_repeat1 = 258,
  aux_sym_module_directive_repeat2 = 259,
  aux_sym_enum_body_repeat1 = 260,
  aux_sym_enum_body_declarations_repeat1 = 261,
  aux_sym_modifiers_repeat1 = 262,
  aux_sym_type_parameters_repeat1 = 263,
  aux_sym_type_bound_repeat1 = 264,
  aux_sym_interface_type_list_repeat1 = 265,
  aux_sym_annotation_type_body_repeat1 = 266,
  aux_sym_interface_body_repeat1 = 267,
  aux_sym__variable_declarator_list_repeat1 = 268,
  aux_sym_array_initializer_repeat1 = 269,
  aux_sym_formal_parameters_repeat1 = 270,
  alias_sym_type_identifier = 271,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_decimal_integer_literal] = "decimal_integer_literal",
  [sym_hex_integer_literal] = "hex_integer_literal",
  [sym_octal_integer_literal] = "octal_integer_literal",
  [sym_binary_integer_literal] = "binary_integer_literal",
  [sym_decimal_floating_point_literal] = "decimal_floating_point_literal",
  [sym_hex_floating_point_literal] = "hex_floating_point_literal",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_null_literal] = "null_literal",
  [anon_sym_LPAREN] = "(",
  [anon_sym_AMP] = "&",
  [anon_sym_RPAREN] = ")",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COMMA] = ",",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON] = ":",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_extends] = "extends",
  [anon_sym_SEMI] = ";",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_assert] = "assert",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_return] = "return",
  [anon_sym_synchronized] = "synchronized",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_AT] = "@",
  [anon_sym_open] = "open",
  [anon_sym_module] = "module",
  [anon_sym_requires] = "requires",
  [anon_sym_exports] = "exports",
  [anon_sym_to] = "to",
  [anon_sym_opens] = "opens",
  [anon_sym_uses] = "uses",
  [anon_sym_provides] = "provides",
  [anon_sym_with] = "with",
  [anon_sym_transitive] = "transitive",
  [anon_sym_static] = "static",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_enum] = "enum",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_private] = "private",
  [anon_sym_abstract] = "abstract",
  [anon_sym_final] = "final",
  [anon_sym_strictfp] = "strictfp",
  [anon_sym_native] = "native",
  [anon_sym_transient] = "transient",
  [anon_sym_volatile] = "volatile",
  [anon_sym_implements] = "implements",
  [anon_sym_ATinterface] = "@interface",
  [anon_sym_interface] = "interface",
  [anon_sym_byte] = "byte",
  [anon_sym_short] = "short",
  [anon_sym_int] = "int",
  [anon_sym_long] = "long",
  [anon_sym_char] = "char",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [sym_boolean_type] = "boolean_type",
  [sym_void_type] = "void_type",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_throws] = "throws",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_comment] = "comment",
  [sym_program] = "program",
  [sym__literal] = "_literal",
  [sym_expression] = "expression",
  [sym_cast_expression] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_instanceof_expression] = "instanceof_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_inferred_parameters] = "inferred_parameters",
  [sym_ternary_expression] = "ternary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_primary_expression] = "primary_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_dimensions_expr] = "dimensions_expr",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_literal] = "class_literal",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym__unqualified_object_creation_expression] = "_unqualified_object_creation_expression",
  [sym_field_access] = "field_access",
  [sym_array_access] = "array_access",
  [sym_method_invocation] = "method_invocation",
  [sym_argument_list] = "argument_list",
  [sym_method_reference] = "method_reference",
  [sym_type_arguments] = "type_arguments",
  [sym_wildcard] = "wildcard",
  [sym__wildcard_bounds] = "_wildcard_bounds",
  [sym_dimensions] = "dimensions",
  [sym_statement] = "statement",
  [sym_block] = "block",
  [sym_expression_statement] = "expression_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_assert_statement] = "assert_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_block] = "switch_block",
  [sym_switch_label] = "switch_label",
  [sym_do_statement] = "do_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_return_statement] = "return_statement",
  [sym_synchronized_statement] = "synchronized_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_formal_parameter] = "catch_formal_parameter",
  [sym_catch_type] = "catch_type",
  [sym_finally_clause] = "finally_clause",
  [sym_try_with_resources_statement] = "try_with_resources_statement",
  [sym_resource_specification] = "resource_specification",
  [sym_resource] = "resource",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_for_statement] = "for_statement",
  [sym_enhanced_for_statement] = "enhanced_for_statement",
  [sym__annotation] = "_annotation",
  [sym_marker_annotation] = "marker_annotation",
  [sym_annotation] = "annotation",
  [sym_annotation_argument_list] = "annotation_argument_list",
  [sym_element_value_pair] = "element_value_pair",
  [sym__element_value] = "_element_value",
  [sym_element_value_array_initializer] = "element_value_array_initializer",
  [sym_declaration] = "declaration",
  [sym_module_declaration] = "module_declaration",
  [sym_module_body] = "module_body",
  [sym_module_directive] = "module_directive",
  [sym_requires_modifier] = "requires_modifier",
  [sym_package_declaration] = "package_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_asterisk] = "asterisk",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_body_declarations] = "enum_body_declarations",
  [sym_enum_constant] = "enum_constant",
  [sym_class_declaration] = "class_declaration",
  [sym_modifiers] = "modifiers",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_type_bound] = "type_bound",
  [sym_superclass] = "superclass",
  [sym_super_interfaces] = "super_interfaces",
  [sym_interface_type_list] = "interface_type_list",
  [sym_class_body] = "class_body",
  [sym_static_initializer] = "static_initializer",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym__constructor_declarator] = "_constructor_declarator",
  [sym_constructor_body] = "constructor_body",
  [sym_explicit_constructor_invocation] = "explicit_constructor_invocation",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_field_declaration] = "field_declaration",
  [sym_annotation_type_declaration] = "annotation_type_declaration",
  [sym_annotation_type_body] = "annotation_type_body",
  [sym_annotation_type_element_declaration] = "annotation_type_element_declaration",
  [sym__default_value] = "_default_value",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_interfaces] = "extends_interfaces",
  [sym_interface_body] = "interface_body",
  [sym_constant_declaration] = "constant_declaration",
  [sym__variable_declarator_list] = "_variable_declarator_list",
  [sym_variable_declarator] = "variable_declarator",
  [sym__variable_declarator_id] = "_variable_declarator_id",
  [sym_array_initializer] = "array_initializer",
  [sym__type] = "_type",
  [sym__unannotated_type] = "_unannotated_type",
  [sym_annotated_type] = "annotated_type",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_generic_type] = "generic_type",
  [sym_array_type] = "array_type",
  [sym_integral_type] = "integral_type",
  [sym_floating_point_type] = "floating_point_type",
  [sym__method_header] = "_method_header",
  [sym__method_declarator] = "_method_declarator",
  [sym_formal_parameters] = "formal_parameters",
  [sym_formal_parameter] = "formal_parameter",
  [sym_receiver_parameter] = "receiver_parameter",
  [sym_spread_parameter] = "spread_parameter",
  [sym_throws] = "throws",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym_method_declaration] = "method_declaration",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_cast_expression_repeat1] = "cast_expression_repeat1",
  [aux_sym_inferred_parameters_repeat1] = "inferred_parameters_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [aux_sym_dimensions_expr_repeat1] = "dimensions_expr_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_dimensions_repeat1] = "dimensions_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_catch_type_repeat1] = "catch_type_repeat1",
  [aux_sym_resource_specification_repeat1] = "resource_specification_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_for_statement_repeat2] = "for_statement_repeat2",
  [aux_sym_annotation_argument_list_repeat1] = "annotation_argument_list_repeat1",
  [aux_sym_element_value_array_initializer_repeat1] = "element_value_array_initializer_repeat1",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym_module_directive_repeat1] = "module_directive_repeat1",
  [aux_sym_module_directive_repeat2] = "module_directive_repeat2",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_enum_body_declarations_repeat1] = "enum_body_declarations_repeat1",
  [aux_sym_modifiers_repeat1] = "modifiers_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_type_bound_repeat1] = "type_bound_repeat1",
  [aux_sym_interface_type_list_repeat1] = "interface_type_list_repeat1",
  [aux_sym_annotation_type_body_repeat1] = "annotation_type_body_repeat1",
  [aux_sym_interface_body_repeat1] = "interface_body_repeat1",
  [aux_sym__variable_declarator_list_repeat1] = "_variable_declarator_list_repeat1",
  [aux_sym_array_initializer_repeat1] = "array_initializer_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_decimal_integer_literal] = sym_decimal_integer_literal,
  [sym_hex_integer_literal] = sym_hex_integer_literal,
  [sym_octal_integer_literal] = sym_octal_integer_literal,
  [sym_binary_integer_literal] = sym_binary_integer_literal,
  [sym_decimal_floating_point_literal] = sym_decimal_floating_point_literal,
  [sym_hex_floating_point_literal] = sym_hex_floating_point_literal,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_null_literal] = sym_null_literal,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_synchronized] = anon_sym_synchronized,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_exports] = anon_sym_exports,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_opens] = anon_sym_opens,
  [anon_sym_uses] = anon_sym_uses,
  [anon_sym_provides] = anon_sym_provides,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_transitive] = anon_sym_transitive,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_strictfp] = anon_sym_strictfp,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_transient] = anon_sym_transient,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_ATinterface] = anon_sym_ATinterface,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_char] = anon_sym_char,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [sym_boolean_type] = sym_boolean_type,
  [sym_void_type] = sym_void_type,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_throws] = anon_sym_throws,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_comment] = sym_comment,
  [sym_program] = sym_program,
  [sym__literal] = sym__literal,
  [sym_expression] = sym_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_instanceof_expression] = sym_instanceof_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_inferred_parameters] = sym_inferred_parameters,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_dimensions_expr] = sym_dimensions_expr,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_literal] = sym_class_literal,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym__unqualified_object_creation_expression] = sym__unqualified_object_creation_expression,
  [sym_field_access] = sym_field_access,
  [sym_array_access] = sym_array_access,
  [sym_method_invocation] = sym_method_invocation,
  [sym_argument_list] = sym_argument_list,
  [sym_method_reference] = sym_method_reference,
  [sym_type_arguments] = sym_type_arguments,
  [sym_wildcard] = sym_wildcard,
  [sym__wildcard_bounds] = sym__wildcard_bounds,
  [sym_dimensions] = sym_dimensions,
  [sym_statement] = sym_statement,
  [sym_block] = sym_block,
  [sym_expression_statement] = sym_expression_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_assert_statement] = sym_assert_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_block] = sym_switch_block,
  [sym_switch_label] = sym_switch_label,
  [sym_do_statement] = sym_do_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_synchronized_statement] = sym_synchronized_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_formal_parameter] = sym_catch_formal_parameter,
  [sym_catch_type] = sym_catch_type,
  [sym_finally_clause] = sym_finally_clause,
  [sym_try_with_resources_statement] = sym_try_with_resources_statement,
  [sym_resource_specification] = sym_resource_specification,
  [sym_resource] = sym_resource,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_enhanced_for_statement] = sym_enhanced_for_statement,
  [sym__annotation] = sym__annotation,
  [sym_marker_annotation] = sym_marker_annotation,
  [sym_annotation] = sym_annotation,
  [sym_annotation_argument_list] = sym_annotation_argument_list,
  [sym_element_value_pair] = sym_element_value_pair,
  [sym__element_value] = sym__element_value,
  [sym_element_value_array_initializer] = sym_element_value_array_initializer,
  [sym_declaration] = sym_declaration,
  [sym_module_declaration] = sym_module_declaration,
  [sym_module_body] = sym_module_body,
  [sym_module_directive] = sym_module_directive,
  [sym_requires_modifier] = sym_requires_modifier,
  [sym_package_declaration] = sym_package_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_asterisk] = sym_asterisk,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_body_declarations] = sym_enum_body_declarations,
  [sym_enum_constant] = sym_enum_constant,
  [sym_class_declaration] = sym_class_declaration,
  [sym_modifiers] = sym_modifiers,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_type_bound] = sym_type_bound,
  [sym_superclass] = sym_superclass,
  [sym_super_interfaces] = sym_super_interfaces,
  [sym_interface_type_list] = sym_interface_type_list,
  [sym_class_body] = sym_class_body,
  [sym_static_initializer] = sym_static_initializer,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym__constructor_declarator] = sym__constructor_declarator,
  [sym_constructor_body] = sym_constructor_body,
  [sym_explicit_constructor_invocation] = sym_explicit_constructor_invocation,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_field_declaration] = sym_field_declaration,
  [sym_annotation_type_declaration] = sym_annotation_type_declaration,
  [sym_annotation_type_body] = sym_annotation_type_body,
  [sym_annotation_type_element_declaration] = sym_annotation_type_element_declaration,
  [sym__default_value] = sym__default_value,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_interfaces] = sym_extends_interfaces,
  [sym_interface_body] = sym_interface_body,
  [sym_constant_declaration] = sym_constant_declaration,
  [sym__variable_declarator_list] = sym__variable_declarator_list,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym__variable_declarator_id] = sym__variable_declarator_id,
  [sym_array_initializer] = sym_array_initializer,
  [sym__type] = sym__type,
  [sym__unannotated_type] = sym__unannotated_type,
  [sym_annotated_type] = sym_annotated_type,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_generic_type] = sym_generic_type,
  [sym_array_type] = sym_array_type,
  [sym_integral_type] = sym_integral_type,
  [sym_floating_point_type] = sym_floating_point_type,
  [sym__method_header] = sym__method_header,
  [sym__method_declarator] = sym__method_declarator,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_formal_parameter] = sym_formal_parameter,
  [sym_receiver_parameter] = sym_receiver_parameter,
  [sym_spread_parameter] = sym_spread_parameter,
  [sym_throws] = sym_throws,
  [sym_local_variable_declaration] = sym_local_variable_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_cast_expression_repeat1] = aux_sym_cast_expression_repeat1,
  [aux_sym_inferred_parameters_repeat1] = aux_sym_inferred_parameters_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [aux_sym_dimensions_expr_repeat1] = aux_sym_dimensions_expr_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_dimensions_repeat1] = aux_sym_dimensions_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_catch_type_repeat1] = aux_sym_catch_type_repeat1,
  [aux_sym_resource_specification_repeat1] = aux_sym_resource_specification_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_for_statement_repeat2] = aux_sym_for_statement_repeat2,
  [aux_sym_annotation_argument_list_repeat1] = aux_sym_annotation_argument_list_repeat1,
  [aux_sym_element_value_array_initializer_repeat1] = aux_sym_element_value_array_initializer_repeat1,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym_module_directive_repeat1] = aux_sym_module_directive_repeat1,
  [aux_sym_module_directive_repeat2] = aux_sym_module_directive_repeat2,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_enum_body_declarations_repeat1] = aux_sym_enum_body_declarations_repeat1,
  [aux_sym_modifiers_repeat1] = aux_sym_modifiers_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_type_bound_repeat1] = aux_sym_type_bound_repeat1,
  [aux_sym_interface_type_list_repeat1] = aux_sym_interface_type_list_repeat1,
  [aux_sym_annotation_type_body_repeat1] = aux_sym_annotation_type_body_repeat1,
  [aux_sym_interface_body_repeat1] = aux_sym_interface_body_repeat1,
  [aux_sym__variable_declarator_list_repeat1] = aux_sym__variable_declarator_list_repeat1,
  [aux_sym_array_initializer_repeat1] = aux_sym_array_initializer_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_synchronized] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exports] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opens] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uses] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_provides] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transient] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATinterface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [sym_boolean_type] = {
    .visible = true,
    .named = true,
  },
  [sym_void_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throws] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instanceof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_inferred_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dimensions_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__unqualified_object_creation_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym_array_access] = {
    .visible = true,
    .named = true,
  },
  [sym_method_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_method_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym__wildcard_bounds] = {
    .visible = false,
    .named = true,
  },
  [sym_dimensions] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_synchronized_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_type] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_try_with_resources_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_resource_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_resource] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enhanced_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_marker_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_element_value_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__element_value] = {
    .visible = false,
    .named = true,
  },
  [sym_element_value_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_package_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_asterisk] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_super_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_static_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_body] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_constructor_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_body] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_element_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__default_value] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_body] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_list] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_id] = {
    .visible = false,
    .named = true,
  },
  [sym_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unannotated_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_annotated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_integral_type] = {
    .visible = true,
    .named = true,
  },
  [sym_floating_point_type] = {
    .visible = true,
    .named = true,
  },
  [sym__method_header] = {
    .visible = false,
    .named = true,
  },
  [sym__method_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_receiver_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_throws] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inferred_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimensions_expr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimensions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_catch_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_resource_specification_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_element_value_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_directive_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_declarations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_bound_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_declarator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_array = 3,
  field_body = 4,
  field_condition = 5,
  field_consequence = 6,
  field_constructor = 7,
  field_declarator = 8,
  field_dimensions = 9,
  field_element = 10,
  field_field = 11,
  field_index = 12,
  field_init = 13,
  field_interfaces = 14,
  field_key = 15,
  field_left = 16,
  field_name = 17,
  field_object = 18,
  field_operand = 19,
  field_operator = 20,
  field_parameters = 21,
  field_resources = 22,
  field_right = 23,
  field_scope = 24,
  field_superclass = 25,
  field_type = 26,
  field_type_arguments = 27,
  field_type_parameters = 28,
  field_update = 29,
  field_value = 30,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_array] = "array",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declarator] = "declarator",
  [field_dimensions] = "dimensions",
  [field_element] = "element",
  [field_field] = "field",
  [field_index] = "index",
  [field_init] = "init",
  [field_interfaces] = "interfaces",
  [field_key] = "key",
  [field_left] = "left",
  [field_name] = "name",
  [field_object] = "object",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_resources] = "resources",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_superclass] = "superclass",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 3},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 1},
  [13] = {.index = 12, .length = 2},
  [14] = {.index = 14, .length = 3},
  [15] = {.index = 17, .length = 2},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 17, .length = 2},
  [18] = {.index = 19, .length = 2},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 2},
  [21] = {.index = 25, .length = 1},
  [22] = {.index = 26, .length = 1},
  [23] = {.index = 27, .length = 2},
  [24] = {.index = 29, .length = 2},
  [25] = {.index = 31, .length = 2},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 33, .length = 3},
  [28] = {.index = 21, .length = 2},
  [30] = {.index = 36, .length = 2},
  [31] = {.index = 36, .length = 2},
  [32] = {.index = 33, .length = 3},
  [33] = {.index = 38, .length = 2},
  [35] = {.index = 40, .length = 2},
  [36] = {.index = 42, .length = 3},
  [37] = {.index = 45, .length = 2},
  [38] = {.index = 45, .length = 2},
  [39] = {.index = 47, .length = 2},
  [40] = {.index = 49, .length = 2},
  [42] = {.index = 51, .length = 3},
  [43] = {.index = 54, .length = 1},
  [44] = {.index = 55, .length = 2},
  [45] = {.index = 57, .length = 2},
  [46] = {.index = 59, .length = 3},
  [47] = {.index = 62, .length = 3},
  [48] = {.index = 59, .length = 3},
  [49] = {.index = 62, .length = 3},
  [50] = {.index = 65, .length = 3},
  [51] = {.index = 65, .length = 3},
  [52] = {.index = 68, .length = 3},
  [53] = {.index = 71, .length = 3},
  [54] = {.index = 74, .length = 3},
  [55] = {.index = 77, .length = 2},
  [56] = {.index = 77, .length = 2},
  [57] = {.index = 79, .length = 2},
  [58] = {.index = 79, .length = 2},
  [60] = {.index = 81, .length = 2},
  [61] = {.index = 83, .length = 3},
  [62] = {.index = 83, .length = 3},
  [64] = {.index = 86, .length = 2},
  [65] = {.index = 88, .length = 2},
  [66] = {.index = 90, .length = 1},
  [67] = {.index = 91, .length = 2},
  [68] = {.index = 93, .length = 3},
  [70] = {.index = 96, .length = 3},
  [71] = {.index = 99, .length = 2},
  [72] = {.index = 101, .length = 4},
  [73] = {.index = 105, .length = 4},
  [74] = {.index = 109, .length = 5},
  [75] = {.index = 114, .length = 6},
  [76] = {.index = 120, .length = 4},
  [77] = {.index = 124, .length = 4},
  [78] = {.index = 128, .length = 4},
  [79] = {.index = 132, .length = 2},
  [80] = {.index = 134, .length = 3},
  [81] = {.index = 137, .length = 1},
  [82] = {.index = 138, .length = 2},
  [83] = {.index = 140, .length = 2},
  [84] = {.index = 142, .length = 3},
  [85] = {.index = 145, .length = 2},
  [86] = {.index = 145, .length = 2},
  [87] = {.index = 147, .length = 4},
  [88] = {.index = 147, .length = 4},
  [89] = {.index = 151, .length = 3},
  [90] = {.index = 154, .length = 3},
  [91] = {.index = 157, .length = 3},
  [92] = {.index = 160, .length = 3},
  [93] = {.index = 163, .length = 2},
  [94] = {.index = 165, .length = 2},
  [95] = {.index = 165, .length = 2},
  [96] = {.index = 167, .length = 4},
  [97] = {.index = 171, .length = 5},
  [98] = {.index = 176, .length = 6},
  [99] = {.index = 182, .length = 3},
  [100] = {.index = 185, .length = 5},
  [101] = {.index = 190, .length = 4},
  [102] = {.index = 99, .length = 2},
  [103] = {.index = 194, .length = 5},
  [104] = {.index = 199, .length = 4},
  [105] = {.index = 203, .length = 2},
  [106] = {.index = 205, .length = 1},
  [107] = {.index = 206, .length = 2},
  [108] = {.index = 208, .length = 2},
  [109] = {.index = 210, .length = 3},
  [110] = {.index = 213, .length = 3},
  [111] = {.index = 213, .length = 3},
  [112] = {.index = 216, .length = 4},
  [113] = {.index = 220, .length = 4},
  [114] = {.index = 224, .length = 4},
  [115] = {.index = 228, .length = 3},
  [116] = {.index = 231, .length = 4},
  [117] = {.index = 235, .length = 5},
  [118] = {.index = 240, .length = 3},
  [119] = {.index = 240, .length = 3},
  [120] = {.index = 243, .length = 4},
  [121] = {.index = 247, .length = 1},
  [122] = {.index = 248, .length = 2},
  [123] = {.index = 250, .length = 2},
  [124] = {.index = 252, .length = 1},
  [125] = {.index = 253, .length = 2},
  [126] = {.index = 255, .length = 2},
  [127] = {.index = 257, .length = 2},
  [128] = {.index = 259, .length = 3},
  [129] = {.index = 262, .length = 3},
  [131] = {.index = 265, .length = 3},
  [132] = {.index = 268, .length = 4},
  [133] = {.index = 268, .length = 4},
  [134] = {.index = 272, .length = 5},
  [135] = {.index = 277, .length = 2},
  [136] = {.index = 279, .length = 3},
  [137] = {.index = 282, .length = 3},
  [138] = {.index = 285, .length = 3},
  [139] = {.index = 288, .length = 3},
  [140] = {.index = 291, .length = 3},
  [141] = {.index = 294, .length = 5},
  [142] = {.index = 299, .length = 4},
  [143] = {.index = 303, .length = 4},
  [146] = {.index = 307, .length = 2},
  [147] = {.index = 309, .length = 3},
  [148] = {.index = 312, .length = 4},
  [149] = {.index = 316, .length = 4},
  [150] = {.index = 320, .length = 4},
  [151] = {.index = 324, .length = 4},
  [152] = {.index = 328, .length = 4},
  [153] = {.index = 332, .length = 5},
  [154] = {.index = 337, .length = 5},
  [155] = {.index = 342, .length = 2},
  [156] = {.index = 344, .length = 1},
  [157] = {.index = 345, .length = 3},
  [158] = {.index = 348, .length = 3},
  [159] = {.index = 351, .length = 3},
  [160] = {.index = 354, .length = 5},
  [161] = {.index = 359, .length = 5},
  [162] = {.index = 364, .length = 5},
  [163] = {.index = 369, .length = 3},
  [164] = {.index = 372, .length = 3},
  [165] = {.index = 375, .length = 4},
  [166] = {.index = 379, .length = 4},
  [167] = {.index = 383, .length = 6},
  [168] = {.index = 389, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_arguments, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_arguments, 0, .inherited = true},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_name, 1},
  [6] =
    {field_arguments, 1},
    {field_name, 0},
  [8] =
    {field_name, 0},
  [9] =
    {field_dimensions, 1},
    {field_element, 0},
  [11] =
    {field_declarator, 0},
  [12] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [14] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
  [17] =
    {field_arguments, 2},
    {field_type, 1},
  [19] =
    {field_dimensions, 2},
    {field_type, 1},
  [21] =
    {field_body, 2},
    {field_name, 1},
  [23] =
    {field_body, 2},
    {field_condition, 1},
  [25] =
    {field_body, 2},
  [26] =
    {field_body, 1},
  [27] =
    {field_body, 2},
    {field_resources, 1},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_arguments, 2},
    {field_name, 1},
  [33] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [36] =
    {field_field, 2},
    {field_object, 0},
  [38] =
    {field_body, 2},
    {field_parameters, 0},
  [40] =
    {field_left, 0},
    {field_right, 2},
  [42] =
    {field_arguments, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
  [45] =
    {field_dimensions, 1},
    {field_name, 0},
  [47] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0},
  [49] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [51] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
  [54] =
    {field_type, 1},
  [55] =
    {field_type, 1},
    {field_value, 3},
  [57] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [59] =
    {field_dimensions, 2},
    {field_type, 1},
    {field_value, 3},
  [62] =
    {field_dimensions, 2},
    {field_dimensions, 3},
    {field_type, 1},
  [65] =
    {field_arguments, 3},
    {field_type, 2},
    {field_type_arguments, 1},
  [68] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [71] =
    {field_body, 3},
    {field_name, 1},
    {field_superclass, 2},
  [74] =
    {field_body, 3},
    {field_interfaces, 2},
    {field_name, 1},
  [77] =
    {field_name, 2},
    {field_scope, 0},
  [79] =
    {field_body, 3},
    {field_name, 2},
  [81] =
    {field_body, 3},
    {field_name, 1},
  [83] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [86] =
    {field_array, 0},
    {field_index, 2},
  [88] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1},
  [90] =
    {field_declarator, 1},
  [91] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [93] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2},
  [96] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
    {field_value, 4},
  [99] =
    {field_name, 0},
    {field_parameters, 1},
  [101] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [105] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0},
  [109] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [114] =
    {field_body, 1},
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [120] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [124] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [128] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_superclass, 2},
  [132] =
    {field_body, 1},
    {field_condition, 3},
  [134] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [137] =
    {field_init, 1},
  [138] =
    {field_init, 0, .inherited = true},
    {field_init, 1, .inherited = true},
  [140] =
    {field_body, 1},
    {field_name, 0},
  [142] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [145] =
    {field_field, 4},
    {field_object, 0},
  [147] =
    {field_arguments, 4},
    {field_name, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [151] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [154] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [157] =
    {field_body, 4},
    {field_name, 2},
    {field_superclass, 3},
  [160] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 2},
  [163] =
    {field_body, 4},
    {field_name, 2},
  [165] =
    {field_body, 4},
    {field_name, 3},
  [167] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [171] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [176] =
    {field_body, 2},
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [182] =
    {field_name, 1},
    {field_parameters, 2},
    {field_type_parameters, 0},
  [185] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1},
    {field_type_parameters, 0},
  [190] =
    {field_body, 2},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [194] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [199] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
    {field_value, 3},
  [203] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [205] =
    {field_body, 5},
  [206] =
    {field_body, 5},
    {field_init, 2},
  [208] =
    {field_key, 0},
    {field_value, 2},
  [210] =
    {field_arguments, 1},
    {field_body, 2},
    {field_name, 0},
  [213] =
    {field_arguments, 5},
    {field_name, 4},
    {field_object, 0},
  [216] =
    {field_body, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [220] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [224] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_superclass, 3},
  [228] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [231] =
    {field_body, 3},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [235] =
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_parameters, 3, .inherited = true},
    {field_type, 2},
    {field_type_parameters, 0},
  [240] =
    {field_dimensions, 2},
    {field_name, 0},
    {field_parameters, 1},
  [243] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
    {field_value, 4},
  [247] =
    {field_body, 4},
  [248] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [250] =
    {field_body, 6},
    {field_update, 4},
  [252] =
    {field_update, 1},
  [253] =
    {field_update, 0, .inherited = true},
    {field_update, 1, .inherited = true},
  [255] =
    {field_body, 6},
    {field_condition, 3},
  [257] =
    {field_body, 6},
    {field_init, 2},
  [259] =
    {field_body, 6},
    {field_init, 2},
    {field_update, 4},
  [262] =
    {field_body, 6},
    {field_condition, 3},
    {field_init, 2},
  [265] =
    {field_arguments, 2},
    {field_body, 3},
    {field_name, 1},
  [268] =
    {field_arguments, 6},
    {field_name, 5},
    {field_object, 0},
    {field_type_arguments, 4},
  [272] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [277] =
    {field_arguments, 1},
    {field_constructor, 0},
  [279] =
    {field_body, 7},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [282] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [285] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 5},
  [288] =
    {field_body, 7},
    {field_condition, 4},
    {field_init, 2},
  [291] =
    {field_body, 7},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [294] =
    {field_body, 7},
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_type, 2},
    {field_value, 5},
  [299] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [303] =
    {field_body, 7},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
  [307] =
    {field_name, 1},
    {field_type, 0},
  [309] =
    {field_arguments, 2},
    {field_constructor, 1},
    {field_type_arguments, 0},
  [312] =
    {field_body, 8},
    {field_condition, 3},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [316] =
    {field_body, 8},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [320] =
    {field_body, 8},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
  [324] =
    {field_body, 8},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
  [328] =
    {field_body, 8},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [332] =
    {field_body, 8},
    {field_dimensions, 4, .inherited = true},
    {field_name, 4, .inherited = true},
    {field_type, 3},
    {field_value, 6},
  [337] =
    {field_body, 8},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [342] =
    {field_name, 2},
    {field_type, 1},
  [344] =
    {field_value, 1},
  [345] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
  [348] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 4, .inherited = true},
  [351] =
    {field_arguments, 3},
    {field_constructor, 2},
    {field_object, 0},
  [354] =
    {field_body, 9},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [359] =
    {field_body, 9},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [364] =
    {field_body, 9},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
  [369] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
  [372] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 5, .inherited = true},
  [375] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
    {field_value, 5, .inherited = true},
  [379] =
    {field_arguments, 4},
    {field_constructor, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [383] =
    {field_body, 10},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
    {field_update, 8, .inherited = true},
  [389] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
    {field_value, 6, .inherited = true},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = sym_identifier,
  },
  [9] = {
    [0] = sym_identifier,
  },
  [17] = {
    [1] = alias_sym_type_identifier,
  },
  [18] = {
    [1] = alias_sym_type_identifier,
  },
  [25] = {
    [1] = sym_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = sym_identifier,
  },
  [29] = {
    [1] = sym_identifier,
  },
  [30] = {
    [2] = sym_identifier,
  },
  [34] = {
    [0] = alias_sym_type_identifier,
    [2] = alias_sym_type_identifier,
  },
  [37] = {
    [0] = sym_identifier,
  },
  [41] = {
    [2] = alias_sym_type_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [51] = {
    [2] = alias_sym_type_identifier,
  },
  [55] = {
    [0] = sym_identifier,
  },
  [57] = {
    [2] = sym_identifier,
  },
  [59] = {
    [2] = sym_identifier,
  },
  [61] = {
    [2] = sym_identifier,
  },
  [63] = {
    [0] = alias_sym_type_identifier,
    [3] = alias_sym_type_identifier,
  },
  [69] = {
    [3] = alias_sym_type_identifier,
  },
  [85] = {
    [4] = sym_identifier,
  },
  [87] = {
    [3] = sym_identifier,
  },
  [94] = {
    [3] = sym_identifier,
  },
  [102] = {
    [0] = sym_identifier,
  },
  [110] = {
    [4] = sym_identifier,
  },
  [118] = {
    [0] = sym_identifier,
  },
  [130] = {
    [1] = sym_identifier,
    [2] = sym_identifier,
  },
  [132] = {
    [5] = sym_identifier,
  },
  [144] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [145] = {
    [3] = sym_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6688
    ? (c < 2984
      ? (c < 2365
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= '$' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2208
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2228 || (c < 2308
                  ? (c >= 2230 && c <= 2247)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2544
            ? (c < 2474
              ? (c < 2437
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2654
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)
                : (c <= 2654 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2869
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2835
                ? (c < 2821
                  ? c == 2809
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))
                : (c <= 2856 || (c < 2866
                  ? (c >= 2858 && c <= 2864)
                  : c <= 2867)))))
            : (c <= 2873 || (c < 2958
              ? (c < 2929
                ? (c < 2908
                  ? c == 2877
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2949
                  ? c == 2947
                  : c <= 2954)))
              : (c <= 2960 || (c < 2972
                ? (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)
                : (c <= 2972 || (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : c <= 2980)))))))))))
      : (c <= 2986 || (c < 4186
        ? (c < 3450
          ? (c < 3242
            ? (c < 3133
              ? (c < 3086
                ? (c < 3024
                  ? (c >= 2990 && c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : c <= 3129)))
              : (c <= 3133 || (c < 3205
                ? (c < 3168
                  ? (c >= 3160 && c <= 3162)
                  : (c <= 3169 || c == 3200))
                : (c <= 3212 || (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : c <= 3240)))))
            : (c <= 3251 || (c < 3342
              ? (c < 3296
                ? (c < 3261
                  ? (c >= 3253 && c <= 3257)
                  : (c <= 3261 || c == 3294))
                : (c <= 3297 || (c < 3332
                  ? (c >= 3313 && c <= 3314)
                  : c <= 3340)))
              : (c <= 3344 || (c < 3406
                ? (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)
                : (c <= 3406 || (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : c <= 3425)))))))
          : (c <= 3455 || (c < 3751
            ? (c < 3634
              ? (c < 3517
                ? (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : c <= 3632)))
              : (c <= 3635 || (c < 3718
                ? (c < 3713
                  ? (c >= 3648 && c <= 3654)
                  : (c <= 3714 || c == 3716))
                : (c <= 3722 || (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)))))
            : (c <= 3760 || (c < 3904
              ? (c < 3782
                ? (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))
                : (c <= 3782 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))
              : (c <= 3911 || (c < 4096
                ? (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)
                : (c <= 4138 || (c < 4176
                  ? c == 4159
                  : c <= 4181)))))))))
        : (c <= 4189 || (c < 5024
          ? (c < 4698
            ? (c < 4295
              ? (c < 4213
                ? (c < 4197
                  ? c == 4193
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))
                : (c <= 4225 || (c < 4256
                  ? c == 4238
                  : c <= 4293)))
              : (c <= 4295 || (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))))
            : (c <= 4701 || (c < 4802
              ? (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))
              : (c <= 4805 || (c < 4882
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)
                : (c <= 4885 || (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : c <= 5007)))))))
          : (c <= 5109 || (c < 6103
            ? (c < 5888
              ? (c < 5761
                ? (c < 5121
                  ? (c >= 5112 && c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))
                : (c <= 5786 || (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))
              : (c <= 5900 || (c < 5984
                ? (c < 5920
                  ? (c >= 5902 && c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6016
                  ? (c >= 5998 && c <= 6000)
                  : c <= 6067)))))
            : (c <= 6103 || (c < 6400
              ? (c < 6279
                ? (c < 6176
                  ? c == 6108
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))
              : (c <= 6430 || (c < 6528
                ? (c < 6512
                  ? (c >= 6480 && c <= 6509)
                  : c <= 6516)
                : (c <= 6571 || (c < 6656
                  ? (c >= 6576 && c <= 6601)
                  : c <= 6678)))))))))))))
    : (c <= 6740 || (c < 43259
      ? (c < 11264
        ? (c < 8064
          ? (c < 7406
            ? (c < 7168
              ? (c < 7043
                ? (c < 6917
                  ? c == 6823
                  : (c <= 6963 || (c >= 6981 && c <= 6987)))
                : (c <= 7072 || (c < 7098
                  ? (c >= 7086 && c <= 7087)
                  : c <= 7141)))
              : (c <= 7203 || (c < 7312
                ? (c < 7258
                  ? (c >= 7245 && c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))
                : (c <= 7354 || (c < 7401
                  ? (c >= 7357 && c <= 7359)
                  : c <= 7404)))))
            : (c <= 7411 || (c < 8008
              ? (c < 7680
                ? (c < 7418
                  ? (c >= 7413 && c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))
                : (c <= 7957 || (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : c <= 8005)))
              : (c <= 8013 || (c < 8027
                ? (c < 8025
                  ? (c >= 8016 && c <= 8023)
                  : c <= 8025)
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))))))
          : (c <= 8116 || (c < 8455
            ? (c < 8160
              ? (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))
              : (c <= 8172 || (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))))
            : (c <= 8455 || (c < 8490
              ? (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))
              : (c <= 8493 || (c < 8517
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : c <= 8511)
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : c <= 8580)))))))))
        : (c <= 11310 || (c < 12549
          ? (c < 11704
            ? (c < 11565
              ? (c < 11506
                ? (c < 11360
                  ? (c >= 11312 && c <= 11358)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))
                : (c <= 11507 || (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : c <= 11559)))
              : (c <= 11565 || (c < 11680
                ? (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))
                : (c <= 11686 || (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : c <= 11702)))))
            : (c <= 11710 || (c < 12337
              ? (c < 11736
                ? (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))
                : (c <= 11742 || (c < 12293
                  ? c == 11823
                  : c <= 12294)))
              : (c <= 12341 || (c < 12445
                ? (c < 12353
                  ? (c >= 12347 && c <= 12348)
                  : c <= 12438)
                : (c <= 12447 || (c < 12540
                  ? (c >= 12449 && c <= 12538)
                  : c <= 12543)))))))
          : (c <= 12591 || (c < 42623
            ? (c < 40956
              ? (c < 13312
                ? (c < 12704
                  ? (c >= 12593 && c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))
                : (c <= 13312 || (c < 19968
                  ? c == 19903
                  : c <= 19968)))
              : (c <= 40956 || (c < 42512
                ? (c < 42192
                  ? (c >= 40960 && c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42560
                  ? (c >= 42538 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 43011
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42943 || (c < 42997
                  ? (c >= 42946 && c <= 42954)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67828
            ? (c < 67639
              ? (c < 67584
                ? (c < 67392
                  ? (c >= 67072 && c <= 67382)
                  : (c <= 67413 || (c >= 67424 && c <= 67431)))
                : (c <= 67589 || (c < 67594
                  ? c == 67592
                  : c <= 67637)))
              : (c <= 67640 || (c < 67680
                ? (c < 67647
                  ? c == 67644
                  : c <= 67669)
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1369
          ? (c < 750
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? c == '$'
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1015
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : c <= 1013)
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1749
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1791
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1994
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2144
                ? (c < 2112
                  ? c == 2088
                  : c <= 2136)
                : (c <= 2154 || (c < 2230
                  ? (c >= 2208 && c <= 2228)
                  : c <= 2247)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4176
        ? (c < 3423
          ? (c < 3218
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3200
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3332
              ? (c < 3294
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : (c <= 3257 || c == 3261))
                : (c <= 3294 || (c < 3313
                  ? (c >= 3296 && c <= 3297)
                  : c <= 3314)))
              : (c <= 3340 || (c < 3389
                ? (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)
                : (c <= 3389 || (c < 3412
                  ? c == 3406
                  : c <= 3414)))))))
          : (c <= 3425 || (c < 3749
            ? (c < 3585
              ? (c < 3507
                ? (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3520
                  ? c == 3517
                  : c <= 3526)))
              : (c <= 3632 || (c < 3716
                ? (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3724
                  ? (c >= 3718 && c <= 3722)
                  : c <= 3747)))))
            : (c <= 3749 || (c < 3840
              ? (c < 3776
                ? (c < 3762
                  ? (c >= 3751 && c <= 3760)
                  : (c <= 3763 || c == 3773))
                : (c <= 3780 || (c < 3804
                  ? c == 3782
                  : c <= 3807)))
              : (c <= 3840 || (c < 3976
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : c <= 3948)
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : c <= 4159)))))))))
        : (c <= 4181 || (c < 4992
          ? (c < 4696
            ? (c < 4256
              ? (c < 4206
                ? (c < 4193
                  ? (c >= 4186 && c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))
                : (c <= 4208 || (c < 4238
                  ? (c >= 4213 && c <= 4225)
                  : c <= 4238)))
              : (c <= 4293 || (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))))
            : (c <= 4696 || (c < 4800
              ? (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))
              : (c <= 4800 || (c < 4824
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : c <= 4822)
                : (c <= 4880 || (c < 4888
                  ? (c >= 4882 && c <= 4885)
                  : c <= 4954)))))))
          : (c <= 5007 || (c < 6016
            ? (c < 5873
              ? (c < 5743
                ? (c < 5112
                  ? (c >= 5024 && c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))
                : (c <= 5759 || (c < 5792
                  ? (c >= 5761 && c <= 5786)
                  : c <= 5866)))
              : (c <= 5880 || (c < 5952
                ? (c < 5902
                  ? (c >= 5888 && c <= 5900)
                  : (c <= 5905 || (c >= 5920 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43250
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6987 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12540
          ? (c < 11696
            ? (c < 11559
              ? (c < 11499
                ? (c < 11312
                  ? (c >= 11264 && c <= 11310)
                  : (c <= 11358 || (c >= 11360 && c <= 11492)))
                : (c <= 11502 || (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : c <= 11557)))
              : (c <= 11559 || (c < 11648
                ? (c < 11568
                  ? c == 11565
                  : (c <= 11623 || c == 11631))
                : (c <= 11670 || (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : c <= 11694)))))
            : (c <= 11702 || (c < 12293
              ? (c < 11728
                ? (c < 11712
                  ? (c >= 11704 && c <= 11710)
                  : (c <= 11718 || (c >= 11720 && c <= 11726)))
                : (c <= 11734 || (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : c <= 11823)))
              : (c <= 12294 || (c < 12353
                ? (c < 12347
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)
                : (c <= 12438 || (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)))))))
          : (c <= 12543 || (c < 42560
            ? (c < 19968
              ? (c < 12784
                ? (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : (c <= 12686 || (c >= 12704 && c <= 12735)))
                : (c <= 12799 || (c < 19903
                  ? c == 13312
                  : c <= 19903)))
              : (c <= 19968 || (c < 42240
                ? (c < 40960
                  ? c == 40956
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : c <= 42539)))))
            : (c <= 42606 || (c < 42997
              ? (c < 42786
                ? (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : (c <= 42725 || (c >= 42775 && c <= 42783)))
                : (c <= 42888 || (c < 42946
                  ? (c >= 42891 && c <= 42943)
                  : c <= 42954)))
              : (c <= 43009 || (c < 43020
                ? (c < 43015
                  ? (c >= 43011 && c <= 43013)
                  : c <= 43018)
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))))))))))
      : (c <= 43255 || (c < 65142
        ? (c < 43793
          ? (c < 43616
            ? (c < 43471
              ? (c < 43312
                ? (c < 43261
                  ? c == 43259
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))
                : (c <= 43334 || (c < 43396
                  ? (c >= 43360 && c <= 43388)
                  : c <= 43442)))
              : (c <= 43471 || (c < 43520
                ? (c < 43494
                  ? (c >= 43488 && c <= 43492)
                  : (c <= 43503 || (c >= 43514 && c <= 43518)))
                : (c <= 43560 || (c < 43588
                  ? (c >= 43584 && c <= 43586)
                  : c <= 43595)))))
            : (c <= 43638 || (c < 43714
              ? (c < 43701
                ? (c < 43646
                  ? c == 43642
                  : (c <= 43695 || c == 43697))
                : (c <= 43702 || (c < 43712
                  ? (c >= 43705 && c <= 43709)
                  : c <= 43712)))
              : (c <= 43714 || (c < 43762
                ? (c < 43744
                  ? (c >= 43739 && c <= 43741)
                  : c <= 43754)
                : (c <= 43764 || (c < 43785
                  ? (c >= 43777 && c <= 43782)
                  : c <= 43790)))))))
          : (c <= 43798 || (c < 64285
            ? (c < 55203
              ? (c < 43868
                ? (c < 43816
                  ? (c >= 43808 && c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))
                : (c <= 43881 || (c < 44032
                  ? (c >= 43888 && c <= 44002)
                  : c <= 44032)))
              : (c <= 55203 || (c < 64112
                ? (c < 55243
                  ? (c >= 55216 && c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64275
                  ? (c >= 64256 && c <= 64262)
                  : c <= 64279)))))
            : (c <= 64285 || (c < 64326
              ? (c < 64318
                ? (c < 64298
                  ? (c >= 64287 && c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64323
                  ? (c >= 64320 && c <= 64321)
                  : c <= 64324)))
              : (c <= 64433 || (c < 64914
                ? (c < 64848
                  ? (c >= 64467 && c <= 64829)
                  : c <= 64911)
                : (c <= 64967 || (c < 65136
                  ? (c >= 65008 && c <= 65019)
                  : c <= 65140)))))))))
        : (c <= 65276 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65474
                ? (c < 65345
                  ? (c >= 65313 && c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : c <= 65495)))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66560
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : c <= 66511)
                : (c <= 66717 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67828
            ? (c < 67594
              ? (c < 67424
                ? (c < 67072
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : c <= 67592)))
              : (c <= 67637 || (c < 67680
                ? (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(46);
      if (lookahead == '!') ADVANCE(128);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '0') ADVANCE(48);
      if (lookahead == ':') ADVANCE(126);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(124);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(133);
      if (lookahead == '^') ADVANCE(113);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '|') ADVANCE(110);
      if (lookahead == '}') ADVANCE(141);
      if (lookahead == '~') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(49);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(146);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(127);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '&') ADVANCE(71);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(11);
      if (lookahead == '/') ADVANCE(8);
      if (lookahead == '0') ADVANCE(48);
      if (lookahead == ':') ADVANCE(126);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(124);
      if (lookahead == '@') ADVANCE(142);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(133);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(141);
      if (lookahead == '~') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(49);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(146);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(15);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == ':') ADVANCE(126);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(124);
      if (lookahead == '@') ADVANCE(142);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(133);
      if (lookahead == '^') ADVANCE(113);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '|') ADVANCE(110);
      if (lookahead == '}') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(146);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(15);
      if (lookahead == '%') ADVANCE(114);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(105);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(134);
      if (lookahead == '/') ADVANCE(107);
      if (lookahead == ':') ADVANCE(126);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(16);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(124);
      if (lookahead == '@') ADVANCE(142);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(133);
      if (lookahead == '^') ADVANCE(112);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '|') ADVANCE(111);
      if (lookahead == '}') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(146);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == '&') ADVANCE(71);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '/') ADVANCE(8);
      if (lookahead == ':') ADVANCE(126);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '@') ADVANCE(142);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(146);
      END_STATE();
    case 6:
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(6);
      END_STATE();
    case 7:
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '.') ADVANCE(134);
      if (lookahead == '/') ADVANCE(8);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(146);
      END_STATE();
    case 8:
      if (lookahead == '*') ADVANCE(10);
      if (lookahead == '/') ADVANCE(148);
      END_STATE();
    case 9:
      if (lookahead == '*') ADVANCE(9);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == '*') ADVANCE(9);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '.') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 12:
      if (lookahead == '.') ADVANCE(145);
      END_STATE();
    case 13:
      if (lookahead == '.') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 14:
      if (lookahead == ':') ADVANCE(138);
      END_STATE();
    case 15:
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 16:
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 17:
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(6);
      END_STATE();
    case 18:
      if (lookahead == '_') ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(49);
      END_STATE();
    case 19:
      if (lookahead == '_') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 20:
      if (lookahead == '_') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 21:
      if (lookahead == '_') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 22:
      if (lookahead == '_') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == 'c') ADVANCE(27);
      END_STATE();
    case 26:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(24);
      END_STATE();
    case 29:
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 30:
      if (lookahead == 'r') ADVANCE(28);
      END_STATE();
    case 31:
      if (lookahead == 't') ADVANCE(26);
      END_STATE();
    case 32:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 33:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 34:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(57);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(55);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 41:
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 42:
      if (lookahead != 0) ADVANCE(6);
      END_STATE();
    case 43:
      if (eof) ADVANCE(46);
      if (lookahead == '!') ADVANCE(128);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '%') ADVANCE(114);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(105);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(137);
      if (lookahead == '/') ADVANCE(107);
      if (lookahead == '0') ADVANCE(48);
      if (lookahead == ':') ADVANCE(126);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(16);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(124);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(133);
      if (lookahead == '^') ADVANCE(112);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '|') ADVANCE(111);
      if (lookahead == '}') ADVANCE(141);
      if (lookahead == '~') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(43)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(49);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(146);
      END_STATE();
    case 44:
      if (eof) ADVANCE(46);
      if (lookahead == '!') ADVANCE(128);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '%') ADVANCE(114);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(105);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '/') ADVANCE(107);
      if (lookahead == '0') ADVANCE(48);
      if (lookahead == ':') ADVANCE(125);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(16);
      if (lookahead == '>') ADVANCE(90);
      if (lookahead == '?') ADVANCE(124);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == ']') ADVANCE(133);
      if (lookahead == '^') ADVANCE(112);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '|') ADVANCE(111);
      if (lookahead == '}') ADVANCE(141);
      if (lookahead == '~') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(44)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(49);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(146);
      END_STATE();
    case 45:
      if (eof) ADVANCE(46);
      if (lookahead == '!') ADVANCE(127);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '&') ADVANCE(71);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(123);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '/') ADVANCE(8);
      if (lookahead == '0') ADVANCE(48);
      if (lookahead == ':') ADVANCE(14);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == '{') ADVANCE(140);
      if (lookahead == '}') ADVANCE(141);
      if (lookahead == '~') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(45)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(49);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(146);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(34);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(47);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(35);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(13);
      if (lookahead == '_') ADVANCE(18);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(32);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(47);
      if (lookahead == '_') ADVANCE(18);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(32);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(49);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(50);
      if (lookahead == '_') ADVANCE(21);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(53);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(33);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(50);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(53);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(38);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(50);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(53);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(33);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(54);
      if (lookahead == '_') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(55);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(56);
      if (lookahead == '_') ADVANCE(34);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(57);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(19);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(20);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(33);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(22);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(38);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(33);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_character_literal);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_string_literal);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(98);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(98);
      if (lookahead == '=') ADVANCE(81);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(95);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(95);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(116);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(130);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == '=') ADVANCE(77);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(131);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(79);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(10);
      if (lookahead == '/') ADVANCE(148);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(10);
      if (lookahead == '/') ADVANCE(148);
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '|') ADVANCE(99);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(99);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(138);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(12);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == 'i') ADVANCE(29);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_ATinterface);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 170 ||
          lookahead == 181 ||
          lookahead == 186 ||
          (192 <= lookahead && lookahead <= 214) ||
          (216 <= lookahead && lookahead <= 246) ||
          (248 <= lookahead && lookahead <= 705) ||
          (710 <= lookahead && lookahead <= 721) ||
          (736 <= lookahead && lookahead <= 740) ||
          lookahead == 748 ||
          lookahead == 750 ||
          (880 <= lookahead && lookahead <= 884) ||
          lookahead == 886 ||
          lookahead == 887 ||
          (890 <= lookahead && lookahead <= 893) ||
          lookahead == 895 ||
          lookahead == 902 ||
          (904 <= lookahead && lookahead <= 906) ||
          lookahead == 908 ||
          (910 <= lookahead && lookahead <= 929) ||
          (931 <= lookahead && lookahead <= 1013) ||
          (1015 <= lookahead && lookahead <= 1153) ||
          (1162 <= lookahead && lookahead <= 1327) ||
          (1329 <= lookahead && lookahead <= 1366) ||
          lookahead == 1369 ||
          (1376 <= lookahead && lookahead <= 1416) ||
          (1488 <= lookahead && lookahead <= 1514) ||
          (1519 <= lookahead && lookahead <= 1522) ||
          (1568 <= lookahead && lookahead <= 1610) ||
          (1632 <= lookahead && lookahead <= 1641) ||
          lookahead == 1646 ||
          lookahead == 1647 ||
          (1649 <= lookahead && lookahead <= 1747) ||
          lookahead == 1749 ||
          lookahead == 1765 ||
          lookahead == 1766 ||
          (1774 <= lookahead && lookahead <= 1788) ||
          lookahead == 1791 ||
          lookahead == 1808 ||
          (1810 <= lookahead && lookahead <= 1839) ||
          (1869 <= lookahead && lookahead <= 1957) ||
          lookahead == 1969 ||
          (1984 <= lookahead && lookahead <= 2026) ||
          lookahead == 2036 ||
          lookahead == 2037 ||
          lookahead == 2042 ||
          (2048 <= lookahead && lookahead <= 2069) ||
          lookahead == 2074 ||
          lookahead == 2084 ||
          lookahead == 2088 ||
          (2112 <= lookahead && lookahead <= 2136) ||
          (2144 <= lookahead && lookahead <= 2154) ||
          (2208 <= lookahead && lookahead <= 2228) ||
          (2230 <= lookahead && lookahead <= 2247) ||
          (2308 <= lookahead && lookahead <= 2361) ||
          lookahead == 2365 ||
          lookahead == 2384 ||
          (2392 <= lookahead && lookahead <= 2401) ||
          (2406 <= lookahead && lookahead <= 2415) ||
          (2417 <= lookahead && lookahead <= 2432) ||
          (2437 <= lookahead && lookahead <= 2444) ||
          lookahead == 2447 ||
          lookahead == 2448 ||
          (2451 <= lookahead && lookahead <= 2472) ||
          (2474 <= lookahead && lookahead <= 2480) ||
          lookahead == 2482 ||
          (2486 <= lookahead && lookahead <= 2489) ||
          lookahead == 2493 ||
          lookahead == 2510 ||
          lookahead == 2524 ||
          lookahead == 2525 ||
          (2527 <= lookahead && lookahead <= 2529) ||
          (2534 <= lookahead && lookahead <= 2545) ||
          lookahead == 2556 ||
          (2565 <= lookahead && lookahead <= 2570) ||
          lookahead == 2575 ||
          lookahead == 2576 ||
          (2579 <= lookahead && lookahead <= 2600) ||
          (2602 <= lookahead && lookahead <= 2608) ||
          lookahead == 2610 ||
          lookahead == 2611 ||
          lookahead == 2613 ||
          lookahead == 2614 ||
          lookahead == 2616 ||
          lookahead == 2617 ||
          (2649 <= lookahead && lookahead <= 2652) ||
          lookahead == 2654 ||
          (2662 <= lookahead && lookahead <= 2671) ||
          (2674 <= lookahead && lookahead <= 2676) ||
          (2693 <= lookahead && lookahead <= 2701) ||
          (2703 <= lookahead && lookahead <= 2705) ||
          (2707 <= lookahead && lookahead <= 2728) ||
          (2730 <= lookahead && lookahead <= 2736) ||
          lookahead == 2738 ||
          lookahead == 2739 ||
          (2741 <= lookahead && lookahead <= 2745) ||
          lookahead == 2749 ||
          lookahead == 2768 ||
          lookahead == 2784 ||
          lookahead == 2785 ||
          (2790 <= lookahead && lookahead <= 2799) ||
          lookahead == 2809 ||
          (2821 <= lookahead && lookahead <= 2828) ||
          lookahead == 2831 ||
          lookahead == 2832 ||
          (2835 <= lookahead && lookahead <= 2856) ||
          (2858 <= lookahead && lookahead <= 2864) ||
          lookahead == 2866 ||
          lookahead == 2867 ||
          (2869 <= lookahead && lookahead <= 2873) ||
          lookahead == 2877 ||
          lookahead == 2908 ||
          lookahead == 2909 ||
          (2911 <= lookahead && lookahead <= 2913) ||
          (2918 <= lookahead && lookahead <= 2927) ||
          lookahead == 2929 ||
          lookahead == 2947 ||
          (2949 <= lookahead && lookahead <= 2954) ||
          (2958 <= lookahead && lookahead <= 2960) ||
          (2962 <= lookahead && lookahead <= 2965) ||
          lookahead == 2969 ||
          lookahead == 2970 ||
          lookahead == 2972 ||
          lookahead == 2974 ||
          lookahead == 2975 ||
          lookahead == 2979 ||
          lookahead == 2980 ||
          (2984 <= lookahead && lookahead <= 2986) ||
          (2990 <= lookahead && lookahead <= 3001) ||
          lookahead == 3024 ||
          (3046 <= lookahead && lookahead <= 3055) ||
          (3077 <= lookahead && lookahead <= 3084) ||
          (3086 <= lookahead && lookahead <= 3088) ||
          (3090 <= lookahead && lookahead <= 3112) ||
          (3114 <= lookahead && lookahead <= 3129) ||
          lookahead == 3133 ||
          (3160 <= lookahead && lookahead <= 3162) ||
          lookahead == 3168 ||
          lookahead == 3169 ||
          (3174 <= lookahead && lookahead <= 3183) ||
          lookahead == 3200 ||
          (3205 <= lookahead && lookahead <= 3212) ||
          (3214 <= lookahead && lookahead <= 3216) ||
          (3218 <= lookahead && lookahead <= 3240) ||
          (3242 <= lookahead && lookahead <= 3251) ||
          (3253 <= lookahead && lookahead <= 3257) ||
          lookahead == 3261 ||
          lookahead == 3294 ||
          lookahead == 3296 ||
          lookahead == 3297 ||
          (3302 <= lookahead && lookahead <= 3311) ||
          lookahead == 3313 ||
          lookahead == 3314 ||
          (3332 <= lookahead && lookahead <= 3340) ||
          (3342 <= lookahead && lookahead <= 3344) ||
          (3346 <= lookahead && lookahead <= 3386) ||
          lookahead == 3389 ||
          lookahead == 3406 ||
          (3412 <= lookahead && lookahead <= 3414) ||
          (3423 <= lookahead && lookahead <= 3425) ||
          (3430 <= lookahead && lookahead <= 3439) ||
          (3450 <= lookahead && lookahead <= 3455) ||
          (3461 <= lookahead && lookahead <= 3478) ||
          (3482 <= lookahead && lookahead <= 3505) ||
          (3507 <= lookahead && lookahead <= 3515) ||
          lookahead == 3517 ||
          (3520 <= lookahead && lookahead <= 3526) ||
          (3558 <= lookahead && lookahead <= 3567) ||
          (3585 <= lookahead && lookahead <= 3632) ||
          lookahead == 3634 ||
          lookahead == 3635 ||
          (3648 <= lookahead && lookahead <= 3654) ||
          (3664 <= lookahead && lookahead <= 3673) ||
          lookahead == 3713 ||
          lookahead == 3714 ||
          lookahead == 3716 ||
          (3718 <= lookahead && lookahead <= 3722) ||
          (3724 <= lookahead && lookahead <= 3747) ||
          lookahead == 3749 ||
          (3751 <= lookahead && lookahead <= 3760) ||
          lookahead == 3762 ||
          lookahead == 3763 ||
          lookahead == 3773 ||
          (3776 <= lookahead && lookahead <= 3780) ||
          lookahead == 3782 ||
          (3792 <= lookahead && lookahead <= 3801) ||
          (3804 <= lookahead && lookahead <= 3807) ||
          lookahead == 3840 ||
          (3872 <= lookahead && lookahead <= 3881) ||
          (3904 <= lookahead && lookahead <= 3911) ||
          (3913 <= lookahead && lookahead <= 3948) ||
          (3976 <= lookahead && lookahead <= 3980) ||
          (4096 <= lookahead && lookahead <= 4138) ||
          (4159 <= lookahead && lookahead <= 4169) ||
          (4176 <= lookahead && lookahead <= 4181) ||
          (4186 <= lookahead && lookahead <= 4189) ||
          lookahead == 4193 ||
          lookahead == 4197 ||
          lookahead == 4198 ||
          (4206 <= lookahead && lookahead <= 4208) ||
          (4213 <= lookahead && lookahead <= 4225) ||
          lookahead == 4238 ||
          (4240 <= lookahead && lookahead <= 4249) ||
          (4256 <= lookahead && lookahead <= 4293) ||
          lookahead == 4295 ||
          lookahead == 4301 ||
          (4304 <= lookahead && lookahead <= 4346) ||
          (4348 <= lookahead && lookahead <= 4680) ||
          (4682 <= lookahead && lookahead <= 4685) ||
          (4688 <= lookahead && lookahead <= 4694) ||
          lookahead == 4696 ||
          (4698 <= lookahead && lookahead <= 4701) ||
          (4704 <= lookahead && lookahead <= 4744) ||
          (4746 <= lookahead && lookahead <= 4749) ||
          (4752 <= lookahead && lookahead <= 4784) ||
          (4786 <= lookahead && lookahead <= 4789) ||
          (4792 <= lookahead && lookahead <= 4798) ||
          lookahead == 4800 ||
          (4802 <= lookahead && lookahead <= 4805) ||
          (4808 <= lookahead && lookahead <= 4822) ||
          (4824 <= lookahead && lookahead <= 4880) ||
          (4882 <= lookahead && lookahead <= 4885) ||
          (4888 <= lookahead && lookahead <= 4954) ||
          (4992 <= lookahead && lookahead <= 5007) ||
          (5024 <= lookahead && lookahead <= 5109) ||
          (5112 <= lookahead && lookahead <= 5117) ||
          (5121 <= lookahead && lookahead <= 5740) ||
          (5743 <= lookahead && lookahead <= 5759) ||
          (5761 <= lookahead && lookahead <= 5786) ||
          (5792 <= lookahead && lookahead <= 5866) ||
          (5873 <= lookahead && lookahead <= 5880) ||
          (5888 <= lookahead && lookahead <= 5900) ||
          (5902 <= lookahead && lookahead <= 5905) ||
          (5920 <= lookahead && lookahead <= 5937) ||
          (5952 <= lookahead && lookahead <= 5969) ||
          (5984 <= lookahead && lookahead <= 5996) ||
          (5998 <= lookahead && lookahead <= 6000) ||
          (6016 <= lookahead && lookahead <= 6067) ||
          lookahead == 6103 ||
          lookahead == 6108 ||
          (6112 <= lookahead && lookahead <= 6121) ||
          (6160 <= lookahead && lookahead <= 6169) ||
          (6176 <= lookahead && lookahead <= 6264) ||
          (6272 <= lookahead && lookahead <= 6276) ||
          (6279 <= lookahead && lookahead <= 6312) ||
          lookahead == 6314 ||
          (6320 <= lookahead && lookahead <= 6389) ||
          (6400 <= lookahead && lookahead <= 6430) ||
          (6470 <= lookahead && lookahead <= 6509) ||
          (6512 <= lookahead && lookahead <= 6516) ||
          (6528 <= lookahead && lookahead <= 6571) ||
          (6576 <= lookahead && lookahead <= 6601) ||
          (6608 <= lookahead && lookahead <= 6617) ||
          (6656 <= lookahead && lookahead <= 6678) ||
          (6688 <= lookahead && lookahead <= 6740) ||
          (6784 <= lookahead && lookahead <= 6793) ||
          (6800 <= lookahead && lookahead <= 6809) ||
          lookahead == 6823 ||
          (6917 <= lookahead && lookahead <= 6963) ||
          (6981 <= lookahead && lookahead <= 6987) ||
          (6992 <= lookahead && lookahead <= 7001) ||
          (7043 <= lookahead && lookahead <= 7072) ||
          (7086 <= lookahead && lookahead <= 7141) ||
          (7168 <= lookahead && lookahead <= 7203) ||
          (7232 <= lookahead && lookahead <= 7241) ||
          (7245 <= lookahead && lookahead <= 7293) ||
          (7296 <= lookahead && lookahead <= 7304) ||
          (7312 <= lookahead && lookahead <= 7354) ||
          (7357 <= lookahead && lookahead <= 7359) ||
          (7401 <= lookahead && lookahead <= 7404) ||
          (7406 <= lookahead && lookahead <= 7411) ||
          lookahead == 7413 ||
          lookahead == 7414 ||
          lookahead == 7418 ||
          (7424 <= lookahead && lookahead <= 7615) ||
          (7680 <= lookahead && lookahead <= 7957) ||
          (7960 <= lookahead && lookahead <= 7965) ||
          (7968 <= lookahead && lookahead <= 8005) ||
          (8008 <= lookahead && lookahead <= 8013) ||
          (8016 <= lookahead && lookahead <= 8023) ||
          lookahead == 8025 ||
          lookahead == 8027 ||
          lookahead == 8029 ||
          (8031 <= lookahead && lookahead <= 8061) ||
          (8064 <= lookahead && lookahead <= 8116) ||
          (8118 <= lookahead && lookahead <= 8124) ||
          lookahead == 8126 ||
          (8130 <= lookahead && lookahead <= 8132) ||
          (8134 <= lookahead && lookahead <= 8140) ||
          (8144 <= lookahead && lookahead <= 8147) ||
          (8150 <= lookahead && lookahead <= 8155) ||
          (8160 <= lookahead && lookahead <= 8172) ||
          (8178 <= lookahead && lookahead <= 8180) ||
          (8182 <= lookahead && lookahead <= 8188) ||
          lookahead == 8305 ||
          lookahead == 8319 ||
          (8336 <= lookahead && lookahead <= 8348) ||
          lookahead == 8450 ||
          lookahead == 8455 ||
          (8458 <= lookahead && lookahead <= 8467) ||
          lookahead == 8469 ||
          (8473 <= lookahead && lookahead <= 8477) ||
          lookahead == 8484 ||
          lookahead == 8486 ||
          lookahead == 8488 ||
          (8490 <= lookahead && lookahead <= 8493) ||
          (8495 <= lookahead && lookahead <= 8505) ||
          (8508 <= lookahead && lookahead <= 8511) ||
          (8517 <= lookahead && lookahead <= 8521) ||
          lookahead == 8526 ||
          lookahead == 8579 ||
          lookahead == 8580 ||
          (11264 <= lookahead && lookahead <= 11310) ||
          (11312 <= lookahead && lookahead <= 11358) ||
          (11360 <= lookahead && lookahead <= 11492) ||
          (11499 <= lookahead && lookahead <= 11502) ||
          lookahead == 11506 ||
          lookahead == 11507 ||
          (11520 <= lookahead && lookahead <= 11557) ||
          lookahead == 11559 ||
          lookahead == 11565 ||
          (11568 <= lookahead && lookahead <= 11623) ||
          lookahead == 11631 ||
          (11648 <= lookahead && lookahead <= 11670) ||
          (11680 <= lookahead && lookahead <= 11686) ||
          (11688 <= lookahead && lookahead <= 11694) ||
          (11696 <= lookahead && lookahead <= 11702) ||
          (11704 <= lookahead && lookahead <= 11710) ||
          (11712 <= lookahead && lookahead <= 11718) ||
          (11720 <= lookahead && lookahead <= 11726) ||
          (11728 <= lookahead && lookahead <= 11734) ||
          (11736 <= lookahead && lookahead <= 11742) ||
          lookahead == 11823 ||
          lookahead == 12293 ||
          lookahead == 12294 ||
          (12337 <= lookahead && lookahead <= 12341) ||
          lookahead == 12347 ||
          lookahead == 12348 ||
          (12353 <= lookahead && lookahead <= 12438) ||
          (12445 <= lookahead && lookahead <= 12447) ||
          (12449 <= lookahead && lookahead <= 12538) ||
          (12540 <= lookahead && lookahead <= 12543) ||
          (12549 <= lookahead && lookahead <= 12591) ||
          (12593 <= lookahead && lookahead <= 12686) ||
          (12704 <= lookahead && lookahead <= 12735) ||
          (12784 <= lookahead && lookahead <= 12799) ||
          lookahead == 13312 ||
          lookahead == 19903 ||
          lookahead == 19968 ||
          lookahead == 40956 ||
          (40960 <= lookahead && lookahead <= 42124) ||
          (42192 <= lookahead && lookahead <= 42237) ||
          (42240 <= lookahead && lookahead <= 42508) ||
          (42512 <= lookahead && lookahead <= 42539) ||
          (42560 <= lookahead && lookahead <= 42606) ||
          (42623 <= lookahead && lookahead <= 42653) ||
          (42656 <= lookahead && lookahead <= 42725) ||
          (42775 <= lookahead && lookahead <= 42783) ||
          (42786 <= lookahead && lookahead <= 42888) ||
          (42891 <= lookahead && lookahead <= 42943) ||
          (42946 <= lookahead && lookahead <= 42954) ||
          (42997 <= lookahead && lookahead <= 43009) ||
          (43011 <= lookahead && lookahead <= 43013) ||
          (43015 <= lookahead && lookahead <= 43018) ||
          (43020 <= lookahead && lookahead <= 43042) ||
          (43072 <= lookahead && lookahead <= 43123) ||
          (43138 <= lookahead && lookahead <= 43187) ||
          (43216 <= lookahead && lookahead <= 43225) ||
          (43250 <= lookahead && lookahead <= 43255) ||
          lookahead == 43259 ||
          lookahead == 43261 ||
          lookahead == 43262 ||
          (43264 <= lookahead && lookahead <= 43301) ||
          (43312 <= lookahead && lookahead <= 43334) ||
          (43360 <= lookahead && lookahead <= 43388) ||
          (43396 <= lookahead && lookahead <= 43442) ||
          (43471 <= lookahead && lookahead <= 43481) ||
          (43488 <= lookahead && lookahead <= 43492) ||
          (43494 <= lookahead && lookahead <= 43518) ||
          (43520 <= lookahead && lookahead <= 43560) ||
          (43584 <= lookahead && lookahead <= 43586) ||
          (43588 <= lookahead && lookahead <= 43595) ||
          (43600 <= lookahead && lookahead <= 43609) ||
          (43616 <= lookahead && lookahead <= 43638) ||
          lookahead == 43642 ||
          (43646 <= lookahead && lookahead <= 43695) ||
          lookahead == 43697 ||
          lookahead == 43701 ||
          lookahead == 43702 ||
          (43705 <= lookahead && lookahead <= 43709) ||
          lookahead == 43712 ||
          lookahead == 43714 ||
          (43739 <= lookahead && lookahead <= 43741) ||
          (43744 <= lookahead && lookahead <= 43754) ||
          (43762 <= lookahead && lookahead <= 43764) ||
          (43777 <= lookahead && lookahead <= 43782) ||
          (43785 <= lookahead && lookahead <= 43790) ||
          (43793 <= lookahead && lookahead <= 43798) ||
          (43808 <= lookahead && lookahead <= 43814) ||
          (43816 <= lookahead && lookahead <= 43822) ||
          (43824 <= lookahead && lookahead <= 43866) ||
          (43868 <= lookahead && lookahead <= 43881) ||
          (43888 <= lookahead && lookahead <= 44002) ||
          (44016 <= lookahead && lookahead <= 44025) ||
          lookahead == 44032 ||
          lookahead == 55203 ||
          (55216 <= lookahead && lookahead <= 55238) ||
          (55243 <= lookahead && lookahead <= 55291) ||
          (63744 <= lookahead && lookahead <= 64109) ||
          (64112 <= lookahead && lookahead <= 64217) ||
          (64256 <= lookahead && lookahead <= 64262) ||
          (64275 <= lookahead && lookahead <= 64279) ||
          lookahead == 64285 ||
          (64287 <= lookahead && lookahead <= 64296) ||
          (64298 <= lookahead && lookahead <= 64310) ||
          (64312 <= lookahead && lookahead <= 64316) ||
          lookahead == 64318 ||
          lookahead == 64320 ||
          lookahead == 64321 ||
          lookahead == 64323 ||
          lookahead == 64324 ||
          (64326 <= lookahead && lookahead <= 64433) ||
          (64467 <= lookahead && lookahead <= 64829) ||
          (64848 <= lookahead && lookahead <= 64911) ||
          (64914 <= lookahead && lookahead <= 64967) ||
          (65008 <= lookahead && lookahead <= 65019) ||
          (65136 <= lookahead && lookahead <= 65140) ||
          (65142 <= lookahead && lookahead <= 65276) ||
          (65296 <= lookahead && lookahead <= 65305) ||
          (65313 <= lookahead && lookahead <= 65338) ||
          (65345 <= lookahead && lookahead <= 65370) ||
          (65382 <= lookahead && lookahead <= 65470) ||
          (65474 <= lookahead && lookahead <= 65479) ||
          (65482 <= lookahead && lookahead <= 65487) ||
          (65490 <= lookahead && lookahead <= 65495) ||
          (65498 <= lookahead && lookahead <= 65500) ||
          (65536 <= lookahead && lookahead <= 65547) ||
          (65549 <= lookahead && lookahead <= 65574) ||
          (65576 <= lookahead && lookahead <= 65594) ||
          lookahead == 65596 ||
          lookahead == 65597 ||
          (65599 <= lookahead && lookahead <= 65613) ||
          (65616 <= lookahead && lookahead <= 65629) ||
          (65664 <= lookahead && lookahead <= 65786) ||
          (66176 <= lookahead && lookahead <= 66204) ||
          (66208 <= lookahead && lookahead <= 66256) ||
          (66304 <= lookahead && lookahead <= 66335) ||
          (66349 <= lookahead && lookahead <= 66368) ||
          (66370 <= lookahead && lookahead <= 66377) ||
          (66384 <= lookahead && lookahead <= 66421) ||
          (66432 <= lookahead && lookahead <= 66461) ||
          (66464 <= lookahead && lookahead <= 66499) ||
          (66504 <= lookahead && lookahead <= 66511) ||
          (66560 <= lookahead && lookahead <= 66717) ||
          (66720 <= lookahead && lookahead <= 66729) ||
          (66736 <= lookahead && lookahead <= 66771) ||
          (66776 <= lookahead && lookahead <= 66811) ||
          (66816 <= lookahead && lookahead <= 66855) ||
          (66864 <= lookahead && lookahead <= 66915) ||
          (67072 <= lookahead && lookahead <= 67382) ||
          (67392 <= lookahead && lookahead <= 67413) ||
          (67424 <= lookahead && lookahead <= 67431) ||
          (67584 <= lookahead && lookahead <= 67589) ||
          lookahead == 67592 ||
          (67594 <= lookahead && lookahead <= 67637) ||
          lookahead == 67639 ||
          lookahead == 67640 ||
          lookahead == 67644 ||
          (67647 <= lookahead && lookahead <= 67669) ||
          (67680 <= lookahead && lookahead <= 67702) ||
          (67712 <= lookahead && lookahead <= 67742) ||
          (67808 <= lookahead && lookahead <= 67826) ||
          lookahead == 67828 ||
          lookahead == 67829 ||
          (67840 <= lookahead && lookahead <= 67861) ||
          (67872 <= lookahead && lookahead <= 67897) ||
          (67968 <= lookahead && lookahead <= 68023) ||
          lookahead == 68030 ||
          lookahead == 68031 ||
          lookahead == 68096 ||
          (68112 <= lookahead && lookahead <= 68115) ||
          (68117 <= lookahead && lookahead <= 68119) ||
          (68121 <= lookahead && lookahead <= 68149) ||
          (68192 <= lookahead && lookahead <= 68220) ||
          (68224 <= lookahead && lookahead <= 68252) ||
          (68288 <= lookahead && lookahead <= 68295) ||
          (68297 <= lookahead && lookahead <= 68309)) ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(148);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'p') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == 'w') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(19);
      if (lookahead == 's') ADVANCE(20);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(21);
      if (lookahead == 'r') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'h') ADVANCE(25);
      if (lookahead == 'l') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      if (lookahead == 'x') ADVANCE(32);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(37);
      if (lookahead == 'm') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(42);
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 11:
      if (lookahead == 'p') ADVANCE(45);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(49);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(50);
      if (lookahead == 't') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      if (lookahead == 'w') ADVANCE(53);
      if (lookahead == 'y') ADVANCE(54);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'r') ADVANCE(57);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(58);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(60);
      if (lookahead == 'i') ADVANCE(61);
      END_STATE();
    case 19:
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 20:
      if (lookahead == 's') ADVANCE(63);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(64);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 23:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(69);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(70);
      END_STATE();
    case 27:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(72);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(73);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(75);
      END_STATE();
    case 32:
      if (lookahead == 'p') ADVANCE(76);
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(78);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 35:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(81);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 38:
      if (lookahead == 'p') ADVANCE(82);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(83);
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(86);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 43:
      if (lookahead == 'w') ADVANCE(88);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 46:
      if (lookahead == 'c') ADVANCE(91);
      END_STATE();
    case 47:
      if (lookahead == 'i') ADVANCE(92);
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 48:
      if (lookahead == 'b') ADVANCE(94);
      END_STATE();
    case 49:
      if (lookahead == 'q') ADVANCE(95);
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 50:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 51:
      if (lookahead == 'a') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(99);
      END_STATE();
    case 52:
      if (lookahead == 'p') ADVANCE(100);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(101);
      END_STATE();
    case 54:
      if (lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 55:
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(106);
      if (lookahead == 'y') ADVANCE(107);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(109);
      if (lookahead == 'l') ADVANCE(110);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(111);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 64:
      if (lookahead == 'l') ADVANCE(115);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(116);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 68:
      if (lookahead == 'c') ADVANCE(119);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(123);
      END_STATE();
    case 73:
      if (lookahead == 'b') ADVANCE(124);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 75:
      if (lookahead == 'm') ADVANCE(126);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 79:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(132);
      if (lookahead == 'o') ADVANCE(133);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 85:
      if (lookahead == 'g') ADVANCE(136);
      END_STATE();
    case 86:
      if (lookahead == 'u') ADVANCE(137);
      END_STATE();
    case 87:
      if (lookahead == 'i') ADVANCE(138);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 90:
      if (lookahead == 'n') ADVANCE(140);
      END_STATE();
    case 91:
      if (lookahead == 'k') ADVANCE(141);
      END_STATE();
    case 92:
      if (lookahead == 'v') ADVANCE(142);
      END_STATE();
    case 93:
      if (lookahead == 't') ADVANCE(143);
      if (lookahead == 'v') ADVANCE(144);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 95:
      if (lookahead == 'u') ADVANCE(146);
      END_STATE();
    case 96:
      if (lookahead == 'u') ADVANCE(147);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(150);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 101:
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 102:
      if (lookahead == 'c') ADVANCE(153);
      END_STATE();
    case 103:
      if (lookahead == 's') ADVANCE(154);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 105:
      if (lookahead == 'n') ADVANCE(156);
      END_STATE();
    case 106:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 108:
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 109:
      if (lookahead == 'd') ADVANCE(159);
      END_STATE();
    case 110:
      if (lookahead == 'a') ADVANCE(160);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 112:
      if (lookahead == 'h') ADVANCE(162);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(163);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 116:
      if (lookahead == 'k') ADVANCE(166);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 119:
      if (lookahead == 'h') ADVANCE(167);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 121:
      if (lookahead == 's') ADVANCE(168);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 123:
      if (lookahead == 'u') ADVANCE(170);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(171);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 127:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(173);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(175);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(178);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(179);
      END_STATE();
    case 135:
      if (lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 137:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 138:
      if (lookahead == 'v') ADVANCE(182);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_open);
      if (lookahead == 's') ADVANCE(183);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(184);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(185);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(187);
      END_STATE();
    case 145:
      if (lookahead == 'i') ADVANCE(188);
      END_STATE();
    case 146:
      if (lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 149:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 150:
      if (lookahead == 'c') ADVANCE(193);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(194);
      END_STATE();
    case 152:
      if (lookahead == 'c') ADVANCE(195);
      END_STATE();
    case 153:
      if (lookahead == 'h') ADVANCE(196);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 155:
      if (lookahead == 'w') ADVANCE(197);
      END_STATE();
    case 156:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_uses);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_void_type);
      END_STATE();
    case 160:
      if (lookahead == 't') ADVANCE(199);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(200);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 164:
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 165:
      if (lookahead == 'a') ADVANCE(203);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(204);
      END_STATE();
    case 170:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(206);
      END_STATE();
    case 172:
      if (lookahead == 't') ADVANCE(207);
      END_STATE();
    case 173:
      if (lookahead == 'd') ADVANCE(208);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(209);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 177:
      if (lookahead == 'm') ADVANCE(210);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(212);
      END_STATE();
    case 180:
      if (lookahead == 'f') ADVANCE(213);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_opens);
      END_STATE();
    case 184:
      if (lookahead == 'g') ADVANCE(216);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 186:
      if (lookahead == 'c') ADVANCE(218);
      END_STATE();
    case 187:
      if (lookahead == 'd') ADVANCE(219);
      END_STATE();
    case 188:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 189:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 190:
      if (lookahead == 'n') ADVANCE(222);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 192:
      if (lookahead == 'c') ADVANCE(223);
      END_STATE();
    case 193:
      if (lookahead == 't') ADVANCE(224);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 195:
      if (lookahead == 'h') ADVANCE(225);
      END_STATE();
    case 196:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_throw);
      if (lookahead == 's') ADVANCE(227);
      END_STATE();
    case 198:
      if (lookahead == 'i') ADVANCE(228);
      END_STATE();
    case 199:
      if (lookahead == 'i') ADVANCE(229);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 201:
      if (lookahead == 'c') ADVANCE(230);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 203:
      if (lookahead == 'n') ADVANCE(231);
      END_STATE();
    case 204:
      if (lookahead == 'u') ADVANCE(232);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 207:
      if (lookahead == 's') ADVANCE(234);
      END_STATE();
    case 208:
      if (lookahead == 's') ADVANCE(235);
      END_STATE();
    case 209:
      if (lookahead == 'y') ADVANCE(236);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(238);
      END_STATE();
    case 213:
      if (lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 216:
      if (lookahead == 'e') ADVANCE(240);
      END_STATE();
    case 217:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 218:
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 219:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 221:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(245);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 226:
      if (lookahead == 'o') ADVANCE(246);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_throws);
      END_STATE();
    case 228:
      if (lookahead == 'e') ADVANCE(247);
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(249);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_boolean_type);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_exports);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 237:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 239:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 242:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 243:
      if (lookahead == 's') ADVANCE(256);
      END_STATE();
    case 244:
      if (lookahead == 's') ADVANCE(257);
      END_STATE();
    case 245:
      if (lookahead == 'p') ADVANCE(258);
      END_STATE();
    case 246:
      if (lookahead == 'n') ADVANCE(259);
      END_STATE();
    case 247:
      if (lookahead == 'n') ADVANCE(260);
      END_STATE();
    case 248:
      if (lookahead == 'i') ADVANCE(261);
      END_STATE();
    case 249:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(263);
      END_STATE();
    case 253:
      if (lookahead == 'o') ADVANCE(264);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 255:
      if (lookahead == 'd') ADVANCE(266);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_provides);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_strictfp);
      END_STATE();
    case 259:
      if (lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 261:
      if (lookahead == 'v') ADVANCE(269);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 263:
      if (lookahead == 's') ADVANCE(270);
      END_STATE();
    case 264:
      if (lookahead == 'f') ADVANCE(271);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 267:
      if (lookahead == 'z') ADVANCE(272);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_transient);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 272:
      if (lookahead == 'e') ADVANCE(274);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_transitive);
      END_STATE();
    case 274:
      if (lookahead == 'd') ADVANCE(275);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_synchronized);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 45},
  [2] = {.lex_state = 45},
  [3] = {.lex_state = 45},
  [4] = {.lex_state = 45},
  [5] = {.lex_state = 45},
  [6] = {.lex_state = 45},
  [7] = {.lex_state = 45},
  [8] = {.lex_state = 45},
  [9] = {.lex_state = 45},
  [10] = {.lex_state = 45},
  [11] = {.lex_state = 45},
  [12] = {.lex_state = 45},
  [13] = {.lex_state = 45},
  [14] = {.lex_state = 45},
  [15] = {.lex_state = 45},
  [16] = {.lex_state = 45},
  [17] = {.lex_state = 45},
  [18] = {.lex_state = 45},
  [19] = {.lex_state = 45},
  [20] = {.lex_state = 45},
  [21] = {.lex_state = 45},
  [22] = {.lex_state = 45},
  [23] = {.lex_state = 45},
  [24] = {.lex_state = 45},
  [25] = {.lex_state = 45},
  [26] = {.lex_state = 45},
  [27] = {.lex_state = 45},
  [28] = {.lex_state = 45},
  [29] = {.lex_state = 45},
  [30] = {.lex_state = 45},
  [31] = {.lex_state = 45},
  [32] = {.lex_state = 45},
  [33] = {.lex_state = 45},
  [34] = {.lex_state = 45},
  [35] = {.lex_state = 45},
  [36] = {.lex_state = 45},
  [37] = {.lex_state = 45},
  [38] = {.lex_state = 45},
  [39] = {.lex_state = 45},
  [40] = {.lex_state = 45},
  [41] = {.lex_state = 45},
  [42] = {.lex_state = 45},
  [43] = {.lex_state = 45},
  [44] = {.lex_state = 45},
  [45] = {.lex_state = 45},
  [46] = {.lex_state = 43},
  [47] = {.lex_state = 43},
  [48] = {.lex_state = 44},
  [49] = {.lex_state = 44},
  [50] = {.lex_state = 43},
  [51] = {.lex_state = 1},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 45},
  [54] = {.lex_state = 45},
  [55] = {.lex_state = 45},
  [56] = {.lex_state = 1},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 45},
  [60] = {.lex_state = 1},
  [61] = {.lex_state = 1},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 45},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 45},
  [71] = {.lex_state = 45},
  [72] = {.lex_state = 45},
  [73] = {.lex_state = 45},
  [74] = {.lex_state = 45},
  [75] = {.lex_state = 45},
  [76] = {.lex_state = 45},
  [77] = {.lex_state = 45},
  [78] = {.lex_state = 45},
  [79] = {.lex_state = 45},
  [80] = {.lex_state = 45},
  [81] = {.lex_state = 45},
  [82] = {.lex_state = 45},
  [83] = {.lex_state = 1},
  [84] = {.lex_state = 45},
  [85] = {.lex_state = 45},
  [86] = {.lex_state = 45},
  [87] = {.lex_state = 45},
  [88] = {.lex_state = 45},
  [89] = {.lex_state = 45},
  [90] = {.lex_state = 45},
  [91] = {.lex_state = 45},
  [92] = {.lex_state = 45},
  [93] = {.lex_state = 45},
  [94] = {.lex_state = 45},
  [95] = {.lex_state = 45},
  [96] = {.lex_state = 45},
  [97] = {.lex_state = 45},
  [98] = {.lex_state = 45},
  [99] = {.lex_state = 45},
  [100] = {.lex_state = 45},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 45},
  [103] = {.lex_state = 45},
  [104] = {.lex_state = 45},
  [105] = {.lex_state = 45},
  [106] = {.lex_state = 45},
  [107] = {.lex_state = 45},
  [108] = {.lex_state = 45},
  [109] = {.lex_state = 45},
  [110] = {.lex_state = 45},
  [111] = {.lex_state = 45},
  [112] = {.lex_state = 45},
  [113] = {.lex_state = 1},
  [114] = {.lex_state = 45},
  [115] = {.lex_state = 45},
  [116] = {.lex_state = 1},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 45},
  [119] = {.lex_state = 1},
  [120] = {.lex_state = 45},
  [121] = {.lex_state = 45},
  [122] = {.lex_state = 45},
  [123] = {.lex_state = 1},
  [124] = {.lex_state = 45},
  [125] = {.lex_state = 45},
  [126] = {.lex_state = 45},
  [127] = {.lex_state = 45},
  [128] = {.lex_state = 45},
  [129] = {.lex_state = 45},
  [130] = {.lex_state = 45},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 45},
  [133] = {.lex_state = 45},
  [134] = {.lex_state = 45},
  [135] = {.lex_state = 1},
  [136] = {.lex_state = 45},
  [137] = {.lex_state = 1},
  [138] = {.lex_state = 45},
  [139] = {.lex_state = 1},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 1},
  [142] = {.lex_state = 45},
  [143] = {.lex_state = 45},
  [144] = {.lex_state = 45},
  [145] = {.lex_state = 45},
  [146] = {.lex_state = 45},
  [147] = {.lex_state = 45},
  [148] = {.lex_state = 45},
  [149] = {.lex_state = 45},
  [150] = {.lex_state = 45},
  [151] = {.lex_state = 45},
  [152] = {.lex_state = 45},
  [153] = {.lex_state = 45},
  [154] = {.lex_state = 45},
  [155] = {.lex_state = 45},
  [156] = {.lex_state = 45},
  [157] = {.lex_state = 45},
  [158] = {.lex_state = 45},
  [159] = {.lex_state = 45},
  [160] = {.lex_state = 45},
  [161] = {.lex_state = 45},
  [162] = {.lex_state = 45},
  [163] = {.lex_state = 45},
  [164] = {.lex_state = 45},
  [165] = {.lex_state = 45},
  [166] = {.lex_state = 45},
  [167] = {.lex_state = 45},
  [168] = {.lex_state = 45},
  [169] = {.lex_state = 45},
  [170] = {.lex_state = 45},
  [171] = {.lex_state = 1},
  [172] = {.lex_state = 1},
  [173] = {.lex_state = 45},
  [174] = {.lex_state = 45},
  [175] = {.lex_state = 45},
  [176] = {.lex_state = 45},
  [177] = {.lex_state = 1},
  [178] = {.lex_state = 45},
  [179] = {.lex_state = 45},
  [180] = {.lex_state = 1},
  [181] = {.lex_state = 45},
  [182] = {.lex_state = 45},
  [183] = {.lex_state = 45},
  [184] = {.lex_state = 45},
  [185] = {.lex_state = 45},
  [186] = {.lex_state = 45},
  [187] = {.lex_state = 45},
  [188] = {.lex_state = 1},
  [189] = {.lex_state = 45},
  [190] = {.lex_state = 45},
  [191] = {.lex_state = 1},
  [192] = {.lex_state = 1},
  [193] = {.lex_state = 1},
  [194] = {.lex_state = 45},
  [195] = {.lex_state = 45},
  [196] = {.lex_state = 45},
  [197] = {.lex_state = 45},
  [198] = {.lex_state = 45},
  [199] = {.lex_state = 45},
  [200] = {.lex_state = 45},
  [201] = {.lex_state = 45},
  [202] = {.lex_state = 45},
  [203] = {.lex_state = 45},
  [204] = {.lex_state = 45},
  [205] = {.lex_state = 45},
  [206] = {.lex_state = 1},
  [207] = {.lex_state = 1},
  [208] = {.lex_state = 1},
  [209] = {.lex_state = 1},
  [210] = {.lex_state = 1},
  [211] = {.lex_state = 1},
  [212] = {.lex_state = 1},
  [213] = {.lex_state = 1},
  [214] = {.lex_state = 1},
  [215] = {.lex_state = 1},
  [216] = {.lex_state = 1},
  [217] = {.lex_state = 1},
  [218] = {.lex_state = 1},
  [219] = {.lex_state = 1},
  [220] = {.lex_state = 1},
  [221] = {.lex_state = 1},
  [222] = {.lex_state = 1},
  [223] = {.lex_state = 1},
  [224] = {.lex_state = 1},
  [225] = {.lex_state = 1},
  [226] = {.lex_state = 1},
  [227] = {.lex_state = 1},
  [228] = {.lex_state = 1},
  [229] = {.lex_state = 1},
  [230] = {.lex_state = 1},
  [231] = {.lex_state = 1},
  [232] = {.lex_state = 1},
  [233] = {.lex_state = 1},
  [234] = {.lex_state = 1},
  [235] = {.lex_state = 45},
  [236] = {.lex_state = 1},
  [237] = {.lex_state = 1},
  [238] = {.lex_state = 45},
  [239] = {.lex_state = 45},
  [240] = {.lex_state = 45},
  [241] = {.lex_state = 1},
  [242] = {.lex_state = 1},
  [243] = {.lex_state = 45},
  [244] = {.lex_state = 45},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 2},
  [251] = {.lex_state = 2},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 2},
  [256] = {.lex_state = 2},
  [257] = {.lex_state = 2},
  [258] = {.lex_state = 2},
  [259] = {.lex_state = 2},
  [260] = {.lex_state = 2},
  [261] = {.lex_state = 2},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 2},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 2},
  [267] = {.lex_state = 2},
  [268] = {.lex_state = 2},
  [269] = {.lex_state = 2},
  [270] = {.lex_state = 2},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 1},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 7},
  [277] = {.lex_state = 7},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 1},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 3},
  [282] = {.lex_state = 1},
  [283] = {.lex_state = 1},
  [284] = {.lex_state = 1},
  [285] = {.lex_state = 2},
  [286] = {.lex_state = 2},
  [287] = {.lex_state = 1},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 2},
  [290] = {.lex_state = 7},
  [291] = {.lex_state = 3},
  [292] = {.lex_state = 3},
  [293] = {.lex_state = 3},
  [294] = {.lex_state = 7},
  [295] = {.lex_state = 2},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 3},
  [298] = {.lex_state = 3},
  [299] = {.lex_state = 3},
  [300] = {.lex_state = 3},
  [301] = {.lex_state = 3},
  [302] = {.lex_state = 3},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 3},
  [307] = {.lex_state = 3},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 0},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 3},
  [319] = {.lex_state = 3},
  [320] = {.lex_state = 3},
  [321] = {.lex_state = 0},
  [322] = {.lex_state = 3},
  [323] = {.lex_state = 3},
  [324] = {.lex_state = 3},
  [325] = {.lex_state = 3},
  [326] = {.lex_state = 3},
  [327] = {.lex_state = 3},
  [328] = {.lex_state = 3},
  [329] = {.lex_state = 3},
  [330] = {.lex_state = 3},
  [331] = {.lex_state = 3},
  [332] = {.lex_state = 3},
  [333] = {.lex_state = 3},
  [334] = {.lex_state = 3},
  [335] = {.lex_state = 3},
  [336] = {.lex_state = 3},
  [337] = {.lex_state = 3},
  [338] = {.lex_state = 1},
  [339] = {.lex_state = 1},
  [340] = {.lex_state = 3},
  [341] = {.lex_state = 3},
  [342] = {.lex_state = 3},
  [343] = {.lex_state = 1},
  [344] = {.lex_state = 1},
  [345] = {.lex_state = 3},
  [346] = {.lex_state = 3},
  [347] = {.lex_state = 3},
  [348] = {.lex_state = 3},
  [349] = {.lex_state = 3},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 1},
  [352] = {.lex_state = 3},
  [353] = {.lex_state = 0},
  [354] = {.lex_state = 0},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 0},
  [357] = {.lex_state = 0},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 0},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 0},
  [362] = {.lex_state = 0},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 0},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 0},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 3},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 0},
  [382] = {.lex_state = 3},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 3},
  [385] = {.lex_state = 3},
  [386] = {.lex_state = 3},
  [387] = {.lex_state = 5},
  [388] = {.lex_state = 3},
  [389] = {.lex_state = 3},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 3},
  [392] = {.lex_state = 3},
  [393] = {.lex_state = 5},
  [394] = {.lex_state = 3},
  [395] = {.lex_state = 3},
  [396] = {.lex_state = 3},
  [397] = {.lex_state = 3},
  [398] = {.lex_state = 3},
  [399] = {.lex_state = 3},
  [400] = {.lex_state = 3},
  [401] = {.lex_state = 3},
  [402] = {.lex_state = 3},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 1},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 3},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 3},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 1},
  [416] = {.lex_state = 1},
  [417] = {.lex_state = 3},
  [418] = {.lex_state = 5},
  [419] = {.lex_state = 3},
  [420] = {.lex_state = 1},
  [421] = {.lex_state = 3},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 3},
  [424] = {.lex_state = 3},
  [425] = {.lex_state = 3},
  [426] = {.lex_state = 3},
  [427] = {.lex_state = 5},
  [428] = {.lex_state = 3},
  [429] = {.lex_state = 3},
  [430] = {.lex_state = 3},
  [431] = {.lex_state = 3},
  [432] = {.lex_state = 3},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 3},
  [435] = {.lex_state = 1},
  [436] = {.lex_state = 3},
  [437] = {.lex_state = 3},
  [438] = {.lex_state = 3},
  [439] = {.lex_state = 3},
  [440] = {.lex_state = 3},
  [441] = {.lex_state = 3},
  [442] = {.lex_state = 3},
  [443] = {.lex_state = 1},
  [444] = {.lex_state = 3},
  [445] = {.lex_state = 3},
  [446] = {.lex_state = 3},
  [447] = {.lex_state = 1},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 1},
  [450] = {.lex_state = 3},
  [451] = {.lex_state = 1},
  [452] = {.lex_state = 1},
  [453] = {.lex_state = 3},
  [454] = {.lex_state = 1},
  [455] = {.lex_state = 3},
  [456] = {.lex_state = 3},
  [457] = {.lex_state = 1},
  [458] = {.lex_state = 3},
  [459] = {.lex_state = 3},
  [460] = {.lex_state = 3},
  [461] = {.lex_state = 3},
  [462] = {.lex_state = 3},
  [463] = {.lex_state = 3},
  [464] = {.lex_state = 3},
  [465] = {.lex_state = 1},
  [466] = {.lex_state = 1},
  [467] = {.lex_state = 1},
  [468] = {.lex_state = 1},
  [469] = {.lex_state = 1},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 1},
  [472] = {.lex_state = 1},
  [473] = {.lex_state = 1},
  [474] = {.lex_state = 1},
  [475] = {.lex_state = 1},
  [476] = {.lex_state = 1},
  [477] = {.lex_state = 1},
  [478] = {.lex_state = 1},
  [479] = {.lex_state = 1},
  [480] = {.lex_state = 1},
  [481] = {.lex_state = 5},
  [482] = {.lex_state = 5},
  [483] = {.lex_state = 1},
  [484] = {.lex_state = 1},
  [485] = {.lex_state = 1},
  [486] = {.lex_state = 1},
  [487] = {.lex_state = 1},
  [488] = {.lex_state = 1},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 1},
  [491] = {.lex_state = 5},
  [492] = {.lex_state = 5},
  [493] = {.lex_state = 5},
  [494] = {.lex_state = 5},
  [495] = {.lex_state = 5},
  [496] = {.lex_state = 5},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 5},
  [499] = {.lex_state = 5},
  [500] = {.lex_state = 5},
  [501] = {.lex_state = 5},
  [502] = {.lex_state = 2},
  [503] = {.lex_state = 5},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 5},
  [506] = {.lex_state = 5},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 1},
  [509] = {.lex_state = 2},
  [510] = {.lex_state = 0},
  [511] = {.lex_state = 0},
  [512] = {.lex_state = 0},
  [513] = {.lex_state = 2},
  [514] = {.lex_state = 0},
  [515] = {.lex_state = 0},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 2},
  [518] = {.lex_state = 2},
  [519] = {.lex_state = 2},
  [520] = {.lex_state = 1},
  [521] = {.lex_state = 1},
  [522] = {.lex_state = 1},
  [523] = {.lex_state = 1},
  [524] = {.lex_state = 1},
  [525] = {.lex_state = 1},
  [526] = {.lex_state = 2},
  [527] = {.lex_state = 1},
  [528] = {.lex_state = 1},
  [529] = {.lex_state = 1},
  [530] = {.lex_state = 1},
  [531] = {.lex_state = 0},
  [532] = {.lex_state = 2},
  [533] = {.lex_state = 1},
  [534] = {.lex_state = 1},
  [535] = {.lex_state = 1},
  [536] = {.lex_state = 2},
  [537] = {.lex_state = 2},
  [538] = {.lex_state = 1},
  [539] = {.lex_state = 1},
  [540] = {.lex_state = 1},
  [541] = {.lex_state = 2},
  [542] = {.lex_state = 1},
  [543] = {.lex_state = 1},
  [544] = {.lex_state = 1},
  [545] = {.lex_state = 1},
  [546] = {.lex_state = 2},
  [547] = {.lex_state = 1},
  [548] = {.lex_state = 1},
  [549] = {.lex_state = 1},
  [550] = {.lex_state = 1},
  [551] = {.lex_state = 1},
  [552] = {.lex_state = 1},
  [553] = {.lex_state = 1},
  [554] = {.lex_state = 1},
  [555] = {.lex_state = 2},
  [556] = {.lex_state = 2},
  [557] = {.lex_state = 1},
  [558] = {.lex_state = 1},
  [559] = {.lex_state = 1},
  [560] = {.lex_state = 2},
  [561] = {.lex_state = 1},
  [562] = {.lex_state = 1},
  [563] = {.lex_state = 2},
  [564] = {.lex_state = 2},
  [565] = {.lex_state = 2},
  [566] = {.lex_state = 2},
  [567] = {.lex_state = 1},
  [568] = {.lex_state = 2},
  [569] = {.lex_state = 2},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 45},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 1},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 1},
  [588] = {.lex_state = 1},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 1},
  [591] = {.lex_state = 1},
  [592] = {.lex_state = 1},
  [593] = {.lex_state = 1},
  [594] = {.lex_state = 1},
  [595] = {.lex_state = 1},
  [596] = {.lex_state = 1},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 1},
  [605] = {.lex_state = 1},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 1},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 1},
  [614] = {.lex_state = 1},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 1},
  [617] = {.lex_state = 1},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 1},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 1},
  [626] = {.lex_state = 1},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 2},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 2},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 2},
  [641] = {.lex_state = 2},
  [642] = {.lex_state = 45},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 45},
  [645] = {.lex_state = 2},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 2},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 2},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 45},
  [657] = {.lex_state = 2},
  [658] = {.lex_state = 2},
  [659] = {.lex_state = 2},
  [660] = {.lex_state = 2},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 45},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 45},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 45},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 2},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 2},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 2},
  [700] = {.lex_state = 45},
  [701] = {.lex_state = 2},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 45},
  [726] = {.lex_state = 2},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 2},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 2},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 2},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 2},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 45},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 45},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 2},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 45},
  [767] = {.lex_state = 2},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 2},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 45},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 45},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 45},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 2},
  [781] = {.lex_state = 2},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 45},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 2},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 45},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 2},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 45},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 45},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 45},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 2},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 2},
  [826] = {.lex_state = 2},
  [827] = {.lex_state = 45},
  [828] = {.lex_state = 2},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 45},
  [832] = {.lex_state = 2},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 45},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 2},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 0},
  [842] = {.lex_state = 2},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 45},
  [847] = {.lex_state = 0},
  [848] = {.lex_state = 2},
  [849] = {.lex_state = 2},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 0},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 2},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 0},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 2},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 0},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 2},
  [876] = {.lex_state = 2},
  [877] = {.lex_state = 2},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 2},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 2},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 0},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 0},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 0},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 0},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 2},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_decimal_integer_literal] = ACTIONS(1),
    [sym_hex_integer_literal] = ACTIONS(1),
    [sym_octal_integer_literal] = ACTIONS(1),
    [sym_binary_integer_literal] = ACTIONS(1),
    [sym_decimal_floating_point_literal] = ACTIONS(1),
    [sym_hex_floating_point_literal] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_character_literal] = ACTIONS(1),
    [sym_string_literal] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_synchronized] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_exports] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_opens] = ACTIONS(1),
    [anon_sym_uses] = ACTIONS(1),
    [anon_sym_provides] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_transitive] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_strictfp] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_transient] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_ATinterface] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [sym_boolean_type] = ACTIONS(1),
    [sym_void_type] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_throws] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(887),
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(10),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(412),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_type_arguments] = STATE(839),
    [sym_statement] = STATE(7),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_explicit_constructor_invocation] = STATE(8),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(81),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(83),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(85),
    [sym_super] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(5),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_switch_label] = STATE(5),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_switch_block_repeat1] = STATE(5),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(89),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_default] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_switch_label] = STATE(4),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_switch_block_repeat1] = STATE(4),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(95),
    [sym_decimal_integer_literal] = ACTIONS(98),
    [sym_hex_integer_literal] = ACTIONS(98),
    [sym_octal_integer_literal] = ACTIONS(101),
    [sym_binary_integer_literal] = ACTIONS(101),
    [sym_decimal_floating_point_literal] = ACTIONS(101),
    [sym_hex_floating_point_literal] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_character_literal] = ACTIONS(101),
    [sym_string_literal] = ACTIONS(101),
    [sym_null_literal] = ACTIONS(98),
    [anon_sym_LPAREN] = ACTIONS(104),
    [anon_sym_PLUS] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(110),
    [anon_sym_TILDE] = ACTIONS(110),
    [anon_sym_PLUS_PLUS] = ACTIONS(113),
    [anon_sym_DASH_DASH] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(119),
    [anon_sym_SEMI] = ACTIONS(122),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_RBRACE] = ACTIONS(128),
    [anon_sym_assert] = ACTIONS(130),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(136),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(142),
    [anon_sym_while] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(148),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(154),
    [anon_sym_synchronized] = ACTIONS(157),
    [anon_sym_throw] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(166),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(172),
    [anon_sym_open] = ACTIONS(175),
    [anon_sym_module] = ACTIONS(178),
    [anon_sym_static] = ACTIONS(181),
    [anon_sym_package] = ACTIONS(184),
    [anon_sym_import] = ACTIONS(187),
    [anon_sym_enum] = ACTIONS(190),
    [anon_sym_public] = ACTIONS(181),
    [anon_sym_protected] = ACTIONS(181),
    [anon_sym_private] = ACTIONS(181),
    [anon_sym_abstract] = ACTIONS(181),
    [anon_sym_final] = ACTIONS(181),
    [anon_sym_strictfp] = ACTIONS(181),
    [anon_sym_native] = ACTIONS(181),
    [anon_sym_transient] = ACTIONS(181),
    [anon_sym_volatile] = ACTIONS(181),
    [anon_sym_ATinterface] = ACTIONS(193),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_byte] = ACTIONS(199),
    [anon_sym_short] = ACTIONS(199),
    [anon_sym_int] = ACTIONS(199),
    [anon_sym_long] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_float] = ACTIONS(202),
    [anon_sym_double] = ACTIONS(202),
    [sym_boolean_type] = ACTIONS(205),
    [sym_void_type] = ACTIONS(205),
    [sym_this] = ACTIONS(208),
    [sym_super] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_switch_label] = STATE(4),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_switch_block_repeat1] = STATE(4),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(214),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_default] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [ts_builtin_sym_end] = ACTIONS(216),
    [sym_identifier] = ACTIONS(218),
    [sym_decimal_integer_literal] = ACTIONS(221),
    [sym_hex_integer_literal] = ACTIONS(221),
    [sym_octal_integer_literal] = ACTIONS(224),
    [sym_binary_integer_literal] = ACTIONS(224),
    [sym_decimal_floating_point_literal] = ACTIONS(224),
    [sym_hex_floating_point_literal] = ACTIONS(221),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_character_literal] = ACTIONS(224),
    [sym_string_literal] = ACTIONS(224),
    [sym_null_literal] = ACTIONS(221),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_DASH] = ACTIONS(230),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_TILDE] = ACTIONS(233),
    [anon_sym_PLUS_PLUS] = ACTIONS(236),
    [anon_sym_DASH_DASH] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_class] = ACTIONS(242),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(248),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_assert] = ACTIONS(251),
    [anon_sym_switch] = ACTIONS(254),
    [anon_sym_default] = ACTIONS(257),
    [anon_sym_do] = ACTIONS(260),
    [anon_sym_while] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(266),
    [anon_sym_continue] = ACTIONS(269),
    [anon_sym_return] = ACTIONS(272),
    [anon_sym_synchronized] = ACTIONS(275),
    [anon_sym_throw] = ACTIONS(278),
    [anon_sym_try] = ACTIONS(281),
    [anon_sym_if] = ACTIONS(284),
    [anon_sym_for] = ACTIONS(287),
    [anon_sym_AT] = ACTIONS(290),
    [anon_sym_open] = ACTIONS(293),
    [anon_sym_module] = ACTIONS(296),
    [anon_sym_static] = ACTIONS(257),
    [anon_sym_package] = ACTIONS(299),
    [anon_sym_import] = ACTIONS(302),
    [anon_sym_enum] = ACTIONS(305),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_abstract] = ACTIONS(257),
    [anon_sym_final] = ACTIONS(257),
    [anon_sym_strictfp] = ACTIONS(257),
    [anon_sym_native] = ACTIONS(257),
    [anon_sym_transient] = ACTIONS(257),
    [anon_sym_volatile] = ACTIONS(257),
    [anon_sym_ATinterface] = ACTIONS(308),
    [anon_sym_interface] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(314),
    [anon_sym_short] = ACTIONS(314),
    [anon_sym_int] = ACTIONS(314),
    [anon_sym_long] = ACTIONS(314),
    [anon_sym_char] = ACTIONS(314),
    [anon_sym_float] = ACTIONS(317),
    [anon_sym_double] = ACTIONS(317),
    [sym_boolean_type] = ACTIONS(320),
    [sym_void_type] = ACTIONS(320),
    [sym_this] = ACTIONS(323),
    [sym_super] = ACTIONS(326),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(329),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(13),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(329),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [ts_builtin_sym_end] = ACTIONS(333),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(9),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(337),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(339),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(12),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(341),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(205),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(175),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(200),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(185),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(196),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(122),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(114),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(159),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(160),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(161),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(144),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(121),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(152),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(173),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(132),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(162),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(955),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(136),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(165),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(181),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(138),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(199),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(146),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(170),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(174),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(186),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(189),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(118),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(195),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(153),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(462),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_statement] = STATE(120),
    [sym_block] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_assert_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_synchronized_statement] = STATE(124),
    [sym_throw_statement] = STATE(124),
    [sym_try_statement] = STATE(124),
    [sym_try_with_resources_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_enhanced_for_statement] = STATE(124),
    [sym__annotation] = STATE(377),
    [sym_marker_annotation] = STATE(377),
    [sym_annotation] = STATE(377),
    [sym_declaration] = STATE(124),
    [sym_module_declaration] = STATE(203),
    [sym_package_declaration] = STATE(203),
    [sym_import_declaration] = STATE(203),
    [sym_enum_declaration] = STATE(203),
    [sym_class_declaration] = STATE(203),
    [sym_modifiers] = STATE(489),
    [sym_annotation_type_declaration] = STATE(203),
    [sym_interface_declaration] = STATE(203),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(513),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(124),
    [aux_sym_dimensions_expr_repeat1] = STATE(451),
    [aux_sym_modifiers_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_synchronized] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_try] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_open] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_package] = ACTIONS(61),
    [anon_sym_import] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_protected] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(33),
    [anon_sym_strictfp] = ACTIONS(33),
    [anon_sym_native] = ACTIONS(33),
    [anon_sym_transient] = ACTIONS(33),
    [anon_sym_volatile] = ACTIONS(33),
    [anon_sym_ATinterface] = ACTIONS(67),
    [anon_sym_interface] = ACTIONS(69),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(343),
    [sym_identifier] = ACTIONS(345),
    [sym_decimal_integer_literal] = ACTIONS(345),
    [sym_hex_integer_literal] = ACTIONS(345),
    [sym_octal_integer_literal] = ACTIONS(343),
    [sym_binary_integer_literal] = ACTIONS(343),
    [sym_decimal_floating_point_literal] = ACTIONS(343),
    [sym_hex_floating_point_literal] = ACTIONS(345),
    [sym_true] = ACTIONS(345),
    [sym_false] = ACTIONS(345),
    [sym_character_literal] = ACTIONS(343),
    [sym_string_literal] = ACTIONS(343),
    [sym_null_literal] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_AMP] = ACTIONS(345),
    [anon_sym_RPAREN] = ACTIONS(343),
    [anon_sym_GT] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(343),
    [anon_sym_LT_EQ] = ACTIONS(343),
    [anon_sym_BANG_EQ] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(343),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_CARET] = ACTIONS(343),
    [anon_sym_PERCENT] = ACTIONS(343),
    [anon_sym_LT_LT] = ACTIONS(343),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_GT_GT_GT] = ACTIONS(343),
    [anon_sym_instanceof] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [anon_sym_QMARK] = ACTIONS(343),
    [anon_sym_COLON] = ACTIONS(345),
    [anon_sym_BANG] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_PLUS_PLUS] = ACTIONS(343),
    [anon_sym_DASH_DASH] = ACTIONS(343),
    [anon_sym_new] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(343),
    [anon_sym_DOT] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(345),
    [anon_sym_COLON_COLON] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(343),
    [anon_sym_assert] = ACTIONS(345),
    [anon_sym_switch] = ACTIONS(345),
    [anon_sym_case] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_do] = ACTIONS(345),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_continue] = ACTIONS(345),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_synchronized] = ACTIONS(345),
    [anon_sym_throw] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_else] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(345),
    [anon_sym_AT] = ACTIONS(345),
    [anon_sym_open] = ACTIONS(345),
    [anon_sym_module] = ACTIONS(345),
    [anon_sym_static] = ACTIONS(345),
    [anon_sym_package] = ACTIONS(345),
    [anon_sym_import] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_public] = ACTIONS(345),
    [anon_sym_protected] = ACTIONS(345),
    [anon_sym_private] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_final] = ACTIONS(345),
    [anon_sym_strictfp] = ACTIONS(345),
    [anon_sym_native] = ACTIONS(345),
    [anon_sym_transient] = ACTIONS(345),
    [anon_sym_volatile] = ACTIONS(345),
    [anon_sym_ATinterface] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_byte] = ACTIONS(345),
    [anon_sym_short] = ACTIONS(345),
    [anon_sym_int] = ACTIONS(345),
    [anon_sym_long] = ACTIONS(345),
    [anon_sym_char] = ACTIONS(345),
    [anon_sym_float] = ACTIONS(345),
    [anon_sym_double] = ACTIONS(345),
    [sym_boolean_type] = ACTIONS(345),
    [sym_void_type] = ACTIONS(345),
    [sym_this] = ACTIONS(345),
    [sym_super] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(347),
    [sym_identifier] = ACTIONS(349),
    [sym_decimal_integer_literal] = ACTIONS(349),
    [sym_hex_integer_literal] = ACTIONS(349),
    [sym_octal_integer_literal] = ACTIONS(347),
    [sym_binary_integer_literal] = ACTIONS(347),
    [sym_decimal_floating_point_literal] = ACTIONS(347),
    [sym_hex_floating_point_literal] = ACTIONS(349),
    [sym_true] = ACTIONS(349),
    [sym_false] = ACTIONS(349),
    [sym_character_literal] = ACTIONS(347),
    [sym_string_literal] = ACTIONS(347),
    [sym_null_literal] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(347),
    [anon_sym_AMP] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(349),
    [anon_sym_LT] = ACTIONS(349),
    [anon_sym_EQ_EQ] = ACTIONS(347),
    [anon_sym_GT_EQ] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(347),
    [anon_sym_BANG_EQ] = ACTIONS(347),
    [anon_sym_AMP_AMP] = ACTIONS(347),
    [anon_sym_PIPE_PIPE] = ACTIONS(347),
    [anon_sym_PLUS] = ACTIONS(349),
    [anon_sym_DASH] = ACTIONS(349),
    [anon_sym_STAR] = ACTIONS(347),
    [anon_sym_SLASH] = ACTIONS(349),
    [anon_sym_PIPE] = ACTIONS(349),
    [anon_sym_CARET] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_GT_GT_GT] = ACTIONS(347),
    [anon_sym_instanceof] = ACTIONS(349),
    [anon_sym_COMMA] = ACTIONS(347),
    [anon_sym_QMARK] = ACTIONS(347),
    [anon_sym_COLON] = ACTIONS(349),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(347),
    [anon_sym_DASH_DASH] = ACTIONS(347),
    [anon_sym_new] = ACTIONS(349),
    [anon_sym_LBRACK] = ACTIONS(347),
    [anon_sym_RBRACK] = ACTIONS(347),
    [anon_sym_DOT] = ACTIONS(349),
    [anon_sym_class] = ACTIONS(349),
    [anon_sym_COLON_COLON] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_assert] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(349),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_default] = ACTIONS(349),
    [anon_sym_do] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_continue] = ACTIONS(349),
    [anon_sym_return] = ACTIONS(349),
    [anon_sym_synchronized] = ACTIONS(349),
    [anon_sym_throw] = ACTIONS(349),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_else] = ACTIONS(349),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_AT] = ACTIONS(349),
    [anon_sym_open] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_static] = ACTIONS(349),
    [anon_sym_package] = ACTIONS(349),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(349),
    [anon_sym_protected] = ACTIONS(349),
    [anon_sym_private] = ACTIONS(349),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_final] = ACTIONS(349),
    [anon_sym_strictfp] = ACTIONS(349),
    [anon_sym_native] = ACTIONS(349),
    [anon_sym_transient] = ACTIONS(349),
    [anon_sym_volatile] = ACTIONS(349),
    [anon_sym_ATinterface] = ACTIONS(347),
    [anon_sym_interface] = ACTIONS(349),
    [anon_sym_byte] = ACTIONS(349),
    [anon_sym_short] = ACTIONS(349),
    [anon_sym_int] = ACTIONS(349),
    [anon_sym_long] = ACTIONS(349),
    [anon_sym_char] = ACTIONS(349),
    [anon_sym_float] = ACTIONS(349),
    [anon_sym_double] = ACTIONS(349),
    [sym_boolean_type] = ACTIONS(349),
    [sym_void_type] = ACTIONS(349),
    [sym_this] = ACTIONS(349),
    [sym_super] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(351),
    [sym_identifier] = ACTIONS(353),
    [sym_decimal_integer_literal] = ACTIONS(353),
    [sym_hex_integer_literal] = ACTIONS(353),
    [sym_octal_integer_literal] = ACTIONS(351),
    [sym_binary_integer_literal] = ACTIONS(351),
    [sym_decimal_floating_point_literal] = ACTIONS(351),
    [sym_hex_floating_point_literal] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_character_literal] = ACTIONS(351),
    [sym_string_literal] = ACTIONS(351),
    [sym_null_literal] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_AMP] = ACTIONS(353),
    [anon_sym_RPAREN] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(353),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_EQ_EQ] = ACTIONS(351),
    [anon_sym_GT_EQ] = ACTIONS(351),
    [anon_sym_LT_EQ] = ACTIONS(351),
    [anon_sym_BANG_EQ] = ACTIONS(351),
    [anon_sym_AMP_AMP] = ACTIONS(351),
    [anon_sym_PIPE_PIPE] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_SLASH] = ACTIONS(353),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_CARET] = ACTIONS(351),
    [anon_sym_PERCENT] = ACTIONS(351),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_GT_GT_GT] = ACTIONS(351),
    [anon_sym_instanceof] = ACTIONS(353),
    [anon_sym_COMMA] = ACTIONS(351),
    [anon_sym_QMARK] = ACTIONS(351),
    [anon_sym_COLON] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_RBRACK] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_assert] = ACTIONS(353),
    [anon_sym_switch] = ACTIONS(353),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_do] = ACTIONS(353),
    [anon_sym_while] = ACTIONS(353),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_continue] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(353),
    [anon_sym_synchronized] = ACTIONS(353),
    [anon_sym_throw] = ACTIONS(353),
    [anon_sym_try] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(353),
    [anon_sym_AT] = ACTIONS(353),
    [anon_sym_open] = ACTIONS(353),
    [anon_sym_module] = ACTIONS(353),
    [anon_sym_static] = ACTIONS(353),
    [anon_sym_package] = ACTIONS(353),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_enum] = ACTIONS(353),
    [anon_sym_public] = ACTIONS(353),
    [anon_sym_protected] = ACTIONS(353),
    [anon_sym_private] = ACTIONS(353),
    [anon_sym_abstract] = ACTIONS(353),
    [anon_sym_final] = ACTIONS(353),
    [anon_sym_strictfp] = ACTIONS(353),
    [anon_sym_native] = ACTIONS(353),
    [anon_sym_transient] = ACTIONS(353),
    [anon_sym_volatile] = ACTIONS(353),
    [anon_sym_ATinterface] = ACTIONS(351),
    [anon_sym_interface] = ACTIONS(353),
    [anon_sym_byte] = ACTIONS(353),
    [anon_sym_short] = ACTIONS(353),
    [anon_sym_int] = ACTIONS(353),
    [anon_sym_long] = ACTIONS(353),
    [anon_sym_char] = ACTIONS(353),
    [anon_sym_float] = ACTIONS(353),
    [anon_sym_double] = ACTIONS(353),
    [sym_boolean_type] = ACTIONS(353),
    [sym_void_type] = ACTIONS(353),
    [sym_this] = ACTIONS(353),
    [sym_super] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_decimal_integer_literal] = ACTIONS(357),
    [sym_hex_integer_literal] = ACTIONS(357),
    [sym_octal_integer_literal] = ACTIONS(355),
    [sym_binary_integer_literal] = ACTIONS(355),
    [sym_decimal_floating_point_literal] = ACTIONS(355),
    [sym_hex_floating_point_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_character_literal] = ACTIONS(355),
    [sym_string_literal] = ACTIONS(355),
    [sym_null_literal] = ACTIONS(357),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(357),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(357),
    [anon_sym_LT] = ACTIONS(357),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_GT_EQ] = ACTIONS(355),
    [anon_sym_LT_EQ] = ACTIONS(355),
    [anon_sym_BANG_EQ] = ACTIONS(355),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [anon_sym_PLUS] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(357),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_SLASH] = ACTIONS(357),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_CARET] = ACTIONS(355),
    [anon_sym_PERCENT] = ACTIONS(355),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(357),
    [anon_sym_GT_GT_GT] = ACTIONS(355),
    [anon_sym_instanceof] = ACTIONS(357),
    [anon_sym_COMMA] = ACTIONS(355),
    [anon_sym_QMARK] = ACTIONS(355),
    [anon_sym_COLON] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(355),
    [anon_sym_DASH_DASH] = ACTIONS(355),
    [anon_sym_new] = ACTIONS(357),
    [anon_sym_RBRACK] = ACTIONS(355),
    [anon_sym_class] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_RBRACE] = ACTIONS(355),
    [anon_sym_assert] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_do] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_break] = ACTIONS(357),
    [anon_sym_continue] = ACTIONS(357),
    [anon_sym_return] = ACTIONS(357),
    [anon_sym_synchronized] = ACTIONS(357),
    [anon_sym_throw] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(357),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_else] = ACTIONS(357),
    [anon_sym_for] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(357),
    [anon_sym_open] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(357),
    [anon_sym_package] = ACTIONS(357),
    [anon_sym_import] = ACTIONS(357),
    [anon_sym_enum] = ACTIONS(357),
    [anon_sym_public] = ACTIONS(357),
    [anon_sym_protected] = ACTIONS(357),
    [anon_sym_private] = ACTIONS(357),
    [anon_sym_abstract] = ACTIONS(357),
    [anon_sym_final] = ACTIONS(357),
    [anon_sym_strictfp] = ACTIONS(357),
    [anon_sym_native] = ACTIONS(357),
    [anon_sym_transient] = ACTIONS(357),
    [anon_sym_volatile] = ACTIONS(357),
    [anon_sym_ATinterface] = ACTIONS(355),
    [anon_sym_interface] = ACTIONS(357),
    [anon_sym_byte] = ACTIONS(357),
    [anon_sym_short] = ACTIONS(357),
    [anon_sym_int] = ACTIONS(357),
    [anon_sym_long] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_float] = ACTIONS(357),
    [anon_sym_double] = ACTIONS(357),
    [sym_boolean_type] = ACTIONS(357),
    [sym_void_type] = ACTIONS(357),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_identifier] = ACTIONS(359),
    [sym_decimal_integer_literal] = ACTIONS(359),
    [sym_hex_integer_literal] = ACTIONS(359),
    [sym_octal_integer_literal] = ACTIONS(361),
    [sym_binary_integer_literal] = ACTIONS(361),
    [sym_decimal_floating_point_literal] = ACTIONS(361),
    [sym_hex_floating_point_literal] = ACTIONS(359),
    [sym_true] = ACTIONS(359),
    [sym_false] = ACTIONS(359),
    [sym_character_literal] = ACTIONS(361),
    [sym_string_literal] = ACTIONS(361),
    [sym_null_literal] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(359),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(359),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_AMP_AMP] = ACTIONS(361),
    [anon_sym_PIPE_PIPE] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_SLASH] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_GT_GT] = ACTIONS(359),
    [anon_sym_GT_GT_GT] = ACTIONS(361),
    [anon_sym_instanceof] = ACTIONS(359),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_QMARK] = ACTIONS(361),
    [anon_sym_COLON] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(361),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_new] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(361),
    [anon_sym_RBRACK] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(359),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_assert] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_do] = ACTIONS(359),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(359),
    [anon_sym_return] = ACTIONS(359),
    [anon_sym_synchronized] = ACTIONS(359),
    [anon_sym_throw] = ACTIONS(359),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(359),
    [anon_sym_AT] = ACTIONS(359),
    [anon_sym_open] = ACTIONS(359),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_static] = ACTIONS(359),
    [anon_sym_package] = ACTIONS(359),
    [anon_sym_import] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(359),
    [anon_sym_public] = ACTIONS(359),
    [anon_sym_protected] = ACTIONS(359),
    [anon_sym_private] = ACTIONS(359),
    [anon_sym_abstract] = ACTIONS(359),
    [anon_sym_final] = ACTIONS(359),
    [anon_sym_strictfp] = ACTIONS(359),
    [anon_sym_native] = ACTIONS(359),
    [anon_sym_transient] = ACTIONS(359),
    [anon_sym_volatile] = ACTIONS(359),
    [anon_sym_ATinterface] = ACTIONS(361),
    [anon_sym_interface] = ACTIONS(359),
    [anon_sym_byte] = ACTIONS(359),
    [anon_sym_short] = ACTIONS(359),
    [anon_sym_int] = ACTIONS(359),
    [anon_sym_long] = ACTIONS(359),
    [anon_sym_char] = ACTIONS(359),
    [anon_sym_float] = ACTIONS(359),
    [anon_sym_double] = ACTIONS(359),
    [sym_boolean_type] = ACTIONS(359),
    [sym_void_type] = ACTIONS(359),
    [sym_this] = ACTIONS(359),
    [sym_super] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(455),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(468),
    [sym_marker_annotation] = STATE(468),
    [sym_annotation] = STATE(468),
    [sym_modifiers] = STATE(512),
    [sym__type] = STATE(688),
    [sym__unannotated_type] = STATE(502),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_formal_parameter] = STATE(751),
    [sym_receiver_parameter] = STATE(279),
    [sym_spread_parameter] = STATE(751),
    [aux_sym_dimensions_expr_repeat1] = STATE(483),
    [aux_sym_modifiers_repeat1] = STATE(404),
    [sym_identifier] = ACTIONS(363),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_synchronized] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_static] = ACTIONS(367),
    [anon_sym_public] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_abstract] = ACTIONS(367),
    [anon_sym_final] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_native] = ACTIONS(367),
    [anon_sym_transient] = ACTIONS(367),
    [anon_sym_volatile] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(417),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(468),
    [sym_marker_annotation] = STATE(468),
    [sym_annotation] = STATE(468),
    [sym_modifiers] = STATE(507),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(509),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [sym_local_variable_declaration] = STATE(171),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [aux_sym_modifiers_repeat1] = STATE(404),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(375),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_synchronized] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_static] = ACTIONS(367),
    [anon_sym_public] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_abstract] = ACTIONS(367),
    [anon_sym_final] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_native] = ACTIONS(367),
    [anon_sym_transient] = ACTIONS(367),
    [anon_sym_volatile] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_catch_clause] = STATE(59),
    [sym_finally_clause] = STATE(128),
    [aux_sym_try_statement_repeat1] = STATE(59),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(379),
    [sym_decimal_integer_literal] = ACTIONS(379),
    [sym_hex_integer_literal] = ACTIONS(379),
    [sym_octal_integer_literal] = ACTIONS(377),
    [sym_binary_integer_literal] = ACTIONS(377),
    [sym_decimal_floating_point_literal] = ACTIONS(377),
    [sym_hex_floating_point_literal] = ACTIONS(379),
    [sym_true] = ACTIONS(379),
    [sym_false] = ACTIONS(379),
    [sym_character_literal] = ACTIONS(377),
    [sym_string_literal] = ACTIONS(377),
    [sym_null_literal] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_TILDE] = ACTIONS(377),
    [anon_sym_PLUS_PLUS] = ACTIONS(377),
    [anon_sym_DASH_DASH] = ACTIONS(377),
    [anon_sym_new] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_assert] = ACTIONS(379),
    [anon_sym_switch] = ACTIONS(379),
    [anon_sym_case] = ACTIONS(379),
    [anon_sym_default] = ACTIONS(379),
    [anon_sym_do] = ACTIONS(379),
    [anon_sym_while] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(379),
    [anon_sym_continue] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_synchronized] = ACTIONS(379),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(379),
    [anon_sym_catch] = ACTIONS(381),
    [anon_sym_finally] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(379),
    [anon_sym_else] = ACTIONS(379),
    [anon_sym_for] = ACTIONS(379),
    [anon_sym_AT] = ACTIONS(379),
    [anon_sym_open] = ACTIONS(379),
    [anon_sym_module] = ACTIONS(379),
    [anon_sym_static] = ACTIONS(379),
    [anon_sym_package] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(379),
    [anon_sym_enum] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(379),
    [anon_sym_protected] = ACTIONS(379),
    [anon_sym_private] = ACTIONS(379),
    [anon_sym_abstract] = ACTIONS(379),
    [anon_sym_final] = ACTIONS(379),
    [anon_sym_strictfp] = ACTIONS(379),
    [anon_sym_native] = ACTIONS(379),
    [anon_sym_transient] = ACTIONS(379),
    [anon_sym_volatile] = ACTIONS(379),
    [anon_sym_ATinterface] = ACTIONS(377),
    [anon_sym_interface] = ACTIONS(379),
    [anon_sym_byte] = ACTIONS(379),
    [anon_sym_short] = ACTIONS(379),
    [anon_sym_int] = ACTIONS(379),
    [anon_sym_long] = ACTIONS(379),
    [anon_sym_char] = ACTIONS(379),
    [anon_sym_float] = ACTIONS(379),
    [anon_sym_double] = ACTIONS(379),
    [sym_boolean_type] = ACTIONS(379),
    [sym_void_type] = ACTIONS(379),
    [sym_this] = ACTIONS(379),
    [sym_super] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_catch_clause] = STATE(55),
    [sym_finally_clause] = STATE(129),
    [aux_sym_try_statement_repeat1] = STATE(55),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(387),
    [sym_decimal_integer_literal] = ACTIONS(387),
    [sym_hex_integer_literal] = ACTIONS(387),
    [sym_octal_integer_literal] = ACTIONS(385),
    [sym_binary_integer_literal] = ACTIONS(385),
    [sym_decimal_floating_point_literal] = ACTIONS(385),
    [sym_hex_floating_point_literal] = ACTIONS(387),
    [sym_true] = ACTIONS(387),
    [sym_false] = ACTIONS(387),
    [sym_character_literal] = ACTIONS(385),
    [sym_string_literal] = ACTIONS(385),
    [sym_null_literal] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_TILDE] = ACTIONS(385),
    [anon_sym_PLUS_PLUS] = ACTIONS(385),
    [anon_sym_DASH_DASH] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_class] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_assert] = ACTIONS(387),
    [anon_sym_switch] = ACTIONS(387),
    [anon_sym_case] = ACTIONS(387),
    [anon_sym_default] = ACTIONS(387),
    [anon_sym_do] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(387),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_continue] = ACTIONS(387),
    [anon_sym_return] = ACTIONS(387),
    [anon_sym_synchronized] = ACTIONS(387),
    [anon_sym_throw] = ACTIONS(387),
    [anon_sym_try] = ACTIONS(387),
    [anon_sym_catch] = ACTIONS(381),
    [anon_sym_finally] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(387),
    [anon_sym_else] = ACTIONS(387),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(387),
    [anon_sym_open] = ACTIONS(387),
    [anon_sym_module] = ACTIONS(387),
    [anon_sym_static] = ACTIONS(387),
    [anon_sym_package] = ACTIONS(387),
    [anon_sym_import] = ACTIONS(387),
    [anon_sym_enum] = ACTIONS(387),
    [anon_sym_public] = ACTIONS(387),
    [anon_sym_protected] = ACTIONS(387),
    [anon_sym_private] = ACTIONS(387),
    [anon_sym_abstract] = ACTIONS(387),
    [anon_sym_final] = ACTIONS(387),
    [anon_sym_strictfp] = ACTIONS(387),
    [anon_sym_native] = ACTIONS(387),
    [anon_sym_transient] = ACTIONS(387),
    [anon_sym_volatile] = ACTIONS(387),
    [anon_sym_ATinterface] = ACTIONS(385),
    [anon_sym_interface] = ACTIONS(387),
    [anon_sym_byte] = ACTIONS(387),
    [anon_sym_short] = ACTIONS(387),
    [anon_sym_int] = ACTIONS(387),
    [anon_sym_long] = ACTIONS(387),
    [anon_sym_char] = ACTIONS(387),
    [anon_sym_float] = ACTIONS(387),
    [anon_sym_double] = ACTIONS(387),
    [sym_boolean_type] = ACTIONS(387),
    [sym_void_type] = ACTIONS(387),
    [sym_this] = ACTIONS(387),
    [sym_super] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_catch_clause] = STATE(59),
    [sym_finally_clause] = STATE(197),
    [aux_sym_try_statement_repeat1] = STATE(59),
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_identifier] = ACTIONS(391),
    [sym_decimal_integer_literal] = ACTIONS(391),
    [sym_hex_integer_literal] = ACTIONS(391),
    [sym_octal_integer_literal] = ACTIONS(389),
    [sym_binary_integer_literal] = ACTIONS(389),
    [sym_decimal_floating_point_literal] = ACTIONS(389),
    [sym_hex_floating_point_literal] = ACTIONS(391),
    [sym_true] = ACTIONS(391),
    [sym_false] = ACTIONS(391),
    [sym_character_literal] = ACTIONS(389),
    [sym_string_literal] = ACTIONS(389),
    [sym_null_literal] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_TILDE] = ACTIONS(389),
    [anon_sym_PLUS_PLUS] = ACTIONS(389),
    [anon_sym_DASH_DASH] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(391),
    [anon_sym_class] = ACTIONS(391),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_LBRACE] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_assert] = ACTIONS(391),
    [anon_sym_switch] = ACTIONS(391),
    [anon_sym_case] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(391),
    [anon_sym_break] = ACTIONS(391),
    [anon_sym_continue] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(391),
    [anon_sym_synchronized] = ACTIONS(391),
    [anon_sym_throw] = ACTIONS(391),
    [anon_sym_try] = ACTIONS(391),
    [anon_sym_catch] = ACTIONS(381),
    [anon_sym_finally] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_else] = ACTIONS(391),
    [anon_sym_for] = ACTIONS(391),
    [anon_sym_AT] = ACTIONS(391),
    [anon_sym_open] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(391),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_package] = ACTIONS(391),
    [anon_sym_import] = ACTIONS(391),
    [anon_sym_enum] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(391),
    [anon_sym_final] = ACTIONS(391),
    [anon_sym_strictfp] = ACTIONS(391),
    [anon_sym_native] = ACTIONS(391),
    [anon_sym_transient] = ACTIONS(391),
    [anon_sym_volatile] = ACTIONS(391),
    [anon_sym_ATinterface] = ACTIONS(389),
    [anon_sym_interface] = ACTIONS(391),
    [anon_sym_byte] = ACTIONS(391),
    [anon_sym_short] = ACTIONS(391),
    [anon_sym_int] = ACTIONS(391),
    [anon_sym_long] = ACTIONS(391),
    [anon_sym_char] = ACTIONS(391),
    [anon_sym_float] = ACTIONS(391),
    [anon_sym_double] = ACTIONS(391),
    [sym_boolean_type] = ACTIONS(391),
    [sym_void_type] = ACTIONS(391),
    [sym_this] = ACTIONS(391),
    [sym_super] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym_element_value_pair] = STATE(708),
    [sym__element_value] = STATE(897),
    [sym_element_value_array_initializer] = STATE(897),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(393),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(395),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym__element_value] = STATE(752),
    [sym_element_value_array_initializer] = STATE(752),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym_element_value_pair] = STATE(779),
    [sym__element_value] = STATE(953),
    [sym_element_value_array_initializer] = STATE(953),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(393),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_catch_clause] = STATE(59),
    [aux_sym_try_statement_repeat1] = STATE(59),
    [ts_builtin_sym_end] = ACTIONS(405),
    [sym_identifier] = ACTIONS(407),
    [sym_decimal_integer_literal] = ACTIONS(407),
    [sym_hex_integer_literal] = ACTIONS(407),
    [sym_octal_integer_literal] = ACTIONS(405),
    [sym_binary_integer_literal] = ACTIONS(405),
    [sym_decimal_floating_point_literal] = ACTIONS(405),
    [sym_hex_floating_point_literal] = ACTIONS(407),
    [sym_true] = ACTIONS(407),
    [sym_false] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(405),
    [sym_string_literal] = ACTIONS(405),
    [sym_null_literal] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_TILDE] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_class] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACE] = ACTIONS(405),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_assert] = ACTIONS(407),
    [anon_sym_switch] = ACTIONS(407),
    [anon_sym_case] = ACTIONS(407),
    [anon_sym_default] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(407),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_continue] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(407),
    [anon_sym_synchronized] = ACTIONS(407),
    [anon_sym_throw] = ACTIONS(407),
    [anon_sym_try] = ACTIONS(407),
    [anon_sym_catch] = ACTIONS(409),
    [anon_sym_finally] = ACTIONS(407),
    [anon_sym_if] = ACTIONS(407),
    [anon_sym_else] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(407),
    [anon_sym_AT] = ACTIONS(407),
    [anon_sym_open] = ACTIONS(407),
    [anon_sym_module] = ACTIONS(407),
    [anon_sym_static] = ACTIONS(407),
    [anon_sym_package] = ACTIONS(407),
    [anon_sym_import] = ACTIONS(407),
    [anon_sym_enum] = ACTIONS(407),
    [anon_sym_public] = ACTIONS(407),
    [anon_sym_protected] = ACTIONS(407),
    [anon_sym_private] = ACTIONS(407),
    [anon_sym_abstract] = ACTIONS(407),
    [anon_sym_final] = ACTIONS(407),
    [anon_sym_strictfp] = ACTIONS(407),
    [anon_sym_native] = ACTIONS(407),
    [anon_sym_transient] = ACTIONS(407),
    [anon_sym_volatile] = ACTIONS(407),
    [anon_sym_ATinterface] = ACTIONS(405),
    [anon_sym_interface] = ACTIONS(407),
    [anon_sym_byte] = ACTIONS(407),
    [anon_sym_short] = ACTIONS(407),
    [anon_sym_int] = ACTIONS(407),
    [anon_sym_long] = ACTIONS(407),
    [anon_sym_char] = ACTIONS(407),
    [anon_sym_float] = ACTIONS(407),
    [anon_sym_double] = ACTIONS(407),
    [sym_boolean_type] = ACTIONS(407),
    [sym_void_type] = ACTIONS(407),
    [sym_this] = ACTIONS(407),
    [sym_super] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym__element_value] = STATE(820),
    [sym_element_value_array_initializer] = STATE(820),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(431),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym_array_initializer] = STATE(758),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(414),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_RBRACE] = ACTIONS(418),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym__element_value] = STATE(820),
    [sym_element_value_array_initializer] = STATE(820),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(440),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym__element_value] = STATE(863),
    [sym_element_value_array_initializer] = STATE(863),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [ts_builtin_sym_end] = ACTIONS(422),
    [sym_identifier] = ACTIONS(424),
    [sym_decimal_integer_literal] = ACTIONS(424),
    [sym_hex_integer_literal] = ACTIONS(424),
    [sym_octal_integer_literal] = ACTIONS(422),
    [sym_binary_integer_literal] = ACTIONS(422),
    [sym_decimal_floating_point_literal] = ACTIONS(422),
    [sym_hex_floating_point_literal] = ACTIONS(424),
    [sym_true] = ACTIONS(424),
    [sym_false] = ACTIONS(424),
    [sym_character_literal] = ACTIONS(422),
    [sym_string_literal] = ACTIONS(422),
    [sym_null_literal] = ACTIONS(424),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_PLUS] = ACTIONS(424),
    [anon_sym_DASH] = ACTIONS(424),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_TILDE] = ACTIONS(422),
    [anon_sym_PLUS_PLUS] = ACTIONS(422),
    [anon_sym_DASH_DASH] = ACTIONS(422),
    [anon_sym_new] = ACTIONS(424),
    [anon_sym_class] = ACTIONS(424),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(422),
    [anon_sym_RBRACE] = ACTIONS(422),
    [anon_sym_assert] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(424),
    [anon_sym_default] = ACTIONS(424),
    [anon_sym_do] = ACTIONS(424),
    [anon_sym_while] = ACTIONS(424),
    [anon_sym_break] = ACTIONS(424),
    [anon_sym_continue] = ACTIONS(424),
    [anon_sym_return] = ACTIONS(424),
    [anon_sym_synchronized] = ACTIONS(424),
    [anon_sym_throw] = ACTIONS(424),
    [anon_sym_try] = ACTIONS(424),
    [anon_sym_catch] = ACTIONS(424),
    [anon_sym_finally] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(424),
    [anon_sym_else] = ACTIONS(424),
    [anon_sym_for] = ACTIONS(424),
    [anon_sym_AT] = ACTIONS(424),
    [anon_sym_open] = ACTIONS(424),
    [anon_sym_module] = ACTIONS(424),
    [anon_sym_static] = ACTIONS(424),
    [anon_sym_package] = ACTIONS(424),
    [anon_sym_import] = ACTIONS(424),
    [anon_sym_enum] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(424),
    [anon_sym_protected] = ACTIONS(424),
    [anon_sym_private] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(424),
    [anon_sym_final] = ACTIONS(424),
    [anon_sym_strictfp] = ACTIONS(424),
    [anon_sym_native] = ACTIONS(424),
    [anon_sym_transient] = ACTIONS(424),
    [anon_sym_volatile] = ACTIONS(424),
    [anon_sym_ATinterface] = ACTIONS(422),
    [anon_sym_interface] = ACTIONS(424),
    [anon_sym_byte] = ACTIONS(424),
    [anon_sym_short] = ACTIONS(424),
    [anon_sym_int] = ACTIONS(424),
    [anon_sym_long] = ACTIONS(424),
    [anon_sym_char] = ACTIONS(424),
    [anon_sym_float] = ACTIONS(424),
    [anon_sym_double] = ACTIONS(424),
    [sym_boolean_type] = ACTIONS(424),
    [sym_void_type] = ACTIONS(424),
    [sym_this] = ACTIONS(424),
    [sym_super] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym__element_value] = STATE(914),
    [sym_element_value_array_initializer] = STATE(914),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym__element_value] = STATE(820),
    [sym_element_value_array_initializer] = STATE(820),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(433),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym_array_initializer] = STATE(856),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_RBRACE] = ACTIONS(426),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(433),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym_array_initializer] = STATE(856),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_RBRACE] = ACTIONS(428),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(410),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(521),
    [sym_marker_annotation] = STATE(521),
    [sym_annotation] = STATE(521),
    [sym__element_value] = STATE(863),
    [sym_element_value_array_initializer] = STATE(863),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_decimal_integer_literal] = ACTIONS(357),
    [sym_hex_integer_literal] = ACTIONS(357),
    [sym_octal_integer_literal] = ACTIONS(355),
    [sym_binary_integer_literal] = ACTIONS(355),
    [sym_decimal_floating_point_literal] = ACTIONS(355),
    [sym_hex_floating_point_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_character_literal] = ACTIONS(355),
    [sym_string_literal] = ACTIONS(355),
    [sym_null_literal] = ACTIONS(357),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_PLUS] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(355),
    [anon_sym_DASH_DASH] = ACTIONS(355),
    [anon_sym_new] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_RBRACE] = ACTIONS(355),
    [anon_sym_assert] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_do] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_break] = ACTIONS(357),
    [anon_sym_continue] = ACTIONS(357),
    [anon_sym_return] = ACTIONS(357),
    [anon_sym_synchronized] = ACTIONS(357),
    [anon_sym_throw] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(357),
    [anon_sym_catch] = ACTIONS(357),
    [anon_sym_finally] = ACTIONS(357),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_else] = ACTIONS(357),
    [anon_sym_for] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(357),
    [anon_sym_open] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(357),
    [anon_sym_package] = ACTIONS(357),
    [anon_sym_import] = ACTIONS(357),
    [anon_sym_enum] = ACTIONS(357),
    [anon_sym_public] = ACTIONS(357),
    [anon_sym_protected] = ACTIONS(357),
    [anon_sym_private] = ACTIONS(357),
    [anon_sym_abstract] = ACTIONS(357),
    [anon_sym_final] = ACTIONS(357),
    [anon_sym_strictfp] = ACTIONS(357),
    [anon_sym_native] = ACTIONS(357),
    [anon_sym_transient] = ACTIONS(357),
    [anon_sym_volatile] = ACTIONS(357),
    [anon_sym_ATinterface] = ACTIONS(355),
    [anon_sym_interface] = ACTIONS(357),
    [anon_sym_byte] = ACTIONS(357),
    [anon_sym_short] = ACTIONS(357),
    [anon_sym_int] = ACTIONS(357),
    [anon_sym_long] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_float] = ACTIONS(357),
    [anon_sym_double] = ACTIONS(357),
    [sym_boolean_type] = ACTIONS(357),
    [sym_void_type] = ACTIONS(357),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(351),
    [sym_identifier] = ACTIONS(353),
    [sym_decimal_integer_literal] = ACTIONS(353),
    [sym_hex_integer_literal] = ACTIONS(353),
    [sym_octal_integer_literal] = ACTIONS(351),
    [sym_binary_integer_literal] = ACTIONS(351),
    [sym_decimal_floating_point_literal] = ACTIONS(351),
    [sym_hex_floating_point_literal] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_character_literal] = ACTIONS(351),
    [sym_string_literal] = ACTIONS(351),
    [sym_null_literal] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_assert] = ACTIONS(353),
    [anon_sym_switch] = ACTIONS(353),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_do] = ACTIONS(353),
    [anon_sym_while] = ACTIONS(353),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_continue] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(353),
    [anon_sym_synchronized] = ACTIONS(353),
    [anon_sym_throw] = ACTIONS(353),
    [anon_sym_try] = ACTIONS(353),
    [anon_sym_catch] = ACTIONS(353),
    [anon_sym_finally] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(353),
    [anon_sym_AT] = ACTIONS(353),
    [anon_sym_open] = ACTIONS(353),
    [anon_sym_module] = ACTIONS(353),
    [anon_sym_static] = ACTIONS(353),
    [anon_sym_package] = ACTIONS(353),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_enum] = ACTIONS(353),
    [anon_sym_public] = ACTIONS(353),
    [anon_sym_protected] = ACTIONS(353),
    [anon_sym_private] = ACTIONS(353),
    [anon_sym_abstract] = ACTIONS(353),
    [anon_sym_final] = ACTIONS(353),
    [anon_sym_strictfp] = ACTIONS(353),
    [anon_sym_native] = ACTIONS(353),
    [anon_sym_transient] = ACTIONS(353),
    [anon_sym_volatile] = ACTIONS(353),
    [anon_sym_ATinterface] = ACTIONS(351),
    [anon_sym_interface] = ACTIONS(353),
    [anon_sym_byte] = ACTIONS(353),
    [anon_sym_short] = ACTIONS(353),
    [anon_sym_int] = ACTIONS(353),
    [anon_sym_long] = ACTIONS(353),
    [anon_sym_char] = ACTIONS(353),
    [anon_sym_float] = ACTIONS(353),
    [anon_sym_double] = ACTIONS(353),
    [sym_boolean_type] = ACTIONS(353),
    [sym_void_type] = ACTIONS(353),
    [sym_this] = ACTIONS(353),
    [sym_super] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(430),
    [sym_identifier] = ACTIONS(432),
    [sym_decimal_integer_literal] = ACTIONS(432),
    [sym_hex_integer_literal] = ACTIONS(432),
    [sym_octal_integer_literal] = ACTIONS(430),
    [sym_binary_integer_literal] = ACTIONS(430),
    [sym_decimal_floating_point_literal] = ACTIONS(430),
    [sym_hex_floating_point_literal] = ACTIONS(432),
    [sym_true] = ACTIONS(432),
    [sym_false] = ACTIONS(432),
    [sym_character_literal] = ACTIONS(430),
    [sym_string_literal] = ACTIONS(430),
    [sym_null_literal] = ACTIONS(432),
    [anon_sym_LPAREN] = ACTIONS(430),
    [anon_sym_LT] = ACTIONS(430),
    [anon_sym_PLUS] = ACTIONS(432),
    [anon_sym_DASH] = ACTIONS(432),
    [anon_sym_BANG] = ACTIONS(430),
    [anon_sym_TILDE] = ACTIONS(430),
    [anon_sym_PLUS_PLUS] = ACTIONS(430),
    [anon_sym_DASH_DASH] = ACTIONS(430),
    [anon_sym_new] = ACTIONS(432),
    [anon_sym_class] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(430),
    [anon_sym_LBRACE] = ACTIONS(430),
    [anon_sym_RBRACE] = ACTIONS(430),
    [anon_sym_assert] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(432),
    [anon_sym_case] = ACTIONS(432),
    [anon_sym_default] = ACTIONS(432),
    [anon_sym_do] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(432),
    [anon_sym_break] = ACTIONS(432),
    [anon_sym_continue] = ACTIONS(432),
    [anon_sym_return] = ACTIONS(432),
    [anon_sym_synchronized] = ACTIONS(432),
    [anon_sym_throw] = ACTIONS(432),
    [anon_sym_try] = ACTIONS(432),
    [anon_sym_if] = ACTIONS(432),
    [anon_sym_else] = ACTIONS(432),
    [anon_sym_for] = ACTIONS(432),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_open] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_package] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(432),
    [anon_sym_enum] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(432),
    [anon_sym_protected] = ACTIONS(432),
    [anon_sym_private] = ACTIONS(432),
    [anon_sym_abstract] = ACTIONS(432),
    [anon_sym_final] = ACTIONS(432),
    [anon_sym_strictfp] = ACTIONS(432),
    [anon_sym_native] = ACTIONS(432),
    [anon_sym_transient] = ACTIONS(432),
    [anon_sym_volatile] = ACTIONS(432),
    [anon_sym_ATinterface] = ACTIONS(430),
    [anon_sym_interface] = ACTIONS(432),
    [anon_sym_byte] = ACTIONS(432),
    [anon_sym_short] = ACTIONS(432),
    [anon_sym_int] = ACTIONS(432),
    [anon_sym_long] = ACTIONS(432),
    [anon_sym_char] = ACTIONS(432),
    [anon_sym_float] = ACTIONS(432),
    [anon_sym_double] = ACTIONS(432),
    [sym_boolean_type] = ACTIONS(432),
    [sym_void_type] = ACTIONS(432),
    [sym_this] = ACTIONS(432),
    [sym_super] = ACTIONS(432),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(434),
    [sym_identifier] = ACTIONS(436),
    [sym_decimal_integer_literal] = ACTIONS(436),
    [sym_hex_integer_literal] = ACTIONS(436),
    [sym_octal_integer_literal] = ACTIONS(434),
    [sym_binary_integer_literal] = ACTIONS(434),
    [sym_decimal_floating_point_literal] = ACTIONS(434),
    [sym_hex_floating_point_literal] = ACTIONS(436),
    [sym_true] = ACTIONS(436),
    [sym_false] = ACTIONS(436),
    [sym_character_literal] = ACTIONS(434),
    [sym_string_literal] = ACTIONS(434),
    [sym_null_literal] = ACTIONS(436),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_LT] = ACTIONS(434),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_BANG] = ACTIONS(434),
    [anon_sym_TILDE] = ACTIONS(434),
    [anon_sym_PLUS_PLUS] = ACTIONS(434),
    [anon_sym_DASH_DASH] = ACTIONS(434),
    [anon_sym_new] = ACTIONS(436),
    [anon_sym_class] = ACTIONS(436),
    [anon_sym_SEMI] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(434),
    [anon_sym_RBRACE] = ACTIONS(434),
    [anon_sym_assert] = ACTIONS(436),
    [anon_sym_switch] = ACTIONS(436),
    [anon_sym_case] = ACTIONS(436),
    [anon_sym_default] = ACTIONS(436),
    [anon_sym_do] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(436),
    [anon_sym_break] = ACTIONS(436),
    [anon_sym_continue] = ACTIONS(436),
    [anon_sym_return] = ACTIONS(436),
    [anon_sym_synchronized] = ACTIONS(436),
    [anon_sym_throw] = ACTIONS(436),
    [anon_sym_try] = ACTIONS(436),
    [anon_sym_if] = ACTIONS(436),
    [anon_sym_else] = ACTIONS(436),
    [anon_sym_for] = ACTIONS(436),
    [anon_sym_AT] = ACTIONS(436),
    [anon_sym_open] = ACTIONS(436),
    [anon_sym_module] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(436),
    [anon_sym_package] = ACTIONS(436),
    [anon_sym_import] = ACTIONS(436),
    [anon_sym_enum] = ACTIONS(436),
    [anon_sym_public] = ACTIONS(436),
    [anon_sym_protected] = ACTIONS(436),
    [anon_sym_private] = ACTIONS(436),
    [anon_sym_abstract] = ACTIONS(436),
    [anon_sym_final] = ACTIONS(436),
    [anon_sym_strictfp] = ACTIONS(436),
    [anon_sym_native] = ACTIONS(436),
    [anon_sym_transient] = ACTIONS(436),
    [anon_sym_volatile] = ACTIONS(436),
    [anon_sym_ATinterface] = ACTIONS(434),
    [anon_sym_interface] = ACTIONS(436),
    [anon_sym_byte] = ACTIONS(436),
    [anon_sym_short] = ACTIONS(436),
    [anon_sym_int] = ACTIONS(436),
    [anon_sym_long] = ACTIONS(436),
    [anon_sym_char] = ACTIONS(436),
    [anon_sym_float] = ACTIONS(436),
    [anon_sym_double] = ACTIONS(436),
    [sym_boolean_type] = ACTIONS(436),
    [sym_void_type] = ACTIONS(436),
    [sym_this] = ACTIONS(436),
    [sym_super] = ACTIONS(436),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(438),
    [sym_identifier] = ACTIONS(440),
    [sym_decimal_integer_literal] = ACTIONS(440),
    [sym_hex_integer_literal] = ACTIONS(440),
    [sym_octal_integer_literal] = ACTIONS(438),
    [sym_binary_integer_literal] = ACTIONS(438),
    [sym_decimal_floating_point_literal] = ACTIONS(438),
    [sym_hex_floating_point_literal] = ACTIONS(440),
    [sym_true] = ACTIONS(440),
    [sym_false] = ACTIONS(440),
    [sym_character_literal] = ACTIONS(438),
    [sym_string_literal] = ACTIONS(438),
    [sym_null_literal] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LT] = ACTIONS(438),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(438),
    [anon_sym_PLUS_PLUS] = ACTIONS(438),
    [anon_sym_DASH_DASH] = ACTIONS(438),
    [anon_sym_new] = ACTIONS(440),
    [anon_sym_class] = ACTIONS(440),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_RBRACE] = ACTIONS(438),
    [anon_sym_assert] = ACTIONS(440),
    [anon_sym_switch] = ACTIONS(440),
    [anon_sym_case] = ACTIONS(440),
    [anon_sym_default] = ACTIONS(440),
    [anon_sym_do] = ACTIONS(440),
    [anon_sym_while] = ACTIONS(440),
    [anon_sym_break] = ACTIONS(440),
    [anon_sym_continue] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(440),
    [anon_sym_synchronized] = ACTIONS(440),
    [anon_sym_throw] = ACTIONS(440),
    [anon_sym_try] = ACTIONS(440),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_else] = ACTIONS(440),
    [anon_sym_for] = ACTIONS(440),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_open] = ACTIONS(440),
    [anon_sym_module] = ACTIONS(440),
    [anon_sym_static] = ACTIONS(440),
    [anon_sym_package] = ACTIONS(440),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_enum] = ACTIONS(440),
    [anon_sym_public] = ACTIONS(440),
    [anon_sym_protected] = ACTIONS(440),
    [anon_sym_private] = ACTIONS(440),
    [anon_sym_abstract] = ACTIONS(440),
    [anon_sym_final] = ACTIONS(440),
    [anon_sym_strictfp] = ACTIONS(440),
    [anon_sym_native] = ACTIONS(440),
    [anon_sym_transient] = ACTIONS(440),
    [anon_sym_volatile] = ACTIONS(440),
    [anon_sym_ATinterface] = ACTIONS(438),
    [anon_sym_interface] = ACTIONS(440),
    [anon_sym_byte] = ACTIONS(440),
    [anon_sym_short] = ACTIONS(440),
    [anon_sym_int] = ACTIONS(440),
    [anon_sym_long] = ACTIONS(440),
    [anon_sym_char] = ACTIONS(440),
    [anon_sym_float] = ACTIONS(440),
    [anon_sym_double] = ACTIONS(440),
    [sym_boolean_type] = ACTIONS(440),
    [sym_void_type] = ACTIONS(440),
    [sym_this] = ACTIONS(440),
    [sym_super] = ACTIONS(440),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(442),
    [sym_identifier] = ACTIONS(444),
    [sym_decimal_integer_literal] = ACTIONS(444),
    [sym_hex_integer_literal] = ACTIONS(444),
    [sym_octal_integer_literal] = ACTIONS(442),
    [sym_binary_integer_literal] = ACTIONS(442),
    [sym_decimal_floating_point_literal] = ACTIONS(442),
    [sym_hex_floating_point_literal] = ACTIONS(444),
    [sym_true] = ACTIONS(444),
    [sym_false] = ACTIONS(444),
    [sym_character_literal] = ACTIONS(442),
    [sym_string_literal] = ACTIONS(442),
    [sym_null_literal] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_PLUS] = ACTIONS(444),
    [anon_sym_DASH] = ACTIONS(444),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_PLUS_PLUS] = ACTIONS(442),
    [anon_sym_DASH_DASH] = ACTIONS(442),
    [anon_sym_new] = ACTIONS(444),
    [anon_sym_class] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(442),
    [anon_sym_assert] = ACTIONS(444),
    [anon_sym_switch] = ACTIONS(444),
    [anon_sym_case] = ACTIONS(444),
    [anon_sym_default] = ACTIONS(444),
    [anon_sym_do] = ACTIONS(444),
    [anon_sym_while] = ACTIONS(444),
    [anon_sym_break] = ACTIONS(444),
    [anon_sym_continue] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(444),
    [anon_sym_synchronized] = ACTIONS(444),
    [anon_sym_throw] = ACTIONS(444),
    [anon_sym_try] = ACTIONS(444),
    [anon_sym_if] = ACTIONS(444),
    [anon_sym_else] = ACTIONS(444),
    [anon_sym_for] = ACTIONS(444),
    [anon_sym_AT] = ACTIONS(444),
    [anon_sym_open] = ACTIONS(444),
    [anon_sym_module] = ACTIONS(444),
    [anon_sym_static] = ACTIONS(444),
    [anon_sym_package] = ACTIONS(444),
    [anon_sym_import] = ACTIONS(444),
    [anon_sym_enum] = ACTIONS(444),
    [anon_sym_public] = ACTIONS(444),
    [anon_sym_protected] = ACTIONS(444),
    [anon_sym_private] = ACTIONS(444),
    [anon_sym_abstract] = ACTIONS(444),
    [anon_sym_final] = ACTIONS(444),
    [anon_sym_strictfp] = ACTIONS(444),
    [anon_sym_native] = ACTIONS(444),
    [anon_sym_transient] = ACTIONS(444),
    [anon_sym_volatile] = ACTIONS(444),
    [anon_sym_ATinterface] = ACTIONS(442),
    [anon_sym_interface] = ACTIONS(444),
    [anon_sym_byte] = ACTIONS(444),
    [anon_sym_short] = ACTIONS(444),
    [anon_sym_int] = ACTIONS(444),
    [anon_sym_long] = ACTIONS(444),
    [anon_sym_char] = ACTIONS(444),
    [anon_sym_float] = ACTIONS(444),
    [anon_sym_double] = ACTIONS(444),
    [sym_boolean_type] = ACTIONS(444),
    [sym_void_type] = ACTIONS(444),
    [sym_this] = ACTIONS(444),
    [sym_super] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(446),
    [sym_identifier] = ACTIONS(448),
    [sym_decimal_integer_literal] = ACTIONS(448),
    [sym_hex_integer_literal] = ACTIONS(448),
    [sym_octal_integer_literal] = ACTIONS(446),
    [sym_binary_integer_literal] = ACTIONS(446),
    [sym_decimal_floating_point_literal] = ACTIONS(446),
    [sym_hex_floating_point_literal] = ACTIONS(448),
    [sym_true] = ACTIONS(448),
    [sym_false] = ACTIONS(448),
    [sym_character_literal] = ACTIONS(446),
    [sym_string_literal] = ACTIONS(446),
    [sym_null_literal] = ACTIONS(448),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_PLUS] = ACTIONS(448),
    [anon_sym_DASH] = ACTIONS(448),
    [anon_sym_BANG] = ACTIONS(446),
    [anon_sym_TILDE] = ACTIONS(446),
    [anon_sym_PLUS_PLUS] = ACTIONS(446),
    [anon_sym_DASH_DASH] = ACTIONS(446),
    [anon_sym_new] = ACTIONS(448),
    [anon_sym_class] = ACTIONS(448),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_RBRACE] = ACTIONS(446),
    [anon_sym_assert] = ACTIONS(448),
    [anon_sym_switch] = ACTIONS(448),
    [anon_sym_case] = ACTIONS(448),
    [anon_sym_default] = ACTIONS(448),
    [anon_sym_do] = ACTIONS(448),
    [anon_sym_while] = ACTIONS(448),
    [anon_sym_break] = ACTIONS(448),
    [anon_sym_continue] = ACTIONS(448),
    [anon_sym_return] = ACTIONS(448),
    [anon_sym_synchronized] = ACTIONS(448),
    [anon_sym_throw] = ACTIONS(448),
    [anon_sym_try] = ACTIONS(448),
    [anon_sym_if] = ACTIONS(448),
    [anon_sym_else] = ACTIONS(448),
    [anon_sym_for] = ACTIONS(448),
    [anon_sym_AT] = ACTIONS(448),
    [anon_sym_open] = ACTIONS(448),
    [anon_sym_module] = ACTIONS(448),
    [anon_sym_static] = ACTIONS(448),
    [anon_sym_package] = ACTIONS(448),
    [anon_sym_import] = ACTIONS(448),
    [anon_sym_enum] = ACTIONS(448),
    [anon_sym_public] = ACTIONS(448),
    [anon_sym_protected] = ACTIONS(448),
    [anon_sym_private] = ACTIONS(448),
    [anon_sym_abstract] = ACTIONS(448),
    [anon_sym_final] = ACTIONS(448),
    [anon_sym_strictfp] = ACTIONS(448),
    [anon_sym_native] = ACTIONS(448),
    [anon_sym_transient] = ACTIONS(448),
    [anon_sym_volatile] = ACTIONS(448),
    [anon_sym_ATinterface] = ACTIONS(446),
    [anon_sym_interface] = ACTIONS(448),
    [anon_sym_byte] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [anon_sym_int] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_char] = ACTIONS(448),
    [anon_sym_float] = ACTIONS(448),
    [anon_sym_double] = ACTIONS(448),
    [sym_boolean_type] = ACTIONS(448),
    [sym_void_type] = ACTIONS(448),
    [sym_this] = ACTIONS(448),
    [sym_super] = ACTIONS(448),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(450),
    [sym_identifier] = ACTIONS(452),
    [sym_decimal_integer_literal] = ACTIONS(452),
    [sym_hex_integer_literal] = ACTIONS(452),
    [sym_octal_integer_literal] = ACTIONS(450),
    [sym_binary_integer_literal] = ACTIONS(450),
    [sym_decimal_floating_point_literal] = ACTIONS(450),
    [sym_hex_floating_point_literal] = ACTIONS(452),
    [sym_true] = ACTIONS(452),
    [sym_false] = ACTIONS(452),
    [sym_character_literal] = ACTIONS(450),
    [sym_string_literal] = ACTIONS(450),
    [sym_null_literal] = ACTIONS(452),
    [anon_sym_LPAREN] = ACTIONS(450),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_PLUS] = ACTIONS(452),
    [anon_sym_DASH] = ACTIONS(452),
    [anon_sym_BANG] = ACTIONS(450),
    [anon_sym_TILDE] = ACTIONS(450),
    [anon_sym_PLUS_PLUS] = ACTIONS(450),
    [anon_sym_DASH_DASH] = ACTIONS(450),
    [anon_sym_new] = ACTIONS(452),
    [anon_sym_class] = ACTIONS(452),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_LBRACE] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(450),
    [anon_sym_assert] = ACTIONS(452),
    [anon_sym_switch] = ACTIONS(452),
    [anon_sym_case] = ACTIONS(452),
    [anon_sym_default] = ACTIONS(452),
    [anon_sym_do] = ACTIONS(452),
    [anon_sym_while] = ACTIONS(452),
    [anon_sym_break] = ACTIONS(452),
    [anon_sym_continue] = ACTIONS(452),
    [anon_sym_return] = ACTIONS(452),
    [anon_sym_synchronized] = ACTIONS(452),
    [anon_sym_throw] = ACTIONS(452),
    [anon_sym_try] = ACTIONS(452),
    [anon_sym_if] = ACTIONS(452),
    [anon_sym_else] = ACTIONS(452),
    [anon_sym_for] = ACTIONS(452),
    [anon_sym_AT] = ACTIONS(452),
    [anon_sym_open] = ACTIONS(452),
    [anon_sym_module] = ACTIONS(452),
    [anon_sym_static] = ACTIONS(452),
    [anon_sym_package] = ACTIONS(452),
    [anon_sym_import] = ACTIONS(452),
    [anon_sym_enum] = ACTIONS(452),
    [anon_sym_public] = ACTIONS(452),
    [anon_sym_protected] = ACTIONS(452),
    [anon_sym_private] = ACTIONS(452),
    [anon_sym_abstract] = ACTIONS(452),
    [anon_sym_final] = ACTIONS(452),
    [anon_sym_strictfp] = ACTIONS(452),
    [anon_sym_native] = ACTIONS(452),
    [anon_sym_transient] = ACTIONS(452),
    [anon_sym_volatile] = ACTIONS(452),
    [anon_sym_ATinterface] = ACTIONS(450),
    [anon_sym_interface] = ACTIONS(452),
    [anon_sym_byte] = ACTIONS(452),
    [anon_sym_short] = ACTIONS(452),
    [anon_sym_int] = ACTIONS(452),
    [anon_sym_long] = ACTIONS(452),
    [anon_sym_char] = ACTIONS(452),
    [anon_sym_float] = ACTIONS(452),
    [anon_sym_double] = ACTIONS(452),
    [sym_boolean_type] = ACTIONS(452),
    [sym_void_type] = ACTIONS(452),
    [sym_this] = ACTIONS(452),
    [sym_super] = ACTIONS(452),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(454),
    [sym_identifier] = ACTIONS(456),
    [sym_decimal_integer_literal] = ACTIONS(456),
    [sym_hex_integer_literal] = ACTIONS(456),
    [sym_octal_integer_literal] = ACTIONS(454),
    [sym_binary_integer_literal] = ACTIONS(454),
    [sym_decimal_floating_point_literal] = ACTIONS(454),
    [sym_hex_floating_point_literal] = ACTIONS(456),
    [sym_true] = ACTIONS(456),
    [sym_false] = ACTIONS(456),
    [sym_character_literal] = ACTIONS(454),
    [sym_string_literal] = ACTIONS(454),
    [sym_null_literal] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(454),
    [anon_sym_LT] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(454),
    [anon_sym_TILDE] = ACTIONS(454),
    [anon_sym_PLUS_PLUS] = ACTIONS(454),
    [anon_sym_DASH_DASH] = ACTIONS(454),
    [anon_sym_new] = ACTIONS(456),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(454),
    [anon_sym_RBRACE] = ACTIONS(454),
    [anon_sym_assert] = ACTIONS(456),
    [anon_sym_switch] = ACTIONS(456),
    [anon_sym_case] = ACTIONS(456),
    [anon_sym_default] = ACTIONS(456),
    [anon_sym_do] = ACTIONS(456),
    [anon_sym_while] = ACTIONS(456),
    [anon_sym_break] = ACTIONS(456),
    [anon_sym_continue] = ACTIONS(456),
    [anon_sym_return] = ACTIONS(456),
    [anon_sym_synchronized] = ACTIONS(456),
    [anon_sym_throw] = ACTIONS(456),
    [anon_sym_try] = ACTIONS(456),
    [anon_sym_if] = ACTIONS(456),
    [anon_sym_else] = ACTIONS(456),
    [anon_sym_for] = ACTIONS(456),
    [anon_sym_AT] = ACTIONS(456),
    [anon_sym_open] = ACTIONS(456),
    [anon_sym_module] = ACTIONS(456),
    [anon_sym_static] = ACTIONS(456),
    [anon_sym_package] = ACTIONS(456),
    [anon_sym_import] = ACTIONS(456),
    [anon_sym_enum] = ACTIONS(456),
    [anon_sym_public] = ACTIONS(456),
    [anon_sym_protected] = ACTIONS(456),
    [anon_sym_private] = ACTIONS(456),
    [anon_sym_abstract] = ACTIONS(456),
    [anon_sym_final] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_native] = ACTIONS(456),
    [anon_sym_transient] = ACTIONS(456),
    [anon_sym_volatile] = ACTIONS(456),
    [anon_sym_ATinterface] = ACTIONS(454),
    [anon_sym_interface] = ACTIONS(456),
    [anon_sym_byte] = ACTIONS(456),
    [anon_sym_short] = ACTIONS(456),
    [anon_sym_int] = ACTIONS(456),
    [anon_sym_long] = ACTIONS(456),
    [anon_sym_char] = ACTIONS(456),
    [anon_sym_float] = ACTIONS(456),
    [anon_sym_double] = ACTIONS(456),
    [sym_boolean_type] = ACTIONS(456),
    [sym_void_type] = ACTIONS(456),
    [sym_this] = ACTIONS(456),
    [sym_super] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(458),
    [sym_identifier] = ACTIONS(460),
    [sym_decimal_integer_literal] = ACTIONS(460),
    [sym_hex_integer_literal] = ACTIONS(460),
    [sym_octal_integer_literal] = ACTIONS(458),
    [sym_binary_integer_literal] = ACTIONS(458),
    [sym_decimal_floating_point_literal] = ACTIONS(458),
    [sym_hex_floating_point_literal] = ACTIONS(460),
    [sym_true] = ACTIONS(460),
    [sym_false] = ACTIONS(460),
    [sym_character_literal] = ACTIONS(458),
    [sym_string_literal] = ACTIONS(458),
    [sym_null_literal] = ACTIONS(460),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_LT] = ACTIONS(458),
    [anon_sym_PLUS] = ACTIONS(460),
    [anon_sym_DASH] = ACTIONS(460),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_TILDE] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(458),
    [anon_sym_DASH_DASH] = ACTIONS(458),
    [anon_sym_new] = ACTIONS(460),
    [anon_sym_class] = ACTIONS(460),
    [anon_sym_SEMI] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(458),
    [anon_sym_RBRACE] = ACTIONS(458),
    [anon_sym_assert] = ACTIONS(460),
    [anon_sym_switch] = ACTIONS(460),
    [anon_sym_case] = ACTIONS(460),
    [anon_sym_default] = ACTIONS(460),
    [anon_sym_do] = ACTIONS(460),
    [anon_sym_while] = ACTIONS(460),
    [anon_sym_break] = ACTIONS(460),
    [anon_sym_continue] = ACTIONS(460),
    [anon_sym_return] = ACTIONS(460),
    [anon_sym_synchronized] = ACTIONS(460),
    [anon_sym_throw] = ACTIONS(460),
    [anon_sym_try] = ACTIONS(460),
    [anon_sym_if] = ACTIONS(460),
    [anon_sym_else] = ACTIONS(460),
    [anon_sym_for] = ACTIONS(460),
    [anon_sym_AT] = ACTIONS(460),
    [anon_sym_open] = ACTIONS(460),
    [anon_sym_module] = ACTIONS(460),
    [anon_sym_static] = ACTIONS(460),
    [anon_sym_package] = ACTIONS(460),
    [anon_sym_import] = ACTIONS(460),
    [anon_sym_enum] = ACTIONS(460),
    [anon_sym_public] = ACTIONS(460),
    [anon_sym_protected] = ACTIONS(460),
    [anon_sym_private] = ACTIONS(460),
    [anon_sym_abstract] = ACTIONS(460),
    [anon_sym_final] = ACTIONS(460),
    [anon_sym_strictfp] = ACTIONS(460),
    [anon_sym_native] = ACTIONS(460),
    [anon_sym_transient] = ACTIONS(460),
    [anon_sym_volatile] = ACTIONS(460),
    [anon_sym_ATinterface] = ACTIONS(458),
    [anon_sym_interface] = ACTIONS(460),
    [anon_sym_byte] = ACTIONS(460),
    [anon_sym_short] = ACTIONS(460),
    [anon_sym_int] = ACTIONS(460),
    [anon_sym_long] = ACTIONS(460),
    [anon_sym_char] = ACTIONS(460),
    [anon_sym_float] = ACTIONS(460),
    [anon_sym_double] = ACTIONS(460),
    [sym_boolean_type] = ACTIONS(460),
    [sym_void_type] = ACTIONS(460),
    [sym_this] = ACTIONS(460),
    [sym_super] = ACTIONS(460),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(462),
    [sym_identifier] = ACTIONS(464),
    [sym_decimal_integer_literal] = ACTIONS(464),
    [sym_hex_integer_literal] = ACTIONS(464),
    [sym_octal_integer_literal] = ACTIONS(462),
    [sym_binary_integer_literal] = ACTIONS(462),
    [sym_decimal_floating_point_literal] = ACTIONS(462),
    [sym_hex_floating_point_literal] = ACTIONS(464),
    [sym_true] = ACTIONS(464),
    [sym_false] = ACTIONS(464),
    [sym_character_literal] = ACTIONS(462),
    [sym_string_literal] = ACTIONS(462),
    [sym_null_literal] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_PLUS] = ACTIONS(464),
    [anon_sym_DASH] = ACTIONS(464),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_TILDE] = ACTIONS(462),
    [anon_sym_PLUS_PLUS] = ACTIONS(462),
    [anon_sym_DASH_DASH] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(464),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(462),
    [anon_sym_RBRACE] = ACTIONS(462),
    [anon_sym_assert] = ACTIONS(464),
    [anon_sym_switch] = ACTIONS(464),
    [anon_sym_case] = ACTIONS(464),
    [anon_sym_default] = ACTIONS(464),
    [anon_sym_do] = ACTIONS(464),
    [anon_sym_while] = ACTIONS(464),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_continue] = ACTIONS(464),
    [anon_sym_return] = ACTIONS(464),
    [anon_sym_synchronized] = ACTIONS(464),
    [anon_sym_throw] = ACTIONS(464),
    [anon_sym_try] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(464),
    [anon_sym_else] = ACTIONS(464),
    [anon_sym_for] = ACTIONS(464),
    [anon_sym_AT] = ACTIONS(464),
    [anon_sym_open] = ACTIONS(464),
    [anon_sym_module] = ACTIONS(464),
    [anon_sym_static] = ACTIONS(464),
    [anon_sym_package] = ACTIONS(464),
    [anon_sym_import] = ACTIONS(464),
    [anon_sym_enum] = ACTIONS(464),
    [anon_sym_public] = ACTIONS(464),
    [anon_sym_protected] = ACTIONS(464),
    [anon_sym_private] = ACTIONS(464),
    [anon_sym_abstract] = ACTIONS(464),
    [anon_sym_final] = ACTIONS(464),
    [anon_sym_strictfp] = ACTIONS(464),
    [anon_sym_native] = ACTIONS(464),
    [anon_sym_transient] = ACTIONS(464),
    [anon_sym_volatile] = ACTIONS(464),
    [anon_sym_ATinterface] = ACTIONS(462),
    [anon_sym_interface] = ACTIONS(464),
    [anon_sym_byte] = ACTIONS(464),
    [anon_sym_short] = ACTIONS(464),
    [anon_sym_int] = ACTIONS(464),
    [anon_sym_long] = ACTIONS(464),
    [anon_sym_char] = ACTIONS(464),
    [anon_sym_float] = ACTIONS(464),
    [anon_sym_double] = ACTIONS(464),
    [sym_boolean_type] = ACTIONS(464),
    [sym_void_type] = ACTIONS(464),
    [sym_this] = ACTIONS(464),
    [sym_super] = ACTIONS(464),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(466),
    [sym_identifier] = ACTIONS(468),
    [sym_decimal_integer_literal] = ACTIONS(468),
    [sym_hex_integer_literal] = ACTIONS(468),
    [sym_octal_integer_literal] = ACTIONS(466),
    [sym_binary_integer_literal] = ACTIONS(466),
    [sym_decimal_floating_point_literal] = ACTIONS(466),
    [sym_hex_floating_point_literal] = ACTIONS(468),
    [sym_true] = ACTIONS(468),
    [sym_false] = ACTIONS(468),
    [sym_character_literal] = ACTIONS(466),
    [sym_string_literal] = ACTIONS(466),
    [sym_null_literal] = ACTIONS(468),
    [anon_sym_LPAREN] = ACTIONS(466),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_BANG] = ACTIONS(466),
    [anon_sym_TILDE] = ACTIONS(466),
    [anon_sym_PLUS_PLUS] = ACTIONS(466),
    [anon_sym_DASH_DASH] = ACTIONS(466),
    [anon_sym_new] = ACTIONS(468),
    [anon_sym_class] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_LBRACE] = ACTIONS(466),
    [anon_sym_RBRACE] = ACTIONS(466),
    [anon_sym_assert] = ACTIONS(468),
    [anon_sym_switch] = ACTIONS(468),
    [anon_sym_case] = ACTIONS(468),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_do] = ACTIONS(468),
    [anon_sym_while] = ACTIONS(468),
    [anon_sym_break] = ACTIONS(468),
    [anon_sym_continue] = ACTIONS(468),
    [anon_sym_return] = ACTIONS(468),
    [anon_sym_synchronized] = ACTIONS(468),
    [anon_sym_throw] = ACTIONS(468),
    [anon_sym_try] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(468),
    [anon_sym_else] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(468),
    [anon_sym_AT] = ACTIONS(468),
    [anon_sym_open] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(468),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_package] = ACTIONS(468),
    [anon_sym_import] = ACTIONS(468),
    [anon_sym_enum] = ACTIONS(468),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(468),
    [anon_sym_final] = ACTIONS(468),
    [anon_sym_strictfp] = ACTIONS(468),
    [anon_sym_native] = ACTIONS(468),
    [anon_sym_transient] = ACTIONS(468),
    [anon_sym_volatile] = ACTIONS(468),
    [anon_sym_ATinterface] = ACTIONS(466),
    [anon_sym_interface] = ACTIONS(468),
    [anon_sym_byte] = ACTIONS(468),
    [anon_sym_short] = ACTIONS(468),
    [anon_sym_int] = ACTIONS(468),
    [anon_sym_long] = ACTIONS(468),
    [anon_sym_char] = ACTIONS(468),
    [anon_sym_float] = ACTIONS(468),
    [anon_sym_double] = ACTIONS(468),
    [sym_boolean_type] = ACTIONS(468),
    [sym_void_type] = ACTIONS(468),
    [sym_this] = ACTIONS(468),
    [sym_super] = ACTIONS(468),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(470),
    [sym_identifier] = ACTIONS(472),
    [sym_decimal_integer_literal] = ACTIONS(472),
    [sym_hex_integer_literal] = ACTIONS(472),
    [sym_octal_integer_literal] = ACTIONS(470),
    [sym_binary_integer_literal] = ACTIONS(470),
    [sym_decimal_floating_point_literal] = ACTIONS(470),
    [sym_hex_floating_point_literal] = ACTIONS(472),
    [sym_true] = ACTIONS(472),
    [sym_false] = ACTIONS(472),
    [sym_character_literal] = ACTIONS(470),
    [sym_string_literal] = ACTIONS(470),
    [sym_null_literal] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_TILDE] = ACTIONS(470),
    [anon_sym_PLUS_PLUS] = ACTIONS(470),
    [anon_sym_DASH_DASH] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(472),
    [anon_sym_class] = ACTIONS(472),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(470),
    [anon_sym_RBRACE] = ACTIONS(470),
    [anon_sym_assert] = ACTIONS(472),
    [anon_sym_switch] = ACTIONS(472),
    [anon_sym_case] = ACTIONS(472),
    [anon_sym_default] = ACTIONS(472),
    [anon_sym_do] = ACTIONS(472),
    [anon_sym_while] = ACTIONS(472),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_continue] = ACTIONS(472),
    [anon_sym_return] = ACTIONS(472),
    [anon_sym_synchronized] = ACTIONS(472),
    [anon_sym_throw] = ACTIONS(472),
    [anon_sym_try] = ACTIONS(472),
    [anon_sym_if] = ACTIONS(472),
    [anon_sym_else] = ACTIONS(472),
    [anon_sym_for] = ACTIONS(472),
    [anon_sym_AT] = ACTIONS(472),
    [anon_sym_open] = ACTIONS(472),
    [anon_sym_module] = ACTIONS(472),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_package] = ACTIONS(472),
    [anon_sym_import] = ACTIONS(472),
    [anon_sym_enum] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(472),
    [anon_sym_protected] = ACTIONS(472),
    [anon_sym_private] = ACTIONS(472),
    [anon_sym_abstract] = ACTIONS(472),
    [anon_sym_final] = ACTIONS(472),
    [anon_sym_strictfp] = ACTIONS(472),
    [anon_sym_native] = ACTIONS(472),
    [anon_sym_transient] = ACTIONS(472),
    [anon_sym_volatile] = ACTIONS(472),
    [anon_sym_ATinterface] = ACTIONS(470),
    [anon_sym_interface] = ACTIONS(472),
    [anon_sym_byte] = ACTIONS(472),
    [anon_sym_short] = ACTIONS(472),
    [anon_sym_int] = ACTIONS(472),
    [anon_sym_long] = ACTIONS(472),
    [anon_sym_char] = ACTIONS(472),
    [anon_sym_float] = ACTIONS(472),
    [anon_sym_double] = ACTIONS(472),
    [sym_boolean_type] = ACTIONS(472),
    [sym_void_type] = ACTIONS(472),
    [sym_this] = ACTIONS(472),
    [sym_super] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(433),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym_array_initializer] = STATE(856),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(474),
    [sym_identifier] = ACTIONS(476),
    [sym_decimal_integer_literal] = ACTIONS(476),
    [sym_hex_integer_literal] = ACTIONS(476),
    [sym_octal_integer_literal] = ACTIONS(474),
    [sym_binary_integer_literal] = ACTIONS(474),
    [sym_decimal_floating_point_literal] = ACTIONS(474),
    [sym_hex_floating_point_literal] = ACTIONS(476),
    [sym_true] = ACTIONS(476),
    [sym_false] = ACTIONS(476),
    [sym_character_literal] = ACTIONS(474),
    [sym_string_literal] = ACTIONS(474),
    [sym_null_literal] = ACTIONS(476),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(474),
    [anon_sym_PLUS] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(476),
    [anon_sym_BANG] = ACTIONS(474),
    [anon_sym_TILDE] = ACTIONS(474),
    [anon_sym_PLUS_PLUS] = ACTIONS(474),
    [anon_sym_DASH_DASH] = ACTIONS(474),
    [anon_sym_new] = ACTIONS(476),
    [anon_sym_class] = ACTIONS(476),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LBRACE] = ACTIONS(474),
    [anon_sym_RBRACE] = ACTIONS(474),
    [anon_sym_assert] = ACTIONS(476),
    [anon_sym_switch] = ACTIONS(476),
    [anon_sym_case] = ACTIONS(476),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_do] = ACTIONS(476),
    [anon_sym_while] = ACTIONS(476),
    [anon_sym_break] = ACTIONS(476),
    [anon_sym_continue] = ACTIONS(476),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_synchronized] = ACTIONS(476),
    [anon_sym_throw] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(476),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_else] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(476),
    [anon_sym_AT] = ACTIONS(476),
    [anon_sym_open] = ACTIONS(476),
    [anon_sym_module] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_package] = ACTIONS(476),
    [anon_sym_import] = ACTIONS(476),
    [anon_sym_enum] = ACTIONS(476),
    [anon_sym_public] = ACTIONS(476),
    [anon_sym_protected] = ACTIONS(476),
    [anon_sym_private] = ACTIONS(476),
    [anon_sym_abstract] = ACTIONS(476),
    [anon_sym_final] = ACTIONS(476),
    [anon_sym_strictfp] = ACTIONS(476),
    [anon_sym_native] = ACTIONS(476),
    [anon_sym_transient] = ACTIONS(476),
    [anon_sym_volatile] = ACTIONS(476),
    [anon_sym_ATinterface] = ACTIONS(474),
    [anon_sym_interface] = ACTIONS(476),
    [anon_sym_byte] = ACTIONS(476),
    [anon_sym_short] = ACTIONS(476),
    [anon_sym_int] = ACTIONS(476),
    [anon_sym_long] = ACTIONS(476),
    [anon_sym_char] = ACTIONS(476),
    [anon_sym_float] = ACTIONS(476),
    [anon_sym_double] = ACTIONS(476),
    [sym_boolean_type] = ACTIONS(476),
    [sym_void_type] = ACTIONS(476),
    [sym_this] = ACTIONS(476),
    [sym_super] = ACTIONS(476),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(478),
    [sym_identifier] = ACTIONS(480),
    [sym_decimal_integer_literal] = ACTIONS(480),
    [sym_hex_integer_literal] = ACTIONS(480),
    [sym_octal_integer_literal] = ACTIONS(478),
    [sym_binary_integer_literal] = ACTIONS(478),
    [sym_decimal_floating_point_literal] = ACTIONS(478),
    [sym_hex_floating_point_literal] = ACTIONS(480),
    [sym_true] = ACTIONS(480),
    [sym_false] = ACTIONS(480),
    [sym_character_literal] = ACTIONS(478),
    [sym_string_literal] = ACTIONS(478),
    [sym_null_literal] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(480),
    [anon_sym_BANG] = ACTIONS(478),
    [anon_sym_TILDE] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_new] = ACTIONS(480),
    [anon_sym_class] = ACTIONS(480),
    [anon_sym_SEMI] = ACTIONS(478),
    [anon_sym_LBRACE] = ACTIONS(478),
    [anon_sym_RBRACE] = ACTIONS(478),
    [anon_sym_assert] = ACTIONS(480),
    [anon_sym_switch] = ACTIONS(480),
    [anon_sym_case] = ACTIONS(480),
    [anon_sym_default] = ACTIONS(480),
    [anon_sym_do] = ACTIONS(480),
    [anon_sym_while] = ACTIONS(480),
    [anon_sym_break] = ACTIONS(480),
    [anon_sym_continue] = ACTIONS(480),
    [anon_sym_return] = ACTIONS(480),
    [anon_sym_synchronized] = ACTIONS(480),
    [anon_sym_throw] = ACTIONS(480),
    [anon_sym_try] = ACTIONS(480),
    [anon_sym_if] = ACTIONS(480),
    [anon_sym_else] = ACTIONS(480),
    [anon_sym_for] = ACTIONS(480),
    [anon_sym_AT] = ACTIONS(480),
    [anon_sym_open] = ACTIONS(480),
    [anon_sym_module] = ACTIONS(480),
    [anon_sym_static] = ACTIONS(480),
    [anon_sym_package] = ACTIONS(480),
    [anon_sym_import] = ACTIONS(480),
    [anon_sym_enum] = ACTIONS(480),
    [anon_sym_public] = ACTIONS(480),
    [anon_sym_protected] = ACTIONS(480),
    [anon_sym_private] = ACTIONS(480),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_final] = ACTIONS(480),
    [anon_sym_strictfp] = ACTIONS(480),
    [anon_sym_native] = ACTIONS(480),
    [anon_sym_transient] = ACTIONS(480),
    [anon_sym_volatile] = ACTIONS(480),
    [anon_sym_ATinterface] = ACTIONS(478),
    [anon_sym_interface] = ACTIONS(480),
    [anon_sym_byte] = ACTIONS(480),
    [anon_sym_short] = ACTIONS(480),
    [anon_sym_int] = ACTIONS(480),
    [anon_sym_long] = ACTIONS(480),
    [anon_sym_char] = ACTIONS(480),
    [anon_sym_float] = ACTIONS(480),
    [anon_sym_double] = ACTIONS(480),
    [sym_boolean_type] = ACTIONS(480),
    [sym_void_type] = ACTIONS(480),
    [sym_this] = ACTIONS(480),
    [sym_super] = ACTIONS(480),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(482),
    [sym_identifier] = ACTIONS(484),
    [sym_decimal_integer_literal] = ACTIONS(484),
    [sym_hex_integer_literal] = ACTIONS(484),
    [sym_octal_integer_literal] = ACTIONS(482),
    [sym_binary_integer_literal] = ACTIONS(482),
    [sym_decimal_floating_point_literal] = ACTIONS(482),
    [sym_hex_floating_point_literal] = ACTIONS(484),
    [sym_true] = ACTIONS(484),
    [sym_false] = ACTIONS(484),
    [sym_character_literal] = ACTIONS(482),
    [sym_string_literal] = ACTIONS(482),
    [sym_null_literal] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(482),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(484),
    [anon_sym_DASH] = ACTIONS(484),
    [anon_sym_BANG] = ACTIONS(482),
    [anon_sym_TILDE] = ACTIONS(482),
    [anon_sym_PLUS_PLUS] = ACTIONS(482),
    [anon_sym_DASH_DASH] = ACTIONS(482),
    [anon_sym_new] = ACTIONS(484),
    [anon_sym_class] = ACTIONS(484),
    [anon_sym_SEMI] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(482),
    [anon_sym_RBRACE] = ACTIONS(482),
    [anon_sym_assert] = ACTIONS(484),
    [anon_sym_switch] = ACTIONS(484),
    [anon_sym_case] = ACTIONS(484),
    [anon_sym_default] = ACTIONS(484),
    [anon_sym_do] = ACTIONS(484),
    [anon_sym_while] = ACTIONS(484),
    [anon_sym_break] = ACTIONS(484),
    [anon_sym_continue] = ACTIONS(484),
    [anon_sym_return] = ACTIONS(484),
    [anon_sym_synchronized] = ACTIONS(484),
    [anon_sym_throw] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(484),
    [anon_sym_if] = ACTIONS(484),
    [anon_sym_else] = ACTIONS(484),
    [anon_sym_for] = ACTIONS(484),
    [anon_sym_AT] = ACTIONS(484),
    [anon_sym_open] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(484),
    [anon_sym_static] = ACTIONS(484),
    [anon_sym_package] = ACTIONS(484),
    [anon_sym_import] = ACTIONS(484),
    [anon_sym_enum] = ACTIONS(484),
    [anon_sym_public] = ACTIONS(484),
    [anon_sym_protected] = ACTIONS(484),
    [anon_sym_private] = ACTIONS(484),
    [anon_sym_abstract] = ACTIONS(484),
    [anon_sym_final] = ACTIONS(484),
    [anon_sym_strictfp] = ACTIONS(484),
    [anon_sym_native] = ACTIONS(484),
    [anon_sym_transient] = ACTIONS(484),
    [anon_sym_volatile] = ACTIONS(484),
    [anon_sym_ATinterface] = ACTIONS(482),
    [anon_sym_interface] = ACTIONS(484),
    [anon_sym_byte] = ACTIONS(484),
    [anon_sym_short] = ACTIONS(484),
    [anon_sym_int] = ACTIONS(484),
    [anon_sym_long] = ACTIONS(484),
    [anon_sym_char] = ACTIONS(484),
    [anon_sym_float] = ACTIONS(484),
    [anon_sym_double] = ACTIONS(484),
    [sym_boolean_type] = ACTIONS(484),
    [sym_void_type] = ACTIONS(484),
    [sym_this] = ACTIONS(484),
    [sym_super] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(486),
    [sym_identifier] = ACTIONS(488),
    [sym_decimal_integer_literal] = ACTIONS(488),
    [sym_hex_integer_literal] = ACTIONS(488),
    [sym_octal_integer_literal] = ACTIONS(486),
    [sym_binary_integer_literal] = ACTIONS(486),
    [sym_decimal_floating_point_literal] = ACTIONS(486),
    [sym_hex_floating_point_literal] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_character_literal] = ACTIONS(486),
    [sym_string_literal] = ACTIONS(486),
    [sym_null_literal] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LT] = ACTIONS(486),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_BANG] = ACTIONS(486),
    [anon_sym_TILDE] = ACTIONS(486),
    [anon_sym_PLUS_PLUS] = ACTIONS(486),
    [anon_sym_DASH_DASH] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_class] = ACTIONS(488),
    [anon_sym_SEMI] = ACTIONS(486),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_RBRACE] = ACTIONS(486),
    [anon_sym_assert] = ACTIONS(488),
    [anon_sym_switch] = ACTIONS(488),
    [anon_sym_case] = ACTIONS(488),
    [anon_sym_default] = ACTIONS(488),
    [anon_sym_do] = ACTIONS(488),
    [anon_sym_while] = ACTIONS(488),
    [anon_sym_break] = ACTIONS(488),
    [anon_sym_continue] = ACTIONS(488),
    [anon_sym_return] = ACTIONS(488),
    [anon_sym_synchronized] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(488),
    [anon_sym_try] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_open] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(488),
    [anon_sym_static] = ACTIONS(488),
    [anon_sym_package] = ACTIONS(488),
    [anon_sym_import] = ACTIONS(488),
    [anon_sym_enum] = ACTIONS(488),
    [anon_sym_public] = ACTIONS(488),
    [anon_sym_protected] = ACTIONS(488),
    [anon_sym_private] = ACTIONS(488),
    [anon_sym_abstract] = ACTIONS(488),
    [anon_sym_final] = ACTIONS(488),
    [anon_sym_strictfp] = ACTIONS(488),
    [anon_sym_native] = ACTIONS(488),
    [anon_sym_transient] = ACTIONS(488),
    [anon_sym_volatile] = ACTIONS(488),
    [anon_sym_ATinterface] = ACTIONS(486),
    [anon_sym_interface] = ACTIONS(488),
    [anon_sym_byte] = ACTIONS(488),
    [anon_sym_short] = ACTIONS(488),
    [anon_sym_int] = ACTIONS(488),
    [anon_sym_long] = ACTIONS(488),
    [anon_sym_char] = ACTIONS(488),
    [anon_sym_float] = ACTIONS(488),
    [anon_sym_double] = ACTIONS(488),
    [sym_boolean_type] = ACTIONS(488),
    [sym_void_type] = ACTIONS(488),
    [sym_this] = ACTIONS(488),
    [sym_super] = ACTIONS(488),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(490),
    [sym_identifier] = ACTIONS(492),
    [sym_decimal_integer_literal] = ACTIONS(492),
    [sym_hex_integer_literal] = ACTIONS(492),
    [sym_octal_integer_literal] = ACTIONS(490),
    [sym_binary_integer_literal] = ACTIONS(490),
    [sym_decimal_floating_point_literal] = ACTIONS(490),
    [sym_hex_floating_point_literal] = ACTIONS(492),
    [sym_true] = ACTIONS(492),
    [sym_false] = ACTIONS(492),
    [sym_character_literal] = ACTIONS(490),
    [sym_string_literal] = ACTIONS(490),
    [sym_null_literal] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_PLUS] = ACTIONS(492),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(490),
    [anon_sym_TILDE] = ACTIONS(490),
    [anon_sym_PLUS_PLUS] = ACTIONS(490),
    [anon_sym_DASH_DASH] = ACTIONS(490),
    [anon_sym_new] = ACTIONS(492),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_SEMI] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(490),
    [anon_sym_RBRACE] = ACTIONS(490),
    [anon_sym_assert] = ACTIONS(492),
    [anon_sym_switch] = ACTIONS(492),
    [anon_sym_case] = ACTIONS(492),
    [anon_sym_default] = ACTIONS(492),
    [anon_sym_do] = ACTIONS(492),
    [anon_sym_while] = ACTIONS(492),
    [anon_sym_break] = ACTIONS(492),
    [anon_sym_continue] = ACTIONS(492),
    [anon_sym_return] = ACTIONS(492),
    [anon_sym_synchronized] = ACTIONS(492),
    [anon_sym_throw] = ACTIONS(492),
    [anon_sym_try] = ACTIONS(492),
    [anon_sym_if] = ACTIONS(492),
    [anon_sym_else] = ACTIONS(492),
    [anon_sym_for] = ACTIONS(492),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_open] = ACTIONS(492),
    [anon_sym_module] = ACTIONS(492),
    [anon_sym_static] = ACTIONS(492),
    [anon_sym_package] = ACTIONS(492),
    [anon_sym_import] = ACTIONS(492),
    [anon_sym_enum] = ACTIONS(492),
    [anon_sym_public] = ACTIONS(492),
    [anon_sym_protected] = ACTIONS(492),
    [anon_sym_private] = ACTIONS(492),
    [anon_sym_abstract] = ACTIONS(492),
    [anon_sym_final] = ACTIONS(492),
    [anon_sym_strictfp] = ACTIONS(492),
    [anon_sym_native] = ACTIONS(492),
    [anon_sym_transient] = ACTIONS(492),
    [anon_sym_volatile] = ACTIONS(492),
    [anon_sym_ATinterface] = ACTIONS(490),
    [anon_sym_interface] = ACTIONS(492),
    [anon_sym_byte] = ACTIONS(492),
    [anon_sym_short] = ACTIONS(492),
    [anon_sym_int] = ACTIONS(492),
    [anon_sym_long] = ACTIONS(492),
    [anon_sym_char] = ACTIONS(492),
    [anon_sym_float] = ACTIONS(492),
    [anon_sym_double] = ACTIONS(492),
    [sym_boolean_type] = ACTIONS(492),
    [sym_void_type] = ACTIONS(492),
    [sym_this] = ACTIONS(492),
    [sym_super] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(494),
    [sym_identifier] = ACTIONS(496),
    [sym_decimal_integer_literal] = ACTIONS(496),
    [sym_hex_integer_literal] = ACTIONS(496),
    [sym_octal_integer_literal] = ACTIONS(494),
    [sym_binary_integer_literal] = ACTIONS(494),
    [sym_decimal_floating_point_literal] = ACTIONS(494),
    [sym_hex_floating_point_literal] = ACTIONS(496),
    [sym_true] = ACTIONS(496),
    [sym_false] = ACTIONS(496),
    [sym_character_literal] = ACTIONS(494),
    [sym_string_literal] = ACTIONS(494),
    [sym_null_literal] = ACTIONS(496),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(494),
    [anon_sym_PLUS_PLUS] = ACTIONS(494),
    [anon_sym_DASH_DASH] = ACTIONS(494),
    [anon_sym_new] = ACTIONS(496),
    [anon_sym_class] = ACTIONS(496),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_assert] = ACTIONS(496),
    [anon_sym_switch] = ACTIONS(496),
    [anon_sym_case] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(496),
    [anon_sym_do] = ACTIONS(496),
    [anon_sym_while] = ACTIONS(496),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_return] = ACTIONS(496),
    [anon_sym_synchronized] = ACTIONS(496),
    [anon_sym_throw] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_else] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(496),
    [anon_sym_open] = ACTIONS(496),
    [anon_sym_module] = ACTIONS(496),
    [anon_sym_static] = ACTIONS(496),
    [anon_sym_package] = ACTIONS(496),
    [anon_sym_import] = ACTIONS(496),
    [anon_sym_enum] = ACTIONS(496),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_abstract] = ACTIONS(496),
    [anon_sym_final] = ACTIONS(496),
    [anon_sym_strictfp] = ACTIONS(496),
    [anon_sym_native] = ACTIONS(496),
    [anon_sym_transient] = ACTIONS(496),
    [anon_sym_volatile] = ACTIONS(496),
    [anon_sym_ATinterface] = ACTIONS(494),
    [anon_sym_interface] = ACTIONS(496),
    [anon_sym_byte] = ACTIONS(496),
    [anon_sym_short] = ACTIONS(496),
    [anon_sym_int] = ACTIONS(496),
    [anon_sym_long] = ACTIONS(496),
    [anon_sym_char] = ACTIONS(496),
    [anon_sym_float] = ACTIONS(496),
    [anon_sym_double] = ACTIONS(496),
    [sym_boolean_type] = ACTIONS(496),
    [sym_void_type] = ACTIONS(496),
    [sym_this] = ACTIONS(496),
    [sym_super] = ACTIONS(496),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(498),
    [sym_identifier] = ACTIONS(500),
    [sym_decimal_integer_literal] = ACTIONS(500),
    [sym_hex_integer_literal] = ACTIONS(500),
    [sym_octal_integer_literal] = ACTIONS(498),
    [sym_binary_integer_literal] = ACTIONS(498),
    [sym_decimal_floating_point_literal] = ACTIONS(498),
    [sym_hex_floating_point_literal] = ACTIONS(500),
    [sym_true] = ACTIONS(500),
    [sym_false] = ACTIONS(500),
    [sym_character_literal] = ACTIONS(498),
    [sym_string_literal] = ACTIONS(498),
    [sym_null_literal] = ACTIONS(500),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(498),
    [anon_sym_PLUS] = ACTIONS(500),
    [anon_sym_DASH] = ACTIONS(500),
    [anon_sym_BANG] = ACTIONS(498),
    [anon_sym_TILDE] = ACTIONS(498),
    [anon_sym_PLUS_PLUS] = ACTIONS(498),
    [anon_sym_DASH_DASH] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(500),
    [anon_sym_class] = ACTIONS(500),
    [anon_sym_SEMI] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(498),
    [anon_sym_RBRACE] = ACTIONS(498),
    [anon_sym_assert] = ACTIONS(500),
    [anon_sym_switch] = ACTIONS(500),
    [anon_sym_case] = ACTIONS(500),
    [anon_sym_default] = ACTIONS(500),
    [anon_sym_do] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(500),
    [anon_sym_break] = ACTIONS(500),
    [anon_sym_continue] = ACTIONS(500),
    [anon_sym_return] = ACTIONS(500),
    [anon_sym_synchronized] = ACTIONS(500),
    [anon_sym_throw] = ACTIONS(500),
    [anon_sym_try] = ACTIONS(500),
    [anon_sym_if] = ACTIONS(500),
    [anon_sym_else] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_AT] = ACTIONS(500),
    [anon_sym_open] = ACTIONS(500),
    [anon_sym_module] = ACTIONS(500),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_package] = ACTIONS(500),
    [anon_sym_import] = ACTIONS(500),
    [anon_sym_enum] = ACTIONS(500),
    [anon_sym_public] = ACTIONS(500),
    [anon_sym_protected] = ACTIONS(500),
    [anon_sym_private] = ACTIONS(500),
    [anon_sym_abstract] = ACTIONS(500),
    [anon_sym_final] = ACTIONS(500),
    [anon_sym_strictfp] = ACTIONS(500),
    [anon_sym_native] = ACTIONS(500),
    [anon_sym_transient] = ACTIONS(500),
    [anon_sym_volatile] = ACTIONS(500),
    [anon_sym_ATinterface] = ACTIONS(498),
    [anon_sym_interface] = ACTIONS(500),
    [anon_sym_byte] = ACTIONS(500),
    [anon_sym_short] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_long] = ACTIONS(500),
    [anon_sym_char] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_double] = ACTIONS(500),
    [sym_boolean_type] = ACTIONS(500),
    [sym_void_type] = ACTIONS(500),
    [sym_this] = ACTIONS(500),
    [sym_super] = ACTIONS(500),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(502),
    [sym_identifier] = ACTIONS(504),
    [sym_decimal_integer_literal] = ACTIONS(504),
    [sym_hex_integer_literal] = ACTIONS(504),
    [sym_octal_integer_literal] = ACTIONS(502),
    [sym_binary_integer_literal] = ACTIONS(502),
    [sym_decimal_floating_point_literal] = ACTIONS(502),
    [sym_hex_floating_point_literal] = ACTIONS(504),
    [sym_true] = ACTIONS(504),
    [sym_false] = ACTIONS(504),
    [sym_character_literal] = ACTIONS(502),
    [sym_string_literal] = ACTIONS(502),
    [sym_null_literal] = ACTIONS(504),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(504),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_BANG] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(502),
    [anon_sym_DASH_DASH] = ACTIONS(502),
    [anon_sym_new] = ACTIONS(504),
    [anon_sym_class] = ACTIONS(504),
    [anon_sym_SEMI] = ACTIONS(502),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_RBRACE] = ACTIONS(502),
    [anon_sym_assert] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(504),
    [anon_sym_case] = ACTIONS(504),
    [anon_sym_default] = ACTIONS(504),
    [anon_sym_do] = ACTIONS(504),
    [anon_sym_while] = ACTIONS(504),
    [anon_sym_break] = ACTIONS(504),
    [anon_sym_continue] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(504),
    [anon_sym_synchronized] = ACTIONS(504),
    [anon_sym_throw] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(504),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_else] = ACTIONS(504),
    [anon_sym_for] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(504),
    [anon_sym_open] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(504),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_package] = ACTIONS(504),
    [anon_sym_import] = ACTIONS(504),
    [anon_sym_enum] = ACTIONS(504),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(504),
    [anon_sym_final] = ACTIONS(504),
    [anon_sym_strictfp] = ACTIONS(504),
    [anon_sym_native] = ACTIONS(504),
    [anon_sym_transient] = ACTIONS(504),
    [anon_sym_volatile] = ACTIONS(504),
    [anon_sym_ATinterface] = ACTIONS(502),
    [anon_sym_interface] = ACTIONS(504),
    [anon_sym_byte] = ACTIONS(504),
    [anon_sym_short] = ACTIONS(504),
    [anon_sym_int] = ACTIONS(504),
    [anon_sym_long] = ACTIONS(504),
    [anon_sym_char] = ACTIONS(504),
    [anon_sym_float] = ACTIONS(504),
    [anon_sym_double] = ACTIONS(504),
    [sym_boolean_type] = ACTIONS(504),
    [sym_void_type] = ACTIONS(504),
    [sym_this] = ACTIONS(504),
    [sym_super] = ACTIONS(504),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [sym_decimal_integer_literal] = ACTIONS(508),
    [sym_hex_integer_literal] = ACTIONS(508),
    [sym_octal_integer_literal] = ACTIONS(506),
    [sym_binary_integer_literal] = ACTIONS(506),
    [sym_decimal_floating_point_literal] = ACTIONS(506),
    [sym_hex_floating_point_literal] = ACTIONS(508),
    [sym_true] = ACTIONS(508),
    [sym_false] = ACTIONS(508),
    [sym_character_literal] = ACTIONS(506),
    [sym_string_literal] = ACTIONS(506),
    [sym_null_literal] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_BANG] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_SEMI] = ACTIONS(506),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_assert] = ACTIONS(508),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_synchronized] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_open] = ACTIONS(508),
    [anon_sym_module] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_protected] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_strictfp] = ACTIONS(508),
    [anon_sym_native] = ACTIONS(508),
    [anon_sym_transient] = ACTIONS(508),
    [anon_sym_volatile] = ACTIONS(508),
    [anon_sym_ATinterface] = ACTIONS(506),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_byte] = ACTIONS(508),
    [anon_sym_short] = ACTIONS(508),
    [anon_sym_int] = ACTIONS(508),
    [anon_sym_long] = ACTIONS(508),
    [anon_sym_char] = ACTIONS(508),
    [anon_sym_float] = ACTIONS(508),
    [anon_sym_double] = ACTIONS(508),
    [sym_boolean_type] = ACTIONS(508),
    [sym_void_type] = ACTIONS(508),
    [sym_this] = ACTIONS(508),
    [sym_super] = ACTIONS(508),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(510),
    [sym_identifier] = ACTIONS(512),
    [sym_decimal_integer_literal] = ACTIONS(512),
    [sym_hex_integer_literal] = ACTIONS(512),
    [sym_octal_integer_literal] = ACTIONS(510),
    [sym_binary_integer_literal] = ACTIONS(510),
    [sym_decimal_floating_point_literal] = ACTIONS(510),
    [sym_hex_floating_point_literal] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_character_literal] = ACTIONS(510),
    [sym_string_literal] = ACTIONS(510),
    [sym_null_literal] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(510),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_PLUS] = ACTIONS(512),
    [anon_sym_DASH] = ACTIONS(512),
    [anon_sym_BANG] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_PLUS_PLUS] = ACTIONS(510),
    [anon_sym_DASH_DASH] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(512),
    [anon_sym_class] = ACTIONS(512),
    [anon_sym_SEMI] = ACTIONS(510),
    [anon_sym_LBRACE] = ACTIONS(510),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_assert] = ACTIONS(512),
    [anon_sym_switch] = ACTIONS(512),
    [anon_sym_case] = ACTIONS(512),
    [anon_sym_default] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(512),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_break] = ACTIONS(512),
    [anon_sym_continue] = ACTIONS(512),
    [anon_sym_return] = ACTIONS(512),
    [anon_sym_synchronized] = ACTIONS(512),
    [anon_sym_throw] = ACTIONS(512),
    [anon_sym_try] = ACTIONS(512),
    [anon_sym_if] = ACTIONS(512),
    [anon_sym_else] = ACTIONS(512),
    [anon_sym_for] = ACTIONS(512),
    [anon_sym_AT] = ACTIONS(512),
    [anon_sym_open] = ACTIONS(512),
    [anon_sym_module] = ACTIONS(512),
    [anon_sym_static] = ACTIONS(512),
    [anon_sym_package] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(512),
    [anon_sym_enum] = ACTIONS(512),
    [anon_sym_public] = ACTIONS(512),
    [anon_sym_protected] = ACTIONS(512),
    [anon_sym_private] = ACTIONS(512),
    [anon_sym_abstract] = ACTIONS(512),
    [anon_sym_final] = ACTIONS(512),
    [anon_sym_strictfp] = ACTIONS(512),
    [anon_sym_native] = ACTIONS(512),
    [anon_sym_transient] = ACTIONS(512),
    [anon_sym_volatile] = ACTIONS(512),
    [anon_sym_ATinterface] = ACTIONS(510),
    [anon_sym_interface] = ACTIONS(512),
    [anon_sym_byte] = ACTIONS(512),
    [anon_sym_short] = ACTIONS(512),
    [anon_sym_int] = ACTIONS(512),
    [anon_sym_long] = ACTIONS(512),
    [anon_sym_char] = ACTIONS(512),
    [anon_sym_float] = ACTIONS(512),
    [anon_sym_double] = ACTIONS(512),
    [sym_boolean_type] = ACTIONS(512),
    [sym_void_type] = ACTIONS(512),
    [sym_this] = ACTIONS(512),
    [sym_super] = ACTIONS(512),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(514),
    [sym_identifier] = ACTIONS(516),
    [sym_decimal_integer_literal] = ACTIONS(516),
    [sym_hex_integer_literal] = ACTIONS(516),
    [sym_octal_integer_literal] = ACTIONS(514),
    [sym_binary_integer_literal] = ACTIONS(514),
    [sym_decimal_floating_point_literal] = ACTIONS(514),
    [sym_hex_floating_point_literal] = ACTIONS(516),
    [sym_true] = ACTIONS(516),
    [sym_false] = ACTIONS(516),
    [sym_character_literal] = ACTIONS(514),
    [sym_string_literal] = ACTIONS(514),
    [sym_null_literal] = ACTIONS(516),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(514),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_BANG] = ACTIONS(514),
    [anon_sym_TILDE] = ACTIONS(514),
    [anon_sym_PLUS_PLUS] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(514),
    [anon_sym_new] = ACTIONS(516),
    [anon_sym_class] = ACTIONS(516),
    [anon_sym_SEMI] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_RBRACE] = ACTIONS(514),
    [anon_sym_assert] = ACTIONS(516),
    [anon_sym_switch] = ACTIONS(516),
    [anon_sym_case] = ACTIONS(516),
    [anon_sym_default] = ACTIONS(516),
    [anon_sym_do] = ACTIONS(516),
    [anon_sym_while] = ACTIONS(516),
    [anon_sym_break] = ACTIONS(516),
    [anon_sym_continue] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(516),
    [anon_sym_synchronized] = ACTIONS(516),
    [anon_sym_throw] = ACTIONS(516),
    [anon_sym_try] = ACTIONS(516),
    [anon_sym_if] = ACTIONS(516),
    [anon_sym_else] = ACTIONS(516),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_open] = ACTIONS(516),
    [anon_sym_module] = ACTIONS(516),
    [anon_sym_static] = ACTIONS(516),
    [anon_sym_package] = ACTIONS(516),
    [anon_sym_import] = ACTIONS(516),
    [anon_sym_enum] = ACTIONS(516),
    [anon_sym_public] = ACTIONS(516),
    [anon_sym_protected] = ACTIONS(516),
    [anon_sym_private] = ACTIONS(516),
    [anon_sym_abstract] = ACTIONS(516),
    [anon_sym_final] = ACTIONS(516),
    [anon_sym_strictfp] = ACTIONS(516),
    [anon_sym_native] = ACTIONS(516),
    [anon_sym_transient] = ACTIONS(516),
    [anon_sym_volatile] = ACTIONS(516),
    [anon_sym_ATinterface] = ACTIONS(514),
    [anon_sym_interface] = ACTIONS(516),
    [anon_sym_byte] = ACTIONS(516),
    [anon_sym_short] = ACTIONS(516),
    [anon_sym_int] = ACTIONS(516),
    [anon_sym_long] = ACTIONS(516),
    [anon_sym_char] = ACTIONS(516),
    [anon_sym_float] = ACTIONS(516),
    [anon_sym_double] = ACTIONS(516),
    [sym_boolean_type] = ACTIONS(516),
    [sym_void_type] = ACTIONS(516),
    [sym_this] = ACTIONS(516),
    [sym_super] = ACTIONS(516),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(518),
    [sym_identifier] = ACTIONS(520),
    [sym_decimal_integer_literal] = ACTIONS(520),
    [sym_hex_integer_literal] = ACTIONS(520),
    [sym_octal_integer_literal] = ACTIONS(518),
    [sym_binary_integer_literal] = ACTIONS(518),
    [sym_decimal_floating_point_literal] = ACTIONS(518),
    [sym_hex_floating_point_literal] = ACTIONS(520),
    [sym_true] = ACTIONS(520),
    [sym_false] = ACTIONS(520),
    [sym_character_literal] = ACTIONS(518),
    [sym_string_literal] = ACTIONS(518),
    [sym_null_literal] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(518),
    [anon_sym_LT] = ACTIONS(518),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [anon_sym_new] = ACTIONS(520),
    [anon_sym_class] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_assert] = ACTIONS(520),
    [anon_sym_switch] = ACTIONS(520),
    [anon_sym_case] = ACTIONS(520),
    [anon_sym_default] = ACTIONS(520),
    [anon_sym_do] = ACTIONS(520),
    [anon_sym_while] = ACTIONS(520),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(520),
    [anon_sym_return] = ACTIONS(520),
    [anon_sym_synchronized] = ACTIONS(520),
    [anon_sym_throw] = ACTIONS(520),
    [anon_sym_try] = ACTIONS(520),
    [anon_sym_if] = ACTIONS(520),
    [anon_sym_else] = ACTIONS(520),
    [anon_sym_for] = ACTIONS(520),
    [anon_sym_AT] = ACTIONS(520),
    [anon_sym_open] = ACTIONS(520),
    [anon_sym_module] = ACTIONS(520),
    [anon_sym_static] = ACTIONS(520),
    [anon_sym_package] = ACTIONS(520),
    [anon_sym_import] = ACTIONS(520),
    [anon_sym_enum] = ACTIONS(520),
    [anon_sym_public] = ACTIONS(520),
    [anon_sym_protected] = ACTIONS(520),
    [anon_sym_private] = ACTIONS(520),
    [anon_sym_abstract] = ACTIONS(520),
    [anon_sym_final] = ACTIONS(520),
    [anon_sym_strictfp] = ACTIONS(520),
    [anon_sym_native] = ACTIONS(520),
    [anon_sym_transient] = ACTIONS(520),
    [anon_sym_volatile] = ACTIONS(520),
    [anon_sym_ATinterface] = ACTIONS(518),
    [anon_sym_interface] = ACTIONS(520),
    [anon_sym_byte] = ACTIONS(520),
    [anon_sym_short] = ACTIONS(520),
    [anon_sym_int] = ACTIONS(520),
    [anon_sym_long] = ACTIONS(520),
    [anon_sym_char] = ACTIONS(520),
    [anon_sym_float] = ACTIONS(520),
    [anon_sym_double] = ACTIONS(520),
    [sym_boolean_type] = ACTIONS(520),
    [sym_void_type] = ACTIONS(520),
    [sym_this] = ACTIONS(520),
    [sym_super] = ACTIONS(520),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(522),
    [sym_identifier] = ACTIONS(524),
    [sym_decimal_integer_literal] = ACTIONS(524),
    [sym_hex_integer_literal] = ACTIONS(524),
    [sym_octal_integer_literal] = ACTIONS(522),
    [sym_binary_integer_literal] = ACTIONS(522),
    [sym_decimal_floating_point_literal] = ACTIONS(522),
    [sym_hex_floating_point_literal] = ACTIONS(524),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_character_literal] = ACTIONS(522),
    [sym_string_literal] = ACTIONS(522),
    [sym_null_literal] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_BANG] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(522),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_DASH_DASH] = ACTIONS(522),
    [anon_sym_new] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(524),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_LBRACE] = ACTIONS(522),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_assert] = ACTIONS(524),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(524),
    [anon_sym_default] = ACTIONS(524),
    [anon_sym_do] = ACTIONS(524),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_break] = ACTIONS(524),
    [anon_sym_continue] = ACTIONS(524),
    [anon_sym_return] = ACTIONS(524),
    [anon_sym_synchronized] = ACTIONS(524),
    [anon_sym_throw] = ACTIONS(524),
    [anon_sym_try] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_else] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_open] = ACTIONS(524),
    [anon_sym_module] = ACTIONS(524),
    [anon_sym_static] = ACTIONS(524),
    [anon_sym_package] = ACTIONS(524),
    [anon_sym_import] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_public] = ACTIONS(524),
    [anon_sym_protected] = ACTIONS(524),
    [anon_sym_private] = ACTIONS(524),
    [anon_sym_abstract] = ACTIONS(524),
    [anon_sym_final] = ACTIONS(524),
    [anon_sym_strictfp] = ACTIONS(524),
    [anon_sym_native] = ACTIONS(524),
    [anon_sym_transient] = ACTIONS(524),
    [anon_sym_volatile] = ACTIONS(524),
    [anon_sym_ATinterface] = ACTIONS(522),
    [anon_sym_interface] = ACTIONS(524),
    [anon_sym_byte] = ACTIONS(524),
    [anon_sym_short] = ACTIONS(524),
    [anon_sym_int] = ACTIONS(524),
    [anon_sym_long] = ACTIONS(524),
    [anon_sym_char] = ACTIONS(524),
    [anon_sym_float] = ACTIONS(524),
    [anon_sym_double] = ACTIONS(524),
    [sym_boolean_type] = ACTIONS(524),
    [sym_void_type] = ACTIONS(524),
    [sym_this] = ACTIONS(524),
    [sym_super] = ACTIONS(524),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(526),
    [sym_identifier] = ACTIONS(528),
    [sym_decimal_integer_literal] = ACTIONS(528),
    [sym_hex_integer_literal] = ACTIONS(528),
    [sym_octal_integer_literal] = ACTIONS(526),
    [sym_binary_integer_literal] = ACTIONS(526),
    [sym_decimal_floating_point_literal] = ACTIONS(526),
    [sym_hex_floating_point_literal] = ACTIONS(528),
    [sym_true] = ACTIONS(528),
    [sym_false] = ACTIONS(528),
    [sym_character_literal] = ACTIONS(526),
    [sym_string_literal] = ACTIONS(526),
    [sym_null_literal] = ACTIONS(528),
    [anon_sym_LPAREN] = ACTIONS(526),
    [anon_sym_LT] = ACTIONS(526),
    [anon_sym_PLUS] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(528),
    [anon_sym_BANG] = ACTIONS(526),
    [anon_sym_TILDE] = ACTIONS(526),
    [anon_sym_PLUS_PLUS] = ACTIONS(526),
    [anon_sym_DASH_DASH] = ACTIONS(526),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_class] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(526),
    [anon_sym_RBRACE] = ACTIONS(526),
    [anon_sym_assert] = ACTIONS(528),
    [anon_sym_switch] = ACTIONS(528),
    [anon_sym_case] = ACTIONS(528),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_do] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(528),
    [anon_sym_continue] = ACTIONS(528),
    [anon_sym_return] = ACTIONS(528),
    [anon_sym_synchronized] = ACTIONS(528),
    [anon_sym_throw] = ACTIONS(528),
    [anon_sym_try] = ACTIONS(528),
    [anon_sym_if] = ACTIONS(528),
    [anon_sym_else] = ACTIONS(528),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_AT] = ACTIONS(528),
    [anon_sym_open] = ACTIONS(528),
    [anon_sym_module] = ACTIONS(528),
    [anon_sym_static] = ACTIONS(528),
    [anon_sym_package] = ACTIONS(528),
    [anon_sym_import] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(528),
    [anon_sym_public] = ACTIONS(528),
    [anon_sym_protected] = ACTIONS(528),
    [anon_sym_private] = ACTIONS(528),
    [anon_sym_abstract] = ACTIONS(528),
    [anon_sym_final] = ACTIONS(528),
    [anon_sym_strictfp] = ACTIONS(528),
    [anon_sym_native] = ACTIONS(528),
    [anon_sym_transient] = ACTIONS(528),
    [anon_sym_volatile] = ACTIONS(528),
    [anon_sym_ATinterface] = ACTIONS(526),
    [anon_sym_interface] = ACTIONS(528),
    [anon_sym_byte] = ACTIONS(528),
    [anon_sym_short] = ACTIONS(528),
    [anon_sym_int] = ACTIONS(528),
    [anon_sym_long] = ACTIONS(528),
    [anon_sym_char] = ACTIONS(528),
    [anon_sym_float] = ACTIONS(528),
    [anon_sym_double] = ACTIONS(528),
    [sym_boolean_type] = ACTIONS(528),
    [sym_void_type] = ACTIONS(528),
    [sym_this] = ACTIONS(528),
    [sym_super] = ACTIONS(528),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(530),
    [sym_identifier] = ACTIONS(532),
    [sym_decimal_integer_literal] = ACTIONS(532),
    [sym_hex_integer_literal] = ACTIONS(532),
    [sym_octal_integer_literal] = ACTIONS(530),
    [sym_binary_integer_literal] = ACTIONS(530),
    [sym_decimal_floating_point_literal] = ACTIONS(530),
    [sym_hex_floating_point_literal] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_character_literal] = ACTIONS(530),
    [sym_string_literal] = ACTIONS(530),
    [sym_null_literal] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(530),
    [anon_sym_TILDE] = ACTIONS(530),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_DASH_DASH] = ACTIONS(530),
    [anon_sym_new] = ACTIONS(532),
    [anon_sym_class] = ACTIONS(532),
    [anon_sym_SEMI] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_assert] = ACTIONS(532),
    [anon_sym_switch] = ACTIONS(532),
    [anon_sym_case] = ACTIONS(532),
    [anon_sym_default] = ACTIONS(532),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_break] = ACTIONS(532),
    [anon_sym_continue] = ACTIONS(532),
    [anon_sym_return] = ACTIONS(532),
    [anon_sym_synchronized] = ACTIONS(532),
    [anon_sym_throw] = ACTIONS(532),
    [anon_sym_try] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_else] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(532),
    [anon_sym_open] = ACTIONS(532),
    [anon_sym_module] = ACTIONS(532),
    [anon_sym_static] = ACTIONS(532),
    [anon_sym_package] = ACTIONS(532),
    [anon_sym_import] = ACTIONS(532),
    [anon_sym_enum] = ACTIONS(532),
    [anon_sym_public] = ACTIONS(532),
    [anon_sym_protected] = ACTIONS(532),
    [anon_sym_private] = ACTIONS(532),
    [anon_sym_abstract] = ACTIONS(532),
    [anon_sym_final] = ACTIONS(532),
    [anon_sym_strictfp] = ACTIONS(532),
    [anon_sym_native] = ACTIONS(532),
    [anon_sym_transient] = ACTIONS(532),
    [anon_sym_volatile] = ACTIONS(532),
    [anon_sym_ATinterface] = ACTIONS(530),
    [anon_sym_interface] = ACTIONS(532),
    [anon_sym_byte] = ACTIONS(532),
    [anon_sym_short] = ACTIONS(532),
    [anon_sym_int] = ACTIONS(532),
    [anon_sym_long] = ACTIONS(532),
    [anon_sym_char] = ACTIONS(532),
    [anon_sym_float] = ACTIONS(532),
    [anon_sym_double] = ACTIONS(532),
    [sym_boolean_type] = ACTIONS(532),
    [sym_void_type] = ACTIONS(532),
    [sym_this] = ACTIONS(532),
    [sym_super] = ACTIONS(532),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [ts_builtin_sym_end] = ACTIONS(534),
    [sym_identifier] = ACTIONS(536),
    [sym_decimal_integer_literal] = ACTIONS(536),
    [sym_hex_integer_literal] = ACTIONS(536),
    [sym_octal_integer_literal] = ACTIONS(534),
    [sym_binary_integer_literal] = ACTIONS(534),
    [sym_decimal_floating_point_literal] = ACTIONS(534),
    [sym_hex_floating_point_literal] = ACTIONS(536),
    [sym_true] = ACTIONS(536),
    [sym_false] = ACTIONS(536),
    [sym_character_literal] = ACTIONS(534),
    [sym_string_literal] = ACTIONS(534),
    [sym_null_literal] = ACTIONS(536),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_LT] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(534),
    [anon_sym_TILDE] = ACTIONS(534),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_DASH_DASH] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(536),
    [anon_sym_class] = ACTIONS(536),
    [anon_sym_SEMI] = ACTIONS(534),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_assert] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(536),
    [anon_sym_case] = ACTIONS(536),
    [anon_sym_default] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(536),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(536),
    [anon_sym_continue] = ACTIONS(536),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_synchronized] = ACTIONS(536),
    [anon_sym_throw] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(536),
    [anon_sym_else] = ACTIONS(536),
    [anon_sym_for] = ACTIONS(536),
    [anon_sym_AT] = ACTIONS(536),
    [anon_sym_open] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_package] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(536),
    [anon_sym_final] = ACTIONS(536),
    [anon_sym_strictfp] = ACTIONS(536),
    [anon_sym_native] = ACTIONS(536),
    [anon_sym_transient] = ACTIONS(536),
    [anon_sym_volatile] = ACTIONS(536),
    [anon_sym_ATinterface] = ACTIONS(534),
    [anon_sym_interface] = ACTIONS(536),
    [anon_sym_byte] = ACTIONS(536),
    [anon_sym_short] = ACTIONS(536),
    [anon_sym_int] = ACTIONS(536),
    [anon_sym_long] = ACTIONS(536),
    [anon_sym_char] = ACTIONS(536),
    [anon_sym_float] = ACTIONS(536),
    [anon_sym_double] = ACTIONS(536),
    [sym_boolean_type] = ACTIONS(536),
    [sym_void_type] = ACTIONS(536),
    [sym_this] = ACTIONS(536),
    [sym_super] = ACTIONS(536),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [ts_builtin_sym_end] = ACTIONS(538),
    [sym_identifier] = ACTIONS(540),
    [sym_decimal_integer_literal] = ACTIONS(540),
    [sym_hex_integer_literal] = ACTIONS(540),
    [sym_octal_integer_literal] = ACTIONS(538),
    [sym_binary_integer_literal] = ACTIONS(538),
    [sym_decimal_floating_point_literal] = ACTIONS(538),
    [sym_hex_floating_point_literal] = ACTIONS(540),
    [sym_true] = ACTIONS(540),
    [sym_false] = ACTIONS(540),
    [sym_character_literal] = ACTIONS(538),
    [sym_string_literal] = ACTIONS(538),
    [sym_null_literal] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_TILDE] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(538),
    [anon_sym_DASH_DASH] = ACTIONS(538),
    [anon_sym_new] = ACTIONS(540),
    [anon_sym_class] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(538),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_assert] = ACTIONS(540),
    [anon_sym_switch] = ACTIONS(540),
    [anon_sym_case] = ACTIONS(540),
    [anon_sym_default] = ACTIONS(540),
    [anon_sym_do] = ACTIONS(540),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_break] = ACTIONS(540),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_return] = ACTIONS(540),
    [anon_sym_synchronized] = ACTIONS(540),
    [anon_sym_throw] = ACTIONS(540),
    [anon_sym_try] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_else] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(540),
    [anon_sym_open] = ACTIONS(540),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_static] = ACTIONS(540),
    [anon_sym_package] = ACTIONS(540),
    [anon_sym_import] = ACTIONS(540),
    [anon_sym_enum] = ACTIONS(540),
    [anon_sym_public] = ACTIONS(540),
    [anon_sym_protected] = ACTIONS(540),
    [anon_sym_private] = ACTIONS(540),
    [anon_sym_abstract] = ACTIONS(540),
    [anon_sym_final] = ACTIONS(540),
    [anon_sym_strictfp] = ACTIONS(540),
    [anon_sym_native] = ACTIONS(540),
    [anon_sym_transient] = ACTIONS(540),
    [anon_sym_volatile] = ACTIONS(540),
    [anon_sym_ATinterface] = ACTIONS(538),
    [anon_sym_interface] = ACTIONS(540),
    [anon_sym_byte] = ACTIONS(540),
    [anon_sym_short] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_long] = ACTIONS(540),
    [anon_sym_char] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [sym_boolean_type] = ACTIONS(540),
    [sym_void_type] = ACTIONS(540),
    [sym_this] = ACTIONS(540),
    [sym_super] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(392),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_block] = STATE(398),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [ts_builtin_sym_end] = ACTIONS(542),
    [sym_identifier] = ACTIONS(544),
    [sym_decimal_integer_literal] = ACTIONS(544),
    [sym_hex_integer_literal] = ACTIONS(544),
    [sym_octal_integer_literal] = ACTIONS(542),
    [sym_binary_integer_literal] = ACTIONS(542),
    [sym_decimal_floating_point_literal] = ACTIONS(542),
    [sym_hex_floating_point_literal] = ACTIONS(544),
    [sym_true] = ACTIONS(544),
    [sym_false] = ACTIONS(544),
    [sym_character_literal] = ACTIONS(542),
    [sym_string_literal] = ACTIONS(542),
    [sym_null_literal] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_PLUS] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_BANG] = ACTIONS(542),
    [anon_sym_TILDE] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_assert] = ACTIONS(544),
    [anon_sym_switch] = ACTIONS(544),
    [anon_sym_case] = ACTIONS(544),
    [anon_sym_default] = ACTIONS(544),
    [anon_sym_do] = ACTIONS(544),
    [anon_sym_while] = ACTIONS(544),
    [anon_sym_break] = ACTIONS(544),
    [anon_sym_continue] = ACTIONS(544),
    [anon_sym_return] = ACTIONS(544),
    [anon_sym_synchronized] = ACTIONS(544),
    [anon_sym_throw] = ACTIONS(544),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(544),
    [anon_sym_else] = ACTIONS(544),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_AT] = ACTIONS(544),
    [anon_sym_open] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_package] = ACTIONS(544),
    [anon_sym_import] = ACTIONS(544),
    [anon_sym_enum] = ACTIONS(544),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(544),
    [anon_sym_final] = ACTIONS(544),
    [anon_sym_strictfp] = ACTIONS(544),
    [anon_sym_native] = ACTIONS(544),
    [anon_sym_transient] = ACTIONS(544),
    [anon_sym_volatile] = ACTIONS(544),
    [anon_sym_ATinterface] = ACTIONS(542),
    [anon_sym_interface] = ACTIONS(544),
    [anon_sym_byte] = ACTIONS(544),
    [anon_sym_short] = ACTIONS(544),
    [anon_sym_int] = ACTIONS(544),
    [anon_sym_long] = ACTIONS(544),
    [anon_sym_char] = ACTIONS(544),
    [anon_sym_float] = ACTIONS(544),
    [anon_sym_double] = ACTIONS(544),
    [sym_boolean_type] = ACTIONS(544),
    [sym_void_type] = ACTIONS(544),
    [sym_this] = ACTIONS(544),
    [sym_super] = ACTIONS(544),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(546),
    [sym_identifier] = ACTIONS(548),
    [sym_decimal_integer_literal] = ACTIONS(548),
    [sym_hex_integer_literal] = ACTIONS(548),
    [sym_octal_integer_literal] = ACTIONS(546),
    [sym_binary_integer_literal] = ACTIONS(546),
    [sym_decimal_floating_point_literal] = ACTIONS(546),
    [sym_hex_floating_point_literal] = ACTIONS(548),
    [sym_true] = ACTIONS(548),
    [sym_false] = ACTIONS(548),
    [sym_character_literal] = ACTIONS(546),
    [sym_string_literal] = ACTIONS(546),
    [sym_null_literal] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LT] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(548),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_BANG] = ACTIONS(546),
    [anon_sym_TILDE] = ACTIONS(546),
    [anon_sym_PLUS_PLUS] = ACTIONS(546),
    [anon_sym_DASH_DASH] = ACTIONS(546),
    [anon_sym_new] = ACTIONS(548),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_SEMI] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_assert] = ACTIONS(548),
    [anon_sym_switch] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_default] = ACTIONS(548),
    [anon_sym_do] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_break] = ACTIONS(548),
    [anon_sym_continue] = ACTIONS(548),
    [anon_sym_return] = ACTIONS(548),
    [anon_sym_synchronized] = ACTIONS(548),
    [anon_sym_throw] = ACTIONS(548),
    [anon_sym_try] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_AT] = ACTIONS(548),
    [anon_sym_open] = ACTIONS(548),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_static] = ACTIONS(548),
    [anon_sym_package] = ACTIONS(548),
    [anon_sym_import] = ACTIONS(548),
    [anon_sym_enum] = ACTIONS(548),
    [anon_sym_public] = ACTIONS(548),
    [anon_sym_protected] = ACTIONS(548),
    [anon_sym_private] = ACTIONS(548),
    [anon_sym_abstract] = ACTIONS(548),
    [anon_sym_final] = ACTIONS(548),
    [anon_sym_strictfp] = ACTIONS(548),
    [anon_sym_native] = ACTIONS(548),
    [anon_sym_transient] = ACTIONS(548),
    [anon_sym_volatile] = ACTIONS(548),
    [anon_sym_ATinterface] = ACTIONS(546),
    [anon_sym_interface] = ACTIONS(548),
    [anon_sym_byte] = ACTIONS(548),
    [anon_sym_short] = ACTIONS(548),
    [anon_sym_int] = ACTIONS(548),
    [anon_sym_long] = ACTIONS(548),
    [anon_sym_char] = ACTIONS(548),
    [anon_sym_float] = ACTIONS(548),
    [anon_sym_double] = ACTIONS(548),
    [sym_boolean_type] = ACTIONS(548),
    [sym_void_type] = ACTIONS(548),
    [sym_this] = ACTIONS(548),
    [sym_super] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(550),
    [sym_identifier] = ACTIONS(552),
    [sym_decimal_integer_literal] = ACTIONS(552),
    [sym_hex_integer_literal] = ACTIONS(552),
    [sym_octal_integer_literal] = ACTIONS(550),
    [sym_binary_integer_literal] = ACTIONS(550),
    [sym_decimal_floating_point_literal] = ACTIONS(550),
    [sym_hex_floating_point_literal] = ACTIONS(552),
    [sym_true] = ACTIONS(552),
    [sym_false] = ACTIONS(552),
    [sym_character_literal] = ACTIONS(550),
    [sym_string_literal] = ACTIONS(550),
    [sym_null_literal] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_BANG] = ACTIONS(550),
    [anon_sym_TILDE] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_new] = ACTIONS(552),
    [anon_sym_class] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_assert] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(552),
    [anon_sym_case] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_do] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_synchronized] = ACTIONS(552),
    [anon_sym_throw] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_else] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_AT] = ACTIONS(552),
    [anon_sym_open] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_package] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_final] = ACTIONS(552),
    [anon_sym_strictfp] = ACTIONS(552),
    [anon_sym_native] = ACTIONS(552),
    [anon_sym_transient] = ACTIONS(552),
    [anon_sym_volatile] = ACTIONS(552),
    [anon_sym_ATinterface] = ACTIONS(550),
    [anon_sym_interface] = ACTIONS(552),
    [anon_sym_byte] = ACTIONS(552),
    [anon_sym_short] = ACTIONS(552),
    [anon_sym_int] = ACTIONS(552),
    [anon_sym_long] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_float] = ACTIONS(552),
    [anon_sym_double] = ACTIONS(552),
    [sym_boolean_type] = ACTIONS(552),
    [sym_void_type] = ACTIONS(552),
    [sym_this] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(554),
    [sym_identifier] = ACTIONS(556),
    [sym_decimal_integer_literal] = ACTIONS(556),
    [sym_hex_integer_literal] = ACTIONS(556),
    [sym_octal_integer_literal] = ACTIONS(554),
    [sym_binary_integer_literal] = ACTIONS(554),
    [sym_decimal_floating_point_literal] = ACTIONS(554),
    [sym_hex_floating_point_literal] = ACTIONS(556),
    [sym_true] = ACTIONS(556),
    [sym_false] = ACTIONS(556),
    [sym_character_literal] = ACTIONS(554),
    [sym_string_literal] = ACTIONS(554),
    [sym_null_literal] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(554),
    [anon_sym_DASH_DASH] = ACTIONS(554),
    [anon_sym_new] = ACTIONS(556),
    [anon_sym_class] = ACTIONS(556),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_assert] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(556),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_do] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(556),
    [anon_sym_continue] = ACTIONS(556),
    [anon_sym_return] = ACTIONS(556),
    [anon_sym_synchronized] = ACTIONS(556),
    [anon_sym_throw] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(556),
    [anon_sym_else] = ACTIONS(556),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_AT] = ACTIONS(556),
    [anon_sym_open] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_package] = ACTIONS(556),
    [anon_sym_import] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(556),
    [anon_sym_final] = ACTIONS(556),
    [anon_sym_strictfp] = ACTIONS(556),
    [anon_sym_native] = ACTIONS(556),
    [anon_sym_transient] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym_ATinterface] = ACTIONS(554),
    [anon_sym_interface] = ACTIONS(556),
    [anon_sym_byte] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [anon_sym_int] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_char] = ACTIONS(556),
    [anon_sym_float] = ACTIONS(556),
    [anon_sym_double] = ACTIONS(556),
    [sym_boolean_type] = ACTIONS(556),
    [sym_void_type] = ACTIONS(556),
    [sym_this] = ACTIONS(556),
    [sym_super] = ACTIONS(556),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(558),
    [sym_identifier] = ACTIONS(560),
    [sym_decimal_integer_literal] = ACTIONS(560),
    [sym_hex_integer_literal] = ACTIONS(560),
    [sym_octal_integer_literal] = ACTIONS(558),
    [sym_binary_integer_literal] = ACTIONS(558),
    [sym_decimal_floating_point_literal] = ACTIONS(558),
    [sym_hex_floating_point_literal] = ACTIONS(560),
    [sym_true] = ACTIONS(560),
    [sym_false] = ACTIONS(560),
    [sym_character_literal] = ACTIONS(558),
    [sym_string_literal] = ACTIONS(558),
    [sym_null_literal] = ACTIONS(560),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(560),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(560),
    [anon_sym_class] = ACTIONS(560),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_assert] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(560),
    [anon_sym_case] = ACTIONS(560),
    [anon_sym_default] = ACTIONS(560),
    [anon_sym_do] = ACTIONS(560),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_break] = ACTIONS(560),
    [anon_sym_continue] = ACTIONS(560),
    [anon_sym_return] = ACTIONS(560),
    [anon_sym_synchronized] = ACTIONS(560),
    [anon_sym_throw] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_else] = ACTIONS(560),
    [anon_sym_for] = ACTIONS(560),
    [anon_sym_AT] = ACTIONS(560),
    [anon_sym_open] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_package] = ACTIONS(560),
    [anon_sym_import] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(560),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(560),
    [anon_sym_final] = ACTIONS(560),
    [anon_sym_strictfp] = ACTIONS(560),
    [anon_sym_native] = ACTIONS(560),
    [anon_sym_transient] = ACTIONS(560),
    [anon_sym_volatile] = ACTIONS(560),
    [anon_sym_ATinterface] = ACTIONS(558),
    [anon_sym_interface] = ACTIONS(560),
    [anon_sym_byte] = ACTIONS(560),
    [anon_sym_short] = ACTIONS(560),
    [anon_sym_int] = ACTIONS(560),
    [anon_sym_long] = ACTIONS(560),
    [anon_sym_char] = ACTIONS(560),
    [anon_sym_float] = ACTIONS(560),
    [anon_sym_double] = ACTIONS(560),
    [sym_boolean_type] = ACTIONS(560),
    [sym_void_type] = ACTIONS(560),
    [sym_this] = ACTIONS(560),
    [sym_super] = ACTIONS(560),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(562),
    [sym_identifier] = ACTIONS(564),
    [sym_decimal_integer_literal] = ACTIONS(564),
    [sym_hex_integer_literal] = ACTIONS(564),
    [sym_octal_integer_literal] = ACTIONS(562),
    [sym_binary_integer_literal] = ACTIONS(562),
    [sym_decimal_floating_point_literal] = ACTIONS(562),
    [sym_hex_floating_point_literal] = ACTIONS(564),
    [sym_true] = ACTIONS(564),
    [sym_false] = ACTIONS(564),
    [sym_character_literal] = ACTIONS(562),
    [sym_string_literal] = ACTIONS(562),
    [sym_null_literal] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_TILDE] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(562),
    [anon_sym_DASH_DASH] = ACTIONS(562),
    [anon_sym_new] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_SEMI] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_assert] = ACTIONS(564),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_case] = ACTIONS(564),
    [anon_sym_default] = ACTIONS(564),
    [anon_sym_do] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_synchronized] = ACTIONS(564),
    [anon_sym_throw] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(564),
    [anon_sym_open] = ACTIONS(564),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_static] = ACTIONS(564),
    [anon_sym_package] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_public] = ACTIONS(564),
    [anon_sym_protected] = ACTIONS(564),
    [anon_sym_private] = ACTIONS(564),
    [anon_sym_abstract] = ACTIONS(564),
    [anon_sym_final] = ACTIONS(564),
    [anon_sym_strictfp] = ACTIONS(564),
    [anon_sym_native] = ACTIONS(564),
    [anon_sym_transient] = ACTIONS(564),
    [anon_sym_volatile] = ACTIONS(564),
    [anon_sym_ATinterface] = ACTIONS(562),
    [anon_sym_interface] = ACTIONS(564),
    [anon_sym_byte] = ACTIONS(564),
    [anon_sym_short] = ACTIONS(564),
    [anon_sym_int] = ACTIONS(564),
    [anon_sym_long] = ACTIONS(564),
    [anon_sym_char] = ACTIONS(564),
    [anon_sym_float] = ACTIONS(564),
    [anon_sym_double] = ACTIONS(564),
    [sym_boolean_type] = ACTIONS(564),
    [sym_void_type] = ACTIONS(564),
    [sym_this] = ACTIONS(564),
    [sym_super] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(566),
    [sym_identifier] = ACTIONS(568),
    [sym_decimal_integer_literal] = ACTIONS(568),
    [sym_hex_integer_literal] = ACTIONS(568),
    [sym_octal_integer_literal] = ACTIONS(566),
    [sym_binary_integer_literal] = ACTIONS(566),
    [sym_decimal_floating_point_literal] = ACTIONS(566),
    [sym_hex_floating_point_literal] = ACTIONS(568),
    [sym_true] = ACTIONS(568),
    [sym_false] = ACTIONS(568),
    [sym_character_literal] = ACTIONS(566),
    [sym_string_literal] = ACTIONS(566),
    [sym_null_literal] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_DASH_DASH] = ACTIONS(566),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_class] = ACTIONS(568),
    [anon_sym_SEMI] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_assert] = ACTIONS(568),
    [anon_sym_switch] = ACTIONS(568),
    [anon_sym_case] = ACTIONS(568),
    [anon_sym_default] = ACTIONS(568),
    [anon_sym_do] = ACTIONS(568),
    [anon_sym_while] = ACTIONS(568),
    [anon_sym_break] = ACTIONS(568),
    [anon_sym_continue] = ACTIONS(568),
    [anon_sym_return] = ACTIONS(568),
    [anon_sym_synchronized] = ACTIONS(568),
    [anon_sym_throw] = ACTIONS(568),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(568),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_for] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(568),
    [anon_sym_open] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_package] = ACTIONS(568),
    [anon_sym_import] = ACTIONS(568),
    [anon_sym_enum] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_abstract] = ACTIONS(568),
    [anon_sym_final] = ACTIONS(568),
    [anon_sym_strictfp] = ACTIONS(568),
    [anon_sym_native] = ACTIONS(568),
    [anon_sym_transient] = ACTIONS(568),
    [anon_sym_volatile] = ACTIONS(568),
    [anon_sym_ATinterface] = ACTIONS(566),
    [anon_sym_interface] = ACTIONS(568),
    [anon_sym_byte] = ACTIONS(568),
    [anon_sym_short] = ACTIONS(568),
    [anon_sym_int] = ACTIONS(568),
    [anon_sym_long] = ACTIONS(568),
    [anon_sym_char] = ACTIONS(568),
    [anon_sym_float] = ACTIONS(568),
    [anon_sym_double] = ACTIONS(568),
    [sym_boolean_type] = ACTIONS(568),
    [sym_void_type] = ACTIONS(568),
    [sym_this] = ACTIONS(568),
    [sym_super] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(570),
    [sym_identifier] = ACTIONS(572),
    [sym_decimal_integer_literal] = ACTIONS(572),
    [sym_hex_integer_literal] = ACTIONS(572),
    [sym_octal_integer_literal] = ACTIONS(570),
    [sym_binary_integer_literal] = ACTIONS(570),
    [sym_decimal_floating_point_literal] = ACTIONS(570),
    [sym_hex_floating_point_literal] = ACTIONS(572),
    [sym_true] = ACTIONS(572),
    [sym_false] = ACTIONS(572),
    [sym_character_literal] = ACTIONS(570),
    [sym_string_literal] = ACTIONS(570),
    [sym_null_literal] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(570),
    [anon_sym_TILDE] = ACTIONS(570),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_DASH_DASH] = ACTIONS(570),
    [anon_sym_new] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(572),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_assert] = ACTIONS(572),
    [anon_sym_switch] = ACTIONS(572),
    [anon_sym_case] = ACTIONS(572),
    [anon_sym_default] = ACTIONS(572),
    [anon_sym_do] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [anon_sym_break] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(572),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_synchronized] = ACTIONS(572),
    [anon_sym_throw] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(572),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(572),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(572),
    [anon_sym_open] = ACTIONS(572),
    [anon_sym_module] = ACTIONS(572),
    [anon_sym_static] = ACTIONS(572),
    [anon_sym_package] = ACTIONS(572),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_enum] = ACTIONS(572),
    [anon_sym_public] = ACTIONS(572),
    [anon_sym_protected] = ACTIONS(572),
    [anon_sym_private] = ACTIONS(572),
    [anon_sym_abstract] = ACTIONS(572),
    [anon_sym_final] = ACTIONS(572),
    [anon_sym_strictfp] = ACTIONS(572),
    [anon_sym_native] = ACTIONS(572),
    [anon_sym_transient] = ACTIONS(572),
    [anon_sym_volatile] = ACTIONS(572),
    [anon_sym_ATinterface] = ACTIONS(570),
    [anon_sym_interface] = ACTIONS(572),
    [anon_sym_byte] = ACTIONS(572),
    [anon_sym_short] = ACTIONS(572),
    [anon_sym_int] = ACTIONS(572),
    [anon_sym_long] = ACTIONS(572),
    [anon_sym_char] = ACTIONS(572),
    [anon_sym_float] = ACTIONS(572),
    [anon_sym_double] = ACTIONS(572),
    [sym_boolean_type] = ACTIONS(572),
    [sym_void_type] = ACTIONS(572),
    [sym_this] = ACTIONS(572),
    [sym_super] = ACTIONS(572),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(574),
    [sym_identifier] = ACTIONS(576),
    [sym_decimal_integer_literal] = ACTIONS(576),
    [sym_hex_integer_literal] = ACTIONS(576),
    [sym_octal_integer_literal] = ACTIONS(574),
    [sym_binary_integer_literal] = ACTIONS(574),
    [sym_decimal_floating_point_literal] = ACTIONS(574),
    [sym_hex_floating_point_literal] = ACTIONS(576),
    [sym_true] = ACTIONS(576),
    [sym_false] = ACTIONS(576),
    [sym_character_literal] = ACTIONS(574),
    [sym_string_literal] = ACTIONS(574),
    [sym_null_literal] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_BANG] = ACTIONS(574),
    [anon_sym_TILDE] = ACTIONS(574),
    [anon_sym_PLUS_PLUS] = ACTIONS(574),
    [anon_sym_DASH_DASH] = ACTIONS(574),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_assert] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_default] = ACTIONS(576),
    [anon_sym_do] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_break] = ACTIONS(576),
    [anon_sym_continue] = ACTIONS(576),
    [anon_sym_return] = ACTIONS(576),
    [anon_sym_synchronized] = ACTIONS(576),
    [anon_sym_throw] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(576),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_open] = ACTIONS(576),
    [anon_sym_module] = ACTIONS(576),
    [anon_sym_static] = ACTIONS(576),
    [anon_sym_package] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(576),
    [anon_sym_public] = ACTIONS(576),
    [anon_sym_protected] = ACTIONS(576),
    [anon_sym_private] = ACTIONS(576),
    [anon_sym_abstract] = ACTIONS(576),
    [anon_sym_final] = ACTIONS(576),
    [anon_sym_strictfp] = ACTIONS(576),
    [anon_sym_native] = ACTIONS(576),
    [anon_sym_transient] = ACTIONS(576),
    [anon_sym_volatile] = ACTIONS(576),
    [anon_sym_ATinterface] = ACTIONS(574),
    [anon_sym_interface] = ACTIONS(576),
    [anon_sym_byte] = ACTIONS(576),
    [anon_sym_short] = ACTIONS(576),
    [anon_sym_int] = ACTIONS(576),
    [anon_sym_long] = ACTIONS(576),
    [anon_sym_char] = ACTIONS(576),
    [anon_sym_float] = ACTIONS(576),
    [anon_sym_double] = ACTIONS(576),
    [sym_boolean_type] = ACTIONS(576),
    [sym_void_type] = ACTIONS(576),
    [sym_this] = ACTIONS(576),
    [sym_super] = ACTIONS(576),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(578),
    [sym_identifier] = ACTIONS(580),
    [sym_decimal_integer_literal] = ACTIONS(580),
    [sym_hex_integer_literal] = ACTIONS(580),
    [sym_octal_integer_literal] = ACTIONS(578),
    [sym_binary_integer_literal] = ACTIONS(578),
    [sym_decimal_floating_point_literal] = ACTIONS(578),
    [sym_hex_floating_point_literal] = ACTIONS(580),
    [sym_true] = ACTIONS(580),
    [sym_false] = ACTIONS(580),
    [sym_character_literal] = ACTIONS(578),
    [sym_string_literal] = ACTIONS(578),
    [sym_null_literal] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_TILDE] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(578),
    [anon_sym_DASH_DASH] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(580),
    [anon_sym_class] = ACTIONS(580),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(578),
    [anon_sym_RBRACE] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(580),
    [anon_sym_switch] = ACTIONS(580),
    [anon_sym_case] = ACTIONS(580),
    [anon_sym_default] = ACTIONS(580),
    [anon_sym_do] = ACTIONS(580),
    [anon_sym_while] = ACTIONS(580),
    [anon_sym_break] = ACTIONS(580),
    [anon_sym_continue] = ACTIONS(580),
    [anon_sym_return] = ACTIONS(580),
    [anon_sym_synchronized] = ACTIONS(580),
    [anon_sym_throw] = ACTIONS(580),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_if] = ACTIONS(580),
    [anon_sym_else] = ACTIONS(580),
    [anon_sym_for] = ACTIONS(580),
    [anon_sym_AT] = ACTIONS(580),
    [anon_sym_open] = ACTIONS(580),
    [anon_sym_module] = ACTIONS(580),
    [anon_sym_static] = ACTIONS(580),
    [anon_sym_package] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_enum] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(580),
    [anon_sym_protected] = ACTIONS(580),
    [anon_sym_private] = ACTIONS(580),
    [anon_sym_abstract] = ACTIONS(580),
    [anon_sym_final] = ACTIONS(580),
    [anon_sym_strictfp] = ACTIONS(580),
    [anon_sym_native] = ACTIONS(580),
    [anon_sym_transient] = ACTIONS(580),
    [anon_sym_volatile] = ACTIONS(580),
    [anon_sym_ATinterface] = ACTIONS(578),
    [anon_sym_interface] = ACTIONS(580),
    [anon_sym_byte] = ACTIONS(580),
    [anon_sym_short] = ACTIONS(580),
    [anon_sym_int] = ACTIONS(580),
    [anon_sym_long] = ACTIONS(580),
    [anon_sym_char] = ACTIONS(580),
    [anon_sym_float] = ACTIONS(580),
    [anon_sym_double] = ACTIONS(580),
    [sym_boolean_type] = ACTIONS(580),
    [sym_void_type] = ACTIONS(580),
    [sym_this] = ACTIONS(580),
    [sym_super] = ACTIONS(580),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_decimal_integer_literal] = ACTIONS(584),
    [sym_hex_integer_literal] = ACTIONS(584),
    [sym_octal_integer_literal] = ACTIONS(582),
    [sym_binary_integer_literal] = ACTIONS(582),
    [sym_decimal_floating_point_literal] = ACTIONS(582),
    [sym_hex_floating_point_literal] = ACTIONS(584),
    [sym_true] = ACTIONS(584),
    [sym_false] = ACTIONS(584),
    [sym_character_literal] = ACTIONS(582),
    [sym_string_literal] = ACTIONS(582),
    [sym_null_literal] = ACTIONS(584),
    [anon_sym_LPAREN] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_TILDE] = ACTIONS(582),
    [anon_sym_PLUS_PLUS] = ACTIONS(582),
    [anon_sym_DASH_DASH] = ACTIONS(582),
    [anon_sym_new] = ACTIONS(584),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(582),
    [anon_sym_RBRACE] = ACTIONS(582),
    [anon_sym_assert] = ACTIONS(584),
    [anon_sym_switch] = ACTIONS(584),
    [anon_sym_case] = ACTIONS(584),
    [anon_sym_default] = ACTIONS(584),
    [anon_sym_do] = ACTIONS(584),
    [anon_sym_while] = ACTIONS(584),
    [anon_sym_break] = ACTIONS(584),
    [anon_sym_continue] = ACTIONS(584),
    [anon_sym_return] = ACTIONS(584),
    [anon_sym_synchronized] = ACTIONS(584),
    [anon_sym_throw] = ACTIONS(584),
    [anon_sym_try] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(584),
    [anon_sym_else] = ACTIONS(584),
    [anon_sym_for] = ACTIONS(584),
    [anon_sym_AT] = ACTIONS(584),
    [anon_sym_open] = ACTIONS(584),
    [anon_sym_module] = ACTIONS(584),
    [anon_sym_static] = ACTIONS(584),
    [anon_sym_package] = ACTIONS(584),
    [anon_sym_import] = ACTIONS(584),
    [anon_sym_enum] = ACTIONS(584),
    [anon_sym_public] = ACTIONS(584),
    [anon_sym_protected] = ACTIONS(584),
    [anon_sym_private] = ACTIONS(584),
    [anon_sym_abstract] = ACTIONS(584),
    [anon_sym_final] = ACTIONS(584),
    [anon_sym_strictfp] = ACTIONS(584),
    [anon_sym_native] = ACTIONS(584),
    [anon_sym_transient] = ACTIONS(584),
    [anon_sym_volatile] = ACTIONS(584),
    [anon_sym_ATinterface] = ACTIONS(582),
    [anon_sym_interface] = ACTIONS(584),
    [anon_sym_byte] = ACTIONS(584),
    [anon_sym_short] = ACTIONS(584),
    [anon_sym_int] = ACTIONS(584),
    [anon_sym_long] = ACTIONS(584),
    [anon_sym_char] = ACTIONS(584),
    [anon_sym_float] = ACTIONS(584),
    [anon_sym_double] = ACTIONS(584),
    [sym_boolean_type] = ACTIONS(584),
    [sym_void_type] = ACTIONS(584),
    [sym_this] = ACTIONS(584),
    [sym_super] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(423),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym_array_initializer] = STATE(737),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(586),
    [sym_identifier] = ACTIONS(588),
    [sym_decimal_integer_literal] = ACTIONS(588),
    [sym_hex_integer_literal] = ACTIONS(588),
    [sym_octal_integer_literal] = ACTIONS(586),
    [sym_binary_integer_literal] = ACTIONS(586),
    [sym_decimal_floating_point_literal] = ACTIONS(586),
    [sym_hex_floating_point_literal] = ACTIONS(588),
    [sym_true] = ACTIONS(588),
    [sym_false] = ACTIONS(588),
    [sym_character_literal] = ACTIONS(586),
    [sym_string_literal] = ACTIONS(586),
    [sym_null_literal] = ACTIONS(588),
    [anon_sym_LPAREN] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_BANG] = ACTIONS(586),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS_PLUS] = ACTIONS(586),
    [anon_sym_DASH_DASH] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(588),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_SEMI] = ACTIONS(586),
    [anon_sym_LBRACE] = ACTIONS(586),
    [anon_sym_RBRACE] = ACTIONS(586),
    [anon_sym_assert] = ACTIONS(588),
    [anon_sym_switch] = ACTIONS(588),
    [anon_sym_case] = ACTIONS(588),
    [anon_sym_default] = ACTIONS(588),
    [anon_sym_do] = ACTIONS(588),
    [anon_sym_while] = ACTIONS(588),
    [anon_sym_break] = ACTIONS(588),
    [anon_sym_continue] = ACTIONS(588),
    [anon_sym_return] = ACTIONS(588),
    [anon_sym_synchronized] = ACTIONS(588),
    [anon_sym_throw] = ACTIONS(588),
    [anon_sym_try] = ACTIONS(588),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_else] = ACTIONS(588),
    [anon_sym_for] = ACTIONS(588),
    [anon_sym_AT] = ACTIONS(588),
    [anon_sym_open] = ACTIONS(588),
    [anon_sym_module] = ACTIONS(588),
    [anon_sym_static] = ACTIONS(588),
    [anon_sym_package] = ACTIONS(588),
    [anon_sym_import] = ACTIONS(588),
    [anon_sym_enum] = ACTIONS(588),
    [anon_sym_public] = ACTIONS(588),
    [anon_sym_protected] = ACTIONS(588),
    [anon_sym_private] = ACTIONS(588),
    [anon_sym_abstract] = ACTIONS(588),
    [anon_sym_final] = ACTIONS(588),
    [anon_sym_strictfp] = ACTIONS(588),
    [anon_sym_native] = ACTIONS(588),
    [anon_sym_transient] = ACTIONS(588),
    [anon_sym_volatile] = ACTIONS(588),
    [anon_sym_ATinterface] = ACTIONS(586),
    [anon_sym_interface] = ACTIONS(588),
    [anon_sym_byte] = ACTIONS(588),
    [anon_sym_short] = ACTIONS(588),
    [anon_sym_int] = ACTIONS(588),
    [anon_sym_long] = ACTIONS(588),
    [anon_sym_char] = ACTIONS(588),
    [anon_sym_float] = ACTIONS(588),
    [anon_sym_double] = ACTIONS(588),
    [sym_boolean_type] = ACTIONS(588),
    [sym_void_type] = ACTIONS(588),
    [sym_this] = ACTIONS(588),
    [sym_super] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(590),
    [sym_identifier] = ACTIONS(592),
    [sym_decimal_integer_literal] = ACTIONS(592),
    [sym_hex_integer_literal] = ACTIONS(592),
    [sym_octal_integer_literal] = ACTIONS(590),
    [sym_binary_integer_literal] = ACTIONS(590),
    [sym_decimal_floating_point_literal] = ACTIONS(590),
    [sym_hex_floating_point_literal] = ACTIONS(592),
    [sym_true] = ACTIONS(592),
    [sym_false] = ACTIONS(592),
    [sym_character_literal] = ACTIONS(590),
    [sym_string_literal] = ACTIONS(590),
    [sym_null_literal] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(592),
    [anon_sym_DASH] = ACTIONS(592),
    [anon_sym_BANG] = ACTIONS(590),
    [anon_sym_TILDE] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_new] = ACTIONS(592),
    [anon_sym_class] = ACTIONS(592),
    [anon_sym_SEMI] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(590),
    [anon_sym_RBRACE] = ACTIONS(590),
    [anon_sym_assert] = ACTIONS(592),
    [anon_sym_switch] = ACTIONS(592),
    [anon_sym_case] = ACTIONS(592),
    [anon_sym_default] = ACTIONS(592),
    [anon_sym_do] = ACTIONS(592),
    [anon_sym_while] = ACTIONS(592),
    [anon_sym_break] = ACTIONS(592),
    [anon_sym_continue] = ACTIONS(592),
    [anon_sym_return] = ACTIONS(592),
    [anon_sym_synchronized] = ACTIONS(592),
    [anon_sym_throw] = ACTIONS(592),
    [anon_sym_try] = ACTIONS(592),
    [anon_sym_if] = ACTIONS(592),
    [anon_sym_else] = ACTIONS(592),
    [anon_sym_for] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym_open] = ACTIONS(592),
    [anon_sym_module] = ACTIONS(592),
    [anon_sym_static] = ACTIONS(592),
    [anon_sym_package] = ACTIONS(592),
    [anon_sym_import] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(592),
    [anon_sym_public] = ACTIONS(592),
    [anon_sym_protected] = ACTIONS(592),
    [anon_sym_private] = ACTIONS(592),
    [anon_sym_abstract] = ACTIONS(592),
    [anon_sym_final] = ACTIONS(592),
    [anon_sym_strictfp] = ACTIONS(592),
    [anon_sym_native] = ACTIONS(592),
    [anon_sym_transient] = ACTIONS(592),
    [anon_sym_volatile] = ACTIONS(592),
    [anon_sym_ATinterface] = ACTIONS(590),
    [anon_sym_interface] = ACTIONS(592),
    [anon_sym_byte] = ACTIONS(592),
    [anon_sym_short] = ACTIONS(592),
    [anon_sym_int] = ACTIONS(592),
    [anon_sym_long] = ACTIONS(592),
    [anon_sym_char] = ACTIONS(592),
    [anon_sym_float] = ACTIONS(592),
    [anon_sym_double] = ACTIONS(592),
    [sym_boolean_type] = ACTIONS(592),
    [sym_void_type] = ACTIONS(592),
    [sym_this] = ACTIONS(592),
    [sym_super] = ACTIONS(592),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(419),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(594),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(442),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(596),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(598),
    [sym_identifier] = ACTIONS(600),
    [sym_decimal_integer_literal] = ACTIONS(600),
    [sym_hex_integer_literal] = ACTIONS(600),
    [sym_octal_integer_literal] = ACTIONS(598),
    [sym_binary_integer_literal] = ACTIONS(598),
    [sym_decimal_floating_point_literal] = ACTIONS(598),
    [sym_hex_floating_point_literal] = ACTIONS(600),
    [sym_true] = ACTIONS(600),
    [sym_false] = ACTIONS(600),
    [sym_character_literal] = ACTIONS(598),
    [sym_string_literal] = ACTIONS(598),
    [sym_null_literal] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(600),
    [anon_sym_DASH] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(598),
    [anon_sym_TILDE] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_new] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(600),
    [anon_sym_switch] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_default] = ACTIONS(600),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_break] = ACTIONS(600),
    [anon_sym_continue] = ACTIONS(600),
    [anon_sym_return] = ACTIONS(600),
    [anon_sym_synchronized] = ACTIONS(600),
    [anon_sym_throw] = ACTIONS(600),
    [anon_sym_try] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_else] = ACTIONS(600),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(600),
    [anon_sym_open] = ACTIONS(600),
    [anon_sym_module] = ACTIONS(600),
    [anon_sym_static] = ACTIONS(600),
    [anon_sym_package] = ACTIONS(600),
    [anon_sym_import] = ACTIONS(600),
    [anon_sym_enum] = ACTIONS(600),
    [anon_sym_public] = ACTIONS(600),
    [anon_sym_protected] = ACTIONS(600),
    [anon_sym_private] = ACTIONS(600),
    [anon_sym_abstract] = ACTIONS(600),
    [anon_sym_final] = ACTIONS(600),
    [anon_sym_strictfp] = ACTIONS(600),
    [anon_sym_native] = ACTIONS(600),
    [anon_sym_transient] = ACTIONS(600),
    [anon_sym_volatile] = ACTIONS(600),
    [anon_sym_ATinterface] = ACTIONS(598),
    [anon_sym_interface] = ACTIONS(600),
    [anon_sym_byte] = ACTIONS(600),
    [anon_sym_short] = ACTIONS(600),
    [anon_sym_int] = ACTIONS(600),
    [anon_sym_long] = ACTIONS(600),
    [anon_sym_char] = ACTIONS(600),
    [anon_sym_float] = ACTIONS(600),
    [anon_sym_double] = ACTIONS(600),
    [sym_boolean_type] = ACTIONS(600),
    [sym_void_type] = ACTIONS(600),
    [sym_this] = ACTIONS(600),
    [sym_super] = ACTIONS(600),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(425),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(604),
    [sym_identifier] = ACTIONS(606),
    [sym_decimal_integer_literal] = ACTIONS(606),
    [sym_hex_integer_literal] = ACTIONS(606),
    [sym_octal_integer_literal] = ACTIONS(604),
    [sym_binary_integer_literal] = ACTIONS(604),
    [sym_decimal_floating_point_literal] = ACTIONS(604),
    [sym_hex_floating_point_literal] = ACTIONS(606),
    [sym_true] = ACTIONS(606),
    [sym_false] = ACTIONS(606),
    [sym_character_literal] = ACTIONS(604),
    [sym_string_literal] = ACTIONS(604),
    [sym_null_literal] = ACTIONS(606),
    [anon_sym_LPAREN] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_BANG] = ACTIONS(604),
    [anon_sym_TILDE] = ACTIONS(604),
    [anon_sym_PLUS_PLUS] = ACTIONS(604),
    [anon_sym_DASH_DASH] = ACTIONS(604),
    [anon_sym_new] = ACTIONS(606),
    [anon_sym_class] = ACTIONS(606),
    [anon_sym_SEMI] = ACTIONS(604),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_RBRACE] = ACTIONS(604),
    [anon_sym_assert] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(606),
    [anon_sym_case] = ACTIONS(606),
    [anon_sym_default] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(606),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_break] = ACTIONS(606),
    [anon_sym_continue] = ACTIONS(606),
    [anon_sym_return] = ACTIONS(606),
    [anon_sym_synchronized] = ACTIONS(606),
    [anon_sym_throw] = ACTIONS(606),
    [anon_sym_try] = ACTIONS(606),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_else] = ACTIONS(606),
    [anon_sym_for] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(606),
    [anon_sym_open] = ACTIONS(606),
    [anon_sym_module] = ACTIONS(606),
    [anon_sym_static] = ACTIONS(606),
    [anon_sym_package] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(606),
    [anon_sym_enum] = ACTIONS(606),
    [anon_sym_public] = ACTIONS(606),
    [anon_sym_protected] = ACTIONS(606),
    [anon_sym_private] = ACTIONS(606),
    [anon_sym_abstract] = ACTIONS(606),
    [anon_sym_final] = ACTIONS(606),
    [anon_sym_strictfp] = ACTIONS(606),
    [anon_sym_native] = ACTIONS(606),
    [anon_sym_transient] = ACTIONS(606),
    [anon_sym_volatile] = ACTIONS(606),
    [anon_sym_ATinterface] = ACTIONS(604),
    [anon_sym_interface] = ACTIONS(606),
    [anon_sym_byte] = ACTIONS(606),
    [anon_sym_short] = ACTIONS(606),
    [anon_sym_int] = ACTIONS(606),
    [anon_sym_long] = ACTIONS(606),
    [anon_sym_char] = ACTIONS(606),
    [anon_sym_float] = ACTIONS(606),
    [anon_sym_double] = ACTIONS(606),
    [sym_boolean_type] = ACTIONS(606),
    [sym_void_type] = ACTIONS(606),
    [sym_this] = ACTIONS(606),
    [sym_super] = ACTIONS(606),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(608),
    [sym_identifier] = ACTIONS(610),
    [sym_decimal_integer_literal] = ACTIONS(610),
    [sym_hex_integer_literal] = ACTIONS(610),
    [sym_octal_integer_literal] = ACTIONS(608),
    [sym_binary_integer_literal] = ACTIONS(608),
    [sym_decimal_floating_point_literal] = ACTIONS(608),
    [sym_hex_floating_point_literal] = ACTIONS(610),
    [sym_true] = ACTIONS(610),
    [sym_false] = ACTIONS(610),
    [sym_character_literal] = ACTIONS(608),
    [sym_string_literal] = ACTIONS(608),
    [sym_null_literal] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(608),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_BANG] = ACTIONS(608),
    [anon_sym_TILDE] = ACTIONS(608),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_new] = ACTIONS(610),
    [anon_sym_class] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_LBRACE] = ACTIONS(608),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_assert] = ACTIONS(610),
    [anon_sym_switch] = ACTIONS(610),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_default] = ACTIONS(610),
    [anon_sym_do] = ACTIONS(610),
    [anon_sym_while] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(610),
    [anon_sym_continue] = ACTIONS(610),
    [anon_sym_return] = ACTIONS(610),
    [anon_sym_synchronized] = ACTIONS(610),
    [anon_sym_throw] = ACTIONS(610),
    [anon_sym_try] = ACTIONS(610),
    [anon_sym_if] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(610),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_open] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_package] = ACTIONS(610),
    [anon_sym_import] = ACTIONS(610),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_abstract] = ACTIONS(610),
    [anon_sym_final] = ACTIONS(610),
    [anon_sym_strictfp] = ACTIONS(610),
    [anon_sym_native] = ACTIONS(610),
    [anon_sym_transient] = ACTIONS(610),
    [anon_sym_volatile] = ACTIONS(610),
    [anon_sym_ATinterface] = ACTIONS(608),
    [anon_sym_interface] = ACTIONS(610),
    [anon_sym_byte] = ACTIONS(610),
    [anon_sym_short] = ACTIONS(610),
    [anon_sym_int] = ACTIONS(610),
    [anon_sym_long] = ACTIONS(610),
    [anon_sym_char] = ACTIONS(610),
    [anon_sym_float] = ACTIONS(610),
    [anon_sym_double] = ACTIONS(610),
    [sym_boolean_type] = ACTIONS(610),
    [sym_void_type] = ACTIONS(610),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(612),
    [sym_identifier] = ACTIONS(614),
    [sym_decimal_integer_literal] = ACTIONS(614),
    [sym_hex_integer_literal] = ACTIONS(614),
    [sym_octal_integer_literal] = ACTIONS(612),
    [sym_binary_integer_literal] = ACTIONS(612),
    [sym_decimal_floating_point_literal] = ACTIONS(612),
    [sym_hex_floating_point_literal] = ACTIONS(614),
    [sym_true] = ACTIONS(614),
    [sym_false] = ACTIONS(614),
    [sym_character_literal] = ACTIONS(612),
    [sym_string_literal] = ACTIONS(612),
    [sym_null_literal] = ACTIONS(614),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_PLUS] = ACTIONS(614),
    [anon_sym_DASH] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(612),
    [anon_sym_TILDE] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(612),
    [anon_sym_DASH_DASH] = ACTIONS(612),
    [anon_sym_new] = ACTIONS(614),
    [anon_sym_class] = ACTIONS(614),
    [anon_sym_SEMI] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_assert] = ACTIONS(614),
    [anon_sym_switch] = ACTIONS(614),
    [anon_sym_case] = ACTIONS(614),
    [anon_sym_default] = ACTIONS(614),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_while] = ACTIONS(614),
    [anon_sym_break] = ACTIONS(614),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_return] = ACTIONS(614),
    [anon_sym_synchronized] = ACTIONS(614),
    [anon_sym_throw] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(614),
    [anon_sym_if] = ACTIONS(614),
    [anon_sym_else] = ACTIONS(614),
    [anon_sym_for] = ACTIONS(614),
    [anon_sym_AT] = ACTIONS(614),
    [anon_sym_open] = ACTIONS(614),
    [anon_sym_module] = ACTIONS(614),
    [anon_sym_static] = ACTIONS(614),
    [anon_sym_package] = ACTIONS(614),
    [anon_sym_import] = ACTIONS(614),
    [anon_sym_enum] = ACTIONS(614),
    [anon_sym_public] = ACTIONS(614),
    [anon_sym_protected] = ACTIONS(614),
    [anon_sym_private] = ACTIONS(614),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_final] = ACTIONS(614),
    [anon_sym_strictfp] = ACTIONS(614),
    [anon_sym_native] = ACTIONS(614),
    [anon_sym_transient] = ACTIONS(614),
    [anon_sym_volatile] = ACTIONS(614),
    [anon_sym_ATinterface] = ACTIONS(612),
    [anon_sym_interface] = ACTIONS(614),
    [anon_sym_byte] = ACTIONS(614),
    [anon_sym_short] = ACTIONS(614),
    [anon_sym_int] = ACTIONS(614),
    [anon_sym_long] = ACTIONS(614),
    [anon_sym_char] = ACTIONS(614),
    [anon_sym_float] = ACTIONS(614),
    [anon_sym_double] = ACTIONS(614),
    [sym_boolean_type] = ACTIONS(614),
    [sym_void_type] = ACTIONS(614),
    [sym_this] = ACTIONS(614),
    [sym_super] = ACTIONS(614),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(446),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(616),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(618),
    [sym_identifier] = ACTIONS(620),
    [sym_decimal_integer_literal] = ACTIONS(620),
    [sym_hex_integer_literal] = ACTIONS(620),
    [sym_octal_integer_literal] = ACTIONS(618),
    [sym_binary_integer_literal] = ACTIONS(618),
    [sym_decimal_floating_point_literal] = ACTIONS(618),
    [sym_hex_floating_point_literal] = ACTIONS(620),
    [sym_true] = ACTIONS(620),
    [sym_false] = ACTIONS(620),
    [sym_character_literal] = ACTIONS(618),
    [sym_string_literal] = ACTIONS(618),
    [sym_null_literal] = ACTIONS(620),
    [anon_sym_LPAREN] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_BANG] = ACTIONS(618),
    [anon_sym_TILDE] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(618),
    [anon_sym_DASH_DASH] = ACTIONS(618),
    [anon_sym_new] = ACTIONS(620),
    [anon_sym_class] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(618),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_RBRACE] = ACTIONS(618),
    [anon_sym_assert] = ACTIONS(620),
    [anon_sym_switch] = ACTIONS(620),
    [anon_sym_case] = ACTIONS(620),
    [anon_sym_default] = ACTIONS(620),
    [anon_sym_do] = ACTIONS(620),
    [anon_sym_while] = ACTIONS(620),
    [anon_sym_break] = ACTIONS(620),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_return] = ACTIONS(620),
    [anon_sym_synchronized] = ACTIONS(620),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_try] = ACTIONS(620),
    [anon_sym_if] = ACTIONS(620),
    [anon_sym_else] = ACTIONS(620),
    [anon_sym_for] = ACTIONS(620),
    [anon_sym_AT] = ACTIONS(620),
    [anon_sym_open] = ACTIONS(620),
    [anon_sym_module] = ACTIONS(620),
    [anon_sym_static] = ACTIONS(620),
    [anon_sym_package] = ACTIONS(620),
    [anon_sym_import] = ACTIONS(620),
    [anon_sym_enum] = ACTIONS(620),
    [anon_sym_public] = ACTIONS(620),
    [anon_sym_protected] = ACTIONS(620),
    [anon_sym_private] = ACTIONS(620),
    [anon_sym_abstract] = ACTIONS(620),
    [anon_sym_final] = ACTIONS(620),
    [anon_sym_strictfp] = ACTIONS(620),
    [anon_sym_native] = ACTIONS(620),
    [anon_sym_transient] = ACTIONS(620),
    [anon_sym_volatile] = ACTIONS(620),
    [anon_sym_ATinterface] = ACTIONS(618),
    [anon_sym_interface] = ACTIONS(620),
    [anon_sym_byte] = ACTIONS(620),
    [anon_sym_short] = ACTIONS(620),
    [anon_sym_int] = ACTIONS(620),
    [anon_sym_long] = ACTIONS(620),
    [anon_sym_char] = ACTIONS(620),
    [anon_sym_float] = ACTIONS(620),
    [anon_sym_double] = ACTIONS(620),
    [sym_boolean_type] = ACTIONS(620),
    [sym_void_type] = ACTIONS(620),
    [sym_this] = ACTIONS(620),
    [sym_super] = ACTIONS(620),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(622),
    [sym_identifier] = ACTIONS(624),
    [sym_decimal_integer_literal] = ACTIONS(624),
    [sym_hex_integer_literal] = ACTIONS(624),
    [sym_octal_integer_literal] = ACTIONS(622),
    [sym_binary_integer_literal] = ACTIONS(622),
    [sym_decimal_floating_point_literal] = ACTIONS(622),
    [sym_hex_floating_point_literal] = ACTIONS(624),
    [sym_true] = ACTIONS(624),
    [sym_false] = ACTIONS(624),
    [sym_character_literal] = ACTIONS(622),
    [sym_string_literal] = ACTIONS(622),
    [sym_null_literal] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(622),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(622),
    [anon_sym_TILDE] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(622),
    [anon_sym_DASH_DASH] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_class] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(622),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_assert] = ACTIONS(624),
    [anon_sym_switch] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(624),
    [anon_sym_default] = ACTIONS(624),
    [anon_sym_do] = ACTIONS(624),
    [anon_sym_while] = ACTIONS(624),
    [anon_sym_break] = ACTIONS(624),
    [anon_sym_continue] = ACTIONS(624),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_synchronized] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(624),
    [anon_sym_try] = ACTIONS(624),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_else] = ACTIONS(624),
    [anon_sym_for] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(624),
    [anon_sym_open] = ACTIONS(624),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(624),
    [anon_sym_package] = ACTIONS(624),
    [anon_sym_import] = ACTIONS(624),
    [anon_sym_enum] = ACTIONS(624),
    [anon_sym_public] = ACTIONS(624),
    [anon_sym_protected] = ACTIONS(624),
    [anon_sym_private] = ACTIONS(624),
    [anon_sym_abstract] = ACTIONS(624),
    [anon_sym_final] = ACTIONS(624),
    [anon_sym_strictfp] = ACTIONS(624),
    [anon_sym_native] = ACTIONS(624),
    [anon_sym_transient] = ACTIONS(624),
    [anon_sym_volatile] = ACTIONS(624),
    [anon_sym_ATinterface] = ACTIONS(622),
    [anon_sym_interface] = ACTIONS(624),
    [anon_sym_byte] = ACTIONS(624),
    [anon_sym_short] = ACTIONS(624),
    [anon_sym_int] = ACTIONS(624),
    [anon_sym_long] = ACTIONS(624),
    [anon_sym_char] = ACTIONS(624),
    [anon_sym_float] = ACTIONS(624),
    [anon_sym_double] = ACTIONS(624),
    [sym_boolean_type] = ACTIONS(624),
    [sym_void_type] = ACTIONS(624),
    [sym_this] = ACTIONS(624),
    [sym_super] = ACTIONS(624),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(626),
    [sym_identifier] = ACTIONS(628),
    [sym_decimal_integer_literal] = ACTIONS(628),
    [sym_hex_integer_literal] = ACTIONS(628),
    [sym_octal_integer_literal] = ACTIONS(626),
    [sym_binary_integer_literal] = ACTIONS(626),
    [sym_decimal_floating_point_literal] = ACTIONS(626),
    [sym_hex_floating_point_literal] = ACTIONS(628),
    [sym_true] = ACTIONS(628),
    [sym_false] = ACTIONS(628),
    [sym_character_literal] = ACTIONS(626),
    [sym_string_literal] = ACTIONS(626),
    [sym_null_literal] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(626),
    [anon_sym_PLUS_PLUS] = ACTIONS(626),
    [anon_sym_DASH_DASH] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(628),
    [anon_sym_SEMI] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_RBRACE] = ACTIONS(626),
    [anon_sym_assert] = ACTIONS(628),
    [anon_sym_switch] = ACTIONS(628),
    [anon_sym_case] = ACTIONS(628),
    [anon_sym_default] = ACTIONS(628),
    [anon_sym_do] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(628),
    [anon_sym_break] = ACTIONS(628),
    [anon_sym_continue] = ACTIONS(628),
    [anon_sym_return] = ACTIONS(628),
    [anon_sym_synchronized] = ACTIONS(628),
    [anon_sym_throw] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(628),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(628),
    [anon_sym_open] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_package] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(628),
    [anon_sym_enum] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_abstract] = ACTIONS(628),
    [anon_sym_final] = ACTIONS(628),
    [anon_sym_strictfp] = ACTIONS(628),
    [anon_sym_native] = ACTIONS(628),
    [anon_sym_transient] = ACTIONS(628),
    [anon_sym_volatile] = ACTIONS(628),
    [anon_sym_ATinterface] = ACTIONS(626),
    [anon_sym_interface] = ACTIONS(628),
    [anon_sym_byte] = ACTIONS(628),
    [anon_sym_short] = ACTIONS(628),
    [anon_sym_int] = ACTIONS(628),
    [anon_sym_long] = ACTIONS(628),
    [anon_sym_char] = ACTIONS(628),
    [anon_sym_float] = ACTIONS(628),
    [anon_sym_double] = ACTIONS(628),
    [sym_boolean_type] = ACTIONS(628),
    [sym_void_type] = ACTIONS(628),
    [sym_this] = ACTIONS(628),
    [sym_super] = ACTIONS(628),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(630),
    [sym_identifier] = ACTIONS(632),
    [sym_decimal_integer_literal] = ACTIONS(632),
    [sym_hex_integer_literal] = ACTIONS(632),
    [sym_octal_integer_literal] = ACTIONS(630),
    [sym_binary_integer_literal] = ACTIONS(630),
    [sym_decimal_floating_point_literal] = ACTIONS(630),
    [sym_hex_floating_point_literal] = ACTIONS(632),
    [sym_true] = ACTIONS(632),
    [sym_false] = ACTIONS(632),
    [sym_character_literal] = ACTIONS(630),
    [sym_string_literal] = ACTIONS(630),
    [sym_null_literal] = ACTIONS(632),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(630),
    [anon_sym_PLUS_PLUS] = ACTIONS(630),
    [anon_sym_DASH_DASH] = ACTIONS(630),
    [anon_sym_new] = ACTIONS(632),
    [anon_sym_class] = ACTIONS(632),
    [anon_sym_SEMI] = ACTIONS(630),
    [anon_sym_LBRACE] = ACTIONS(630),
    [anon_sym_RBRACE] = ACTIONS(630),
    [anon_sym_assert] = ACTIONS(632),
    [anon_sym_switch] = ACTIONS(632),
    [anon_sym_case] = ACTIONS(632),
    [anon_sym_default] = ACTIONS(632),
    [anon_sym_do] = ACTIONS(632),
    [anon_sym_while] = ACTIONS(632),
    [anon_sym_break] = ACTIONS(632),
    [anon_sym_continue] = ACTIONS(632),
    [anon_sym_return] = ACTIONS(632),
    [anon_sym_synchronized] = ACTIONS(632),
    [anon_sym_throw] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_else] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(632),
    [anon_sym_AT] = ACTIONS(632),
    [anon_sym_open] = ACTIONS(632),
    [anon_sym_module] = ACTIONS(632),
    [anon_sym_static] = ACTIONS(632),
    [anon_sym_package] = ACTIONS(632),
    [anon_sym_import] = ACTIONS(632),
    [anon_sym_enum] = ACTIONS(632),
    [anon_sym_public] = ACTIONS(632),
    [anon_sym_protected] = ACTIONS(632),
    [anon_sym_private] = ACTIONS(632),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_final] = ACTIONS(632),
    [anon_sym_strictfp] = ACTIONS(632),
    [anon_sym_native] = ACTIONS(632),
    [anon_sym_transient] = ACTIONS(632),
    [anon_sym_volatile] = ACTIONS(632),
    [anon_sym_ATinterface] = ACTIONS(630),
    [anon_sym_interface] = ACTIONS(632),
    [anon_sym_byte] = ACTIONS(632),
    [anon_sym_short] = ACTIONS(632),
    [anon_sym_int] = ACTIONS(632),
    [anon_sym_long] = ACTIONS(632),
    [anon_sym_char] = ACTIONS(632),
    [anon_sym_float] = ACTIONS(632),
    [anon_sym_double] = ACTIONS(632),
    [sym_boolean_type] = ACTIONS(632),
    [sym_void_type] = ACTIONS(632),
    [sym_this] = ACTIONS(632),
    [sym_super] = ACTIONS(632),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(634),
    [sym_identifier] = ACTIONS(636),
    [sym_decimal_integer_literal] = ACTIONS(636),
    [sym_hex_integer_literal] = ACTIONS(636),
    [sym_octal_integer_literal] = ACTIONS(634),
    [sym_binary_integer_literal] = ACTIONS(634),
    [sym_decimal_floating_point_literal] = ACTIONS(634),
    [sym_hex_floating_point_literal] = ACTIONS(636),
    [sym_true] = ACTIONS(636),
    [sym_false] = ACTIONS(636),
    [sym_character_literal] = ACTIONS(634),
    [sym_string_literal] = ACTIONS(634),
    [sym_null_literal] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(634),
    [anon_sym_PLUS_PLUS] = ACTIONS(634),
    [anon_sym_DASH_DASH] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_class] = ACTIONS(636),
    [anon_sym_SEMI] = ACTIONS(634),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_RBRACE] = ACTIONS(634),
    [anon_sym_assert] = ACTIONS(636),
    [anon_sym_switch] = ACTIONS(636),
    [anon_sym_case] = ACTIONS(636),
    [anon_sym_default] = ACTIONS(636),
    [anon_sym_do] = ACTIONS(636),
    [anon_sym_while] = ACTIONS(636),
    [anon_sym_break] = ACTIONS(636),
    [anon_sym_continue] = ACTIONS(636),
    [anon_sym_return] = ACTIONS(636),
    [anon_sym_synchronized] = ACTIONS(636),
    [anon_sym_throw] = ACTIONS(636),
    [anon_sym_try] = ACTIONS(636),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_else] = ACTIONS(636),
    [anon_sym_for] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_open] = ACTIONS(636),
    [anon_sym_module] = ACTIONS(636),
    [anon_sym_static] = ACTIONS(636),
    [anon_sym_package] = ACTIONS(636),
    [anon_sym_import] = ACTIONS(636),
    [anon_sym_enum] = ACTIONS(636),
    [anon_sym_public] = ACTIONS(636),
    [anon_sym_protected] = ACTIONS(636),
    [anon_sym_private] = ACTIONS(636),
    [anon_sym_abstract] = ACTIONS(636),
    [anon_sym_final] = ACTIONS(636),
    [anon_sym_strictfp] = ACTIONS(636),
    [anon_sym_native] = ACTIONS(636),
    [anon_sym_transient] = ACTIONS(636),
    [anon_sym_volatile] = ACTIONS(636),
    [anon_sym_ATinterface] = ACTIONS(634),
    [anon_sym_interface] = ACTIONS(636),
    [anon_sym_byte] = ACTIONS(636),
    [anon_sym_short] = ACTIONS(636),
    [anon_sym_int] = ACTIONS(636),
    [anon_sym_long] = ACTIONS(636),
    [anon_sym_char] = ACTIONS(636),
    [anon_sym_float] = ACTIONS(636),
    [anon_sym_double] = ACTIONS(636),
    [sym_boolean_type] = ACTIONS(636),
    [sym_void_type] = ACTIONS(636),
    [sym_this] = ACTIONS(636),
    [sym_super] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_identifier] = ACTIONS(391),
    [sym_decimal_integer_literal] = ACTIONS(391),
    [sym_hex_integer_literal] = ACTIONS(391),
    [sym_octal_integer_literal] = ACTIONS(389),
    [sym_binary_integer_literal] = ACTIONS(389),
    [sym_decimal_floating_point_literal] = ACTIONS(389),
    [sym_hex_floating_point_literal] = ACTIONS(391),
    [sym_true] = ACTIONS(391),
    [sym_false] = ACTIONS(391),
    [sym_character_literal] = ACTIONS(389),
    [sym_string_literal] = ACTIONS(389),
    [sym_null_literal] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_TILDE] = ACTIONS(389),
    [anon_sym_PLUS_PLUS] = ACTIONS(389),
    [anon_sym_DASH_DASH] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(391),
    [anon_sym_class] = ACTIONS(391),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_LBRACE] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_assert] = ACTIONS(391),
    [anon_sym_switch] = ACTIONS(391),
    [anon_sym_case] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(391),
    [anon_sym_break] = ACTIONS(391),
    [anon_sym_continue] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(391),
    [anon_sym_synchronized] = ACTIONS(391),
    [anon_sym_throw] = ACTIONS(391),
    [anon_sym_try] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_else] = ACTIONS(391),
    [anon_sym_for] = ACTIONS(391),
    [anon_sym_AT] = ACTIONS(391),
    [anon_sym_open] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(391),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_package] = ACTIONS(391),
    [anon_sym_import] = ACTIONS(391),
    [anon_sym_enum] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(391),
    [anon_sym_final] = ACTIONS(391),
    [anon_sym_strictfp] = ACTIONS(391),
    [anon_sym_native] = ACTIONS(391),
    [anon_sym_transient] = ACTIONS(391),
    [anon_sym_volatile] = ACTIONS(391),
    [anon_sym_ATinterface] = ACTIONS(389),
    [anon_sym_interface] = ACTIONS(391),
    [anon_sym_byte] = ACTIONS(391),
    [anon_sym_short] = ACTIONS(391),
    [anon_sym_int] = ACTIONS(391),
    [anon_sym_long] = ACTIONS(391),
    [anon_sym_char] = ACTIONS(391),
    [anon_sym_float] = ACTIONS(391),
    [anon_sym_double] = ACTIONS(391),
    [sym_boolean_type] = ACTIONS(391),
    [sym_void_type] = ACTIONS(391),
    [sym_this] = ACTIONS(391),
    [sym_super] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(638),
    [sym_identifier] = ACTIONS(640),
    [sym_decimal_integer_literal] = ACTIONS(640),
    [sym_hex_integer_literal] = ACTIONS(640),
    [sym_octal_integer_literal] = ACTIONS(638),
    [sym_binary_integer_literal] = ACTIONS(638),
    [sym_decimal_floating_point_literal] = ACTIONS(638),
    [sym_hex_floating_point_literal] = ACTIONS(640),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_character_literal] = ACTIONS(638),
    [sym_string_literal] = ACTIONS(638),
    [sym_null_literal] = ACTIONS(640),
    [anon_sym_LPAREN] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_new] = ACTIONS(640),
    [anon_sym_class] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_assert] = ACTIONS(640),
    [anon_sym_switch] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(640),
    [anon_sym_default] = ACTIONS(640),
    [anon_sym_do] = ACTIONS(640),
    [anon_sym_while] = ACTIONS(640),
    [anon_sym_break] = ACTIONS(640),
    [anon_sym_continue] = ACTIONS(640),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_synchronized] = ACTIONS(640),
    [anon_sym_throw] = ACTIONS(640),
    [anon_sym_try] = ACTIONS(640),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_else] = ACTIONS(640),
    [anon_sym_for] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(640),
    [anon_sym_open] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_package] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(640),
    [anon_sym_enum] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(640),
    [anon_sym_final] = ACTIONS(640),
    [anon_sym_strictfp] = ACTIONS(640),
    [anon_sym_native] = ACTIONS(640),
    [anon_sym_transient] = ACTIONS(640),
    [anon_sym_volatile] = ACTIONS(640),
    [anon_sym_ATinterface] = ACTIONS(638),
    [anon_sym_interface] = ACTIONS(640),
    [anon_sym_byte] = ACTIONS(640),
    [anon_sym_short] = ACTIONS(640),
    [anon_sym_int] = ACTIONS(640),
    [anon_sym_long] = ACTIONS(640),
    [anon_sym_char] = ACTIONS(640),
    [anon_sym_float] = ACTIONS(640),
    [anon_sym_double] = ACTIONS(640),
    [sym_boolean_type] = ACTIONS(640),
    [sym_void_type] = ACTIONS(640),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(640),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(441),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(644),
    [sym_identifier] = ACTIONS(646),
    [sym_decimal_integer_literal] = ACTIONS(646),
    [sym_hex_integer_literal] = ACTIONS(646),
    [sym_octal_integer_literal] = ACTIONS(644),
    [sym_binary_integer_literal] = ACTIONS(644),
    [sym_decimal_floating_point_literal] = ACTIONS(644),
    [sym_hex_floating_point_literal] = ACTIONS(646),
    [sym_true] = ACTIONS(646),
    [sym_false] = ACTIONS(646),
    [sym_character_literal] = ACTIONS(644),
    [sym_string_literal] = ACTIONS(644),
    [sym_null_literal] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_TILDE] = ACTIONS(644),
    [anon_sym_PLUS_PLUS] = ACTIONS(644),
    [anon_sym_DASH_DASH] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(646),
    [anon_sym_SEMI] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_assert] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(646),
    [anon_sym_case] = ACTIONS(646),
    [anon_sym_default] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(646),
    [anon_sym_break] = ACTIONS(646),
    [anon_sym_continue] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(646),
    [anon_sym_synchronized] = ACTIONS(646),
    [anon_sym_throw] = ACTIONS(646),
    [anon_sym_try] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_open] = ACTIONS(646),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_static] = ACTIONS(646),
    [anon_sym_package] = ACTIONS(646),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_enum] = ACTIONS(646),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_abstract] = ACTIONS(646),
    [anon_sym_final] = ACTIONS(646),
    [anon_sym_strictfp] = ACTIONS(646),
    [anon_sym_native] = ACTIONS(646),
    [anon_sym_transient] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym_ATinterface] = ACTIONS(644),
    [anon_sym_interface] = ACTIONS(646),
    [anon_sym_byte] = ACTIONS(646),
    [anon_sym_short] = ACTIONS(646),
    [anon_sym_int] = ACTIONS(646),
    [anon_sym_long] = ACTIONS(646),
    [anon_sym_char] = ACTIONS(646),
    [anon_sym_float] = ACTIONS(646),
    [anon_sym_double] = ACTIONS(646),
    [sym_boolean_type] = ACTIONS(646),
    [sym_void_type] = ACTIONS(646),
    [sym_this] = ACTIONS(646),
    [sym_super] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(648),
    [sym_identifier] = ACTIONS(650),
    [sym_decimal_integer_literal] = ACTIONS(650),
    [sym_hex_integer_literal] = ACTIONS(650),
    [sym_octal_integer_literal] = ACTIONS(648),
    [sym_binary_integer_literal] = ACTIONS(648),
    [sym_decimal_floating_point_literal] = ACTIONS(648),
    [sym_hex_floating_point_literal] = ACTIONS(650),
    [sym_true] = ACTIONS(650),
    [sym_false] = ACTIONS(650),
    [sym_character_literal] = ACTIONS(648),
    [sym_string_literal] = ACTIONS(648),
    [sym_null_literal] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_TILDE] = ACTIONS(648),
    [anon_sym_PLUS_PLUS] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(648),
    [anon_sym_new] = ACTIONS(650),
    [anon_sym_class] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_RBRACE] = ACTIONS(648),
    [anon_sym_assert] = ACTIONS(650),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(650),
    [anon_sym_do] = ACTIONS(650),
    [anon_sym_while] = ACTIONS(650),
    [anon_sym_break] = ACTIONS(650),
    [anon_sym_continue] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_synchronized] = ACTIONS(650),
    [anon_sym_throw] = ACTIONS(650),
    [anon_sym_try] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_for] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_open] = ACTIONS(650),
    [anon_sym_module] = ACTIONS(650),
    [anon_sym_static] = ACTIONS(650),
    [anon_sym_package] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(650),
    [anon_sym_public] = ACTIONS(650),
    [anon_sym_protected] = ACTIONS(650),
    [anon_sym_private] = ACTIONS(650),
    [anon_sym_abstract] = ACTIONS(650),
    [anon_sym_final] = ACTIONS(650),
    [anon_sym_strictfp] = ACTIONS(650),
    [anon_sym_native] = ACTIONS(650),
    [anon_sym_transient] = ACTIONS(650),
    [anon_sym_volatile] = ACTIONS(650),
    [anon_sym_ATinterface] = ACTIONS(648),
    [anon_sym_interface] = ACTIONS(650),
    [anon_sym_byte] = ACTIONS(650),
    [anon_sym_short] = ACTIONS(650),
    [anon_sym_int] = ACTIONS(650),
    [anon_sym_long] = ACTIONS(650),
    [anon_sym_char] = ACTIONS(650),
    [anon_sym_float] = ACTIONS(650),
    [anon_sym_double] = ACTIONS(650),
    [sym_boolean_type] = ACTIONS(650),
    [sym_void_type] = ACTIONS(650),
    [sym_this] = ACTIONS(650),
    [sym_super] = ACTIONS(650),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(652),
    [sym_identifier] = ACTIONS(654),
    [sym_decimal_integer_literal] = ACTIONS(654),
    [sym_hex_integer_literal] = ACTIONS(654),
    [sym_octal_integer_literal] = ACTIONS(652),
    [sym_binary_integer_literal] = ACTIONS(652),
    [sym_decimal_floating_point_literal] = ACTIONS(652),
    [sym_hex_floating_point_literal] = ACTIONS(654),
    [sym_true] = ACTIONS(654),
    [sym_false] = ACTIONS(654),
    [sym_character_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(652),
    [sym_null_literal] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_PLUS_PLUS] = ACTIONS(652),
    [anon_sym_DASH_DASH] = ACTIONS(652),
    [anon_sym_new] = ACTIONS(654),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_assert] = ACTIONS(654),
    [anon_sym_switch] = ACTIONS(654),
    [anon_sym_case] = ACTIONS(654),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_break] = ACTIONS(654),
    [anon_sym_continue] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(654),
    [anon_sym_synchronized] = ACTIONS(654),
    [anon_sym_throw] = ACTIONS(654),
    [anon_sym_try] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(654),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_open] = ACTIONS(654),
    [anon_sym_module] = ACTIONS(654),
    [anon_sym_static] = ACTIONS(654),
    [anon_sym_package] = ACTIONS(654),
    [anon_sym_import] = ACTIONS(654),
    [anon_sym_enum] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(654),
    [anon_sym_protected] = ACTIONS(654),
    [anon_sym_private] = ACTIONS(654),
    [anon_sym_abstract] = ACTIONS(654),
    [anon_sym_final] = ACTIONS(654),
    [anon_sym_strictfp] = ACTIONS(654),
    [anon_sym_native] = ACTIONS(654),
    [anon_sym_transient] = ACTIONS(654),
    [anon_sym_volatile] = ACTIONS(654),
    [anon_sym_ATinterface] = ACTIONS(652),
    [anon_sym_interface] = ACTIONS(654),
    [anon_sym_byte] = ACTIONS(654),
    [anon_sym_short] = ACTIONS(654),
    [anon_sym_int] = ACTIONS(654),
    [anon_sym_long] = ACTIONS(654),
    [anon_sym_char] = ACTIONS(654),
    [anon_sym_float] = ACTIONS(654),
    [anon_sym_double] = ACTIONS(654),
    [sym_boolean_type] = ACTIONS(654),
    [sym_void_type] = ACTIONS(654),
    [sym_this] = ACTIONS(654),
    [sym_super] = ACTIONS(654),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(422),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(658),
    [sym_identifier] = ACTIONS(660),
    [sym_decimal_integer_literal] = ACTIONS(660),
    [sym_hex_integer_literal] = ACTIONS(660),
    [sym_octal_integer_literal] = ACTIONS(658),
    [sym_binary_integer_literal] = ACTIONS(658),
    [sym_decimal_floating_point_literal] = ACTIONS(658),
    [sym_hex_floating_point_literal] = ACTIONS(660),
    [sym_true] = ACTIONS(660),
    [sym_false] = ACTIONS(660),
    [sym_character_literal] = ACTIONS(658),
    [sym_string_literal] = ACTIONS(658),
    [sym_null_literal] = ACTIONS(660),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_BANG] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(658),
    [anon_sym_PLUS_PLUS] = ACTIONS(658),
    [anon_sym_DASH_DASH] = ACTIONS(658),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_class] = ACTIONS(660),
    [anon_sym_SEMI] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(658),
    [anon_sym_RBRACE] = ACTIONS(658),
    [anon_sym_assert] = ACTIONS(660),
    [anon_sym_switch] = ACTIONS(660),
    [anon_sym_case] = ACTIONS(660),
    [anon_sym_default] = ACTIONS(660),
    [anon_sym_do] = ACTIONS(660),
    [anon_sym_while] = ACTIONS(660),
    [anon_sym_break] = ACTIONS(660),
    [anon_sym_continue] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(660),
    [anon_sym_synchronized] = ACTIONS(660),
    [anon_sym_throw] = ACTIONS(660),
    [anon_sym_try] = ACTIONS(660),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_else] = ACTIONS(660),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(660),
    [anon_sym_open] = ACTIONS(660),
    [anon_sym_module] = ACTIONS(660),
    [anon_sym_static] = ACTIONS(660),
    [anon_sym_package] = ACTIONS(660),
    [anon_sym_import] = ACTIONS(660),
    [anon_sym_enum] = ACTIONS(660),
    [anon_sym_public] = ACTIONS(660),
    [anon_sym_protected] = ACTIONS(660),
    [anon_sym_private] = ACTIONS(660),
    [anon_sym_abstract] = ACTIONS(660),
    [anon_sym_final] = ACTIONS(660),
    [anon_sym_strictfp] = ACTIONS(660),
    [anon_sym_native] = ACTIONS(660),
    [anon_sym_transient] = ACTIONS(660),
    [anon_sym_volatile] = ACTIONS(660),
    [anon_sym_ATinterface] = ACTIONS(658),
    [anon_sym_interface] = ACTIONS(660),
    [anon_sym_byte] = ACTIONS(660),
    [anon_sym_short] = ACTIONS(660),
    [anon_sym_int] = ACTIONS(660),
    [anon_sym_long] = ACTIONS(660),
    [anon_sym_char] = ACTIONS(660),
    [anon_sym_float] = ACTIONS(660),
    [anon_sym_double] = ACTIONS(660),
    [sym_boolean_type] = ACTIONS(660),
    [sym_void_type] = ACTIONS(660),
    [sym_this] = ACTIONS(660),
    [sym_super] = ACTIONS(660),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(464),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(664),
    [sym_identifier] = ACTIONS(666),
    [sym_decimal_integer_literal] = ACTIONS(666),
    [sym_hex_integer_literal] = ACTIONS(666),
    [sym_octal_integer_literal] = ACTIONS(664),
    [sym_binary_integer_literal] = ACTIONS(664),
    [sym_decimal_floating_point_literal] = ACTIONS(664),
    [sym_hex_floating_point_literal] = ACTIONS(666),
    [sym_true] = ACTIONS(666),
    [sym_false] = ACTIONS(666),
    [sym_character_literal] = ACTIONS(664),
    [sym_string_literal] = ACTIONS(664),
    [sym_null_literal] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_TILDE] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(664),
    [anon_sym_DASH_DASH] = ACTIONS(664),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LBRACE] = ACTIONS(664),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_assert] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_synchronized] = ACTIONS(666),
    [anon_sym_throw] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_open] = ACTIONS(666),
    [anon_sym_module] = ACTIONS(666),
    [anon_sym_static] = ACTIONS(666),
    [anon_sym_package] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(666),
    [anon_sym_enum] = ACTIONS(666),
    [anon_sym_public] = ACTIONS(666),
    [anon_sym_protected] = ACTIONS(666),
    [anon_sym_private] = ACTIONS(666),
    [anon_sym_abstract] = ACTIONS(666),
    [anon_sym_final] = ACTIONS(666),
    [anon_sym_strictfp] = ACTIONS(666),
    [anon_sym_native] = ACTIONS(666),
    [anon_sym_transient] = ACTIONS(666),
    [anon_sym_volatile] = ACTIONS(666),
    [anon_sym_ATinterface] = ACTIONS(664),
    [anon_sym_interface] = ACTIONS(666),
    [anon_sym_byte] = ACTIONS(666),
    [anon_sym_short] = ACTIONS(666),
    [anon_sym_int] = ACTIONS(666),
    [anon_sym_long] = ACTIONS(666),
    [anon_sym_char] = ACTIONS(666),
    [anon_sym_float] = ACTIONS(666),
    [anon_sym_double] = ACTIONS(666),
    [sym_boolean_type] = ACTIONS(666),
    [sym_void_type] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_super] = ACTIONS(666),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(429),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(424),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(428),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [sym_decimal_integer_literal] = ACTIONS(676),
    [sym_hex_integer_literal] = ACTIONS(676),
    [sym_octal_integer_literal] = ACTIONS(674),
    [sym_binary_integer_literal] = ACTIONS(674),
    [sym_decimal_floating_point_literal] = ACTIONS(674),
    [sym_hex_floating_point_literal] = ACTIONS(676),
    [sym_true] = ACTIONS(676),
    [sym_false] = ACTIONS(676),
    [sym_character_literal] = ACTIONS(674),
    [sym_string_literal] = ACTIONS(674),
    [sym_null_literal] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(674),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_BANG] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(674),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_SEMI] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_assert] = ACTIONS(676),
    [anon_sym_switch] = ACTIONS(676),
    [anon_sym_case] = ACTIONS(676),
    [anon_sym_default] = ACTIONS(676),
    [anon_sym_do] = ACTIONS(676),
    [anon_sym_while] = ACTIONS(676),
    [anon_sym_break] = ACTIONS(676),
    [anon_sym_continue] = ACTIONS(676),
    [anon_sym_return] = ACTIONS(676),
    [anon_sym_synchronized] = ACTIONS(676),
    [anon_sym_throw] = ACTIONS(676),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_for] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(676),
    [anon_sym_open] = ACTIONS(676),
    [anon_sym_module] = ACTIONS(676),
    [anon_sym_static] = ACTIONS(676),
    [anon_sym_package] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_enum] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_final] = ACTIONS(676),
    [anon_sym_strictfp] = ACTIONS(676),
    [anon_sym_native] = ACTIONS(676),
    [anon_sym_transient] = ACTIONS(676),
    [anon_sym_volatile] = ACTIONS(676),
    [anon_sym_ATinterface] = ACTIONS(674),
    [anon_sym_interface] = ACTIONS(676),
    [anon_sym_byte] = ACTIONS(676),
    [anon_sym_short] = ACTIONS(676),
    [anon_sym_int] = ACTIONS(676),
    [anon_sym_long] = ACTIONS(676),
    [anon_sym_char] = ACTIONS(676),
    [anon_sym_float] = ACTIONS(676),
    [anon_sym_double] = ACTIONS(676),
    [sym_boolean_type] = ACTIONS(676),
    [sym_void_type] = ACTIONS(676),
    [sym_this] = ACTIONS(676),
    [sym_super] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(678),
    [sym_identifier] = ACTIONS(680),
    [sym_decimal_integer_literal] = ACTIONS(680),
    [sym_hex_integer_literal] = ACTIONS(680),
    [sym_octal_integer_literal] = ACTIONS(678),
    [sym_binary_integer_literal] = ACTIONS(678),
    [sym_decimal_floating_point_literal] = ACTIONS(678),
    [sym_hex_floating_point_literal] = ACTIONS(680),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_character_literal] = ACTIONS(678),
    [sym_string_literal] = ACTIONS(678),
    [sym_null_literal] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(678),
    [anon_sym_DASH_DASH] = ACTIONS(678),
    [anon_sym_new] = ACTIONS(680),
    [anon_sym_class] = ACTIONS(680),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_assert] = ACTIONS(680),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(680),
    [anon_sym_default] = ACTIONS(680),
    [anon_sym_do] = ACTIONS(680),
    [anon_sym_while] = ACTIONS(680),
    [anon_sym_break] = ACTIONS(680),
    [anon_sym_continue] = ACTIONS(680),
    [anon_sym_return] = ACTIONS(680),
    [anon_sym_synchronized] = ACTIONS(680),
    [anon_sym_throw] = ACTIONS(680),
    [anon_sym_try] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_else] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [anon_sym_open] = ACTIONS(680),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_static] = ACTIONS(680),
    [anon_sym_package] = ACTIONS(680),
    [anon_sym_import] = ACTIONS(680),
    [anon_sym_enum] = ACTIONS(680),
    [anon_sym_public] = ACTIONS(680),
    [anon_sym_protected] = ACTIONS(680),
    [anon_sym_private] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(680),
    [anon_sym_final] = ACTIONS(680),
    [anon_sym_strictfp] = ACTIONS(680),
    [anon_sym_native] = ACTIONS(680),
    [anon_sym_transient] = ACTIONS(680),
    [anon_sym_volatile] = ACTIONS(680),
    [anon_sym_ATinterface] = ACTIONS(678),
    [anon_sym_interface] = ACTIONS(680),
    [anon_sym_byte] = ACTIONS(680),
    [anon_sym_short] = ACTIONS(680),
    [anon_sym_int] = ACTIONS(680),
    [anon_sym_long] = ACTIONS(680),
    [anon_sym_char] = ACTIONS(680),
    [anon_sym_float] = ACTIONS(680),
    [anon_sym_double] = ACTIONS(680),
    [sym_boolean_type] = ACTIONS(680),
    [sym_void_type] = ACTIONS(680),
    [sym_this] = ACTIONS(680),
    [sym_super] = ACTIONS(680),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(682),
    [sym_identifier] = ACTIONS(684),
    [sym_decimal_integer_literal] = ACTIONS(684),
    [sym_hex_integer_literal] = ACTIONS(684),
    [sym_octal_integer_literal] = ACTIONS(682),
    [sym_binary_integer_literal] = ACTIONS(682),
    [sym_decimal_floating_point_literal] = ACTIONS(682),
    [sym_hex_floating_point_literal] = ACTIONS(684),
    [sym_true] = ACTIONS(684),
    [sym_false] = ACTIONS(684),
    [sym_character_literal] = ACTIONS(682),
    [sym_string_literal] = ACTIONS(682),
    [sym_null_literal] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(682),
    [anon_sym_PLUS] = ACTIONS(684),
    [anon_sym_DASH] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(682),
    [anon_sym_TILDE] = ACTIONS(682),
    [anon_sym_PLUS_PLUS] = ACTIONS(682),
    [anon_sym_DASH_DASH] = ACTIONS(682),
    [anon_sym_new] = ACTIONS(684),
    [anon_sym_class] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(682),
    [anon_sym_assert] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_break] = ACTIONS(684),
    [anon_sym_continue] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_synchronized] = ACTIONS(684),
    [anon_sym_throw] = ACTIONS(684),
    [anon_sym_try] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(684),
    [anon_sym_open] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_package] = ACTIONS(684),
    [anon_sym_import] = ACTIONS(684),
    [anon_sym_enum] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(684),
    [anon_sym_final] = ACTIONS(684),
    [anon_sym_strictfp] = ACTIONS(684),
    [anon_sym_native] = ACTIONS(684),
    [anon_sym_transient] = ACTIONS(684),
    [anon_sym_volatile] = ACTIONS(684),
    [anon_sym_ATinterface] = ACTIONS(682),
    [anon_sym_interface] = ACTIONS(684),
    [anon_sym_byte] = ACTIONS(684),
    [anon_sym_short] = ACTIONS(684),
    [anon_sym_int] = ACTIONS(684),
    [anon_sym_long] = ACTIONS(684),
    [anon_sym_char] = ACTIONS(684),
    [anon_sym_float] = ACTIONS(684),
    [anon_sym_double] = ACTIONS(684),
    [sym_boolean_type] = ACTIONS(684),
    [sym_void_type] = ACTIONS(684),
    [sym_this] = ACTIONS(684),
    [sym_super] = ACTIONS(684),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(686),
    [sym_identifier] = ACTIONS(688),
    [sym_decimal_integer_literal] = ACTIONS(688),
    [sym_hex_integer_literal] = ACTIONS(688),
    [sym_octal_integer_literal] = ACTIONS(686),
    [sym_binary_integer_literal] = ACTIONS(686),
    [sym_decimal_floating_point_literal] = ACTIONS(686),
    [sym_hex_floating_point_literal] = ACTIONS(688),
    [sym_true] = ACTIONS(688),
    [sym_false] = ACTIONS(688),
    [sym_character_literal] = ACTIONS(686),
    [sym_string_literal] = ACTIONS(686),
    [sym_null_literal] = ACTIONS(688),
    [anon_sym_LPAREN] = ACTIONS(686),
    [anon_sym_PLUS] = ACTIONS(688),
    [anon_sym_DASH] = ACTIONS(688),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_PLUS_PLUS] = ACTIONS(686),
    [anon_sym_DASH_DASH] = ACTIONS(686),
    [anon_sym_new] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(688),
    [anon_sym_SEMI] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(686),
    [anon_sym_RBRACE] = ACTIONS(686),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_switch] = ACTIONS(688),
    [anon_sym_case] = ACTIONS(688),
    [anon_sym_default] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(688),
    [anon_sym_while] = ACTIONS(688),
    [anon_sym_break] = ACTIONS(688),
    [anon_sym_continue] = ACTIONS(688),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_synchronized] = ACTIONS(688),
    [anon_sym_throw] = ACTIONS(688),
    [anon_sym_try] = ACTIONS(688),
    [anon_sym_if] = ACTIONS(688),
    [anon_sym_else] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(688),
    [anon_sym_open] = ACTIONS(688),
    [anon_sym_module] = ACTIONS(688),
    [anon_sym_static] = ACTIONS(688),
    [anon_sym_package] = ACTIONS(688),
    [anon_sym_import] = ACTIONS(688),
    [anon_sym_enum] = ACTIONS(688),
    [anon_sym_public] = ACTIONS(688),
    [anon_sym_protected] = ACTIONS(688),
    [anon_sym_private] = ACTIONS(688),
    [anon_sym_abstract] = ACTIONS(688),
    [anon_sym_final] = ACTIONS(688),
    [anon_sym_strictfp] = ACTIONS(688),
    [anon_sym_native] = ACTIONS(688),
    [anon_sym_transient] = ACTIONS(688),
    [anon_sym_volatile] = ACTIONS(688),
    [anon_sym_ATinterface] = ACTIONS(686),
    [anon_sym_interface] = ACTIONS(688),
    [anon_sym_byte] = ACTIONS(688),
    [anon_sym_short] = ACTIONS(688),
    [anon_sym_int] = ACTIONS(688),
    [anon_sym_long] = ACTIONS(688),
    [anon_sym_char] = ACTIONS(688),
    [anon_sym_float] = ACTIONS(688),
    [anon_sym_double] = ACTIONS(688),
    [sym_boolean_type] = ACTIONS(688),
    [sym_void_type] = ACTIONS(688),
    [sym_this] = ACTIONS(688),
    [sym_super] = ACTIONS(688),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(690),
    [sym_identifier] = ACTIONS(692),
    [sym_decimal_integer_literal] = ACTIONS(692),
    [sym_hex_integer_literal] = ACTIONS(692),
    [sym_octal_integer_literal] = ACTIONS(690),
    [sym_binary_integer_literal] = ACTIONS(690),
    [sym_decimal_floating_point_literal] = ACTIONS(690),
    [sym_hex_floating_point_literal] = ACTIONS(692),
    [sym_true] = ACTIONS(692),
    [sym_false] = ACTIONS(692),
    [sym_character_literal] = ACTIONS(690),
    [sym_string_literal] = ACTIONS(690),
    [sym_null_literal] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_PLUS] = ACTIONS(692),
    [anon_sym_DASH] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(690),
    [anon_sym_TILDE] = ACTIONS(690),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_class] = ACTIONS(692),
    [anon_sym_SEMI] = ACTIONS(690),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_assert] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(692),
    [anon_sym_case] = ACTIONS(692),
    [anon_sym_default] = ACTIONS(692),
    [anon_sym_do] = ACTIONS(692),
    [anon_sym_while] = ACTIONS(692),
    [anon_sym_break] = ACTIONS(692),
    [anon_sym_continue] = ACTIONS(692),
    [anon_sym_return] = ACTIONS(692),
    [anon_sym_synchronized] = ACTIONS(692),
    [anon_sym_throw] = ACTIONS(692),
    [anon_sym_try] = ACTIONS(692),
    [anon_sym_if] = ACTIONS(692),
    [anon_sym_else] = ACTIONS(692),
    [anon_sym_for] = ACTIONS(692),
    [anon_sym_AT] = ACTIONS(692),
    [anon_sym_open] = ACTIONS(692),
    [anon_sym_module] = ACTIONS(692),
    [anon_sym_static] = ACTIONS(692),
    [anon_sym_package] = ACTIONS(692),
    [anon_sym_import] = ACTIONS(692),
    [anon_sym_enum] = ACTIONS(692),
    [anon_sym_public] = ACTIONS(692),
    [anon_sym_protected] = ACTIONS(692),
    [anon_sym_private] = ACTIONS(692),
    [anon_sym_abstract] = ACTIONS(692),
    [anon_sym_final] = ACTIONS(692),
    [anon_sym_strictfp] = ACTIONS(692),
    [anon_sym_native] = ACTIONS(692),
    [anon_sym_transient] = ACTIONS(692),
    [anon_sym_volatile] = ACTIONS(692),
    [anon_sym_ATinterface] = ACTIONS(690),
    [anon_sym_interface] = ACTIONS(692),
    [anon_sym_byte] = ACTIONS(692),
    [anon_sym_short] = ACTIONS(692),
    [anon_sym_int] = ACTIONS(692),
    [anon_sym_long] = ACTIONS(692),
    [anon_sym_char] = ACTIONS(692),
    [anon_sym_float] = ACTIONS(692),
    [anon_sym_double] = ACTIONS(692),
    [sym_boolean_type] = ACTIONS(692),
    [sym_void_type] = ACTIONS(692),
    [sym_this] = ACTIONS(692),
    [sym_super] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(694),
    [sym_identifier] = ACTIONS(696),
    [sym_decimal_integer_literal] = ACTIONS(696),
    [sym_hex_integer_literal] = ACTIONS(696),
    [sym_octal_integer_literal] = ACTIONS(694),
    [sym_binary_integer_literal] = ACTIONS(694),
    [sym_decimal_floating_point_literal] = ACTIONS(694),
    [sym_hex_floating_point_literal] = ACTIONS(696),
    [sym_true] = ACTIONS(696),
    [sym_false] = ACTIONS(696),
    [sym_character_literal] = ACTIONS(694),
    [sym_string_literal] = ACTIONS(694),
    [sym_null_literal] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(696),
    [anon_sym_DASH] = ACTIONS(696),
    [anon_sym_BANG] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_class] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_assert] = ACTIONS(696),
    [anon_sym_switch] = ACTIONS(696),
    [anon_sym_case] = ACTIONS(696),
    [anon_sym_default] = ACTIONS(696),
    [anon_sym_do] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(696),
    [anon_sym_break] = ACTIONS(696),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_return] = ACTIONS(696),
    [anon_sym_synchronized] = ACTIONS(696),
    [anon_sym_throw] = ACTIONS(696),
    [anon_sym_try] = ACTIONS(696),
    [anon_sym_if] = ACTIONS(696),
    [anon_sym_else] = ACTIONS(696),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_AT] = ACTIONS(696),
    [anon_sym_open] = ACTIONS(696),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(696),
    [anon_sym_package] = ACTIONS(696),
    [anon_sym_import] = ACTIONS(696),
    [anon_sym_enum] = ACTIONS(696),
    [anon_sym_public] = ACTIONS(696),
    [anon_sym_protected] = ACTIONS(696),
    [anon_sym_private] = ACTIONS(696),
    [anon_sym_abstract] = ACTIONS(696),
    [anon_sym_final] = ACTIONS(696),
    [anon_sym_strictfp] = ACTIONS(696),
    [anon_sym_native] = ACTIONS(696),
    [anon_sym_transient] = ACTIONS(696),
    [anon_sym_volatile] = ACTIONS(696),
    [anon_sym_ATinterface] = ACTIONS(694),
    [anon_sym_interface] = ACTIONS(696),
    [anon_sym_byte] = ACTIONS(696),
    [anon_sym_short] = ACTIONS(696),
    [anon_sym_int] = ACTIONS(696),
    [anon_sym_long] = ACTIONS(696),
    [anon_sym_char] = ACTIONS(696),
    [anon_sym_float] = ACTIONS(696),
    [anon_sym_double] = ACTIONS(696),
    [sym_boolean_type] = ACTIONS(696),
    [sym_void_type] = ACTIONS(696),
    [sym_this] = ACTIONS(696),
    [sym_super] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(698),
    [sym_identifier] = ACTIONS(700),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(700),
    [sym_octal_integer_literal] = ACTIONS(698),
    [sym_binary_integer_literal] = ACTIONS(698),
    [sym_decimal_floating_point_literal] = ACTIONS(698),
    [sym_hex_floating_point_literal] = ACTIONS(700),
    [sym_true] = ACTIONS(700),
    [sym_false] = ACTIONS(700),
    [sym_character_literal] = ACTIONS(698),
    [sym_string_literal] = ACTIONS(698),
    [sym_null_literal] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(698),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(698),
    [anon_sym_TILDE] = ACTIONS(698),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_new] = ACTIONS(700),
    [anon_sym_class] = ACTIONS(700),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(698),
    [anon_sym_RBRACE] = ACTIONS(698),
    [anon_sym_assert] = ACTIONS(700),
    [anon_sym_switch] = ACTIONS(700),
    [anon_sym_case] = ACTIONS(700),
    [anon_sym_default] = ACTIONS(700),
    [anon_sym_do] = ACTIONS(700),
    [anon_sym_while] = ACTIONS(700),
    [anon_sym_break] = ACTIONS(700),
    [anon_sym_continue] = ACTIONS(700),
    [anon_sym_return] = ACTIONS(700),
    [anon_sym_synchronized] = ACTIONS(700),
    [anon_sym_throw] = ACTIONS(700),
    [anon_sym_try] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(700),
    [anon_sym_else] = ACTIONS(700),
    [anon_sym_for] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(700),
    [anon_sym_open] = ACTIONS(700),
    [anon_sym_module] = ACTIONS(700),
    [anon_sym_static] = ACTIONS(700),
    [anon_sym_package] = ACTIONS(700),
    [anon_sym_import] = ACTIONS(700),
    [anon_sym_enum] = ACTIONS(700),
    [anon_sym_public] = ACTIONS(700),
    [anon_sym_protected] = ACTIONS(700),
    [anon_sym_private] = ACTIONS(700),
    [anon_sym_abstract] = ACTIONS(700),
    [anon_sym_final] = ACTIONS(700),
    [anon_sym_strictfp] = ACTIONS(700),
    [anon_sym_native] = ACTIONS(700),
    [anon_sym_transient] = ACTIONS(700),
    [anon_sym_volatile] = ACTIONS(700),
    [anon_sym_ATinterface] = ACTIONS(698),
    [anon_sym_interface] = ACTIONS(700),
    [anon_sym_byte] = ACTIONS(700),
    [anon_sym_short] = ACTIONS(700),
    [anon_sym_int] = ACTIONS(700),
    [anon_sym_long] = ACTIONS(700),
    [anon_sym_char] = ACTIONS(700),
    [anon_sym_float] = ACTIONS(700),
    [anon_sym_double] = ACTIONS(700),
    [sym_boolean_type] = ACTIONS(700),
    [sym_void_type] = ACTIONS(700),
    [sym_this] = ACTIONS(700),
    [sym_super] = ACTIONS(700),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(702),
    [sym_identifier] = ACTIONS(704),
    [sym_decimal_integer_literal] = ACTIONS(704),
    [sym_hex_integer_literal] = ACTIONS(704),
    [sym_octal_integer_literal] = ACTIONS(702),
    [sym_binary_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(702),
    [sym_hex_floating_point_literal] = ACTIONS(704),
    [sym_true] = ACTIONS(704),
    [sym_false] = ACTIONS(704),
    [sym_character_literal] = ACTIONS(702),
    [sym_string_literal] = ACTIONS(702),
    [sym_null_literal] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(702),
    [anon_sym_new] = ACTIONS(704),
    [anon_sym_class] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_assert] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(704),
    [anon_sym_case] = ACTIONS(704),
    [anon_sym_default] = ACTIONS(704),
    [anon_sym_do] = ACTIONS(704),
    [anon_sym_while] = ACTIONS(704),
    [anon_sym_break] = ACTIONS(704),
    [anon_sym_continue] = ACTIONS(704),
    [anon_sym_return] = ACTIONS(704),
    [anon_sym_synchronized] = ACTIONS(704),
    [anon_sym_throw] = ACTIONS(704),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_else] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(704),
    [anon_sym_AT] = ACTIONS(704),
    [anon_sym_open] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_package] = ACTIONS(704),
    [anon_sym_import] = ACTIONS(704),
    [anon_sym_enum] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_abstract] = ACTIONS(704),
    [anon_sym_final] = ACTIONS(704),
    [anon_sym_strictfp] = ACTIONS(704),
    [anon_sym_native] = ACTIONS(704),
    [anon_sym_transient] = ACTIONS(704),
    [anon_sym_volatile] = ACTIONS(704),
    [anon_sym_ATinterface] = ACTIONS(702),
    [anon_sym_interface] = ACTIONS(704),
    [anon_sym_byte] = ACTIONS(704),
    [anon_sym_short] = ACTIONS(704),
    [anon_sym_int] = ACTIONS(704),
    [anon_sym_long] = ACTIONS(704),
    [anon_sym_char] = ACTIONS(704),
    [anon_sym_float] = ACTIONS(704),
    [anon_sym_double] = ACTIONS(704),
    [sym_boolean_type] = ACTIONS(704),
    [sym_void_type] = ACTIONS(704),
    [sym_this] = ACTIONS(704),
    [sym_super] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(706),
    [sym_identifier] = ACTIONS(708),
    [sym_decimal_integer_literal] = ACTIONS(708),
    [sym_hex_integer_literal] = ACTIONS(708),
    [sym_octal_integer_literal] = ACTIONS(706),
    [sym_binary_integer_literal] = ACTIONS(706),
    [sym_decimal_floating_point_literal] = ACTIONS(706),
    [sym_hex_floating_point_literal] = ACTIONS(708),
    [sym_true] = ACTIONS(708),
    [sym_false] = ACTIONS(708),
    [sym_character_literal] = ACTIONS(706),
    [sym_string_literal] = ACTIONS(706),
    [sym_null_literal] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(708),
    [anon_sym_BANG] = ACTIONS(706),
    [anon_sym_TILDE] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_class] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(706),
    [anon_sym_LBRACE] = ACTIONS(706),
    [anon_sym_RBRACE] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(708),
    [anon_sym_switch] = ACTIONS(708),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(708),
    [anon_sym_do] = ACTIONS(708),
    [anon_sym_while] = ACTIONS(708),
    [anon_sym_break] = ACTIONS(708),
    [anon_sym_continue] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(708),
    [anon_sym_synchronized] = ACTIONS(708),
    [anon_sym_throw] = ACTIONS(708),
    [anon_sym_try] = ACTIONS(708),
    [anon_sym_if] = ACTIONS(708),
    [anon_sym_else] = ACTIONS(708),
    [anon_sym_for] = ACTIONS(708),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_open] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(708),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_package] = ACTIONS(708),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_enum] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_protected] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_abstract] = ACTIONS(708),
    [anon_sym_final] = ACTIONS(708),
    [anon_sym_strictfp] = ACTIONS(708),
    [anon_sym_native] = ACTIONS(708),
    [anon_sym_transient] = ACTIONS(708),
    [anon_sym_volatile] = ACTIONS(708),
    [anon_sym_ATinterface] = ACTIONS(706),
    [anon_sym_interface] = ACTIONS(708),
    [anon_sym_byte] = ACTIONS(708),
    [anon_sym_short] = ACTIONS(708),
    [anon_sym_int] = ACTIONS(708),
    [anon_sym_long] = ACTIONS(708),
    [anon_sym_char] = ACTIONS(708),
    [anon_sym_float] = ACTIONS(708),
    [anon_sym_double] = ACTIONS(708),
    [sym_boolean_type] = ACTIONS(708),
    [sym_void_type] = ACTIONS(708),
    [sym_this] = ACTIONS(708),
    [sym_super] = ACTIONS(708),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(710),
    [sym_identifier] = ACTIONS(712),
    [sym_decimal_integer_literal] = ACTIONS(712),
    [sym_hex_integer_literal] = ACTIONS(712),
    [sym_octal_integer_literal] = ACTIONS(710),
    [sym_binary_integer_literal] = ACTIONS(710),
    [sym_decimal_floating_point_literal] = ACTIONS(710),
    [sym_hex_floating_point_literal] = ACTIONS(712),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_character_literal] = ACTIONS(710),
    [sym_string_literal] = ACTIONS(710),
    [sym_null_literal] = ACTIONS(712),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DASH] = ACTIONS(712),
    [anon_sym_BANG] = ACTIONS(710),
    [anon_sym_TILDE] = ACTIONS(710),
    [anon_sym_PLUS_PLUS] = ACTIONS(710),
    [anon_sym_DASH_DASH] = ACTIONS(710),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_class] = ACTIONS(712),
    [anon_sym_SEMI] = ACTIONS(710),
    [anon_sym_LBRACE] = ACTIONS(710),
    [anon_sym_RBRACE] = ACTIONS(710),
    [anon_sym_assert] = ACTIONS(712),
    [anon_sym_switch] = ACTIONS(712),
    [anon_sym_case] = ACTIONS(712),
    [anon_sym_default] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(712),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_break] = ACTIONS(712),
    [anon_sym_continue] = ACTIONS(712),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_synchronized] = ACTIONS(712),
    [anon_sym_throw] = ACTIONS(712),
    [anon_sym_try] = ACTIONS(712),
    [anon_sym_if] = ACTIONS(712),
    [anon_sym_else] = ACTIONS(712),
    [anon_sym_for] = ACTIONS(712),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_open] = ACTIONS(712),
    [anon_sym_module] = ACTIONS(712),
    [anon_sym_static] = ACTIONS(712),
    [anon_sym_package] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(712),
    [anon_sym_enum] = ACTIONS(712),
    [anon_sym_public] = ACTIONS(712),
    [anon_sym_protected] = ACTIONS(712),
    [anon_sym_private] = ACTIONS(712),
    [anon_sym_abstract] = ACTIONS(712),
    [anon_sym_final] = ACTIONS(712),
    [anon_sym_strictfp] = ACTIONS(712),
    [anon_sym_native] = ACTIONS(712),
    [anon_sym_transient] = ACTIONS(712),
    [anon_sym_volatile] = ACTIONS(712),
    [anon_sym_ATinterface] = ACTIONS(710),
    [anon_sym_interface] = ACTIONS(712),
    [anon_sym_byte] = ACTIONS(712),
    [anon_sym_short] = ACTIONS(712),
    [anon_sym_int] = ACTIONS(712),
    [anon_sym_long] = ACTIONS(712),
    [anon_sym_char] = ACTIONS(712),
    [anon_sym_float] = ACTIONS(712),
    [anon_sym_double] = ACTIONS(712),
    [sym_boolean_type] = ACTIONS(712),
    [sym_void_type] = ACTIONS(712),
    [sym_this] = ACTIONS(712),
    [sym_super] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(714),
    [sym_identifier] = ACTIONS(716),
    [sym_decimal_integer_literal] = ACTIONS(716),
    [sym_hex_integer_literal] = ACTIONS(716),
    [sym_octal_integer_literal] = ACTIONS(714),
    [sym_binary_integer_literal] = ACTIONS(714),
    [sym_decimal_floating_point_literal] = ACTIONS(714),
    [sym_hex_floating_point_literal] = ACTIONS(716),
    [sym_true] = ACTIONS(716),
    [sym_false] = ACTIONS(716),
    [sym_character_literal] = ACTIONS(714),
    [sym_string_literal] = ACTIONS(714),
    [sym_null_literal] = ACTIONS(716),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_PLUS] = ACTIONS(716),
    [anon_sym_DASH] = ACTIONS(716),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_PLUS_PLUS] = ACTIONS(714),
    [anon_sym_DASH_DASH] = ACTIONS(714),
    [anon_sym_new] = ACTIONS(716),
    [anon_sym_class] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_assert] = ACTIONS(716),
    [anon_sym_switch] = ACTIONS(716),
    [anon_sym_case] = ACTIONS(716),
    [anon_sym_default] = ACTIONS(716),
    [anon_sym_do] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_break] = ACTIONS(716),
    [anon_sym_continue] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(716),
    [anon_sym_synchronized] = ACTIONS(716),
    [anon_sym_throw] = ACTIONS(716),
    [anon_sym_try] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_else] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_AT] = ACTIONS(716),
    [anon_sym_open] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(716),
    [anon_sym_static] = ACTIONS(716),
    [anon_sym_package] = ACTIONS(716),
    [anon_sym_import] = ACTIONS(716),
    [anon_sym_enum] = ACTIONS(716),
    [anon_sym_public] = ACTIONS(716),
    [anon_sym_protected] = ACTIONS(716),
    [anon_sym_private] = ACTIONS(716),
    [anon_sym_abstract] = ACTIONS(716),
    [anon_sym_final] = ACTIONS(716),
    [anon_sym_strictfp] = ACTIONS(716),
    [anon_sym_native] = ACTIONS(716),
    [anon_sym_transient] = ACTIONS(716),
    [anon_sym_volatile] = ACTIONS(716),
    [anon_sym_ATinterface] = ACTIONS(714),
    [anon_sym_interface] = ACTIONS(716),
    [anon_sym_byte] = ACTIONS(716),
    [anon_sym_short] = ACTIONS(716),
    [anon_sym_int] = ACTIONS(716),
    [anon_sym_long] = ACTIONS(716),
    [anon_sym_char] = ACTIONS(716),
    [anon_sym_float] = ACTIONS(716),
    [anon_sym_double] = ACTIONS(716),
    [sym_boolean_type] = ACTIONS(716),
    [sym_void_type] = ACTIONS(716),
    [sym_this] = ACTIONS(716),
    [sym_super] = ACTIONS(716),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(718),
    [sym_identifier] = ACTIONS(720),
    [sym_decimal_integer_literal] = ACTIONS(720),
    [sym_hex_integer_literal] = ACTIONS(720),
    [sym_octal_integer_literal] = ACTIONS(718),
    [sym_binary_integer_literal] = ACTIONS(718),
    [sym_decimal_floating_point_literal] = ACTIONS(718),
    [sym_hex_floating_point_literal] = ACTIONS(720),
    [sym_true] = ACTIONS(720),
    [sym_false] = ACTIONS(720),
    [sym_character_literal] = ACTIONS(718),
    [sym_string_literal] = ACTIONS(718),
    [sym_null_literal] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_PLUS_PLUS] = ACTIONS(718),
    [anon_sym_DASH_DASH] = ACTIONS(718),
    [anon_sym_new] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(718),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_assert] = ACTIONS(720),
    [anon_sym_switch] = ACTIONS(720),
    [anon_sym_case] = ACTIONS(720),
    [anon_sym_default] = ACTIONS(720),
    [anon_sym_do] = ACTIONS(720),
    [anon_sym_while] = ACTIONS(720),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(720),
    [anon_sym_return] = ACTIONS(720),
    [anon_sym_synchronized] = ACTIONS(720),
    [anon_sym_throw] = ACTIONS(720),
    [anon_sym_try] = ACTIONS(720),
    [anon_sym_if] = ACTIONS(720),
    [anon_sym_else] = ACTIONS(720),
    [anon_sym_for] = ACTIONS(720),
    [anon_sym_AT] = ACTIONS(720),
    [anon_sym_open] = ACTIONS(720),
    [anon_sym_module] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(720),
    [anon_sym_package] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_enum] = ACTIONS(720),
    [anon_sym_public] = ACTIONS(720),
    [anon_sym_protected] = ACTIONS(720),
    [anon_sym_private] = ACTIONS(720),
    [anon_sym_abstract] = ACTIONS(720),
    [anon_sym_final] = ACTIONS(720),
    [anon_sym_strictfp] = ACTIONS(720),
    [anon_sym_native] = ACTIONS(720),
    [anon_sym_transient] = ACTIONS(720),
    [anon_sym_volatile] = ACTIONS(720),
    [anon_sym_ATinterface] = ACTIONS(718),
    [anon_sym_interface] = ACTIONS(720),
    [anon_sym_byte] = ACTIONS(720),
    [anon_sym_short] = ACTIONS(720),
    [anon_sym_int] = ACTIONS(720),
    [anon_sym_long] = ACTIONS(720),
    [anon_sym_char] = ACTIONS(720),
    [anon_sym_float] = ACTIONS(720),
    [anon_sym_double] = ACTIONS(720),
    [sym_boolean_type] = ACTIONS(720),
    [sym_void_type] = ACTIONS(720),
    [sym_this] = ACTIONS(720),
    [sym_super] = ACTIONS(720),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(722),
    [sym_identifier] = ACTIONS(724),
    [sym_decimal_integer_literal] = ACTIONS(724),
    [sym_hex_integer_literal] = ACTIONS(724),
    [sym_octal_integer_literal] = ACTIONS(722),
    [sym_binary_integer_literal] = ACTIONS(722),
    [sym_decimal_floating_point_literal] = ACTIONS(722),
    [sym_hex_floating_point_literal] = ACTIONS(724),
    [sym_true] = ACTIONS(724),
    [sym_false] = ACTIONS(724),
    [sym_character_literal] = ACTIONS(722),
    [sym_string_literal] = ACTIONS(722),
    [sym_null_literal] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(722),
    [anon_sym_DASH_DASH] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_assert] = ACTIONS(724),
    [anon_sym_switch] = ACTIONS(724),
    [anon_sym_case] = ACTIONS(724),
    [anon_sym_default] = ACTIONS(724),
    [anon_sym_do] = ACTIONS(724),
    [anon_sym_while] = ACTIONS(724),
    [anon_sym_break] = ACTIONS(724),
    [anon_sym_continue] = ACTIONS(724),
    [anon_sym_return] = ACTIONS(724),
    [anon_sym_synchronized] = ACTIONS(724),
    [anon_sym_throw] = ACTIONS(724),
    [anon_sym_try] = ACTIONS(724),
    [anon_sym_if] = ACTIONS(724),
    [anon_sym_else] = ACTIONS(724),
    [anon_sym_for] = ACTIONS(724),
    [anon_sym_AT] = ACTIONS(724),
    [anon_sym_open] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_package] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(724),
    [anon_sym_enum] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_abstract] = ACTIONS(724),
    [anon_sym_final] = ACTIONS(724),
    [anon_sym_strictfp] = ACTIONS(724),
    [anon_sym_native] = ACTIONS(724),
    [anon_sym_transient] = ACTIONS(724),
    [anon_sym_volatile] = ACTIONS(724),
    [anon_sym_ATinterface] = ACTIONS(722),
    [anon_sym_interface] = ACTIONS(724),
    [anon_sym_byte] = ACTIONS(724),
    [anon_sym_short] = ACTIONS(724),
    [anon_sym_int] = ACTIONS(724),
    [anon_sym_long] = ACTIONS(724),
    [anon_sym_char] = ACTIONS(724),
    [anon_sym_float] = ACTIONS(724),
    [anon_sym_double] = ACTIONS(724),
    [sym_boolean_type] = ACTIONS(724),
    [sym_void_type] = ACTIONS(724),
    [sym_this] = ACTIONS(724),
    [sym_super] = ACTIONS(724),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(726),
    [sym_identifier] = ACTIONS(728),
    [sym_decimal_integer_literal] = ACTIONS(728),
    [sym_hex_integer_literal] = ACTIONS(728),
    [sym_octal_integer_literal] = ACTIONS(726),
    [sym_binary_integer_literal] = ACTIONS(726),
    [sym_decimal_floating_point_literal] = ACTIONS(726),
    [sym_hex_floating_point_literal] = ACTIONS(728),
    [sym_true] = ACTIONS(728),
    [sym_false] = ACTIONS(728),
    [sym_character_literal] = ACTIONS(726),
    [sym_string_literal] = ACTIONS(726),
    [sym_null_literal] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_PLUS] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_TILDE] = ACTIONS(726),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_class] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_LBRACE] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_assert] = ACTIONS(728),
    [anon_sym_switch] = ACTIONS(728),
    [anon_sym_case] = ACTIONS(728),
    [anon_sym_default] = ACTIONS(728),
    [anon_sym_do] = ACTIONS(728),
    [anon_sym_while] = ACTIONS(728),
    [anon_sym_break] = ACTIONS(728),
    [anon_sym_continue] = ACTIONS(728),
    [anon_sym_return] = ACTIONS(728),
    [anon_sym_synchronized] = ACTIONS(728),
    [anon_sym_throw] = ACTIONS(728),
    [anon_sym_try] = ACTIONS(728),
    [anon_sym_if] = ACTIONS(728),
    [anon_sym_else] = ACTIONS(728),
    [anon_sym_for] = ACTIONS(728),
    [anon_sym_AT] = ACTIONS(728),
    [anon_sym_open] = ACTIONS(728),
    [anon_sym_module] = ACTIONS(728),
    [anon_sym_static] = ACTIONS(728),
    [anon_sym_package] = ACTIONS(728),
    [anon_sym_import] = ACTIONS(728),
    [anon_sym_enum] = ACTIONS(728),
    [anon_sym_public] = ACTIONS(728),
    [anon_sym_protected] = ACTIONS(728),
    [anon_sym_private] = ACTIONS(728),
    [anon_sym_abstract] = ACTIONS(728),
    [anon_sym_final] = ACTIONS(728),
    [anon_sym_strictfp] = ACTIONS(728),
    [anon_sym_native] = ACTIONS(728),
    [anon_sym_transient] = ACTIONS(728),
    [anon_sym_volatile] = ACTIONS(728),
    [anon_sym_ATinterface] = ACTIONS(726),
    [anon_sym_interface] = ACTIONS(728),
    [anon_sym_byte] = ACTIONS(728),
    [anon_sym_short] = ACTIONS(728),
    [anon_sym_int] = ACTIONS(728),
    [anon_sym_long] = ACTIONS(728),
    [anon_sym_char] = ACTIONS(728),
    [anon_sym_float] = ACTIONS(728),
    [anon_sym_double] = ACTIONS(728),
    [sym_boolean_type] = ACTIONS(728),
    [sym_void_type] = ACTIONS(728),
    [sym_this] = ACTIONS(728),
    [sym_super] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(730),
    [sym_identifier] = ACTIONS(732),
    [sym_decimal_integer_literal] = ACTIONS(732),
    [sym_hex_integer_literal] = ACTIONS(732),
    [sym_octal_integer_literal] = ACTIONS(730),
    [sym_binary_integer_literal] = ACTIONS(730),
    [sym_decimal_floating_point_literal] = ACTIONS(730),
    [sym_hex_floating_point_literal] = ACTIONS(732),
    [sym_true] = ACTIONS(732),
    [sym_false] = ACTIONS(732),
    [sym_character_literal] = ACTIONS(730),
    [sym_string_literal] = ACTIONS(730),
    [sym_null_literal] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_TILDE] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(730),
    [anon_sym_DASH_DASH] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_class] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(730),
    [anon_sym_LBRACE] = ACTIONS(730),
    [anon_sym_RBRACE] = ACTIONS(730),
    [anon_sym_assert] = ACTIONS(732),
    [anon_sym_switch] = ACTIONS(732),
    [anon_sym_case] = ACTIONS(732),
    [anon_sym_default] = ACTIONS(732),
    [anon_sym_do] = ACTIONS(732),
    [anon_sym_while] = ACTIONS(732),
    [anon_sym_break] = ACTIONS(732),
    [anon_sym_continue] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(732),
    [anon_sym_synchronized] = ACTIONS(732),
    [anon_sym_throw] = ACTIONS(732),
    [anon_sym_try] = ACTIONS(732),
    [anon_sym_if] = ACTIONS(732),
    [anon_sym_else] = ACTIONS(732),
    [anon_sym_for] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(732),
    [anon_sym_open] = ACTIONS(732),
    [anon_sym_module] = ACTIONS(732),
    [anon_sym_static] = ACTIONS(732),
    [anon_sym_package] = ACTIONS(732),
    [anon_sym_import] = ACTIONS(732),
    [anon_sym_enum] = ACTIONS(732),
    [anon_sym_public] = ACTIONS(732),
    [anon_sym_protected] = ACTIONS(732),
    [anon_sym_private] = ACTIONS(732),
    [anon_sym_abstract] = ACTIONS(732),
    [anon_sym_final] = ACTIONS(732),
    [anon_sym_strictfp] = ACTIONS(732),
    [anon_sym_native] = ACTIONS(732),
    [anon_sym_transient] = ACTIONS(732),
    [anon_sym_volatile] = ACTIONS(732),
    [anon_sym_ATinterface] = ACTIONS(730),
    [anon_sym_interface] = ACTIONS(732),
    [anon_sym_byte] = ACTIONS(732),
    [anon_sym_short] = ACTIONS(732),
    [anon_sym_int] = ACTIONS(732),
    [anon_sym_long] = ACTIONS(732),
    [anon_sym_char] = ACTIONS(732),
    [anon_sym_float] = ACTIONS(732),
    [anon_sym_double] = ACTIONS(732),
    [sym_boolean_type] = ACTIONS(732),
    [sym_void_type] = ACTIONS(732),
    [sym_this] = ACTIONS(732),
    [sym_super] = ACTIONS(732),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(734),
    [sym_identifier] = ACTIONS(736),
    [sym_decimal_integer_literal] = ACTIONS(736),
    [sym_hex_integer_literal] = ACTIONS(736),
    [sym_octal_integer_literal] = ACTIONS(734),
    [sym_binary_integer_literal] = ACTIONS(734),
    [sym_decimal_floating_point_literal] = ACTIONS(734),
    [sym_hex_floating_point_literal] = ACTIONS(736),
    [sym_true] = ACTIONS(736),
    [sym_false] = ACTIONS(736),
    [sym_character_literal] = ACTIONS(734),
    [sym_string_literal] = ACTIONS(734),
    [sym_null_literal] = ACTIONS(736),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(734),
    [anon_sym_PLUS_PLUS] = ACTIONS(734),
    [anon_sym_DASH_DASH] = ACTIONS(734),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(734),
    [anon_sym_RBRACE] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(736),
    [anon_sym_switch] = ACTIONS(736),
    [anon_sym_case] = ACTIONS(736),
    [anon_sym_default] = ACTIONS(736),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_break] = ACTIONS(736),
    [anon_sym_continue] = ACTIONS(736),
    [anon_sym_return] = ACTIONS(736),
    [anon_sym_synchronized] = ACTIONS(736),
    [anon_sym_throw] = ACTIONS(736),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(736),
    [anon_sym_else] = ACTIONS(736),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_open] = ACTIONS(736),
    [anon_sym_module] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(736),
    [anon_sym_package] = ACTIONS(736),
    [anon_sym_import] = ACTIONS(736),
    [anon_sym_enum] = ACTIONS(736),
    [anon_sym_public] = ACTIONS(736),
    [anon_sym_protected] = ACTIONS(736),
    [anon_sym_private] = ACTIONS(736),
    [anon_sym_abstract] = ACTIONS(736),
    [anon_sym_final] = ACTIONS(736),
    [anon_sym_strictfp] = ACTIONS(736),
    [anon_sym_native] = ACTIONS(736),
    [anon_sym_transient] = ACTIONS(736),
    [anon_sym_volatile] = ACTIONS(736),
    [anon_sym_ATinterface] = ACTIONS(734),
    [anon_sym_interface] = ACTIONS(736),
    [anon_sym_byte] = ACTIONS(736),
    [anon_sym_short] = ACTIONS(736),
    [anon_sym_int] = ACTIONS(736),
    [anon_sym_long] = ACTIONS(736),
    [anon_sym_char] = ACTIONS(736),
    [anon_sym_float] = ACTIONS(736),
    [anon_sym_double] = ACTIONS(736),
    [sym_boolean_type] = ACTIONS(736),
    [sym_void_type] = ACTIONS(736),
    [sym_this] = ACTIONS(736),
    [sym_super] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(738),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(740),
    [sym_hex_integer_literal] = ACTIONS(740),
    [sym_octal_integer_literal] = ACTIONS(738),
    [sym_binary_integer_literal] = ACTIONS(738),
    [sym_decimal_floating_point_literal] = ACTIONS(738),
    [sym_hex_floating_point_literal] = ACTIONS(740),
    [sym_true] = ACTIONS(740),
    [sym_false] = ACTIONS(740),
    [sym_character_literal] = ACTIONS(738),
    [sym_string_literal] = ACTIONS(738),
    [sym_null_literal] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_PLUS_PLUS] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(738),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_class] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_assert] = ACTIONS(740),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_case] = ACTIONS(740),
    [anon_sym_default] = ACTIONS(740),
    [anon_sym_do] = ACTIONS(740),
    [anon_sym_while] = ACTIONS(740),
    [anon_sym_break] = ACTIONS(740),
    [anon_sym_continue] = ACTIONS(740),
    [anon_sym_return] = ACTIONS(740),
    [anon_sym_synchronized] = ACTIONS(740),
    [anon_sym_throw] = ACTIONS(740),
    [anon_sym_try] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(740),
    [anon_sym_else] = ACTIONS(740),
    [anon_sym_for] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(740),
    [anon_sym_open] = ACTIONS(740),
    [anon_sym_module] = ACTIONS(740),
    [anon_sym_static] = ACTIONS(740),
    [anon_sym_package] = ACTIONS(740),
    [anon_sym_import] = ACTIONS(740),
    [anon_sym_enum] = ACTIONS(740),
    [anon_sym_public] = ACTIONS(740),
    [anon_sym_protected] = ACTIONS(740),
    [anon_sym_private] = ACTIONS(740),
    [anon_sym_abstract] = ACTIONS(740),
    [anon_sym_final] = ACTIONS(740),
    [anon_sym_strictfp] = ACTIONS(740),
    [anon_sym_native] = ACTIONS(740),
    [anon_sym_transient] = ACTIONS(740),
    [anon_sym_volatile] = ACTIONS(740),
    [anon_sym_ATinterface] = ACTIONS(738),
    [anon_sym_interface] = ACTIONS(740),
    [anon_sym_byte] = ACTIONS(740),
    [anon_sym_short] = ACTIONS(740),
    [anon_sym_int] = ACTIONS(740),
    [anon_sym_long] = ACTIONS(740),
    [anon_sym_char] = ACTIONS(740),
    [anon_sym_float] = ACTIONS(740),
    [anon_sym_double] = ACTIONS(740),
    [sym_boolean_type] = ACTIONS(740),
    [sym_void_type] = ACTIONS(740),
    [sym_this] = ACTIONS(740),
    [sym_super] = ACTIONS(740),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(742),
    [sym_identifier] = ACTIONS(744),
    [sym_decimal_integer_literal] = ACTIONS(744),
    [sym_hex_integer_literal] = ACTIONS(744),
    [sym_octal_integer_literal] = ACTIONS(742),
    [sym_binary_integer_literal] = ACTIONS(742),
    [sym_decimal_floating_point_literal] = ACTIONS(742),
    [sym_hex_floating_point_literal] = ACTIONS(744),
    [sym_true] = ACTIONS(744),
    [sym_false] = ACTIONS(744),
    [sym_character_literal] = ACTIONS(742),
    [sym_string_literal] = ACTIONS(742),
    [sym_null_literal] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_TILDE] = ACTIONS(742),
    [anon_sym_PLUS_PLUS] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(744),
    [anon_sym_class] = ACTIONS(744),
    [anon_sym_SEMI] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(742),
    [anon_sym_assert] = ACTIONS(744),
    [anon_sym_switch] = ACTIONS(744),
    [anon_sym_case] = ACTIONS(744),
    [anon_sym_default] = ACTIONS(744),
    [anon_sym_do] = ACTIONS(744),
    [anon_sym_while] = ACTIONS(744),
    [anon_sym_break] = ACTIONS(744),
    [anon_sym_continue] = ACTIONS(744),
    [anon_sym_return] = ACTIONS(744),
    [anon_sym_synchronized] = ACTIONS(744),
    [anon_sym_throw] = ACTIONS(744),
    [anon_sym_try] = ACTIONS(744),
    [anon_sym_if] = ACTIONS(744),
    [anon_sym_else] = ACTIONS(744),
    [anon_sym_for] = ACTIONS(744),
    [anon_sym_AT] = ACTIONS(744),
    [anon_sym_open] = ACTIONS(744),
    [anon_sym_module] = ACTIONS(744),
    [anon_sym_static] = ACTIONS(744),
    [anon_sym_package] = ACTIONS(744),
    [anon_sym_import] = ACTIONS(744),
    [anon_sym_enum] = ACTIONS(744),
    [anon_sym_public] = ACTIONS(744),
    [anon_sym_protected] = ACTIONS(744),
    [anon_sym_private] = ACTIONS(744),
    [anon_sym_abstract] = ACTIONS(744),
    [anon_sym_final] = ACTIONS(744),
    [anon_sym_strictfp] = ACTIONS(744),
    [anon_sym_native] = ACTIONS(744),
    [anon_sym_transient] = ACTIONS(744),
    [anon_sym_volatile] = ACTIONS(744),
    [anon_sym_ATinterface] = ACTIONS(742),
    [anon_sym_interface] = ACTIONS(744),
    [anon_sym_byte] = ACTIONS(744),
    [anon_sym_short] = ACTIONS(744),
    [anon_sym_int] = ACTIONS(744),
    [anon_sym_long] = ACTIONS(744),
    [anon_sym_char] = ACTIONS(744),
    [anon_sym_float] = ACTIONS(744),
    [anon_sym_double] = ACTIONS(744),
    [sym_boolean_type] = ACTIONS(744),
    [sym_void_type] = ACTIONS(744),
    [sym_this] = ACTIONS(744),
    [sym_super] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(746),
    [sym_identifier] = ACTIONS(748),
    [sym_decimal_integer_literal] = ACTIONS(748),
    [sym_hex_integer_literal] = ACTIONS(748),
    [sym_octal_integer_literal] = ACTIONS(746),
    [sym_binary_integer_literal] = ACTIONS(746),
    [sym_decimal_floating_point_literal] = ACTIONS(746),
    [sym_hex_floating_point_literal] = ACTIONS(748),
    [sym_true] = ACTIONS(748),
    [sym_false] = ACTIONS(748),
    [sym_character_literal] = ACTIONS(746),
    [sym_string_literal] = ACTIONS(746),
    [sym_null_literal] = ACTIONS(748),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(746),
    [anon_sym_DASH_DASH] = ACTIONS(746),
    [anon_sym_new] = ACTIONS(748),
    [anon_sym_class] = ACTIONS(748),
    [anon_sym_SEMI] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(746),
    [anon_sym_RBRACE] = ACTIONS(746),
    [anon_sym_assert] = ACTIONS(748),
    [anon_sym_switch] = ACTIONS(748),
    [anon_sym_case] = ACTIONS(748),
    [anon_sym_default] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_break] = ACTIONS(748),
    [anon_sym_continue] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_synchronized] = ACTIONS(748),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_try] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_open] = ACTIONS(748),
    [anon_sym_module] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(748),
    [anon_sym_package] = ACTIONS(748),
    [anon_sym_import] = ACTIONS(748),
    [anon_sym_enum] = ACTIONS(748),
    [anon_sym_public] = ACTIONS(748),
    [anon_sym_protected] = ACTIONS(748),
    [anon_sym_private] = ACTIONS(748),
    [anon_sym_abstract] = ACTIONS(748),
    [anon_sym_final] = ACTIONS(748),
    [anon_sym_strictfp] = ACTIONS(748),
    [anon_sym_native] = ACTIONS(748),
    [anon_sym_transient] = ACTIONS(748),
    [anon_sym_volatile] = ACTIONS(748),
    [anon_sym_ATinterface] = ACTIONS(746),
    [anon_sym_interface] = ACTIONS(748),
    [anon_sym_byte] = ACTIONS(748),
    [anon_sym_short] = ACTIONS(748),
    [anon_sym_int] = ACTIONS(748),
    [anon_sym_long] = ACTIONS(748),
    [anon_sym_char] = ACTIONS(748),
    [anon_sym_float] = ACTIONS(748),
    [anon_sym_double] = ACTIONS(748),
    [sym_boolean_type] = ACTIONS(748),
    [sym_void_type] = ACTIONS(748),
    [sym_this] = ACTIONS(748),
    [sym_super] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(750),
    [sym_identifier] = ACTIONS(752),
    [sym_decimal_integer_literal] = ACTIONS(752),
    [sym_hex_integer_literal] = ACTIONS(752),
    [sym_octal_integer_literal] = ACTIONS(750),
    [sym_binary_integer_literal] = ACTIONS(750),
    [sym_decimal_floating_point_literal] = ACTIONS(750),
    [sym_hex_floating_point_literal] = ACTIONS(752),
    [sym_true] = ACTIONS(752),
    [sym_false] = ACTIONS(752),
    [sym_character_literal] = ACTIONS(750),
    [sym_string_literal] = ACTIONS(750),
    [sym_null_literal] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(750),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_TILDE] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(750),
    [anon_sym_DASH_DASH] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(752),
    [anon_sym_class] = ACTIONS(752),
    [anon_sym_SEMI] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_RBRACE] = ACTIONS(750),
    [anon_sym_assert] = ACTIONS(752),
    [anon_sym_switch] = ACTIONS(752),
    [anon_sym_case] = ACTIONS(752),
    [anon_sym_default] = ACTIONS(752),
    [anon_sym_do] = ACTIONS(752),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_break] = ACTIONS(752),
    [anon_sym_continue] = ACTIONS(752),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_synchronized] = ACTIONS(752),
    [anon_sym_throw] = ACTIONS(752),
    [anon_sym_try] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(752),
    [anon_sym_else] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(752),
    [anon_sym_open] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(752),
    [anon_sym_static] = ACTIONS(752),
    [anon_sym_package] = ACTIONS(752),
    [anon_sym_import] = ACTIONS(752),
    [anon_sym_enum] = ACTIONS(752),
    [anon_sym_public] = ACTIONS(752),
    [anon_sym_protected] = ACTIONS(752),
    [anon_sym_private] = ACTIONS(752),
    [anon_sym_abstract] = ACTIONS(752),
    [anon_sym_final] = ACTIONS(752),
    [anon_sym_strictfp] = ACTIONS(752),
    [anon_sym_native] = ACTIONS(752),
    [anon_sym_transient] = ACTIONS(752),
    [anon_sym_volatile] = ACTIONS(752),
    [anon_sym_ATinterface] = ACTIONS(750),
    [anon_sym_interface] = ACTIONS(752),
    [anon_sym_byte] = ACTIONS(752),
    [anon_sym_short] = ACTIONS(752),
    [anon_sym_int] = ACTIONS(752),
    [anon_sym_long] = ACTIONS(752),
    [anon_sym_char] = ACTIONS(752),
    [anon_sym_float] = ACTIONS(752),
    [anon_sym_double] = ACTIONS(752),
    [sym_boolean_type] = ACTIONS(752),
    [sym_void_type] = ACTIONS(752),
    [sym_this] = ACTIONS(752),
    [sym_super] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(754),
    [sym_identifier] = ACTIONS(756),
    [sym_decimal_integer_literal] = ACTIONS(756),
    [sym_hex_integer_literal] = ACTIONS(756),
    [sym_octal_integer_literal] = ACTIONS(754),
    [sym_binary_integer_literal] = ACTIONS(754),
    [sym_decimal_floating_point_literal] = ACTIONS(754),
    [sym_hex_floating_point_literal] = ACTIONS(756),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_character_literal] = ACTIONS(754),
    [sym_string_literal] = ACTIONS(754),
    [sym_null_literal] = ACTIONS(756),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_PLUS] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_TILDE] = ACTIONS(754),
    [anon_sym_PLUS_PLUS] = ACTIONS(754),
    [anon_sym_DASH_DASH] = ACTIONS(754),
    [anon_sym_new] = ACTIONS(756),
    [anon_sym_class] = ACTIONS(756),
    [anon_sym_SEMI] = ACTIONS(754),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_assert] = ACTIONS(756),
    [anon_sym_switch] = ACTIONS(756),
    [anon_sym_case] = ACTIONS(756),
    [anon_sym_default] = ACTIONS(756),
    [anon_sym_do] = ACTIONS(756),
    [anon_sym_while] = ACTIONS(756),
    [anon_sym_break] = ACTIONS(756),
    [anon_sym_continue] = ACTIONS(756),
    [anon_sym_return] = ACTIONS(756),
    [anon_sym_synchronized] = ACTIONS(756),
    [anon_sym_throw] = ACTIONS(756),
    [anon_sym_try] = ACTIONS(756),
    [anon_sym_if] = ACTIONS(756),
    [anon_sym_else] = ACTIONS(756),
    [anon_sym_for] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(756),
    [anon_sym_open] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_package] = ACTIONS(756),
    [anon_sym_import] = ACTIONS(756),
    [anon_sym_enum] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_final] = ACTIONS(756),
    [anon_sym_strictfp] = ACTIONS(756),
    [anon_sym_native] = ACTIONS(756),
    [anon_sym_transient] = ACTIONS(756),
    [anon_sym_volatile] = ACTIONS(756),
    [anon_sym_ATinterface] = ACTIONS(754),
    [anon_sym_interface] = ACTIONS(756),
    [anon_sym_byte] = ACTIONS(756),
    [anon_sym_short] = ACTIONS(756),
    [anon_sym_int] = ACTIONS(756),
    [anon_sym_long] = ACTIONS(756),
    [anon_sym_char] = ACTIONS(756),
    [anon_sym_float] = ACTIONS(756),
    [anon_sym_double] = ACTIONS(756),
    [sym_boolean_type] = ACTIONS(756),
    [sym_void_type] = ACTIONS(756),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(758),
    [sym_identifier] = ACTIONS(760),
    [sym_decimal_integer_literal] = ACTIONS(760),
    [sym_hex_integer_literal] = ACTIONS(760),
    [sym_octal_integer_literal] = ACTIONS(758),
    [sym_binary_integer_literal] = ACTIONS(758),
    [sym_decimal_floating_point_literal] = ACTIONS(758),
    [sym_hex_floating_point_literal] = ACTIONS(760),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [sym_character_literal] = ACTIONS(758),
    [sym_string_literal] = ACTIONS(758),
    [sym_null_literal] = ACTIONS(760),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_TILDE] = ACTIONS(758),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_new] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(758),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_RBRACE] = ACTIONS(758),
    [anon_sym_assert] = ACTIONS(760),
    [anon_sym_switch] = ACTIONS(760),
    [anon_sym_case] = ACTIONS(760),
    [anon_sym_default] = ACTIONS(760),
    [anon_sym_do] = ACTIONS(760),
    [anon_sym_while] = ACTIONS(760),
    [anon_sym_break] = ACTIONS(760),
    [anon_sym_continue] = ACTIONS(760),
    [anon_sym_return] = ACTIONS(760),
    [anon_sym_synchronized] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(760),
    [anon_sym_try] = ACTIONS(760),
    [anon_sym_if] = ACTIONS(760),
    [anon_sym_else] = ACTIONS(760),
    [anon_sym_for] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_open] = ACTIONS(760),
    [anon_sym_module] = ACTIONS(760),
    [anon_sym_static] = ACTIONS(760),
    [anon_sym_package] = ACTIONS(760),
    [anon_sym_import] = ACTIONS(760),
    [anon_sym_enum] = ACTIONS(760),
    [anon_sym_public] = ACTIONS(760),
    [anon_sym_protected] = ACTIONS(760),
    [anon_sym_private] = ACTIONS(760),
    [anon_sym_abstract] = ACTIONS(760),
    [anon_sym_final] = ACTIONS(760),
    [anon_sym_strictfp] = ACTIONS(760),
    [anon_sym_native] = ACTIONS(760),
    [anon_sym_transient] = ACTIONS(760),
    [anon_sym_volatile] = ACTIONS(760),
    [anon_sym_ATinterface] = ACTIONS(758),
    [anon_sym_interface] = ACTIONS(760),
    [anon_sym_byte] = ACTIONS(760),
    [anon_sym_short] = ACTIONS(760),
    [anon_sym_int] = ACTIONS(760),
    [anon_sym_long] = ACTIONS(760),
    [anon_sym_char] = ACTIONS(760),
    [anon_sym_float] = ACTIONS(760),
    [anon_sym_double] = ACTIONS(760),
    [sym_boolean_type] = ACTIONS(760),
    [sym_void_type] = ACTIONS(760),
    [sym_this] = ACTIONS(760),
    [sym_super] = ACTIONS(760),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(762),
    [sym_identifier] = ACTIONS(764),
    [sym_decimal_integer_literal] = ACTIONS(764),
    [sym_hex_integer_literal] = ACTIONS(764),
    [sym_octal_integer_literal] = ACTIONS(762),
    [sym_binary_integer_literal] = ACTIONS(762),
    [sym_decimal_floating_point_literal] = ACTIONS(762),
    [sym_hex_floating_point_literal] = ACTIONS(764),
    [sym_true] = ACTIONS(764),
    [sym_false] = ACTIONS(764),
    [sym_character_literal] = ACTIONS(762),
    [sym_string_literal] = ACTIONS(762),
    [sym_null_literal] = ACTIONS(764),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(762),
    [anon_sym_DASH_DASH] = ACTIONS(762),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_class] = ACTIONS(764),
    [anon_sym_SEMI] = ACTIONS(762),
    [anon_sym_LBRACE] = ACTIONS(762),
    [anon_sym_RBRACE] = ACTIONS(762),
    [anon_sym_assert] = ACTIONS(764),
    [anon_sym_switch] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(764),
    [anon_sym_default] = ACTIONS(764),
    [anon_sym_do] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(764),
    [anon_sym_break] = ACTIONS(764),
    [anon_sym_continue] = ACTIONS(764),
    [anon_sym_return] = ACTIONS(764),
    [anon_sym_synchronized] = ACTIONS(764),
    [anon_sym_throw] = ACTIONS(764),
    [anon_sym_try] = ACTIONS(764),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_else] = ACTIONS(764),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(764),
    [anon_sym_open] = ACTIONS(764),
    [anon_sym_module] = ACTIONS(764),
    [anon_sym_static] = ACTIONS(764),
    [anon_sym_package] = ACTIONS(764),
    [anon_sym_import] = ACTIONS(764),
    [anon_sym_enum] = ACTIONS(764),
    [anon_sym_public] = ACTIONS(764),
    [anon_sym_protected] = ACTIONS(764),
    [anon_sym_private] = ACTIONS(764),
    [anon_sym_abstract] = ACTIONS(764),
    [anon_sym_final] = ACTIONS(764),
    [anon_sym_strictfp] = ACTIONS(764),
    [anon_sym_native] = ACTIONS(764),
    [anon_sym_transient] = ACTIONS(764),
    [anon_sym_volatile] = ACTIONS(764),
    [anon_sym_ATinterface] = ACTIONS(762),
    [anon_sym_interface] = ACTIONS(764),
    [anon_sym_byte] = ACTIONS(764),
    [anon_sym_short] = ACTIONS(764),
    [anon_sym_int] = ACTIONS(764),
    [anon_sym_long] = ACTIONS(764),
    [anon_sym_char] = ACTIONS(764),
    [anon_sym_float] = ACTIONS(764),
    [anon_sym_double] = ACTIONS(764),
    [sym_boolean_type] = ACTIONS(764),
    [sym_void_type] = ACTIONS(764),
    [sym_this] = ACTIONS(764),
    [sym_super] = ACTIONS(764),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(766),
    [sym_identifier] = ACTIONS(768),
    [sym_decimal_integer_literal] = ACTIONS(768),
    [sym_hex_integer_literal] = ACTIONS(768),
    [sym_octal_integer_literal] = ACTIONS(766),
    [sym_binary_integer_literal] = ACTIONS(766),
    [sym_decimal_floating_point_literal] = ACTIONS(766),
    [sym_hex_floating_point_literal] = ACTIONS(768),
    [sym_true] = ACTIONS(768),
    [sym_false] = ACTIONS(768),
    [sym_character_literal] = ACTIONS(766),
    [sym_string_literal] = ACTIONS(766),
    [sym_null_literal] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(766),
    [anon_sym_DASH_DASH] = ACTIONS(766),
    [anon_sym_new] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(768),
    [anon_sym_SEMI] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_RBRACE] = ACTIONS(766),
    [anon_sym_assert] = ACTIONS(768),
    [anon_sym_switch] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(768),
    [anon_sym_default] = ACTIONS(768),
    [anon_sym_do] = ACTIONS(768),
    [anon_sym_while] = ACTIONS(768),
    [anon_sym_break] = ACTIONS(768),
    [anon_sym_continue] = ACTIONS(768),
    [anon_sym_return] = ACTIONS(768),
    [anon_sym_synchronized] = ACTIONS(768),
    [anon_sym_throw] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(768),
    [anon_sym_if] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(768),
    [anon_sym_for] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_open] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_package] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_enum] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_abstract] = ACTIONS(768),
    [anon_sym_final] = ACTIONS(768),
    [anon_sym_strictfp] = ACTIONS(768),
    [anon_sym_native] = ACTIONS(768),
    [anon_sym_transient] = ACTIONS(768),
    [anon_sym_volatile] = ACTIONS(768),
    [anon_sym_ATinterface] = ACTIONS(766),
    [anon_sym_interface] = ACTIONS(768),
    [anon_sym_byte] = ACTIONS(768),
    [anon_sym_short] = ACTIONS(768),
    [anon_sym_int] = ACTIONS(768),
    [anon_sym_long] = ACTIONS(768),
    [anon_sym_char] = ACTIONS(768),
    [anon_sym_float] = ACTIONS(768),
    [anon_sym_double] = ACTIONS(768),
    [sym_boolean_type] = ACTIONS(768),
    [sym_void_type] = ACTIONS(768),
    [sym_this] = ACTIONS(768),
    [sym_super] = ACTIONS(768),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(770),
    [sym_identifier] = ACTIONS(772),
    [sym_decimal_integer_literal] = ACTIONS(772),
    [sym_hex_integer_literal] = ACTIONS(772),
    [sym_octal_integer_literal] = ACTIONS(770),
    [sym_binary_integer_literal] = ACTIONS(770),
    [sym_decimal_floating_point_literal] = ACTIONS(770),
    [sym_hex_floating_point_literal] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_character_literal] = ACTIONS(770),
    [sym_string_literal] = ACTIONS(770),
    [sym_null_literal] = ACTIONS(772),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_TILDE] = ACTIONS(770),
    [anon_sym_PLUS_PLUS] = ACTIONS(770),
    [anon_sym_DASH_DASH] = ACTIONS(770),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_class] = ACTIONS(772),
    [anon_sym_SEMI] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_RBRACE] = ACTIONS(770),
    [anon_sym_assert] = ACTIONS(772),
    [anon_sym_switch] = ACTIONS(772),
    [anon_sym_case] = ACTIONS(772),
    [anon_sym_default] = ACTIONS(772),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_while] = ACTIONS(772),
    [anon_sym_break] = ACTIONS(772),
    [anon_sym_continue] = ACTIONS(772),
    [anon_sym_return] = ACTIONS(772),
    [anon_sym_synchronized] = ACTIONS(772),
    [anon_sym_throw] = ACTIONS(772),
    [anon_sym_try] = ACTIONS(772),
    [anon_sym_if] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(772),
    [anon_sym_for] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_open] = ACTIONS(772),
    [anon_sym_module] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(772),
    [anon_sym_package] = ACTIONS(772),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_enum] = ACTIONS(772),
    [anon_sym_public] = ACTIONS(772),
    [anon_sym_protected] = ACTIONS(772),
    [anon_sym_private] = ACTIONS(772),
    [anon_sym_abstract] = ACTIONS(772),
    [anon_sym_final] = ACTIONS(772),
    [anon_sym_strictfp] = ACTIONS(772),
    [anon_sym_native] = ACTIONS(772),
    [anon_sym_transient] = ACTIONS(772),
    [anon_sym_volatile] = ACTIONS(772),
    [anon_sym_ATinterface] = ACTIONS(770),
    [anon_sym_interface] = ACTIONS(772),
    [anon_sym_byte] = ACTIONS(772),
    [anon_sym_short] = ACTIONS(772),
    [anon_sym_int] = ACTIONS(772),
    [anon_sym_long] = ACTIONS(772),
    [anon_sym_char] = ACTIONS(772),
    [anon_sym_float] = ACTIONS(772),
    [anon_sym_double] = ACTIONS(772),
    [sym_boolean_type] = ACTIONS(772),
    [sym_void_type] = ACTIONS(772),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(774),
    [sym_identifier] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(776),
    [sym_hex_integer_literal] = ACTIONS(776),
    [sym_octal_integer_literal] = ACTIONS(774),
    [sym_binary_integer_literal] = ACTIONS(774),
    [sym_decimal_floating_point_literal] = ACTIONS(774),
    [sym_hex_floating_point_literal] = ACTIONS(776),
    [sym_true] = ACTIONS(776),
    [sym_false] = ACTIONS(776),
    [sym_character_literal] = ACTIONS(774),
    [sym_string_literal] = ACTIONS(774),
    [sym_null_literal] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(774),
    [anon_sym_TILDE] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(774),
    [anon_sym_DASH_DASH] = ACTIONS(774),
    [anon_sym_new] = ACTIONS(776),
    [anon_sym_class] = ACTIONS(776),
    [anon_sym_SEMI] = ACTIONS(774),
    [anon_sym_LBRACE] = ACTIONS(774),
    [anon_sym_RBRACE] = ACTIONS(774),
    [anon_sym_assert] = ACTIONS(776),
    [anon_sym_switch] = ACTIONS(776),
    [anon_sym_case] = ACTIONS(776),
    [anon_sym_default] = ACTIONS(776),
    [anon_sym_do] = ACTIONS(776),
    [anon_sym_while] = ACTIONS(776),
    [anon_sym_break] = ACTIONS(776),
    [anon_sym_continue] = ACTIONS(776),
    [anon_sym_return] = ACTIONS(776),
    [anon_sym_synchronized] = ACTIONS(776),
    [anon_sym_throw] = ACTIONS(776),
    [anon_sym_try] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(776),
    [anon_sym_else] = ACTIONS(776),
    [anon_sym_for] = ACTIONS(776),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_open] = ACTIONS(776),
    [anon_sym_module] = ACTIONS(776),
    [anon_sym_static] = ACTIONS(776),
    [anon_sym_package] = ACTIONS(776),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_enum] = ACTIONS(776),
    [anon_sym_public] = ACTIONS(776),
    [anon_sym_protected] = ACTIONS(776),
    [anon_sym_private] = ACTIONS(776),
    [anon_sym_abstract] = ACTIONS(776),
    [anon_sym_final] = ACTIONS(776),
    [anon_sym_strictfp] = ACTIONS(776),
    [anon_sym_native] = ACTIONS(776),
    [anon_sym_transient] = ACTIONS(776),
    [anon_sym_volatile] = ACTIONS(776),
    [anon_sym_ATinterface] = ACTIONS(774),
    [anon_sym_interface] = ACTIONS(776),
    [anon_sym_byte] = ACTIONS(776),
    [anon_sym_short] = ACTIONS(776),
    [anon_sym_int] = ACTIONS(776),
    [anon_sym_long] = ACTIONS(776),
    [anon_sym_char] = ACTIONS(776),
    [anon_sym_float] = ACTIONS(776),
    [anon_sym_double] = ACTIONS(776),
    [sym_boolean_type] = ACTIONS(776),
    [sym_void_type] = ACTIONS(776),
    [sym_this] = ACTIONS(776),
    [sym_super] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(778),
    [sym_identifier] = ACTIONS(780),
    [sym_decimal_integer_literal] = ACTIONS(780),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_octal_integer_literal] = ACTIONS(778),
    [sym_binary_integer_literal] = ACTIONS(778),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [sym_hex_floating_point_literal] = ACTIONS(780),
    [sym_true] = ACTIONS(780),
    [sym_false] = ACTIONS(780),
    [sym_character_literal] = ACTIONS(778),
    [sym_string_literal] = ACTIONS(778),
    [sym_null_literal] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_PLUS_PLUS] = ACTIONS(778),
    [anon_sym_DASH_DASH] = ACTIONS(778),
    [anon_sym_new] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(778),
    [anon_sym_LBRACE] = ACTIONS(778),
    [anon_sym_RBRACE] = ACTIONS(778),
    [anon_sym_assert] = ACTIONS(780),
    [anon_sym_switch] = ACTIONS(780),
    [anon_sym_case] = ACTIONS(780),
    [anon_sym_default] = ACTIONS(780),
    [anon_sym_do] = ACTIONS(780),
    [anon_sym_while] = ACTIONS(780),
    [anon_sym_break] = ACTIONS(780),
    [anon_sym_continue] = ACTIONS(780),
    [anon_sym_return] = ACTIONS(780),
    [anon_sym_synchronized] = ACTIONS(780),
    [anon_sym_throw] = ACTIONS(780),
    [anon_sym_try] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(780),
    [anon_sym_else] = ACTIONS(780),
    [anon_sym_for] = ACTIONS(780),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_open] = ACTIONS(780),
    [anon_sym_module] = ACTIONS(780),
    [anon_sym_static] = ACTIONS(780),
    [anon_sym_package] = ACTIONS(780),
    [anon_sym_import] = ACTIONS(780),
    [anon_sym_enum] = ACTIONS(780),
    [anon_sym_public] = ACTIONS(780),
    [anon_sym_protected] = ACTIONS(780),
    [anon_sym_private] = ACTIONS(780),
    [anon_sym_abstract] = ACTIONS(780),
    [anon_sym_final] = ACTIONS(780),
    [anon_sym_strictfp] = ACTIONS(780),
    [anon_sym_native] = ACTIONS(780),
    [anon_sym_transient] = ACTIONS(780),
    [anon_sym_volatile] = ACTIONS(780),
    [anon_sym_ATinterface] = ACTIONS(778),
    [anon_sym_interface] = ACTIONS(780),
    [anon_sym_byte] = ACTIONS(780),
    [anon_sym_short] = ACTIONS(780),
    [anon_sym_int] = ACTIONS(780),
    [anon_sym_long] = ACTIONS(780),
    [anon_sym_char] = ACTIONS(780),
    [anon_sym_float] = ACTIONS(780),
    [anon_sym_double] = ACTIONS(780),
    [sym_boolean_type] = ACTIONS(780),
    [sym_void_type] = ACTIONS(780),
    [sym_this] = ACTIONS(780),
    [sym_super] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(782),
    [sym_identifier] = ACTIONS(784),
    [sym_decimal_integer_literal] = ACTIONS(784),
    [sym_hex_integer_literal] = ACTIONS(784),
    [sym_octal_integer_literal] = ACTIONS(782),
    [sym_binary_integer_literal] = ACTIONS(782),
    [sym_decimal_floating_point_literal] = ACTIONS(782),
    [sym_hex_floating_point_literal] = ACTIONS(784),
    [sym_true] = ACTIONS(784),
    [sym_false] = ACTIONS(784),
    [sym_character_literal] = ACTIONS(782),
    [sym_string_literal] = ACTIONS(782),
    [sym_null_literal] = ACTIONS(784),
    [anon_sym_LPAREN] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(782),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_class] = ACTIONS(784),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_RBRACE] = ACTIONS(782),
    [anon_sym_assert] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_case] = ACTIONS(784),
    [anon_sym_default] = ACTIONS(784),
    [anon_sym_do] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(784),
    [anon_sym_break] = ACTIONS(784),
    [anon_sym_continue] = ACTIONS(784),
    [anon_sym_return] = ACTIONS(784),
    [anon_sym_synchronized] = ACTIONS(784),
    [anon_sym_throw] = ACTIONS(784),
    [anon_sym_try] = ACTIONS(784),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(784),
    [anon_sym_AT] = ACTIONS(784),
    [anon_sym_open] = ACTIONS(784),
    [anon_sym_module] = ACTIONS(784),
    [anon_sym_static] = ACTIONS(784),
    [anon_sym_package] = ACTIONS(784),
    [anon_sym_import] = ACTIONS(784),
    [anon_sym_enum] = ACTIONS(784),
    [anon_sym_public] = ACTIONS(784),
    [anon_sym_protected] = ACTIONS(784),
    [anon_sym_private] = ACTIONS(784),
    [anon_sym_abstract] = ACTIONS(784),
    [anon_sym_final] = ACTIONS(784),
    [anon_sym_strictfp] = ACTIONS(784),
    [anon_sym_native] = ACTIONS(784),
    [anon_sym_transient] = ACTIONS(784),
    [anon_sym_volatile] = ACTIONS(784),
    [anon_sym_ATinterface] = ACTIONS(782),
    [anon_sym_interface] = ACTIONS(784),
    [anon_sym_byte] = ACTIONS(784),
    [anon_sym_short] = ACTIONS(784),
    [anon_sym_int] = ACTIONS(784),
    [anon_sym_long] = ACTIONS(784),
    [anon_sym_char] = ACTIONS(784),
    [anon_sym_float] = ACTIONS(784),
    [anon_sym_double] = ACTIONS(784),
    [sym_boolean_type] = ACTIONS(784),
    [sym_void_type] = ACTIONS(784),
    [sym_this] = ACTIONS(784),
    [sym_super] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(786),
    [sym_identifier] = ACTIONS(788),
    [sym_decimal_integer_literal] = ACTIONS(788),
    [sym_hex_integer_literal] = ACTIONS(788),
    [sym_octal_integer_literal] = ACTIONS(786),
    [sym_binary_integer_literal] = ACTIONS(786),
    [sym_decimal_floating_point_literal] = ACTIONS(786),
    [sym_hex_floating_point_literal] = ACTIONS(788),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_character_literal] = ACTIONS(786),
    [sym_string_literal] = ACTIONS(786),
    [sym_null_literal] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_PLUS_PLUS] = ACTIONS(786),
    [anon_sym_DASH_DASH] = ACTIONS(786),
    [anon_sym_new] = ACTIONS(788),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_SEMI] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_assert] = ACTIONS(788),
    [anon_sym_switch] = ACTIONS(788),
    [anon_sym_case] = ACTIONS(788),
    [anon_sym_default] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_break] = ACTIONS(788),
    [anon_sym_continue] = ACTIONS(788),
    [anon_sym_return] = ACTIONS(788),
    [anon_sym_synchronized] = ACTIONS(788),
    [anon_sym_throw] = ACTIONS(788),
    [anon_sym_try] = ACTIONS(788),
    [anon_sym_if] = ACTIONS(788),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(788),
    [anon_sym_open] = ACTIONS(788),
    [anon_sym_module] = ACTIONS(788),
    [anon_sym_static] = ACTIONS(788),
    [anon_sym_package] = ACTIONS(788),
    [anon_sym_import] = ACTIONS(788),
    [anon_sym_enum] = ACTIONS(788),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_abstract] = ACTIONS(788),
    [anon_sym_final] = ACTIONS(788),
    [anon_sym_strictfp] = ACTIONS(788),
    [anon_sym_native] = ACTIONS(788),
    [anon_sym_transient] = ACTIONS(788),
    [anon_sym_volatile] = ACTIONS(788),
    [anon_sym_ATinterface] = ACTIONS(786),
    [anon_sym_interface] = ACTIONS(788),
    [anon_sym_byte] = ACTIONS(788),
    [anon_sym_short] = ACTIONS(788),
    [anon_sym_int] = ACTIONS(788),
    [anon_sym_long] = ACTIONS(788),
    [anon_sym_char] = ACTIONS(788),
    [anon_sym_float] = ACTIONS(788),
    [anon_sym_double] = ACTIONS(788),
    [sym_boolean_type] = ACTIONS(788),
    [sym_void_type] = ACTIONS(788),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(463),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(456),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(792),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(794),
    [sym_identifier] = ACTIONS(796),
    [sym_decimal_integer_literal] = ACTIONS(796),
    [sym_hex_integer_literal] = ACTIONS(796),
    [sym_octal_integer_literal] = ACTIONS(794),
    [sym_binary_integer_literal] = ACTIONS(794),
    [sym_decimal_floating_point_literal] = ACTIONS(794),
    [sym_hex_floating_point_literal] = ACTIONS(796),
    [sym_true] = ACTIONS(796),
    [sym_false] = ACTIONS(796),
    [sym_character_literal] = ACTIONS(794),
    [sym_string_literal] = ACTIONS(794),
    [sym_null_literal] = ACTIONS(796),
    [anon_sym_LPAREN] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(794),
    [anon_sym_TILDE] = ACTIONS(794),
    [anon_sym_PLUS_PLUS] = ACTIONS(794),
    [anon_sym_DASH_DASH] = ACTIONS(794),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_class] = ACTIONS(796),
    [anon_sym_SEMI] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_RBRACE] = ACTIONS(794),
    [anon_sym_assert] = ACTIONS(796),
    [anon_sym_switch] = ACTIONS(796),
    [anon_sym_case] = ACTIONS(796),
    [anon_sym_default] = ACTIONS(796),
    [anon_sym_do] = ACTIONS(796),
    [anon_sym_while] = ACTIONS(796),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_return] = ACTIONS(796),
    [anon_sym_synchronized] = ACTIONS(796),
    [anon_sym_throw] = ACTIONS(796),
    [anon_sym_try] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(796),
    [anon_sym_else] = ACTIONS(798),
    [anon_sym_for] = ACTIONS(796),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_open] = ACTIONS(796),
    [anon_sym_module] = ACTIONS(796),
    [anon_sym_static] = ACTIONS(796),
    [anon_sym_package] = ACTIONS(796),
    [anon_sym_import] = ACTIONS(796),
    [anon_sym_enum] = ACTIONS(796),
    [anon_sym_public] = ACTIONS(796),
    [anon_sym_protected] = ACTIONS(796),
    [anon_sym_private] = ACTIONS(796),
    [anon_sym_abstract] = ACTIONS(796),
    [anon_sym_final] = ACTIONS(796),
    [anon_sym_strictfp] = ACTIONS(796),
    [anon_sym_native] = ACTIONS(796),
    [anon_sym_transient] = ACTIONS(796),
    [anon_sym_volatile] = ACTIONS(796),
    [anon_sym_ATinterface] = ACTIONS(794),
    [anon_sym_interface] = ACTIONS(796),
    [anon_sym_byte] = ACTIONS(796),
    [anon_sym_short] = ACTIONS(796),
    [anon_sym_int] = ACTIONS(796),
    [anon_sym_long] = ACTIONS(796),
    [anon_sym_char] = ACTIONS(796),
    [anon_sym_float] = ACTIONS(796),
    [anon_sym_double] = ACTIONS(796),
    [sym_boolean_type] = ACTIONS(796),
    [sym_void_type] = ACTIONS(796),
    [sym_this] = ACTIONS(796),
    [sym_super] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(800),
    [sym_identifier] = ACTIONS(802),
    [sym_decimal_integer_literal] = ACTIONS(802),
    [sym_hex_integer_literal] = ACTIONS(802),
    [sym_octal_integer_literal] = ACTIONS(800),
    [sym_binary_integer_literal] = ACTIONS(800),
    [sym_decimal_floating_point_literal] = ACTIONS(800),
    [sym_hex_floating_point_literal] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_character_literal] = ACTIONS(800),
    [sym_string_literal] = ACTIONS(800),
    [sym_null_literal] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(800),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(800),
    [anon_sym_PLUS_PLUS] = ACTIONS(800),
    [anon_sym_DASH_DASH] = ACTIONS(800),
    [anon_sym_new] = ACTIONS(802),
    [anon_sym_class] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(800),
    [anon_sym_RBRACE] = ACTIONS(800),
    [anon_sym_assert] = ACTIONS(802),
    [anon_sym_switch] = ACTIONS(802),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_default] = ACTIONS(802),
    [anon_sym_do] = ACTIONS(802),
    [anon_sym_while] = ACTIONS(802),
    [anon_sym_break] = ACTIONS(802),
    [anon_sym_continue] = ACTIONS(802),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_synchronized] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_try] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_else] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(802),
    [anon_sym_AT] = ACTIONS(802),
    [anon_sym_open] = ACTIONS(802),
    [anon_sym_module] = ACTIONS(802),
    [anon_sym_static] = ACTIONS(802),
    [anon_sym_package] = ACTIONS(802),
    [anon_sym_import] = ACTIONS(802),
    [anon_sym_enum] = ACTIONS(802),
    [anon_sym_public] = ACTIONS(802),
    [anon_sym_protected] = ACTIONS(802),
    [anon_sym_private] = ACTIONS(802),
    [anon_sym_abstract] = ACTIONS(802),
    [anon_sym_final] = ACTIONS(802),
    [anon_sym_strictfp] = ACTIONS(802),
    [anon_sym_native] = ACTIONS(802),
    [anon_sym_transient] = ACTIONS(802),
    [anon_sym_volatile] = ACTIONS(802),
    [anon_sym_ATinterface] = ACTIONS(800),
    [anon_sym_interface] = ACTIONS(802),
    [anon_sym_byte] = ACTIONS(802),
    [anon_sym_short] = ACTIONS(802),
    [anon_sym_int] = ACTIONS(802),
    [anon_sym_long] = ACTIONS(802),
    [anon_sym_char] = ACTIONS(802),
    [anon_sym_float] = ACTIONS(802),
    [anon_sym_double] = ACTIONS(802),
    [sym_boolean_type] = ACTIONS(802),
    [sym_void_type] = ACTIONS(802),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(804),
    [sym_identifier] = ACTIONS(806),
    [sym_decimal_integer_literal] = ACTIONS(806),
    [sym_hex_integer_literal] = ACTIONS(806),
    [sym_octal_integer_literal] = ACTIONS(804),
    [sym_binary_integer_literal] = ACTIONS(804),
    [sym_decimal_floating_point_literal] = ACTIONS(804),
    [sym_hex_floating_point_literal] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_character_literal] = ACTIONS(804),
    [sym_string_literal] = ACTIONS(804),
    [sym_null_literal] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_BANG] = ACTIONS(804),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_new] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_RBRACE] = ACTIONS(804),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_switch] = ACTIONS(806),
    [anon_sym_case] = ACTIONS(806),
    [anon_sym_default] = ACTIONS(806),
    [anon_sym_do] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_synchronized] = ACTIONS(806),
    [anon_sym_throw] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(806),
    [anon_sym_open] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [anon_sym_static] = ACTIONS(806),
    [anon_sym_package] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_enum] = ACTIONS(806),
    [anon_sym_public] = ACTIONS(806),
    [anon_sym_protected] = ACTIONS(806),
    [anon_sym_private] = ACTIONS(806),
    [anon_sym_abstract] = ACTIONS(806),
    [anon_sym_final] = ACTIONS(806),
    [anon_sym_strictfp] = ACTIONS(806),
    [anon_sym_native] = ACTIONS(806),
    [anon_sym_transient] = ACTIONS(806),
    [anon_sym_volatile] = ACTIONS(806),
    [anon_sym_ATinterface] = ACTIONS(804),
    [anon_sym_interface] = ACTIONS(806),
    [anon_sym_byte] = ACTIONS(806),
    [anon_sym_short] = ACTIONS(806),
    [anon_sym_int] = ACTIONS(806),
    [anon_sym_long] = ACTIONS(806),
    [anon_sym_char] = ACTIONS(806),
    [anon_sym_float] = ACTIONS(806),
    [anon_sym_double] = ACTIONS(806),
    [sym_boolean_type] = ACTIONS(806),
    [sym_void_type] = ACTIONS(806),
    [sym_this] = ACTIONS(806),
    [sym_super] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(379),
    [sym_decimal_integer_literal] = ACTIONS(379),
    [sym_hex_integer_literal] = ACTIONS(379),
    [sym_octal_integer_literal] = ACTIONS(377),
    [sym_binary_integer_literal] = ACTIONS(377),
    [sym_decimal_floating_point_literal] = ACTIONS(377),
    [sym_hex_floating_point_literal] = ACTIONS(379),
    [sym_true] = ACTIONS(379),
    [sym_false] = ACTIONS(379),
    [sym_character_literal] = ACTIONS(377),
    [sym_string_literal] = ACTIONS(377),
    [sym_null_literal] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_TILDE] = ACTIONS(377),
    [anon_sym_PLUS_PLUS] = ACTIONS(377),
    [anon_sym_DASH_DASH] = ACTIONS(377),
    [anon_sym_new] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_assert] = ACTIONS(379),
    [anon_sym_switch] = ACTIONS(379),
    [anon_sym_case] = ACTIONS(379),
    [anon_sym_default] = ACTIONS(379),
    [anon_sym_do] = ACTIONS(379),
    [anon_sym_while] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(379),
    [anon_sym_continue] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_synchronized] = ACTIONS(379),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(379),
    [anon_sym_else] = ACTIONS(379),
    [anon_sym_for] = ACTIONS(379),
    [anon_sym_AT] = ACTIONS(379),
    [anon_sym_open] = ACTIONS(379),
    [anon_sym_module] = ACTIONS(379),
    [anon_sym_static] = ACTIONS(379),
    [anon_sym_package] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(379),
    [anon_sym_enum] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(379),
    [anon_sym_protected] = ACTIONS(379),
    [anon_sym_private] = ACTIONS(379),
    [anon_sym_abstract] = ACTIONS(379),
    [anon_sym_final] = ACTIONS(379),
    [anon_sym_strictfp] = ACTIONS(379),
    [anon_sym_native] = ACTIONS(379),
    [anon_sym_transient] = ACTIONS(379),
    [anon_sym_volatile] = ACTIONS(379),
    [anon_sym_ATinterface] = ACTIONS(377),
    [anon_sym_interface] = ACTIONS(379),
    [anon_sym_byte] = ACTIONS(379),
    [anon_sym_short] = ACTIONS(379),
    [anon_sym_int] = ACTIONS(379),
    [anon_sym_long] = ACTIONS(379),
    [anon_sym_char] = ACTIONS(379),
    [anon_sym_float] = ACTIONS(379),
    [anon_sym_double] = ACTIONS(379),
    [sym_boolean_type] = ACTIONS(379),
    [sym_void_type] = ACTIONS(379),
    [sym_this] = ACTIONS(379),
    [sym_super] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(442),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(808),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(810),
    [sym_identifier] = ACTIONS(812),
    [sym_decimal_integer_literal] = ACTIONS(812),
    [sym_hex_integer_literal] = ACTIONS(812),
    [sym_octal_integer_literal] = ACTIONS(810),
    [sym_binary_integer_literal] = ACTIONS(810),
    [sym_decimal_floating_point_literal] = ACTIONS(810),
    [sym_hex_floating_point_literal] = ACTIONS(812),
    [sym_true] = ACTIONS(812),
    [sym_false] = ACTIONS(812),
    [sym_character_literal] = ACTIONS(810),
    [sym_string_literal] = ACTIONS(810),
    [sym_null_literal] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(812),
    [anon_sym_DASH] = ACTIONS(812),
    [anon_sym_BANG] = ACTIONS(810),
    [anon_sym_TILDE] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(810),
    [anon_sym_DASH_DASH] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_class] = ACTIONS(812),
    [anon_sym_SEMI] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(810),
    [anon_sym_RBRACE] = ACTIONS(810),
    [anon_sym_assert] = ACTIONS(812),
    [anon_sym_switch] = ACTIONS(812),
    [anon_sym_case] = ACTIONS(812),
    [anon_sym_default] = ACTIONS(812),
    [anon_sym_do] = ACTIONS(812),
    [anon_sym_while] = ACTIONS(812),
    [anon_sym_break] = ACTIONS(812),
    [anon_sym_continue] = ACTIONS(812),
    [anon_sym_return] = ACTIONS(812),
    [anon_sym_synchronized] = ACTIONS(812),
    [anon_sym_throw] = ACTIONS(812),
    [anon_sym_try] = ACTIONS(812),
    [anon_sym_if] = ACTIONS(812),
    [anon_sym_else] = ACTIONS(812),
    [anon_sym_for] = ACTIONS(812),
    [anon_sym_AT] = ACTIONS(812),
    [anon_sym_open] = ACTIONS(812),
    [anon_sym_module] = ACTIONS(812),
    [anon_sym_static] = ACTIONS(812),
    [anon_sym_package] = ACTIONS(812),
    [anon_sym_import] = ACTIONS(812),
    [anon_sym_enum] = ACTIONS(812),
    [anon_sym_public] = ACTIONS(812),
    [anon_sym_protected] = ACTIONS(812),
    [anon_sym_private] = ACTIONS(812),
    [anon_sym_abstract] = ACTIONS(812),
    [anon_sym_final] = ACTIONS(812),
    [anon_sym_strictfp] = ACTIONS(812),
    [anon_sym_native] = ACTIONS(812),
    [anon_sym_transient] = ACTIONS(812),
    [anon_sym_volatile] = ACTIONS(812),
    [anon_sym_ATinterface] = ACTIONS(810),
    [anon_sym_interface] = ACTIONS(812),
    [anon_sym_byte] = ACTIONS(812),
    [anon_sym_short] = ACTIONS(812),
    [anon_sym_int] = ACTIONS(812),
    [anon_sym_long] = ACTIONS(812),
    [anon_sym_char] = ACTIONS(812),
    [anon_sym_float] = ACTIONS(812),
    [anon_sym_double] = ACTIONS(812),
    [sym_boolean_type] = ACTIONS(812),
    [sym_void_type] = ACTIONS(812),
    [sym_this] = ACTIONS(812),
    [sym_super] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(814),
    [sym_identifier] = ACTIONS(816),
    [sym_decimal_integer_literal] = ACTIONS(816),
    [sym_hex_integer_literal] = ACTIONS(816),
    [sym_octal_integer_literal] = ACTIONS(814),
    [sym_binary_integer_literal] = ACTIONS(814),
    [sym_decimal_floating_point_literal] = ACTIONS(814),
    [sym_hex_floating_point_literal] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_character_literal] = ACTIONS(814),
    [sym_string_literal] = ACTIONS(814),
    [sym_null_literal] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(816),
    [anon_sym_DASH] = ACTIONS(816),
    [anon_sym_BANG] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(814),
    [anon_sym_DASH_DASH] = ACTIONS(814),
    [anon_sym_new] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_assert] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(816),
    [anon_sym_case] = ACTIONS(816),
    [anon_sym_default] = ACTIONS(816),
    [anon_sym_do] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(816),
    [anon_sym_continue] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_synchronized] = ACTIONS(816),
    [anon_sym_throw] = ACTIONS(816),
    [anon_sym_try] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_else] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(816),
    [anon_sym_open] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(816),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_package] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(816),
    [anon_sym_enum] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(816),
    [anon_sym_final] = ACTIONS(816),
    [anon_sym_strictfp] = ACTIONS(816),
    [anon_sym_native] = ACTIONS(816),
    [anon_sym_transient] = ACTIONS(816),
    [anon_sym_volatile] = ACTIONS(816),
    [anon_sym_ATinterface] = ACTIONS(814),
    [anon_sym_interface] = ACTIONS(816),
    [anon_sym_byte] = ACTIONS(816),
    [anon_sym_short] = ACTIONS(816),
    [anon_sym_int] = ACTIONS(816),
    [anon_sym_long] = ACTIONS(816),
    [anon_sym_char] = ACTIONS(816),
    [anon_sym_float] = ACTIONS(816),
    [anon_sym_double] = ACTIONS(816),
    [sym_boolean_type] = ACTIONS(816),
    [sym_void_type] = ACTIONS(816),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(446),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(820),
    [sym_identifier] = ACTIONS(822),
    [sym_decimal_integer_literal] = ACTIONS(822),
    [sym_hex_integer_literal] = ACTIONS(822),
    [sym_octal_integer_literal] = ACTIONS(820),
    [sym_binary_integer_literal] = ACTIONS(820),
    [sym_decimal_floating_point_literal] = ACTIONS(820),
    [sym_hex_floating_point_literal] = ACTIONS(822),
    [sym_true] = ACTIONS(822),
    [sym_false] = ACTIONS(822),
    [sym_character_literal] = ACTIONS(820),
    [sym_string_literal] = ACTIONS(820),
    [sym_null_literal] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_PLUS_PLUS] = ACTIONS(820),
    [anon_sym_DASH_DASH] = ACTIONS(820),
    [anon_sym_new] = ACTIONS(822),
    [anon_sym_class] = ACTIONS(822),
    [anon_sym_SEMI] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(820),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_assert] = ACTIONS(822),
    [anon_sym_switch] = ACTIONS(822),
    [anon_sym_case] = ACTIONS(822),
    [anon_sym_default] = ACTIONS(822),
    [anon_sym_do] = ACTIONS(822),
    [anon_sym_while] = ACTIONS(822),
    [anon_sym_break] = ACTIONS(822),
    [anon_sym_continue] = ACTIONS(822),
    [anon_sym_return] = ACTIONS(822),
    [anon_sym_synchronized] = ACTIONS(822),
    [anon_sym_throw] = ACTIONS(822),
    [anon_sym_try] = ACTIONS(822),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_else] = ACTIONS(822),
    [anon_sym_for] = ACTIONS(822),
    [anon_sym_AT] = ACTIONS(822),
    [anon_sym_open] = ACTIONS(822),
    [anon_sym_module] = ACTIONS(822),
    [anon_sym_static] = ACTIONS(822),
    [anon_sym_package] = ACTIONS(822),
    [anon_sym_import] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(822),
    [anon_sym_public] = ACTIONS(822),
    [anon_sym_protected] = ACTIONS(822),
    [anon_sym_private] = ACTIONS(822),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_final] = ACTIONS(822),
    [anon_sym_strictfp] = ACTIONS(822),
    [anon_sym_native] = ACTIONS(822),
    [anon_sym_transient] = ACTIONS(822),
    [anon_sym_volatile] = ACTIONS(822),
    [anon_sym_ATinterface] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_byte] = ACTIONS(822),
    [anon_sym_short] = ACTIONS(822),
    [anon_sym_int] = ACTIONS(822),
    [anon_sym_long] = ACTIONS(822),
    [anon_sym_char] = ACTIONS(822),
    [anon_sym_float] = ACTIONS(822),
    [anon_sym_double] = ACTIONS(822),
    [sym_boolean_type] = ACTIONS(822),
    [sym_void_type] = ACTIONS(822),
    [sym_this] = ACTIONS(822),
    [sym_super] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(824),
    [sym_identifier] = ACTIONS(826),
    [sym_decimal_integer_literal] = ACTIONS(826),
    [sym_hex_integer_literal] = ACTIONS(826),
    [sym_octal_integer_literal] = ACTIONS(824),
    [sym_binary_integer_literal] = ACTIONS(824),
    [sym_decimal_floating_point_literal] = ACTIONS(824),
    [sym_hex_floating_point_literal] = ACTIONS(826),
    [sym_true] = ACTIONS(826),
    [sym_false] = ACTIONS(826),
    [sym_character_literal] = ACTIONS(824),
    [sym_string_literal] = ACTIONS(824),
    [sym_null_literal] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_PLUS] = ACTIONS(826),
    [anon_sym_DASH] = ACTIONS(826),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_PLUS_PLUS] = ACTIONS(824),
    [anon_sym_DASH_DASH] = ACTIONS(824),
    [anon_sym_new] = ACTIONS(826),
    [anon_sym_class] = ACTIONS(826),
    [anon_sym_SEMI] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_RBRACE] = ACTIONS(824),
    [anon_sym_assert] = ACTIONS(826),
    [anon_sym_switch] = ACTIONS(826),
    [anon_sym_case] = ACTIONS(826),
    [anon_sym_default] = ACTIONS(826),
    [anon_sym_do] = ACTIONS(826),
    [anon_sym_while] = ACTIONS(826),
    [anon_sym_break] = ACTIONS(826),
    [anon_sym_continue] = ACTIONS(826),
    [anon_sym_return] = ACTIONS(826),
    [anon_sym_synchronized] = ACTIONS(826),
    [anon_sym_throw] = ACTIONS(826),
    [anon_sym_try] = ACTIONS(826),
    [anon_sym_if] = ACTIONS(826),
    [anon_sym_else] = ACTIONS(826),
    [anon_sym_for] = ACTIONS(826),
    [anon_sym_AT] = ACTIONS(826),
    [anon_sym_open] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_package] = ACTIONS(826),
    [anon_sym_import] = ACTIONS(826),
    [anon_sym_enum] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_abstract] = ACTIONS(826),
    [anon_sym_final] = ACTIONS(826),
    [anon_sym_strictfp] = ACTIONS(826),
    [anon_sym_native] = ACTIONS(826),
    [anon_sym_transient] = ACTIONS(826),
    [anon_sym_volatile] = ACTIONS(826),
    [anon_sym_ATinterface] = ACTIONS(824),
    [anon_sym_interface] = ACTIONS(826),
    [anon_sym_byte] = ACTIONS(826),
    [anon_sym_short] = ACTIONS(826),
    [anon_sym_int] = ACTIONS(826),
    [anon_sym_long] = ACTIONS(826),
    [anon_sym_char] = ACTIONS(826),
    [anon_sym_float] = ACTIONS(826),
    [anon_sym_double] = ACTIONS(826),
    [sym_boolean_type] = ACTIONS(826),
    [sym_void_type] = ACTIONS(826),
    [sym_this] = ACTIONS(826),
    [sym_super] = ACTIONS(826),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(828),
    [sym_identifier] = ACTIONS(830),
    [sym_decimal_integer_literal] = ACTIONS(830),
    [sym_hex_integer_literal] = ACTIONS(830),
    [sym_octal_integer_literal] = ACTIONS(828),
    [sym_binary_integer_literal] = ACTIONS(828),
    [sym_decimal_floating_point_literal] = ACTIONS(828),
    [sym_hex_floating_point_literal] = ACTIONS(830),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_character_literal] = ACTIONS(828),
    [sym_string_literal] = ACTIONS(828),
    [sym_null_literal] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(828),
    [anon_sym_TILDE] = ACTIONS(828),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_new] = ACTIONS(830),
    [anon_sym_class] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_RBRACE] = ACTIONS(828),
    [anon_sym_assert] = ACTIONS(830),
    [anon_sym_switch] = ACTIONS(830),
    [anon_sym_case] = ACTIONS(830),
    [anon_sym_default] = ACTIONS(830),
    [anon_sym_do] = ACTIONS(830),
    [anon_sym_while] = ACTIONS(830),
    [anon_sym_break] = ACTIONS(830),
    [anon_sym_continue] = ACTIONS(830),
    [anon_sym_return] = ACTIONS(830),
    [anon_sym_synchronized] = ACTIONS(830),
    [anon_sym_throw] = ACTIONS(830),
    [anon_sym_try] = ACTIONS(830),
    [anon_sym_if] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(830),
    [anon_sym_open] = ACTIONS(830),
    [anon_sym_module] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(830),
    [anon_sym_package] = ACTIONS(830),
    [anon_sym_import] = ACTIONS(830),
    [anon_sym_enum] = ACTIONS(830),
    [anon_sym_public] = ACTIONS(830),
    [anon_sym_protected] = ACTIONS(830),
    [anon_sym_private] = ACTIONS(830),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_final] = ACTIONS(830),
    [anon_sym_strictfp] = ACTIONS(830),
    [anon_sym_native] = ACTIONS(830),
    [anon_sym_transient] = ACTIONS(830),
    [anon_sym_volatile] = ACTIONS(830),
    [anon_sym_ATinterface] = ACTIONS(828),
    [anon_sym_interface] = ACTIONS(830),
    [anon_sym_byte] = ACTIONS(830),
    [anon_sym_short] = ACTIONS(830),
    [anon_sym_int] = ACTIONS(830),
    [anon_sym_long] = ACTIONS(830),
    [anon_sym_char] = ACTIONS(830),
    [anon_sym_float] = ACTIONS(830),
    [anon_sym_double] = ACTIONS(830),
    [sym_boolean_type] = ACTIONS(830),
    [sym_void_type] = ACTIONS(830),
    [sym_this] = ACTIONS(830),
    [sym_super] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(832),
    [sym_identifier] = ACTIONS(834),
    [sym_decimal_integer_literal] = ACTIONS(834),
    [sym_hex_integer_literal] = ACTIONS(834),
    [sym_octal_integer_literal] = ACTIONS(832),
    [sym_binary_integer_literal] = ACTIONS(832),
    [sym_decimal_floating_point_literal] = ACTIONS(832),
    [sym_hex_floating_point_literal] = ACTIONS(834),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_character_literal] = ACTIONS(832),
    [sym_string_literal] = ACTIONS(832),
    [sym_null_literal] = ACTIONS(834),
    [anon_sym_LPAREN] = ACTIONS(832),
    [anon_sym_PLUS] = ACTIONS(834),
    [anon_sym_DASH] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_TILDE] = ACTIONS(832),
    [anon_sym_PLUS_PLUS] = ACTIONS(832),
    [anon_sym_DASH_DASH] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(832),
    [anon_sym_RBRACE] = ACTIONS(832),
    [anon_sym_assert] = ACTIONS(834),
    [anon_sym_switch] = ACTIONS(834),
    [anon_sym_case] = ACTIONS(834),
    [anon_sym_default] = ACTIONS(834),
    [anon_sym_do] = ACTIONS(834),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(834),
    [anon_sym_return] = ACTIONS(834),
    [anon_sym_synchronized] = ACTIONS(834),
    [anon_sym_throw] = ACTIONS(834),
    [anon_sym_try] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(834),
    [anon_sym_else] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(834),
    [anon_sym_open] = ACTIONS(834),
    [anon_sym_module] = ACTIONS(834),
    [anon_sym_static] = ACTIONS(834),
    [anon_sym_package] = ACTIONS(834),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_enum] = ACTIONS(834),
    [anon_sym_public] = ACTIONS(834),
    [anon_sym_protected] = ACTIONS(834),
    [anon_sym_private] = ACTIONS(834),
    [anon_sym_abstract] = ACTIONS(834),
    [anon_sym_final] = ACTIONS(834),
    [anon_sym_strictfp] = ACTIONS(834),
    [anon_sym_native] = ACTIONS(834),
    [anon_sym_transient] = ACTIONS(834),
    [anon_sym_volatile] = ACTIONS(834),
    [anon_sym_ATinterface] = ACTIONS(832),
    [anon_sym_interface] = ACTIONS(834),
    [anon_sym_byte] = ACTIONS(834),
    [anon_sym_short] = ACTIONS(834),
    [anon_sym_int] = ACTIONS(834),
    [anon_sym_long] = ACTIONS(834),
    [anon_sym_char] = ACTIONS(834),
    [anon_sym_float] = ACTIONS(834),
    [anon_sym_double] = ACTIONS(834),
    [sym_boolean_type] = ACTIONS(834),
    [sym_void_type] = ACTIONS(834),
    [sym_this] = ACTIONS(834),
    [sym_super] = ACTIONS(834),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(836),
    [sym_identifier] = ACTIONS(838),
    [sym_decimal_integer_literal] = ACTIONS(838),
    [sym_hex_integer_literal] = ACTIONS(838),
    [sym_octal_integer_literal] = ACTIONS(836),
    [sym_binary_integer_literal] = ACTIONS(836),
    [sym_decimal_floating_point_literal] = ACTIONS(836),
    [sym_hex_floating_point_literal] = ACTIONS(838),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_character_literal] = ACTIONS(836),
    [sym_string_literal] = ACTIONS(836),
    [sym_null_literal] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_BANG] = ACTIONS(836),
    [anon_sym_TILDE] = ACTIONS(836),
    [anon_sym_PLUS_PLUS] = ACTIONS(836),
    [anon_sym_DASH_DASH] = ACTIONS(836),
    [anon_sym_new] = ACTIONS(838),
    [anon_sym_class] = ACTIONS(838),
    [anon_sym_SEMI] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_RBRACE] = ACTIONS(836),
    [anon_sym_assert] = ACTIONS(838),
    [anon_sym_switch] = ACTIONS(838),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_default] = ACTIONS(838),
    [anon_sym_do] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_break] = ACTIONS(838),
    [anon_sym_continue] = ACTIONS(838),
    [anon_sym_return] = ACTIONS(838),
    [anon_sym_synchronized] = ACTIONS(838),
    [anon_sym_throw] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(838),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_open] = ACTIONS(838),
    [anon_sym_module] = ACTIONS(838),
    [anon_sym_static] = ACTIONS(838),
    [anon_sym_package] = ACTIONS(838),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_enum] = ACTIONS(838),
    [anon_sym_public] = ACTIONS(838),
    [anon_sym_protected] = ACTIONS(838),
    [anon_sym_private] = ACTIONS(838),
    [anon_sym_abstract] = ACTIONS(838),
    [anon_sym_final] = ACTIONS(838),
    [anon_sym_strictfp] = ACTIONS(838),
    [anon_sym_native] = ACTIONS(838),
    [anon_sym_transient] = ACTIONS(838),
    [anon_sym_volatile] = ACTIONS(838),
    [anon_sym_ATinterface] = ACTIONS(836),
    [anon_sym_interface] = ACTIONS(838),
    [anon_sym_byte] = ACTIONS(838),
    [anon_sym_short] = ACTIONS(838),
    [anon_sym_int] = ACTIONS(838),
    [anon_sym_long] = ACTIONS(838),
    [anon_sym_char] = ACTIONS(838),
    [anon_sym_float] = ACTIONS(838),
    [anon_sym_double] = ACTIONS(838),
    [sym_boolean_type] = ACTIONS(838),
    [sym_void_type] = ACTIONS(838),
    [sym_this] = ACTIONS(838),
    [sym_super] = ACTIONS(838),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(840),
    [sym_identifier] = ACTIONS(842),
    [sym_decimal_integer_literal] = ACTIONS(842),
    [sym_hex_integer_literal] = ACTIONS(842),
    [sym_octal_integer_literal] = ACTIONS(840),
    [sym_binary_integer_literal] = ACTIONS(840),
    [sym_decimal_floating_point_literal] = ACTIONS(840),
    [sym_hex_floating_point_literal] = ACTIONS(842),
    [sym_true] = ACTIONS(842),
    [sym_false] = ACTIONS(842),
    [sym_character_literal] = ACTIONS(840),
    [sym_string_literal] = ACTIONS(840),
    [sym_null_literal] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(842),
    [anon_sym_class] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(840),
    [anon_sym_assert] = ACTIONS(842),
    [anon_sym_switch] = ACTIONS(842),
    [anon_sym_case] = ACTIONS(842),
    [anon_sym_default] = ACTIONS(842),
    [anon_sym_do] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(842),
    [anon_sym_break] = ACTIONS(842),
    [anon_sym_continue] = ACTIONS(842),
    [anon_sym_return] = ACTIONS(842),
    [anon_sym_synchronized] = ACTIONS(842),
    [anon_sym_throw] = ACTIONS(842),
    [anon_sym_try] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(842),
    [anon_sym_else] = ACTIONS(842),
    [anon_sym_for] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(842),
    [anon_sym_open] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_package] = ACTIONS(842),
    [anon_sym_import] = ACTIONS(842),
    [anon_sym_enum] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_abstract] = ACTIONS(842),
    [anon_sym_final] = ACTIONS(842),
    [anon_sym_strictfp] = ACTIONS(842),
    [anon_sym_native] = ACTIONS(842),
    [anon_sym_transient] = ACTIONS(842),
    [anon_sym_volatile] = ACTIONS(842),
    [anon_sym_ATinterface] = ACTIONS(840),
    [anon_sym_interface] = ACTIONS(842),
    [anon_sym_byte] = ACTIONS(842),
    [anon_sym_short] = ACTIONS(842),
    [anon_sym_int] = ACTIONS(842),
    [anon_sym_long] = ACTIONS(842),
    [anon_sym_char] = ACTIONS(842),
    [anon_sym_float] = ACTIONS(842),
    [anon_sym_double] = ACTIONS(842),
    [sym_boolean_type] = ACTIONS(842),
    [sym_void_type] = ACTIONS(842),
    [sym_this] = ACTIONS(842),
    [sym_super] = ACTIONS(842),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(844),
    [sym_identifier] = ACTIONS(846),
    [sym_decimal_integer_literal] = ACTIONS(846),
    [sym_hex_integer_literal] = ACTIONS(846),
    [sym_octal_integer_literal] = ACTIONS(844),
    [sym_binary_integer_literal] = ACTIONS(844),
    [sym_decimal_floating_point_literal] = ACTIONS(844),
    [sym_hex_floating_point_literal] = ACTIONS(846),
    [sym_true] = ACTIONS(846),
    [sym_false] = ACTIONS(846),
    [sym_character_literal] = ACTIONS(844),
    [sym_string_literal] = ACTIONS(844),
    [sym_null_literal] = ACTIONS(846),
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(846),
    [anon_sym_class] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(844),
    [anon_sym_assert] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_case] = ACTIONS(846),
    [anon_sym_default] = ACTIONS(846),
    [anon_sym_do] = ACTIONS(846),
    [anon_sym_while] = ACTIONS(846),
    [anon_sym_break] = ACTIONS(846),
    [anon_sym_continue] = ACTIONS(846),
    [anon_sym_return] = ACTIONS(846),
    [anon_sym_synchronized] = ACTIONS(846),
    [anon_sym_throw] = ACTIONS(846),
    [anon_sym_try] = ACTIONS(846),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_else] = ACTIONS(846),
    [anon_sym_for] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(846),
    [anon_sym_open] = ACTIONS(846),
    [anon_sym_module] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(846),
    [anon_sym_package] = ACTIONS(846),
    [anon_sym_import] = ACTIONS(846),
    [anon_sym_enum] = ACTIONS(846),
    [anon_sym_public] = ACTIONS(846),
    [anon_sym_protected] = ACTIONS(846),
    [anon_sym_private] = ACTIONS(846),
    [anon_sym_abstract] = ACTIONS(846),
    [anon_sym_final] = ACTIONS(846),
    [anon_sym_strictfp] = ACTIONS(846),
    [anon_sym_native] = ACTIONS(846),
    [anon_sym_transient] = ACTIONS(846),
    [anon_sym_volatile] = ACTIONS(846),
    [anon_sym_ATinterface] = ACTIONS(844),
    [anon_sym_interface] = ACTIONS(846),
    [anon_sym_byte] = ACTIONS(846),
    [anon_sym_short] = ACTIONS(846),
    [anon_sym_int] = ACTIONS(846),
    [anon_sym_long] = ACTIONS(846),
    [anon_sym_char] = ACTIONS(846),
    [anon_sym_float] = ACTIONS(846),
    [anon_sym_double] = ACTIONS(846),
    [sym_boolean_type] = ACTIONS(846),
    [sym_void_type] = ACTIONS(846),
    [sym_this] = ACTIONS(846),
    [sym_super] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(426),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(850),
    [sym_identifier] = ACTIONS(852),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(852),
    [sym_octal_integer_literal] = ACTIONS(850),
    [sym_binary_integer_literal] = ACTIONS(850),
    [sym_decimal_floating_point_literal] = ACTIONS(850),
    [sym_hex_floating_point_literal] = ACTIONS(852),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_character_literal] = ACTIONS(850),
    [sym_string_literal] = ACTIONS(850),
    [sym_null_literal] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_BANG] = ACTIONS(850),
    [anon_sym_TILDE] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_new] = ACTIONS(852),
    [anon_sym_class] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_RBRACE] = ACTIONS(850),
    [anon_sym_assert] = ACTIONS(852),
    [anon_sym_switch] = ACTIONS(852),
    [anon_sym_case] = ACTIONS(852),
    [anon_sym_default] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(852),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_break] = ACTIONS(852),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(852),
    [anon_sym_synchronized] = ACTIONS(852),
    [anon_sym_throw] = ACTIONS(852),
    [anon_sym_try] = ACTIONS(852),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(852),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(852),
    [anon_sym_open] = ACTIONS(852),
    [anon_sym_module] = ACTIONS(852),
    [anon_sym_static] = ACTIONS(852),
    [anon_sym_package] = ACTIONS(852),
    [anon_sym_import] = ACTIONS(852),
    [anon_sym_enum] = ACTIONS(852),
    [anon_sym_public] = ACTIONS(852),
    [anon_sym_protected] = ACTIONS(852),
    [anon_sym_private] = ACTIONS(852),
    [anon_sym_abstract] = ACTIONS(852),
    [anon_sym_final] = ACTIONS(852),
    [anon_sym_strictfp] = ACTIONS(852),
    [anon_sym_native] = ACTIONS(852),
    [anon_sym_transient] = ACTIONS(852),
    [anon_sym_volatile] = ACTIONS(852),
    [anon_sym_ATinterface] = ACTIONS(850),
    [anon_sym_interface] = ACTIONS(852),
    [anon_sym_byte] = ACTIONS(852),
    [anon_sym_short] = ACTIONS(852),
    [anon_sym_int] = ACTIONS(852),
    [anon_sym_long] = ACTIONS(852),
    [anon_sym_char] = ACTIONS(852),
    [anon_sym_float] = ACTIONS(852),
    [anon_sym_double] = ACTIONS(852),
    [sym_boolean_type] = ACTIONS(852),
    [sym_void_type] = ACTIONS(852),
    [sym_this] = ACTIONS(852),
    [sym_super] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(854),
    [sym_identifier] = ACTIONS(856),
    [sym_decimal_integer_literal] = ACTIONS(856),
    [sym_hex_integer_literal] = ACTIONS(856),
    [sym_octal_integer_literal] = ACTIONS(854),
    [sym_binary_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(854),
    [sym_hex_floating_point_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(856),
    [sym_false] = ACTIONS(856),
    [sym_character_literal] = ACTIONS(854),
    [sym_string_literal] = ACTIONS(854),
    [sym_null_literal] = ACTIONS(856),
    [anon_sym_LPAREN] = ACTIONS(854),
    [anon_sym_PLUS] = ACTIONS(856),
    [anon_sym_DASH] = ACTIONS(856),
    [anon_sym_BANG] = ACTIONS(854),
    [anon_sym_TILDE] = ACTIONS(854),
    [anon_sym_PLUS_PLUS] = ACTIONS(854),
    [anon_sym_DASH_DASH] = ACTIONS(854),
    [anon_sym_new] = ACTIONS(856),
    [anon_sym_class] = ACTIONS(856),
    [anon_sym_SEMI] = ACTIONS(854),
    [anon_sym_LBRACE] = ACTIONS(854),
    [anon_sym_RBRACE] = ACTIONS(854),
    [anon_sym_assert] = ACTIONS(856),
    [anon_sym_switch] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(856),
    [anon_sym_default] = ACTIONS(856),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_while] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(856),
    [anon_sym_continue] = ACTIONS(856),
    [anon_sym_return] = ACTIONS(856),
    [anon_sym_synchronized] = ACTIONS(856),
    [anon_sym_throw] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_else] = ACTIONS(856),
    [anon_sym_for] = ACTIONS(856),
    [anon_sym_AT] = ACTIONS(856),
    [anon_sym_open] = ACTIONS(856),
    [anon_sym_module] = ACTIONS(856),
    [anon_sym_static] = ACTIONS(856),
    [anon_sym_package] = ACTIONS(856),
    [anon_sym_import] = ACTIONS(856),
    [anon_sym_enum] = ACTIONS(856),
    [anon_sym_public] = ACTIONS(856),
    [anon_sym_protected] = ACTIONS(856),
    [anon_sym_private] = ACTIONS(856),
    [anon_sym_abstract] = ACTIONS(856),
    [anon_sym_final] = ACTIONS(856),
    [anon_sym_strictfp] = ACTIONS(856),
    [anon_sym_native] = ACTIONS(856),
    [anon_sym_transient] = ACTIONS(856),
    [anon_sym_volatile] = ACTIONS(856),
    [anon_sym_ATinterface] = ACTIONS(854),
    [anon_sym_interface] = ACTIONS(856),
    [anon_sym_byte] = ACTIONS(856),
    [anon_sym_short] = ACTIONS(856),
    [anon_sym_int] = ACTIONS(856),
    [anon_sym_long] = ACTIONS(856),
    [anon_sym_char] = ACTIONS(856),
    [anon_sym_float] = ACTIONS(856),
    [anon_sym_double] = ACTIONS(856),
    [sym_boolean_type] = ACTIONS(856),
    [sym_void_type] = ACTIONS(856),
    [sym_this] = ACTIONS(856),
    [sym_super] = ACTIONS(856),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(453),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(858),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(430),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(421),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(862),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(864),
    [sym_identifier] = ACTIONS(866),
    [sym_decimal_integer_literal] = ACTIONS(866),
    [sym_hex_integer_literal] = ACTIONS(866),
    [sym_octal_integer_literal] = ACTIONS(864),
    [sym_binary_integer_literal] = ACTIONS(864),
    [sym_decimal_floating_point_literal] = ACTIONS(864),
    [sym_hex_floating_point_literal] = ACTIONS(866),
    [sym_true] = ACTIONS(866),
    [sym_false] = ACTIONS(866),
    [sym_character_literal] = ACTIONS(864),
    [sym_string_literal] = ACTIONS(864),
    [sym_null_literal] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(864),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(864),
    [anon_sym_TILDE] = ACTIONS(864),
    [anon_sym_PLUS_PLUS] = ACTIONS(864),
    [anon_sym_DASH_DASH] = ACTIONS(864),
    [anon_sym_new] = ACTIONS(866),
    [anon_sym_class] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(864),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_RBRACE] = ACTIONS(864),
    [anon_sym_assert] = ACTIONS(866),
    [anon_sym_switch] = ACTIONS(866),
    [anon_sym_case] = ACTIONS(866),
    [anon_sym_default] = ACTIONS(866),
    [anon_sym_do] = ACTIONS(866),
    [anon_sym_while] = ACTIONS(866),
    [anon_sym_break] = ACTIONS(866),
    [anon_sym_continue] = ACTIONS(866),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_synchronized] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_try] = ACTIONS(866),
    [anon_sym_if] = ACTIONS(866),
    [anon_sym_else] = ACTIONS(866),
    [anon_sym_for] = ACTIONS(866),
    [anon_sym_AT] = ACTIONS(866),
    [anon_sym_open] = ACTIONS(866),
    [anon_sym_module] = ACTIONS(866),
    [anon_sym_static] = ACTIONS(866),
    [anon_sym_package] = ACTIONS(866),
    [anon_sym_import] = ACTIONS(866),
    [anon_sym_enum] = ACTIONS(866),
    [anon_sym_public] = ACTIONS(866),
    [anon_sym_protected] = ACTIONS(866),
    [anon_sym_private] = ACTIONS(866),
    [anon_sym_abstract] = ACTIONS(866),
    [anon_sym_final] = ACTIONS(866),
    [anon_sym_strictfp] = ACTIONS(866),
    [anon_sym_native] = ACTIONS(866),
    [anon_sym_transient] = ACTIONS(866),
    [anon_sym_volatile] = ACTIONS(866),
    [anon_sym_ATinterface] = ACTIONS(864),
    [anon_sym_interface] = ACTIONS(866),
    [anon_sym_byte] = ACTIONS(866),
    [anon_sym_short] = ACTIONS(866),
    [anon_sym_int] = ACTIONS(866),
    [anon_sym_long] = ACTIONS(866),
    [anon_sym_char] = ACTIONS(866),
    [anon_sym_float] = ACTIONS(866),
    [anon_sym_double] = ACTIONS(866),
    [sym_boolean_type] = ACTIONS(866),
    [sym_void_type] = ACTIONS(866),
    [sym_this] = ACTIONS(866),
    [sym_super] = ACTIONS(866),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(868),
    [sym_identifier] = ACTIONS(870),
    [sym_decimal_integer_literal] = ACTIONS(870),
    [sym_hex_integer_literal] = ACTIONS(870),
    [sym_octal_integer_literal] = ACTIONS(868),
    [sym_binary_integer_literal] = ACTIONS(868),
    [sym_decimal_floating_point_literal] = ACTIONS(868),
    [sym_hex_floating_point_literal] = ACTIONS(870),
    [sym_true] = ACTIONS(870),
    [sym_false] = ACTIONS(870),
    [sym_character_literal] = ACTIONS(868),
    [sym_string_literal] = ACTIONS(868),
    [sym_null_literal] = ACTIONS(870),
    [anon_sym_LPAREN] = ACTIONS(868),
    [anon_sym_PLUS] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(870),
    [anon_sym_BANG] = ACTIONS(868),
    [anon_sym_TILDE] = ACTIONS(868),
    [anon_sym_PLUS_PLUS] = ACTIONS(868),
    [anon_sym_DASH_DASH] = ACTIONS(868),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_LBRACE] = ACTIONS(868),
    [anon_sym_RBRACE] = ACTIONS(868),
    [anon_sym_assert] = ACTIONS(870),
    [anon_sym_switch] = ACTIONS(870),
    [anon_sym_case] = ACTIONS(870),
    [anon_sym_default] = ACTIONS(870),
    [anon_sym_do] = ACTIONS(870),
    [anon_sym_while] = ACTIONS(870),
    [anon_sym_break] = ACTIONS(870),
    [anon_sym_continue] = ACTIONS(870),
    [anon_sym_return] = ACTIONS(870),
    [anon_sym_synchronized] = ACTIONS(870),
    [anon_sym_throw] = ACTIONS(870),
    [anon_sym_try] = ACTIONS(870),
    [anon_sym_if] = ACTIONS(870),
    [anon_sym_else] = ACTIONS(870),
    [anon_sym_for] = ACTIONS(870),
    [anon_sym_AT] = ACTIONS(870),
    [anon_sym_open] = ACTIONS(870),
    [anon_sym_module] = ACTIONS(870),
    [anon_sym_static] = ACTIONS(870),
    [anon_sym_package] = ACTIONS(870),
    [anon_sym_import] = ACTIONS(870),
    [anon_sym_enum] = ACTIONS(870),
    [anon_sym_public] = ACTIONS(870),
    [anon_sym_protected] = ACTIONS(870),
    [anon_sym_private] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_final] = ACTIONS(870),
    [anon_sym_strictfp] = ACTIONS(870),
    [anon_sym_native] = ACTIONS(870),
    [anon_sym_transient] = ACTIONS(870),
    [anon_sym_volatile] = ACTIONS(870),
    [anon_sym_ATinterface] = ACTIONS(868),
    [anon_sym_interface] = ACTIONS(870),
    [anon_sym_byte] = ACTIONS(870),
    [anon_sym_short] = ACTIONS(870),
    [anon_sym_int] = ACTIONS(870),
    [anon_sym_long] = ACTIONS(870),
    [anon_sym_char] = ACTIONS(870),
    [anon_sym_float] = ACTIONS(870),
    [anon_sym_double] = ACTIONS(870),
    [sym_boolean_type] = ACTIONS(870),
    [sym_void_type] = ACTIONS(870),
    [sym_this] = ACTIONS(870),
    [sym_super] = ACTIONS(870),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(872),
    [sym_identifier] = ACTIONS(874),
    [sym_decimal_integer_literal] = ACTIONS(874),
    [sym_hex_integer_literal] = ACTIONS(874),
    [sym_octal_integer_literal] = ACTIONS(872),
    [sym_binary_integer_literal] = ACTIONS(872),
    [sym_decimal_floating_point_literal] = ACTIONS(872),
    [sym_hex_floating_point_literal] = ACTIONS(874),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_character_literal] = ACTIONS(872),
    [sym_string_literal] = ACTIONS(872),
    [sym_null_literal] = ACTIONS(874),
    [anon_sym_LPAREN] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(874),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_PLUS_PLUS] = ACTIONS(872),
    [anon_sym_DASH_DASH] = ACTIONS(872),
    [anon_sym_new] = ACTIONS(874),
    [anon_sym_class] = ACTIONS(874),
    [anon_sym_SEMI] = ACTIONS(872),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_RBRACE] = ACTIONS(872),
    [anon_sym_assert] = ACTIONS(874),
    [anon_sym_switch] = ACTIONS(874),
    [anon_sym_case] = ACTIONS(874),
    [anon_sym_default] = ACTIONS(874),
    [anon_sym_do] = ACTIONS(874),
    [anon_sym_while] = ACTIONS(874),
    [anon_sym_break] = ACTIONS(874),
    [anon_sym_continue] = ACTIONS(874),
    [anon_sym_return] = ACTIONS(874),
    [anon_sym_synchronized] = ACTIONS(874),
    [anon_sym_throw] = ACTIONS(874),
    [anon_sym_try] = ACTIONS(874),
    [anon_sym_if] = ACTIONS(874),
    [anon_sym_else] = ACTIONS(874),
    [anon_sym_for] = ACTIONS(874),
    [anon_sym_AT] = ACTIONS(874),
    [anon_sym_open] = ACTIONS(874),
    [anon_sym_module] = ACTIONS(874),
    [anon_sym_static] = ACTIONS(874),
    [anon_sym_package] = ACTIONS(874),
    [anon_sym_import] = ACTIONS(874),
    [anon_sym_enum] = ACTIONS(874),
    [anon_sym_public] = ACTIONS(874),
    [anon_sym_protected] = ACTIONS(874),
    [anon_sym_private] = ACTIONS(874),
    [anon_sym_abstract] = ACTIONS(874),
    [anon_sym_final] = ACTIONS(874),
    [anon_sym_strictfp] = ACTIONS(874),
    [anon_sym_native] = ACTIONS(874),
    [anon_sym_transient] = ACTIONS(874),
    [anon_sym_volatile] = ACTIONS(874),
    [anon_sym_ATinterface] = ACTIONS(872),
    [anon_sym_interface] = ACTIONS(874),
    [anon_sym_byte] = ACTIONS(874),
    [anon_sym_short] = ACTIONS(874),
    [anon_sym_int] = ACTIONS(874),
    [anon_sym_long] = ACTIONS(874),
    [anon_sym_char] = ACTIONS(874),
    [anon_sym_float] = ACTIONS(874),
    [anon_sym_double] = ACTIONS(874),
    [sym_boolean_type] = ACTIONS(874),
    [sym_void_type] = ACTIONS(874),
    [sym_this] = ACTIONS(874),
    [sym_super] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(876),
    [sym_identifier] = ACTIONS(878),
    [sym_decimal_integer_literal] = ACTIONS(878),
    [sym_hex_integer_literal] = ACTIONS(878),
    [sym_octal_integer_literal] = ACTIONS(876),
    [sym_binary_integer_literal] = ACTIONS(876),
    [sym_decimal_floating_point_literal] = ACTIONS(876),
    [sym_hex_floating_point_literal] = ACTIONS(878),
    [sym_true] = ACTIONS(878),
    [sym_false] = ACTIONS(878),
    [sym_character_literal] = ACTIONS(876),
    [sym_string_literal] = ACTIONS(876),
    [sym_null_literal] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(876),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_BANG] = ACTIONS(876),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_PLUS_PLUS] = ACTIONS(876),
    [anon_sym_DASH_DASH] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_class] = ACTIONS(878),
    [anon_sym_SEMI] = ACTIONS(876),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(876),
    [anon_sym_assert] = ACTIONS(878),
    [anon_sym_switch] = ACTIONS(878),
    [anon_sym_case] = ACTIONS(878),
    [anon_sym_default] = ACTIONS(878),
    [anon_sym_do] = ACTIONS(878),
    [anon_sym_while] = ACTIONS(878),
    [anon_sym_break] = ACTIONS(878),
    [anon_sym_continue] = ACTIONS(878),
    [anon_sym_return] = ACTIONS(878),
    [anon_sym_synchronized] = ACTIONS(878),
    [anon_sym_throw] = ACTIONS(878),
    [anon_sym_try] = ACTIONS(878),
    [anon_sym_if] = ACTIONS(878),
    [anon_sym_else] = ACTIONS(878),
    [anon_sym_for] = ACTIONS(878),
    [anon_sym_AT] = ACTIONS(878),
    [anon_sym_open] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(878),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_package] = ACTIONS(878),
    [anon_sym_import] = ACTIONS(878),
    [anon_sym_enum] = ACTIONS(878),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(878),
    [anon_sym_final] = ACTIONS(878),
    [anon_sym_strictfp] = ACTIONS(878),
    [anon_sym_native] = ACTIONS(878),
    [anon_sym_transient] = ACTIONS(878),
    [anon_sym_volatile] = ACTIONS(878),
    [anon_sym_ATinterface] = ACTIONS(876),
    [anon_sym_interface] = ACTIONS(878),
    [anon_sym_byte] = ACTIONS(878),
    [anon_sym_short] = ACTIONS(878),
    [anon_sym_int] = ACTIONS(878),
    [anon_sym_long] = ACTIONS(878),
    [anon_sym_char] = ACTIONS(878),
    [anon_sym_float] = ACTIONS(878),
    [anon_sym_double] = ACTIONS(878),
    [sym_boolean_type] = ACTIONS(878),
    [sym_void_type] = ACTIONS(878),
    [sym_this] = ACTIONS(878),
    [sym_super] = ACTIONS(878),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(880),
    [sym_identifier] = ACTIONS(882),
    [sym_decimal_integer_literal] = ACTIONS(882),
    [sym_hex_integer_literal] = ACTIONS(882),
    [sym_octal_integer_literal] = ACTIONS(880),
    [sym_binary_integer_literal] = ACTIONS(880),
    [sym_decimal_floating_point_literal] = ACTIONS(880),
    [sym_hex_floating_point_literal] = ACTIONS(882),
    [sym_true] = ACTIONS(882),
    [sym_false] = ACTIONS(882),
    [sym_character_literal] = ACTIONS(880),
    [sym_string_literal] = ACTIONS(880),
    [sym_null_literal] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(882),
    [anon_sym_DASH] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(880),
    [anon_sym_TILDE] = ACTIONS(880),
    [anon_sym_PLUS_PLUS] = ACTIONS(880),
    [anon_sym_DASH_DASH] = ACTIONS(880),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_class] = ACTIONS(882),
    [anon_sym_SEMI] = ACTIONS(880),
    [anon_sym_LBRACE] = ACTIONS(880),
    [anon_sym_RBRACE] = ACTIONS(880),
    [anon_sym_assert] = ACTIONS(882),
    [anon_sym_switch] = ACTIONS(882),
    [anon_sym_case] = ACTIONS(882),
    [anon_sym_default] = ACTIONS(882),
    [anon_sym_do] = ACTIONS(882),
    [anon_sym_while] = ACTIONS(882),
    [anon_sym_break] = ACTIONS(882),
    [anon_sym_continue] = ACTIONS(882),
    [anon_sym_return] = ACTIONS(882),
    [anon_sym_synchronized] = ACTIONS(882),
    [anon_sym_throw] = ACTIONS(882),
    [anon_sym_try] = ACTIONS(882),
    [anon_sym_if] = ACTIONS(882),
    [anon_sym_else] = ACTIONS(882),
    [anon_sym_for] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(882),
    [anon_sym_open] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_package] = ACTIONS(882),
    [anon_sym_import] = ACTIONS(882),
    [anon_sym_enum] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_abstract] = ACTIONS(882),
    [anon_sym_final] = ACTIONS(882),
    [anon_sym_strictfp] = ACTIONS(882),
    [anon_sym_native] = ACTIONS(882),
    [anon_sym_transient] = ACTIONS(882),
    [anon_sym_volatile] = ACTIONS(882),
    [anon_sym_ATinterface] = ACTIONS(880),
    [anon_sym_interface] = ACTIONS(882),
    [anon_sym_byte] = ACTIONS(882),
    [anon_sym_short] = ACTIONS(882),
    [anon_sym_int] = ACTIONS(882),
    [anon_sym_long] = ACTIONS(882),
    [anon_sym_char] = ACTIONS(882),
    [anon_sym_float] = ACTIONS(882),
    [anon_sym_double] = ACTIONS(882),
    [sym_boolean_type] = ACTIONS(882),
    [sym_void_type] = ACTIONS(882),
    [sym_this] = ACTIONS(882),
    [sym_super] = ACTIONS(882),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(884),
    [sym_identifier] = ACTIONS(886),
    [sym_decimal_integer_literal] = ACTIONS(886),
    [sym_hex_integer_literal] = ACTIONS(886),
    [sym_octal_integer_literal] = ACTIONS(884),
    [sym_binary_integer_literal] = ACTIONS(884),
    [sym_decimal_floating_point_literal] = ACTIONS(884),
    [sym_hex_floating_point_literal] = ACTIONS(886),
    [sym_true] = ACTIONS(886),
    [sym_false] = ACTIONS(886),
    [sym_character_literal] = ACTIONS(884),
    [sym_string_literal] = ACTIONS(884),
    [sym_null_literal] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(884),
    [anon_sym_PLUS_PLUS] = ACTIONS(884),
    [anon_sym_DASH_DASH] = ACTIONS(884),
    [anon_sym_new] = ACTIONS(886),
    [anon_sym_class] = ACTIONS(886),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym_LBRACE] = ACTIONS(884),
    [anon_sym_RBRACE] = ACTIONS(884),
    [anon_sym_assert] = ACTIONS(886),
    [anon_sym_switch] = ACTIONS(886),
    [anon_sym_case] = ACTIONS(886),
    [anon_sym_default] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(886),
    [anon_sym_while] = ACTIONS(886),
    [anon_sym_break] = ACTIONS(886),
    [anon_sym_continue] = ACTIONS(886),
    [anon_sym_return] = ACTIONS(886),
    [anon_sym_synchronized] = ACTIONS(886),
    [anon_sym_throw] = ACTIONS(886),
    [anon_sym_try] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_else] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_open] = ACTIONS(886),
    [anon_sym_module] = ACTIONS(886),
    [anon_sym_static] = ACTIONS(886),
    [anon_sym_package] = ACTIONS(886),
    [anon_sym_import] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(886),
    [anon_sym_public] = ACTIONS(886),
    [anon_sym_protected] = ACTIONS(886),
    [anon_sym_private] = ACTIONS(886),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_final] = ACTIONS(886),
    [anon_sym_strictfp] = ACTIONS(886),
    [anon_sym_native] = ACTIONS(886),
    [anon_sym_transient] = ACTIONS(886),
    [anon_sym_volatile] = ACTIONS(886),
    [anon_sym_ATinterface] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_byte] = ACTIONS(886),
    [anon_sym_short] = ACTIONS(886),
    [anon_sym_int] = ACTIONS(886),
    [anon_sym_long] = ACTIONS(886),
    [anon_sym_char] = ACTIONS(886),
    [anon_sym_float] = ACTIONS(886),
    [anon_sym_double] = ACTIONS(886),
    [sym_boolean_type] = ACTIONS(886),
    [sym_void_type] = ACTIONS(886),
    [sym_this] = ACTIONS(886),
    [sym_super] = ACTIONS(886),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(888),
    [sym_identifier] = ACTIONS(890),
    [sym_decimal_integer_literal] = ACTIONS(890),
    [sym_hex_integer_literal] = ACTIONS(890),
    [sym_octal_integer_literal] = ACTIONS(888),
    [sym_binary_integer_literal] = ACTIONS(888),
    [sym_decimal_floating_point_literal] = ACTIONS(888),
    [sym_hex_floating_point_literal] = ACTIONS(890),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_character_literal] = ACTIONS(888),
    [sym_string_literal] = ACTIONS(888),
    [sym_null_literal] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(888),
    [anon_sym_PLUS_PLUS] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(888),
    [anon_sym_new] = ACTIONS(890),
    [anon_sym_class] = ACTIONS(890),
    [anon_sym_SEMI] = ACTIONS(888),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_RBRACE] = ACTIONS(888),
    [anon_sym_assert] = ACTIONS(890),
    [anon_sym_switch] = ACTIONS(890),
    [anon_sym_case] = ACTIONS(890),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_do] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_synchronized] = ACTIONS(890),
    [anon_sym_throw] = ACTIONS(890),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(890),
    [anon_sym_open] = ACTIONS(890),
    [anon_sym_module] = ACTIONS(890),
    [anon_sym_static] = ACTIONS(890),
    [anon_sym_package] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_public] = ACTIONS(890),
    [anon_sym_protected] = ACTIONS(890),
    [anon_sym_private] = ACTIONS(890),
    [anon_sym_abstract] = ACTIONS(890),
    [anon_sym_final] = ACTIONS(890),
    [anon_sym_strictfp] = ACTIONS(890),
    [anon_sym_native] = ACTIONS(890),
    [anon_sym_transient] = ACTIONS(890),
    [anon_sym_volatile] = ACTIONS(890),
    [anon_sym_ATinterface] = ACTIONS(888),
    [anon_sym_interface] = ACTIONS(890),
    [anon_sym_byte] = ACTIONS(890),
    [anon_sym_short] = ACTIONS(890),
    [anon_sym_int] = ACTIONS(890),
    [anon_sym_long] = ACTIONS(890),
    [anon_sym_char] = ACTIONS(890),
    [anon_sym_float] = ACTIONS(890),
    [anon_sym_double] = ACTIONS(890),
    [sym_boolean_type] = ACTIONS(890),
    [sym_void_type] = ACTIONS(890),
    [sym_this] = ACTIONS(890),
    [sym_super] = ACTIONS(890),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(892),
    [sym_identifier] = ACTIONS(894),
    [sym_decimal_integer_literal] = ACTIONS(894),
    [sym_hex_integer_literal] = ACTIONS(894),
    [sym_octal_integer_literal] = ACTIONS(892),
    [sym_binary_integer_literal] = ACTIONS(892),
    [sym_decimal_floating_point_literal] = ACTIONS(892),
    [sym_hex_floating_point_literal] = ACTIONS(894),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_character_literal] = ACTIONS(892),
    [sym_string_literal] = ACTIONS(892),
    [sym_null_literal] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_new] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_RBRACE] = ACTIONS(892),
    [anon_sym_assert] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_default] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_synchronized] = ACTIONS(894),
    [anon_sym_throw] = ACTIONS(894),
    [anon_sym_try] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(894),
    [anon_sym_open] = ACTIONS(894),
    [anon_sym_module] = ACTIONS(894),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_package] = ACTIONS(894),
    [anon_sym_import] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_public] = ACTIONS(894),
    [anon_sym_protected] = ACTIONS(894),
    [anon_sym_private] = ACTIONS(894),
    [anon_sym_abstract] = ACTIONS(894),
    [anon_sym_final] = ACTIONS(894),
    [anon_sym_strictfp] = ACTIONS(894),
    [anon_sym_native] = ACTIONS(894),
    [anon_sym_transient] = ACTIONS(894),
    [anon_sym_volatile] = ACTIONS(894),
    [anon_sym_ATinterface] = ACTIONS(892),
    [anon_sym_interface] = ACTIONS(894),
    [anon_sym_byte] = ACTIONS(894),
    [anon_sym_short] = ACTIONS(894),
    [anon_sym_int] = ACTIONS(894),
    [anon_sym_long] = ACTIONS(894),
    [anon_sym_char] = ACTIONS(894),
    [anon_sym_float] = ACTIONS(894),
    [anon_sym_double] = ACTIONS(894),
    [sym_boolean_type] = ACTIONS(894),
    [sym_void_type] = ACTIONS(894),
    [sym_this] = ACTIONS(894),
    [sym_super] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(896),
    [sym_identifier] = ACTIONS(898),
    [sym_decimal_integer_literal] = ACTIONS(898),
    [sym_hex_integer_literal] = ACTIONS(898),
    [sym_octal_integer_literal] = ACTIONS(896),
    [sym_binary_integer_literal] = ACTIONS(896),
    [sym_decimal_floating_point_literal] = ACTIONS(896),
    [sym_hex_floating_point_literal] = ACTIONS(898),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_character_literal] = ACTIONS(896),
    [sym_string_literal] = ACTIONS(896),
    [sym_null_literal] = ACTIONS(898),
    [anon_sym_LPAREN] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_PLUS_PLUS] = ACTIONS(896),
    [anon_sym_DASH_DASH] = ACTIONS(896),
    [anon_sym_new] = ACTIONS(898),
    [anon_sym_class] = ACTIONS(898),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(898),
    [anon_sym_case] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(898),
    [anon_sym_break] = ACTIONS(898),
    [anon_sym_continue] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_synchronized] = ACTIONS(898),
    [anon_sym_throw] = ACTIONS(898),
    [anon_sym_try] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(898),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_AT] = ACTIONS(898),
    [anon_sym_open] = ACTIONS(898),
    [anon_sym_module] = ACTIONS(898),
    [anon_sym_static] = ACTIONS(898),
    [anon_sym_package] = ACTIONS(898),
    [anon_sym_import] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_public] = ACTIONS(898),
    [anon_sym_protected] = ACTIONS(898),
    [anon_sym_private] = ACTIONS(898),
    [anon_sym_abstract] = ACTIONS(898),
    [anon_sym_final] = ACTIONS(898),
    [anon_sym_strictfp] = ACTIONS(898),
    [anon_sym_native] = ACTIONS(898),
    [anon_sym_transient] = ACTIONS(898),
    [anon_sym_volatile] = ACTIONS(898),
    [anon_sym_ATinterface] = ACTIONS(896),
    [anon_sym_interface] = ACTIONS(898),
    [anon_sym_byte] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [anon_sym_int] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_char] = ACTIONS(898),
    [anon_sym_float] = ACTIONS(898),
    [anon_sym_double] = ACTIONS(898),
    [sym_boolean_type] = ACTIONS(898),
    [sym_void_type] = ACTIONS(898),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(900),
    [sym_identifier] = ACTIONS(902),
    [sym_decimal_integer_literal] = ACTIONS(902),
    [sym_hex_integer_literal] = ACTIONS(902),
    [sym_octal_integer_literal] = ACTIONS(900),
    [sym_binary_integer_literal] = ACTIONS(900),
    [sym_decimal_floating_point_literal] = ACTIONS(900),
    [sym_hex_floating_point_literal] = ACTIONS(902),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_character_literal] = ACTIONS(900),
    [sym_string_literal] = ACTIONS(900),
    [sym_null_literal] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_BANG] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_new] = ACTIONS(902),
    [anon_sym_class] = ACTIONS(902),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_assert] = ACTIONS(902),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_synchronized] = ACTIONS(902),
    [anon_sym_throw] = ACTIONS(902),
    [anon_sym_try] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(902),
    [anon_sym_open] = ACTIONS(902),
    [anon_sym_module] = ACTIONS(902),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_package] = ACTIONS(902),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_public] = ACTIONS(902),
    [anon_sym_protected] = ACTIONS(902),
    [anon_sym_private] = ACTIONS(902),
    [anon_sym_abstract] = ACTIONS(902),
    [anon_sym_final] = ACTIONS(902),
    [anon_sym_strictfp] = ACTIONS(902),
    [anon_sym_native] = ACTIONS(902),
    [anon_sym_transient] = ACTIONS(902),
    [anon_sym_volatile] = ACTIONS(902),
    [anon_sym_ATinterface] = ACTIONS(900),
    [anon_sym_interface] = ACTIONS(902),
    [anon_sym_byte] = ACTIONS(902),
    [anon_sym_short] = ACTIONS(902),
    [anon_sym_int] = ACTIONS(902),
    [anon_sym_long] = ACTIONS(902),
    [anon_sym_char] = ACTIONS(902),
    [anon_sym_float] = ACTIONS(902),
    [anon_sym_double] = ACTIONS(902),
    [sym_boolean_type] = ACTIONS(902),
    [sym_void_type] = ACTIONS(902),
    [sym_this] = ACTIONS(902),
    [sym_super] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(904),
    [sym_identifier] = ACTIONS(906),
    [sym_decimal_integer_literal] = ACTIONS(906),
    [sym_hex_integer_literal] = ACTIONS(906),
    [sym_octal_integer_literal] = ACTIONS(904),
    [sym_binary_integer_literal] = ACTIONS(904),
    [sym_decimal_floating_point_literal] = ACTIONS(904),
    [sym_hex_floating_point_literal] = ACTIONS(906),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_character_literal] = ACTIONS(904),
    [sym_string_literal] = ACTIONS(904),
    [sym_null_literal] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_BANG] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_PLUS_PLUS] = ACTIONS(904),
    [anon_sym_DASH_DASH] = ACTIONS(904),
    [anon_sym_new] = ACTIONS(906),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(904),
    [anon_sym_assert] = ACTIONS(906),
    [anon_sym_switch] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_synchronized] = ACTIONS(906),
    [anon_sym_throw] = ACTIONS(906),
    [anon_sym_try] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_open] = ACTIONS(906),
    [anon_sym_module] = ACTIONS(906),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_package] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_public] = ACTIONS(906),
    [anon_sym_protected] = ACTIONS(906),
    [anon_sym_private] = ACTIONS(906),
    [anon_sym_abstract] = ACTIONS(906),
    [anon_sym_final] = ACTIONS(906),
    [anon_sym_strictfp] = ACTIONS(906),
    [anon_sym_native] = ACTIONS(906),
    [anon_sym_transient] = ACTIONS(906),
    [anon_sym_volatile] = ACTIONS(906),
    [anon_sym_ATinterface] = ACTIONS(904),
    [anon_sym_interface] = ACTIONS(906),
    [anon_sym_byte] = ACTIONS(906),
    [anon_sym_short] = ACTIONS(906),
    [anon_sym_int] = ACTIONS(906),
    [anon_sym_long] = ACTIONS(906),
    [anon_sym_char] = ACTIONS(906),
    [anon_sym_float] = ACTIONS(906),
    [anon_sym_double] = ACTIONS(906),
    [sym_boolean_type] = ACTIONS(906),
    [sym_void_type] = ACTIONS(906),
    [sym_this] = ACTIONS(906),
    [sym_super] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(908),
    [sym_identifier] = ACTIONS(910),
    [sym_decimal_integer_literal] = ACTIONS(910),
    [sym_hex_integer_literal] = ACTIONS(910),
    [sym_octal_integer_literal] = ACTIONS(908),
    [sym_binary_integer_literal] = ACTIONS(908),
    [sym_decimal_floating_point_literal] = ACTIONS(908),
    [sym_hex_floating_point_literal] = ACTIONS(910),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_character_literal] = ACTIONS(908),
    [sym_string_literal] = ACTIONS(908),
    [sym_null_literal] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_new] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(910),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_assert] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_synchronized] = ACTIONS(910),
    [anon_sym_throw] = ACTIONS(910),
    [anon_sym_try] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_open] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_package] = ACTIONS(910),
    [anon_sym_import] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_abstract] = ACTIONS(910),
    [anon_sym_final] = ACTIONS(910),
    [anon_sym_strictfp] = ACTIONS(910),
    [anon_sym_native] = ACTIONS(910),
    [anon_sym_transient] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_ATinterface] = ACTIONS(908),
    [anon_sym_interface] = ACTIONS(910),
    [anon_sym_byte] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [anon_sym_int] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_float] = ACTIONS(910),
    [anon_sym_double] = ACTIONS(910),
    [sym_boolean_type] = ACTIONS(910),
    [sym_void_type] = ACTIONS(910),
    [sym_this] = ACTIONS(910),
    [sym_super] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(389),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(446),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(437),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(402),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(397),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(458),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(379),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(380),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(400),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(442),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(396),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(438),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(395),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(394),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(450),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(384),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(386),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(455),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(436),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(459),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(439),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(444),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(445),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(382),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(432),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(461),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(460),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(434),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym__literal] = STATE(316),
    [sym_expression] = STATE(388),
    [sym_cast_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_instanceof_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_inferred_parameters] = STATE(884),
    [sym_ternary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_primary_expression] = STATE(311),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(269),
    [sym_array_access] = STATE(269),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym__annotation] = STATE(485),
    [sym_marker_annotation] = STATE(485),
    [sym_annotation] = STATE(485),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(564),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [sym_formal_parameters] = STATE(884),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_identifier] = ACTIONS(912),
    [sym_decimal_integer_literal] = ACTIONS(912),
    [sym_hex_integer_literal] = ACTIONS(912),
    [sym_octal_integer_literal] = ACTIONS(914),
    [sym_binary_integer_literal] = ACTIONS(914),
    [sym_decimal_floating_point_literal] = ACTIONS(914),
    [sym_hex_floating_point_literal] = ACTIONS(912),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [sym_character_literal] = ACTIONS(914),
    [sym_string_literal] = ACTIONS(914),
    [sym_null_literal] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(914),
    [anon_sym_new] = ACTIONS(912),
    [anon_sym_class] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(914),
    [anon_sym_RBRACE] = ACTIONS(914),
    [anon_sym_assert] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_case] = ACTIONS(912),
    [anon_sym_default] = ACTIONS(912),
    [anon_sym_do] = ACTIONS(912),
    [anon_sym_while] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(912),
    [anon_sym_continue] = ACTIONS(912),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_synchronized] = ACTIONS(912),
    [anon_sym_throw] = ACTIONS(912),
    [anon_sym_try] = ACTIONS(912),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(912),
    [anon_sym_open] = ACTIONS(912),
    [anon_sym_module] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(912),
    [anon_sym_package] = ACTIONS(912),
    [anon_sym_import] = ACTIONS(912),
    [anon_sym_enum] = ACTIONS(912),
    [anon_sym_public] = ACTIONS(912),
    [anon_sym_protected] = ACTIONS(912),
    [anon_sym_private] = ACTIONS(912),
    [anon_sym_abstract] = ACTIONS(912),
    [anon_sym_final] = ACTIONS(912),
    [anon_sym_strictfp] = ACTIONS(912),
    [anon_sym_native] = ACTIONS(912),
    [anon_sym_transient] = ACTIONS(912),
    [anon_sym_volatile] = ACTIONS(912),
    [anon_sym_ATinterface] = ACTIONS(914),
    [anon_sym_interface] = ACTIONS(912),
    [anon_sym_byte] = ACTIONS(912),
    [anon_sym_short] = ACTIONS(912),
    [anon_sym_int] = ACTIONS(912),
    [anon_sym_long] = ACTIONS(912),
    [anon_sym_char] = ACTIONS(912),
    [anon_sym_float] = ACTIONS(912),
    [anon_sym_double] = ACTIONS(912),
    [sym_boolean_type] = ACTIONS(912),
    [sym_void_type] = ACTIONS(912),
    [sym_this] = ACTIONS(912),
    [sym_super] = ACTIONS(912),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym__literal] = STATE(316),
    [sym_primary_expression] = STATE(793),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(640),
    [sym_array_access] = STATE(316),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_resource] = STATE(807),
    [sym__annotation] = STATE(468),
    [sym_marker_annotation] = STATE(468),
    [sym_annotation] = STATE(468),
    [sym_modifiers] = STATE(514),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(532),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [aux_sym_modifiers_repeat1] = STATE(404),
    [sym_identifier] = ACTIONS(916),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(920),
    [anon_sym_new] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_synchronized] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(924),
    [anon_sym_module] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(367),
    [anon_sym_public] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_abstract] = ACTIONS(367),
    [anon_sym_final] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_native] = ACTIONS(367),
    [anon_sym_transient] = ACTIONS(367),
    [anon_sym_volatile] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym__literal] = STATE(316),
    [sym_primary_expression] = STATE(793),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(640),
    [sym_array_access] = STATE(316),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_resource] = STATE(807),
    [sym__annotation] = STATE(468),
    [sym_marker_annotation] = STATE(468),
    [sym_annotation] = STATE(468),
    [sym_modifiers] = STATE(514),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(532),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [aux_sym_modifiers_repeat1] = STATE(404),
    [sym_identifier] = ACTIONS(916),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_new] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_synchronized] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(924),
    [anon_sym_module] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(367),
    [anon_sym_public] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_abstract] = ACTIONS(367),
    [anon_sym_final] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_native] = ACTIONS(367),
    [anon_sym_transient] = ACTIONS(367),
    [anon_sym_volatile] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_identifier] = ACTIONS(928),
    [sym_decimal_integer_literal] = ACTIONS(928),
    [sym_hex_integer_literal] = ACTIONS(928),
    [sym_octal_integer_literal] = ACTIONS(930),
    [sym_binary_integer_literal] = ACTIONS(930),
    [sym_decimal_floating_point_literal] = ACTIONS(930),
    [sym_hex_floating_point_literal] = ACTIONS(928),
    [sym_true] = ACTIONS(928),
    [sym_false] = ACTIONS(928),
    [sym_character_literal] = ACTIONS(930),
    [sym_string_literal] = ACTIONS(930),
    [sym_null_literal] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(930),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_PLUS_PLUS] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(930),
    [anon_sym_new] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(930),
    [anon_sym_RBRACE] = ACTIONS(930),
    [anon_sym_assert] = ACTIONS(928),
    [anon_sym_switch] = ACTIONS(928),
    [anon_sym_case] = ACTIONS(928),
    [anon_sym_default] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_synchronized] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(928),
    [anon_sym_open] = ACTIONS(928),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_package] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_enum] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_abstract] = ACTIONS(928),
    [anon_sym_final] = ACTIONS(928),
    [anon_sym_strictfp] = ACTIONS(928),
    [anon_sym_native] = ACTIONS(928),
    [anon_sym_transient] = ACTIONS(928),
    [anon_sym_volatile] = ACTIONS(928),
    [anon_sym_ATinterface] = ACTIONS(930),
    [anon_sym_interface] = ACTIONS(928),
    [anon_sym_byte] = ACTIONS(928),
    [anon_sym_short] = ACTIONS(928),
    [anon_sym_int] = ACTIONS(928),
    [anon_sym_long] = ACTIONS(928),
    [anon_sym_char] = ACTIONS(928),
    [anon_sym_float] = ACTIONS(928),
    [anon_sym_double] = ACTIONS(928),
    [sym_boolean_type] = ACTIONS(928),
    [sym_void_type] = ACTIONS(928),
    [sym_this] = ACTIONS(928),
    [sym_super] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_identifier] = ACTIONS(932),
    [sym_decimal_integer_literal] = ACTIONS(932),
    [sym_hex_integer_literal] = ACTIONS(932),
    [sym_octal_integer_literal] = ACTIONS(934),
    [sym_binary_integer_literal] = ACTIONS(934),
    [sym_decimal_floating_point_literal] = ACTIONS(934),
    [sym_hex_floating_point_literal] = ACTIONS(932),
    [sym_true] = ACTIONS(932),
    [sym_false] = ACTIONS(932),
    [sym_character_literal] = ACTIONS(934),
    [sym_string_literal] = ACTIONS(934),
    [sym_null_literal] = ACTIONS(932),
    [anon_sym_LPAREN] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_BANG] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(934),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_new] = ACTIONS(932),
    [anon_sym_class] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(934),
    [anon_sym_RBRACE] = ACTIONS(934),
    [anon_sym_assert] = ACTIONS(932),
    [anon_sym_switch] = ACTIONS(932),
    [anon_sym_default] = ACTIONS(932),
    [anon_sym_do] = ACTIONS(932),
    [anon_sym_while] = ACTIONS(932),
    [anon_sym_break] = ACTIONS(932),
    [anon_sym_continue] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(932),
    [anon_sym_synchronized] = ACTIONS(932),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_try] = ACTIONS(932),
    [anon_sym_if] = ACTIONS(932),
    [anon_sym_for] = ACTIONS(932),
    [anon_sym_AT] = ACTIONS(932),
    [anon_sym_open] = ACTIONS(932),
    [anon_sym_module] = ACTIONS(932),
    [anon_sym_static] = ACTIONS(932),
    [anon_sym_package] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(932),
    [anon_sym_enum] = ACTIONS(932),
    [anon_sym_public] = ACTIONS(932),
    [anon_sym_protected] = ACTIONS(932),
    [anon_sym_private] = ACTIONS(932),
    [anon_sym_abstract] = ACTIONS(932),
    [anon_sym_final] = ACTIONS(932),
    [anon_sym_strictfp] = ACTIONS(932),
    [anon_sym_native] = ACTIONS(932),
    [anon_sym_transient] = ACTIONS(932),
    [anon_sym_volatile] = ACTIONS(932),
    [anon_sym_ATinterface] = ACTIONS(934),
    [anon_sym_interface] = ACTIONS(932),
    [anon_sym_byte] = ACTIONS(932),
    [anon_sym_short] = ACTIONS(932),
    [anon_sym_int] = ACTIONS(932),
    [anon_sym_long] = ACTIONS(932),
    [anon_sym_char] = ACTIONS(932),
    [anon_sym_float] = ACTIONS(932),
    [anon_sym_double] = ACTIONS(932),
    [sym_boolean_type] = ACTIONS(932),
    [sym_void_type] = ACTIONS(932),
    [sym_this] = ACTIONS(932),
    [sym_super] = ACTIONS(932),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_identifier] = ACTIONS(936),
    [sym_decimal_integer_literal] = ACTIONS(936),
    [sym_hex_integer_literal] = ACTIONS(936),
    [sym_octal_integer_literal] = ACTIONS(938),
    [sym_binary_integer_literal] = ACTIONS(938),
    [sym_decimal_floating_point_literal] = ACTIONS(938),
    [sym_hex_floating_point_literal] = ACTIONS(936),
    [sym_true] = ACTIONS(936),
    [sym_false] = ACTIONS(936),
    [sym_character_literal] = ACTIONS(938),
    [sym_string_literal] = ACTIONS(938),
    [sym_null_literal] = ACTIONS(936),
    [anon_sym_LPAREN] = ACTIONS(938),
    [anon_sym_PLUS] = ACTIONS(936),
    [anon_sym_DASH] = ACTIONS(936),
    [anon_sym_BANG] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_SEMI] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_RBRACE] = ACTIONS(938),
    [anon_sym_assert] = ACTIONS(936),
    [anon_sym_switch] = ACTIONS(936),
    [anon_sym_default] = ACTIONS(936),
    [anon_sym_do] = ACTIONS(936),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_synchronized] = ACTIONS(936),
    [anon_sym_throw] = ACTIONS(936),
    [anon_sym_try] = ACTIONS(936),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_AT] = ACTIONS(936),
    [anon_sym_open] = ACTIONS(936),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_package] = ACTIONS(936),
    [anon_sym_import] = ACTIONS(936),
    [anon_sym_enum] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_abstract] = ACTIONS(936),
    [anon_sym_final] = ACTIONS(936),
    [anon_sym_strictfp] = ACTIONS(936),
    [anon_sym_native] = ACTIONS(936),
    [anon_sym_transient] = ACTIONS(936),
    [anon_sym_volatile] = ACTIONS(936),
    [anon_sym_ATinterface] = ACTIONS(938),
    [anon_sym_interface] = ACTIONS(936),
    [anon_sym_byte] = ACTIONS(936),
    [anon_sym_short] = ACTIONS(936),
    [anon_sym_int] = ACTIONS(936),
    [anon_sym_long] = ACTIONS(936),
    [anon_sym_char] = ACTIONS(936),
    [anon_sym_float] = ACTIONS(936),
    [anon_sym_double] = ACTIONS(936),
    [sym_boolean_type] = ACTIONS(936),
    [sym_void_type] = ACTIONS(936),
    [sym_this] = ACTIONS(936),
    [sym_super] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym__literal] = STATE(316),
    [sym_primary_expression] = STATE(793),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(640),
    [sym_array_access] = STATE(316),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_resource] = STATE(807),
    [sym__annotation] = STATE(468),
    [sym_marker_annotation] = STATE(468),
    [sym_annotation] = STATE(468),
    [sym_modifiers] = STATE(514),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(532),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [aux_sym_modifiers_repeat1] = STATE(404),
    [sym_identifier] = ACTIONS(916),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_new] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_synchronized] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(924),
    [anon_sym_module] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(367),
    [anon_sym_public] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_abstract] = ACTIONS(367),
    [anon_sym_final] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_native] = ACTIONS(367),
    [anon_sym_transient] = ACTIONS(367),
    [anon_sym_volatile] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym__literal] = STATE(316),
    [sym_primary_expression] = STATE(793),
    [sym_array_creation_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_class_literal] = STATE(316),
    [sym_object_creation_expression] = STATE(316),
    [sym__unqualified_object_creation_expression] = STATE(310),
    [sym_field_access] = STATE(640),
    [sym_array_access] = STATE(316),
    [sym_method_invocation] = STATE(316),
    [sym_method_reference] = STATE(316),
    [sym_resource] = STATE(794),
    [sym__annotation] = STATE(468),
    [sym_marker_annotation] = STATE(468),
    [sym_annotation] = STATE(468),
    [sym_modifiers] = STATE(514),
    [sym__type] = STATE(917),
    [sym__unannotated_type] = STATE(532),
    [sym_annotated_type] = STATE(574),
    [sym_scoped_type_identifier] = STATE(536),
    [sym_generic_type] = STATE(560),
    [sym_array_type] = STATE(506),
    [sym_integral_type] = STATE(506),
    [sym_floating_point_type] = STATE(506),
    [aux_sym_dimensions_expr_repeat1] = STATE(485),
    [aux_sym_modifiers_repeat1] = STATE(404),
    [sym_identifier] = ACTIONS(916),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_new] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_synchronized] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(924),
    [anon_sym_module] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(367),
    [anon_sym_public] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_abstract] = ACTIONS(367),
    [anon_sym_final] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_native] = ACTIONS(367),
    [anon_sym_transient] = ACTIONS(367),
    [anon_sym_volatile] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(71),
    [anon_sym_short] = ACTIONS(71),
    [anon_sym_int] = ACTIONS(71),
    [anon_sym_long] = ACTIONS(71),
    [anon_sym_char] = ACTIONS(71),
    [anon_sym_float] = ACTIONS(73),
    [anon_sym_double] = ACTIONS(73),
    [sym_boolean_type] = ACTIONS(75),
    [sym_void_type] = ACTIONS(75),
    [sym_this] = ACTIONS(77),
    [sym_super] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_identifier] = ACTIONS(940),
    [sym_decimal_integer_literal] = ACTIONS(940),
    [sym_hex_integer_literal] = ACTIONS(940),
    [sym_octal_integer_literal] = ACTIONS(942),
    [sym_binary_integer_literal] = ACTIONS(942),
    [sym_decimal_floating_point_literal] = ACTIONS(942),
    [sym_hex_floating_point_literal] = ACTIONS(940),
    [sym_true] = ACTIONS(940),
    [sym_false] = ACTIONS(940),
    [sym_character_literal] = ACTIONS(942),
    [sym_string_literal] = ACTIONS(942),
    [sym_null_literal] = ACTIONS(940),
    [anon_sym_LPAREN] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(942),
    [anon_sym_DASH_DASH] = ACTIONS(942),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_class] = ACTIONS(940),
    [anon_sym_SEMI] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_RBRACE] = ACTIONS(942),
    [anon_sym_assert] = ACTIONS(940),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_default] = ACTIONS(940),
    [anon_sym_do] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_synchronized] = ACTIONS(940),
    [anon_sym_throw] = ACTIONS(940),
    [anon_sym_try] = ACTIONS(940),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_AT] = ACTIONS(940),
    [anon_sym_open] = ACTIONS(940),
    [anon_sym_module] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(940),
    [anon_sym_package] = ACTIONS(940),
    [anon_sym_import] = ACTIONS(940),
    [anon_sym_enum] = ACTIONS(940),
    [anon_sym_public] = ACTIONS(940),
    [anon_sym_protected] = ACTIONS(940),
    [anon_sym_private] = ACTIONS(940),
    [anon_sym_abstract] = ACTIONS(940),
    [anon_sym_final] = ACTIONS(940),
    [anon_sym_strictfp] = ACTIONS(940),
    [anon_sym_native] = ACTIONS(940),
    [anon_sym_transient] = ACTIONS(940),
    [anon_sym_volatile] = ACTIONS(940),
    [anon_sym_ATinterface] = ACTIONS(942),
    [anon_sym_interface] = ACTIONS(940),
    [anon_sym_byte] = ACTIONS(940),
    [anon_sym_short] = ACTIONS(940),
    [anon_sym_int] = ACTIONS(940),
    [anon_sym_long] = ACTIONS(940),
    [anon_sym_char] = ACTIONS(940),
    [anon_sym_float] = ACTIONS(940),
    [anon_sym_double] = ACTIONS(940),
    [sym_boolean_type] = ACTIONS(940),
    [sym_void_type] = ACTIONS(940),
    [sym_this] = ACTIONS(940),
    [sym_super] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_identifier] = ACTIONS(944),
    [sym_decimal_integer_literal] = ACTIONS(944),
    [sym_hex_integer_literal] = ACTIONS(944),
    [sym_octal_integer_literal] = ACTIONS(946),
    [sym_binary_integer_literal] = ACTIONS(946),
    [sym_decimal_floating_point_literal] = ACTIONS(946),
    [sym_hex_floating_point_literal] = ACTIONS(944),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_character_literal] = ACTIONS(946),
    [sym_string_literal] = ACTIONS(946),
    [sym_null_literal] = ACTIONS(944),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_PLUS] = ACTIONS(944),
    [anon_sym_DASH] = ACTIONS(944),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_new] = ACTIONS(944),
    [anon_sym_class] = ACTIONS(944),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_assert] = ACTIONS(944),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_do] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_synchronized] = ACTIONS(944),
    [anon_sym_throw] = ACTIONS(944),
    [anon_sym_try] = ACTIONS(944),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_AT] = ACTIONS(944),
    [anon_sym_open] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_package] = ACTIONS(944),
    [anon_sym_import] = ACTIONS(944),
    [anon_sym_enum] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(944),
    [anon_sym_final] = ACTIONS(944),
    [anon_sym_strictfp] = ACTIONS(944),
    [anon_sym_native] = ACTIONS(944),
    [anon_sym_transient] = ACTIONS(944),
    [anon_sym_volatile] = ACTIONS(944),
    [anon_sym_ATinterface] = ACTIONS(946),
    [anon_sym_interface] = ACTIONS(944),
    [anon_sym_byte] = ACTIONS(944),
    [anon_sym_short] = ACTIONS(944),
    [anon_sym_int] = ACTIONS(944),
    [anon_sym_long] = ACTIONS(944),
    [anon_sym_char] = ACTIONS(944),
    [anon_sym_float] = ACTIONS(944),
    [anon_sym_double] = ACTIONS(944),
    [sym_boolean_type] = ACTIONS(944),
    [sym_void_type] = ACTIONS(944),
    [sym_this] = ACTIONS(944),
    [sym_super] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(948), 1,
      sym_identifier,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(952), 1,
      anon_sym_SEMI,
    ACTIONS(954), 1,
      anon_sym_RBRACE,
    ACTIONS(956), 1,
      anon_sym_static,
    STATE(448), 1,
      sym_modifiers,
    STATE(480), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(524), 1,
      sym__unannotated_type,
    STATE(673), 1,
      sym__constructor_declarator,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(247), 10,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(33), 11,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [109] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(948), 1,
      sym_identifier,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(956), 1,
      anon_sym_static,
    ACTIONS(958), 1,
      anon_sym_SEMI,
    ACTIONS(960), 1,
      anon_sym_RBRACE,
    STATE(448), 1,
      sym_modifiers,
    STATE(480), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(524), 1,
      sym__unannotated_type,
    STATE(673), 1,
      sym__constructor_declarator,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(249), 10,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(33), 11,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [218] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 1,
      sym_identifier,
    ACTIONS(965), 1,
      anon_sym_LT,
    ACTIONS(968), 1,
      anon_sym_class,
    ACTIONS(971), 1,
      anon_sym_SEMI,
    ACTIONS(974), 1,
      anon_sym_LBRACE,
    ACTIONS(977), 1,
      anon_sym_RBRACE,
    ACTIONS(982), 1,
      anon_sym_AT,
    ACTIONS(985), 1,
      anon_sym_static,
    ACTIONS(988), 1,
      anon_sym_enum,
    ACTIONS(991), 1,
      anon_sym_ATinterface,
    ACTIONS(994), 1,
      anon_sym_interface,
    STATE(448), 1,
      sym_modifiers,
    STATE(480), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(524), 1,
      sym__unannotated_type,
    STATE(673), 1,
      sym__constructor_declarator,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(1000), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1003), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(997), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(247), 10,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(979), 11,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [327] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(948), 1,
      sym_identifier,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(956), 1,
      anon_sym_static,
    ACTIONS(1006), 1,
      anon_sym_SEMI,
    ACTIONS(1008), 1,
      anon_sym_RBRACE,
    STATE(448), 1,
      sym_modifiers,
    STATE(480), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(524), 1,
      sym__unannotated_type,
    STATE(673), 1,
      sym__constructor_declarator,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(245), 10,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(33), 11,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [436] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(948), 1,
      sym_identifier,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(952), 1,
      anon_sym_SEMI,
    ACTIONS(956), 1,
      anon_sym_static,
    ACTIONS(1010), 1,
      anon_sym_RBRACE,
    STATE(448), 1,
      sym_modifiers,
    STATE(480), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(524), 1,
      sym__unannotated_type,
    STATE(673), 1,
      sym__constructor_declarator,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(247), 10,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(33), 11,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [545] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1020), 1,
      anon_sym_EQ,
    ACTIONS(1024), 1,
      anon_sym_LT,
    ACTIONS(1027), 1,
      anon_sym_DASH_GT,
    ACTIONS(1032), 1,
      anon_sym_DOT,
    ACTIONS(1036), 1,
      anon_sym_AT,
    STATE(345), 1,
      sym_argument_list,
    STATE(499), 1,
      sym_type_arguments,
    ACTIONS(1029), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1012), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    ACTIONS(1022), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1016), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
    ACTIONS(1018), 14,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [627] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1020), 1,
      anon_sym_EQ,
    ACTIONS(1024), 1,
      anon_sym_LT,
    ACTIONS(1027), 1,
      anon_sym_DASH_GT,
    ACTIONS(1038), 1,
      anon_sym_AMP,
    ACTIONS(1041), 1,
      anon_sym_RPAREN,
    ACTIONS(1045), 1,
      anon_sym_COMMA,
    ACTIONS(1047), 1,
      anon_sym_DOT,
    STATE(345), 1,
      sym_argument_list,
    STATE(499), 1,
      sym_type_arguments,
    STATE(798), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(1029), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1036), 2,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1012), 4,
      anon_sym_open,
      anon_sym_module,
      sym_this,
      sym_identifier,
    ACTIONS(1018), 9,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1022), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1016), 12,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [716] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 1,
      sym_identifier,
    ACTIONS(1054), 1,
      anon_sym_LT,
    ACTIONS(1057), 1,
      anon_sym_class,
    ACTIONS(1060), 1,
      anon_sym_SEMI,
    ACTIONS(1063), 1,
      anon_sym_RBRACE,
    ACTIONS(1068), 1,
      anon_sym_AT,
    ACTIONS(1071), 1,
      anon_sym_enum,
    ACTIONS(1074), 1,
      anon_sym_ATinterface,
    ACTIONS(1077), 1,
      anon_sym_interface,
    STATE(470), 1,
      sym_modifiers,
    STATE(486), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(520), 1,
      sym__unannotated_type,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(1083), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1086), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1080), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(252), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(1065), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [814] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1091), 1,
      anon_sym_SEMI,
    ACTIONS(1093), 1,
      anon_sym_RBRACE,
    STATE(470), 1,
      sym_modifiers,
    STATE(486), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(520), 1,
      sym__unannotated_type,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(252), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(33), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [912] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1095), 1,
      anon_sym_SEMI,
    ACTIONS(1097), 1,
      anon_sym_RBRACE,
    STATE(470), 1,
      sym_modifiers,
    STATE(486), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(520), 1,
      sym__unannotated_type,
    STATE(765), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(253), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(33), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [1010] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1020), 1,
      anon_sym_EQ,
    ACTIONS(1024), 1,
      anon_sym_LT,
    ACTIONS(1027), 1,
      anon_sym_DASH_GT,
    ACTIONS(1032), 1,
      anon_sym_DOT,
    ACTIONS(1036), 1,
      anon_sym_AT,
    ACTIONS(1099), 1,
      anon_sym_COLON,
    STATE(345), 1,
      sym_argument_list,
    STATE(499), 1,
      sym_type_arguments,
    ACTIONS(1029), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1012), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    ACTIONS(1018), 10,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
    ACTIONS(1022), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1016), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1090] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    STATE(327), 1,
      sym_argument_list,
    ACTIONS(1107), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1101), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1103), 18,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(305), 1,
      sym_argument_list,
    ACTIONS(1109), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1111), 29,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(332), 1,
      sym_argument_list,
    ACTIONS(1113), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1115), 29,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(307), 1,
      sym_argument_list,
    ACTIONS(1117), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1119), 29,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(329), 1,
      sym_argument_list,
    ACTIONS(1121), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1123), 29,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1384] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    ACTIONS(1125), 1,
      sym_identifier,
    STATE(327), 1,
      sym_argument_list,
    STATE(767), 1,
      sym_scoped_identifier,
    ACTIONS(1127), 2,
      anon_sym_open,
      anon_sym_module,
    ACTIONS(1107), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1103), 13,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
    ACTIONS(1101), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1451] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      sym_identifier,
    ACTIONS(1132), 1,
      anon_sym_class,
    ACTIONS(1135), 1,
      anon_sym_RBRACE,
    ACTIONS(1140), 1,
      anon_sym_AT,
    ACTIONS(1143), 1,
      anon_sym_ATinterface,
    ACTIONS(1146), 1,
      anon_sym_interface,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(497), 1,
      sym_modifiers,
    STATE(505), 1,
      sym_generic_type,
    STATE(534), 1,
      sym__unannotated_type,
    ACTIONS(1152), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1155), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1149), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(262), 6,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(1137), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [1533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1109), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1111), 29,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1585] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1158), 1,
      anon_sym_RBRACE,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(497), 1,
      sym_modifiers,
    STATE(505), 1,
      sym_generic_type,
    STATE(534), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(265), 6,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(33), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [1667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_ATinterface,
    ACTIONS(69), 1,
      anon_sym_interface,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1160), 1,
      anon_sym_RBRACE,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(497), 1,
      sym_modifiers,
    STATE(505), 1,
      sym_generic_type,
    STATE(534), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(309), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(262), 6,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(33), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [1749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1119), 29,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1801] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1024), 1,
      anon_sym_LT,
    ACTIONS(1027), 1,
      anon_sym_DASH_GT,
    ACTIONS(1032), 1,
      anon_sym_DOT,
    ACTIONS(1036), 1,
      anon_sym_AT,
    ACTIONS(1162), 1,
      anon_sym_EQ,
    STATE(345), 1,
      sym_argument_list,
    STATE(499), 1,
      sym_type_arguments,
    ACTIONS(1029), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1018), 11,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1022), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1016), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
  [1873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1166), 29,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 1,
      anon_sym_EQ,
    ACTIONS(1022), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1016), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1018), 18,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [1981] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    ACTIONS(1168), 1,
      anon_sym_module,
    STATE(327), 1,
      sym_argument_list,
    ACTIONS(1107), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1101), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(1103), 14,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [2041] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1174), 1,
      anon_sym_LBRACK,
    STATE(275), 1,
      aux_sym_dimensions_repeat1,
    STATE(336), 1,
      sym_dimensions,
    STATE(274), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(591), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1170), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1172), 22,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [2102] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1174), 1,
      anon_sym_LBRACK,
    STATE(275), 1,
      aux_sym_dimensions_repeat1,
    STATE(331), 1,
      sym_dimensions,
    STATE(274), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(591), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1176), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1178), 22,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [2163] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_RPAREN,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(279), 1,
      sym_receiver_parameter,
    STATE(404), 1,
      aux_sym_modifiers_repeat1,
    STATE(487), 1,
      aux_sym_dimensions_expr_repeat1,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(512), 1,
      sym_modifiers,
    STATE(533), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(751), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(468), 3,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [2240] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1184), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_AT,
    STATE(274), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(605), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1180), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1182), 22,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [2295] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1194), 1,
      anon_sym_LBRACK,
    STATE(278), 1,
      aux_sym_dimensions_repeat1,
    STATE(593), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1190), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1192), 22,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [2349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1198), 7,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_ATinterface,
    ACTIONS(1196), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_to,
      anon_sym_with,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [2395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 7,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_ATinterface,
    ACTIONS(1200), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_to,
      anon_sym_with,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [2441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1211), 1,
      anon_sym_AT,
    STATE(278), 1,
      aux_sym_dimensions_repeat1,
    STATE(593), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1204), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1206), 22,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [2495] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1214), 1,
      anon_sym_RPAREN,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(512), 1,
      sym_modifiers,
    STATE(539), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(720), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(404), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [2564] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1194), 1,
      anon_sym_LBRACK,
    STATE(275), 1,
      aux_sym_dimensions_repeat1,
    STATE(372), 1,
      sym_dimensions,
    STATE(593), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1216), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1218), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [2619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1194), 1,
      anon_sym_LBRACK,
    STATE(275), 1,
      aux_sym_dimensions_repeat1,
    STATE(372), 1,
      sym_dimensions,
    STATE(593), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1220), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1222), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [2674] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(512), 1,
      sym_modifiers,
    STATE(539), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(806), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(404), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [2740] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(504), 1,
      sym_modifiers,
    STATE(505), 1,
      sym_generic_type,
    STATE(540), 1,
      sym__unannotated_type,
    STATE(662), 1,
      sym_catch_type,
    STATE(899), 1,
      sym_catch_formal_parameter,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(404), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [2808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 12,
      sym_octal_integer_literal,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      sym_string_literal,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(624), 23,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_open,
      anon_sym_module,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [2851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 1,
      anon_sym_LPAREN,
    ACTIONS(1230), 1,
      anon_sym_DOT,
    STATE(343), 1,
      sym_annotation_argument_list,
    ACTIONS(1228), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1224), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [2900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_DOT,
    STATE(344), 1,
      sym_annotation_argument_list,
    ACTIONS(1234), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1232), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [2949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 12,
      sym_octal_integer_literal,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      sym_string_literal,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(776), 23,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_open,
      anon_sym_module,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [2992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_class_body,
    ACTIONS(1238), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1240), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1200), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_LPAREN,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    STATE(359), 1,
      sym_annotation_argument_list,
    ACTIONS(1228), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1224), 29,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(334), 1,
      sym_class_body,
    ACTIONS(1248), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1250), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(315), 1,
      sym_class_body,
    ACTIONS(1252), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1254), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(314), 1,
      sym_class_body,
    ACTIONS(1256), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1258), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_LPAREN,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    STATE(366), 1,
      sym_annotation_argument_list,
    ACTIONS(1234), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1232), 29,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1198), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1196), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1264), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [3397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1270), 1,
      anon_sym_LT,
    ACTIONS(1273), 1,
      anon_sym_DOT,
    STATE(306), 1,
      sym_type_arguments,
    ACTIONS(1266), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1268), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [3444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1277), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [3485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1206), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [3526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1281), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [3567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1285), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [3608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1289), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [3649] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 1,
      anon_sym_LT,
    ACTIONS(1294), 1,
      anon_sym_DOT,
    STATE(319), 1,
      sym_type_arguments,
    ACTIONS(1012), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1036), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [3696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1296), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1298), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [3737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1302), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1306), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [3817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1310), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1314), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_AT,
    ACTIONS(1318), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(321), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1320), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
    ACTIONS(1316), 13,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1324), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [3983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LBRACK,
    ACTIONS(1332), 1,
      anon_sym_DOT,
    ACTIONS(1334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1326), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1328), 20,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1336), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1338), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1340), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1342), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1344), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1346), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1350), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1016), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1018), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1354), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1358), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1362), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [4349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1366), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 1,
      anon_sym_AT,
    ACTIONS(1370), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(321), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1372), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
    ACTIONS(1368), 13,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1380), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1384), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1388), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1392), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1394), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1396), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1400), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1404), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1408), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1412), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1416), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1420), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1424), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1428), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1432), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [4995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1436), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [5035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1273), 1,
      anon_sym_DOT,
    ACTIONS(1266), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1268), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1438), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1442), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1448), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1452), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1456), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1458), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1462), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1468), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [5397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1472), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [5437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1476), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1480), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1484), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1488), 24,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1490), 25,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1496), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [5676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1490), 29,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1498), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1442), 29,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1502), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1506), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1512), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1510), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1458), 29,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1514), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1518), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1522), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1268), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [6105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1528), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [6144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1530), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1462), 29,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1438), 29,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1534), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1538), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1542), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1546), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1552), 23,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_AT,
  [6456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1554), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 5,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1558), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 4,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1562), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 4,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1566), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_ATinterface,
    ACTIONS(1575), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
    ACTIONS(1570), 11,
      anon_sym_AT,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1573), 15,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
  [6652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(373), 1,
      sym_block,
    ACTIONS(1577), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    ACTIONS(1573), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1579), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1581), 19,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [6733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1587), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [6770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_LPAREN,
    ACTIONS(1577), 1,
      anon_sym_ATinterface,
    STATE(819), 1,
      sym_parenthesized_expression,
    ACTIONS(1573), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1591), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [6848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1482), 17,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [6885] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1595), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [6944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1619), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [6981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1623), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1450), 17,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1625), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1627), 19,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7094] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1625), 4,
      anon_sym_AMP,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(1627), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1328), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(932), 1,
      sym_argument_list,
    ACTIONS(1016), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1018), 19,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [7221] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1629), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1446), 17,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7317] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1625), 1,
      anon_sym_PIPE,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1627), 9,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1625), 6,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
    ACTIONS(1627), 15,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7415] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1625), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1627), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7466] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1631), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1629), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1623), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7599] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1635), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1218), 21,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1579), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1581), 19,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [7734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_ATinterface,
    ACTIONS(1637), 1,
      anon_sym_COLON,
    ACTIONS(1573), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    STATE(415), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1316), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1639), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [7811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1643), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1641), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1645), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1649), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1653), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1657), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7986] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1661), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [8043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1665), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1663), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8078] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LBRACK,
    ACTIONS(1334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1667), 1,
      anon_sym_DOT,
    ACTIONS(1326), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1328), 16,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
  [8119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1669), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1675), 2,
      anon_sym_RBRACE,
      anon_sym_ATinterface,
    ACTIONS(1673), 25,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_AT,
    STATE(415), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1368), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1677), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [8228] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_GT,
    ACTIONS(1685), 1,
      anon_sym_QMARK,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(771), 2,
      sym_wildcard,
      sym__type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(478), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [8286] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1687), 1,
      anon_sym_COMMA,
    ACTIONS(1689), 1,
      anon_sym_SEMI,
    STATE(734), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    STATE(427), 1,
      aux_sym_dimensions_repeat1,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1190), 9,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1192), 10,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
  [8388] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1693), 1,
      anon_sym_RPAREN,
    ACTIONS(1695), 1,
      anon_sym_COMMA,
    STATE(710), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8448] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1685), 1,
      anon_sym_QMARK,
    ACTIONS(1697), 1,
      anon_sym_GT,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(725), 2,
      sym_wildcard,
      sym__type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(478), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [8506] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1699), 1,
      anon_sym_RPAREN,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    STATE(759), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8566] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1703), 1,
      anon_sym_RPAREN,
    STATE(757), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8626] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1705), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8682] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1707), 1,
      anon_sym_RPAREN,
    STATE(763), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8742] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1709), 1,
      anon_sym_RPAREN,
    STATE(724), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8802] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1711), 1,
      anon_sym_RPAREN,
    STATE(774), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 1,
      anon_sym_AT,
    ACTIONS(1713), 1,
      anon_sym_LBRACK,
    STATE(427), 1,
      aux_sym_dimensions_repeat1,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1204), 9,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1206), 10,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
  [8904] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1716), 1,
      anon_sym_RPAREN,
    STATE(772), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [8964] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1718), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9024] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1720), 1,
      anon_sym_RPAREN,
    STATE(762), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9084] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1722), 1,
      anon_sym_COMMA,
    ACTIONS(1724), 1,
      anon_sym_RBRACE,
    STATE(789), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9144] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1726), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9199] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1728), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9254] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1730), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9309] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1685), 1,
      anon_sym_QMARK,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(846), 2,
      sym_wildcard,
      sym__type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(478), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [9364] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1732), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9419] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1734), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9474] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1736), 1,
      anon_sym_COLON,
    ACTIONS(1738), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9531] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1740), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9586] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1661), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9641] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1742), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9695] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1744), 1,
      anon_sym_RBRACK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9749] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1746), 1,
      sym_identifier,
    ACTIONS(1748), 1,
      anon_sym_COMMA,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
    ACTIONS(1752), 1,
      anon_sym_RBRACE,
    STATE(630), 1,
      sym_enum_constant,
    STATE(888), 1,
      sym_modifiers,
    STATE(890), 1,
      sym_enum_body_declarations,
    STATE(404), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [9797] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1754), 1,
      anon_sym_RPAREN,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9851] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1756), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9905] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1758), 1,
      anon_sym_RBRACK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [9959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1762), 2,
      anon_sym_RPAREN,
      anon_sym_AT,
    ACTIONS(1760), 22,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9991] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 1,
      sym_identifier,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(1764), 1,
      anon_sym_class,
    ACTIONS(1766), 1,
      anon_sym_enum,
    ACTIONS(1768), 1,
      anon_sym_ATinterface,
    ACTIONS(1770), 1,
      anon_sym_interface,
    STATE(480), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(525), 1,
      sym__unannotated_type,
    STATE(667), 1,
      sym__constructor_declarator,
    STATE(776), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1774), 2,
      anon_sym_RPAREN,
      anon_sym_AT,
    ACTIONS(1772), 22,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10083] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1776), 1,
      anon_sym_COLON,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10137] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_open,
    ACTIONS(1780), 1,
      anon_sym_module,
    ACTIONS(1782), 1,
      anon_sym_package,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(508), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1786), 2,
      anon_sym_RPAREN,
      anon_sym_AT,
    ACTIONS(1784), 22,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10223] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10277] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(754), 1,
      sym__type,
    STATE(922), 1,
      sym_interface_type_list,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10331] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10385] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1792), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10439] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(754), 1,
      sym__type,
    STATE(903), 1,
      sym_interface_type_list,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10493] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1794), 1,
      anon_sym_RPAREN,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10547] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1796), 1,
      anon_sym_RBRACK,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10601] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1798), 1,
      anon_sym_COLON,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10655] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10709] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1802), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10763] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1804), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10817] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_AMP,
    ACTIONS(1601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 1,
      anon_sym_instanceof,
    ACTIONS(1615), 1,
      anon_sym_QMARK,
    ACTIONS(1806), 1,
      anon_sym_SEMI,
    ACTIONS(1583), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1597), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1603), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1605), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1609), 2,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1599), 4,
      anon_sym_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 2,
      anon_sym_RPAREN,
      anon_sym_AT,
    ACTIONS(1808), 22,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10903] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(795), 1,
      sym__type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10954] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1746), 1,
      sym_identifier,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
    ACTIONS(1812), 1,
      anon_sym_RBRACE,
    STATE(712), 1,
      sym_enum_constant,
    STATE(888), 1,
      sym_modifiers,
    STATE(894), 1,
      sym_enum_body_declarations,
    STATE(404), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [10999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_AT,
    ACTIONS(1570), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1573), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [11032] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(665), 1,
      sym__type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11083] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1764), 1,
      anon_sym_class,
    ACTIONS(1766), 1,
      anon_sym_enum,
    ACTIONS(1768), 1,
      anon_sym_ATinterface,
    ACTIONS(1770), 1,
      anon_sym_interface,
    STATE(486), 1,
      sym_type_parameters,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(522), 1,
      sym__unannotated_type,
    STATE(776), 1,
      sym__method_header,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11140] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(836), 1,
      sym__type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11191] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(855), 1,
      sym__type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11242] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(770), 1,
      sym__type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11293] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1817), 1,
      sym_identifier,
    STATE(280), 1,
      sym__unannotated_type,
    STATE(297), 1,
      sym_scoped_type_identifier,
    STATE(337), 1,
      sym_generic_type,
    STATE(385), 1,
      sym__type,
    STATE(401), 1,
      sym_annotated_type,
    ACTIONS(1821), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1823), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(363), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(479), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1819), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11344] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1746), 1,
      sym_identifier,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
    ACTIONS(1825), 1,
      anon_sym_RBRACE,
    STATE(712), 1,
      sym_enum_constant,
    STATE(888), 1,
      sym_modifiers,
    STATE(956), 1,
      sym_enum_body_declarations,
    STATE(404), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [11389] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(802), 1,
      sym__type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11440] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(523), 1,
      sym__unannotated_type,
    STATE(574), 1,
      sym_annotated_type,
    STATE(700), 1,
      sym__type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(485), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11491] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1827), 1,
      anon_sym_QMARK,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(508), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11539] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1817), 1,
      sym_identifier,
    STATE(281), 1,
      sym__unannotated_type,
    STATE(297), 1,
      sym_scoped_type_identifier,
    STATE(337), 1,
      sym_generic_type,
    ACTIONS(1821), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1823), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(363), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1819), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1829), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(553), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(484), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 9,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1264), 12,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [11658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 9,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1206), 12,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [11687] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(538), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11732] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(550), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11777] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(508), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11822] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(553), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(484), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11867] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(567), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1835), 1,
      anon_sym_AT,
    ACTIONS(1833), 2,
      anon_sym_QMARK,
      anon_sym_LBRACK,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1831), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11944] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1764), 1,
      anon_sym_class,
    ACTIONS(1766), 1,
      anon_sym_enum,
    ACTIONS(1768), 1,
      anon_sym_ATinterface,
    ACTIONS(1770), 1,
      anon_sym_interface,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(528), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11992] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1746), 1,
      sym_identifier,
    STATE(712), 1,
      sym_enum_constant,
    STATE(888), 1,
      sym_modifiers,
    STATE(404), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(367), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
  [12028] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    STATE(498), 1,
      sym_type_arguments,
    ACTIONS(1266), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1268), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1480), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1840), 1,
      anon_sym_DOT,
    STATE(499), 1,
      sym_type_arguments,
    ACTIONS(1012), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1036), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1476), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1456), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1488), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12202] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    ACTIONS(1764), 1,
      anon_sym_class,
    ACTIONS(1768), 1,
      anon_sym_ATinterface,
    ACTIONS(1770), 1,
      anon_sym_interface,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(529), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1306), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1362), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1528), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1496), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12351] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1842), 1,
      sym_identifier,
    ACTIONS(1844), 1,
      anon_sym_DOT,
    ACTIONS(1848), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1850), 1,
      sym_this,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(882), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    ACTIONS(1218), 3,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [12397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1552), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12422] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(540), 1,
      sym__unannotated_type,
    STATE(676), 1,
      sym_catch_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1266), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1268), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 6,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      sym_this,
      sym_identifier,
    ACTIONS(1268), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [12513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(530), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1222), 8,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_implements,
  [12581] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1218), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1852), 1,
      sym_identifier,
    ACTIONS(1854), 1,
      anon_sym_DOT,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(692), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(937), 1,
      sym__variable_declarator_list,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [12625] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1856), 1,
      sym_identifier,
    STATE(526), 1,
      sym_scoped_type_identifier,
    STATE(531), 1,
      sym_type_arguments,
    STATE(541), 1,
      sym_generic_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1858), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(557), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12663] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1860), 1,
      sym_identifier,
    STATE(531), 1,
      sym_type_arguments,
    STATE(634), 1,
      sym_scoped_type_identifier,
    STATE(726), 1,
      sym_generic_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1862), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(864), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12701] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(542), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12737] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1218), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1852), 1,
      sym_identifier,
    ACTIONS(1854), 1,
      anon_sym_DOT,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(923), 1,
      sym__variable_declarator_list,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [12781] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(548), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12817] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1864), 1,
      sym_identifier,
    STATE(518), 1,
      sym_scoped_type_identifier,
    STATE(531), 1,
      sym_type_arguments,
    STATE(546), 1,
      sym_generic_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1866), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(549), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12855] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      sym_identifier,
    STATE(491), 1,
      sym_scoped_type_identifier,
    STATE(505), 1,
      sym_generic_type,
    STATE(552), 1,
      sym__unannotated_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(75), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(506), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12891] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    STATE(291), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(499), 1,
      sym_type_arguments,
    STATE(800), 1,
      sym_dimensions,
    STATE(271), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [12932] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(288), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(498), 1,
      sym_type_arguments,
    STATE(858), 1,
      sym_dimensions,
    STATE(556), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [12973] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    STATE(291), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(499), 1,
      sym_type_arguments,
    STATE(800), 1,
      sym_dimensions,
    STATE(555), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13014] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1874), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(661), 1,
      sym__method_declarator,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(898), 1,
      sym__variable_declarator_list,
    ACTIONS(1876), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1878), 1,
      anon_sym_AT,
    ACTIONS(1661), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(1575), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [13080] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1874), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(661), 1,
      sym__method_declarator,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(889), 1,
      sym__variable_declarator_list,
    ACTIONS(1876), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13121] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1218), 7,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_implements,
  [13152] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1874), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(661), 1,
      sym__method_declarator,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(946), 1,
      sym__variable_declarator_list,
    ACTIONS(1876), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13193] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1874), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(661), 1,
      sym__method_declarator,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(951), 1,
      sym__variable_declarator_list,
    ACTIONS(1876), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13234] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(288), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(498), 1,
      sym_type_arguments,
    STATE(858), 1,
      sym_dimensions,
    STATE(272), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1882), 2,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(1880), 12,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [13297] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(904), 1,
      sym__variable_declarator_list,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13335] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1884), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(889), 1,
      sym__variable_declarator_list,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13373] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(670), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(947), 1,
      sym__variable_declarator_list,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13411] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 1,
      sym_identifier,
    STATE(641), 1,
      sym_scoped_type_identifier,
    STATE(764), 1,
      sym_generic_type,
    ACTIONS(73), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1888), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(837), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(71), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13443] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1218), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1852), 1,
      sym_identifier,
    ACTIONS(1854), 1,
      anon_sym_DOT,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(905), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1842), 1,
      sym_identifier,
    ACTIONS(1848), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1850), 1,
      sym_this,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(882), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13519] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1890), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(760), 1,
      sym_variable_declarator,
    STATE(898), 1,
      sym__variable_declarator_list,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1894), 2,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(1892), 12,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [13579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1896), 1,
      anon_sym_DOT,
    STATE(498), 1,
      sym_type_arguments,
    ACTIONS(1266), 4,
      anon_sym_open,
      anon_sym_module,
      sym_this,
      sym_identifier,
    ACTIONS(1268), 6,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [13606] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_DOT,
    ACTIONS(1036), 1,
      anon_sym_AT,
    STATE(345), 1,
      sym_argument_list,
    STATE(499), 1,
      sym_type_arguments,
    ACTIONS(1029), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1899), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1012), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [13641] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1901), 1,
      sym_identifier,
    ACTIONS(1903), 1,
      sym_this,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    ACTIONS(1222), 3,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13674] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1848), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(882), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13709] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1907), 1,
      anon_sym_PIPE,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(631), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(1905), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(288), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(858), 1,
      sym_dimensions,
    STATE(272), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1852), 1,
      sym_identifier,
    ACTIONS(1909), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(801), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13812] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(629), 1,
      sym_dimensions,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1911), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [13841] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(558), 1,
      sym_formal_parameters,
    STATE(629), 1,
      sym_dimensions,
    ACTIONS(1911), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13874] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(559), 1,
      sym_formal_parameters,
    STATE(633), 1,
      sym_dimensions,
    ACTIONS(1915), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13907] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(288), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(858), 1,
      sym_dimensions,
    STATE(556), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [13942] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(633), 1,
      sym_dimensions,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1915), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [13971] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(900), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14003] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    STATE(288), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(858), 1,
      sym_dimensions,
    STATE(556), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14035] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1917), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(687), 1,
      sym__method_declarator,
    ACTIONS(1919), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14067] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1921), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(629), 1,
      sym_dimensions,
    ACTIONS(1911), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1925), 1,
      anon_sym_PIPE,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    ACTIONS(1923), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14127] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1917), 1,
      sym_identifier,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(649), 1,
      sym__method_declarator,
    ACTIONS(1919), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14159] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1927), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(629), 1,
      sym_dimensions,
    ACTIONS(1911), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14189] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    STATE(336), 1,
      sym_dimensions,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(1172), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(274), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    STATE(331), 1,
      sym_dimensions,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(1178), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(274), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1868), 1,
      anon_sym_LBRACK,
    STATE(288), 1,
      sym_argument_list,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(858), 1,
      sym_dimensions,
    STATE(272), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(604), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14281] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(747), 1,
      sym_dimensions,
    ACTIONS(1929), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_throws,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(746), 1,
      sym_dimensions,
    ACTIONS(1931), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_throws,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_DOT,
    ACTIONS(1266), 4,
      anon_sym_open,
      anon_sym_module,
      sym_this,
      sym_identifier,
    ACTIONS(1268), 6,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14356] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1933), 1,
      anon_sym_SEMI,
    ACTIONS(1935), 1,
      anon_sym_default,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(721), 1,
      sym_dimensions,
    STATE(915), 1,
      sym__default_value,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14387] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1935), 1,
      anon_sym_default,
    ACTIONS(1937), 1,
      anon_sym_SEMI,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(733), 1,
      sym_dimensions,
    STATE(931), 1,
      sym__default_value,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1939), 1,
      anon_sym_DOT,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(629), 1,
      sym_dimensions,
    ACTIONS(1911), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1218), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1854), 1,
      anon_sym_DOT,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14475] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    STATE(499), 1,
      sym_type_arguments,
    STATE(813), 1,
      sym_formal_parameters,
    ACTIONS(1036), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1012), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [14503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    STATE(499), 1,
      sym_type_arguments,
    STATE(821), 1,
      sym_formal_parameters,
    ACTIONS(1036), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1012), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [14531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1901), 1,
      sym_identifier,
    ACTIONS(1903), 1,
      sym_this,
    STATE(418), 1,
      aux_sym_dimensions_repeat1,
    STATE(503), 1,
      sym_dimensions,
    STATE(617), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14559] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(1941), 1,
      sym_identifier,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(1945), 1,
      anon_sym_SEMI,
    ACTIONS(1949), 1,
      anon_sym_to,
    STATE(697), 1,
      sym_scoped_identifier,
    STATE(753), 1,
      aux_sym_module_directive_repeat2,
    ACTIONS(1947), 2,
      anon_sym_open,
      anon_sym_module,
  [14588] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(1951), 1,
      sym_identifier,
    ACTIONS(1953), 1,
      anon_sym_SEMI,
    ACTIONS(1957), 1,
      anon_sym_to,
    STATE(701), 1,
      sym_scoped_identifier,
    STATE(709), 1,
      aux_sym_module_directive_repeat2,
    ACTIONS(1955), 2,
      anon_sym_open,
      anon_sym_module,
  [14617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1959), 1,
      sym_identifier,
    ACTIONS(1961), 1,
      anon_sym_new,
    ACTIONS(1965), 1,
      sym_this,
    ACTIONS(1967), 1,
      sym_super,
    STATE(318), 1,
      sym__unqualified_object_creation_expression,
    STATE(718), 1,
      sym_type_arguments,
    ACTIONS(1963), 2,
      anon_sym_open,
      anon_sym_module,
  [14646] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1959), 1,
      sym_identifier,
    ACTIONS(1961), 1,
      anon_sym_new,
    ACTIONS(1965), 1,
      sym_this,
    ACTIONS(1969), 1,
      sym_super,
    STATE(318), 1,
      sym__unqualified_object_creation_expression,
    STATE(655), 1,
      sym_type_arguments,
    ACTIONS(1963), 2,
      anon_sym_open,
      anon_sym_module,
  [14675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    STATE(848), 1,
      sym_scoped_identifier,
    ACTIONS(1973), 2,
      anon_sym_open,
      anon_sym_module,
    ACTIONS(1975), 2,
      anon_sym_transitive,
      anon_sym_static,
    STATE(575), 2,
      sym_requires_modifier,
      aux_sym_module_directive_repeat1,
  [14697] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 1,
      anon_sym_RBRACE,
    ACTIONS(1979), 1,
      anon_sym_requires,
    ACTIONS(1985), 1,
      anon_sym_uses,
    ACTIONS(1988), 1,
      anon_sym_provides,
    ACTIONS(1982), 2,
      anon_sym_exports,
      anon_sym_opens,
    STATE(573), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
  [14721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 8,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_implements,
  [14735] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 1,
      sym_identifier,
    STATE(877), 1,
      sym_scoped_identifier,
    ACTIONS(1975), 2,
      anon_sym_transitive,
      anon_sym_static,
    ACTIONS(1993), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(580), 2,
      sym_requires_modifier,
      aux_sym_module_directive_repeat1,
  [14757] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_RBRACE,
    ACTIONS(1997), 1,
      anon_sym_requires,
    ACTIONS(2001), 1,
      anon_sym_uses,
    ACTIONS(2003), 1,
      anon_sym_provides,
    ACTIONS(1999), 2,
      anon_sym_exports,
      anon_sym_opens,
    STATE(573), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
  [14781] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_requires,
    ACTIONS(2001), 1,
      anon_sym_uses,
    ACTIONS(2003), 1,
      anon_sym_provides,
    ACTIONS(2005), 1,
      anon_sym_RBRACE,
    ACTIONS(1999), 2,
      anon_sym_exports,
      anon_sym_opens,
    STATE(576), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
  [14805] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_extends,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(96), 1,
      sym_class_body,
    STATE(620), 1,
      sym_type_parameters,
    STATE(696), 1,
      sym_superclass,
    STATE(859), 1,
      sym_super_interfaces,
  [14833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_extends,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(89), 1,
      sym_class_body,
    STATE(598), 1,
      sym_type_parameters,
    STATE(669), 1,
      sym_superclass,
    STATE(822), 1,
      sym_super_interfaces,
  [14861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 2,
      anon_sym_transitive,
      anon_sym_static,
    STATE(580), 2,
      sym_requires_modifier,
      aux_sym_module_directive_repeat1,
    ACTIONS(2011), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [14878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2016), 1,
      sym_identifier,
    ACTIONS(2018), 1,
      anon_sym_SEMI,
    STATE(659), 1,
      sym_scoped_identifier,
    STATE(786), 1,
      aux_sym_module_directive_repeat2,
    ACTIONS(2020), 2,
      anon_sym_open,
      anon_sym_module,
  [14901] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2022), 1,
      sym_identifier,
    ACTIONS(2024), 1,
      anon_sym_SEMI,
    STATE(657), 1,
      sym_scoped_identifier,
    STATE(791), 1,
      aux_sym_module_directive_repeat2,
    ACTIONS(2026), 2,
      anon_sym_open,
      anon_sym_module,
  [14924] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(637), 1,
      sym_argument_list,
    STATE(706), 1,
      sym_class_body,
    ACTIONS(2028), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [14945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2030), 1,
      sym_identifier,
    STATE(766), 1,
      sym_type_parameter,
    STATE(592), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [14964] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(643), 1,
      sym_argument_list,
    STATE(715), 1,
      sym_class_body,
    ACTIONS(2032), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [14985] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1959), 1,
      sym_identifier,
    ACTIONS(1965), 1,
      sym_this,
    ACTIONS(1967), 1,
      sym_super,
    STATE(718), 1,
      sym_type_arguments,
    ACTIONS(1963), 2,
      anon_sym_open,
      anon_sym_module,
  [15008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2030), 1,
      sym_identifier,
    STATE(808), 1,
      sym_type_parameter,
    STATE(592), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2036), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2038), 1,
      sym_identifier,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2040), 1,
      anon_sym_LBRACK,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2042), 1,
      sym_identifier,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2044), 1,
      anon_sym_LBRACK,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2046), 1,
      sym_identifier,
    STATE(626), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2048), 1,
      sym_identifier,
    STATE(619), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2050), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_throws,
  [15163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(2052), 1,
      sym_identifier,
    ACTIONS(2056), 1,
      sym_this,
    STATE(714), 1,
      sym_type_arguments,
    ACTIONS(2054), 2,
      anon_sym_open,
      anon_sym_module,
  [15183] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_extends,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(79), 1,
      sym_class_body,
    STATE(681), 1,
      sym_superclass,
    STATE(862), 1,
      sym_super_interfaces,
  [15205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2058), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2060), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2062), 1,
      anon_sym_extends,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(93), 1,
      sym_interface_body,
    STATE(691), 1,
      sym_type_parameters,
    STATE(854), 1,
      sym_extends_interfaces,
  [15251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2068), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2070), 1,
      anon_sym_LBRACK,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2072), 1,
      anon_sym_LBRACK,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2062), 1,
      anon_sym_extends,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(107), 1,
      sym_interface_body,
    STATE(651), 1,
      sym_type_parameters,
    STATE(878), 1,
      sym_extends_interfaces,
  [15329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2078), 1,
      sym_identifier,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2084), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2086), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_throws,
  [15417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_throws,
  [15429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2090), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2092), 1,
      sym_identifier,
    STATE(590), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2094), 1,
      anon_sym_LBRACK,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2098), 1,
      sym_identifier,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_extends,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(80), 1,
      sym_class_body,
    STATE(693), 1,
      sym_superclass,
    STATE(880), 1,
      sym_super_interfaces,
  [15523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2100), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2102), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [15571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_throws,
  [15583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_AT,
    ACTIONS(2110), 1,
      sym_identifier,
    STATE(488), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2112), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_transitive,
      anon_sym_static,
      sym_identifier,
  [15610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2114), 1,
      anon_sym_catch,
    ACTIONS(2116), 1,
      anon_sym_finally,
    STATE(176), 1,
      sym_finally_clause,
    STATE(53), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [15627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2118), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [15638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
    ACTIONS(2120), 1,
      anon_sym_COMMA,
    ACTIONS(2122), 1,
      anon_sym_RBRACE,
    STATE(639), 1,
      aux_sym_enum_body_repeat1,
    STATE(921), 1,
      sym_enum_body_declarations,
  [15657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_PIPE,
    STATE(635), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(2124), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [15672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(804), 1,
      sym_variable_declarator,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
  [15689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2126), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [15700] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(288), 1,
      sym_argument_list,
    STATE(498), 1,
      sym_type_arguments,
  [15719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      anon_sym_PIPE,
    STATE(635), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(1923), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [15734] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    STATE(291), 1,
      sym_argument_list,
    STATE(499), 1,
      sym_type_arguments,
  [15753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(711), 1,
      sym_class_body,
    ACTIONS(2131), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [15768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      sym_identifier,
    ACTIONS(2137), 1,
      anon_sym_static,
    STATE(816), 1,
      sym_scoped_identifier,
    ACTIONS(2135), 2,
      anon_sym_open,
      anon_sym_module,
  [15785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
    ACTIONS(1812), 1,
      anon_sym_RBRACE,
    ACTIONS(2139), 1,
      anon_sym_COMMA,
    STATE(705), 1,
      aux_sym_enum_body_repeat1,
    STATE(894), 1,
      sym_enum_body_declarations,
  [15804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1018), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [15817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(293), 1,
      sym_argument_list,
    STATE(498), 1,
      sym_type_arguments,
  [15836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(831), 1,
      sym__wildcard_bounds,
    ACTIONS(2141), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    ACTIONS(2143), 2,
      anon_sym_extends,
      sym_super,
  [15851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(792), 1,
      sym_class_body,
    ACTIONS(2145), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [15866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(814), 1,
      sym__wildcard_bounds,
    ACTIONS(2143), 2,
      anon_sym_extends,
      sym_super,
    ACTIONS(2147), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [15881] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    STATE(292), 1,
      sym_argument_list,
    STATE(499), 1,
      sym_type_arguments,
  [15900] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(847), 1,
      sym_variable_declarator,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
  [15917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(327), 1,
      sym_argument_list,
    ACTIONS(1103), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [15932] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(677), 1,
      sym__variable_declarator_id,
    STATE(840), 1,
      sym_variable_declarator,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
  [15949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_throws,
    STATE(845), 1,
      sym_throws,
    ACTIONS(2149), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [15963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      sym_identifier,
    STATE(569), 1,
      sym_scoped_identifier,
    ACTIONS(2155), 2,
      anon_sym_open,
      anon_sym_module,
  [15977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2062), 1,
      anon_sym_extends,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(97), 1,
      sym_interface_body,
    STATE(869), 1,
      sym_extends_interfaces,
  [15993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 1,
      sym_identifier,
    STATE(286), 1,
      sym_scoped_identifier,
    ACTIONS(2159), 2,
      anon_sym_open,
      anon_sym_module,
  [16007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2161), 1,
      anon_sym_DOT,
    STATE(932), 1,
      sym_argument_list,
  [16023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2163), 1,
      sym_identifier,
    STATE(743), 1,
      sym_scoped_identifier,
    ACTIONS(2165), 2,
      anon_sym_open,
      anon_sym_module,
  [16037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2167), 1,
      sym_identifier,
    ACTIONS(2171), 1,
      sym_super,
    ACTIONS(2169), 2,
      anon_sym_open,
      anon_sym_module,
  [16051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      anon_sym_AMP,
    STATE(656), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(2176), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [16065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2178), 1,
      anon_sym_SEMI,
    STATE(738), 1,
      aux_sym_module_directive_repeat2,
  [16081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2180), 1,
      anon_sym_SEMI,
    STATE(742), 1,
      aux_sym_module_directive_repeat2,
  [16097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2182), 1,
      anon_sym_SEMI,
    STATE(749), 1,
      aux_sym_module_directive_repeat2,
  [16113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2184), 1,
      anon_sym_SEMI,
    STATE(750), 1,
      aux_sym_module_directive_repeat2,
  [16129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_throws,
    STATE(850), 1,
      sym_throws,
    ACTIONS(2186), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [16143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(924), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
  [16157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2188), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      sym_identifier,
    STATE(832), 1,
      sym_scoped_identifier,
    ACTIONS(2192), 2,
      anon_sym_open,
      anon_sym_module,
  [16181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_COMMA,
    STATE(683), 1,
      aux_sym_interface_type_list_repeat1,
    ACTIONS(2196), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [16195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2200), 1,
      anon_sym_extends,
    STATE(827), 1,
      sym_type_bound,
    ACTIONS(2198), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [16209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_throws,
    ACTIONS(2202), 1,
      anon_sym_LBRACE,
    STATE(370), 1,
      sym_constructor_body,
    STATE(811), 1,
      sym_throws,
  [16225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 1,
      sym_identifier,
    STATE(729), 1,
      sym_scoped_identifier,
    ACTIONS(2206), 2,
      anon_sym_open,
      anon_sym_module,
  [16239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(112), 1,
      sym_class_body,
    STATE(871), 1,
      sym_super_interfaces,
  [16255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_EQ,
    ACTIONS(2212), 1,
      anon_sym_COLON,
    ACTIONS(2210), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [16269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_COMMA,
    STATE(671), 1,
      aux_sym_interface_type_list_repeat1,
    ACTIONS(2217), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [16283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2200), 1,
      anon_sym_extends,
    STATE(810), 1,
      sym_type_bound,
    ACTIONS(2219), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [16297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_throws,
    ACTIONS(2202), 1,
      anon_sym_LBRACE,
    STATE(374), 1,
      sym_constructor_body,
    STATE(818), 1,
      sym_throws,
  [16313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    STATE(876), 1,
      sym_scoped_identifier,
    ACTIONS(2223), 2,
      anon_sym_open,
      anon_sym_module,
  [16327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_LBRACE,
    STATE(628), 1,
      sym_block,
    STATE(824), 1,
      sym_resource_specification,
  [16343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      sym_identifier,
    STATE(933), 1,
      sym__variable_declarator_id,
    ACTIONS(1846), 2,
      anon_sym_open,
      anon_sym_module,
  [16357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_EQ,
    ACTIONS(2210), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [16369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_implements,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    STATE(99), 1,
      sym_enum_body,
    STATE(873), 1,
      sym_super_interfaces,
  [16385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2233), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(92), 1,
      sym_class_body,
    STATE(799), 1,
      sym_super_interfaces,
  [16421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(294), 1,
      sym_scoped_identifier,
    ACTIONS(2237), 2,
      anon_sym_open,
      anon_sym_module,
  [16435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_COMMA,
    STATE(671), 1,
      aux_sym_interface_type_list_repeat1,
    ACTIONS(2239), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [16449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      sym_identifier,
    STATE(826), 1,
      sym_scoped_identifier,
    ACTIONS(2245), 2,
      anon_sym_open,
      anon_sym_module,
  [16473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_LT,
    STATE(881), 1,
      sym_type_arguments,
    ACTIONS(2247), 2,
      anon_sym_new,
      sym_identifier,
  [16487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_throws,
    STATE(809), 1,
      sym_throws,
    ACTIONS(2249), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [16501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2251), 1,
      anon_sym_AMP,
    ACTIONS(2253), 1,
      anon_sym_RPAREN,
    STATE(730), 1,
      aux_sym_cast_expression_repeat1,
  [16517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_implements,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    STATE(95), 1,
      sym_enum_body,
    STATE(857), 1,
      sym_super_interfaces,
  [16533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_AMP,
    STATE(656), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(2257), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [16547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2062), 1,
      anon_sym_extends,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(78), 1,
      sym_interface_body,
    STATE(805), 1,
      sym_extends_interfaces,
  [16563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_EQ,
    ACTIONS(2259), 1,
      anon_sym_COLON,
    ACTIONS(2210), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [16577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(100), 1,
      sym_class_body,
    STATE(867), 1,
      sym_super_interfaces,
  [16593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      sym_identifier,
    STATE(781), 1,
      sym_scoped_identifier,
    ACTIONS(2263), 2,
      anon_sym_open,
      anon_sym_module,
  [16607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2265), 1,
      anon_sym_SEMI,
    STATE(782), 1,
      aux_sym_module_directive_repeat2,
  [16623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(2009), 1,
      anon_sym_implements,
    STATE(74), 1,
      sym_class_body,
    STATE(879), 1,
      sym_super_interfaces,
  [16639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2018), 1,
      anon_sym_SEMI,
    STATE(786), 1,
      aux_sym_module_directive_repeat2,
  [16655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    STATE(848), 1,
      sym_scoped_identifier,
    ACTIONS(1973), 2,
      anon_sym_open,
      anon_sym_module,
  [16669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2267), 1,
      anon_sym_SEMI,
    STATE(788), 1,
      aux_sym_module_directive_repeat2,
  [16685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_AMP,
    STATE(690), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(2269), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [16699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2024), 1,
      anon_sym_SEMI,
    STATE(791), 1,
      aux_sym_module_directive_repeat2,
  [16715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(853), 1,
      sym_scoped_identifier,
    ACTIONS(2273), 2,
      anon_sym_open,
      anon_sym_module,
  [16729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    STATE(659), 1,
      sym_scoped_identifier,
    ACTIONS(2020), 2,
      anon_sym_open,
      anon_sym_module,
  [16743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2022), 1,
      sym_identifier,
    STATE(657), 1,
      sym_scoped_identifier,
    ACTIONS(2026), 2,
      anon_sym_open,
      anon_sym_module,
  [16757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_COMMA,
    STATE(705), 1,
      aux_sym_enum_body_repeat1,
    ACTIONS(2278), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2282), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [16793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    STATE(748), 1,
      aux_sym_annotation_argument_list_repeat1,
  [16806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2024), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [16819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 1,
      anon_sym_COMMA,
    ACTIONS(2288), 1,
      anon_sym_RPAREN,
    STATE(741), 1,
      aux_sym_argument_list_repeat1,
  [16832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_STAR,
    STATE(926), 1,
      sym_asterisk,
  [16863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      sym_identifier,
    ACTIONS(2298), 2,
      anon_sym_open,
      anon_sym_module,
  [16874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [16883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 1,
      anon_sym_STAR,
    ACTIONS(2302), 1,
      sym_identifier,
    STATE(925), 1,
      sym_asterisk,
  [16896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
    ACTIONS(2122), 1,
      anon_sym_RBRACE,
    STATE(921), 1,
      sym_enum_body_declarations,
  [16909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2167), 1,
      sym_identifier,
    ACTIONS(2169), 2,
      anon_sym_open,
      anon_sym_module,
  [16920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    ACTIONS(2306), 1,
      anon_sym_COMMA,
    STATE(790), 1,
      aux_sym_formal_parameters_repeat1,
  [16933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    ACTIONS(2306), 1,
      anon_sym_COMMA,
    STATE(777), 1,
      aux_sym_formal_parameters_repeat1,
  [16946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 1,
      anon_sym_default,
    ACTIONS(2308), 1,
      anon_sym_SEMI,
    STATE(893), 1,
      sym__default_value,
  [16959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 1,
      anon_sym_STAR,
    ACTIONS(2302), 1,
      sym_identifier,
    STATE(886), 1,
      sym_asterisk,
  [16972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 1,
      anon_sym_RPAREN,
    ACTIONS(2312), 1,
      anon_sym_COMMA,
    STATE(723), 1,
      aux_sym_inferred_parameters_repeat1,
  [16985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2315), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [16998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2317), 1,
      anon_sym_GT,
    ACTIONS(2319), 1,
      anon_sym_COMMA,
    STATE(773), 1,
      aux_sym_type_arguments_repeat1,
  [17011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(288), 1,
      sym_argument_list,
  [17024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_COMMA,
    ACTIONS(2321), 1,
      anon_sym_LBRACE,
    STATE(671), 1,
      aux_sym_interface_type_list_repeat1,
  [17037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_STAR,
    STATE(891), 1,
      sym_asterisk,
  [17050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2323), 1,
      anon_sym_LBRACE,
    STATE(148), 1,
      sym_module_body,
  [17063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_AMP,
    ACTIONS(2325), 1,
      anon_sym_RPAREN,
    STATE(796), 1,
      aux_sym_cast_expression_repeat1,
  [17076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2323), 1,
      anon_sym_LBRACE,
    STATE(147), 1,
      sym_module_body,
  [17089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_RBRACE,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    STATE(732), 1,
      aux_sym_array_initializer_repeat1,
  [17102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 1,
      anon_sym_default,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    STATE(907), 1,
      sym__default_value,
  [17115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 1,
      anon_sym_COMMA,
    ACTIONS(2332), 1,
      anon_sym_SEMI,
    STATE(768), 1,
      aux_sym_for_statement_repeat1,
  [17128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_RPAREN,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_annotation_argument_list_repeat1,
  [17141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_COMMA,
    ACTIONS(2342), 1,
      anon_sym_SEMI,
    STATE(736), 1,
      aux_sym__variable_declarator_list_repeat1,
  [17154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1705), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [17163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2344), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(926), 1,
      anon_sym_RPAREN,
    ACTIONS(2346), 1,
      anon_sym_SEMI,
    STATE(783), 1,
      aux_sym_resource_specification_repeat1,
  [17189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2323), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_module_body,
  [17202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_RPAREN,
    ACTIONS(2348), 1,
      anon_sym_COMMA,
    STATE(741), 1,
      aux_sym_argument_list_repeat1,
  [17215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2351), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2323), 1,
      anon_sym_LBRACE,
    STATE(157), 1,
      sym_module_body,
  [17241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_COMMA,
    ACTIONS(2355), 1,
      anon_sym_SEMI,
    STATE(736), 1,
      aux_sym__variable_declarator_list_repeat1,
  [17254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 1,
      anon_sym_RBRACE,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    STATE(778), 1,
      aux_sym_element_value_array_initializer_repeat1,
  [17267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_throws,
  [17276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_throws,
  [17285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    ACTIONS(2363), 1,
      anon_sym_RPAREN,
    STATE(735), 1,
      aux_sym_annotation_argument_list_repeat1,
  [17298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2365), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2367), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_RPAREN,
    ACTIONS(2306), 1,
      anon_sym_COMMA,
    STATE(719), 1,
      aux_sym_formal_parameters_repeat1,
  [17337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COMMA,
    ACTIONS(2371), 1,
      anon_sym_RBRACE,
    STATE(745), 1,
      aux_sym_element_value_array_initializer_repeat1,
  [17350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2018), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_COMMA,
    ACTIONS(2373), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      aux_sym_interface_type_list_repeat1,
  [17376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 1,
      anon_sym_GT,
    ACTIONS(2377), 1,
      anon_sym_COMMA,
    STATE(755), 1,
      aux_sym_type_arguments_repeat1,
  [17389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 1,
      anon_sym_RPAREN,
    ACTIONS(2382), 1,
      anon_sym_COMMA,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [17402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [17415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1722), 1,
      anon_sym_COMMA,
    ACTIONS(1724), 1,
      anon_sym_RBRACE,
    STATE(789), 1,
      aux_sym_array_initializer_repeat1,
  [17428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2387), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [17441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_COMMA,
    ACTIONS(2389), 1,
      anon_sym_SEMI,
    STATE(744), 1,
      aux_sym__variable_declarator_list_repeat1,
  [17454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2391), 1,
      anon_sym_GT,
    ACTIONS(2393), 1,
      anon_sym_COMMA,
    STATE(784), 1,
      aux_sym_type_parameters_repeat1,
  [17467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2395), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [17480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [17493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(1872), 1,
      anon_sym_DOT,
    STATE(293), 1,
      sym_argument_list,
  [17506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(2399), 1,
      anon_sym_SEMI,
    STATE(356), 1,
      sym_block,
  [17519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2393), 1,
      anon_sym_COMMA,
    ACTIONS(2401), 1,
      anon_sym_GT,
    STATE(761), 1,
      aux_sym_type_parameters_repeat1,
  [17532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2323), 1,
      anon_sym_LBRACE,
    STATE(164), 1,
      sym_module_body,
  [17545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_COMMA,
    ACTIONS(2406), 1,
      anon_sym_SEMI,
    STATE(768), 1,
      aux_sym_for_statement_repeat1,
  [17558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2323), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_module_body,
  [17571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [17580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 1,
      anon_sym_COMMA,
    ACTIONS(2408), 1,
      anon_sym_GT,
    STATE(775), 1,
      aux_sym_type_arguments_repeat1,
  [17593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2410), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [17606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 1,
      anon_sym_COMMA,
    ACTIONS(2412), 1,
      anon_sym_GT,
    STATE(755), 1,
      aux_sym_type_arguments_repeat1,
  [17619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(2414), 1,
      anon_sym_RPAREN,
    STATE(756), 1,
      aux_sym_for_statement_repeat2,
  [17632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 1,
      anon_sym_COMMA,
    ACTIONS(2416), 1,
      anon_sym_GT,
    STATE(755), 1,
      aux_sym_type_arguments_repeat1,
  [17645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(2418), 1,
      anon_sym_SEMI,
    STATE(371), 1,
      sym_block,
  [17658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_COMMA,
    ACTIONS(2420), 1,
      anon_sym_RPAREN,
    STATE(790), 1,
      aux_sym_formal_parameters_repeat1,
  [17671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2425), 1,
      anon_sym_RBRACE,
    STATE(778), 1,
      aux_sym_element_value_array_initializer_repeat1,
  [17684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    ACTIONS(2427), 1,
      anon_sym_RPAREN,
    STATE(785), 1,
      aux_sym_annotation_argument_list_repeat1,
  [17697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2429), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [17708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2431), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [17719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2433), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2435), 1,
      anon_sym_RPAREN,
    ACTIONS(2437), 1,
      anon_sym_SEMI,
    STATE(783), 1,
      aux_sym_resource_specification_repeat1,
  [17745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_GT,
    ACTIONS(2442), 1,
      anon_sym_COMMA,
    STATE(784), 1,
      aux_sym_type_parameters_repeat1,
  [17758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    ACTIONS(2445), 1,
      anon_sym_RPAREN,
    STATE(735), 1,
      aux_sym_annotation_argument_list_repeat1,
  [17771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2182), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 1,
      anon_sym_SEMI,
    ACTIONS(2447), 1,
      anon_sym_COMMA,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2450), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_RBRACE,
    ACTIONS(2452), 1,
      anon_sym_COMMA,
    STATE(732), 1,
      aux_sym_array_initializer_repeat1,
  [17823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_RPAREN,
    ACTIONS(2456), 1,
      anon_sym_COMMA,
    STATE(790), 1,
      aux_sym_formal_parameters_repeat1,
  [17836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(2178), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      aux_sym_module_directive_repeat2,
  [17849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [17858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LBRACK,
    ACTIONS(1332), 1,
      anon_sym_DOT,
    ACTIONS(1334), 1,
      anon_sym_COLON_COLON,
  [17871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 1,
      anon_sym_RPAREN,
    ACTIONS(2463), 1,
      anon_sym_SEMI,
    STATE(739), 1,
      aux_sym_resource_specification_repeat1,
  [17884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 3,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_COMMA,
  [17893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_AMP,
    ACTIONS(2468), 1,
      anon_sym_RPAREN,
    STATE(796), 1,
      aux_sym_cast_expression_repeat1,
  [17906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    STATE(930), 1,
      sym_argument_list,
  [17919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      anon_sym_COMMA,
    ACTIONS(2472), 1,
      anon_sym_RPAREN,
    STATE(723), 1,
      aux_sym_inferred_parameters_repeat1,
  [17932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(81), 1,
      sym_class_body,
  [17942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 1,
      anon_sym_LBRACE,
    STATE(335), 1,
      sym_array_initializer,
  [17952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [17960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 2,
      anon_sym_AMP,
      anon_sym_RPAREN,
  [17968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(127), 1,
      sym_block,
  [17978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [17986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(104), 1,
      sym_interface_body,
  [17996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [18004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2435), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [18012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [18020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [18028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [18036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 1,
      anon_sym_LBRACE,
    STATE(357), 1,
      sym_constructor_body,
  [18046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_LPAREN,
    STATE(911), 1,
      sym_parenthesized_expression,
  [18056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [18064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [18072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    STATE(204), 1,
      sym_switch_block,
  [18082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_DOT,
    ACTIONS(2490), 1,
      anon_sym_SEMI,
  [18092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    STATE(559), 1,
      sym_formal_parameters,
  [18102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 1,
      anon_sym_LBRACE,
    STATE(360), 1,
      sym_constructor_body,
  [18112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(194), 1,
      sym_block,
  [18122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [18130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [18138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(111), 1,
      sym_class_body,
  [18148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    STATE(558), 1,
      sym_formal_parameters,
  [18158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_LBRACE,
    STATE(54), 1,
      sym_block,
  [18168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2494), 1,
      anon_sym_SEMI,
  [18178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2496), 1,
      anon_sym_SEMI,
  [18188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [18196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      anon_sym_DOT,
    ACTIONS(2500), 1,
      anon_sym_SEMI,
  [18206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_LPAREN,
    STATE(815), 1,
      sym_parenthesized_expression,
  [18216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [18224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [18232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2504), 1,
      anon_sym_SEMI,
  [18242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    STATE(103), 1,
      sym_annotation_type_body,
  [18252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_LPAREN,
    STATE(15), 1,
      sym_parenthesized_expression,
  [18262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(326), 1,
      sym_argument_list,
  [18272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [18280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(293), 1,
      sym_argument_list,
  [18290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2510), 1,
      anon_sym_SEMI,
  [18300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 2,
      sym_this,
      sym_super,
  [18308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [18316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 1,
      sym_identifier,
    STATE(872), 1,
      sym_element_value_pair,
  [18326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2161), 1,
      anon_sym_DOT,
  [18336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(952), 1,
      sym_argument_list,
  [18346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      sym_identifier,
    ACTIONS(2520), 1,
      anon_sym_SEMI,
  [18356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [18364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [18372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [18380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(1953), 1,
      anon_sym_SEMI,
  [18390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2526), 1,
      anon_sym_with,
  [18400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [18408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 1,
      sym_identifier,
    ACTIONS(2532), 1,
      anon_sym_SEMI,
  [18418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(902), 1,
      sym_argument_list,
  [18428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2534), 1,
      anon_sym_with,
  [18438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(77), 1,
      sym_interface_body,
  [18448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [18456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [18464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_enum_body,
  [18474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 1,
      anon_sym_LBRACE,
    STATE(330), 1,
      sym_array_initializer,
  [18484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(75), 1,
      sym_class_body,
  [18494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_LBRACE,
    STATE(64), 1,
      sym_block,
  [18504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_LPAREN,
    STATE(28), 1,
      sym_parenthesized_expression,
  [18514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(91), 1,
      sym_class_body,
  [18524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [18532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(288), 1,
      sym_argument_list,
  [18542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      anon_sym_DOT,
    ACTIONS(2542), 1,
      anon_sym_SEMI,
  [18552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(325), 1,
      sym_argument_list,
  [18562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(86), 1,
      sym_class_body,
  [18572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(323), 1,
      sym_argument_list,
  [18582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(82), 1,
      sym_interface_body,
  [18592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LPAREN,
    STATE(324), 1,
      sym_argument_list,
  [18602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(90), 1,
      sym_class_body,
  [18612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [18620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    STATE(106), 1,
      sym_enum_body,
  [18630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    STATE(94), 1,
      sym_annotation_type_body,
  [18640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_SEMI,
  [18650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_DOT,
    ACTIONS(2546), 1,
      anon_sym_SEMI,
  [18660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_DOT,
    ACTIONS(2024), 1,
      anon_sym_SEMI,
  [18670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_LBRACE,
    STATE(72), 1,
      sym_interface_body,
  [18680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(108), 1,
      sym_class_body,
  [18690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(110), 1,
      sym_class_body,
  [18700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 2,
      anon_sym_new,
      sym_identifier,
  [18708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [18716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_DOT,
    ACTIONS(1945), 1,
      anon_sym_SEMI,
  [18726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DASH_GT,
  [18733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      anon_sym_RPAREN,
  [18740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SEMI,
  [18747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      ts_builtin_sym_end,
  [18754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      sym_identifier,
  [18761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 1,
      anon_sym_SEMI,
  [18768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2122), 1,
      anon_sym_RBRACE,
  [18775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_SEMI,
  [18782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_SEMI,
  [18789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      anon_sym_SEMI,
  [18796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1825), 1,
      anon_sym_RBRACE,
  [18803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 1,
      sym_identifier,
  [18810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      sym_identifier,
  [18817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
  [18824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_SEMI,
  [18831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      anon_sym_RPAREN,
  [18838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      anon_sym_EQ,
  [18845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_DOT,
  [18852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym_SEMI,
  [18859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      anon_sym_LBRACE,
  [18866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_SEMI,
  [18873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_EQ,
  [18880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      sym_identifier,
  [18887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_SEMI,
  [18894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
  [18901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym_identifier,
  [18908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      sym_identifier,
  [18915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_SEMI,
  [18922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 1,
      anon_sym_EQ,
  [18929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(596), 1,
      anon_sym_RBRACK,
  [18936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_SEMI,
  [18943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_SEMI,
  [18950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      sym_identifier,
  [18957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 1,
      anon_sym_COLON_COLON,
  [18964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 1,
      anon_sym_RBRACK,
  [18971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_class,
  [18978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
  [18985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 1,
      anon_sym_RBRACE,
  [18992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_LBRACE,
  [18999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_SEMI,
  [19006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_RPAREN,
  [19013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_SEMI,
  [19020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2618), 1,
      anon_sym_SEMI,
  [19027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 1,
      anon_sym_LBRACE,
  [19034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_module,
  [19041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      sym_identifier,
  [19048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2626), 1,
      anon_sym_SEMI,
  [19055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_SEMI,
  [19062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_SEMI,
  [19069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
  [19076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2634), 1,
      sym_this,
  [19083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 1,
      anon_sym_RBRACE,
  [19090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_RBRACK,
  [19097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym_SEMI,
  [19104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2638), 1,
      sym_identifier,
  [19111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_DASH_GT,
  [19118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 1,
      sym_identifier,
  [19125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_RBRACE,
  [19132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 1,
      sym_identifier,
  [19139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2642), 1,
      sym_identifier,
  [19146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      sym_identifier,
  [19153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      sym_identifier,
  [19160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_SEMI,
  [19167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_SEMI,
  [19174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(808), 1,
      anon_sym_RBRACK,
  [19181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_DOT,
  [19188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 1,
      anon_sym_RPAREN,
  [19195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_SEMI,
  [19202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 1,
      anon_sym_SEMI,
  [19209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_RPAREN,
  [19216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2660), 1,
      anon_sym_LBRACE,
  [19223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2662), 1,
      anon_sym_while,
  [19230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 1,
      anon_sym_RBRACE,
  [19237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2666), 1,
      sym_this,
  [19244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_SEMI,
  [19251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_DASH_GT,
  [19258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      anon_sym_SEMI,
  [19265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_LPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(245)] = 0,
  [SMALL_STATE(246)] = 109,
  [SMALL_STATE(247)] = 218,
  [SMALL_STATE(248)] = 327,
  [SMALL_STATE(249)] = 436,
  [SMALL_STATE(250)] = 545,
  [SMALL_STATE(251)] = 627,
  [SMALL_STATE(252)] = 716,
  [SMALL_STATE(253)] = 814,
  [SMALL_STATE(254)] = 912,
  [SMALL_STATE(255)] = 1010,
  [SMALL_STATE(256)] = 1090,
  [SMALL_STATE(257)] = 1152,
  [SMALL_STATE(258)] = 1210,
  [SMALL_STATE(259)] = 1268,
  [SMALL_STATE(260)] = 1326,
  [SMALL_STATE(261)] = 1384,
  [SMALL_STATE(262)] = 1451,
  [SMALL_STATE(263)] = 1533,
  [SMALL_STATE(264)] = 1585,
  [SMALL_STATE(265)] = 1667,
  [SMALL_STATE(266)] = 1749,
  [SMALL_STATE(267)] = 1801,
  [SMALL_STATE(268)] = 1873,
  [SMALL_STATE(269)] = 1925,
  [SMALL_STATE(270)] = 1981,
  [SMALL_STATE(271)] = 2041,
  [SMALL_STATE(272)] = 2102,
  [SMALL_STATE(273)] = 2163,
  [SMALL_STATE(274)] = 2240,
  [SMALL_STATE(275)] = 2295,
  [SMALL_STATE(276)] = 2349,
  [SMALL_STATE(277)] = 2395,
  [SMALL_STATE(278)] = 2441,
  [SMALL_STATE(279)] = 2495,
  [SMALL_STATE(280)] = 2564,
  [SMALL_STATE(281)] = 2619,
  [SMALL_STATE(282)] = 2674,
  [SMALL_STATE(283)] = 2740,
  [SMALL_STATE(284)] = 2808,
  [SMALL_STATE(285)] = 2851,
  [SMALL_STATE(286)] = 2900,
  [SMALL_STATE(287)] = 2949,
  [SMALL_STATE(288)] = 2992,
  [SMALL_STATE(289)] = 3038,
  [SMALL_STATE(290)] = 3080,
  [SMALL_STATE(291)] = 3128,
  [SMALL_STATE(292)] = 3174,
  [SMALL_STATE(293)] = 3220,
  [SMALL_STATE(294)] = 3266,
  [SMALL_STATE(295)] = 3314,
  [SMALL_STATE(296)] = 3356,
  [SMALL_STATE(297)] = 3397,
  [SMALL_STATE(298)] = 3444,
  [SMALL_STATE(299)] = 3485,
  [SMALL_STATE(300)] = 3526,
  [SMALL_STATE(301)] = 3567,
  [SMALL_STATE(302)] = 3608,
  [SMALL_STATE(303)] = 3649,
  [SMALL_STATE(304)] = 3696,
  [SMALL_STATE(305)] = 3737,
  [SMALL_STATE(306)] = 3777,
  [SMALL_STATE(307)] = 3817,
  [SMALL_STATE(308)] = 3857,
  [SMALL_STATE(309)] = 3897,
  [SMALL_STATE(310)] = 3943,
  [SMALL_STATE(311)] = 3983,
  [SMALL_STATE(312)] = 4029,
  [SMALL_STATE(313)] = 4069,
  [SMALL_STATE(314)] = 4109,
  [SMALL_STATE(315)] = 4149,
  [SMALL_STATE(316)] = 4189,
  [SMALL_STATE(317)] = 4229,
  [SMALL_STATE(318)] = 4269,
  [SMALL_STATE(319)] = 4309,
  [SMALL_STATE(320)] = 4349,
  [SMALL_STATE(321)] = 4389,
  [SMALL_STATE(322)] = 4435,
  [SMALL_STATE(323)] = 4475,
  [SMALL_STATE(324)] = 4515,
  [SMALL_STATE(325)] = 4555,
  [SMALL_STATE(326)] = 4595,
  [SMALL_STATE(327)] = 4635,
  [SMALL_STATE(328)] = 4675,
  [SMALL_STATE(329)] = 4715,
  [SMALL_STATE(330)] = 4755,
  [SMALL_STATE(331)] = 4795,
  [SMALL_STATE(332)] = 4835,
  [SMALL_STATE(333)] = 4875,
  [SMALL_STATE(334)] = 4915,
  [SMALL_STATE(335)] = 4955,
  [SMALL_STATE(336)] = 4995,
  [SMALL_STATE(337)] = 5035,
  [SMALL_STATE(338)] = 5077,
  [SMALL_STATE(339)] = 5117,
  [SMALL_STATE(340)] = 5157,
  [SMALL_STATE(341)] = 5197,
  [SMALL_STATE(342)] = 5237,
  [SMALL_STATE(343)] = 5277,
  [SMALL_STATE(344)] = 5317,
  [SMALL_STATE(345)] = 5357,
  [SMALL_STATE(346)] = 5397,
  [SMALL_STATE(347)] = 5437,
  [SMALL_STATE(348)] = 5477,
  [SMALL_STATE(349)] = 5517,
  [SMALL_STATE(350)] = 5557,
  [SMALL_STATE(351)] = 5597,
  [SMALL_STATE(352)] = 5637,
  [SMALL_STATE(353)] = 5676,
  [SMALL_STATE(354)] = 5715,
  [SMALL_STATE(355)] = 5754,
  [SMALL_STATE(356)] = 5793,
  [SMALL_STATE(357)] = 5832,
  [SMALL_STATE(358)] = 5871,
  [SMALL_STATE(359)] = 5910,
  [SMALL_STATE(360)] = 5949,
  [SMALL_STATE(361)] = 5988,
  [SMALL_STATE(362)] = 6027,
  [SMALL_STATE(363)] = 6066,
  [SMALL_STATE(364)] = 6105,
  [SMALL_STATE(365)] = 6144,
  [SMALL_STATE(366)] = 6183,
  [SMALL_STATE(367)] = 6222,
  [SMALL_STATE(368)] = 6261,
  [SMALL_STATE(369)] = 6300,
  [SMALL_STATE(370)] = 6339,
  [SMALL_STATE(371)] = 6378,
  [SMALL_STATE(372)] = 6417,
  [SMALL_STATE(373)] = 6456,
  [SMALL_STATE(374)] = 6495,
  [SMALL_STATE(375)] = 6534,
  [SMALL_STATE(376)] = 6572,
  [SMALL_STATE(377)] = 6610,
  [SMALL_STATE(378)] = 6652,
  [SMALL_STATE(379)] = 6694,
  [SMALL_STATE(380)] = 6733,
  [SMALL_STATE(381)] = 6770,
  [SMALL_STATE(382)] = 6811,
  [SMALL_STATE(383)] = 6848,
  [SMALL_STATE(384)] = 6885,
  [SMALL_STATE(385)] = 6944,
  [SMALL_STATE(386)] = 6981,
  [SMALL_STATE(387)] = 7018,
  [SMALL_STATE(388)] = 7055,
  [SMALL_STATE(389)] = 7094,
  [SMALL_STATE(390)] = 7143,
  [SMALL_STATE(391)] = 7180,
  [SMALL_STATE(392)] = 7221,
  [SMALL_STATE(393)] = 7280,
  [SMALL_STATE(394)] = 7317,
  [SMALL_STATE(395)] = 7372,
  [SMALL_STATE(396)] = 7415,
  [SMALL_STATE(397)] = 7466,
  [SMALL_STATE(398)] = 7525,
  [SMALL_STATE(399)] = 7562,
  [SMALL_STATE(400)] = 7599,
  [SMALL_STATE(401)] = 7658,
  [SMALL_STATE(402)] = 7695,
  [SMALL_STATE(403)] = 7734,
  [SMALL_STATE(404)] = 7772,
  [SMALL_STATE(405)] = 7811,
  [SMALL_STATE(406)] = 7846,
  [SMALL_STATE(407)] = 7881,
  [SMALL_STATE(408)] = 7916,
  [SMALL_STATE(409)] = 7951,
  [SMALL_STATE(410)] = 7986,
  [SMALL_STATE(411)] = 8043,
  [SMALL_STATE(412)] = 8078,
  [SMALL_STATE(413)] = 8119,
  [SMALL_STATE(414)] = 8154,
  [SMALL_STATE(415)] = 8189,
  [SMALL_STATE(416)] = 8228,
  [SMALL_STATE(417)] = 8286,
  [SMALL_STATE(418)] = 8346,
  [SMALL_STATE(419)] = 8388,
  [SMALL_STATE(420)] = 8448,
  [SMALL_STATE(421)] = 8506,
  [SMALL_STATE(422)] = 8566,
  [SMALL_STATE(423)] = 8626,
  [SMALL_STATE(424)] = 8682,
  [SMALL_STATE(425)] = 8742,
  [SMALL_STATE(426)] = 8802,
  [SMALL_STATE(427)] = 8862,
  [SMALL_STATE(428)] = 8904,
  [SMALL_STATE(429)] = 8964,
  [SMALL_STATE(430)] = 9024,
  [SMALL_STATE(431)] = 9084,
  [SMALL_STATE(432)] = 9144,
  [SMALL_STATE(433)] = 9199,
  [SMALL_STATE(434)] = 9254,
  [SMALL_STATE(435)] = 9309,
  [SMALL_STATE(436)] = 9364,
  [SMALL_STATE(437)] = 9419,
  [SMALL_STATE(438)] = 9474,
  [SMALL_STATE(439)] = 9531,
  [SMALL_STATE(440)] = 9586,
  [SMALL_STATE(441)] = 9641,
  [SMALL_STATE(442)] = 9695,
  [SMALL_STATE(443)] = 9749,
  [SMALL_STATE(444)] = 9797,
  [SMALL_STATE(445)] = 9851,
  [SMALL_STATE(446)] = 9905,
  [SMALL_STATE(447)] = 9959,
  [SMALL_STATE(448)] = 9991,
  [SMALL_STATE(449)] = 10051,
  [SMALL_STATE(450)] = 10083,
  [SMALL_STATE(451)] = 10137,
  [SMALL_STATE(452)] = 10191,
  [SMALL_STATE(453)] = 10223,
  [SMALL_STATE(454)] = 10277,
  [SMALL_STATE(455)] = 10331,
  [SMALL_STATE(456)] = 10385,
  [SMALL_STATE(457)] = 10439,
  [SMALL_STATE(458)] = 10493,
  [SMALL_STATE(459)] = 10547,
  [SMALL_STATE(460)] = 10601,
  [SMALL_STATE(461)] = 10655,
  [SMALL_STATE(462)] = 10709,
  [SMALL_STATE(463)] = 10763,
  [SMALL_STATE(464)] = 10817,
  [SMALL_STATE(465)] = 10871,
  [SMALL_STATE(466)] = 10903,
  [SMALL_STATE(467)] = 10954,
  [SMALL_STATE(468)] = 10999,
  [SMALL_STATE(469)] = 11032,
  [SMALL_STATE(470)] = 11083,
  [SMALL_STATE(471)] = 11140,
  [SMALL_STATE(472)] = 11191,
  [SMALL_STATE(473)] = 11242,
  [SMALL_STATE(474)] = 11293,
  [SMALL_STATE(475)] = 11344,
  [SMALL_STATE(476)] = 11389,
  [SMALL_STATE(477)] = 11440,
  [SMALL_STATE(478)] = 11491,
  [SMALL_STATE(479)] = 11539,
  [SMALL_STATE(480)] = 11584,
  [SMALL_STATE(481)] = 11629,
  [SMALL_STATE(482)] = 11658,
  [SMALL_STATE(483)] = 11687,
  [SMALL_STATE(484)] = 11732,
  [SMALL_STATE(485)] = 11777,
  [SMALL_STATE(486)] = 11822,
  [SMALL_STATE(487)] = 11867,
  [SMALL_STATE(488)] = 11912,
  [SMALL_STATE(489)] = 11944,
  [SMALL_STATE(490)] = 11992,
  [SMALL_STATE(491)] = 12028,
  [SMALL_STATE(492)] = 12061,
  [SMALL_STATE(493)] = 12088,
  [SMALL_STATE(494)] = 12121,
  [SMALL_STATE(495)] = 12148,
  [SMALL_STATE(496)] = 12175,
  [SMALL_STATE(497)] = 12202,
  [SMALL_STATE(498)] = 12247,
  [SMALL_STATE(499)] = 12273,
  [SMALL_STATE(500)] = 12299,
  [SMALL_STATE(501)] = 12325,
  [SMALL_STATE(502)] = 12351,
  [SMALL_STATE(503)] = 12397,
  [SMALL_STATE(504)] = 12422,
  [SMALL_STATE(505)] = 12461,
  [SMALL_STATE(506)] = 12488,
  [SMALL_STATE(507)] = 12513,
  [SMALL_STATE(508)] = 12549,
  [SMALL_STATE(509)] = 12581,
  [SMALL_STATE(510)] = 12625,
  [SMALL_STATE(511)] = 12663,
  [SMALL_STATE(512)] = 12701,
  [SMALL_STATE(513)] = 12737,
  [SMALL_STATE(514)] = 12781,
  [SMALL_STATE(515)] = 12817,
  [SMALL_STATE(516)] = 12855,
  [SMALL_STATE(517)] = 12891,
  [SMALL_STATE(518)] = 12932,
  [SMALL_STATE(519)] = 12973,
  [SMALL_STATE(520)] = 13014,
  [SMALL_STATE(521)] = 13055,
  [SMALL_STATE(522)] = 13080,
  [SMALL_STATE(523)] = 13121,
  [SMALL_STATE(524)] = 13152,
  [SMALL_STATE(525)] = 13193,
  [SMALL_STATE(526)] = 13234,
  [SMALL_STATE(527)] = 13275,
  [SMALL_STATE(528)] = 13297,
  [SMALL_STATE(529)] = 13335,
  [SMALL_STATE(530)] = 13373,
  [SMALL_STATE(531)] = 13411,
  [SMALL_STATE(532)] = 13443,
  [SMALL_STATE(533)] = 13481,
  [SMALL_STATE(534)] = 13519,
  [SMALL_STATE(535)] = 13557,
  [SMALL_STATE(536)] = 13579,
  [SMALL_STATE(537)] = 13606,
  [SMALL_STATE(538)] = 13641,
  [SMALL_STATE(539)] = 13674,
  [SMALL_STATE(540)] = 13709,
  [SMALL_STATE(541)] = 13742,
  [SMALL_STATE(542)] = 13777,
  [SMALL_STATE(543)] = 13812,
  [SMALL_STATE(544)] = 13841,
  [SMALL_STATE(545)] = 13874,
  [SMALL_STATE(546)] = 13907,
  [SMALL_STATE(547)] = 13942,
  [SMALL_STATE(548)] = 13971,
  [SMALL_STATE(549)] = 14003,
  [SMALL_STATE(550)] = 14035,
  [SMALL_STATE(551)] = 14067,
  [SMALL_STATE(552)] = 14097,
  [SMALL_STATE(553)] = 14127,
  [SMALL_STATE(554)] = 14159,
  [SMALL_STATE(555)] = 14189,
  [SMALL_STATE(556)] = 14219,
  [SMALL_STATE(557)] = 14249,
  [SMALL_STATE(558)] = 14281,
  [SMALL_STATE(559)] = 14308,
  [SMALL_STATE(560)] = 14335,
  [SMALL_STATE(561)] = 14356,
  [SMALL_STATE(562)] = 14387,
  [SMALL_STATE(563)] = 14418,
  [SMALL_STATE(564)] = 14447,
  [SMALL_STATE(565)] = 14475,
  [SMALL_STATE(566)] = 14503,
  [SMALL_STATE(567)] = 14531,
  [SMALL_STATE(568)] = 14559,
  [SMALL_STATE(569)] = 14588,
  [SMALL_STATE(570)] = 14617,
  [SMALL_STATE(571)] = 14646,
  [SMALL_STATE(572)] = 14675,
  [SMALL_STATE(573)] = 14697,
  [SMALL_STATE(574)] = 14721,
  [SMALL_STATE(575)] = 14735,
  [SMALL_STATE(576)] = 14757,
  [SMALL_STATE(577)] = 14781,
  [SMALL_STATE(578)] = 14805,
  [SMALL_STATE(579)] = 14833,
  [SMALL_STATE(580)] = 14861,
  [SMALL_STATE(581)] = 14878,
  [SMALL_STATE(582)] = 14901,
  [SMALL_STATE(583)] = 14924,
  [SMALL_STATE(584)] = 14945,
  [SMALL_STATE(585)] = 14964,
  [SMALL_STATE(586)] = 14985,
  [SMALL_STATE(587)] = 15008,
  [SMALL_STATE(588)] = 15027,
  [SMALL_STATE(589)] = 15043,
  [SMALL_STATE(590)] = 15055,
  [SMALL_STATE(591)] = 15071,
  [SMALL_STATE(592)] = 15087,
  [SMALL_STATE(593)] = 15103,
  [SMALL_STATE(594)] = 15119,
  [SMALL_STATE(595)] = 15135,
  [SMALL_STATE(596)] = 15151,
  [SMALL_STATE(597)] = 15163,
  [SMALL_STATE(598)] = 15183,
  [SMALL_STATE(599)] = 15205,
  [SMALL_STATE(600)] = 15217,
  [SMALL_STATE(601)] = 15229,
  [SMALL_STATE(602)] = 15251,
  [SMALL_STATE(603)] = 15263,
  [SMALL_STATE(604)] = 15275,
  [SMALL_STATE(605)] = 15291,
  [SMALL_STATE(606)] = 15307,
  [SMALL_STATE(607)] = 15329,
  [SMALL_STATE(608)] = 15341,
  [SMALL_STATE(609)] = 15353,
  [SMALL_STATE(610)] = 15369,
  [SMALL_STATE(611)] = 15381,
  [SMALL_STATE(612)] = 15393,
  [SMALL_STATE(613)] = 15405,
  [SMALL_STATE(614)] = 15417,
  [SMALL_STATE(615)] = 15429,
  [SMALL_STATE(616)] = 15441,
  [SMALL_STATE(617)] = 15457,
  [SMALL_STATE(618)] = 15473,
  [SMALL_STATE(619)] = 15485,
  [SMALL_STATE(620)] = 15501,
  [SMALL_STATE(621)] = 15523,
  [SMALL_STATE(622)] = 15535,
  [SMALL_STATE(623)] = 15547,
  [SMALL_STATE(624)] = 15559,
  [SMALL_STATE(625)] = 15571,
  [SMALL_STATE(626)] = 15583,
  [SMALL_STATE(627)] = 15599,
  [SMALL_STATE(628)] = 15610,
  [SMALL_STATE(629)] = 15627,
  [SMALL_STATE(630)] = 15638,
  [SMALL_STATE(631)] = 15657,
  [SMALL_STATE(632)] = 15672,
  [SMALL_STATE(633)] = 15689,
  [SMALL_STATE(634)] = 15700,
  [SMALL_STATE(635)] = 15719,
  [SMALL_STATE(636)] = 15734,
  [SMALL_STATE(637)] = 15753,
  [SMALL_STATE(638)] = 15768,
  [SMALL_STATE(639)] = 15785,
  [SMALL_STATE(640)] = 15804,
  [SMALL_STATE(641)] = 15817,
  [SMALL_STATE(642)] = 15836,
  [SMALL_STATE(643)] = 15851,
  [SMALL_STATE(644)] = 15866,
  [SMALL_STATE(645)] = 15881,
  [SMALL_STATE(646)] = 15900,
  [SMALL_STATE(647)] = 15917,
  [SMALL_STATE(648)] = 15932,
  [SMALL_STATE(649)] = 15949,
  [SMALL_STATE(650)] = 15963,
  [SMALL_STATE(651)] = 15977,
  [SMALL_STATE(652)] = 15993,
  [SMALL_STATE(653)] = 16007,
  [SMALL_STATE(654)] = 16023,
  [SMALL_STATE(655)] = 16037,
  [SMALL_STATE(656)] = 16051,
  [SMALL_STATE(657)] = 16065,
  [SMALL_STATE(658)] = 16081,
  [SMALL_STATE(659)] = 16097,
  [SMALL_STATE(660)] = 16113,
  [SMALL_STATE(661)] = 16129,
  [SMALL_STATE(662)] = 16143,
  [SMALL_STATE(663)] = 16157,
  [SMALL_STATE(664)] = 16167,
  [SMALL_STATE(665)] = 16181,
  [SMALL_STATE(666)] = 16195,
  [SMALL_STATE(667)] = 16209,
  [SMALL_STATE(668)] = 16225,
  [SMALL_STATE(669)] = 16239,
  [SMALL_STATE(670)] = 16255,
  [SMALL_STATE(671)] = 16269,
  [SMALL_STATE(672)] = 16283,
  [SMALL_STATE(673)] = 16297,
  [SMALL_STATE(674)] = 16313,
  [SMALL_STATE(675)] = 16327,
  [SMALL_STATE(676)] = 16343,
  [SMALL_STATE(677)] = 16357,
  [SMALL_STATE(678)] = 16369,
  [SMALL_STATE(679)] = 16385,
  [SMALL_STATE(680)] = 16395,
  [SMALL_STATE(681)] = 16405,
  [SMALL_STATE(682)] = 16421,
  [SMALL_STATE(683)] = 16435,
  [SMALL_STATE(684)] = 16449,
  [SMALL_STATE(685)] = 16459,
  [SMALL_STATE(686)] = 16473,
  [SMALL_STATE(687)] = 16487,
  [SMALL_STATE(688)] = 16501,
  [SMALL_STATE(689)] = 16517,
  [SMALL_STATE(690)] = 16533,
  [SMALL_STATE(691)] = 16547,
  [SMALL_STATE(692)] = 16563,
  [SMALL_STATE(693)] = 16577,
  [SMALL_STATE(694)] = 16593,
  [SMALL_STATE(695)] = 16607,
  [SMALL_STATE(696)] = 16623,
  [SMALL_STATE(697)] = 16639,
  [SMALL_STATE(698)] = 16655,
  [SMALL_STATE(699)] = 16669,
  [SMALL_STATE(700)] = 16685,
  [SMALL_STATE(701)] = 16699,
  [SMALL_STATE(702)] = 16715,
  [SMALL_STATE(703)] = 16729,
  [SMALL_STATE(704)] = 16743,
  [SMALL_STATE(705)] = 16757,
  [SMALL_STATE(706)] = 16771,
  [SMALL_STATE(707)] = 16780,
  [SMALL_STATE(708)] = 16793,
  [SMALL_STATE(709)] = 16806,
  [SMALL_STATE(710)] = 16819,
  [SMALL_STATE(711)] = 16832,
  [SMALL_STATE(712)] = 16841,
  [SMALL_STATE(713)] = 16850,
  [SMALL_STATE(714)] = 16863,
  [SMALL_STATE(715)] = 16874,
  [SMALL_STATE(716)] = 16883,
  [SMALL_STATE(717)] = 16896,
  [SMALL_STATE(718)] = 16909,
  [SMALL_STATE(719)] = 16920,
  [SMALL_STATE(720)] = 16933,
  [SMALL_STATE(721)] = 16946,
  [SMALL_STATE(722)] = 16959,
  [SMALL_STATE(723)] = 16972,
  [SMALL_STATE(724)] = 16985,
  [SMALL_STATE(725)] = 16998,
  [SMALL_STATE(726)] = 17011,
  [SMALL_STATE(727)] = 17024,
  [SMALL_STATE(728)] = 17037,
  [SMALL_STATE(729)] = 17050,
  [SMALL_STATE(730)] = 17063,
  [SMALL_STATE(731)] = 17076,
  [SMALL_STATE(732)] = 17089,
  [SMALL_STATE(733)] = 17102,
  [SMALL_STATE(734)] = 17115,
  [SMALL_STATE(735)] = 17128,
  [SMALL_STATE(736)] = 17141,
  [SMALL_STATE(737)] = 17154,
  [SMALL_STATE(738)] = 17163,
  [SMALL_STATE(739)] = 17176,
  [SMALL_STATE(740)] = 17189,
  [SMALL_STATE(741)] = 17202,
  [SMALL_STATE(742)] = 17215,
  [SMALL_STATE(743)] = 17228,
  [SMALL_STATE(744)] = 17241,
  [SMALL_STATE(745)] = 17254,
  [SMALL_STATE(746)] = 17267,
  [SMALL_STATE(747)] = 17276,
  [SMALL_STATE(748)] = 17285,
  [SMALL_STATE(749)] = 17298,
  [SMALL_STATE(750)] = 17311,
  [SMALL_STATE(751)] = 17324,
  [SMALL_STATE(752)] = 17337,
  [SMALL_STATE(753)] = 17350,
  [SMALL_STATE(754)] = 17363,
  [SMALL_STATE(755)] = 17376,
  [SMALL_STATE(756)] = 17389,
  [SMALL_STATE(757)] = 17402,
  [SMALL_STATE(758)] = 17415,
  [SMALL_STATE(759)] = 17428,
  [SMALL_STATE(760)] = 17441,
  [SMALL_STATE(761)] = 17454,
  [SMALL_STATE(762)] = 17467,
  [SMALL_STATE(763)] = 17480,
  [SMALL_STATE(764)] = 17493,
  [SMALL_STATE(765)] = 17506,
  [SMALL_STATE(766)] = 17519,
  [SMALL_STATE(767)] = 17532,
  [SMALL_STATE(768)] = 17545,
  [SMALL_STATE(769)] = 17558,
  [SMALL_STATE(770)] = 17571,
  [SMALL_STATE(771)] = 17580,
  [SMALL_STATE(772)] = 17593,
  [SMALL_STATE(773)] = 17606,
  [SMALL_STATE(774)] = 17619,
  [SMALL_STATE(775)] = 17632,
  [SMALL_STATE(776)] = 17645,
  [SMALL_STATE(777)] = 17658,
  [SMALL_STATE(778)] = 17671,
  [SMALL_STATE(779)] = 17684,
  [SMALL_STATE(780)] = 17697,
  [SMALL_STATE(781)] = 17708,
  [SMALL_STATE(782)] = 17719,
  [SMALL_STATE(783)] = 17732,
  [SMALL_STATE(784)] = 17745,
  [SMALL_STATE(785)] = 17758,
  [SMALL_STATE(786)] = 17771,
  [SMALL_STATE(787)] = 17784,
  [SMALL_STATE(788)] = 17797,
  [SMALL_STATE(789)] = 17810,
  [SMALL_STATE(790)] = 17823,
  [SMALL_STATE(791)] = 17836,
  [SMALL_STATE(792)] = 17849,
  [SMALL_STATE(793)] = 17858,
  [SMALL_STATE(794)] = 17871,
  [SMALL_STATE(795)] = 17884,
  [SMALL_STATE(796)] = 17893,
  [SMALL_STATE(797)] = 17906,
  [SMALL_STATE(798)] = 17919,
  [SMALL_STATE(799)] = 17932,
  [SMALL_STATE(800)] = 17942,
  [SMALL_STATE(801)] = 17952,
  [SMALL_STATE(802)] = 17960,
  [SMALL_STATE(803)] = 17968,
  [SMALL_STATE(804)] = 17978,
  [SMALL_STATE(805)] = 17986,
  [SMALL_STATE(806)] = 17996,
  [SMALL_STATE(807)] = 18004,
  [SMALL_STATE(808)] = 18012,
  [SMALL_STATE(809)] = 18020,
  [SMALL_STATE(810)] = 18028,
  [SMALL_STATE(811)] = 18036,
  [SMALL_STATE(812)] = 18046,
  [SMALL_STATE(813)] = 18056,
  [SMALL_STATE(814)] = 18064,
  [SMALL_STATE(815)] = 18072,
  [SMALL_STATE(816)] = 18082,
  [SMALL_STATE(817)] = 18092,
  [SMALL_STATE(818)] = 18102,
  [SMALL_STATE(819)] = 18112,
  [SMALL_STATE(820)] = 18122,
  [SMALL_STATE(821)] = 18130,
  [SMALL_STATE(822)] = 18138,
  [SMALL_STATE(823)] = 18148,
  [SMALL_STATE(824)] = 18158,
  [SMALL_STATE(825)] = 18168,
  [SMALL_STATE(826)] = 18178,
  [SMALL_STATE(827)] = 18188,
  [SMALL_STATE(828)] = 18196,
  [SMALL_STATE(829)] = 18206,
  [SMALL_STATE(830)] = 18216,
  [SMALL_STATE(831)] = 18224,
  [SMALL_STATE(832)] = 18232,
  [SMALL_STATE(833)] = 18242,
  [SMALL_STATE(834)] = 18252,
  [SMALL_STATE(835)] = 18262,
  [SMALL_STATE(836)] = 18272,
  [SMALL_STATE(837)] = 18280,
  [SMALL_STATE(838)] = 18290,
  [SMALL_STATE(839)] = 18300,
  [SMALL_STATE(840)] = 18308,
  [SMALL_STATE(841)] = 18316,
  [SMALL_STATE(842)] = 18326,
  [SMALL_STATE(843)] = 18336,
  [SMALL_STATE(844)] = 18346,
  [SMALL_STATE(845)] = 18356,
  [SMALL_STATE(846)] = 18364,
  [SMALL_STATE(847)] = 18372,
  [SMALL_STATE(848)] = 18380,
  [SMALL_STATE(849)] = 18390,
  [SMALL_STATE(850)] = 18400,
  [SMALL_STATE(851)] = 18408,
  [SMALL_STATE(852)] = 18418,
  [SMALL_STATE(853)] = 18428,
  [SMALL_STATE(854)] = 18438,
  [SMALL_STATE(855)] = 18448,
  [SMALL_STATE(856)] = 18456,
  [SMALL_STATE(857)] = 18464,
  [SMALL_STATE(858)] = 18474,
  [SMALL_STATE(859)] = 18484,
  [SMALL_STATE(860)] = 18494,
  [SMALL_STATE(861)] = 18504,
  [SMALL_STATE(862)] = 18514,
  [SMALL_STATE(863)] = 18524,
  [SMALL_STATE(864)] = 18532,
  [SMALL_STATE(865)] = 18542,
  [SMALL_STATE(866)] = 18552,
  [SMALL_STATE(867)] = 18562,
  [SMALL_STATE(868)] = 18572,
  [SMALL_STATE(869)] = 18582,
  [SMALL_STATE(870)] = 18592,
  [SMALL_STATE(871)] = 18602,
  [SMALL_STATE(872)] = 18612,
  [SMALL_STATE(873)] = 18620,
  [SMALL_STATE(874)] = 18630,
  [SMALL_STATE(875)] = 18640,
  [SMALL_STATE(876)] = 18650,
  [SMALL_STATE(877)] = 18660,
  [SMALL_STATE(878)] = 18670,
  [SMALL_STATE(879)] = 18680,
  [SMALL_STATE(880)] = 18690,
  [SMALL_STATE(881)] = 18700,
  [SMALL_STATE(882)] = 18708,
  [SMALL_STATE(883)] = 18716,
  [SMALL_STATE(884)] = 18726,
  [SMALL_STATE(885)] = 18733,
  [SMALL_STATE(886)] = 18740,
  [SMALL_STATE(887)] = 18747,
  [SMALL_STATE(888)] = 18754,
  [SMALL_STATE(889)] = 18761,
  [SMALL_STATE(890)] = 18768,
  [SMALL_STATE(891)] = 18775,
  [SMALL_STATE(892)] = 18782,
  [SMALL_STATE(893)] = 18789,
  [SMALL_STATE(894)] = 18796,
  [SMALL_STATE(895)] = 18803,
  [SMALL_STATE(896)] = 18810,
  [SMALL_STATE(897)] = 18817,
  [SMALL_STATE(898)] = 18824,
  [SMALL_STATE(899)] = 18831,
  [SMALL_STATE(900)] = 18838,
  [SMALL_STATE(901)] = 18845,
  [SMALL_STATE(902)] = 18852,
  [SMALL_STATE(903)] = 18859,
  [SMALL_STATE(904)] = 18866,
  [SMALL_STATE(905)] = 18873,
  [SMALL_STATE(906)] = 18880,
  [SMALL_STATE(907)] = 18887,
  [SMALL_STATE(908)] = 18894,
  [SMALL_STATE(909)] = 18901,
  [SMALL_STATE(910)] = 18908,
  [SMALL_STATE(911)] = 18915,
  [SMALL_STATE(912)] = 18922,
  [SMALL_STATE(913)] = 18929,
  [SMALL_STATE(914)] = 18936,
  [SMALL_STATE(915)] = 18943,
  [SMALL_STATE(916)] = 18950,
  [SMALL_STATE(917)] = 18957,
  [SMALL_STATE(918)] = 18964,
  [SMALL_STATE(919)] = 18971,
  [SMALL_STATE(920)] = 18978,
  [SMALL_STATE(921)] = 18985,
  [SMALL_STATE(922)] = 18992,
  [SMALL_STATE(923)] = 18999,
  [SMALL_STATE(924)] = 19006,
  [SMALL_STATE(925)] = 19013,
  [SMALL_STATE(926)] = 19020,
  [SMALL_STATE(927)] = 19027,
  [SMALL_STATE(928)] = 19034,
  [SMALL_STATE(929)] = 19041,
  [SMALL_STATE(930)] = 19048,
  [SMALL_STATE(931)] = 19055,
  [SMALL_STATE(932)] = 19062,
  [SMALL_STATE(933)] = 19069,
  [SMALL_STATE(934)] = 19076,
  [SMALL_STATE(935)] = 19083,
  [SMALL_STATE(936)] = 19090,
  [SMALL_STATE(937)] = 19097,
  [SMALL_STATE(938)] = 19104,
  [SMALL_STATE(939)] = 19111,
  [SMALL_STATE(940)] = 19118,
  [SMALL_STATE(941)] = 19125,
  [SMALL_STATE(942)] = 19132,
  [SMALL_STATE(943)] = 19139,
  [SMALL_STATE(944)] = 19146,
  [SMALL_STATE(945)] = 19153,
  [SMALL_STATE(946)] = 19160,
  [SMALL_STATE(947)] = 19167,
  [SMALL_STATE(948)] = 19174,
  [SMALL_STATE(949)] = 19181,
  [SMALL_STATE(950)] = 19188,
  [SMALL_STATE(951)] = 19195,
  [SMALL_STATE(952)] = 19202,
  [SMALL_STATE(953)] = 19209,
  [SMALL_STATE(954)] = 19216,
  [SMALL_STATE(955)] = 19223,
  [SMALL_STATE(956)] = 19230,
  [SMALL_STATE(957)] = 19237,
  [SMALL_STATE(958)] = 19244,
  [SMALL_STATE(959)] = 19251,
  [SMALL_STATE(960)] = 19258,
  [SMALL_STATE(961)] = 19265,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(255),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(317),
  [101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(317),
  [104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(51),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(209),
  [110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(212),
  [113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(222),
  [116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(510),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(943),
  [122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(124),
  [125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(11),
  [128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(217),
  [133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(829),
  [136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(220),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(403),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(31),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(834),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(844),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(851),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(131),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(381),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(228),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(675),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(861),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(920),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(682),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(270),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(261),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(309),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(685),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(638),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(910),
  [193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(909),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(906),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(500),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(501),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(506),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(316),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(842),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(255),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(317),
  [224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(317),
  [227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(51),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(209),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(212),
  [236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(222),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(510),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(943),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(124),
  [248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(217),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(829),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(309),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(834),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(844),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(851),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(131),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(381),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(228),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(675),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(861),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(920),
  [290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(682),
  [293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(270),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(261),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(685),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(638),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(910),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(909),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(906),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(500),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(501),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(506),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(316),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(842),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 22),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 22),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 23),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 23),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 23),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 23),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(961),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 121),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 121),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 60),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 60),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 6),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 6),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 92),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 92),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 93),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 93),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 90),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 90),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 52),
  [460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 52),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 103),
  [468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 103),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 84),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 84),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 3),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 3),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 3),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 3),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 134),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 134),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 19),
  [496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 19),
  [498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 78),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 78),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 77),
  [504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 77),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 76),
  [508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 76),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 58),
  [512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 58),
  [514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 58),
  [516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 58),
  [518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 58),
  [520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 58),
  [522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 58),
  [524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 58),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 52),
  [528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 52),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 19),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 19),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 112),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 112),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 2),
  [544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 2),
  [546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 19),
  [548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 19),
  [550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 115),
  [552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 115),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 2),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 2),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 54),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 54),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 19),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 19),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 114),
  [568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 114),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 113),
  [576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 113),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 54),
  [580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 54),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 53),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 53),
  [586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 138),
  [588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 138),
  [590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 128),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 128),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 127),
  [606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 127),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 126),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 126),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 123),
  [614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 123),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 39),
  [624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 39),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2),
  [632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 22),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 22),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 148),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 148),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6, .production_id = 59),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6, .production_id = 59),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 129),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 129),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 107),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 107),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 106),
  [692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 106),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 57),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 57),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 58),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 58),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 2),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 2),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, .production_id = 59),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, .production_id = 59),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 136),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 136),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 137),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 137),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3),
  [726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, .production_id = 29),
  [728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, .production_id = 29),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 95),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 95),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 94),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 94),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 139),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 139),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 140),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 140),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 141),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 141),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 142),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 142),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3, .production_id = 29),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3, .production_id = 29),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 19),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 19),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 143),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 143),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 28),
  [772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 28),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 65),
  [776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 65),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4, .production_id = 59),
  [780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4, .production_id = 59),
  [782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4),
  [784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, .production_id = 167),
  [788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, .production_id = 167),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 24),
  [796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 24),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 162),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 162),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 161),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 161),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5),
  [812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, .production_id = 29),
  [816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, .production_id = 29),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 160),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 160),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 3),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 5),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 5),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 154),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 154),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 149),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 149),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 79),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 79),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 150),
  [852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 150),
  [854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_synchronized_statement, 3, .production_id = 21),
  [866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_synchronized_statement, 3, .production_id = 21),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 151),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 151),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 80),
  [874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 80),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 23),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 23),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 152),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 152),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 153),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 153),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 3),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 20),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 20),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 20),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 20),
  [912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_label, 3),
  [914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 3),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_label, 2),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 2),
  [932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 147),
  [934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 147),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 135),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 135),
  [940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 159),
  [942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 159),
  [944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 166),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 166),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 2),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(566),
  [965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(584),
  [968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(943),
  [971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(247),
  [974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(11),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(309),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(682),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(378),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(910),
  [991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(909),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(906),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(500),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(501),
  [1003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(506),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 1),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(420),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1032] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(609),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1041] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(959),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1047] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(609),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(493),
  [1054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(584),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(943),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(252),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(309),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(682),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(910),
  [1074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(909),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(906),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(500),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(501),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(506),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .production_id = 86),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .production_id = 86),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .production_id = 85),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .production_id = 85),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 31),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 31),
  [1121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 30),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 30),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(493),
  [1132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(943),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(309),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(682),
  [1143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(909),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(906),
  [1149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(500),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(501),
  [1155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(506),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 4, .production_id = 64),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 4, .production_id = 64),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 18),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 18),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 16),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 16),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [1184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(207),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(652),
  [1190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions, 1),
  [1192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions, 1),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 56),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 56),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 55),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 55),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(936),
  [1211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(652),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotated_type, 2),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotated_type, 2),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [1238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 15),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 15),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 17),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 17),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 50),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 50),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1),
  [1270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(416),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 4),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 4),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 3),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 3),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [1291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(416),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 111),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 111),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 62),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 62),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 4),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 4),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifiers, 1),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifiers, 1),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 3),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 3),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 2),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 2),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 50),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 50),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, .production_id = 36),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, .production_id = 36),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 5),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 5),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(321),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(682),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 3),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 3),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 133),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 133),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 132),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 132),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 88),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 88),
  [1394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 87),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 87),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 15),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 15),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 61),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 61),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 46),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 46),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 110),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 110),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_literal, 3),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_literal, 3),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 17),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 17),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 4),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 4),
  [1442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 3),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 3),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 69),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 69),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 25),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 25),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 4),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 4),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 34),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 34),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 41),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 41),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 63),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 63),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 2),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 2),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_floating_point_type, 1),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_floating_point_type, 1),
  [1498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 97),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 97),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 75),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 75),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, .production_id = 116),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, .production_id = 116),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 74),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 74),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 101),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 101),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 3),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 3),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 65),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 65),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integral_type, 1),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integral_type, 1),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 4),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 4),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 2),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 2),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 39),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 39),
  [1542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 96),
  [1544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 96),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 98),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 98),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_initializer, 2),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_initializer, 2),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 2, .production_id = 72),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 2, .production_id = 72),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 4, .production_id = 65),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 4, .production_id = 65),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 3, .production_id = 39),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 3, .production_id = 39),
  [1570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 5, .production_id = 70),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 5, .production_id = 70),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 89),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 3, .production_id = 35),
  [1619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 3, .production_id = 35),
  [1621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2),
  [1623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2),
  [1625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 32),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 32),
  [1629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 33),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 27),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 33),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 32),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 163),
  [1643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 163),
  [1645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 155),
  [1647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 155),
  [1649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 146),
  [1651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 146),
  [1653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 157),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 157),
  [1657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 158),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 158),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__element_value, 1),
  [1663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 168),
  [1665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 168),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 165),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 165),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 164),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 164),
  [1677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(415),
  [1680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(652),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 68),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(918),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 5, .production_id = 120),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 124),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 4, .production_id = 104),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 81),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 3),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 3),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [1772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 4),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 4),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 2),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 2),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 5),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 5),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_expr_repeat1, 2),
  [1833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 2),
  [1835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 2), SHIFT_REPEAT(652),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1),
  [1880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [1882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [1892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [1894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [1896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(616),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 1),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [1905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 1),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 10),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 9),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 71),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 102),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2),
  [1979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(572),
  [1982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(650),
  [1985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(698),
  [1988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(702),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_directive_repeat1, 2),
  [2013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_directive_repeat1, 2), SHIFT_REPEAT(627),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [2028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 1, .production_id = 10),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 6),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 5, .production_id = 59),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 6),
  [2060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 6, .production_id = 29),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 6, .production_id = 144),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 4, .production_id = 29),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 4, .production_id = 130),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 4),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 4, .production_id = 59),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 5, .production_id = 130),
  [2084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 5, .production_id = 144),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 3),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 5, .production_id = 29),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 5, .production_id = 145),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 5),
  [2104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 3, .production_id = 29),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 6, .production_id = 145),
  [2108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_modifier, 1),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 38),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 2),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 37),
  [2128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2), SHIFT_REPEAT(516),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 8),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 2),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 26),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 1),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 100),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [2173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2), SHIFT_REPEAT(466),
  [2176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 2, .production_id = 73),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 4),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 2),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 13),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_list_repeat1, 2), SHIFT_REPEAT(473),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_type_list_repeat1, 2),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [2223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 5),
  [2233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 2),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 3),
  [2241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 3),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 117),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 3),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 2),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [2275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(490),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 83),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 109),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 19),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2), SHIFT_REPEAT(938),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type_list, 2),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2), SHIFT_REPEAT(83),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2),
  [2336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2), SHIFT_REPEAT(841),
  [2339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 67), SHIFT_REPEAT(646),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 67),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(230),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 2, .production_id = 40),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 118),
  [2361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 119),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type_list, 1),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [2377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(435),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 125),
  [2382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 125), SHIFT_REPEAT(224),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 1, .production_id = 12),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 82), SHIFT_REPEAT(226),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 82),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2), SHIFT_REPEAT(66),
  [2425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_directive_repeat2, 2, .production_id = 29),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_directive_repeat2, 2),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2),
  [2437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2), SHIFT_REPEAT(241),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [2442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(587),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_directive_repeat2, 2), SHIFT_REPEAT(694),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(282),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 4, .production_id = 131),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 45), SHIFT_REPEAT(476),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 45),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 3, .production_id = 42),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 43),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 3),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 5, .production_id = 117),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 3, .production_id = 99),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 2, .production_id = 71),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 3),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_bounds, 2),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 4),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 100),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 66),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 73),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_pair, 3, .production_id = 108),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 2, .production_id = 14),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2556] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asterisk, 1),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_interfaces, 2),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [2590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 3),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_value, 2, .production_id = 156),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_interfaces, 2),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 2, .production_id = 105),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 5),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 3, .production_id = 122),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 4),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 4),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 3),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_java(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
