#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 237
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 110
#define ALIAS_COUNT 0
#define TOKEN_COUNT 60
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 2
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 2

enum {
  anon_sym_if = 1,
  anon_sym_elif = 2,
  anon_sym_else = 3,
  anon_sym_endif = 4,
  anon_sym_foreach = 5,
  anon_sym_COLON = 6,
  anon_sym_endforeach = 7,
  anon_sym_EQ = 8,
  anon_sym_STAR_EQ = 9,
  anon_sym_SLASH_EQ = 10,
  anon_sym_PERCENT_EQ = 11,
  anon_sym_PLUS_EQ = 12,
  anon_sym_DASH_EQ = 13,
  anon_sym_break = 14,
  anon_sym_continue = 15,
  anon_sym_LPAREN = 16,
  anon_sym_RPAREN = 17,
  anon_sym_COMMA = 18,
  anon_sym_DOT = 19,
  anon_sym_LBRACK = 20,
  anon_sym_RBRACK = 21,
  anon_sym_not = 22,
  anon_sym_BANG = 23,
  anon_sym_DASH = 24,
  anon_sym_and = 25,
  anon_sym_or = 26,
  anon_sym_PLUS = 27,
  anon_sym_STAR = 28,
  anon_sym_SLASH = 29,
  anon_sym_PERCENT = 30,
  anon_sym_EQ_EQ = 31,
  anon_sym_BANG_EQ = 32,
  anon_sym_GT = 33,
  anon_sym_LT = 34,
  anon_sym_GT_EQ = 35,
  anon_sym_LT_EQ = 36,
  anon_sym_in = 37,
  anon_sym_QMARK = 38,
  sym__DECIMAL_NUMBER = 39,
  anon_sym_0o = 40,
  sym__OCTAL_NUMBER = 41,
  anon_sym_0x = 42,
  sym__HEX_NUMBER = 43,
  anon_sym_0b = 44,
  sym__BINARY_NUMBER = 45,
  sym_escape_sequence = 46,
  anon_sym_SQUOTE = 47,
  aux_sym_string_simple_token1 = 48,
  anon_sym_SQUOTE_SQUOTE_SQUOTE = 49,
  aux_sym_string_multiline_token1 = 50,
  anon_sym_SQUOTE_SQUOTE = 51,
  anon_sym_true = 52,
  anon_sym_false = 53,
  anon_sym_LF = 54,
  anon_sym_CR_LF = 55,
  anon_sym_LBRACE = 56,
  anon_sym_RBRACE = 57,
  sym__IDENTIFIER = 58,
  sym_comment = 59,
  sym_source_file = 60,
  sym_build_definition = 61,
  sym_statement = 62,
  sym_selection_statement = 63,
  sym_iteration_statement = 64,
  sym_assignment_statement = 65,
  sym_assignment_operator = 66,
  sym_jump_statement = 67,
  sym_condition = 68,
  sym_expression = 69,
  sym_function_expression = 70,
  sym_argument_list = 71,
  sym_keyword_item = 72,
  sym_key_value_item = 73,
  sym_method_expression = 74,
  sym_subscript_expression = 75,
  sym_unary_expression = 76,
  sym_binary_expression = 77,
  sym_add_operator = 78,
  sym_mult_operator = 79,
  sym_equ_operator = 80,
  sym_rel_operator = 81,
  sym_conditional_expression = 82,
  sym__literal = 83,
  sym_integer_literal = 84,
  sym__decimal_literal = 85,
  sym__octal_literal = 86,
  sym__hex_literal = 87,
  sym__binary_literal = 88,
  sym_string_literal = 89,
  sym_string_simple = 90,
  sym_string_multiline = 91,
  sym_boolean_literal = 92,
  sym_array_literal = 93,
  sym__NEWLINE = 94,
  sym_dictionary_literal = 95,
  sym_identifier_list = 96,
  sym_primary_expression = 97,
  sym_function_id = 98,
  sym_keyword_arg_key = 99,
  sym_id_expression = 100,
  aux_sym_build_definition_repeat1 = 101,
  aux_sym_selection_statement_repeat1 = 102,
  aux_sym_iteration_statement_repeat1 = 103,
  aux_sym_argument_list_repeat1 = 104,
  aux_sym_key_value_list_repeat1 = 105,
  aux_sym_string_simple_repeat1 = 106,
  aux_sym_string_multiline_repeat1 = 107,
  aux_sym_array_literal_repeat1 = 108,
  aux_sym_identifier_list_repeat1 = 109,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_if] = "if",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_endif] = "endif",
  [anon_sym_foreach] = "foreach",
  [anon_sym_COLON] = ":",
  [anon_sym_endforeach] = "endforeach",
  [anon_sym_EQ] = "=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_DASH] = "-",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_in] = "in",
  [anon_sym_QMARK] = "\?",
  [sym__DECIMAL_NUMBER] = "_DECIMAL_NUMBER",
  [anon_sym_0o] = "0o",
  [sym__OCTAL_NUMBER] = "_OCTAL_NUMBER",
  [anon_sym_0x] = "0x",
  [sym__HEX_NUMBER] = "_HEX_NUMBER",
  [anon_sym_0b] = "0b",
  [sym__BINARY_NUMBER] = "_BINARY_NUMBER",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_simple_token1] = "string_simple_token1",
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = "'''",
  [aux_sym_string_multiline_token1] = "string_multiline_token1",
  [anon_sym_SQUOTE_SQUOTE] = "''",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_LF] = "\n",
  [anon_sym_CR_LF] = "\r\n",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym__IDENTIFIER] = "_IDENTIFIER",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym_build_definition] = "build_definition",
  [sym_statement] = "statement",
  [sym_selection_statement] = "selection_statement",
  [sym_iteration_statement] = "iteration_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_assignment_operator] = "assignment_operator",
  [sym_jump_statement] = "jump_statement",
  [sym_condition] = "condition",
  [sym_expression] = "expression",
  [sym_function_expression] = "function_expression",
  [sym_argument_list] = "argument_list",
  [sym_keyword_item] = "keyword_item",
  [sym_key_value_item] = "key_value_item",
  [sym_method_expression] = "method_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_add_operator] = "add_operator",
  [sym_mult_operator] = "mult_operator",
  [sym_equ_operator] = "equ_operator",
  [sym_rel_operator] = "rel_operator",
  [sym_conditional_expression] = "conditional_expression",
  [sym__literal] = "_literal",
  [sym_integer_literal] = "integer_literal",
  [sym__decimal_literal] = "_decimal_literal",
  [sym__octal_literal] = "_octal_literal",
  [sym__hex_literal] = "_hex_literal",
  [sym__binary_literal] = "_binary_literal",
  [sym_string_literal] = "string_literal",
  [sym_string_simple] = "string_simple",
  [sym_string_multiline] = "string_multiline",
  [sym_boolean_literal] = "boolean_literal",
  [sym_array_literal] = "array_literal",
  [sym__NEWLINE] = "_NEWLINE",
  [sym_dictionary_literal] = "dictionary_literal",
  [sym_identifier_list] = "identifier_list",
  [sym_primary_expression] = "primary_expression",
  [sym_function_id] = "function_id",
  [sym_keyword_arg_key] = "keyword_arg_key",
  [sym_id_expression] = "id_expression",
  [aux_sym_build_definition_repeat1] = "build_definition_repeat1",
  [aux_sym_selection_statement_repeat1] = "selection_statement_repeat1",
  [aux_sym_iteration_statement_repeat1] = "iteration_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_key_value_list_repeat1] = "key_value_list_repeat1",
  [aux_sym_string_simple_repeat1] = "string_simple_repeat1",
  [aux_sym_string_multiline_repeat1] = "string_multiline_repeat1",
  [aux_sym_array_literal_repeat1] = "array_literal_repeat1",
  [aux_sym_identifier_list_repeat1] = "identifier_list_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_endif] = anon_sym_endif,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_endforeach] = anon_sym_endforeach,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym__DECIMAL_NUMBER] = sym__DECIMAL_NUMBER,
  [anon_sym_0o] = anon_sym_0o,
  [sym__OCTAL_NUMBER] = sym__OCTAL_NUMBER,
  [anon_sym_0x] = anon_sym_0x,
  [sym__HEX_NUMBER] = sym__HEX_NUMBER,
  [anon_sym_0b] = anon_sym_0b,
  [sym__BINARY_NUMBER] = sym__BINARY_NUMBER,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_simple_token1] = aux_sym_string_simple_token1,
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE_SQUOTE,
  [aux_sym_string_multiline_token1] = aux_sym_string_multiline_token1,
  [anon_sym_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR_LF] = anon_sym_CR_LF,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [sym__IDENTIFIER] = sym__IDENTIFIER,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym_build_definition] = sym_build_definition,
  [sym_statement] = sym_statement,
  [sym_selection_statement] = sym_selection_statement,
  [sym_iteration_statement] = sym_iteration_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_assignment_operator] = sym_assignment_operator,
  [sym_jump_statement] = sym_jump_statement,
  [sym_condition] = sym_condition,
  [sym_expression] = sym_expression,
  [sym_function_expression] = sym_function_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_keyword_item] = sym_keyword_item,
  [sym_key_value_item] = sym_key_value_item,
  [sym_method_expression] = sym_method_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_add_operator] = sym_add_operator,
  [sym_mult_operator] = sym_mult_operator,
  [sym_equ_operator] = sym_equ_operator,
  [sym_rel_operator] = sym_rel_operator,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym__literal] = sym__literal,
  [sym_integer_literal] = sym_integer_literal,
  [sym__decimal_literal] = sym__decimal_literal,
  [sym__octal_literal] = sym__octal_literal,
  [sym__hex_literal] = sym__hex_literal,
  [sym__binary_literal] = sym__binary_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_string_simple] = sym_string_simple,
  [sym_string_multiline] = sym_string_multiline,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_array_literal] = sym_array_literal,
  [sym__NEWLINE] = sym__NEWLINE,
  [sym_dictionary_literal] = sym_dictionary_literal,
  [sym_identifier_list] = sym_identifier_list,
  [sym_primary_expression] = sym_primary_expression,
  [sym_function_id] = sym_function_id,
  [sym_keyword_arg_key] = sym_keyword_arg_key,
  [sym_id_expression] = sym_id_expression,
  [aux_sym_build_definition_repeat1] = aux_sym_build_definition_repeat1,
  [aux_sym_selection_statement_repeat1] = aux_sym_selection_statement_repeat1,
  [aux_sym_iteration_statement_repeat1] = aux_sym_iteration_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_key_value_list_repeat1] = aux_sym_key_value_list_repeat1,
  [aux_sym_string_simple_repeat1] = aux_sym_string_simple_repeat1,
  [aux_sym_string_multiline_repeat1] = aux_sym_string_multiline_repeat1,
  [aux_sym_array_literal_repeat1] = aux_sym_array_literal_repeat1,
  [aux_sym_identifier_list_repeat1] = aux_sym_identifier_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endforeach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym__DECIMAL_NUMBER] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_0o] = {
    .visible = true,
    .named = false,
  },
  [sym__OCTAL_NUMBER] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_0x] = {
    .visible = true,
    .named = false,
  },
  [sym__HEX_NUMBER] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_0b] = {
    .visible = true,
    .named = false,
  },
  [sym__BINARY_NUMBER] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_simple_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_multiline_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__IDENTIFIER] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_build_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_selection_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_iteration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_jump_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_item] = {
    .visible = true,
    .named = true,
  },
  [sym_key_value_item] = {
    .visible = true,
    .named = true,
  },
  [sym_method_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_add_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_mult_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_equ_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_rel_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__decimal_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__octal_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_simple] = {
    .visible = true,
    .named = true,
  },
  [sym_string_multiline] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_array_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__NEWLINE] = {
    .visible = false,
    .named = true,
  },
  [sym_dictionary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_id] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_arg_key] = {
    .visible = true,
    .named = true,
  },
  [sym_id_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_build_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_selection_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_iteration_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_key_value_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_simple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_multiline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_identifier_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_key = 1,
  field_value = 2,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_key] = "key",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_key, 0},
    {field_value, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(68);
      if (lookahead == '!') ADVANCE(101);
      if (lookahead == '#') ADVANCE(197);
      if (lookahead == '%') ADVANCE(113);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == ')') ADVANCE(93);
      if (lookahead == '*') ADVANCE(109);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(95);
      if (lookahead == '/') ADVANCE(111);
      if (lookahead == '0') ADVANCE(123);
      if (lookahead == '1') ADVANCE(124);
      if (lookahead == ':') ADVANCE(79);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(116);
      if (lookahead == '?') ADVANCE(121);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead == ']') ADVANCE(97);
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'b') ADVANCE(47);
      if (lookahead == 'c') ADVANCE(45);
      if (lookahead == 'e') ADVANCE(38);
      if (lookahead == 'f') ADVANCE(14);
      if (lookahead == 'i') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == 't') ADVANCE(49);
      if (lookahead == '{') ADVANCE(150);
      if (lookahead == '}') ADVANCE(151);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(125);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '!') ADVANCE(11);
      if (lookahead == '#') ADVANCE(197);
      if (lookahead == '%') ADVANCE(113);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == '*') ADVANCE(109);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(95);
      if (lookahead == '/') ADVANCE(111);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(116);
      if (lookahead == '?') ADVANCE(121);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(1)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(10)
      if (lookahead == '\'') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(139);
      if (lookahead != 0) ADVANCE(140);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '#') ADVANCE(197);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == 'b') ADVANCE(189);
      if (lookahead == 'c') ADVANCE(185);
      if (lookahead == 'e') ADVANCE(182);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == 'n') ADVANCE(184);
      if (lookahead == 't') ADVANCE(187);
      if (lookahead == '{') ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '#') ADVANCE(197);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == 'e') ADVANCE(179);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == 'n') ADVANCE(184);
      if (lookahead == 't') ADVANCE(187);
      if (lookahead == '{') ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '#') ADVANCE(197);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == 'e') ADVANCE(180);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == 'n') ADVANCE(184);
      if (lookahead == 't') ADVANCE(187);
      if (lookahead == '{') ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == ')') ADVANCE(93);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == ']') ADVANCE(97);
      if (lookahead == 'f') ADVANCE(153);
      if (lookahead == 'n') ADVANCE(184);
      if (lookahead == 't') ADVANCE(187);
      if (lookahead == '{') ADVANCE(150);
      if (lookahead == '}') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(11);
      if (lookahead == '%') ADVANCE(112);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == ')') ADVANCE(93);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(95);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == ':') ADVANCE(79);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(12);
      if (lookahead == '>') ADVANCE(116);
      if (lookahead == '?') ADVANCE(121);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == ']') ADVANCE(97);
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == '}') ADVANCE(151);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      END_STATE();
    case 8:
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(142);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 9:
      if (lookahead == '\'') ADVANCE(141);
      END_STATE();
    case 10:
      if (lookahead == '\'') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      END_STATE();
    case 11:
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 13:
      if (lookahead == 'U') ADVANCE(66);
      if (lookahead == 'u') ADVANCE(62);
      if (lookahead == 'x') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(135);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(37);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(18);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(19);
      END_STATE();
    case 18:
      if (lookahead == 'c') ADVANCE(33);
      END_STATE();
    case 19:
      if (lookahead == 'c') ADVANCE(34);
      END_STATE();
    case 20:
      if (lookahead == 'd') ADVANCE(104);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(32);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(15);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 25:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 26:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(16);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(17);
      END_STATE();
    case 29:
      if (lookahead == 'f') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 30:
      if (lookahead == 'f') ADVANCE(71);
      END_STATE();
    case 31:
      if (lookahead == 'f') ADVANCE(75);
      END_STATE();
    case 32:
      if (lookahead == 'f') ADVANCE(46);
      if (lookahead == 'i') ADVANCE(31);
      END_STATE();
    case 33:
      if (lookahead == 'h') ADVANCE(77);
      END_STATE();
    case 34:
      if (lookahead == 'h') ADVANCE(80);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 's') ADVANCE(23);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 37:
      if (lookahead == 'k') ADVANCE(88);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'n') ADVANCE(21);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(52);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(20);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 45:
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 46:
      if (lookahead == 'o') ADVANCE(51);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(105);
      END_STATE();
    case 49:
      if (lookahead == 'r') ADVANCE(55);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(28);
      END_STATE();
    case 52:
      if (lookahead == 's') ADVANCE(25);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(36);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(26);
      END_STATE();
    case 57:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(128);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 58:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(133);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 67:
      if (eof) ADVANCE(68);
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '#') ADVANCE(197);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(92);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '0') ADVANCE(122);
      if (lookahead == '[') ADVANCE(96);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == 'n') ADVANCE(184);
      if (lookahead == 't') ADVANCE(187);
      if (lookahead == '{') ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_elif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_endif);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_endif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_foreach);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_endforeach);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_endforeach);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_break);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_continue);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_not);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(86);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym__DECIMAL_NUMBER);
      if (lookahead == 'b') ADVANCE(131);
      if (lookahead == 'o') ADVANCE(127);
      if (lookahead == 'x') ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym__DECIMAL_NUMBER);
      if (lookahead == 'b') ADVANCE(131);
      if (lookahead == 'x') ADVANCE(129);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(124);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(126);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(125);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym__DECIMAL_NUMBER);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(124);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(126);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym__DECIMAL_NUMBER);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__DECIMAL_NUMBER);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_0o);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym__OCTAL_NUMBER);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_0x);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym__HEX_NUMBER);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_0b);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym__BINARY_NUMBER);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(133);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(144);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(9);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_string_simple_token1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_string_simple_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_string_multiline_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_string_multiline_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE);
      if (lookahead == '\'') ADVANCE(141);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(1);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'o') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(169);
      if (lookahead == 's') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(174);
      if (lookahead == 'n') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(195);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(197);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 67},
  [2] = {.lex_state = 4},
  [3] = {.lex_state = 3},
  [4] = {.lex_state = 3},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 4},
  [7] = {.lex_state = 4},
  [8] = {.lex_state = 4},
  [9] = {.lex_state = 4},
  [10] = {.lex_state = 67},
  [11] = {.lex_state = 5},
  [12] = {.lex_state = 5},
  [13] = {.lex_state = 5},
  [14] = {.lex_state = 5},
  [15] = {.lex_state = 5},
  [16] = {.lex_state = 5},
  [17] = {.lex_state = 67},
  [18] = {.lex_state = 5},
  [19] = {.lex_state = 6},
  [20] = {.lex_state = 6},
  [21] = {.lex_state = 6},
  [22] = {.lex_state = 6},
  [23] = {.lex_state = 6},
  [24] = {.lex_state = 6},
  [25] = {.lex_state = 6},
  [26] = {.lex_state = 6},
  [27] = {.lex_state = 6},
  [28] = {.lex_state = 6},
  [29] = {.lex_state = 6},
  [30] = {.lex_state = 6},
  [31] = {.lex_state = 6},
  [32] = {.lex_state = 6},
  [33] = {.lex_state = 6},
  [34] = {.lex_state = 6},
  [35] = {.lex_state = 6},
  [36] = {.lex_state = 6},
  [37] = {.lex_state = 6},
  [38] = {.lex_state = 6},
  [39] = {.lex_state = 6},
  [40] = {.lex_state = 6},
  [41] = {.lex_state = 6},
  [42] = {.lex_state = 6},
  [43] = {.lex_state = 6},
  [44] = {.lex_state = 6},
  [45] = {.lex_state = 6},
  [46] = {.lex_state = 6},
  [47] = {.lex_state = 6},
  [48] = {.lex_state = 6},
  [49] = {.lex_state = 6},
  [50] = {.lex_state = 6},
  [51] = {.lex_state = 6},
  [52] = {.lex_state = 6},
  [53] = {.lex_state = 6},
  [54] = {.lex_state = 6},
  [55] = {.lex_state = 6},
  [56] = {.lex_state = 6},
  [57] = {.lex_state = 6},
  [58] = {.lex_state = 6},
  [59] = {.lex_state = 1},
  [60] = {.lex_state = 1},
  [61] = {.lex_state = 1},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 1},
  [72] = {.lex_state = 1},
  [73] = {.lex_state = 7},
  [74] = {.lex_state = 1},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 1},
  [77] = {.lex_state = 1},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 7},
  [80] = {.lex_state = 7},
  [81] = {.lex_state = 7},
  [82] = {.lex_state = 7},
  [83] = {.lex_state = 1},
  [84] = {.lex_state = 1},
  [85] = {.lex_state = 7},
  [86] = {.lex_state = 1},
  [87] = {.lex_state = 7},
  [88] = {.lex_state = 1},
  [89] = {.lex_state = 7},
  [90] = {.lex_state = 1},
  [91] = {.lex_state = 1},
  [92] = {.lex_state = 1},
  [93] = {.lex_state = 1},
  [94] = {.lex_state = 1},
  [95] = {.lex_state = 1},
  [96] = {.lex_state = 1},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 1},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 1},
  [103] = {.lex_state = 1},
  [104] = {.lex_state = 7},
  [105] = {.lex_state = 7},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 1},
  [108] = {.lex_state = 7},
  [109] = {.lex_state = 7},
  [110] = {.lex_state = 7},
  [111] = {.lex_state = 7},
  [112] = {.lex_state = 7},
  [113] = {.lex_state = 7},
  [114] = {.lex_state = 7},
  [115] = {.lex_state = 7},
  [116] = {.lex_state = 7},
  [117] = {.lex_state = 7},
  [118] = {.lex_state = 7},
  [119] = {.lex_state = 7},
  [120] = {.lex_state = 7},
  [121] = {.lex_state = 7},
  [122] = {.lex_state = 7},
  [123] = {.lex_state = 7},
  [124] = {.lex_state = 7},
  [125] = {.lex_state = 7},
  [126] = {.lex_state = 7},
  [127] = {.lex_state = 7},
  [128] = {.lex_state = 7},
  [129] = {.lex_state = 7},
  [130] = {.lex_state = 7},
  [131] = {.lex_state = 7},
  [132] = {.lex_state = 7},
  [133] = {.lex_state = 7},
  [134] = {.lex_state = 7},
  [135] = {.lex_state = 7},
  [136] = {.lex_state = 7},
  [137] = {.lex_state = 7},
  [138] = {.lex_state = 7},
  [139] = {.lex_state = 7},
  [140] = {.lex_state = 7},
  [141] = {.lex_state = 7},
  [142] = {.lex_state = 7},
  [143] = {.lex_state = 7},
  [144] = {.lex_state = 7},
  [145] = {.lex_state = 7},
  [146] = {.lex_state = 4},
  [147] = {.lex_state = 4},
  [148] = {.lex_state = 3},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 3},
  [151] = {.lex_state = 5},
  [152] = {.lex_state = 5},
  [153] = {.lex_state = 67},
  [154] = {.lex_state = 67},
  [155] = {.lex_state = 6},
  [156] = {.lex_state = 6},
  [157] = {.lex_state = 6},
  [158] = {.lex_state = 6},
  [159] = {.lex_state = 6},
  [160] = {.lex_state = 6},
  [161] = {.lex_state = 8},
  [162] = {.lex_state = 8},
  [163] = {.lex_state = 8},
  [164] = {.lex_state = 8},
  [165] = {.lex_state = 8},
  [166] = {.lex_state = 1},
  [167] = {.lex_state = 0},
  [168] = {.lex_state = 2},
  [169] = {.lex_state = 1},
  [170] = {.lex_state = 1},
  [171] = {.lex_state = 1},
  [172] = {.lex_state = 0},
  [173] = {.lex_state = 1},
  [174] = {.lex_state = 2},
  [175] = {.lex_state = 1},
  [176] = {.lex_state = 1},
  [177] = {.lex_state = 2},
  [178] = {.lex_state = 2},
  [179] = {.lex_state = 0},
  [180] = {.lex_state = 2},
  [181] = {.lex_state = 1},
  [182] = {.lex_state = 0},
  [183] = {.lex_state = 0},
  [184] = {.lex_state = 1},
  [185] = {.lex_state = 0},
  [186] = {.lex_state = 1},
  [187] = {.lex_state = 0},
  [188] = {.lex_state = 0},
  [189] = {.lex_state = 0},
  [190] = {.lex_state = 0},
  [191] = {.lex_state = 0},
  [192] = {.lex_state = 1},
  [193] = {.lex_state = 1},
  [194] = {.lex_state = 0},
  [195] = {.lex_state = 1},
  [196] = {.lex_state = 1},
  [197] = {.lex_state = 1},
  [198] = {.lex_state = 57},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 0},
  [201] = {.lex_state = 0},
  [202] = {.lex_state = 1},
  [203] = {.lex_state = 0},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 1},
  [206] = {.lex_state = 0},
  [207] = {.lex_state = 0},
  [208] = {.lex_state = 1},
  [209] = {.lex_state = 57},
  [210] = {.lex_state = 1},
  [211] = {.lex_state = 0},
  [212] = {.lex_state = 57},
  [213] = {.lex_state = 57},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 1},
  [216] = {.lex_state = 57},
  [217] = {.lex_state = 0},
  [218] = {.lex_state = 0},
  [219] = {.lex_state = 0},
  [220] = {.lex_state = 0},
  [221] = {.lex_state = 0},
  [222] = {.lex_state = 0},
  [223] = {.lex_state = 0},
  [224] = {.lex_state = 0},
  [225] = {.lex_state = 0},
  [226] = {.lex_state = 0},
  [227] = {.lex_state = 7},
  [228] = {.lex_state = 0},
  [229] = {.lex_state = 58},
  [230] = {.lex_state = 57},
  [231] = {.lex_state = 7},
  [232] = {.lex_state = 0},
  [233] = {.lex_state = 58},
  [234] = {.lex_state = 57},
  [235] = {.lex_state = 0},
  [236] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_endif] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_endforeach] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym__DECIMAL_NUMBER] = ACTIONS(1),
    [sym__OCTAL_NUMBER] = ACTIONS(1),
    [anon_sym_0x] = ACTIONS(1),
    [anon_sym_0b] = ACTIONS(1),
    [sym__BINARY_NUMBER] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_comment] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(225),
    [sym_build_definition] = STATE(217),
    [sym_statement] = STATE(10),
    [sym_selection_statement] = STATE(171),
    [sym_iteration_statement] = STATE(171),
    [sym_assignment_statement] = STATE(171),
    [sym_expression] = STATE(62),
    [sym_function_expression] = STATE(76),
    [sym_method_expression] = STATE(76),
    [sym_subscript_expression] = STATE(76),
    [sym_unary_expression] = STATE(76),
    [sym_binary_expression] = STATE(76),
    [sym_conditional_expression] = STATE(76),
    [sym__literal] = STATE(76),
    [sym_integer_literal] = STATE(76),
    [sym__decimal_literal] = STATE(77),
    [sym__octal_literal] = STATE(77),
    [sym__hex_literal] = STATE(77),
    [sym__binary_literal] = STATE(77),
    [sym_string_literal] = STATE(76),
    [sym_string_simple] = STATE(78),
    [sym_string_multiline] = STATE(78),
    [sym_boolean_literal] = STATE(76),
    [sym_array_literal] = STATE(76),
    [sym_dictionary_literal] = STATE(76),
    [sym_primary_expression] = STATE(76),
    [sym_function_id] = STATE(236),
    [sym_id_expression] = STATE(91),
    [aux_sym_build_definition_repeat1] = STATE(10),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_foreach] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_not] = ACTIONS(11),
    [anon_sym_BANG] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [sym__DECIMAL_NUMBER] = ACTIONS(15),
    [anon_sym_0o] = ACTIONS(17),
    [anon_sym_0x] = ACTIONS(19),
    [anon_sym_0b] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_true] = ACTIONS(27),
    [anon_sym_false] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [sym__IDENTIFIER] = ACTIONS(31),
    [sym_comment] = ACTIONS(33),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 28,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(35), 1,
      anon_sym_elif,
    ACTIONS(37), 1,
      anon_sym_else,
    ACTIONS(39), 1,
      anon_sym_endif,
    ACTIONS(41), 1,
      sym_comment,
    STATE(59), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(167), 1,
      aux_sym_selection_statement_repeat1,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(176), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [106] = 26,
    ACTIONS(43), 1,
      anon_sym_if,
    ACTIONS(46), 1,
      anon_sym_foreach,
    ACTIONS(49), 1,
      anon_sym_endforeach,
    ACTIONS(54), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_LBRACK,
    ACTIONS(60), 1,
      anon_sym_not,
    ACTIONS(66), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(69), 1,
      anon_sym_0o,
    ACTIONS(72), 1,
      anon_sym_0x,
    ACTIONS(75), 1,
      anon_sym_0b,
    ACTIONS(78), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_LBRACE,
    ACTIONS(90), 1,
      sym__IDENTIFIER,
    ACTIONS(93), 1,
      sym_comment,
    STATE(61), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(51), 2,
      anon_sym_break,
      anon_sym_continue,
    ACTIONS(63), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(84), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(3), 3,
      sym_statement,
      sym_jump_statement,
      aux_sym_iteration_statement_repeat1,
    STATE(169), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [208] = 26,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(96), 1,
      anon_sym_endforeach,
    ACTIONS(100), 1,
      sym_comment,
    STATE(61), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(98), 2,
      anon_sym_break,
      anon_sym_continue,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(3), 3,
      sym_statement,
      sym_jump_statement,
      aux_sym_iteration_statement_repeat1,
    STATE(169), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [310] = 26,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(100), 1,
      sym_comment,
    ACTIONS(102), 1,
      anon_sym_endforeach,
    STATE(61), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(98), 2,
      anon_sym_break,
      anon_sym_continue,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(4), 3,
      sym_statement,
      sym_jump_statement,
      aux_sym_iteration_statement_repeat1,
    STATE(169), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [412] = 28,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(35), 1,
      anon_sym_elif,
    ACTIONS(41), 1,
      sym_comment,
    ACTIONS(104), 1,
      anon_sym_else,
    ACTIONS(106), 1,
      anon_sym_endif,
    STATE(59), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(172), 1,
      aux_sym_selection_statement_repeat1,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(176), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [518] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(41), 1,
      sym_comment,
    STATE(59), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    ACTIONS(108), 3,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_endif,
    STATE(176), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [617] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(41), 1,
      sym_comment,
    STATE(59), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(7), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    ACTIONS(110), 3,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_endif,
    STATE(176), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [716] = 25,
    ACTIONS(112), 1,
      anon_sym_if,
    ACTIONS(117), 1,
      anon_sym_foreach,
    ACTIONS(120), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(126), 1,
      anon_sym_not,
    ACTIONS(132), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(135), 1,
      anon_sym_0o,
    ACTIONS(138), 1,
      anon_sym_0x,
    ACTIONS(141), 1,
      anon_sym_0b,
    ACTIONS(144), 1,
      anon_sym_SQUOTE,
    ACTIONS(147), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_LBRACE,
    ACTIONS(156), 1,
      sym__IDENTIFIER,
    ACTIONS(159), 1,
      sym_comment,
    STATE(59), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(129), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(150), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    ACTIONS(115), 3,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_endif,
    STATE(176), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [815] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(33), 1,
      sym_comment,
    ACTIONS(162), 1,
      ts_builtin_sym_end,
    STATE(62), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(17), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(171), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [912] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(164), 1,
      anon_sym_endif,
    ACTIONS(166), 1,
      sym_comment,
    STATE(60), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(15), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(170), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1009] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(39), 1,
      anon_sym_endif,
    ACTIONS(166), 1,
      sym_comment,
    STATE(60), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(13), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(170), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1106] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(166), 1,
      sym_comment,
    ACTIONS(168), 1,
      anon_sym_endif,
    STATE(60), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(15), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(170), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1203] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(166), 1,
      sym_comment,
    ACTIONS(170), 1,
      anon_sym_endif,
    STATE(60), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(15), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(170), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1300] = 25,
    ACTIONS(112), 1,
      anon_sym_if,
    ACTIONS(115), 1,
      anon_sym_endif,
    ACTIONS(117), 1,
      anon_sym_foreach,
    ACTIONS(120), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(126), 1,
      anon_sym_not,
    ACTIONS(132), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(135), 1,
      anon_sym_0o,
    ACTIONS(138), 1,
      anon_sym_0x,
    ACTIONS(141), 1,
      anon_sym_0b,
    ACTIONS(144), 1,
      anon_sym_SQUOTE,
    ACTIONS(147), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_LBRACE,
    ACTIONS(156), 1,
      sym__IDENTIFIER,
    ACTIONS(172), 1,
      sym_comment,
    STATE(60), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(129), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(150), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(15), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(170), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1397] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(166), 1,
      sym_comment,
    ACTIONS(168), 1,
      anon_sym_endif,
    STATE(60), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(14), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(170), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1494] = 25,
    ACTIONS(112), 1,
      anon_sym_if,
    ACTIONS(117), 1,
      anon_sym_foreach,
    ACTIONS(120), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(126), 1,
      anon_sym_not,
    ACTIONS(132), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(135), 1,
      anon_sym_0o,
    ACTIONS(138), 1,
      anon_sym_0x,
    ACTIONS(141), 1,
      anon_sym_0b,
    ACTIONS(144), 1,
      anon_sym_SQUOTE,
    ACTIONS(147), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_LBRACE,
    ACTIONS(156), 1,
      sym__IDENTIFIER,
    ACTIONS(175), 1,
      ts_builtin_sym_end,
    ACTIONS(177), 1,
      sym_comment,
    STATE(62), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(129), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(150), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(17), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(171), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1591] = 25,
    ACTIONS(3), 1,
      anon_sym_if,
    ACTIONS(5), 1,
      anon_sym_foreach,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    ACTIONS(166), 1,
      sym_comment,
    ACTIONS(170), 1,
      anon_sym_endif,
    STATE(60), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(11), 2,
      sym_statement,
      aux_sym_build_definition_repeat1,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(170), 3,
      sym_selection_statement,
      sym_iteration_statement,
      sym_assignment_statement,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1688] = 23,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(182), 1,
      anon_sym_RPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(206), 1,
      sym__IDENTIFIER,
    STATE(104), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(204), 1,
      sym_keyword_item,
    STATE(221), 1,
      sym_keyword_arg_key,
    STATE(222), 1,
      sym_argument_list,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1776] = 23,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(206), 1,
      sym__IDENTIFIER,
    ACTIONS(208), 1,
      anon_sym_RPAREN,
    STATE(104), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(204), 1,
      sym_keyword_item,
    STATE(220), 1,
      sym_argument_list,
    STATE(221), 1,
      sym_keyword_arg_key,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1864] = 23,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(206), 1,
      sym__IDENTIFIER,
    ACTIONS(210), 1,
      anon_sym_RPAREN,
    STATE(104), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(204), 1,
      sym_keyword_item,
    STATE(221), 1,
      sym_keyword_arg_key,
    STATE(224), 1,
      sym_argument_list,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [1952] = 23,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(206), 1,
      sym__IDENTIFIER,
    ACTIONS(212), 1,
      anon_sym_RPAREN,
    STATE(104), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(204), 1,
      sym_keyword_item,
    STATE(218), 1,
      sym_argument_list,
    STATE(221), 1,
      sym_keyword_arg_key,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2040] = 22,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(206), 1,
      sym__IDENTIFIER,
    ACTIONS(214), 1,
      anon_sym_RPAREN,
    STATE(109), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(214), 1,
      sym_keyword_item,
    STATE(221), 1,
      sym_keyword_arg_key,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2125] = 22,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(206), 1,
      sym__IDENTIFIER,
    ACTIONS(216), 1,
      anon_sym_RPAREN,
    STATE(109), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(214), 1,
      sym_keyword_item,
    STATE(221), 1,
      sym_keyword_arg_key,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2210] = 21,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(218), 1,
      anon_sym_RBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(127), 1,
      sym_id_expression,
    STATE(138), 1,
      sym_expression,
    STATE(191), 1,
      sym_key_value_item,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2292] = 21,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    ACTIONS(222), 1,
      anon_sym_RBRACE,
    STATE(127), 1,
      sym_id_expression,
    STATE(138), 1,
      sym_expression,
    STATE(194), 1,
      sym_key_value_item,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2374] = 21,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(206), 1,
      sym__IDENTIFIER,
    STATE(109), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(214), 1,
      sym_keyword_item,
    STATE(221), 1,
      sym_keyword_arg_key,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2456] = 20,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(91), 1,
      sym_id_expression,
    STATE(107), 1,
      sym_expression,
    STATE(181), 1,
      sym_condition,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2535] = 20,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    ACTIONS(224), 1,
      anon_sym_RBRACK,
    STATE(108), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2614] = 20,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    ACTIONS(226), 1,
      anon_sym_RBRACK,
    STATE(105), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2693] = 20,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(91), 1,
      sym_id_expression,
    STATE(107), 1,
      sym_expression,
    STATE(173), 1,
      sym_condition,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2772] = 20,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(127), 1,
      sym_id_expression,
    STATE(138), 1,
      sym_expression,
    STATE(207), 1,
      sym_key_value_item,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2851] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(73), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [2927] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(67), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3003] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(89), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3079] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(125), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3155] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(119), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3231] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(85), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3307] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(82), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3383] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(112), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3459] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(81), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3535] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(80), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3611] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(79), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3687] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(110), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3763] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(69), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3839] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(120), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3915] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(68), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [3991] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(127), 1,
      sym_id_expression,
    STATE(130), 1,
      sym_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4067] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(123), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4143] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(113), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4219] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(70), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4295] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(87), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4371] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(65), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4447] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(63), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4523] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(64), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4599] = 19,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(184), 1,
      anon_sym_LBRACK,
    ACTIONS(186), 1,
      anon_sym_not,
    ACTIONS(190), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(192), 1,
      anon_sym_0o,
    ACTIONS(194), 1,
      anon_sym_0x,
    ACTIONS(196), 1,
      anon_sym_0b,
    ACTIONS(198), 1,
      anon_sym_SQUOTE,
    ACTIONS(200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(204), 1,
      anon_sym_LBRACE,
    ACTIONS(220), 1,
      sym__IDENTIFIER,
    STATE(116), 1,
      sym_expression,
    STATE(127), 1,
      sym_id_expression,
    STATE(232), 1,
      sym_function_id,
    ACTIONS(188), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(202), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(128), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(114), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(129), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4675] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(91), 1,
      sym_id_expression,
    STATE(106), 1,
      sym_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4751] = 19,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_LBRACK,
    ACTIONS(11), 1,
      anon_sym_not,
    ACTIONS(15), 1,
      sym__DECIMAL_NUMBER,
    ACTIONS(17), 1,
      anon_sym_0o,
    ACTIONS(19), 1,
      anon_sym_0x,
    ACTIONS(21), 1,
      anon_sym_0b,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(31), 1,
      sym__IDENTIFIER,
    STATE(66), 1,
      sym_expression,
    STATE(91), 1,
      sym_id_expression,
    STATE(236), 1,
      sym_function_id,
    ACTIONS(13), 2,
      anon_sym_BANG,
      anon_sym_DASH,
    ACTIONS(27), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(78), 2,
      sym_string_simple,
      sym_string_multiline,
    STATE(77), 4,
      sym__decimal_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym__binary_literal,
    STATE(76), 13,
      sym_function_expression,
      sym_method_expression,
      sym_subscript_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_conditional_expression,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_boolean_literal,
      sym_array_literal,
      sym_dictionary_literal,
      sym_primary_expression,
  [4827] = 19,
    ACTIONS(230), 1,
      anon_sym_DOT,
    ACTIONS(232), 1,
      anon_sym_LBRACK,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    ACTIONS(240), 1,
      anon_sym_or,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    ACTIONS(252), 1,
      sym_comment,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(57), 1,
      sym_assignment_operator,
    STATE(58), 1,
      sym_add_operator,
    STATE(147), 1,
      sym__NEWLINE,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(250), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(228), 6,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [4899] = 19,
    ACTIONS(230), 1,
      anon_sym_DOT,
    ACTIONS(232), 1,
      anon_sym_LBRACK,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    ACTIONS(240), 1,
      anon_sym_or,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    ACTIONS(256), 1,
      sym_comment,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(57), 1,
      sym_assignment_operator,
    STATE(58), 1,
      sym_add_operator,
    STATE(152), 1,
      sym__NEWLINE,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(254), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(228), 6,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [4971] = 19,
    ACTIONS(230), 1,
      anon_sym_DOT,
    ACTIONS(232), 1,
      anon_sym_LBRACK,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    ACTIONS(240), 1,
      anon_sym_or,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    ACTIONS(260), 1,
      sym_comment,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(57), 1,
      sym_assignment_operator,
    STATE(58), 1,
      sym_add_operator,
    STATE(149), 1,
      sym__NEWLINE,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(258), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(228), 6,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [5043] = 19,
    ACTIONS(230), 1,
      anon_sym_DOT,
    ACTIONS(232), 1,
      anon_sym_LBRACK,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    ACTIONS(240), 1,
      anon_sym_or,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    ACTIONS(264), 1,
      sym_comment,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(57), 1,
      sym_assignment_operator,
    STATE(58), 1,
      sym_add_operator,
    STATE(154), 1,
      sym__NEWLINE,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(262), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(228), 6,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [5115] = 7,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(266), 22,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5161] = 5,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(266), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5203] = 8,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(266), 20,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5251] = 6,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(266), 24,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5295] = 11,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(266), 13,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5349] = 11,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(268), 13,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5403] = 15,
    ACTIONS(230), 1,
      anon_sym_DOT,
    ACTIONS(232), 1,
      anon_sym_LBRACK,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    ACTIONS(240), 1,
      anon_sym_or,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(270), 9,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5465] = 10,
    ACTIONS(234), 1,
      anon_sym_not,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(266), 14,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5517] = 2,
    ACTIONS(274), 1,
      anon_sym_LPAREN,
    ACTIONS(272), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5550] = 1,
    ACTIONS(276), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5580] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(278), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [5640] = 1,
    ACTIONS(300), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5670] = 1,
    ACTIONS(302), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5700] = 1,
    ACTIONS(304), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5730] = 1,
    ACTIONS(306), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5760] = 1,
    ACTIONS(308), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [5790] = 12,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(310), 9,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_or,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [5842] = 9,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(312), 14,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [5888] = 8,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(312), 16,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [5932] = 6,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(312), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [5972] = 1,
    ACTIONS(314), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6002] = 1,
    ACTIONS(316), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6032] = 7,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(312), 18,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [6074] = 1,
    ACTIONS(318), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6104] = 12,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(312), 9,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_or,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [6156] = 1,
    ACTIONS(320), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6186] = 11,
    ACTIONS(284), 1,
      anon_sym_not,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
    ACTIONS(312), 10,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [6236] = 1,
    ACTIONS(322), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6266] = 1,
    ACTIONS(324), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6296] = 1,
    ACTIONS(326), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6326] = 1,
    ACTIONS(328), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6356] = 1,
    ACTIONS(330), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6386] = 1,
    ACTIONS(332), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6416] = 1,
    ACTIONS(334), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6446] = 1,
    ACTIONS(336), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6476] = 1,
    ACTIONS(338), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6506] = 1,
    ACTIONS(340), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6536] = 1,
    ACTIONS(342), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6566] = 1,
    ACTIONS(344), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6596] = 1,
    ACTIONS(346), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6626] = 1,
    ACTIONS(348), 27,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [6656] = 18,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(350), 1,
      anon_sym_RPAREN,
    ACTIONS(352), 1,
      anon_sym_COMMA,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    STATE(199), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [6718] = 18,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(354), 1,
      anon_sym_COMMA,
    ACTIONS(356), 1,
      anon_sym_RBRACK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    STATE(187), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [6780] = 15,
    ACTIONS(230), 1,
      anon_sym_DOT,
    ACTIONS(232), 1,
      anon_sym_LBRACK,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    ACTIONS(240), 1,
      anon_sym_or,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(358), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [6836] = 15,
    ACTIONS(230), 1,
      anon_sym_DOT,
    ACTIONS(232), 1,
      anon_sym_LBRACK,
    ACTIONS(234), 1,
      anon_sym_not,
    ACTIONS(238), 1,
      anon_sym_and,
    ACTIONS(240), 1,
      anon_sym_or,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    STATE(53), 1,
      sym_rel_operator,
    STATE(54), 1,
      sym_equ_operator,
    STATE(55), 1,
      sym_mult_operator,
    STATE(58), 1,
      sym_add_operator,
    ACTIONS(236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(244), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(242), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(360), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
    ACTIONS(246), 5,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [6892] = 18,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(354), 1,
      anon_sym_COMMA,
    ACTIONS(362), 1,
      anon_sym_RBRACK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    STATE(189), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [6954] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(364), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7011] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(366), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7068] = 3,
    ACTIONS(370), 1,
      anon_sym_LPAREN,
    ACTIONS(272), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(368), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7099] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(372), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7156] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(374), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7213] = 2,
    ACTIONS(306), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(376), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7241] = 2,
    ACTIONS(300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(378), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7269] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(380), 1,
      anon_sym_COLON,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7325] = 2,
    ACTIONS(330), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(382), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7353] = 2,
    ACTIONS(346), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(384), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7381] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(386), 1,
      anon_sym_COLON,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7437] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(388), 1,
      anon_sym_RBRACK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7493] = 2,
    ACTIONS(338), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(390), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7521] = 2,
    ACTIONS(328), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(392), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7549] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(394), 1,
      anon_sym_RPAREN,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7605] = 2,
    ACTIONS(344), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7633] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(398), 1,
      anon_sym_RPAREN,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7689] = 2,
    ACTIONS(332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(400), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7717] = 2,
    ACTIONS(324), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(402), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7745] = 2,
    ACTIONS(308), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(404), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7773] = 2,
    ACTIONS(304), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7801] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(408), 1,
      anon_sym_RBRACK,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [7857] = 2,
    ACTIONS(348), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(410), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7885] = 2,
    ACTIONS(314), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(412), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7913] = 2,
    ACTIONS(302), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(414), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7941] = 2,
    ACTIONS(336), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(416), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7969] = 2,
    ACTIONS(276), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [7997] = 2,
    ACTIONS(342), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(420), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8025] = 2,
    ACTIONS(334), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8053] = 16,
    ACTIONS(280), 1,
      anon_sym_DOT,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_not,
    ACTIONS(288), 1,
      anon_sym_and,
    ACTIONS(290), 1,
      anon_sym_or,
    ACTIONS(298), 1,
      anon_sym_QMARK,
    ACTIONS(424), 1,
      anon_sym_COLON,
    STATE(38), 1,
      sym_add_operator,
    STATE(39), 1,
      sym_mult_operator,
    STATE(41), 1,
      sym_equ_operator,
    STATE(42), 1,
      sym_rel_operator,
    ACTIONS(246), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(286), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(292), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
  [8109] = 2,
    ACTIONS(326), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(426), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8137] = 2,
    ACTIONS(340), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8165] = 2,
    ACTIONS(316), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(430), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8193] = 2,
    ACTIONS(318), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(432), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8221] = 2,
    ACTIONS(320), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(434), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8249] = 2,
    ACTIONS(322), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(436), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACE,
  [8277] = 4,
    ACTIONS(370), 1,
      anon_sym_LPAREN,
    ACTIONS(438), 1,
      anon_sym_COLON,
    ACTIONS(272), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(368), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_in,
      anon_sym_QMARK,
  [8308] = 2,
    ACTIONS(442), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
    ACTIONS(440), 11,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_endif,
      anon_sym_foreach,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
  [8334] = 2,
    ACTIONS(446), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
    ACTIONS(444), 11,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_endif,
      anon_sym_foreach,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
  [8360] = 2,
    ACTIONS(450), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
    ACTIONS(448), 11,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
  [8386] = 2,
    ACTIONS(446), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
    ACTIONS(444), 11,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
  [8412] = 2,
    ACTIONS(442), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
    ACTIONS(440), 11,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
  [8438] = 2,
    ACTIONS(440), 9,
      anon_sym_if,
      anon_sym_endif,
      anon_sym_foreach,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(442), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
  [8462] = 2,
    ACTIONS(444), 9,
      anon_sym_if,
      anon_sym_endif,
      anon_sym_foreach,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(446), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
  [8486] = 2,
    ACTIONS(440), 8,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(442), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
  [8510] = 2,
    ACTIONS(444), 8,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(446), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      sym_comment,
  [8534] = 2,
    ACTIONS(454), 6,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(452), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
  [8554] = 2,
    ACTIONS(458), 6,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(456), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
  [8574] = 2,
    ACTIONS(462), 6,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(460), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
  [8594] = 2,
    ACTIONS(466), 6,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(464), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
  [8614] = 2,
    ACTIONS(470), 6,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(468), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
  [8634] = 2,
    ACTIONS(474), 6,
      anon_sym_not,
      sym__DECIMAL_NUMBER,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym__IDENTIFIER,
    ACTIONS(472), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_0o,
      anon_sym_0x,
      anon_sym_0b,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
  [8654] = 4,
    ACTIONS(478), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(480), 1,
      aux_sym_string_multiline_token1,
    STATE(165), 1,
      aux_sym_string_multiline_repeat1,
    ACTIONS(476), 3,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [8669] = 4,
    ACTIONS(484), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(486), 1,
      aux_sym_string_multiline_token1,
    STATE(163), 1,
      aux_sym_string_multiline_repeat1,
    ACTIONS(482), 3,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [8684] = 4,
    ACTIONS(480), 1,
      aux_sym_string_multiline_token1,
    ACTIONS(488), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(165), 1,
      aux_sym_string_multiline_repeat1,
    ACTIONS(476), 3,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [8699] = 4,
    ACTIONS(492), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(494), 1,
      aux_sym_string_multiline_token1,
    STATE(161), 1,
      aux_sym_string_multiline_repeat1,
    ACTIONS(490), 3,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [8714] = 4,
    ACTIONS(499), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(501), 1,
      aux_sym_string_multiline_token1,
    STATE(165), 1,
      aux_sym_string_multiline_repeat1,
    ACTIONS(496), 3,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [8729] = 3,
    ACTIONS(260), 1,
      sym_comment,
    STATE(148), 1,
      sym__NEWLINE,
    ACTIONS(504), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8740] = 4,
    ACTIONS(506), 1,
      anon_sym_elif,
    ACTIONS(508), 1,
      anon_sym_else,
    ACTIONS(510), 1,
      anon_sym_endif,
    STATE(179), 1,
      aux_sym_selection_statement_repeat1,
  [8753] = 4,
    ACTIONS(512), 1,
      sym_escape_sequence,
    ACTIONS(514), 1,
      anon_sym_SQUOTE,
    ACTIONS(516), 1,
      aux_sym_string_simple_token1,
    STATE(180), 1,
      aux_sym_string_simple_repeat1,
  [8766] = 3,
    ACTIONS(260), 1,
      sym_comment,
    STATE(149), 1,
      sym__NEWLINE,
    ACTIONS(258), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8777] = 3,
    ACTIONS(256), 1,
      sym_comment,
    STATE(152), 1,
      sym__NEWLINE,
    ACTIONS(254), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8788] = 3,
    ACTIONS(264), 1,
      sym_comment,
    STATE(154), 1,
      sym__NEWLINE,
    ACTIONS(262), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8799] = 4,
    ACTIONS(506), 1,
      anon_sym_elif,
    ACTIONS(518), 1,
      anon_sym_else,
    ACTIONS(520), 1,
      anon_sym_endif,
    STATE(179), 1,
      aux_sym_selection_statement_repeat1,
  [8812] = 3,
    ACTIONS(252), 1,
      sym_comment,
    STATE(6), 1,
      sym__NEWLINE,
    ACTIONS(522), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8823] = 4,
    ACTIONS(524), 1,
      sym_escape_sequence,
    ACTIONS(526), 1,
      anon_sym_SQUOTE,
    ACTIONS(528), 1,
      aux_sym_string_simple_token1,
    STATE(178), 1,
      aux_sym_string_simple_repeat1,
  [8836] = 3,
    ACTIONS(260), 1,
      sym_comment,
    STATE(5), 1,
      sym__NEWLINE,
    ACTIONS(530), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8847] = 3,
    ACTIONS(252), 1,
      sym_comment,
    STATE(147), 1,
      sym__NEWLINE,
    ACTIONS(250), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8858] = 4,
    ACTIONS(532), 1,
      sym_escape_sequence,
    ACTIONS(534), 1,
      anon_sym_SQUOTE,
    ACTIONS(536), 1,
      aux_sym_string_simple_token1,
    STATE(174), 1,
      aux_sym_string_simple_repeat1,
  [8871] = 4,
    ACTIONS(538), 1,
      sym_escape_sequence,
    ACTIONS(541), 1,
      anon_sym_SQUOTE,
    ACTIONS(543), 1,
      aux_sym_string_simple_token1,
    STATE(178), 1,
      aux_sym_string_simple_repeat1,
  [8884] = 3,
    ACTIONS(546), 1,
      anon_sym_elif,
    STATE(179), 1,
      aux_sym_selection_statement_repeat1,
    ACTIONS(549), 2,
      anon_sym_else,
      anon_sym_endif,
  [8895] = 4,
    ACTIONS(524), 1,
      sym_escape_sequence,
    ACTIONS(528), 1,
      aux_sym_string_simple_token1,
    ACTIONS(551), 1,
      anon_sym_SQUOTE,
    STATE(178), 1,
      aux_sym_string_simple_repeat1,
  [8908] = 3,
    ACTIONS(252), 1,
      sym_comment,
    STATE(8), 1,
      sym__NEWLINE,
    ACTIONS(553), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [8919] = 3,
    ACTIONS(372), 1,
      anon_sym_RBRACK,
    ACTIONS(555), 1,
      anon_sym_COMMA,
    STATE(182), 1,
      aux_sym_array_literal_repeat1,
  [8929] = 3,
    ACTIONS(558), 1,
      anon_sym_COLON,
    ACTIONS(560), 1,
      anon_sym_COMMA,
    STATE(183), 1,
      aux_sym_identifier_list_repeat1,
  [8939] = 1,
    ACTIONS(563), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [8945] = 3,
    ACTIONS(565), 1,
      anon_sym_COMMA,
    ACTIONS(567), 1,
      anon_sym_RBRACE,
    STATE(200), 1,
      aux_sym_key_value_list_repeat1,
  [8955] = 1,
    ACTIONS(569), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [8961] = 3,
    ACTIONS(354), 1,
      anon_sym_COMMA,
    ACTIONS(571), 1,
      anon_sym_RBRACK,
    STATE(182), 1,
      aux_sym_array_literal_repeat1,
  [8971] = 3,
    ACTIONS(573), 1,
      anon_sym_COLON,
    ACTIONS(575), 1,
      anon_sym_COMMA,
    STATE(183), 1,
      aux_sym_identifier_list_repeat1,
  [8981] = 3,
    ACTIONS(354), 1,
      anon_sym_COMMA,
    ACTIONS(577), 1,
      anon_sym_RBRACK,
    STATE(182), 1,
      aux_sym_array_literal_repeat1,
  [8991] = 3,
    ACTIONS(364), 1,
      anon_sym_RPAREN,
    ACTIONS(579), 1,
      anon_sym_COMMA,
    STATE(190), 1,
      aux_sym_argument_list_repeat1,
  [9001] = 3,
    ACTIONS(565), 1,
      anon_sym_COMMA,
    ACTIONS(582), 1,
      anon_sym_RBRACE,
    STATE(201), 1,
      aux_sym_key_value_list_repeat1,
  [9011] = 1,
    ACTIONS(584), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [9017] = 1,
    ACTIONS(586), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [9023] = 3,
    ACTIONS(565), 1,
      anon_sym_COMMA,
    ACTIONS(588), 1,
      anon_sym_RBRACE,
    STATE(185), 1,
      aux_sym_key_value_list_repeat1,
  [9033] = 1,
    ACTIONS(590), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [9039] = 1,
    ACTIONS(592), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [9045] = 1,
    ACTIONS(594), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [9051] = 3,
    ACTIONS(596), 1,
      sym__IDENTIFIER,
    STATE(203), 1,
      sym_id_expression,
    STATE(228), 1,
      sym_identifier_list,
  [9061] = 3,
    ACTIONS(216), 1,
      anon_sym_RPAREN,
    ACTIONS(598), 1,
      anon_sym_COMMA,
    STATE(190), 1,
      aux_sym_argument_list_repeat1,
  [9071] = 3,
    ACTIONS(600), 1,
      anon_sym_COMMA,
    ACTIONS(603), 1,
      anon_sym_RBRACE,
    STATE(200), 1,
      aux_sym_key_value_list_repeat1,
  [9081] = 3,
    ACTIONS(565), 1,
      anon_sym_COMMA,
    ACTIONS(605), 1,
      anon_sym_RBRACE,
    STATE(200), 1,
      aux_sym_key_value_list_repeat1,
  [9091] = 1,
    ACTIONS(272), 3,
      anon_sym_LF,
      anon_sym_CR_LF,
      sym_comment,
  [9097] = 3,
    ACTIONS(575), 1,
      anon_sym_COMMA,
    ACTIONS(607), 1,
      anon_sym_COLON,
    STATE(188), 1,
      aux_sym_identifier_list_repeat1,
  [9107] = 3,
    ACTIONS(350), 1,
      anon_sym_RPAREN,
    ACTIONS(352), 1,
      anon_sym_COMMA,
    STATE(199), 1,
      aux_sym_argument_list_repeat1,
  [9117] = 1,
    ACTIONS(609), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [9122] = 1,
    ACTIONS(368), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [9127] = 1,
    ACTIONS(603), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [9132] = 1,
    ACTIONS(611), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [9137] = 2,
    ACTIONS(613), 1,
      sym__IDENTIFIER,
    STATE(175), 1,
      sym_id_expression,
  [9144] = 1,
    ACTIONS(615), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [9149] = 1,
    ACTIONS(558), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [9154] = 2,
    ACTIONS(617), 1,
      sym__IDENTIFIER,
    STATE(226), 1,
      sym_function_id,
  [9161] = 2,
    ACTIONS(617), 1,
      sym__IDENTIFIER,
    STATE(235), 1,
      sym_function_id,
  [9168] = 1,
    ACTIONS(364), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [9173] = 1,
    ACTIONS(619), 2,
      anon_sym_LF,
      anon_sym_CR_LF,
  [9178] = 2,
    ACTIONS(596), 1,
      sym__IDENTIFIER,
    STATE(211), 1,
      sym_id_expression,
  [9185] = 1,
    ACTIONS(621), 1,
      ts_builtin_sym_end,
  [9189] = 1,
    ACTIONS(623), 1,
      anon_sym_RPAREN,
  [9193] = 1,
    ACTIONS(370), 1,
      anon_sym_LPAREN,
  [9197] = 1,
    ACTIONS(625), 1,
      anon_sym_RPAREN,
  [9201] = 1,
    ACTIONS(627), 1,
      anon_sym_COLON,
  [9205] = 1,
    ACTIONS(629), 1,
      anon_sym_RPAREN,
  [9209] = 1,
    ACTIONS(631), 1,
      anon_sym_in,
  [9213] = 1,
    ACTIONS(633), 1,
      anon_sym_RPAREN,
  [9217] = 1,
    ACTIONS(635), 1,
      ts_builtin_sym_end,
  [9221] = 1,
    ACTIONS(637), 1,
      anon_sym_LPAREN,
  [9225] = 1,
    ACTIONS(639), 1,
      sym__BINARY_NUMBER,
  [9229] = 1,
    ACTIONS(641), 1,
      anon_sym_COLON,
  [9233] = 1,
    ACTIONS(643), 1,
      sym__HEX_NUMBER,
  [9237] = 1,
    ACTIONS(645), 1,
      sym__OCTAL_NUMBER,
  [9241] = 1,
    ACTIONS(647), 1,
      sym__BINARY_NUMBER,
  [9245] = 1,
    ACTIONS(649), 1,
      anon_sym_LPAREN,
  [9249] = 1,
    ACTIONS(651), 1,
      sym__HEX_NUMBER,
  [9253] = 1,
    ACTIONS(653), 1,
      sym__OCTAL_NUMBER,
  [9257] = 1,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
  [9261] = 1,
    ACTIONS(657), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 106,
  [SMALL_STATE(4)] = 208,
  [SMALL_STATE(5)] = 310,
  [SMALL_STATE(6)] = 412,
  [SMALL_STATE(7)] = 518,
  [SMALL_STATE(8)] = 617,
  [SMALL_STATE(9)] = 716,
  [SMALL_STATE(10)] = 815,
  [SMALL_STATE(11)] = 912,
  [SMALL_STATE(12)] = 1009,
  [SMALL_STATE(13)] = 1106,
  [SMALL_STATE(14)] = 1203,
  [SMALL_STATE(15)] = 1300,
  [SMALL_STATE(16)] = 1397,
  [SMALL_STATE(17)] = 1494,
  [SMALL_STATE(18)] = 1591,
  [SMALL_STATE(19)] = 1688,
  [SMALL_STATE(20)] = 1776,
  [SMALL_STATE(21)] = 1864,
  [SMALL_STATE(22)] = 1952,
  [SMALL_STATE(23)] = 2040,
  [SMALL_STATE(24)] = 2125,
  [SMALL_STATE(25)] = 2210,
  [SMALL_STATE(26)] = 2292,
  [SMALL_STATE(27)] = 2374,
  [SMALL_STATE(28)] = 2456,
  [SMALL_STATE(29)] = 2535,
  [SMALL_STATE(30)] = 2614,
  [SMALL_STATE(31)] = 2693,
  [SMALL_STATE(32)] = 2772,
  [SMALL_STATE(33)] = 2851,
  [SMALL_STATE(34)] = 2927,
  [SMALL_STATE(35)] = 3003,
  [SMALL_STATE(36)] = 3079,
  [SMALL_STATE(37)] = 3155,
  [SMALL_STATE(38)] = 3231,
  [SMALL_STATE(39)] = 3307,
  [SMALL_STATE(40)] = 3383,
  [SMALL_STATE(41)] = 3459,
  [SMALL_STATE(42)] = 3535,
  [SMALL_STATE(43)] = 3611,
  [SMALL_STATE(44)] = 3687,
  [SMALL_STATE(45)] = 3763,
  [SMALL_STATE(46)] = 3839,
  [SMALL_STATE(47)] = 3915,
  [SMALL_STATE(48)] = 3991,
  [SMALL_STATE(49)] = 4067,
  [SMALL_STATE(50)] = 4143,
  [SMALL_STATE(51)] = 4219,
  [SMALL_STATE(52)] = 4295,
  [SMALL_STATE(53)] = 4371,
  [SMALL_STATE(54)] = 4447,
  [SMALL_STATE(55)] = 4523,
  [SMALL_STATE(56)] = 4599,
  [SMALL_STATE(57)] = 4675,
  [SMALL_STATE(58)] = 4751,
  [SMALL_STATE(59)] = 4827,
  [SMALL_STATE(60)] = 4899,
  [SMALL_STATE(61)] = 4971,
  [SMALL_STATE(62)] = 5043,
  [SMALL_STATE(63)] = 5115,
  [SMALL_STATE(64)] = 5161,
  [SMALL_STATE(65)] = 5203,
  [SMALL_STATE(66)] = 5251,
  [SMALL_STATE(67)] = 5295,
  [SMALL_STATE(68)] = 5349,
  [SMALL_STATE(69)] = 5403,
  [SMALL_STATE(70)] = 5465,
  [SMALL_STATE(71)] = 5517,
  [SMALL_STATE(72)] = 5550,
  [SMALL_STATE(73)] = 5580,
  [SMALL_STATE(74)] = 5640,
  [SMALL_STATE(75)] = 5670,
  [SMALL_STATE(76)] = 5700,
  [SMALL_STATE(77)] = 5730,
  [SMALL_STATE(78)] = 5760,
  [SMALL_STATE(79)] = 5790,
  [SMALL_STATE(80)] = 5842,
  [SMALL_STATE(81)] = 5888,
  [SMALL_STATE(82)] = 5932,
  [SMALL_STATE(83)] = 5972,
  [SMALL_STATE(84)] = 6002,
  [SMALL_STATE(85)] = 6032,
  [SMALL_STATE(86)] = 6074,
  [SMALL_STATE(87)] = 6104,
  [SMALL_STATE(88)] = 6156,
  [SMALL_STATE(89)] = 6186,
  [SMALL_STATE(90)] = 6236,
  [SMALL_STATE(91)] = 6266,
  [SMALL_STATE(92)] = 6296,
  [SMALL_STATE(93)] = 6326,
  [SMALL_STATE(94)] = 6356,
  [SMALL_STATE(95)] = 6386,
  [SMALL_STATE(96)] = 6416,
  [SMALL_STATE(97)] = 6446,
  [SMALL_STATE(98)] = 6476,
  [SMALL_STATE(99)] = 6506,
  [SMALL_STATE(100)] = 6536,
  [SMALL_STATE(101)] = 6566,
  [SMALL_STATE(102)] = 6596,
  [SMALL_STATE(103)] = 6626,
  [SMALL_STATE(104)] = 6656,
  [SMALL_STATE(105)] = 6718,
  [SMALL_STATE(106)] = 6780,
  [SMALL_STATE(107)] = 6836,
  [SMALL_STATE(108)] = 6892,
  [SMALL_STATE(109)] = 6954,
  [SMALL_STATE(110)] = 7011,
  [SMALL_STATE(111)] = 7068,
  [SMALL_STATE(112)] = 7099,
  [SMALL_STATE(113)] = 7156,
  [SMALL_STATE(114)] = 7213,
  [SMALL_STATE(115)] = 7241,
  [SMALL_STATE(116)] = 7269,
  [SMALL_STATE(117)] = 7325,
  [SMALL_STATE(118)] = 7353,
  [SMALL_STATE(119)] = 7381,
  [SMALL_STATE(120)] = 7437,
  [SMALL_STATE(121)] = 7493,
  [SMALL_STATE(122)] = 7521,
  [SMALL_STATE(123)] = 7549,
  [SMALL_STATE(124)] = 7605,
  [SMALL_STATE(125)] = 7633,
  [SMALL_STATE(126)] = 7689,
  [SMALL_STATE(127)] = 7717,
  [SMALL_STATE(128)] = 7745,
  [SMALL_STATE(129)] = 7773,
  [SMALL_STATE(130)] = 7801,
  [SMALL_STATE(131)] = 7857,
  [SMALL_STATE(132)] = 7885,
  [SMALL_STATE(133)] = 7913,
  [SMALL_STATE(134)] = 7941,
  [SMALL_STATE(135)] = 7969,
  [SMALL_STATE(136)] = 7997,
  [SMALL_STATE(137)] = 8025,
  [SMALL_STATE(138)] = 8053,
  [SMALL_STATE(139)] = 8109,
  [SMALL_STATE(140)] = 8137,
  [SMALL_STATE(141)] = 8165,
  [SMALL_STATE(142)] = 8193,
  [SMALL_STATE(143)] = 8221,
  [SMALL_STATE(144)] = 8249,
  [SMALL_STATE(145)] = 8277,
  [SMALL_STATE(146)] = 8308,
  [SMALL_STATE(147)] = 8334,
  [SMALL_STATE(148)] = 8360,
  [SMALL_STATE(149)] = 8386,
  [SMALL_STATE(150)] = 8412,
  [SMALL_STATE(151)] = 8438,
  [SMALL_STATE(152)] = 8462,
  [SMALL_STATE(153)] = 8486,
  [SMALL_STATE(154)] = 8510,
  [SMALL_STATE(155)] = 8534,
  [SMALL_STATE(156)] = 8554,
  [SMALL_STATE(157)] = 8574,
  [SMALL_STATE(158)] = 8594,
  [SMALL_STATE(159)] = 8614,
  [SMALL_STATE(160)] = 8634,
  [SMALL_STATE(161)] = 8654,
  [SMALL_STATE(162)] = 8669,
  [SMALL_STATE(163)] = 8684,
  [SMALL_STATE(164)] = 8699,
  [SMALL_STATE(165)] = 8714,
  [SMALL_STATE(166)] = 8729,
  [SMALL_STATE(167)] = 8740,
  [SMALL_STATE(168)] = 8753,
  [SMALL_STATE(169)] = 8766,
  [SMALL_STATE(170)] = 8777,
  [SMALL_STATE(171)] = 8788,
  [SMALL_STATE(172)] = 8799,
  [SMALL_STATE(173)] = 8812,
  [SMALL_STATE(174)] = 8823,
  [SMALL_STATE(175)] = 8836,
  [SMALL_STATE(176)] = 8847,
  [SMALL_STATE(177)] = 8858,
  [SMALL_STATE(178)] = 8871,
  [SMALL_STATE(179)] = 8884,
  [SMALL_STATE(180)] = 8895,
  [SMALL_STATE(181)] = 8908,
  [SMALL_STATE(182)] = 8919,
  [SMALL_STATE(183)] = 8929,
  [SMALL_STATE(184)] = 8939,
  [SMALL_STATE(185)] = 8945,
  [SMALL_STATE(186)] = 8955,
  [SMALL_STATE(187)] = 8961,
  [SMALL_STATE(188)] = 8971,
  [SMALL_STATE(189)] = 8981,
  [SMALL_STATE(190)] = 8991,
  [SMALL_STATE(191)] = 9001,
  [SMALL_STATE(192)] = 9011,
  [SMALL_STATE(193)] = 9017,
  [SMALL_STATE(194)] = 9023,
  [SMALL_STATE(195)] = 9033,
  [SMALL_STATE(196)] = 9039,
  [SMALL_STATE(197)] = 9045,
  [SMALL_STATE(198)] = 9051,
  [SMALL_STATE(199)] = 9061,
  [SMALL_STATE(200)] = 9071,
  [SMALL_STATE(201)] = 9081,
  [SMALL_STATE(202)] = 9091,
  [SMALL_STATE(203)] = 9097,
  [SMALL_STATE(204)] = 9107,
  [SMALL_STATE(205)] = 9117,
  [SMALL_STATE(206)] = 9122,
  [SMALL_STATE(207)] = 9127,
  [SMALL_STATE(208)] = 9132,
  [SMALL_STATE(209)] = 9137,
  [SMALL_STATE(210)] = 9144,
  [SMALL_STATE(211)] = 9149,
  [SMALL_STATE(212)] = 9154,
  [SMALL_STATE(213)] = 9161,
  [SMALL_STATE(214)] = 9168,
  [SMALL_STATE(215)] = 9173,
  [SMALL_STATE(216)] = 9178,
  [SMALL_STATE(217)] = 9185,
  [SMALL_STATE(218)] = 9189,
  [SMALL_STATE(219)] = 9193,
  [SMALL_STATE(220)] = 9197,
  [SMALL_STATE(221)] = 9201,
  [SMALL_STATE(222)] = 9205,
  [SMALL_STATE(223)] = 9209,
  [SMALL_STATE(224)] = 9213,
  [SMALL_STATE(225)] = 9217,
  [SMALL_STATE(226)] = 9221,
  [SMALL_STATE(227)] = 9225,
  [SMALL_STATE(228)] = 9229,
  [SMALL_STATE(229)] = 9233,
  [SMALL_STATE(230)] = 9237,
  [SMALL_STATE(231)] = 9241,
  [SMALL_STATE(232)] = 9245,
  [SMALL_STATE(233)] = 9249,
  [SMALL_STATE(234)] = 9253,
  [SMALL_STATE(235)] = 9257,
  [SMALL_STATE(236)] = 9261,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [43] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(31),
  [46] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(198),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2),
  [51] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(166),
  [54] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(36),
  [57] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(30),
  [60] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(45),
  [63] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(45),
  [66] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(77),
  [69] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(234),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(233),
  [75] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(231),
  [78] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(168),
  [81] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(164),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(74),
  [87] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(26),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(71),
  [93] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iteration_statement_repeat1, 2), SHIFT_REPEAT(169),
  [96] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [98] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_selection_statement_repeat1, 4),
  [110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_selection_statement_repeat1, 3),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(31),
  [115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(198),
  [120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(36),
  [123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(30),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(45),
  [129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(45),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(77),
  [135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(234),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(233),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(231),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(168),
  [147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(164),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(74),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(26),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(71),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(176),
  [162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build_definition, 1),
  [164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(170),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2),
  [177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_build_definition_repeat1, 2), SHIFT_REPEAT(171),
  [180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3),
  [268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_id_expression, 1),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_id, 1),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4),
  [278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1),
  [302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_expression, 6),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_literal, 1),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5),
  [312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3),
  [314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 3),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 3),
  [318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_simple, 3),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_multiline, 3),
  [322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_literal, 3),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 4),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hex_literal, 2),
  [330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_multiline, 2),
  [332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 2),
  [334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_literal, 4),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_expression, 5),
  [338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_literal, 2),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 3),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4),
  [344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__octal_literal, 2),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_simple, 2),
  [348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_literal, 2),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 1),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3),
  [360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition, 1),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_item, 3),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_id_expression, 1),
  [370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_id, 1),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_literal_repeat1, 2),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_value_item, 3, .production_id = 1),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_literal, 1),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_multiline, 2),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_simple, 2),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_literal, 2),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hex_literal, 2),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__octal_literal, 2),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 2),
  [402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_literal, 2),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 3),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_expression, 6),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_expression, 5),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_literal, 4),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 4),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 3),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_simple, 3),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_multiline, 3),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_literal, 3),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_arg_key, 1),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__NEWLINE, 2),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__NEWLINE, 2),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 2),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 2),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jump_statement, 2),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jump_statement, 2),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_operator, 1),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_operator, 1),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rel_operator, 2),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rel_operator, 2),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rel_operator, 1),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rel_operator, 1),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equ_operator, 1),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equ_operator, 1),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mult_operator, 1),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mult_operator, 1),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_operator, 1),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_add_operator, 1),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_multiline_repeat1, 2), SHIFT_REPEAT(165),
  [499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_multiline_repeat1, 2),
  [501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_multiline_repeat1, 2), SHIFT_REPEAT(165),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_simple_repeat1, 2), SHIFT_REPEAT(178),
  [541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_simple_repeat1, 2),
  [543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_simple_repeat1, 2), SHIFT_REPEAT(178),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_selection_statement_repeat1, 2), SHIFT_REPEAT(28),
  [549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_selection_statement_repeat1, 2),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_literal_repeat1, 2), SHIFT_REPEAT(40),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_identifier_list_repeat1, 2),
  [560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_identifier_list_repeat1, 2), SHIFT_REPEAT(216),
  [563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 6),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selection_statement, 6),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_list, 2),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(27),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selection_statement, 8),
  [586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selection_statement, 4),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 7),
  [592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selection_statement, 7),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selection_statement, 5),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_key_value_list_repeat1, 2), SHIFT_REPEAT(32),
  [603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_key_value_list_repeat1, 2),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_list, 1),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [635] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_meson(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
