#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 454
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 109
#define ALIAS_COUNT 0
#define TOKEN_COUNT 72
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 13
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 18

enum {
  anon_sym_SEMI = 1,
  anon_sym_LF = 2,
  anon_sym_PIPE = 3,
  anon_sym_COMMA = 4,
  anon_sym_COLON = 5,
  anon_sym_export = 6,
  anon_sym_env = 7,
  anon_sym_if = 8,
  anon_sym_else = 9,
  anon_sym_def = 10,
  anon_sym_alias = 11,
  anon_sym_EQ = 12,
  anon_sym_LBRACK = 13,
  anon_sym_RBRACK = 14,
  anon_sym_QMARK = 15,
  anon_sym_LPAREN = 16,
  anon_sym_RPAREN = 17,
  sym_flag_name = 18,
  sym_flag_shorthand_name = 19,
  anon_sym_DOT_DOT_DOTrest = 20,
  anon_sym_int = 21,
  anon_sym_float = 22,
  anon_sym_range = 23,
  anon_sym_bool = 24,
  anon_sym_string = 25,
  anon_sym_block = 26,
  anon_sym_duration = 27,
  anon_sym_date = 28,
  anon_sym_filesize = 29,
  anon_sym_number = 30,
  anon_sym_table = 31,
  anon_sym_error = 32,
  anon_sym_binary = 33,
  anon_sym_let = 34,
  sym_number_literal = 35,
  sym_word = 36,
  anon_sym_DOLLAR = 37,
  anon_sym_DQUOTE = 38,
  aux_sym_string_token1 = 39,
  anon_sym_SQUOTE = 40,
  aux_sym_string_token2 = 41,
  anon_sym_BQUOTE = 42,
  aux_sym_string_token3 = 43,
  anon_sym_DOT = 44,
  aux_sym_file_path_token1 = 45,
  aux_sym_file_path_token2 = 46,
  sym_flag_arg = 47,
  anon_sym_DOT_DOT = 48,
  sym_identifier = 49,
  anon_sym_LBRACE = 50,
  anon_sym_RBRACE = 51,
  sym_comment = 52,
  anon_sym_PLUS = 53,
  anon_sym_DASH = 54,
  anon_sym_STAR = 55,
  anon_sym_SLASH = 56,
  anon_sym_PERCENT = 57,
  anon_sym_mod = 58,
  anon_sym_PIPE_PIPE = 59,
  anon_sym_AMP_AMP = 60,
  anon_sym_EQ_TILDE = 61,
  anon_sym_EQ_EQ = 62,
  anon_sym_BANG_EQ = 63,
  anon_sym_in = 64,
  anon_sym_GT = 65,
  anon_sym_GT_EQ = 66,
  anon_sym_LT_EQ = 67,
  anon_sym_LT = 68,
  anon_sym_LT_LT = 69,
  anon_sym_GT_GT = 70,
  sym__cmd_newline = 71,
  sym_source_file = 72,
  sym__statements = 73,
  sym__terminator = 74,
  sym__statement = 75,
  sym_record_entry = 76,
  sym_env_export = 77,
  sym_if_statement = 78,
  sym_function_definition = 79,
  sym_alias = 80,
  sym_signature = 81,
  sym_parameter = 82,
  sym_flag = 83,
  sym_rest = 84,
  sym_type = 85,
  sym_variable_declaration = 86,
  sym_command = 87,
  sym__expression = 88,
  sym__cmd_expr = 89,
  sym_string = 90,
  sym_value_path = 91,
  sym_file_path = 92,
  sym_range = 93,
  sym_table = 94,
  sym_array = 95,
  sym_record_or_block = 96,
  sym_block = 97,
  sym_block_args = 98,
  sym_cmd_invocation = 99,
  sym_binary_expression = 100,
  aux_sym__statements_repeat1 = 101,
  aux_sym__statement_repeat1 = 102,
  aux_sym_signature_repeat1 = 103,
  aux_sym_command_repeat1 = 104,
  aux_sym_value_path_repeat1 = 105,
  aux_sym_table_repeat1 = 106,
  aux_sym_array_repeat1 = 107,
  aux_sym_block_args_repeat1 = 108,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_PIPE] = "|",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON] = ":",
  [anon_sym_export] = "export",
  [anon_sym_env] = "env",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_def] = "def",
  [anon_sym_alias] = "alias",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_QMARK] = "\?",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [sym_flag_name] = "flag_name",
  [sym_flag_shorthand_name] = "flag_shorthand_name",
  [anon_sym_DOT_DOT_DOTrest] = "...rest",
  [anon_sym_int] = "int",
  [anon_sym_float] = "float",
  [anon_sym_range] = "range",
  [anon_sym_bool] = "bool",
  [anon_sym_string] = "string",
  [anon_sym_block] = "block",
  [anon_sym_duration] = "duration",
  [anon_sym_date] = "date",
  [anon_sym_filesize] = "filesize",
  [anon_sym_number] = "number",
  [anon_sym_table] = "table",
  [anon_sym_error] = "error",
  [anon_sym_binary] = "binary",
  [anon_sym_let] = "let",
  [sym_number_literal] = "number_literal",
  [sym_word] = "word",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [anon_sym_BQUOTE] = "`",
  [aux_sym_string_token3] = "string_token3",
  [anon_sym_DOT] = ".",
  [aux_sym_file_path_token1] = "file_path_token1",
  [aux_sym_file_path_token2] = "file_path_token2",
  [sym_flag_arg] = "flag_arg",
  [anon_sym_DOT_DOT] = "..",
  [sym_identifier] = "identifier",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_comment] = "comment",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_mod] = "mod",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_in] = "in",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [sym__cmd_newline] = "_cmd_newline",
  [sym_source_file] = "source_file",
  [sym__statements] = "_statements",
  [sym__terminator] = "_terminator",
  [sym__statement] = "_statement",
  [sym_record_entry] = "record_entry",
  [sym_env_export] = "env_export",
  [sym_if_statement] = "if_statement",
  [sym_function_definition] = "function_definition",
  [sym_alias] = "alias",
  [sym_signature] = "signature",
  [sym_parameter] = "parameter",
  [sym_flag] = "flag",
  [sym_rest] = "rest",
  [sym_type] = "type",
  [sym_variable_declaration] = "variable_declaration",
  [sym_command] = "command",
  [sym__expression] = "_expression",
  [sym__cmd_expr] = "_cmd_expr",
  [sym_string] = "string",
  [sym_value_path] = "value_path",
  [sym_file_path] = "file_path",
  [sym_range] = "range",
  [sym_table] = "table",
  [sym_array] = "array",
  [sym_record_or_block] = "record_or_block",
  [sym_block] = "block",
  [sym_block_args] = "block_args",
  [sym_cmd_invocation] = "cmd_invocation",
  [sym_binary_expression] = "binary_expression",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym__statement_repeat1] = "_statement_repeat1",
  [aux_sym_signature_repeat1] = "signature_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_value_path_repeat1] = "value_path_repeat1",
  [aux_sym_table_repeat1] = "table_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_block_args_repeat1] = "block_args_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_env] = anon_sym_env,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [sym_flag_name] = sym_flag_name,
  [sym_flag_shorthand_name] = sym_flag_shorthand_name,
  [anon_sym_DOT_DOT_DOTrest] = anon_sym_DOT_DOT_DOTrest,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_range] = anon_sym_range,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_block] = anon_sym_block,
  [anon_sym_duration] = anon_sym_duration,
  [anon_sym_date] = anon_sym_date,
  [anon_sym_filesize] = anon_sym_filesize,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_table] = anon_sym_table,
  [anon_sym_error] = anon_sym_error,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_let] = anon_sym_let,
  [sym_number_literal] = sym_number_literal,
  [sym_word] = sym_word,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym_string_token3] = aux_sym_string_token3,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym_file_path_token1] = aux_sym_file_path_token1,
  [aux_sym_file_path_token2] = aux_sym_file_path_token2,
  [sym_flag_arg] = sym_flag_arg,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [sym_identifier] = sym_identifier,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [sym_comment] = sym_comment,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [sym__cmd_newline] = sym__cmd_newline,
  [sym_source_file] = sym_source_file,
  [sym__statements] = sym__statements,
  [sym__terminator] = sym__terminator,
  [sym__statement] = sym__statement,
  [sym_record_entry] = sym_record_entry,
  [sym_env_export] = sym_env_export,
  [sym_if_statement] = sym_if_statement,
  [sym_function_definition] = sym_function_definition,
  [sym_alias] = sym_alias,
  [sym_signature] = sym_signature,
  [sym_parameter] = sym_parameter,
  [sym_flag] = sym_flag,
  [sym_rest] = sym_rest,
  [sym_type] = sym_type,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_command] = sym_command,
  [sym__expression] = sym__expression,
  [sym__cmd_expr] = sym__cmd_expr,
  [sym_string] = sym_string,
  [sym_value_path] = sym_value_path,
  [sym_file_path] = sym_file_path,
  [sym_range] = sym_range,
  [sym_table] = sym_table,
  [sym_array] = sym_array,
  [sym_record_or_block] = sym_record_or_block,
  [sym_block] = sym_block,
  [sym_block_args] = sym_block_args,
  [sym_cmd_invocation] = sym_cmd_invocation,
  [sym_binary_expression] = sym_binary_expression,
  [aux_sym__statements_repeat1] = aux_sym__statements_repeat1,
  [aux_sym__statement_repeat1] = aux_sym__statement_repeat1,
  [aux_sym_signature_repeat1] = aux_sym_signature_repeat1,
  [aux_sym_command_repeat1] = aux_sym_command_repeat1,
  [aux_sym_value_path_repeat1] = aux_sym_value_path_repeat1,
  [aux_sym_table_repeat1] = aux_sym_table_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_block_args_repeat1] = aux_sym_block_args_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_env] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_flag_name] = {
    .visible = true,
    .named = true,
  },
  [sym_flag_shorthand_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOTrest] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_duration] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_date] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_filesize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_error] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_file_path_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_file_path_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_flag_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__cmd_newline] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_record_entry] = {
    .visible = true,
    .named = true,
  },
  [sym_env_export] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_flag] = {
    .visible = true,
    .named = true,
  },
  [sym_rest] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_value_path] = {
    .visible = true,
    .named = true,
  },
  [sym_file_path] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_record_or_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block_args] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_value_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_args_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alias_name = 1,
  field_arg = 2,
  field_block_param = 3,
  field_cmd_name = 4,
  field_entry_name = 5,
  field_from = 6,
  field_func_name = 7,
  field_left = 8,
  field_name = 9,
  field_operator = 10,
  field_right = 11,
  field_to = 12,
  field_value = 13,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias_name] = "alias_name",
  [field_arg] = "arg",
  [field_block_param] = "block_param",
  [field_cmd_name] = "cmd_name",
  [field_entry_name] = "entry_name",
  [field_from] = "from",
  [field_func_name] = "func_name",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_right] = "right",
  [field_to] = "to",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 2},
  [7] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 1},
  [9] = {.index = 12, .length = 3},
  [10] = {.index = 15, .length = 1},
  [11] = {.index = 16, .length = 1},
  [12] = {.index = 17, .length = 1},
  [13] = {.index = 18, .length = 2},
  [14] = {.index = 20, .length = 3},
  [15] = {.index = 23, .length = 1},
  [16] = {.index = 24, .length = 2},
  [17] = {.index = 26, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_cmd_name, 0},
  [1] =
    {field_arg, 0},
  [2] =
    {field_from, 0},
    {field_to, 2},
  [4] =
    {field_entry_name, 0},
  [5] =
    {field_cmd_name, 0},
    {field_cmd_name, 1},
  [7] =
    {field_arg, 1, .inherited = true},
    {field_cmd_name, 0},
  [9] =
    {field_arg, 0, .inherited = true},
    {field_arg, 1, .inherited = true},
  [11] =
    {field_block_param, 0},
  [12] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [15] =
    {field_func_name, 1},
  [16] =
    {field_alias_name, 1},
  [17] =
    {field_value, 3},
  [18] =
    {field_name, 1},
    {field_value, 3},
  [20] =
    {field_arg, 2, .inherited = true},
    {field_cmd_name, 0},
    {field_cmd_name, 1},
  [23] =
    {field_block_param, 1, .inherited = true},
  [24] =
    {field_block_param, 0, .inherited = true},
    {field_block_param, 1, .inherited = true},
  [26] =
    {field_func_name, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_word_character_set_1(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '$')))
    : (c <= ')' || (c < '['
      ? (c < ';'
        ? c == '-'
        : c <= ';')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '}')))));
}

static inline bool sym_word_character_set_2(int32_t c) {
  return (c < '"'
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == ' '))
    : (c <= '$' || (c < '['
      ? (c < ';'
        ? (c >= '\'' && c <= ')')
        : c <= ';')
      : (c <= ']' || (c >= '`' && c <= '}')))));
}

static inline bool sym_word_character_set_3(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '$')))
    : (c <= ')' || (c < '['
      ? (c < ';'
        ? (c >= '-' && c <= '.')
        : c <= ';')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '}')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(130);
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == ')') ADVANCE(169);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == ',') ADVANCE(144);
      if (lookahead == '-') ADVANCE(338);
      if (lookahead == '.') ADVANCE(289);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ':') ADVANCE(146);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '?') ADVANCE(165);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'a') ADVANCE(206);
      if (lookahead == 'b') ADVANCE(204);
      if (lookahead == 'd') ADVANCE(199);
      if (lookahead == 'e') ADVANCE(207);
      if (lookahead == 'f') ADVANCE(205);
      if (lookahead == 'i') ADVANCE(203);
      if (lookahead == 'l') ADVANCE(202);
      if (lookahead == 'm') ADVANCE(208);
      if (lookahead == 'n') ADVANCE(210);
      if (lookahead == 'r') ADVANCE(201);
      if (lookahead == 's') ADVANCE(209);
      if (lookahead == 't') ADVANCE(200);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(331);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(191);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(290);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(135);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == ':') ADVANCE(146);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '?') ADVANCE(165);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(4);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(135);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == ':') ADVANCE(146);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '?') ADVANCE(165);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(4);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(136);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '?') ADVANCE(165);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(6);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(136);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '?') ADVANCE(165);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(6);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(137);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(8);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(137);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(8);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(138);
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(33);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(10);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 10:
      if (lookahead == '\n') ADVANCE(138);
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(34);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(10);
      if (lookahead == ')' ||
          lookahead == ']' ||
          lookahead == '}') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == ')') ADVANCE(169);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == ',') ADVANCE(144);
      if (lookahead == '-') ADVANCE(338);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ':') ADVANCE(146);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '?') ADVANCE(165);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'a') ADVANCE(206);
      if (lookahead == 'b') ADVANCE(204);
      if (lookahead == 'd') ADVANCE(199);
      if (lookahead == 'e') ADVANCE(207);
      if (lookahead == 'f') ADVANCE(205);
      if (lookahead == 'i') ADVANCE(203);
      if (lookahead == 'l') ADVANCE(202);
      if (lookahead == 'm') ADVANCE(208);
      if (lookahead == 'n') ADVANCE(210);
      if (lookahead == 'r') ADVANCE(201);
      if (lookahead == 's') ADVANCE(209);
      if (lookahead == 't') ADVANCE(200);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(331);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(191);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == ',') ADVANCE(144);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ')' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == ',') ADVANCE(144);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(290);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == ';') ADVANCE(132);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ')' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == ',') ADVANCE(144);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(33);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(198);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '%') ADVANCE(345);
      if (lookahead == '&') ADVANCE(195);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '+') ADVANCE(336);
      if (lookahead == ',') ADVANCE(144);
      if (lookahead == '-') ADVANCE(339);
      if (lookahead == '.') ADVANCE(34);
      if (lookahead == '/') ADVANCE(343);
      if (lookahead == '<') ADVANCE(361);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(357);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead == 'm') ADVANCE(309);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'm') ADVANCE(85);
      if (lookahead == '{') ADVANCE(328);
      if (lookahead == '|') ADVANCE(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16)
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == ')') ADVANCE(169);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'a') ADVANCE(307);
      if (lookahead == 'd') ADVANCE(305);
      if (lookahead == 'e') ADVANCE(310);
      if (lookahead == 'i') ADVANCE(306);
      if (lookahead == 'l') ADVANCE(304);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '}') ADVANCE(331);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ';' ||
          lookahead == ']') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(163);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '$') ADVANCE(271);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == '(') ADVANCE(166);
      if (lookahead == ',') ADVANCE(143);
      if (lookahead == '-') ADVANCE(24);
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == ':') ADVANCE(145);
      if (lookahead == '?') ADVANCE(164);
      if (lookahead == ']') ADVANCE(162);
      if (lookahead == '`') ADVANCE(283);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '-') ADVANCE(116);
      if (lookahead == '=') ADVANCE(157);
      if (lookahead == 'b') ADVANCE(69);
      if (lookahead == 'd') ADVANCE(46);
      if (lookahead == 'e') ADVANCE(95);
      if (lookahead == 'f') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(84);
      if (lookahead == 'n') ADVANCE(108);
      if (lookahead == 'r') ADVANCE(48);
      if (lookahead == 's') ADVANCE(107);
      if (lookahead == 't') ADVANCE(45);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      END_STATE();
    case 22:
      if (lookahead == '&') ADVANCE(350);
      END_STATE();
    case 23:
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '~') ADVANCE(40);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(297);
      END_STATE();
    case 24:
      if (lookahead == '-') ADVANCE(115);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '|') ADVANCE(349);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(302);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(291);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(291);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(117);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(40);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(293);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(293);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 33:
      if (lookahead == '.') ADVANCE(303);
      if (lookahead == '/') ADVANCE(117);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(40);
      END_STATE();
    case 34:
      if (lookahead == '.') ADVANCE(303);
      if (lookahead == '/') ADVANCE(295);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(294);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(291);
      END_STATE();
    case 35:
      if (lookahead == '.') ADVANCE(301);
      END_STATE();
    case 36:
      if (lookahead == '.') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(270);
      END_STATE();
    case 37:
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 38:
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 39:
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (('-' <= lookahead && lookahead <= '9') ||
          lookahead == '~') ADVANCE(40);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(297);
      END_STATE();
    case 40:
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '.') ADVANCE(292);
      if (lookahead == '/') ADVANCE(295);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(294);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(291);
      END_STATE();
    case 42:
      if (lookahead == '.') ADVANCE(43);
      END_STATE();
    case 43:
      if (lookahead == '.') ADVANCE(98);
      END_STATE();
    case 44:
      if (lookahead == '=') ADVANCE(353);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(106);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 49:
      if (lookahead == 'a') ADVANCE(94);
      END_STATE();
    case 50:
      if (lookahead == 'a') ADVANCE(102);
      END_STATE();
    case 51:
      if (lookahead == 'b') ADVANCE(63);
      END_STATE();
    case 52:
      if (lookahead == 'b') ADVANCE(76);
      END_STATE();
    case 53:
      if (lookahead == 'c') ADVANCE(72);
      END_STATE();
    case 54:
      if (lookahead == 'd') ADVANCE(346);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 64:
      if (lookahead == 'f') ADVANCE(153);
      END_STATE();
    case 65:
      if (lookahead == 'g') ADVANCE(178);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(57);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(74);
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(111);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(83);
      if (lookahead == 'l') ADVANCE(86);
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(89);
      END_STATE();
    case 72:
      if (lookahead == 'k') ADVANCE(179);
      END_STATE();
    case 73:
      if (lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 74:
      if (lookahead == 'l') ADVANCE(61);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(101);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(58);
      END_STATE();
    case 77:
      if (lookahead == 'm') ADVANCE(51);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(354);
      END_STATE();
    case 79:
      if (lookahead == 'n') ADVANCE(180);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 85:
      if (lookahead == 'o') ADVANCE(54);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 87:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(91);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 90:
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 91:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 94:
      if (lookahead == 'r') ADVANCE(110);
      END_STATE();
    case 95:
      if (lookahead == 'r') ADVANCE(97);
      END_STATE();
    case 96:
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 98:
      if (lookahead == 'r') ADVANCE(62);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 100:
      if (lookahead == 's') ADVANCE(104);
      END_STATE();
    case 101:
      if (lookahead == 's') ADVANCE(56);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(55);
      END_STATE();
    case 106:
      if (lookahead == 't') ADVANCE(71);
      END_STATE();
    case 107:
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 108:
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 109:
      if (lookahead == 'v') ADVANCE(149);
      END_STATE();
    case 110:
      if (lookahead == 'y') ADVANCE(186);
      END_STATE();
    case 111:
      if (lookahead == 'z') ADVANCE(59);
      END_STATE();
    case 112:
      if (lookahead == '|') ADVANCE(349);
      END_STATE();
    case 113:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 114:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(299);
      END_STATE();
    case 115:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(170);
      END_STATE();
    case 116:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      END_STATE();
    case 117:
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(40);
      END_STATE();
    case 118:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(270);
      END_STATE();
    case 119:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '$') ADVANCE(271);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == ',') ADVANCE(143);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '.') ADVANCE(288);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == '`') ADVANCE(283);
      if (lookahead == 'i') ADVANCE(325);
      if (lookahead == 'm') ADVANCE(326);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(121)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 120:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '$') ADVANCE(271);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == ',') ADVANCE(143);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == '`') ADVANCE(283);
      if (lookahead == 'i') ADVANCE(325);
      if (lookahead == 'm') ADVANCE(326);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(120)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 121:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '$') ADVANCE(271);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == ',') ADVANCE(143);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == '`') ADVANCE(283);
      if (lookahead == 'i') ADVANCE(325);
      if (lookahead == 'm') ADVANCE(326);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(121)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 122:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '.') ADVANCE(288);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ':') ADVANCE(145);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'm') ADVANCE(85);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(124)
      END_STATE();
    case 123:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'm') ADVANCE(85);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(123)
      END_STATE();
    case 124:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ':') ADVANCE(145);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'm') ADVANCE(85);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(124)
      END_STATE();
    case 125:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '$') ADVANCE(271);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == ',') ADVANCE(143);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == '`') ADVANCE(283);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(125)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 126:
      if (eof) ADVANCE(130);
      if (lookahead == '\n') ADVANCE(134);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == ';') ADVANCE(131);
      if (lookahead == 'e') ADVANCE(75);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(126)
      END_STATE();
    case 127:
      if (eof) ADVANCE(130);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '.') ADVANCE(288);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ':') ADVANCE(145);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == '[') ADVANCE(160);
      if (lookahead == ']') ADVANCE(162);
      if (lookahead == '`') ADVANCE(283);
      if (lookahead == 'd') ADVANCE(60);
      if (lookahead == 'e') ADVANCE(80);
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'm') ADVANCE(85);
      if (lookahead == '{') ADVANCE(328);
      if (lookahead == '|') ADVANCE(112);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(128)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 128:
      if (eof) ADVANCE(130);
      if (lookahead == '!') ADVANCE(44);
      if (lookahead == '"') ADVANCE(273);
      if (lookahead == '#') ADVANCE(334);
      if (lookahead == '%') ADVANCE(344);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == ')') ADVANCE(168);
      if (lookahead == '*') ADVANCE(340);
      if (lookahead == '+') ADVANCE(335);
      if (lookahead == '-') ADVANCE(337);
      if (lookahead == '/') ADVANCE(342);
      if (lookahead == ':') ADVANCE(145);
      if (lookahead == '<') ADVANCE(362);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(358);
      if (lookahead == '[') ADVANCE(160);
      if (lookahead == ']') ADVANCE(162);
      if (lookahead == '`') ADVANCE(283);
      if (lookahead == 'd') ADVANCE(60);
      if (lookahead == 'e') ADVANCE(80);
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'm') ADVANCE(85);
      if (lookahead == '{') ADVANCE(328);
      if (lookahead == '|') ADVANCE(112);
      if (lookahead == '}') ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(128)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 129:
      if (eof) ADVANCE(130);
      if (lookahead == '"') ADVANCE(274);
      if (lookahead == '#') ADVANCE(333);
      if (lookahead == '$') ADVANCE(272);
      if (lookahead == '\'') ADVANCE(279);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == ')') ADVANCE(169);
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '[') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '`') ADVANCE(284);
      if (lookahead == 'a') ADVANCE(307);
      if (lookahead == 'd') ADVANCE(305);
      if (lookahead == 'e') ADVANCE(310);
      if (lookahead == 'i') ADVANCE(306);
      if (lookahead == 'l') ADVANCE(304);
      if (lookahead == '{') ADVANCE(329);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '}') ADVANCE(331);
      if (lookahead == '~') ADVANCE(196);
      if (lookahead == ';' ||
          lookahead == ']') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(311);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(135);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(4);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(6);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(137);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(8);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(10);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '|') ADVANCE(349);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(349);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_COMMA);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_env);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_alias);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '=') ADVANCE(352);
      if (lookahead == '~') ADVANCE(351);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(352);
      if (lookahead == '~') ADVANCE(351);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_flag_name);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(171);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_flag_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_flag_shorthand_name);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOTrest);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_range);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_duration);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_date);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_filesize);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_table);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_error);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_let);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '.') ADVANCE(31);
      if (lookahead == '/') ADVANCE(269);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(190);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(197);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '.') ADVANCE(37);
      if (lookahead == '/') ADVANCE(269);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(190);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(197);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '&') ADVANCE(350);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '\\') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(197);
      if (!sym_word_character_set_2(lookahead)) ADVANCE(270);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '\\') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(197);
      if (!sym_word_character_set_2(lookahead)) ADVANCE(270);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '=') ADVANCE(353);
      if (lookahead == '\\') ADVANCE(118);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'a') ADVANCE(261);
      if (lookahead == 'e') ADVANCE(228);
      if (lookahead == 'u') ADVANCE(255);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'a') ADVANCE(218);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'a') ADVANCE(240);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(262);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'f') ADVANCE(150);
      if (lookahead == 'n') ADVANCE(354);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(242);
      if (lookahead == 'l') ADVANCE(244);
      if (lookahead == 'o') ADVANCE(245);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(237);
      if (lookahead == 'l') ADVANCE(247);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(231);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(259);
      if (lookahead == 'n') ADVANCE(266);
      if (lookahead == 'r') ADVANCE(256);
      if (lookahead == 'x') ADVANCE(250);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'o') ADVANCE(220);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 't') ADVANCE(254);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'u') ADVANCE(239);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(118);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '.') ADVANCE(291);
      if (lookahead == '\\') ADVANCE(118);
      if (!sym_word_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'a') ADVANCE(258);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'a') ADVANCE(265);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'a') ADVANCE(263);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'a') ADVANCE(251);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'b') ADVANCE(227);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'b') ADVANCE(238);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'c') ADVANCE(235);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'd') ADVANCE(346);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(181);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(152);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(176);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(184);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(182);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(260);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(253);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'f') ADVANCE(153);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'g') ADVANCE(178);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'g') ADVANCE(223);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(213);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(268);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(243);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(246);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'k') ADVANCE(179);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(177);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(226);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(224);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'm') ADVANCE(217);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'n') ADVANCE(230);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'n') ADVANCE(180);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'n') ADVANCE(216);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'n') ADVANCE(229);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'o') ADVANCE(219);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'o') ADVANCE(236);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'o') ADVANCE(241);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'o') ADVANCE(215);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'o') ADVANCE(252);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'o') ADVANCE(257);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'p') ADVANCE(249);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(267);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(185);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(183);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(233);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(214);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(248);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(264);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 's') ADVANCE(155);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 's') ADVANCE(222);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 's') ADVANCE(232);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 't') ADVANCE(221);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 't') ADVANCE(187);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 't') ADVANCE(175);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 't') ADVANCE(147);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 't') ADVANCE(234);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'v') ADVANCE(149);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'y') ADVANCE(186);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == 'z') ADVANCE(225);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (lookahead == '-' ||
          lookahead == '.') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(197);
      if (!sym_word_character_set_2(lookahead)) ADVANCE(270);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\') ADVANCE(118);
      if (!sym_word_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(275);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(276);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(277);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(277);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '\n') ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(280);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '#') ADVANCE(280);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(282);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(282);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '\n') ADVANCE(287);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(285);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '#') ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(286);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(287);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(302);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(117);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(40);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_file_path_token1);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_file_path_token1);
      if (lookahead == '.') ADVANCE(293);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_file_path_token1);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_file_path_token1);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(40);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_file_path_token1);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '~') ADVANCE(40);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_file_path_token2);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_flag_arg);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '~') ADVANCE(40);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(298);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(297);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_flag_arg);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '~') ADVANCE(40);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(298);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_flag_arg);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(300);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(299);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_flag_arg);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(300);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(291);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(293);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '-' ||
          lookahead == '~') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(296);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'e') ADVANCE(320);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'e') ADVANCE(314);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'f') ADVANCE(151);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'l') ADVANCE(315);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'n') ADVANCE(355);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'o') ADVANCE(313);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'x') ADVANCE(317);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'a') ADVANCE(319);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'd') ADVANCE(347);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'f') ADVANCE(154);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'i') ADVANCE(312);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'o') ADVANCE(318);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'p') ADVANCE(316);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 'r') ADVANCE(321);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 's') ADVANCE(156);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 't') ADVANCE(188);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '~') ADVANCE(40);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(323);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(348);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(356);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(324);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(334);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(334);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(334);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(114);
      if (lookahead == '.') ADVANCE(28);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(299);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '/') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '~') ADVANCE(40);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(297);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_mod);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_mod);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '-') ADVANCE(323);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead == '~') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(322);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(327);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '=') ADVANCE(359);
      if (lookahead == '>') ADVANCE(364);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(359);
      if (lookahead == '>') ADVANCE(364);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '<') ADVANCE(363);
      if (lookahead == '=') ADVANCE(360);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(363);
      if (lookahead == '=') ADVANCE(360);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 129},
  [2] = {.lex_state = 129},
  [3] = {.lex_state = 129},
  [4] = {.lex_state = 129},
  [5] = {.lex_state = 129},
  [6] = {.lex_state = 129},
  [7] = {.lex_state = 129},
  [8] = {.lex_state = 129},
  [9] = {.lex_state = 129},
  [10] = {.lex_state = 129},
  [11] = {.lex_state = 129},
  [12] = {.lex_state = 129},
  [13] = {.lex_state = 129},
  [14] = {.lex_state = 129},
  [15] = {.lex_state = 129},
  [16] = {.lex_state = 129},
  [17] = {.lex_state = 129},
  [18] = {.lex_state = 129},
  [19] = {.lex_state = 129},
  [20] = {.lex_state = 2, .external_lex_state = 1},
  [21] = {.lex_state = 2, .external_lex_state = 1},
  [22] = {.lex_state = 2, .external_lex_state = 1},
  [23] = {.lex_state = 2, .external_lex_state = 1},
  [24] = {.lex_state = 129},
  [25] = {.lex_state = 2, .external_lex_state = 1},
  [26] = {.lex_state = 9, .external_lex_state = 1},
  [27] = {.lex_state = 9, .external_lex_state = 1},
  [28] = {.lex_state = 2, .external_lex_state = 1},
  [29] = {.lex_state = 129},
  [30] = {.lex_state = 13},
  [31] = {.lex_state = 2, .external_lex_state = 1},
  [32] = {.lex_state = 13},
  [33] = {.lex_state = 2, .external_lex_state = 1},
  [34] = {.lex_state = 2, .external_lex_state = 1},
  [35] = {.lex_state = 2, .external_lex_state = 1},
  [36] = {.lex_state = 2, .external_lex_state = 1},
  [37] = {.lex_state = 2, .external_lex_state = 1},
  [38] = {.lex_state = 2, .external_lex_state = 1},
  [39] = {.lex_state = 2, .external_lex_state = 1},
  [40] = {.lex_state = 2, .external_lex_state = 1},
  [41] = {.lex_state = 2, .external_lex_state = 1},
  [42] = {.lex_state = 2, .external_lex_state = 1},
  [43] = {.lex_state = 2, .external_lex_state = 1},
  [44] = {.lex_state = 2, .external_lex_state = 1},
  [45] = {.lex_state = 2, .external_lex_state = 1},
  [46] = {.lex_state = 2, .external_lex_state = 1},
  [47] = {.lex_state = 13},
  [48] = {.lex_state = 2, .external_lex_state = 1},
  [49] = {.lex_state = 2, .external_lex_state = 1},
  [50] = {.lex_state = 2, .external_lex_state = 1},
  [51] = {.lex_state = 2, .external_lex_state = 1},
  [52] = {.lex_state = 2, .external_lex_state = 1},
  [53] = {.lex_state = 2, .external_lex_state = 1},
  [54] = {.lex_state = 2, .external_lex_state = 1},
  [55] = {.lex_state = 2, .external_lex_state = 1},
  [56] = {.lex_state = 2, .external_lex_state = 1},
  [57] = {.lex_state = 2, .external_lex_state = 1},
  [58] = {.lex_state = 2, .external_lex_state = 1},
  [59] = {.lex_state = 13},
  [60] = {.lex_state = 13},
  [61] = {.lex_state = 14},
  [62] = {.lex_state = 13},
  [63] = {.lex_state = 13},
  [64] = {.lex_state = 13},
  [65] = {.lex_state = 13},
  [66] = {.lex_state = 13},
  [67] = {.lex_state = 13},
  [68] = {.lex_state = 13},
  [69] = {.lex_state = 13},
  [70] = {.lex_state = 13},
  [71] = {.lex_state = 13},
  [72] = {.lex_state = 13},
  [73] = {.lex_state = 13},
  [74] = {.lex_state = 13},
  [75] = {.lex_state = 13},
  [76] = {.lex_state = 13},
  [77] = {.lex_state = 13},
  [78] = {.lex_state = 13},
  [79] = {.lex_state = 13},
  [80] = {.lex_state = 13},
  [81] = {.lex_state = 13},
  [82] = {.lex_state = 13},
  [83] = {.lex_state = 13},
  [84] = {.lex_state = 13},
  [85] = {.lex_state = 13},
  [86] = {.lex_state = 13},
  [87] = {.lex_state = 13},
  [88] = {.lex_state = 13},
  [89] = {.lex_state = 13},
  [90] = {.lex_state = 13},
  [91] = {.lex_state = 13},
  [92] = {.lex_state = 13},
  [93] = {.lex_state = 13},
  [94] = {.lex_state = 119},
  [95] = {.lex_state = 119},
  [96] = {.lex_state = 119},
  [97] = {.lex_state = 119},
  [98] = {.lex_state = 119},
  [99] = {.lex_state = 3, .external_lex_state = 1},
  [100] = {.lex_state = 5, .external_lex_state = 1},
  [101] = {.lex_state = 5, .external_lex_state = 1},
  [102] = {.lex_state = 119},
  [103] = {.lex_state = 5, .external_lex_state = 1},
  [104] = {.lex_state = 5, .external_lex_state = 1},
  [105] = {.lex_state = 5, .external_lex_state = 1},
  [106] = {.lex_state = 5, .external_lex_state = 1},
  [107] = {.lex_state = 120},
  [108] = {.lex_state = 5, .external_lex_state = 1},
  [109] = {.lex_state = 119},
  [110] = {.lex_state = 119},
  [111] = {.lex_state = 7, .external_lex_state = 1},
  [112] = {.lex_state = 7, .external_lex_state = 1},
  [113] = {.lex_state = 119},
  [114] = {.lex_state = 119},
  [115] = {.lex_state = 7, .external_lex_state = 1},
  [116] = {.lex_state = 119},
  [117] = {.lex_state = 119},
  [118] = {.lex_state = 119},
  [119] = {.lex_state = 119},
  [120] = {.lex_state = 119},
  [121] = {.lex_state = 7, .external_lex_state = 1},
  [122] = {.lex_state = 7, .external_lex_state = 1},
  [123] = {.lex_state = 7, .external_lex_state = 1},
  [124] = {.lex_state = 7, .external_lex_state = 1},
  [125] = {.lex_state = 119},
  [126] = {.lex_state = 119},
  [127] = {.lex_state = 119},
  [128] = {.lex_state = 119},
  [129] = {.lex_state = 119},
  [130] = {.lex_state = 7, .external_lex_state = 1},
  [131] = {.lex_state = 119},
  [132] = {.lex_state = 119},
  [133] = {.lex_state = 7, .external_lex_state = 1},
  [134] = {.lex_state = 119},
  [135] = {.lex_state = 119},
  [136] = {.lex_state = 7, .external_lex_state = 1},
  [137] = {.lex_state = 7, .external_lex_state = 1},
  [138] = {.lex_state = 7, .external_lex_state = 1},
  [139] = {.lex_state = 119},
  [140] = {.lex_state = 119},
  [141] = {.lex_state = 119},
  [142] = {.lex_state = 119},
  [143] = {.lex_state = 119},
  [144] = {.lex_state = 119},
  [145] = {.lex_state = 7, .external_lex_state = 1},
  [146] = {.lex_state = 119},
  [147] = {.lex_state = 7, .external_lex_state = 1},
  [148] = {.lex_state = 119},
  [149] = {.lex_state = 7, .external_lex_state = 1},
  [150] = {.lex_state = 7, .external_lex_state = 1},
  [151] = {.lex_state = 122},
  [152] = {.lex_state = 122},
  [153] = {.lex_state = 122},
  [154] = {.lex_state = 122},
  [155] = {.lex_state = 122},
  [156] = {.lex_state = 122},
  [157] = {.lex_state = 18},
  [158] = {.lex_state = 18},
  [159] = {.lex_state = 18},
  [160] = {.lex_state = 18},
  [161] = {.lex_state = 18},
  [162] = {.lex_state = 18},
  [163] = {.lex_state = 18},
  [164] = {.lex_state = 122},
  [165] = {.lex_state = 18},
  [166] = {.lex_state = 18},
  [167] = {.lex_state = 18},
  [168] = {.lex_state = 18},
  [169] = {.lex_state = 122},
  [170] = {.lex_state = 18},
  [171] = {.lex_state = 122},
  [172] = {.lex_state = 123},
  [173] = {.lex_state = 122},
  [174] = {.lex_state = 122},
  [175] = {.lex_state = 18},
  [176] = {.lex_state = 122},
  [177] = {.lex_state = 122},
  [178] = {.lex_state = 122},
  [179] = {.lex_state = 122},
  [180] = {.lex_state = 122},
  [181] = {.lex_state = 122},
  [182] = {.lex_state = 122},
  [183] = {.lex_state = 122},
  [184] = {.lex_state = 122},
  [185] = {.lex_state = 122},
  [186] = {.lex_state = 122},
  [187] = {.lex_state = 122},
  [188] = {.lex_state = 122},
  [189] = {.lex_state = 122},
  [190] = {.lex_state = 122},
  [191] = {.lex_state = 122},
  [192] = {.lex_state = 122},
  [193] = {.lex_state = 122},
  [194] = {.lex_state = 122},
  [195] = {.lex_state = 122},
  [196] = {.lex_state = 122},
  [197] = {.lex_state = 122},
  [198] = {.lex_state = 122},
  [199] = {.lex_state = 122},
  [200] = {.lex_state = 122},
  [201] = {.lex_state = 18},
  [202] = {.lex_state = 18},
  [203] = {.lex_state = 18},
  [204] = {.lex_state = 18},
  [205] = {.lex_state = 18},
  [206] = {.lex_state = 18},
  [207] = {.lex_state = 18},
  [208] = {.lex_state = 18},
  [209] = {.lex_state = 18},
  [210] = {.lex_state = 18},
  [211] = {.lex_state = 18},
  [212] = {.lex_state = 18},
  [213] = {.lex_state = 18},
  [214] = {.lex_state = 18},
  [215] = {.lex_state = 18},
  [216] = {.lex_state = 18},
  [217] = {.lex_state = 18},
  [218] = {.lex_state = 18},
  [219] = {.lex_state = 18},
  [220] = {.lex_state = 18},
  [221] = {.lex_state = 18},
  [222] = {.lex_state = 18},
  [223] = {.lex_state = 18},
  [224] = {.lex_state = 18},
  [225] = {.lex_state = 18},
  [226] = {.lex_state = 18},
  [227] = {.lex_state = 18},
  [228] = {.lex_state = 18},
  [229] = {.lex_state = 18},
  [230] = {.lex_state = 18},
  [231] = {.lex_state = 18},
  [232] = {.lex_state = 18},
  [233] = {.lex_state = 18},
  [234] = {.lex_state = 18},
  [235] = {.lex_state = 18},
  [236] = {.lex_state = 18},
  [237] = {.lex_state = 18},
  [238] = {.lex_state = 18},
  [239] = {.lex_state = 18},
  [240] = {.lex_state = 18},
  [241] = {.lex_state = 18},
  [242] = {.lex_state = 18},
  [243] = {.lex_state = 18},
  [244] = {.lex_state = 18},
  [245] = {.lex_state = 127},
  [246] = {.lex_state = 127},
  [247] = {.lex_state = 127},
  [248] = {.lex_state = 127},
  [249] = {.lex_state = 127},
  [250] = {.lex_state = 127},
  [251] = {.lex_state = 127},
  [252] = {.lex_state = 127},
  [253] = {.lex_state = 127},
  [254] = {.lex_state = 127},
  [255] = {.lex_state = 129},
  [256] = {.lex_state = 16},
  [257] = {.lex_state = 16},
  [258] = {.lex_state = 129},
  [259] = {.lex_state = 127},
  [260] = {.lex_state = 127},
  [261] = {.lex_state = 127},
  [262] = {.lex_state = 127},
  [263] = {.lex_state = 127},
  [264] = {.lex_state = 127},
  [265] = {.lex_state = 127},
  [266] = {.lex_state = 127},
  [267] = {.lex_state = 127},
  [268] = {.lex_state = 127},
  [269] = {.lex_state = 127},
  [270] = {.lex_state = 127},
  [271] = {.lex_state = 127},
  [272] = {.lex_state = 127},
  [273] = {.lex_state = 127},
  [274] = {.lex_state = 127},
  [275] = {.lex_state = 127},
  [276] = {.lex_state = 127},
  [277] = {.lex_state = 127},
  [278] = {.lex_state = 127},
  [279] = {.lex_state = 127},
  [280] = {.lex_state = 127},
  [281] = {.lex_state = 127},
  [282] = {.lex_state = 127},
  [283] = {.lex_state = 129},
  [284] = {.lex_state = 129},
  [285] = {.lex_state = 129},
  [286] = {.lex_state = 7, .external_lex_state = 1},
  [287] = {.lex_state = 125},
  [288] = {.lex_state = 125},
  [289] = {.lex_state = 21},
  [290] = {.lex_state = 18},
  [291] = {.lex_state = 21},
  [292] = {.lex_state = 21},
  [293] = {.lex_state = 21},
  [294] = {.lex_state = 125},
  [295] = {.lex_state = 125},
  [296] = {.lex_state = 20},
  [297] = {.lex_state = 20},
  [298] = {.lex_state = 20},
  [299] = {.lex_state = 125},
  [300] = {.lex_state = 126},
  [301] = {.lex_state = 125},
  [302] = {.lex_state = 20},
  [303] = {.lex_state = 126},
  [304] = {.lex_state = 20},
  [305] = {.lex_state = 126},
  [306] = {.lex_state = 126},
  [307] = {.lex_state = 20},
  [308] = {.lex_state = 125},
  [309] = {.lex_state = 20},
  [310] = {.lex_state = 125},
  [311] = {.lex_state = 125},
  [312] = {.lex_state = 20},
  [313] = {.lex_state = 125},
  [314] = {.lex_state = 20},
  [315] = {.lex_state = 20},
  [316] = {.lex_state = 20},
  [317] = {.lex_state = 20},
  [318] = {.lex_state = 20},
  [319] = {.lex_state = 20},
  [320] = {.lex_state = 20},
  [321] = {.lex_state = 20},
  [322] = {.lex_state = 20},
  [323] = {.lex_state = 20},
  [324] = {.lex_state = 20},
  [325] = {.lex_state = 20},
  [326] = {.lex_state = 20},
  [327] = {.lex_state = 20},
  [328] = {.lex_state = 127},
  [329] = {.lex_state = 127},
  [330] = {.lex_state = 127},
  [331] = {.lex_state = 127},
  [332] = {.lex_state = 127},
  [333] = {.lex_state = 127},
  [334] = {.lex_state = 127},
  [335] = {.lex_state = 127},
  [336] = {.lex_state = 127},
  [337] = {.lex_state = 127},
  [338] = {.lex_state = 127},
  [339] = {.lex_state = 20},
  [340] = {.lex_state = 125},
  [341] = {.lex_state = 20},
  [342] = {.lex_state = 20},
  [343] = {.lex_state = 20},
  [344] = {.lex_state = 127},
  [345] = {.lex_state = 20},
  [346] = {.lex_state = 20},
  [347] = {.lex_state = 127},
  [348] = {.lex_state = 20},
  [349] = {.lex_state = 127},
  [350] = {.lex_state = 127},
  [351] = {.lex_state = 20},
  [352] = {.lex_state = 127},
  [353] = {.lex_state = 20},
  [354] = {.lex_state = 20},
  [355] = {.lex_state = 20},
  [356] = {.lex_state = 127},
  [357] = {.lex_state = 127},
  [358] = {.lex_state = 127},
  [359] = {.lex_state = 20},
  [360] = {.lex_state = 127},
  [361] = {.lex_state = 127},
  [362] = {.lex_state = 127},
  [363] = {.lex_state = 127},
  [364] = {.lex_state = 127},
  [365] = {.lex_state = 127},
  [366] = {.lex_state = 286},
  [367] = {.lex_state = 281},
  [368] = {.lex_state = 276},
  [369] = {.lex_state = 127},
  [370] = {.lex_state = 21},
  [371] = {.lex_state = 21},
  [372] = {.lex_state = 127},
  [373] = {.lex_state = 127},
  [374] = {.lex_state = 127},
  [375] = {.lex_state = 127},
  [376] = {.lex_state = 127},
  [377] = {.lex_state = 127},
  [378] = {.lex_state = 127},
  [379] = {.lex_state = 127},
  [380] = {.lex_state = 127},
  [381] = {.lex_state = 127},
  [382] = {.lex_state = 127},
  [383] = {.lex_state = 21},
  [384] = {.lex_state = 127},
  [385] = {.lex_state = 127},
  [386] = {.lex_state = 127},
  [387] = {.lex_state = 127},
  [388] = {.lex_state = 127},
  [389] = {.lex_state = 127},
  [390] = {.lex_state = 127},
  [391] = {.lex_state = 127},
  [392] = {.lex_state = 127},
  [393] = {.lex_state = 127},
  [394] = {.lex_state = 127},
  [395] = {.lex_state = 127},
  [396] = {.lex_state = 127},
  [397] = {.lex_state = 127},
  [398] = {.lex_state = 127},
  [399] = {.lex_state = 127},
  [400] = {.lex_state = 20},
  [401] = {.lex_state = 127},
  [402] = {.lex_state = 127},
  [403] = {.lex_state = 127},
  [404] = {.lex_state = 127},
  [405] = {.lex_state = 127},
  [406] = {.lex_state = 127},
  [407] = {.lex_state = 127},
  [408] = {.lex_state = 127},
  [409] = {.lex_state = 127},
  [410] = {.lex_state = 127},
  [411] = {.lex_state = 127},
  [412] = {.lex_state = 127},
  [413] = {.lex_state = 127},
  [414] = {.lex_state = 127},
  [415] = {.lex_state = 127},
  [416] = {.lex_state = 21},
  [417] = {.lex_state = 127},
  [418] = {.lex_state = 127},
  [419] = {.lex_state = 127},
  [420] = {.lex_state = 127},
  [421] = {.lex_state = 127},
  [422] = {.lex_state = 286},
  [423] = {.lex_state = 276},
  [424] = {.lex_state = 281},
  [425] = {.lex_state = 286},
  [426] = {.lex_state = 281},
  [427] = {.lex_state = 276},
  [428] = {.lex_state = 281},
  [429] = {.lex_state = 286},
  [430] = {.lex_state = 276},
  [431] = {.lex_state = 276},
  [432] = {.lex_state = 281},
  [433] = {.lex_state = 286},
  [434] = {.lex_state = 127},
  [435] = {.lex_state = 276},
  [436] = {.lex_state = 281},
  [437] = {.lex_state = 286},
  [438] = {.lex_state = 127},
  [439] = {.lex_state = 276},
  [440] = {.lex_state = 281},
  [441] = {.lex_state = 286},
  [442] = {.lex_state = 20},
  [443] = {.lex_state = 276},
  [444] = {.lex_state = 281},
  [445] = {.lex_state = 286},
  [446] = {.lex_state = 127},
  [447] = {.lex_state = 276},
  [448] = {.lex_state = 281},
  [449] = {.lex_state = 286},
  [450] = {.lex_state = 127},
  [451] = {.lex_state = 276},
  [452] = {.lex_state = 281},
  [453] = {.lex_state = 286},
};

enum {
  ts_external_token__cmd_newline = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__cmd_newline] = sym__cmd_newline,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__cmd_newline] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_env] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_range] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_duration] = ACTIONS(1),
    [anon_sym_date] = ACTIONS(1),
    [anon_sym_filesize] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_table] = ACTIONS(1),
    [anon_sym_error] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [sym_word] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [aux_sym_file_path_token1] = ACTIONS(1),
    [sym_flag_arg] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [sym__cmd_newline] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(361),
    [sym__statements] = STATE(406),
    [sym__statement] = STATE(299),
    [sym_record_entry] = STATE(294),
    [sym_env_export] = STATE(299),
    [sym_if_statement] = STATE(299),
    [sym_function_definition] = STATE(299),
    [sym_alias] = STATE(299),
    [sym_variable_declaration] = STATE(299),
    [sym_command] = STATE(198),
    [sym__expression] = STATE(198),
    [sym_string] = STATE(164),
    [sym_value_path] = STATE(164),
    [sym_file_path] = STATE(198),
    [sym_range] = STATE(198),
    [sym_table] = STATE(198),
    [sym_array] = STATE(198),
    [sym_record_or_block] = STATE(198),
    [sym_cmd_invocation] = STATE(198),
    [sym_binary_expression] = STATE(198),
    [aux_sym__statements_repeat1] = STATE(24),
    [aux_sym__statement_repeat1] = STATE(287),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_export] = ACTIONS(7),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_def] = ACTIONS(11),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_LBRACK] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [sym_number_literal] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_DOLLAR] = ACTIONS(25),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [aux_sym_file_path_token1] = ACTIONS(33),
    [aux_sym_file_path_token2] = ACTIONS(33),
    [sym_flag_arg] = ACTIONS(23),
    [sym_identifier] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(37),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(39), 1,
      anon_sym_PIPE,
    ACTIONS(41), 1,
      anon_sym_RBRACE,
    STATE(11), 1,
      sym_block_args,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(421), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [98] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(39), 1,
      anon_sym_PIPE,
    ACTIONS(43), 1,
      anon_sym_RBRACE,
    STATE(10), 1,
      sym_block_args,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(402), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [196] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(39), 1,
      anon_sym_PIPE,
    ACTIONS(45), 1,
      anon_sym_RBRACE,
    STATE(13), 1,
      sym_block_args,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(391), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [294] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(39), 1,
      anon_sym_PIPE,
    ACTIONS(47), 1,
      anon_sym_RBRACE,
    STATE(12), 1,
      sym_block_args,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(378), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [392] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(39), 1,
      anon_sym_PIPE,
    ACTIONS(49), 1,
      anon_sym_RBRACE,
    STATE(9), 1,
      sym_block_args,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(413), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [490] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(39), 1,
      anon_sym_PIPE,
    ACTIONS(51), 1,
      anon_sym_RBRACE,
    STATE(8), 1,
      sym_block_args,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(390), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [588] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_RBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(365), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [680] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_RBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(420), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [772] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_RBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(438), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [864] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(59), 1,
      anon_sym_RBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(405), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [956] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_RBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(382), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1048] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(63), 1,
      anon_sym_RBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(398), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1140] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(373), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1229] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(403), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1318] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(408), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1407] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(372), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1496] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(24), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    STATE(386), 1,
      sym__statements,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(299), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1585] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_export,
    ACTIONS(68), 1,
      anon_sym_if,
    ACTIONS(71), 1,
      anon_sym_def,
    ACTIONS(74), 1,
      anon_sym_alias,
    ACTIONS(77), 1,
      anon_sym_LBRACK,
    ACTIONS(80), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(86), 1,
      sym_number_literal,
    ACTIONS(92), 1,
      anon_sym_DOLLAR,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(98), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(107), 1,
      sym_identifier,
    ACTIONS(110), 1,
      anon_sym_LBRACE,
    STATE(19), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    ACTIONS(89), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(104), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(340), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_DOT,
    STATE(23), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(115), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(113), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [1721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_DOT,
    STATE(20), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(121), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(119), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [1771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_DOT,
    STATE(25), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(125), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(123), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [1821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_DOT,
    STATE(23), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(129), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(127), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [1871] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(19), 1,
      aux_sym__statements_repeat1,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(301), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [1957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_DOT,
    STATE(23), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(136), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(134), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(140), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(138), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(146), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(144), 15,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
    ACTIONS(138), 19,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(127), 35,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2148] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_export,
    ACTIONS(9), 1,
      anon_sym_if,
    ACTIONS(11), 1,
      anon_sym_def,
    ACTIONS(13), 1,
      anon_sym_alias,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_let,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    STATE(287), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    ACTIONS(23), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(164), 2,
      sym_string,
      sym_value_path,
    STATE(310), 6,
      sym__statement,
      sym_env_export,
      sym_if_statement,
      sym_function_definition,
      sym_alias,
      sym_variable_declaration,
    STATE(198), 9,
      sym_command,
      sym__expression,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [2231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_DOT,
    STATE(59), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(136), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(134), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [2279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(152), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(150), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_DOT,
    STATE(60), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(121), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(119), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [2371] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(168), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(162), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(164), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(166), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(154), 17,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [2427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(172), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(170), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2471] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(168), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(162), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(166), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(154), 21,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [2525] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(168), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(162), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 25,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [2577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(162), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 27,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(174), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(180), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(178), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(174), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2759] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(182), 1,
      anon_sym_AMP_AMP,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(160), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(168), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(162), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(164), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(166), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(154), 16,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
  [2817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(154), 33,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(162), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(186), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(184), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(190), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(188), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [2999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(194), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(192), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_DOT,
    STATE(30), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(125), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(123), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(198), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(196), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(200), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(154), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(146), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(144), 15,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
    ACTIONS(138), 19,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(204), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(208), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(212), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(216), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(220), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(220), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(226), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(224), 34,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [3577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(228), 1,
      anon_sym_DOT,
    STATE(59), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(129), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(127), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_DOT,
    STATE(59), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(115), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(113), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_DOT_DOT,
    ACTIONS(140), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(138), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(127), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 1,
      anon_sym_SEMI,
    ACTIONS(140), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(138), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(235), 1,
      anon_sym_SEMI,
    ACTIONS(140), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(138), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(212), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(198), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(196), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 1,
      anon_sym_SEMI,
    ACTIONS(140), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(138), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [3982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(239), 1,
      anon_sym_SEMI,
    ACTIONS(140), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(138), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 1,
      anon_sym_SEMI,
    ACTIONS(140), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(138), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(216), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(180), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(178), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(226), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(224), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(186), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(184), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(220), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(220), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(190), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(188), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(194), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(192), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(200), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(204), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(152), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(150), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(174), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4576] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(243), 1,
      anon_sym_COMMA,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(253), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(255), 1,
      anon_sym_AMP_AMP,
    ACTIONS(259), 1,
      anon_sym_in,
    ACTIONS(249), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(261), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(263), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(257), 3,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(251), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(247), 14,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [4638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(249), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(251), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(154), 18,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4686] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(249), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(251), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(154), 18,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4736] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(249), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(261), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(263), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(251), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(154), 16,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_in,
  [4790] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(259), 1,
      anon_sym_in,
    ACTIONS(156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(249), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(261), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(263), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(257), 3,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(251), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 15,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [4848] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(255), 1,
      anon_sym_AMP_AMP,
    ACTIONS(259), 1,
      anon_sym_in,
    ACTIONS(249), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(261), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(263), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(257), 3,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(251), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 15,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [4908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(172), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(170), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(156), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(154), 24,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [4994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_EQ,
    ACTIONS(251), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(154), 20,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [5040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(154), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [5082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(208), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [5124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(174), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
  [5166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(267), 1,
      anon_sym_DOT,
    STATE(94), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(129), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(127), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [5211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_DOT,
    STATE(98), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(125), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(123), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [5256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_DOT,
    STATE(97), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(121), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(119), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [5301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_DOT,
    STATE(94), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(115), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(113), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [5346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_DOT,
    STATE(94), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(136), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(134), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [5391] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(276), 1,
      anon_sym_COLON,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_QMARK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    STATE(145), 1,
      aux_sym_command_repeat1,
    STATE(200), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(272), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(274), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [5468] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(306), 1,
      anon_sym_QMARK,
    STATE(126), 1,
      sym__terminator,
    STATE(133), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(302), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(304), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [5542] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_QMARK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    STATE(145), 1,
      aux_sym_command_repeat1,
    STATE(200), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(272), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(274), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [5616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 3,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_DOT,
    ACTIONS(127), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [5656] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_QMARK,
    STATE(78), 1,
      sym__terminator,
    STATE(138), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(308), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(310), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [5730] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(318), 1,
      anon_sym_QMARK,
    ACTIONS(320), 1,
      anon_sym_LBRACE,
    STATE(112), 1,
      aux_sym_command_repeat1,
    STATE(263), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(314), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(316), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [5804] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(318), 1,
      anon_sym_QMARK,
    STATE(112), 1,
      aux_sym_command_repeat1,
    STATE(263), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(314), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(316), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [5878] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(318), 1,
      anon_sym_QMARK,
    ACTIONS(320), 1,
      anon_sym_LBRACE,
    ACTIONS(329), 1,
      anon_sym_LBRACK,
    ACTIONS(332), 1,
      anon_sym_LPAREN,
    ACTIONS(335), 1,
      sym_number_literal,
    ACTIONS(341), 1,
      anon_sym_DOLLAR,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(347), 1,
      anon_sym_SQUOTE,
    ACTIONS(350), 1,
      anon_sym_BQUOTE,
    ACTIONS(356), 1,
      sym_identifier,
    STATE(112), 1,
      aux_sym_command_repeat1,
    STATE(263), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(323), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(326), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(338), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(353), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [5952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(359), 1,
      anon_sym_DOT_DOT,
    ACTIONS(140), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(138), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [5994] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(365), 1,
      anon_sym_QMARK,
    STATE(49), 1,
      sym__terminator,
    STATE(123), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(361), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(363), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(216), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(371), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(373), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(154), 16,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [6156] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      aux_sym_command_repeat1,
    STATE(261), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(377), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(379), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6227] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LF,
    ACTIONS(385), 1,
      sym__cmd_newline,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(271), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(381), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6300] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(391), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(393), 1,
      anon_sym_AMP_AMP,
    ACTIONS(369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(387), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(371), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(373), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(395), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(389), 10,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
  [6355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(226), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(224), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6394] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(399), 1,
      anon_sym_LF,
    ACTIONS(401), 1,
      sym__cmd_newline,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(193), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(397), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(174), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(174), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(172), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(170), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(220), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(220), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6662] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(405), 1,
      anon_sym_LF,
    ACTIONS(407), 1,
      sym__cmd_newline,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(276), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(403), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6735] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(411), 1,
      anon_sym_LF,
    ACTIONS(413), 1,
      sym__cmd_newline,
    STATE(56), 1,
      sym__terminator,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(409), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6808] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(417), 1,
      anon_sym_LF,
    ACTIONS(419), 1,
      sym__cmd_newline,
    STATE(40), 1,
      sym__terminator,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(415), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6881] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    STATE(34), 1,
      sym__terminator,
    STATE(122), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(421), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(423), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [6952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(212), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [6991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(200), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(204), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(152), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(150), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(208), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7147] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(427), 1,
      anon_sym_LF,
    ACTIONS(429), 1,
      sym__cmd_newline,
    STATE(119), 1,
      sym__terminator,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(425), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [7220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(154), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7259] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(371), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 24,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7302] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(433), 1,
      anon_sym_LF,
    ACTIONS(435), 1,
      sym__cmd_newline,
    STATE(116), 1,
      sym__terminator,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(431), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [7375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(154), 28,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7416] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(393), 1,
      anon_sym_AMP_AMP,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(371), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(373), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(395), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(154), 11,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
  [7469] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    STATE(118), 1,
      sym__terminator,
    STATE(130), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(437), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(439), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [7540] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(443), 1,
      anon_sym_LF,
    ACTIONS(445), 1,
      sym__cmd_newline,
    STATE(75), 1,
      sym__terminator,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(441), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [7613] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(449), 1,
      anon_sym_LF,
    ACTIONS(451), 1,
      sym__cmd_newline,
    STATE(93), 1,
      sym__terminator,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(447), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [7686] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(371), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(373), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(395), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(154), 12,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [7737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(198), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(196), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7776] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(371), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 20,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [7823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(371), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 22,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(180), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(178), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(186), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(184), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [7946] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(455), 1,
      anon_sym_LF,
    ACTIONS(457), 1,
      sym__cmd_newline,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(178), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(453), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(190), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(188), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8058] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    STATE(115), 1,
      aux_sym_command_repeat1,
    STATE(176), 1,
      sym__terminator,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(459), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(461), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(194), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(192), 29,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8168] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      sym_number_literal,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(298), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    STATE(88), 1,
      sym__terminator,
    STATE(137), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(286), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(463), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(465), 2,
      sym__cmd_newline,
      anon_sym_LF,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8239] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_LBRACK,
    ACTIONS(474), 1,
      anon_sym_LPAREN,
    ACTIONS(477), 1,
      sym_number_literal,
    ACTIONS(483), 1,
      anon_sym_DOLLAR,
    ACTIONS(486), 1,
      anon_sym_DQUOTE,
    ACTIONS(489), 1,
      anon_sym_SQUOTE,
    ACTIONS(492), 1,
      anon_sym_BQUOTE,
    ACTIONS(498), 1,
      sym_identifier,
    ACTIONS(501), 1,
      anon_sym_LBRACE,
    STATE(150), 1,
      aux_sym_command_repeat1,
    STATE(286), 1,
      sym__cmd_expr,
    ACTIONS(467), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(469), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(480), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(495), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(282), 2,
      sym_command,
      sym__expression,
    STATE(51), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 1,
      anon_sym_DOT,
    STATE(153), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(136), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(134), 24,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 1,
      anon_sym_DOT,
    STATE(151), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(125), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(123), 24,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(506), 1,
      anon_sym_DOT,
    STATE(153), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(129), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(127), 24,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 1,
      anon_sym_DOT,
    STATE(153), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(115), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(113), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 1,
      anon_sym_DOT,
    STATE(154), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(121), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(119), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 3,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_DOT,
    ACTIONS(127), 24,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8540] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(511), 1,
      anon_sym_RBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    STATE(64), 1,
      sym_array,
    STATE(159), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 10,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8600] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_RBRACK,
    STATE(163), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8658] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(535), 1,
      anon_sym_RBRACK,
    STATE(163), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8716] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(537), 1,
      anon_sym_RBRACK,
    STATE(167), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8774] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(539), 1,
      anon_sym_RBRACK,
    STATE(69), 1,
      sym_array,
    STATE(162), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 10,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8834] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(541), 1,
      anon_sym_RBRACK,
    STATE(163), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8892] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_LBRACK,
    ACTIONS(546), 1,
      anon_sym_RBRACK,
    ACTIONS(548), 1,
      anon_sym_LPAREN,
    ACTIONS(551), 1,
      sym_number_literal,
    ACTIONS(557), 1,
      anon_sym_DOLLAR,
    ACTIONS(560), 1,
      anon_sym_DQUOTE,
    ACTIONS(563), 1,
      anon_sym_SQUOTE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(572), 1,
      sym_identifier,
    ACTIONS(575), 1,
      anon_sym_LBRACE,
    STATE(163), 1,
      aux_sym_array_repeat1,
    ACTIONS(554), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(569), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [8950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(276), 1,
      anon_sym_COLON,
    ACTIONS(140), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(138), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [8986] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(537), 1,
      anon_sym_RBRACK,
    STATE(63), 1,
      sym_array,
    STATE(167), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 10,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [9046] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(578), 1,
      anon_sym_RBRACK,
    STATE(68), 1,
      sym_array,
    STATE(158), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 10,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [9106] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_RBRACK,
    STATE(163), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [9164] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(582), 1,
      anon_sym_RBRACK,
    STATE(67), 1,
      sym_array,
    STATE(170), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 10,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [9224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(152), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(150), 24,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9258] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(584), 1,
      anon_sym_RBRACK,
    STATE(163), 1,
      aux_sym_array_repeat1,
    ACTIONS(517), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(82), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [9316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(186), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(184), 24,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_DOT_DOT,
    ACTIONS(140), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(138), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 16,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(226), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(224), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9458] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      sym_number_literal,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(612), 1,
      sym_identifier,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    STATE(358), 1,
      sym__cmd_expr,
    ACTIONS(600), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(281), 2,
      sym_command,
      sym__expression,
    STATE(269), 9,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [9515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(172), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(170), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(174), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(176), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(174), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(204), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(208), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(154), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 18,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(154), 22,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [9785] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(616), 1,
      anon_sym_AMP_AMP,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(618), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(620), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(154), 5,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
  [9832] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(618), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(620), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(154), 6,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [9877] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(620), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(154), 10,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [9920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(154), 14,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [9961] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(616), 1,
      anon_sym_AMP_AMP,
    ACTIONS(628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(624), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(618), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(620), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(626), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [10010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(212), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10043] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(616), 1,
      anon_sym_AMP_AMP,
    ACTIONS(628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(630), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(618), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(620), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(632), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [10092] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(616), 1,
      anon_sym_AMP_AMP,
    ACTIONS(628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(634), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(618), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(620), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(636), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [10141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(220), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(222), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(220), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(190), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(188), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(180), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(178), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(218), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(216), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(194), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(192), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10339] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_EQ,
    ACTIONS(616), 1,
      anon_sym_AMP_AMP,
    ACTIONS(628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(638), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(592), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(618), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
    ACTIONS(620), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(640), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [10388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(198), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(196), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(202), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(200), 23,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [10454] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(644), 2,
      sym_word,
      sym_flag_arg,
    STATE(42), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10506] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(648), 2,
      sym_word,
      sym_flag_arg,
    STATE(35), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10558] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(650), 2,
      sym_word,
      sym_flag_arg,
    STATE(185), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10610] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(654), 2,
      sym_word,
      sym_flag_arg,
    STATE(191), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10662] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(658), 2,
      sym_word,
      sym_flag_arg,
    STATE(277), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10714] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(668), 2,
      sym_word,
      sym_flag_arg,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    STATE(132), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10766] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(684), 2,
      sym_word,
      sym_flag_arg,
    STATE(264), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10818] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(686), 2,
      sym_word,
      sym_flag_arg,
    STATE(267), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10870] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(688), 2,
      sym_word,
      sym_flag_arg,
    STATE(268), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10922] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(690), 2,
      sym_word,
      sym_flag_arg,
    STATE(260), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [10974] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(692), 2,
      sym_word,
      sym_flag_arg,
    STATE(259), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11026] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(694), 2,
      sym_word,
      sym_flag_arg,
    STATE(270), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11078] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(656), 1,
      sym_number_literal,
    ACTIONS(660), 1,
      sym_identifier,
    ACTIONS(610), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(696), 2,
      sym_word,
      sym_flag_arg,
    STATE(273), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11130] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(698), 2,
      sym_word,
      sym_flag_arg,
    STATE(134), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11182] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(700), 2,
      sym_word,
      sym_flag_arg,
    STATE(183), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11234] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(702), 2,
      sym_word,
      sym_flag_arg,
    STATE(135), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11286] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(704), 2,
      sym_word,
      sym_flag_arg,
    STATE(139), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11338] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(706), 2,
      sym_word,
      sym_flag_arg,
    STATE(110), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11390] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(708), 2,
      sym_word,
      sym_flag_arg,
    STATE(141), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11442] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(710), 2,
      sym_word,
      sym_flag_arg,
    STATE(142), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11494] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(712), 2,
      sym_word,
      sym_flag_arg,
    STATE(190), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11546] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(714), 2,
      sym_word,
      sym_flag_arg,
    STATE(37), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11598] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(716), 2,
      sym_word,
      sym_flag_arg,
    STATE(36), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11650] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(718), 2,
      sym_word,
      sym_flag_arg,
    STATE(184), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11702] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(720), 2,
      sym_word,
      sym_flag_arg,
    STATE(91), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11754] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(722), 2,
      sym_word,
      sym_flag_arg,
    STATE(90), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11806] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(724), 2,
      sym_word,
      sym_flag_arg,
    STATE(89), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11858] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(726), 2,
      sym_word,
      sym_flag_arg,
    STATE(87), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11910] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(728), 2,
      sym_word,
      sym_flag_arg,
    STATE(86), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [11962] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(730), 2,
      sym_word,
      sym_flag_arg,
    STATE(85), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12014] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(732), 2,
      sym_word,
      sym_flag_arg,
    STATE(84), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12066] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(513), 1,
      anon_sym_LPAREN,
    ACTIONS(515), 1,
      sym_number_literal,
    ACTIONS(519), 1,
      anon_sym_DOLLAR,
    ACTIONS(521), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_SQUOTE,
    ACTIONS(525), 1,
      anon_sym_BQUOTE,
    ACTIONS(529), 1,
      sym_identifier,
    ACTIONS(531), 1,
      anon_sym_LBRACE,
    ACTIONS(527), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(734), 2,
      sym_word,
      sym_flag_arg,
    STATE(83), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12118] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(736), 2,
      sym_word,
      sym_flag_arg,
    STATE(33), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12170] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(738), 2,
      sym_word,
      sym_flag_arg,
    STATE(41), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12222] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(740), 2,
      sym_word,
      sym_flag_arg,
    STATE(113), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12274] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      sym_number_literal,
    ACTIONS(670), 1,
      anon_sym_DOLLAR,
    ACTIONS(672), 1,
      anon_sym_DQUOTE,
    ACTIONS(674), 1,
      anon_sym_SQUOTE,
    ACTIONS(676), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_identifier,
    ACTIONS(682), 1,
      anon_sym_LBRACE,
    ACTIONS(678), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(742), 2,
      sym_word,
      sym_flag_arg,
    STATE(131), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12326] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(744), 2,
      sym_word,
      sym_flag_arg,
    STATE(43), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12378] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      anon_sym_DQUOTE,
    ACTIONS(292), 1,
      anon_sym_SQUOTE,
    ACTIONS(294), 1,
      anon_sym_BQUOTE,
    ACTIONS(300), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      sym_number_literal,
    ACTIONS(646), 1,
      sym_identifier,
    ACTIONS(296), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(746), 2,
      sym_word,
      sym_flag_arg,
    STATE(50), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12430] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(748), 2,
      sym_word,
      sym_flag_arg,
    STATE(188), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12482] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(750), 2,
      sym_word,
      sym_flag_arg,
    STATE(173), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12534] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(752), 2,
      sym_word,
      sym_flag_arg,
    STATE(187), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12586] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(754), 2,
      sym_word,
      sym_flag_arg,
    STATE(186), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12638] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(756), 2,
      sym_word,
      sym_flag_arg,
    STATE(181), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12690] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      sym_number_literal,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_BQUOTE,
    ACTIONS(37), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(33), 2,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
    ACTIONS(758), 2,
      sym_word,
      sym_flag_arg,
    STATE(182), 11,
      sym_command,
      sym__expression,
      sym_string,
      sym_value_path,
      sym_file_path,
      sym_range,
      sym_table,
      sym_array,
      sym_record_or_block,
      sym_cmd_invocation,
      sym_binary_expression,
  [12742] = 5,
    ACTIONS(760), 1,
      anon_sym_DOT,
    ACTIONS(763), 1,
      sym_comment,
    STATE(245), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(127), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(129), 18,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12777] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_DOT,
    STATE(245), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(134), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(136), 18,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12812] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_DOT,
    STATE(246), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(123), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(125), 18,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12847] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_DOT,
    STATE(251), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(119), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(121), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12881] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(212), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(214), 19,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12911] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(196), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(198), 19,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12941] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_DOT,
    STATE(245), 1,
      aux_sym_value_path_repeat1,
    ACTIONS(113), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(115), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [12975] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(150), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(152), 19,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13005] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(127), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(129), 19,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13035] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(184), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(186), 19,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 1,
      ts_builtin_sym_end,
    ACTIONS(771), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(769), 18,
      anon_sym_export,
      anon_sym_if,
      anon_sym_def,
      anon_sym_alias,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_let,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [13096] = 5,
    ACTIONS(146), 1,
      anon_sym_LBRACE,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(773), 1,
      anon_sym_DOT_DOT,
    ACTIONS(138), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(140), 16,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13129] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(773), 1,
      anon_sym_DOT_DOT,
    ACTIONS(138), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(140), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(775), 1,
      ts_builtin_sym_end,
    ACTIONS(777), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(769), 18,
      anon_sym_export,
      anon_sym_if,
      anon_sym_def,
      anon_sym_alias,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_let,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [13191] = 8,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(781), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(789), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(783), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 7,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [13229] = 9,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(781), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(789), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(156), 3,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(783), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(791), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [13269] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(170), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(172), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13297] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(220), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(222), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13325] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(200), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(202), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13353] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(154), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(783), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 13,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13385] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(224), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(226), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13413] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(216), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(218), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13441] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(154), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(156), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13471] = 10,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(156), 2,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
    ACTIONS(781), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(789), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(783), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(791), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [13513] = 4,
    ACTIONS(146), 1,
      anon_sym_LBRACE,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(138), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(140), 16,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13543] = 7,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(154), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(781), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(789), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(783), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 9,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [13579] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(174), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(176), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13607] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(208), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(210), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13635] = 6,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(154), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(781), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(783), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(156), 11,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13669] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(192), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(194), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13697] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(188), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(190), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13725] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(220), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(222), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13753] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(154), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(156), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13781] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(178), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(180), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13809] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(174), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(176), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13837] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(204), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(206), 17,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [13865] = 10,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(795), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(781), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(785), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(789), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(783), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(791), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [13906] = 10,
    ACTIONS(158), 1,
      anon_sym_EQ,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(166), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(799), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_mod,
    ACTIONS(805), 4,
      anon_sym_EQ_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_in,
  [13947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(811), 19,
      anon_sym_export,
      anon_sym_if,
      anon_sym_def,
      anon_sym_alias,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_let,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [13972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(813), 19,
      anon_sym_export,
      anon_sym_if,
      anon_sym_def,
      anon_sym_alias,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_let,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [13997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 18,
      anon_sym_export,
      anon_sym_if,
      anon_sym_def,
      anon_sym_alias,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_let,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [14021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 2,
      sym__cmd_newline,
      anon_sym_LF,
    ACTIONS(815), 15,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [14046] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(602), 1,
      anon_sym_DOLLAR,
    ACTIONS(604), 1,
      anon_sym_DQUOTE,
    ACTIONS(606), 1,
      anon_sym_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_BQUOTE,
    ACTIONS(819), 1,
      sym_identifier,
    STATE(288), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    ACTIONS(638), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(384), 2,
      sym_string,
      sym_value_path,
    ACTIONS(640), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14085] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_DOLLAR,
    ACTIONS(828), 1,
      anon_sym_DQUOTE,
    ACTIONS(831), 1,
      anon_sym_SQUOTE,
    ACTIONS(834), 1,
      anon_sym_BQUOTE,
    ACTIONS(837), 1,
      sym_identifier,
    STATE(288), 1,
      aux_sym__statement_repeat1,
    STATE(294), 1,
      sym_record_entry,
    ACTIONS(821), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(384), 2,
      sym_string,
      sym_value_path,
    ACTIONS(823), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14124] = 3,
    ACTIONS(763), 1,
      sym_comment,
    STATE(322), 1,
      sym_type,
    ACTIONS(840), 13,
      anon_sym_int,
      anon_sym_float,
      anon_sym_range,
      anon_sym_bool,
      anon_sym_string,
      anon_sym_block,
      anon_sym_duration,
      anon_sym_date,
      anon_sym_filesize,
      anon_sym_number,
      anon_sym_table,
      anon_sym_error,
      anon_sym_binary,
  [14146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 14,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      sym_number_literal,
      sym_word,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      aux_sym_file_path_token1,
      aux_sym_file_path_token2,
      sym_flag_arg,
      sym_identifier,
      anon_sym_LBRACE,
  [14166] = 3,
    ACTIONS(763), 1,
      sym_comment,
    STATE(312), 1,
      sym_type,
    ACTIONS(840), 13,
      anon_sym_int,
      anon_sym_float,
      anon_sym_range,
      anon_sym_bool,
      anon_sym_string,
      anon_sym_block,
      anon_sym_duration,
      anon_sym_date,
      anon_sym_filesize,
      anon_sym_number,
      anon_sym_table,
      anon_sym_error,
      anon_sym_binary,
  [14188] = 3,
    ACTIONS(763), 1,
      sym_comment,
    STATE(323), 1,
      sym_type,
    ACTIONS(840), 13,
      anon_sym_int,
      anon_sym_float,
      anon_sym_range,
      anon_sym_bool,
      anon_sym_string,
      anon_sym_block,
      anon_sym_duration,
      anon_sym_date,
      anon_sym_filesize,
      anon_sym_number,
      anon_sym_table,
      anon_sym_error,
      anon_sym_binary,
  [14210] = 3,
    ACTIONS(763), 1,
      sym_comment,
    STATE(324), 1,
      sym_type,
    ACTIONS(840), 13,
      anon_sym_int,
      anon_sym_float,
      anon_sym_range,
      anon_sym_bool,
      anon_sym_string,
      anon_sym_block,
      anon_sym_duration,
      anon_sym_date,
      anon_sym_filesize,
      anon_sym_number,
      anon_sym_table,
      anon_sym_error,
      anon_sym_binary,
  [14232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_COMMA,
    ACTIONS(842), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(844), 9,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
  [14254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(821), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(823), 9,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_identifier,
      anon_sym_RBRACE,
  [14273] = 7,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_RBRACK,
    ACTIONS(850), 1,
      sym_flag_name,
    ACTIONS(852), 1,
      anon_sym_DOT_DOT_DOTrest,
    ACTIONS(854), 1,
      sym_identifier,
    STATE(297), 1,
      aux_sym_signature_repeat1,
    STATE(318), 3,
      sym_parameter,
      sym_flag,
      sym_rest,
  [14297] = 7,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(850), 1,
      sym_flag_name,
    ACTIONS(852), 1,
      anon_sym_DOT_DOT_DOTrest,
    ACTIONS(854), 1,
      sym_identifier,
    ACTIONS(856), 1,
      anon_sym_RBRACK,
    STATE(298), 1,
      aux_sym_signature_repeat1,
    STATE(318), 3,
      sym_parameter,
      sym_flag,
      sym_rest,
  [14321] = 7,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_RBRACK,
    ACTIONS(860), 1,
      sym_flag_name,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOTrest,
    ACTIONS(866), 1,
      sym_identifier,
    STATE(298), 1,
      aux_sym_signature_repeat1,
    STATE(318), 3,
      sym_parameter,
      sym_flag,
      sym_rest,
  [14345] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      ts_builtin_sym_end,
    ACTIONS(873), 1,
      anon_sym_LF,
    STATE(255), 1,
      sym__terminator,
    ACTIONS(871), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(875), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(879), 5,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 1,
      ts_builtin_sym_end,
    ACTIONS(883), 1,
      anon_sym_LF,
    STATE(258), 1,
      sym__terminator,
    ACTIONS(771), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(881), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [14402] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(887), 1,
      anon_sym_COLON,
    ACTIONS(889), 1,
      anon_sym_LPAREN,
    ACTIONS(885), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(893), 5,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14434] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_COLON,
    ACTIONS(899), 1,
      anon_sym_QMARK,
    ACTIONS(895), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(905), 1,
      anon_sym_else,
    ACTIONS(901), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(903), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(907), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(909), 5,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14483] = 7,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(911), 1,
      anon_sym_DOLLAR,
    ACTIONS(913), 1,
      anon_sym_DQUOTE,
    ACTIONS(915), 1,
      anon_sym_SQUOTE,
    ACTIONS(917), 1,
      anon_sym_BQUOTE,
    ACTIONS(919), 1,
      sym_identifier,
    STATE(356), 1,
      sym_string,
  [14505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(921), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(923), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14519] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(927), 1,
      anon_sym_COLON,
    ACTIONS(925), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(931), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(933), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(935), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14561] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_QMARK,
    ACTIONS(937), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(943), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [14589] = 7,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(911), 1,
      anon_sym_DOLLAR,
    ACTIONS(913), 1,
      anon_sym_DQUOTE,
    ACTIONS(915), 1,
      anon_sym_SQUOTE,
    ACTIONS(917), 1,
      anon_sym_BQUOTE,
    ACTIONS(945), 1,
      sym_identifier,
    STATE(350), 1,
      sym_string,
  [14611] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(947), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14623] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(951), 1,
      anon_sym_COLON,
    ACTIONS(949), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14637] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(955), 1,
      anon_sym_DQUOTE,
    ACTIONS(957), 1,
      anon_sym_SQUOTE,
    ACTIONS(959), 1,
      anon_sym_BQUOTE,
    ACTIONS(953), 2,
      sym_number_literal,
      sym_identifier,
  [14654] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_COMMA,
    ACTIONS(963), 4,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14667] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(967), 1,
      anon_sym_DQUOTE,
    ACTIONS(969), 1,
      anon_sym_SQUOTE,
    ACTIONS(971), 1,
      anon_sym_BQUOTE,
    ACTIONS(965), 2,
      sym_number_literal,
      sym_identifier,
  [14684] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(973), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14695] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(975), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14706] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(977), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14717] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(979), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14728] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(981), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14739] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(985), 1,
      anon_sym_DQUOTE,
    ACTIONS(987), 1,
      anon_sym_SQUOTE,
    ACTIONS(989), 1,
      anon_sym_BQUOTE,
    ACTIONS(983), 2,
      sym_number_literal,
      sym_identifier,
  [14756] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(993), 1,
      anon_sym_DQUOTE,
    ACTIONS(995), 1,
      anon_sym_SQUOTE,
    ACTIONS(997), 1,
      anon_sym_BQUOTE,
    ACTIONS(991), 2,
      sym_number_literal,
      sym_identifier,
  [14773] = 5,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_DQUOTE,
    ACTIONS(1003), 1,
      anon_sym_SQUOTE,
    ACTIONS(1005), 1,
      anon_sym_BQUOTE,
    ACTIONS(999), 2,
      sym_number_literal,
      sym_identifier,
  [14790] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1009), 1,
      anon_sym_RBRACK,
    STATE(335), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14804] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1011), 1,
      anon_sym_RBRACK,
    STATE(331), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14818] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    STATE(334), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14832] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1015), 1,
      anon_sym_RBRACK,
    STATE(334), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14846] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1017), 1,
      anon_sym_RBRACK,
    STATE(334), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14860] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1019), 1,
      anon_sym_RBRACK,
    STATE(330), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14874] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_LBRACK,
    ACTIONS(1024), 1,
      anon_sym_RBRACK,
    STATE(334), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14888] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1026), 1,
      anon_sym_RBRACK,
    STATE(334), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14902] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1028), 1,
      anon_sym_RBRACK,
    STATE(332), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14916] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1030), 1,
      anon_sym_RBRACK,
    STATE(338), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14930] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_LBRACK,
    ACTIONS(1032), 1,
      anon_sym_RBRACK,
    STATE(334), 2,
      sym_array,
      aux_sym_table_repeat1,
  [14944] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(858), 4,
      anon_sym_RBRACK,
      sym_flag_name,
      anon_sym_DOT_DOT_DOTrest,
      sym_identifier,
  [14954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_LF,
    STATE(285), 1,
      sym__terminator,
    ACTIONS(1034), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [14968] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1038), 1,
      anon_sym_PIPE,
    ACTIONS(1040), 1,
      sym_identifier,
    STATE(342), 1,
      aux_sym_block_args_repeat1,
  [14981] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1042), 1,
      anon_sym_PIPE,
    STATE(343), 1,
      aux_sym_block_args_repeat1,
  [14994] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      sym_identifier,
    STATE(343), 1,
      aux_sym_block_args_repeat1,
  [15007] = 4,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(993), 1,
      anon_sym_DQUOTE,
    ACTIONS(995), 1,
      anon_sym_SQUOTE,
    ACTIONS(997), 1,
      anon_sym_BQUOTE,
  [15020] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1051), 1,
      anon_sym_COMMA,
    ACTIONS(1049), 2,
      anon_sym_PIPE,
      sym_identifier,
  [15031] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1053), 2,
      sym_number_literal,
      sym_identifier,
  [15039] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1055), 1,
      anon_sym_LBRACE,
    STATE(311), 1,
      sym_block,
  [15049] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1057), 2,
      sym_number_literal,
      sym_identifier,
  [15057] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1055), 1,
      anon_sym_LBRACE,
    STATE(308), 1,
      sym_block,
  [15067] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_LBRACK,
    STATE(347), 1,
      sym_signature,
  [15077] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1061), 2,
      sym_number_literal,
      sym_identifier,
  [15085] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1055), 1,
      anon_sym_LBRACE,
    STATE(313), 1,
      sym_block,
  [15095] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1063), 2,
      sym_number_literal,
      sym_identifier,
  [15103] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1065), 2,
      anon_sym_PIPE,
      sym_identifier,
  [15111] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1067), 2,
      sym_number_literal,
      sym_identifier,
  [15119] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_LBRACK,
    STATE(352), 1,
      sym_signature,
  [15129] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_env,
    ACTIONS(1071), 1,
      anon_sym_def,
  [15139] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1055), 1,
      anon_sym_LBRACE,
    STATE(305), 1,
      sym_block,
  [15149] = 3,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1073), 1,
      sym_number_literal,
    ACTIONS(1075), 1,
      sym_identifier,
  [15159] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_BQUOTE,
  [15166] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1079), 1,
      ts_builtin_sym_end,
  [15173] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1081), 1,
      anon_sym_DQUOTE,
  [15180] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1081), 1,
      anon_sym_SQUOTE,
  [15187] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1081), 1,
      anon_sym_BQUOTE,
  [15194] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1083), 1,
      anon_sym_RBRACE,
  [15201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      aux_sym_string_token3,
  [15208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      aux_sym_string_token2,
  [15215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      aux_sym_string_token1,
  [15222] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1091), 1,
      sym_number_literal,
  [15229] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_EQ,
  [15236] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1095), 1,
      anon_sym_EQ,
  [15243] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
  [15250] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1099), 1,
      anon_sym_RPAREN,
  [15257] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1101), 1,
      sym_number_literal,
  [15264] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1103), 1,
      anon_sym_DQUOTE,
  [15271] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1103), 1,
      anon_sym_SQUOTE,
  [15278] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1103), 1,
      anon_sym_BQUOTE,
  [15285] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1105), 1,
      anon_sym_RBRACE,
  [15292] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_DQUOTE,
  [15299] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_SQUOTE,
  [15306] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_BQUOTE,
  [15313] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1109), 1,
      anon_sym_RBRACE,
  [15320] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_EQ,
  [15327] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1113), 1,
      anon_sym_COLON,
  [15334] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_LBRACE,
  [15341] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
  [15348] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1119), 1,
      sym_number_literal,
  [15355] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_DQUOTE,
  [15362] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_SQUOTE,
  [15369] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1121), 1,
      anon_sym_RBRACE,
  [15376] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
  [15383] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1125), 1,
      anon_sym_BQUOTE,
  [15390] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1125), 1,
      anon_sym_SQUOTE,
  [15397] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1125), 1,
      anon_sym_DQUOTE,
  [15404] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1127), 1,
      anon_sym_DQUOTE,
  [15411] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1127), 1,
      anon_sym_SQUOTE,
  [15418] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1127), 1,
      anon_sym_BQUOTE,
  [15425] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_RBRACE,
  [15432] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1131), 1,
      sym_number_literal,
  [15439] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1133), 1,
      sym_identifier,
  [15446] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_RPAREN,
  [15453] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
  [15460] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
  [15467] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_SQUOTE,
  [15474] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_RBRACE,
  [15481] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1145), 1,
      ts_builtin_sym_end,
  [15488] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_DQUOTE,
  [15495] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_RPAREN,
  [15502] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1149), 1,
      sym_number_literal,
  [15509] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1151), 1,
      anon_sym_DQUOTE,
  [15516] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1151), 1,
      anon_sym_SQUOTE,
  [15523] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1151), 1,
      anon_sym_BQUOTE,
  [15530] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1153), 1,
      anon_sym_RBRACE,
  [15537] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
  [15544] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1155), 1,
      anon_sym_LBRACE,
  [15551] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1157), 1,
      sym_flag_shorthand_name,
  [15558] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_DQUOTE,
  [15565] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_SQUOTE,
  [15572] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
  [15579] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
  [15586] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
  [15593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      aux_sym_string_token3,
  [15600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      aux_sym_string_token1,
  [15607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      aux_sym_string_token2,
  [15614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 1,
      aux_sym_string_token3,
  [15621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      aux_sym_string_token2,
  [15628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 1,
      aux_sym_string_token1,
  [15635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      aux_sym_string_token2,
  [15642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 1,
      aux_sym_string_token3,
  [15649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 1,
      aux_sym_string_token1,
  [15656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 1,
      aux_sym_string_token1,
  [15663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      aux_sym_string_token2,
  [15670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 1,
      aux_sym_string_token3,
  [15677] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1189), 1,
      anon_sym_DQUOTE,
  [15684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 1,
      aux_sym_string_token1,
  [15691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      aux_sym_string_token2,
  [15698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 1,
      aux_sym_string_token3,
  [15705] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1197), 1,
      anon_sym_RBRACE,
  [15712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 1,
      aux_sym_string_token1,
  [15719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 1,
      aux_sym_string_token2,
  [15726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 1,
      aux_sym_string_token3,
  [15733] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1205), 1,
      sym_identifier,
  [15740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 1,
      aux_sym_string_token1,
  [15747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 1,
      aux_sym_string_token2,
  [15754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 1,
      aux_sym_string_token3,
  [15761] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1189), 1,
      anon_sym_SQUOTE,
  [15768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 1,
      aux_sym_string_token1,
  [15775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 1,
      aux_sym_string_token2,
  [15782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      aux_sym_string_token3,
  [15789] = 2,
    ACTIONS(763), 1,
      sym_comment,
    ACTIONS(1189), 1,
      anon_sym_BQUOTE,
  [15796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      aux_sym_string_token1,
  [15803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      aux_sym_string_token2,
  [15810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      aux_sym_string_token3,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 98,
  [SMALL_STATE(4)] = 196,
  [SMALL_STATE(5)] = 294,
  [SMALL_STATE(6)] = 392,
  [SMALL_STATE(7)] = 490,
  [SMALL_STATE(8)] = 588,
  [SMALL_STATE(9)] = 680,
  [SMALL_STATE(10)] = 772,
  [SMALL_STATE(11)] = 864,
  [SMALL_STATE(12)] = 956,
  [SMALL_STATE(13)] = 1048,
  [SMALL_STATE(14)] = 1140,
  [SMALL_STATE(15)] = 1229,
  [SMALL_STATE(16)] = 1318,
  [SMALL_STATE(17)] = 1407,
  [SMALL_STATE(18)] = 1496,
  [SMALL_STATE(19)] = 1585,
  [SMALL_STATE(20)] = 1671,
  [SMALL_STATE(21)] = 1721,
  [SMALL_STATE(22)] = 1771,
  [SMALL_STATE(23)] = 1821,
  [SMALL_STATE(24)] = 1871,
  [SMALL_STATE(25)] = 1957,
  [SMALL_STATE(26)] = 2007,
  [SMALL_STATE(27)] = 2054,
  [SMALL_STATE(28)] = 2103,
  [SMALL_STATE(29)] = 2148,
  [SMALL_STATE(30)] = 2231,
  [SMALL_STATE(31)] = 2279,
  [SMALL_STATE(32)] = 2323,
  [SMALL_STATE(33)] = 2371,
  [SMALL_STATE(34)] = 2427,
  [SMALL_STATE(35)] = 2471,
  [SMALL_STATE(36)] = 2525,
  [SMALL_STATE(37)] = 2577,
  [SMALL_STATE(38)] = 2627,
  [SMALL_STATE(39)] = 2671,
  [SMALL_STATE(40)] = 2715,
  [SMALL_STATE(41)] = 2759,
  [SMALL_STATE(42)] = 2817,
  [SMALL_STATE(43)] = 2863,
  [SMALL_STATE(44)] = 2911,
  [SMALL_STATE(45)] = 2955,
  [SMALL_STATE(46)] = 2999,
  [SMALL_STATE(47)] = 3043,
  [SMALL_STATE(48)] = 3091,
  [SMALL_STATE(49)] = 3135,
  [SMALL_STATE(50)] = 3179,
  [SMALL_STATE(51)] = 3223,
  [SMALL_STATE(52)] = 3269,
  [SMALL_STATE(53)] = 3313,
  [SMALL_STATE(54)] = 3357,
  [SMALL_STATE(55)] = 3401,
  [SMALL_STATE(56)] = 3445,
  [SMALL_STATE(57)] = 3489,
  [SMALL_STATE(58)] = 3533,
  [SMALL_STATE(59)] = 3577,
  [SMALL_STATE(60)] = 3625,
  [SMALL_STATE(61)] = 3673,
  [SMALL_STATE(62)] = 3718,
  [SMALL_STATE(63)] = 3761,
  [SMALL_STATE(64)] = 3806,
  [SMALL_STATE(65)] = 3851,
  [SMALL_STATE(66)] = 3894,
  [SMALL_STATE(67)] = 3937,
  [SMALL_STATE(68)] = 3982,
  [SMALL_STATE(69)] = 4027,
  [SMALL_STATE(70)] = 4072,
  [SMALL_STATE(71)] = 4114,
  [SMALL_STATE(72)] = 4156,
  [SMALL_STATE(73)] = 4198,
  [SMALL_STATE(74)] = 4240,
  [SMALL_STATE(75)] = 4282,
  [SMALL_STATE(76)] = 4324,
  [SMALL_STATE(77)] = 4366,
  [SMALL_STATE(78)] = 4408,
  [SMALL_STATE(79)] = 4450,
  [SMALL_STATE(80)] = 4492,
  [SMALL_STATE(81)] = 4534,
  [SMALL_STATE(82)] = 4576,
  [SMALL_STATE(83)] = 4638,
  [SMALL_STATE(84)] = 4686,
  [SMALL_STATE(85)] = 4736,
  [SMALL_STATE(86)] = 4790,
  [SMALL_STATE(87)] = 4848,
  [SMALL_STATE(88)] = 4908,
  [SMALL_STATE(89)] = 4950,
  [SMALL_STATE(90)] = 4994,
  [SMALL_STATE(91)] = 5040,
  [SMALL_STATE(92)] = 5082,
  [SMALL_STATE(93)] = 5124,
  [SMALL_STATE(94)] = 5166,
  [SMALL_STATE(95)] = 5211,
  [SMALL_STATE(96)] = 5256,
  [SMALL_STATE(97)] = 5301,
  [SMALL_STATE(98)] = 5346,
  [SMALL_STATE(99)] = 5391,
  [SMALL_STATE(100)] = 5468,
  [SMALL_STATE(101)] = 5542,
  [SMALL_STATE(102)] = 5616,
  [SMALL_STATE(103)] = 5656,
  [SMALL_STATE(104)] = 5730,
  [SMALL_STATE(105)] = 5804,
  [SMALL_STATE(106)] = 5878,
  [SMALL_STATE(107)] = 5952,
  [SMALL_STATE(108)] = 5994,
  [SMALL_STATE(109)] = 6068,
  [SMALL_STATE(110)] = 6107,
  [SMALL_STATE(111)] = 6156,
  [SMALL_STATE(112)] = 6227,
  [SMALL_STATE(113)] = 6300,
  [SMALL_STATE(114)] = 6355,
  [SMALL_STATE(115)] = 6394,
  [SMALL_STATE(116)] = 6467,
  [SMALL_STATE(117)] = 6506,
  [SMALL_STATE(118)] = 6545,
  [SMALL_STATE(119)] = 6584,
  [SMALL_STATE(120)] = 6623,
  [SMALL_STATE(121)] = 6662,
  [SMALL_STATE(122)] = 6735,
  [SMALL_STATE(123)] = 6808,
  [SMALL_STATE(124)] = 6881,
  [SMALL_STATE(125)] = 6952,
  [SMALL_STATE(126)] = 6991,
  [SMALL_STATE(127)] = 7030,
  [SMALL_STATE(128)] = 7069,
  [SMALL_STATE(129)] = 7108,
  [SMALL_STATE(130)] = 7147,
  [SMALL_STATE(131)] = 7220,
  [SMALL_STATE(132)] = 7259,
  [SMALL_STATE(133)] = 7302,
  [SMALL_STATE(134)] = 7375,
  [SMALL_STATE(135)] = 7416,
  [SMALL_STATE(136)] = 7469,
  [SMALL_STATE(137)] = 7540,
  [SMALL_STATE(138)] = 7613,
  [SMALL_STATE(139)] = 7686,
  [SMALL_STATE(140)] = 7737,
  [SMALL_STATE(141)] = 7776,
  [SMALL_STATE(142)] = 7823,
  [SMALL_STATE(143)] = 7868,
  [SMALL_STATE(144)] = 7907,
  [SMALL_STATE(145)] = 7946,
  [SMALL_STATE(146)] = 8019,
  [SMALL_STATE(147)] = 8058,
  [SMALL_STATE(148)] = 8129,
  [SMALL_STATE(149)] = 8168,
  [SMALL_STATE(150)] = 8239,
  [SMALL_STATE(151)] = 8307,
  [SMALL_STATE(152)] = 8347,
  [SMALL_STATE(153)] = 8387,
  [SMALL_STATE(154)] = 8427,
  [SMALL_STATE(155)] = 8466,
  [SMALL_STATE(156)] = 8505,
  [SMALL_STATE(157)] = 8540,
  [SMALL_STATE(158)] = 8600,
  [SMALL_STATE(159)] = 8658,
  [SMALL_STATE(160)] = 8716,
  [SMALL_STATE(161)] = 8774,
  [SMALL_STATE(162)] = 8834,
  [SMALL_STATE(163)] = 8892,
  [SMALL_STATE(164)] = 8950,
  [SMALL_STATE(165)] = 8986,
  [SMALL_STATE(166)] = 9046,
  [SMALL_STATE(167)] = 9106,
  [SMALL_STATE(168)] = 9164,
  [SMALL_STATE(169)] = 9224,
  [SMALL_STATE(170)] = 9258,
  [SMALL_STATE(171)] = 9316,
  [SMALL_STATE(172)] = 9350,
  [SMALL_STATE(173)] = 9386,
  [SMALL_STATE(174)] = 9425,
  [SMALL_STATE(175)] = 9458,
  [SMALL_STATE(176)] = 9515,
  [SMALL_STATE(177)] = 9548,
  [SMALL_STATE(178)] = 9581,
  [SMALL_STATE(179)] = 9614,
  [SMALL_STATE(180)] = 9647,
  [SMALL_STATE(181)] = 9680,
  [SMALL_STATE(182)] = 9713,
  [SMALL_STATE(183)] = 9750,
  [SMALL_STATE(184)] = 9785,
  [SMALL_STATE(185)] = 9832,
  [SMALL_STATE(186)] = 9877,
  [SMALL_STATE(187)] = 9920,
  [SMALL_STATE(188)] = 9961,
  [SMALL_STATE(189)] = 10010,
  [SMALL_STATE(190)] = 10043,
  [SMALL_STATE(191)] = 10092,
  [SMALL_STATE(192)] = 10141,
  [SMALL_STATE(193)] = 10174,
  [SMALL_STATE(194)] = 10207,
  [SMALL_STATE(195)] = 10240,
  [SMALL_STATE(196)] = 10273,
  [SMALL_STATE(197)] = 10306,
  [SMALL_STATE(198)] = 10339,
  [SMALL_STATE(199)] = 10388,
  [SMALL_STATE(200)] = 10421,
  [SMALL_STATE(201)] = 10454,
  [SMALL_STATE(202)] = 10506,
  [SMALL_STATE(203)] = 10558,
  [SMALL_STATE(204)] = 10610,
  [SMALL_STATE(205)] = 10662,
  [SMALL_STATE(206)] = 10714,
  [SMALL_STATE(207)] = 10766,
  [SMALL_STATE(208)] = 10818,
  [SMALL_STATE(209)] = 10870,
  [SMALL_STATE(210)] = 10922,
  [SMALL_STATE(211)] = 10974,
  [SMALL_STATE(212)] = 11026,
  [SMALL_STATE(213)] = 11078,
  [SMALL_STATE(214)] = 11130,
  [SMALL_STATE(215)] = 11182,
  [SMALL_STATE(216)] = 11234,
  [SMALL_STATE(217)] = 11286,
  [SMALL_STATE(218)] = 11338,
  [SMALL_STATE(219)] = 11390,
  [SMALL_STATE(220)] = 11442,
  [SMALL_STATE(221)] = 11494,
  [SMALL_STATE(222)] = 11546,
  [SMALL_STATE(223)] = 11598,
  [SMALL_STATE(224)] = 11650,
  [SMALL_STATE(225)] = 11702,
  [SMALL_STATE(226)] = 11754,
  [SMALL_STATE(227)] = 11806,
  [SMALL_STATE(228)] = 11858,
  [SMALL_STATE(229)] = 11910,
  [SMALL_STATE(230)] = 11962,
  [SMALL_STATE(231)] = 12014,
  [SMALL_STATE(232)] = 12066,
  [SMALL_STATE(233)] = 12118,
  [SMALL_STATE(234)] = 12170,
  [SMALL_STATE(235)] = 12222,
  [SMALL_STATE(236)] = 12274,
  [SMALL_STATE(237)] = 12326,
  [SMALL_STATE(238)] = 12378,
  [SMALL_STATE(239)] = 12430,
  [SMALL_STATE(240)] = 12482,
  [SMALL_STATE(241)] = 12534,
  [SMALL_STATE(242)] = 12586,
  [SMALL_STATE(243)] = 12638,
  [SMALL_STATE(244)] = 12690,
  [SMALL_STATE(245)] = 12742,
  [SMALL_STATE(246)] = 12777,
  [SMALL_STATE(247)] = 12812,
  [SMALL_STATE(248)] = 12847,
  [SMALL_STATE(249)] = 12881,
  [SMALL_STATE(250)] = 12911,
  [SMALL_STATE(251)] = 12941,
  [SMALL_STATE(252)] = 12975,
  [SMALL_STATE(253)] = 13005,
  [SMALL_STATE(254)] = 13035,
  [SMALL_STATE(255)] = 13065,
  [SMALL_STATE(256)] = 13096,
  [SMALL_STATE(257)] = 13129,
  [SMALL_STATE(258)] = 13160,
  [SMALL_STATE(259)] = 13191,
  [SMALL_STATE(260)] = 13229,
  [SMALL_STATE(261)] = 13269,
  [SMALL_STATE(262)] = 13297,
  [SMALL_STATE(263)] = 13325,
  [SMALL_STATE(264)] = 13353,
  [SMALL_STATE(265)] = 13385,
  [SMALL_STATE(266)] = 13413,
  [SMALL_STATE(267)] = 13441,
  [SMALL_STATE(268)] = 13471,
  [SMALL_STATE(269)] = 13513,
  [SMALL_STATE(270)] = 13543,
  [SMALL_STATE(271)] = 13579,
  [SMALL_STATE(272)] = 13607,
  [SMALL_STATE(273)] = 13635,
  [SMALL_STATE(274)] = 13669,
  [SMALL_STATE(275)] = 13697,
  [SMALL_STATE(276)] = 13725,
  [SMALL_STATE(277)] = 13753,
  [SMALL_STATE(278)] = 13781,
  [SMALL_STATE(279)] = 13809,
  [SMALL_STATE(280)] = 13837,
  [SMALL_STATE(281)] = 13865,
  [SMALL_STATE(282)] = 13906,
  [SMALL_STATE(283)] = 13947,
  [SMALL_STATE(284)] = 13972,
  [SMALL_STATE(285)] = 13997,
  [SMALL_STATE(286)] = 14021,
  [SMALL_STATE(287)] = 14046,
  [SMALL_STATE(288)] = 14085,
  [SMALL_STATE(289)] = 14124,
  [SMALL_STATE(290)] = 14146,
  [SMALL_STATE(291)] = 14166,
  [SMALL_STATE(292)] = 14188,
  [SMALL_STATE(293)] = 14210,
  [SMALL_STATE(294)] = 14232,
  [SMALL_STATE(295)] = 14254,
  [SMALL_STATE(296)] = 14273,
  [SMALL_STATE(297)] = 14297,
  [SMALL_STATE(298)] = 14321,
  [SMALL_STATE(299)] = 14345,
  [SMALL_STATE(300)] = 14366,
  [SMALL_STATE(301)] = 14381,
  [SMALL_STATE(302)] = 14402,
  [SMALL_STATE(303)] = 14419,
  [SMALL_STATE(304)] = 14434,
  [SMALL_STATE(305)] = 14451,
  [SMALL_STATE(306)] = 14468,
  [SMALL_STATE(307)] = 14483,
  [SMALL_STATE(308)] = 14505,
  [SMALL_STATE(309)] = 14519,
  [SMALL_STATE(310)] = 14533,
  [SMALL_STATE(311)] = 14547,
  [SMALL_STATE(312)] = 14561,
  [SMALL_STATE(313)] = 14575,
  [SMALL_STATE(314)] = 14589,
  [SMALL_STATE(315)] = 14611,
  [SMALL_STATE(316)] = 14623,
  [SMALL_STATE(317)] = 14637,
  [SMALL_STATE(318)] = 14654,
  [SMALL_STATE(319)] = 14667,
  [SMALL_STATE(320)] = 14684,
  [SMALL_STATE(321)] = 14695,
  [SMALL_STATE(322)] = 14706,
  [SMALL_STATE(323)] = 14717,
  [SMALL_STATE(324)] = 14728,
  [SMALL_STATE(325)] = 14739,
  [SMALL_STATE(326)] = 14756,
  [SMALL_STATE(327)] = 14773,
  [SMALL_STATE(328)] = 14790,
  [SMALL_STATE(329)] = 14804,
  [SMALL_STATE(330)] = 14818,
  [SMALL_STATE(331)] = 14832,
  [SMALL_STATE(332)] = 14846,
  [SMALL_STATE(333)] = 14860,
  [SMALL_STATE(334)] = 14874,
  [SMALL_STATE(335)] = 14888,
  [SMALL_STATE(336)] = 14902,
  [SMALL_STATE(337)] = 14916,
  [SMALL_STATE(338)] = 14930,
  [SMALL_STATE(339)] = 14944,
  [SMALL_STATE(340)] = 14954,
  [SMALL_STATE(341)] = 14968,
  [SMALL_STATE(342)] = 14981,
  [SMALL_STATE(343)] = 14994,
  [SMALL_STATE(344)] = 15007,
  [SMALL_STATE(345)] = 15020,
  [SMALL_STATE(346)] = 15031,
  [SMALL_STATE(347)] = 15039,
  [SMALL_STATE(348)] = 15049,
  [SMALL_STATE(349)] = 15057,
  [SMALL_STATE(350)] = 15067,
  [SMALL_STATE(351)] = 15077,
  [SMALL_STATE(352)] = 15085,
  [SMALL_STATE(353)] = 15095,
  [SMALL_STATE(354)] = 15103,
  [SMALL_STATE(355)] = 15111,
  [SMALL_STATE(356)] = 15119,
  [SMALL_STATE(357)] = 15129,
  [SMALL_STATE(358)] = 15139,
  [SMALL_STATE(359)] = 15149,
  [SMALL_STATE(360)] = 15159,
  [SMALL_STATE(361)] = 15166,
  [SMALL_STATE(362)] = 15173,
  [SMALL_STATE(363)] = 15180,
  [SMALL_STATE(364)] = 15187,
  [SMALL_STATE(365)] = 15194,
  [SMALL_STATE(366)] = 15201,
  [SMALL_STATE(367)] = 15208,
  [SMALL_STATE(368)] = 15215,
  [SMALL_STATE(369)] = 15222,
  [SMALL_STATE(370)] = 15229,
  [SMALL_STATE(371)] = 15236,
  [SMALL_STATE(372)] = 15243,
  [SMALL_STATE(373)] = 15250,
  [SMALL_STATE(374)] = 15257,
  [SMALL_STATE(375)] = 15264,
  [SMALL_STATE(376)] = 15271,
  [SMALL_STATE(377)] = 15278,
  [SMALL_STATE(378)] = 15285,
  [SMALL_STATE(379)] = 15292,
  [SMALL_STATE(380)] = 15299,
  [SMALL_STATE(381)] = 15306,
  [SMALL_STATE(382)] = 15313,
  [SMALL_STATE(383)] = 15320,
  [SMALL_STATE(384)] = 15327,
  [SMALL_STATE(385)] = 15334,
  [SMALL_STATE(386)] = 15341,
  [SMALL_STATE(387)] = 15348,
  [SMALL_STATE(388)] = 15355,
  [SMALL_STATE(389)] = 15362,
  [SMALL_STATE(390)] = 15369,
  [SMALL_STATE(391)] = 15376,
  [SMALL_STATE(392)] = 15383,
  [SMALL_STATE(393)] = 15390,
  [SMALL_STATE(394)] = 15397,
  [SMALL_STATE(395)] = 15404,
  [SMALL_STATE(396)] = 15411,
  [SMALL_STATE(397)] = 15418,
  [SMALL_STATE(398)] = 15425,
  [SMALL_STATE(399)] = 15432,
  [SMALL_STATE(400)] = 15439,
  [SMALL_STATE(401)] = 15446,
  [SMALL_STATE(402)] = 15453,
  [SMALL_STATE(403)] = 15460,
  [SMALL_STATE(404)] = 15467,
  [SMALL_STATE(405)] = 15474,
  [SMALL_STATE(406)] = 15481,
  [SMALL_STATE(407)] = 15488,
  [SMALL_STATE(408)] = 15495,
  [SMALL_STATE(409)] = 15502,
  [SMALL_STATE(410)] = 15509,
  [SMALL_STATE(411)] = 15516,
  [SMALL_STATE(412)] = 15523,
  [SMALL_STATE(413)] = 15530,
  [SMALL_STATE(414)] = 15537,
  [SMALL_STATE(415)] = 15544,
  [SMALL_STATE(416)] = 15551,
  [SMALL_STATE(417)] = 15558,
  [SMALL_STATE(418)] = 15565,
  [SMALL_STATE(419)] = 15572,
  [SMALL_STATE(420)] = 15579,
  [SMALL_STATE(421)] = 15586,
  [SMALL_STATE(422)] = 15593,
  [SMALL_STATE(423)] = 15600,
  [SMALL_STATE(424)] = 15607,
  [SMALL_STATE(425)] = 15614,
  [SMALL_STATE(426)] = 15621,
  [SMALL_STATE(427)] = 15628,
  [SMALL_STATE(428)] = 15635,
  [SMALL_STATE(429)] = 15642,
  [SMALL_STATE(430)] = 15649,
  [SMALL_STATE(431)] = 15656,
  [SMALL_STATE(432)] = 15663,
  [SMALL_STATE(433)] = 15670,
  [SMALL_STATE(434)] = 15677,
  [SMALL_STATE(435)] = 15684,
  [SMALL_STATE(436)] = 15691,
  [SMALL_STATE(437)] = 15698,
  [SMALL_STATE(438)] = 15705,
  [SMALL_STATE(439)] = 15712,
  [SMALL_STATE(440)] = 15719,
  [SMALL_STATE(441)] = 15726,
  [SMALL_STATE(442)] = 15733,
  [SMALL_STATE(443)] = 15740,
  [SMALL_STATE(444)] = 15747,
  [SMALL_STATE(445)] = 15754,
  [SMALL_STATE(446)] = 15761,
  [SMALL_STATE(447)] = 15768,
  [SMALL_STATE(448)] = 15775,
  [SMALL_STATE(449)] = 15782,
  [SMALL_STATE(450)] = 15789,
  [SMALL_STATE(451)] = 15796,
  [SMALL_STATE(452)] = 15803,
  [SMALL_STATE(453)] = 15810,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [65] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(357),
  [68] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(175),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(307),
  [74] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(442),
  [77] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(166),
  [80] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(359),
  [86] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(172),
  [89] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(198),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(325),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(430),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(426),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(422),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(174),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(99),
  [110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_invocation, 4),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_invocation, 4),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_invocation, 3),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_invocation, 3),
  [123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_path, 2),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_path, 2),
  [127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_value_path_repeat1, 2),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_value_path_repeat1, 2),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_path_repeat1, 2), SHIFT_REPEAT(348),
  [134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_path, 3),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_path, 3),
  [138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cmd_expr, 1),
  [146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cmd_expr, 1),
  [148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 9),
  [156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 9),
  [158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 3, .production_id = 5),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 3, .production_id = 5),
  [174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 3, .production_id = 6),
  [176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 3, .production_id = 6),
  [178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 4),
  [180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 4),
  [182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 4),
  [186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 4),
  [188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_or_block, 4),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_or_block, 4),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 5),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 5),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 2, .production_id = 1),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 2, .production_id = 1),
  [204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 3, .production_id = 3),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 3, .production_id = 3),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_or_block, 3),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_or_block, 3),
  [212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_or_block, 2),
  [218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_or_block, 2),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 4, .production_id = 14),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 4, .production_id = 14),
  [224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_file_path, 1),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_path, 1),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_path_repeat1, 2), SHIFT_REPEAT(355),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_path_repeat1, 2), SHIFT_REPEAT(351),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(4),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(263),
  [326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cmd_expr, 1), SHIFT(263),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(161),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(18),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(27),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(51),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(319),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(439),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(440),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(441),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(58),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cmd_expr, 1), SHIFT(106),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_entry, 3, .production_id = 4),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_entry, 3, .production_id = 4),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7),
  [469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(161),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(18),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(27),
  [480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(51),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(319),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(439),
  [489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(440),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(441),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(58),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(106),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2, .production_id = 7), SHIFT_REPEAT(4),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_path_repeat1, 2), SHIFT_REPEAT(346),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(157),
  [546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(14),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(61),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(82),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(327),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(431),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(432),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(433),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(72),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(103),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(5),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_env_export, 4),
  [626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_env_export, 4),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, .production_id = 12),
  [632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, .production_id = 12),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, .production_id = 13),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, .production_id = 13),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_path_repeat1, 2), SHIFT_REPEAT(353),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 2),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 2),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 3),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 3),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_args, 2),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_args, 3, .production_id = 15),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 1, .production_id = 2),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_repeat1, 1, .production_id = 2),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_repeat1, 2),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_repeat1, 2),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_repeat1, 2), SHIFT_REPEAT(326),
  [828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_repeat1, 2), SHIFT_REPEAT(423),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_repeat1, 2), SHIFT_REPEAT(424),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_repeat1, 2), SHIFT_REPEAT(425),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_repeat1, 2), SHIFT_REPEAT(384),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_repeat1, 1),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_repeat1, 1),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2),
  [860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2), SHIFT_REPEAT(302),
  [863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2), SHIFT_REPEAT(316),
  [866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2), SHIFT_REPEAT(304),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 1),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 1),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flag, 1),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3),
  [903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5),
  [923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flag, 4),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 4, .production_id = 11),
  [931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 4, .production_id = 11),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 17),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 17),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 10),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 10),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest, 1),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 1),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flag, 3),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest, 3),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flag, 6),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2), SHIFT_REPEAT(160),
  [1024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_args_repeat1, 2, .production_id = 16),
  [1046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_args_repeat1, 2, .production_id = 16), SHIFT_REPEAT(345),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_args_repeat1, 1, .production_id = 8),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_args_repeat1, 2, .production_id = 8),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1079] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 3),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_nu_external_scanner_create(void);
void tree_sitter_nu_external_scanner_destroy(void *);
bool tree_sitter_nu_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_nu_external_scanner_serialize(void *, char *);
void tree_sitter_nu_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_nu(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_nu_external_scanner_create,
      tree_sitter_nu_external_scanner_destroy,
      tree_sitter_nu_external_scanner_scan,
      tree_sitter_nu_external_scanner_serialize,
      tree_sitter_nu_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
