#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1353
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 275
#define ALIAS_COUNT 0
#define TOKEN_COUNT 147
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 16
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 51

enum {
  sym__identifier = 1,
  sym_keyword_select = 2,
  sym_keyword_delete = 3,
  sym_keyword_insert = 4,
  sym_keyword_replace = 5,
  sym_keyword_update = 6,
  sym_keyword_into = 7,
  sym_keyword_values = 8,
  sym_keyword_set = 9,
  sym_keyword_from = 10,
  sym_keyword_left = 11,
  sym_keyword_right = 12,
  sym_keyword_inner = 13,
  sym_keyword_outer = 14,
  sym_keyword_cross = 15,
  sym_keyword_join = 16,
  sym_keyword_lateral = 17,
  sym_keyword_on = 18,
  sym_keyword_where = 19,
  sym_keyword_order_by = 20,
  sym_keyword_group_by = 21,
  sym_keyword_having = 22,
  sym_keyword_desc = 23,
  sym_keyword_asc = 24,
  sym_keyword_limit = 25,
  sym_keyword_offset = 26,
  sym_keyword_primary = 27,
  sym_keyword_create = 28,
  sym_keyword_alter = 29,
  sym_keyword_drop = 30,
  sym_keyword_add = 31,
  sym_keyword_table = 32,
  sym_keyword_view = 33,
  sym_keyword_materialized = 34,
  sym_keyword_column = 35,
  sym_keyword_key = 36,
  sym_keyword_as = 37,
  sym_keyword_distinct = 38,
  sym_keyword_constraint = 39,
  sym_keyword_count = 40,
  sym_keyword_max = 41,
  sym_keyword_min = 42,
  sym_keyword_avg = 43,
  sym_keyword_case = 44,
  sym_keyword_when = 45,
  sym_keyword_then = 46,
  sym_keyword_else = 47,
  sym_keyword_end = 48,
  sym_keyword_in = 49,
  sym_keyword_and = 50,
  sym_keyword_or = 51,
  sym_keyword_is = 52,
  sym_keyword_not = 53,
  sym_keyword_force = 54,
  sym_keyword_using = 55,
  sym_keyword_use = 56,
  sym_keyword_index = 57,
  sym_keyword_for = 58,
  sym_keyword_if = 59,
  sym_keyword_exists = 60,
  sym_keyword_auto_increment = 61,
  sym_keyword_default = 62,
  sym_keyword_cascade = 63,
  aux_sym_keyword_with_token1 = 64,
  sym_keyword_no = 65,
  sym_keyword_data = 66,
  sym_keyword_type = 67,
  sym_keyword_rename = 68,
  sym_keyword_to = 69,
  sym_keyword_schema = 70,
  sym_keyword_owner = 71,
  sym_keyword_temp = 72,
  sym_keyword_temporary = 73,
  sym_keyword_union = 74,
  sym_keyword_all = 75,
  sym_keyword_except = 76,
  sym_keyword_intersect = 77,
  sym_keyword_returning = 78,
  sym_keyword_begin = 79,
  sym_keyword_commit = 80,
  sym_keyword_rollback = 81,
  sym_keyword_transaction = 82,
  sym_keyword_null = 83,
  sym_keyword_true = 84,
  sym_keyword_false = 85,
  sym_keyword_boolean = 86,
  sym_keyword_smallserial = 87,
  sym_keyword_serial = 88,
  sym_keyword_bigserial = 89,
  sym_keyword_smallint = 90,
  aux_sym_keyword_int_token1 = 91,
  aux_sym_keyword_int_token2 = 92,
  sym_keyword_bigint = 93,
  sym_keyword_decimal = 94,
  sym_keyword_numeric = 95,
  sym_keyword_real = 96,
  aux_sym_double_token1 = 97,
  aux_sym_double_token2 = 98,
  sym_keyword_money = 99,
  aux_sym_keyword_char_token1 = 100,
  aux_sym_keyword_char_token2 = 101,
  aux_sym_keyword_varchar_token1 = 102,
  aux_sym_keyword_varchar_token2 = 103,
  sym_keyword_text = 104,
  sym_keyword_uuid = 105,
  sym_keyword_json = 106,
  sym_keyword_jsonb = 107,
  sym_keyword_xml = 108,
  sym_keyword_bytea = 109,
  sym_keyword_date = 110,
  sym_keyword_datetime = 111,
  aux_sym_keyword_timestamp_token1 = 112,
  aux_sym_keyword_timestamp_token2 = 113,
  aux_sym_keyword_timestamp_token3 = 114,
  aux_sym_keyword_timestamp_token4 = 115,
  aux_sym_keyword_timestamptz_token1 = 116,
  sym_keyword_geometry = 117,
  sym_keyword_geography = 118,
  sym_keyword_box2d = 119,
  sym_keyword_box3d = 120,
  anon_sym_LPAREN = 121,
  anon_sym_RPAREN = 122,
  anon_sym_COMMA = 123,
  sym_comment = 124,
  sym_marginalia = 125,
  anon_sym_SEMI = 126,
  anon_sym_DOT = 127,
  anon_sym_EQ = 128,
  anon_sym_STAR = 129,
  anon_sym_LT = 130,
  anon_sym_LT_EQ = 131,
  anon_sym_BANG_EQ = 132,
  anon_sym_GT_EQ = 133,
  anon_sym_GT = 134,
  anon_sym_PLUS = 135,
  anon_sym_DASH = 136,
  anon_sym_SLASH = 137,
  anon_sym_PERCENT = 138,
  anon_sym_CARET = 139,
  anon_sym_PIPE_PIPE = 140,
  anon_sym_SQUOTE = 141,
  aux_sym__literal_string_token1 = 142,
  anon_sym_DQUOTE = 143,
  aux_sym__literal_string_token2 = 144,
  sym__number = 145,
  anon_sym_BQUOTE = 146,
  sym_program = 147,
  sym_keyword_with = 148,
  sym__temporary = 149,
  sym__not_null = 150,
  sym__primary_key = 151,
  sym__if_exists = 152,
  sym__if_not_exists = 153,
  sym__or_replace = 154,
  sym__default_null = 155,
  sym_direction = 156,
  sym_keyword_int = 157,
  sym_double = 158,
  sym_keyword_char = 159,
  sym_keyword_varchar = 160,
  sym_keyword_timestamp = 161,
  sym_keyword_timestamptz = 162,
  sym__type = 163,
  sym_bigint = 164,
  sym_decimal = 165,
  sym_numeric = 166,
  sym_char = 167,
  sym_varchar = 168,
  sym_statement = 169,
  sym__ddl_statement = 170,
  sym__dml_statement = 171,
  sym_cte = 172,
  sym_transaction = 173,
  sym__begin = 174,
  sym__commit = 175,
  sym__rollback = 176,
  sym__select_statement = 177,
  sym_select = 178,
  sym_select_expression = 179,
  sym__select_expression = 180,
  sym__delete_statement = 181,
  sym__delete_from = 182,
  sym_delete = 183,
  sym__create_statement = 184,
  sym_create_table = 185,
  sym_create_view = 186,
  sym_create_materialized_view = 187,
  sym__alter_statement = 188,
  sym_alter_table = 189,
  sym_add_column = 190,
  sym_alter_column = 191,
  sym_drop_column = 192,
  sym_rename_column = 193,
  sym_alter_view = 194,
  sym__drop_statement = 195,
  sym_drop_table = 196,
  sym_drop_view = 197,
  sym_rename_object = 198,
  sym_set_schema = 199,
  sym_change_ownership = 200,
  sym_table_reference = 201,
  sym__insert_statement = 202,
  sym_insert = 203,
  sym_insert_expression = 204,
  sym__column_list_without_order = 205,
  sym__column_without_order = 206,
  sym__update_statement = 207,
  sym_update = 208,
  sym_update_expression = 209,
  sym__single_table_update = 210,
  sym__multi_table_update = 211,
  sym__table_references = 212,
  sym_assignment_list = 213,
  sym_assignment = 214,
  sym_table_options = 215,
  sym_table_option = 216,
  sym_column_definitions = 217,
  sym_column_definition = 218,
  sym_constraints = 219,
  sym_constraint = 220,
  sym__constraint_literal = 221,
  sym__primary_key_constraint = 222,
  sym__key_constraint = 223,
  sym_column_list = 224,
  sym_column = 225,
  sym_all_fields = 226,
  sym_case = 227,
  sym_field = 228,
  sym_function_call = 229,
  sym_invocation = 230,
  sym__count_function = 231,
  sym__function_params = 232,
  sym__alias = 233,
  sym_from = 234,
  sym_table_expression = 235,
  sym_index_hint = 236,
  sym_join = 237,
  sym_lateral_join = 238,
  sym_where = 239,
  sym_group_by = 240,
  sym__having = 241,
  sym_order_by = 242,
  sym_order_expression = 243,
  sym_limit = 244,
  sym_offset = 245,
  sym_returning = 246,
  sym_where_expression = 247,
  sym_predicate = 248,
  sym__expression = 249,
  sym_binary_expression = 250,
  sym_subquery = 251,
  sym_list = 252,
  sym_literal = 253,
  sym__literal_string = 254,
  sym_identifier = 255,
  aux_sym_program_repeat1 = 256,
  aux_sym__dml_statement_repeat1 = 257,
  aux_sym_transaction_repeat1 = 258,
  aux_sym__select_statement_repeat1 = 259,
  aux_sym_select_expression_repeat1 = 260,
  aux_sym_alter_table_repeat1 = 261,
  aux_sym__column_list_without_order_repeat1 = 262,
  aux_sym__table_references_repeat1 = 263,
  aux_sym_assignment_list_repeat1 = 264,
  aux_sym_table_options_repeat1 = 265,
  aux_sym_column_definitions_repeat1 = 266,
  aux_sym_constraints_repeat1 = 267,
  aux_sym_column_list_repeat1 = 268,
  aux_sym_case_repeat1 = 269,
  aux_sym_case_repeat2 = 270,
  aux_sym__function_params_repeat1 = 271,
  aux_sym_from_repeat1 = 272,
  aux_sym_order_expression_repeat1 = 273,
  aux_sym_list_repeat1 = 274,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier] = "_identifier",
  [sym_keyword_select] = "keyword_select",
  [sym_keyword_delete] = "keyword_delete",
  [sym_keyword_insert] = "keyword_insert",
  [sym_keyword_replace] = "keyword_replace",
  [sym_keyword_update] = "keyword_update",
  [sym_keyword_into] = "keyword_into",
  [sym_keyword_values] = "keyword_values",
  [sym_keyword_set] = "keyword_set",
  [sym_keyword_from] = "keyword_from",
  [sym_keyword_left] = "keyword_left",
  [sym_keyword_right] = "keyword_right",
  [sym_keyword_inner] = "keyword_inner",
  [sym_keyword_outer] = "keyword_outer",
  [sym_keyword_cross] = "keyword_cross",
  [sym_keyword_join] = "keyword_join",
  [sym_keyword_lateral] = "keyword_lateral",
  [sym_keyword_on] = "keyword_on",
  [sym_keyword_where] = "keyword_where",
  [sym_keyword_order_by] = "keyword_order_by",
  [sym_keyword_group_by] = "keyword_group_by",
  [sym_keyword_having] = "keyword_having",
  [sym_keyword_desc] = "keyword_desc",
  [sym_keyword_asc] = "keyword_asc",
  [sym_keyword_limit] = "keyword_limit",
  [sym_keyword_offset] = "keyword_offset",
  [sym_keyword_primary] = "keyword_primary",
  [sym_keyword_create] = "keyword_create",
  [sym_keyword_alter] = "keyword_alter",
  [sym_keyword_drop] = "keyword_drop",
  [sym_keyword_add] = "keyword_add",
  [sym_keyword_table] = "keyword_table",
  [sym_keyword_view] = "keyword_view",
  [sym_keyword_materialized] = "keyword_materialized",
  [sym_keyword_column] = "keyword_column",
  [sym_keyword_key] = "keyword_key",
  [sym_keyword_as] = "keyword_as",
  [sym_keyword_distinct] = "keyword_distinct",
  [sym_keyword_constraint] = "keyword_constraint",
  [sym_keyword_count] = "identifier",
  [sym_keyword_max] = "keyword_max",
  [sym_keyword_min] = "keyword_min",
  [sym_keyword_avg] = "keyword_avg",
  [sym_keyword_case] = "keyword_case",
  [sym_keyword_when] = "keyword_when",
  [sym_keyword_then] = "keyword_then",
  [sym_keyword_else] = "keyword_else",
  [sym_keyword_end] = "keyword_end",
  [sym_keyword_in] = "keyword_in",
  [sym_keyword_and] = "keyword_and",
  [sym_keyword_or] = "keyword_or",
  [sym_keyword_is] = "keyword_is",
  [sym_keyword_not] = "keyword_not",
  [sym_keyword_force] = "keyword_force",
  [sym_keyword_using] = "keyword_using",
  [sym_keyword_use] = "keyword_use",
  [sym_keyword_index] = "keyword_index",
  [sym_keyword_for] = "keyword_for",
  [sym_keyword_if] = "keyword_if",
  [sym_keyword_exists] = "keyword_exists",
  [sym_keyword_auto_increment] = "keyword_auto_increment",
  [sym_keyword_default] = "keyword_default",
  [sym_keyword_cascade] = "keyword_cascade",
  [aux_sym_keyword_with_token1] = "keyword_with_token1",
  [sym_keyword_no] = "keyword_no",
  [sym_keyword_data] = "keyword_data",
  [sym_keyword_type] = "keyword_type",
  [sym_keyword_rename] = "keyword_rename",
  [sym_keyword_to] = "keyword_to",
  [sym_keyword_schema] = "keyword_schema",
  [sym_keyword_owner] = "keyword_owner",
  [sym_keyword_temp] = "keyword_temp",
  [sym_keyword_temporary] = "keyword_temporary",
  [sym_keyword_union] = "keyword_union",
  [sym_keyword_all] = "keyword_all",
  [sym_keyword_except] = "keyword_except",
  [sym_keyword_intersect] = "keyword_intersect",
  [sym_keyword_returning] = "keyword_returning",
  [sym_keyword_begin] = "keyword_begin",
  [sym_keyword_commit] = "keyword_commit",
  [sym_keyword_rollback] = "keyword_rollback",
  [sym_keyword_transaction] = "keyword_transaction",
  [sym_keyword_null] = "keyword_null",
  [sym_keyword_true] = "keyword_true",
  [sym_keyword_false] = "keyword_false",
  [sym_keyword_boolean] = "keyword_boolean",
  [sym_keyword_smallserial] = "keyword_smallserial",
  [sym_keyword_serial] = "keyword_serial",
  [sym_keyword_bigserial] = "keyword_bigserial",
  [sym_keyword_smallint] = "keyword_smallint",
  [aux_sym_keyword_int_token1] = "keyword_int_token1",
  [aux_sym_keyword_int_token2] = "keyword_int_token2",
  [sym_keyword_bigint] = "keyword_bigint",
  [sym_keyword_decimal] = "keyword_decimal",
  [sym_keyword_numeric] = "keyword_numeric",
  [sym_keyword_real] = "keyword_real",
  [aux_sym_double_token1] = "double_token1",
  [aux_sym_double_token2] = "double_token2",
  [sym_keyword_money] = "keyword_money",
  [aux_sym_keyword_char_token1] = "keyword_char_token1",
  [aux_sym_keyword_char_token2] = "keyword_char_token2",
  [aux_sym_keyword_varchar_token1] = "keyword_varchar_token1",
  [aux_sym_keyword_varchar_token2] = "keyword_varchar_token2",
  [sym_keyword_text] = "keyword_text",
  [sym_keyword_uuid] = "keyword_uuid",
  [sym_keyword_json] = "keyword_json",
  [sym_keyword_jsonb] = "keyword_jsonb",
  [sym_keyword_xml] = "keyword_xml",
  [sym_keyword_bytea] = "keyword_bytea",
  [sym_keyword_date] = "keyword_date",
  [sym_keyword_datetime] = "keyword_datetime",
  [aux_sym_keyword_timestamp_token1] = "keyword_timestamp_token1",
  [aux_sym_keyword_timestamp_token2] = "keyword_timestamp_token2",
  [aux_sym_keyword_timestamp_token3] = "keyword_timestamp_token3",
  [aux_sym_keyword_timestamp_token4] = "keyword_timestamp_token4",
  [aux_sym_keyword_timestamptz_token1] = "keyword_timestamptz_token1",
  [sym_keyword_geometry] = "keyword_geometry",
  [sym_keyword_geography] = "keyword_geography",
  [sym_keyword_box2d] = "keyword_box2d",
  [sym_keyword_box3d] = "keyword_box3d",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [sym_comment] = "comment",
  [sym_marginalia] = "marginalia",
  [anon_sym_SEMI] = ";",
  [anon_sym_DOT] = ".",
  [anon_sym_EQ] = "=",
  [anon_sym_STAR] = "*",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_SQUOTE] = "'",
  [aux_sym__literal_string_token1] = "_literal_string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym__literal_string_token2] = "_literal_string_token2",
  [sym__number] = "_number",
  [anon_sym_BQUOTE] = "`",
  [sym_program] = "program",
  [sym_keyword_with] = "keyword_with",
  [sym__temporary] = "_temporary",
  [sym__not_null] = "_not_null",
  [sym__primary_key] = "_primary_key",
  [sym__if_exists] = "_if_exists",
  [sym__if_not_exists] = "_if_not_exists",
  [sym__or_replace] = "_or_replace",
  [sym__default_null] = "_default_null",
  [sym_direction] = "direction",
  [sym_keyword_int] = "keyword_int",
  [sym_double] = "double",
  [sym_keyword_char] = "keyword_char",
  [sym_keyword_varchar] = "keyword_varchar",
  [sym_keyword_timestamp] = "keyword_timestamp",
  [sym_keyword_timestamptz] = "keyword_timestamptz",
  [sym__type] = "_type",
  [sym_bigint] = "bigint",
  [sym_decimal] = "decimal",
  [sym_numeric] = "numeric",
  [sym_char] = "char",
  [sym_varchar] = "varchar",
  [sym_statement] = "statement",
  [sym__ddl_statement] = "_ddl_statement",
  [sym__dml_statement] = "_dml_statement",
  [sym_cte] = "cte",
  [sym_transaction] = "transaction",
  [sym__begin] = "_begin",
  [sym__commit] = "_commit",
  [sym__rollback] = "_rollback",
  [sym__select_statement] = "_select_statement",
  [sym_select] = "select",
  [sym_select_expression] = "select_expression",
  [sym__select_expression] = "_select_expression",
  [sym__delete_statement] = "_delete_statement",
  [sym__delete_from] = "from",
  [sym_delete] = "delete",
  [sym__create_statement] = "_create_statement",
  [sym_create_table] = "create_table",
  [sym_create_view] = "create_view",
  [sym_create_materialized_view] = "create_materialized_view",
  [sym__alter_statement] = "_alter_statement",
  [sym_alter_table] = "alter_table",
  [sym_add_column] = "add_column",
  [sym_alter_column] = "alter_column",
  [sym_drop_column] = "drop_column",
  [sym_rename_column] = "rename_column",
  [sym_alter_view] = "alter_view",
  [sym__drop_statement] = "_drop_statement",
  [sym_drop_table] = "drop_table",
  [sym_drop_view] = "drop_view",
  [sym_rename_object] = "rename_object",
  [sym_set_schema] = "set_schema",
  [sym_change_ownership] = "change_ownership",
  [sym_table_reference] = "table_reference",
  [sym__insert_statement] = "_insert_statement",
  [sym_insert] = "insert",
  [sym_insert_expression] = "insert_expression",
  [sym__column_list_without_order] = "column_list",
  [sym__column_without_order] = "column",
  [sym__update_statement] = "_update_statement",
  [sym_update] = "update",
  [sym_update_expression] = "update_expression",
  [sym__single_table_update] = "_single_table_update",
  [sym__multi_table_update] = "_multi_table_update",
  [sym__table_references] = "_table_references",
  [sym_assignment_list] = "assignment_list",
  [sym_assignment] = "assignment",
  [sym_table_options] = "table_options",
  [sym_table_option] = "table_option",
  [sym_column_definitions] = "column_definitions",
  [sym_column_definition] = "column_definition",
  [sym_constraints] = "constraints",
  [sym_constraint] = "constraint",
  [sym__constraint_literal] = "_constraint_literal",
  [sym__primary_key_constraint] = "_primary_key_constraint",
  [sym__key_constraint] = "_key_constraint",
  [sym_column_list] = "column_list",
  [sym_column] = "column",
  [sym_all_fields] = "all_fields",
  [sym_case] = "case",
  [sym_field] = "field",
  [sym_function_call] = "function_call",
  [sym_invocation] = "invocation",
  [sym__count_function] = "_count_function",
  [sym__function_params] = "_function_params",
  [sym__alias] = "_alias",
  [sym_from] = "from",
  [sym_table_expression] = "table_expression",
  [sym_index_hint] = "index_hint",
  [sym_join] = "join",
  [sym_lateral_join] = "lateral_join",
  [sym_where] = "where",
  [sym_group_by] = "group_by",
  [sym__having] = "_having",
  [sym_order_by] = "order_by",
  [sym_order_expression] = "order_expression",
  [sym_limit] = "limit",
  [sym_offset] = "offset",
  [sym_returning] = "returning",
  [sym_where_expression] = "where_expression",
  [sym_predicate] = "predicate",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_subquery] = "subquery",
  [sym_list] = "list",
  [sym_literal] = "literal",
  [sym__literal_string] = "_literal_string",
  [sym_identifier] = "identifier",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym__dml_statement_repeat1] = "_dml_statement_repeat1",
  [aux_sym_transaction_repeat1] = "transaction_repeat1",
  [aux_sym__select_statement_repeat1] = "_select_statement_repeat1",
  [aux_sym_select_expression_repeat1] = "select_expression_repeat1",
  [aux_sym_alter_table_repeat1] = "alter_table_repeat1",
  [aux_sym__column_list_without_order_repeat1] = "_column_list_without_order_repeat1",
  [aux_sym__table_references_repeat1] = "_table_references_repeat1",
  [aux_sym_assignment_list_repeat1] = "assignment_list_repeat1",
  [aux_sym_table_options_repeat1] = "table_options_repeat1",
  [aux_sym_column_definitions_repeat1] = "column_definitions_repeat1",
  [aux_sym_constraints_repeat1] = "constraints_repeat1",
  [aux_sym_column_list_repeat1] = "column_list_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_repeat2] = "case_repeat2",
  [aux_sym__function_params_repeat1] = "_function_params_repeat1",
  [aux_sym_from_repeat1] = "from_repeat1",
  [aux_sym_order_expression_repeat1] = "order_expression_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier] = sym__identifier,
  [sym_keyword_select] = sym_keyword_select,
  [sym_keyword_delete] = sym_keyword_delete,
  [sym_keyword_insert] = sym_keyword_insert,
  [sym_keyword_replace] = sym_keyword_replace,
  [sym_keyword_update] = sym_keyword_update,
  [sym_keyword_into] = sym_keyword_into,
  [sym_keyword_values] = sym_keyword_values,
  [sym_keyword_set] = sym_keyword_set,
  [sym_keyword_from] = sym_keyword_from,
  [sym_keyword_left] = sym_keyword_left,
  [sym_keyword_right] = sym_keyword_right,
  [sym_keyword_inner] = sym_keyword_inner,
  [sym_keyword_outer] = sym_keyword_outer,
  [sym_keyword_cross] = sym_keyword_cross,
  [sym_keyword_join] = sym_keyword_join,
  [sym_keyword_lateral] = sym_keyword_lateral,
  [sym_keyword_on] = sym_keyword_on,
  [sym_keyword_where] = sym_keyword_where,
  [sym_keyword_order_by] = sym_keyword_order_by,
  [sym_keyword_group_by] = sym_keyword_group_by,
  [sym_keyword_having] = sym_keyword_having,
  [sym_keyword_desc] = sym_keyword_desc,
  [sym_keyword_asc] = sym_keyword_asc,
  [sym_keyword_limit] = sym_keyword_limit,
  [sym_keyword_offset] = sym_keyword_offset,
  [sym_keyword_primary] = sym_keyword_primary,
  [sym_keyword_create] = sym_keyword_create,
  [sym_keyword_alter] = sym_keyword_alter,
  [sym_keyword_drop] = sym_keyword_drop,
  [sym_keyword_add] = sym_keyword_add,
  [sym_keyword_table] = sym_keyword_table,
  [sym_keyword_view] = sym_keyword_view,
  [sym_keyword_materialized] = sym_keyword_materialized,
  [sym_keyword_column] = sym_keyword_column,
  [sym_keyword_key] = sym_keyword_key,
  [sym_keyword_as] = sym_keyword_as,
  [sym_keyword_distinct] = sym_keyword_distinct,
  [sym_keyword_constraint] = sym_keyword_constraint,
  [sym_keyword_count] = sym_identifier,
  [sym_keyword_max] = sym_keyword_max,
  [sym_keyword_min] = sym_keyword_min,
  [sym_keyword_avg] = sym_keyword_avg,
  [sym_keyword_case] = sym_keyword_case,
  [sym_keyword_when] = sym_keyword_when,
  [sym_keyword_then] = sym_keyword_then,
  [sym_keyword_else] = sym_keyword_else,
  [sym_keyword_end] = sym_keyword_end,
  [sym_keyword_in] = sym_keyword_in,
  [sym_keyword_and] = sym_keyword_and,
  [sym_keyword_or] = sym_keyword_or,
  [sym_keyword_is] = sym_keyword_is,
  [sym_keyword_not] = sym_keyword_not,
  [sym_keyword_force] = sym_keyword_force,
  [sym_keyword_using] = sym_keyword_using,
  [sym_keyword_use] = sym_keyword_use,
  [sym_keyword_index] = sym_keyword_index,
  [sym_keyword_for] = sym_keyword_for,
  [sym_keyword_if] = sym_keyword_if,
  [sym_keyword_exists] = sym_keyword_exists,
  [sym_keyword_auto_increment] = sym_keyword_auto_increment,
  [sym_keyword_default] = sym_keyword_default,
  [sym_keyword_cascade] = sym_keyword_cascade,
  [aux_sym_keyword_with_token1] = aux_sym_keyword_with_token1,
  [sym_keyword_no] = sym_keyword_no,
  [sym_keyword_data] = sym_keyword_data,
  [sym_keyword_type] = sym_keyword_type,
  [sym_keyword_rename] = sym_keyword_rename,
  [sym_keyword_to] = sym_keyword_to,
  [sym_keyword_schema] = sym_keyword_schema,
  [sym_keyword_owner] = sym_keyword_owner,
  [sym_keyword_temp] = sym_keyword_temp,
  [sym_keyword_temporary] = sym_keyword_temporary,
  [sym_keyword_union] = sym_keyword_union,
  [sym_keyword_all] = sym_keyword_all,
  [sym_keyword_except] = sym_keyword_except,
  [sym_keyword_intersect] = sym_keyword_intersect,
  [sym_keyword_returning] = sym_keyword_returning,
  [sym_keyword_begin] = sym_keyword_begin,
  [sym_keyword_commit] = sym_keyword_commit,
  [sym_keyword_rollback] = sym_keyword_rollback,
  [sym_keyword_transaction] = sym_keyword_transaction,
  [sym_keyword_null] = sym_keyword_null,
  [sym_keyword_true] = sym_keyword_true,
  [sym_keyword_false] = sym_keyword_false,
  [sym_keyword_boolean] = sym_keyword_boolean,
  [sym_keyword_smallserial] = sym_keyword_smallserial,
  [sym_keyword_serial] = sym_keyword_serial,
  [sym_keyword_bigserial] = sym_keyword_bigserial,
  [sym_keyword_smallint] = sym_keyword_smallint,
  [aux_sym_keyword_int_token1] = aux_sym_keyword_int_token1,
  [aux_sym_keyword_int_token2] = aux_sym_keyword_int_token2,
  [sym_keyword_bigint] = sym_keyword_bigint,
  [sym_keyword_decimal] = sym_keyword_decimal,
  [sym_keyword_numeric] = sym_keyword_numeric,
  [sym_keyword_real] = sym_keyword_real,
  [aux_sym_double_token1] = aux_sym_double_token1,
  [aux_sym_double_token2] = aux_sym_double_token2,
  [sym_keyword_money] = sym_keyword_money,
  [aux_sym_keyword_char_token1] = aux_sym_keyword_char_token1,
  [aux_sym_keyword_char_token2] = aux_sym_keyword_char_token2,
  [aux_sym_keyword_varchar_token1] = aux_sym_keyword_varchar_token1,
  [aux_sym_keyword_varchar_token2] = aux_sym_keyword_varchar_token2,
  [sym_keyword_text] = sym_keyword_text,
  [sym_keyword_uuid] = sym_keyword_uuid,
  [sym_keyword_json] = sym_keyword_json,
  [sym_keyword_jsonb] = sym_keyword_jsonb,
  [sym_keyword_xml] = sym_keyword_xml,
  [sym_keyword_bytea] = sym_keyword_bytea,
  [sym_keyword_date] = sym_keyword_date,
  [sym_keyword_datetime] = sym_keyword_datetime,
  [aux_sym_keyword_timestamp_token1] = aux_sym_keyword_timestamp_token1,
  [aux_sym_keyword_timestamp_token2] = aux_sym_keyword_timestamp_token2,
  [aux_sym_keyword_timestamp_token3] = aux_sym_keyword_timestamp_token3,
  [aux_sym_keyword_timestamp_token4] = aux_sym_keyword_timestamp_token4,
  [aux_sym_keyword_timestamptz_token1] = aux_sym_keyword_timestamptz_token1,
  [sym_keyword_geometry] = sym_keyword_geometry,
  [sym_keyword_geography] = sym_keyword_geography,
  [sym_keyword_box2d] = sym_keyword_box2d,
  [sym_keyword_box3d] = sym_keyword_box3d,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_comment] = sym_comment,
  [sym_marginalia] = sym_marginalia,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym__literal_string_token1] = aux_sym__literal_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym__literal_string_token2] = aux_sym__literal_string_token2,
  [sym__number] = sym__number,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [sym_program] = sym_program,
  [sym_keyword_with] = sym_keyword_with,
  [sym__temporary] = sym__temporary,
  [sym__not_null] = sym__not_null,
  [sym__primary_key] = sym__primary_key,
  [sym__if_exists] = sym__if_exists,
  [sym__if_not_exists] = sym__if_not_exists,
  [sym__or_replace] = sym__or_replace,
  [sym__default_null] = sym__default_null,
  [sym_direction] = sym_direction,
  [sym_keyword_int] = sym_keyword_int,
  [sym_double] = sym_double,
  [sym_keyword_char] = sym_keyword_char,
  [sym_keyword_varchar] = sym_keyword_varchar,
  [sym_keyword_timestamp] = sym_keyword_timestamp,
  [sym_keyword_timestamptz] = sym_keyword_timestamptz,
  [sym__type] = sym__type,
  [sym_bigint] = sym_bigint,
  [sym_decimal] = sym_decimal,
  [sym_numeric] = sym_numeric,
  [sym_char] = sym_char,
  [sym_varchar] = sym_varchar,
  [sym_statement] = sym_statement,
  [sym__ddl_statement] = sym__ddl_statement,
  [sym__dml_statement] = sym__dml_statement,
  [sym_cte] = sym_cte,
  [sym_transaction] = sym_transaction,
  [sym__begin] = sym__begin,
  [sym__commit] = sym__commit,
  [sym__rollback] = sym__rollback,
  [sym__select_statement] = sym__select_statement,
  [sym_select] = sym_select,
  [sym_select_expression] = sym_select_expression,
  [sym__select_expression] = sym__select_expression,
  [sym__delete_statement] = sym__delete_statement,
  [sym__delete_from] = sym_from,
  [sym_delete] = sym_delete,
  [sym__create_statement] = sym__create_statement,
  [sym_create_table] = sym_create_table,
  [sym_create_view] = sym_create_view,
  [sym_create_materialized_view] = sym_create_materialized_view,
  [sym__alter_statement] = sym__alter_statement,
  [sym_alter_table] = sym_alter_table,
  [sym_add_column] = sym_add_column,
  [sym_alter_column] = sym_alter_column,
  [sym_drop_column] = sym_drop_column,
  [sym_rename_column] = sym_rename_column,
  [sym_alter_view] = sym_alter_view,
  [sym__drop_statement] = sym__drop_statement,
  [sym_drop_table] = sym_drop_table,
  [sym_drop_view] = sym_drop_view,
  [sym_rename_object] = sym_rename_object,
  [sym_set_schema] = sym_set_schema,
  [sym_change_ownership] = sym_change_ownership,
  [sym_table_reference] = sym_table_reference,
  [sym__insert_statement] = sym__insert_statement,
  [sym_insert] = sym_insert,
  [sym_insert_expression] = sym_insert_expression,
  [sym__column_list_without_order] = sym_column_list,
  [sym__column_without_order] = sym_column,
  [sym__update_statement] = sym__update_statement,
  [sym_update] = sym_update,
  [sym_update_expression] = sym_update_expression,
  [sym__single_table_update] = sym__single_table_update,
  [sym__multi_table_update] = sym__multi_table_update,
  [sym__table_references] = sym__table_references,
  [sym_assignment_list] = sym_assignment_list,
  [sym_assignment] = sym_assignment,
  [sym_table_options] = sym_table_options,
  [sym_table_option] = sym_table_option,
  [sym_column_definitions] = sym_column_definitions,
  [sym_column_definition] = sym_column_definition,
  [sym_constraints] = sym_constraints,
  [sym_constraint] = sym_constraint,
  [sym__constraint_literal] = sym__constraint_literal,
  [sym__primary_key_constraint] = sym__primary_key_constraint,
  [sym__key_constraint] = sym__key_constraint,
  [sym_column_list] = sym_column_list,
  [sym_column] = sym_column,
  [sym_all_fields] = sym_all_fields,
  [sym_case] = sym_case,
  [sym_field] = sym_field,
  [sym_function_call] = sym_function_call,
  [sym_invocation] = sym_invocation,
  [sym__count_function] = sym__count_function,
  [sym__function_params] = sym__function_params,
  [sym__alias] = sym__alias,
  [sym_from] = sym_from,
  [sym_table_expression] = sym_table_expression,
  [sym_index_hint] = sym_index_hint,
  [sym_join] = sym_join,
  [sym_lateral_join] = sym_lateral_join,
  [sym_where] = sym_where,
  [sym_group_by] = sym_group_by,
  [sym__having] = sym__having,
  [sym_order_by] = sym_order_by,
  [sym_order_expression] = sym_order_expression,
  [sym_limit] = sym_limit,
  [sym_offset] = sym_offset,
  [sym_returning] = sym_returning,
  [sym_where_expression] = sym_where_expression,
  [sym_predicate] = sym_predicate,
  [sym__expression] = sym__expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_subquery] = sym_subquery,
  [sym_list] = sym_list,
  [sym_literal] = sym_literal,
  [sym__literal_string] = sym__literal_string,
  [sym_identifier] = sym_identifier,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym__dml_statement_repeat1] = aux_sym__dml_statement_repeat1,
  [aux_sym_transaction_repeat1] = aux_sym_transaction_repeat1,
  [aux_sym__select_statement_repeat1] = aux_sym__select_statement_repeat1,
  [aux_sym_select_expression_repeat1] = aux_sym_select_expression_repeat1,
  [aux_sym_alter_table_repeat1] = aux_sym_alter_table_repeat1,
  [aux_sym__column_list_without_order_repeat1] = aux_sym__column_list_without_order_repeat1,
  [aux_sym__table_references_repeat1] = aux_sym__table_references_repeat1,
  [aux_sym_assignment_list_repeat1] = aux_sym_assignment_list_repeat1,
  [aux_sym_table_options_repeat1] = aux_sym_table_options_repeat1,
  [aux_sym_column_definitions_repeat1] = aux_sym_column_definitions_repeat1,
  [aux_sym_constraints_repeat1] = aux_sym_constraints_repeat1,
  [aux_sym_column_list_repeat1] = aux_sym_column_list_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_case_repeat2] = aux_sym_case_repeat2,
  [aux_sym__function_params_repeat1] = aux_sym__function_params_repeat1,
  [aux_sym_from_repeat1] = aux_sym_from_repeat1,
  [aux_sym_order_expression_repeat1] = aux_sym_order_expression_repeat1,
  [aux_sym_list_repeat1] = aux_sym_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_select] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_delete] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_insert] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_replace] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_update] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_into] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_values] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_set] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_from] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_left] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_right] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_inner] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_outer] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cross] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_join] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_lateral] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_on] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_where] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_order_by] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_group_by] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_having] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_desc] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_asc] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_limit] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_offset] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_primary] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_create] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_alter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_drop] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_add] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_table] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_view] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_materialized] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_column] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_key] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_as] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_distinct] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_count] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_max] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_min] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_avg] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_case] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_when] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_then] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_else] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_end] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_in] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_and] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_or] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_is] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_not] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_force] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_using] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_use] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_index] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_for] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_if] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_exists] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_auto_increment] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_default] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cascade] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_with_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_no] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_data] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_rename] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_to] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_schema] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_owner] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_temp] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_temporary] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_union] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_all] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_except] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_intersect] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_returning] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_commit] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_rollback] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_transaction] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_null] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_true] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_false] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_smallserial] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_serial] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_bigserial] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_smallint] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_int_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_int_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_bigint] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_numeric] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_real] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_double_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_money] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_char_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_varchar_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_varchar_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_text] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_uuid] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_json] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_jsonb] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_xml] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_bytea] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_date] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_datetime] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_timestamp_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_timestamp_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_timestamp_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_timestamp_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_timestamptz_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_geometry] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_geography] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_box2d] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_box3d] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_marginalia] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__literal_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__literal_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__number] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_with] = {
    .visible = true,
    .named = true,
  },
  [sym__temporary] = {
    .visible = false,
    .named = true,
  },
  [sym__not_null] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_key] = {
    .visible = false,
    .named = true,
  },
  [sym__if_exists] = {
    .visible = false,
    .named = true,
  },
  [sym__if_not_exists] = {
    .visible = false,
    .named = true,
  },
  [sym__or_replace] = {
    .visible = false,
    .named = true,
  },
  [sym__default_null] = {
    .visible = false,
    .named = true,
  },
  [sym_direction] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_int] = {
    .visible = true,
    .named = true,
  },
  [sym_double] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_char] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_varchar] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_timestamp] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_timestamptz] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_bigint] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_numeric] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_varchar] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__ddl_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__dml_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_cte] = {
    .visible = true,
    .named = true,
  },
  [sym_transaction] = {
    .visible = true,
    .named = true,
  },
  [sym__begin] = {
    .visible = false,
    .named = true,
  },
  [sym__commit] = {
    .visible = false,
    .named = true,
  },
  [sym__rollback] = {
    .visible = false,
    .named = true,
  },
  [sym__select_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_select] = {
    .visible = true,
    .named = true,
  },
  [sym_select_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__select_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__delete_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__delete_from] = {
    .visible = true,
    .named = true,
  },
  [sym_delete] = {
    .visible = true,
    .named = true,
  },
  [sym__create_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_create_table] = {
    .visible = true,
    .named = true,
  },
  [sym_create_view] = {
    .visible = true,
    .named = true,
  },
  [sym_create_materialized_view] = {
    .visible = true,
    .named = true,
  },
  [sym__alter_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_alter_table] = {
    .visible = true,
    .named = true,
  },
  [sym_add_column] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_column] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_column] = {
    .visible = true,
    .named = true,
  },
  [sym_rename_column] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_view] = {
    .visible = true,
    .named = true,
  },
  [sym__drop_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_drop_table] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_view] = {
    .visible = true,
    .named = true,
  },
  [sym_rename_object] = {
    .visible = true,
    .named = true,
  },
  [sym_set_schema] = {
    .visible = true,
    .named = true,
  },
  [sym_change_ownership] = {
    .visible = true,
    .named = true,
  },
  [sym_table_reference] = {
    .visible = true,
    .named = true,
  },
  [sym__insert_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_insert] = {
    .visible = true,
    .named = true,
  },
  [sym_insert_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__column_list_without_order] = {
    .visible = true,
    .named = true,
  },
  [sym__column_without_order] = {
    .visible = true,
    .named = true,
  },
  [sym__update_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_update] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__single_table_update] = {
    .visible = false,
    .named = true,
  },
  [sym__multi_table_update] = {
    .visible = false,
    .named = true,
  },
  [sym__table_references] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_table_options] = {
    .visible = true,
    .named = true,
  },
  [sym_table_option] = {
    .visible = true,
    .named = true,
  },
  [sym_column_definitions] = {
    .visible = true,
    .named = true,
  },
  [sym_column_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym__constraint_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_key_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym__key_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_column_list] = {
    .visible = true,
    .named = true,
  },
  [sym_column] = {
    .visible = true,
    .named = true,
  },
  [sym_all_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym__count_function] = {
    .visible = false,
    .named = true,
  },
  [sym__function_params] = {
    .visible = false,
    .named = true,
  },
  [sym__alias] = {
    .visible = false,
    .named = true,
  },
  [sym_from] = {
    .visible = true,
    .named = true,
  },
  [sym_table_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_hint] = {
    .visible = true,
    .named = true,
  },
  [sym_join] = {
    .visible = true,
    .named = true,
  },
  [sym_lateral_join] = {
    .visible = true,
    .named = true,
  },
  [sym_where] = {
    .visible = true,
    .named = true,
  },
  [sym_group_by] = {
    .visible = true,
    .named = true,
  },
  [sym__having] = {
    .visible = false,
    .named = true,
  },
  [sym_order_by] = {
    .visible = true,
    .named = true,
  },
  [sym_order_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_limit] = {
    .visible = true,
    .named = true,
  },
  [sym_offset] = {
    .visible = true,
    .named = true,
  },
  [sym_returning] = {
    .visible = true,
    .named = true,
  },
  [sym_where_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subquery] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__literal_string] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__dml_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_transaction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__select_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alter_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__column_list_without_order_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__table_references_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assignment_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_options_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_column_definitions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_column_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_from_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_order_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alias = 1,
  field_index_name = 2,
  field_left = 3,
  field_name = 4,
  field_new_name = 5,
  field_old_name = 6,
  field_operator = 7,
  field_parameter = 8,
  field_precision = 9,
  field_right = 10,
  field_scale = 11,
  field_schema = 12,
  field_size = 13,
  field_table_alias = 14,
  field_type = 15,
  field_value = 16,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_index_name] = "index_name",
  [field_left] = "left",
  [field_name] = "name",
  [field_new_name] = "new_name",
  [field_old_name] = "old_name",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_precision] = "precision",
  [field_right] = "right",
  [field_scale] = "scale",
  [field_schema] = "schema",
  [field_size] = "size",
  [field_table_alias] = "table_alias",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 1},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 1},
  [8] = {.index = 9, .length = 3},
  [9] = {.index = 12, .length = 1},
  [10] = {.index = 13, .length = 1},
  [11] = {.index = 14, .length = 2},
  [12] = {.index = 16, .length = 2},
  [13] = {.index = 18, .length = 2},
  [14] = {.index = 20, .length = 2},
  [15] = {.index = 22, .length = 2},
  [16] = {.index = 24, .length = 2},
  [17] = {.index = 3, .length = 1},
  [18] = {.index = 26, .length = 2},
  [19] = {.index = 28, .length = 2},
  [20] = {.index = 30, .length = 5},
  [21] = {.index = 35, .length = 1},
  [22] = {.index = 36, .length = 2},
  [23] = {.index = 38, .length = 2},
  [24] = {.index = 40, .length = 3},
  [25] = {.index = 43, .length = 1},
  [26] = {.index = 44, .length = 1},
  [27] = {.index = 45, .length = 2},
  [28] = {.index = 47, .length = 2},
  [29] = {.index = 49, .length = 1},
  [30] = {.index = 50, .length = 1},
  [32] = {.index = 51, .length = 3},
  [33] = {.index = 54, .length = 6},
  [34] = {.index = 60, .length = 1},
  [35] = {.index = 61, .length = 2},
  [36] = {.index = 63, .length = 1},
  [37] = {.index = 64, .length = 2},
  [38] = {.index = 66, .length = 3},
  [39] = {.index = 69, .length = 1},
  [40] = {.index = 70, .length = 2},
  [41] = {.index = 72, .length = 2},
  [42] = {.index = 74, .length = 1},
  [43] = {.index = 75, .length = 1},
  [44] = {.index = 76, .length = 1},
  [45] = {.index = 77, .length = 1},
  [46] = {.index = 78, .length = 2},
  [47] = {.index = 80, .length = 1},
  [48] = {.index = 81, .length = 2},
  [49] = {.index = 83, .length = 1},
  [50] = {.index = 84, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_alias, 0, .inherited = true},
  [1] =
    {field_name, 0, .inherited = true},
    {field_parameter, 0, .inherited = true},
  [3] =
    {field_name, 0},
  [4] =
    {field_alias, 0, .inherited = true},
    {field_alias, 1, .inherited = true},
  [6] =
    {field_alias, 1, .inherited = true},
  [7] =
    {field_alias, 0},
  [8] =
    {field_alias, 1},
  [9] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [12] =
    {field_parameter, 0},
  [13] =
    {field_table_alias, 0},
  [14] =
    {field_name, 2},
    {field_table_alias, 0},
  [16] =
    {field_name, 2},
    {field_schema, 0},
  [18] =
    {field_name, 0},
    {field_table_alias, 1},
  [20] =
    {field_name, 0},
    {field_parameter, 2},
  [22] =
    {field_name, 0},
    {field_parameter, 2, .inherited = true},
  [24] =
    {field_parameter, 0},
    {field_parameter, 1, .inherited = true},
  [26] =
    {field_name, 0},
    {field_table_alias, 2},
  [28] =
    {field_name, 0},
    {field_parameter, 3},
  [30] =
    {field_left, 0},
    {field_operator, 1},
    {field_operator, 2},
    {field_operator, 3},
    {field_right, 4},
  [35] =
    {field_parameter, 1},
  [36] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [38] =
    {field_schema, 0},
    {field_table_alias, 2},
  [40] =
    {field_name, 4},
    {field_schema, 0},
    {field_table_alias, 2},
  [43] =
    {field_index_name, 3},
  [44] =
    {field_name, 1, .inherited = true},
  [45] =
    {field_left, 0},
    {field_right, 2},
  [47] =
    {field_name, 0},
    {field_type, 1},
  [49] =
    {field_schema, 2},
  [50] =
    {field_name, 2},
  [51] =
    {field_name, 2},
    {field_schema, 0},
    {field_table_alias, 3},
  [54] =
    {field_left, 0},
    {field_operator, 1},
    {field_operator, 2},
    {field_operator, 3},
    {field_operator, 4},
    {field_right, 5},
  [60] =
    {field_name, 0, .inherited = true},
  [61] =
    {field_name, 0},
    {field_value, 2},
  [63] =
    {field_name, 3},
  [64] =
    {field_new_name, 3},
    {field_old_name, 1},
  [66] =
    {field_name, 2},
    {field_schema, 0},
    {field_table_alias, 4},
  [69] =
    {field_index_name, 5},
  [70] =
    {field_name, 2},
    {field_type, 4},
  [72] =
    {field_new_name, 4},
    {field_old_name, 2},
  [74] =
    {field_name, 1},
  [75] =
    {field_size, 2},
  [76] =
    {field_precision, 2},
  [77] =
    {field_alias, 3},
  [78] =
    {field_name, 2},
    {field_type, 6},
  [80] =
    {field_alias, 4},
  [81] =
    {field_precision, 2},
    {field_scale, 4},
  [83] =
    {field_alias, 5},
  [84] =
    {field_alias, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [17] = {
    [0] = sym_identifier,
  },
  [31] = {
    [3] = sym_statement,
  },
  [43] = {
    [2] = sym_literal,
  },
  [44] = {
    [2] = sym_literal,
  },
  [48] = {
    [2] = sym_literal,
    [4] = sym_literal,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__select_statement, 2,
    sym__select_statement,
    sym_statement,
  sym__delete_statement, 2,
    sym__delete_statement,
    sym_statement,
  sym__insert_statement, 2,
    sym__insert_statement,
    sym_statement,
  sym__update_statement, 2,
    sym__update_statement,
    sym_statement,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(27);
      if (lookahead == '!') ADVANCE(10);
      if (lookahead == '"') ADVANCE(66);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '\'') ADVANCE(57);
      if (lookahead == '(') ADVANCE(33);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(51);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(53);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(50);
      if (lookahead == 'G') ADVANCE(85);
      if (lookahead == 'O') ADVANCE(86);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'g') ADVANCE(95);
      if (lookahead == 'o') ADVANCE(96);
      if (lookahead == '|') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead != 0) ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(10);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '(') ADVANCE(33);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(51);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(53);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(50);
      if (lookahead == 'O') ADVANCE(88);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(98);
      if (lookahead == '|') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(10);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(51);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '/') ADVANCE(53);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(50);
      if (lookahead == 'O') ADVANCE(86);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(96);
      if (lookahead == '|') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 4:
      if (lookahead == '\'') ADVANCE(4);
      if (lookahead == '*') ADVANCE(7);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 5:
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(9);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == 'O') ADVANCE(87);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 6:
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '-') ADVANCE(9);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == 'G') ADVANCE(85);
      if (lookahead == 'O') ADVANCE(87);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'g') ADVANCE(95);
      if (lookahead == 'o') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(7);
      if (lookahead == '/') ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == '*') ADVANCE(7);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 9:
      if (lookahead == '-') ADVANCE(1);
      END_STATE();
    case 10:
      if (lookahead == '=') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'B') ADVANCE(13);
      END_STATE();
    case 12:
      if (lookahead == 'B') ADVANCE(14);
      END_STATE();
    case 13:
      if (lookahead == 'Y') ADVANCE(29);
      END_STATE();
    case 14:
      if (lookahead == 'Y') ADVANCE(28);
      END_STATE();
    case 15:
      if (lookahead == 'b') ADVANCE(17);
      END_STATE();
    case 16:
      if (lookahead == 'b') ADVANCE(18);
      END_STATE();
    case 17:
      if (lookahead == 'y') ADVANCE(29);
      END_STATE();
    case 18:
      if (lookahead == 'y') ADVANCE(28);
      END_STATE();
    case 19:
      if (lookahead == '|') ADVANCE(56);
      END_STATE();
    case 20:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '-') ADVANCE(9);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == 'G') ADVANCE(85);
      if (lookahead == 'O') ADVANCE(87);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'g') ADVANCE(95);
      if (lookahead == 'o') ADVANCE(97);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 21:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (lookahead == '!') ADVANCE(10);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '(') ADVANCE(33);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(51);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(53);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(50);
      if (lookahead == 'O') ADVANCE(88);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(98);
      if (lookahead == '|') ADVANCE(19);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 22:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (lookahead == '!') ADVANCE(10);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(51);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '/') ADVANCE(53);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(50);
      if (lookahead == 'O') ADVANCE(86);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(96);
      if (lookahead == '|') ADVANCE(19);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 23:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(9);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == 'O') ADVANCE(87);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(97);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 24:
      if (eof) ADVANCE(27);
      if (lookahead == '"') ADVANCE(66);
      if (lookahead == '\'') ADVANCE(57);
      if (lookahead == '(') ADVANCE(33);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(9);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 25:
      if (eof) ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      if (lookahead == '!') ADVANCE(10);
      if (lookahead == '"') ADVANCE(66);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '\'') ADVANCE(57);
      if (lookahead == '(') ADVANCE(33);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(51);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(53);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '<') ADVANCE(46);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(50);
      if (lookahead == 'G') ADVANCE(85);
      if (lookahead == 'O') ADVANCE(86);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '`') ADVANCE(76);
      if (lookahead == 'g') ADVANCE(95);
      if (lookahead == 'o') ADVANCE(96);
      if (lookahead == '|') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 26:
      if (eof) ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      if (lookahead == '"') ADVANCE(66);
      if (lookahead == '\'') ADVANCE(57);
      if (lookahead == '(') ADVANCE(33);
      if (lookahead == ')') ADVANCE(34);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == ',') ADVANCE(35);
      if (lookahead == '-') ADVANCE(9);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == ';') ADVANCE(42);
      if (lookahead == '`') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_keyword_order_by);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_keyword_group_by);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_keyword_or);
      if (lookahead == 'D') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(sym_keyword_or);
      if (lookahead == 'd') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_keyword_or);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(65);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_marginalia);
      if (lookahead == '\n') ADVANCE(65);
      if (lookahead == '\'') ADVANCE(8);
      if (lookahead == '*') ADVANCE(59);
      if (lookahead != 0) ADVANCE(60);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_marginalia);
      if (lookahead == '\n') ADVANCE(74);
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead != 0) ADVANCE(69);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_marginalia);
      if (lookahead == '*') ADVANCE(7);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(49);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(1);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '\'') ADVANCE(4);
      if (lookahead == '*') ADVANCE(7);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead == '\n') ADVANCE(65);
      if (lookahead == '\'') ADVANCE(4);
      if (lookahead == '*') ADVANCE(59);
      if (lookahead != 0) ADVANCE(60);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead == '\n') ADVANCE(65);
      if (lookahead == '\'') ADVANCE(8);
      if (lookahead == '*') ADVANCE(59);
      if (lookahead == '/') ADVANCE(39);
      if (lookahead != 0) ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead == '\n') ADVANCE(65);
      if (lookahead == '\'') ADVANCE(8);
      if (lookahead == '*') ADVANCE(59);
      if (lookahead != 0) ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\'') ADVANCE(1);
      if (lookahead != 0) ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '/') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(65);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead == '-') ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(65);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(64);
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '/') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym__literal_string_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead == '\n') ADVANCE(74);
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '\'') ADVANCE(67);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead != 0) ADVANCE(69);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead == '\n') ADVANCE(74);
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '/') ADVANCE(40);
      if (lookahead != 0) ADVANCE(69);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead == '\n') ADVANCE(74);
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead != 0) ADVANCE(69);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead == '\n') ADVANCE(37);
      if (lookahead == '"') ADVANCE(1);
      if (lookahead != 0) ADVANCE(70);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead == '-') ADVANCE(72);
      if (lookahead == '/') ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead == '-') ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(73);
      if (lookahead == '-') ADVANCE(72);
      if (lookahead == '/') ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym__literal_string_token2);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym__number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ' ') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ' ') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ' ') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == ' ') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'D') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'E') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'O') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'P') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'R') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'R') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'R') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'R') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'R') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'U') ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'd') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'e') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'o') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'p') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'r') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'r') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'r') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'r') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'r') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == 'u') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym__identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(101);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'B') ADVANCE(2);
      if (lookahead == 'C') ADVANCE(3);
      if (lookahead == 'D') ADVANCE(4);
      if (lookahead == 'E') ADVANCE(5);
      if (lookahead == 'F') ADVANCE(6);
      if (lookahead == 'G') ADVANCE(7);
      if (lookahead == 'H') ADVANCE(8);
      if (lookahead == 'I') ADVANCE(9);
      if (lookahead == 'J') ADVANCE(10);
      if (lookahead == 'K') ADVANCE(11);
      if (lookahead == 'L') ADVANCE(12);
      if (lookahead == 'M') ADVANCE(13);
      if (lookahead == 'N') ADVANCE(14);
      if (lookahead == 'O') ADVANCE(15);
      if (lookahead == 'P') ADVANCE(16);
      if (lookahead == 'R') ADVANCE(17);
      if (lookahead == 'S') ADVANCE(18);
      if (lookahead == 'T') ADVANCE(19);
      if (lookahead == 'U') ADVANCE(20);
      if (lookahead == 'V') ADVANCE(21);
      if (lookahead == 'W') ADVANCE(22);
      if (lookahead == 'X') ADVANCE(23);
      if (lookahead == 'Z') ADVANCE(24);
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'b') ADVANCE(26);
      if (lookahead == 'c') ADVANCE(27);
      if (lookahead == 'd') ADVANCE(28);
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'f') ADVANCE(30);
      if (lookahead == 'g') ADVANCE(31);
      if (lookahead == 'h') ADVANCE(32);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'j') ADVANCE(34);
      if (lookahead == 'k') ADVANCE(35);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'm') ADVANCE(37);
      if (lookahead == 'n') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'p') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 's') ADVANCE(42);
      if (lookahead == 't') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(44);
      if (lookahead == 'v') ADVANCE(45);
      if (lookahead == 'w') ADVANCE(46);
      if (lookahead == 'x') ADVANCE(47);
      if (lookahead == 'z') ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49)
      END_STATE();
    case 1:
      if (lookahead == 'D') ADVANCE(50);
      if (lookahead == 'L') ADVANCE(51);
      if (lookahead == 'N') ADVANCE(52);
      if (lookahead == 'S') ADVANCE(53);
      if (lookahead == 'U') ADVANCE(54);
      if (lookahead == 'V') ADVANCE(55);
      END_STATE();
    case 2:
      if (lookahead == 'E') ADVANCE(56);
      if (lookahead == 'I') ADVANCE(57);
      if (lookahead == 'O') ADVANCE(58);
      if (lookahead == 'Y') ADVANCE(59);
      END_STATE();
    case 3:
      if (lookahead == 'A') ADVANCE(60);
      if (lookahead == 'H') ADVANCE(61);
      if (lookahead == 'O') ADVANCE(62);
      if (lookahead == 'R') ADVANCE(63);
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(64);
      if (lookahead == 'E') ADVANCE(65);
      if (lookahead == 'I') ADVANCE(66);
      if (lookahead == 'O') ADVANCE(67);
      if (lookahead == 'R') ADVANCE(68);
      END_STATE();
    case 5:
      if (lookahead == 'L') ADVANCE(69);
      if (lookahead == 'N') ADVANCE(70);
      if (lookahead == 'X') ADVANCE(71);
      END_STATE();
    case 6:
      if (lookahead == 'A') ADVANCE(72);
      if (lookahead == 'O') ADVANCE(73);
      if (lookahead == 'R') ADVANCE(74);
      END_STATE();
    case 7:
      if (lookahead == 'E') ADVANCE(75);
      END_STATE();
    case 8:
      if (lookahead == 'A') ADVANCE(76);
      END_STATE();
    case 9:
      if (lookahead == 'F') ADVANCE(77);
      if (lookahead == 'N') ADVANCE(78);
      if (lookahead == 'S') ADVANCE(79);
      END_STATE();
    case 10:
      if (lookahead == 'O') ADVANCE(80);
      if (lookahead == 'S') ADVANCE(81);
      END_STATE();
    case 11:
      if (lookahead == 'E') ADVANCE(82);
      END_STATE();
    case 12:
      if (lookahead == 'A') ADVANCE(83);
      if (lookahead == 'E') ADVANCE(84);
      if (lookahead == 'I') ADVANCE(85);
      END_STATE();
    case 13:
      if (lookahead == 'A') ADVANCE(86);
      if (lookahead == 'I') ADVANCE(87);
      if (lookahead == 'O') ADVANCE(88);
      END_STATE();
    case 14:
      if (lookahead == 'O') ADVANCE(89);
      if (lookahead == 'U') ADVANCE(90);
      END_STATE();
    case 15:
      if (lookahead == 'F') ADVANCE(91);
      if (lookahead == 'N') ADVANCE(92);
      if (lookahead == 'U') ADVANCE(93);
      if (lookahead == 'W') ADVANCE(94);
      END_STATE();
    case 16:
      if (lookahead == 'R') ADVANCE(95);
      END_STATE();
    case 17:
      if (lookahead == 'E') ADVANCE(96);
      if (lookahead == 'I') ADVANCE(97);
      if (lookahead == 'O') ADVANCE(98);
      END_STATE();
    case 18:
      if (lookahead == 'C') ADVANCE(99);
      if (lookahead == 'E') ADVANCE(100);
      if (lookahead == 'M') ADVANCE(101);
      END_STATE();
    case 19:
      if (lookahead == 'A') ADVANCE(102);
      if (lookahead == 'E') ADVANCE(103);
      if (lookahead == 'H') ADVANCE(104);
      if (lookahead == 'I') ADVANCE(105);
      if (lookahead == 'O') ADVANCE(106);
      if (lookahead == 'R') ADVANCE(107);
      if (lookahead == 'Y') ADVANCE(108);
      END_STATE();
    case 20:
      if (lookahead == 'N') ADVANCE(109);
      if (lookahead == 'P') ADVANCE(110);
      if (lookahead == 'S') ADVANCE(111);
      if (lookahead == 'U') ADVANCE(112);
      END_STATE();
    case 21:
      if (lookahead == 'A') ADVANCE(113);
      if (lookahead == 'I') ADVANCE(114);
      END_STATE();
    case 22:
      if (lookahead == 'H') ADVANCE(115);
      if (lookahead == 'I') ADVANCE(116);
      END_STATE();
    case 23:
      if (lookahead == 'M') ADVANCE(117);
      END_STATE();
    case 24:
      if (lookahead == 'O') ADVANCE(118);
      END_STATE();
    case 25:
      if (lookahead == 'd') ADVANCE(119);
      if (lookahead == 'l') ADVANCE(120);
      if (lookahead == 'n') ADVANCE(121);
      if (lookahead == 's') ADVANCE(122);
      if (lookahead == 'u') ADVANCE(123);
      if (lookahead == 'v') ADVANCE(124);
      END_STATE();
    case 26:
      if (lookahead == 'e') ADVANCE(125);
      if (lookahead == 'i') ADVANCE(126);
      if (lookahead == 'o') ADVANCE(127);
      if (lookahead == 'y') ADVANCE(128);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(129);
      if (lookahead == 'h') ADVANCE(130);
      if (lookahead == 'o') ADVANCE(131);
      if (lookahead == 'r') ADVANCE(132);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(133);
      if (lookahead == 'e') ADVANCE(134);
      if (lookahead == 'i') ADVANCE(135);
      if (lookahead == 'o') ADVANCE(136);
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(138);
      if (lookahead == 'n') ADVANCE(139);
      if (lookahead == 'x') ADVANCE(140);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(141);
      if (lookahead == 'o') ADVANCE(142);
      if (lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(145);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(77);
      if (lookahead == 'n') ADVANCE(146);
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 34:
      if (lookahead == 'o') ADVANCE(147);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 36:
      if (lookahead == 'a') ADVANCE(150);
      if (lookahead == 'e') ADVANCE(151);
      if (lookahead == 'i') ADVANCE(152);
      END_STATE();
    case 37:
      if (lookahead == 'a') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(156);
      if (lookahead == 'u') ADVANCE(157);
      END_STATE();
    case 39:
      if (lookahead == 'f') ADVANCE(158);
      if (lookahead == 'n') ADVANCE(92);
      if (lookahead == 'u') ADVANCE(159);
      if (lookahead == 'w') ADVANCE(160);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(161);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(162);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 42:
      if (lookahead == 'c') ADVANCE(165);
      if (lookahead == 'e') ADVANCE(166);
      if (lookahead == 'm') ADVANCE(167);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(168);
      if (lookahead == 'e') ADVANCE(169);
      if (lookahead == 'h') ADVANCE(170);
      if (lookahead == 'i') ADVANCE(171);
      if (lookahead == 'o') ADVANCE(106);
      if (lookahead == 'r') ADVANCE(172);
      if (lookahead == 'y') ADVANCE(173);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(174);
      if (lookahead == 'p') ADVANCE(175);
      if (lookahead == 's') ADVANCE(176);
      if (lookahead == 'u') ADVANCE(177);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 46:
      if (lookahead == 'h') ADVANCE(180);
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 47:
      if (lookahead == 'm') ADVANCE(182);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 49:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49)
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'B') ADVANCE(2);
      if (lookahead == 'C') ADVANCE(3);
      if (lookahead == 'D') ADVANCE(4);
      if (lookahead == 'E') ADVANCE(5);
      if (lookahead == 'F') ADVANCE(6);
      if (lookahead == 'G') ADVANCE(7);
      if (lookahead == 'H') ADVANCE(8);
      if (lookahead == 'I') ADVANCE(9);
      if (lookahead == 'J') ADVANCE(10);
      if (lookahead == 'K') ADVANCE(11);
      if (lookahead == 'L') ADVANCE(12);
      if (lookahead == 'M') ADVANCE(13);
      if (lookahead == 'N') ADVANCE(14);
      if (lookahead == 'O') ADVANCE(15);
      if (lookahead == 'P') ADVANCE(16);
      if (lookahead == 'R') ADVANCE(17);
      if (lookahead == 'S') ADVANCE(18);
      if (lookahead == 'T') ADVANCE(19);
      if (lookahead == 'U') ADVANCE(20);
      if (lookahead == 'V') ADVANCE(21);
      if (lookahead == 'W') ADVANCE(22);
      if (lookahead == 'X') ADVANCE(23);
      if (lookahead == 'Z') ADVANCE(24);
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'b') ADVANCE(26);
      if (lookahead == 'c') ADVANCE(27);
      if (lookahead == 'd') ADVANCE(28);
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'f') ADVANCE(30);
      if (lookahead == 'g') ADVANCE(31);
      if (lookahead == 'h') ADVANCE(32);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'j') ADVANCE(34);
      if (lookahead == 'k') ADVANCE(35);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'm') ADVANCE(37);
      if (lookahead == 'n') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'p') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 's') ADVANCE(42);
      if (lookahead == 't') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(44);
      if (lookahead == 'v') ADVANCE(45);
      if (lookahead == 'w') ADVANCE(46);
      if (lookahead == 'x') ADVANCE(47);
      if (lookahead == 'z') ADVANCE(48);
      END_STATE();
    case 50:
      if (lookahead == 'D') ADVANCE(184);
      END_STATE();
    case 51:
      if (lookahead == 'L') ADVANCE(185);
      if (lookahead == 'T') ADVANCE(186);
      END_STATE();
    case 52:
      if (lookahead == 'D') ADVANCE(187);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_keyword_as);
      if (lookahead == 'C') ADVANCE(188);
      END_STATE();
    case 54:
      if (lookahead == 'T') ADVANCE(189);
      END_STATE();
    case 55:
      if (lookahead == 'G') ADVANCE(190);
      END_STATE();
    case 56:
      if (lookahead == 'G') ADVANCE(191);
      END_STATE();
    case 57:
      if (lookahead == 'G') ADVANCE(192);
      END_STATE();
    case 58:
      if (lookahead == 'O') ADVANCE(193);
      if (lookahead == 'X') ADVANCE(194);
      END_STATE();
    case 59:
      if (lookahead == 'T') ADVANCE(195);
      END_STATE();
    case 60:
      if (lookahead == 'S') ADVANCE(196);
      END_STATE();
    case 61:
      if (lookahead == 'A') ADVANCE(197);
      END_STATE();
    case 62:
      if (lookahead == 'L') ADVANCE(198);
      if (lookahead == 'M') ADVANCE(199);
      if (lookahead == 'N') ADVANCE(200);
      if (lookahead == 'U') ADVANCE(201);
      END_STATE();
    case 63:
      if (lookahead == 'E') ADVANCE(202);
      if (lookahead == 'O') ADVANCE(203);
      END_STATE();
    case 64:
      if (lookahead == 'T') ADVANCE(204);
      END_STATE();
    case 65:
      if (lookahead == 'C') ADVANCE(205);
      if (lookahead == 'F') ADVANCE(206);
      if (lookahead == 'L') ADVANCE(207);
      if (lookahead == 'S') ADVANCE(208);
      END_STATE();
    case 66:
      if (lookahead == 'S') ADVANCE(209);
      END_STATE();
    case 67:
      if (lookahead == 'U') ADVANCE(210);
      END_STATE();
    case 68:
      if (lookahead == 'O') ADVANCE(211);
      END_STATE();
    case 69:
      if (lookahead == 'S') ADVANCE(212);
      END_STATE();
    case 70:
      if (lookahead == 'D') ADVANCE(213);
      END_STATE();
    case 71:
      if (lookahead == 'C') ADVANCE(214);
      if (lookahead == 'I') ADVANCE(215);
      END_STATE();
    case 72:
      if (lookahead == 'L') ADVANCE(216);
      END_STATE();
    case 73:
      if (lookahead == 'R') ADVANCE(217);
      END_STATE();
    case 74:
      if (lookahead == 'O') ADVANCE(218);
      END_STATE();
    case 75:
      if (lookahead == 'O') ADVANCE(219);
      END_STATE();
    case 76:
      if (lookahead == 'V') ADVANCE(220);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_keyword_if);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_keyword_in);
      if (lookahead == 'D') ADVANCE(221);
      if (lookahead == 'N') ADVANCE(222);
      if (lookahead == 'S') ADVANCE(223);
      if (lookahead == 'T') ADVANCE(224);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_keyword_is);
      END_STATE();
    case 80:
      if (lookahead == 'I') ADVANCE(225);
      END_STATE();
    case 81:
      if (lookahead == 'O') ADVANCE(226);
      END_STATE();
    case 82:
      if (lookahead == 'Y') ADVANCE(227);
      END_STATE();
    case 83:
      if (lookahead == 'T') ADVANCE(228);
      END_STATE();
    case 84:
      if (lookahead == 'F') ADVANCE(229);
      END_STATE();
    case 85:
      if (lookahead == 'M') ADVANCE(230);
      END_STATE();
    case 86:
      if (lookahead == 'T') ADVANCE(231);
      if (lookahead == 'X') ADVANCE(232);
      END_STATE();
    case 87:
      if (lookahead == 'N') ADVANCE(233);
      END_STATE();
    case 88:
      if (lookahead == 'N') ADVANCE(234);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_keyword_no);
      if (lookahead == 'T') ADVANCE(235);
      END_STATE();
    case 90:
      if (lookahead == 'L') ADVANCE(236);
      if (lookahead == 'M') ADVANCE(237);
      END_STATE();
    case 91:
      if (lookahead == 'F') ADVANCE(238);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_keyword_on);
      END_STATE();
    case 93:
      if (lookahead == 'T') ADVANCE(239);
      END_STATE();
    case 94:
      if (lookahead == 'N') ADVANCE(240);
      END_STATE();
    case 95:
      if (lookahead == 'E') ADVANCE(241);
      if (lookahead == 'I') ADVANCE(242);
      END_STATE();
    case 96:
      if (lookahead == 'A') ADVANCE(243);
      if (lookahead == 'N') ADVANCE(244);
      if (lookahead == 'P') ADVANCE(245);
      if (lookahead == 'T') ADVANCE(246);
      END_STATE();
    case 97:
      if (lookahead == 'G') ADVANCE(247);
      END_STATE();
    case 98:
      if (lookahead == 'L') ADVANCE(248);
      END_STATE();
    case 99:
      if (lookahead == 'H') ADVANCE(249);
      END_STATE();
    case 100:
      if (lookahead == 'L') ADVANCE(250);
      if (lookahead == 'R') ADVANCE(251);
      if (lookahead == 'T') ADVANCE(252);
      END_STATE();
    case 101:
      if (lookahead == 'A') ADVANCE(253);
      END_STATE();
    case 102:
      if (lookahead == 'B') ADVANCE(254);
      END_STATE();
    case 103:
      if (lookahead == 'M') ADVANCE(255);
      if (lookahead == 'X') ADVANCE(256);
      END_STATE();
    case 104:
      if (lookahead == 'E') ADVANCE(257);
      END_STATE();
    case 105:
      if (lookahead == 'M') ADVANCE(258);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_keyword_to);
      END_STATE();
    case 107:
      if (lookahead == 'A') ADVANCE(259);
      if (lookahead == 'U') ADVANCE(260);
      END_STATE();
    case 108:
      if (lookahead == 'P') ADVANCE(261);
      END_STATE();
    case 109:
      if (lookahead == 'I') ADVANCE(262);
      END_STATE();
    case 110:
      if (lookahead == 'D') ADVANCE(263);
      END_STATE();
    case 111:
      if (lookahead == 'E') ADVANCE(264);
      if (lookahead == 'I') ADVANCE(265);
      END_STATE();
    case 112:
      if (lookahead == 'I') ADVANCE(266);
      END_STATE();
    case 113:
      if (lookahead == 'L') ADVANCE(267);
      if (lookahead == 'R') ADVANCE(268);
      END_STATE();
    case 114:
      if (lookahead == 'E') ADVANCE(269);
      END_STATE();
    case 115:
      if (lookahead == 'E') ADVANCE(270);
      END_STATE();
    case 116:
      if (lookahead == 'T') ADVANCE(271);
      END_STATE();
    case 117:
      if (lookahead == 'L') ADVANCE(272);
      END_STATE();
    case 118:
      if (lookahead == 'N') ADVANCE(273);
      END_STATE();
    case 119:
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 120:
      if (lookahead == 'l') ADVANCE(185);
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 121:
      if (lookahead == 'd') ADVANCE(187);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_keyword_as);
      if (lookahead == 'c') ADVANCE(188);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(275);
      END_STATE();
    case 124:
      if (lookahead == 'g') ADVANCE(190);
      END_STATE();
    case 125:
      if (lookahead == 'g') ADVANCE(276);
      END_STATE();
    case 126:
      if (lookahead == 'g') ADVANCE(277);
      END_STATE();
    case 127:
      if (lookahead == 'o') ADVANCE(278);
      if (lookahead == 'x') ADVANCE(279);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(281);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(282);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(283);
      if (lookahead == 'm') ADVANCE(284);
      if (lookahead == 'n') ADVANCE(285);
      if (lookahead == 'u') ADVANCE(286);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(287);
      if (lookahead == 'o') ADVANCE(288);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 134:
      if (lookahead == 'c') ADVANCE(290);
      if (lookahead == 'f') ADVANCE(291);
      if (lookahead == 'l') ADVANCE(292);
      if (lookahead == 's') ADVANCE(293);
      END_STATE();
    case 135:
      if (lookahead == 's') ADVANCE(294);
      END_STATE();
    case 136:
      if (lookahead == 'u') ADVANCE(295);
      END_STATE();
    case 137:
      if (lookahead == 'o') ADVANCE(296);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(297);
      END_STATE();
    case 139:
      if (lookahead == 'd') ADVANCE(213);
      END_STATE();
    case 140:
      if (lookahead == 'c') ADVANCE(298);
      if (lookahead == 'i') ADVANCE(299);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(300);
      END_STATE();
    case 142:
      if (lookahead == 'r') ADVANCE(301);
      END_STATE();
    case 143:
      if (lookahead == 'o') ADVANCE(302);
      END_STATE();
    case 144:
      if (lookahead == 'o') ADVANCE(303);
      END_STATE();
    case 145:
      if (lookahead == 'v') ADVANCE(304);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_keyword_in);
      if (lookahead == 'd') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(306);
      if (lookahead == 's') ADVANCE(307);
      if (lookahead == 't') ADVANCE(308);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(309);
      END_STATE();
    case 148:
      if (lookahead == 'o') ADVANCE(310);
      END_STATE();
    case 149:
      if (lookahead == 'y') ADVANCE(227);
      END_STATE();
    case 150:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 151:
      if (lookahead == 'f') ADVANCE(312);
      END_STATE();
    case 152:
      if (lookahead == 'm') ADVANCE(313);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(314);
      if (lookahead == 'x') ADVANCE(232);
      END_STATE();
    case 154:
      if (lookahead == 'n') ADVANCE(233);
      END_STATE();
    case 155:
      if (lookahead == 'n') ADVANCE(315);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_keyword_no);
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 157:
      if (lookahead == 'l') ADVANCE(316);
      if (lookahead == 'm') ADVANCE(317);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(318);
      END_STATE();
    case 159:
      if (lookahead == 't') ADVANCE(319);
      END_STATE();
    case 160:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(321);
      if (lookahead == 'i') ADVANCE(322);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(323);
      if (lookahead == 'n') ADVANCE(324);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 163:
      if (lookahead == 'g') ADVANCE(327);
      END_STATE();
    case 164:
      if (lookahead == 'l') ADVANCE(328);
      END_STATE();
    case 165:
      if (lookahead == 'h') ADVANCE(329);
      END_STATE();
    case 166:
      if (lookahead == 'l') ADVANCE(330);
      if (lookahead == 'r') ADVANCE(331);
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 167:
      if (lookahead == 'a') ADVANCE(332);
      END_STATE();
    case 168:
      if (lookahead == 'b') ADVANCE(333);
      END_STATE();
    case 169:
      if (lookahead == 'm') ADVANCE(334);
      if (lookahead == 'x') ADVANCE(335);
      END_STATE();
    case 170:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 171:
      if (lookahead == 'm') ADVANCE(337);
      END_STATE();
    case 172:
      if (lookahead == 'a') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(339);
      END_STATE();
    case 173:
      if (lookahead == 'p') ADVANCE(340);
      END_STATE();
    case 174:
      if (lookahead == 'i') ADVANCE(341);
      END_STATE();
    case 175:
      if (lookahead == 'd') ADVANCE(342);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == 'i') ADVANCE(343);
      END_STATE();
    case 177:
      if (lookahead == 'i') ADVANCE(344);
      END_STATE();
    case 178:
      if (lookahead == 'l') ADVANCE(345);
      if (lookahead == 'r') ADVANCE(346);
      END_STATE();
    case 179:
      if (lookahead == 'e') ADVANCE(347);
      END_STATE();
    case 180:
      if (lookahead == 'e') ADVANCE(348);
      END_STATE();
    case 181:
      if (lookahead == 't') ADVANCE(349);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(272);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(350);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_keyword_add);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_keyword_all);
      END_STATE();
    case 186:
      if (lookahead == 'E') ADVANCE(351);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_keyword_and);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_keyword_asc);
      END_STATE();
    case 189:
      if (lookahead == 'O') ADVANCE(352);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_keyword_avg);
      END_STATE();
    case 191:
      if (lookahead == 'I') ADVANCE(353);
      END_STATE();
    case 192:
      if (lookahead == 'I') ADVANCE(354);
      if (lookahead == 'S') ADVANCE(355);
      END_STATE();
    case 193:
      if (lookahead == 'L') ADVANCE(356);
      END_STATE();
    case 194:
      if (lookahead == '2') ADVANCE(357);
      if (lookahead == '3') ADVANCE(358);
      END_STATE();
    case 195:
      if (lookahead == 'E') ADVANCE(359);
      END_STATE();
    case 196:
      if (lookahead == 'C') ADVANCE(360);
      if (lookahead == 'E') ADVANCE(361);
      END_STATE();
    case 197:
      if (lookahead == 'R') ADVANCE(362);
      END_STATE();
    case 198:
      if (lookahead == 'U') ADVANCE(363);
      END_STATE();
    case 199:
      if (lookahead == 'M') ADVANCE(364);
      END_STATE();
    case 200:
      if (lookahead == 'S') ADVANCE(365);
      END_STATE();
    case 201:
      if (lookahead == 'N') ADVANCE(366);
      END_STATE();
    case 202:
      if (lookahead == 'A') ADVANCE(367);
      END_STATE();
    case 203:
      if (lookahead == 'S') ADVANCE(368);
      END_STATE();
    case 204:
      if (lookahead == 'A') ADVANCE(369);
      if (lookahead == 'E') ADVANCE(370);
      END_STATE();
    case 205:
      if (lookahead == 'I') ADVANCE(371);
      END_STATE();
    case 206:
      if (lookahead == 'A') ADVANCE(372);
      END_STATE();
    case 207:
      if (lookahead == 'E') ADVANCE(373);
      END_STATE();
    case 208:
      if (lookahead == 'C') ADVANCE(374);
      END_STATE();
    case 209:
      if (lookahead == 'T') ADVANCE(375);
      END_STATE();
    case 210:
      if (lookahead == 'B') ADVANCE(376);
      END_STATE();
    case 211:
      if (lookahead == 'P') ADVANCE(377);
      END_STATE();
    case 212:
      if (lookahead == 'E') ADVANCE(378);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_keyword_end);
      END_STATE();
    case 214:
      if (lookahead == 'E') ADVANCE(379);
      END_STATE();
    case 215:
      if (lookahead == 'S') ADVANCE(380);
      END_STATE();
    case 216:
      if (lookahead == 'S') ADVANCE(381);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_keyword_for);
      if (lookahead == 'C') ADVANCE(382);
      END_STATE();
    case 218:
      if (lookahead == 'M') ADVANCE(383);
      END_STATE();
    case 219:
      if (lookahead == 'G') ADVANCE(384);
      if (lookahead == 'M') ADVANCE(385);
      END_STATE();
    case 220:
      if (lookahead == 'I') ADVANCE(386);
      END_STATE();
    case 221:
      if (lookahead == 'E') ADVANCE(387);
      END_STATE();
    case 222:
      if (lookahead == 'E') ADVANCE(388);
      END_STATE();
    case 223:
      if (lookahead == 'E') ADVANCE(389);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym_keyword_int_token1);
      if (lookahead == 'E') ADVANCE(390);
      if (lookahead == 'O') ADVANCE(391);
      END_STATE();
    case 225:
      if (lookahead == 'N') ADVANCE(392);
      END_STATE();
    case 226:
      if (lookahead == 'N') ADVANCE(393);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_keyword_key);
      END_STATE();
    case 228:
      if (lookahead == 'E') ADVANCE(394);
      END_STATE();
    case 229:
      if (lookahead == 'T') ADVANCE(395);
      END_STATE();
    case 230:
      if (lookahead == 'I') ADVANCE(396);
      END_STATE();
    case 231:
      if (lookahead == 'E') ADVANCE(397);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_keyword_max);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_keyword_min);
      END_STATE();
    case 234:
      if (lookahead == 'E') ADVANCE(398);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_keyword_not);
      END_STATE();
    case 236:
      if (lookahead == 'L') ADVANCE(399);
      END_STATE();
    case 237:
      if (lookahead == 'E') ADVANCE(400);
      END_STATE();
    case 238:
      if (lookahead == 'S') ADVANCE(401);
      END_STATE();
    case 239:
      if (lookahead == 'E') ADVANCE(402);
      END_STATE();
    case 240:
      if (lookahead == 'E') ADVANCE(403);
      END_STATE();
    case 241:
      if (lookahead == 'C') ADVANCE(404);
      END_STATE();
    case 242:
      if (lookahead == 'M') ADVANCE(405);
      END_STATE();
    case 243:
      if (lookahead == 'L') ADVANCE(406);
      END_STATE();
    case 244:
      if (lookahead == 'A') ADVANCE(407);
      END_STATE();
    case 245:
      if (lookahead == 'L') ADVANCE(408);
      END_STATE();
    case 246:
      if (lookahead == 'U') ADVANCE(409);
      END_STATE();
    case 247:
      if (lookahead == 'H') ADVANCE(410);
      END_STATE();
    case 248:
      if (lookahead == 'L') ADVANCE(411);
      END_STATE();
    case 249:
      if (lookahead == 'E') ADVANCE(412);
      END_STATE();
    case 250:
      if (lookahead == 'E') ADVANCE(413);
      END_STATE();
    case 251:
      if (lookahead == 'I') ADVANCE(414);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_keyword_set);
      END_STATE();
    case 253:
      if (lookahead == 'L') ADVANCE(415);
      END_STATE();
    case 254:
      if (lookahead == 'L') ADVANCE(416);
      END_STATE();
    case 255:
      if (lookahead == 'P') ADVANCE(417);
      END_STATE();
    case 256:
      if (lookahead == 'T') ADVANCE(418);
      END_STATE();
    case 257:
      if (lookahead == 'N') ADVANCE(419);
      END_STATE();
    case 258:
      if (lookahead == 'E') ADVANCE(420);
      END_STATE();
    case 259:
      if (lookahead == 'N') ADVANCE(421);
      END_STATE();
    case 260:
      if (lookahead == 'E') ADVANCE(422);
      END_STATE();
    case 261:
      if (lookahead == 'E') ADVANCE(423);
      END_STATE();
    case 262:
      if (lookahead == 'O') ADVANCE(424);
      END_STATE();
    case 263:
      if (lookahead == 'A') ADVANCE(425);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_keyword_use);
      END_STATE();
    case 265:
      if (lookahead == 'N') ADVANCE(426);
      END_STATE();
    case 266:
      if (lookahead == 'D') ADVANCE(427);
      END_STATE();
    case 267:
      if (lookahead == 'U') ADVANCE(428);
      END_STATE();
    case 268:
      if (lookahead == 'C') ADVANCE(429);
      if (lookahead == 'Y') ADVANCE(430);
      END_STATE();
    case 269:
      if (lookahead == 'W') ADVANCE(431);
      END_STATE();
    case 270:
      if (lookahead == 'N') ADVANCE(432);
      if (lookahead == 'R') ADVANCE(433);
      END_STATE();
    case 271:
      if (lookahead == 'H') ADVANCE(434);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_keyword_xml);
      END_STATE();
    case 273:
      if (lookahead == 'E') ADVANCE(435);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(436);
      END_STATE();
    case 275:
      if (lookahead == 'o') ADVANCE(437);
      END_STATE();
    case 276:
      if (lookahead == 'i') ADVANCE(438);
      END_STATE();
    case 277:
      if (lookahead == 'i') ADVANCE(439);
      if (lookahead == 's') ADVANCE(440);
      END_STATE();
    case 278:
      if (lookahead == 'l') ADVANCE(441);
      END_STATE();
    case 279:
      if (lookahead == '2') ADVANCE(442);
      if (lookahead == '3') ADVANCE(443);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(444);
      END_STATE();
    case 281:
      if (lookahead == 'c') ADVANCE(445);
      if (lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 282:
      if (lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 283:
      if (lookahead == 'u') ADVANCE(447);
      END_STATE();
    case 284:
      if (lookahead == 'm') ADVANCE(448);
      END_STATE();
    case 285:
      if (lookahead == 's') ADVANCE(449);
      END_STATE();
    case 286:
      if (lookahead == 'n') ADVANCE(450);
      END_STATE();
    case 287:
      if (lookahead == 'a') ADVANCE(451);
      END_STATE();
    case 288:
      if (lookahead == 's') ADVANCE(452);
      END_STATE();
    case 289:
      if (lookahead == 'a') ADVANCE(369);
      if (lookahead == 'e') ADVANCE(453);
      END_STATE();
    case 290:
      if (lookahead == 'i') ADVANCE(454);
      END_STATE();
    case 291:
      if (lookahead == 'a') ADVANCE(455);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(456);
      END_STATE();
    case 293:
      if (lookahead == 'c') ADVANCE(374);
      END_STATE();
    case 294:
      if (lookahead == 't') ADVANCE(457);
      END_STATE();
    case 295:
      if (lookahead == 'b') ADVANCE(458);
      END_STATE();
    case 296:
      if (lookahead == 'p') ADVANCE(377);
      END_STATE();
    case 297:
      if (lookahead == 'e') ADVANCE(378);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 299:
      if (lookahead == 's') ADVANCE(460);
      END_STATE();
    case 300:
      if (lookahead == 's') ADVANCE(461);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_keyword_for);
      if (lookahead == 'c') ADVANCE(462);
      END_STATE();
    case 302:
      if (lookahead == 'm') ADVANCE(383);
      END_STATE();
    case 303:
      if (lookahead == 'g') ADVANCE(463);
      if (lookahead == 'm') ADVANCE(464);
      END_STATE();
    case 304:
      if (lookahead == 'i') ADVANCE(465);
      END_STATE();
    case 305:
      if (lookahead == 'e') ADVANCE(466);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(467);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(468);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_keyword_int_token1);
      if (lookahead == 'e') ADVANCE(469);
      if (lookahead == 'o') ADVANCE(391);
      END_STATE();
    case 309:
      if (lookahead == 'n') ADVANCE(392);
      END_STATE();
    case 310:
      if (lookahead == 'n') ADVANCE(470);
      END_STATE();
    case 311:
      if (lookahead == 'e') ADVANCE(471);
      END_STATE();
    case 312:
      if (lookahead == 't') ADVANCE(395);
      END_STATE();
    case 313:
      if (lookahead == 'i') ADVANCE(472);
      END_STATE();
    case 314:
      if (lookahead == 'e') ADVANCE(473);
      END_STATE();
    case 315:
      if (lookahead == 'e') ADVANCE(474);
      END_STATE();
    case 316:
      if (lookahead == 'l') ADVANCE(399);
      END_STATE();
    case 317:
      if (lookahead == 'e') ADVANCE(475);
      END_STATE();
    case 318:
      if (lookahead == 's') ADVANCE(476);
      END_STATE();
    case 319:
      if (lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 320:
      if (lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 321:
      if (lookahead == 'c') ADVANCE(479);
      END_STATE();
    case 322:
      if (lookahead == 'm') ADVANCE(480);
      END_STATE();
    case 323:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 324:
      if (lookahead == 'a') ADVANCE(481);
      END_STATE();
    case 325:
      if (lookahead == 'l') ADVANCE(482);
      END_STATE();
    case 326:
      if (lookahead == 'u') ADVANCE(483);
      END_STATE();
    case 327:
      if (lookahead == 'h') ADVANCE(484);
      END_STATE();
    case 328:
      if (lookahead == 'l') ADVANCE(485);
      END_STATE();
    case 329:
      if (lookahead == 'e') ADVANCE(486);
      END_STATE();
    case 330:
      if (lookahead == 'e') ADVANCE(487);
      END_STATE();
    case 331:
      if (lookahead == 'i') ADVANCE(488);
      END_STATE();
    case 332:
      if (lookahead == 'l') ADVANCE(489);
      END_STATE();
    case 333:
      if (lookahead == 'l') ADVANCE(490);
      END_STATE();
    case 334:
      if (lookahead == 'p') ADVANCE(491);
      END_STATE();
    case 335:
      if (lookahead == 't') ADVANCE(418);
      END_STATE();
    case 336:
      if (lookahead == 'n') ADVANCE(419);
      END_STATE();
    case 337:
      if (lookahead == 'e') ADVANCE(492);
      END_STATE();
    case 338:
      if (lookahead == 'n') ADVANCE(493);
      END_STATE();
    case 339:
      if (lookahead == 'e') ADVANCE(422);
      END_STATE();
    case 340:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 341:
      if (lookahead == 'o') ADVANCE(494);
      END_STATE();
    case 342:
      if (lookahead == 'a') ADVANCE(495);
      END_STATE();
    case 343:
      if (lookahead == 'n') ADVANCE(496);
      END_STATE();
    case 344:
      if (lookahead == 'd') ADVANCE(427);
      END_STATE();
    case 345:
      if (lookahead == 'u') ADVANCE(497);
      END_STATE();
    case 346:
      if (lookahead == 'c') ADVANCE(498);
      if (lookahead == 'y') ADVANCE(499);
      END_STATE();
    case 347:
      if (lookahead == 'w') ADVANCE(431);
      END_STATE();
    case 348:
      if (lookahead == 'n') ADVANCE(432);
      if (lookahead == 'r') ADVANCE(500);
      END_STATE();
    case 349:
      if (lookahead == 'h') ADVANCE(501);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(435);
      END_STATE();
    case 351:
      if (lookahead == 'R') ADVANCE(502);
      END_STATE();
    case 352:
      if (lookahead == '_') ADVANCE(503);
      END_STATE();
    case 353:
      if (lookahead == 'N') ADVANCE(504);
      END_STATE();
    case 354:
      if (lookahead == 'N') ADVANCE(505);
      END_STATE();
    case 355:
      if (lookahead == 'E') ADVANCE(506);
      END_STATE();
    case 356:
      if (lookahead == 'E') ADVANCE(507);
      END_STATE();
    case 357:
      if (lookahead == 'D') ADVANCE(508);
      END_STATE();
    case 358:
      if (lookahead == 'D') ADVANCE(509);
      END_STATE();
    case 359:
      if (lookahead == 'A') ADVANCE(510);
      END_STATE();
    case 360:
      if (lookahead == 'A') ADVANCE(511);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_keyword_case);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym_keyword_char_token1);
      if (lookahead == 'A') ADVANCE(512);
      END_STATE();
    case 363:
      if (lookahead == 'M') ADVANCE(513);
      END_STATE();
    case 364:
      if (lookahead == 'I') ADVANCE(514);
      END_STATE();
    case 365:
      if (lookahead == 'T') ADVANCE(515);
      END_STATE();
    case 366:
      if (lookahead == 'T') ADVANCE(516);
      END_STATE();
    case 367:
      if (lookahead == 'T') ADVANCE(517);
      END_STATE();
    case 368:
      if (lookahead == 'S') ADVANCE(518);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_keyword_data);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_keyword_date);
      if (lookahead == 'T') ADVANCE(519);
      END_STATE();
    case 371:
      if (lookahead == 'M') ADVANCE(520);
      END_STATE();
    case 372:
      if (lookahead == 'U') ADVANCE(521);
      END_STATE();
    case 373:
      if (lookahead == 'T') ADVANCE(522);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_keyword_desc);
      END_STATE();
    case 375:
      if (lookahead == 'I') ADVANCE(523);
      END_STATE();
    case 376:
      if (lookahead == 'L') ADVANCE(524);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_keyword_drop);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_keyword_else);
      END_STATE();
    case 379:
      if (lookahead == 'P') ADVANCE(525);
      END_STATE();
    case 380:
      if (lookahead == 'T') ADVANCE(526);
      END_STATE();
    case 381:
      if (lookahead == 'E') ADVANCE(527);
      END_STATE();
    case 382:
      if (lookahead == 'E') ADVANCE(528);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_keyword_from);
      END_STATE();
    case 384:
      if (lookahead == 'R') ADVANCE(529);
      END_STATE();
    case 385:
      if (lookahead == 'E') ADVANCE(530);
      END_STATE();
    case 386:
      if (lookahead == 'N') ADVANCE(531);
      END_STATE();
    case 387:
      if (lookahead == 'X') ADVANCE(532);
      END_STATE();
    case 388:
      if (lookahead == 'R') ADVANCE(533);
      END_STATE();
    case 389:
      if (lookahead == 'R') ADVANCE(534);
      END_STATE();
    case 390:
      if (lookahead == 'G') ADVANCE(535);
      if (lookahead == 'R') ADVANCE(536);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_keyword_into);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_keyword_join);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_keyword_json);
      if (lookahead == 'B') ADVANCE(537);
      END_STATE();
    case 394:
      if (lookahead == 'R') ADVANCE(538);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_keyword_left);
      END_STATE();
    case 396:
      if (lookahead == 'T') ADVANCE(539);
      END_STATE();
    case 397:
      if (lookahead == 'R') ADVANCE(540);
      END_STATE();
    case 398:
      if (lookahead == 'Y') ADVANCE(541);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_keyword_null);
      END_STATE();
    case 400:
      if (lookahead == 'R') ADVANCE(542);
      END_STATE();
    case 401:
      if (lookahead == 'E') ADVANCE(543);
      END_STATE();
    case 402:
      if (lookahead == 'R') ADVANCE(544);
      END_STATE();
    case 403:
      if (lookahead == 'R') ADVANCE(545);
      END_STATE();
    case 404:
      if (lookahead == 'I') ADVANCE(546);
      END_STATE();
    case 405:
      if (lookahead == 'A') ADVANCE(547);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_keyword_real);
      END_STATE();
    case 407:
      if (lookahead == 'M') ADVANCE(548);
      END_STATE();
    case 408:
      if (lookahead == 'A') ADVANCE(549);
      END_STATE();
    case 409:
      if (lookahead == 'R') ADVANCE(550);
      END_STATE();
    case 410:
      if (lookahead == 'T') ADVANCE(551);
      END_STATE();
    case 411:
      if (lookahead == 'B') ADVANCE(552);
      END_STATE();
    case 412:
      if (lookahead == 'M') ADVANCE(553);
      END_STATE();
    case 413:
      if (lookahead == 'C') ADVANCE(554);
      END_STATE();
    case 414:
      if (lookahead == 'A') ADVANCE(555);
      END_STATE();
    case 415:
      if (lookahead == 'L') ADVANCE(556);
      END_STATE();
    case 416:
      if (lookahead == 'E') ADVANCE(557);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_keyword_temp);
      if (lookahead == 'O') ADVANCE(558);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_keyword_text);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_keyword_then);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(aux_sym_keyword_timestamp_token3);
      if (lookahead == 'S') ADVANCE(559);
      END_STATE();
    case 421:
      if (lookahead == 'S') ADVANCE(560);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym_keyword_true);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym_keyword_type);
      END_STATE();
    case 424:
      if (lookahead == 'N') ADVANCE(561);
      END_STATE();
    case 425:
      if (lookahead == 'T') ADVANCE(562);
      END_STATE();
    case 426:
      if (lookahead == 'G') ADVANCE(563);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_keyword_uuid);
      END_STATE();
    case 428:
      if (lookahead == 'E') ADVANCE(564);
      END_STATE();
    case 429:
      if (lookahead == 'H') ADVANCE(565);
      END_STATE();
    case 430:
      if (lookahead == 'I') ADVANCE(566);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(sym_keyword_view);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(sym_keyword_when);
      END_STATE();
    case 433:
      if (lookahead == 'E') ADVANCE(567);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(aux_sym_keyword_with_token1);
      if (lookahead == 'O') ADVANCE(568);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(aux_sym_keyword_timestamp_token4);
      END_STATE();
    case 436:
      if (lookahead == 'r') ADVANCE(502);
      END_STATE();
    case 437:
      if (lookahead == '_') ADVANCE(569);
      END_STATE();
    case 438:
      if (lookahead == 'n') ADVANCE(504);
      END_STATE();
    case 439:
      if (lookahead == 'n') ADVANCE(570);
      END_STATE();
    case 440:
      if (lookahead == 'e') ADVANCE(571);
      END_STATE();
    case 441:
      if (lookahead == 'e') ADVANCE(572);
      END_STATE();
    case 442:
      if (lookahead == 'd') ADVANCE(508);
      END_STATE();
    case 443:
      if (lookahead == 'd') ADVANCE(509);
      END_STATE();
    case 444:
      if (lookahead == 'a') ADVANCE(510);
      END_STATE();
    case 445:
      if (lookahead == 'a') ADVANCE(573);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(aux_sym_keyword_char_token1);
      if (lookahead == 'a') ADVANCE(574);
      END_STATE();
    case 447:
      if (lookahead == 'm') ADVANCE(575);
      END_STATE();
    case 448:
      if (lookahead == 'i') ADVANCE(576);
      END_STATE();
    case 449:
      if (lookahead == 't') ADVANCE(577);
      END_STATE();
    case 450:
      if (lookahead == 't') ADVANCE(516);
      END_STATE();
    case 451:
      if (lookahead == 't') ADVANCE(578);
      END_STATE();
    case 452:
      if (lookahead == 's') ADVANCE(518);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym_keyword_date);
      if (lookahead == 't') ADVANCE(579);
      END_STATE();
    case 454:
      if (lookahead == 'm') ADVANCE(580);
      END_STATE();
    case 455:
      if (lookahead == 'u') ADVANCE(581);
      END_STATE();
    case 456:
      if (lookahead == 't') ADVANCE(582);
      END_STATE();
    case 457:
      if (lookahead == 'i') ADVANCE(583);
      END_STATE();
    case 458:
      if (lookahead == 'l') ADVANCE(584);
      END_STATE();
    case 459:
      if (lookahead == 'p') ADVANCE(585);
      END_STATE();
    case 460:
      if (lookahead == 't') ADVANCE(586);
      END_STATE();
    case 461:
      if (lookahead == 'e') ADVANCE(527);
      END_STATE();
    case 462:
      if (lookahead == 'e') ADVANCE(528);
      END_STATE();
    case 463:
      if (lookahead == 'r') ADVANCE(587);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(588);
      END_STATE();
    case 465:
      if (lookahead == 'n') ADVANCE(589);
      END_STATE();
    case 466:
      if (lookahead == 'x') ADVANCE(532);
      END_STATE();
    case 467:
      if (lookahead == 'r') ADVANCE(533);
      END_STATE();
    case 468:
      if (lookahead == 'r') ADVANCE(590);
      END_STATE();
    case 469:
      if (lookahead == 'g') ADVANCE(591);
      if (lookahead == 'r') ADVANCE(592);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_keyword_json);
      if (lookahead == 'b') ADVANCE(537);
      END_STATE();
    case 471:
      if (lookahead == 'r') ADVANCE(593);
      END_STATE();
    case 472:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 473:
      if (lookahead == 'r') ADVANCE(594);
      END_STATE();
    case 474:
      if (lookahead == 'y') ADVANCE(541);
      END_STATE();
    case 475:
      if (lookahead == 'r') ADVANCE(595);
      END_STATE();
    case 476:
      if (lookahead == 'e') ADVANCE(596);
      END_STATE();
    case 477:
      if (lookahead == 'r') ADVANCE(544);
      END_STATE();
    case 478:
      if (lookahead == 'r') ADVANCE(545);
      END_STATE();
    case 479:
      if (lookahead == 'i') ADVANCE(597);
      END_STATE();
    case 480:
      if (lookahead == 'a') ADVANCE(598);
      END_STATE();
    case 481:
      if (lookahead == 'm') ADVANCE(599);
      END_STATE();
    case 482:
      if (lookahead == 'a') ADVANCE(600);
      END_STATE();
    case 483:
      if (lookahead == 'r') ADVANCE(601);
      END_STATE();
    case 484:
      if (lookahead == 't') ADVANCE(551);
      END_STATE();
    case 485:
      if (lookahead == 'b') ADVANCE(602);
      END_STATE();
    case 486:
      if (lookahead == 'm') ADVANCE(603);
      END_STATE();
    case 487:
      if (lookahead == 'c') ADVANCE(604);
      END_STATE();
    case 488:
      if (lookahead == 'a') ADVANCE(605);
      END_STATE();
    case 489:
      if (lookahead == 'l') ADVANCE(606);
      END_STATE();
    case 490:
      if (lookahead == 'e') ADVANCE(557);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(sym_keyword_temp);
      if (lookahead == 'o') ADVANCE(607);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(aux_sym_keyword_timestamp_token3);
      if (lookahead == 's') ADVANCE(608);
      END_STATE();
    case 493:
      if (lookahead == 's') ADVANCE(609);
      END_STATE();
    case 494:
      if (lookahead == 'n') ADVANCE(561);
      END_STATE();
    case 495:
      if (lookahead == 't') ADVANCE(610);
      END_STATE();
    case 496:
      if (lookahead == 'g') ADVANCE(563);
      END_STATE();
    case 497:
      if (lookahead == 'e') ADVANCE(611);
      END_STATE();
    case 498:
      if (lookahead == 'h') ADVANCE(612);
      END_STATE();
    case 499:
      if (lookahead == 'i') ADVANCE(613);
      END_STATE();
    case 500:
      if (lookahead == 'e') ADVANCE(567);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(aux_sym_keyword_with_token1);
      if (lookahead == 'o') ADVANCE(614);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_keyword_alter);
      END_STATE();
    case 503:
      if (lookahead == 'I') ADVANCE(615);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_keyword_begin);
      END_STATE();
    case 505:
      if (lookahead == 'T') ADVANCE(616);
      END_STATE();
    case 506:
      if (lookahead == 'R') ADVANCE(617);
      END_STATE();
    case 507:
      if (lookahead == 'A') ADVANCE(618);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_keyword_box2d);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_keyword_box3d);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_keyword_bytea);
      END_STATE();
    case 511:
      if (lookahead == 'D') ADVANCE(619);
      END_STATE();
    case 512:
      if (lookahead == 'C') ADVANCE(620);
      END_STATE();
    case 513:
      if (lookahead == 'N') ADVANCE(621);
      END_STATE();
    case 514:
      if (lookahead == 'T') ADVANCE(622);
      END_STATE();
    case 515:
      if (lookahead == 'R') ADVANCE(623);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_keyword_count);
      END_STATE();
    case 517:
      if (lookahead == 'E') ADVANCE(624);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_keyword_cross);
      END_STATE();
    case 519:
      if (lookahead == 'I') ADVANCE(625);
      END_STATE();
    case 520:
      if (lookahead == 'A') ADVANCE(626);
      END_STATE();
    case 521:
      if (lookahead == 'L') ADVANCE(627);
      END_STATE();
    case 522:
      if (lookahead == 'E') ADVANCE(628);
      END_STATE();
    case 523:
      if (lookahead == 'N') ADVANCE(629);
      END_STATE();
    case 524:
      if (lookahead == 'E') ADVANCE(630);
      END_STATE();
    case 525:
      if (lookahead == 'T') ADVANCE(631);
      END_STATE();
    case 526:
      if (lookahead == 'S') ADVANCE(632);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(sym_keyword_false);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_keyword_force);
      END_STATE();
    case 529:
      if (lookahead == 'A') ADVANCE(633);
      END_STATE();
    case 530:
      if (lookahead == 'T') ADVANCE(634);
      END_STATE();
    case 531:
      if (lookahead == 'G') ADVANCE(635);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_keyword_index);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_keyword_inner);
      END_STATE();
    case 534:
      if (lookahead == 'T') ADVANCE(636);
      END_STATE();
    case 535:
      if (lookahead == 'E') ADVANCE(637);
      END_STATE();
    case 536:
      if (lookahead == 'S') ADVANCE(638);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_keyword_jsonb);
      END_STATE();
    case 538:
      if (lookahead == 'A') ADVANCE(639);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_keyword_limit);
      END_STATE();
    case 540:
      if (lookahead == 'I') ADVANCE(640);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_keyword_money);
      END_STATE();
    case 542:
      if (lookahead == 'I') ADVANCE(641);
      END_STATE();
    case 543:
      if (lookahead == 'T') ADVANCE(642);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_keyword_outer);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_keyword_owner);
      END_STATE();
    case 546:
      if (lookahead == 'S') ADVANCE(643);
      END_STATE();
    case 547:
      if (lookahead == 'R') ADVANCE(644);
      END_STATE();
    case 548:
      if (lookahead == 'E') ADVANCE(645);
      END_STATE();
    case 549:
      if (lookahead == 'C') ADVANCE(646);
      END_STATE();
    case 550:
      if (lookahead == 'N') ADVANCE(647);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_keyword_right);
      END_STATE();
    case 552:
      if (lookahead == 'A') ADVANCE(648);
      END_STATE();
    case 553:
      if (lookahead == 'A') ADVANCE(649);
      END_STATE();
    case 554:
      if (lookahead == 'T') ADVANCE(650);
      END_STATE();
    case 555:
      if (lookahead == 'L') ADVANCE(651);
      END_STATE();
    case 556:
      if (lookahead == 'I') ADVANCE(652);
      if (lookahead == 'S') ADVANCE(653);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_keyword_table);
      END_STATE();
    case 558:
      if (lookahead == 'R') ADVANCE(654);
      END_STATE();
    case 559:
      if (lookahead == 'T') ADVANCE(655);
      END_STATE();
    case 560:
      if (lookahead == 'A') ADVANCE(656);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_keyword_union);
      END_STATE();
    case 562:
      if (lookahead == 'E') ADVANCE(657);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_keyword_using);
      END_STATE();
    case 564:
      if (lookahead == 'S') ADVANCE(658);
      END_STATE();
    case 565:
      if (lookahead == 'A') ADVANCE(659);
      END_STATE();
    case 566:
      if (lookahead == 'N') ADVANCE(660);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_keyword_where);
      END_STATE();
    case 568:
      if (lookahead == 'U') ADVANCE(661);
      END_STATE();
    case 569:
      if (lookahead == 'i') ADVANCE(662);
      END_STATE();
    case 570:
      if (lookahead == 't') ADVANCE(616);
      END_STATE();
    case 571:
      if (lookahead == 'r') ADVANCE(663);
      END_STATE();
    case 572:
      if (lookahead == 'a') ADVANCE(664);
      END_STATE();
    case 573:
      if (lookahead == 'd') ADVANCE(665);
      END_STATE();
    case 574:
      if (lookahead == 'c') ADVANCE(666);
      END_STATE();
    case 575:
      if (lookahead == 'n') ADVANCE(621);
      END_STATE();
    case 576:
      if (lookahead == 't') ADVANCE(622);
      END_STATE();
    case 577:
      if (lookahead == 'r') ADVANCE(667);
      END_STATE();
    case 578:
      if (lookahead == 'e') ADVANCE(624);
      END_STATE();
    case 579:
      if (lookahead == 'i') ADVANCE(668);
      END_STATE();
    case 580:
      if (lookahead == 'a') ADVANCE(669);
      END_STATE();
    case 581:
      if (lookahead == 'l') ADVANCE(670);
      END_STATE();
    case 582:
      if (lookahead == 'e') ADVANCE(628);
      END_STATE();
    case 583:
      if (lookahead == 'n') ADVANCE(671);
      END_STATE();
    case 584:
      if (lookahead == 'e') ADVANCE(630);
      END_STATE();
    case 585:
      if (lookahead == 't') ADVANCE(631);
      END_STATE();
    case 586:
      if (lookahead == 's') ADVANCE(632);
      END_STATE();
    case 587:
      if (lookahead == 'a') ADVANCE(672);
      END_STATE();
    case 588:
      if (lookahead == 't') ADVANCE(673);
      END_STATE();
    case 589:
      if (lookahead == 'g') ADVANCE(635);
      END_STATE();
    case 590:
      if (lookahead == 't') ADVANCE(636);
      END_STATE();
    case 591:
      if (lookahead == 'e') ADVANCE(674);
      END_STATE();
    case 592:
      if (lookahead == 's') ADVANCE(675);
      END_STATE();
    case 593:
      if (lookahead == 'a') ADVANCE(676);
      END_STATE();
    case 594:
      if (lookahead == 'i') ADVANCE(677);
      END_STATE();
    case 595:
      if (lookahead == 'i') ADVANCE(678);
      END_STATE();
    case 596:
      if (lookahead == 't') ADVANCE(642);
      END_STATE();
    case 597:
      if (lookahead == 's') ADVANCE(679);
      END_STATE();
    case 598:
      if (lookahead == 'r') ADVANCE(680);
      END_STATE();
    case 599:
      if (lookahead == 'e') ADVANCE(645);
      END_STATE();
    case 600:
      if (lookahead == 'c') ADVANCE(681);
      END_STATE();
    case 601:
      if (lookahead == 'n') ADVANCE(682);
      END_STATE();
    case 602:
      if (lookahead == 'a') ADVANCE(683);
      END_STATE();
    case 603:
      if (lookahead == 'a') ADVANCE(649);
      END_STATE();
    case 604:
      if (lookahead == 't') ADVANCE(650);
      END_STATE();
    case 605:
      if (lookahead == 'l') ADVANCE(651);
      END_STATE();
    case 606:
      if (lookahead == 'i') ADVANCE(684);
      if (lookahead == 's') ADVANCE(685);
      END_STATE();
    case 607:
      if (lookahead == 'r') ADVANCE(686);
      END_STATE();
    case 608:
      if (lookahead == 't') ADVANCE(687);
      END_STATE();
    case 609:
      if (lookahead == 'a') ADVANCE(688);
      END_STATE();
    case 610:
      if (lookahead == 'e') ADVANCE(657);
      END_STATE();
    case 611:
      if (lookahead == 's') ADVANCE(658);
      END_STATE();
    case 612:
      if (lookahead == 'a') ADVANCE(689);
      END_STATE();
    case 613:
      if (lookahead == 'n') ADVANCE(690);
      END_STATE();
    case 614:
      if (lookahead == 'u') ADVANCE(691);
      END_STATE();
    case 615:
      if (lookahead == 'N') ADVANCE(692);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_keyword_bigint);
      END_STATE();
    case 617:
      if (lookahead == 'I') ADVANCE(693);
      END_STATE();
    case 618:
      if (lookahead == 'N') ADVANCE(694);
      END_STATE();
    case 619:
      if (lookahead == 'E') ADVANCE(695);
      END_STATE();
    case 620:
      if (lookahead == 'T') ADVANCE(696);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_keyword_column);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_keyword_commit);
      END_STATE();
    case 623:
      if (lookahead == 'A') ADVANCE(697);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_keyword_create);
      END_STATE();
    case 625:
      if (lookahead == 'M') ADVANCE(698);
      END_STATE();
    case 626:
      if (lookahead == 'L') ADVANCE(699);
      END_STATE();
    case 627:
      if (lookahead == 'T') ADVANCE(700);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_keyword_delete);
      END_STATE();
    case 629:
      if (lookahead == 'C') ADVANCE(701);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(aux_sym_double_token1);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_keyword_except);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_keyword_exists);
      END_STATE();
    case 633:
      if (lookahead == 'P') ADVANCE(702);
      END_STATE();
    case 634:
      if (lookahead == 'R') ADVANCE(703);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_keyword_having);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_keyword_insert);
      END_STATE();
    case 637:
      if (lookahead == 'R') ADVANCE(704);
      END_STATE();
    case 638:
      if (lookahead == 'E') ADVANCE(705);
      END_STATE();
    case 639:
      if (lookahead == 'L') ADVANCE(706);
      END_STATE();
    case 640:
      if (lookahead == 'A') ADVANCE(707);
      END_STATE();
    case 641:
      if (lookahead == 'C') ADVANCE(708);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_keyword_offset);
      END_STATE();
    case 643:
      if (lookahead == 'I') ADVANCE(709);
      END_STATE();
    case 644:
      if (lookahead == 'Y') ADVANCE(710);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_keyword_rename);
      END_STATE();
    case 646:
      if (lookahead == 'E') ADVANCE(711);
      END_STATE();
    case 647:
      if (lookahead == 'I') ADVANCE(712);
      END_STATE();
    case 648:
      if (lookahead == 'C') ADVANCE(713);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_keyword_schema);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_keyword_select);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_keyword_serial);
      END_STATE();
    case 652:
      if (lookahead == 'N') ADVANCE(714);
      END_STATE();
    case 653:
      if (lookahead == 'E') ADVANCE(715);
      END_STATE();
    case 654:
      if (lookahead == 'A') ADVANCE(716);
      END_STATE();
    case 655:
      if (lookahead == 'A') ADVANCE(717);
      END_STATE();
    case 656:
      if (lookahead == 'C') ADVANCE(718);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_keyword_update);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_keyword_values);
      END_STATE();
    case 659:
      if (lookahead == 'R') ADVANCE(719);
      END_STATE();
    case 660:
      if (lookahead == 'G') ADVANCE(720);
      END_STATE();
    case 661:
      if (lookahead == 'T') ADVANCE(721);
      END_STATE();
    case 662:
      if (lookahead == 'n') ADVANCE(722);
      END_STATE();
    case 663:
      if (lookahead == 'i') ADVANCE(723);
      END_STATE();
    case 664:
      if (lookahead == 'n') ADVANCE(694);
      END_STATE();
    case 665:
      if (lookahead == 'e') ADVANCE(695);
      END_STATE();
    case 666:
      if (lookahead == 't') ADVANCE(724);
      END_STATE();
    case 667:
      if (lookahead == 'a') ADVANCE(725);
      END_STATE();
    case 668:
      if (lookahead == 'm') ADVANCE(726);
      END_STATE();
    case 669:
      if (lookahead == 'l') ADVANCE(699);
      END_STATE();
    case 670:
      if (lookahead == 't') ADVANCE(700);
      END_STATE();
    case 671:
      if (lookahead == 'c') ADVANCE(727);
      END_STATE();
    case 672:
      if (lookahead == 'p') ADVANCE(728);
      END_STATE();
    case 673:
      if (lookahead == 'r') ADVANCE(729);
      END_STATE();
    case 674:
      if (lookahead == 'r') ADVANCE(704);
      END_STATE();
    case 675:
      if (lookahead == 'e') ADVANCE(730);
      END_STATE();
    case 676:
      if (lookahead == 'l') ADVANCE(706);
      END_STATE();
    case 677:
      if (lookahead == 'a') ADVANCE(731);
      END_STATE();
    case 678:
      if (lookahead == 'c') ADVANCE(708);
      END_STATE();
    case 679:
      if (lookahead == 'i') ADVANCE(732);
      END_STATE();
    case 680:
      if (lookahead == 'y') ADVANCE(710);
      END_STATE();
    case 681:
      if (lookahead == 'e') ADVANCE(711);
      END_STATE();
    case 682:
      if (lookahead == 'i') ADVANCE(733);
      END_STATE();
    case 683:
      if (lookahead == 'c') ADVANCE(734);
      END_STATE();
    case 684:
      if (lookahead == 'n') ADVANCE(735);
      END_STATE();
    case 685:
      if (lookahead == 'e') ADVANCE(736);
      END_STATE();
    case 686:
      if (lookahead == 'a') ADVANCE(737);
      END_STATE();
    case 687:
      if (lookahead == 'a') ADVANCE(738);
      END_STATE();
    case 688:
      if (lookahead == 'c') ADVANCE(739);
      END_STATE();
    case 689:
      if (lookahead == 'r') ADVANCE(719);
      END_STATE();
    case 690:
      if (lookahead == 'g') ADVANCE(720);
      END_STATE();
    case 691:
      if (lookahead == 't') ADVANCE(721);
      END_STATE();
    case 692:
      if (lookahead == 'C') ADVANCE(740);
      END_STATE();
    case 693:
      if (lookahead == 'A') ADVANCE(741);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym_keyword_boolean);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym_keyword_cascade);
      END_STATE();
    case 696:
      if (lookahead == 'E') ADVANCE(742);
      END_STATE();
    case 697:
      if (lookahead == 'I') ADVANCE(743);
      END_STATE();
    case 698:
      if (lookahead == 'E') ADVANCE(744);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym_keyword_decimal);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym_keyword_default);
      END_STATE();
    case 701:
      if (lookahead == 'T') ADVANCE(745);
      END_STATE();
    case 702:
      if (lookahead == 'H') ADVANCE(746);
      END_STATE();
    case 703:
      if (lookahead == 'Y') ADVANCE(747);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(aux_sym_keyword_int_token2);
      END_STATE();
    case 705:
      if (lookahead == 'C') ADVANCE(748);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_keyword_lateral);
      END_STATE();
    case 707:
      if (lookahead == 'L') ADVANCE(749);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym_keyword_numeric);
      END_STATE();
    case 709:
      if (lookahead == 'O') ADVANCE(750);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym_keyword_primary);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_keyword_replace);
      END_STATE();
    case 712:
      if (lookahead == 'N') ADVANCE(751);
      END_STATE();
    case 713:
      if (lookahead == 'K') ADVANCE(752);
      END_STATE();
    case 714:
      if (lookahead == 'T') ADVANCE(753);
      END_STATE();
    case 715:
      if (lookahead == 'R') ADVANCE(754);
      END_STATE();
    case 716:
      if (lookahead == 'R') ADVANCE(755);
      END_STATE();
    case 717:
      if (lookahead == 'M') ADVANCE(756);
      END_STATE();
    case 718:
      if (lookahead == 'T') ADVANCE(757);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(aux_sym_keyword_varchar_token1);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(aux_sym_keyword_varchar_token2);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(aux_sym_keyword_timestamp_token2);
      END_STATE();
    case 722:
      if (lookahead == 'c') ADVANCE(758);
      END_STATE();
    case 723:
      if (lookahead == 'a') ADVANCE(759);
      END_STATE();
    case 724:
      if (lookahead == 'e') ADVANCE(760);
      END_STATE();
    case 725:
      if (lookahead == 'i') ADVANCE(761);
      END_STATE();
    case 726:
      if (lookahead == 'e') ADVANCE(744);
      END_STATE();
    case 727:
      if (lookahead == 't') ADVANCE(745);
      END_STATE();
    case 728:
      if (lookahead == 'h') ADVANCE(762);
      END_STATE();
    case 729:
      if (lookahead == 'y') ADVANCE(747);
      END_STATE();
    case 730:
      if (lookahead == 'c') ADVANCE(763);
      END_STATE();
    case 731:
      if (lookahead == 'l') ADVANCE(764);
      END_STATE();
    case 732:
      if (lookahead == 'o') ADVANCE(765);
      END_STATE();
    case 733:
      if (lookahead == 'n') ADVANCE(766);
      END_STATE();
    case 734:
      if (lookahead == 'k') ADVANCE(752);
      END_STATE();
    case 735:
      if (lookahead == 't') ADVANCE(753);
      END_STATE();
    case 736:
      if (lookahead == 'r') ADVANCE(767);
      END_STATE();
    case 737:
      if (lookahead == 'r') ADVANCE(768);
      END_STATE();
    case 738:
      if (lookahead == 'm') ADVANCE(769);
      END_STATE();
    case 739:
      if (lookahead == 't') ADVANCE(770);
      END_STATE();
    case 740:
      if (lookahead == 'R') ADVANCE(771);
      END_STATE();
    case 741:
      if (lookahead == 'L') ADVANCE(772);
      END_STATE();
    case 742:
      if (lookahead == 'R') ADVANCE(773);
      END_STATE();
    case 743:
      if (lookahead == 'N') ADVANCE(774);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_keyword_datetime);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_keyword_distinct);
      END_STATE();
    case 746:
      if (lookahead == 'Y') ADVANCE(775);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym_keyword_geometry);
      END_STATE();
    case 748:
      if (lookahead == 'T') ADVANCE(776);
      END_STATE();
    case 749:
      if (lookahead == 'I') ADVANCE(777);
      END_STATE();
    case 750:
      if (lookahead == 'N') ADVANCE(778);
      END_STATE();
    case 751:
      if (lookahead == 'G') ADVANCE(779);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym_keyword_rollback);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(sym_keyword_smallint);
      END_STATE();
    case 754:
      if (lookahead == 'I') ADVANCE(780);
      END_STATE();
    case 755:
      if (lookahead == 'Y') ADVANCE(781);
      END_STATE();
    case 756:
      if (lookahead == 'P') ADVANCE(782);
      END_STATE();
    case 757:
      if (lookahead == 'I') ADVANCE(783);
      END_STATE();
    case 758:
      if (lookahead == 'r') ADVANCE(784);
      END_STATE();
    case 759:
      if (lookahead == 'l') ADVANCE(772);
      END_STATE();
    case 760:
      if (lookahead == 'r') ADVANCE(773);
      END_STATE();
    case 761:
      if (lookahead == 'n') ADVANCE(785);
      END_STATE();
    case 762:
      if (lookahead == 'y') ADVANCE(775);
      END_STATE();
    case 763:
      if (lookahead == 't') ADVANCE(776);
      END_STATE();
    case 764:
      if (lookahead == 'i') ADVANCE(786);
      END_STATE();
    case 765:
      if (lookahead == 'n') ADVANCE(778);
      END_STATE();
    case 766:
      if (lookahead == 'g') ADVANCE(779);
      END_STATE();
    case 767:
      if (lookahead == 'i') ADVANCE(787);
      END_STATE();
    case 768:
      if (lookahead == 'y') ADVANCE(781);
      END_STATE();
    case 769:
      if (lookahead == 'p') ADVANCE(788);
      END_STATE();
    case 770:
      if (lookahead == 'i') ADVANCE(789);
      END_STATE();
    case 771:
      if (lookahead == 'E') ADVANCE(790);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(sym_keyword_bigserial);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(aux_sym_keyword_char_token2);
      END_STATE();
    case 774:
      if (lookahead == 'T') ADVANCE(791);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_keyword_geography);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_keyword_intersect);
      END_STATE();
    case 777:
      if (lookahead == 'Z') ADVANCE(792);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(aux_sym_double_token2);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_keyword_returning);
      END_STATE();
    case 780:
      if (lookahead == 'A') ADVANCE(793);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_keyword_temporary);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(aux_sym_keyword_timestamp_token1);
      if (lookahead == 'T') ADVANCE(794);
      END_STATE();
    case 783:
      if (lookahead == 'O') ADVANCE(795);
      END_STATE();
    case 784:
      if (lookahead == 'e') ADVANCE(796);
      END_STATE();
    case 785:
      if (lookahead == 't') ADVANCE(791);
      END_STATE();
    case 786:
      if (lookahead == 'z') ADVANCE(797);
      END_STATE();
    case 787:
      if (lookahead == 'a') ADVANCE(798);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(aux_sym_keyword_timestamp_token1);
      if (lookahead == 't') ADVANCE(799);
      END_STATE();
    case 789:
      if (lookahead == 'o') ADVANCE(800);
      END_STATE();
    case 790:
      if (lookahead == 'M') ADVANCE(801);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(sym_keyword_constraint);
      END_STATE();
    case 792:
      if (lookahead == 'E') ADVANCE(802);
      END_STATE();
    case 793:
      if (lookahead == 'L') ADVANCE(803);
      END_STATE();
    case 794:
      if (lookahead == 'Z') ADVANCE(804);
      END_STATE();
    case 795:
      if (lookahead == 'N') ADVANCE(805);
      END_STATE();
    case 796:
      if (lookahead == 'm') ADVANCE(806);
      END_STATE();
    case 797:
      if (lookahead == 'e') ADVANCE(807);
      END_STATE();
    case 798:
      if (lookahead == 'l') ADVANCE(803);
      END_STATE();
    case 799:
      if (lookahead == 'z') ADVANCE(804);
      END_STATE();
    case 800:
      if (lookahead == 'n') ADVANCE(805);
      END_STATE();
    case 801:
      if (lookahead == 'E') ADVANCE(808);
      END_STATE();
    case 802:
      if (lookahead == 'D') ADVANCE(809);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym_keyword_smallserial);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(aux_sym_keyword_timestamptz_token1);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym_keyword_transaction);
      END_STATE();
    case 806:
      if (lookahead == 'e') ADVANCE(810);
      END_STATE();
    case 807:
      if (lookahead == 'd') ADVANCE(809);
      END_STATE();
    case 808:
      if (lookahead == 'N') ADVANCE(811);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym_keyword_materialized);
      END_STATE();
    case 810:
      if (lookahead == 'n') ADVANCE(812);
      END_STATE();
    case 811:
      if (lookahead == 'T') ADVANCE(813);
      END_STATE();
    case 812:
      if (lookahead == 't') ADVANCE(813);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym_keyword_auto_increment);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 24},
  [2] = {.lex_state = 6},
  [3] = {.lex_state = 6},
  [4] = {.lex_state = 2},
  [5] = {.lex_state = 2},
  [6] = {.lex_state = 24},
  [7] = {.lex_state = 24},
  [8] = {.lex_state = 24},
  [9] = {.lex_state = 24},
  [10] = {.lex_state = 24},
  [11] = {.lex_state = 24},
  [12] = {.lex_state = 24},
  [13] = {.lex_state = 0},
  [14] = {.lex_state = 0},
  [15] = {.lex_state = 0},
  [16] = {.lex_state = 24},
  [17] = {.lex_state = 0},
  [18] = {.lex_state = 0},
  [19] = {.lex_state = 0},
  [20] = {.lex_state = 0},
  [21] = {.lex_state = 0},
  [22] = {.lex_state = 0},
  [23] = {.lex_state = 0},
  [24] = {.lex_state = 0},
  [25] = {.lex_state = 0},
  [26] = {.lex_state = 0},
  [27] = {.lex_state = 0},
  [28] = {.lex_state = 0},
  [29] = {.lex_state = 0},
  [30] = {.lex_state = 0},
  [31] = {.lex_state = 0},
  [32] = {.lex_state = 0},
  [33] = {.lex_state = 0},
  [34] = {.lex_state = 0},
  [35] = {.lex_state = 0},
  [36] = {.lex_state = 0},
  [37] = {.lex_state = 0},
  [38] = {.lex_state = 0},
  [39] = {.lex_state = 0},
  [40] = {.lex_state = 0},
  [41] = {.lex_state = 0},
  [42] = {.lex_state = 0},
  [43] = {.lex_state = 0},
  [44] = {.lex_state = 0},
  [45] = {.lex_state = 0},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 0},
  [48] = {.lex_state = 0},
  [49] = {.lex_state = 0},
  [50] = {.lex_state = 0},
  [51] = {.lex_state = 0},
  [52] = {.lex_state = 0},
  [53] = {.lex_state = 0},
  [54] = {.lex_state = 0},
  [55] = {.lex_state = 0},
  [56] = {.lex_state = 0},
  [57] = {.lex_state = 0},
  [58] = {.lex_state = 0},
  [59] = {.lex_state = 0},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 0},
  [63] = {.lex_state = 0},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 0},
  [66] = {.lex_state = 0},
  [67] = {.lex_state = 0},
  [68] = {.lex_state = 0},
  [69] = {.lex_state = 2},
  [70] = {.lex_state = 2},
  [71] = {.lex_state = 2},
  [72] = {.lex_state = 2},
  [73] = {.lex_state = 2},
  [74] = {.lex_state = 2},
  [75] = {.lex_state = 2},
  [76] = {.lex_state = 2},
  [77] = {.lex_state = 2},
  [78] = {.lex_state = 2},
  [79] = {.lex_state = 2},
  [80] = {.lex_state = 2},
  [81] = {.lex_state = 2},
  [82] = {.lex_state = 2},
  [83] = {.lex_state = 2},
  [84] = {.lex_state = 2},
  [85] = {.lex_state = 2},
  [86] = {.lex_state = 2},
  [87] = {.lex_state = 2},
  [88] = {.lex_state = 2},
  [89] = {.lex_state = 2},
  [90] = {.lex_state = 2},
  [91] = {.lex_state = 2},
  [92] = {.lex_state = 24},
  [93] = {.lex_state = 2},
  [94] = {.lex_state = 0},
  [95] = {.lex_state = 2},
  [96] = {.lex_state = 2},
  [97] = {.lex_state = 2},
  [98] = {.lex_state = 2},
  [99] = {.lex_state = 2},
  [100] = {.lex_state = 2},
  [101] = {.lex_state = 2},
  [102] = {.lex_state = 2},
  [103] = {.lex_state = 2},
  [104] = {.lex_state = 2},
  [105] = {.lex_state = 2},
  [106] = {.lex_state = 2},
  [107] = {.lex_state = 2},
  [108] = {.lex_state = 2},
  [109] = {.lex_state = 2},
  [110] = {.lex_state = 2},
  [111] = {.lex_state = 2},
  [112] = {.lex_state = 2},
  [113] = {.lex_state = 2},
  [114] = {.lex_state = 2},
  [115] = {.lex_state = 2},
  [116] = {.lex_state = 2},
  [117] = {.lex_state = 2},
  [118] = {.lex_state = 2},
  [119] = {.lex_state = 2},
  [120] = {.lex_state = 0},
  [121] = {.lex_state = 2},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 2},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 24},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 2},
  [128] = {.lex_state = 2},
  [129] = {.lex_state = 2},
  [130] = {.lex_state = 2},
  [131] = {.lex_state = 2},
  [132] = {.lex_state = 2},
  [133] = {.lex_state = 2},
  [134] = {.lex_state = 2},
  [135] = {.lex_state = 2},
  [136] = {.lex_state = 2},
  [137] = {.lex_state = 0},
  [138] = {.lex_state = 2},
  [139] = {.lex_state = 2},
  [140] = {.lex_state = 2},
  [141] = {.lex_state = 2},
  [142] = {.lex_state = 2},
  [143] = {.lex_state = 2},
  [144] = {.lex_state = 2},
  [145] = {.lex_state = 2},
  [146] = {.lex_state = 2},
  [147] = {.lex_state = 2},
  [148] = {.lex_state = 2},
  [149] = {.lex_state = 2},
  [150] = {.lex_state = 2},
  [151] = {.lex_state = 0},
  [152] = {.lex_state = 2},
  [153] = {.lex_state = 2},
  [154] = {.lex_state = 2},
  [155] = {.lex_state = 2},
  [156] = {.lex_state = 2},
  [157] = {.lex_state = 2},
  [158] = {.lex_state = 2},
  [159] = {.lex_state = 2},
  [160] = {.lex_state = 2},
  [161] = {.lex_state = 2},
  [162] = {.lex_state = 2},
  [163] = {.lex_state = 2},
  [164] = {.lex_state = 2},
  [165] = {.lex_state = 2},
  [166] = {.lex_state = 24},
  [167] = {.lex_state = 2},
  [168] = {.lex_state = 2},
  [169] = {.lex_state = 2},
  [170] = {.lex_state = 24},
  [171] = {.lex_state = 24},
  [172] = {.lex_state = 0},
  [173] = {.lex_state = 2},
  [174] = {.lex_state = 2},
  [175] = {.lex_state = 2},
  [176] = {.lex_state = 2},
  [177] = {.lex_state = 2},
  [178] = {.lex_state = 2},
  [179] = {.lex_state = 2},
  [180] = {.lex_state = 2},
  [181] = {.lex_state = 2},
  [182] = {.lex_state = 2},
  [183] = {.lex_state = 2},
  [184] = {.lex_state = 0},
  [185] = {.lex_state = 0},
  [186] = {.lex_state = 0},
  [187] = {.lex_state = 0},
  [188] = {.lex_state = 0},
  [189] = {.lex_state = 0},
  [190] = {.lex_state = 0},
  [191] = {.lex_state = 0},
  [192] = {.lex_state = 0},
  [193] = {.lex_state = 24},
  [194] = {.lex_state = 0},
  [195] = {.lex_state = 0},
  [196] = {.lex_state = 0},
  [197] = {.lex_state = 0},
  [198] = {.lex_state = 0},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 0},
  [201] = {.lex_state = 0},
  [202] = {.lex_state = 0},
  [203] = {.lex_state = 0},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 0},
  [206] = {.lex_state = 0},
  [207] = {.lex_state = 0},
  [208] = {.lex_state = 0},
  [209] = {.lex_state = 0},
  [210] = {.lex_state = 0},
  [211] = {.lex_state = 0},
  [212] = {.lex_state = 0},
  [213] = {.lex_state = 0},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 0},
  [216] = {.lex_state = 0},
  [217] = {.lex_state = 0},
  [218] = {.lex_state = 0},
  [219] = {.lex_state = 0},
  [220] = {.lex_state = 0},
  [221] = {.lex_state = 0},
  [222] = {.lex_state = 0},
  [223] = {.lex_state = 0},
  [224] = {.lex_state = 0},
  [225] = {.lex_state = 0},
  [226] = {.lex_state = 0},
  [227] = {.lex_state = 0},
  [228] = {.lex_state = 0},
  [229] = {.lex_state = 0},
  [230] = {.lex_state = 0},
  [231] = {.lex_state = 0},
  [232] = {.lex_state = 0},
  [233] = {.lex_state = 0},
  [234] = {.lex_state = 0},
  [235] = {.lex_state = 0},
  [236] = {.lex_state = 0},
  [237] = {.lex_state = 24},
  [238] = {.lex_state = 0},
  [239] = {.lex_state = 0},
  [240] = {.lex_state = 0},
  [241] = {.lex_state = 0},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 0},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 0},
  [256] = {.lex_state = 0},
  [257] = {.lex_state = 0},
  [258] = {.lex_state = 0},
  [259] = {.lex_state = 0},
  [260] = {.lex_state = 0},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 0},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 0},
  [268] = {.lex_state = 0},
  [269] = {.lex_state = 0},
  [270] = {.lex_state = 24},
  [271] = {.lex_state = 2},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 24},
  [274] = {.lex_state = 24},
  [275] = {.lex_state = 24},
  [276] = {.lex_state = 2},
  [277] = {.lex_state = 24},
  [278] = {.lex_state = 24},
  [279] = {.lex_state = 24},
  [280] = {.lex_state = 24},
  [281] = {.lex_state = 6},
  [282] = {.lex_state = 24},
  [283] = {.lex_state = 24},
  [284] = {.lex_state = 2},
  [285] = {.lex_state = 24},
  [286] = {.lex_state = 24},
  [287] = {.lex_state = 24},
  [288] = {.lex_state = 24},
  [289] = {.lex_state = 24},
  [290] = {.lex_state = 2},
  [291] = {.lex_state = 24},
  [292] = {.lex_state = 2},
  [293] = {.lex_state = 24},
  [294] = {.lex_state = 0},
  [295] = {.lex_state = 2},
  [296] = {.lex_state = 0},
  [297] = {.lex_state = 24},
  [298] = {.lex_state = 0},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 0},
  [301] = {.lex_state = 0},
  [302] = {.lex_state = 0},
  [303] = {.lex_state = 0},
  [304] = {.lex_state = 0},
  [305] = {.lex_state = 0},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 0},
  [308] = {.lex_state = 24},
  [309] = {.lex_state = 0},
  [310] = {.lex_state = 0},
  [311] = {.lex_state = 0},
  [312] = {.lex_state = 0},
  [313] = {.lex_state = 0},
  [314] = {.lex_state = 2},
  [315] = {.lex_state = 0},
  [316] = {.lex_state = 24},
  [317] = {.lex_state = 24},
  [318] = {.lex_state = 24},
  [319] = {.lex_state = 24},
  [320] = {.lex_state = 2},
  [321] = {.lex_state = 0},
  [322] = {.lex_state = 24},
  [323] = {.lex_state = 0},
  [324] = {.lex_state = 0},
  [325] = {.lex_state = 0},
  [326] = {.lex_state = 0},
  [327] = {.lex_state = 24},
  [328] = {.lex_state = 0},
  [329] = {.lex_state = 24},
  [330] = {.lex_state = 0},
  [331] = {.lex_state = 0},
  [332] = {.lex_state = 24},
  [333] = {.lex_state = 24},
  [334] = {.lex_state = 0},
  [335] = {.lex_state = 24},
  [336] = {.lex_state = 0},
  [337] = {.lex_state = 0},
  [338] = {.lex_state = 24},
  [339] = {.lex_state = 24},
  [340] = {.lex_state = 2},
  [341] = {.lex_state = 24},
  [342] = {.lex_state = 24},
  [343] = {.lex_state = 0},
  [344] = {.lex_state = 24},
  [345] = {.lex_state = 24},
  [346] = {.lex_state = 24},
  [347] = {.lex_state = 24},
  [348] = {.lex_state = 24},
  [349] = {.lex_state = 24},
  [350] = {.lex_state = 24},
  [351] = {.lex_state = 2},
  [352] = {.lex_state = 2},
  [353] = {.lex_state = 2},
  [354] = {.lex_state = 24},
  [355] = {.lex_state = 2},
  [356] = {.lex_state = 24},
  [357] = {.lex_state = 2},
  [358] = {.lex_state = 2},
  [359] = {.lex_state = 24},
  [360] = {.lex_state = 24},
  [361] = {.lex_state = 24},
  [362] = {.lex_state = 2},
  [363] = {.lex_state = 24},
  [364] = {.lex_state = 2},
  [365] = {.lex_state = 24},
  [366] = {.lex_state = 24},
  [367] = {.lex_state = 24},
  [368] = {.lex_state = 2},
  [369] = {.lex_state = 24},
  [370] = {.lex_state = 24},
  [371] = {.lex_state = 24},
  [372] = {.lex_state = 24},
  [373] = {.lex_state = 24},
  [374] = {.lex_state = 24},
  [375] = {.lex_state = 24},
  [376] = {.lex_state = 2},
  [377] = {.lex_state = 24},
  [378] = {.lex_state = 2},
  [379] = {.lex_state = 2},
  [380] = {.lex_state = 2},
  [381] = {.lex_state = 2},
  [382] = {.lex_state = 2},
  [383] = {.lex_state = 2},
  [384] = {.lex_state = 24},
  [385] = {.lex_state = 24},
  [386] = {.lex_state = 24},
  [387] = {.lex_state = 24},
  [388] = {.lex_state = 24},
  [389] = {.lex_state = 24},
  [390] = {.lex_state = 24},
  [391] = {.lex_state = 24},
  [392] = {.lex_state = 24},
  [393] = {.lex_state = 24},
  [394] = {.lex_state = 24},
  [395] = {.lex_state = 24},
  [396] = {.lex_state = 24},
  [397] = {.lex_state = 24},
  [398] = {.lex_state = 24},
  [399] = {.lex_state = 24},
  [400] = {.lex_state = 24},
  [401] = {.lex_state = 24},
  [402] = {.lex_state = 24},
  [403] = {.lex_state = 24},
  [404] = {.lex_state = 24},
  [405] = {.lex_state = 24},
  [406] = {.lex_state = 24},
  [407] = {.lex_state = 24},
  [408] = {.lex_state = 24},
  [409] = {.lex_state = 24},
  [410] = {.lex_state = 24},
  [411] = {.lex_state = 24},
  [412] = {.lex_state = 2},
  [413] = {.lex_state = 24},
  [414] = {.lex_state = 24},
  [415] = {.lex_state = 24},
  [416] = {.lex_state = 24},
  [417] = {.lex_state = 24},
  [418] = {.lex_state = 24},
  [419] = {.lex_state = 24},
  [420] = {.lex_state = 2},
  [421] = {.lex_state = 24},
  [422] = {.lex_state = 24},
  [423] = {.lex_state = 24},
  [424] = {.lex_state = 2},
  [425] = {.lex_state = 24},
  [426] = {.lex_state = 24},
  [427] = {.lex_state = 24},
  [428] = {.lex_state = 24},
  [429] = {.lex_state = 24},
  [430] = {.lex_state = 24},
  [431] = {.lex_state = 24},
  [432] = {.lex_state = 24},
  [433] = {.lex_state = 24},
  [434] = {.lex_state = 24},
  [435] = {.lex_state = 24},
  [436] = {.lex_state = 24},
  [437] = {.lex_state = 24},
  [438] = {.lex_state = 24},
  [439] = {.lex_state = 24},
  [440] = {.lex_state = 24},
  [441] = {.lex_state = 24},
  [442] = {.lex_state = 24},
  [443] = {.lex_state = 24},
  [444] = {.lex_state = 2},
  [445] = {.lex_state = 2},
  [446] = {.lex_state = 24},
  [447] = {.lex_state = 2},
  [448] = {.lex_state = 2},
  [449] = {.lex_state = 2},
  [450] = {.lex_state = 2},
  [451] = {.lex_state = 24},
  [452] = {.lex_state = 2},
  [453] = {.lex_state = 2},
  [454] = {.lex_state = 2},
  [455] = {.lex_state = 24},
  [456] = {.lex_state = 24},
  [457] = {.lex_state = 24},
  [458] = {.lex_state = 24},
  [459] = {.lex_state = 24},
  [460] = {.lex_state = 24},
  [461] = {.lex_state = 24},
  [462] = {.lex_state = 24},
  [463] = {.lex_state = 24},
  [464] = {.lex_state = 24},
  [465] = {.lex_state = 24},
  [466] = {.lex_state = 24},
  [467] = {.lex_state = 24},
  [468] = {.lex_state = 24},
  [469] = {.lex_state = 24},
  [470] = {.lex_state = 24},
  [471] = {.lex_state = 24},
  [472] = {.lex_state = 24},
  [473] = {.lex_state = 24},
  [474] = {.lex_state = 24},
  [475] = {.lex_state = 24},
  [476] = {.lex_state = 24},
  [477] = {.lex_state = 24},
  [478] = {.lex_state = 24},
  [479] = {.lex_state = 24},
  [480] = {.lex_state = 24},
  [481] = {.lex_state = 24},
  [482] = {.lex_state = 24},
  [483] = {.lex_state = 2},
  [484] = {.lex_state = 24},
  [485] = {.lex_state = 24},
  [486] = {.lex_state = 24},
  [487] = {.lex_state = 24},
  [488] = {.lex_state = 24},
  [489] = {.lex_state = 24},
  [490] = {.lex_state = 24},
  [491] = {.lex_state = 3},
  [492] = {.lex_state = 24},
  [493] = {.lex_state = 24},
  [494] = {.lex_state = 24},
  [495] = {.lex_state = 24},
  [496] = {.lex_state = 24},
  [497] = {.lex_state = 24},
  [498] = {.lex_state = 24},
  [499] = {.lex_state = 24},
  [500] = {.lex_state = 24},
  [501] = {.lex_state = 24},
  [502] = {.lex_state = 24},
  [503] = {.lex_state = 24},
  [504] = {.lex_state = 24},
  [505] = {.lex_state = 24},
  [506] = {.lex_state = 24},
  [507] = {.lex_state = 24},
  [508] = {.lex_state = 24},
  [509] = {.lex_state = 24},
  [510] = {.lex_state = 24},
  [511] = {.lex_state = 24},
  [512] = {.lex_state = 24},
  [513] = {.lex_state = 24},
  [514] = {.lex_state = 24},
  [515] = {.lex_state = 24},
  [516] = {.lex_state = 24},
  [517] = {.lex_state = 24},
  [518] = {.lex_state = 24},
  [519] = {.lex_state = 24},
  [520] = {.lex_state = 24},
  [521] = {.lex_state = 24},
  [522] = {.lex_state = 24},
  [523] = {.lex_state = 24},
  [524] = {.lex_state = 24},
  [525] = {.lex_state = 24},
  [526] = {.lex_state = 24},
  [527] = {.lex_state = 24},
  [528] = {.lex_state = 24},
  [529] = {.lex_state = 24},
  [530] = {.lex_state = 24},
  [531] = {.lex_state = 24},
  [532] = {.lex_state = 24},
  [533] = {.lex_state = 24},
  [534] = {.lex_state = 24},
  [535] = {.lex_state = 24},
  [536] = {.lex_state = 24},
  [537] = {.lex_state = 24},
  [538] = {.lex_state = 24},
  [539] = {.lex_state = 24},
  [540] = {.lex_state = 24},
  [541] = {.lex_state = 24},
  [542] = {.lex_state = 24},
  [543] = {.lex_state = 24},
  [544] = {.lex_state = 24},
  [545] = {.lex_state = 24},
  [546] = {.lex_state = 24},
  [547] = {.lex_state = 24},
  [548] = {.lex_state = 24},
  [549] = {.lex_state = 24},
  [550] = {.lex_state = 24},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 6},
  [553] = {.lex_state = 6},
  [554] = {.lex_state = 6},
  [555] = {.lex_state = 6},
  [556] = {.lex_state = 6},
  [557] = {.lex_state = 2},
  [558] = {.lex_state = 2},
  [559] = {.lex_state = 2},
  [560] = {.lex_state = 2},
  [561] = {.lex_state = 2},
  [562] = {.lex_state = 2},
  [563] = {.lex_state = 2},
  [564] = {.lex_state = 2},
  [565] = {.lex_state = 2},
  [566] = {.lex_state = 2},
  [567] = {.lex_state = 2},
  [568] = {.lex_state = 2},
  [569] = {.lex_state = 2},
  [570] = {.lex_state = 2},
  [571] = {.lex_state = 2},
  [572] = {.lex_state = 2},
  [573] = {.lex_state = 2},
  [574] = {.lex_state = 3},
  [575] = {.lex_state = 6},
  [576] = {.lex_state = 2},
  [577] = {.lex_state = 2},
  [578] = {.lex_state = 2},
  [579] = {.lex_state = 2},
  [580] = {.lex_state = 2},
  [581] = {.lex_state = 2},
  [582] = {.lex_state = 6},
  [583] = {.lex_state = 2},
  [584] = {.lex_state = 2},
  [585] = {.lex_state = 2},
  [586] = {.lex_state = 6},
  [587] = {.lex_state = 2},
  [588] = {.lex_state = 6},
  [589] = {.lex_state = 2},
  [590] = {.lex_state = 6},
  [591] = {.lex_state = 2},
  [592] = {.lex_state = 2},
  [593] = {.lex_state = 6},
  [594] = {.lex_state = 6},
  [595] = {.lex_state = 2},
  [596] = {.lex_state = 6},
  [597] = {.lex_state = 2},
  [598] = {.lex_state = 2},
  [599] = {.lex_state = 2},
  [600] = {.lex_state = 2},
  [601] = {.lex_state = 2},
  [602] = {.lex_state = 2},
  [603] = {.lex_state = 2},
  [604] = {.lex_state = 2},
  [605] = {.lex_state = 2},
  [606] = {.lex_state = 2},
  [607] = {.lex_state = 2},
  [608] = {.lex_state = 2},
  [609] = {.lex_state = 2},
  [610] = {.lex_state = 2},
  [611] = {.lex_state = 2},
  [612] = {.lex_state = 2},
  [613] = {.lex_state = 2},
  [614] = {.lex_state = 2},
  [615] = {.lex_state = 2},
  [616] = {.lex_state = 2},
  [617] = {.lex_state = 2},
  [618] = {.lex_state = 2},
  [619] = {.lex_state = 2},
  [620] = {.lex_state = 2},
  [621] = {.lex_state = 2},
  [622] = {.lex_state = 2},
  [623] = {.lex_state = 2},
  [624] = {.lex_state = 2},
  [625] = {.lex_state = 2},
  [626] = {.lex_state = 2},
  [627] = {.lex_state = 2},
  [628] = {.lex_state = 2},
  [629] = {.lex_state = 2},
  [630] = {.lex_state = 2},
  [631] = {.lex_state = 2},
  [632] = {.lex_state = 2},
  [633] = {.lex_state = 2},
  [634] = {.lex_state = 2},
  [635] = {.lex_state = 2},
  [636] = {.lex_state = 2},
  [637] = {.lex_state = 2},
  [638] = {.lex_state = 2},
  [639] = {.lex_state = 2},
  [640] = {.lex_state = 2},
  [641] = {.lex_state = 2},
  [642] = {.lex_state = 2},
  [643] = {.lex_state = 2},
  [644] = {.lex_state = 2},
  [645] = {.lex_state = 2},
  [646] = {.lex_state = 2},
  [647] = {.lex_state = 2},
  [648] = {.lex_state = 2},
  [649] = {.lex_state = 2},
  [650] = {.lex_state = 2},
  [651] = {.lex_state = 2},
  [652] = {.lex_state = 2},
  [653] = {.lex_state = 2},
  [654] = {.lex_state = 2},
  [655] = {.lex_state = 6},
  [656] = {.lex_state = 2},
  [657] = {.lex_state = 2},
  [658] = {.lex_state = 2},
  [659] = {.lex_state = 2},
  [660] = {.lex_state = 2},
  [661] = {.lex_state = 6},
  [662] = {.lex_state = 2},
  [663] = {.lex_state = 2},
  [664] = {.lex_state = 2},
  [665] = {.lex_state = 2},
  [666] = {.lex_state = 2},
  [667] = {.lex_state = 6},
  [668] = {.lex_state = 6},
  [669] = {.lex_state = 2},
  [670] = {.lex_state = 2},
  [671] = {.lex_state = 2},
  [672] = {.lex_state = 6},
  [673] = {.lex_state = 2},
  [674] = {.lex_state = 6},
  [675] = {.lex_state = 6},
  [676] = {.lex_state = 6},
  [677] = {.lex_state = 6},
  [678] = {.lex_state = 24},
  [679] = {.lex_state = 24},
  [680] = {.lex_state = 24},
  [681] = {.lex_state = 24},
  [682] = {.lex_state = 6},
  [683] = {.lex_state = 6},
  [684] = {.lex_state = 6},
  [685] = {.lex_state = 6},
  [686] = {.lex_state = 24},
  [687] = {.lex_state = 24},
  [688] = {.lex_state = 24},
  [689] = {.lex_state = 24},
  [690] = {.lex_state = 24},
  [691] = {.lex_state = 24},
  [692] = {.lex_state = 5},
  [693] = {.lex_state = 5},
  [694] = {.lex_state = 24},
  [695] = {.lex_state = 24},
  [696] = {.lex_state = 24},
  [697] = {.lex_state = 5},
  [698] = {.lex_state = 5},
  [699] = {.lex_state = 24},
  [700] = {.lex_state = 24},
  [701] = {.lex_state = 5},
  [702] = {.lex_state = 24},
  [703] = {.lex_state = 24},
  [704] = {.lex_state = 24},
  [705] = {.lex_state = 5},
  [706] = {.lex_state = 24},
  [707] = {.lex_state = 24},
  [708] = {.lex_state = 24},
  [709] = {.lex_state = 24},
  [710] = {.lex_state = 24},
  [711] = {.lex_state = 6},
  [712] = {.lex_state = 24},
  [713] = {.lex_state = 24},
  [714] = {.lex_state = 24},
  [715] = {.lex_state = 24},
  [716] = {.lex_state = 24},
  [717] = {.lex_state = 24},
  [718] = {.lex_state = 24},
  [719] = {.lex_state = 24},
  [720] = {.lex_state = 5},
  [721] = {.lex_state = 24},
  [722] = {.lex_state = 24},
  [723] = {.lex_state = 24},
  [724] = {.lex_state = 24},
  [725] = {.lex_state = 5},
  [726] = {.lex_state = 24},
  [727] = {.lex_state = 24},
  [728] = {.lex_state = 24},
  [729] = {.lex_state = 5},
  [730] = {.lex_state = 24},
  [731] = {.lex_state = 24},
  [732] = {.lex_state = 24},
  [733] = {.lex_state = 24},
  [734] = {.lex_state = 24},
  [735] = {.lex_state = 24},
  [736] = {.lex_state = 24},
  [737] = {.lex_state = 24},
  [738] = {.lex_state = 5},
  [739] = {.lex_state = 24},
  [740] = {.lex_state = 24},
  [741] = {.lex_state = 24},
  [742] = {.lex_state = 24},
  [743] = {.lex_state = 24},
  [744] = {.lex_state = 24},
  [745] = {.lex_state = 24},
  [746] = {.lex_state = 24},
  [747] = {.lex_state = 24},
  [748] = {.lex_state = 24},
  [749] = {.lex_state = 24},
  [750] = {.lex_state = 24},
  [751] = {.lex_state = 24},
  [752] = {.lex_state = 24},
  [753] = {.lex_state = 24},
  [754] = {.lex_state = 24},
  [755] = {.lex_state = 24},
  [756] = {.lex_state = 24},
  [757] = {.lex_state = 5},
  [758] = {.lex_state = 24},
  [759] = {.lex_state = 5},
  [760] = {.lex_state = 24},
  [761] = {.lex_state = 24},
  [762] = {.lex_state = 24},
  [763] = {.lex_state = 24},
  [764] = {.lex_state = 24},
  [765] = {.lex_state = 24},
  [766] = {.lex_state = 24},
  [767] = {.lex_state = 24},
  [768] = {.lex_state = 5},
  [769] = {.lex_state = 24},
  [770] = {.lex_state = 24},
  [771] = {.lex_state = 24},
  [772] = {.lex_state = 2},
  [773] = {.lex_state = 24},
  [774] = {.lex_state = 24},
  [775] = {.lex_state = 24},
  [776] = {.lex_state = 24},
  [777] = {.lex_state = 5},
  [778] = {.lex_state = 24},
  [779] = {.lex_state = 24},
  [780] = {.lex_state = 24},
  [781] = {.lex_state = 5},
  [782] = {.lex_state = 24},
  [783] = {.lex_state = 24},
  [784] = {.lex_state = 24},
  [785] = {.lex_state = 24},
  [786] = {.lex_state = 6},
  [787] = {.lex_state = 24},
  [788] = {.lex_state = 24},
  [789] = {.lex_state = 24},
  [790] = {.lex_state = 24},
  [791] = {.lex_state = 6},
  [792] = {.lex_state = 24},
  [793] = {.lex_state = 24},
  [794] = {.lex_state = 24},
  [795] = {.lex_state = 24},
  [796] = {.lex_state = 24},
  [797] = {.lex_state = 24},
  [798] = {.lex_state = 24},
  [799] = {.lex_state = 24},
  [800] = {.lex_state = 5},
  [801] = {.lex_state = 5},
  [802] = {.lex_state = 5},
  [803] = {.lex_state = 24},
  [804] = {.lex_state = 6},
  [805] = {.lex_state = 24},
  [806] = {.lex_state = 24},
  [807] = {.lex_state = 24},
  [808] = {.lex_state = 24},
  [809] = {.lex_state = 24},
  [810] = {.lex_state = 24},
  [811] = {.lex_state = 24},
  [812] = {.lex_state = 24},
  [813] = {.lex_state = 24},
  [814] = {.lex_state = 24},
  [815] = {.lex_state = 24},
  [816] = {.lex_state = 24},
  [817] = {.lex_state = 24},
  [818] = {.lex_state = 24},
  [819] = {.lex_state = 24},
  [820] = {.lex_state = 24},
  [821] = {.lex_state = 24},
  [822] = {.lex_state = 24},
  [823] = {.lex_state = 24},
  [824] = {.lex_state = 24},
  [825] = {.lex_state = 24},
  [826] = {.lex_state = 24},
  [827] = {.lex_state = 24},
  [828] = {.lex_state = 24},
  [829] = {.lex_state = 24},
  [830] = {.lex_state = 24},
  [831] = {.lex_state = 24},
  [832] = {.lex_state = 24},
  [833] = {.lex_state = 24},
  [834] = {.lex_state = 24},
  [835] = {.lex_state = 24},
  [836] = {.lex_state = 24},
  [837] = {.lex_state = 24},
  [838] = {.lex_state = 24},
  [839] = {.lex_state = 24},
  [840] = {.lex_state = 24},
  [841] = {.lex_state = 24},
  [842] = {.lex_state = 24},
  [843] = {.lex_state = 24},
  [844] = {.lex_state = 24},
  [845] = {.lex_state = 24},
  [846] = {.lex_state = 24},
  [847] = {.lex_state = 24},
  [848] = {.lex_state = 24},
  [849] = {.lex_state = 24},
  [850] = {.lex_state = 24},
  [851] = {.lex_state = 24},
  [852] = {.lex_state = 24},
  [853] = {.lex_state = 24},
  [854] = {.lex_state = 24},
  [855] = {.lex_state = 24},
  [856] = {.lex_state = 24},
  [857] = {.lex_state = 24},
  [858] = {.lex_state = 24},
  [859] = {.lex_state = 24},
  [860] = {.lex_state = 24},
  [861] = {.lex_state = 24},
  [862] = {.lex_state = 24},
  [863] = {.lex_state = 5},
  [864] = {.lex_state = 24},
  [865] = {.lex_state = 5},
  [866] = {.lex_state = 24},
  [867] = {.lex_state = 24},
  [868] = {.lex_state = 24},
  [869] = {.lex_state = 24},
  [870] = {.lex_state = 24},
  [871] = {.lex_state = 24},
  [872] = {.lex_state = 24},
  [873] = {.lex_state = 24},
  [874] = {.lex_state = 5},
  [875] = {.lex_state = 24},
  [876] = {.lex_state = 24},
  [877] = {.lex_state = 24},
  [878] = {.lex_state = 24},
  [879] = {.lex_state = 24},
  [880] = {.lex_state = 24},
  [881] = {.lex_state = 24},
  [882] = {.lex_state = 24},
  [883] = {.lex_state = 5},
  [884] = {.lex_state = 5},
  [885] = {.lex_state = 24},
  [886] = {.lex_state = 24},
  [887] = {.lex_state = 24},
  [888] = {.lex_state = 24},
  [889] = {.lex_state = 24},
  [890] = {.lex_state = 24},
  [891] = {.lex_state = 24},
  [892] = {.lex_state = 24},
  [893] = {.lex_state = 24},
  [894] = {.lex_state = 24},
  [895] = {.lex_state = 24},
  [896] = {.lex_state = 24},
  [897] = {.lex_state = 24},
  [898] = {.lex_state = 24},
  [899] = {.lex_state = 24},
  [900] = {.lex_state = 24},
  [901] = {.lex_state = 24},
  [902] = {.lex_state = 24},
  [903] = {.lex_state = 24},
  [904] = {.lex_state = 24},
  [905] = {.lex_state = 24},
  [906] = {.lex_state = 24},
  [907] = {.lex_state = 24},
  [908] = {.lex_state = 24},
  [909] = {.lex_state = 24},
  [910] = {.lex_state = 24},
  [911] = {.lex_state = 24},
  [912] = {.lex_state = 24},
  [913] = {.lex_state = 24},
  [914] = {.lex_state = 24},
  [915] = {.lex_state = 24},
  [916] = {.lex_state = 24},
  [917] = {.lex_state = 24},
  [918] = {.lex_state = 24},
  [919] = {.lex_state = 24},
  [920] = {.lex_state = 24},
  [921] = {.lex_state = 24},
  [922] = {.lex_state = 24},
  [923] = {.lex_state = 24},
  [924] = {.lex_state = 24},
  [925] = {.lex_state = 24},
  [926] = {.lex_state = 24},
  [927] = {.lex_state = 24},
  [928] = {.lex_state = 24},
  [929] = {.lex_state = 24},
  [930] = {.lex_state = 24},
  [931] = {.lex_state = 24},
  [932] = {.lex_state = 24},
  [933] = {.lex_state = 24},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 24},
  [936] = {.lex_state = 24},
  [937] = {.lex_state = 24},
  [938] = {.lex_state = 24},
  [939] = {.lex_state = 24},
  [940] = {.lex_state = 24},
  [941] = {.lex_state = 24},
  [942] = {.lex_state = 24},
  [943] = {.lex_state = 24},
  [944] = {.lex_state = 24},
  [945] = {.lex_state = 24},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 24},
  [948] = {.lex_state = 24},
  [949] = {.lex_state = 24},
  [950] = {.lex_state = 24},
  [951] = {.lex_state = 24},
  [952] = {.lex_state = 24},
  [953] = {.lex_state = 24},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 24},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 24},
  [958] = {.lex_state = 24},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 24},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 24},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 24},
  [966] = {.lex_state = 24},
  [967] = {.lex_state = 24},
  [968] = {.lex_state = 24},
  [969] = {.lex_state = 24},
  [970] = {.lex_state = 24},
  [971] = {.lex_state = 24},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 24},
  [974] = {.lex_state = 24},
  [975] = {.lex_state = 24},
  [976] = {.lex_state = 24},
  [977] = {.lex_state = 24},
  [978] = {.lex_state = 24},
  [979] = {.lex_state = 24},
  [980] = {.lex_state = 24},
  [981] = {.lex_state = 24},
  [982] = {.lex_state = 24},
  [983] = {.lex_state = 24},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 24},
  [986] = {.lex_state = 24},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 24},
  [989] = {.lex_state = 24},
  [990] = {.lex_state = 24},
  [991] = {.lex_state = 24},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 24},
  [994] = {.lex_state = 24},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 24},
  [997] = {.lex_state = 24},
  [998] = {.lex_state = 24},
  [999] = {.lex_state = 24},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 24},
  [1002] = {.lex_state = 24},
  [1003] = {.lex_state = 24},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 24},
  [1006] = {.lex_state = 24},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 24},
  [1010] = {.lex_state = 24},
  [1011] = {.lex_state = 24},
  [1012] = {.lex_state = 24},
  [1013] = {.lex_state = 24},
  [1014] = {.lex_state = 24},
  [1015] = {.lex_state = 24},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 24},
  [1018] = {.lex_state = 24},
  [1019] = {.lex_state = 24},
  [1020] = {.lex_state = 24},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 24},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 24},
  [1025] = {.lex_state = 24},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 24},
  [1028] = {.lex_state = 24},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 24},
  [1031] = {.lex_state = 24},
  [1032] = {.lex_state = 24},
  [1033] = {.lex_state = 24},
  [1034] = {.lex_state = 24},
  [1035] = {.lex_state = 24},
  [1036] = {.lex_state = 24},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 24},
  [1039] = {.lex_state = 24},
  [1040] = {.lex_state = 24},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 24},
  [1044] = {.lex_state = 24},
  [1045] = {.lex_state = 24},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 24},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 24},
  [1050] = {.lex_state = 24},
  [1051] = {.lex_state = 24},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 24},
  [1055] = {.lex_state = 24},
  [1056] = {.lex_state = 24},
  [1057] = {.lex_state = 24},
  [1058] = {.lex_state = 24},
  [1059] = {.lex_state = 24},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 24},
  [1064] = {.lex_state = 24},
  [1065] = {.lex_state = 24},
  [1066] = {.lex_state = 24},
  [1067] = {.lex_state = 24},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 24},
  [1075] = {.lex_state = 24},
  [1076] = {.lex_state = 24},
  [1077] = {.lex_state = 24},
  [1078] = {.lex_state = 24},
  [1079] = {.lex_state = 24},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 24},
  [1082] = {.lex_state = 24},
  [1083] = {.lex_state = 24},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 24},
  [1086] = {.lex_state = 24},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 24},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 24},
  [1095] = {.lex_state = 24},
  [1096] = {.lex_state = 24},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 24},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 24},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 24},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 24},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 24},
  [1113] = {.lex_state = 24},
  [1114] = {.lex_state = 24},
  [1115] = {.lex_state = 24},
  [1116] = {.lex_state = 24},
  [1117] = {.lex_state = 24},
  [1118] = {.lex_state = 24},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 24},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 24},
  [1125] = {.lex_state = 24},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 24},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 24},
  [1135] = {.lex_state = 24},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 24},
  [1138] = {.lex_state = 24},
  [1139] = {.lex_state = 24},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 24},
  [1144] = {.lex_state = 24},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 24},
  [1148] = {.lex_state = 24},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 24},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 24},
  [1153] = {.lex_state = 24},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 24},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 24},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 24},
  [1162] = {.lex_state = 24},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 24},
  [1169] = {.lex_state = 24},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 24},
  [1172] = {.lex_state = 24},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 24},
  [1175] = {.lex_state = 24},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 24},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 24},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 24},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 62},
  [1188] = {.lex_state = 71},
  [1189] = {.lex_state = 24},
  [1190] = {.lex_state = 24},
  [1191] = {.lex_state = 24},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 24},
  [1194] = {.lex_state = 24},
  [1195] = {.lex_state = 24},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 24},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 24},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 24},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 24},
  [1206] = {.lex_state = 24},
  [1207] = {.lex_state = 24},
  [1208] = {.lex_state = 24},
  [1209] = {.lex_state = 24},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 24},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 24},
  [1214] = {.lex_state = 24},
  [1215] = {.lex_state = 24},
  [1216] = {.lex_state = 62},
  [1217] = {.lex_state = 71},
  [1218] = {.lex_state = 24},
  [1219] = {.lex_state = 71},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 24},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 62},
  [1228] = {.lex_state = 71},
  [1229] = {.lex_state = 24},
  [1230] = {.lex_state = 24},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 24},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 24},
  [1235] = {.lex_state = 24},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 62},
  [1239] = {.lex_state = 71},
  [1240] = {.lex_state = 24},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 24},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 24},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 62},
  [1250] = {.lex_state = 71},
  [1251] = {.lex_state = 24},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 24},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 62},
  [1261] = {.lex_state = 71},
  [1262] = {.lex_state = 24},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 24},
  [1265] = {.lex_state = 24},
  [1266] = {.lex_state = 62},
  [1267] = {.lex_state = 24},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 62},
  [1272] = {.lex_state = 71},
  [1273] = {.lex_state = 24},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 24},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 24},
  [1282] = {.lex_state = 24},
  [1283] = {.lex_state = 24},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 24},
  [1288] = {.lex_state = 24},
  [1289] = {.lex_state = 24},
  [1290] = {.lex_state = 24},
  [1291] = {.lex_state = 24},
  [1292] = {.lex_state = 24},
  [1293] = {.lex_state = 24},
  [1294] = {.lex_state = 24},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 24},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 24},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 24},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 24},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 24},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 24},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 24},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 24},
  [1325] = {.lex_state = 24},
  [1326] = {.lex_state = 24},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 24},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 24},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 24},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 24},
  [1338] = {.lex_state = 24},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 24},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 24},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 24},
  [1352] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier] = ACTIONS(1),
    [sym_keyword_select] = ACTIONS(1),
    [sym_keyword_delete] = ACTIONS(1),
    [sym_keyword_insert] = ACTIONS(1),
    [sym_keyword_replace] = ACTIONS(1),
    [sym_keyword_update] = ACTIONS(1),
    [sym_keyword_into] = ACTIONS(1),
    [sym_keyword_values] = ACTIONS(1),
    [sym_keyword_set] = ACTIONS(1),
    [sym_keyword_from] = ACTIONS(1),
    [sym_keyword_left] = ACTIONS(1),
    [sym_keyword_right] = ACTIONS(1),
    [sym_keyword_inner] = ACTIONS(1),
    [sym_keyword_outer] = ACTIONS(1),
    [sym_keyword_cross] = ACTIONS(1),
    [sym_keyword_join] = ACTIONS(1),
    [sym_keyword_lateral] = ACTIONS(1),
    [sym_keyword_on] = ACTIONS(1),
    [sym_keyword_where] = ACTIONS(1),
    [sym_keyword_order_by] = ACTIONS(1),
    [sym_keyword_group_by] = ACTIONS(1),
    [sym_keyword_having] = ACTIONS(1),
    [sym_keyword_desc] = ACTIONS(1),
    [sym_keyword_asc] = ACTIONS(1),
    [sym_keyword_limit] = ACTIONS(1),
    [sym_keyword_offset] = ACTIONS(1),
    [sym_keyword_primary] = ACTIONS(1),
    [sym_keyword_create] = ACTIONS(1),
    [sym_keyword_alter] = ACTIONS(1),
    [sym_keyword_drop] = ACTIONS(1),
    [sym_keyword_add] = ACTIONS(1),
    [sym_keyword_table] = ACTIONS(1),
    [sym_keyword_view] = ACTIONS(1),
    [sym_keyword_materialized] = ACTIONS(1),
    [sym_keyword_column] = ACTIONS(1),
    [sym_keyword_key] = ACTIONS(1),
    [sym_keyword_as] = ACTIONS(1),
    [sym_keyword_distinct] = ACTIONS(1),
    [sym_keyword_constraint] = ACTIONS(1),
    [sym_keyword_count] = ACTIONS(1),
    [sym_keyword_max] = ACTIONS(1),
    [sym_keyword_min] = ACTIONS(1),
    [sym_keyword_avg] = ACTIONS(1),
    [sym_keyword_case] = ACTIONS(1),
    [sym_keyword_when] = ACTIONS(1),
    [sym_keyword_then] = ACTIONS(1),
    [sym_keyword_else] = ACTIONS(1),
    [sym_keyword_end] = ACTIONS(1),
    [sym_keyword_in] = ACTIONS(1),
    [sym_keyword_and] = ACTIONS(1),
    [sym_keyword_or] = ACTIONS(1),
    [sym_keyword_is] = ACTIONS(1),
    [sym_keyword_not] = ACTIONS(1),
    [sym_keyword_force] = ACTIONS(1),
    [sym_keyword_using] = ACTIONS(1),
    [sym_keyword_use] = ACTIONS(1),
    [sym_keyword_index] = ACTIONS(1),
    [sym_keyword_for] = ACTIONS(1),
    [sym_keyword_if] = ACTIONS(1),
    [sym_keyword_exists] = ACTIONS(1),
    [sym_keyword_auto_increment] = ACTIONS(1),
    [sym_keyword_default] = ACTIONS(1),
    [sym_keyword_cascade] = ACTIONS(1),
    [aux_sym_keyword_with_token1] = ACTIONS(1),
    [sym_keyword_no] = ACTIONS(1),
    [sym_keyword_data] = ACTIONS(1),
    [sym_keyword_type] = ACTIONS(1),
    [sym_keyword_rename] = ACTIONS(1),
    [sym_keyword_to] = ACTIONS(1),
    [sym_keyword_schema] = ACTIONS(1),
    [sym_keyword_owner] = ACTIONS(1),
    [sym_keyword_temp] = ACTIONS(1),
    [sym_keyword_temporary] = ACTIONS(1),
    [sym_keyword_union] = ACTIONS(1),
    [sym_keyword_all] = ACTIONS(1),
    [sym_keyword_except] = ACTIONS(1),
    [sym_keyword_intersect] = ACTIONS(1),
    [sym_keyword_returning] = ACTIONS(1),
    [sym_keyword_begin] = ACTIONS(1),
    [sym_keyword_commit] = ACTIONS(1),
    [sym_keyword_rollback] = ACTIONS(1),
    [sym_keyword_transaction] = ACTIONS(1),
    [sym_keyword_null] = ACTIONS(1),
    [sym_keyword_true] = ACTIONS(1),
    [sym_keyword_false] = ACTIONS(1),
    [sym_keyword_boolean] = ACTIONS(1),
    [sym_keyword_smallserial] = ACTIONS(1),
    [sym_keyword_serial] = ACTIONS(1),
    [sym_keyword_bigserial] = ACTIONS(1),
    [sym_keyword_smallint] = ACTIONS(1),
    [aux_sym_keyword_int_token1] = ACTIONS(1),
    [aux_sym_keyword_int_token2] = ACTIONS(1),
    [sym_keyword_bigint] = ACTIONS(1),
    [sym_keyword_decimal] = ACTIONS(1),
    [sym_keyword_numeric] = ACTIONS(1),
    [sym_keyword_real] = ACTIONS(1),
    [aux_sym_double_token1] = ACTIONS(1),
    [aux_sym_double_token2] = ACTIONS(1),
    [sym_keyword_money] = ACTIONS(1),
    [aux_sym_keyword_char_token1] = ACTIONS(1),
    [aux_sym_keyword_char_token2] = ACTIONS(1),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1),
    [aux_sym_keyword_varchar_token2] = ACTIONS(1),
    [sym_keyword_text] = ACTIONS(1),
    [sym_keyword_uuid] = ACTIONS(1),
    [sym_keyword_json] = ACTIONS(1),
    [sym_keyword_jsonb] = ACTIONS(1),
    [sym_keyword_xml] = ACTIONS(1),
    [sym_keyword_bytea] = ACTIONS(1),
    [sym_keyword_date] = ACTIONS(1),
    [sym_keyword_datetime] = ACTIONS(1),
    [aux_sym_keyword_timestamp_token1] = ACTIONS(1),
    [aux_sym_keyword_timestamp_token2] = ACTIONS(1),
    [aux_sym_keyword_timestamp_token3] = ACTIONS(1),
    [aux_sym_keyword_timestamp_token4] = ACTIONS(1),
    [aux_sym_keyword_timestamptz_token1] = ACTIONS(1),
    [sym_keyword_geometry] = ACTIONS(1),
    [sym_keyword_geography] = ACTIONS(1),
    [sym_keyword_box2d] = ACTIONS(1),
    [sym_keyword_box3d] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym__number] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1274),
    [sym_keyword_with] = STATE(917),
    [sym_statement] = STATE(10),
    [sym__ddl_statement] = STATE(1263),
    [sym__dml_statement] = STATE(1263),
    [sym_transaction] = STATE(10),
    [sym__begin] = STATE(11),
    [sym__select_statement] = STATE(1263),
    [sym_select] = STATE(715),
    [sym__delete_statement] = STATE(1263),
    [sym_delete] = STATE(1117),
    [sym__create_statement] = STATE(1263),
    [sym_create_table] = STATE(1263),
    [sym_create_view] = STATE(1263),
    [sym_create_materialized_view] = STATE(1263),
    [sym__alter_statement] = STATE(1263),
    [sym_alter_table] = STATE(1263),
    [sym_alter_view] = STATE(1263),
    [sym__drop_statement] = STATE(1263),
    [sym_drop_table] = STATE(1263),
    [sym_drop_view] = STATE(1263),
    [sym__insert_statement] = STATE(1263),
    [sym_insert] = STATE(922),
    [sym__update_statement] = STATE(1263),
    [sym_update] = STATE(925),
    [aux_sym_program_repeat1] = STATE(10),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_create] = ACTIONS(15),
    [sym_keyword_alter] = ACTIONS(17),
    [sym_keyword_drop] = ACTIONS(19),
    [aux_sym_keyword_with_token1] = ACTIONS(21),
    [sym_keyword_begin] = ACTIONS(23),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(27), 6,
      sym_keyword_order_by,
      sym_keyword_group_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_BQUOTE,
    ACTIONS(25), 47,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_force,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_boolean,
      sym_keyword_smallserial,
      sym_keyword_serial,
      sym_keyword_bigserial,
      sym_keyword_smallint,
      aux_sym_keyword_int_token1,
      aux_sym_keyword_int_token2,
      sym_keyword_bigint,
      sym_keyword_decimal,
      sym_keyword_numeric,
      sym_keyword_real,
      aux_sym_double_token1,
      sym_keyword_money,
      aux_sym_keyword_char_token1,
      aux_sym_keyword_char_token2,
      aux_sym_keyword_varchar_token1,
      sym_keyword_text,
      sym_keyword_uuid,
      sym_keyword_json,
      sym_keyword_jsonb,
      sym_keyword_xml,
      sym_keyword_bytea,
      sym_keyword_date,
      sym_keyword_datetime,
      aux_sym_keyword_timestamp_token1,
      aux_sym_keyword_timestamptz_token1,
      sym_keyword_geometry,
      sym_keyword_geography,
      sym_keyword_box2d,
      sym_keyword_box3d,
      sym__identifier,
  [62] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(31), 6,
      sym_keyword_order_by,
      sym_keyword_group_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_BQUOTE,
    ACTIONS(29), 47,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_force,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_boolean,
      sym_keyword_smallserial,
      sym_keyword_serial,
      sym_keyword_bigserial,
      sym_keyword_smallint,
      aux_sym_keyword_int_token1,
      aux_sym_keyword_int_token2,
      sym_keyword_bigint,
      sym_keyword_decimal,
      sym_keyword_numeric,
      sym_keyword_real,
      aux_sym_double_token1,
      sym_keyword_money,
      aux_sym_keyword_char_token1,
      aux_sym_keyword_char_token2,
      aux_sym_keyword_varchar_token1,
      sym_keyword_text,
      sym_keyword_uuid,
      sym_keyword_json,
      sym_keyword_jsonb,
      sym_keyword_xml,
      sym_keyword_bytea,
      sym_keyword_date,
      sym_keyword_datetime,
      aux_sym_keyword_timestamp_token1,
      aux_sym_keyword_timestamptz_token1,
      sym_keyword_geometry,
      sym_keyword_geography,
      sym_keyword_box2d,
      sym_keyword_box3d,
      sym__identifier,
  [124] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(27), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(25), 32,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_primary,
      sym_keyword_alter,
      sym_keyword_drop,
      sym_keyword_add,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_cascade,
      aux_sym_keyword_with_token1,
      sym_keyword_type,
      sym_keyword_rename,
      sym_keyword_to,
      sym_keyword_owner,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [180] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(31), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(29), 32,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_primary,
      sym_keyword_alter,
      sym_keyword_drop,
      sym_keyword_add,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_cascade,
      aux_sym_keyword_with_token1,
      sym_keyword_type,
      sym_keyword_rename,
      sym_keyword_to,
      sym_keyword_owner,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [236] = 17,
    ACTIONS(35), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(37), 1,
      aux_sym_keyword_int_token2,
    ACTIONS(39), 1,
      sym_keyword_bigint,
    ACTIONS(41), 1,
      sym_keyword_decimal,
    ACTIONS(43), 1,
      sym_keyword_numeric,
    ACTIONS(45), 1,
      aux_sym_double_token1,
    ACTIONS(47), 1,
      aux_sym_keyword_char_token1,
    ACTIONS(49), 1,
      aux_sym_keyword_char_token2,
    ACTIONS(51), 1,
      aux_sym_keyword_varchar_token1,
    ACTIONS(55), 1,
      aux_sym_keyword_timestamp_token1,
    ACTIONS(57), 1,
      aux_sym_keyword_timestamptz_token1,
    STATE(709), 1,
      sym_keyword_char,
    STATE(727), 1,
      sym_keyword_varchar,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(53), 2,
      sym_keyword_json,
      sym_keyword_date,
    STATE(1108), 10,
      sym_keyword_int,
      sym_double,
      sym_keyword_timestamp,
      sym_keyword_timestamptz,
      sym__type,
      sym_bigint,
      sym_decimal,
      sym_numeric,
      sym_char,
      sym_varchar,
    ACTIONS(33), 17,
      sym_keyword_boolean,
      sym_keyword_smallserial,
      sym_keyword_serial,
      sym_keyword_bigserial,
      sym_keyword_smallint,
      sym_keyword_real,
      sym_keyword_money,
      sym_keyword_text,
      sym_keyword_uuid,
      sym_keyword_jsonb,
      sym_keyword_xml,
      sym_keyword_bytea,
      sym_keyword_datetime,
      sym_keyword_geometry,
      sym_keyword_geography,
      sym_keyword_box2d,
      sym_keyword_box3d,
  [315] = 17,
    ACTIONS(35), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(37), 1,
      aux_sym_keyword_int_token2,
    ACTIONS(39), 1,
      sym_keyword_bigint,
    ACTIONS(41), 1,
      sym_keyword_decimal,
    ACTIONS(43), 1,
      sym_keyword_numeric,
    ACTIONS(45), 1,
      aux_sym_double_token1,
    ACTIONS(47), 1,
      aux_sym_keyword_char_token1,
    ACTIONS(49), 1,
      aux_sym_keyword_char_token2,
    ACTIONS(51), 1,
      aux_sym_keyword_varchar_token1,
    ACTIONS(55), 1,
      aux_sym_keyword_timestamp_token1,
    ACTIONS(57), 1,
      aux_sym_keyword_timestamptz_token1,
    STATE(709), 1,
      sym_keyword_char,
    STATE(727), 1,
      sym_keyword_varchar,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(61), 2,
      sym_keyword_json,
      sym_keyword_date,
    STATE(687), 10,
      sym_keyword_int,
      sym_double,
      sym_keyword_timestamp,
      sym_keyword_timestamptz,
      sym__type,
      sym_bigint,
      sym_decimal,
      sym_numeric,
      sym_char,
      sym_varchar,
    ACTIONS(59), 17,
      sym_keyword_boolean,
      sym_keyword_smallserial,
      sym_keyword_serial,
      sym_keyword_bigserial,
      sym_keyword_smallint,
      sym_keyword_real,
      sym_keyword_money,
      sym_keyword_text,
      sym_keyword_uuid,
      sym_keyword_jsonb,
      sym_keyword_xml,
      sym_keyword_bytea,
      sym_keyword_datetime,
      sym_keyword_geometry,
      sym_keyword_geography,
      sym_keyword_box2d,
      sym_keyword_box3d,
  [394] = 17,
    ACTIONS(35), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(37), 1,
      aux_sym_keyword_int_token2,
    ACTIONS(39), 1,
      sym_keyword_bigint,
    ACTIONS(41), 1,
      sym_keyword_decimal,
    ACTIONS(43), 1,
      sym_keyword_numeric,
    ACTIONS(45), 1,
      aux_sym_double_token1,
    ACTIONS(47), 1,
      aux_sym_keyword_char_token1,
    ACTIONS(49), 1,
      aux_sym_keyword_char_token2,
    ACTIONS(51), 1,
      aux_sym_keyword_varchar_token1,
    ACTIONS(55), 1,
      aux_sym_keyword_timestamp_token1,
    ACTIONS(57), 1,
      aux_sym_keyword_timestamptz_token1,
    STATE(709), 1,
      sym_keyword_char,
    STATE(727), 1,
      sym_keyword_varchar,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(65), 2,
      sym_keyword_json,
      sym_keyword_date,
    STATE(1105), 10,
      sym_keyword_int,
      sym_double,
      sym_keyword_timestamp,
      sym_keyword_timestamptz,
      sym__type,
      sym_bigint,
      sym_decimal,
      sym_numeric,
      sym_char,
      sym_varchar,
    ACTIONS(63), 17,
      sym_keyword_boolean,
      sym_keyword_smallserial,
      sym_keyword_serial,
      sym_keyword_bigserial,
      sym_keyword_smallint,
      sym_keyword_real,
      sym_keyword_money,
      sym_keyword_text,
      sym_keyword_uuid,
      sym_keyword_jsonb,
      sym_keyword_xml,
      sym_keyword_bytea,
      sym_keyword_datetime,
      sym_keyword_geometry,
      sym_keyword_geography,
      sym_keyword_box2d,
      sym_keyword_box3d,
  [473] = 19,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(13), 1,
      sym_keyword_update,
    ACTIONS(15), 1,
      sym_keyword_create,
    ACTIONS(17), 1,
      sym_keyword_alter,
    ACTIONS(19), 1,
      sym_keyword_drop,
    ACTIONS(21), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(67), 1,
      sym_keyword_commit,
    ACTIONS(69), 1,
      sym_keyword_rollback,
    STATE(715), 1,
      sym_select,
    STATE(917), 1,
      sym_keyword_with,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(16), 2,
      sym_statement,
      aux_sym_transaction_repeat1,
    STATE(702), 2,
      sym__commit,
      sym__rollback,
    STATE(1263), 16,
      sym__ddl_statement,
      sym__dml_statement,
      sym__select_statement,
      sym__delete_statement,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym__alter_statement,
      sym_alter_table,
      sym_alter_view,
      sym__drop_statement,
      sym_drop_table,
      sym_drop_view,
      sym__insert_statement,
      sym__update_statement,
  [550] = 19,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(13), 1,
      sym_keyword_update,
    ACTIONS(15), 1,
      sym_keyword_create,
    ACTIONS(17), 1,
      sym_keyword_alter,
    ACTIONS(19), 1,
      sym_keyword_drop,
    ACTIONS(21), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(23), 1,
      sym_keyword_begin,
    ACTIONS(71), 1,
      ts_builtin_sym_end,
    STATE(11), 1,
      sym__begin,
    STATE(715), 1,
      sym_select,
    STATE(917), 1,
      sym_keyword_with,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(12), 3,
      sym_statement,
      sym_transaction,
      aux_sym_program_repeat1,
    STATE(1263), 16,
      sym__ddl_statement,
      sym__dml_statement,
      sym__select_statement,
      sym__delete_statement,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym__alter_statement,
      sym_alter_table,
      sym_alter_view,
      sym__drop_statement,
      sym_drop_table,
      sym_drop_view,
      sym__insert_statement,
      sym__update_statement,
  [627] = 19,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(13), 1,
      sym_keyword_update,
    ACTIONS(15), 1,
      sym_keyword_create,
    ACTIONS(17), 1,
      sym_keyword_alter,
    ACTIONS(19), 1,
      sym_keyword_drop,
    ACTIONS(21), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(67), 1,
      sym_keyword_commit,
    ACTIONS(69), 1,
      sym_keyword_rollback,
    STATE(715), 1,
      sym_select,
    STATE(917), 1,
      sym_keyword_with,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(9), 2,
      sym_statement,
      aux_sym_transaction_repeat1,
    STATE(706), 2,
      sym__commit,
      sym__rollback,
    STATE(1263), 16,
      sym__ddl_statement,
      sym__dml_statement,
      sym__select_statement,
      sym__delete_statement,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym__alter_statement,
      sym_alter_table,
      sym_alter_view,
      sym__drop_statement,
      sym_drop_table,
      sym_drop_view,
      sym__insert_statement,
      sym__update_statement,
  [704] = 19,
    ACTIONS(73), 1,
      ts_builtin_sym_end,
    ACTIONS(75), 1,
      sym_keyword_select,
    ACTIONS(78), 1,
      sym_keyword_delete,
    ACTIONS(84), 1,
      sym_keyword_update,
    ACTIONS(87), 1,
      sym_keyword_create,
    ACTIONS(90), 1,
      sym_keyword_alter,
    ACTIONS(93), 1,
      sym_keyword_drop,
    ACTIONS(96), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(99), 1,
      sym_keyword_begin,
    STATE(11), 1,
      sym__begin,
    STATE(715), 1,
      sym_select,
    STATE(917), 1,
      sym_keyword_with,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(81), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(12), 3,
      sym_statement,
      sym_transaction,
      aux_sym_program_repeat1,
    STATE(1263), 16,
      sym__ddl_statement,
      sym__dml_statement,
      sym__select_statement,
      sym__delete_statement,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym__alter_statement,
      sym_alter_table,
      sym_alter_view,
      sym__drop_statement,
      sym_drop_table,
      sym_drop_view,
      sym__insert_statement,
      sym__update_statement,
  [781] = 5,
    ACTIONS(106), 1,
      anon_sym_LPAREN,
    ACTIONS(108), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(102), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [829] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(27), 29,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [873] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(31), 29,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [917] = 17,
    ACTIONS(110), 1,
      sym_keyword_select,
    ACTIONS(113), 1,
      sym_keyword_delete,
    ACTIONS(119), 1,
      sym_keyword_update,
    ACTIONS(122), 1,
      sym_keyword_create,
    ACTIONS(125), 1,
      sym_keyword_alter,
    ACTIONS(128), 1,
      sym_keyword_drop,
    ACTIONS(131), 1,
      aux_sym_keyword_with_token1,
    STATE(715), 1,
      sym_select,
    STATE(917), 1,
      sym_keyword_with,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(116), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    ACTIONS(134), 2,
      sym_keyword_commit,
      sym_keyword_rollback,
    STATE(16), 2,
      sym_statement,
      aux_sym_transaction_repeat1,
    STATE(1263), 16,
      sym__ddl_statement,
      sym__dml_statement,
      sym__select_statement,
      sym__delete_statement,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym__alter_statement,
      sym_alter_table,
      sym_alter_view,
      sym__drop_statement,
      sym_drop_table,
      sym_drop_view,
      sym__insert_statement,
      sym__update_statement,
  [988] = 4,
    ACTIONS(140), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(136), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1033] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(142), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1075] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(148), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(146), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1117] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(150), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1161] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(158), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(156), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1203] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(160), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1247] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(160), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1291] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(166), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1335] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(170), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(168), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1377] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(172), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1419] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(178), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(176), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1461] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(180), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1505] = 9,
    ACTIONS(184), 1,
      sym_keyword_in,
    ACTIONS(190), 1,
      anon_sym_PLUS,
    ACTIONS(192), 1,
      anon_sym_DASH,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(188), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(186), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(182), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [1559] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(198), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1603] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(166), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1647] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(200), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1691] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(200), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1735] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(198), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1779] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(202), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1823] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(202), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [1867] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(206), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(204), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1909] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(210), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(208), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1951] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(212), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [1993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(218), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(216), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2035] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(220), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2079] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(220), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2123] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(222), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2167] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(222), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2211] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2253] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(224), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2297] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(224), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2341] = 9,
    ACTIONS(184), 1,
      sym_keyword_in,
    ACTIONS(190), 1,
      anon_sym_PLUS,
    ACTIONS(192), 1,
      anon_sym_DASH,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(188), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(228), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(226), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [2395] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(230), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2439] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(230), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2483] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(150), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2527] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(234), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(232), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2569] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(238), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(236), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2611] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(242), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(240), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2653] = 8,
    ACTIONS(190), 1,
      anon_sym_PLUS,
    ACTIONS(192), 1,
      anon_sym_DASH,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(188), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [2705] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(250), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(248), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2747] = 13,
    ACTIONS(184), 1,
      sym_keyword_in,
    ACTIONS(190), 1,
      anon_sym_PLUS,
    ACTIONS(192), 1,
      anon_sym_DASH,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(246), 1,
      sym_keyword_or,
    ACTIONS(252), 1,
      sym_keyword_is,
    ACTIONS(258), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(188), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(254), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(244), 17,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [2809] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(262), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(260), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2851] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(264), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [2893] = 9,
    ACTIONS(184), 1,
      sym_keyword_in,
    ACTIONS(190), 1,
      anon_sym_PLUS,
    ACTIONS(192), 1,
      anon_sym_DASH,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(188), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [2947] = 4,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 26,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
  [2991] = 6,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(188), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(270), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(268), 24,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
  [3039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(274), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(272), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3081] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3123] = 12,
    ACTIONS(184), 1,
      sym_keyword_in,
    ACTIONS(190), 1,
      anon_sym_PLUS,
    ACTIONS(192), 1,
      anon_sym_DASH,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(196), 1,
      anon_sym_CARET,
    ACTIONS(252), 1,
      sym_keyword_is,
    ACTIONS(270), 1,
      sym_keyword_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(188), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(254), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 18,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
  [3183] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(278), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(276), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3225] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(180), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [3269] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(282), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(280), 27,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3311] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(27), 27,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3351] = 5,
    ACTIONS(284), 1,
      anon_sym_LPAREN,
    ACTIONS(286), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(102), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(104), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [3395] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(31), 27,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3435] = 5,
    ACTIONS(284), 1,
      anon_sym_LPAREN,
    ACTIONS(288), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(102), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(104), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [3479] = 19,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(294), 1,
      sym_keyword_as,
    ACTIONS(296), 1,
      sym_keyword_in,
    ACTIONS(300), 1,
      sym_keyword_is,
    ACTIONS(310), 1,
      anon_sym_PLUS,
    ACTIONS(312), 1,
      anon_sym_DASH,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(318), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    STATE(749), 1,
      sym__alias,
    STATE(750), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(298), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(308), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(302), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(304), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(292), 6,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [3551] = 5,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(102), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3595] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(274), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(272), 27,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_auto_increment,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3635] = 17,
    ACTIONS(330), 1,
      sym_keyword_in,
    ACTIONS(334), 1,
      sym_keyword_is,
    ACTIONS(336), 1,
      anon_sym_COMMA,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(352), 1,
      anon_sym_PIPE_PIPE,
    STATE(717), 1,
      aux_sym_order_expression_repeat1,
    STATE(718), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(332), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(342), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(338), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(328), 8,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [3702] = 4,
    ACTIONS(354), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(136), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3743] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(164), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(162), 17,
      sym_keyword_from,
      sym_keyword_offset,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [3782] = 5,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(102), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3825] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(240), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(242), 17,
      sym_keyword_from,
      sym_keyword_offset,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [3864] = 4,
    ACTIONS(360), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(136), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(138), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [3905] = 4,
    ACTIONS(362), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(136), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(138), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [3946] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(27), 25,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [3985] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(31), 25,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4024] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(264), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(266), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [4062] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(276), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(278), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [4100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(250), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(248), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4138] = 9,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(228), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(226), 20,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [4188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(204), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(206), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [4226] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(218), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(216), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4264] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(206), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(204), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4302] = 19,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(376), 1,
      sym_keyword_distinct,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(386), 1,
      anon_sym_STAR,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(72), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    STATE(767), 1,
      sym_select_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(714), 2,
      sym__select_expression,
      sym_all_fields,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(73), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(208), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(210), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [4410] = 5,
    ACTIONS(394), 1,
      anon_sym_LPAREN,
    ACTIONS(396), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(102), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4452] = 9,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(182), 20,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [4502] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(158), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(156), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4540] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(210), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(208), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4578] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(178), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(176), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4616] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(216), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(218), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [4654] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(282), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(280), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4692] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(212), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4730] = 8,
    ACTIONS(310), 1,
      anon_sym_PLUS,
    ACTIONS(312), 1,
      anon_sym_DASH,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(244), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(246), 14,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [4778] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(278), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(276), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(172), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(174), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [4854] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(172), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4892] = 11,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 15,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
  [4946] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [4984] = 12,
    ACTIONS(296), 1,
      sym_keyword_in,
    ACTIONS(300), 1,
      sym_keyword_is,
    ACTIONS(310), 1,
      anon_sym_PLUS,
    ACTIONS(312), 1,
      anon_sym_DASH,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(308), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(304), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(270), 10,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [5040] = 6,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(270), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(268), 22,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
  [5084] = 4,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 24,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
  [5124] = 9,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(246), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(244), 20,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [5174] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(262), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(260), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5212] = 12,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(244), 14,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [5268] = 8,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(246), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(244), 21,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [5316] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(242), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(240), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5354] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(238), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(236), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5392] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(142), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5430] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(234), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(232), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5468] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(148), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(146), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5506] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(27), 23,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5582] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(31), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5620] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(156), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(158), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [5658] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(27), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5696] = 19,
    ACTIONS(386), 1,
      anon_sym_STAR,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(408), 1,
      sym_keyword_distinct,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(295), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    STATE(767), 1,
      sym_select_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(871), 2,
      sym__select_expression,
      sym_all_fields,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(276), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [5766] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(31), 23,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5804] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(268), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(270), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [5842] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(168), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(170), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [5880] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(272), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(274), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [5918] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(280), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(282), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [5956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(170), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(168), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [5994] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(212), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(214), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6032] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(232), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(234), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6070] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(264), 25,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [6108] = 15,
    ACTIONS(330), 1,
      sym_keyword_in,
    ACTIONS(334), 1,
      sym_keyword_is,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(352), 1,
      anon_sym_PIPE_PIPE,
    STATE(761), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(332), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(342), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(338), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(426), 9,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [6170] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(146), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(148), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6208] = 5,
    ACTIONS(428), 1,
      anon_sym_LPAREN,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(102), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [6250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(176), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(178), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6288] = 6,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(268), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(270), 15,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [6332] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(248), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(250), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6370] = 4,
    ACTIONS(432), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(136), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [6410] = 4,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(268), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(270), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6450] = 9,
    ACTIONS(296), 1,
      sym_keyword_in,
    ACTIONS(310), 1,
      anon_sym_PLUS,
    ACTIONS(312), 1,
      anon_sym_DASH,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(244), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(246), 13,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [6500] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(260), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(262), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6538] = 13,
    ACTIONS(296), 1,
      sym_keyword_in,
    ACTIONS(300), 1,
      sym_keyword_is,
    ACTIONS(310), 1,
      anon_sym_PLUS,
    ACTIONS(312), 1,
      anon_sym_DASH,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(318), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(308), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    ACTIONS(304), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(246), 10,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [6596] = 9,
    ACTIONS(296), 1,
      sym_keyword_in,
    ACTIONS(310), 1,
      anon_sym_PLUS,
    ACTIONS(312), 1,
      anon_sym_DASH,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(226), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(228), 13,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [6646] = 9,
    ACTIONS(296), 1,
      sym_keyword_in,
    ACTIONS(310), 1,
      anon_sym_PLUS,
    ACTIONS(312), 1,
      anon_sym_DASH,
    ACTIONS(314), 1,
      anon_sym_SLASH,
    ACTIONS(316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(306), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(182), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(186), 13,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [6696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(236), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(238), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6734] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(142), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(144), 16,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [6772] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(212), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [6809] = 4,
    ACTIONS(434), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(136), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [6848] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [6885] = 9,
    ACTIONS(330), 1,
      sym_keyword_in,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(246), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(244), 19,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [6934] = 11,
    ACTIONS(330), 1,
      sym_keyword_in,
    ACTIONS(334), 1,
      sym_keyword_is,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(342), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(338), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 14,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
  [6987] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(262), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(260), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7024] = 12,
    ACTIONS(330), 1,
      sym_keyword_in,
    ACTIONS(334), 1,
      sym_keyword_is,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(342), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(338), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(244), 13,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [7079] = 6,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(270), 4,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(268), 20,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
  [7122] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(172), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7159] = 8,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 3,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 19,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [7206] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(274), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(272), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7243] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(242), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(240), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7280] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(278), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(276), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(234), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(232), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7354] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(238), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(236), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7391] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(142), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7428] = 18,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(386), 1,
      anon_sym_STAR,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(72), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    STATE(782), 1,
      sym_select_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(714), 2,
      sym__select_expression,
      sym_all_fields,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(73), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7495] = 4,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 22,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
  [7534] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(148), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(146), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7571] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(282), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(280), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7608] = 18,
    ACTIONS(386), 1,
      anon_sym_STAR,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(295), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    STATE(782), 1,
      sym_select_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(871), 2,
      sym__select_expression,
      sym_all_fields,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(276), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7675] = 18,
    ACTIONS(386), 1,
      anon_sym_STAR,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(295), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    STATE(1088), 1,
      sym_select_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(871), 2,
      sym__select_expression,
      sym_all_fields,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(276), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7742] = 4,
    ACTIONS(436), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(136), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7781] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7818] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(170), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(168), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7855] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(178), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(176), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7892] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(264), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(210), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(208), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [7966] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(158), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(156), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8003] = 9,
    ACTIONS(330), 1,
      sym_keyword_in,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(182), 19,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [8052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(206), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(204), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8089] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(218), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(216), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8126] = 9,
    ACTIONS(330), 1,
      sym_keyword_in,
    ACTIONS(344), 1,
      anon_sym_PLUS,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      anon_sym_SLASH,
    ACTIONS(350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(228), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(340), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(226), 19,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [8175] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(250), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(248), 23,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8212] = 13,
    ACTIONS(246), 1,
      sym_keyword_or,
    ACTIONS(438), 1,
      sym_keyword_in,
    ACTIONS(440), 1,
      sym_keyword_is,
    ACTIONS(448), 1,
      anon_sym_PLUS,
    ACTIONS(450), 1,
      anon_sym_DASH,
    ACTIONS(452), 1,
      anon_sym_SLASH,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(456), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(444), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(446), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(442), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(244), 11,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      anon_sym_RPAREN,
  [8268] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(160), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8306] = 14,
    ACTIONS(460), 1,
      sym_keyword_in,
    ACTIONS(462), 1,
      sym_keyword_and,
    ACTIONS(464), 1,
      sym_keyword_or,
    ACTIONS(466), 1,
      sym_keyword_is,
    ACTIONS(474), 1,
      anon_sym_PLUS,
    ACTIONS(476), 1,
      anon_sym_DASH,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(472), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(468), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(458), 10,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [8364] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(264), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(212), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8436] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(172), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(27), 22,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8508] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(142), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(31), 22,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8580] = 17,
    ACTIONS(386), 1,
      anon_sym_STAR,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(295), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(753), 2,
      sym__select_expression,
      sym_all_fields,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(276), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8644] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(170), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(168), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8680] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(178), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(176), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(210), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(208), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8752] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(158), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(156), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8788] = 9,
    ACTIONS(438), 1,
      sym_keyword_in,
    ACTIONS(448), 1,
      anon_sym_PLUS,
    ACTIONS(450), 1,
      anon_sym_DASH,
    ACTIONS(452), 1,
      anon_sym_SLASH,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(444), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(186), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(182), 17,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [8836] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(206), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(204), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8872] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(218), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(216), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8908] = 9,
    ACTIONS(438), 1,
      sym_keyword_in,
    ACTIONS(448), 1,
      anon_sym_PLUS,
    ACTIONS(450), 1,
      anon_sym_DASH,
    ACTIONS(452), 1,
      anon_sym_SLASH,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(444), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(228), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(226), 17,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [8956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(250), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(248), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [8992] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(274), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(272), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9028] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(282), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(280), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(278), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(276), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9100] = 5,
    ACTIONS(484), 1,
      anon_sym_LPAREN,
    ACTIONS(486), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(102), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9140] = 12,
    ACTIONS(270), 1,
      sym_keyword_or,
    ACTIONS(438), 1,
      sym_keyword_in,
    ACTIONS(440), 1,
      sym_keyword_is,
    ACTIONS(448), 1,
      anon_sym_PLUS,
    ACTIONS(450), 1,
      anon_sym_DASH,
    ACTIONS(452), 1,
      anon_sym_SLASH,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(444), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(446), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(442), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 12,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [9194] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(170), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(168), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(178), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(176), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(210), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(208), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(158), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(156), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9338] = 9,
    ACTIONS(460), 1,
      sym_keyword_in,
    ACTIONS(474), 1,
      anon_sym_PLUS,
    ACTIONS(476), 1,
      anon_sym_DASH,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(186), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(182), 17,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [9386] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(206), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(204), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9422] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(218), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(216), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9458] = 9,
    ACTIONS(460), 1,
      sym_keyword_in,
    ACTIONS(474), 1,
      anon_sym_PLUS,
    ACTIONS(476), 1,
      anon_sym_DASH,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(228), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(226), 17,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [9506] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(250), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(248), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9542] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(264), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9578] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(274), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(272), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9614] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(282), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(280), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9650] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(212), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9686] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9722] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(278), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(276), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(172), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9794] = 12,
    ACTIONS(270), 1,
      sym_keyword_or,
    ACTIONS(460), 1,
      sym_keyword_in,
    ACTIONS(466), 1,
      sym_keyword_is,
    ACTIONS(474), 1,
      anon_sym_PLUS,
    ACTIONS(476), 1,
      anon_sym_DASH,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(472), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(468), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 12,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
  [9848] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [9884] = 6,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(270), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(268), 18,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
  [9926] = 4,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 20,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
  [9964] = 6,
    ACTIONS(452), 1,
      anon_sym_SLASH,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(444), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(270), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(268), 18,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
  [10006] = 4,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 20,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
  [10044] = 9,
    ACTIONS(460), 1,
      sym_keyword_in,
    ACTIONS(474), 1,
      anon_sym_PLUS,
    ACTIONS(476), 1,
      anon_sym_DASH,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 17,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [10092] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(262), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(260), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10128] = 13,
    ACTIONS(246), 1,
      sym_keyword_or,
    ACTIONS(460), 1,
      sym_keyword_in,
    ACTIONS(466), 1,
      sym_keyword_is,
    ACTIONS(474), 1,
      anon_sym_PLUS,
    ACTIONS(476), 1,
      anon_sym_DASH,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(472), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(468), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(244), 11,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [10184] = 8,
    ACTIONS(474), 1,
      anon_sym_PLUS,
    ACTIONS(476), 1,
      anon_sym_DASH,
    ACTIONS(478), 1,
      anon_sym_SLASH,
    ACTIONS(480), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(470), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 17,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [10230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(242), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(240), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(238), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(236), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(142), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10338] = 17,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(386), 1,
      anon_sym_STAR,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(72), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(753), 2,
      sym__select_expression,
      sym_all_fields,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(73), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10402] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(234), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(232), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10438] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(148), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(146), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10474] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 21,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10510] = 9,
    ACTIONS(438), 1,
      sym_keyword_in,
    ACTIONS(448), 1,
      anon_sym_PLUS,
    ACTIONS(450), 1,
      anon_sym_DASH,
    ACTIONS(452), 1,
      anon_sym_SLASH,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(444), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 17,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [10558] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(262), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(260), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10594] = 8,
    ACTIONS(448), 1,
      anon_sym_PLUS,
    ACTIONS(450), 1,
      anon_sym_DASH,
    ACTIONS(452), 1,
      anon_sym_SLASH,
    ACTIONS(454), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(444), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 17,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [10640] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(242), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(240), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10676] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(230), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10714] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(230), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10752] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(238), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(236), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10788] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(224), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10826] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(224), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10864] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(234), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(232), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10900] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(148), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(146), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10936] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(198), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [10974] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(198), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11012] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(222), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11050] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(222), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11088] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(220), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11126] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(180), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11164] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(180), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11202] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(220), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11240] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(202), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11278] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(202), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11316] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(150), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11354] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(200), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11392] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(200), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11430] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(166), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11468] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(166), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11506] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(150), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11544] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(160), 10,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(164), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11582] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 21,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11618] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(953), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(578), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [11681] = 5,
    ACTIONS(508), 1,
      anon_sym_LPAREN,
    ACTIONS(510), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(102), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [11720] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(512), 9,
      sym_keyword_order_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(154), 11,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [11757] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1020), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(583), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [11820] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1160), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [11883] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1025), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(576), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [11946] = 19,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(292), 1,
      sym_keyword_from,
    ACTIONS(294), 1,
      sym_keyword_as,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(516), 1,
      sym_keyword_in,
    ACTIONS(520), 1,
      sym_keyword_is,
    ACTIONS(528), 1,
      anon_sym_PLUS,
    ACTIONS(530), 1,
      anon_sym_DASH,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(536), 1,
      anon_sym_PIPE_PIPE,
    STATE(749), 1,
      sym__alias,
    STATE(750), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(518), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(526), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(302), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(522), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [12013] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1044), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(579), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12076] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1065), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(581), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12139] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(955), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(587), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12202] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1058), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(589), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12265] = 17,
    ACTIONS(538), 1,
      sym_keyword_left,
    ACTIONS(540), 1,
      sym_keyword_right,
    ACTIONS(544), 1,
      sym_keyword_join,
    ACTIONS(546), 1,
      sym_keyword_where,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(550), 1,
      sym_keyword_group_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(554), 1,
      sym_index_hint,
    STATE(684), 1,
      sym_where,
    STATE(701), 1,
      sym_group_by,
    STATE(763), 1,
      sym_order_by,
    STATE(794), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(542), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
    STATE(555), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
    ACTIONS(556), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [12328] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(490), 1,
      sym_keyword_select,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(973), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(591), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12391] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(558), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1184), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12454] = 17,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(562), 1,
      anon_sym_COMMA,
    STATE(837), 1,
      aux_sym_order_expression_repeat1,
    STATE(842), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(328), 4,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [12517] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(564), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1173), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12580] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1154), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12643] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1243), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12706] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1298), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12769] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1344), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12832] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(31), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [12867] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(574), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1277), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [12930] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(27), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [12965] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      anon_sym_RPAREN,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(1295), 1,
      sym__function_params,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(584), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [13028] = 4,
    ACTIONS(578), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(136), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13065] = 5,
    ACTIONS(508), 1,
      anon_sym_LPAREN,
    ACTIONS(580), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(104), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(102), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [13104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(212), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13138] = 16,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    STATE(765), 1,
      sym_order_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(76), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [13198] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(148), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(146), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13232] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(234), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(232), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(142), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13300] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(238), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(236), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(242), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(240), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13368] = 8,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 16,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [13412] = 13,
    ACTIONS(246), 1,
      sym_keyword_or,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(612), 1,
      sym_keyword_is,
    ACTIONS(618), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(616), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(614), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(244), 9,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [13466] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(262), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(260), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13500] = 9,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 15,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [13546] = 4,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 19,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
  [13582] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(620), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(637), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [13642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(170), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(168), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13676] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(264), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13710] = 12,
    ACTIONS(270), 1,
      sym_keyword_or,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(612), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(616), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(614), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 10,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
  [13762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(172), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13796] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(278), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(276), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13830] = 4,
    ACTIONS(622), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(136), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [13866] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(178), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(176), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [13900] = 16,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    STATE(711), 1,
      sym_where_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(551), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [13960] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(765), 1,
      sym_order_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(284), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14020] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(609), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14080] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(711), 1,
      sym_where_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(577), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14140] = 4,
    ACTIONS(644), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(138), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(136), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [14176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(158), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(156), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14210] = 16,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    STATE(711), 1,
      sym_where_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(186), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14270] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(164), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14304] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(282), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(280), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14338] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(274), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(272), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(268), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14406] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(664), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(665), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14466] = 6,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(270), 4,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(268), 17,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
  [14506] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(666), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(636), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14566] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(250), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(248), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14600] = 9,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(228), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(226), 15,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [14646] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(668), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(631), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14706] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(670), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(613), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14766] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(218), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(216), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14800] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(672), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(628), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(206), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(204), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [14894] = 9,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(186), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(182), 15,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
  [14940] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(674), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(600), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15000] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(676), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(653), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15060] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    STATE(761), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(426), 5,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [15118] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(678), 1,
      sym_keyword_distinct,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(662), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15178] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(680), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(618), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15238] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(210), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(208), 20,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [15272] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(682), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(615), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15332] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(684), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(614), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15392] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(686), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(612), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15452] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(688), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(604), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15512] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(690), 1,
      sym_keyword_when,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(602), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15572] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(267), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(692), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15633] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(50), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(694), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15694] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(148), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(146), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [15727] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(172), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [15760] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(162), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(164), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [15793] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(570), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15850] = 12,
    ACTIONS(516), 1,
      sym_keyword_in,
    ACTIONS(520), 1,
      sym_keyword_is,
    ACTIONS(528), 1,
      anon_sym_PLUS,
    ACTIONS(530), 1,
      anon_sym_DASH,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(526), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(522), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(268), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(270), 5,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym__identifier,
  [15901] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(146), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15958] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(268), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [15991] = 6,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(268), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(270), 10,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [16030] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(620), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16087] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(622), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16146] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(625), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16203] = 4,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(270), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(268), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [16238] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(626), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16297] = 9,
    ACTIONS(516), 1,
      sym_keyword_in,
    ACTIONS(528), 1,
      anon_sym_PLUS,
    ACTIONS(530), 1,
      anon_sym_DASH,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(246), 8,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
    ACTIONS(244), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [16342] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(627), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16399] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(629), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16458] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(632), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16515] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(262), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(260), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [16548] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(639), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16607] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(640), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16664] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(643), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16723] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(644), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16780] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(645), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16839] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(647), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16896] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(648), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16955] = 13,
    ACTIONS(516), 1,
      sym_keyword_in,
    ACTIONS(520), 1,
      sym_keyword_is,
    ACTIONS(528), 1,
      anon_sym_PLUS,
    ACTIONS(530), 1,
      anon_sym_DASH,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(526), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(244), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    ACTIONS(522), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(246), 5,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym__identifier,
  [17008] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(587), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17065] = 8,
    ACTIONS(528), 1,
      anon_sym_PLUS,
    ACTIONS(530), 1,
      anon_sym_DASH,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(244), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(246), 9,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [17108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(212), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [17141] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(242), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(240), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [17174] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(238), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(236), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [17207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(142), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [17240] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(282), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(280), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [17273] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(355), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17330] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(357), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17387] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(358), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17444] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(491), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17501] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(362), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17558] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(364), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17615] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(376), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17672] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(657), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17729] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(598), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17786] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(664), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17843] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(558), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17900] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(564), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17957] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(663), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18014] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(660), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18071] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(34), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(696), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18132] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(659), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18189] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(658), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18246] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(567), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18303] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(135), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18360] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(568), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18417] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(654), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18474] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(272), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(670), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18533] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(651), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18590] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(650), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18647] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(642), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18704] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(378), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18761] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(571), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18818] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(559), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18875] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(278), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(276), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [18908] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(638), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18965] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(445), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19022] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(635), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19079] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(617), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19138] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(616), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19195] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(634), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19252] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(633), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19309] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(274), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(272), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [19342] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(569), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19399] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(566), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19456] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(630), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19513] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(264), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [19546] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(624), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19603] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(623), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19660] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(621), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19717] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(560), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19774] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(565), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19831] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(619), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19888] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(608), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19945] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(607), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20002] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(606), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20059] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(561), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20116] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(562), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20173] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(646), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20230] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(641), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20287] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(649), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20344] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(652), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20401] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(573), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20458] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(572), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20515] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(656), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20572] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(95), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20629] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(250), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(248), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [20662] = 9,
    ACTIONS(516), 1,
      sym_keyword_in,
    ACTIONS(528), 1,
      anon_sym_PLUS,
    ACTIONS(530), 1,
      anon_sym_DASH,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(228), 8,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
    ACTIONS(226), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [20707] = 15,
    ACTIONS(406), 1,
      sym__identifier,
    ACTIONS(410), 1,
      sym_keyword_count,
    ACTIONS(412), 1,
      sym_keyword_case,
    ACTIONS(416), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_SQUOTE,
    ACTIONS(420), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      sym__number,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    STATE(271), 1,
      sym_identifier,
    STATE(351), 1,
      sym_invocation,
    STATE(353), 1,
      sym__literal_string,
    STATE(483), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(414), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(449), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20764] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(218), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(216), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [20797] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(206), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(204), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [20830] = 9,
    ACTIONS(516), 1,
      sym_keyword_in,
    ACTIONS(528), 1,
      anon_sym_PLUS,
    ACTIONS(530), 1,
      anon_sym_DASH,
    ACTIONS(532), 1,
      anon_sym_SLASH,
    ACTIONS(534), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(524), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(186), 8,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
    ACTIONS(182), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [20875] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(158), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(156), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [20908] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(88), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20965] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(210), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(208), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [20998] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(178), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(176), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [21031] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(170), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(168), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [21064] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(233), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21121] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(232), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21178] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(230), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21235] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(227), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21292] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(226), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21349] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(225), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21406] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(224), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21463] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(215), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21520] = 15,
    ACTIONS(646), 1,
      sym__identifier,
    ACTIONS(648), 1,
      sym_keyword_count,
    ACTIONS(650), 1,
      sym_keyword_case,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DQUOTE,
    ACTIONS(660), 1,
      sym__number,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    STATE(137), 1,
      sym_identifier,
    STATE(238), 1,
      sym__count_function,
    STATE(239), 1,
      sym_invocation,
    STATE(240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(652), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(212), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21577] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(159), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21634] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(156), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21691] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(106), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21748] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(107), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21805] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(109), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21862] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(110), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21919] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(28), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(698), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21980] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(111), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22037] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(113), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22094] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(20), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(700), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22155] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(114), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22212] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(153), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22269] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(167), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22326] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(157), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22383] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(152), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22440] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(154), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22497] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(182), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22554] = 15,
    ACTIONS(582), 1,
      sym__identifier,
    ACTIONS(584), 1,
      sym_keyword_count,
    ACTIONS(586), 1,
      sym_keyword_case,
    ACTIONS(590), 1,
      anon_sym_LPAREN,
    ACTIONS(592), 1,
      anon_sym_SQUOTE,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      sym__number,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    STATE(79), 1,
      sym_identifier,
    STATE(163), 1,
      sym__count_function,
    STATE(168), 1,
      sym_invocation,
    STATE(173), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(588), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(179), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22611] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(303), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22668] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(234), 11,
      sym_keyword_from,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
    ACTIONS(232), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_BQUOTE,
  [22701] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(304), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22758] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(306), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22815] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(307), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22872] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(328), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22929] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(326), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22986] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(311), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23043] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(599), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23100] = 14,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(612), 1,
      sym_keyword_is,
    ACTIONS(618), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(704), 1,
      sym_keyword_and,
    ACTIONS(706), 1,
      sym_keyword_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(616), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(614), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(702), 7,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [23155] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(595), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23212] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(611), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23269] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(47), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(708), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23330] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(605), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23387] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(603), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23444] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(331), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23501] = 15,
    ACTIONS(624), 1,
      sym__identifier,
    ACTIONS(626), 1,
      sym_keyword_count,
    ACTIONS(628), 1,
      sym_keyword_case,
    ACTIONS(632), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_SQUOTE,
    ACTIONS(636), 1,
      anon_sym_DQUOTE,
    ACTIONS(638), 1,
      sym__number,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    STATE(206), 1,
      sym_identifier,
    STATE(298), 1,
      sym_invocation,
    STATE(299), 1,
      sym__count_function,
    STATE(323), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(630), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(337), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23558] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(580), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23615] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(592), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23672] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(55), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23729] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(57), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23786] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(44), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(728), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23847] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(563), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23904] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(60), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23961] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(245), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(730), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24022] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(248), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(732), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24083] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(42), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(734), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24144] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(254), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(736), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24205] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(256), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(738), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24266] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(260), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(740), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24327] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(61), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24384] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(263), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(742), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24445] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(265), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(744), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24506] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(185), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(746), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24567] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(147), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24624] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(258), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(748), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24685] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(62), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24742] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(574), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(669), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24801] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(340), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24858] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(597), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24915] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(253), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(750), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(673), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24976] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(64), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25033] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(36), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(752), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25094] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(557), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25151] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(65), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25208] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(23), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(754), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25269] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(48), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25326] = 15,
    ACTIONS(710), 1,
      sym__identifier,
    ACTIONS(712), 1,
      sym_keyword_count,
    ACTIONS(714), 1,
      sym_keyword_case,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_SQUOTE,
    ACTIONS(722), 1,
      anon_sym_DQUOTE,
    ACTIONS(724), 1,
      sym__number,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    STATE(13), 1,
      sym_identifier,
    STATE(19), 1,
      sym_invocation,
    STATE(45), 1,
      sym__literal_string,
    STATE(52), 1,
      sym__count_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(716), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(29), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25383] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(31), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(756), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25444] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(108), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25501] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(243), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25558] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(184), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25615] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(241), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25672] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(229), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25729] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(228), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25786] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(221), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25843] = 17,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(496), 1,
      sym_keyword_null,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(33), 1,
      sym_predicate,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(776), 2,
      sym_keyword_true,
      sym_keyword_false,
    STATE(671), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25904] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(207), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25961] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(127), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26018] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(139), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26075] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(585), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26132] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(198), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26189] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(142), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26246] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(143), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26303] = 15,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(601), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26360] = 15,
    ACTIONS(758), 1,
      sym__identifier,
    ACTIONS(760), 1,
      sym_keyword_count,
    ACTIONS(762), 1,
      sym_keyword_case,
    ACTIONS(766), 1,
      anon_sym_LPAREN,
    ACTIONS(768), 1,
      anon_sym_SQUOTE,
    ACTIONS(770), 1,
      anon_sym_DQUOTE,
    ACTIONS(772), 1,
      sym__number,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    STATE(94), 1,
      sym_identifier,
    STATE(250), 1,
      sym__count_function,
    STATE(251), 1,
      sym_invocation,
    STATE(269), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(764), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(201), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26417] = 16,
    ACTIONS(488), 1,
      sym__identifier,
    ACTIONS(492), 1,
      sym_keyword_count,
    ACTIONS(494), 1,
      sym_keyword_case,
    ACTIONS(498), 1,
      anon_sym_LPAREN,
    ACTIONS(500), 1,
      anon_sym_SQUOTE,
    ACTIONS(502), 1,
      anon_sym_DQUOTE,
    ACTIONS(504), 1,
      sym__number,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(74), 1,
      sym_identifier,
    STATE(118), 1,
      sym__count_function,
    STATE(119), 1,
      sym_invocation,
    STATE(121), 1,
      sym__literal_string,
    STATE(610), 1,
      sym_predicate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(496), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(666), 8,
      sym_case,
      sym_field,
      sym_function_call,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26476] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(145), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26533] = 15,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym_keyword_count,
    ACTIONS(380), 1,
      sym_keyword_case,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      sym__number,
    STATE(70), 1,
      sym_identifier,
    STATE(78), 1,
      sym__literal_string,
    STATE(133), 1,
      sym__count_function,
    STATE(136), 1,
      sym_invocation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(382), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(102), 9,
      sym_case,
      sym_field,
      sym_function_call,
      sym_predicate,
      sym__expression,
      sym_binary_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26590] = 14,
    ACTIONS(602), 1,
      anon_sym_PLUS,
    ACTIONS(604), 1,
      anon_sym_DASH,
    ACTIONS(606), 1,
      anon_sym_SLASH,
    ACTIONS(608), 1,
      anon_sym_CARET,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(612), 1,
      sym_keyword_is,
    ACTIONS(618), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(704), 1,
      sym_keyword_and,
    ACTIONS(706), 1,
      sym_keyword_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(600), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(616), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(614), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(458), 6,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [26644] = 8,
    ACTIONS(778), 1,
      sym__identifier,
    ACTIONS(784), 1,
      sym_keyword_as,
    ACTIONS(786), 1,
      anon_sym_DOT,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    STATE(582), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(782), 4,
      sym_keyword_order_by,
      sym_keyword_group_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(780), 14,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_limit,
      sym_keyword_force,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [26686] = 15,
    ACTIONS(538), 1,
      sym_keyword_left,
    ACTIONS(540), 1,
      sym_keyword_right,
    ACTIONS(544), 1,
      sym_keyword_join,
    ACTIONS(546), 1,
      sym_keyword_where,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(550), 1,
      sym_keyword_group_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(682), 1,
      sym_where,
    STATE(705), 1,
      sym_group_by,
    STATE(730), 1,
      sym_order_by,
    STATE(796), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(542), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(593), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
    ACTIONS(790), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [26742] = 15,
    ACTIONS(538), 1,
      sym_keyword_left,
    ACTIONS(540), 1,
      sym_keyword_right,
    ACTIONS(544), 1,
      sym_keyword_join,
    ACTIONS(546), 1,
      sym_keyword_where,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(550), 1,
      sym_keyword_group_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(683), 1,
      sym_where,
    STATE(698), 1,
      sym_group_by,
    STATE(754), 1,
      sym_order_by,
    STATE(793), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(542), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(553), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
    ACTIONS(792), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [26798] = 15,
    ACTIONS(538), 1,
      sym_keyword_left,
    ACTIONS(540), 1,
      sym_keyword_right,
    ACTIONS(544), 1,
      sym_keyword_join,
    ACTIONS(546), 1,
      sym_keyword_where,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(550), 1,
      sym_keyword_group_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(683), 1,
      sym_where,
    STATE(698), 1,
      sym_group_by,
    STATE(754), 1,
      sym_order_by,
    STATE(793), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(542), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(593), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
    ACTIONS(792), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [26854] = 7,
    ACTIONS(778), 1,
      sym__identifier,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(798), 1,
      sym_keyword_as,
    STATE(590), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(796), 4,
      sym_keyword_order_by,
      sym_keyword_group_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(794), 14,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_limit,
      sym_keyword_force,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [26893] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(702), 5,
      sym_keyword_where,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [26944] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(802), 1,
      sym_keyword_else,
    ACTIONS(804), 1,
      sym_keyword_end,
    STATE(942), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27000] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(808), 1,
      sym_keyword_else,
    ACTIONS(810), 1,
      sym_keyword_end,
    STATE(926), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27056] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(812), 1,
      sym_keyword_else,
    ACTIONS(814), 1,
      sym_keyword_end,
    STATE(916), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27112] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(816), 1,
      sym_keyword_else,
    ACTIONS(818), 1,
      sym_keyword_end,
    STATE(901), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27168] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(820), 1,
      sym_keyword_else,
    ACTIONS(822), 1,
      sym_keyword_end,
    STATE(887), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27224] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(824), 1,
      sym_keyword_else,
    ACTIONS(826), 1,
      sym_keyword_end,
    STATE(905), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27280] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(828), 1,
      sym_keyword_else,
    ACTIONS(830), 1,
      sym_keyword_end,
    STATE(940), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27336] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(832), 1,
      sym_keyword_else,
    ACTIONS(834), 1,
      sym_keyword_end,
    STATE(912), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27392] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(836), 1,
      sym_keyword_else,
    ACTIONS(838), 1,
      sym_keyword_end,
    STATE(918), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27448] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(840), 1,
      sym_keyword_else,
    ACTIONS(842), 1,
      sym_keyword_end,
    STATE(935), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27504] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(844), 1,
      sym_keyword_else,
    ACTIONS(846), 1,
      sym_keyword_end,
    STATE(932), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27560] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(848), 1,
      sym_keyword_else,
    ACTIONS(850), 1,
      sym_keyword_end,
    STATE(921), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27616] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(852), 1,
      sym_keyword_else,
    ACTIONS(854), 1,
      sym_keyword_end,
    STATE(923), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27672] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(856), 1,
      sym_keyword_else,
    ACTIONS(858), 1,
      sym_keyword_end,
    STATE(928), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27728] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(860), 1,
      sym_keyword_else,
    ACTIONS(862), 1,
      sym_keyword_end,
    STATE(910), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27784] = 16,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(864), 1,
      sym_keyword_else,
    ACTIONS(866), 1,
      sym_keyword_end,
    STATE(899), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27840] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(512), 3,
      sym_keyword_order_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
    ACTIONS(152), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 12,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [27871] = 17,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(556), 1,
      anon_sym_RPAREN,
    ACTIONS(868), 1,
      sym_keyword_left,
    ACTIONS(870), 1,
      sym_keyword_right,
    ACTIONS(874), 1,
      sym_keyword_join,
    ACTIONS(876), 1,
      sym_keyword_where,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(880), 1,
      sym_keyword_group_by,
    STATE(667), 1,
      sym_index_hint,
    STATE(763), 1,
      sym_order_by,
    STATE(794), 1,
      sym_limit,
    STATE(804), 1,
      sym_where,
    STATE(863), 1,
      sym_group_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
    ACTIONS(872), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(668), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
  [27928] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(882), 1,
      anon_sym_RPAREN,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    STATE(1029), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27981] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(458), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28030] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(886), 1,
      anon_sym_RPAREN,
    STATE(1042), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28083] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(888), 1,
      anon_sym_RPAREN,
    STATE(1037), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28136] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(890), 3,
      sym_keyword_when,
      sym_keyword_else,
      sym_keyword_end,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28185] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(892), 1,
      anon_sym_RPAREN,
    STATE(1053), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28238] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(894), 20,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [28265] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(896), 1,
      anon_sym_RPAREN,
    STATE(1021), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28318] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(898), 1,
      anon_sym_RPAREN,
    ACTIONS(900), 1,
      anon_sym_COMMA,
    STATE(961), 1,
      aux_sym__function_params_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28371] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(902), 3,
      sym_keyword_when,
      sym_keyword_else,
      sym_keyword_end,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28420] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(904), 20,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [28447] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(906), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28500] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(908), 20,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [28527] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(910), 1,
      anon_sym_RPAREN,
    STATE(1061), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28580] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(912), 20,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [28607] = 15,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(914), 1,
      anon_sym_RPAREN,
    STATE(984), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28660] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(916), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28708] = 7,
    ACTIONS(918), 1,
      sym_keyword_left,
    ACTIONS(921), 1,
      sym_keyword_right,
    ACTIONS(927), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(924), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(593), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
    ACTIONS(930), 11,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [28744] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(932), 19,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_using,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [28770] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(934), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28818] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(936), 19,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      sym_keyword_using,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [28844] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(938), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28892] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(940), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28939] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(942), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [28986] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(944), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29033] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(946), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29080] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(948), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29127] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(950), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29174] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(952), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29221] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(954), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29268] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(956), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29315] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(958), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29362] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(960), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29409] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(962), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29456] = 4,
    ACTIONS(964), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [29485] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(966), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29532] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(968), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29579] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(970), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29626] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(972), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29673] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(974), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29720] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(976), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29767] = 4,
    ACTIONS(978), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [29796] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(980), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29843] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(982), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29890] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(984), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29937] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(986), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29984] = 4,
    ACTIONS(988), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [30013] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(990), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30060] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(992), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30107] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(994), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30154] = 4,
    ACTIONS(996), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [30183] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(998), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30230] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1000), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30277] = 4,
    ACTIONS(1002), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [30306] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1004), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30353] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1006), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30400] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1008), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30447] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1010), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30494] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1012), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30541] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1014), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30588] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1016), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30635] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1018), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30682] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1020), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30729] = 4,
    ACTIONS(1022), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [30758] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1024), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30805] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1026), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30852] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1028), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30899] = 4,
    ACTIONS(1030), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [30928] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1032), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [30975] = 4,
    ACTIONS(1034), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [31004] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1036), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31051] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1038), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31098] = 4,
    ACTIONS(1040), 1,
      sym_keyword_then,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(152), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(154), 13,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
  [31127] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1042), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31174] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1044), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31221] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1046), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31268] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1048), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31315] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31362] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1052), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31409] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1054), 18,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [31434] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1056), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31481] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1058), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31528] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1060), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31575] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1062), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31622] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1064), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31669] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1066), 18,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [31694] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1068), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31741] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31788] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1072), 1,
      sym_keyword_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31835] = 13,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31882] = 12,
    ACTIONS(364), 1,
      sym_keyword_in,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(398), 1,
      sym_keyword_is,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(402), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(400), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31926] = 15,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    ACTIONS(868), 1,
      sym_keyword_left,
    ACTIONS(870), 1,
      sym_keyword_right,
    ACTIONS(874), 1,
      sym_keyword_join,
    ACTIONS(876), 1,
      sym_keyword_where,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(880), 1,
      sym_keyword_group_by,
    STATE(754), 1,
      sym_order_by,
    STATE(791), 1,
      sym_where,
    STATE(793), 1,
      sym_limit,
    STATE(884), 1,
      sym_group_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(872), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(672), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
  [31976] = 15,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    ACTIONS(868), 1,
      sym_keyword_left,
    ACTIONS(870), 1,
      sym_keyword_right,
    ACTIONS(874), 1,
      sym_keyword_join,
    ACTIONS(876), 1,
      sym_keyword_where,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(880), 1,
      sym_keyword_group_by,
    STATE(754), 1,
      sym_order_by,
    STATE(791), 1,
      sym_where,
    STATE(793), 1,
      sym_limit,
    STATE(884), 1,
      sym_group_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(872), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(685), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
  [32026] = 12,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(610), 1,
      sym_keyword_in,
    ACTIONS(612), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(616), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(704), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(614), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32070] = 12,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(466), 1,
      sym_keyword_is,
    ACTIONS(1076), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(462), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(472), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(468), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32114] = 12,
    ACTIONS(252), 1,
      sym_keyword_is,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1078), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1080), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(254), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32158] = 15,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(790), 1,
      anon_sym_RPAREN,
    ACTIONS(868), 1,
      sym_keyword_left,
    ACTIONS(870), 1,
      sym_keyword_right,
    ACTIONS(874), 1,
      sym_keyword_join,
    ACTIONS(876), 1,
      sym_keyword_where,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(880), 1,
      sym_keyword_group_by,
    STATE(730), 1,
      sym_order_by,
    STATE(786), 1,
      sym_where,
    STATE(796), 1,
      sym_limit,
    STATE(865), 1,
      sym_group_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(872), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(685), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
  [32208] = 12,
    ACTIONS(368), 1,
      anon_sym_PLUS,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_CARET,
    ACTIONS(404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(440), 1,
      sym_keyword_is,
    ACTIONS(1082), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(366), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(446), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1084), 2,
      sym_keyword_and,
      sym_keyword_or,
    ACTIONS(442), 4,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32252] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(220), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32275] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(160), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32298] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(180), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32321] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(198), 16,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32344] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(13), 1,
      sym_keyword_update,
    ACTIONS(1086), 1,
      anon_sym_COMMA,
    STATE(679), 1,
      aux_sym__dml_statement_repeat1,
    STATE(715), 1,
      sym_select,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(1348), 4,
      sym__select_statement,
      sym__delete_statement,
      sym__insert_statement,
      sym__update_statement,
  [32386] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(13), 1,
      sym_keyword_update,
    ACTIONS(1086), 1,
      anon_sym_COMMA,
    STATE(715), 1,
      sym_select,
    STATE(787), 1,
      aux_sym__dml_statement_repeat1,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(1258), 4,
      sym__select_statement,
      sym__delete_statement,
      sym__insert_statement,
      sym__update_statement,
  [32428] = 3,
    ACTIONS(1090), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1088), 13,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_alter,
      sym_keyword_drop,
      sym_keyword_add,
      sym_keyword_as,
      sym_keyword_cascade,
      sym_keyword_rename,
      sym_keyword_owner,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [32451] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1092), 13,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_begin,
      sym_keyword_commit,
      sym_keyword_rollback,
  [32471] = 8,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(550), 1,
      sym_keyword_group_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(697), 1,
      sym_group_by,
    STATE(760), 1,
      sym_order_by,
    STATE(797), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1094), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32503] = 8,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(550), 1,
      sym_keyword_group_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(705), 1,
      sym_group_by,
    STATE(730), 1,
      sym_order_by,
    STATE(796), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(790), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32535] = 8,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(550), 1,
      sym_keyword_group_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(698), 1,
      sym_group_by,
    STATE(754), 1,
      sym_order_by,
    STATE(793), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(792), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32567] = 7,
    ACTIONS(1096), 1,
      sym_keyword_left,
    ACTIONS(1099), 1,
      sym_keyword_right,
    ACTIONS(1105), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1102), 2,
      sym_keyword_inner,
      sym_keyword_cross,
    STATE(685), 3,
      sym_join,
      sym_lateral_join,
      aux_sym_from_repeat1,
    ACTIONS(930), 5,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
  [32597] = 9,
    ACTIONS(1108), 1,
      sym_keyword_set,
    ACTIONS(1110), 1,
      sym_keyword_alter,
    ACTIONS(1112), 1,
      sym_keyword_drop,
    ACTIONS(1114), 1,
      sym_keyword_add,
    ACTIONS(1116), 1,
      sym_keyword_rename,
    ACTIONS(1118), 1,
      sym_keyword_owner,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1008), 3,
      sym_add_column,
      sym_alter_column,
      sym_drop_column,
    STATE(1245), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [32631] = 10,
    ACTIONS(1120), 1,
      sym_keyword_primary,
    ACTIONS(1122), 1,
      sym_keyword_not,
    ACTIONS(1124), 1,
      sym_keyword_auto_increment,
    ACTIONS(1126), 1,
      sym_keyword_default,
    STATE(830), 1,
      sym__primary_key,
    STATE(1026), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    STATE(737), 2,
      sym__not_null,
      sym__default_null,
    ACTIONS(1128), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [32667] = 10,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(13), 1,
      sym_keyword_update,
    STATE(715), 1,
      sym_select,
    STATE(922), 1,
      sym_insert,
    STATE(925), 1,
      sym_update,
    STATE(1117), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(1200), 4,
      sym__select_statement,
      sym__delete_statement,
      sym__insert_statement,
      sym__update_statement,
  [32703] = 9,
    ACTIONS(1108), 1,
      sym_keyword_set,
    ACTIONS(1110), 1,
      sym_keyword_alter,
    ACTIONS(1112), 1,
      sym_keyword_drop,
    ACTIONS(1114), 1,
      sym_keyword_add,
    ACTIONS(1116), 1,
      sym_keyword_rename,
    ACTIONS(1118), 1,
      sym_keyword_owner,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(995), 3,
      sym_add_column,
      sym_alter_column,
      sym_drop_column,
    STATE(1286), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [32737] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1130), 13,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_alter,
      sym_keyword_drop,
      sym_keyword_add,
      sym_keyword_as,
      sym_keyword_cascade,
      sym_keyword_rename,
      sym_keyword_owner,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [32757] = 13,
    ACTIONS(778), 1,
      sym__identifier,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1132), 1,
      sym_keyword_primary,
    ACTIONS(1134), 1,
      sym_keyword_key,
    ACTIONS(1136), 1,
      sym_keyword_constraint,
    STATE(7), 1,
      sym_identifier,
    STATE(1052), 1,
      sym_constraint,
    STATE(1122), 1,
      sym__primary_key,
    STATE(1123), 1,
      sym_column_definition,
    STATE(1129), 1,
      sym__constraint_literal,
    STATE(1132), 1,
      sym__primary_key_constraint,
    STATE(1133), 1,
      sym__key_constraint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [32798] = 8,
    ACTIONS(778), 1,
      sym__identifier,
    ACTIONS(784), 1,
      sym_keyword_as,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1138), 1,
      anon_sym_DOT,
    STATE(582), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(780), 3,
      sym_keyword_where,
      sym_keyword_limit,
      sym_keyword_returning,
    ACTIONS(782), 3,
      sym_keyword_order_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32828] = 4,
    ACTIONS(1142), 1,
      sym_keyword_having,
    STATE(757), 1,
      sym__having,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1140), 9,
      sym_keyword_order_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32850] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1144), 11,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_commit,
      sym_keyword_rollback,
  [32868] = 4,
    ACTIONS(1148), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(1150), 1,
      aux_sym_keyword_timestamp_token2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1146), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [32890] = 3,
    ACTIONS(1154), 1,
      aux_sym_keyword_varchar_token2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1152), 10,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [32910] = 6,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(755), 1,
      sym_order_by,
    STATE(805), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1156), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32936] = 6,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(730), 1,
      sym_order_by,
    STATE(796), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(790), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [32962] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1158), 11,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_begin,
  [32980] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1160), 11,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_begin,
  [32998] = 6,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(754), 1,
      sym_order_by,
    STATE(793), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(792), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33024] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1162), 11,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_begin,
  [33042] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1164), 11,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_begin,
  [33060] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1166), 11,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_begin,
  [33078] = 6,
    ACTIONS(548), 1,
      sym_keyword_order_by,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(760), 1,
      sym_order_by,
    STATE(797), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1094), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33104] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1168), 11,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_begin,
  [33122] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1170), 11,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_drop,
      aux_sym_keyword_with_token1,
      sym_keyword_commit,
      sym_keyword_rollback,
  [33140] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(27), 3,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_BQUOTE,
    ACTIONS(25), 7,
      sym_keyword_on,
      sym_keyword_as,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_default,
      sym__identifier,
  [33159] = 3,
    ACTIONS(1174), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1172), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33178] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1176), 10,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33195] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1178), 10,
      sym_keyword_order_by,
      sym_keyword_group_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33212] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(31), 3,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_BQUOTE,
    ACTIONS(29), 7,
      sym_keyword_on,
      sym_keyword_as,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_default,
      sym__identifier,
  [33231] = 4,
    ACTIONS(1182), 1,
      anon_sym_COMMA,
    STATE(713), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1180), 8,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33252] = 4,
    ACTIONS(1187), 1,
      anon_sym_COMMA,
    STATE(723), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1185), 8,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33273] = 7,
    ACTIONS(1189), 1,
      sym_keyword_from,
    ACTIONS(1193), 1,
      sym_keyword_union,
    STATE(775), 1,
      sym_from,
    STATE(783), 1,
      aux_sym__select_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1195), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(1191), 4,
      aux_sym_keyword_with_token1,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33300] = 4,
    ACTIONS(336), 1,
      anon_sym_COMMA,
    STATE(719), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1197), 8,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33321] = 4,
    ACTIONS(336), 1,
      anon_sym_COMMA,
    STATE(719), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1199), 8,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33342] = 4,
    ACTIONS(336), 1,
      anon_sym_COMMA,
    STATE(716), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1199), 8,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33363] = 4,
    ACTIONS(1201), 1,
      anon_sym_COMMA,
    STATE(719), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(426), 8,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(25), 5,
      sym_keyword_where,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_returning,
      sym__identifier,
    ACTIONS(27), 5,
      sym_keyword_order_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_BQUOTE,
  [33403] = 3,
    ACTIONS(1206), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1204), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33422] = 3,
    ACTIONS(1210), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1208), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33441] = 4,
    ACTIONS(1187), 1,
      anon_sym_COMMA,
    STATE(713), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1212), 8,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33462] = 3,
    ACTIONS(1216), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1214), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33481] = 7,
    ACTIONS(778), 1,
      sym__identifier,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(798), 1,
      sym_keyword_as,
    STATE(590), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(794), 3,
      sym_keyword_where,
      sym_keyword_limit,
      sym_keyword_returning,
    ACTIONS(796), 3,
      sym_keyword_order_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33508] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1152), 10,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33525] = 3,
    ACTIONS(1220), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1218), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33544] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1222), 10,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33561] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(29), 5,
      sym_keyword_where,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_returning,
      sym__identifier,
    ACTIONS(31), 5,
      sym_keyword_order_by,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_BQUOTE,
  [33580] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(797), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1094), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33600] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1224), 9,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33616] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1226), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33632] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1228), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33648] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1230), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33664] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1232), 1,
      sym_keyword_as,
    ACTIONS(1234), 1,
      anon_sym_DOT,
    STATE(582), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(780), 4,
      sym_keyword_on,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
  [33690] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1236), 9,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33706] = 7,
    ACTIONS(1120), 1,
      sym_keyword_primary,
    ACTIONS(1238), 1,
      sym_keyword_auto_increment,
    STATE(807), 1,
      sym__primary_key,
    STATE(1023), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(1240), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33732] = 8,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(876), 1,
      sym_keyword_where,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    STATE(800), 1,
      sym_where,
    STATE(875), 1,
      sym_order_by,
    STATE(958), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1242), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33760] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1244), 9,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33776] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1246), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33792] = 4,
    ACTIONS(1248), 1,
      sym_keyword_offset,
    STATE(806), 1,
      sym_offset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1250), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33812] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1252), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33828] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1254), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33844] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1256), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33860] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1258), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33876] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1260), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33892] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1262), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33908] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1264), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33924] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1266), 9,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33940] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1268), 9,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33956] = 4,
    ACTIONS(1189), 1,
      sym_keyword_from,
    STATE(789), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1270), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33976] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1272), 9,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [33992] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1274), 9,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34008] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(796), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(790), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34028] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(803), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1276), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34048] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1278), 9,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34064] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1280), 9,
      sym_keyword_order_by,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34080] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1282), 9,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_default,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34096] = 8,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(876), 1,
      sym_keyword_where,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    STATE(802), 1,
      sym_where,
    STATE(862), 1,
      sym_order_by,
    STATE(965), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1284), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34124] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(805), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1156), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34144] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1286), 9,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34160] = 4,
    ACTIONS(1189), 1,
      sym_keyword_from,
    STATE(785), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1288), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34180] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(793), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(792), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34200] = 6,
    ACTIONS(1120), 1,
      sym_keyword_primary,
    STATE(808), 1,
      sym__primary_key,
    STATE(1000), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(1290), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34223] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1292), 8,
      sym_keyword_limit,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34238] = 5,
    ACTIONS(1193), 1,
      sym_keyword_union,
    STATE(784), 1,
      aux_sym__select_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1195), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(1294), 4,
      aux_sym_keyword_with_token1,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1296), 8,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34274] = 4,
    ACTIONS(1300), 1,
      anon_sym_COMMA,
    STATE(777), 1,
      aux_sym_assignment_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1298), 6,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34293] = 6,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    STATE(78), 1,
      sym__literal_string,
    STATE(741), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(392), 4,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym__number,
  [34316] = 8,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1302), 1,
      sym_keyword_default,
    ACTIONS(1304), 1,
      anon_sym_SEMI,
    STATE(1327), 1,
      sym_identifier,
    STATE(1333), 1,
      sym_table_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(792), 2,
      sym_table_option,
      aux_sym_table_options_repeat1,
  [34343] = 8,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1302), 1,
      sym_keyword_default,
    ACTIONS(1306), 1,
      anon_sym_SEMI,
    STATE(1225), 1,
      sym_table_options,
    STATE(1327), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(792), 2,
      sym_table_option,
      aux_sym_table_options_repeat1,
  [34370] = 9,
    ACTIONS(1308), 1,
      sym_keyword_table,
    ACTIONS(1310), 1,
      sym_keyword_view,
    ACTIONS(1312), 1,
      sym_keyword_materialized,
    ACTIONS(1314), 1,
      sym_keyword_or,
    ACTIONS(1316), 1,
      sym_keyword_temp,
    ACTIONS(1318), 1,
      sym_keyword_temporary,
    STATE(1082), 1,
      sym__or_replace,
    STATE(1328), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [34399] = 6,
    ACTIONS(1120), 1,
      sym_keyword_primary,
    STATE(807), 1,
      sym__primary_key,
    STATE(1023), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(1240), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34422] = 9,
    ACTIONS(1120), 1,
      sym_keyword_primary,
    ACTIONS(1320), 1,
      sym_keyword_key,
    ACTIONS(1322), 1,
      sym_keyword_constraint,
    STATE(1099), 1,
      sym_constraint,
    STATE(1122), 1,
      sym__primary_key,
    STATE(1129), 1,
      sym__constraint_literal,
    STATE(1132), 1,
      sym__primary_key_constraint,
    STATE(1133), 1,
      sym__key_constraint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [34451] = 5,
    ACTIONS(1193), 1,
      sym_keyword_union,
    STATE(766), 1,
      aux_sym__select_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1195), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(1324), 4,
      aux_sym_keyword_with_token1,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34472] = 8,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1302), 1,
      sym_keyword_default,
    ACTIONS(1326), 1,
      anon_sym_SEMI,
    STATE(1157), 1,
      sym_table_options,
    STATE(1327), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(792), 2,
      sym_table_option,
      aux_sym_table_options_repeat1,
  [34499] = 4,
    ACTIONS(1300), 1,
      anon_sym_COMMA,
    STATE(781), 1,
      aux_sym_assignment_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1328), 6,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34518] = 8,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(968), 1,
      sym_table_reference,
    STATE(1057), 1,
      sym_update_expression,
    STATE(1289), 1,
      sym__table_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1064), 2,
      sym__single_table_update,
      sym__multi_table_update,
  [34545] = 6,
    ACTIONS(388), 1,
      anon_sym_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_DQUOTE,
    STATE(78), 1,
      sym__literal_string,
    STATE(790), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(392), 4,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym__number,
  [34568] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1332), 1,
      sym_keyword_as,
    STATE(590), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(794), 4,
      sym_keyword_on,
      sym_keyword_force,
      sym_keyword_using,
      sym_keyword_use,
  [34591] = 4,
    ACTIONS(1336), 1,
      anon_sym_COMMA,
    STATE(781), 1,
      aux_sym_assignment_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1334), 6,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34610] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1339), 8,
      sym_keyword_from,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34625] = 5,
    ACTIONS(1193), 1,
      sym_keyword_union,
    STATE(784), 1,
      aux_sym__select_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1195), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(1324), 4,
      aux_sym_keyword_with_token1,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34646] = 5,
    ACTIONS(1341), 1,
      sym_keyword_union,
    STATE(784), 1,
      aux_sym__select_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1344), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(1288), 4,
      aux_sym_keyword_with_token1,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34667] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1270), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34681] = 8,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(880), 1,
      sym_keyword_group_by,
    ACTIONS(1094), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      sym_order_by,
    STATE(797), 1,
      sym_limit,
    STATE(874), 1,
      sym_group_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [34707] = 4,
    ACTIONS(1349), 1,
      anon_sym_COMMA,
    STATE(787), 1,
      aux_sym__dml_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1347), 5,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
  [34725] = 5,
    ACTIONS(1108), 1,
      sym_keyword_set,
    ACTIONS(1116), 1,
      sym_keyword_rename,
    ACTIONS(1118), 1,
      sym_keyword_owner,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1259), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [34745] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1352), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34759] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1354), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34773] = 8,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(790), 1,
      anon_sym_RPAREN,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(880), 1,
      sym_keyword_group_by,
    STATE(730), 1,
      sym_order_by,
    STATE(796), 1,
      sym_limit,
    STATE(865), 1,
      sym_group_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [34799] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1302), 1,
      sym_keyword_default,
    ACTIONS(1356), 1,
      anon_sym_SEMI,
    STATE(1327), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(799), 2,
      sym_table_option,
      aux_sym_table_options_repeat1,
  [34823] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(790), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34837] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(792), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34851] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1358), 7,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_auto_increment,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34865] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1094), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34879] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1156), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34893] = 5,
    ACTIONS(1108), 1,
      sym_keyword_set,
    ACTIONS(1116), 1,
      sym_keyword_rename,
    ACTIONS(1118), 1,
      sym_keyword_owner,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1246), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [34913] = 7,
    ACTIONS(1360), 1,
      sym__identifier,
    ACTIONS(1363), 1,
      sym_keyword_default,
    ACTIONS(1366), 1,
      anon_sym_SEMI,
    ACTIONS(1368), 1,
      anon_sym_BQUOTE,
    STATE(1327), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(799), 2,
      sym_table_option,
      aux_sym_table_options_repeat1,
  [34937] = 6,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    STATE(857), 1,
      sym_order_by,
    STATE(1056), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1371), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34959] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1334), 7,
      sym_keyword_where,
      sym_keyword_order_by,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34973] = 6,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    STATE(882), 1,
      sym_order_by,
    STATE(1054), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1373), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34995] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1375), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35009] = 8,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(880), 1,
      sym_keyword_group_by,
    STATE(754), 1,
      sym_order_by,
    STATE(793), 1,
      sym_limit,
    STATE(884), 1,
      sym_group_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35035] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1276), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35049] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1377), 7,
      aux_sym_keyword_with_token1,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35063] = 4,
    STATE(1000), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(1290), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35080] = 4,
    STATE(1060), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(1379), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35097] = 5,
    ACTIONS(1381), 1,
      sym_keyword_distinct,
    ACTIONS(1383), 1,
      sym_keyword_not,
    STATE(368), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1385), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35116] = 4,
    ACTIONS(1387), 1,
      anon_sym_COMMA,
    STATE(810), 1,
      aux_sym_assignment_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1334), 4,
      sym_keyword_where,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35133] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(1275), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(853), 2,
      sym_invocation,
      sym_subquery,
  [35154] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1392), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(896), 1,
      sym__if_not_exists,
    STATE(1193), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35177] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1392), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(949), 1,
      sym__if_not_exists,
    STATE(1146), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35200] = 4,
    ACTIONS(1394), 1,
      anon_sym_COMMA,
    STATE(810), 1,
      aux_sym_assignment_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1328), 4,
      sym_keyword_where,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35217] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1392), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(920), 1,
      sym__if_not_exists,
    STATE(1296), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35240] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1396), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(890), 1,
      sym__if_exists,
    STATE(1125), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35263] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1392), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(947), 1,
      sym__if_not_exists,
    STATE(1195), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35286] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1398), 6,
      sym_keyword_desc,
      sym_keyword_asc,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35299] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1396), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(897), 1,
      sym__if_exists,
    STATE(1094), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35322] = 5,
    ACTIONS(1400), 1,
      sym_keyword_distinct,
    ACTIONS(1402), 1,
      sym_keyword_not,
    STATE(231), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1404), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35341] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1396), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(798), 1,
      sym_table_reference,
    STATE(892), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35364] = 4,
    ACTIONS(1406), 1,
      anon_sym_COMMA,
    STATE(822), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(426), 4,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35381] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1396), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(686), 1,
      sym_table_reference,
    STATE(894), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35404] = 4,
    ACTIONS(562), 1,
      anon_sym_COMMA,
    STATE(822), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1197), 4,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35421] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(1275), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(864), 2,
      sym_invocation,
      sym_subquery,
  [35442] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1392), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(908), 1,
      sym__if_not_exists,
    STATE(1098), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35465] = 5,
    ACTIONS(1409), 1,
      sym_keyword_distinct,
    ACTIONS(1411), 1,
      sym_keyword_not,
    STATE(112), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1413), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35484] = 5,
    ACTIONS(1415), 1,
      sym_keyword_distinct,
    ACTIONS(1417), 1,
      sym_keyword_not,
    STATE(242), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1419), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35503] = 7,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1392), 1,
      sym_keyword_if,
    STATE(680), 1,
      sym_identifier,
    STATE(904), 1,
      sym__if_not_exists,
    STATE(1194), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35526] = 4,
    STATE(1023), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(1240), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35543] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1421), 6,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      anon_sym_COMMA,
  [35556] = 5,
    ACTIONS(1423), 1,
      sym_keyword_distinct,
    ACTIONS(1425), 1,
      sym_keyword_not,
    STATE(144), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1427), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35575] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(1275), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(856), 2,
      sym_invocation,
      sym_subquery,
  [35596] = 7,
    ACTIONS(778), 1,
      sym__identifier,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1392), 1,
      sym_keyword_if,
    STATE(7), 1,
      sym_identifier,
    STATE(933), 1,
      sym__if_not_exists,
    STATE(1091), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35619] = 7,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(847), 1,
      sym_assignment,
    STATE(872), 1,
      sym_assignment_list,
    STATE(1141), 1,
      sym_identifier,
    STATE(1192), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35642] = 7,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(738), 1,
      sym_assignment_list,
    STATE(768), 1,
      sym_assignment,
    STATE(1141), 1,
      sym_identifier,
    STATE(1176), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35665] = 4,
    ACTIONS(562), 1,
      anon_sym_COMMA,
    STATE(822), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1199), 4,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35682] = 5,
    ACTIONS(1429), 1,
      sym_keyword_distinct,
    ACTIONS(1431), 1,
      sym_keyword_not,
    STATE(58), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1433), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35701] = 5,
    ACTIONS(1110), 1,
      sym_keyword_alter,
    ACTIONS(1112), 1,
      sym_keyword_drop,
    ACTIONS(1114), 1,
      sym_keyword_add,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1093), 3,
      sym_add_column,
      sym_alter_column,
      sym_drop_column,
  [35720] = 5,
    ACTIONS(1435), 1,
      sym_keyword_distinct,
    ACTIONS(1437), 1,
      sym_keyword_not,
    STATE(155), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1439), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35739] = 7,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(1441), 1,
      sym_keyword_values,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    STATE(715), 1,
      sym_select,
    STATE(939), 1,
      sym__column_list_without_order,
    STATE(1022), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35762] = 4,
    ACTIONS(562), 1,
      anon_sym_COMMA,
    STATE(824), 1,
      aux_sym_order_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1199), 4,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35779] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1347), 6,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      anon_sym_COMMA,
  [35792] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(1275), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(858), 2,
      sym_invocation,
      sym_subquery,
  [35813] = 5,
    ACTIONS(1445), 1,
      sym_keyword_distinct,
    ACTIONS(1447), 1,
      sym_keyword_not,
    STATE(305), 1,
      sym__not_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1449), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
  [35832] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(1275), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(866), 2,
      sym_invocation,
      sym_subquery,
  [35853] = 4,
    ACTIONS(1394), 1,
      anon_sym_COMMA,
    STATE(814), 1,
      aux_sym_assignment_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1298), 4,
      sym_keyword_where,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35870] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(1275), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(855), 2,
      sym_invocation,
      sym_subquery,
  [35891] = 5,
    ACTIONS(1451), 1,
      sym_keyword_on,
    ACTIONS(1453), 1,
      sym_keyword_using,
    STATE(1137), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
  [35909] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(841), 1,
      sym_table_reference,
    STATE(1009), 1,
      sym_insert_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35929] = 6,
    ACTIONS(1455), 1,
      sym__identifier,
    ACTIONS(1457), 1,
      sym_keyword_lateral,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    STATE(735), 1,
      sym_identifier,
    STATE(849), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35949] = 5,
    ACTIONS(1461), 1,
      sym_keyword_on,
    ACTIONS(1463), 1,
      sym_keyword_using,
    STATE(1100), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
  [35967] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1465), 1,
      sym_keyword_on,
    ACTIONS(1467), 1,
      sym_keyword_as,
    STATE(1301), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [35987] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1469), 1,
      sym_keyword_column,
    ACTIONS(1471), 1,
      sym_keyword_to,
    STATE(1278), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36007] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1473), 1,
      sym_keyword_on,
    ACTIONS(1475), 1,
      sym_keyword_as,
    STATE(1152), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36027] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1477), 1,
      sym_keyword_on,
    ACTIONS(1479), 1,
      sym_keyword_as,
    STATE(1213), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36047] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(1013), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1481), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36063] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1483), 1,
      sym_keyword_on,
    ACTIONS(1485), 1,
      sym_keyword_as,
    STATE(1211), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36083] = 4,
    ACTIONS(1487), 1,
      anon_sym_COMMA,
    STATE(859), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1180), 3,
      sym_keyword_from,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36099] = 5,
    ACTIONS(1463), 1,
      sym_keyword_using,
    ACTIONS(1490), 1,
      sym_keyword_on,
    STATE(1135), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
  [36117] = 6,
    ACTIONS(1455), 1,
      sym__identifier,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1492), 1,
      sym_keyword_lateral,
    STATE(735), 1,
      sym_identifier,
    STATE(870), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36137] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(1054), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1373), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36153] = 6,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    STATE(754), 1,
      sym_order_by,
    STATE(793), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36173] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1494), 1,
      sym_keyword_on,
    ACTIONS(1496), 1,
      sym_keyword_as,
    STATE(1291), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36193] = 6,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(1094), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      sym_order_by,
    STATE(797), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36213] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1498), 1,
      sym_keyword_on,
    ACTIONS(1500), 1,
      sym_keyword_as,
    STATE(1207), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36233] = 4,
    ACTIONS(1502), 1,
      anon_sym_COMMA,
    STATE(859), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1212), 3,
      sym_keyword_from,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36249] = 6,
    ACTIONS(1455), 1,
      sym__identifier,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1504), 1,
      sym_keyword_lateral,
    STATE(735), 1,
      sym_identifier,
    STATE(860), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36269] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(801), 1,
      sym_assignment,
    STATE(1141), 1,
      sym_identifier,
    STATE(1192), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36289] = 5,
    ACTIONS(1506), 1,
      sym_keyword_on,
    ACTIONS(1508), 1,
      sym_keyword_using,
    STATE(1112), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
  [36307] = 4,
    ACTIONS(1502), 1,
      anon_sym_COMMA,
    STATE(867), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1185), 3,
      sym_keyword_from,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36323] = 4,
    ACTIONS(1510), 1,
      sym_keyword_where,
    STATE(957), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1512), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36339] = 4,
    STATE(1080), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(326), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(1514), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36355] = 6,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    ACTIONS(1156), 1,
      anon_sym_RPAREN,
    STATE(755), 1,
      sym_order_by,
    STATE(805), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36375] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(1056), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1371), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36391] = 6,
    ACTIONS(290), 1,
      sym__identifier,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1396), 1,
      sym_keyword_if,
    STATE(976), 1,
      sym__if_exists,
    STATE(1087), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36411] = 6,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(801), 1,
      sym_assignment,
    STATE(1141), 1,
      sym_identifier,
    STATE(1176), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36431] = 5,
    ACTIONS(1508), 1,
      sym_keyword_using,
    ACTIONS(1516), 1,
      sym_keyword_on,
    STATE(1138), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
  [36449] = 6,
    ACTIONS(1455), 1,
      sym__identifier,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1518), 1,
      sym_keyword_lateral,
    STATE(735), 1,
      sym_identifier,
    STATE(881), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36469] = 6,
    ACTIONS(1455), 1,
      sym__identifier,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1520), 1,
      sym_keyword_lateral,
    STATE(735), 1,
      sym_identifier,
    STATE(878), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36489] = 5,
    ACTIONS(1453), 1,
      sym_keyword_using,
    ACTIONS(1522), 1,
      sym_keyword_on,
    STATE(1104), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
  [36507] = 4,
    ACTIONS(552), 1,
      sym_keyword_limit,
    STATE(1006), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1524), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36523] = 4,
    ACTIONS(1526), 1,
      sym_keyword_having,
    STATE(757), 1,
      sym__having,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1140), 3,
      sym_keyword_order_by,
      sym_keyword_limit,
      anon_sym_RPAREN,
  [36539] = 6,
    ACTIONS(552), 1,
      sym_keyword_limit,
    ACTIONS(790), 1,
      anon_sym_RPAREN,
    ACTIONS(878), 1,
      sym_keyword_order_by,
    STATE(730), 1,
      sym_order_by,
    STATE(796), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36559] = 6,
    ACTIONS(1455), 1,
      sym__identifier,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1528), 1,
      sym_keyword_lateral,
    STATE(735), 1,
      sym_identifier,
    STATE(852), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36579] = 4,
    ACTIONS(1530), 1,
      sym_keyword_from,
    STATE(1168), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(554), 2,
      sym_keyword_force,
      sym_keyword_use,
  [36594] = 5,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(816), 1,
      sym_keyword_else,
    ACTIONS(818), 1,
      sym_keyword_end,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36611] = 3,
    ACTIONS(142), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(144), 3,
      sym_keyword_on,
      sym_keyword_as,
      sym__identifier,
  [36624] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1532), 2,
      sym_keyword_default,
      sym__identifier,
    ACTIONS(1534), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [36637] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1118), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36654] = 5,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(552), 1,
      sym_identifier,
    STATE(575), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36671] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(788), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36688] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1538), 2,
      sym_keyword_default,
      sym__identifier,
    ACTIONS(1540), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [36701] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(689), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36718] = 5,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(7), 1,
      sym_identifier,
    STATE(1123), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36735] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1292), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36752] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36769] = 5,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(1542), 1,
      sym__identifier,
    STATE(873), 1,
      sym_identifier,
    STATE(956), 1,
      sym_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36786] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(1048), 1,
      sym_keyword_end,
    ACTIONS(1544), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36803] = 3,
    ACTIONS(172), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(174), 3,
      sym_keyword_on,
      sym_keyword_as,
      sym__identifier,
  [36816] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(956), 1,
      sym_keyword_end,
    ACTIONS(1546), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36833] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(843), 1,
      sym_cte,
    STATE(1335), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36850] = 3,
    ACTIONS(212), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(214), 3,
      sym_keyword_on,
      sym_keyword_as,
      sym__identifier,
  [36863] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1193), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36880] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(976), 1,
      sym_keyword_end,
    ACTIONS(1548), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36897] = 5,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(1542), 1,
      sym__identifier,
    STATE(873), 1,
      sym_identifier,
    STATE(1126), 1,
      sym_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36914] = 3,
    ACTIONS(264), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(266), 3,
      sym_keyword_on,
      sym_keyword_as,
      sym__identifier,
  [36927] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1146), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36944] = 4,
    ACTIONS(1550), 1,
      sym_keyword_when,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1553), 2,
      sym_keyword_else,
      sym_keyword_end,
  [36959] = 5,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(864), 1,
      sym_keyword_else,
    ACTIONS(866), 1,
      sym_keyword_end,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36976] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1071), 1,
      sym_identifier,
    STATE(1119), 1,
      sym__column_without_order,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [36993] = 5,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(812), 1,
      sym_keyword_else,
    ACTIONS(814), 1,
      sym_keyword_end,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37010] = 5,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(735), 1,
      sym_identifier,
    STATE(852), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37027] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1148), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37044] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1307), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37061] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(986), 1,
      sym_keyword_end,
    ACTIONS(1557), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37078] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(678), 1,
      sym_cte,
    STATE(1335), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37095] = 5,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(848), 1,
      sym_keyword_else,
    ACTIONS(850), 1,
      sym_keyword_end,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37112] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1559), 1,
      anon_sym_STAR,
    STATE(81), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37129] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1320), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37146] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(1010), 1,
      sym_keyword_end,
    ACTIONS(1561), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37163] = 4,
    ACTIONS(1563), 1,
      sym_keyword_returning,
    STATE(1073), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1565), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37178] = 5,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(824), 1,
      sym_keyword_else,
    ACTIONS(826), 1,
      sym_keyword_end,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37195] = 5,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(735), 1,
      sym_identifier,
    STATE(849), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37212] = 4,
    ACTIONS(1563), 1,
      sym_keyword_returning,
    STATE(1069), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1567), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37227] = 5,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(856), 1,
      sym_keyword_else,
    ACTIONS(858), 1,
      sym_keyword_end,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37244] = 5,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    ACTIONS(1569), 1,
      sym__identifier,
    ACTIONS(1571), 1,
      anon_sym_STAR,
    STATE(447), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37261] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(1028), 1,
      sym_keyword_end,
    ACTIONS(1573), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37278] = 5,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    ACTIONS(1559), 1,
      anon_sym_STAR,
    ACTIONS(1569), 1,
      sym__identifier,
    STATE(320), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37295] = 5,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(735), 1,
      sym_identifier,
    STATE(860), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37312] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1575), 2,
      sym_keyword_default,
      sym__identifier,
    ACTIONS(1577), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [37325] = 5,
    ACTIONS(806), 1,
      sym_keyword_when,
    ACTIONS(840), 1,
      sym_keyword_else,
    ACTIONS(842), 1,
      sym_keyword_end,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37342] = 5,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(7), 1,
      sym_identifier,
    STATE(1127), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37359] = 5,
    ACTIONS(1579), 1,
      anon_sym_RPAREN,
    ACTIONS(1581), 1,
      anon_sym_COMMA,
    STATE(946), 1,
      aux_sym_column_definitions_repeat1,
    STATE(1350), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37376] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(1060), 1,
      sym_keyword_end,
    ACTIONS(1583), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37393] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1585), 2,
      sym_keyword_default,
      sym__identifier,
    ACTIONS(1587), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [37406] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(959), 1,
      sym__column_without_order,
    STATE(1071), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37423] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    ACTIONS(1571), 1,
      anon_sym_STAR,
    STATE(99), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37440] = 5,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(1589), 1,
      sym_keyword_values,
    STATE(715), 1,
      sym_select,
    STATE(960), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37457] = 5,
    ACTIONS(802), 1,
      sym_keyword_else,
    ACTIONS(804), 1,
      sym_keyword_end,
    ACTIONS(806), 1,
      sym_keyword_when,
    STATE(909), 1,
      aux_sym_case_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37474] = 3,
    ACTIONS(1593), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1591), 3,
      sym_keyword_no,
      sym_keyword_data,
      sym__identifier,
  [37487] = 5,
    ACTIONS(800), 1,
      sym_keyword_when,
    ACTIONS(1072), 1,
      sym_keyword_end,
    ACTIONS(1595), 1,
      sym_keyword_else,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37504] = 5,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(735), 1,
      sym_identifier,
    STATE(881), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37521] = 5,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(7), 1,
      sym_identifier,
    STATE(934), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37538] = 5,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(281), 1,
      sym_table_expression,
    STATE(552), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37555] = 5,
    ACTIONS(1581), 1,
      anon_sym_COMMA,
    ACTIONS(1597), 1,
      anon_sym_RPAREN,
    STATE(1016), 1,
      aux_sym_column_definitions_repeat1,
    STATE(1220), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37572] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1296), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37589] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1599), 2,
      sym_keyword_default,
      sym__identifier,
    ACTIONS(1601), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [37602] = 5,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
    STATE(1097), 1,
      sym_table_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37619] = 4,
    ACTIONS(1563), 1,
      sym_keyword_returning,
    STATE(1084), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1603), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37634] = 5,
    ACTIONS(1605), 1,
      sym__identifier,
    ACTIONS(1607), 1,
      anon_sym_BQUOTE,
    STATE(692), 1,
      sym_identifier,
    STATE(759), 1,
      sym_table_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37651] = 4,
    ACTIONS(1609), 1,
      sym_keyword_when,
    STATE(952), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1612), 2,
      sym_keyword_else,
      sym_keyword_end,
  [37666] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1616), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37680] = 4,
    ACTIONS(1618), 1,
      anon_sym_RPAREN,
    ACTIONS(1620), 1,
      anon_sym_COMMA,
    STATE(1007), 1,
      aux_sym__column_list_without_order_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37694] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1622), 1,
      anon_sym_RPAREN,
    STATE(1268), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37708] = 4,
    ACTIONS(1624), 1,
      anon_sym_RPAREN,
    ACTIONS(1626), 1,
      anon_sym_COMMA,
    STATE(1062), 1,
      aux_sym_column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37722] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1628), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37732] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1371), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37742] = 4,
    ACTIONS(1620), 1,
      anon_sym_COMMA,
    ACTIONS(1630), 1,
      anon_sym_RPAREN,
    STATE(954), 1,
      aux_sym__column_list_without_order_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37756] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1632), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37766] = 4,
    ACTIONS(900), 1,
      anon_sym_COMMA,
    ACTIONS(1634), 1,
      anon_sym_RPAREN,
    STATE(963), 1,
      aux_sym__function_params_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37780] = 4,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(1636), 1,
      sym_keyword_all,
    STATE(762), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37794] = 4,
    ACTIONS(1638), 1,
      anon_sym_RPAREN,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    STATE(963), 1,
      aux_sym__function_params_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37808] = 4,
    ACTIONS(934), 1,
      anon_sym_RPAREN,
    ACTIONS(1643), 1,
      anon_sym_COMMA,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37822] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1373), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37832] = 4,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(936), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37846] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(586), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37860] = 4,
    ACTIONS(1646), 1,
      sym_keyword_set,
    ACTIONS(1648), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym__table_references_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37874] = 4,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(715), 1,
      sym_select,
    STATE(1027), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37888] = 4,
    ACTIONS(21), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(1650), 1,
      anon_sym_SEMI,
    STATE(1066), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37902] = 4,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(715), 1,
      sym_select,
    STATE(1155), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37916] = 4,
    ACTIONS(1652), 1,
      anon_sym_COMMA,
    ACTIONS(1654), 1,
      anon_sym_SEMI,
    STATE(987), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37930] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1656), 1,
      anon_sym_RPAREN,
    STATE(1300), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37944] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1658), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37954] = 4,
    ACTIONS(1660), 1,
      sym_keyword_set,
    ACTIONS(1662), 1,
      sym_keyword_drop,
    ACTIONS(1664), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37968] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1128), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37982] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(99), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [37996] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1233), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38010] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1214), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38024] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1244), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38038] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1213), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38052] = 4,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    ACTIONS(1666), 1,
      sym__identifier,
    STATE(151), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38066] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1211), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38080] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38094] = 4,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(715), 1,
      sym_select,
    STATE(1330), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38108] = 4,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(715), 1,
      sym_select,
    STATE(970), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38122] = 4,
    ACTIONS(1670), 1,
      anon_sym_COMMA,
    ACTIONS(1673), 1,
      anon_sym_SEMI,
    STATE(987), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38136] = 4,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(556), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38150] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(736), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38164] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1152), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38178] = 4,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(588), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38192] = 4,
    ACTIONS(1675), 1,
      anon_sym_RPAREN,
    ACTIONS(1677), 1,
      anon_sym_COMMA,
    STATE(992), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38206] = 4,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(883), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38220] = 4,
    ACTIONS(1605), 1,
      sym__identifier,
    ACTIONS(1607), 1,
      anon_sym_BQUOTE,
    STATE(725), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38234] = 4,
    ACTIONS(1652), 1,
      anon_sym_COMMA,
    ACTIONS(1680), 1,
      anon_sym_SEMI,
    STATE(972), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38248] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(588), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38262] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1318), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38276] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(975), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38290] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1309), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38304] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1379), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [38314] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1304), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38328] = 4,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(693), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38342] = 4,
    ACTIONS(662), 1,
      anon_sym_BQUOTE,
    ACTIONS(1666), 1,
      sym__identifier,
    STATE(214), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38356] = 4,
    ACTIONS(1652), 1,
      anon_sym_COMMA,
    ACTIONS(1680), 1,
      anon_sym_SEMI,
    STATE(987), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38370] = 4,
    ACTIONS(788), 1,
      anon_sym_BQUOTE,
    ACTIONS(1536), 1,
      sym__identifier,
    STATE(586), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38384] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1682), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [38394] = 4,
    ACTIONS(1684), 1,
      anon_sym_RPAREN,
    ACTIONS(1686), 1,
      anon_sym_COMMA,
    STATE(1007), 1,
      aux_sym__column_list_without_order_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38408] = 4,
    ACTIONS(1652), 1,
      anon_sym_COMMA,
    ACTIONS(1689), 1,
      anon_sym_SEMI,
    STATE(1004), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38422] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1691), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [38432] = 4,
    ACTIONS(1648), 1,
      anon_sym_COMMA,
    ACTIONS(1693), 1,
      sym_keyword_set,
    STATE(1019), 1,
      aux_sym__table_references_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38446] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(690), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38460] = 4,
    ACTIONS(21), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(1695), 1,
      anon_sym_SEMI,
    STATE(1134), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38474] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1697), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [38484] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1090), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38498] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1092), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38512] = 4,
    ACTIONS(1699), 1,
      anon_sym_RPAREN,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    STATE(1016), 1,
      aux_sym_column_definitions_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38526] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(82), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38540] = 4,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(715), 1,
      sym_select,
    STATE(1297), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38554] = 4,
    ACTIONS(1704), 1,
      sym_keyword_set,
    ACTIONS(1706), 1,
      anon_sym_COMMA,
    STATE(1019), 1,
      aux_sym__table_references_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38568] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1709), 1,
      anon_sym_RPAREN,
    STATE(1183), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38582] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1711), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38596] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1713), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [38606] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1290), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [38616] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1342), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38630] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1715), 1,
      anon_sym_RPAREN,
    STATE(1170), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38644] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1240), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [38654] = 4,
    ACTIONS(21), 1,
      aux_sym_keyword_with_token1,
    ACTIONS(1717), 1,
      anon_sym_SEMI,
    STATE(1067), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38668] = 4,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    ACTIONS(1719), 1,
      sym__identifier,
    STATE(200), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38682] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1721), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38696] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1103), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38710] = 4,
    ACTIONS(774), 1,
      anon_sym_BQUOTE,
    ACTIONS(1719), 1,
      sym__identifier,
    STATE(172), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38724] = 4,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(715), 1,
      sym_select,
    STATE(1012), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38738] = 4,
    ACTIONS(1723), 1,
      sym_keyword_not,
    ACTIONS(1725), 1,
      sym_keyword_default,
    ACTIONS(1727), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38752] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1729), 1,
      anon_sym_RPAREN,
    STATE(1252), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38766] = 4,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    ACTIONS(1731), 1,
      sym__identifier,
    STATE(40), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38780] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1279), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38794] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1733), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38808] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1288), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38822] = 4,
    ACTIONS(726), 1,
      anon_sym_BQUOTE,
    ACTIONS(1731), 1,
      sym__identifier,
    STATE(17), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38836] = 4,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    ACTIONS(1735), 1,
      sym__identifier,
    STATE(141), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38850] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1737), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38864] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1739), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38878] = 4,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(1542), 1,
      sym__identifier,
    STATE(77), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38892] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1741), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38906] = 4,
    ACTIONS(320), 1,
      anon_sym_BQUOTE,
    ACTIONS(1330), 1,
      sym__identifier,
    STATE(1301), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38920] = 4,
    ACTIONS(1743), 1,
      anon_sym_RPAREN,
    ACTIONS(1745), 1,
      anon_sym_COMMA,
    STATE(1046), 1,
      aux_sym_column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38934] = 4,
    ACTIONS(1459), 1,
      anon_sym_BQUOTE,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(780), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38948] = 4,
    ACTIONS(1748), 1,
      anon_sym_RPAREN,
    ACTIONS(1750), 1,
      anon_sym_COMMA,
    STATE(992), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38962] = 4,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    ACTIONS(1569), 1,
      sym__identifier,
    STATE(447), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38976] = 4,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(1542), 1,
      sym__identifier,
    STATE(90), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [38990] = 4,
    ACTIONS(598), 1,
      anon_sym_BQUOTE,
    ACTIONS(1735), 1,
      sym__identifier,
    STATE(181), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39004] = 4,
    ACTIONS(1750), 1,
      anon_sym_COMMA,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
    STATE(1048), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39018] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1754), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39032] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1524), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39042] = 4,
    ACTIONS(424), 1,
      anon_sym_BQUOTE,
    ACTIONS(1569), 1,
      sym__identifier,
    STATE(314), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39056] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1481), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39066] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1756), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39076] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(1346), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39090] = 4,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    ACTIONS(1760), 1,
      sym__identifier,
    STATE(294), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39104] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1762), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39114] = 4,
    ACTIONS(884), 1,
      anon_sym_COMMA,
    ACTIONS(1764), 1,
      anon_sym_RPAREN,
    STATE(964), 1,
      aux_sym_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39128] = 4,
    ACTIONS(1626), 1,
      anon_sym_COMMA,
    ACTIONS(1766), 1,
      anon_sym_RPAREN,
    STATE(1046), 1,
      aux_sym_column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39142] = 4,
    ACTIONS(640), 1,
      anon_sym_BQUOTE,
    ACTIONS(1760), 1,
      sym__identifier,
    STATE(334), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39156] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1768), 3,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39166] = 4,
    ACTIONS(1614), 1,
      sym_keyword_from,
    ACTIONS(1770), 1,
      anon_sym_RPAREN,
    STATE(1310), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39180] = 3,
    ACTIONS(1772), 1,
      sym_keyword_no,
    ACTIONS(1774), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39191] = 3,
    ACTIONS(1776), 1,
      sym_keyword_no,
    ACTIONS(1778), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39202] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1780), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39211] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39220] = 3,
    ACTIONS(1784), 1,
      anon_sym_LPAREN,
    STATE(974), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39231] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1786), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39240] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1788), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39249] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1790), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39258] = 3,
    ACTIONS(1792), 1,
      sym_keyword_table,
    ACTIONS(1794), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39269] = 3,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(762), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39280] = 3,
    ACTIONS(1796), 1,
      sym_keyword_distinct,
    ACTIONS(1798), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39291] = 3,
    ACTIONS(1800), 1,
      sym_keyword_table,
    ACTIONS(1802), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39302] = 3,
    ACTIONS(1804), 1,
      sym_keyword_transaction,
    ACTIONS(1806), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39313] = 3,
    ACTIONS(1808), 1,
      sym_keyword_transaction,
    ACTIONS(1810), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39324] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1812), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39333] = 3,
    ACTIONS(1814), 1,
      sym_keyword_transaction,
    ACTIONS(1816), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39344] = 3,
    ACTIONS(1818), 1,
      sym_keyword_view,
    ACTIONS(1820), 1,
      sym_keyword_materialized,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39355] = 3,
    ACTIONS(7), 1,
      sym_keyword_select,
    STATE(751), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39366] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1822), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39375] = 3,
    ACTIONS(1824), 1,
      sym_keyword_outer,
    ACTIONS(1826), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39386] = 3,
    ACTIONS(1828), 1,
      sym_keyword_outer,
    ACTIONS(1830), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39397] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1832), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39406] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1834), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [39415] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1836), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39424] = 3,
    ACTIONS(1838), 1,
      anon_sym_LPAREN,
    STATE(1068), 1,
      sym_column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39435] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1840), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39444] = 3,
    ACTIONS(1120), 1,
      sym_keyword_primary,
    STATE(1121), 1,
      sym__primary_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39455] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1673), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39464] = 3,
    ACTIONS(1842), 1,
      sym_keyword_cascade,
    ACTIONS(1844), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39475] = 3,
    ACTIONS(1846), 1,
      sym_keyword_distinct,
    ACTIONS(1848), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39486] = 3,
    ACTIONS(1850), 1,
      sym_keyword_distinct,
    ACTIONS(1852), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39497] = 3,
    ACTIONS(1854), 1,
      anon_sym_LPAREN,
    STATE(776), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39508] = 3,
    ACTIONS(1854), 1,
      anon_sym_LPAREN,
    STATE(770), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39519] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1675), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39528] = 3,
    ACTIONS(1856), 1,
      sym_keyword_on,
    ACTIONS(1858), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39539] = 3,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    STATE(674), 1,
      sym__column_list_without_order,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39550] = 3,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    STATE(675), 1,
      sym__column_list_without_order,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39561] = 3,
    ACTIONS(136), 1,
      anon_sym_EQ,
    ACTIONS(362), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39572] = 3,
    ACTIONS(1461), 1,
      sym_keyword_on,
    ACTIONS(1463), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39583] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1860), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39592] = 3,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    STATE(676), 1,
      sym__column_list_without_order,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39603] = 3,
    ACTIONS(1862), 1,
      sym_keyword_select,
    STATE(1034), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39614] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39623] = 3,
    ACTIONS(1866), 1,
      sym_keyword_distinct,
    ACTIONS(1868), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39634] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1870), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39643] = 3,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    STATE(677), 1,
      sym__column_list_without_order,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39654] = 3,
    ACTIONS(1453), 1,
      sym_keyword_using,
    ACTIONS(1522), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39665] = 3,
    ACTIONS(1872), 1,
      sym_keyword_outer,
    ACTIONS(1874), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39676] = 3,
    ACTIONS(1876), 1,
      sym_keyword_outer,
    ACTIONS(1878), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39687] = 3,
    ACTIONS(1880), 1,
      sym_keyword_cascade,
    ACTIONS(1882), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39698] = 3,
    ACTIONS(1884), 1,
      sym_keyword_for,
    ACTIONS(1886), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39709] = 3,
    ACTIONS(1888), 1,
      sym_keyword_from,
    STATE(950), 1,
      sym__delete_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39720] = 3,
    ACTIONS(1890), 1,
      sym_keyword_cascade,
    ACTIONS(1892), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39731] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1894), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39740] = 3,
    ACTIONS(1896), 1,
      sym_keyword_distinct,
    ACTIONS(1898), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39751] = 3,
    ACTIONS(1838), 1,
      anon_sym_LPAREN,
    STATE(1136), 1,
      sym_column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39762] = 3,
    ACTIONS(1838), 1,
      anon_sym_LPAREN,
    STATE(1089), 1,
      sym_column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39773] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1699), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39782] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1900), 2,
      anon_sym_BQUOTE,
      sym__identifier,
  [39791] = 3,
    ACTIONS(1902), 1,
      sym_keyword_cascade,
    ACTIONS(1904), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39802] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1743), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39811] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39820] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1908), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39829] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39838] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1912), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39847] = 3,
    ACTIONS(1723), 1,
      sym_keyword_not,
    ACTIONS(1914), 1,
      sym_keyword_default,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39858] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1916), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39867] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39876] = 3,
    ACTIONS(1918), 1,
      sym_keyword_no,
    ACTIONS(1920), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39887] = 3,
    ACTIONS(1858), 1,
      sym_keyword_using,
    ACTIONS(1922), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39898] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39907] = 3,
    ACTIONS(1463), 1,
      sym_keyword_using,
    ACTIONS(1490), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39918] = 3,
    ACTIONS(1451), 1,
      sym_keyword_on,
    ACTIONS(1453), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39929] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 2,
      anon_sym_BQUOTE,
      sym__identifier,
  [39938] = 3,
    ACTIONS(1928), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39949] = 3,
    ACTIONS(102), 1,
      anon_sym_EQ,
    ACTIONS(1932), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39960] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(938), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [39969] = 3,
    ACTIONS(1934), 1,
      sym_keyword_distinct,
    ACTIONS(1936), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39980] = 3,
    ACTIONS(1938), 1,
      sym_keyword_distinct,
    ACTIONS(1940), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [39991] = 3,
    ACTIONS(1784), 1,
      anon_sym_LPAREN,
    STATE(960), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40002] = 3,
    ACTIONS(1854), 1,
      anon_sym_LPAREN,
    STATE(771), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40013] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 2,
      sym_keyword_view,
      sym_keyword_materialized,
  [40022] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1704), 2,
      sym_keyword_set,
      anon_sym_COMMA,
  [40031] = 3,
    ACTIONS(1944), 1,
      anon_sym_RPAREN,
    ACTIONS(1946), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40042] = 3,
    ACTIONS(1948), 1,
      sym_keyword_distinct,
    ACTIONS(1950), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40053] = 2,
    ACTIONS(1952), 1,
      sym__number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40061] = 2,
    ACTIONS(1954), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40069] = 2,
    ACTIONS(1956), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40077] = 2,
    ACTIONS(1958), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40085] = 2,
    ACTIONS(1960), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40093] = 2,
    ACTIONS(1962), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40101] = 2,
    ACTIONS(1964), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40109] = 2,
    ACTIONS(1966), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40117] = 2,
    ACTIONS(1968), 1,
      aux_sym_keyword_timestamp_token4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40125] = 2,
    ACTIONS(1970), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40133] = 2,
    ACTIONS(1972), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40141] = 2,
    ACTIONS(1974), 1,
      aux_sym_keyword_timestamp_token4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40149] = 2,
    ACTIONS(1976), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40157] = 2,
    ACTIONS(1978), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40165] = 2,
    ACTIONS(1980), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40173] = 2,
    ACTIONS(1980), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40181] = 2,
    ACTIONS(1982), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40189] = 2,
    ACTIONS(1984), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40197] = 2,
    ACTIONS(1986), 1,
      sym_keyword_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40205] = 2,
    ACTIONS(1988), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40213] = 2,
    ACTIONS(1990), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40221] = 2,
    ACTIONS(1992), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40229] = 2,
    ACTIONS(1994), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40237] = 2,
    ACTIONS(1996), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40245] = 2,
    ACTIONS(1998), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40253] = 2,
    ACTIONS(2000), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40261] = 2,
    ACTIONS(1848), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40269] = 2,
    ACTIONS(2002), 1,
      sym__number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40277] = 2,
    ACTIONS(2004), 1,
      sym__number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40285] = 2,
    ACTIONS(2006), 1,
      aux_sym_keyword_timestamp_token3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40293] = 2,
    ACTIONS(2008), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40301] = 2,
    ACTIONS(2010), 1,
      sym_keyword_index,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40309] = 2,
    ACTIONS(2012), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40317] = 2,
    ACTIONS(2014), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40325] = 2,
    ACTIONS(2016), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40333] = 2,
    ACTIONS(2018), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40341] = 2,
    ACTIONS(2022), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40349] = 2,
    ACTIONS(2024), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40357] = 2,
    ACTIONS(2026), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40365] = 2,
    ACTIONS(2028), 1,
      sym_keyword_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40373] = 2,
    ACTIONS(2030), 1,
      aux_sym_keyword_timestamp_token3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40381] = 2,
    ACTIONS(2032), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40389] = 2,
    ACTIONS(2034), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40397] = 2,
    ACTIONS(2036), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40405] = 2,
    ACTIONS(2038), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40413] = 2,
    ACTIONS(2040), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40421] = 2,
    ACTIONS(2042), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40429] = 2,
    ACTIONS(2044), 1,
      sym__number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40437] = 2,
    ACTIONS(2046), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40445] = 2,
    ACTIONS(2048), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40453] = 2,
    ACTIONS(1778), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40461] = 2,
    ACTIONS(2050), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40469] = 2,
    ACTIONS(2052), 1,
      sym__number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40477] = 2,
    ACTIONS(2054), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40485] = 2,
    ACTIONS(2056), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40493] = 2,
    ACTIONS(2058), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40501] = 2,
    ACTIONS(2060), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40509] = 2,
    ACTIONS(2062), 1,
      sym_keyword_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40517] = 2,
    ACTIONS(2064), 1,
      sym_keyword_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40525] = 2,
    ACTIONS(2066), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40533] = 2,
    ACTIONS(2068), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40541] = 2,
    ACTIONS(2070), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40549] = 2,
    ACTIONS(2072), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40557] = 2,
    ACTIONS(2074), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40565] = 2,
    ACTIONS(2076), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40573] = 2,
    ACTIONS(2078), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40581] = 2,
    ACTIONS(2080), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40589] = 2,
    ACTIONS(2082), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40597] = 2,
    ACTIONS(2084), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40605] = 2,
    ACTIONS(2086), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40613] = 2,
    ACTIONS(2088), 1,
      sym_keyword_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40621] = 2,
    ACTIONS(2070), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40629] = 2,
    ACTIONS(2050), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40637] = 2,
    ACTIONS(2090), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40645] = 2,
    ACTIONS(1326), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40653] = 2,
    ACTIONS(2092), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40661] = 2,
    ACTIONS(2094), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40669] = 2,
    ACTIONS(2096), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40677] = 2,
    ACTIONS(2098), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40685] = 2,
    ACTIONS(2100), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40693] = 2,
    ACTIONS(2102), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40701] = 2,
    ACTIONS(2104), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40709] = 2,
    ACTIONS(2106), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40717] = 2,
    ACTIONS(2108), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40725] = 2,
    ACTIONS(2110), 1,
      sym_keyword_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40733] = 2,
    ACTIONS(2112), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40741] = 2,
    ACTIONS(2114), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40749] = 2,
    ACTIONS(2116), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40757] = 2,
    ACTIONS(2118), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40765] = 2,
    ACTIONS(2120), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40773] = 2,
    ACTIONS(1695), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40781] = 2,
    ACTIONS(2122), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40789] = 2,
    ACTIONS(2124), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40797] = 2,
    ACTIONS(2126), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40805] = 2,
    ACTIONS(1689), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40813] = 2,
    ACTIONS(2128), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40821] = 2,
    ACTIONS(2130), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40829] = 2,
    ACTIONS(1892), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40837] = 2,
    ACTIONS(2132), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40845] = 2,
    ACTIONS(2134), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40853] = 2,
    ACTIONS(2136), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40861] = 2,
    ACTIONS(2138), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40869] = 2,
    ACTIONS(2140), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40877] = 2,
    ACTIONS(1920), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40885] = 2,
    ACTIONS(2142), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40893] = 2,
    ACTIONS(2144), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40901] = 2,
    ACTIONS(1882), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40909] = 2,
    ACTIONS(2146), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40917] = 2,
    ACTIONS(2148), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40925] = 2,
    ACTIONS(2150), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40933] = 2,
    ACTIONS(2152), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40941] = 2,
    ACTIONS(2154), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40949] = 2,
    ACTIONS(2156), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40957] = 2,
    ACTIONS(2158), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40965] = 2,
    ACTIONS(2160), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40973] = 2,
    ACTIONS(2162), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [40981] = 2,
    ACTIONS(1878), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40989] = 2,
    ACTIONS(2164), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [40997] = 2,
    ACTIONS(2166), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41005] = 2,
    ACTIONS(2168), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41013] = 2,
    ACTIONS(2170), 1,
      aux_sym__literal_string_token1,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [41021] = 2,
    ACTIONS(2172), 1,
      aux_sym__literal_string_token2,
    ACTIONS(2020), 2,
      sym_comment,
      sym_marginalia,
  [41029] = 2,
    ACTIONS(2174), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41037] = 2,
    ACTIONS(2176), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41045] = 2,
    ACTIONS(2178), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41053] = 2,
    ACTIONS(2168), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41061] = 2,
    ACTIONS(2180), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41069] = 2,
    ACTIONS(2182), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41077] = 2,
    ACTIONS(2184), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41085] = 2,
    ACTIONS(2186), 1,
      sym__number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41093] = 2,
    ACTIONS(2188), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41101] = 2,
    ACTIONS(2190), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41109] = 2,
    ACTIONS(2192), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41117] = 2,
    ACTIONS(2194), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41125] = 2,
    ACTIONS(2196), 1,
      sym__number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41133] = 2,
    ACTIONS(1680), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41141] = 2,
    ACTIONS(2198), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41149] = 2,
    ACTIONS(2200), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41157] = 2,
    ACTIONS(2202), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41165] = 2,
    ACTIONS(2204), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41173] = 2,
    ACTIONS(2206), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41181] = 2,
    ACTIONS(2208), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41189] = 2,
    ACTIONS(2210), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41197] = 2,
    ACTIONS(2212), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41205] = 2,
    ACTIONS(2214), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41213] = 2,
    ACTIONS(2216), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41221] = 2,
    ACTIONS(2218), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41229] = 2,
    ACTIONS(2220), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41237] = 2,
    ACTIONS(2222), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41245] = 2,
    ACTIONS(2224), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41253] = 2,
    ACTIONS(2226), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41261] = 2,
    ACTIONS(2228), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41269] = 2,
    ACTIONS(2230), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41277] = 2,
    ACTIONS(2232), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41285] = 2,
    ACTIONS(2234), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41293] = 2,
    ACTIONS(2236), 1,
      sym_keyword_replace,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41301] = 2,
    ACTIONS(2238), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41309] = 2,
    ACTIONS(2240), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41317] = 2,
    ACTIONS(2242), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41325] = 2,
    ACTIONS(2244), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41333] = 2,
    ACTIONS(2246), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41341] = 2,
    ACTIONS(2248), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41349] = 2,
    ACTIONS(2250), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41357] = 2,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41365] = 2,
    ACTIONS(2254), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41373] = 2,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41381] = 2,
    ACTIONS(2258), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41389] = 2,
    ACTIONS(2260), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41397] = 2,
    ACTIONS(2256), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41405] = 2,
    ACTIONS(2262), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41413] = 2,
    ACTIONS(1966), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41421] = 2,
    ACTIONS(2264), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41429] = 2,
    ACTIONS(2266), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41437] = 2,
    ACTIONS(1830), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41445] = 2,
    ACTIONS(2268), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41453] = 2,
    ACTIONS(2270), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41461] = 2,
    ACTIONS(2272), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41469] = 2,
    ACTIONS(2274), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41477] = 2,
    ACTIONS(2266), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41485] = 2,
    ACTIONS(2276), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41493] = 2,
    ACTIONS(2278), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41501] = 2,
    ACTIONS(2280), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41509] = 2,
    ACTIONS(1306), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41517] = 2,
    ACTIONS(2282), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41525] = 2,
    ACTIONS(2284), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41533] = 2,
    ACTIONS(2286), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41541] = 2,
    ACTIONS(2288), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41549] = 2,
    ACTIONS(2290), 1,
      aux_sym_double_token2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41557] = 2,
    ACTIONS(2292), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41565] = 2,
    ACTIONS(2294), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41573] = 2,
    ACTIONS(2296), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41581] = 2,
    ACTIONS(2298), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41589] = 2,
    ACTIONS(2300), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41597] = 2,
    ACTIONS(2302), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41605] = 2,
    ACTIONS(2304), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41613] = 2,
    ACTIONS(2306), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41621] = 2,
    ACTIONS(2308), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41629] = 2,
    ACTIONS(2310), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41637] = 2,
    ACTIONS(2312), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41645] = 2,
    ACTIONS(1597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41653] = 2,
    ACTIONS(2314), 1,
      sym_keyword_into,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [41661] = 2,
    ACTIONS(2092), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 62,
  [SMALL_STATE(4)] = 124,
  [SMALL_STATE(5)] = 180,
  [SMALL_STATE(6)] = 236,
  [SMALL_STATE(7)] = 315,
  [SMALL_STATE(8)] = 394,
  [SMALL_STATE(9)] = 473,
  [SMALL_STATE(10)] = 550,
  [SMALL_STATE(11)] = 627,
  [SMALL_STATE(12)] = 704,
  [SMALL_STATE(13)] = 781,
  [SMALL_STATE(14)] = 829,
  [SMALL_STATE(15)] = 873,
  [SMALL_STATE(16)] = 917,
  [SMALL_STATE(17)] = 988,
  [SMALL_STATE(18)] = 1033,
  [SMALL_STATE(19)] = 1075,
  [SMALL_STATE(20)] = 1117,
  [SMALL_STATE(21)] = 1161,
  [SMALL_STATE(22)] = 1203,
  [SMALL_STATE(23)] = 1247,
  [SMALL_STATE(24)] = 1291,
  [SMALL_STATE(25)] = 1335,
  [SMALL_STATE(26)] = 1377,
  [SMALL_STATE(27)] = 1419,
  [SMALL_STATE(28)] = 1461,
  [SMALL_STATE(29)] = 1505,
  [SMALL_STATE(30)] = 1559,
  [SMALL_STATE(31)] = 1603,
  [SMALL_STATE(32)] = 1647,
  [SMALL_STATE(33)] = 1691,
  [SMALL_STATE(34)] = 1735,
  [SMALL_STATE(35)] = 1779,
  [SMALL_STATE(36)] = 1823,
  [SMALL_STATE(37)] = 1867,
  [SMALL_STATE(38)] = 1909,
  [SMALL_STATE(39)] = 1951,
  [SMALL_STATE(40)] = 1993,
  [SMALL_STATE(41)] = 2035,
  [SMALL_STATE(42)] = 2079,
  [SMALL_STATE(43)] = 2123,
  [SMALL_STATE(44)] = 2167,
  [SMALL_STATE(45)] = 2211,
  [SMALL_STATE(46)] = 2253,
  [SMALL_STATE(47)] = 2297,
  [SMALL_STATE(48)] = 2341,
  [SMALL_STATE(49)] = 2395,
  [SMALL_STATE(50)] = 2439,
  [SMALL_STATE(51)] = 2483,
  [SMALL_STATE(52)] = 2527,
  [SMALL_STATE(53)] = 2569,
  [SMALL_STATE(54)] = 2611,
  [SMALL_STATE(55)] = 2653,
  [SMALL_STATE(56)] = 2705,
  [SMALL_STATE(57)] = 2747,
  [SMALL_STATE(58)] = 2809,
  [SMALL_STATE(59)] = 2851,
  [SMALL_STATE(60)] = 2893,
  [SMALL_STATE(61)] = 2947,
  [SMALL_STATE(62)] = 2991,
  [SMALL_STATE(63)] = 3039,
  [SMALL_STATE(64)] = 3081,
  [SMALL_STATE(65)] = 3123,
  [SMALL_STATE(66)] = 3183,
  [SMALL_STATE(67)] = 3225,
  [SMALL_STATE(68)] = 3269,
  [SMALL_STATE(69)] = 3311,
  [SMALL_STATE(70)] = 3351,
  [SMALL_STATE(71)] = 3395,
  [SMALL_STATE(72)] = 3435,
  [SMALL_STATE(73)] = 3479,
  [SMALL_STATE(74)] = 3551,
  [SMALL_STATE(75)] = 3595,
  [SMALL_STATE(76)] = 3635,
  [SMALL_STATE(77)] = 3702,
  [SMALL_STATE(78)] = 3743,
  [SMALL_STATE(79)] = 3782,
  [SMALL_STATE(80)] = 3825,
  [SMALL_STATE(81)] = 3864,
  [SMALL_STATE(82)] = 3905,
  [SMALL_STATE(83)] = 3946,
  [SMALL_STATE(84)] = 3985,
  [SMALL_STATE(85)] = 4024,
  [SMALL_STATE(86)] = 4062,
  [SMALL_STATE(87)] = 4100,
  [SMALL_STATE(88)] = 4138,
  [SMALL_STATE(89)] = 4188,
  [SMALL_STATE(90)] = 4226,
  [SMALL_STATE(91)] = 4264,
  [SMALL_STATE(92)] = 4302,
  [SMALL_STATE(93)] = 4372,
  [SMALL_STATE(94)] = 4410,
  [SMALL_STATE(95)] = 4452,
  [SMALL_STATE(96)] = 4502,
  [SMALL_STATE(97)] = 4540,
  [SMALL_STATE(98)] = 4578,
  [SMALL_STATE(99)] = 4616,
  [SMALL_STATE(100)] = 4654,
  [SMALL_STATE(101)] = 4692,
  [SMALL_STATE(102)] = 4730,
  [SMALL_STATE(103)] = 4778,
  [SMALL_STATE(104)] = 4816,
  [SMALL_STATE(105)] = 4854,
  [SMALL_STATE(106)] = 4892,
  [SMALL_STATE(107)] = 4946,
  [SMALL_STATE(108)] = 4984,
  [SMALL_STATE(109)] = 5040,
  [SMALL_STATE(110)] = 5084,
  [SMALL_STATE(111)] = 5124,
  [SMALL_STATE(112)] = 5174,
  [SMALL_STATE(113)] = 5212,
  [SMALL_STATE(114)] = 5268,
  [SMALL_STATE(115)] = 5316,
  [SMALL_STATE(116)] = 5354,
  [SMALL_STATE(117)] = 5392,
  [SMALL_STATE(118)] = 5430,
  [SMALL_STATE(119)] = 5468,
  [SMALL_STATE(120)] = 5506,
  [SMALL_STATE(121)] = 5544,
  [SMALL_STATE(122)] = 5582,
  [SMALL_STATE(123)] = 5620,
  [SMALL_STATE(124)] = 5658,
  [SMALL_STATE(125)] = 5696,
  [SMALL_STATE(126)] = 5766,
  [SMALL_STATE(127)] = 5804,
  [SMALL_STATE(128)] = 5842,
  [SMALL_STATE(129)] = 5880,
  [SMALL_STATE(130)] = 5918,
  [SMALL_STATE(131)] = 5956,
  [SMALL_STATE(132)] = 5994,
  [SMALL_STATE(133)] = 6032,
  [SMALL_STATE(134)] = 6070,
  [SMALL_STATE(135)] = 6108,
  [SMALL_STATE(136)] = 6170,
  [SMALL_STATE(137)] = 6208,
  [SMALL_STATE(138)] = 6250,
  [SMALL_STATE(139)] = 6288,
  [SMALL_STATE(140)] = 6332,
  [SMALL_STATE(141)] = 6370,
  [SMALL_STATE(142)] = 6410,
  [SMALL_STATE(143)] = 6450,
  [SMALL_STATE(144)] = 6500,
  [SMALL_STATE(145)] = 6538,
  [SMALL_STATE(146)] = 6596,
  [SMALL_STATE(147)] = 6646,
  [SMALL_STATE(148)] = 6696,
  [SMALL_STATE(149)] = 6734,
  [SMALL_STATE(150)] = 6772,
  [SMALL_STATE(151)] = 6809,
  [SMALL_STATE(152)] = 6848,
  [SMALL_STATE(153)] = 6885,
  [SMALL_STATE(154)] = 6934,
  [SMALL_STATE(155)] = 6987,
  [SMALL_STATE(156)] = 7024,
  [SMALL_STATE(157)] = 7079,
  [SMALL_STATE(158)] = 7122,
  [SMALL_STATE(159)] = 7159,
  [SMALL_STATE(160)] = 7206,
  [SMALL_STATE(161)] = 7243,
  [SMALL_STATE(162)] = 7280,
  [SMALL_STATE(163)] = 7317,
  [SMALL_STATE(164)] = 7354,
  [SMALL_STATE(165)] = 7391,
  [SMALL_STATE(166)] = 7428,
  [SMALL_STATE(167)] = 7495,
  [SMALL_STATE(168)] = 7534,
  [SMALL_STATE(169)] = 7571,
  [SMALL_STATE(170)] = 7608,
  [SMALL_STATE(171)] = 7675,
  [SMALL_STATE(172)] = 7742,
  [SMALL_STATE(173)] = 7781,
  [SMALL_STATE(174)] = 7818,
  [SMALL_STATE(175)] = 7855,
  [SMALL_STATE(176)] = 7892,
  [SMALL_STATE(177)] = 7929,
  [SMALL_STATE(178)] = 7966,
  [SMALL_STATE(179)] = 8003,
  [SMALL_STATE(180)] = 8052,
  [SMALL_STATE(181)] = 8089,
  [SMALL_STATE(182)] = 8126,
  [SMALL_STATE(183)] = 8175,
  [SMALL_STATE(184)] = 8212,
  [SMALL_STATE(185)] = 8268,
  [SMALL_STATE(186)] = 8306,
  [SMALL_STATE(187)] = 8364,
  [SMALL_STATE(188)] = 8400,
  [SMALL_STATE(189)] = 8436,
  [SMALL_STATE(190)] = 8472,
  [SMALL_STATE(191)] = 8508,
  [SMALL_STATE(192)] = 8544,
  [SMALL_STATE(193)] = 8580,
  [SMALL_STATE(194)] = 8644,
  [SMALL_STATE(195)] = 8680,
  [SMALL_STATE(196)] = 8716,
  [SMALL_STATE(197)] = 8752,
  [SMALL_STATE(198)] = 8788,
  [SMALL_STATE(199)] = 8836,
  [SMALL_STATE(200)] = 8872,
  [SMALL_STATE(201)] = 8908,
  [SMALL_STATE(202)] = 8956,
  [SMALL_STATE(203)] = 8992,
  [SMALL_STATE(204)] = 9028,
  [SMALL_STATE(205)] = 9064,
  [SMALL_STATE(206)] = 9100,
  [SMALL_STATE(207)] = 9140,
  [SMALL_STATE(208)] = 9194,
  [SMALL_STATE(209)] = 9230,
  [SMALL_STATE(210)] = 9266,
  [SMALL_STATE(211)] = 9302,
  [SMALL_STATE(212)] = 9338,
  [SMALL_STATE(213)] = 9386,
  [SMALL_STATE(214)] = 9422,
  [SMALL_STATE(215)] = 9458,
  [SMALL_STATE(216)] = 9506,
  [SMALL_STATE(217)] = 9542,
  [SMALL_STATE(218)] = 9578,
  [SMALL_STATE(219)] = 9614,
  [SMALL_STATE(220)] = 9650,
  [SMALL_STATE(221)] = 9686,
  [SMALL_STATE(222)] = 9722,
  [SMALL_STATE(223)] = 9758,
  [SMALL_STATE(224)] = 9794,
  [SMALL_STATE(225)] = 9848,
  [SMALL_STATE(226)] = 9884,
  [SMALL_STATE(227)] = 9926,
  [SMALL_STATE(228)] = 9964,
  [SMALL_STATE(229)] = 10006,
  [SMALL_STATE(230)] = 10044,
  [SMALL_STATE(231)] = 10092,
  [SMALL_STATE(232)] = 10128,
  [SMALL_STATE(233)] = 10184,
  [SMALL_STATE(234)] = 10230,
  [SMALL_STATE(235)] = 10266,
  [SMALL_STATE(236)] = 10302,
  [SMALL_STATE(237)] = 10338,
  [SMALL_STATE(238)] = 10402,
  [SMALL_STATE(239)] = 10438,
  [SMALL_STATE(240)] = 10474,
  [SMALL_STATE(241)] = 10510,
  [SMALL_STATE(242)] = 10558,
  [SMALL_STATE(243)] = 10594,
  [SMALL_STATE(244)] = 10640,
  [SMALL_STATE(245)] = 10676,
  [SMALL_STATE(246)] = 10714,
  [SMALL_STATE(247)] = 10752,
  [SMALL_STATE(248)] = 10788,
  [SMALL_STATE(249)] = 10826,
  [SMALL_STATE(250)] = 10864,
  [SMALL_STATE(251)] = 10900,
  [SMALL_STATE(252)] = 10936,
  [SMALL_STATE(253)] = 10974,
  [SMALL_STATE(254)] = 11012,
  [SMALL_STATE(255)] = 11050,
  [SMALL_STATE(256)] = 11088,
  [SMALL_STATE(257)] = 11126,
  [SMALL_STATE(258)] = 11164,
  [SMALL_STATE(259)] = 11202,
  [SMALL_STATE(260)] = 11240,
  [SMALL_STATE(261)] = 11278,
  [SMALL_STATE(262)] = 11316,
  [SMALL_STATE(263)] = 11354,
  [SMALL_STATE(264)] = 11392,
  [SMALL_STATE(265)] = 11430,
  [SMALL_STATE(266)] = 11468,
  [SMALL_STATE(267)] = 11506,
  [SMALL_STATE(268)] = 11544,
  [SMALL_STATE(269)] = 11582,
  [SMALL_STATE(270)] = 11618,
  [SMALL_STATE(271)] = 11681,
  [SMALL_STATE(272)] = 11720,
  [SMALL_STATE(273)] = 11757,
  [SMALL_STATE(274)] = 11820,
  [SMALL_STATE(275)] = 11883,
  [SMALL_STATE(276)] = 11946,
  [SMALL_STATE(277)] = 12013,
  [SMALL_STATE(278)] = 12076,
  [SMALL_STATE(279)] = 12139,
  [SMALL_STATE(280)] = 12202,
  [SMALL_STATE(281)] = 12265,
  [SMALL_STATE(282)] = 12328,
  [SMALL_STATE(283)] = 12391,
  [SMALL_STATE(284)] = 12454,
  [SMALL_STATE(285)] = 12517,
  [SMALL_STATE(286)] = 12580,
  [SMALL_STATE(287)] = 12643,
  [SMALL_STATE(288)] = 12706,
  [SMALL_STATE(289)] = 12769,
  [SMALL_STATE(290)] = 12832,
  [SMALL_STATE(291)] = 12867,
  [SMALL_STATE(292)] = 12930,
  [SMALL_STATE(293)] = 12965,
  [SMALL_STATE(294)] = 13028,
  [SMALL_STATE(295)] = 13065,
  [SMALL_STATE(296)] = 13104,
  [SMALL_STATE(297)] = 13138,
  [SMALL_STATE(298)] = 13198,
  [SMALL_STATE(299)] = 13232,
  [SMALL_STATE(300)] = 13266,
  [SMALL_STATE(301)] = 13300,
  [SMALL_STATE(302)] = 13334,
  [SMALL_STATE(303)] = 13368,
  [SMALL_STATE(304)] = 13412,
  [SMALL_STATE(305)] = 13466,
  [SMALL_STATE(306)] = 13500,
  [SMALL_STATE(307)] = 13546,
  [SMALL_STATE(308)] = 13582,
  [SMALL_STATE(309)] = 13642,
  [SMALL_STATE(310)] = 13676,
  [SMALL_STATE(311)] = 13710,
  [SMALL_STATE(312)] = 13762,
  [SMALL_STATE(313)] = 13796,
  [SMALL_STATE(314)] = 13830,
  [SMALL_STATE(315)] = 13866,
  [SMALL_STATE(316)] = 13900,
  [SMALL_STATE(317)] = 13960,
  [SMALL_STATE(318)] = 14020,
  [SMALL_STATE(319)] = 14080,
  [SMALL_STATE(320)] = 14140,
  [SMALL_STATE(321)] = 14176,
  [SMALL_STATE(322)] = 14210,
  [SMALL_STATE(323)] = 14270,
  [SMALL_STATE(324)] = 14304,
  [SMALL_STATE(325)] = 14338,
  [SMALL_STATE(326)] = 14372,
  [SMALL_STATE(327)] = 14406,
  [SMALL_STATE(328)] = 14466,
  [SMALL_STATE(329)] = 14506,
  [SMALL_STATE(330)] = 14566,
  [SMALL_STATE(331)] = 14600,
  [SMALL_STATE(332)] = 14646,
  [SMALL_STATE(333)] = 14706,
  [SMALL_STATE(334)] = 14766,
  [SMALL_STATE(335)] = 14800,
  [SMALL_STATE(336)] = 14860,
  [SMALL_STATE(337)] = 14894,
  [SMALL_STATE(338)] = 14940,
  [SMALL_STATE(339)] = 15000,
  [SMALL_STATE(340)] = 15060,
  [SMALL_STATE(341)] = 15118,
  [SMALL_STATE(342)] = 15178,
  [SMALL_STATE(343)] = 15238,
  [SMALL_STATE(344)] = 15272,
  [SMALL_STATE(345)] = 15332,
  [SMALL_STATE(346)] = 15392,
  [SMALL_STATE(347)] = 15452,
  [SMALL_STATE(348)] = 15512,
  [SMALL_STATE(349)] = 15572,
  [SMALL_STATE(350)] = 15633,
  [SMALL_STATE(351)] = 15694,
  [SMALL_STATE(352)] = 15727,
  [SMALL_STATE(353)] = 15760,
  [SMALL_STATE(354)] = 15793,
  [SMALL_STATE(355)] = 15850,
  [SMALL_STATE(356)] = 15901,
  [SMALL_STATE(357)] = 15958,
  [SMALL_STATE(358)] = 15991,
  [SMALL_STATE(359)] = 16030,
  [SMALL_STATE(360)] = 16087,
  [SMALL_STATE(361)] = 16146,
  [SMALL_STATE(362)] = 16203,
  [SMALL_STATE(363)] = 16238,
  [SMALL_STATE(364)] = 16297,
  [SMALL_STATE(365)] = 16342,
  [SMALL_STATE(366)] = 16399,
  [SMALL_STATE(367)] = 16458,
  [SMALL_STATE(368)] = 16515,
  [SMALL_STATE(369)] = 16548,
  [SMALL_STATE(370)] = 16607,
  [SMALL_STATE(371)] = 16664,
  [SMALL_STATE(372)] = 16723,
  [SMALL_STATE(373)] = 16780,
  [SMALL_STATE(374)] = 16839,
  [SMALL_STATE(375)] = 16896,
  [SMALL_STATE(376)] = 16955,
  [SMALL_STATE(377)] = 17008,
  [SMALL_STATE(378)] = 17065,
  [SMALL_STATE(379)] = 17108,
  [SMALL_STATE(380)] = 17141,
  [SMALL_STATE(381)] = 17174,
  [SMALL_STATE(382)] = 17207,
  [SMALL_STATE(383)] = 17240,
  [SMALL_STATE(384)] = 17273,
  [SMALL_STATE(385)] = 17330,
  [SMALL_STATE(386)] = 17387,
  [SMALL_STATE(387)] = 17444,
  [SMALL_STATE(388)] = 17501,
  [SMALL_STATE(389)] = 17558,
  [SMALL_STATE(390)] = 17615,
  [SMALL_STATE(391)] = 17672,
  [SMALL_STATE(392)] = 17729,
  [SMALL_STATE(393)] = 17786,
  [SMALL_STATE(394)] = 17843,
  [SMALL_STATE(395)] = 17900,
  [SMALL_STATE(396)] = 17957,
  [SMALL_STATE(397)] = 18014,
  [SMALL_STATE(398)] = 18071,
  [SMALL_STATE(399)] = 18132,
  [SMALL_STATE(400)] = 18189,
  [SMALL_STATE(401)] = 18246,
  [SMALL_STATE(402)] = 18303,
  [SMALL_STATE(403)] = 18360,
  [SMALL_STATE(404)] = 18417,
  [SMALL_STATE(405)] = 18474,
  [SMALL_STATE(406)] = 18533,
  [SMALL_STATE(407)] = 18590,
  [SMALL_STATE(408)] = 18647,
  [SMALL_STATE(409)] = 18704,
  [SMALL_STATE(410)] = 18761,
  [SMALL_STATE(411)] = 18818,
  [SMALL_STATE(412)] = 18875,
  [SMALL_STATE(413)] = 18908,
  [SMALL_STATE(414)] = 18965,
  [SMALL_STATE(415)] = 19022,
  [SMALL_STATE(416)] = 19079,
  [SMALL_STATE(417)] = 19138,
  [SMALL_STATE(418)] = 19195,
  [SMALL_STATE(419)] = 19252,
  [SMALL_STATE(420)] = 19309,
  [SMALL_STATE(421)] = 19342,
  [SMALL_STATE(422)] = 19399,
  [SMALL_STATE(423)] = 19456,
  [SMALL_STATE(424)] = 19513,
  [SMALL_STATE(425)] = 19546,
  [SMALL_STATE(426)] = 19603,
  [SMALL_STATE(427)] = 19660,
  [SMALL_STATE(428)] = 19717,
  [SMALL_STATE(429)] = 19774,
  [SMALL_STATE(430)] = 19831,
  [SMALL_STATE(431)] = 19888,
  [SMALL_STATE(432)] = 19945,
  [SMALL_STATE(433)] = 20002,
  [SMALL_STATE(434)] = 20059,
  [SMALL_STATE(435)] = 20116,
  [SMALL_STATE(436)] = 20173,
  [SMALL_STATE(437)] = 20230,
  [SMALL_STATE(438)] = 20287,
  [SMALL_STATE(439)] = 20344,
  [SMALL_STATE(440)] = 20401,
  [SMALL_STATE(441)] = 20458,
  [SMALL_STATE(442)] = 20515,
  [SMALL_STATE(443)] = 20572,
  [SMALL_STATE(444)] = 20629,
  [SMALL_STATE(445)] = 20662,
  [SMALL_STATE(446)] = 20707,
  [SMALL_STATE(447)] = 20764,
  [SMALL_STATE(448)] = 20797,
  [SMALL_STATE(449)] = 20830,
  [SMALL_STATE(450)] = 20875,
  [SMALL_STATE(451)] = 20908,
  [SMALL_STATE(452)] = 20965,
  [SMALL_STATE(453)] = 20998,
  [SMALL_STATE(454)] = 21031,
  [SMALL_STATE(455)] = 21064,
  [SMALL_STATE(456)] = 21121,
  [SMALL_STATE(457)] = 21178,
  [SMALL_STATE(458)] = 21235,
  [SMALL_STATE(459)] = 21292,
  [SMALL_STATE(460)] = 21349,
  [SMALL_STATE(461)] = 21406,
  [SMALL_STATE(462)] = 21463,
  [SMALL_STATE(463)] = 21520,
  [SMALL_STATE(464)] = 21577,
  [SMALL_STATE(465)] = 21634,
  [SMALL_STATE(466)] = 21691,
  [SMALL_STATE(467)] = 21748,
  [SMALL_STATE(468)] = 21805,
  [SMALL_STATE(469)] = 21862,
  [SMALL_STATE(470)] = 21919,
  [SMALL_STATE(471)] = 21980,
  [SMALL_STATE(472)] = 22037,
  [SMALL_STATE(473)] = 22094,
  [SMALL_STATE(474)] = 22155,
  [SMALL_STATE(475)] = 22212,
  [SMALL_STATE(476)] = 22269,
  [SMALL_STATE(477)] = 22326,
  [SMALL_STATE(478)] = 22383,
  [SMALL_STATE(479)] = 22440,
  [SMALL_STATE(480)] = 22497,
  [SMALL_STATE(481)] = 22554,
  [SMALL_STATE(482)] = 22611,
  [SMALL_STATE(483)] = 22668,
  [SMALL_STATE(484)] = 22701,
  [SMALL_STATE(485)] = 22758,
  [SMALL_STATE(486)] = 22815,
  [SMALL_STATE(487)] = 22872,
  [SMALL_STATE(488)] = 22929,
  [SMALL_STATE(489)] = 22986,
  [SMALL_STATE(490)] = 23043,
  [SMALL_STATE(491)] = 23100,
  [SMALL_STATE(492)] = 23155,
  [SMALL_STATE(493)] = 23212,
  [SMALL_STATE(494)] = 23269,
  [SMALL_STATE(495)] = 23330,
  [SMALL_STATE(496)] = 23387,
  [SMALL_STATE(497)] = 23444,
  [SMALL_STATE(498)] = 23501,
  [SMALL_STATE(499)] = 23558,
  [SMALL_STATE(500)] = 23615,
  [SMALL_STATE(501)] = 23672,
  [SMALL_STATE(502)] = 23729,
  [SMALL_STATE(503)] = 23786,
  [SMALL_STATE(504)] = 23847,
  [SMALL_STATE(505)] = 23904,
  [SMALL_STATE(506)] = 23961,
  [SMALL_STATE(507)] = 24022,
  [SMALL_STATE(508)] = 24083,
  [SMALL_STATE(509)] = 24144,
  [SMALL_STATE(510)] = 24205,
  [SMALL_STATE(511)] = 24266,
  [SMALL_STATE(512)] = 24327,
  [SMALL_STATE(513)] = 24384,
  [SMALL_STATE(514)] = 24445,
  [SMALL_STATE(515)] = 24506,
  [SMALL_STATE(516)] = 24567,
  [SMALL_STATE(517)] = 24624,
  [SMALL_STATE(518)] = 24685,
  [SMALL_STATE(519)] = 24742,
  [SMALL_STATE(520)] = 24801,
  [SMALL_STATE(521)] = 24858,
  [SMALL_STATE(522)] = 24915,
  [SMALL_STATE(523)] = 24976,
  [SMALL_STATE(524)] = 25033,
  [SMALL_STATE(525)] = 25094,
  [SMALL_STATE(526)] = 25151,
  [SMALL_STATE(527)] = 25208,
  [SMALL_STATE(528)] = 25269,
  [SMALL_STATE(529)] = 25326,
  [SMALL_STATE(530)] = 25383,
  [SMALL_STATE(531)] = 25444,
  [SMALL_STATE(532)] = 25501,
  [SMALL_STATE(533)] = 25558,
  [SMALL_STATE(534)] = 25615,
  [SMALL_STATE(535)] = 25672,
  [SMALL_STATE(536)] = 25729,
  [SMALL_STATE(537)] = 25786,
  [SMALL_STATE(538)] = 25843,
  [SMALL_STATE(539)] = 25904,
  [SMALL_STATE(540)] = 25961,
  [SMALL_STATE(541)] = 26018,
  [SMALL_STATE(542)] = 26075,
  [SMALL_STATE(543)] = 26132,
  [SMALL_STATE(544)] = 26189,
  [SMALL_STATE(545)] = 26246,
  [SMALL_STATE(546)] = 26303,
  [SMALL_STATE(547)] = 26360,
  [SMALL_STATE(548)] = 26417,
  [SMALL_STATE(549)] = 26476,
  [SMALL_STATE(550)] = 26533,
  [SMALL_STATE(551)] = 26590,
  [SMALL_STATE(552)] = 26644,
  [SMALL_STATE(553)] = 26686,
  [SMALL_STATE(554)] = 26742,
  [SMALL_STATE(555)] = 26798,
  [SMALL_STATE(556)] = 26854,
  [SMALL_STATE(557)] = 26893,
  [SMALL_STATE(558)] = 26944,
  [SMALL_STATE(559)] = 27000,
  [SMALL_STATE(560)] = 27056,
  [SMALL_STATE(561)] = 27112,
  [SMALL_STATE(562)] = 27168,
  [SMALL_STATE(563)] = 27224,
  [SMALL_STATE(564)] = 27280,
  [SMALL_STATE(565)] = 27336,
  [SMALL_STATE(566)] = 27392,
  [SMALL_STATE(567)] = 27448,
  [SMALL_STATE(568)] = 27504,
  [SMALL_STATE(569)] = 27560,
  [SMALL_STATE(570)] = 27616,
  [SMALL_STATE(571)] = 27672,
  [SMALL_STATE(572)] = 27728,
  [SMALL_STATE(573)] = 27784,
  [SMALL_STATE(574)] = 27840,
  [SMALL_STATE(575)] = 27871,
  [SMALL_STATE(576)] = 27928,
  [SMALL_STATE(577)] = 27981,
  [SMALL_STATE(578)] = 28030,
  [SMALL_STATE(579)] = 28083,
  [SMALL_STATE(580)] = 28136,
  [SMALL_STATE(581)] = 28185,
  [SMALL_STATE(582)] = 28238,
  [SMALL_STATE(583)] = 28265,
  [SMALL_STATE(584)] = 28318,
  [SMALL_STATE(585)] = 28371,
  [SMALL_STATE(586)] = 28420,
  [SMALL_STATE(587)] = 28447,
  [SMALL_STATE(588)] = 28500,
  [SMALL_STATE(589)] = 28527,
  [SMALL_STATE(590)] = 28580,
  [SMALL_STATE(591)] = 28607,
  [SMALL_STATE(592)] = 28660,
  [SMALL_STATE(593)] = 28708,
  [SMALL_STATE(594)] = 28744,
  [SMALL_STATE(595)] = 28770,
  [SMALL_STATE(596)] = 28818,
  [SMALL_STATE(597)] = 28844,
  [SMALL_STATE(598)] = 28892,
  [SMALL_STATE(599)] = 28939,
  [SMALL_STATE(600)] = 28986,
  [SMALL_STATE(601)] = 29033,
  [SMALL_STATE(602)] = 29080,
  [SMALL_STATE(603)] = 29127,
  [SMALL_STATE(604)] = 29174,
  [SMALL_STATE(605)] = 29221,
  [SMALL_STATE(606)] = 29268,
  [SMALL_STATE(607)] = 29315,
  [SMALL_STATE(608)] = 29362,
  [SMALL_STATE(609)] = 29409,
  [SMALL_STATE(610)] = 29456,
  [SMALL_STATE(611)] = 29485,
  [SMALL_STATE(612)] = 29532,
  [SMALL_STATE(613)] = 29579,
  [SMALL_STATE(614)] = 29626,
  [SMALL_STATE(615)] = 29673,
  [SMALL_STATE(616)] = 29720,
  [SMALL_STATE(617)] = 29767,
  [SMALL_STATE(618)] = 29796,
  [SMALL_STATE(619)] = 29843,
  [SMALL_STATE(620)] = 29890,
  [SMALL_STATE(621)] = 29937,
  [SMALL_STATE(622)] = 29984,
  [SMALL_STATE(623)] = 30013,
  [SMALL_STATE(624)] = 30060,
  [SMALL_STATE(625)] = 30107,
  [SMALL_STATE(626)] = 30154,
  [SMALL_STATE(627)] = 30183,
  [SMALL_STATE(628)] = 30230,
  [SMALL_STATE(629)] = 30277,
  [SMALL_STATE(630)] = 30306,
  [SMALL_STATE(631)] = 30353,
  [SMALL_STATE(632)] = 30400,
  [SMALL_STATE(633)] = 30447,
  [SMALL_STATE(634)] = 30494,
  [SMALL_STATE(635)] = 30541,
  [SMALL_STATE(636)] = 30588,
  [SMALL_STATE(637)] = 30635,
  [SMALL_STATE(638)] = 30682,
  [SMALL_STATE(639)] = 30729,
  [SMALL_STATE(640)] = 30758,
  [SMALL_STATE(641)] = 30805,
  [SMALL_STATE(642)] = 30852,
  [SMALL_STATE(643)] = 30899,
  [SMALL_STATE(644)] = 30928,
  [SMALL_STATE(645)] = 30975,
  [SMALL_STATE(646)] = 31004,
  [SMALL_STATE(647)] = 31051,
  [SMALL_STATE(648)] = 31098,
  [SMALL_STATE(649)] = 31127,
  [SMALL_STATE(650)] = 31174,
  [SMALL_STATE(651)] = 31221,
  [SMALL_STATE(652)] = 31268,
  [SMALL_STATE(653)] = 31315,
  [SMALL_STATE(654)] = 31362,
  [SMALL_STATE(655)] = 31409,
  [SMALL_STATE(656)] = 31434,
  [SMALL_STATE(657)] = 31481,
  [SMALL_STATE(658)] = 31528,
  [SMALL_STATE(659)] = 31575,
  [SMALL_STATE(660)] = 31622,
  [SMALL_STATE(661)] = 31669,
  [SMALL_STATE(662)] = 31694,
  [SMALL_STATE(663)] = 31741,
  [SMALL_STATE(664)] = 31788,
  [SMALL_STATE(665)] = 31835,
  [SMALL_STATE(666)] = 31882,
  [SMALL_STATE(667)] = 31926,
  [SMALL_STATE(668)] = 31976,
  [SMALL_STATE(669)] = 32026,
  [SMALL_STATE(670)] = 32070,
  [SMALL_STATE(671)] = 32114,
  [SMALL_STATE(672)] = 32158,
  [SMALL_STATE(673)] = 32208,
  [SMALL_STATE(674)] = 32252,
  [SMALL_STATE(675)] = 32275,
  [SMALL_STATE(676)] = 32298,
  [SMALL_STATE(677)] = 32321,
  [SMALL_STATE(678)] = 32344,
  [SMALL_STATE(679)] = 32386,
  [SMALL_STATE(680)] = 32428,
  [SMALL_STATE(681)] = 32451,
  [SMALL_STATE(682)] = 32471,
  [SMALL_STATE(683)] = 32503,
  [SMALL_STATE(684)] = 32535,
  [SMALL_STATE(685)] = 32567,
  [SMALL_STATE(686)] = 32597,
  [SMALL_STATE(687)] = 32631,
  [SMALL_STATE(688)] = 32667,
  [SMALL_STATE(689)] = 32703,
  [SMALL_STATE(690)] = 32737,
  [SMALL_STATE(691)] = 32757,
  [SMALL_STATE(692)] = 32798,
  [SMALL_STATE(693)] = 32828,
  [SMALL_STATE(694)] = 32850,
  [SMALL_STATE(695)] = 32868,
  [SMALL_STATE(696)] = 32890,
  [SMALL_STATE(697)] = 32910,
  [SMALL_STATE(698)] = 32936,
  [SMALL_STATE(699)] = 32962,
  [SMALL_STATE(700)] = 32980,
  [SMALL_STATE(701)] = 32998,
  [SMALL_STATE(702)] = 33024,
  [SMALL_STATE(703)] = 33042,
  [SMALL_STATE(704)] = 33060,
  [SMALL_STATE(705)] = 33078,
  [SMALL_STATE(706)] = 33104,
  [SMALL_STATE(707)] = 33122,
  [SMALL_STATE(708)] = 33140,
  [SMALL_STATE(709)] = 33159,
  [SMALL_STATE(710)] = 33178,
  [SMALL_STATE(711)] = 33195,
  [SMALL_STATE(712)] = 33212,
  [SMALL_STATE(713)] = 33231,
  [SMALL_STATE(714)] = 33252,
  [SMALL_STATE(715)] = 33273,
  [SMALL_STATE(716)] = 33300,
  [SMALL_STATE(717)] = 33321,
  [SMALL_STATE(718)] = 33342,
  [SMALL_STATE(719)] = 33363,
  [SMALL_STATE(720)] = 33384,
  [SMALL_STATE(721)] = 33403,
  [SMALL_STATE(722)] = 33422,
  [SMALL_STATE(723)] = 33441,
  [SMALL_STATE(724)] = 33462,
  [SMALL_STATE(725)] = 33481,
  [SMALL_STATE(726)] = 33508,
  [SMALL_STATE(727)] = 33525,
  [SMALL_STATE(728)] = 33544,
  [SMALL_STATE(729)] = 33561,
  [SMALL_STATE(730)] = 33580,
  [SMALL_STATE(731)] = 33600,
  [SMALL_STATE(732)] = 33616,
  [SMALL_STATE(733)] = 33632,
  [SMALL_STATE(734)] = 33648,
  [SMALL_STATE(735)] = 33664,
  [SMALL_STATE(736)] = 33690,
  [SMALL_STATE(737)] = 33706,
  [SMALL_STATE(738)] = 33732,
  [SMALL_STATE(739)] = 33760,
  [SMALL_STATE(740)] = 33776,
  [SMALL_STATE(741)] = 33792,
  [SMALL_STATE(742)] = 33812,
  [SMALL_STATE(743)] = 33828,
  [SMALL_STATE(744)] = 33844,
  [SMALL_STATE(745)] = 33860,
  [SMALL_STATE(746)] = 33876,
  [SMALL_STATE(747)] = 33892,
  [SMALL_STATE(748)] = 33908,
  [SMALL_STATE(749)] = 33924,
  [SMALL_STATE(750)] = 33940,
  [SMALL_STATE(751)] = 33956,
  [SMALL_STATE(752)] = 33976,
  [SMALL_STATE(753)] = 33992,
  [SMALL_STATE(754)] = 34008,
  [SMALL_STATE(755)] = 34028,
  [SMALL_STATE(756)] = 34048,
  [SMALL_STATE(757)] = 34064,
  [SMALL_STATE(758)] = 34080,
  [SMALL_STATE(759)] = 34096,
  [SMALL_STATE(760)] = 34124,
  [SMALL_STATE(761)] = 34144,
  [SMALL_STATE(762)] = 34160,
  [SMALL_STATE(763)] = 34180,
  [SMALL_STATE(764)] = 34200,
  [SMALL_STATE(765)] = 34223,
  [SMALL_STATE(766)] = 34238,
  [SMALL_STATE(767)] = 34259,
  [SMALL_STATE(768)] = 34274,
  [SMALL_STATE(769)] = 34293,
  [SMALL_STATE(770)] = 34316,
  [SMALL_STATE(771)] = 34343,
  [SMALL_STATE(772)] = 34370,
  [SMALL_STATE(773)] = 34399,
  [SMALL_STATE(774)] = 34422,
  [SMALL_STATE(775)] = 34451,
  [SMALL_STATE(776)] = 34472,
  [SMALL_STATE(777)] = 34499,
  [SMALL_STATE(778)] = 34518,
  [SMALL_STATE(779)] = 34545,
  [SMALL_STATE(780)] = 34568,
  [SMALL_STATE(781)] = 34591,
  [SMALL_STATE(782)] = 34610,
  [SMALL_STATE(783)] = 34625,
  [SMALL_STATE(784)] = 34646,
  [SMALL_STATE(785)] = 34667,
  [SMALL_STATE(786)] = 34681,
  [SMALL_STATE(787)] = 34707,
  [SMALL_STATE(788)] = 34725,
  [SMALL_STATE(789)] = 34745,
  [SMALL_STATE(790)] = 34759,
  [SMALL_STATE(791)] = 34773,
  [SMALL_STATE(792)] = 34799,
  [SMALL_STATE(793)] = 34823,
  [SMALL_STATE(794)] = 34837,
  [SMALL_STATE(795)] = 34851,
  [SMALL_STATE(796)] = 34865,
  [SMALL_STATE(797)] = 34879,
  [SMALL_STATE(798)] = 34893,
  [SMALL_STATE(799)] = 34913,
  [SMALL_STATE(800)] = 34937,
  [SMALL_STATE(801)] = 34959,
  [SMALL_STATE(802)] = 34973,
  [SMALL_STATE(803)] = 34995,
  [SMALL_STATE(804)] = 35009,
  [SMALL_STATE(805)] = 35035,
  [SMALL_STATE(806)] = 35049,
  [SMALL_STATE(807)] = 35063,
  [SMALL_STATE(808)] = 35080,
  [SMALL_STATE(809)] = 35097,
  [SMALL_STATE(810)] = 35116,
  [SMALL_STATE(811)] = 35133,
  [SMALL_STATE(812)] = 35154,
  [SMALL_STATE(813)] = 35177,
  [SMALL_STATE(814)] = 35200,
  [SMALL_STATE(815)] = 35217,
  [SMALL_STATE(816)] = 35240,
  [SMALL_STATE(817)] = 35263,
  [SMALL_STATE(818)] = 35286,
  [SMALL_STATE(819)] = 35299,
  [SMALL_STATE(820)] = 35322,
  [SMALL_STATE(821)] = 35341,
  [SMALL_STATE(822)] = 35364,
  [SMALL_STATE(823)] = 35381,
  [SMALL_STATE(824)] = 35404,
  [SMALL_STATE(825)] = 35421,
  [SMALL_STATE(826)] = 35442,
  [SMALL_STATE(827)] = 35465,
  [SMALL_STATE(828)] = 35484,
  [SMALL_STATE(829)] = 35503,
  [SMALL_STATE(830)] = 35526,
  [SMALL_STATE(831)] = 35543,
  [SMALL_STATE(832)] = 35556,
  [SMALL_STATE(833)] = 35575,
  [SMALL_STATE(834)] = 35596,
  [SMALL_STATE(835)] = 35619,
  [SMALL_STATE(836)] = 35642,
  [SMALL_STATE(837)] = 35665,
  [SMALL_STATE(838)] = 35682,
  [SMALL_STATE(839)] = 35701,
  [SMALL_STATE(840)] = 35720,
  [SMALL_STATE(841)] = 35739,
  [SMALL_STATE(842)] = 35762,
  [SMALL_STATE(843)] = 35779,
  [SMALL_STATE(844)] = 35792,
  [SMALL_STATE(845)] = 35813,
  [SMALL_STATE(846)] = 35832,
  [SMALL_STATE(847)] = 35853,
  [SMALL_STATE(848)] = 35870,
  [SMALL_STATE(849)] = 35891,
  [SMALL_STATE(850)] = 35909,
  [SMALL_STATE(851)] = 35929,
  [SMALL_STATE(852)] = 35949,
  [SMALL_STATE(853)] = 35967,
  [SMALL_STATE(854)] = 35987,
  [SMALL_STATE(855)] = 36007,
  [SMALL_STATE(856)] = 36027,
  [SMALL_STATE(857)] = 36047,
  [SMALL_STATE(858)] = 36063,
  [SMALL_STATE(859)] = 36083,
  [SMALL_STATE(860)] = 36099,
  [SMALL_STATE(861)] = 36117,
  [SMALL_STATE(862)] = 36137,
  [SMALL_STATE(863)] = 36153,
  [SMALL_STATE(864)] = 36173,
  [SMALL_STATE(865)] = 36193,
  [SMALL_STATE(866)] = 36213,
  [SMALL_STATE(867)] = 36233,
  [SMALL_STATE(868)] = 36249,
  [SMALL_STATE(869)] = 36269,
  [SMALL_STATE(870)] = 36289,
  [SMALL_STATE(871)] = 36307,
  [SMALL_STATE(872)] = 36323,
  [SMALL_STATE(873)] = 36339,
  [SMALL_STATE(874)] = 36355,
  [SMALL_STATE(875)] = 36375,
  [SMALL_STATE(876)] = 36391,
  [SMALL_STATE(877)] = 36411,
  [SMALL_STATE(878)] = 36431,
  [SMALL_STATE(879)] = 36449,
  [SMALL_STATE(880)] = 36469,
  [SMALL_STATE(881)] = 36489,
  [SMALL_STATE(882)] = 36507,
  [SMALL_STATE(883)] = 36523,
  [SMALL_STATE(884)] = 36539,
  [SMALL_STATE(885)] = 36559,
  [SMALL_STATE(886)] = 36579,
  [SMALL_STATE(887)] = 36594,
  [SMALL_STATE(888)] = 36611,
  [SMALL_STATE(889)] = 36624,
  [SMALL_STATE(890)] = 36637,
  [SMALL_STATE(891)] = 36654,
  [SMALL_STATE(892)] = 36671,
  [SMALL_STATE(893)] = 36688,
  [SMALL_STATE(894)] = 36701,
  [SMALL_STATE(895)] = 36718,
  [SMALL_STATE(896)] = 36735,
  [SMALL_STATE(897)] = 36752,
  [SMALL_STATE(898)] = 36769,
  [SMALL_STATE(899)] = 36786,
  [SMALL_STATE(900)] = 36803,
  [SMALL_STATE(901)] = 36816,
  [SMALL_STATE(902)] = 36833,
  [SMALL_STATE(903)] = 36850,
  [SMALL_STATE(904)] = 36863,
  [SMALL_STATE(905)] = 36880,
  [SMALL_STATE(906)] = 36897,
  [SMALL_STATE(907)] = 36914,
  [SMALL_STATE(908)] = 36927,
  [SMALL_STATE(909)] = 36944,
  [SMALL_STATE(910)] = 36959,
  [SMALL_STATE(911)] = 36976,
  [SMALL_STATE(912)] = 36993,
  [SMALL_STATE(913)] = 37010,
  [SMALL_STATE(914)] = 37027,
  [SMALL_STATE(915)] = 37044,
  [SMALL_STATE(916)] = 37061,
  [SMALL_STATE(917)] = 37078,
  [SMALL_STATE(918)] = 37095,
  [SMALL_STATE(919)] = 37112,
  [SMALL_STATE(920)] = 37129,
  [SMALL_STATE(921)] = 37146,
  [SMALL_STATE(922)] = 37163,
  [SMALL_STATE(923)] = 37178,
  [SMALL_STATE(924)] = 37195,
  [SMALL_STATE(925)] = 37212,
  [SMALL_STATE(926)] = 37227,
  [SMALL_STATE(927)] = 37244,
  [SMALL_STATE(928)] = 37261,
  [SMALL_STATE(929)] = 37278,
  [SMALL_STATE(930)] = 37295,
  [SMALL_STATE(931)] = 37312,
  [SMALL_STATE(932)] = 37325,
  [SMALL_STATE(933)] = 37342,
  [SMALL_STATE(934)] = 37359,
  [SMALL_STATE(935)] = 37376,
  [SMALL_STATE(936)] = 37393,
  [SMALL_STATE(937)] = 37406,
  [SMALL_STATE(938)] = 37423,
  [SMALL_STATE(939)] = 37440,
  [SMALL_STATE(940)] = 37457,
  [SMALL_STATE(941)] = 37474,
  [SMALL_STATE(942)] = 37487,
  [SMALL_STATE(943)] = 37504,
  [SMALL_STATE(944)] = 37521,
  [SMALL_STATE(945)] = 37538,
  [SMALL_STATE(946)] = 37555,
  [SMALL_STATE(947)] = 37572,
  [SMALL_STATE(948)] = 37589,
  [SMALL_STATE(949)] = 37602,
  [SMALL_STATE(950)] = 37619,
  [SMALL_STATE(951)] = 37634,
  [SMALL_STATE(952)] = 37651,
  [SMALL_STATE(953)] = 37666,
  [SMALL_STATE(954)] = 37680,
  [SMALL_STATE(955)] = 37694,
  [SMALL_STATE(956)] = 37708,
  [SMALL_STATE(957)] = 37722,
  [SMALL_STATE(958)] = 37732,
  [SMALL_STATE(959)] = 37742,
  [SMALL_STATE(960)] = 37756,
  [SMALL_STATE(961)] = 37766,
  [SMALL_STATE(962)] = 37780,
  [SMALL_STATE(963)] = 37794,
  [SMALL_STATE(964)] = 37808,
  [SMALL_STATE(965)] = 37822,
  [SMALL_STATE(966)] = 37832,
  [SMALL_STATE(967)] = 37846,
  [SMALL_STATE(968)] = 37860,
  [SMALL_STATE(969)] = 37874,
  [SMALL_STATE(970)] = 37888,
  [SMALL_STATE(971)] = 37902,
  [SMALL_STATE(972)] = 37916,
  [SMALL_STATE(973)] = 37930,
  [SMALL_STATE(974)] = 37944,
  [SMALL_STATE(975)] = 37954,
  [SMALL_STATE(976)] = 37968,
  [SMALL_STATE(977)] = 37982,
  [SMALL_STATE(978)] = 37996,
  [SMALL_STATE(979)] = 38010,
  [SMALL_STATE(980)] = 38024,
  [SMALL_STATE(981)] = 38038,
  [SMALL_STATE(982)] = 38052,
  [SMALL_STATE(983)] = 38066,
  [SMALL_STATE(984)] = 38080,
  [SMALL_STATE(985)] = 38094,
  [SMALL_STATE(986)] = 38108,
  [SMALL_STATE(987)] = 38122,
  [SMALL_STATE(988)] = 38136,
  [SMALL_STATE(989)] = 38150,
  [SMALL_STATE(990)] = 38164,
  [SMALL_STATE(991)] = 38178,
  [SMALL_STATE(992)] = 38192,
  [SMALL_STATE(993)] = 38206,
  [SMALL_STATE(994)] = 38220,
  [SMALL_STATE(995)] = 38234,
  [SMALL_STATE(996)] = 38248,
  [SMALL_STATE(997)] = 38262,
  [SMALL_STATE(998)] = 38276,
  [SMALL_STATE(999)] = 38290,
  [SMALL_STATE(1000)] = 38304,
  [SMALL_STATE(1001)] = 38314,
  [SMALL_STATE(1002)] = 38328,
  [SMALL_STATE(1003)] = 38342,
  [SMALL_STATE(1004)] = 38356,
  [SMALL_STATE(1005)] = 38370,
  [SMALL_STATE(1006)] = 38384,
  [SMALL_STATE(1007)] = 38394,
  [SMALL_STATE(1008)] = 38408,
  [SMALL_STATE(1009)] = 38422,
  [SMALL_STATE(1010)] = 38432,
  [SMALL_STATE(1011)] = 38446,
  [SMALL_STATE(1012)] = 38460,
  [SMALL_STATE(1013)] = 38474,
  [SMALL_STATE(1014)] = 38484,
  [SMALL_STATE(1015)] = 38498,
  [SMALL_STATE(1016)] = 38512,
  [SMALL_STATE(1017)] = 38526,
  [SMALL_STATE(1018)] = 38540,
  [SMALL_STATE(1019)] = 38554,
  [SMALL_STATE(1020)] = 38568,
  [SMALL_STATE(1021)] = 38582,
  [SMALL_STATE(1022)] = 38596,
  [SMALL_STATE(1023)] = 38606,
  [SMALL_STATE(1024)] = 38616,
  [SMALL_STATE(1025)] = 38630,
  [SMALL_STATE(1026)] = 38644,
  [SMALL_STATE(1027)] = 38654,
  [SMALL_STATE(1028)] = 38668,
  [SMALL_STATE(1029)] = 38682,
  [SMALL_STATE(1030)] = 38696,
  [SMALL_STATE(1031)] = 38710,
  [SMALL_STATE(1032)] = 38724,
  [SMALL_STATE(1033)] = 38738,
  [SMALL_STATE(1034)] = 38752,
  [SMALL_STATE(1035)] = 38766,
  [SMALL_STATE(1036)] = 38780,
  [SMALL_STATE(1037)] = 38794,
  [SMALL_STATE(1038)] = 38808,
  [SMALL_STATE(1039)] = 38822,
  [SMALL_STATE(1040)] = 38836,
  [SMALL_STATE(1041)] = 38850,
  [SMALL_STATE(1042)] = 38864,
  [SMALL_STATE(1043)] = 38878,
  [SMALL_STATE(1044)] = 38892,
  [SMALL_STATE(1045)] = 38906,
  [SMALL_STATE(1046)] = 38920,
  [SMALL_STATE(1047)] = 38934,
  [SMALL_STATE(1048)] = 38948,
  [SMALL_STATE(1049)] = 38962,
  [SMALL_STATE(1050)] = 38976,
  [SMALL_STATE(1051)] = 38990,
  [SMALL_STATE(1052)] = 39004,
  [SMALL_STATE(1053)] = 39018,
  [SMALL_STATE(1054)] = 39032,
  [SMALL_STATE(1055)] = 39042,
  [SMALL_STATE(1056)] = 39056,
  [SMALL_STATE(1057)] = 39066,
  [SMALL_STATE(1058)] = 39076,
  [SMALL_STATE(1059)] = 39090,
  [SMALL_STATE(1060)] = 39104,
  [SMALL_STATE(1061)] = 39114,
  [SMALL_STATE(1062)] = 39128,
  [SMALL_STATE(1063)] = 39142,
  [SMALL_STATE(1064)] = 39156,
  [SMALL_STATE(1065)] = 39166,
  [SMALL_STATE(1066)] = 39180,
  [SMALL_STATE(1067)] = 39191,
  [SMALL_STATE(1068)] = 39202,
  [SMALL_STATE(1069)] = 39211,
  [SMALL_STATE(1070)] = 39220,
  [SMALL_STATE(1071)] = 39231,
  [SMALL_STATE(1072)] = 39240,
  [SMALL_STATE(1073)] = 39249,
  [SMALL_STATE(1074)] = 39258,
  [SMALL_STATE(1075)] = 39269,
  [SMALL_STATE(1076)] = 39280,
  [SMALL_STATE(1077)] = 39291,
  [SMALL_STATE(1078)] = 39302,
  [SMALL_STATE(1079)] = 39313,
  [SMALL_STATE(1080)] = 39324,
  [SMALL_STATE(1081)] = 39333,
  [SMALL_STATE(1082)] = 39344,
  [SMALL_STATE(1083)] = 39355,
  [SMALL_STATE(1084)] = 39366,
  [SMALL_STATE(1085)] = 39375,
  [SMALL_STATE(1086)] = 39386,
  [SMALL_STATE(1087)] = 39397,
  [SMALL_STATE(1088)] = 39406,
  [SMALL_STATE(1089)] = 39415,
  [SMALL_STATE(1090)] = 39424,
  [SMALL_STATE(1091)] = 39435,
  [SMALL_STATE(1092)] = 39444,
  [SMALL_STATE(1093)] = 39455,
  [SMALL_STATE(1094)] = 39464,
  [SMALL_STATE(1095)] = 39475,
  [SMALL_STATE(1096)] = 39486,
  [SMALL_STATE(1097)] = 39497,
  [SMALL_STATE(1098)] = 39508,
  [SMALL_STATE(1099)] = 39519,
  [SMALL_STATE(1100)] = 39528,
  [SMALL_STATE(1101)] = 39539,
  [SMALL_STATE(1102)] = 39550,
  [SMALL_STATE(1103)] = 39561,
  [SMALL_STATE(1104)] = 39572,
  [SMALL_STATE(1105)] = 39583,
  [SMALL_STATE(1106)] = 39592,
  [SMALL_STATE(1107)] = 39603,
  [SMALL_STATE(1108)] = 39614,
  [SMALL_STATE(1109)] = 39623,
  [SMALL_STATE(1110)] = 39634,
  [SMALL_STATE(1111)] = 39643,
  [SMALL_STATE(1112)] = 39654,
  [SMALL_STATE(1113)] = 39665,
  [SMALL_STATE(1114)] = 39676,
  [SMALL_STATE(1115)] = 39687,
  [SMALL_STATE(1116)] = 39698,
  [SMALL_STATE(1117)] = 39709,
  [SMALL_STATE(1118)] = 39720,
  [SMALL_STATE(1119)] = 39731,
  [SMALL_STATE(1120)] = 39740,
  [SMALL_STATE(1121)] = 39751,
  [SMALL_STATE(1122)] = 39762,
  [SMALL_STATE(1123)] = 39773,
  [SMALL_STATE(1124)] = 39782,
  [SMALL_STATE(1125)] = 39791,
  [SMALL_STATE(1126)] = 39802,
  [SMALL_STATE(1127)] = 39811,
  [SMALL_STATE(1128)] = 39820,
  [SMALL_STATE(1129)] = 39829,
  [SMALL_STATE(1130)] = 39838,
  [SMALL_STATE(1131)] = 39847,
  [SMALL_STATE(1132)] = 39858,
  [SMALL_STATE(1133)] = 39867,
  [SMALL_STATE(1134)] = 39876,
  [SMALL_STATE(1135)] = 39887,
  [SMALL_STATE(1136)] = 39898,
  [SMALL_STATE(1137)] = 39907,
  [SMALL_STATE(1138)] = 39918,
  [SMALL_STATE(1139)] = 39929,
  [SMALL_STATE(1140)] = 39938,
  [SMALL_STATE(1141)] = 39949,
  [SMALL_STATE(1142)] = 39960,
  [SMALL_STATE(1143)] = 39969,
  [SMALL_STATE(1144)] = 39980,
  [SMALL_STATE(1145)] = 39991,
  [SMALL_STATE(1146)] = 40002,
  [SMALL_STATE(1147)] = 40013,
  [SMALL_STATE(1148)] = 40022,
  [SMALL_STATE(1149)] = 40031,
  [SMALL_STATE(1150)] = 40042,
  [SMALL_STATE(1151)] = 40053,
  [SMALL_STATE(1152)] = 40061,
  [SMALL_STATE(1153)] = 40069,
  [SMALL_STATE(1154)] = 40077,
  [SMALL_STATE(1155)] = 40085,
  [SMALL_STATE(1156)] = 40093,
  [SMALL_STATE(1157)] = 40101,
  [SMALL_STATE(1158)] = 40109,
  [SMALL_STATE(1159)] = 40117,
  [SMALL_STATE(1160)] = 40125,
  [SMALL_STATE(1161)] = 40133,
  [SMALL_STATE(1162)] = 40141,
  [SMALL_STATE(1163)] = 40149,
  [SMALL_STATE(1164)] = 40157,
  [SMALL_STATE(1165)] = 40165,
  [SMALL_STATE(1166)] = 40173,
  [SMALL_STATE(1167)] = 40181,
  [SMALL_STATE(1168)] = 40189,
  [SMALL_STATE(1169)] = 40197,
  [SMALL_STATE(1170)] = 40205,
  [SMALL_STATE(1171)] = 40213,
  [SMALL_STATE(1172)] = 40221,
  [SMALL_STATE(1173)] = 40229,
  [SMALL_STATE(1174)] = 40237,
  [SMALL_STATE(1175)] = 40245,
  [SMALL_STATE(1176)] = 40253,
  [SMALL_STATE(1177)] = 40261,
  [SMALL_STATE(1178)] = 40269,
  [SMALL_STATE(1179)] = 40277,
  [SMALL_STATE(1180)] = 40285,
  [SMALL_STATE(1181)] = 40293,
  [SMALL_STATE(1182)] = 40301,
  [SMALL_STATE(1183)] = 40309,
  [SMALL_STATE(1184)] = 40317,
  [SMALL_STATE(1185)] = 40325,
  [SMALL_STATE(1186)] = 40333,
  [SMALL_STATE(1187)] = 40341,
  [SMALL_STATE(1188)] = 40349,
  [SMALL_STATE(1189)] = 40357,
  [SMALL_STATE(1190)] = 40365,
  [SMALL_STATE(1191)] = 40373,
  [SMALL_STATE(1192)] = 40381,
  [SMALL_STATE(1193)] = 40389,
  [SMALL_STATE(1194)] = 40397,
  [SMALL_STATE(1195)] = 40405,
  [SMALL_STATE(1196)] = 40413,
  [SMALL_STATE(1197)] = 40421,
  [SMALL_STATE(1198)] = 40429,
  [SMALL_STATE(1199)] = 40437,
  [SMALL_STATE(1200)] = 40445,
  [SMALL_STATE(1201)] = 40453,
  [SMALL_STATE(1202)] = 40461,
  [SMALL_STATE(1203)] = 40469,
  [SMALL_STATE(1204)] = 40477,
  [SMALL_STATE(1205)] = 40485,
  [SMALL_STATE(1206)] = 40493,
  [SMALL_STATE(1207)] = 40501,
  [SMALL_STATE(1208)] = 40509,
  [SMALL_STATE(1209)] = 40517,
  [SMALL_STATE(1210)] = 40525,
  [SMALL_STATE(1211)] = 40533,
  [SMALL_STATE(1212)] = 40541,
  [SMALL_STATE(1213)] = 40549,
  [SMALL_STATE(1214)] = 40557,
  [SMALL_STATE(1215)] = 40565,
  [SMALL_STATE(1216)] = 40573,
  [SMALL_STATE(1217)] = 40581,
  [SMALL_STATE(1218)] = 40589,
  [SMALL_STATE(1219)] = 40597,
  [SMALL_STATE(1220)] = 40605,
  [SMALL_STATE(1221)] = 40613,
  [SMALL_STATE(1222)] = 40621,
  [SMALL_STATE(1223)] = 40629,
  [SMALL_STATE(1224)] = 40637,
  [SMALL_STATE(1225)] = 40645,
  [SMALL_STATE(1226)] = 40653,
  [SMALL_STATE(1227)] = 40661,
  [SMALL_STATE(1228)] = 40669,
  [SMALL_STATE(1229)] = 40677,
  [SMALL_STATE(1230)] = 40685,
  [SMALL_STATE(1231)] = 40693,
  [SMALL_STATE(1232)] = 40701,
  [SMALL_STATE(1233)] = 40709,
  [SMALL_STATE(1234)] = 40717,
  [SMALL_STATE(1235)] = 40725,
  [SMALL_STATE(1236)] = 40733,
  [SMALL_STATE(1237)] = 40741,
  [SMALL_STATE(1238)] = 40749,
  [SMALL_STATE(1239)] = 40757,
  [SMALL_STATE(1240)] = 40765,
  [SMALL_STATE(1241)] = 40773,
  [SMALL_STATE(1242)] = 40781,
  [SMALL_STATE(1243)] = 40789,
  [SMALL_STATE(1244)] = 40797,
  [SMALL_STATE(1245)] = 40805,
  [SMALL_STATE(1246)] = 40813,
  [SMALL_STATE(1247)] = 40821,
  [SMALL_STATE(1248)] = 40829,
  [SMALL_STATE(1249)] = 40837,
  [SMALL_STATE(1250)] = 40845,
  [SMALL_STATE(1251)] = 40853,
  [SMALL_STATE(1252)] = 40861,
  [SMALL_STATE(1253)] = 40869,
  [SMALL_STATE(1254)] = 40877,
  [SMALL_STATE(1255)] = 40885,
  [SMALL_STATE(1256)] = 40893,
  [SMALL_STATE(1257)] = 40901,
  [SMALL_STATE(1258)] = 40909,
  [SMALL_STATE(1259)] = 40917,
  [SMALL_STATE(1260)] = 40925,
  [SMALL_STATE(1261)] = 40933,
  [SMALL_STATE(1262)] = 40941,
  [SMALL_STATE(1263)] = 40949,
  [SMALL_STATE(1264)] = 40957,
  [SMALL_STATE(1265)] = 40965,
  [SMALL_STATE(1266)] = 40973,
  [SMALL_STATE(1267)] = 40981,
  [SMALL_STATE(1268)] = 40989,
  [SMALL_STATE(1269)] = 40997,
  [SMALL_STATE(1270)] = 41005,
  [SMALL_STATE(1271)] = 41013,
  [SMALL_STATE(1272)] = 41021,
  [SMALL_STATE(1273)] = 41029,
  [SMALL_STATE(1274)] = 41037,
  [SMALL_STATE(1275)] = 41045,
  [SMALL_STATE(1276)] = 41053,
  [SMALL_STATE(1277)] = 41061,
  [SMALL_STATE(1278)] = 41069,
  [SMALL_STATE(1279)] = 41077,
  [SMALL_STATE(1280)] = 41085,
  [SMALL_STATE(1281)] = 41093,
  [SMALL_STATE(1282)] = 41101,
  [SMALL_STATE(1283)] = 41109,
  [SMALL_STATE(1284)] = 41117,
  [SMALL_STATE(1285)] = 41125,
  [SMALL_STATE(1286)] = 41133,
  [SMALL_STATE(1287)] = 41141,
  [SMALL_STATE(1288)] = 41149,
  [SMALL_STATE(1289)] = 41157,
  [SMALL_STATE(1290)] = 41165,
  [SMALL_STATE(1291)] = 41173,
  [SMALL_STATE(1292)] = 41181,
  [SMALL_STATE(1293)] = 41189,
  [SMALL_STATE(1294)] = 41197,
  [SMALL_STATE(1295)] = 41205,
  [SMALL_STATE(1296)] = 41213,
  [SMALL_STATE(1297)] = 41221,
  [SMALL_STATE(1298)] = 41229,
  [SMALL_STATE(1299)] = 41237,
  [SMALL_STATE(1300)] = 41245,
  [SMALL_STATE(1301)] = 41253,
  [SMALL_STATE(1302)] = 41261,
  [SMALL_STATE(1303)] = 41269,
  [SMALL_STATE(1304)] = 41277,
  [SMALL_STATE(1305)] = 41285,
  [SMALL_STATE(1306)] = 41293,
  [SMALL_STATE(1307)] = 41301,
  [SMALL_STATE(1308)] = 41309,
  [SMALL_STATE(1309)] = 41317,
  [SMALL_STATE(1310)] = 41325,
  [SMALL_STATE(1311)] = 41333,
  [SMALL_STATE(1312)] = 41341,
  [SMALL_STATE(1313)] = 41349,
  [SMALL_STATE(1314)] = 41357,
  [SMALL_STATE(1315)] = 41365,
  [SMALL_STATE(1316)] = 41373,
  [SMALL_STATE(1317)] = 41381,
  [SMALL_STATE(1318)] = 41389,
  [SMALL_STATE(1319)] = 41397,
  [SMALL_STATE(1320)] = 41405,
  [SMALL_STATE(1321)] = 41413,
  [SMALL_STATE(1322)] = 41421,
  [SMALL_STATE(1323)] = 41429,
  [SMALL_STATE(1324)] = 41437,
  [SMALL_STATE(1325)] = 41445,
  [SMALL_STATE(1326)] = 41453,
  [SMALL_STATE(1327)] = 41461,
  [SMALL_STATE(1328)] = 41469,
  [SMALL_STATE(1329)] = 41477,
  [SMALL_STATE(1330)] = 41485,
  [SMALL_STATE(1331)] = 41493,
  [SMALL_STATE(1332)] = 41501,
  [SMALL_STATE(1333)] = 41509,
  [SMALL_STATE(1334)] = 41517,
  [SMALL_STATE(1335)] = 41525,
  [SMALL_STATE(1336)] = 41533,
  [SMALL_STATE(1337)] = 41541,
  [SMALL_STATE(1338)] = 41549,
  [SMALL_STATE(1339)] = 41557,
  [SMALL_STATE(1340)] = 41565,
  [SMALL_STATE(1341)] = 41573,
  [SMALL_STATE(1342)] = 41581,
  [SMALL_STATE(1343)] = 41589,
  [SMALL_STATE(1344)] = 41597,
  [SMALL_STATE(1345)] = 41605,
  [SMALL_STATE(1346)] = 41613,
  [SMALL_STATE(1347)] = 41621,
  [SMALL_STATE(1348)] = 41629,
  [SMALL_STATE(1349)] = 41637,
  [SMALL_STATE(1350)] = 41645,
  [SMALL_STATE(1351)] = 41653,
  [SMALL_STATE(1352)] = 41661,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [25] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 3),
  [27] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 3),
  [29] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1),
  [31] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [75] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(92),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(886),
  [81] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1351),
  [84] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(778),
  [87] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(772),
  [90] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1074),
  [93] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1077),
  [96] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(941),
  [99] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1079),
  [102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, .production_id = 3),
  [104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 1, .production_id = 3),
  [106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(92),
  [113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(886),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(1351),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(778),
  [122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(772),
  [125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(1074),
  [128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(1077),
  [131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2), SHIFT_REPEAT(941),
  [134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, .production_id = 11),
  [138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 3, .production_id = 11),
  [140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subquery, 3),
  [144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subquery, 3),
  [146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 1),
  [148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 1),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 5),
  [152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 7),
  [158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 7),
  [160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 6),
  [162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1),
  [166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 6),
  [168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 10),
  [170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 10),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 3, .production_id = 3),
  [174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 3, .production_id = 3),
  [176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 9),
  [178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 9),
  [180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 5),
  [182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate, 6, .production_id = 33),
  [184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate, 6, .production_id = 33),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 4),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 6, .production_id = 45),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 7),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 8),
  [210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 8),
  [212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subquery, 4),
  [214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subquery, 4),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, .production_id = 24),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 5, .production_id = 24),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 7),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 7, .production_id = 47),
  [224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 8, .production_id = 49),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate, 5, .production_id = 20),
  [228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate, 5, .production_id = 20),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 9, .production_id = 50),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 1, .production_id = 2),
  [234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 1, .production_id = 2),
  [236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal_string, 3),
  [242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal_string, 3),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate, 3, .production_id = 8),
  [246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate, 3, .production_id = 8),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__count_function, 5, .production_id = 19),
  [250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__count_function, 5, .production_id = 19),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate, 3),
  [262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate, 3),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 4, .production_id = 15),
  [266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 4, .production_id = 15),
  [268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 8),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 8),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__not_null, 2),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__not_null, 2),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__count_function, 4, .production_id = 14),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__count_function, 4, .production_id = 14),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4),
  [282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__select_expression, 1),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_expression, 1),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_expression, 1),
  [330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_order_expression_repeat1, 2),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_expression, 1),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__having, 2),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 2),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 27),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_expression, 1, .production_id = 3),
  [782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_expression, 1, .production_id = 3),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 4),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 3),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_expression, 3, .production_id = 12),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_expression, 3, .production_id = 12),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 4),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_expression, 2, .production_id = 13),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_params, 1, .production_id = 9),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat2, 4),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_expression, 5, .production_id = 38),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_expression, 3, .production_id = 18),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_expression, 4, .production_id = 32),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_params_repeat1, 2, .production_id = 21),
  [918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(1114),
  [921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(1113),
  [924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(1267),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(861),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_hint, 7, .production_id = 39),
  [934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_hint, 5, .production_id = 25),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 6, .production_id = 30),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_list_without_order, 4, .production_id = 26),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_list_without_order, 3, .production_id = 26),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_reference, 1, .production_id = 3),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [1092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 2),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 5),
  [1096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(1086),
  [1099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(1085),
  [1102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(1324),
  [1105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2), SHIFT_REPEAT(880),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [1128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definition, 2, .production_id = 28),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_reference, 3, .production_id = 12),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [1140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_by, 2),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__begin, 2),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_timestamp, 1),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [1152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_char, 1),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 6),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__commit, 3),
  [1160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rollback, 3),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transaction, 3),
  [1164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rollback, 2),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__commit, 2),
  [1168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transaction, 2),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__begin, 3),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 1),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_varchar, 2),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where, 2),
  [1180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, .production_id = 4),
  [1182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, .production_id = 4), SHIFT_REPEAT(237),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 1, .production_id = 1),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_statement, 1),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_expression, 3),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_expression, 2),
  [1201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_expression_repeat1, 2), SHIFT_REPEAT(402),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 1),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 1),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 2, .production_id = 4),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_numeric, 1),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varchar, 1),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_varchar, 1),
  [1224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_direction, 1),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 2),
  [1228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_timestamptz, 1),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 4, .production_id = 43),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alias, 2, .production_id = 7),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definition, 3, .production_id = 28),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_table_update, 3),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_all_fields, 3, .production_id = 10),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 4, .production_id = 44),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_limit, 2),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_numeric, 6, .production_id = 48),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_numeric, 4, .production_id = 44),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_timestamptz, 4),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_timestamp, 4),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 4, .production_id = 43),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varchar, 4, .production_id = 43),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 6, .production_id = 48),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_expression, 2, .production_id = 5),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alias, 1, .production_id = 6),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__select_statement_repeat1, 3),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_all_fields, 1),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, .production_id = 5),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 7),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_all_fields, 5, .production_id = 23),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_by, 3),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_int, 1),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 2),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_order_expression_repeat1, 3),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__select_statement_repeat1, 2),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definition, 4, .production_id = 28),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by, 2),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_statement, 3),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 2),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_list, 1),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 4),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 5),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_statement, 2),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 6),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_list, 2),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assignment_list_repeat1, 2),
  [1336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assignment_list_repeat1, 2), SHIFT_REPEAT(877),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 3),
  [1341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__select_statement_repeat1, 2), SHIFT_REPEAT(962),
  [1344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__select_statement_repeat1, 2), SHIFT_REPEAT(1075),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__dml_statement_repeat1, 2),
  [1349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__dml_statement_repeat1, 2), SHIFT_REPEAT(902),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__select_statement_repeat1, 4),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offset, 2),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_options, 1),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_null, 2),
  [1360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_options_repeat1, 2), SHIFT_REPEAT(5),
  [1363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_options_repeat1, 2), SHIFT_REPEAT(889),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_options_repeat1, 2),
  [1368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_options_repeat1, 2), SHIFT_REPEAT(1215),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_table_update, 4),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 3),
  [1375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 8),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_limit, 3),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definition, 5, .production_id = 28),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assignment_list_repeat1, 2), SHIFT_REPEAT(869),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_key, 2),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_expression_repeat1, 2), SHIFT_REPEAT(520),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 5, .production_id = 31),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [1481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_table_update, 5),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, .production_id = 4), SHIFT_REPEAT(193),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multi_table_update, 3),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column, 1, .production_id = 3),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 4),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete, 1),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_option, 1, .production_id = 17),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_option, 1, .production_id = 17),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_column_definitions, 5),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definitions, 5),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat2, 2), SHIFT_REPEAT(416),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat2, 2),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_statement, 1),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__update_statement, 1),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_column_definitions, 4),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definitions, 4),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_option, 3, .production_id = 35),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_option, 3, .production_id = 35),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_with, 1),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_with, 1),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_column_definitions, 3),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definitions, 3),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_statement, 2),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [1609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(493),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multi_table_update, 4),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert_expression, 3),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_params, 2, .production_id = 16),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_params_repeat1, 2, .production_id = 22),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_params_repeat1, 2, .production_id = 22), SHIFT_REPEAT(500),
  [1643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(492),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 6),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_table, 6),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert_expression, 4),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_table_repeat1, 2), SHIFT_REPEAT(839),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_table_repeat1, 2),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraints_repeat1, 2),
  [1677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraints_repeat1, 2), SHIFT_REPEAT(774),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_table, 5),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 5),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_list_without_order_repeat1, 2),
  [1686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__column_list_without_order_repeat1, 2), SHIFT_REPEAT(911),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_table, 4),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 3),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__table_references, 2),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 8),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_table_update, 6),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_column_definitions_repeat1, 2),
  [1701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definitions_repeat1, 2), SHIFT_REPEAT(895),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__table_references_repeat1, 2),
  [1706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__table_references_repeat1, 2), SHIFT_REPEAT(914),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert_expression, 2),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 7),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_column_list_repeat1, 2),
  [1745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_list_repeat1, 2), SHIFT_REPEAT(906),
  [1748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 3),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 2),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update, 2),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definition, 6, .production_id = 28),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 1),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [1780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 3, .production_id = 42),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__update_statement, 2),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_without_order, 1, .production_id = 3),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_list, 3),
  [1790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_statement, 2),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column, 2, .production_id = 3),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_statement, 3),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [1832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_column, 3, .production_id = 30),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_returning, 2),
  [1836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_key_constraint, 2),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_column, 3),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_view, 3),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 7, .production_id = 46),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 5, .production_id = 40),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 5, .production_id = 30),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [1882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_view, 4),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_table, 4),
  [1894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_list_without_order_repeat1, 2, .production_id = 26),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_not_exists, 3),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_table, 3),
  [1906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_column, 4),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_column, 4, .production_id = 36),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, .production_id = 34),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_list, 4),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint_literal, 4, .production_id = 42),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_exists, 2),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__or_replace, 2),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 7),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 7),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete, 2),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_view, 5),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rename_column, 4, .production_id = 37),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 9),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_view, 4),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_table, 5),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_statement, 4),
  [2148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_view, 5),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2176] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [2184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rename_column, 5, .production_id = 41),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 5),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_ownership, 3),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rename_object, 3),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 10),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_schema, 3, .production_id = 29),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 6),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 11),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_statement, 3),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_sql(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
